﻿
//*****************************************************************************************************\\
// Copyright (©) Cergey Latchenko ( github.com/SunSerega | forum.mmcs.sfedu.ru/u/sun_serega )
// This code is distributed under the Unlicense
// For details see LICENSE file or this:
// https://github.com/SunSerega/POCGL/blob/master/LICENSE
//*****************************************************************************************************\\
// Copyright (©) Сергей Латченко ( github.com/SunSerega | forum.mmcs.sfedu.ru/u/sun_serega )
// Этот код распространяется с лицензией Unlicense
// Подробнее в файле LICENSE или тут:
// https://github.com/SunSerega/POCGL/blob/master/LICENSE
//*****************************************************************************************************\\

///
///Код переведён отсюда:
///   https://github.com/KhronosGroup/OpenGL-Registry/tree/master/xml
///
///Спецификации всех версий OpenGL:
///   https://www.khronos.org/registry/OpenGL/specs/gl/
///
///Если чего-либо не хватает, или найдена ошибка - писать сюда:
///   https://github.com/SunSerega/POCGL/issues
///
unit OpenGL;

interface

uses System;
uses System.Runtime.InteropServices;
uses System.Runtime.CompilerServices;

{$region Основные типы} type
  
  DummyEnum  = UInt32;
  DummyFlags = UInt32;
  
  OpenGLException = class(Exception)
    
    constructor(text: string) :=
    inherited Create($'Ошибка OpenGL: "{text}"');
    
  end;
  
{$endregion Основные типы}

{$region Записи-имена} type
  
  GLsync = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLsync read default(GLsync);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLeglImageOES = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLeglImageOES read default(GLeglImageOES);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  QueryName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: QueryName read default(QueryName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  BufferName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: BufferName read default(BufferName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  ShaderName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ShaderName read default(ShaderName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  ProgramName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ProgramName read default(ProgramName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  ProgramPipelineName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ProgramPipelineName read default(ProgramPipelineName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  TextureName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: TextureName read default(TextureName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  SamplerName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: SamplerName read default(SamplerName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  FramebufferName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: FramebufferName read default(FramebufferName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  RenderbufferName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: RenderbufferName read default(RenderbufferName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  VertexArrayName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: VertexArrayName read default(VertexArrayName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  TransformFeedbackName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: TransformFeedbackName read default(TransformFeedbackName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  
  GLContext = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: GLContext read default(GLContext);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  GDI_DC = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GDI_DC read default(GDI_DC);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  //	типы	для	совместимости	с	OpenCL
  ///--
  cl_context = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: cl_context read default(cl_context);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  ///--
  cl_event = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: cl_event read default(cl_event);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  
  
  
  
  //	INTEL_performance_query
  PerfQueryIdINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: PerfQueryIdINTEL read default(PerfQueryIdINTEL);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  PerfQueryHandleINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: PerfQueryHandleINTEL read default(PerfQueryHandleINTEL);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  
  
  //ToDo	переименовать	и	проверить	типы	всего	дальше:
  
  EGLsync = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: EGLsync read default(EGLsync);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  EGLDisplay = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: EGLDisplay read default(EGLDisplay);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  ShaderBinaryFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ShaderBinaryFormat read default(ShaderBinaryFormat);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  ProgramResourceIndex = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ProgramResourceIndex read default(ProgramResourceIndex);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  ProgramBinaryFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: ProgramBinaryFormat read default(ProgramBinaryFormat);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  
  GLhandleARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: GLhandleARB read default(GLhandleARB);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  PBufferName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: PBufferName read default(PBufferName);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  HPVIDEODEV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: HPVIDEODEV read default(HPVIDEODEV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  HVIDEOOUTPUTDEVICENV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: HVIDEOOUTPUTDEVICENV read default(HVIDEOOUTPUTDEVICENV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  HVIDEOINPUTDEVICENV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: HVIDEOINPUTDEVICENV read default(HVIDEOINPUTDEVICENV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  PGPU_DEVICE = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: PGPU_DEVICE read default(PGPU_DEVICE);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  HGPUNV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: HGPUNV read default(HGPUNV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  HPBUFFER = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: HPBUFFER read default(HPBUFFER);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLeglClientBufferEXT = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLeglClientBufferEXT read default(GLeglClientBufferEXT);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  VideoOutputDeviceHandleNV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: VideoOutputDeviceHandleNV read default(VideoOutputDeviceHandleNV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  VideoInputDeviceHandleNV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: VideoInputDeviceHandleNV read default(VideoInputDeviceHandleNV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  VideoDeviceHandleNV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: VideoDeviceHandleNV read default(VideoDeviceHandleNV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLvdpauSurfaceNV = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLvdpauSurfaceNV read default(GLvdpauSurfaceNV);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GPUAffinityHandle = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GPUAffinityHandle read default(GPUAffinityHandle);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXFBConfig = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXFBConfig read default(GLXFBConfig);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXContextID = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXContextID read default(GLXContextID);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXPbuffer = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXPbuffer read default(GLXPbuffer);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXWindow = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXWindow read default(GLXWindow);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXPixmap = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXPixmap read default(GLXPixmap);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXColormap = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXColormap read default(GLXColormap);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXDrawable = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXDrawable read default(GLXDrawable);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXContext = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXContext read default(GLXContext);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXVideoCaptureDeviceNV = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXVideoCaptureDeviceNV read default(GLXVideoCaptureDeviceNV);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXVideoSourceSGIX = record
    public val: UInt64;
    public constructor(val: UInt64) := self.val := val;
    public static property Zero: GLXVideoSourceSGIX read default(GLXVideoSourceSGIX);
    public static property Size: integer read Marshal.SizeOf&<UInt64>;
  end;
  GLXVideoDeviceNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    public static property Zero: GLXVideoDeviceNV read default(GLXVideoDeviceNV);
    public static property Size: integer read Marshal.SizeOf&<UInt32>;
  end;
  GLXFuncPtr = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXFuncPtr read default(GLXFuncPtr);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  PDisplay = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: PDisplay read default(PDisplay);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  PXVisualInfo = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: PXVisualInfo read default(PXVisualInfo);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  
  
  //ToDo	эти	типы	вообще	угадывал,	перепроверить
  
  GLXDMparams = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXDMparams read default(GLXDMparams);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXDMbuffer = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXDMbuffer read default(GLXDMbuffer);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXVLServer = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXVLServer read default(GLXVLServer);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXVLPath = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXVLPath read default(GLXVLPath);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXVLNode = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXVLNode read default(GLXVLNode);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLXStatus = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLXStatus read default(GLXStatus);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GLUnurbs = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GLUnurbs read default(GLUnurbs);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  GDI_HENHMetafile = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GDI_HENHMetafile read default(GDI_HENHMetafile);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
  GDI_LayerPlaneDescriptor = record
    public val: IntPtr;
    public constructor(val: IntPtr) := self.val := val;
    public static property Zero: GDI_LayerPlaneDescriptor read default(GDI_LayerPlaneDescriptor);
    public static property Size: integer read Marshal.SizeOf&<IntPtr>;
  end;
  
{$endregion Записи-имена}

{$region Перечисления} type
  
  {$region Core}
  
  AccumOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ACCUM  := new AccumOp($0100);
    private static _LOAD   := new AccumOp($0101);
    private static _RETURN := new AccumOp($0102);
    private static _MULT   := new AccumOp($0103);
    private static _ADD    := new AccumOp($0104);
    
    public static property ACCUM:  AccumOp read _ACCUM;
    public static property LOAD:   AccumOp read _LOAD;
    public static property RETURN: AccumOp read _RETURN;
    public static property MULT:   AccumOp read _MULT;
    public static property ADD:    AccumOp read _ADD;
    
    public function ToString: string; override;
    begin
      var res := typeof(AccumOp).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->AccumOp(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'AccumOp[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  AlphaFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEVER    := new AlphaFunction($0200);
    private static _LESS     := new AlphaFunction($0201);
    private static _EQUAL    := new AlphaFunction($0202);
    private static _LEQUAL   := new AlphaFunction($0203);
    private static _GREATER  := new AlphaFunction($0204);
    private static _NOTEQUAL := new AlphaFunction($0205);
    private static _GEQUAL   := new AlphaFunction($0206);
    private static _ALWAYS   := new AlphaFunction($0207);
    
    public static property NEVER:    AlphaFunction read _NEVER;
    public static property LESS:     AlphaFunction read _LESS;
    public static property EQUAL:    AlphaFunction read _EQUAL;
    public static property LEQUAL:   AlphaFunction read _LEQUAL;
    public static property GREATER:  AlphaFunction read _GREATER;
    public static property NOTEQUAL: AlphaFunction read _NOTEQUAL;
    public static property GEQUAL:   AlphaFunction read _GEQUAL;
    public static property ALWAYS:   AlphaFunction read _ALWAYS;
    
    public function ToString: string; override;
    begin
      var res := typeof(AlphaFunction).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->AlphaFunction(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'AlphaFunction[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  AtomicCounterBufferPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER         := new AtomicCounterBufferPName($90ED);
    private static _ATOMIC_COUNTER_BUFFER_BINDING                              := new AtomicCounterBufferPName($92C1);
    private static _ATOMIC_COUNTER_BUFFER_DATA_SIZE                            := new AtomicCounterBufferPName($92C4);
    private static _ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS               := new AtomicCounterBufferPName($92C5);
    private static _ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES        := new AtomicCounterBufferPName($92C6);
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER          := new AtomicCounterBufferPName($92C7);
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER    := new AtomicCounterBufferPName($92C8);
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER := new AtomicCounterBufferPName($92C9);
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER        := new AtomicCounterBufferPName($92CA);
    private static _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER        := new AtomicCounterBufferPName($92CB);
    
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER:         AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_COMPUTE_SHADER;
    public static property ATOMIC_COUNTER_BUFFER_BINDING:                              AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_BINDING;
    public static property ATOMIC_COUNTER_BUFFER_DATA_SIZE:                            AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_DATA_SIZE;
    public static property ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS:               AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTERS;
    public static property ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES:        AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_ACTIVE_ATOMIC_COUNTER_INDICES;
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER:          AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_VERTEX_SHADER;
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER:    AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_CONTROL_SHADER;
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER: AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_TESS_EVALUATION_SHADER;
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER:        AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_GEOMETRY_SHADER;
    public static property ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER:        AtomicCounterBufferPName read _ATOMIC_COUNTER_BUFFER_REFERENCED_BY_FRAGMENT_SHADER;
    
    public function ToString: string; override;
    begin
      var res := typeof(AtomicCounterBufferPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->AtomicCounterBufferPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'AtomicCounterBufferPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  AttribMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CURRENT_BIT          := new AttribMask($0001);
    private static _POINT_BIT            := new AttribMask($0002);
    private static _LINE_BIT             := new AttribMask($0004);
    private static _POLYGON_BIT          := new AttribMask($0008);
    private static _POLYGON_STIPPLE_BIT  := new AttribMask($0010);
    private static _PIXEL_MODE_BIT       := new AttribMask($0020);
    private static _LIGHTING_BIT         := new AttribMask($0040);
    private static _FOG_BIT              := new AttribMask($0080);
    private static _DEPTH_BUFFER_BIT     := new AttribMask($0100);
    private static _ACCUM_BUFFER_BIT     := new AttribMask($0200);
    private static _STENCIL_BUFFER_BIT   := new AttribMask($0400);
    private static _VIEWPORT_BIT         := new AttribMask($0800);
    private static _TRANSFORM_BIT        := new AttribMask($1000);
    private static _ENABLE_BIT           := new AttribMask($2000);
    private static _COLOR_BUFFER_BIT     := new AttribMask($4000);
    private static _HINT_BIT             := new AttribMask($8000);
    private static _EVAL_BIT             := new AttribMask($10000);
    private static _LIST_BIT             := new AttribMask($20000);
    private static _TEXTURE_BIT          := new AttribMask($40000);
    private static _SCISSOR_BIT          := new AttribMask($80000);
    private static _MULTISAMPLE_BIT      := new AttribMask($20000000);
    private static _MULTISAMPLE_BIT_3DFX := new AttribMask($20000000);
    private static _MULTISAMPLE_BIT_ARB  := new AttribMask($20000000);
    private static _MULTISAMPLE_BIT_EXT  := new AttribMask($20000000);
    private static _ALL_ATTRIB_BITS      := new AttribMask($FFFFFFFF);
    
    public static property CURRENT_BIT:          AttribMask read _CURRENT_BIT;
    public static property POINT_BIT:            AttribMask read _POINT_BIT;
    public static property LINE_BIT:             AttribMask read _LINE_BIT;
    public static property POLYGON_BIT:          AttribMask read _POLYGON_BIT;
    public static property POLYGON_STIPPLE_BIT:  AttribMask read _POLYGON_STIPPLE_BIT;
    public static property PIXEL_MODE_BIT:       AttribMask read _PIXEL_MODE_BIT;
    public static property LIGHTING_BIT:         AttribMask read _LIGHTING_BIT;
    public static property FOG_BIT:              AttribMask read _FOG_BIT;
    public static property DEPTH_BUFFER_BIT:     AttribMask read _DEPTH_BUFFER_BIT;
    public static property ACCUM_BUFFER_BIT:     AttribMask read _ACCUM_BUFFER_BIT;
    public static property STENCIL_BUFFER_BIT:   AttribMask read _STENCIL_BUFFER_BIT;
    public static property VIEWPORT_BIT:         AttribMask read _VIEWPORT_BIT;
    public static property TRANSFORM_BIT:        AttribMask read _TRANSFORM_BIT;
    public static property ENABLE_BIT:           AttribMask read _ENABLE_BIT;
    public static property COLOR_BUFFER_BIT:     AttribMask read _COLOR_BUFFER_BIT;
    public static property HINT_BIT:             AttribMask read _HINT_BIT;
    public static property EVAL_BIT:             AttribMask read _EVAL_BIT;
    public static property LIST_BIT:             AttribMask read _LIST_BIT;
    public static property TEXTURE_BIT:          AttribMask read _TEXTURE_BIT;
    public static property SCISSOR_BIT:          AttribMask read _SCISSOR_BIT;
    public static property MULTISAMPLE_BIT:      AttribMask read _MULTISAMPLE_BIT;
    public static property MULTISAMPLE_BIT_3DFX: AttribMask read _MULTISAMPLE_BIT_3DFX;
    public static property MULTISAMPLE_BIT_ARB:  AttribMask read _MULTISAMPLE_BIT_ARB;
    public static property MULTISAMPLE_BIT_EXT:  AttribMask read _MULTISAMPLE_BIT_EXT;
    public static property ALL_ATTRIB_BITS:      AttribMask read _ALL_ATTRIB_BITS;
    
    public static function operator or(f1,f2: AttribMask) := new AttribMask(f1.val or f2.val);
    
    public property HAS_FLAG_CURRENT_BIT:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_POINT_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_LINE_BIT:             boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_POLYGON_BIT:          boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_POLYGON_STIPPLE_BIT:  boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_PIXEL_MODE_BIT:       boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_LIGHTING_BIT:         boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_FOG_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_DEPTH_BUFFER_BIT:     boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_ACCUM_BUFFER_BIT:     boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_STENCIL_BUFFER_BIT:   boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_VIEWPORT_BIT:         boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_TRANSFORM_BIT:        boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_ENABLE_BIT:           boolean read self.val and $2000 <> 0;
    public property HAS_FLAG_COLOR_BUFFER_BIT:     boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_HINT_BIT:             boolean read self.val and $8000 <> 0;
    public property HAS_FLAG_EVAL_BIT:             boolean read self.val and $10000 <> 0;
    public property HAS_FLAG_LIST_BIT:             boolean read self.val and $20000 <> 0;
    public property HAS_FLAG_TEXTURE_BIT:          boolean read self.val and $40000 <> 0;
    public property HAS_FLAG_SCISSOR_BIT:          boolean read self.val and $80000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT:      boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_3DFX: boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_ARB:  boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_MULTISAMPLE_BIT_EXT:  boolean read self.val and $20000000 <> 0;
    public property HAS_FLAG_ALL_ATTRIB_BITS:      boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(AttribMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'AttribMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  AttributeType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INT                                       := new AttributeType($1404);
    private static _UNSIGNED_INT                              := new AttributeType($1405);
    private static _FLOAT                                     := new AttributeType($1406);
    private static _DOUBLE                                    := new AttributeType($140A);
    private static _INT64_ARB                                 := new AttributeType($140E);
    private static _INT64_NV                                  := new AttributeType($140E);
    private static _UNSIGNED_INT64_ARB                        := new AttributeType($140F);
    private static _UNSIGNED_INT64_NV                         := new AttributeType($140F);
    private static _FLOAT_VEC2                                := new AttributeType($8B50);
    private static _FLOAT_VEC2_ARB                            := new AttributeType($8B50);
    private static _FLOAT_VEC3                                := new AttributeType($8B51);
    private static _FLOAT_VEC3_ARB                            := new AttributeType($8B51);
    private static _FLOAT_VEC4                                := new AttributeType($8B52);
    private static _FLOAT_VEC4_ARB                            := new AttributeType($8B52);
    private static _INT_VEC2                                  := new AttributeType($8B53);
    private static _INT_VEC2_ARB                              := new AttributeType($8B53);
    private static _INT_VEC3                                  := new AttributeType($8B54);
    private static _INT_VEC3_ARB                              := new AttributeType($8B54);
    private static _INT_VEC4                                  := new AttributeType($8B55);
    private static _INT_VEC4_ARB                              := new AttributeType($8B55);
    private static _BOOL                                      := new AttributeType($8B56);
    private static _BOOL_ARB                                  := new AttributeType($8B56);
    private static _BOOL_VEC2                                 := new AttributeType($8B57);
    private static _BOOL_VEC2_ARB                             := new AttributeType($8B57);
    private static _BOOL_VEC3                                 := new AttributeType($8B58);
    private static _BOOL_VEC3_ARB                             := new AttributeType($8B58);
    private static _BOOL_VEC4                                 := new AttributeType($8B59);
    private static _BOOL_VEC4_ARB                             := new AttributeType($8B59);
    private static _FLOAT_MAT2                                := new AttributeType($8B5A);
    private static _FLOAT_MAT2_ARB                            := new AttributeType($8B5A);
    private static _FLOAT_MAT3                                := new AttributeType($8B5B);
    private static _FLOAT_MAT3_ARB                            := new AttributeType($8B5B);
    private static _FLOAT_MAT4                                := new AttributeType($8B5C);
    private static _FLOAT_MAT4_ARB                            := new AttributeType($8B5C);
    private static _SAMPLER_1D                                := new AttributeType($8B5D);
    private static _SAMPLER_1D_ARB                            := new AttributeType($8B5D);
    private static _SAMPLER_2D                                := new AttributeType($8B5E);
    private static _SAMPLER_2D_ARB                            := new AttributeType($8B5E);
    private static _SAMPLER_3D                                := new AttributeType($8B5F);
    private static _SAMPLER_3D_ARB                            := new AttributeType($8B5F);
    private static _SAMPLER_3D_OES                            := new AttributeType($8B5F);
    private static _SAMPLER_CUBE                              := new AttributeType($8B60);
    private static _SAMPLER_CUBE_ARB                          := new AttributeType($8B60);
    private static _SAMPLER_1D_SHADOW                         := new AttributeType($8B61);
    private static _SAMPLER_1D_SHADOW_ARB                     := new AttributeType($8B61);
    private static _SAMPLER_2D_SHADOW                         := new AttributeType($8B62);
    private static _SAMPLER_2D_SHADOW_ARB                     := new AttributeType($8B62);
    private static _SAMPLER_2D_SHADOW_EXT                     := new AttributeType($8B62);
    private static _SAMPLER_2D_RECT                           := new AttributeType($8B63);
    private static _SAMPLER_2D_RECT_ARB                       := new AttributeType($8B63);
    private static _SAMPLER_2D_RECT_SHADOW                    := new AttributeType($8B64);
    private static _SAMPLER_2D_RECT_SHADOW_ARB                := new AttributeType($8B64);
    private static _FLOAT_MAT2x3                              := new AttributeType($8B65);
    private static _FLOAT_MAT2x3_NV                           := new AttributeType($8B65);
    private static _FLOAT_MAT2x4                              := new AttributeType($8B66);
    private static _FLOAT_MAT2x4_NV                           := new AttributeType($8B66);
    private static _FLOAT_MAT3x2                              := new AttributeType($8B67);
    private static _FLOAT_MAT3x2_NV                           := new AttributeType($8B67);
    private static _FLOAT_MAT3x4                              := new AttributeType($8B68);
    private static _FLOAT_MAT3x4_NV                           := new AttributeType($8B68);
    private static _FLOAT_MAT4x2                              := new AttributeType($8B69);
    private static _FLOAT_MAT4x2_NV                           := new AttributeType($8B69);
    private static _FLOAT_MAT4x3                              := new AttributeType($8B6A);
    private static _FLOAT_MAT4x3_NV                           := new AttributeType($8B6A);
    private static _SAMPLER_BUFFER                            := new AttributeType($8DC2);
    private static _SAMPLER_1D_ARRAY_SHADOW                   := new AttributeType($8DC3);
    private static _SAMPLER_2D_ARRAY_SHADOW                   := new AttributeType($8DC4);
    private static _SAMPLER_CUBE_SHADOW                       := new AttributeType($8DC5);
    private static _UNSIGNED_INT_VEC2                         := new AttributeType($8DC6);
    private static _UNSIGNED_INT_VEC3                         := new AttributeType($8DC7);
    private static _UNSIGNED_INT_VEC4                         := new AttributeType($8DC8);
    private static _INT_SAMPLER_1D                            := new AttributeType($8DC9);
    private static _INT_SAMPLER_2D                            := new AttributeType($8DCA);
    private static _INT_SAMPLER_3D                            := new AttributeType($8DCB);
    private static _INT_SAMPLER_CUBE                          := new AttributeType($8DCC);
    private static _INT_SAMPLER_2D_RECT                       := new AttributeType($8DCD);
    private static _INT_SAMPLER_1D_ARRAY                      := new AttributeType($8DCE);
    private static _INT_SAMPLER_2D_ARRAY                      := new AttributeType($8DCF);
    private static _INT_SAMPLER_BUFFER                        := new AttributeType($8DD0);
    private static _UNSIGNED_INT_SAMPLER_1D                   := new AttributeType($8DD1);
    private static _UNSIGNED_INT_SAMPLER_2D                   := new AttributeType($8DD2);
    private static _UNSIGNED_INT_SAMPLER_3D                   := new AttributeType($8DD3);
    private static _UNSIGNED_INT_SAMPLER_CUBE                 := new AttributeType($8DD4);
    private static _UNSIGNED_INT_SAMPLER_2D_RECT              := new AttributeType($8DD5);
    private static _UNSIGNED_INT_SAMPLER_1D_ARRAY             := new AttributeType($8DD6);
    private static _UNSIGNED_INT_SAMPLER_2D_ARRAY             := new AttributeType($8DD7);
    private static _UNSIGNED_INT_SAMPLER_BUFFER               := new AttributeType($8DD8);
    private static _DOUBLE_MAT2                               := new AttributeType($8F46);
    private static _DOUBLE_MAT3                               := new AttributeType($8F47);
    private static _DOUBLE_MAT4                               := new AttributeType($8F48);
    private static _DOUBLE_MAT2x3                             := new AttributeType($8F49);
    private static _DOUBLE_MAT2x4                             := new AttributeType($8F4A);
    private static _DOUBLE_MAT3x2                             := new AttributeType($8F4B);
    private static _DOUBLE_MAT3x4                             := new AttributeType($8F4C);
    private static _DOUBLE_MAT4x2                             := new AttributeType($8F4D);
    private static _DOUBLE_MAT4x3                             := new AttributeType($8F4E);
    private static _INT64_VEC2_ARB                            := new AttributeType($8FE9);
    private static _INT64_VEC3_ARB                            := new AttributeType($8FEA);
    private static _INT64_VEC4_ARB                            := new AttributeType($8FEB);
    private static _UNSIGNED_INT64_VEC2_ARB                   := new AttributeType($8FF5);
    private static _UNSIGNED_INT64_VEC3_ARB                   := new AttributeType($8FF6);
    private static _UNSIGNED_INT64_VEC4_ARB                   := new AttributeType($8FF7);
    private static _DOUBLE_VEC2                               := new AttributeType($8FFC);
    private static _DOUBLE_VEC3                               := new AttributeType($8FFD);
    private static _DOUBLE_VEC4                               := new AttributeType($8FFE);
    private static _SAMPLER_CUBE_MAP_ARRAY                    := new AttributeType($900C);
    private static _SAMPLER_CUBE_MAP_ARRAY_SHADOW             := new AttributeType($900D);
    private static _INT_SAMPLER_CUBE_MAP_ARRAY                := new AttributeType($900E);
    private static _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY       := new AttributeType($900F);
    private static _IMAGE_1D                                  := new AttributeType($904C);
    private static _IMAGE_2D                                  := new AttributeType($904D);
    private static _IMAGE_3D                                  := new AttributeType($904E);
    private static _IMAGE_2D_RECT                             := new AttributeType($904F);
    private static _IMAGE_CUBE                                := new AttributeType($9050);
    private static _IMAGE_BUFFER                              := new AttributeType($9051);
    private static _IMAGE_1D_ARRAY                            := new AttributeType($9052);
    private static _IMAGE_2D_ARRAY                            := new AttributeType($9053);
    private static _IMAGE_CUBE_MAP_ARRAY                      := new AttributeType($9054);
    private static _IMAGE_2D_MULTISAMPLE                      := new AttributeType($9055);
    private static _IMAGE_2D_MULTISAMPLE_ARRAY                := new AttributeType($9056);
    private static _INT_IMAGE_1D                              := new AttributeType($9057);
    private static _INT_IMAGE_2D                              := new AttributeType($9058);
    private static _INT_IMAGE_3D                              := new AttributeType($9059);
    private static _INT_IMAGE_2D_RECT                         := new AttributeType($905A);
    private static _INT_IMAGE_CUBE                            := new AttributeType($905B);
    private static _INT_IMAGE_BUFFER                          := new AttributeType($905C);
    private static _INT_IMAGE_1D_ARRAY                        := new AttributeType($905D);
    private static _INT_IMAGE_2D_ARRAY                        := new AttributeType($905E);
    private static _INT_IMAGE_CUBE_MAP_ARRAY                  := new AttributeType($905F);
    private static _INT_IMAGE_2D_MULTISAMPLE                  := new AttributeType($9060);
    private static _INT_IMAGE_2D_MULTISAMPLE_ARRAY            := new AttributeType($9061);
    private static _UNSIGNED_INT_IMAGE_1D                     := new AttributeType($9062);
    private static _UNSIGNED_INT_IMAGE_2D                     := new AttributeType($9063);
    private static _UNSIGNED_INT_IMAGE_3D                     := new AttributeType($9064);
    private static _UNSIGNED_INT_IMAGE_2D_RECT                := new AttributeType($9065);
    private static _UNSIGNED_INT_IMAGE_CUBE                   := new AttributeType($9066);
    private static _UNSIGNED_INT_IMAGE_BUFFER                 := new AttributeType($9067);
    private static _UNSIGNED_INT_IMAGE_1D_ARRAY               := new AttributeType($9068);
    private static _UNSIGNED_INT_IMAGE_2D_ARRAY               := new AttributeType($9069);
    private static _UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY         := new AttributeType($906A);
    private static _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE         := new AttributeType($906B);
    private static _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY   := new AttributeType($906C);
    private static _SAMPLER_2D_MULTISAMPLE                    := new AttributeType($9108);
    private static _INT_SAMPLER_2D_MULTISAMPLE                := new AttributeType($9109);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE       := new AttributeType($910A);
    private static _SAMPLER_2D_MULTISAMPLE_ARRAY              := new AttributeType($910B);
    private static _INT_SAMPLER_2D_MULTISAMPLE_ARRAY          := new AttributeType($910C);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY := new AttributeType($910D);
    
    public static property INT:                                       AttributeType read _INT;
    public static property UNSIGNED_INT:                              AttributeType read _UNSIGNED_INT;
    public static property FLOAT:                                     AttributeType read _FLOAT;
    public static property DOUBLE:                                    AttributeType read _DOUBLE;
    public static property INT64_ARB:                                 AttributeType read _INT64_ARB;
    public static property INT64_NV:                                  AttributeType read _INT64_NV;
    public static property UNSIGNED_INT64_ARB:                        AttributeType read _UNSIGNED_INT64_ARB;
    public static property UNSIGNED_INT64_NV:                         AttributeType read _UNSIGNED_INT64_NV;
    public static property FLOAT_VEC2:                                AttributeType read _FLOAT_VEC2;
    public static property FLOAT_VEC2_ARB:                            AttributeType read _FLOAT_VEC2_ARB;
    public static property FLOAT_VEC3:                                AttributeType read _FLOAT_VEC3;
    public static property FLOAT_VEC3_ARB:                            AttributeType read _FLOAT_VEC3_ARB;
    public static property FLOAT_VEC4:                                AttributeType read _FLOAT_VEC4;
    public static property FLOAT_VEC4_ARB:                            AttributeType read _FLOAT_VEC4_ARB;
    public static property INT_VEC2:                                  AttributeType read _INT_VEC2;
    public static property INT_VEC2_ARB:                              AttributeType read _INT_VEC2_ARB;
    public static property INT_VEC3:                                  AttributeType read _INT_VEC3;
    public static property INT_VEC3_ARB:                              AttributeType read _INT_VEC3_ARB;
    public static property INT_VEC4:                                  AttributeType read _INT_VEC4;
    public static property INT_VEC4_ARB:                              AttributeType read _INT_VEC4_ARB;
    public static property BOOL:                                      AttributeType read _BOOL;
    public static property BOOL_ARB:                                  AttributeType read _BOOL_ARB;
    public static property BOOL_VEC2:                                 AttributeType read _BOOL_VEC2;
    public static property BOOL_VEC2_ARB:                             AttributeType read _BOOL_VEC2_ARB;
    public static property BOOL_VEC3:                                 AttributeType read _BOOL_VEC3;
    public static property BOOL_VEC3_ARB:                             AttributeType read _BOOL_VEC3_ARB;
    public static property BOOL_VEC4:                                 AttributeType read _BOOL_VEC4;
    public static property BOOL_VEC4_ARB:                             AttributeType read _BOOL_VEC4_ARB;
    public static property FLOAT_MAT2:                                AttributeType read _FLOAT_MAT2;
    public static property FLOAT_MAT2_ARB:                            AttributeType read _FLOAT_MAT2_ARB;
    public static property FLOAT_MAT3:                                AttributeType read _FLOAT_MAT3;
    public static property FLOAT_MAT3_ARB:                            AttributeType read _FLOAT_MAT3_ARB;
    public static property FLOAT_MAT4:                                AttributeType read _FLOAT_MAT4;
    public static property FLOAT_MAT4_ARB:                            AttributeType read _FLOAT_MAT4_ARB;
    public static property SAMPLER_1D:                                AttributeType read _SAMPLER_1D;
    public static property SAMPLER_1D_ARB:                            AttributeType read _SAMPLER_1D_ARB;
    public static property SAMPLER_2D:                                AttributeType read _SAMPLER_2D;
    public static property SAMPLER_2D_ARB:                            AttributeType read _SAMPLER_2D_ARB;
    public static property SAMPLER_3D:                                AttributeType read _SAMPLER_3D;
    public static property SAMPLER_3D_ARB:                            AttributeType read _SAMPLER_3D_ARB;
    public static property SAMPLER_3D_OES:                            AttributeType read _SAMPLER_3D_OES;
    public static property SAMPLER_CUBE:                              AttributeType read _SAMPLER_CUBE;
    public static property SAMPLER_CUBE_ARB:                          AttributeType read _SAMPLER_CUBE_ARB;
    public static property SAMPLER_1D_SHADOW:                         AttributeType read _SAMPLER_1D_SHADOW;
    public static property SAMPLER_1D_SHADOW_ARB:                     AttributeType read _SAMPLER_1D_SHADOW_ARB;
    public static property SAMPLER_2D_SHADOW:                         AttributeType read _SAMPLER_2D_SHADOW;
    public static property SAMPLER_2D_SHADOW_ARB:                     AttributeType read _SAMPLER_2D_SHADOW_ARB;
    public static property SAMPLER_2D_SHADOW_EXT:                     AttributeType read _SAMPLER_2D_SHADOW_EXT;
    public static property SAMPLER_2D_RECT:                           AttributeType read _SAMPLER_2D_RECT;
    public static property SAMPLER_2D_RECT_ARB:                       AttributeType read _SAMPLER_2D_RECT_ARB;
    public static property SAMPLER_2D_RECT_SHADOW:                    AttributeType read _SAMPLER_2D_RECT_SHADOW;
    public static property SAMPLER_2D_RECT_SHADOW_ARB:                AttributeType read _SAMPLER_2D_RECT_SHADOW_ARB;
    public static property FLOAT_MAT2x3:                              AttributeType read _FLOAT_MAT2x3;
    public static property FLOAT_MAT2x3_NV:                           AttributeType read _FLOAT_MAT2x3_NV;
    public static property FLOAT_MAT2x4:                              AttributeType read _FLOAT_MAT2x4;
    public static property FLOAT_MAT2x4_NV:                           AttributeType read _FLOAT_MAT2x4_NV;
    public static property FLOAT_MAT3x2:                              AttributeType read _FLOAT_MAT3x2;
    public static property FLOAT_MAT3x2_NV:                           AttributeType read _FLOAT_MAT3x2_NV;
    public static property FLOAT_MAT3x4:                              AttributeType read _FLOAT_MAT3x4;
    public static property FLOAT_MAT3x4_NV:                           AttributeType read _FLOAT_MAT3x4_NV;
    public static property FLOAT_MAT4x2:                              AttributeType read _FLOAT_MAT4x2;
    public static property FLOAT_MAT4x2_NV:                           AttributeType read _FLOAT_MAT4x2_NV;
    public static property FLOAT_MAT4x3:                              AttributeType read _FLOAT_MAT4x3;
    public static property FLOAT_MAT4x3_NV:                           AttributeType read _FLOAT_MAT4x3_NV;
    public static property SAMPLER_BUFFER:                            AttributeType read _SAMPLER_BUFFER;
    public static property SAMPLER_1D_ARRAY_SHADOW:                   AttributeType read _SAMPLER_1D_ARRAY_SHADOW;
    public static property SAMPLER_2D_ARRAY_SHADOW:                   AttributeType read _SAMPLER_2D_ARRAY_SHADOW;
    public static property SAMPLER_CUBE_SHADOW:                       AttributeType read _SAMPLER_CUBE_SHADOW;
    public static property UNSIGNED_INT_VEC2:                         AttributeType read _UNSIGNED_INT_VEC2;
    public static property UNSIGNED_INT_VEC3:                         AttributeType read _UNSIGNED_INT_VEC3;
    public static property UNSIGNED_INT_VEC4:                         AttributeType read _UNSIGNED_INT_VEC4;
    public static property INT_SAMPLER_1D:                            AttributeType read _INT_SAMPLER_1D;
    public static property INT_SAMPLER_2D:                            AttributeType read _INT_SAMPLER_2D;
    public static property INT_SAMPLER_3D:                            AttributeType read _INT_SAMPLER_3D;
    public static property INT_SAMPLER_CUBE:                          AttributeType read _INT_SAMPLER_CUBE;
    public static property INT_SAMPLER_2D_RECT:                       AttributeType read _INT_SAMPLER_2D_RECT;
    public static property INT_SAMPLER_1D_ARRAY:                      AttributeType read _INT_SAMPLER_1D_ARRAY;
    public static property INT_SAMPLER_2D_ARRAY:                      AttributeType read _INT_SAMPLER_2D_ARRAY;
    public static property INT_SAMPLER_BUFFER:                        AttributeType read _INT_SAMPLER_BUFFER;
    public static property UNSIGNED_INT_SAMPLER_1D:                   AttributeType read _UNSIGNED_INT_SAMPLER_1D;
    public static property UNSIGNED_INT_SAMPLER_2D:                   AttributeType read _UNSIGNED_INT_SAMPLER_2D;
    public static property UNSIGNED_INT_SAMPLER_3D:                   AttributeType read _UNSIGNED_INT_SAMPLER_3D;
    public static property UNSIGNED_INT_SAMPLER_CUBE:                 AttributeType read _UNSIGNED_INT_SAMPLER_CUBE;
    public static property UNSIGNED_INT_SAMPLER_2D_RECT:              AttributeType read _UNSIGNED_INT_SAMPLER_2D_RECT;
    public static property UNSIGNED_INT_SAMPLER_1D_ARRAY:             AttributeType read _UNSIGNED_INT_SAMPLER_1D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_ARRAY:             AttributeType read _UNSIGNED_INT_SAMPLER_2D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_BUFFER:               AttributeType read _UNSIGNED_INT_SAMPLER_BUFFER;
    public static property DOUBLE_MAT2:                               AttributeType read _DOUBLE_MAT2;
    public static property DOUBLE_MAT3:                               AttributeType read _DOUBLE_MAT3;
    public static property DOUBLE_MAT4:                               AttributeType read _DOUBLE_MAT4;
    public static property DOUBLE_MAT2x3:                             AttributeType read _DOUBLE_MAT2x3;
    public static property DOUBLE_MAT2x4:                             AttributeType read _DOUBLE_MAT2x4;
    public static property DOUBLE_MAT3x2:                             AttributeType read _DOUBLE_MAT3x2;
    public static property DOUBLE_MAT3x4:                             AttributeType read _DOUBLE_MAT3x4;
    public static property DOUBLE_MAT4x2:                             AttributeType read _DOUBLE_MAT4x2;
    public static property DOUBLE_MAT4x3:                             AttributeType read _DOUBLE_MAT4x3;
    public static property INT64_VEC2_ARB:                            AttributeType read _INT64_VEC2_ARB;
    public static property INT64_VEC3_ARB:                            AttributeType read _INT64_VEC3_ARB;
    public static property INT64_VEC4_ARB:                            AttributeType read _INT64_VEC4_ARB;
    public static property UNSIGNED_INT64_VEC2_ARB:                   AttributeType read _UNSIGNED_INT64_VEC2_ARB;
    public static property UNSIGNED_INT64_VEC3_ARB:                   AttributeType read _UNSIGNED_INT64_VEC3_ARB;
    public static property UNSIGNED_INT64_VEC4_ARB:                   AttributeType read _UNSIGNED_INT64_VEC4_ARB;
    public static property DOUBLE_VEC2:                               AttributeType read _DOUBLE_VEC2;
    public static property DOUBLE_VEC3:                               AttributeType read _DOUBLE_VEC3;
    public static property DOUBLE_VEC4:                               AttributeType read _DOUBLE_VEC4;
    public static property SAMPLER_CUBE_MAP_ARRAY:                    AttributeType read _SAMPLER_CUBE_MAP_ARRAY;
    public static property SAMPLER_CUBE_MAP_ARRAY_SHADOW:             AttributeType read _SAMPLER_CUBE_MAP_ARRAY_SHADOW;
    public static property INT_SAMPLER_CUBE_MAP_ARRAY:                AttributeType read _INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY:       AttributeType read _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property IMAGE_1D:                                  AttributeType read _IMAGE_1D;
    public static property IMAGE_2D:                                  AttributeType read _IMAGE_2D;
    public static property IMAGE_3D:                                  AttributeType read _IMAGE_3D;
    public static property IMAGE_2D_RECT:                             AttributeType read _IMAGE_2D_RECT;
    public static property IMAGE_CUBE:                                AttributeType read _IMAGE_CUBE;
    public static property IMAGE_BUFFER:                              AttributeType read _IMAGE_BUFFER;
    public static property IMAGE_1D_ARRAY:                            AttributeType read _IMAGE_1D_ARRAY;
    public static property IMAGE_2D_ARRAY:                            AttributeType read _IMAGE_2D_ARRAY;
    public static property IMAGE_CUBE_MAP_ARRAY:                      AttributeType read _IMAGE_CUBE_MAP_ARRAY;
    public static property IMAGE_2D_MULTISAMPLE:                      AttributeType read _IMAGE_2D_MULTISAMPLE;
    public static property IMAGE_2D_MULTISAMPLE_ARRAY:                AttributeType read _IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property INT_IMAGE_1D:                              AttributeType read _INT_IMAGE_1D;
    public static property INT_IMAGE_2D:                              AttributeType read _INT_IMAGE_2D;
    public static property INT_IMAGE_3D:                              AttributeType read _INT_IMAGE_3D;
    public static property INT_IMAGE_2D_RECT:                         AttributeType read _INT_IMAGE_2D_RECT;
    public static property INT_IMAGE_CUBE:                            AttributeType read _INT_IMAGE_CUBE;
    public static property INT_IMAGE_BUFFER:                          AttributeType read _INT_IMAGE_BUFFER;
    public static property INT_IMAGE_1D_ARRAY:                        AttributeType read _INT_IMAGE_1D_ARRAY;
    public static property INT_IMAGE_2D_ARRAY:                        AttributeType read _INT_IMAGE_2D_ARRAY;
    public static property INT_IMAGE_CUBE_MAP_ARRAY:                  AttributeType read _INT_IMAGE_CUBE_MAP_ARRAY;
    public static property INT_IMAGE_2D_MULTISAMPLE:                  AttributeType read _INT_IMAGE_2D_MULTISAMPLE;
    public static property INT_IMAGE_2D_MULTISAMPLE_ARRAY:            AttributeType read _INT_IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_IMAGE_1D:                     AttributeType read _UNSIGNED_INT_IMAGE_1D;
    public static property UNSIGNED_INT_IMAGE_2D:                     AttributeType read _UNSIGNED_INT_IMAGE_2D;
    public static property UNSIGNED_INT_IMAGE_3D:                     AttributeType read _UNSIGNED_INT_IMAGE_3D;
    public static property UNSIGNED_INT_IMAGE_2D_RECT:                AttributeType read _UNSIGNED_INT_IMAGE_2D_RECT;
    public static property UNSIGNED_INT_IMAGE_CUBE:                   AttributeType read _UNSIGNED_INT_IMAGE_CUBE;
    public static property UNSIGNED_INT_IMAGE_BUFFER:                 AttributeType read _UNSIGNED_INT_IMAGE_BUFFER;
    public static property UNSIGNED_INT_IMAGE_1D_ARRAY:               AttributeType read _UNSIGNED_INT_IMAGE_1D_ARRAY;
    public static property UNSIGNED_INT_IMAGE_2D_ARRAY:               AttributeType read _UNSIGNED_INT_IMAGE_2D_ARRAY;
    public static property UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY:         AttributeType read _UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY;
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE:         AttributeType read _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE;
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY:   AttributeType read _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property SAMPLER_2D_MULTISAMPLE:                    AttributeType read _SAMPLER_2D_MULTISAMPLE;
    public static property INT_SAMPLER_2D_MULTISAMPLE:                AttributeType read _INT_SAMPLER_2D_MULTISAMPLE;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE:       AttributeType read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE;
    public static property SAMPLER_2D_MULTISAMPLE_ARRAY:              AttributeType read _SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property INT_SAMPLER_2D_MULTISAMPLE_ARRAY:          AttributeType read _INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: AttributeType read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    
    public function ToString: string; override;
    begin
      var res := typeof(AttributeType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->AttributeType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'AttributeType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BindTransformFeedbackTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TRANSFORM_FEEDBACK := new BindTransformFeedbackTarget($8E22);
    
    public static property TRANSFORM_FEEDBACK: BindTransformFeedbackTarget read _TRANSFORM_FEEDBACK;
    
    public function ToString: string; override;
    begin
      var res := typeof(BindTransformFeedbackTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BindTransformFeedbackTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BindTransformFeedbackTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BlendingFactor = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ZERO                     := new BlendingFactor($0000);
    private static _ONE                      := new BlendingFactor($0001);
    private static _SRC_COLOR                := new BlendingFactor($0300);
    private static _ONE_MINUS_SRC_COLOR      := new BlendingFactor($0301);
    private static _SRC_ALPHA                := new BlendingFactor($0302);
    private static _ONE_MINUS_SRC_ALPHA      := new BlendingFactor($0303);
    private static _DST_ALPHA                := new BlendingFactor($0304);
    private static _ONE_MINUS_DST_ALPHA      := new BlendingFactor($0305);
    private static _DST_COLOR                := new BlendingFactor($0306);
    private static _ONE_MINUS_DST_COLOR      := new BlendingFactor($0307);
    private static _SRC_ALPHA_SATURATE       := new BlendingFactor($0308);
    private static _CONSTANT_COLOR           := new BlendingFactor($8001);
    private static _ONE_MINUS_CONSTANT_COLOR := new BlendingFactor($8002);
    private static _CONSTANT_ALPHA           := new BlendingFactor($8003);
    private static _ONE_MINUS_CONSTANT_ALPHA := new BlendingFactor($8004);
    private static _SRC1_ALPHA               := new BlendingFactor($8589);
    private static _SRC1_COLOR               := new BlendingFactor($88F9);
    private static _ONE_MINUS_SRC1_COLOR     := new BlendingFactor($88FA);
    private static _ONE_MINUS_SRC1_ALPHA     := new BlendingFactor($88FB);
    
    public static property ZERO:                     BlendingFactor read _ZERO;
    public static property ONE:                      BlendingFactor read _ONE;
    public static property SRC_COLOR:                BlendingFactor read _SRC_COLOR;
    public static property ONE_MINUS_SRC_COLOR:      BlendingFactor read _ONE_MINUS_SRC_COLOR;
    public static property SRC_ALPHA:                BlendingFactor read _SRC_ALPHA;
    public static property ONE_MINUS_SRC_ALPHA:      BlendingFactor read _ONE_MINUS_SRC_ALPHA;
    public static property DST_ALPHA:                BlendingFactor read _DST_ALPHA;
    public static property ONE_MINUS_DST_ALPHA:      BlendingFactor read _ONE_MINUS_DST_ALPHA;
    public static property DST_COLOR:                BlendingFactor read _DST_COLOR;
    public static property ONE_MINUS_DST_COLOR:      BlendingFactor read _ONE_MINUS_DST_COLOR;
    public static property SRC_ALPHA_SATURATE:       BlendingFactor read _SRC_ALPHA_SATURATE;
    public static property CONSTANT_COLOR:           BlendingFactor read _CONSTANT_COLOR;
    public static property ONE_MINUS_CONSTANT_COLOR: BlendingFactor read _ONE_MINUS_CONSTANT_COLOR;
    public static property CONSTANT_ALPHA:           BlendingFactor read _CONSTANT_ALPHA;
    public static property ONE_MINUS_CONSTANT_ALPHA: BlendingFactor read _ONE_MINUS_CONSTANT_ALPHA;
    public static property SRC1_ALPHA:               BlendingFactor read _SRC1_ALPHA;
    public static property SRC1_COLOR:               BlendingFactor read _SRC1_COLOR;
    public static property ONE_MINUS_SRC1_COLOR:     BlendingFactor read _ONE_MINUS_SRC1_COLOR;
    public static property ONE_MINUS_SRC1_ALPHA:     BlendingFactor read _ONE_MINUS_SRC1_ALPHA;
    
    public function ToString: string; override;
    begin
      var res := typeof(BlendingFactor).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BlendingFactor(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BlendingFactor[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BlitFramebufferFilter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEAREST := new BlitFramebufferFilter($2600);
    private static _LINEAR  := new BlitFramebufferFilter($2601);
    
    public static property NEAREST: BlitFramebufferFilter read _NEAREST;
    public static property LINEAR:  BlitFramebufferFilter read _LINEAR;
    
    public function ToString: string; override;
    begin
      var res := typeof(BlitFramebufferFilter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BlitFramebufferFilter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BlitFramebufferFilter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  Buffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR   := new Buffer($1800);
    private static _DEPTH   := new Buffer($1801);
    private static _STENCIL := new Buffer($1802);
    
    public static property COLOR:   Buffer read _COLOR;
    public static property DEPTH:   Buffer read _DEPTH;
    public static property STENCIL: Buffer read _STENCIL;
    
    public function ToString: string; override;
    begin
      var res := typeof(Buffer).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->Buffer(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'Buffer[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BufferStorageMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP_READ_BIT                  := new BufferStorageMask($0001);
    private static _MAP_READ_BIT_EXT              := new BufferStorageMask($0001);
    private static _MAP_WRITE_BIT                 := new BufferStorageMask($0002);
    private static _MAP_WRITE_BIT_EXT             := new BufferStorageMask($0002);
    private static _MAP_PERSISTENT_BIT            := new BufferStorageMask($0040);
    private static _MAP_PERSISTENT_BIT_EXT        := new BufferStorageMask($0040);
    private static _MAP_COHERENT_BIT              := new BufferStorageMask($0080);
    private static _MAP_COHERENT_BIT_EXT          := new BufferStorageMask($0080);
    private static _DYNAMIC_STORAGE_BIT           := new BufferStorageMask($0100);
    private static _DYNAMIC_STORAGE_BIT_EXT       := new BufferStorageMask($0100);
    private static _CLIENT_STORAGE_BIT            := new BufferStorageMask($0200);
    private static _CLIENT_STORAGE_BIT_EXT        := new BufferStorageMask($0200);
    private static _SPARSE_STORAGE_BIT_ARB        := new BufferStorageMask($0400);
    private static _LGPU_SEPARATE_STORAGE_BIT_NVX := new BufferStorageMask($0800);
    private static _PER_GPU_STORAGE_BIT_NV        := new BufferStorageMask($0800);
    private static _EXTERNAL_STORAGE_BIT_NVX      := new BufferStorageMask($2000);
    
    public static property MAP_READ_BIT:                  BufferStorageMask read _MAP_READ_BIT;
    public static property MAP_READ_BIT_EXT:              BufferStorageMask read _MAP_READ_BIT_EXT;
    public static property MAP_WRITE_BIT:                 BufferStorageMask read _MAP_WRITE_BIT;
    public static property MAP_WRITE_BIT_EXT:             BufferStorageMask read _MAP_WRITE_BIT_EXT;
    public static property MAP_PERSISTENT_BIT:            BufferStorageMask read _MAP_PERSISTENT_BIT;
    public static property MAP_PERSISTENT_BIT_EXT:        BufferStorageMask read _MAP_PERSISTENT_BIT_EXT;
    public static property MAP_COHERENT_BIT:              BufferStorageMask read _MAP_COHERENT_BIT;
    public static property MAP_COHERENT_BIT_EXT:          BufferStorageMask read _MAP_COHERENT_BIT_EXT;
    public static property DYNAMIC_STORAGE_BIT:           BufferStorageMask read _DYNAMIC_STORAGE_BIT;
    public static property DYNAMIC_STORAGE_BIT_EXT:       BufferStorageMask read _DYNAMIC_STORAGE_BIT_EXT;
    public static property CLIENT_STORAGE_BIT:            BufferStorageMask read _CLIENT_STORAGE_BIT;
    public static property CLIENT_STORAGE_BIT_EXT:        BufferStorageMask read _CLIENT_STORAGE_BIT_EXT;
    public static property SPARSE_STORAGE_BIT_ARB:        BufferStorageMask read _SPARSE_STORAGE_BIT_ARB;
    public static property LGPU_SEPARATE_STORAGE_BIT_NVX: BufferStorageMask read _LGPU_SEPARATE_STORAGE_BIT_NVX;
    public static property PER_GPU_STORAGE_BIT_NV:        BufferStorageMask read _PER_GPU_STORAGE_BIT_NV;
    public static property EXTERNAL_STORAGE_BIT_NVX:      BufferStorageMask read _EXTERNAL_STORAGE_BIT_NVX;
    
    public static function operator or(f1,f2: BufferStorageMask) := new BufferStorageMask(f1.val or f2.val);
    
    public property HAS_FLAG_MAP_READ_BIT:                  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_READ_BIT_EXT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT:                 boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT_EXT:             boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT:            boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT_EXT:        boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT_EXT:          boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_DYNAMIC_STORAGE_BIT:           boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_DYNAMIC_STORAGE_BIT_EXT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_CLIENT_STORAGE_BIT:            boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_CLIENT_STORAGE_BIT_EXT:        boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_SPARSE_STORAGE_BIT_ARB:        boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_LGPU_SEPARATE_STORAGE_BIT_NVX: boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_PER_GPU_STORAGE_BIT_NV:        boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_EXTERNAL_STORAGE_BIT_NVX:      boolean read self.val and $2000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferStorageMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'BufferStorageMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  BufferStorageTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ARRAY_BUFFER              := new BufferStorageTarget($8892);
    private static _ELEMENT_ARRAY_BUFFER      := new BufferStorageTarget($8893);
    private static _PIXEL_PACK_BUFFER         := new BufferStorageTarget($88EB);
    private static _PIXEL_UNPACK_BUFFER       := new BufferStorageTarget($88EC);
    private static _UNIFORM_BUFFER            := new BufferStorageTarget($8A11);
    private static _TEXTURE_BUFFER            := new BufferStorageTarget($8C2A);
    private static _TRANSFORM_FEEDBACK_BUFFER := new BufferStorageTarget($8C8E);
    private static _COPY_READ_BUFFER          := new BufferStorageTarget($8F36);
    private static _COPY_WRITE_BUFFER         := new BufferStorageTarget($8F37);
    private static _DRAW_INDIRECT_BUFFER      := new BufferStorageTarget($8F3F);
    private static _SHADER_STORAGE_BUFFER     := new BufferStorageTarget($90D2);
    private static _DISPATCH_INDIRECT_BUFFER  := new BufferStorageTarget($90EE);
    private static _QUERY_BUFFER              := new BufferStorageTarget($9192);
    private static _ATOMIC_COUNTER_BUFFER     := new BufferStorageTarget($92C0);
    
    public static property ARRAY_BUFFER:              BufferStorageTarget read _ARRAY_BUFFER;
    public static property ELEMENT_ARRAY_BUFFER:      BufferStorageTarget read _ELEMENT_ARRAY_BUFFER;
    public static property PIXEL_PACK_BUFFER:         BufferStorageTarget read _PIXEL_PACK_BUFFER;
    public static property PIXEL_UNPACK_BUFFER:       BufferStorageTarget read _PIXEL_UNPACK_BUFFER;
    public static property UNIFORM_BUFFER:            BufferStorageTarget read _UNIFORM_BUFFER;
    public static property TEXTURE_BUFFER:            BufferStorageTarget read _TEXTURE_BUFFER;
    public static property TRANSFORM_FEEDBACK_BUFFER: BufferStorageTarget read _TRANSFORM_FEEDBACK_BUFFER;
    public static property COPY_READ_BUFFER:          BufferStorageTarget read _COPY_READ_BUFFER;
    public static property COPY_WRITE_BUFFER:         BufferStorageTarget read _COPY_WRITE_BUFFER;
    public static property DRAW_INDIRECT_BUFFER:      BufferStorageTarget read _DRAW_INDIRECT_BUFFER;
    public static property SHADER_STORAGE_BUFFER:     BufferStorageTarget read _SHADER_STORAGE_BUFFER;
    public static property DISPATCH_INDIRECT_BUFFER:  BufferStorageTarget read _DISPATCH_INDIRECT_BUFFER;
    public static property QUERY_BUFFER:              BufferStorageTarget read _QUERY_BUFFER;
    public static property ATOMIC_COUNTER_BUFFER:     BufferStorageTarget read _ATOMIC_COUNTER_BUFFER;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferStorageTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferStorageTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferStorageTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ClearBufferMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DEPTH_BUFFER_BIT       := new ClearBufferMask($0100);
    private static _ACCUM_BUFFER_BIT       := new ClearBufferMask($0200);
    private static _STENCIL_BUFFER_BIT     := new ClearBufferMask($0400);
    private static _COLOR_BUFFER_BIT       := new ClearBufferMask($4000);
    private static _COVERAGE_BUFFER_BIT_NV := new ClearBufferMask($8000);
    
    public static property DEPTH_BUFFER_BIT:       ClearBufferMask read _DEPTH_BUFFER_BIT;
    public static property ACCUM_BUFFER_BIT:       ClearBufferMask read _ACCUM_BUFFER_BIT;
    public static property STENCIL_BUFFER_BIT:     ClearBufferMask read _STENCIL_BUFFER_BIT;
    public static property COLOR_BUFFER_BIT:       ClearBufferMask read _COLOR_BUFFER_BIT;
    public static property COVERAGE_BUFFER_BIT_NV: ClearBufferMask read _COVERAGE_BUFFER_BIT_NV;
    
    public static function operator or(f1,f2: ClearBufferMask) := new ClearBufferMask(f1.val or f2.val);
    
    public property HAS_FLAG_DEPTH_BUFFER_BIT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_ACCUM_BUFFER_BIT:       boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_STENCIL_BUFFER_BIT:     boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_COLOR_BUFFER_BIT:       boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_COVERAGE_BUFFER_BIT_NV: boolean read self.val and $8000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClearBufferMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'ClearBufferMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  ClientAttribMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CLIENT_PIXEL_STORE_BIT  := new ClientAttribMask($0001);
    private static _CLIENT_VERTEX_ARRAY_BIT := new ClientAttribMask($0002);
    private static _CLIENT_ALL_ATTRIB_BITS  := new ClientAttribMask($FFFFFFFF);
    
    public static property CLIENT_PIXEL_STORE_BIT:  ClientAttribMask read _CLIENT_PIXEL_STORE_BIT;
    public static property CLIENT_VERTEX_ARRAY_BIT: ClientAttribMask read _CLIENT_VERTEX_ARRAY_BIT;
    public static property CLIENT_ALL_ATTRIB_BITS:  ClientAttribMask read _CLIENT_ALL_ATTRIB_BITS;
    
    public static function operator or(f1,f2: ClientAttribMask) := new ClientAttribMask(f1.val or f2.val);
    
    public property HAS_FLAG_CLIENT_PIXEL_STORE_BIT:  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_CLIENT_VERTEX_ARRAY_BIT: boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_CLIENT_ALL_ATTRIB_BITS:  boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClientAttribMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'ClientAttribMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  ClipControlDepth = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEGATIVE_ONE_TO_ONE := new ClipControlDepth($935E);
    private static _ZERO_TO_ONE         := new ClipControlDepth($935F);
    
    public static property NEGATIVE_ONE_TO_ONE: ClipControlDepth read _NEGATIVE_ONE_TO_ONE;
    public static property ZERO_TO_ONE:         ClipControlDepth read _ZERO_TO_ONE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClipControlDepth).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ClipControlDepth(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ClipControlDepth[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ClipControlOrigin = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LOWER_LEFT := new ClipControlOrigin($8CA1);
    private static _UPPER_LEFT := new ClipControlOrigin($8CA2);
    
    public static property LOWER_LEFT: ClipControlOrigin read _LOWER_LEFT;
    public static property UPPER_LEFT: ClipControlOrigin read _UPPER_LEFT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClipControlOrigin).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ClipControlOrigin(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ClipControlOrigin[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ClipPlaneName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CLIP_DISTANCE0 := new ClipPlaneName($3000);
    private static _CLIP_PLANE0    := new ClipPlaneName($3000);
    private static _CLIP_DISTANCE1 := new ClipPlaneName($3001);
    private static _CLIP_PLANE1    := new ClipPlaneName($3001);
    private static _CLIP_DISTANCE2 := new ClipPlaneName($3002);
    private static _CLIP_PLANE2    := new ClipPlaneName($3002);
    private static _CLIP_DISTANCE3 := new ClipPlaneName($3003);
    private static _CLIP_PLANE3    := new ClipPlaneName($3003);
    private static _CLIP_DISTANCE4 := new ClipPlaneName($3004);
    private static _CLIP_PLANE4    := new ClipPlaneName($3004);
    private static _CLIP_DISTANCE5 := new ClipPlaneName($3005);
    private static _CLIP_PLANE5    := new ClipPlaneName($3005);
    private static _CLIP_DISTANCE6 := new ClipPlaneName($3006);
    private static _CLIP_DISTANCE7 := new ClipPlaneName($3007);
    
    public static property CLIP_DISTANCE0: ClipPlaneName read _CLIP_DISTANCE0;
    public static property CLIP_PLANE0:    ClipPlaneName read _CLIP_PLANE0;
    public static property CLIP_DISTANCE1: ClipPlaneName read _CLIP_DISTANCE1;
    public static property CLIP_PLANE1:    ClipPlaneName read _CLIP_PLANE1;
    public static property CLIP_DISTANCE2: ClipPlaneName read _CLIP_DISTANCE2;
    public static property CLIP_PLANE2:    ClipPlaneName read _CLIP_PLANE2;
    public static property CLIP_DISTANCE3: ClipPlaneName read _CLIP_DISTANCE3;
    public static property CLIP_PLANE3:    ClipPlaneName read _CLIP_PLANE3;
    public static property CLIP_DISTANCE4: ClipPlaneName read _CLIP_DISTANCE4;
    public static property CLIP_PLANE4:    ClipPlaneName read _CLIP_PLANE4;
    public static property CLIP_DISTANCE5: ClipPlaneName read _CLIP_DISTANCE5;
    public static property CLIP_PLANE5:    ClipPlaneName read _CLIP_PLANE5;
    public static property CLIP_DISTANCE6: ClipPlaneName read _CLIP_DISTANCE6;
    public static property CLIP_DISTANCE7: ClipPlaneName read _CLIP_DISTANCE7;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClipPlaneName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ClipPlaneName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ClipPlaneName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ColorBuffer = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE               := new ColorBuffer($0000);
    private static _FRONT_LEFT         := new ColorBuffer($0400);
    private static _FRONT_RIGHT        := new ColorBuffer($0401);
    private static _BACK_LEFT          := new ColorBuffer($0402);
    private static _BACK_RIGHT         := new ColorBuffer($0403);
    private static _FRONT              := new ColorBuffer($0404);
    private static _BACK               := new ColorBuffer($0405);
    private static _LEFT               := new ColorBuffer($0406);
    private static _RIGHT              := new ColorBuffer($0407);
    private static _FRONT_AND_BACK     := new ColorBuffer($0408);
    private static _COLOR_ATTACHMENT0  := new ColorBuffer($8CE0);
    private static _COLOR_ATTACHMENT1  := new ColorBuffer($8CE1);
    private static _COLOR_ATTACHMENT2  := new ColorBuffer($8CE2);
    private static _COLOR_ATTACHMENT3  := new ColorBuffer($8CE3);
    private static _COLOR_ATTACHMENT4  := new ColorBuffer($8CE4);
    private static _COLOR_ATTACHMENT5  := new ColorBuffer($8CE5);
    private static _COLOR_ATTACHMENT6  := new ColorBuffer($8CE6);
    private static _COLOR_ATTACHMENT7  := new ColorBuffer($8CE7);
    private static _COLOR_ATTACHMENT8  := new ColorBuffer($8CE8);
    private static _COLOR_ATTACHMENT9  := new ColorBuffer($8CE9);
    private static _COLOR_ATTACHMENT10 := new ColorBuffer($8CEA);
    private static _COLOR_ATTACHMENT11 := new ColorBuffer($8CEB);
    private static _COLOR_ATTACHMENT12 := new ColorBuffer($8CEC);
    private static _COLOR_ATTACHMENT13 := new ColorBuffer($8CED);
    private static _COLOR_ATTACHMENT14 := new ColorBuffer($8CEE);
    private static _COLOR_ATTACHMENT15 := new ColorBuffer($8CEF);
    private static _COLOR_ATTACHMENT16 := new ColorBuffer($8CF0);
    private static _COLOR_ATTACHMENT17 := new ColorBuffer($8CF1);
    private static _COLOR_ATTACHMENT18 := new ColorBuffer($8CF2);
    private static _COLOR_ATTACHMENT19 := new ColorBuffer($8CF3);
    private static _COLOR_ATTACHMENT20 := new ColorBuffer($8CF4);
    private static _COLOR_ATTACHMENT21 := new ColorBuffer($8CF5);
    private static _COLOR_ATTACHMENT22 := new ColorBuffer($8CF6);
    private static _COLOR_ATTACHMENT23 := new ColorBuffer($8CF7);
    private static _COLOR_ATTACHMENT24 := new ColorBuffer($8CF8);
    private static _COLOR_ATTACHMENT25 := new ColorBuffer($8CF9);
    private static _COLOR_ATTACHMENT26 := new ColorBuffer($8CFA);
    private static _COLOR_ATTACHMENT27 := new ColorBuffer($8CFB);
    private static _COLOR_ATTACHMENT28 := new ColorBuffer($8CFC);
    private static _COLOR_ATTACHMENT29 := new ColorBuffer($8CFD);
    private static _COLOR_ATTACHMENT30 := new ColorBuffer($8CFE);
    private static _COLOR_ATTACHMENT31 := new ColorBuffer($8CFF);
    
    public static property NONE:               ColorBuffer read _NONE;
    public static property FRONT_LEFT:         ColorBuffer read _FRONT_LEFT;
    public static property FRONT_RIGHT:        ColorBuffer read _FRONT_RIGHT;
    public static property BACK_LEFT:          ColorBuffer read _BACK_LEFT;
    public static property BACK_RIGHT:         ColorBuffer read _BACK_RIGHT;
    public static property FRONT:              ColorBuffer read _FRONT;
    public static property BACK:               ColorBuffer read _BACK;
    public static property LEFT:               ColorBuffer read _LEFT;
    public static property RIGHT:              ColorBuffer read _RIGHT;
    public static property FRONT_AND_BACK:     ColorBuffer read _FRONT_AND_BACK;
    public static property COLOR_ATTACHMENT0:  ColorBuffer read _COLOR_ATTACHMENT0;
    public static property COLOR_ATTACHMENT1:  ColorBuffer read _COLOR_ATTACHMENT1;
    public static property COLOR_ATTACHMENT2:  ColorBuffer read _COLOR_ATTACHMENT2;
    public static property COLOR_ATTACHMENT3:  ColorBuffer read _COLOR_ATTACHMENT3;
    public static property COLOR_ATTACHMENT4:  ColorBuffer read _COLOR_ATTACHMENT4;
    public static property COLOR_ATTACHMENT5:  ColorBuffer read _COLOR_ATTACHMENT5;
    public static property COLOR_ATTACHMENT6:  ColorBuffer read _COLOR_ATTACHMENT6;
    public static property COLOR_ATTACHMENT7:  ColorBuffer read _COLOR_ATTACHMENT7;
    public static property COLOR_ATTACHMENT8:  ColorBuffer read _COLOR_ATTACHMENT8;
    public static property COLOR_ATTACHMENT9:  ColorBuffer read _COLOR_ATTACHMENT9;
    public static property COLOR_ATTACHMENT10: ColorBuffer read _COLOR_ATTACHMENT10;
    public static property COLOR_ATTACHMENT11: ColorBuffer read _COLOR_ATTACHMENT11;
    public static property COLOR_ATTACHMENT12: ColorBuffer read _COLOR_ATTACHMENT12;
    public static property COLOR_ATTACHMENT13: ColorBuffer read _COLOR_ATTACHMENT13;
    public static property COLOR_ATTACHMENT14: ColorBuffer read _COLOR_ATTACHMENT14;
    public static property COLOR_ATTACHMENT15: ColorBuffer read _COLOR_ATTACHMENT15;
    public static property COLOR_ATTACHMENT16: ColorBuffer read _COLOR_ATTACHMENT16;
    public static property COLOR_ATTACHMENT17: ColorBuffer read _COLOR_ATTACHMENT17;
    public static property COLOR_ATTACHMENT18: ColorBuffer read _COLOR_ATTACHMENT18;
    public static property COLOR_ATTACHMENT19: ColorBuffer read _COLOR_ATTACHMENT19;
    public static property COLOR_ATTACHMENT20: ColorBuffer read _COLOR_ATTACHMENT20;
    public static property COLOR_ATTACHMENT21: ColorBuffer read _COLOR_ATTACHMENT21;
    public static property COLOR_ATTACHMENT22: ColorBuffer read _COLOR_ATTACHMENT22;
    public static property COLOR_ATTACHMENT23: ColorBuffer read _COLOR_ATTACHMENT23;
    public static property COLOR_ATTACHMENT24: ColorBuffer read _COLOR_ATTACHMENT24;
    public static property COLOR_ATTACHMENT25: ColorBuffer read _COLOR_ATTACHMENT25;
    public static property COLOR_ATTACHMENT26: ColorBuffer read _COLOR_ATTACHMENT26;
    public static property COLOR_ATTACHMENT27: ColorBuffer read _COLOR_ATTACHMENT27;
    public static property COLOR_ATTACHMENT28: ColorBuffer read _COLOR_ATTACHMENT28;
    public static property COLOR_ATTACHMENT29: ColorBuffer read _COLOR_ATTACHMENT29;
    public static property COLOR_ATTACHMENT30: ColorBuffer read _COLOR_ATTACHMENT30;
    public static property COLOR_ATTACHMENT31: ColorBuffer read _COLOR_ATTACHMENT31;
    
    public function ToString: string; override;
    begin
      var res := typeof(ColorBuffer).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ColorBuffer(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ColorBuffer[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ColorMaterialParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _AMBIENT             := new ColorMaterialParameter($1200);
    private static _DIFFUSE             := new ColorMaterialParameter($1201);
    private static _SPECULAR            := new ColorMaterialParameter($1202);
    private static _EMISSION            := new ColorMaterialParameter($1600);
    private static _AMBIENT_AND_DIFFUSE := new ColorMaterialParameter($1602);
    
    public static property AMBIENT:             ColorMaterialParameter read _AMBIENT;
    public static property DIFFUSE:             ColorMaterialParameter read _DIFFUSE;
    public static property SPECULAR:            ColorMaterialParameter read _SPECULAR;
    public static property EMISSION:            ColorMaterialParameter read _EMISSION;
    public static property AMBIENT_AND_DIFFUSE: ColorMaterialParameter read _AMBIENT_AND_DIFFUSE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ColorMaterialParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ColorMaterialParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ColorMaterialParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ColorPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE           := new ColorPointerType($1400);
    private static _UNSIGNED_BYTE  := new ColorPointerType($1401);
    private static _UNSIGNED_SHORT := new ColorPointerType($1403);
    private static _UNSIGNED_INT   := new ColorPointerType($1405);
    
    public static property BYTE:           ColorPointerType read _BYTE;
    public static property UNSIGNED_BYTE:  ColorPointerType read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: ColorPointerType read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   ColorPointerType read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ColorPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ColorPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ColorPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ColorTableTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR_TABLE                   := new ColorTableTarget($80D0);
    private static _POST_CONVOLUTION_COLOR_TABLE  := new ColorTableTarget($80D1);
    private static _POST_COLOR_MATRIX_COLOR_TABLE := new ColorTableTarget($80D2);
    
    public static property COLOR_TABLE:                   ColorTableTarget read _COLOR_TABLE;
    public static property POST_CONVOLUTION_COLOR_TABLE:  ColorTableTarget read _POST_CONVOLUTION_COLOR_TABLE;
    public static property POST_COLOR_MATRIX_COLOR_TABLE: ColorTableTarget read _POST_COLOR_MATRIX_COLOR_TABLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ColorTableTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ColorTableTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ColorTableTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ConditionalRenderMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _QUERY_WAIT                       := new ConditionalRenderMode($8E13);
    private static _QUERY_NO_WAIT                    := new ConditionalRenderMode($8E14);
    private static _QUERY_BY_REGION_WAIT             := new ConditionalRenderMode($8E15);
    private static _QUERY_BY_REGION_NO_WAIT          := new ConditionalRenderMode($8E16);
    private static _QUERY_WAIT_INVERTED              := new ConditionalRenderMode($8E17);
    private static _QUERY_NO_WAIT_INVERTED           := new ConditionalRenderMode($8E18);
    private static _QUERY_BY_REGION_WAIT_INVERTED    := new ConditionalRenderMode($8E19);
    private static _QUERY_BY_REGION_NO_WAIT_INVERTED := new ConditionalRenderMode($8E1A);
    
    public static property QUERY_WAIT:                       ConditionalRenderMode read _QUERY_WAIT;
    public static property QUERY_NO_WAIT:                    ConditionalRenderMode read _QUERY_NO_WAIT;
    public static property QUERY_BY_REGION_WAIT:             ConditionalRenderMode read _QUERY_BY_REGION_WAIT;
    public static property QUERY_BY_REGION_NO_WAIT:          ConditionalRenderMode read _QUERY_BY_REGION_NO_WAIT;
    public static property QUERY_WAIT_INVERTED:              ConditionalRenderMode read _QUERY_WAIT_INVERTED;
    public static property QUERY_NO_WAIT_INVERTED:           ConditionalRenderMode read _QUERY_NO_WAIT_INVERTED;
    public static property QUERY_BY_REGION_WAIT_INVERTED:    ConditionalRenderMode read _QUERY_BY_REGION_WAIT_INVERTED;
    public static property QUERY_BY_REGION_NO_WAIT_INVERTED: ConditionalRenderMode read _QUERY_BY_REGION_NO_WAIT_INVERTED;
    
    public function ToString: string; override;
    begin
      var res := typeof(ConditionalRenderMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ConditionalRenderMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ConditionalRenderMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ConvolutionTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CONVOLUTION_1D := new ConvolutionTarget($8010);
    private static _CONVOLUTION_2D := new ConvolutionTarget($8011);
    
    public static property CONVOLUTION_1D: ConvolutionTarget read _CONVOLUTION_1D;
    public static property CONVOLUTION_2D: ConvolutionTarget read _CONVOLUTION_2D;
    
    public function ToString: string; override;
    begin
      var res := typeof(ConvolutionTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ConvolutionTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ConvolutionTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CopyBufferSubDataTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ARRAY_BUFFER              := new CopyBufferSubDataTarget($8892);
    private static _ELEMENT_ARRAY_BUFFER      := new CopyBufferSubDataTarget($8893);
    private static _PIXEL_PACK_BUFFER         := new CopyBufferSubDataTarget($88EB);
    private static _PIXEL_UNPACK_BUFFER       := new CopyBufferSubDataTarget($88EC);
    private static _UNIFORM_BUFFER            := new CopyBufferSubDataTarget($8A11);
    private static _TEXTURE_BUFFER            := new CopyBufferSubDataTarget($8C2A);
    private static _TRANSFORM_FEEDBACK_BUFFER := new CopyBufferSubDataTarget($8C8E);
    private static _COPY_READ_BUFFER          := new CopyBufferSubDataTarget($8F36);
    private static _COPY_WRITE_BUFFER         := new CopyBufferSubDataTarget($8F37);
    private static _DRAW_INDIRECT_BUFFER      := new CopyBufferSubDataTarget($8F3F);
    private static _SHADER_STORAGE_BUFFER     := new CopyBufferSubDataTarget($90D2);
    private static _DISPATCH_INDIRECT_BUFFER  := new CopyBufferSubDataTarget($90EE);
    private static _QUERY_BUFFER              := new CopyBufferSubDataTarget($9192);
    private static _ATOMIC_COUNTER_BUFFER     := new CopyBufferSubDataTarget($92C0);
    
    public static property ARRAY_BUFFER:              CopyBufferSubDataTarget read _ARRAY_BUFFER;
    public static property ELEMENT_ARRAY_BUFFER:      CopyBufferSubDataTarget read _ELEMENT_ARRAY_BUFFER;
    public static property PIXEL_PACK_BUFFER:         CopyBufferSubDataTarget read _PIXEL_PACK_BUFFER;
    public static property PIXEL_UNPACK_BUFFER:       CopyBufferSubDataTarget read _PIXEL_UNPACK_BUFFER;
    public static property UNIFORM_BUFFER:            CopyBufferSubDataTarget read _UNIFORM_BUFFER;
    public static property TEXTURE_BUFFER:            CopyBufferSubDataTarget read _TEXTURE_BUFFER;
    public static property TRANSFORM_FEEDBACK_BUFFER: CopyBufferSubDataTarget read _TRANSFORM_FEEDBACK_BUFFER;
    public static property COPY_READ_BUFFER:          CopyBufferSubDataTarget read _COPY_READ_BUFFER;
    public static property COPY_WRITE_BUFFER:         CopyBufferSubDataTarget read _COPY_WRITE_BUFFER;
    public static property DRAW_INDIRECT_BUFFER:      CopyBufferSubDataTarget read _DRAW_INDIRECT_BUFFER;
    public static property SHADER_STORAGE_BUFFER:     CopyBufferSubDataTarget read _SHADER_STORAGE_BUFFER;
    public static property DISPATCH_INDIRECT_BUFFER:  CopyBufferSubDataTarget read _DISPATCH_INDIRECT_BUFFER;
    public static property QUERY_BUFFER:              CopyBufferSubDataTarget read _QUERY_BUFFER;
    public static property ATOMIC_COUNTER_BUFFER:     CopyBufferSubDataTarget read _ATOMIC_COUNTER_BUFFER;
    
    public function ToString: string; override;
    begin
      var res := typeof(CopyBufferSubDataTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CopyBufferSubDataTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CopyBufferSubDataTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CopyImageSubDataTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_1D                   := new CopyImageSubDataTarget($0DE0);
    private static _TEXTURE_2D                   := new CopyImageSubDataTarget($0DE1);
    private static _TEXTURE_3D                   := new CopyImageSubDataTarget($806F);
    private static _TEXTURE_RECTANGLE            := new CopyImageSubDataTarget($84F5);
    private static _TEXTURE_CUBE_MAP             := new CopyImageSubDataTarget($8513);
    private static _TEXTURE_1D_ARRAY             := new CopyImageSubDataTarget($8C18);
    private static _TEXTURE_2D_ARRAY             := new CopyImageSubDataTarget($8C1A);
    private static _RENDERBUFFER                 := new CopyImageSubDataTarget($8D41);
    private static _TEXTURE_CUBE_MAP_ARRAY       := new CopyImageSubDataTarget($9009);
    private static _TEXTURE_2D_MULTISAMPLE       := new CopyImageSubDataTarget($9100);
    private static _TEXTURE_2D_MULTISAMPLE_ARRAY := new CopyImageSubDataTarget($9102);
    
    public static property TEXTURE_1D:                   CopyImageSubDataTarget read _TEXTURE_1D;
    public static property TEXTURE_2D:                   CopyImageSubDataTarget read _TEXTURE_2D;
    public static property TEXTURE_3D:                   CopyImageSubDataTarget read _TEXTURE_3D;
    public static property TEXTURE_RECTANGLE:            CopyImageSubDataTarget read _TEXTURE_RECTANGLE;
    public static property TEXTURE_CUBE_MAP:             CopyImageSubDataTarget read _TEXTURE_CUBE_MAP;
    public static property TEXTURE_1D_ARRAY:             CopyImageSubDataTarget read _TEXTURE_1D_ARRAY;
    public static property TEXTURE_2D_ARRAY:             CopyImageSubDataTarget read _TEXTURE_2D_ARRAY;
    public static property RENDERBUFFER:                 CopyImageSubDataTarget read _RENDERBUFFER;
    public static property TEXTURE_CUBE_MAP_ARRAY:       CopyImageSubDataTarget read _TEXTURE_CUBE_MAP_ARRAY;
    public static property TEXTURE_2D_MULTISAMPLE:       CopyImageSubDataTarget read _TEXTURE_2D_MULTISAMPLE;
    public static property TEXTURE_2D_MULTISAMPLE_ARRAY: CopyImageSubDataTarget read _TEXTURE_2D_MULTISAMPLE_ARRAY;
    
    public function ToString: string; override;
    begin
      var res := typeof(CopyImageSubDataTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CopyImageSubDataTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CopyImageSubDataTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CullFaceMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRONT          := new CullFaceMode($0404);
    private static _BACK           := new CullFaceMode($0405);
    private static _FRONT_AND_BACK := new CullFaceMode($0408);
    
    public static property FRONT:          CullFaceMode read _FRONT;
    public static property BACK:           CullFaceMode read _BACK;
    public static property FRONT_AND_BACK: CullFaceMode read _FRONT_AND_BACK;
    
    public function ToString: string; override;
    begin
      var res := typeof(CullFaceMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CullFaceMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CullFaceMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DebugSeverity = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DONT_CARE                   := new DebugSeverity($1100);
    private static _DEBUG_SEVERITY_NOTIFICATION := new DebugSeverity($826B);
    private static _DEBUG_SEVERITY_HIGH         := new DebugSeverity($9146);
    private static _DEBUG_SEVERITY_MEDIUM       := new DebugSeverity($9147);
    private static _DEBUG_SEVERITY_LOW          := new DebugSeverity($9148);
    
    public static property DONT_CARE:                   DebugSeverity read _DONT_CARE;
    public static property DEBUG_SEVERITY_NOTIFICATION: DebugSeverity read _DEBUG_SEVERITY_NOTIFICATION;
    public static property DEBUG_SEVERITY_HIGH:         DebugSeverity read _DEBUG_SEVERITY_HIGH;
    public static property DEBUG_SEVERITY_MEDIUM:       DebugSeverity read _DEBUG_SEVERITY_MEDIUM;
    public static property DEBUG_SEVERITY_LOW:          DebugSeverity read _DEBUG_SEVERITY_LOW;
    
    public function ToString: string; override;
    begin
      var res := typeof(DebugSeverity).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DebugSeverity(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DebugSeverity[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DebugSource = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DONT_CARE                    := new DebugSource($1100);
    private static _DEBUG_SOURCE_API             := new DebugSource($8246);
    private static _DEBUG_SOURCE_WINDOW_SYSTEM   := new DebugSource($8247);
    private static _DEBUG_SOURCE_SHADER_COMPILER := new DebugSource($8248);
    private static _DEBUG_SOURCE_THIRD_PARTY     := new DebugSource($8249);
    private static _DEBUG_SOURCE_APPLICATION     := new DebugSource($824A);
    private static _DEBUG_SOURCE_OTHER           := new DebugSource($824B);
    
    public static property DONT_CARE:                    DebugSource read _DONT_CARE;
    public static property DEBUG_SOURCE_API:             DebugSource read _DEBUG_SOURCE_API;
    public static property DEBUG_SOURCE_WINDOW_SYSTEM:   DebugSource read _DEBUG_SOURCE_WINDOW_SYSTEM;
    public static property DEBUG_SOURCE_SHADER_COMPILER: DebugSource read _DEBUG_SOURCE_SHADER_COMPILER;
    public static property DEBUG_SOURCE_THIRD_PARTY:     DebugSource read _DEBUG_SOURCE_THIRD_PARTY;
    public static property DEBUG_SOURCE_APPLICATION:     DebugSource read _DEBUG_SOURCE_APPLICATION;
    public static property DEBUG_SOURCE_OTHER:           DebugSource read _DEBUG_SOURCE_OTHER;
    
    public function ToString: string; override;
    begin
      var res := typeof(DebugSource).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DebugSource(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DebugSource[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DebugType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DONT_CARE                      := new DebugType($1100);
    private static _DEBUG_TYPE_ERROR               := new DebugType($824C);
    private static _DEBUG_TYPE_DEPRECATED_BEHAVIOR := new DebugType($824D);
    private static _DEBUG_TYPE_UNDEFINED_BEHAVIOR  := new DebugType($824E);
    private static _DEBUG_TYPE_PORTABILITY         := new DebugType($824F);
    private static _DEBUG_TYPE_PERFORMANCE         := new DebugType($8250);
    private static _DEBUG_TYPE_OTHER               := new DebugType($8251);
    private static _DEBUG_TYPE_MARKER              := new DebugType($8268);
    private static _DEBUG_TYPE_PUSH_GROUP          := new DebugType($8269);
    private static _DEBUG_TYPE_POP_GROUP           := new DebugType($826A);
    
    public static property DONT_CARE:                      DebugType read _DONT_CARE;
    public static property DEBUG_TYPE_ERROR:               DebugType read _DEBUG_TYPE_ERROR;
    public static property DEBUG_TYPE_DEPRECATED_BEHAVIOR: DebugType read _DEBUG_TYPE_DEPRECATED_BEHAVIOR;
    public static property DEBUG_TYPE_UNDEFINED_BEHAVIOR:  DebugType read _DEBUG_TYPE_UNDEFINED_BEHAVIOR;
    public static property DEBUG_TYPE_PORTABILITY:         DebugType read _DEBUG_TYPE_PORTABILITY;
    public static property DEBUG_TYPE_PERFORMANCE:         DebugType read _DEBUG_TYPE_PERFORMANCE;
    public static property DEBUG_TYPE_OTHER:               DebugType read _DEBUG_TYPE_OTHER;
    public static property DEBUG_TYPE_MARKER:              DebugType read _DEBUG_TYPE_MARKER;
    public static property DEBUG_TYPE_PUSH_GROUP:          DebugType read _DEBUG_TYPE_PUSH_GROUP;
    public static property DEBUG_TYPE_POP_GROUP:           DebugType read _DEBUG_TYPE_POP_GROUP;
    
    public function ToString: string; override;
    begin
      var res := typeof(DebugType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DebugType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DebugType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DepthFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEVER    := new DepthFunction($0200);
    private static _LESS     := new DepthFunction($0201);
    private static _EQUAL    := new DepthFunction($0202);
    private static _LEQUAL   := new DepthFunction($0203);
    private static _GREATER  := new DepthFunction($0204);
    private static _NOTEQUAL := new DepthFunction($0205);
    private static _GEQUAL   := new DepthFunction($0206);
    private static _ALWAYS   := new DepthFunction($0207);
    
    public static property NEVER:    DepthFunction read _NEVER;
    public static property LESS:     DepthFunction read _LESS;
    public static property EQUAL:    DepthFunction read _EQUAL;
    public static property LEQUAL:   DepthFunction read _LEQUAL;
    public static property GREATER:  DepthFunction read _GREATER;
    public static property NOTEQUAL: DepthFunction read _NOTEQUAL;
    public static property GEQUAL:   DepthFunction read _GEQUAL;
    public static property ALWAYS:   DepthFunction read _ALWAYS;
    
    public function ToString: string; override;
    begin
      var res := typeof(DepthFunction).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DepthFunction(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DepthFunction[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DrawBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE               := new DrawBufferMode($0000);
    private static _NONE_OES           := new DrawBufferMode($0000);
    private static _FRONT_LEFT         := new DrawBufferMode($0400);
    private static _FRONT_RIGHT        := new DrawBufferMode($0401);
    private static _BACK_LEFT          := new DrawBufferMode($0402);
    private static _BACK_RIGHT         := new DrawBufferMode($0403);
    private static _FRONT              := new DrawBufferMode($0404);
    private static _BACK               := new DrawBufferMode($0405);
    private static _LEFT               := new DrawBufferMode($0406);
    private static _RIGHT              := new DrawBufferMode($0407);
    private static _FRONT_AND_BACK     := new DrawBufferMode($0408);
    private static _AUX0               := new DrawBufferMode($0409);
    private static _AUX1               := new DrawBufferMode($040A);
    private static _AUX2               := new DrawBufferMode($040B);
    private static _AUX3               := new DrawBufferMode($040C);
    private static _COLOR_ATTACHMENT0  := new DrawBufferMode($8CE0);
    private static _COLOR_ATTACHMENT1  := new DrawBufferMode($8CE1);
    private static _COLOR_ATTACHMENT2  := new DrawBufferMode($8CE2);
    private static _COLOR_ATTACHMENT3  := new DrawBufferMode($8CE3);
    private static _COLOR_ATTACHMENT4  := new DrawBufferMode($8CE4);
    private static _COLOR_ATTACHMENT5  := new DrawBufferMode($8CE5);
    private static _COLOR_ATTACHMENT6  := new DrawBufferMode($8CE6);
    private static _COLOR_ATTACHMENT7  := new DrawBufferMode($8CE7);
    private static _COLOR_ATTACHMENT8  := new DrawBufferMode($8CE8);
    private static _COLOR_ATTACHMENT9  := new DrawBufferMode($8CE9);
    private static _COLOR_ATTACHMENT10 := new DrawBufferMode($8CEA);
    private static _COLOR_ATTACHMENT11 := new DrawBufferMode($8CEB);
    private static _COLOR_ATTACHMENT12 := new DrawBufferMode($8CEC);
    private static _COLOR_ATTACHMENT13 := new DrawBufferMode($8CED);
    private static _COLOR_ATTACHMENT14 := new DrawBufferMode($8CEE);
    private static _COLOR_ATTACHMENT15 := new DrawBufferMode($8CEF);
    private static _COLOR_ATTACHMENT16 := new DrawBufferMode($8CF0);
    private static _COLOR_ATTACHMENT17 := new DrawBufferMode($8CF1);
    private static _COLOR_ATTACHMENT18 := new DrawBufferMode($8CF2);
    private static _COLOR_ATTACHMENT19 := new DrawBufferMode($8CF3);
    private static _COLOR_ATTACHMENT20 := new DrawBufferMode($8CF4);
    private static _COLOR_ATTACHMENT21 := new DrawBufferMode($8CF5);
    private static _COLOR_ATTACHMENT22 := new DrawBufferMode($8CF6);
    private static _COLOR_ATTACHMENT23 := new DrawBufferMode($8CF7);
    private static _COLOR_ATTACHMENT24 := new DrawBufferMode($8CF8);
    private static _COLOR_ATTACHMENT25 := new DrawBufferMode($8CF9);
    private static _COLOR_ATTACHMENT26 := new DrawBufferMode($8CFA);
    private static _COLOR_ATTACHMENT27 := new DrawBufferMode($8CFB);
    private static _COLOR_ATTACHMENT28 := new DrawBufferMode($8CFC);
    private static _COLOR_ATTACHMENT29 := new DrawBufferMode($8CFD);
    private static _COLOR_ATTACHMENT30 := new DrawBufferMode($8CFE);
    private static _COLOR_ATTACHMENT31 := new DrawBufferMode($8CFF);
    
    public static property NONE:               DrawBufferMode read _NONE;
    public static property NONE_OES:           DrawBufferMode read _NONE_OES;
    public static property FRONT_LEFT:         DrawBufferMode read _FRONT_LEFT;
    public static property FRONT_RIGHT:        DrawBufferMode read _FRONT_RIGHT;
    public static property BACK_LEFT:          DrawBufferMode read _BACK_LEFT;
    public static property BACK_RIGHT:         DrawBufferMode read _BACK_RIGHT;
    public static property FRONT:              DrawBufferMode read _FRONT;
    public static property BACK:               DrawBufferMode read _BACK;
    public static property LEFT:               DrawBufferMode read _LEFT;
    public static property RIGHT:              DrawBufferMode read _RIGHT;
    public static property FRONT_AND_BACK:     DrawBufferMode read _FRONT_AND_BACK;
    public static property AUX0:               DrawBufferMode read _AUX0;
    public static property AUX1:               DrawBufferMode read _AUX1;
    public static property AUX2:               DrawBufferMode read _AUX2;
    public static property AUX3:               DrawBufferMode read _AUX3;
    public static property COLOR_ATTACHMENT0:  DrawBufferMode read _COLOR_ATTACHMENT0;
    public static property COLOR_ATTACHMENT1:  DrawBufferMode read _COLOR_ATTACHMENT1;
    public static property COLOR_ATTACHMENT2:  DrawBufferMode read _COLOR_ATTACHMENT2;
    public static property COLOR_ATTACHMENT3:  DrawBufferMode read _COLOR_ATTACHMENT3;
    public static property COLOR_ATTACHMENT4:  DrawBufferMode read _COLOR_ATTACHMENT4;
    public static property COLOR_ATTACHMENT5:  DrawBufferMode read _COLOR_ATTACHMENT5;
    public static property COLOR_ATTACHMENT6:  DrawBufferMode read _COLOR_ATTACHMENT6;
    public static property COLOR_ATTACHMENT7:  DrawBufferMode read _COLOR_ATTACHMENT7;
    public static property COLOR_ATTACHMENT8:  DrawBufferMode read _COLOR_ATTACHMENT8;
    public static property COLOR_ATTACHMENT9:  DrawBufferMode read _COLOR_ATTACHMENT9;
    public static property COLOR_ATTACHMENT10: DrawBufferMode read _COLOR_ATTACHMENT10;
    public static property COLOR_ATTACHMENT11: DrawBufferMode read _COLOR_ATTACHMENT11;
    public static property COLOR_ATTACHMENT12: DrawBufferMode read _COLOR_ATTACHMENT12;
    public static property COLOR_ATTACHMENT13: DrawBufferMode read _COLOR_ATTACHMENT13;
    public static property COLOR_ATTACHMENT14: DrawBufferMode read _COLOR_ATTACHMENT14;
    public static property COLOR_ATTACHMENT15: DrawBufferMode read _COLOR_ATTACHMENT15;
    public static property COLOR_ATTACHMENT16: DrawBufferMode read _COLOR_ATTACHMENT16;
    public static property COLOR_ATTACHMENT17: DrawBufferMode read _COLOR_ATTACHMENT17;
    public static property COLOR_ATTACHMENT18: DrawBufferMode read _COLOR_ATTACHMENT18;
    public static property COLOR_ATTACHMENT19: DrawBufferMode read _COLOR_ATTACHMENT19;
    public static property COLOR_ATTACHMENT20: DrawBufferMode read _COLOR_ATTACHMENT20;
    public static property COLOR_ATTACHMENT21: DrawBufferMode read _COLOR_ATTACHMENT21;
    public static property COLOR_ATTACHMENT22: DrawBufferMode read _COLOR_ATTACHMENT22;
    public static property COLOR_ATTACHMENT23: DrawBufferMode read _COLOR_ATTACHMENT23;
    public static property COLOR_ATTACHMENT24: DrawBufferMode read _COLOR_ATTACHMENT24;
    public static property COLOR_ATTACHMENT25: DrawBufferMode read _COLOR_ATTACHMENT25;
    public static property COLOR_ATTACHMENT26: DrawBufferMode read _COLOR_ATTACHMENT26;
    public static property COLOR_ATTACHMENT27: DrawBufferMode read _COLOR_ATTACHMENT27;
    public static property COLOR_ATTACHMENT28: DrawBufferMode read _COLOR_ATTACHMENT28;
    public static property COLOR_ATTACHMENT29: DrawBufferMode read _COLOR_ATTACHMENT29;
    public static property COLOR_ATTACHMENT30: DrawBufferMode read _COLOR_ATTACHMENT30;
    public static property COLOR_ATTACHMENT31: DrawBufferMode read _COLOR_ATTACHMENT31;
    
    public function ToString: string; override;
    begin
      var res := typeof(DrawBufferMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DrawBufferMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DrawBufferMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DrawElementsType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_BYTE  := new DrawElementsType($1401);
    private static _UNSIGNED_SHORT := new DrawElementsType($1403);
    private static _UNSIGNED_INT   := new DrawElementsType($1405);
    
    public static property UNSIGNED_BYTE:  DrawElementsType read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: DrawElementsType read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   DrawElementsType read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(DrawElementsType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DrawElementsType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DrawElementsType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  EnableCap = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINT_SMOOTH                      := new EnableCap($0B10);
    private static _LINE_SMOOTH                       := new EnableCap($0B20);
    private static _LINE_STIPPLE                      := new EnableCap($0B24);
    private static _POLYGON_SMOOTH                    := new EnableCap($0B41);
    private static _POLYGON_STIPPLE                   := new EnableCap($0B42);
    private static _CULL_FACE                         := new EnableCap($0B44);
    private static _LIGHTING                          := new EnableCap($0B50);
    private static _COLOR_MATERIAL                    := new EnableCap($0B57);
    private static _FOG                               := new EnableCap($0B60);
    private static _DEPTH_TEST                        := new EnableCap($0B71);
    private static _STENCIL_TEST                      := new EnableCap($0B90);
    private static _NORMALIZE                         := new EnableCap($0BA1);
    private static _ALPHA_TEST                        := new EnableCap($0BC0);
    private static _DITHER                            := new EnableCap($0BD0);
    private static _BLEND                             := new EnableCap($0BE2);
    private static _INDEX_LOGIC_OP                    := new EnableCap($0BF1);
    private static _COLOR_LOGIC_OP                    := new EnableCap($0BF2);
    private static _SCISSOR_TEST                      := new EnableCap($0C11);
    private static _TEXTURE_GEN_S                     := new EnableCap($0C60);
    private static _TEXTURE_GEN_T                     := new EnableCap($0C61);
    private static _TEXTURE_GEN_R                     := new EnableCap($0C62);
    private static _TEXTURE_GEN_Q                     := new EnableCap($0C63);
    private static _AUTO_NORMAL                       := new EnableCap($0D80);
    private static _MAP1_COLOR_4                      := new EnableCap($0D90);
    private static _MAP1_INDEX                        := new EnableCap($0D91);
    private static _MAP1_NORMAL                       := new EnableCap($0D92);
    private static _MAP1_TEXTURE_COORD_1              := new EnableCap($0D93);
    private static _MAP1_TEXTURE_COORD_2              := new EnableCap($0D94);
    private static _MAP1_TEXTURE_COORD_3              := new EnableCap($0D95);
    private static _MAP1_TEXTURE_COORD_4              := new EnableCap($0D96);
    private static _MAP1_VERTEX_3                     := new EnableCap($0D97);
    private static _MAP1_VERTEX_4                     := new EnableCap($0D98);
    private static _MAP2_COLOR_4                      := new EnableCap($0DB0);
    private static _MAP2_INDEX                        := new EnableCap($0DB1);
    private static _MAP2_NORMAL                       := new EnableCap($0DB2);
    private static _MAP2_TEXTURE_COORD_1              := new EnableCap($0DB3);
    private static _MAP2_TEXTURE_COORD_2              := new EnableCap($0DB4);
    private static _MAP2_TEXTURE_COORD_3              := new EnableCap($0DB5);
    private static _MAP2_TEXTURE_COORD_4              := new EnableCap($0DB6);
    private static _MAP2_VERTEX_3                     := new EnableCap($0DB7);
    private static _MAP2_VERTEX_4                     := new EnableCap($0DB8);
    private static _TEXTURE_1D                        := new EnableCap($0DE0);
    private static _TEXTURE_2D                        := new EnableCap($0DE1);
    private static _POLYGON_OFFSET_POINT              := new EnableCap($2A01);
    private static _POLYGON_OFFSET_LINE               := new EnableCap($2A02);
    private static _CLIP_DISTANCE0                    := new EnableCap($3000);
    private static _CLIP_PLANE0                       := new EnableCap($3000);
    private static _CLIP_DISTANCE1                    := new EnableCap($3001);
    private static _CLIP_PLANE1                       := new EnableCap($3001);
    private static _CLIP_DISTANCE2                    := new EnableCap($3002);
    private static _CLIP_PLANE2                       := new EnableCap($3002);
    private static _CLIP_DISTANCE3                    := new EnableCap($3003);
    private static _CLIP_PLANE3                       := new EnableCap($3003);
    private static _CLIP_DISTANCE4                    := new EnableCap($3004);
    private static _CLIP_PLANE4                       := new EnableCap($3004);
    private static _CLIP_DISTANCE5                    := new EnableCap($3005);
    private static _CLIP_PLANE5                       := new EnableCap($3005);
    private static _CLIP_DISTANCE6                    := new EnableCap($3006);
    private static _CLIP_DISTANCE7                    := new EnableCap($3007);
    private static _LIGHT0                            := new EnableCap($4000);
    private static _LIGHT1                            := new EnableCap($4001);
    private static _LIGHT2                            := new EnableCap($4002);
    private static _LIGHT3                            := new EnableCap($4003);
    private static _LIGHT4                            := new EnableCap($4004);
    private static _LIGHT5                            := new EnableCap($4005);
    private static _LIGHT6                            := new EnableCap($4006);
    private static _LIGHT7                            := new EnableCap($4007);
    private static _CONVOLUTION_1D_EXT                := new EnableCap($8010);
    private static _CONVOLUTION_2D_EXT                := new EnableCap($8011);
    private static _SEPARABLE_2D_EXT                  := new EnableCap($8012);
    private static _HISTOGRAM_EXT                     := new EnableCap($8024);
    private static _MINMAX_EXT                        := new EnableCap($802E);
    private static _POLYGON_OFFSET_FILL               := new EnableCap($8037);
    private static _RESCALE_NORMAL_EXT                := new EnableCap($803A);
    private static _TEXTURE_3D_EXT                    := new EnableCap($806F);
    private static _VERTEX_ARRAY                      := new EnableCap($8074);
    private static _NORMAL_ARRAY                      := new EnableCap($8075);
    private static _COLOR_ARRAY                       := new EnableCap($8076);
    private static _INDEX_ARRAY                       := new EnableCap($8077);
    private static _TEXTURE_COORD_ARRAY               := new EnableCap($8078);
    private static _EDGE_FLAG_ARRAY                   := new EnableCap($8079);
    private static _INTERLACE_SGIX                    := new EnableCap($8094);
    private static _MULTISAMPLE                       := new EnableCap($809D);
    private static _MULTISAMPLE_SGIS                  := new EnableCap($809D);
    private static _SAMPLE_ALPHA_TO_COVERAGE          := new EnableCap($809E);
    private static _SAMPLE_ALPHA_TO_MASK_SGIS         := new EnableCap($809E);
    private static _SAMPLE_ALPHA_TO_ONE               := new EnableCap($809F);
    private static _SAMPLE_ALPHA_TO_ONE_SGIS          := new EnableCap($809F);
    private static _SAMPLE_COVERAGE                   := new EnableCap($80A0);
    private static _SAMPLE_MASK_SGIS                  := new EnableCap($80A0);
    private static _TEXTURE_COLOR_TABLE_SGI           := new EnableCap($80BC);
    private static _COLOR_TABLE_SGI                   := new EnableCap($80D0);
    private static _POST_CONVOLUTION_COLOR_TABLE_SGI  := new EnableCap($80D1);
    private static _POST_COLOR_MATRIX_COLOR_TABLE_SGI := new EnableCap($80D2);
    private static _TEXTURE_4D_SGIS                   := new EnableCap($8134);
    private static _PIXEL_TEX_GEN_SGIX                := new EnableCap($8139);
    private static _SPRITE_SGIX                       := new EnableCap($8148);
    private static _REFERENCE_PLANE_SGIX              := new EnableCap($817D);
    private static _IR_INSTRUMENT1_SGIX               := new EnableCap($817F);
    private static _CALLIGRAPHIC_FRAGMENT_SGIX        := new EnableCap($8183);
    private static _FRAMEZOOM_SGIX                    := new EnableCap($818B);
    private static _FOG_OFFSET_SGIX                   := new EnableCap($8198);
    private static _SHARED_TEXTURE_PALETTE_EXT        := new EnableCap($81FB);
    private static _DEBUG_OUTPUT_SYNCHRONOUS          := new EnableCap($8242);
    private static _ASYNC_HISTOGRAM_SGIX              := new EnableCap($832C);
    private static _PIXEL_TEXTURE_SGIS                := new EnableCap($8353);
    private static _ASYNC_TEX_IMAGE_SGIX              := new EnableCap($835C);
    private static _ASYNC_DRAW_PIXELS_SGIX            := new EnableCap($835D);
    private static _ASYNC_READ_PIXELS_SGIX            := new EnableCap($835E);
    private static _FRAGMENT_LIGHTING_SGIX            := new EnableCap($8400);
    private static _FRAGMENT_COLOR_MATERIAL_SGIX      := new EnableCap($8401);
    private static _FRAGMENT_LIGHT0_SGIX              := new EnableCap($840C);
    private static _FRAGMENT_LIGHT1_SGIX              := new EnableCap($840D);
    private static _FRAGMENT_LIGHT2_SGIX              := new EnableCap($840E);
    private static _FRAGMENT_LIGHT3_SGIX              := new EnableCap($840F);
    private static _FRAGMENT_LIGHT4_SGIX              := new EnableCap($8410);
    private static _FRAGMENT_LIGHT5_SGIX              := new EnableCap($8411);
    private static _FRAGMENT_LIGHT6_SGIX              := new EnableCap($8412);
    private static _FRAGMENT_LIGHT7_SGIX              := new EnableCap($8413);
    private static _PROGRAM_POINT_SIZE                := new EnableCap($8642);
    private static _DEPTH_CLAMP                       := new EnableCap($864F);
    private static _TEXTURE_CUBE_MAP_SEAMLESS         := new EnableCap($884F);
    private static _SAMPLE_SHADING                    := new EnableCap($8C36);
    private static _RASTERIZER_DISCARD                := new EnableCap($8C89);
    private static _PRIMITIVE_RESTART_FIXED_INDEX     := new EnableCap($8D69);
    private static _FRAMEBUFFER_SRGB                  := new EnableCap($8DB9);
    private static _SAMPLE_MASK                       := new EnableCap($8E51);
    private static _PRIMITIVE_RESTART                 := new EnableCap($8F9D);
    private static _DEBUG_OUTPUT                      := new EnableCap($92E0);
    
    public static property POINT_SMOOTH:                      EnableCap read _POINT_SMOOTH;
    public static property LINE_SMOOTH:                       EnableCap read _LINE_SMOOTH;
    public static property LINE_STIPPLE:                      EnableCap read _LINE_STIPPLE;
    public static property POLYGON_SMOOTH:                    EnableCap read _POLYGON_SMOOTH;
    public static property POLYGON_STIPPLE:                   EnableCap read _POLYGON_STIPPLE;
    public static property CULL_FACE:                         EnableCap read _CULL_FACE;
    public static property LIGHTING:                          EnableCap read _LIGHTING;
    public static property COLOR_MATERIAL:                    EnableCap read _COLOR_MATERIAL;
    public static property FOG:                               EnableCap read _FOG;
    public static property DEPTH_TEST:                        EnableCap read _DEPTH_TEST;
    public static property STENCIL_TEST:                      EnableCap read _STENCIL_TEST;
    public static property NORMALIZE:                         EnableCap read _NORMALIZE;
    public static property ALPHA_TEST:                        EnableCap read _ALPHA_TEST;
    public static property DITHER:                            EnableCap read _DITHER;
    public static property BLEND:                             EnableCap read _BLEND;
    public static property INDEX_LOGIC_OP:                    EnableCap read _INDEX_LOGIC_OP;
    public static property COLOR_LOGIC_OP:                    EnableCap read _COLOR_LOGIC_OP;
    public static property SCISSOR_TEST:                      EnableCap read _SCISSOR_TEST;
    public static property TEXTURE_GEN_S:                     EnableCap read _TEXTURE_GEN_S;
    public static property TEXTURE_GEN_T:                     EnableCap read _TEXTURE_GEN_T;
    public static property TEXTURE_GEN_R:                     EnableCap read _TEXTURE_GEN_R;
    public static property TEXTURE_GEN_Q:                     EnableCap read _TEXTURE_GEN_Q;
    public static property AUTO_NORMAL:                       EnableCap read _AUTO_NORMAL;
    public static property MAP1_COLOR_4:                      EnableCap read _MAP1_COLOR_4;
    public static property MAP1_INDEX:                        EnableCap read _MAP1_INDEX;
    public static property MAP1_NORMAL:                       EnableCap read _MAP1_NORMAL;
    public static property MAP1_TEXTURE_COORD_1:              EnableCap read _MAP1_TEXTURE_COORD_1;
    public static property MAP1_TEXTURE_COORD_2:              EnableCap read _MAP1_TEXTURE_COORD_2;
    public static property MAP1_TEXTURE_COORD_3:              EnableCap read _MAP1_TEXTURE_COORD_3;
    public static property MAP1_TEXTURE_COORD_4:              EnableCap read _MAP1_TEXTURE_COORD_4;
    public static property MAP1_VERTEX_3:                     EnableCap read _MAP1_VERTEX_3;
    public static property MAP1_VERTEX_4:                     EnableCap read _MAP1_VERTEX_4;
    public static property MAP2_COLOR_4:                      EnableCap read _MAP2_COLOR_4;
    public static property MAP2_INDEX:                        EnableCap read _MAP2_INDEX;
    public static property MAP2_NORMAL:                       EnableCap read _MAP2_NORMAL;
    public static property MAP2_TEXTURE_COORD_1:              EnableCap read _MAP2_TEXTURE_COORD_1;
    public static property MAP2_TEXTURE_COORD_2:              EnableCap read _MAP2_TEXTURE_COORD_2;
    public static property MAP2_TEXTURE_COORD_3:              EnableCap read _MAP2_TEXTURE_COORD_3;
    public static property MAP2_TEXTURE_COORD_4:              EnableCap read _MAP2_TEXTURE_COORD_4;
    public static property MAP2_VERTEX_3:                     EnableCap read _MAP2_VERTEX_3;
    public static property MAP2_VERTEX_4:                     EnableCap read _MAP2_VERTEX_4;
    public static property TEXTURE_1D:                        EnableCap read _TEXTURE_1D;
    public static property TEXTURE_2D:                        EnableCap read _TEXTURE_2D;
    public static property POLYGON_OFFSET_POINT:              EnableCap read _POLYGON_OFFSET_POINT;
    public static property POLYGON_OFFSET_LINE:               EnableCap read _POLYGON_OFFSET_LINE;
    public static property CLIP_DISTANCE0:                    EnableCap read _CLIP_DISTANCE0;
    public static property CLIP_PLANE0:                       EnableCap read _CLIP_PLANE0;
    public static property CLIP_DISTANCE1:                    EnableCap read _CLIP_DISTANCE1;
    public static property CLIP_PLANE1:                       EnableCap read _CLIP_PLANE1;
    public static property CLIP_DISTANCE2:                    EnableCap read _CLIP_DISTANCE2;
    public static property CLIP_PLANE2:                       EnableCap read _CLIP_PLANE2;
    public static property CLIP_DISTANCE3:                    EnableCap read _CLIP_DISTANCE3;
    public static property CLIP_PLANE3:                       EnableCap read _CLIP_PLANE3;
    public static property CLIP_DISTANCE4:                    EnableCap read _CLIP_DISTANCE4;
    public static property CLIP_PLANE4:                       EnableCap read _CLIP_PLANE4;
    public static property CLIP_DISTANCE5:                    EnableCap read _CLIP_DISTANCE5;
    public static property CLIP_PLANE5:                       EnableCap read _CLIP_PLANE5;
    public static property CLIP_DISTANCE6:                    EnableCap read _CLIP_DISTANCE6;
    public static property CLIP_DISTANCE7:                    EnableCap read _CLIP_DISTANCE7;
    public static property LIGHT0:                            EnableCap read _LIGHT0;
    public static property LIGHT1:                            EnableCap read _LIGHT1;
    public static property LIGHT2:                            EnableCap read _LIGHT2;
    public static property LIGHT3:                            EnableCap read _LIGHT3;
    public static property LIGHT4:                            EnableCap read _LIGHT4;
    public static property LIGHT5:                            EnableCap read _LIGHT5;
    public static property LIGHT6:                            EnableCap read _LIGHT6;
    public static property LIGHT7:                            EnableCap read _LIGHT7;
    public static property CONVOLUTION_1D_EXT:                EnableCap read _CONVOLUTION_1D_EXT;
    public static property CONVOLUTION_2D_EXT:                EnableCap read _CONVOLUTION_2D_EXT;
    public static property SEPARABLE_2D_EXT:                  EnableCap read _SEPARABLE_2D_EXT;
    public static property HISTOGRAM_EXT:                     EnableCap read _HISTOGRAM_EXT;
    public static property MINMAX_EXT:                        EnableCap read _MINMAX_EXT;
    public static property POLYGON_OFFSET_FILL:               EnableCap read _POLYGON_OFFSET_FILL;
    public static property RESCALE_NORMAL_EXT:                EnableCap read _RESCALE_NORMAL_EXT;
    public static property TEXTURE_3D_EXT:                    EnableCap read _TEXTURE_3D_EXT;
    public static property VERTEX_ARRAY:                      EnableCap read _VERTEX_ARRAY;
    public static property NORMAL_ARRAY:                      EnableCap read _NORMAL_ARRAY;
    public static property COLOR_ARRAY:                       EnableCap read _COLOR_ARRAY;
    public static property INDEX_ARRAY:                       EnableCap read _INDEX_ARRAY;
    public static property TEXTURE_COORD_ARRAY:               EnableCap read _TEXTURE_COORD_ARRAY;
    public static property EDGE_FLAG_ARRAY:                   EnableCap read _EDGE_FLAG_ARRAY;
    public static property INTERLACE_SGIX:                    EnableCap read _INTERLACE_SGIX;
    public static property MULTISAMPLE:                       EnableCap read _MULTISAMPLE;
    public static property MULTISAMPLE_SGIS:                  EnableCap read _MULTISAMPLE_SGIS;
    public static property SAMPLE_ALPHA_TO_COVERAGE:          EnableCap read _SAMPLE_ALPHA_TO_COVERAGE;
    public static property SAMPLE_ALPHA_TO_MASK_SGIS:         EnableCap read _SAMPLE_ALPHA_TO_MASK_SGIS;
    public static property SAMPLE_ALPHA_TO_ONE:               EnableCap read _SAMPLE_ALPHA_TO_ONE;
    public static property SAMPLE_ALPHA_TO_ONE_SGIS:          EnableCap read _SAMPLE_ALPHA_TO_ONE_SGIS;
    public static property SAMPLE_COVERAGE:                   EnableCap read _SAMPLE_COVERAGE;
    public static property SAMPLE_MASK_SGIS:                  EnableCap read _SAMPLE_MASK_SGIS;
    public static property TEXTURE_COLOR_TABLE_SGI:           EnableCap read _TEXTURE_COLOR_TABLE_SGI;
    public static property COLOR_TABLE_SGI:                   EnableCap read _COLOR_TABLE_SGI;
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:  EnableCap read _POST_CONVOLUTION_COLOR_TABLE_SGI;
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI: EnableCap read _POST_COLOR_MATRIX_COLOR_TABLE_SGI;
    public static property TEXTURE_4D_SGIS:                   EnableCap read _TEXTURE_4D_SGIS;
    public static property PIXEL_TEX_GEN_SGIX:                EnableCap read _PIXEL_TEX_GEN_SGIX;
    public static property SPRITE_SGIX:                       EnableCap read _SPRITE_SGIX;
    public static property REFERENCE_PLANE_SGIX:              EnableCap read _REFERENCE_PLANE_SGIX;
    public static property IR_INSTRUMENT1_SGIX:               EnableCap read _IR_INSTRUMENT1_SGIX;
    public static property CALLIGRAPHIC_FRAGMENT_SGIX:        EnableCap read _CALLIGRAPHIC_FRAGMENT_SGIX;
    public static property FRAMEZOOM_SGIX:                    EnableCap read _FRAMEZOOM_SGIX;
    public static property FOG_OFFSET_SGIX:                   EnableCap read _FOG_OFFSET_SGIX;
    public static property SHARED_TEXTURE_PALETTE_EXT:        EnableCap read _SHARED_TEXTURE_PALETTE_EXT;
    public static property DEBUG_OUTPUT_SYNCHRONOUS:          EnableCap read _DEBUG_OUTPUT_SYNCHRONOUS;
    public static property ASYNC_HISTOGRAM_SGIX:              EnableCap read _ASYNC_HISTOGRAM_SGIX;
    public static property PIXEL_TEXTURE_SGIS:                EnableCap read _PIXEL_TEXTURE_SGIS;
    public static property ASYNC_TEX_IMAGE_SGIX:              EnableCap read _ASYNC_TEX_IMAGE_SGIX;
    public static property ASYNC_DRAW_PIXELS_SGIX:            EnableCap read _ASYNC_DRAW_PIXELS_SGIX;
    public static property ASYNC_READ_PIXELS_SGIX:            EnableCap read _ASYNC_READ_PIXELS_SGIX;
    public static property FRAGMENT_LIGHTING_SGIX:            EnableCap read _FRAGMENT_LIGHTING_SGIX;
    public static property FRAGMENT_COLOR_MATERIAL_SGIX:      EnableCap read _FRAGMENT_COLOR_MATERIAL_SGIX;
    public static property FRAGMENT_LIGHT0_SGIX:              EnableCap read _FRAGMENT_LIGHT0_SGIX;
    public static property FRAGMENT_LIGHT1_SGIX:              EnableCap read _FRAGMENT_LIGHT1_SGIX;
    public static property FRAGMENT_LIGHT2_SGIX:              EnableCap read _FRAGMENT_LIGHT2_SGIX;
    public static property FRAGMENT_LIGHT3_SGIX:              EnableCap read _FRAGMENT_LIGHT3_SGIX;
    public static property FRAGMENT_LIGHT4_SGIX:              EnableCap read _FRAGMENT_LIGHT4_SGIX;
    public static property FRAGMENT_LIGHT5_SGIX:              EnableCap read _FRAGMENT_LIGHT5_SGIX;
    public static property FRAGMENT_LIGHT6_SGIX:              EnableCap read _FRAGMENT_LIGHT6_SGIX;
    public static property FRAGMENT_LIGHT7_SGIX:              EnableCap read _FRAGMENT_LIGHT7_SGIX;
    public static property PROGRAM_POINT_SIZE:                EnableCap read _PROGRAM_POINT_SIZE;
    public static property DEPTH_CLAMP:                       EnableCap read _DEPTH_CLAMP;
    public static property TEXTURE_CUBE_MAP_SEAMLESS:         EnableCap read _TEXTURE_CUBE_MAP_SEAMLESS;
    public static property SAMPLE_SHADING:                    EnableCap read _SAMPLE_SHADING;
    public static property RASTERIZER_DISCARD:                EnableCap read _RASTERIZER_DISCARD;
    public static property PRIMITIVE_RESTART_FIXED_INDEX:     EnableCap read _PRIMITIVE_RESTART_FIXED_INDEX;
    public static property FRAMEBUFFER_SRGB:                  EnableCap read _FRAMEBUFFER_SRGB;
    public static property SAMPLE_MASK:                       EnableCap read _SAMPLE_MASK;
    public static property PRIMITIVE_RESTART:                 EnableCap read _PRIMITIVE_RESTART;
    public static property DEBUG_OUTPUT:                      EnableCap read _DEBUG_OUTPUT;
    
    public function ToString: string; override;
    begin
      var res := typeof(EnableCap).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->EnableCap(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'EnableCap[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ErrorCode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NO_ERROR                          := new ErrorCode($0000);
    private static _INVALID_ENUM                      := new ErrorCode($0500);
    private static _INVALID_VALUE                     := new ErrorCode($0501);
    private static _INVALID_OPERATION                 := new ErrorCode($0502);
    private static _STACK_OVERFLOW                    := new ErrorCode($0503);
    private static _STACK_UNDERFLOW                   := new ErrorCode($0504);
    private static _OUT_OF_MEMORY                     := new ErrorCode($0505);
    private static _INVALID_FRAMEBUFFER_OPERATION     := new ErrorCode($0506);
    private static _INVALID_FRAMEBUFFER_OPERATION_EXT := new ErrorCode($0506);
    private static _INVALID_FRAMEBUFFER_OPERATION_OES := new ErrorCode($0506);
    private static _TABLE_TOO_LARGE                   := new ErrorCode($8031);
    private static _TABLE_TOO_LARGE_EXT               := new ErrorCode($8031);
    private static _TEXTURE_TOO_LARGE_EXT             := new ErrorCode($8065);
    
    public static property NO_ERROR:                          ErrorCode read _NO_ERROR;
    public static property INVALID_ENUM:                      ErrorCode read _INVALID_ENUM;
    public static property INVALID_VALUE:                     ErrorCode read _INVALID_VALUE;
    public static property INVALID_OPERATION:                 ErrorCode read _INVALID_OPERATION;
    public static property STACK_OVERFLOW:                    ErrorCode read _STACK_OVERFLOW;
    public static property STACK_UNDERFLOW:                   ErrorCode read _STACK_UNDERFLOW;
    public static property OUT_OF_MEMORY:                     ErrorCode read _OUT_OF_MEMORY;
    public static property INVALID_FRAMEBUFFER_OPERATION:     ErrorCode read _INVALID_FRAMEBUFFER_OPERATION;
    public static property INVALID_FRAMEBUFFER_OPERATION_EXT: ErrorCode read _INVALID_FRAMEBUFFER_OPERATION_EXT;
    public static property INVALID_FRAMEBUFFER_OPERATION_OES: ErrorCode read _INVALID_FRAMEBUFFER_OPERATION_OES;
    public static property TABLE_TOO_LARGE:                   ErrorCode read _TABLE_TOO_LARGE;
    public static property TABLE_TOO_LARGE_EXT:               ErrorCode read _TABLE_TOO_LARGE_EXT;
    public static property TEXTURE_TOO_LARGE_EXT:             ErrorCode read _TEXTURE_TOO_LARGE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ErrorCode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ErrorCode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ErrorCode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ExternalHandleType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _HANDLE_TYPE_OPAQUE_FD_EXT        := new ExternalHandleType($9586);
    private static _HANDLE_TYPE_OPAQUE_WIN32_EXT     := new ExternalHandleType($9587);
    private static _HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT := new ExternalHandleType($9588);
    private static _HANDLE_TYPE_D3D12_TILEPOOL_EXT   := new ExternalHandleType($9589);
    private static _HANDLE_TYPE_D3D12_RESOURCE_EXT   := new ExternalHandleType($958A);
    private static _HANDLE_TYPE_D3D11_IMAGE_EXT      := new ExternalHandleType($958B);
    private static _HANDLE_TYPE_D3D11_IMAGE_KMT_EXT  := new ExternalHandleType($958C);
    private static _HANDLE_TYPE_D3D12_FENCE_EXT      := new ExternalHandleType($9594);
    
    public static property HANDLE_TYPE_OPAQUE_FD_EXT:        ExternalHandleType read _HANDLE_TYPE_OPAQUE_FD_EXT;
    public static property HANDLE_TYPE_OPAQUE_WIN32_EXT:     ExternalHandleType read _HANDLE_TYPE_OPAQUE_WIN32_EXT;
    public static property HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT: ExternalHandleType read _HANDLE_TYPE_OPAQUE_WIN32_KMT_EXT;
    public static property HANDLE_TYPE_D3D12_TILEPOOL_EXT:   ExternalHandleType read _HANDLE_TYPE_D3D12_TILEPOOL_EXT;
    public static property HANDLE_TYPE_D3D12_RESOURCE_EXT:   ExternalHandleType read _HANDLE_TYPE_D3D12_RESOURCE_EXT;
    public static property HANDLE_TYPE_D3D11_IMAGE_EXT:      ExternalHandleType read _HANDLE_TYPE_D3D11_IMAGE_EXT;
    public static property HANDLE_TYPE_D3D11_IMAGE_KMT_EXT:  ExternalHandleType read _HANDLE_TYPE_D3D11_IMAGE_KMT_EXT;
    public static property HANDLE_TYPE_D3D12_FENCE_EXT:      ExternalHandleType read _HANDLE_TYPE_D3D12_FENCE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ExternalHandleType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ExternalHandleType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ExternalHandleType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FeedbackType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _GL_2D               := new FeedbackType($0600);
    private static _GL_3D               := new FeedbackType($0601);
    private static _GL_3D_COLOR         := new FeedbackType($0602);
    private static _GL_3D_COLOR_TEXTURE := new FeedbackType($0603);
    private static _GL_4D_COLOR_TEXTURE := new FeedbackType($0604);
    
    public static property GL_2D:               FeedbackType read _GL_2D;
    public static property GL_3D:               FeedbackType read _GL_3D;
    public static property GL_3D_COLOR:         FeedbackType read _GL_3D_COLOR;
    public static property GL_3D_COLOR_TEXTURE: FeedbackType read _GL_3D_COLOR_TEXTURE;
    public static property GL_4D_COLOR_TEXTURE: FeedbackType read _GL_4D_COLOR_TEXTURE;
    
    public function ToString: string; override;
    begin
      var res := typeof(FeedbackType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FeedbackType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FeedbackType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FogCoordinatePointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLOAT  := new FogCoordinatePointerType($1406);
    private static _DOUBLE := new FogCoordinatePointerType($140A);
    
    public static property FLOAT:  FogCoordinatePointerType read _FLOAT;
    public static property DOUBLE: FogCoordinatePointerType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(FogCoordinatePointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FogCoordinatePointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FogCoordinatePointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FogParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FOG_INDEX             := new FogParameter($0B61);
    private static _FOG_DENSITY           := new FogParameter($0B62);
    private static _FOG_START             := new FogParameter($0B63);
    private static _FOG_END               := new FogParameter($0B64);
    private static _FOG_MODE              := new FogParameter($0B65);
    private static _FOG_COLOR             := new FogParameter($0B66);
    private static _FOG_OFFSET_VALUE_SGIX := new FogParameter($8199);
    
    public static property FOG_INDEX:             FogParameter read _FOG_INDEX;
    public static property FOG_DENSITY:           FogParameter read _FOG_DENSITY;
    public static property FOG_START:             FogParameter read _FOG_START;
    public static property FOG_END:               FogParameter read _FOG_END;
    public static property FOG_MODE:              FogParameter read _FOG_MODE;
    public static property FOG_COLOR:             FogParameter read _FOG_COLOR;
    public static property FOG_OFFSET_VALUE_SGIX: FogParameter read _FOG_OFFSET_VALUE_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(FogParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FogParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FogParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FogPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FOG_INDEX     := new FogPName($0B61);
    private static _FOG_DENSITY   := new FogPName($0B62);
    private static _FOG_START     := new FogPName($0B63);
    private static _FOG_END       := new FogPName($0B64);
    private static _FOG_MODE      := new FogPName($0B65);
    private static _FOG_COORD_SRC := new FogPName($8450);
    
    public static property FOG_INDEX:     FogPName read _FOG_INDEX;
    public static property FOG_DENSITY:   FogPName read _FOG_DENSITY;
    public static property FOG_START:     FogPName read _FOG_START;
    public static property FOG_END:       FogPName read _FOG_END;
    public static property FOG_MODE:      FogPName read _FOG_MODE;
    public static property FOG_COORD_SRC: FogPName read _FOG_COORD_SRC;
    
    public function ToString: string; override;
    begin
      var res := typeof(FogPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FogPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FogPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FramebufferAttachment = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR_ATTACHMENT0  := new FramebufferAttachment($8CE0);
    private static _COLOR_ATTACHMENT1  := new FramebufferAttachment($8CE1);
    private static _COLOR_ATTACHMENT2  := new FramebufferAttachment($8CE2);
    private static _COLOR_ATTACHMENT3  := new FramebufferAttachment($8CE3);
    private static _COLOR_ATTACHMENT4  := new FramebufferAttachment($8CE4);
    private static _COLOR_ATTACHMENT5  := new FramebufferAttachment($8CE5);
    private static _COLOR_ATTACHMENT6  := new FramebufferAttachment($8CE6);
    private static _COLOR_ATTACHMENT7  := new FramebufferAttachment($8CE7);
    private static _COLOR_ATTACHMENT8  := new FramebufferAttachment($8CE8);
    private static _COLOR_ATTACHMENT9  := new FramebufferAttachment($8CE9);
    private static _COLOR_ATTACHMENT10 := new FramebufferAttachment($8CEA);
    private static _COLOR_ATTACHMENT11 := new FramebufferAttachment($8CEB);
    private static _COLOR_ATTACHMENT12 := new FramebufferAttachment($8CEC);
    private static _COLOR_ATTACHMENT13 := new FramebufferAttachment($8CED);
    private static _COLOR_ATTACHMENT14 := new FramebufferAttachment($8CEE);
    private static _COLOR_ATTACHMENT15 := new FramebufferAttachment($8CEF);
    private static _COLOR_ATTACHMENT16 := new FramebufferAttachment($8CF0);
    private static _COLOR_ATTACHMENT17 := new FramebufferAttachment($8CF1);
    private static _COLOR_ATTACHMENT18 := new FramebufferAttachment($8CF2);
    private static _COLOR_ATTACHMENT19 := new FramebufferAttachment($8CF3);
    private static _COLOR_ATTACHMENT20 := new FramebufferAttachment($8CF4);
    private static _COLOR_ATTACHMENT21 := new FramebufferAttachment($8CF5);
    private static _COLOR_ATTACHMENT22 := new FramebufferAttachment($8CF6);
    private static _COLOR_ATTACHMENT23 := new FramebufferAttachment($8CF7);
    private static _COLOR_ATTACHMENT24 := new FramebufferAttachment($8CF8);
    private static _COLOR_ATTACHMENT25 := new FramebufferAttachment($8CF9);
    private static _COLOR_ATTACHMENT26 := new FramebufferAttachment($8CFA);
    private static _COLOR_ATTACHMENT27 := new FramebufferAttachment($8CFB);
    private static _COLOR_ATTACHMENT28 := new FramebufferAttachment($8CFC);
    private static _COLOR_ATTACHMENT29 := new FramebufferAttachment($8CFD);
    private static _COLOR_ATTACHMENT30 := new FramebufferAttachment($8CFE);
    private static _COLOR_ATTACHMENT31 := new FramebufferAttachment($8CFF);
    private static _STENCIL_ATTACHMENT := new FramebufferAttachment($8D20);
    
    public static property COLOR_ATTACHMENT0:  FramebufferAttachment read _COLOR_ATTACHMENT0;
    public static property COLOR_ATTACHMENT1:  FramebufferAttachment read _COLOR_ATTACHMENT1;
    public static property COLOR_ATTACHMENT2:  FramebufferAttachment read _COLOR_ATTACHMENT2;
    public static property COLOR_ATTACHMENT3:  FramebufferAttachment read _COLOR_ATTACHMENT3;
    public static property COLOR_ATTACHMENT4:  FramebufferAttachment read _COLOR_ATTACHMENT4;
    public static property COLOR_ATTACHMENT5:  FramebufferAttachment read _COLOR_ATTACHMENT5;
    public static property COLOR_ATTACHMENT6:  FramebufferAttachment read _COLOR_ATTACHMENT6;
    public static property COLOR_ATTACHMENT7:  FramebufferAttachment read _COLOR_ATTACHMENT7;
    public static property COLOR_ATTACHMENT8:  FramebufferAttachment read _COLOR_ATTACHMENT8;
    public static property COLOR_ATTACHMENT9:  FramebufferAttachment read _COLOR_ATTACHMENT9;
    public static property COLOR_ATTACHMENT10: FramebufferAttachment read _COLOR_ATTACHMENT10;
    public static property COLOR_ATTACHMENT11: FramebufferAttachment read _COLOR_ATTACHMENT11;
    public static property COLOR_ATTACHMENT12: FramebufferAttachment read _COLOR_ATTACHMENT12;
    public static property COLOR_ATTACHMENT13: FramebufferAttachment read _COLOR_ATTACHMENT13;
    public static property COLOR_ATTACHMENT14: FramebufferAttachment read _COLOR_ATTACHMENT14;
    public static property COLOR_ATTACHMENT15: FramebufferAttachment read _COLOR_ATTACHMENT15;
    public static property COLOR_ATTACHMENT16: FramebufferAttachment read _COLOR_ATTACHMENT16;
    public static property COLOR_ATTACHMENT17: FramebufferAttachment read _COLOR_ATTACHMENT17;
    public static property COLOR_ATTACHMENT18: FramebufferAttachment read _COLOR_ATTACHMENT18;
    public static property COLOR_ATTACHMENT19: FramebufferAttachment read _COLOR_ATTACHMENT19;
    public static property COLOR_ATTACHMENT20: FramebufferAttachment read _COLOR_ATTACHMENT20;
    public static property COLOR_ATTACHMENT21: FramebufferAttachment read _COLOR_ATTACHMENT21;
    public static property COLOR_ATTACHMENT22: FramebufferAttachment read _COLOR_ATTACHMENT22;
    public static property COLOR_ATTACHMENT23: FramebufferAttachment read _COLOR_ATTACHMENT23;
    public static property COLOR_ATTACHMENT24: FramebufferAttachment read _COLOR_ATTACHMENT24;
    public static property COLOR_ATTACHMENT25: FramebufferAttachment read _COLOR_ATTACHMENT25;
    public static property COLOR_ATTACHMENT26: FramebufferAttachment read _COLOR_ATTACHMENT26;
    public static property COLOR_ATTACHMENT27: FramebufferAttachment read _COLOR_ATTACHMENT27;
    public static property COLOR_ATTACHMENT28: FramebufferAttachment read _COLOR_ATTACHMENT28;
    public static property COLOR_ATTACHMENT29: FramebufferAttachment read _COLOR_ATTACHMENT29;
    public static property COLOR_ATTACHMENT30: FramebufferAttachment read _COLOR_ATTACHMENT30;
    public static property COLOR_ATTACHMENT31: FramebufferAttachment read _COLOR_ATTACHMENT31;
    public static property STENCIL_ATTACHMENT: FramebufferAttachment read _STENCIL_ATTACHMENT;
    
    public function ToString: string; override;
    begin
      var res := typeof(FramebufferAttachment).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FramebufferAttachment(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FramebufferAttachment[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FramebufferAttachmentParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING              := new FramebufferAttachmentParameterName($8210);
    private static _FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT          := new FramebufferAttachmentParameterName($8210);
    private static _FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE              := new FramebufferAttachmentParameterName($8211);
    private static _FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT          := new FramebufferAttachmentParameterName($8211);
    private static _FRAMEBUFFER_ATTACHMENT_RED_SIZE                    := new FramebufferAttachmentParameterName($8212);
    private static _FRAMEBUFFER_ATTACHMENT_GREEN_SIZE                  := new FramebufferAttachmentParameterName($8213);
    private static _FRAMEBUFFER_ATTACHMENT_BLUE_SIZE                   := new FramebufferAttachmentParameterName($8214);
    private static _FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE                  := new FramebufferAttachmentParameterName($8215);
    private static _FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE                  := new FramebufferAttachmentParameterName($8216);
    private static _FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE                := new FramebufferAttachmentParameterName($8217);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE                 := new FramebufferAttachmentParameterName($8CD0);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT             := new FramebufferAttachmentParameterName($8CD0);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES             := new FramebufferAttachmentParameterName($8CD0);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME                 := new FramebufferAttachmentParameterName($8CD1);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT             := new FramebufferAttachmentParameterName($8CD1);
    private static _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES             := new FramebufferAttachmentParameterName($8CD1);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL               := new FramebufferAttachmentParameterName($8CD2);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT           := new FramebufferAttachmentParameterName($8CD2);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES           := new FramebufferAttachmentParameterName($8CD2);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE       := new FramebufferAttachmentParameterName($8CD3);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT   := new FramebufferAttachmentParameterName($8CD3);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES   := new FramebufferAttachmentParameterName($8CD3);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT      := new FramebufferAttachmentParameterName($8CD4);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES      := new FramebufferAttachmentParameterName($8CD4);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER               := new FramebufferAttachmentParameterName($8CD4);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT           := new FramebufferAttachmentParameterName($8CD4);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT         := new FramebufferAttachmentParameterName($8D6C);
    private static _FRAMEBUFFER_ATTACHMENT_LAYERED                     := new FramebufferAttachmentParameterName($8DA7);
    private static _FRAMEBUFFER_ATTACHMENT_LAYERED_ARB                 := new FramebufferAttachmentParameterName($8DA7);
    private static _FRAMEBUFFER_ATTACHMENT_LAYERED_EXT                 := new FramebufferAttachmentParameterName($8DA7);
    private static _FRAMEBUFFER_ATTACHMENT_LAYERED_OES                 := new FramebufferAttachmentParameterName($8DA7);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG           := new FramebufferAttachmentParameterName($913F);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR       := new FramebufferAttachmentParameterName($9630);
    private static _FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR := new FramebufferAttachmentParameterName($9632);
    
    public static property FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:              FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING;
    public static property FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT:          FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:              FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE;
    public static property FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT:          FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_RED_SIZE:                    FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_RED_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:                  FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_GREEN_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:                   FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_BLUE_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:                  FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:                  FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:                FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:                 FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT:             FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES:             FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_OES;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:                 FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT:             FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES:             FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_OES;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:               FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT:           FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES:           FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_OES;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:       FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT:   FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES:   FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_OES;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT:      FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES:      FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_OES;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:               FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT:           FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT:         FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED:                     FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_LAYERED;
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_ARB:                 FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_LAYERED_ARB;
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_EXT:                 FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_LAYERED_EXT;
    public static property FRAMEBUFFER_ATTACHMENT_LAYERED_OES:                 FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_LAYERED_OES;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG:           FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR:       FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR;
    public static property FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR: FramebufferAttachmentParameterName read _FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR;
    
    public function ToString: string; override;
    begin
      var res := typeof(FramebufferAttachmentParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FramebufferAttachmentParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FramebufferAttachmentParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FramebufferParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAMEBUFFER_DEFAULT_WIDTH                  := new FramebufferParameterName($9310);
    private static _FRAMEBUFFER_DEFAULT_HEIGHT                 := new FramebufferParameterName($9311);
    private static _FRAMEBUFFER_DEFAULT_LAYERS                 := new FramebufferParameterName($9312);
    private static _FRAMEBUFFER_DEFAULT_SAMPLES                := new FramebufferParameterName($9313);
    private static _FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS := new FramebufferParameterName($9314);
    
    public static property FRAMEBUFFER_DEFAULT_WIDTH:                  FramebufferParameterName read _FRAMEBUFFER_DEFAULT_WIDTH;
    public static property FRAMEBUFFER_DEFAULT_HEIGHT:                 FramebufferParameterName read _FRAMEBUFFER_DEFAULT_HEIGHT;
    public static property FRAMEBUFFER_DEFAULT_LAYERS:                 FramebufferParameterName read _FRAMEBUFFER_DEFAULT_LAYERS;
    public static property FRAMEBUFFER_DEFAULT_SAMPLES:                FramebufferParameterName read _FRAMEBUFFER_DEFAULT_SAMPLES;
    public static property FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS: FramebufferParameterName read _FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS;
    
    public function ToString: string; override;
    begin
      var res := typeof(FramebufferParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FramebufferParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FramebufferParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FramebufferStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAMEBUFFER_UNDEFINED                     := new FramebufferStatus($8219);
    private static _FRAMEBUFFER_COMPLETE                      := new FramebufferStatus($8CD5);
    private static _FRAMEBUFFER_INCOMPLETE_ATTACHMENT         := new FramebufferStatus($8CD6);
    private static _FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT := new FramebufferStatus($8CD7);
    private static _FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER        := new FramebufferStatus($8CDB);
    private static _FRAMEBUFFER_INCOMPLETE_READ_BUFFER        := new FramebufferStatus($8CDC);
    private static _FRAMEBUFFER_UNSUPPORTED                   := new FramebufferStatus($8CDD);
    private static _FRAMEBUFFER_INCOMPLETE_MULTISAMPLE        := new FramebufferStatus($8D56);
    private static _FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS      := new FramebufferStatus($8DA8);
    
    public static property FRAMEBUFFER_UNDEFINED:                     FramebufferStatus read _FRAMEBUFFER_UNDEFINED;
    public static property FRAMEBUFFER_COMPLETE:                      FramebufferStatus read _FRAMEBUFFER_COMPLETE;
    public static property FRAMEBUFFER_INCOMPLETE_ATTACHMENT:         FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_ATTACHMENT;
    public static property FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT;
    public static property FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER:        FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER;
    public static property FRAMEBUFFER_INCOMPLETE_READ_BUFFER:        FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_READ_BUFFER;
    public static property FRAMEBUFFER_UNSUPPORTED:                   FramebufferStatus read _FRAMEBUFFER_UNSUPPORTED;
    public static property FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:        FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_MULTISAMPLE;
    public static property FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS:      FramebufferStatus read _FRAMEBUFFER_INCOMPLETE_LAYER_TARGETS;
    
    public function ToString: string; override;
    begin
      var res := typeof(FramebufferStatus).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FramebufferStatus(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FramebufferStatus[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FramebufferTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _READ_FRAMEBUFFER := new FramebufferTarget($8CA8);
    private static _DRAW_FRAMEBUFFER := new FramebufferTarget($8CA9);
    private static _FRAMEBUFFER      := new FramebufferTarget($8D40);
    private static _FRAMEBUFFER_OES  := new FramebufferTarget($8D40);
    
    public static property READ_FRAMEBUFFER: FramebufferTarget read _READ_FRAMEBUFFER;
    public static property DRAW_FRAMEBUFFER: FramebufferTarget read _DRAW_FRAMEBUFFER;
    public static property FRAMEBUFFER:      FramebufferTarget read _FRAMEBUFFER;
    public static property FRAMEBUFFER_OES:  FramebufferTarget read _FRAMEBUFFER_OES;
    
    public function ToString: string; override;
    begin
      var res := typeof(FramebufferTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FramebufferTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FramebufferTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FrontFaceDirection = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CW  := new FrontFaceDirection($0900);
    private static _CCW := new FrontFaceDirection($0901);
    
    public static property CW:  FrontFaceDirection read _CW;
    public static property CCW: FrontFaceDirection read _CCW;
    
    public function ToString: string; override;
    begin
      var res := typeof(FrontFaceDirection).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FrontFaceDirection(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FrontFaceDirection[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetFramebufferParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DOUBLEBUFFER                               := new GetFramebufferParameter($0C32);
    private static _STEREO                                     := new GetFramebufferParameter($0C33);
    private static _SAMPLE_BUFFERS                             := new GetFramebufferParameter($80A8);
    private static _SAMPLES                                    := new GetFramebufferParameter($80A9);
    private static _IMPLEMENTATION_COLOR_READ_TYPE             := new GetFramebufferParameter($8B9A);
    private static _IMPLEMENTATION_COLOR_READ_FORMAT           := new GetFramebufferParameter($8B9B);
    private static _FRAMEBUFFER_DEFAULT_WIDTH                  := new GetFramebufferParameter($9310);
    private static _FRAMEBUFFER_DEFAULT_HEIGHT                 := new GetFramebufferParameter($9311);
    private static _FRAMEBUFFER_DEFAULT_LAYERS                 := new GetFramebufferParameter($9312);
    private static _FRAMEBUFFER_DEFAULT_SAMPLES                := new GetFramebufferParameter($9313);
    private static _FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS := new GetFramebufferParameter($9314);
    
    public static property DOUBLEBUFFER:                               GetFramebufferParameter read _DOUBLEBUFFER;
    public static property STEREO:                                     GetFramebufferParameter read _STEREO;
    public static property SAMPLE_BUFFERS:                             GetFramebufferParameter read _SAMPLE_BUFFERS;
    public static property SAMPLES:                                    GetFramebufferParameter read _SAMPLES;
    public static property IMPLEMENTATION_COLOR_READ_TYPE:             GetFramebufferParameter read _IMPLEMENTATION_COLOR_READ_TYPE;
    public static property IMPLEMENTATION_COLOR_READ_FORMAT:           GetFramebufferParameter read _IMPLEMENTATION_COLOR_READ_FORMAT;
    public static property FRAMEBUFFER_DEFAULT_WIDTH:                  GetFramebufferParameter read _FRAMEBUFFER_DEFAULT_WIDTH;
    public static property FRAMEBUFFER_DEFAULT_HEIGHT:                 GetFramebufferParameter read _FRAMEBUFFER_DEFAULT_HEIGHT;
    public static property FRAMEBUFFER_DEFAULT_LAYERS:                 GetFramebufferParameter read _FRAMEBUFFER_DEFAULT_LAYERS;
    public static property FRAMEBUFFER_DEFAULT_SAMPLES:                GetFramebufferParameter read _FRAMEBUFFER_DEFAULT_SAMPLES;
    public static property FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS: GetFramebufferParameter read _FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetFramebufferParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetFramebufferParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetFramebufferParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetMapQuery = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COEFF  := new GetMapQuery($0A00);
    private static _ORDER  := new GetMapQuery($0A01);
    private static _DOMAIN := new GetMapQuery($0A02);
    
    public static property COEFF:  GetMapQuery read _COEFF;
    public static property ORDER:  GetMapQuery read _ORDER;
    public static property DOMAIN: GetMapQuery read _DOMAIN;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetMapQuery).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetMapQuery(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetMapQuery[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CURRENT_COLOR                                  := new GetPName($0B00);
    private static _CURRENT_INDEX                                  := new GetPName($0B01);
    private static _CURRENT_NORMAL                                 := new GetPName($0B02);
    private static _CURRENT_TEXTURE_COORDS                         := new GetPName($0B03);
    private static _CURRENT_RASTER_COLOR                           := new GetPName($0B04);
    private static _CURRENT_RASTER_INDEX                           := new GetPName($0B05);
    private static _CURRENT_RASTER_TEXTURE_COORDS                  := new GetPName($0B06);
    private static _CURRENT_RASTER_POSITION                        := new GetPName($0B07);
    private static _CURRENT_RASTER_POSITION_VALID                  := new GetPName($0B08);
    private static _CURRENT_RASTER_DISTANCE                        := new GetPName($0B09);
    private static _POINT_SMOOTH                                   := new GetPName($0B10);
    private static _POINT_SIZE                                     := new GetPName($0B11);
    private static _POINT_SIZE_RANGE                               := new GetPName($0B12);
    private static _SMOOTH_POINT_SIZE_RANGE                        := new GetPName($0B12);
    private static _POINT_SIZE_GRANULARITY                         := new GetPName($0B13);
    private static _SMOOTH_POINT_SIZE_GRANULARITY                  := new GetPName($0B13);
    private static _LINE_SMOOTH                                    := new GetPName($0B20);
    private static _LINE_WIDTH                                     := new GetPName($0B21);
    private static _LINE_WIDTH_RANGE                               := new GetPName($0B22);
    private static _SMOOTH_LINE_WIDTH_RANGE                        := new GetPName($0B22);
    private static _LINE_WIDTH_GRANULARITY                         := new GetPName($0B23);
    private static _SMOOTH_LINE_WIDTH_GRANULARITY                  := new GetPName($0B23);
    private static _LINE_STIPPLE                                   := new GetPName($0B24);
    private static _LINE_STIPPLE_PATTERN                           := new GetPName($0B25);
    private static _LINE_STIPPLE_REPEAT                            := new GetPName($0B26);
    private static _LIST_MODE                                      := new GetPName($0B30);
    private static _MAX_LIST_NESTING                               := new GetPName($0B31);
    private static _LIST_BASE                                      := new GetPName($0B32);
    private static _LIST_INDEX                                     := new GetPName($0B33);
    private static _POLYGON_MODE                                   := new GetPName($0B40);
    private static _POLYGON_SMOOTH                                 := new GetPName($0B41);
    private static _POLYGON_STIPPLE                                := new GetPName($0B42);
    private static _EDGE_FLAG                                      := new GetPName($0B43);
    private static _CULL_FACE                                      := new GetPName($0B44);
    private static _CULL_FACE_MODE                                 := new GetPName($0B45);
    private static _FRONT_FACE                                     := new GetPName($0B46);
    private static _LIGHTING                                       := new GetPName($0B50);
    private static _LIGHT_MODEL_LOCAL_VIEWER                       := new GetPName($0B51);
    private static _LIGHT_MODEL_TWO_SIDE                           := new GetPName($0B52);
    private static _LIGHT_MODEL_AMBIENT                            := new GetPName($0B53);
    private static _SHADE_MODEL                                    := new GetPName($0B54);
    private static _COLOR_MATERIAL_FACE                            := new GetPName($0B55);
    private static _COLOR_MATERIAL_PARAMETER                       := new GetPName($0B56);
    private static _COLOR_MATERIAL                                 := new GetPName($0B57);
    private static _FOG                                            := new GetPName($0B60);
    private static _FOG_INDEX                                      := new GetPName($0B61);
    private static _FOG_DENSITY                                    := new GetPName($0B62);
    private static _FOG_START                                      := new GetPName($0B63);
    private static _FOG_END                                        := new GetPName($0B64);
    private static _FOG_MODE                                       := new GetPName($0B65);
    private static _FOG_COLOR                                      := new GetPName($0B66);
    private static _DEPTH_RANGE                                    := new GetPName($0B70);
    private static _DEPTH_TEST                                     := new GetPName($0B71);
    private static _DEPTH_WRITEMASK                                := new GetPName($0B72);
    private static _DEPTH_CLEAR_VALUE                              := new GetPName($0B73);
    private static _DEPTH_FUNC                                     := new GetPName($0B74);
    private static _ACCUM_CLEAR_VALUE                              := new GetPName($0B80);
    private static _STENCIL_TEST                                   := new GetPName($0B90);
    private static _STENCIL_CLEAR_VALUE                            := new GetPName($0B91);
    private static _STENCIL_FUNC                                   := new GetPName($0B92);
    private static _STENCIL_VALUE_MASK                             := new GetPName($0B93);
    private static _STENCIL_FAIL                                   := new GetPName($0B94);
    private static _STENCIL_PASS_DEPTH_FAIL                        := new GetPName($0B95);
    private static _STENCIL_PASS_DEPTH_PASS                        := new GetPName($0B96);
    private static _STENCIL_REF                                    := new GetPName($0B97);
    private static _STENCIL_WRITEMASK                              := new GetPName($0B98);
    private static _MATRIX_MODE                                    := new GetPName($0BA0);
    private static _NORMALIZE                                      := new GetPName($0BA1);
    private static _VIEWPORT                                       := new GetPName($0BA2);
    private static _MODELVIEW_STACK_DEPTH                          := new GetPName($0BA3);
    private static _MODELVIEW0_STACK_DEPTH_EXT                     := new GetPName($0BA3);
    private static _PROJECTION_STACK_DEPTH                         := new GetPName($0BA4);
    private static _TEXTURE_STACK_DEPTH                            := new GetPName($0BA5);
    private static _MODELVIEW_MATRIX                               := new GetPName($0BA6);
    private static _MODELVIEW0_MATRIX_EXT                          := new GetPName($0BA6);
    private static _PROJECTION_MATRIX                              := new GetPName($0BA7);
    private static _TEXTURE_MATRIX                                 := new GetPName($0BA8);
    private static _ATTRIB_STACK_DEPTH                             := new GetPName($0BB0);
    private static _CLIENT_ATTRIB_STACK_DEPTH                      := new GetPName($0BB1);
    private static _ALPHA_TEST                                     := new GetPName($0BC0);
    private static _ALPHA_TEST_QCOM                                := new GetPName($0BC0);
    private static _ALPHA_TEST_FUNC                                := new GetPName($0BC1);
    private static _ALPHA_TEST_FUNC_QCOM                           := new GetPName($0BC1);
    private static _ALPHA_TEST_REF                                 := new GetPName($0BC2);
    private static _ALPHA_TEST_REF_QCOM                            := new GetPName($0BC2);
    private static _DITHER                                         := new GetPName($0BD0);
    private static _BLEND_DST                                      := new GetPName($0BE0);
    private static _BLEND_SRC                                      := new GetPName($0BE1);
    private static _BLEND                                          := new GetPName($0BE2);
    private static _LOGIC_OP_MODE                                  := new GetPName($0BF0);
    private static _INDEX_LOGIC_OP                                 := new GetPName($0BF1);
    private static _LOGIC_OP                                       := new GetPName($0BF1);
    private static _COLOR_LOGIC_OP                                 := new GetPName($0BF2);
    private static _AUX_BUFFERS                                    := new GetPName($0C00);
    private static _DRAW_BUFFER                                    := new GetPName($0C01);
    private static _DRAW_BUFFER_EXT                                := new GetPName($0C01);
    private static _READ_BUFFER                                    := new GetPName($0C02);
    private static _READ_BUFFER_EXT                                := new GetPName($0C02);
    private static _READ_BUFFER_NV                                 := new GetPName($0C02);
    private static _SCISSOR_BOX                                    := new GetPName($0C10);
    private static _SCISSOR_TEST                                   := new GetPName($0C11);
    private static _INDEX_CLEAR_VALUE                              := new GetPName($0C20);
    private static _INDEX_WRITEMASK                                := new GetPName($0C21);
    private static _COLOR_CLEAR_VALUE                              := new GetPName($0C22);
    private static _COLOR_WRITEMASK                                := new GetPName($0C23);
    private static _INDEX_MODE                                     := new GetPName($0C30);
    private static _RGBA_MODE                                      := new GetPName($0C31);
    private static _DOUBLEBUFFER                                   := new GetPName($0C32);
    private static _STEREO                                         := new GetPName($0C33);
    private static _RENDER_MODE                                    := new GetPName($0C40);
    private static _PERSPECTIVE_CORRECTION_HINT                    := new GetPName($0C50);
    private static _POINT_SMOOTH_HINT                              := new GetPName($0C51);
    private static _LINE_SMOOTH_HINT                               := new GetPName($0C52);
    private static _POLYGON_SMOOTH_HINT                            := new GetPName($0C53);
    private static _FOG_HINT                                       := new GetPName($0C54);
    private static _TEXTURE_GEN_S                                  := new GetPName($0C60);
    private static _TEXTURE_GEN_T                                  := new GetPName($0C61);
    private static _TEXTURE_GEN_R                                  := new GetPName($0C62);
    private static _TEXTURE_GEN_Q                                  := new GetPName($0C63);
    private static _PIXEL_MAP_I_TO_I_SIZE                          := new GetPName($0CB0);
    private static _PIXEL_MAP_S_TO_S_SIZE                          := new GetPName($0CB1);
    private static _PIXEL_MAP_I_TO_R_SIZE                          := new GetPName($0CB2);
    private static _PIXEL_MAP_I_TO_G_SIZE                          := new GetPName($0CB3);
    private static _PIXEL_MAP_I_TO_B_SIZE                          := new GetPName($0CB4);
    private static _PIXEL_MAP_I_TO_A_SIZE                          := new GetPName($0CB5);
    private static _PIXEL_MAP_R_TO_R_SIZE                          := new GetPName($0CB6);
    private static _PIXEL_MAP_G_TO_G_SIZE                          := new GetPName($0CB7);
    private static _PIXEL_MAP_B_TO_B_SIZE                          := new GetPName($0CB8);
    private static _PIXEL_MAP_A_TO_A_SIZE                          := new GetPName($0CB9);
    private static _UNPACK_SWAP_BYTES                              := new GetPName($0CF0);
    private static _UNPACK_LSB_FIRST                               := new GetPName($0CF1);
    private static _UNPACK_ROW_LENGTH                              := new GetPName($0CF2);
    private static _UNPACK_SKIP_ROWS                               := new GetPName($0CF3);
    private static _UNPACK_SKIP_PIXELS                             := new GetPName($0CF4);
    private static _UNPACK_ALIGNMENT                               := new GetPName($0CF5);
    private static _PACK_SWAP_BYTES                                := new GetPName($0D00);
    private static _PACK_LSB_FIRST                                 := new GetPName($0D01);
    private static _PACK_ROW_LENGTH                                := new GetPName($0D02);
    private static _PACK_SKIP_ROWS                                 := new GetPName($0D03);
    private static _PACK_SKIP_PIXELS                               := new GetPName($0D04);
    private static _PACK_ALIGNMENT                                 := new GetPName($0D05);
    private static _MAP_COLOR                                      := new GetPName($0D10);
    private static _MAP_STENCIL                                    := new GetPName($0D11);
    private static _INDEX_SHIFT                                    := new GetPName($0D12);
    private static _INDEX_OFFSET                                   := new GetPName($0D13);
    private static _RED_SCALE                                      := new GetPName($0D14);
    private static _RED_BIAS                                       := new GetPName($0D15);
    private static _ZOOM_X                                         := new GetPName($0D16);
    private static _ZOOM_Y                                         := new GetPName($0D17);
    private static _GREEN_SCALE                                    := new GetPName($0D18);
    private static _GREEN_BIAS                                     := new GetPName($0D19);
    private static _BLUE_SCALE                                     := new GetPName($0D1A);
    private static _BLUE_BIAS                                      := new GetPName($0D1B);
    private static _ALPHA_SCALE                                    := new GetPName($0D1C);
    private static _ALPHA_BIAS                                     := new GetPName($0D1D);
    private static _DEPTH_SCALE                                    := new GetPName($0D1E);
    private static _DEPTH_BIAS                                     := new GetPName($0D1F);
    private static _MAX_EVAL_ORDER                                 := new GetPName($0D30);
    private static _MAX_LIGHTS                                     := new GetPName($0D31);
    private static _MAX_CLIP_DISTANCES                             := new GetPName($0D32);
    private static _MAX_CLIP_PLANES                                := new GetPName($0D32);
    private static _MAX_TEXTURE_SIZE                               := new GetPName($0D33);
    private static _MAX_PIXEL_MAP_TABLE                            := new GetPName($0D34);
    private static _MAX_ATTRIB_STACK_DEPTH                         := new GetPName($0D35);
    private static _MAX_MODELVIEW_STACK_DEPTH                      := new GetPName($0D36);
    private static _MAX_NAME_STACK_DEPTH                           := new GetPName($0D37);
    private static _MAX_PROJECTION_STACK_DEPTH                     := new GetPName($0D38);
    private static _MAX_TEXTURE_STACK_DEPTH                        := new GetPName($0D39);
    private static _MAX_VIEWPORT_DIMS                              := new GetPName($0D3A);
    private static _MAX_CLIENT_ATTRIB_STACK_DEPTH                  := new GetPName($0D3B);
    private static _SUBPIXEL_BITS                                  := new GetPName($0D50);
    private static _INDEX_BITS                                     := new GetPName($0D51);
    private static _RED_BITS                                       := new GetPName($0D52);
    private static _GREEN_BITS                                     := new GetPName($0D53);
    private static _BLUE_BITS                                      := new GetPName($0D54);
    private static _ALPHA_BITS                                     := new GetPName($0D55);
    private static _DEPTH_BITS                                     := new GetPName($0D56);
    private static _STENCIL_BITS                                   := new GetPName($0D57);
    private static _ACCUM_RED_BITS                                 := new GetPName($0D58);
    private static _ACCUM_GREEN_BITS                               := new GetPName($0D59);
    private static _ACCUM_BLUE_BITS                                := new GetPName($0D5A);
    private static _ACCUM_ALPHA_BITS                               := new GetPName($0D5B);
    private static _NAME_STACK_DEPTH                               := new GetPName($0D70);
    private static _AUTO_NORMAL                                    := new GetPName($0D80);
    private static _MAP1_COLOR_4                                   := new GetPName($0D90);
    private static _MAP1_INDEX                                     := new GetPName($0D91);
    private static _MAP1_NORMAL                                    := new GetPName($0D92);
    private static _MAP1_TEXTURE_COORD_1                           := new GetPName($0D93);
    private static _MAP1_TEXTURE_COORD_2                           := new GetPName($0D94);
    private static _MAP1_TEXTURE_COORD_3                           := new GetPName($0D95);
    private static _MAP1_TEXTURE_COORD_4                           := new GetPName($0D96);
    private static _MAP1_VERTEX_3                                  := new GetPName($0D97);
    private static _MAP1_VERTEX_4                                  := new GetPName($0D98);
    private static _MAP2_COLOR_4                                   := new GetPName($0DB0);
    private static _MAP2_INDEX                                     := new GetPName($0DB1);
    private static _MAP2_NORMAL                                    := new GetPName($0DB2);
    private static _MAP2_TEXTURE_COORD_1                           := new GetPName($0DB3);
    private static _MAP2_TEXTURE_COORD_2                           := new GetPName($0DB4);
    private static _MAP2_TEXTURE_COORD_3                           := new GetPName($0DB5);
    private static _MAP2_TEXTURE_COORD_4                           := new GetPName($0DB6);
    private static _MAP2_VERTEX_3                                  := new GetPName($0DB7);
    private static _MAP2_VERTEX_4                                  := new GetPName($0DB8);
    private static _MAP1_GRID_DOMAIN                               := new GetPName($0DD0);
    private static _MAP1_GRID_SEGMENTS                             := new GetPName($0DD1);
    private static _MAP2_GRID_DOMAIN                               := new GetPName($0DD2);
    private static _MAP2_GRID_SEGMENTS                             := new GetPName($0DD3);
    private static _TEXTURE_1D                                     := new GetPName($0DE0);
    private static _TEXTURE_2D                                     := new GetPName($0DE1);
    private static _FEEDBACK_BUFFER_SIZE                           := new GetPName($0DF1);
    private static _FEEDBACK_BUFFER_TYPE                           := new GetPName($0DF2);
    private static _SELECTION_BUFFER_SIZE                          := new GetPName($0DF4);
    private static _POLYGON_OFFSET_UNITS                           := new GetPName($2A00);
    private static _POLYGON_OFFSET_POINT                           := new GetPName($2A01);
    private static _POLYGON_OFFSET_LINE                            := new GetPName($2A02);
    private static _CLIP_PLANE0                                    := new GetPName($3000);
    private static _CLIP_PLANE1                                    := new GetPName($3001);
    private static _CLIP_PLANE2                                    := new GetPName($3002);
    private static _CLIP_PLANE3                                    := new GetPName($3003);
    private static _CLIP_PLANE4                                    := new GetPName($3004);
    private static _CLIP_PLANE5                                    := new GetPName($3005);
    private static _LIGHT0                                         := new GetPName($4000);
    private static _LIGHT1                                         := new GetPName($4001);
    private static _LIGHT2                                         := new GetPName($4002);
    private static _LIGHT3                                         := new GetPName($4003);
    private static _LIGHT4                                         := new GetPName($4004);
    private static _LIGHT5                                         := new GetPName($4005);
    private static _LIGHT6                                         := new GetPName($4006);
    private static _LIGHT7                                         := new GetPName($4007);
    private static _BLEND_COLOR                                    := new GetPName($8005);
    private static _BLEND_COLOR_EXT                                := new GetPName($8005);
    private static _BLEND_EQUATION_EXT                             := new GetPName($8009);
    private static _BLEND_EQUATION_RGB                             := new GetPName($8009);
    private static _PACK_CMYK_HINT_EXT                             := new GetPName($800E);
    private static _UNPACK_CMYK_HINT_EXT                           := new GetPName($800F);
    private static _CONVOLUTION_1D_EXT                             := new GetPName($8010);
    private static _CONVOLUTION_2D_EXT                             := new GetPName($8011);
    private static _SEPARABLE_2D_EXT                               := new GetPName($8012);
    private static _POST_CONVOLUTION_RED_SCALE_EXT                 := new GetPName($801C);
    private static _POST_CONVOLUTION_GREEN_SCALE_EXT               := new GetPName($801D);
    private static _POST_CONVOLUTION_BLUE_SCALE_EXT                := new GetPName($801E);
    private static _POST_CONVOLUTION_ALPHA_SCALE_EXT               := new GetPName($801F);
    private static _POST_CONVOLUTION_RED_BIAS_EXT                  := new GetPName($8020);
    private static _POST_CONVOLUTION_GREEN_BIAS_EXT                := new GetPName($8021);
    private static _POST_CONVOLUTION_BLUE_BIAS_EXT                 := new GetPName($8022);
    private static _POST_CONVOLUTION_ALPHA_BIAS_EXT                := new GetPName($8023);
    private static _HISTOGRAM_EXT                                  := new GetPName($8024);
    private static _MINMAX_EXT                                     := new GetPName($802E);
    private static _POLYGON_OFFSET_FILL                            := new GetPName($8037);
    private static _POLYGON_OFFSET_FACTOR                          := new GetPName($8038);
    private static _POLYGON_OFFSET_BIAS_EXT                        := new GetPName($8039);
    private static _RESCALE_NORMAL_EXT                             := new GetPName($803A);
    private static _TEXTURE_BINDING_1D                             := new GetPName($8068);
    private static _TEXTURE_BINDING_2D                             := new GetPName($8069);
    private static _TEXTURE_3D_BINDING_EXT                         := new GetPName($806A);
    private static _TEXTURE_BINDING_3D                             := new GetPName($806A);
    private static _PACK_SKIP_IMAGES                               := new GetPName($806B);
    private static _PACK_SKIP_IMAGES_EXT                           := new GetPName($806B);
    private static _PACK_IMAGE_HEIGHT                              := new GetPName($806C);
    private static _PACK_IMAGE_HEIGHT_EXT                          := new GetPName($806C);
    private static _UNPACK_SKIP_IMAGES                             := new GetPName($806D);
    private static _UNPACK_SKIP_IMAGES_EXT                         := new GetPName($806D);
    private static _UNPACK_IMAGE_HEIGHT                            := new GetPName($806E);
    private static _UNPACK_IMAGE_HEIGHT_EXT                        := new GetPName($806E);
    private static _TEXTURE_3D_EXT                                 := new GetPName($806F);
    private static _MAX_3D_TEXTURE_SIZE                            := new GetPName($8073);
    private static _MAX_3D_TEXTURE_SIZE_EXT                        := new GetPName($8073);
    private static _VERTEX_ARRAY                                   := new GetPName($8074);
    private static _NORMAL_ARRAY                                   := new GetPName($8075);
    private static _COLOR_ARRAY                                    := new GetPName($8076);
    private static _INDEX_ARRAY                                    := new GetPName($8077);
    private static _TEXTURE_COORD_ARRAY                            := new GetPName($8078);
    private static _EDGE_FLAG_ARRAY                                := new GetPName($8079);
    private static _VERTEX_ARRAY_SIZE                              := new GetPName($807A);
    private static _VERTEX_ARRAY_TYPE                              := new GetPName($807B);
    private static _VERTEX_ARRAY_STRIDE                            := new GetPName($807C);
    private static _VERTEX_ARRAY_COUNT_EXT                         := new GetPName($807D);
    private static _NORMAL_ARRAY_TYPE                              := new GetPName($807E);
    private static _NORMAL_ARRAY_STRIDE                            := new GetPName($807F);
    private static _NORMAL_ARRAY_COUNT_EXT                         := new GetPName($8080);
    private static _COLOR_ARRAY_SIZE                               := new GetPName($8081);
    private static _COLOR_ARRAY_TYPE                               := new GetPName($8082);
    private static _COLOR_ARRAY_STRIDE                             := new GetPName($8083);
    private static _COLOR_ARRAY_COUNT_EXT                          := new GetPName($8084);
    private static _INDEX_ARRAY_TYPE                               := new GetPName($8085);
    private static _INDEX_ARRAY_STRIDE                             := new GetPName($8086);
    private static _INDEX_ARRAY_COUNT_EXT                          := new GetPName($8087);
    private static _TEXTURE_COORD_ARRAY_SIZE                       := new GetPName($8088);
    private static _TEXTURE_COORD_ARRAY_TYPE                       := new GetPName($8089);
    private static _TEXTURE_COORD_ARRAY_STRIDE                     := new GetPName($808A);
    private static _TEXTURE_COORD_ARRAY_COUNT_EXT                  := new GetPName($808B);
    private static _EDGE_FLAG_ARRAY_STRIDE                         := new GetPName($808C);
    private static _EDGE_FLAG_ARRAY_COUNT_EXT                      := new GetPName($808D);
    private static _INTERLACE_SGIX                                 := new GetPName($8094);
    private static _DETAIL_TEXTURE_2D_BINDING_SGIS                 := new GetPName($8096);
    private static _MULTISAMPLE_SGIS                               := new GetPName($809D);
    private static _SAMPLE_ALPHA_TO_MASK_SGIS                      := new GetPName($809E);
    private static _SAMPLE_ALPHA_TO_ONE_SGIS                       := new GetPName($809F);
    private static _SAMPLE_MASK_SGIS                               := new GetPName($80A0);
    private static _SAMPLE_BUFFERS                                 := new GetPName($80A8);
    private static _SAMPLE_BUFFERS_SGIS                            := new GetPName($80A8);
    private static _SAMPLES                                        := new GetPName($80A9);
    private static _SAMPLES_SGIS                                   := new GetPName($80A9);
    private static _SAMPLE_COVERAGE_VALUE                          := new GetPName($80AA);
    private static _SAMPLE_MASK_VALUE_SGIS                         := new GetPName($80AA);
    private static _SAMPLE_COVERAGE_INVERT                         := new GetPName($80AB);
    private static _SAMPLE_MASK_INVERT_SGIS                        := new GetPName($80AB);
    private static _SAMPLE_PATTERN_SGIS                            := new GetPName($80AC);
    private static _COLOR_MATRIX_SGI                               := new GetPName($80B1);
    private static _COLOR_MATRIX_STACK_DEPTH_SGI                   := new GetPName($80B2);
    private static _MAX_COLOR_MATRIX_STACK_DEPTH_SGI               := new GetPName($80B3);
    private static _POST_COLOR_MATRIX_RED_SCALE_SGI                := new GetPName($80B4);
    private static _POST_COLOR_MATRIX_GREEN_SCALE_SGI              := new GetPName($80B5);
    private static _POST_COLOR_MATRIX_BLUE_SCALE_SGI               := new GetPName($80B6);
    private static _POST_COLOR_MATRIX_ALPHA_SCALE_SGI              := new GetPName($80B7);
    private static _POST_COLOR_MATRIX_RED_BIAS_SGI                 := new GetPName($80B8);
    private static _POST_COLOR_MATRIX_GREEN_BIAS_SGI               := new GetPName($80B9);
    private static _POST_COLOR_MATRIX_BLUE_BIAS_SGI                := new GetPName($80BA);
    private static _POST_COLOR_MATRIX_ALPHA_BIAS_SGI               := new GetPName($80BB);
    private static _TEXTURE_COLOR_TABLE_SGI                        := new GetPName($80BC);
    private static _BLEND_DST_RGB                                  := new GetPName($80C8);
    private static _BLEND_SRC_RGB                                  := new GetPName($80C9);
    private static _BLEND_DST_ALPHA                                := new GetPName($80CA);
    private static _BLEND_SRC_ALPHA                                := new GetPName($80CB);
    private static _COLOR_TABLE_SGI                                := new GetPName($80D0);
    private static _POST_CONVOLUTION_COLOR_TABLE_SGI               := new GetPName($80D1);
    private static _POST_COLOR_MATRIX_COLOR_TABLE_SGI              := new GetPName($80D2);
    private static _MAX_ELEMENTS_VERTICES                          := new GetPName($80E8);
    private static _MAX_ELEMENTS_INDICES                           := new GetPName($80E9);
    private static _POINT_SIZE_MIN_SGIS                            := new GetPName($8126);
    private static _POINT_SIZE_MAX_SGIS                            := new GetPName($8127);
    private static _POINT_FADE_THRESHOLD_SIZE                      := new GetPName($8128);
    private static _POINT_FADE_THRESHOLD_SIZE_SGIS                 := new GetPName($8128);
    private static _DISTANCE_ATTENUATION_SGIS                      := new GetPName($8129);
    private static _FOG_FUNC_POINTS_SGIS                           := new GetPName($812B);
    private static _MAX_FOG_FUNC_POINTS_SGIS                       := new GetPName($812C);
    private static _PACK_SKIP_VOLUMES_SGIS                         := new GetPName($8130);
    private static _PACK_IMAGE_DEPTH_SGIS                          := new GetPName($8131);
    private static _UNPACK_SKIP_VOLUMES_SGIS                       := new GetPName($8132);
    private static _UNPACK_IMAGE_DEPTH_SGIS                        := new GetPName($8133);
    private static _TEXTURE_4D_SGIS                                := new GetPName($8134);
    private static _MAX_4D_TEXTURE_SIZE_SGIS                       := new GetPName($8138);
    private static _PIXEL_TEX_GEN_SGIX                             := new GetPName($8139);
    private static _PIXEL_TILE_BEST_ALIGNMENT_SGIX                 := new GetPName($813E);
    private static _PIXEL_TILE_CACHE_INCREMENT_SGIX                := new GetPName($813F);
    private static _PIXEL_TILE_WIDTH_SGIX                          := new GetPName($8140);
    private static _PIXEL_TILE_HEIGHT_SGIX                         := new GetPName($8141);
    private static _PIXEL_TILE_GRID_WIDTH_SGIX                     := new GetPName($8142);
    private static _PIXEL_TILE_GRID_HEIGHT_SGIX                    := new GetPName($8143);
    private static _PIXEL_TILE_GRID_DEPTH_SGIX                     := new GetPName($8144);
    private static _PIXEL_TILE_CACHE_SIZE_SGIX                     := new GetPName($8145);
    private static _SPRITE_SGIX                                    := new GetPName($8148);
    private static _SPRITE_MODE_SGIX                               := new GetPName($8149);
    private static _SPRITE_AXIS_SGIX                               := new GetPName($814A);
    private static _SPRITE_TRANSLATION_SGIX                        := new GetPName($814B);
    private static _TEXTURE_4D_BINDING_SGIS                        := new GetPName($814F);
    private static _MAX_CLIPMAP_DEPTH_SGIX                         := new GetPName($8177);
    private static _MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX                 := new GetPName($8178);
    private static _POST_TEXTURE_FILTER_BIAS_RANGE_SGIX            := new GetPName($817B);
    private static _POST_TEXTURE_FILTER_SCALE_RANGE_SGIX           := new GetPName($817C);
    private static _REFERENCE_PLANE_SGIX                           := new GetPName($817D);
    private static _REFERENCE_PLANE_EQUATION_SGIX                  := new GetPName($817E);
    private static _IR_INSTRUMENT1_SGIX                            := new GetPName($817F);
    private static _INSTRUMENT_MEASUREMENTS_SGIX                   := new GetPName($8181);
    private static _CALLIGRAPHIC_FRAGMENT_SGIX                     := new GetPName($8183);
    private static _FRAMEZOOM_SGIX                                 := new GetPName($818B);
    private static _FRAMEZOOM_FACTOR_SGIX                          := new GetPName($818C);
    private static _MAX_FRAMEZOOM_FACTOR_SGIX                      := new GetPName($818D);
    private static _GENERATE_MIPMAP_HINT_SGIS                      := new GetPName($8192);
    private static _DEFORMATIONS_MASK_SGIX                         := new GetPName($8196);
    private static _FOG_OFFSET_SGIX                                := new GetPName($8198);
    private static _FOG_OFFSET_VALUE_SGIX                          := new GetPName($8199);
    private static _LIGHT_MODEL_COLOR_CONTROL                      := new GetPName($81F8);
    private static _SHARED_TEXTURE_PALETTE_EXT                     := new GetPName($81FB);
    private static _MAJOR_VERSION                                  := new GetPName($821B);
    private static _MINOR_VERSION                                  := new GetPName($821C);
    private static _NUM_EXTENSIONS                                 := new GetPName($821D);
    private static _CONTEXT_FLAGS                                  := new GetPName($821E);
    private static _PROGRAM_PIPELINE_BINDING                       := new GetPName($825A);
    private static _MAX_VIEWPORTS                                  := new GetPName($825B);
    private static _VIEWPORT_SUBPIXEL_BITS                         := new GetPName($825C);
    private static _VIEWPORT_BOUNDS_RANGE                          := new GetPName($825D);
    private static _LAYER_PROVOKING_VERTEX                         := new GetPName($825E);
    private static _VIEWPORT_INDEX_PROVOKING_VERTEX                := new GetPName($825F);
    private static _MAX_COMPUTE_UNIFORM_COMPONENTS                 := new GetPName($8263);
    private static _MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS             := new GetPName($8264);
    private static _MAX_COMPUTE_ATOMIC_COUNTERS                    := new GetPName($8265);
    private static _MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS        := new GetPName($8266);
    private static _MAX_DEBUG_GROUP_STACK_DEPTH                    := new GetPName($826C);
    private static _DEBUG_GROUP_STACK_DEPTH                        := new GetPName($826D);
    private static _MAX_UNIFORM_LOCATIONS                          := new GetPName($826E);
    private static _VERTEX_BINDING_DIVISOR                         := new GetPName($82D6);
    private static _VERTEX_BINDING_OFFSET                          := new GetPName($82D7);
    private static _VERTEX_BINDING_STRIDE                          := new GetPName($82D8);
    private static _MAX_VERTEX_ATTRIB_RELATIVE_OFFSET              := new GetPName($82D9);
    private static _MAX_VERTEX_ATTRIB_BINDINGS                     := new GetPName($82DA);
    private static _MAX_LABEL_LENGTH                               := new GetPName($82E8);
    private static _CONVOLUTION_HINT_SGIX                          := new GetPName($8316);
    private static _ASYNC_MARKER_SGIX                              := new GetPName($8329);
    private static _PIXEL_TEX_GEN_MODE_SGIX                        := new GetPName($832B);
    private static _ASYNC_HISTOGRAM_SGIX                           := new GetPName($832C);
    private static _MAX_ASYNC_HISTOGRAM_SGIX                       := new GetPName($832D);
    private static _PIXEL_TEXTURE_SGIS                             := new GetPName($8353);
    private static _ASYNC_TEX_IMAGE_SGIX                           := new GetPName($835C);
    private static _ASYNC_DRAW_PIXELS_SGIX                         := new GetPName($835D);
    private static _ASYNC_READ_PIXELS_SGIX                         := new GetPName($835E);
    private static _MAX_ASYNC_TEX_IMAGE_SGIX                       := new GetPName($835F);
    private static _MAX_ASYNC_DRAW_PIXELS_SGIX                     := new GetPName($8360);
    private static _MAX_ASYNC_READ_PIXELS_SGIX                     := new GetPName($8361);
    private static _VERTEX_PRECLIP_SGIX                            := new GetPName($83EE);
    private static _VERTEX_PRECLIP_HINT_SGIX                       := new GetPName($83EF);
    private static _FRAGMENT_LIGHTING_SGIX                         := new GetPName($8400);
    private static _FRAGMENT_COLOR_MATERIAL_SGIX                   := new GetPName($8401);
    private static _FRAGMENT_COLOR_MATERIAL_FACE_SGIX              := new GetPName($8402);
    private static _FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX         := new GetPName($8403);
    private static _MAX_FRAGMENT_LIGHTS_SGIX                       := new GetPName($8404);
    private static _MAX_ACTIVE_LIGHTS_SGIX                         := new GetPName($8405);
    private static _LIGHT_ENV_MODE_SGIX                            := new GetPName($8407);
    private static _FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX         := new GetPName($8408);
    private static _FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX             := new GetPName($8409);
    private static _FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX              := new GetPName($840A);
    private static _FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX := new GetPName($840B);
    private static _FRAGMENT_LIGHT0_SGIX                           := new GetPName($840C);
    private static _PACK_RESAMPLE_SGIX                             := new GetPName($842E);
    private static _UNPACK_RESAMPLE_SGIX                           := new GetPName($842F);
    private static _ALIASED_POINT_SIZE_RANGE                       := new GetPName($846D);
    private static _ALIASED_LINE_WIDTH_RANGE                       := new GetPName($846E);
    private static _ACTIVE_TEXTURE                                 := new GetPName($84E0);
    private static _MAX_RENDERBUFFER_SIZE                          := new GetPName($84E8);
    private static _TEXTURE_COMPRESSION_HINT                       := new GetPName($84EF);
    private static _TEXTURE_BINDING_RECTANGLE                      := new GetPName($84F6);
    private static _MAX_RECTANGLE_TEXTURE_SIZE                     := new GetPName($84F8);
    private static _MAX_TEXTURE_LOD_BIAS                           := new GetPName($84FD);
    private static _TEXTURE_BINDING_CUBE_MAP                       := new GetPName($8514);
    private static _MAX_CUBE_MAP_TEXTURE_SIZE                      := new GetPName($851C);
    private static _PACK_SUBSAMPLE_RATE_SGIX                       := new GetPName($85A0);
    private static _UNPACK_SUBSAMPLE_RATE_SGIX                     := new GetPName($85A1);
    private static _VERTEX_ARRAY_BINDING                           := new GetPName($85B5);
    private static _PROGRAM_POINT_SIZE                             := new GetPName($8642);
    private static _NUM_COMPRESSED_TEXTURE_FORMATS                 := new GetPName($86A2);
    private static _COMPRESSED_TEXTURE_FORMATS                     := new GetPName($86A3);
    private static _NUM_PROGRAM_BINARY_FORMATS                     := new GetPName($87FE);
    private static _PROGRAM_BINARY_FORMATS                         := new GetPName($87FF);
    private static _STENCIL_BACK_FUNC                              := new GetPName($8800);
    private static _STENCIL_BACK_FAIL                              := new GetPName($8801);
    private static _STENCIL_BACK_PASS_DEPTH_FAIL                   := new GetPName($8802);
    private static _STENCIL_BACK_PASS_DEPTH_PASS                   := new GetPName($8803);
    private static _MAX_DRAW_BUFFERS                               := new GetPName($8824);
    private static _BLEND_EQUATION_ALPHA                           := new GetPName($883D);
    private static _MAX_VERTEX_ATTRIBS                             := new GetPName($8869);
    private static _MAX_TEXTURE_IMAGE_UNITS                        := new GetPName($8872);
    private static _ARRAY_BUFFER_BINDING                           := new GetPName($8894);
    private static _ELEMENT_ARRAY_BUFFER_BINDING                   := new GetPName($8895);
    private static _PIXEL_PACK_BUFFER_BINDING                      := new GetPName($88ED);
    private static _PIXEL_UNPACK_BUFFER_BINDING                    := new GetPName($88EF);
    private static _MAX_DUAL_SOURCE_DRAW_BUFFERS                   := new GetPName($88FC);
    private static _MAX_ARRAY_TEXTURE_LAYERS                       := new GetPName($88FF);
    private static _MIN_PROGRAM_TEXEL_OFFSET                       := new GetPName($8904);
    private static _MAX_PROGRAM_TEXEL_OFFSET                       := new GetPName($8905);
    private static _SAMPLER_BINDING                                := new GetPName($8919);
    private static _UNIFORM_BUFFER_BINDING                         := new GetPName($8A28);
    private static _UNIFORM_BUFFER_START                           := new GetPName($8A29);
    private static _UNIFORM_BUFFER_SIZE                            := new GetPName($8A2A);
    private static _MAX_VERTEX_UNIFORM_BLOCKS                      := new GetPName($8A2B);
    private static _MAX_GEOMETRY_UNIFORM_BLOCKS                    := new GetPName($8A2C);
    private static _MAX_FRAGMENT_UNIFORM_BLOCKS                    := new GetPName($8A2D);
    private static _MAX_COMBINED_UNIFORM_BLOCKS                    := new GetPName($8A2E);
    private static _MAX_UNIFORM_BUFFER_BINDINGS                    := new GetPName($8A2F);
    private static _MAX_UNIFORM_BLOCK_SIZE                         := new GetPName($8A30);
    private static _MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS         := new GetPName($8A31);
    private static _MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS       := new GetPName($8A32);
    private static _MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS       := new GetPName($8A33);
    private static _UNIFORM_BUFFER_OFFSET_ALIGNMENT                := new GetPName($8A34);
    private static _MAX_FRAGMENT_UNIFORM_COMPONENTS                := new GetPName($8B49);
    private static _MAX_VERTEX_UNIFORM_COMPONENTS                  := new GetPName($8B4A);
    private static _MAX_VARYING_COMPONENTS                         := new GetPName($8B4B);
    private static _MAX_VARYING_FLOATS                             := new GetPName($8B4B);
    private static _MAX_VERTEX_TEXTURE_IMAGE_UNITS                 := new GetPName($8B4C);
    private static _MAX_COMBINED_TEXTURE_IMAGE_UNITS               := new GetPName($8B4D);
    private static _FRAGMENT_SHADER_DERIVATIVE_HINT                := new GetPName($8B8B);
    private static _CURRENT_PROGRAM                                := new GetPName($8B8D);
    private static _IMPLEMENTATION_COLOR_READ_TYPE                 := new GetPName($8B9A);
    private static _IMPLEMENTATION_COLOR_READ_FORMAT               := new GetPName($8B9B);
    private static _TEXTURE_BINDING_1D_ARRAY                       := new GetPName($8C1C);
    private static _TEXTURE_BINDING_2D_ARRAY                       := new GetPName($8C1D);
    private static _MAX_GEOMETRY_TEXTURE_IMAGE_UNITS               := new GetPName($8C29);
    private static _MAX_TEXTURE_BUFFER_SIZE                        := new GetPName($8C2B);
    private static _TEXTURE_BINDING_BUFFER                         := new GetPName($8C2C);
    private static _TRANSFORM_FEEDBACK_BUFFER_START                := new GetPName($8C84);
    private static _TRANSFORM_FEEDBACK_BUFFER_SIZE                 := new GetPName($8C85);
    private static _TRANSFORM_FEEDBACK_BUFFER_BINDING              := new GetPName($8C8F);
    private static _STENCIL_BACK_REF                               := new GetPName($8CA3);
    private static _STENCIL_BACK_VALUE_MASK                        := new GetPName($8CA4);
    private static _STENCIL_BACK_WRITEMASK                         := new GetPName($8CA5);
    private static _DRAW_FRAMEBUFFER_BINDING                       := new GetPName($8CA6);
    private static _RENDERBUFFER_BINDING                           := new GetPName($8CA7);
    private static _READ_FRAMEBUFFER_BINDING                       := new GetPName($8CAA);
    private static _MAX_ELEMENT_INDEX                              := new GetPName($8D6B);
    private static _MAX_GEOMETRY_UNIFORM_COMPONENTS                := new GetPName($8DDF);
    private static _NUM_SHADER_BINARY_FORMATS                      := new GetPName($8DF9);
    private static _SHADER_COMPILER                                := new GetPName($8DFA);
    private static _MAX_VERTEX_UNIFORM_VECTORS                     := new GetPName($8DFB);
    private static _MAX_VARYING_VECTORS                            := new GetPName($8DFC);
    private static _MAX_FRAGMENT_UNIFORM_VECTORS                   := new GetPName($8DFD);
    private static _TIMESTAMP                                      := new GetPName($8E28);
    private static _PROVOKING_VERTEX                               := new GetPName($8E4F);
    private static _MAX_SAMPLE_MASK_WORDS                          := new GetPName($8E59);
    private static _PRIMITIVE_RESTART_INDEX                        := new GetPName($8F9E);
    private static _MIN_MAP_BUFFER_ALIGNMENT                       := new GetPName($90BC);
    private static _SHADER_STORAGE_BUFFER_BINDING                  := new GetPName($90D3);
    private static _SHADER_STORAGE_BUFFER_START                    := new GetPName($90D4);
    private static _SHADER_STORAGE_BUFFER_SIZE                     := new GetPName($90D5);
    private static _MAX_VERTEX_SHADER_STORAGE_BLOCKS               := new GetPName($90D6);
    private static _MAX_GEOMETRY_SHADER_STORAGE_BLOCKS             := new GetPName($90D7);
    private static _MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS         := new GetPName($90D8);
    private static _MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS      := new GetPName($90D9);
    private static _MAX_FRAGMENT_SHADER_STORAGE_BLOCKS             := new GetPName($90DA);
    private static _MAX_COMPUTE_SHADER_STORAGE_BLOCKS              := new GetPName($90DB);
    private static _MAX_COMBINED_SHADER_STORAGE_BLOCKS             := new GetPName($90DC);
    private static _MAX_SHADER_STORAGE_BUFFER_BINDINGS             := new GetPName($90DD);
    private static _SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT         := new GetPName($90DF);
    private static _MAX_COMPUTE_WORK_GROUP_INVOCATIONS             := new GetPName($90EB);
    private static _DISPATCH_INDIRECT_BUFFER_BINDING               := new GetPName($90EF);
    private static _TEXTURE_BINDING_2D_MULTISAMPLE                 := new GetPName($9104);
    private static _TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY           := new GetPName($9105);
    private static _MAX_COLOR_TEXTURE_SAMPLES                      := new GetPName($910E);
    private static _MAX_DEPTH_TEXTURE_SAMPLES                      := new GetPName($910F);
    private static _MAX_INTEGER_SAMPLES                            := new GetPName($9110);
    private static _MAX_SERVER_WAIT_TIMEOUT                        := new GetPName($9111);
    private static _MAX_VERTEX_OUTPUT_COMPONENTS                   := new GetPName($9122);
    private static _MAX_GEOMETRY_INPUT_COMPONENTS                  := new GetPName($9123);
    private static _MAX_GEOMETRY_OUTPUT_COMPONENTS                 := new GetPName($9124);
    private static _MAX_FRAGMENT_INPUT_COMPONENTS                  := new GetPName($9125);
    private static _TEXTURE_BUFFER_OFFSET_ALIGNMENT                := new GetPName($919F);
    private static _MAX_COMPUTE_UNIFORM_BLOCKS                     := new GetPName($91BB);
    private static _MAX_COMPUTE_TEXTURE_IMAGE_UNITS                := new GetPName($91BC);
    private static _MAX_COMPUTE_WORK_GROUP_COUNT                   := new GetPName($91BE);
    private static _MAX_COMPUTE_WORK_GROUP_SIZE                    := new GetPName($91BF);
    private static _MAX_VERTEX_ATOMIC_COUNTERS                     := new GetPName($92D2);
    private static _MAX_TESS_CONTROL_ATOMIC_COUNTERS               := new GetPName($92D3);
    private static _MAX_TESS_EVALUATION_ATOMIC_COUNTERS            := new GetPName($92D4);
    private static _MAX_GEOMETRY_ATOMIC_COUNTERS                   := new GetPName($92D5);
    private static _MAX_FRAGMENT_ATOMIC_COUNTERS                   := new GetPName($92D6);
    private static _MAX_COMBINED_ATOMIC_COUNTERS                   := new GetPName($92D7);
    private static _MAX_FRAMEBUFFER_WIDTH                          := new GetPName($9315);
    private static _MAX_FRAMEBUFFER_HEIGHT                         := new GetPName($9316);
    private static _MAX_FRAMEBUFFER_LAYERS                         := new GetPName($9317);
    private static _MAX_FRAMEBUFFER_SAMPLES                        := new GetPName($9318);
    private static _NUM_DEVICE_UUIDS_EXT                           := new GetPName($9596);
    private static _DEVICE_UUID_EXT                                := new GetPName($9597);
    private static _DRIVER_UUID_EXT                                := new GetPName($9598);
    private static _DEVICE_LUID_EXT                                := new GetPName($9599);
    private static _DEVICE_NODE_MASK_EXT                           := new GetPName($959A);
    
    public static property CURRENT_COLOR:                                  GetPName read _CURRENT_COLOR;
    public static property CURRENT_INDEX:                                  GetPName read _CURRENT_INDEX;
    public static property CURRENT_NORMAL:                                 GetPName read _CURRENT_NORMAL;
    public static property CURRENT_TEXTURE_COORDS:                         GetPName read _CURRENT_TEXTURE_COORDS;
    public static property CURRENT_RASTER_COLOR:                           GetPName read _CURRENT_RASTER_COLOR;
    public static property CURRENT_RASTER_INDEX:                           GetPName read _CURRENT_RASTER_INDEX;
    public static property CURRENT_RASTER_TEXTURE_COORDS:                  GetPName read _CURRENT_RASTER_TEXTURE_COORDS;
    public static property CURRENT_RASTER_POSITION:                        GetPName read _CURRENT_RASTER_POSITION;
    public static property CURRENT_RASTER_POSITION_VALID:                  GetPName read _CURRENT_RASTER_POSITION_VALID;
    public static property CURRENT_RASTER_DISTANCE:                        GetPName read _CURRENT_RASTER_DISTANCE;
    public static property POINT_SMOOTH:                                   GetPName read _POINT_SMOOTH;
    public static property POINT_SIZE:                                     GetPName read _POINT_SIZE;
    public static property POINT_SIZE_RANGE:                               GetPName read _POINT_SIZE_RANGE;
    public static property SMOOTH_POINT_SIZE_RANGE:                        GetPName read _SMOOTH_POINT_SIZE_RANGE;
    public static property POINT_SIZE_GRANULARITY:                         GetPName read _POINT_SIZE_GRANULARITY;
    public static property SMOOTH_POINT_SIZE_GRANULARITY:                  GetPName read _SMOOTH_POINT_SIZE_GRANULARITY;
    public static property LINE_SMOOTH:                                    GetPName read _LINE_SMOOTH;
    public static property LINE_WIDTH:                                     GetPName read _LINE_WIDTH;
    public static property LINE_WIDTH_RANGE:                               GetPName read _LINE_WIDTH_RANGE;
    public static property SMOOTH_LINE_WIDTH_RANGE:                        GetPName read _SMOOTH_LINE_WIDTH_RANGE;
    public static property LINE_WIDTH_GRANULARITY:                         GetPName read _LINE_WIDTH_GRANULARITY;
    public static property SMOOTH_LINE_WIDTH_GRANULARITY:                  GetPName read _SMOOTH_LINE_WIDTH_GRANULARITY;
    public static property LINE_STIPPLE:                                   GetPName read _LINE_STIPPLE;
    public static property LINE_STIPPLE_PATTERN:                           GetPName read _LINE_STIPPLE_PATTERN;
    public static property LINE_STIPPLE_REPEAT:                            GetPName read _LINE_STIPPLE_REPEAT;
    public static property LIST_MODE:                                      GetPName read _LIST_MODE;
    public static property MAX_LIST_NESTING:                               GetPName read _MAX_LIST_NESTING;
    public static property LIST_BASE:                                      GetPName read _LIST_BASE;
    public static property LIST_INDEX:                                     GetPName read _LIST_INDEX;
    public static property POLYGON_MODE:                                   GetPName read _POLYGON_MODE;
    public static property POLYGON_SMOOTH:                                 GetPName read _POLYGON_SMOOTH;
    public static property POLYGON_STIPPLE:                                GetPName read _POLYGON_STIPPLE;
    public static property EDGE_FLAG:                                      GetPName read _EDGE_FLAG;
    public static property CULL_FACE:                                      GetPName read _CULL_FACE;
    public static property CULL_FACE_MODE:                                 GetPName read _CULL_FACE_MODE;
    public static property FRONT_FACE:                                     GetPName read _FRONT_FACE;
    public static property LIGHTING:                                       GetPName read _LIGHTING;
    public static property LIGHT_MODEL_LOCAL_VIEWER:                       GetPName read _LIGHT_MODEL_LOCAL_VIEWER;
    public static property LIGHT_MODEL_TWO_SIDE:                           GetPName read _LIGHT_MODEL_TWO_SIDE;
    public static property LIGHT_MODEL_AMBIENT:                            GetPName read _LIGHT_MODEL_AMBIENT;
    public static property SHADE_MODEL:                                    GetPName read _SHADE_MODEL;
    public static property COLOR_MATERIAL_FACE:                            GetPName read _COLOR_MATERIAL_FACE;
    public static property COLOR_MATERIAL_PARAMETER:                       GetPName read _COLOR_MATERIAL_PARAMETER;
    public static property COLOR_MATERIAL:                                 GetPName read _COLOR_MATERIAL;
    public static property FOG:                                            GetPName read _FOG;
    public static property FOG_INDEX:                                      GetPName read _FOG_INDEX;
    public static property FOG_DENSITY:                                    GetPName read _FOG_DENSITY;
    public static property FOG_START:                                      GetPName read _FOG_START;
    public static property FOG_END:                                        GetPName read _FOG_END;
    public static property FOG_MODE:                                       GetPName read _FOG_MODE;
    public static property FOG_COLOR:                                      GetPName read _FOG_COLOR;
    public static property DEPTH_RANGE:                                    GetPName read _DEPTH_RANGE;
    public static property DEPTH_TEST:                                     GetPName read _DEPTH_TEST;
    public static property DEPTH_WRITEMASK:                                GetPName read _DEPTH_WRITEMASK;
    public static property DEPTH_CLEAR_VALUE:                              GetPName read _DEPTH_CLEAR_VALUE;
    public static property DEPTH_FUNC:                                     GetPName read _DEPTH_FUNC;
    public static property ACCUM_CLEAR_VALUE:                              GetPName read _ACCUM_CLEAR_VALUE;
    public static property STENCIL_TEST:                                   GetPName read _STENCIL_TEST;
    public static property STENCIL_CLEAR_VALUE:                            GetPName read _STENCIL_CLEAR_VALUE;
    public static property STENCIL_FUNC:                                   GetPName read _STENCIL_FUNC;
    public static property STENCIL_VALUE_MASK:                             GetPName read _STENCIL_VALUE_MASK;
    public static property STENCIL_FAIL:                                   GetPName read _STENCIL_FAIL;
    public static property STENCIL_PASS_DEPTH_FAIL:                        GetPName read _STENCIL_PASS_DEPTH_FAIL;
    public static property STENCIL_PASS_DEPTH_PASS:                        GetPName read _STENCIL_PASS_DEPTH_PASS;
    public static property STENCIL_REF:                                    GetPName read _STENCIL_REF;
    public static property STENCIL_WRITEMASK:                              GetPName read _STENCIL_WRITEMASK;
    public static property MATRIX_MODE:                                    GetPName read _MATRIX_MODE;
    public static property NORMALIZE:                                      GetPName read _NORMALIZE;
    public static property VIEWPORT:                                       GetPName read _VIEWPORT;
    public static property MODELVIEW_STACK_DEPTH:                          GetPName read _MODELVIEW_STACK_DEPTH;
    public static property MODELVIEW0_STACK_DEPTH_EXT:                     GetPName read _MODELVIEW0_STACK_DEPTH_EXT;
    public static property PROJECTION_STACK_DEPTH:                         GetPName read _PROJECTION_STACK_DEPTH;
    public static property TEXTURE_STACK_DEPTH:                            GetPName read _TEXTURE_STACK_DEPTH;
    public static property MODELVIEW_MATRIX:                               GetPName read _MODELVIEW_MATRIX;
    public static property MODELVIEW0_MATRIX_EXT:                          GetPName read _MODELVIEW0_MATRIX_EXT;
    public static property PROJECTION_MATRIX:                              GetPName read _PROJECTION_MATRIX;
    public static property TEXTURE_MATRIX:                                 GetPName read _TEXTURE_MATRIX;
    public static property ATTRIB_STACK_DEPTH:                             GetPName read _ATTRIB_STACK_DEPTH;
    public static property CLIENT_ATTRIB_STACK_DEPTH:                      GetPName read _CLIENT_ATTRIB_STACK_DEPTH;
    public static property ALPHA_TEST:                                     GetPName read _ALPHA_TEST;
    public static property ALPHA_TEST_QCOM:                                GetPName read _ALPHA_TEST_QCOM;
    public static property ALPHA_TEST_FUNC:                                GetPName read _ALPHA_TEST_FUNC;
    public static property ALPHA_TEST_FUNC_QCOM:                           GetPName read _ALPHA_TEST_FUNC_QCOM;
    public static property ALPHA_TEST_REF:                                 GetPName read _ALPHA_TEST_REF;
    public static property ALPHA_TEST_REF_QCOM:                            GetPName read _ALPHA_TEST_REF_QCOM;
    public static property DITHER:                                         GetPName read _DITHER;
    public static property BLEND_DST:                                      GetPName read _BLEND_DST;
    public static property BLEND_SRC:                                      GetPName read _BLEND_SRC;
    public static property BLEND:                                          GetPName read _BLEND;
    public static property LOGIC_OP_MODE:                                  GetPName read _LOGIC_OP_MODE;
    public static property INDEX_LOGIC_OP:                                 GetPName read _INDEX_LOGIC_OP;
    public static property LOGIC_OP:                                       GetPName read _LOGIC_OP;
    public static property COLOR_LOGIC_OP:                                 GetPName read _COLOR_LOGIC_OP;
    public static property AUX_BUFFERS:                                    GetPName read _AUX_BUFFERS;
    public static property DRAW_BUFFER:                                    GetPName read _DRAW_BUFFER;
    public static property DRAW_BUFFER_EXT:                                GetPName read _DRAW_BUFFER_EXT;
    public static property READ_BUFFER:                                    GetPName read _READ_BUFFER;
    public static property READ_BUFFER_EXT:                                GetPName read _READ_BUFFER_EXT;
    public static property READ_BUFFER_NV:                                 GetPName read _READ_BUFFER_NV;
    public static property SCISSOR_BOX:                                    GetPName read _SCISSOR_BOX;
    public static property SCISSOR_TEST:                                   GetPName read _SCISSOR_TEST;
    public static property INDEX_CLEAR_VALUE:                              GetPName read _INDEX_CLEAR_VALUE;
    public static property INDEX_WRITEMASK:                                GetPName read _INDEX_WRITEMASK;
    public static property COLOR_CLEAR_VALUE:                              GetPName read _COLOR_CLEAR_VALUE;
    public static property COLOR_WRITEMASK:                                GetPName read _COLOR_WRITEMASK;
    public static property INDEX_MODE:                                     GetPName read _INDEX_MODE;
    public static property RGBA_MODE:                                      GetPName read _RGBA_MODE;
    public static property DOUBLEBUFFER:                                   GetPName read _DOUBLEBUFFER;
    public static property STEREO:                                         GetPName read _STEREO;
    public static property RENDER_MODE:                                    GetPName read _RENDER_MODE;
    public static property PERSPECTIVE_CORRECTION_HINT:                    GetPName read _PERSPECTIVE_CORRECTION_HINT;
    public static property POINT_SMOOTH_HINT:                              GetPName read _POINT_SMOOTH_HINT;
    public static property LINE_SMOOTH_HINT:                               GetPName read _LINE_SMOOTH_HINT;
    public static property POLYGON_SMOOTH_HINT:                            GetPName read _POLYGON_SMOOTH_HINT;
    public static property FOG_HINT:                                       GetPName read _FOG_HINT;
    public static property TEXTURE_GEN_S:                                  GetPName read _TEXTURE_GEN_S;
    public static property TEXTURE_GEN_T:                                  GetPName read _TEXTURE_GEN_T;
    public static property TEXTURE_GEN_R:                                  GetPName read _TEXTURE_GEN_R;
    public static property TEXTURE_GEN_Q:                                  GetPName read _TEXTURE_GEN_Q;
    public static property PIXEL_MAP_I_TO_I_SIZE:                          GetPName read _PIXEL_MAP_I_TO_I_SIZE;
    public static property PIXEL_MAP_S_TO_S_SIZE:                          GetPName read _PIXEL_MAP_S_TO_S_SIZE;
    public static property PIXEL_MAP_I_TO_R_SIZE:                          GetPName read _PIXEL_MAP_I_TO_R_SIZE;
    public static property PIXEL_MAP_I_TO_G_SIZE:                          GetPName read _PIXEL_MAP_I_TO_G_SIZE;
    public static property PIXEL_MAP_I_TO_B_SIZE:                          GetPName read _PIXEL_MAP_I_TO_B_SIZE;
    public static property PIXEL_MAP_I_TO_A_SIZE:                          GetPName read _PIXEL_MAP_I_TO_A_SIZE;
    public static property PIXEL_MAP_R_TO_R_SIZE:                          GetPName read _PIXEL_MAP_R_TO_R_SIZE;
    public static property PIXEL_MAP_G_TO_G_SIZE:                          GetPName read _PIXEL_MAP_G_TO_G_SIZE;
    public static property PIXEL_MAP_B_TO_B_SIZE:                          GetPName read _PIXEL_MAP_B_TO_B_SIZE;
    public static property PIXEL_MAP_A_TO_A_SIZE:                          GetPName read _PIXEL_MAP_A_TO_A_SIZE;
    public static property UNPACK_SWAP_BYTES:                              GetPName read _UNPACK_SWAP_BYTES;
    public static property UNPACK_LSB_FIRST:                               GetPName read _UNPACK_LSB_FIRST;
    public static property UNPACK_ROW_LENGTH:                              GetPName read _UNPACK_ROW_LENGTH;
    public static property UNPACK_SKIP_ROWS:                               GetPName read _UNPACK_SKIP_ROWS;
    public static property UNPACK_SKIP_PIXELS:                             GetPName read _UNPACK_SKIP_PIXELS;
    public static property UNPACK_ALIGNMENT:                               GetPName read _UNPACK_ALIGNMENT;
    public static property PACK_SWAP_BYTES:                                GetPName read _PACK_SWAP_BYTES;
    public static property PACK_LSB_FIRST:                                 GetPName read _PACK_LSB_FIRST;
    public static property PACK_ROW_LENGTH:                                GetPName read _PACK_ROW_LENGTH;
    public static property PACK_SKIP_ROWS:                                 GetPName read _PACK_SKIP_ROWS;
    public static property PACK_SKIP_PIXELS:                               GetPName read _PACK_SKIP_PIXELS;
    public static property PACK_ALIGNMENT:                                 GetPName read _PACK_ALIGNMENT;
    public static property MAP_COLOR:                                      GetPName read _MAP_COLOR;
    public static property MAP_STENCIL:                                    GetPName read _MAP_STENCIL;
    public static property INDEX_SHIFT:                                    GetPName read _INDEX_SHIFT;
    public static property INDEX_OFFSET:                                   GetPName read _INDEX_OFFSET;
    public static property RED_SCALE:                                      GetPName read _RED_SCALE;
    public static property RED_BIAS:                                       GetPName read _RED_BIAS;
    public static property ZOOM_X:                                         GetPName read _ZOOM_X;
    public static property ZOOM_Y:                                         GetPName read _ZOOM_Y;
    public static property GREEN_SCALE:                                    GetPName read _GREEN_SCALE;
    public static property GREEN_BIAS:                                     GetPName read _GREEN_BIAS;
    public static property BLUE_SCALE:                                     GetPName read _BLUE_SCALE;
    public static property BLUE_BIAS:                                      GetPName read _BLUE_BIAS;
    public static property ALPHA_SCALE:                                    GetPName read _ALPHA_SCALE;
    public static property ALPHA_BIAS:                                     GetPName read _ALPHA_BIAS;
    public static property DEPTH_SCALE:                                    GetPName read _DEPTH_SCALE;
    public static property DEPTH_BIAS:                                     GetPName read _DEPTH_BIAS;
    public static property MAX_EVAL_ORDER:                                 GetPName read _MAX_EVAL_ORDER;
    public static property MAX_LIGHTS:                                     GetPName read _MAX_LIGHTS;
    public static property MAX_CLIP_DISTANCES:                             GetPName read _MAX_CLIP_DISTANCES;
    public static property MAX_CLIP_PLANES:                                GetPName read _MAX_CLIP_PLANES;
    public static property MAX_TEXTURE_SIZE:                               GetPName read _MAX_TEXTURE_SIZE;
    public static property MAX_PIXEL_MAP_TABLE:                            GetPName read _MAX_PIXEL_MAP_TABLE;
    public static property MAX_ATTRIB_STACK_DEPTH:                         GetPName read _MAX_ATTRIB_STACK_DEPTH;
    public static property MAX_MODELVIEW_STACK_DEPTH:                      GetPName read _MAX_MODELVIEW_STACK_DEPTH;
    public static property MAX_NAME_STACK_DEPTH:                           GetPName read _MAX_NAME_STACK_DEPTH;
    public static property MAX_PROJECTION_STACK_DEPTH:                     GetPName read _MAX_PROJECTION_STACK_DEPTH;
    public static property MAX_TEXTURE_STACK_DEPTH:                        GetPName read _MAX_TEXTURE_STACK_DEPTH;
    public static property MAX_VIEWPORT_DIMS:                              GetPName read _MAX_VIEWPORT_DIMS;
    public static property MAX_CLIENT_ATTRIB_STACK_DEPTH:                  GetPName read _MAX_CLIENT_ATTRIB_STACK_DEPTH;
    public static property SUBPIXEL_BITS:                                  GetPName read _SUBPIXEL_BITS;
    public static property INDEX_BITS:                                     GetPName read _INDEX_BITS;
    public static property RED_BITS:                                       GetPName read _RED_BITS;
    public static property GREEN_BITS:                                     GetPName read _GREEN_BITS;
    public static property BLUE_BITS:                                      GetPName read _BLUE_BITS;
    public static property ALPHA_BITS:                                     GetPName read _ALPHA_BITS;
    public static property DEPTH_BITS:                                     GetPName read _DEPTH_BITS;
    public static property STENCIL_BITS:                                   GetPName read _STENCIL_BITS;
    public static property ACCUM_RED_BITS:                                 GetPName read _ACCUM_RED_BITS;
    public static property ACCUM_GREEN_BITS:                               GetPName read _ACCUM_GREEN_BITS;
    public static property ACCUM_BLUE_BITS:                                GetPName read _ACCUM_BLUE_BITS;
    public static property ACCUM_ALPHA_BITS:                               GetPName read _ACCUM_ALPHA_BITS;
    public static property NAME_STACK_DEPTH:                               GetPName read _NAME_STACK_DEPTH;
    public static property AUTO_NORMAL:                                    GetPName read _AUTO_NORMAL;
    public static property MAP1_COLOR_4:                                   GetPName read _MAP1_COLOR_4;
    public static property MAP1_INDEX:                                     GetPName read _MAP1_INDEX;
    public static property MAP1_NORMAL:                                    GetPName read _MAP1_NORMAL;
    public static property MAP1_TEXTURE_COORD_1:                           GetPName read _MAP1_TEXTURE_COORD_1;
    public static property MAP1_TEXTURE_COORD_2:                           GetPName read _MAP1_TEXTURE_COORD_2;
    public static property MAP1_TEXTURE_COORD_3:                           GetPName read _MAP1_TEXTURE_COORD_3;
    public static property MAP1_TEXTURE_COORD_4:                           GetPName read _MAP1_TEXTURE_COORD_4;
    public static property MAP1_VERTEX_3:                                  GetPName read _MAP1_VERTEX_3;
    public static property MAP1_VERTEX_4:                                  GetPName read _MAP1_VERTEX_4;
    public static property MAP2_COLOR_4:                                   GetPName read _MAP2_COLOR_4;
    public static property MAP2_INDEX:                                     GetPName read _MAP2_INDEX;
    public static property MAP2_NORMAL:                                    GetPName read _MAP2_NORMAL;
    public static property MAP2_TEXTURE_COORD_1:                           GetPName read _MAP2_TEXTURE_COORD_1;
    public static property MAP2_TEXTURE_COORD_2:                           GetPName read _MAP2_TEXTURE_COORD_2;
    public static property MAP2_TEXTURE_COORD_3:                           GetPName read _MAP2_TEXTURE_COORD_3;
    public static property MAP2_TEXTURE_COORD_4:                           GetPName read _MAP2_TEXTURE_COORD_4;
    public static property MAP2_VERTEX_3:                                  GetPName read _MAP2_VERTEX_3;
    public static property MAP2_VERTEX_4:                                  GetPName read _MAP2_VERTEX_4;
    public static property MAP1_GRID_DOMAIN:                               GetPName read _MAP1_GRID_DOMAIN;
    public static property MAP1_GRID_SEGMENTS:                             GetPName read _MAP1_GRID_SEGMENTS;
    public static property MAP2_GRID_DOMAIN:                               GetPName read _MAP2_GRID_DOMAIN;
    public static property MAP2_GRID_SEGMENTS:                             GetPName read _MAP2_GRID_SEGMENTS;
    public static property TEXTURE_1D:                                     GetPName read _TEXTURE_1D;
    public static property TEXTURE_2D:                                     GetPName read _TEXTURE_2D;
    public static property FEEDBACK_BUFFER_SIZE:                           GetPName read _FEEDBACK_BUFFER_SIZE;
    public static property FEEDBACK_BUFFER_TYPE:                           GetPName read _FEEDBACK_BUFFER_TYPE;
    public static property SELECTION_BUFFER_SIZE:                          GetPName read _SELECTION_BUFFER_SIZE;
    public static property POLYGON_OFFSET_UNITS:                           GetPName read _POLYGON_OFFSET_UNITS;
    public static property POLYGON_OFFSET_POINT:                           GetPName read _POLYGON_OFFSET_POINT;
    public static property POLYGON_OFFSET_LINE:                            GetPName read _POLYGON_OFFSET_LINE;
    public static property CLIP_PLANE0:                                    GetPName read _CLIP_PLANE0;
    public static property CLIP_PLANE1:                                    GetPName read _CLIP_PLANE1;
    public static property CLIP_PLANE2:                                    GetPName read _CLIP_PLANE2;
    public static property CLIP_PLANE3:                                    GetPName read _CLIP_PLANE3;
    public static property CLIP_PLANE4:                                    GetPName read _CLIP_PLANE4;
    public static property CLIP_PLANE5:                                    GetPName read _CLIP_PLANE5;
    public static property LIGHT0:                                         GetPName read _LIGHT0;
    public static property LIGHT1:                                         GetPName read _LIGHT1;
    public static property LIGHT2:                                         GetPName read _LIGHT2;
    public static property LIGHT3:                                         GetPName read _LIGHT3;
    public static property LIGHT4:                                         GetPName read _LIGHT4;
    public static property LIGHT5:                                         GetPName read _LIGHT5;
    public static property LIGHT6:                                         GetPName read _LIGHT6;
    public static property LIGHT7:                                         GetPName read _LIGHT7;
    public static property BLEND_COLOR:                                    GetPName read _BLEND_COLOR;
    public static property BLEND_COLOR_EXT:                                GetPName read _BLEND_COLOR_EXT;
    public static property BLEND_EQUATION_EXT:                             GetPName read _BLEND_EQUATION_EXT;
    public static property BLEND_EQUATION_RGB:                             GetPName read _BLEND_EQUATION_RGB;
    public static property PACK_CMYK_HINT_EXT:                             GetPName read _PACK_CMYK_HINT_EXT;
    public static property UNPACK_CMYK_HINT_EXT:                           GetPName read _UNPACK_CMYK_HINT_EXT;
    public static property CONVOLUTION_1D_EXT:                             GetPName read _CONVOLUTION_1D_EXT;
    public static property CONVOLUTION_2D_EXT:                             GetPName read _CONVOLUTION_2D_EXT;
    public static property SEPARABLE_2D_EXT:                               GetPName read _SEPARABLE_2D_EXT;
    public static property POST_CONVOLUTION_RED_SCALE_EXT:                 GetPName read _POST_CONVOLUTION_RED_SCALE_EXT;
    public static property POST_CONVOLUTION_GREEN_SCALE_EXT:               GetPName read _POST_CONVOLUTION_GREEN_SCALE_EXT;
    public static property POST_CONVOLUTION_BLUE_SCALE_EXT:                GetPName read _POST_CONVOLUTION_BLUE_SCALE_EXT;
    public static property POST_CONVOLUTION_ALPHA_SCALE_EXT:               GetPName read _POST_CONVOLUTION_ALPHA_SCALE_EXT;
    public static property POST_CONVOLUTION_RED_BIAS_EXT:                  GetPName read _POST_CONVOLUTION_RED_BIAS_EXT;
    public static property POST_CONVOLUTION_GREEN_BIAS_EXT:                GetPName read _POST_CONVOLUTION_GREEN_BIAS_EXT;
    public static property POST_CONVOLUTION_BLUE_BIAS_EXT:                 GetPName read _POST_CONVOLUTION_BLUE_BIAS_EXT;
    public static property POST_CONVOLUTION_ALPHA_BIAS_EXT:                GetPName read _POST_CONVOLUTION_ALPHA_BIAS_EXT;
    public static property HISTOGRAM_EXT:                                  GetPName read _HISTOGRAM_EXT;
    public static property MINMAX_EXT:                                     GetPName read _MINMAX_EXT;
    public static property POLYGON_OFFSET_FILL:                            GetPName read _POLYGON_OFFSET_FILL;
    public static property POLYGON_OFFSET_FACTOR:                          GetPName read _POLYGON_OFFSET_FACTOR;
    public static property POLYGON_OFFSET_BIAS_EXT:                        GetPName read _POLYGON_OFFSET_BIAS_EXT;
    public static property RESCALE_NORMAL_EXT:                             GetPName read _RESCALE_NORMAL_EXT;
    public static property TEXTURE_BINDING_1D:                             GetPName read _TEXTURE_BINDING_1D;
    public static property TEXTURE_BINDING_2D:                             GetPName read _TEXTURE_BINDING_2D;
    public static property TEXTURE_3D_BINDING_EXT:                         GetPName read _TEXTURE_3D_BINDING_EXT;
    public static property TEXTURE_BINDING_3D:                             GetPName read _TEXTURE_BINDING_3D;
    public static property PACK_SKIP_IMAGES:                               GetPName read _PACK_SKIP_IMAGES;
    public static property PACK_SKIP_IMAGES_EXT:                           GetPName read _PACK_SKIP_IMAGES_EXT;
    public static property PACK_IMAGE_HEIGHT:                              GetPName read _PACK_IMAGE_HEIGHT;
    public static property PACK_IMAGE_HEIGHT_EXT:                          GetPName read _PACK_IMAGE_HEIGHT_EXT;
    public static property UNPACK_SKIP_IMAGES:                             GetPName read _UNPACK_SKIP_IMAGES;
    public static property UNPACK_SKIP_IMAGES_EXT:                         GetPName read _UNPACK_SKIP_IMAGES_EXT;
    public static property UNPACK_IMAGE_HEIGHT:                            GetPName read _UNPACK_IMAGE_HEIGHT;
    public static property UNPACK_IMAGE_HEIGHT_EXT:                        GetPName read _UNPACK_IMAGE_HEIGHT_EXT;
    public static property TEXTURE_3D_EXT:                                 GetPName read _TEXTURE_3D_EXT;
    public static property MAX_3D_TEXTURE_SIZE:                            GetPName read _MAX_3D_TEXTURE_SIZE;
    public static property MAX_3D_TEXTURE_SIZE_EXT:                        GetPName read _MAX_3D_TEXTURE_SIZE_EXT;
    public static property VERTEX_ARRAY:                                   GetPName read _VERTEX_ARRAY;
    public static property NORMAL_ARRAY:                                   GetPName read _NORMAL_ARRAY;
    public static property COLOR_ARRAY:                                    GetPName read _COLOR_ARRAY;
    public static property INDEX_ARRAY:                                    GetPName read _INDEX_ARRAY;
    public static property TEXTURE_COORD_ARRAY:                            GetPName read _TEXTURE_COORD_ARRAY;
    public static property EDGE_FLAG_ARRAY:                                GetPName read _EDGE_FLAG_ARRAY;
    public static property VERTEX_ARRAY_SIZE:                              GetPName read _VERTEX_ARRAY_SIZE;
    public static property VERTEX_ARRAY_TYPE:                              GetPName read _VERTEX_ARRAY_TYPE;
    public static property VERTEX_ARRAY_STRIDE:                            GetPName read _VERTEX_ARRAY_STRIDE;
    public static property VERTEX_ARRAY_COUNT_EXT:                         GetPName read _VERTEX_ARRAY_COUNT_EXT;
    public static property NORMAL_ARRAY_TYPE:                              GetPName read _NORMAL_ARRAY_TYPE;
    public static property NORMAL_ARRAY_STRIDE:                            GetPName read _NORMAL_ARRAY_STRIDE;
    public static property NORMAL_ARRAY_COUNT_EXT:                         GetPName read _NORMAL_ARRAY_COUNT_EXT;
    public static property COLOR_ARRAY_SIZE:                               GetPName read _COLOR_ARRAY_SIZE;
    public static property COLOR_ARRAY_TYPE:                               GetPName read _COLOR_ARRAY_TYPE;
    public static property COLOR_ARRAY_STRIDE:                             GetPName read _COLOR_ARRAY_STRIDE;
    public static property COLOR_ARRAY_COUNT_EXT:                          GetPName read _COLOR_ARRAY_COUNT_EXT;
    public static property INDEX_ARRAY_TYPE:                               GetPName read _INDEX_ARRAY_TYPE;
    public static property INDEX_ARRAY_STRIDE:                             GetPName read _INDEX_ARRAY_STRIDE;
    public static property INDEX_ARRAY_COUNT_EXT:                          GetPName read _INDEX_ARRAY_COUNT_EXT;
    public static property TEXTURE_COORD_ARRAY_SIZE:                       GetPName read _TEXTURE_COORD_ARRAY_SIZE;
    public static property TEXTURE_COORD_ARRAY_TYPE:                       GetPName read _TEXTURE_COORD_ARRAY_TYPE;
    public static property TEXTURE_COORD_ARRAY_STRIDE:                     GetPName read _TEXTURE_COORD_ARRAY_STRIDE;
    public static property TEXTURE_COORD_ARRAY_COUNT_EXT:                  GetPName read _TEXTURE_COORD_ARRAY_COUNT_EXT;
    public static property EDGE_FLAG_ARRAY_STRIDE:                         GetPName read _EDGE_FLAG_ARRAY_STRIDE;
    public static property EDGE_FLAG_ARRAY_COUNT_EXT:                      GetPName read _EDGE_FLAG_ARRAY_COUNT_EXT;
    public static property INTERLACE_SGIX:                                 GetPName read _INTERLACE_SGIX;
    public static property DETAIL_TEXTURE_2D_BINDING_SGIS:                 GetPName read _DETAIL_TEXTURE_2D_BINDING_SGIS;
    public static property MULTISAMPLE_SGIS:                               GetPName read _MULTISAMPLE_SGIS;
    public static property SAMPLE_ALPHA_TO_MASK_SGIS:                      GetPName read _SAMPLE_ALPHA_TO_MASK_SGIS;
    public static property SAMPLE_ALPHA_TO_ONE_SGIS:                       GetPName read _SAMPLE_ALPHA_TO_ONE_SGIS;
    public static property SAMPLE_MASK_SGIS:                               GetPName read _SAMPLE_MASK_SGIS;
    public static property SAMPLE_BUFFERS:                                 GetPName read _SAMPLE_BUFFERS;
    public static property SAMPLE_BUFFERS_SGIS:                            GetPName read _SAMPLE_BUFFERS_SGIS;
    public static property SAMPLES:                                        GetPName read _SAMPLES;
    public static property SAMPLES_SGIS:                                   GetPName read _SAMPLES_SGIS;
    public static property SAMPLE_COVERAGE_VALUE:                          GetPName read _SAMPLE_COVERAGE_VALUE;
    public static property SAMPLE_MASK_VALUE_SGIS:                         GetPName read _SAMPLE_MASK_VALUE_SGIS;
    public static property SAMPLE_COVERAGE_INVERT:                         GetPName read _SAMPLE_COVERAGE_INVERT;
    public static property SAMPLE_MASK_INVERT_SGIS:                        GetPName read _SAMPLE_MASK_INVERT_SGIS;
    public static property SAMPLE_PATTERN_SGIS:                            GetPName read _SAMPLE_PATTERN_SGIS;
    public static property COLOR_MATRIX_SGI:                               GetPName read _COLOR_MATRIX_SGI;
    public static property COLOR_MATRIX_STACK_DEPTH_SGI:                   GetPName read _COLOR_MATRIX_STACK_DEPTH_SGI;
    public static property MAX_COLOR_MATRIX_STACK_DEPTH_SGI:               GetPName read _MAX_COLOR_MATRIX_STACK_DEPTH_SGI;
    public static property POST_COLOR_MATRIX_RED_SCALE_SGI:                GetPName read _POST_COLOR_MATRIX_RED_SCALE_SGI;
    public static property POST_COLOR_MATRIX_GREEN_SCALE_SGI:              GetPName read _POST_COLOR_MATRIX_GREEN_SCALE_SGI;
    public static property POST_COLOR_MATRIX_BLUE_SCALE_SGI:               GetPName read _POST_COLOR_MATRIX_BLUE_SCALE_SGI;
    public static property POST_COLOR_MATRIX_ALPHA_SCALE_SGI:              GetPName read _POST_COLOR_MATRIX_ALPHA_SCALE_SGI;
    public static property POST_COLOR_MATRIX_RED_BIAS_SGI:                 GetPName read _POST_COLOR_MATRIX_RED_BIAS_SGI;
    public static property POST_COLOR_MATRIX_GREEN_BIAS_SGI:               GetPName read _POST_COLOR_MATRIX_GREEN_BIAS_SGI;
    public static property POST_COLOR_MATRIX_BLUE_BIAS_SGI:                GetPName read _POST_COLOR_MATRIX_BLUE_BIAS_SGI;
    public static property POST_COLOR_MATRIX_ALPHA_BIAS_SGI:               GetPName read _POST_COLOR_MATRIX_ALPHA_BIAS_SGI;
    public static property TEXTURE_COLOR_TABLE_SGI:                        GetPName read _TEXTURE_COLOR_TABLE_SGI;
    public static property BLEND_DST_RGB:                                  GetPName read _BLEND_DST_RGB;
    public static property BLEND_SRC_RGB:                                  GetPName read _BLEND_SRC_RGB;
    public static property BLEND_DST_ALPHA:                                GetPName read _BLEND_DST_ALPHA;
    public static property BLEND_SRC_ALPHA:                                GetPName read _BLEND_SRC_ALPHA;
    public static property COLOR_TABLE_SGI:                                GetPName read _COLOR_TABLE_SGI;
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:               GetPName read _POST_CONVOLUTION_COLOR_TABLE_SGI;
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI:              GetPName read _POST_COLOR_MATRIX_COLOR_TABLE_SGI;
    public static property MAX_ELEMENTS_VERTICES:                          GetPName read _MAX_ELEMENTS_VERTICES;
    public static property MAX_ELEMENTS_INDICES:                           GetPName read _MAX_ELEMENTS_INDICES;
    public static property POINT_SIZE_MIN_SGIS:                            GetPName read _POINT_SIZE_MIN_SGIS;
    public static property POINT_SIZE_MAX_SGIS:                            GetPName read _POINT_SIZE_MAX_SGIS;
    public static property POINT_FADE_THRESHOLD_SIZE:                      GetPName read _POINT_FADE_THRESHOLD_SIZE;
    public static property POINT_FADE_THRESHOLD_SIZE_SGIS:                 GetPName read _POINT_FADE_THRESHOLD_SIZE_SGIS;
    public static property DISTANCE_ATTENUATION_SGIS:                      GetPName read _DISTANCE_ATTENUATION_SGIS;
    public static property FOG_FUNC_POINTS_SGIS:                           GetPName read _FOG_FUNC_POINTS_SGIS;
    public static property MAX_FOG_FUNC_POINTS_SGIS:                       GetPName read _MAX_FOG_FUNC_POINTS_SGIS;
    public static property PACK_SKIP_VOLUMES_SGIS:                         GetPName read _PACK_SKIP_VOLUMES_SGIS;
    public static property PACK_IMAGE_DEPTH_SGIS:                          GetPName read _PACK_IMAGE_DEPTH_SGIS;
    public static property UNPACK_SKIP_VOLUMES_SGIS:                       GetPName read _UNPACK_SKIP_VOLUMES_SGIS;
    public static property UNPACK_IMAGE_DEPTH_SGIS:                        GetPName read _UNPACK_IMAGE_DEPTH_SGIS;
    public static property TEXTURE_4D_SGIS:                                GetPName read _TEXTURE_4D_SGIS;
    public static property MAX_4D_TEXTURE_SIZE_SGIS:                       GetPName read _MAX_4D_TEXTURE_SIZE_SGIS;
    public static property PIXEL_TEX_GEN_SGIX:                             GetPName read _PIXEL_TEX_GEN_SGIX;
    public static property PIXEL_TILE_BEST_ALIGNMENT_SGIX:                 GetPName read _PIXEL_TILE_BEST_ALIGNMENT_SGIX;
    public static property PIXEL_TILE_CACHE_INCREMENT_SGIX:                GetPName read _PIXEL_TILE_CACHE_INCREMENT_SGIX;
    public static property PIXEL_TILE_WIDTH_SGIX:                          GetPName read _PIXEL_TILE_WIDTH_SGIX;
    public static property PIXEL_TILE_HEIGHT_SGIX:                         GetPName read _PIXEL_TILE_HEIGHT_SGIX;
    public static property PIXEL_TILE_GRID_WIDTH_SGIX:                     GetPName read _PIXEL_TILE_GRID_WIDTH_SGIX;
    public static property PIXEL_TILE_GRID_HEIGHT_SGIX:                    GetPName read _PIXEL_TILE_GRID_HEIGHT_SGIX;
    public static property PIXEL_TILE_GRID_DEPTH_SGIX:                     GetPName read _PIXEL_TILE_GRID_DEPTH_SGIX;
    public static property PIXEL_TILE_CACHE_SIZE_SGIX:                     GetPName read _PIXEL_TILE_CACHE_SIZE_SGIX;
    public static property SPRITE_SGIX:                                    GetPName read _SPRITE_SGIX;
    public static property SPRITE_MODE_SGIX:                               GetPName read _SPRITE_MODE_SGIX;
    public static property SPRITE_AXIS_SGIX:                               GetPName read _SPRITE_AXIS_SGIX;
    public static property SPRITE_TRANSLATION_SGIX:                        GetPName read _SPRITE_TRANSLATION_SGIX;
    public static property TEXTURE_4D_BINDING_SGIS:                        GetPName read _TEXTURE_4D_BINDING_SGIS;
    public static property MAX_CLIPMAP_DEPTH_SGIX:                         GetPName read _MAX_CLIPMAP_DEPTH_SGIX;
    public static property MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX:                 GetPName read _MAX_CLIPMAP_VIRTUAL_DEPTH_SGIX;
    public static property POST_TEXTURE_FILTER_BIAS_RANGE_SGIX:            GetPName read _POST_TEXTURE_FILTER_BIAS_RANGE_SGIX;
    public static property POST_TEXTURE_FILTER_SCALE_RANGE_SGIX:           GetPName read _POST_TEXTURE_FILTER_SCALE_RANGE_SGIX;
    public static property REFERENCE_PLANE_SGIX:                           GetPName read _REFERENCE_PLANE_SGIX;
    public static property REFERENCE_PLANE_EQUATION_SGIX:                  GetPName read _REFERENCE_PLANE_EQUATION_SGIX;
    public static property IR_INSTRUMENT1_SGIX:                            GetPName read _IR_INSTRUMENT1_SGIX;
    public static property INSTRUMENT_MEASUREMENTS_SGIX:                   GetPName read _INSTRUMENT_MEASUREMENTS_SGIX;
    public static property CALLIGRAPHIC_FRAGMENT_SGIX:                     GetPName read _CALLIGRAPHIC_FRAGMENT_SGIX;
    public static property FRAMEZOOM_SGIX:                                 GetPName read _FRAMEZOOM_SGIX;
    public static property FRAMEZOOM_FACTOR_SGIX:                          GetPName read _FRAMEZOOM_FACTOR_SGIX;
    public static property MAX_FRAMEZOOM_FACTOR_SGIX:                      GetPName read _MAX_FRAMEZOOM_FACTOR_SGIX;
    public static property GENERATE_MIPMAP_HINT_SGIS:                      GetPName read _GENERATE_MIPMAP_HINT_SGIS;
    public static property DEFORMATIONS_MASK_SGIX:                         GetPName read _DEFORMATIONS_MASK_SGIX;
    public static property FOG_OFFSET_SGIX:                                GetPName read _FOG_OFFSET_SGIX;
    public static property FOG_OFFSET_VALUE_SGIX:                          GetPName read _FOG_OFFSET_VALUE_SGIX;
    public static property LIGHT_MODEL_COLOR_CONTROL:                      GetPName read _LIGHT_MODEL_COLOR_CONTROL;
    public static property SHARED_TEXTURE_PALETTE_EXT:                     GetPName read _SHARED_TEXTURE_PALETTE_EXT;
    public static property MAJOR_VERSION:                                  GetPName read _MAJOR_VERSION;
    public static property MINOR_VERSION:                                  GetPName read _MINOR_VERSION;
    public static property NUM_EXTENSIONS:                                 GetPName read _NUM_EXTENSIONS;
    public static property CONTEXT_FLAGS:                                  GetPName read _CONTEXT_FLAGS;
    public static property PROGRAM_PIPELINE_BINDING:                       GetPName read _PROGRAM_PIPELINE_BINDING;
    public static property MAX_VIEWPORTS:                                  GetPName read _MAX_VIEWPORTS;
    public static property VIEWPORT_SUBPIXEL_BITS:                         GetPName read _VIEWPORT_SUBPIXEL_BITS;
    public static property VIEWPORT_BOUNDS_RANGE:                          GetPName read _VIEWPORT_BOUNDS_RANGE;
    public static property LAYER_PROVOKING_VERTEX:                         GetPName read _LAYER_PROVOKING_VERTEX;
    public static property VIEWPORT_INDEX_PROVOKING_VERTEX:                GetPName read _VIEWPORT_INDEX_PROVOKING_VERTEX;
    public static property MAX_COMPUTE_UNIFORM_COMPONENTS:                 GetPName read _MAX_COMPUTE_UNIFORM_COMPONENTS;
    public static property MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS:             GetPName read _MAX_COMPUTE_ATOMIC_COUNTER_BUFFERS;
    public static property MAX_COMPUTE_ATOMIC_COUNTERS:                    GetPName read _MAX_COMPUTE_ATOMIC_COUNTERS;
    public static property MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS:        GetPName read _MAX_COMBINED_COMPUTE_UNIFORM_COMPONENTS;
    public static property MAX_DEBUG_GROUP_STACK_DEPTH:                    GetPName read _MAX_DEBUG_GROUP_STACK_DEPTH;
    public static property DEBUG_GROUP_STACK_DEPTH:                        GetPName read _DEBUG_GROUP_STACK_DEPTH;
    public static property MAX_UNIFORM_LOCATIONS:                          GetPName read _MAX_UNIFORM_LOCATIONS;
    public static property VERTEX_BINDING_DIVISOR:                         GetPName read _VERTEX_BINDING_DIVISOR;
    public static property VERTEX_BINDING_OFFSET:                          GetPName read _VERTEX_BINDING_OFFSET;
    public static property VERTEX_BINDING_STRIDE:                          GetPName read _VERTEX_BINDING_STRIDE;
    public static property MAX_VERTEX_ATTRIB_RELATIVE_OFFSET:              GetPName read _MAX_VERTEX_ATTRIB_RELATIVE_OFFSET;
    public static property MAX_VERTEX_ATTRIB_BINDINGS:                     GetPName read _MAX_VERTEX_ATTRIB_BINDINGS;
    public static property MAX_LABEL_LENGTH:                               GetPName read _MAX_LABEL_LENGTH;
    public static property CONVOLUTION_HINT_SGIX:                          GetPName read _CONVOLUTION_HINT_SGIX;
    public static property ASYNC_MARKER_SGIX:                              GetPName read _ASYNC_MARKER_SGIX;
    public static property PIXEL_TEX_GEN_MODE_SGIX:                        GetPName read _PIXEL_TEX_GEN_MODE_SGIX;
    public static property ASYNC_HISTOGRAM_SGIX:                           GetPName read _ASYNC_HISTOGRAM_SGIX;
    public static property MAX_ASYNC_HISTOGRAM_SGIX:                       GetPName read _MAX_ASYNC_HISTOGRAM_SGIX;
    public static property PIXEL_TEXTURE_SGIS:                             GetPName read _PIXEL_TEXTURE_SGIS;
    public static property ASYNC_TEX_IMAGE_SGIX:                           GetPName read _ASYNC_TEX_IMAGE_SGIX;
    public static property ASYNC_DRAW_PIXELS_SGIX:                         GetPName read _ASYNC_DRAW_PIXELS_SGIX;
    public static property ASYNC_READ_PIXELS_SGIX:                         GetPName read _ASYNC_READ_PIXELS_SGIX;
    public static property MAX_ASYNC_TEX_IMAGE_SGIX:                       GetPName read _MAX_ASYNC_TEX_IMAGE_SGIX;
    public static property MAX_ASYNC_DRAW_PIXELS_SGIX:                     GetPName read _MAX_ASYNC_DRAW_PIXELS_SGIX;
    public static property MAX_ASYNC_READ_PIXELS_SGIX:                     GetPName read _MAX_ASYNC_READ_PIXELS_SGIX;
    public static property VERTEX_PRECLIP_SGIX:                            GetPName read _VERTEX_PRECLIP_SGIX;
    public static property VERTEX_PRECLIP_HINT_SGIX:                       GetPName read _VERTEX_PRECLIP_HINT_SGIX;
    public static property FRAGMENT_LIGHTING_SGIX:                         GetPName read _FRAGMENT_LIGHTING_SGIX;
    public static property FRAGMENT_COLOR_MATERIAL_SGIX:                   GetPName read _FRAGMENT_COLOR_MATERIAL_SGIX;
    public static property FRAGMENT_COLOR_MATERIAL_FACE_SGIX:              GetPName read _FRAGMENT_COLOR_MATERIAL_FACE_SGIX;
    public static property FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX:         GetPName read _FRAGMENT_COLOR_MATERIAL_PARAMETER_SGIX;
    public static property MAX_FRAGMENT_LIGHTS_SGIX:                       GetPName read _MAX_FRAGMENT_LIGHTS_SGIX;
    public static property MAX_ACTIVE_LIGHTS_SGIX:                         GetPName read _MAX_ACTIVE_LIGHTS_SGIX;
    public static property LIGHT_ENV_MODE_SGIX:                            GetPName read _LIGHT_ENV_MODE_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX:         GetPName read _FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX:             GetPName read _FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX:              GetPName read _FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX: GetPName read _FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX;
    public static property FRAGMENT_LIGHT0_SGIX:                           GetPName read _FRAGMENT_LIGHT0_SGIX;
    public static property PACK_RESAMPLE_SGIX:                             GetPName read _PACK_RESAMPLE_SGIX;
    public static property UNPACK_RESAMPLE_SGIX:                           GetPName read _UNPACK_RESAMPLE_SGIX;
    public static property ALIASED_POINT_SIZE_RANGE:                       GetPName read _ALIASED_POINT_SIZE_RANGE;
    public static property ALIASED_LINE_WIDTH_RANGE:                       GetPName read _ALIASED_LINE_WIDTH_RANGE;
    public static property ACTIVE_TEXTURE:                                 GetPName read _ACTIVE_TEXTURE;
    public static property MAX_RENDERBUFFER_SIZE:                          GetPName read _MAX_RENDERBUFFER_SIZE;
    public static property TEXTURE_COMPRESSION_HINT:                       GetPName read _TEXTURE_COMPRESSION_HINT;
    public static property TEXTURE_BINDING_RECTANGLE:                      GetPName read _TEXTURE_BINDING_RECTANGLE;
    public static property MAX_RECTANGLE_TEXTURE_SIZE:                     GetPName read _MAX_RECTANGLE_TEXTURE_SIZE;
    public static property MAX_TEXTURE_LOD_BIAS:                           GetPName read _MAX_TEXTURE_LOD_BIAS;
    public static property TEXTURE_BINDING_CUBE_MAP:                       GetPName read _TEXTURE_BINDING_CUBE_MAP;
    public static property MAX_CUBE_MAP_TEXTURE_SIZE:                      GetPName read _MAX_CUBE_MAP_TEXTURE_SIZE;
    public static property PACK_SUBSAMPLE_RATE_SGIX:                       GetPName read _PACK_SUBSAMPLE_RATE_SGIX;
    public static property UNPACK_SUBSAMPLE_RATE_SGIX:                     GetPName read _UNPACK_SUBSAMPLE_RATE_SGIX;
    public static property VERTEX_ARRAY_BINDING:                           GetPName read _VERTEX_ARRAY_BINDING;
    public static property PROGRAM_POINT_SIZE:                             GetPName read _PROGRAM_POINT_SIZE;
    public static property NUM_COMPRESSED_TEXTURE_FORMATS:                 GetPName read _NUM_COMPRESSED_TEXTURE_FORMATS;
    public static property COMPRESSED_TEXTURE_FORMATS:                     GetPName read _COMPRESSED_TEXTURE_FORMATS;
    public static property NUM_PROGRAM_BINARY_FORMATS:                     GetPName read _NUM_PROGRAM_BINARY_FORMATS;
    public static property PROGRAM_BINARY_FORMATS:                         GetPName read _PROGRAM_BINARY_FORMATS;
    public static property STENCIL_BACK_FUNC:                              GetPName read _STENCIL_BACK_FUNC;
    public static property STENCIL_BACK_FAIL:                              GetPName read _STENCIL_BACK_FAIL;
    public static property STENCIL_BACK_PASS_DEPTH_FAIL:                   GetPName read _STENCIL_BACK_PASS_DEPTH_FAIL;
    public static property STENCIL_BACK_PASS_DEPTH_PASS:                   GetPName read _STENCIL_BACK_PASS_DEPTH_PASS;
    public static property MAX_DRAW_BUFFERS:                               GetPName read _MAX_DRAW_BUFFERS;
    public static property BLEND_EQUATION_ALPHA:                           GetPName read _BLEND_EQUATION_ALPHA;
    public static property MAX_VERTEX_ATTRIBS:                             GetPName read _MAX_VERTEX_ATTRIBS;
    public static property MAX_TEXTURE_IMAGE_UNITS:                        GetPName read _MAX_TEXTURE_IMAGE_UNITS;
    public static property ARRAY_BUFFER_BINDING:                           GetPName read _ARRAY_BUFFER_BINDING;
    public static property ELEMENT_ARRAY_BUFFER_BINDING:                   GetPName read _ELEMENT_ARRAY_BUFFER_BINDING;
    public static property PIXEL_PACK_BUFFER_BINDING:                      GetPName read _PIXEL_PACK_BUFFER_BINDING;
    public static property PIXEL_UNPACK_BUFFER_BINDING:                    GetPName read _PIXEL_UNPACK_BUFFER_BINDING;
    public static property MAX_DUAL_SOURCE_DRAW_BUFFERS:                   GetPName read _MAX_DUAL_SOURCE_DRAW_BUFFERS;
    public static property MAX_ARRAY_TEXTURE_LAYERS:                       GetPName read _MAX_ARRAY_TEXTURE_LAYERS;
    public static property MIN_PROGRAM_TEXEL_OFFSET:                       GetPName read _MIN_PROGRAM_TEXEL_OFFSET;
    public static property MAX_PROGRAM_TEXEL_OFFSET:                       GetPName read _MAX_PROGRAM_TEXEL_OFFSET;
    public static property SAMPLER_BINDING:                                GetPName read _SAMPLER_BINDING;
    public static property UNIFORM_BUFFER_BINDING:                         GetPName read _UNIFORM_BUFFER_BINDING;
    public static property UNIFORM_BUFFER_START:                           GetPName read _UNIFORM_BUFFER_START;
    public static property UNIFORM_BUFFER_SIZE:                            GetPName read _UNIFORM_BUFFER_SIZE;
    public static property MAX_VERTEX_UNIFORM_BLOCKS:                      GetPName read _MAX_VERTEX_UNIFORM_BLOCKS;
    public static property MAX_GEOMETRY_UNIFORM_BLOCKS:                    GetPName read _MAX_GEOMETRY_UNIFORM_BLOCKS;
    public static property MAX_FRAGMENT_UNIFORM_BLOCKS:                    GetPName read _MAX_FRAGMENT_UNIFORM_BLOCKS;
    public static property MAX_COMBINED_UNIFORM_BLOCKS:                    GetPName read _MAX_COMBINED_UNIFORM_BLOCKS;
    public static property MAX_UNIFORM_BUFFER_BINDINGS:                    GetPName read _MAX_UNIFORM_BUFFER_BINDINGS;
    public static property MAX_UNIFORM_BLOCK_SIZE:                         GetPName read _MAX_UNIFORM_BLOCK_SIZE;
    public static property MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:         GetPName read _MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS;
    public static property MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS:       GetPName read _MAX_COMBINED_GEOMETRY_UNIFORM_COMPONENTS;
    public static property MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:       GetPName read _MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS;
    public static property UNIFORM_BUFFER_OFFSET_ALIGNMENT:                GetPName read _UNIFORM_BUFFER_OFFSET_ALIGNMENT;
    public static property MAX_FRAGMENT_UNIFORM_COMPONENTS:                GetPName read _MAX_FRAGMENT_UNIFORM_COMPONENTS;
    public static property MAX_VERTEX_UNIFORM_COMPONENTS:                  GetPName read _MAX_VERTEX_UNIFORM_COMPONENTS;
    public static property MAX_VARYING_COMPONENTS:                         GetPName read _MAX_VARYING_COMPONENTS;
    public static property MAX_VARYING_FLOATS:                             GetPName read _MAX_VARYING_FLOATS;
    public static property MAX_VERTEX_TEXTURE_IMAGE_UNITS:                 GetPName read _MAX_VERTEX_TEXTURE_IMAGE_UNITS;
    public static property MAX_COMBINED_TEXTURE_IMAGE_UNITS:               GetPName read _MAX_COMBINED_TEXTURE_IMAGE_UNITS;
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT:                GetPName read _FRAGMENT_SHADER_DERIVATIVE_HINT;
    public static property CURRENT_PROGRAM:                                GetPName read _CURRENT_PROGRAM;
    public static property IMPLEMENTATION_COLOR_READ_TYPE:                 GetPName read _IMPLEMENTATION_COLOR_READ_TYPE;
    public static property IMPLEMENTATION_COLOR_READ_FORMAT:               GetPName read _IMPLEMENTATION_COLOR_READ_FORMAT;
    public static property TEXTURE_BINDING_1D_ARRAY:                       GetPName read _TEXTURE_BINDING_1D_ARRAY;
    public static property TEXTURE_BINDING_2D_ARRAY:                       GetPName read _TEXTURE_BINDING_2D_ARRAY;
    public static property MAX_GEOMETRY_TEXTURE_IMAGE_UNITS:               GetPName read _MAX_GEOMETRY_TEXTURE_IMAGE_UNITS;
    public static property MAX_TEXTURE_BUFFER_SIZE:                        GetPName read _MAX_TEXTURE_BUFFER_SIZE;
    public static property TEXTURE_BINDING_BUFFER:                         GetPName read _TEXTURE_BINDING_BUFFER;
    public static property TRANSFORM_FEEDBACK_BUFFER_START:                GetPName read _TRANSFORM_FEEDBACK_BUFFER_START;
    public static property TRANSFORM_FEEDBACK_BUFFER_SIZE:                 GetPName read _TRANSFORM_FEEDBACK_BUFFER_SIZE;
    public static property TRANSFORM_FEEDBACK_BUFFER_BINDING:              GetPName read _TRANSFORM_FEEDBACK_BUFFER_BINDING;
    public static property STENCIL_BACK_REF:                               GetPName read _STENCIL_BACK_REF;
    public static property STENCIL_BACK_VALUE_MASK:                        GetPName read _STENCIL_BACK_VALUE_MASK;
    public static property STENCIL_BACK_WRITEMASK:                         GetPName read _STENCIL_BACK_WRITEMASK;
    public static property DRAW_FRAMEBUFFER_BINDING:                       GetPName read _DRAW_FRAMEBUFFER_BINDING;
    public static property RENDERBUFFER_BINDING:                           GetPName read _RENDERBUFFER_BINDING;
    public static property READ_FRAMEBUFFER_BINDING:                       GetPName read _READ_FRAMEBUFFER_BINDING;
    public static property MAX_ELEMENT_INDEX:                              GetPName read _MAX_ELEMENT_INDEX;
    public static property MAX_GEOMETRY_UNIFORM_COMPONENTS:                GetPName read _MAX_GEOMETRY_UNIFORM_COMPONENTS;
    public static property NUM_SHADER_BINARY_FORMATS:                      GetPName read _NUM_SHADER_BINARY_FORMATS;
    public static property SHADER_COMPILER:                                GetPName read _SHADER_COMPILER;
    public static property MAX_VERTEX_UNIFORM_VECTORS:                     GetPName read _MAX_VERTEX_UNIFORM_VECTORS;
    public static property MAX_VARYING_VECTORS:                            GetPName read _MAX_VARYING_VECTORS;
    public static property MAX_FRAGMENT_UNIFORM_VECTORS:                   GetPName read _MAX_FRAGMENT_UNIFORM_VECTORS;
    public static property TIMESTAMP:                                      GetPName read _TIMESTAMP;
    public static property PROVOKING_VERTEX:                               GetPName read _PROVOKING_VERTEX;
    public static property MAX_SAMPLE_MASK_WORDS:                          GetPName read _MAX_SAMPLE_MASK_WORDS;
    public static property PRIMITIVE_RESTART_INDEX:                        GetPName read _PRIMITIVE_RESTART_INDEX;
    public static property MIN_MAP_BUFFER_ALIGNMENT:                       GetPName read _MIN_MAP_BUFFER_ALIGNMENT;
    public static property SHADER_STORAGE_BUFFER_BINDING:                  GetPName read _SHADER_STORAGE_BUFFER_BINDING;
    public static property SHADER_STORAGE_BUFFER_START:                    GetPName read _SHADER_STORAGE_BUFFER_START;
    public static property SHADER_STORAGE_BUFFER_SIZE:                     GetPName read _SHADER_STORAGE_BUFFER_SIZE;
    public static property MAX_VERTEX_SHADER_STORAGE_BLOCKS:               GetPName read _MAX_VERTEX_SHADER_STORAGE_BLOCKS;
    public static property MAX_GEOMETRY_SHADER_STORAGE_BLOCKS:             GetPName read _MAX_GEOMETRY_SHADER_STORAGE_BLOCKS;
    public static property MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS:         GetPName read _MAX_TESS_CONTROL_SHADER_STORAGE_BLOCKS;
    public static property MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS:      GetPName read _MAX_TESS_EVALUATION_SHADER_STORAGE_BLOCKS;
    public static property MAX_FRAGMENT_SHADER_STORAGE_BLOCKS:             GetPName read _MAX_FRAGMENT_SHADER_STORAGE_BLOCKS;
    public static property MAX_COMPUTE_SHADER_STORAGE_BLOCKS:              GetPName read _MAX_COMPUTE_SHADER_STORAGE_BLOCKS;
    public static property MAX_COMBINED_SHADER_STORAGE_BLOCKS:             GetPName read _MAX_COMBINED_SHADER_STORAGE_BLOCKS;
    public static property MAX_SHADER_STORAGE_BUFFER_BINDINGS:             GetPName read _MAX_SHADER_STORAGE_BUFFER_BINDINGS;
    public static property SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT:         GetPName read _SHADER_STORAGE_BUFFER_OFFSET_ALIGNMENT;
    public static property MAX_COMPUTE_WORK_GROUP_INVOCATIONS:             GetPName read _MAX_COMPUTE_WORK_GROUP_INVOCATIONS;
    public static property DISPATCH_INDIRECT_BUFFER_BINDING:               GetPName read _DISPATCH_INDIRECT_BUFFER_BINDING;
    public static property TEXTURE_BINDING_2D_MULTISAMPLE:                 GetPName read _TEXTURE_BINDING_2D_MULTISAMPLE;
    public static property TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY:           GetPName read _TEXTURE_BINDING_2D_MULTISAMPLE_ARRAY;
    public static property MAX_COLOR_TEXTURE_SAMPLES:                      GetPName read _MAX_COLOR_TEXTURE_SAMPLES;
    public static property MAX_DEPTH_TEXTURE_SAMPLES:                      GetPName read _MAX_DEPTH_TEXTURE_SAMPLES;
    public static property MAX_INTEGER_SAMPLES:                            GetPName read _MAX_INTEGER_SAMPLES;
    public static property MAX_SERVER_WAIT_TIMEOUT:                        GetPName read _MAX_SERVER_WAIT_TIMEOUT;
    public static property MAX_VERTEX_OUTPUT_COMPONENTS:                   GetPName read _MAX_VERTEX_OUTPUT_COMPONENTS;
    public static property MAX_GEOMETRY_INPUT_COMPONENTS:                  GetPName read _MAX_GEOMETRY_INPUT_COMPONENTS;
    public static property MAX_GEOMETRY_OUTPUT_COMPONENTS:                 GetPName read _MAX_GEOMETRY_OUTPUT_COMPONENTS;
    public static property MAX_FRAGMENT_INPUT_COMPONENTS:                  GetPName read _MAX_FRAGMENT_INPUT_COMPONENTS;
    public static property TEXTURE_BUFFER_OFFSET_ALIGNMENT:                GetPName read _TEXTURE_BUFFER_OFFSET_ALIGNMENT;
    public static property MAX_COMPUTE_UNIFORM_BLOCKS:                     GetPName read _MAX_COMPUTE_UNIFORM_BLOCKS;
    public static property MAX_COMPUTE_TEXTURE_IMAGE_UNITS:                GetPName read _MAX_COMPUTE_TEXTURE_IMAGE_UNITS;
    public static property MAX_COMPUTE_WORK_GROUP_COUNT:                   GetPName read _MAX_COMPUTE_WORK_GROUP_COUNT;
    public static property MAX_COMPUTE_WORK_GROUP_SIZE:                    GetPName read _MAX_COMPUTE_WORK_GROUP_SIZE;
    public static property MAX_VERTEX_ATOMIC_COUNTERS:                     GetPName read _MAX_VERTEX_ATOMIC_COUNTERS;
    public static property MAX_TESS_CONTROL_ATOMIC_COUNTERS:               GetPName read _MAX_TESS_CONTROL_ATOMIC_COUNTERS;
    public static property MAX_TESS_EVALUATION_ATOMIC_COUNTERS:            GetPName read _MAX_TESS_EVALUATION_ATOMIC_COUNTERS;
    public static property MAX_GEOMETRY_ATOMIC_COUNTERS:                   GetPName read _MAX_GEOMETRY_ATOMIC_COUNTERS;
    public static property MAX_FRAGMENT_ATOMIC_COUNTERS:                   GetPName read _MAX_FRAGMENT_ATOMIC_COUNTERS;
    public static property MAX_COMBINED_ATOMIC_COUNTERS:                   GetPName read _MAX_COMBINED_ATOMIC_COUNTERS;
    public static property MAX_FRAMEBUFFER_WIDTH:                          GetPName read _MAX_FRAMEBUFFER_WIDTH;
    public static property MAX_FRAMEBUFFER_HEIGHT:                         GetPName read _MAX_FRAMEBUFFER_HEIGHT;
    public static property MAX_FRAMEBUFFER_LAYERS:                         GetPName read _MAX_FRAMEBUFFER_LAYERS;
    public static property MAX_FRAMEBUFFER_SAMPLES:                        GetPName read _MAX_FRAMEBUFFER_SAMPLES;
    public static property NUM_DEVICE_UUIDS_EXT:                           GetPName read _NUM_DEVICE_UUIDS_EXT;
    public static property DEVICE_UUID_EXT:                                GetPName read _DEVICE_UUID_EXT;
    public static property DRIVER_UUID_EXT:                                GetPName read _DRIVER_UUID_EXT;
    public static property DEVICE_LUID_EXT:                                GetPName read _DEVICE_LUID_EXT;
    public static property DEVICE_NODE_MASK_EXT:                           GetPName read _DEVICE_NODE_MASK_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetPointervPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FEEDBACK_BUFFER_POINTER         := new GetPointervPName($0DF0);
    private static _SELECTION_BUFFER_POINTER        := new GetPointervPName($0DF3);
    private static _VERTEX_ARRAY_POINTER            := new GetPointervPName($808E);
    private static _VERTEX_ARRAY_POINTER_EXT        := new GetPointervPName($808E);
    private static _NORMAL_ARRAY_POINTER            := new GetPointervPName($808F);
    private static _NORMAL_ARRAY_POINTER_EXT        := new GetPointervPName($808F);
    private static _COLOR_ARRAY_POINTER             := new GetPointervPName($8090);
    private static _COLOR_ARRAY_POINTER_EXT         := new GetPointervPName($8090);
    private static _INDEX_ARRAY_POINTER             := new GetPointervPName($8091);
    private static _INDEX_ARRAY_POINTER_EXT         := new GetPointervPName($8091);
    private static _TEXTURE_COORD_ARRAY_POINTER     := new GetPointervPName($8092);
    private static _TEXTURE_COORD_ARRAY_POINTER_EXT := new GetPointervPName($8092);
    private static _EDGE_FLAG_ARRAY_POINTER         := new GetPointervPName($8093);
    private static _EDGE_FLAG_ARRAY_POINTER_EXT     := new GetPointervPName($8093);
    private static _INSTRUMENT_BUFFER_POINTER_SGIX  := new GetPointervPName($8180);
    private static _DEBUG_CALLBACK_FUNCTION         := new GetPointervPName($8244);
    private static _DEBUG_CALLBACK_USER_PARAM       := new GetPointervPName($8245);
    
    public static property FEEDBACK_BUFFER_POINTER:         GetPointervPName read _FEEDBACK_BUFFER_POINTER;
    public static property SELECTION_BUFFER_POINTER:        GetPointervPName read _SELECTION_BUFFER_POINTER;
    public static property VERTEX_ARRAY_POINTER:            GetPointervPName read _VERTEX_ARRAY_POINTER;
    public static property VERTEX_ARRAY_POINTER_EXT:        GetPointervPName read _VERTEX_ARRAY_POINTER_EXT;
    public static property NORMAL_ARRAY_POINTER:            GetPointervPName read _NORMAL_ARRAY_POINTER;
    public static property NORMAL_ARRAY_POINTER_EXT:        GetPointervPName read _NORMAL_ARRAY_POINTER_EXT;
    public static property COLOR_ARRAY_POINTER:             GetPointervPName read _COLOR_ARRAY_POINTER;
    public static property COLOR_ARRAY_POINTER_EXT:         GetPointervPName read _COLOR_ARRAY_POINTER_EXT;
    public static property INDEX_ARRAY_POINTER:             GetPointervPName read _INDEX_ARRAY_POINTER;
    public static property INDEX_ARRAY_POINTER_EXT:         GetPointervPName read _INDEX_ARRAY_POINTER_EXT;
    public static property TEXTURE_COORD_ARRAY_POINTER:     GetPointervPName read _TEXTURE_COORD_ARRAY_POINTER;
    public static property TEXTURE_COORD_ARRAY_POINTER_EXT: GetPointervPName read _TEXTURE_COORD_ARRAY_POINTER_EXT;
    public static property EDGE_FLAG_ARRAY_POINTER:         GetPointervPName read _EDGE_FLAG_ARRAY_POINTER;
    public static property EDGE_FLAG_ARRAY_POINTER_EXT:     GetPointervPName read _EDGE_FLAG_ARRAY_POINTER_EXT;
    public static property INSTRUMENT_BUFFER_POINTER_SGIX:  GetPointervPName read _INSTRUMENT_BUFFER_POINTER_SGIX;
    public static property DEBUG_CALLBACK_FUNCTION:         GetPointervPName read _DEBUG_CALLBACK_FUNCTION;
    public static property DEBUG_CALLBACK_USER_PARAM:       GetPointervPName read _DEBUG_CALLBACK_USER_PARAM;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetPointervPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetPointervPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetPointervPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetTextureParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_WIDTH                        := new GetTextureParameter($1000);
    private static _TEXTURE_HEIGHT                       := new GetTextureParameter($1001);
    private static _TEXTURE_COMPONENTS                   := new GetTextureParameter($1003);
    private static _TEXTURE_INTERNAL_FORMAT              := new GetTextureParameter($1003);
    private static _TEXTURE_BORDER_COLOR                 := new GetTextureParameter($1004);
    private static _TEXTURE_BORDER_COLOR_NV              := new GetTextureParameter($1004);
    private static _TEXTURE_BORDER                       := new GetTextureParameter($1005);
    private static _TEXTURE_MAG_FILTER                   := new GetTextureParameter($2800);
    private static _TEXTURE_MIN_FILTER                   := new GetTextureParameter($2801);
    private static _TEXTURE_WRAP_S                       := new GetTextureParameter($2802);
    private static _TEXTURE_WRAP_T                       := new GetTextureParameter($2803);
    private static _TEXTURE_RED_SIZE                     := new GetTextureParameter($805C);
    private static _TEXTURE_GREEN_SIZE                   := new GetTextureParameter($805D);
    private static _TEXTURE_BLUE_SIZE                    := new GetTextureParameter($805E);
    private static _TEXTURE_ALPHA_SIZE                   := new GetTextureParameter($805F);
    private static _TEXTURE_LUMINANCE_SIZE               := new GetTextureParameter($8060);
    private static _TEXTURE_INTENSITY_SIZE               := new GetTextureParameter($8061);
    private static _TEXTURE_PRIORITY                     := new GetTextureParameter($8066);
    private static _TEXTURE_RESIDENT                     := new GetTextureParameter($8067);
    private static _TEXTURE_DEPTH_EXT                    := new GetTextureParameter($8071);
    private static _TEXTURE_WRAP_R_EXT                   := new GetTextureParameter($8072);
    private static _DETAIL_TEXTURE_LEVEL_SGIS            := new GetTextureParameter($809A);
    private static _DETAIL_TEXTURE_MODE_SGIS             := new GetTextureParameter($809B);
    private static _DETAIL_TEXTURE_FUNC_POINTS_SGIS      := new GetTextureParameter($809C);
    private static _SHARPEN_TEXTURE_FUNC_POINTS_SGIS     := new GetTextureParameter($80B0);
    private static _SHADOW_AMBIENT_SGIX                  := new GetTextureParameter($80BF);
    private static _DUAL_TEXTURE_SELECT_SGIS             := new GetTextureParameter($8124);
    private static _QUAD_TEXTURE_SELECT_SGIS             := new GetTextureParameter($8125);
    private static _TEXTURE_4DSIZE_SGIS                  := new GetTextureParameter($8136);
    private static _TEXTURE_WRAP_Q_SGIS                  := new GetTextureParameter($8137);
    private static _TEXTURE_MIN_LOD_SGIS                 := new GetTextureParameter($813A);
    private static _TEXTURE_MAX_LOD_SGIS                 := new GetTextureParameter($813B);
    private static _TEXTURE_BASE_LEVEL_SGIS              := new GetTextureParameter($813C);
    private static _TEXTURE_MAX_LEVEL_SGIS               := new GetTextureParameter($813D);
    private static _TEXTURE_FILTER4_SIZE_SGIS            := new GetTextureParameter($8147);
    private static _TEXTURE_CLIPMAP_CENTER_SGIX          := new GetTextureParameter($8171);
    private static _TEXTURE_CLIPMAP_FRAME_SGIX           := new GetTextureParameter($8172);
    private static _TEXTURE_CLIPMAP_OFFSET_SGIX          := new GetTextureParameter($8173);
    private static _TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX   := new GetTextureParameter($8174);
    private static _TEXTURE_CLIPMAP_LOD_OFFSET_SGIX      := new GetTextureParameter($8175);
    private static _TEXTURE_CLIPMAP_DEPTH_SGIX           := new GetTextureParameter($8176);
    private static _POST_TEXTURE_FILTER_BIAS_SGIX        := new GetTextureParameter($8179);
    private static _POST_TEXTURE_FILTER_SCALE_SGIX       := new GetTextureParameter($817A);
    private static _TEXTURE_LOD_BIAS_S_SGIX              := new GetTextureParameter($818E);
    private static _TEXTURE_LOD_BIAS_T_SGIX              := new GetTextureParameter($818F);
    private static _TEXTURE_LOD_BIAS_R_SGIX              := new GetTextureParameter($8190);
    private static _GENERATE_MIPMAP_SGIS                 := new GetTextureParameter($8191);
    private static _TEXTURE_COMPARE_SGIX                 := new GetTextureParameter($819A);
    private static _TEXTURE_COMPARE_OPERATOR_SGIX        := new GetTextureParameter($819B);
    private static _TEXTURE_LEQUAL_R_SGIX                := new GetTextureParameter($819C);
    private static _TEXTURE_GEQUAL_R_SGIX                := new GetTextureParameter($819D);
    private static _TEXTURE_MAX_CLAMP_S_SGIX             := new GetTextureParameter($8369);
    private static _TEXTURE_MAX_CLAMP_T_SGIX             := new GetTextureParameter($836A);
    private static _TEXTURE_MAX_CLAMP_R_SGIX             := new GetTextureParameter($836B);
    private static _TEXTURE_UNNORMALIZED_COORDINATES_ARM := new GetTextureParameter($8F6A);
    
    public static property TEXTURE_WIDTH:                        GetTextureParameter read _TEXTURE_WIDTH;
    public static property TEXTURE_HEIGHT:                       GetTextureParameter read _TEXTURE_HEIGHT;
    public static property TEXTURE_COMPONENTS:                   GetTextureParameter read _TEXTURE_COMPONENTS;
    public static property TEXTURE_INTERNAL_FORMAT:              GetTextureParameter read _TEXTURE_INTERNAL_FORMAT;
    public static property TEXTURE_BORDER_COLOR:                 GetTextureParameter read _TEXTURE_BORDER_COLOR;
    public static property TEXTURE_BORDER_COLOR_NV:              GetTextureParameter read _TEXTURE_BORDER_COLOR_NV;
    public static property TEXTURE_BORDER:                       GetTextureParameter read _TEXTURE_BORDER;
    public static property TEXTURE_MAG_FILTER:                   GetTextureParameter read _TEXTURE_MAG_FILTER;
    public static property TEXTURE_MIN_FILTER:                   GetTextureParameter read _TEXTURE_MIN_FILTER;
    public static property TEXTURE_WRAP_S:                       GetTextureParameter read _TEXTURE_WRAP_S;
    public static property TEXTURE_WRAP_T:                       GetTextureParameter read _TEXTURE_WRAP_T;
    public static property TEXTURE_RED_SIZE:                     GetTextureParameter read _TEXTURE_RED_SIZE;
    public static property TEXTURE_GREEN_SIZE:                   GetTextureParameter read _TEXTURE_GREEN_SIZE;
    public static property TEXTURE_BLUE_SIZE:                    GetTextureParameter read _TEXTURE_BLUE_SIZE;
    public static property TEXTURE_ALPHA_SIZE:                   GetTextureParameter read _TEXTURE_ALPHA_SIZE;
    public static property TEXTURE_LUMINANCE_SIZE:               GetTextureParameter read _TEXTURE_LUMINANCE_SIZE;
    public static property TEXTURE_INTENSITY_SIZE:               GetTextureParameter read _TEXTURE_INTENSITY_SIZE;
    public static property TEXTURE_PRIORITY:                     GetTextureParameter read _TEXTURE_PRIORITY;
    public static property TEXTURE_RESIDENT:                     GetTextureParameter read _TEXTURE_RESIDENT;
    public static property TEXTURE_DEPTH_EXT:                    GetTextureParameter read _TEXTURE_DEPTH_EXT;
    public static property TEXTURE_WRAP_R_EXT:                   GetTextureParameter read _TEXTURE_WRAP_R_EXT;
    public static property DETAIL_TEXTURE_LEVEL_SGIS:            GetTextureParameter read _DETAIL_TEXTURE_LEVEL_SGIS;
    public static property DETAIL_TEXTURE_MODE_SGIS:             GetTextureParameter read _DETAIL_TEXTURE_MODE_SGIS;
    public static property DETAIL_TEXTURE_FUNC_POINTS_SGIS:      GetTextureParameter read _DETAIL_TEXTURE_FUNC_POINTS_SGIS;
    public static property SHARPEN_TEXTURE_FUNC_POINTS_SGIS:     GetTextureParameter read _SHARPEN_TEXTURE_FUNC_POINTS_SGIS;
    public static property SHADOW_AMBIENT_SGIX:                  GetTextureParameter read _SHADOW_AMBIENT_SGIX;
    public static property DUAL_TEXTURE_SELECT_SGIS:             GetTextureParameter read _DUAL_TEXTURE_SELECT_SGIS;
    public static property QUAD_TEXTURE_SELECT_SGIS:             GetTextureParameter read _QUAD_TEXTURE_SELECT_SGIS;
    public static property TEXTURE_4DSIZE_SGIS:                  GetTextureParameter read _TEXTURE_4DSIZE_SGIS;
    public static property TEXTURE_WRAP_Q_SGIS:                  GetTextureParameter read _TEXTURE_WRAP_Q_SGIS;
    public static property TEXTURE_MIN_LOD_SGIS:                 GetTextureParameter read _TEXTURE_MIN_LOD_SGIS;
    public static property TEXTURE_MAX_LOD_SGIS:                 GetTextureParameter read _TEXTURE_MAX_LOD_SGIS;
    public static property TEXTURE_BASE_LEVEL_SGIS:              GetTextureParameter read _TEXTURE_BASE_LEVEL_SGIS;
    public static property TEXTURE_MAX_LEVEL_SGIS:               GetTextureParameter read _TEXTURE_MAX_LEVEL_SGIS;
    public static property TEXTURE_FILTER4_SIZE_SGIS:            GetTextureParameter read _TEXTURE_FILTER4_SIZE_SGIS;
    public static property TEXTURE_CLIPMAP_CENTER_SGIX:          GetTextureParameter read _TEXTURE_CLIPMAP_CENTER_SGIX;
    public static property TEXTURE_CLIPMAP_FRAME_SGIX:           GetTextureParameter read _TEXTURE_CLIPMAP_FRAME_SGIX;
    public static property TEXTURE_CLIPMAP_OFFSET_SGIX:          GetTextureParameter read _TEXTURE_CLIPMAP_OFFSET_SGIX;
    public static property TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX:   GetTextureParameter read _TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX;
    public static property TEXTURE_CLIPMAP_LOD_OFFSET_SGIX:      GetTextureParameter read _TEXTURE_CLIPMAP_LOD_OFFSET_SGIX;
    public static property TEXTURE_CLIPMAP_DEPTH_SGIX:           GetTextureParameter read _TEXTURE_CLIPMAP_DEPTH_SGIX;
    public static property POST_TEXTURE_FILTER_BIAS_SGIX:        GetTextureParameter read _POST_TEXTURE_FILTER_BIAS_SGIX;
    public static property POST_TEXTURE_FILTER_SCALE_SGIX:       GetTextureParameter read _POST_TEXTURE_FILTER_SCALE_SGIX;
    public static property TEXTURE_LOD_BIAS_S_SGIX:              GetTextureParameter read _TEXTURE_LOD_BIAS_S_SGIX;
    public static property TEXTURE_LOD_BIAS_T_SGIX:              GetTextureParameter read _TEXTURE_LOD_BIAS_T_SGIX;
    public static property TEXTURE_LOD_BIAS_R_SGIX:              GetTextureParameter read _TEXTURE_LOD_BIAS_R_SGIX;
    public static property GENERATE_MIPMAP_SGIS:                 GetTextureParameter read _GENERATE_MIPMAP_SGIS;
    public static property TEXTURE_COMPARE_SGIX:                 GetTextureParameter read _TEXTURE_COMPARE_SGIX;
    public static property TEXTURE_COMPARE_OPERATOR_SGIX:        GetTextureParameter read _TEXTURE_COMPARE_OPERATOR_SGIX;
    public static property TEXTURE_LEQUAL_R_SGIX:                GetTextureParameter read _TEXTURE_LEQUAL_R_SGIX;
    public static property TEXTURE_GEQUAL_R_SGIX:                GetTextureParameter read _TEXTURE_GEQUAL_R_SGIX;
    public static property TEXTURE_MAX_CLAMP_S_SGIX:             GetTextureParameter read _TEXTURE_MAX_CLAMP_S_SGIX;
    public static property TEXTURE_MAX_CLAMP_T_SGIX:             GetTextureParameter read _TEXTURE_MAX_CLAMP_T_SGIX;
    public static property TEXTURE_MAX_CLAMP_R_SGIX:             GetTextureParameter read _TEXTURE_MAX_CLAMP_R_SGIX;
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: GetTextureParameter read _TEXTURE_UNNORMALIZED_COORDINATES_ARM;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetTextureParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetTextureParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetTextureParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GlslTypeToken = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INT                                       := new GlslTypeToken($1404);
    private static _UNSIGNED_INT                              := new GlslTypeToken($1405);
    private static _FLOAT                                     := new GlslTypeToken($1406);
    private static _DOUBLE                                    := new GlslTypeToken($140A);
    private static _FLOAT_VEC2                                := new GlslTypeToken($8B50);
    private static _FLOAT_VEC3                                := new GlslTypeToken($8B51);
    private static _FLOAT_VEC4                                := new GlslTypeToken($8B52);
    private static _INT_VEC2                                  := new GlslTypeToken($8B53);
    private static _INT_VEC3                                  := new GlslTypeToken($8B54);
    private static _INT_VEC4                                  := new GlslTypeToken($8B55);
    private static _BOOL                                      := new GlslTypeToken($8B56);
    private static _BOOL_VEC2                                 := new GlslTypeToken($8B57);
    private static _BOOL_VEC3                                 := new GlslTypeToken($8B58);
    private static _BOOL_VEC4                                 := new GlslTypeToken($8B59);
    private static _FLOAT_MAT2                                := new GlslTypeToken($8B5A);
    private static _FLOAT_MAT3                                := new GlslTypeToken($8B5B);
    private static _FLOAT_MAT4                                := new GlslTypeToken($8B5C);
    private static _SAMPLER_1D                                := new GlslTypeToken($8B5D);
    private static _SAMPLER_2D                                := new GlslTypeToken($8B5E);
    private static _SAMPLER_3D                                := new GlslTypeToken($8B5F);
    private static _SAMPLER_CUBE                              := new GlslTypeToken($8B60);
    private static _SAMPLER_1D_SHADOW                         := new GlslTypeToken($8B61);
    private static _SAMPLER_2D_SHADOW                         := new GlslTypeToken($8B62);
    private static _SAMPLER_2D_RECT                           := new GlslTypeToken($8B63);
    private static _SAMPLER_2D_RECT_SHADOW                    := new GlslTypeToken($8B64);
    private static _FLOAT_MAT2x3                              := new GlslTypeToken($8B65);
    private static _FLOAT_MAT2x4                              := new GlslTypeToken($8B66);
    private static _FLOAT_MAT3x2                              := new GlslTypeToken($8B67);
    private static _FLOAT_MAT3x4                              := new GlslTypeToken($8B68);
    private static _FLOAT_MAT4x2                              := new GlslTypeToken($8B69);
    private static _FLOAT_MAT4x3                              := new GlslTypeToken($8B6A);
    private static _SAMPLER_1D_ARRAY                          := new GlslTypeToken($8DC0);
    private static _SAMPLER_2D_ARRAY                          := new GlslTypeToken($8DC1);
    private static _SAMPLER_BUFFER                            := new GlslTypeToken($8DC2);
    private static _SAMPLER_1D_ARRAY_SHADOW                   := new GlslTypeToken($8DC3);
    private static _SAMPLER_2D_ARRAY_SHADOW                   := new GlslTypeToken($8DC4);
    private static _SAMPLER_CUBE_SHADOW                       := new GlslTypeToken($8DC5);
    private static _UNSIGNED_INT_VEC2                         := new GlslTypeToken($8DC6);
    private static _UNSIGNED_INT_VEC3                         := new GlslTypeToken($8DC7);
    private static _UNSIGNED_INT_VEC4                         := new GlslTypeToken($8DC8);
    private static _INT_SAMPLER_1D                            := new GlslTypeToken($8DC9);
    private static _INT_SAMPLER_2D                            := new GlslTypeToken($8DCA);
    private static _INT_SAMPLER_3D                            := new GlslTypeToken($8DCB);
    private static _INT_SAMPLER_CUBE                          := new GlslTypeToken($8DCC);
    private static _INT_SAMPLER_2D_RECT                       := new GlslTypeToken($8DCD);
    private static _INT_SAMPLER_1D_ARRAY                      := new GlslTypeToken($8DCE);
    private static _INT_SAMPLER_2D_ARRAY                      := new GlslTypeToken($8DCF);
    private static _INT_SAMPLER_BUFFER                        := new GlslTypeToken($8DD0);
    private static _UNSIGNED_INT_SAMPLER_1D                   := new GlslTypeToken($8DD1);
    private static _UNSIGNED_INT_SAMPLER_2D                   := new GlslTypeToken($8DD2);
    private static _UNSIGNED_INT_SAMPLER_3D                   := new GlslTypeToken($8DD3);
    private static _UNSIGNED_INT_SAMPLER_CUBE                 := new GlslTypeToken($8DD4);
    private static _UNSIGNED_INT_SAMPLER_2D_RECT              := new GlslTypeToken($8DD5);
    private static _UNSIGNED_INT_SAMPLER_1D_ARRAY             := new GlslTypeToken($8DD6);
    private static _UNSIGNED_INT_SAMPLER_2D_ARRAY             := new GlslTypeToken($8DD7);
    private static _UNSIGNED_INT_SAMPLER_BUFFER               := new GlslTypeToken($8DD8);
    private static _DOUBLE_MAT2                               := new GlslTypeToken($8F46);
    private static _DOUBLE_MAT3                               := new GlslTypeToken($8F47);
    private static _DOUBLE_MAT4                               := new GlslTypeToken($8F48);
    private static _DOUBLE_VEC2                               := new GlslTypeToken($8FFC);
    private static _DOUBLE_VEC3                               := new GlslTypeToken($8FFD);
    private static _DOUBLE_VEC4                               := new GlslTypeToken($8FFE);
    private static _SAMPLER_CUBE_MAP_ARRAY                    := new GlslTypeToken($900C);
    private static _SAMPLER_CUBE_MAP_ARRAY_SHADOW             := new GlslTypeToken($900D);
    private static _INT_SAMPLER_CUBE_MAP_ARRAY                := new GlslTypeToken($900E);
    private static _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY       := new GlslTypeToken($900F);
    private static _IMAGE_1D                                  := new GlslTypeToken($904C);
    private static _IMAGE_2D                                  := new GlslTypeToken($904D);
    private static _IMAGE_3D                                  := new GlslTypeToken($904E);
    private static _IMAGE_2D_RECT                             := new GlslTypeToken($904F);
    private static _IMAGE_CUBE                                := new GlslTypeToken($9050);
    private static _IMAGE_BUFFER                              := new GlslTypeToken($9051);
    private static _IMAGE_1D_ARRAY                            := new GlslTypeToken($9052);
    private static _IMAGE_2D_ARRAY                            := new GlslTypeToken($9053);
    private static _IMAGE_CUBE_MAP_ARRAY                      := new GlslTypeToken($9054);
    private static _IMAGE_2D_MULTISAMPLE                      := new GlslTypeToken($9055);
    private static _IMAGE_2D_MULTISAMPLE_ARRAY                := new GlslTypeToken($9056);
    private static _INT_IMAGE_1D                              := new GlslTypeToken($9057);
    private static _INT_IMAGE_2D                              := new GlslTypeToken($9058);
    private static _INT_IMAGE_3D                              := new GlslTypeToken($9059);
    private static _INT_IMAGE_2D_RECT                         := new GlslTypeToken($905A);
    private static _INT_IMAGE_CUBE                            := new GlslTypeToken($905B);
    private static _INT_IMAGE_BUFFER                          := new GlslTypeToken($905C);
    private static _INT_IMAGE_1D_ARRAY                        := new GlslTypeToken($905D);
    private static _INT_IMAGE_2D_ARRAY                        := new GlslTypeToken($905E);
    private static _INT_IMAGE_CUBE_MAP_ARRAY                  := new GlslTypeToken($905F);
    private static _INT_IMAGE_2D_MULTISAMPLE                  := new GlslTypeToken($9060);
    private static _INT_IMAGE_2D_MULTISAMPLE_ARRAY            := new GlslTypeToken($9061);
    private static _UNSIGNED_INT_IMAGE_1D                     := new GlslTypeToken($9062);
    private static _UNSIGNED_INT_IMAGE_2D                     := new GlslTypeToken($9063);
    private static _UNSIGNED_INT_IMAGE_3D                     := new GlslTypeToken($9064);
    private static _UNSIGNED_INT_IMAGE_2D_RECT                := new GlslTypeToken($9065);
    private static _UNSIGNED_INT_IMAGE_CUBE                   := new GlslTypeToken($9066);
    private static _UNSIGNED_INT_IMAGE_BUFFER                 := new GlslTypeToken($9067);
    private static _UNSIGNED_INT_IMAGE_1D_ARRAY               := new GlslTypeToken($9068);
    private static _UNSIGNED_INT_IMAGE_2D_ARRAY               := new GlslTypeToken($9069);
    private static _UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY         := new GlslTypeToken($906A);
    private static _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE         := new GlslTypeToken($906B);
    private static _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY   := new GlslTypeToken($906C);
    private static _SAMPLER_2D_MULTISAMPLE                    := new GlslTypeToken($9108);
    private static _INT_SAMPLER_2D_MULTISAMPLE                := new GlslTypeToken($9109);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE       := new GlslTypeToken($910A);
    private static _SAMPLER_2D_MULTISAMPLE_ARRAY              := new GlslTypeToken($910B);
    private static _INT_SAMPLER_2D_MULTISAMPLE_ARRAY          := new GlslTypeToken($910C);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY := new GlslTypeToken($910D);
    private static _UNSIGNED_INT_ATOMIC_COUNTER               := new GlslTypeToken($92DB);
    
    public static property INT:                                       GlslTypeToken read _INT;
    public static property UNSIGNED_INT:                              GlslTypeToken read _UNSIGNED_INT;
    public static property FLOAT:                                     GlslTypeToken read _FLOAT;
    public static property DOUBLE:                                    GlslTypeToken read _DOUBLE;
    public static property FLOAT_VEC2:                                GlslTypeToken read _FLOAT_VEC2;
    public static property FLOAT_VEC3:                                GlslTypeToken read _FLOAT_VEC3;
    public static property FLOAT_VEC4:                                GlslTypeToken read _FLOAT_VEC4;
    public static property INT_VEC2:                                  GlslTypeToken read _INT_VEC2;
    public static property INT_VEC3:                                  GlslTypeToken read _INT_VEC3;
    public static property INT_VEC4:                                  GlslTypeToken read _INT_VEC4;
    public static property BOOL:                                      GlslTypeToken read _BOOL;
    public static property BOOL_VEC2:                                 GlslTypeToken read _BOOL_VEC2;
    public static property BOOL_VEC3:                                 GlslTypeToken read _BOOL_VEC3;
    public static property BOOL_VEC4:                                 GlslTypeToken read _BOOL_VEC4;
    public static property FLOAT_MAT2:                                GlslTypeToken read _FLOAT_MAT2;
    public static property FLOAT_MAT3:                                GlslTypeToken read _FLOAT_MAT3;
    public static property FLOAT_MAT4:                                GlslTypeToken read _FLOAT_MAT4;
    public static property SAMPLER_1D:                                GlslTypeToken read _SAMPLER_1D;
    public static property SAMPLER_2D:                                GlslTypeToken read _SAMPLER_2D;
    public static property SAMPLER_3D:                                GlslTypeToken read _SAMPLER_3D;
    public static property SAMPLER_CUBE:                              GlslTypeToken read _SAMPLER_CUBE;
    public static property SAMPLER_1D_SHADOW:                         GlslTypeToken read _SAMPLER_1D_SHADOW;
    public static property SAMPLER_2D_SHADOW:                         GlslTypeToken read _SAMPLER_2D_SHADOW;
    public static property SAMPLER_2D_RECT:                           GlslTypeToken read _SAMPLER_2D_RECT;
    public static property SAMPLER_2D_RECT_SHADOW:                    GlslTypeToken read _SAMPLER_2D_RECT_SHADOW;
    public static property FLOAT_MAT2x3:                              GlslTypeToken read _FLOAT_MAT2x3;
    public static property FLOAT_MAT2x4:                              GlslTypeToken read _FLOAT_MAT2x4;
    public static property FLOAT_MAT3x2:                              GlslTypeToken read _FLOAT_MAT3x2;
    public static property FLOAT_MAT3x4:                              GlslTypeToken read _FLOAT_MAT3x4;
    public static property FLOAT_MAT4x2:                              GlslTypeToken read _FLOAT_MAT4x2;
    public static property FLOAT_MAT4x3:                              GlslTypeToken read _FLOAT_MAT4x3;
    public static property SAMPLER_1D_ARRAY:                          GlslTypeToken read _SAMPLER_1D_ARRAY;
    public static property SAMPLER_2D_ARRAY:                          GlslTypeToken read _SAMPLER_2D_ARRAY;
    public static property SAMPLER_BUFFER:                            GlslTypeToken read _SAMPLER_BUFFER;
    public static property SAMPLER_1D_ARRAY_SHADOW:                   GlslTypeToken read _SAMPLER_1D_ARRAY_SHADOW;
    public static property SAMPLER_2D_ARRAY_SHADOW:                   GlslTypeToken read _SAMPLER_2D_ARRAY_SHADOW;
    public static property SAMPLER_CUBE_SHADOW:                       GlslTypeToken read _SAMPLER_CUBE_SHADOW;
    public static property UNSIGNED_INT_VEC2:                         GlslTypeToken read _UNSIGNED_INT_VEC2;
    public static property UNSIGNED_INT_VEC3:                         GlslTypeToken read _UNSIGNED_INT_VEC3;
    public static property UNSIGNED_INT_VEC4:                         GlslTypeToken read _UNSIGNED_INT_VEC4;
    public static property INT_SAMPLER_1D:                            GlslTypeToken read _INT_SAMPLER_1D;
    public static property INT_SAMPLER_2D:                            GlslTypeToken read _INT_SAMPLER_2D;
    public static property INT_SAMPLER_3D:                            GlslTypeToken read _INT_SAMPLER_3D;
    public static property INT_SAMPLER_CUBE:                          GlslTypeToken read _INT_SAMPLER_CUBE;
    public static property INT_SAMPLER_2D_RECT:                       GlslTypeToken read _INT_SAMPLER_2D_RECT;
    public static property INT_SAMPLER_1D_ARRAY:                      GlslTypeToken read _INT_SAMPLER_1D_ARRAY;
    public static property INT_SAMPLER_2D_ARRAY:                      GlslTypeToken read _INT_SAMPLER_2D_ARRAY;
    public static property INT_SAMPLER_BUFFER:                        GlslTypeToken read _INT_SAMPLER_BUFFER;
    public static property UNSIGNED_INT_SAMPLER_1D:                   GlslTypeToken read _UNSIGNED_INT_SAMPLER_1D;
    public static property UNSIGNED_INT_SAMPLER_2D:                   GlslTypeToken read _UNSIGNED_INT_SAMPLER_2D;
    public static property UNSIGNED_INT_SAMPLER_3D:                   GlslTypeToken read _UNSIGNED_INT_SAMPLER_3D;
    public static property UNSIGNED_INT_SAMPLER_CUBE:                 GlslTypeToken read _UNSIGNED_INT_SAMPLER_CUBE;
    public static property UNSIGNED_INT_SAMPLER_2D_RECT:              GlslTypeToken read _UNSIGNED_INT_SAMPLER_2D_RECT;
    public static property UNSIGNED_INT_SAMPLER_1D_ARRAY:             GlslTypeToken read _UNSIGNED_INT_SAMPLER_1D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_ARRAY:             GlslTypeToken read _UNSIGNED_INT_SAMPLER_2D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_BUFFER:               GlslTypeToken read _UNSIGNED_INT_SAMPLER_BUFFER;
    public static property DOUBLE_MAT2:                               GlslTypeToken read _DOUBLE_MAT2;
    public static property DOUBLE_MAT3:                               GlslTypeToken read _DOUBLE_MAT3;
    public static property DOUBLE_MAT4:                               GlslTypeToken read _DOUBLE_MAT4;
    public static property DOUBLE_VEC2:                               GlslTypeToken read _DOUBLE_VEC2;
    public static property DOUBLE_VEC3:                               GlslTypeToken read _DOUBLE_VEC3;
    public static property DOUBLE_VEC4:                               GlslTypeToken read _DOUBLE_VEC4;
    public static property SAMPLER_CUBE_MAP_ARRAY:                    GlslTypeToken read _SAMPLER_CUBE_MAP_ARRAY;
    public static property SAMPLER_CUBE_MAP_ARRAY_SHADOW:             GlslTypeToken read _SAMPLER_CUBE_MAP_ARRAY_SHADOW;
    public static property INT_SAMPLER_CUBE_MAP_ARRAY:                GlslTypeToken read _INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY:       GlslTypeToken read _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property IMAGE_1D:                                  GlslTypeToken read _IMAGE_1D;
    public static property IMAGE_2D:                                  GlslTypeToken read _IMAGE_2D;
    public static property IMAGE_3D:                                  GlslTypeToken read _IMAGE_3D;
    public static property IMAGE_2D_RECT:                             GlslTypeToken read _IMAGE_2D_RECT;
    public static property IMAGE_CUBE:                                GlslTypeToken read _IMAGE_CUBE;
    public static property IMAGE_BUFFER:                              GlslTypeToken read _IMAGE_BUFFER;
    public static property IMAGE_1D_ARRAY:                            GlslTypeToken read _IMAGE_1D_ARRAY;
    public static property IMAGE_2D_ARRAY:                            GlslTypeToken read _IMAGE_2D_ARRAY;
    public static property IMAGE_CUBE_MAP_ARRAY:                      GlslTypeToken read _IMAGE_CUBE_MAP_ARRAY;
    public static property IMAGE_2D_MULTISAMPLE:                      GlslTypeToken read _IMAGE_2D_MULTISAMPLE;
    public static property IMAGE_2D_MULTISAMPLE_ARRAY:                GlslTypeToken read _IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property INT_IMAGE_1D:                              GlslTypeToken read _INT_IMAGE_1D;
    public static property INT_IMAGE_2D:                              GlslTypeToken read _INT_IMAGE_2D;
    public static property INT_IMAGE_3D:                              GlslTypeToken read _INT_IMAGE_3D;
    public static property INT_IMAGE_2D_RECT:                         GlslTypeToken read _INT_IMAGE_2D_RECT;
    public static property INT_IMAGE_CUBE:                            GlslTypeToken read _INT_IMAGE_CUBE;
    public static property INT_IMAGE_BUFFER:                          GlslTypeToken read _INT_IMAGE_BUFFER;
    public static property INT_IMAGE_1D_ARRAY:                        GlslTypeToken read _INT_IMAGE_1D_ARRAY;
    public static property INT_IMAGE_2D_ARRAY:                        GlslTypeToken read _INT_IMAGE_2D_ARRAY;
    public static property INT_IMAGE_CUBE_MAP_ARRAY:                  GlslTypeToken read _INT_IMAGE_CUBE_MAP_ARRAY;
    public static property INT_IMAGE_2D_MULTISAMPLE:                  GlslTypeToken read _INT_IMAGE_2D_MULTISAMPLE;
    public static property INT_IMAGE_2D_MULTISAMPLE_ARRAY:            GlslTypeToken read _INT_IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_IMAGE_1D:                     GlslTypeToken read _UNSIGNED_INT_IMAGE_1D;
    public static property UNSIGNED_INT_IMAGE_2D:                     GlslTypeToken read _UNSIGNED_INT_IMAGE_2D;
    public static property UNSIGNED_INT_IMAGE_3D:                     GlslTypeToken read _UNSIGNED_INT_IMAGE_3D;
    public static property UNSIGNED_INT_IMAGE_2D_RECT:                GlslTypeToken read _UNSIGNED_INT_IMAGE_2D_RECT;
    public static property UNSIGNED_INT_IMAGE_CUBE:                   GlslTypeToken read _UNSIGNED_INT_IMAGE_CUBE;
    public static property UNSIGNED_INT_IMAGE_BUFFER:                 GlslTypeToken read _UNSIGNED_INT_IMAGE_BUFFER;
    public static property UNSIGNED_INT_IMAGE_1D_ARRAY:               GlslTypeToken read _UNSIGNED_INT_IMAGE_1D_ARRAY;
    public static property UNSIGNED_INT_IMAGE_2D_ARRAY:               GlslTypeToken read _UNSIGNED_INT_IMAGE_2D_ARRAY;
    public static property UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY:         GlslTypeToken read _UNSIGNED_INT_IMAGE_CUBE_MAP_ARRAY;
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE:         GlslTypeToken read _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE;
    public static property UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY:   GlslTypeToken read _UNSIGNED_INT_IMAGE_2D_MULTISAMPLE_ARRAY;
    public static property SAMPLER_2D_MULTISAMPLE:                    GlslTypeToken read _SAMPLER_2D_MULTISAMPLE;
    public static property INT_SAMPLER_2D_MULTISAMPLE:                GlslTypeToken read _INT_SAMPLER_2D_MULTISAMPLE;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE:       GlslTypeToken read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE;
    public static property SAMPLER_2D_MULTISAMPLE_ARRAY:              GlslTypeToken read _SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property INT_SAMPLER_2D_MULTISAMPLE_ARRAY:          GlslTypeToken read _INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: GlslTypeToken read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_ATOMIC_COUNTER:               GlslTypeToken read _UNSIGNED_INT_ATOMIC_COUNTER;
    
    public function ToString: string; override;
    begin
      var res := typeof(GlslTypeToken).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GlslTypeToken(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GlslTypeToken[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GraphicsResetStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NO_ERROR               := new GraphicsResetStatus($0000);
    private static _GUILTY_CONTEXT_RESET   := new GraphicsResetStatus($8253);
    private static _INNOCENT_CONTEXT_RESET := new GraphicsResetStatus($8254);
    private static _UNKNOWN_CONTEXT_RESET  := new GraphicsResetStatus($8255);
    
    public static property NO_ERROR:               GraphicsResetStatus read _NO_ERROR;
    public static property GUILTY_CONTEXT_RESET:   GraphicsResetStatus read _GUILTY_CONTEXT_RESET;
    public static property INNOCENT_CONTEXT_RESET: GraphicsResetStatus read _INNOCENT_CONTEXT_RESET;
    public static property UNKNOWN_CONTEXT_RESET:  GraphicsResetStatus read _UNKNOWN_CONTEXT_RESET;
    
    public function ToString: string; override;
    begin
      var res := typeof(GraphicsResetStatus).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GraphicsResetStatus(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GraphicsResetStatus[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  HintMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DONT_CARE := new HintMode($1100);
    private static _FASTEST   := new HintMode($1101);
    private static _NICEST    := new HintMode($1102);
    
    public static property DONT_CARE: HintMode read _DONT_CARE;
    public static property FASTEST:   HintMode read _FASTEST;
    public static property NICEST:    HintMode read _NICEST;
    
    public function ToString: string; override;
    begin
      var res := typeof(HintMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->HintMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'HintMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  HintTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PERSPECTIVE_CORRECTION_HINT         := new HintTarget($0C50);
    private static _POINT_SMOOTH_HINT                   := new HintTarget($0C51);
    private static _LINE_SMOOTH_HINT                    := new HintTarget($0C52);
    private static _POLYGON_SMOOTH_HINT                 := new HintTarget($0C53);
    private static _FOG_HINT                            := new HintTarget($0C54);
    private static _PACK_CMYK_HINT_EXT                  := new HintTarget($800E);
    private static _UNPACK_CMYK_HINT_EXT                := new HintTarget($800F);
    private static _PHONG_HINT_WIN                      := new HintTarget($80EB);
    private static _CLIP_VOLUME_CLIPPING_HINT_EXT       := new HintTarget($80F0);
    private static _TEXTURE_MULTI_BUFFER_HINT_SGIX      := new HintTarget($812E);
    private static _GENERATE_MIPMAP_HINT                := new HintTarget($8192);
    private static _GENERATE_MIPMAP_HINT_SGIS           := new HintTarget($8192);
    private static _PROGRAM_BINARY_RETRIEVABLE_HINT     := new HintTarget($8257);
    private static _CONVOLUTION_HINT_SGIX               := new HintTarget($8316);
    private static _SCALEBIAS_HINT_SGIX                 := new HintTarget($8322);
    private static _LINE_QUALITY_HINT_SGIX              := new HintTarget($835B);
    private static _VERTEX_PRECLIP_SGIX                 := new HintTarget($83EE);
    private static _VERTEX_PRECLIP_HINT_SGIX            := new HintTarget($83EF);
    private static _TEXTURE_COMPRESSION_HINT            := new HintTarget($84EF);
    private static _TEXTURE_COMPRESSION_HINT_ARB        := new HintTarget($84EF);
    private static _VERTEX_ARRAY_STORAGE_HINT_APPLE     := new HintTarget($851F);
    private static _MULTISAMPLE_FILTER_HINT_NV          := new HintTarget($8534);
    private static _TRANSFORM_HINT_APPLE                := new HintTarget($85B1);
    private static _TEXTURE_STORAGE_HINT_APPLE          := new HintTarget($85BC);
    private static _FRAGMENT_SHADER_DERIVATIVE_HINT     := new HintTarget($8B8B);
    private static _FRAGMENT_SHADER_DERIVATIVE_HINT_ARB := new HintTarget($8B8B);
    private static _FRAGMENT_SHADER_DERIVATIVE_HINT_OES := new HintTarget($8B8B);
    private static _BINNING_CONTROL_HINT_QCOM           := new HintTarget($8FB0);
    private static _PREFER_DOUBLEBUFFER_HINT_PGI        := new HintTarget($1A1F8);
    private static _CONSERVE_MEMORY_HINT_PGI            := new HintTarget($1A1FD);
    private static _RECLAIM_MEMORY_HINT_PGI             := new HintTarget($1A1FE);
    private static _NATIVE_GRAPHICS_BEGIN_HINT_PGI      := new HintTarget($1A203);
    private static _NATIVE_GRAPHICS_END_HINT_PGI        := new HintTarget($1A204);
    private static _ALWAYS_FAST_HINT_PGI                := new HintTarget($1A20C);
    private static _ALWAYS_SOFT_HINT_PGI                := new HintTarget($1A20D);
    private static _ALLOW_DRAW_OBJ_HINT_PGI             := new HintTarget($1A20E);
    private static _ALLOW_DRAW_WIN_HINT_PGI             := new HintTarget($1A20F);
    private static _ALLOW_DRAW_FRG_HINT_PGI             := new HintTarget($1A210);
    private static _ALLOW_DRAW_MEM_HINT_PGI             := new HintTarget($1A211);
    private static _STRICT_DEPTHFUNC_HINT_PGI           := new HintTarget($1A216);
    private static _STRICT_LIGHTING_HINT_PGI            := new HintTarget($1A217);
    private static _STRICT_SCISSOR_HINT_PGI             := new HintTarget($1A218);
    private static _FULL_STIPPLE_HINT_PGI               := new HintTarget($1A219);
    private static _CLIP_NEAR_HINT_PGI                  := new HintTarget($1A220);
    private static _CLIP_FAR_HINT_PGI                   := new HintTarget($1A221);
    private static _WIDE_LINE_HINT_PGI                  := new HintTarget($1A222);
    private static _BACK_NORMALS_HINT_PGI               := new HintTarget($1A223);
    private static _VERTEX_DATA_HINT_PGI                := new HintTarget($1A22A);
    private static _VERTEX_CONSISTENT_HINT_PGI          := new HintTarget($1A22B);
    private static _MATERIAL_SIDE_HINT_PGI              := new HintTarget($1A22C);
    private static _MAX_VERTEX_HINT_PGI                 := new HintTarget($1A22D);
    
    public static property PERSPECTIVE_CORRECTION_HINT:         HintTarget read _PERSPECTIVE_CORRECTION_HINT;
    public static property POINT_SMOOTH_HINT:                   HintTarget read _POINT_SMOOTH_HINT;
    public static property LINE_SMOOTH_HINT:                    HintTarget read _LINE_SMOOTH_HINT;
    public static property POLYGON_SMOOTH_HINT:                 HintTarget read _POLYGON_SMOOTH_HINT;
    public static property FOG_HINT:                            HintTarget read _FOG_HINT;
    public static property PACK_CMYK_HINT_EXT:                  HintTarget read _PACK_CMYK_HINT_EXT;
    public static property UNPACK_CMYK_HINT_EXT:                HintTarget read _UNPACK_CMYK_HINT_EXT;
    public static property PHONG_HINT_WIN:                      HintTarget read _PHONG_HINT_WIN;
    public static property CLIP_VOLUME_CLIPPING_HINT_EXT:       HintTarget read _CLIP_VOLUME_CLIPPING_HINT_EXT;
    public static property TEXTURE_MULTI_BUFFER_HINT_SGIX:      HintTarget read _TEXTURE_MULTI_BUFFER_HINT_SGIX;
    public static property GENERATE_MIPMAP_HINT:                HintTarget read _GENERATE_MIPMAP_HINT;
    public static property GENERATE_MIPMAP_HINT_SGIS:           HintTarget read _GENERATE_MIPMAP_HINT_SGIS;
    public static property PROGRAM_BINARY_RETRIEVABLE_HINT:     HintTarget read _PROGRAM_BINARY_RETRIEVABLE_HINT;
    public static property CONVOLUTION_HINT_SGIX:               HintTarget read _CONVOLUTION_HINT_SGIX;
    public static property SCALEBIAS_HINT_SGIX:                 HintTarget read _SCALEBIAS_HINT_SGIX;
    public static property LINE_QUALITY_HINT_SGIX:              HintTarget read _LINE_QUALITY_HINT_SGIX;
    public static property VERTEX_PRECLIP_SGIX:                 HintTarget read _VERTEX_PRECLIP_SGIX;
    public static property VERTEX_PRECLIP_HINT_SGIX:            HintTarget read _VERTEX_PRECLIP_HINT_SGIX;
    public static property TEXTURE_COMPRESSION_HINT:            HintTarget read _TEXTURE_COMPRESSION_HINT;
    public static property TEXTURE_COMPRESSION_HINT_ARB:        HintTarget read _TEXTURE_COMPRESSION_HINT_ARB;
    public static property VERTEX_ARRAY_STORAGE_HINT_APPLE:     HintTarget read _VERTEX_ARRAY_STORAGE_HINT_APPLE;
    public static property MULTISAMPLE_FILTER_HINT_NV:          HintTarget read _MULTISAMPLE_FILTER_HINT_NV;
    public static property TRANSFORM_HINT_APPLE:                HintTarget read _TRANSFORM_HINT_APPLE;
    public static property TEXTURE_STORAGE_HINT_APPLE:          HintTarget read _TEXTURE_STORAGE_HINT_APPLE;
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT:     HintTarget read _FRAGMENT_SHADER_DERIVATIVE_HINT;
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT_ARB: HintTarget read _FRAGMENT_SHADER_DERIVATIVE_HINT_ARB;
    public static property FRAGMENT_SHADER_DERIVATIVE_HINT_OES: HintTarget read _FRAGMENT_SHADER_DERIVATIVE_HINT_OES;
    public static property BINNING_CONTROL_HINT_QCOM:           HintTarget read _BINNING_CONTROL_HINT_QCOM;
    public static property PREFER_DOUBLEBUFFER_HINT_PGI:        HintTarget read _PREFER_DOUBLEBUFFER_HINT_PGI;
    public static property CONSERVE_MEMORY_HINT_PGI:            HintTarget read _CONSERVE_MEMORY_HINT_PGI;
    public static property RECLAIM_MEMORY_HINT_PGI:             HintTarget read _RECLAIM_MEMORY_HINT_PGI;
    public static property NATIVE_GRAPHICS_BEGIN_HINT_PGI:      HintTarget read _NATIVE_GRAPHICS_BEGIN_HINT_PGI;
    public static property NATIVE_GRAPHICS_END_HINT_PGI:        HintTarget read _NATIVE_GRAPHICS_END_HINT_PGI;
    public static property ALWAYS_FAST_HINT_PGI:                HintTarget read _ALWAYS_FAST_HINT_PGI;
    public static property ALWAYS_SOFT_HINT_PGI:                HintTarget read _ALWAYS_SOFT_HINT_PGI;
    public static property ALLOW_DRAW_OBJ_HINT_PGI:             HintTarget read _ALLOW_DRAW_OBJ_HINT_PGI;
    public static property ALLOW_DRAW_WIN_HINT_PGI:             HintTarget read _ALLOW_DRAW_WIN_HINT_PGI;
    public static property ALLOW_DRAW_FRG_HINT_PGI:             HintTarget read _ALLOW_DRAW_FRG_HINT_PGI;
    public static property ALLOW_DRAW_MEM_HINT_PGI:             HintTarget read _ALLOW_DRAW_MEM_HINT_PGI;
    public static property STRICT_DEPTHFUNC_HINT_PGI:           HintTarget read _STRICT_DEPTHFUNC_HINT_PGI;
    public static property STRICT_LIGHTING_HINT_PGI:            HintTarget read _STRICT_LIGHTING_HINT_PGI;
    public static property STRICT_SCISSOR_HINT_PGI:             HintTarget read _STRICT_SCISSOR_HINT_PGI;
    public static property FULL_STIPPLE_HINT_PGI:               HintTarget read _FULL_STIPPLE_HINT_PGI;
    public static property CLIP_NEAR_HINT_PGI:                  HintTarget read _CLIP_NEAR_HINT_PGI;
    public static property CLIP_FAR_HINT_PGI:                   HintTarget read _CLIP_FAR_HINT_PGI;
    public static property WIDE_LINE_HINT_PGI:                  HintTarget read _WIDE_LINE_HINT_PGI;
    public static property BACK_NORMALS_HINT_PGI:               HintTarget read _BACK_NORMALS_HINT_PGI;
    public static property VERTEX_DATA_HINT_PGI:                HintTarget read _VERTEX_DATA_HINT_PGI;
    public static property VERTEX_CONSISTENT_HINT_PGI:          HintTarget read _VERTEX_CONSISTENT_HINT_PGI;
    public static property MATERIAL_SIDE_HINT_PGI:              HintTarget read _MATERIAL_SIDE_HINT_PGI;
    public static property MAX_VERTEX_HINT_PGI:                 HintTarget read _MAX_VERTEX_HINT_PGI;
    
    public function ToString: string; override;
    begin
      var res := typeof(HintTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->HintTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'HintTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  IndexPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SHORT  := new IndexPointerType($1402);
    private static _INT    := new IndexPointerType($1404);
    private static _FLOAT  := new IndexPointerType($1406);
    private static _DOUBLE := new IndexPointerType($140A);
    
    public static property SHORT:  IndexPointerType read _SHORT;
    public static property INT:    IndexPointerType read _INT;
    public static property FLOAT:  IndexPointerType read _FLOAT;
    public static property DOUBLE: IndexPointerType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(IndexPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->IndexPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'IndexPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  InterleavedArrayFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _V2F             := new InterleavedArrayFormat($2A20);
    private static _V3F             := new InterleavedArrayFormat($2A21);
    private static _C4UB_V2F        := new InterleavedArrayFormat($2A22);
    private static _C4UB_V3F        := new InterleavedArrayFormat($2A23);
    private static _C3F_V3F         := new InterleavedArrayFormat($2A24);
    private static _N3F_V3F         := new InterleavedArrayFormat($2A25);
    private static _C4F_N3F_V3F     := new InterleavedArrayFormat($2A26);
    private static _T2F_V3F         := new InterleavedArrayFormat($2A27);
    private static _T4F_V4F         := new InterleavedArrayFormat($2A28);
    private static _T2F_C4UB_V3F    := new InterleavedArrayFormat($2A29);
    private static _T2F_C3F_V3F     := new InterleavedArrayFormat($2A2A);
    private static _T2F_N3F_V3F     := new InterleavedArrayFormat($2A2B);
    private static _T2F_C4F_N3F_V3F := new InterleavedArrayFormat($2A2C);
    private static _T4F_C4F_N3F_V4F := new InterleavedArrayFormat($2A2D);
    
    public static property V2F:             InterleavedArrayFormat read _V2F;
    public static property V3F:             InterleavedArrayFormat read _V3F;
    public static property C4UB_V2F:        InterleavedArrayFormat read _C4UB_V2F;
    public static property C4UB_V3F:        InterleavedArrayFormat read _C4UB_V3F;
    public static property C3F_V3F:         InterleavedArrayFormat read _C3F_V3F;
    public static property N3F_V3F:         InterleavedArrayFormat read _N3F_V3F;
    public static property C4F_N3F_V3F:     InterleavedArrayFormat read _C4F_N3F_V3F;
    public static property T2F_V3F:         InterleavedArrayFormat read _T2F_V3F;
    public static property T4F_V4F:         InterleavedArrayFormat read _T4F_V4F;
    public static property T2F_C4UB_V3F:    InterleavedArrayFormat read _T2F_C4UB_V3F;
    public static property T2F_C3F_V3F:     InterleavedArrayFormat read _T2F_C3F_V3F;
    public static property T2F_N3F_V3F:     InterleavedArrayFormat read _T2F_N3F_V3F;
    public static property T2F_C4F_N3F_V3F: InterleavedArrayFormat read _T2F_C4F_N3F_V3F;
    public static property T4F_C4F_N3F_V4F: InterleavedArrayFormat read _T4F_C4F_N3F_V4F;
    
    public function ToString: string; override;
    begin
      var res := typeof(InterleavedArrayFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->InterleavedArrayFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'InterleavedArrayFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  InternalFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STENCIL_INDEX                             := new InternalFormat($1901);
    private static _STENCIL_INDEX_OES                         := new InternalFormat($1901);
    private static _DEPTH_COMPONENT                           := new InternalFormat($1902);
    private static _RED                                       := new InternalFormat($1903);
    private static _RED_EXT                                   := new InternalFormat($1903);
    private static _RGB                                       := new InternalFormat($1907);
    private static _RGBA                                      := new InternalFormat($1908);
    private static _R3_G3_B2                                  := new InternalFormat($2A10);
    private static _ALPHA4                                    := new InternalFormat($803B);
    private static _ALPHA8                                    := new InternalFormat($803C);
    private static _ALPHA12                                   := new InternalFormat($803D);
    private static _ALPHA16                                   := new InternalFormat($803E);
    private static _LUMINANCE4                                := new InternalFormat($803F);
    private static _LUMINANCE8                                := new InternalFormat($8040);
    private static _LUMINANCE12                               := new InternalFormat($8041);
    private static _LUMINANCE16                               := new InternalFormat($8042);
    private static _LUMINANCE4_ALPHA4                         := new InternalFormat($8043);
    private static _LUMINANCE6_ALPHA2                         := new InternalFormat($8044);
    private static _LUMINANCE8_ALPHA8                         := new InternalFormat($8045);
    private static _LUMINANCE12_ALPHA4                        := new InternalFormat($8046);
    private static _LUMINANCE12_ALPHA12                       := new InternalFormat($8047);
    private static _LUMINANCE16_ALPHA16                       := new InternalFormat($8048);
    private static _INTENSITY                                 := new InternalFormat($8049);
    private static _INTENSITY4                                := new InternalFormat($804A);
    private static _INTENSITY8                                := new InternalFormat($804B);
    private static _INTENSITY12                               := new InternalFormat($804C);
    private static _INTENSITY16                               := new InternalFormat($804D);
    private static _RGB2_EXT                                  := new InternalFormat($804E);
    private static _RGB4                                      := new InternalFormat($804F);
    private static _RGB4_EXT                                  := new InternalFormat($804F);
    private static _RGB5                                      := new InternalFormat($8050);
    private static _RGB5_EXT                                  := new InternalFormat($8050);
    private static _RGB8                                      := new InternalFormat($8051);
    private static _RGB8_EXT                                  := new InternalFormat($8051);
    private static _RGB8_OES                                  := new InternalFormat($8051);
    private static _RGB10                                     := new InternalFormat($8052);
    private static _RGB10_EXT                                 := new InternalFormat($8052);
    private static _RGB12                                     := new InternalFormat($8053);
    private static _RGB12_EXT                                 := new InternalFormat($8053);
    private static _RGB16                                     := new InternalFormat($8054);
    private static _RGB16_EXT                                 := new InternalFormat($8054);
    private static _RGBA4                                     := new InternalFormat($8056);
    private static _RGBA4_EXT                                 := new InternalFormat($8056);
    private static _RGBA4_OES                                 := new InternalFormat($8056);
    private static _RGB5_A1                                   := new InternalFormat($8057);
    private static _RGB5_A1_EXT                               := new InternalFormat($8057);
    private static _RGB5_A1_OES                               := new InternalFormat($8057);
    private static _RGBA8                                     := new InternalFormat($8058);
    private static _RGBA8_EXT                                 := new InternalFormat($8058);
    private static _RGBA8_OES                                 := new InternalFormat($8058);
    private static _RGB10_A2                                  := new InternalFormat($8059);
    private static _RGB10_A2_EXT                              := new InternalFormat($8059);
    private static _RGBA12                                    := new InternalFormat($805A);
    private static _RGBA12_EXT                                := new InternalFormat($805A);
    private static _RGBA16                                    := new InternalFormat($805B);
    private static _RGBA16_EXT                                := new InternalFormat($805B);
    private static _DUAL_ALPHA4_SGIS                          := new InternalFormat($8110);
    private static _DUAL_ALPHA8_SGIS                          := new InternalFormat($8111);
    private static _DUAL_ALPHA12_SGIS                         := new InternalFormat($8112);
    private static _DUAL_ALPHA16_SGIS                         := new InternalFormat($8113);
    private static _DUAL_LUMINANCE4_SGIS                      := new InternalFormat($8114);
    private static _DUAL_LUMINANCE8_SGIS                      := new InternalFormat($8115);
    private static _DUAL_LUMINANCE12_SGIS                     := new InternalFormat($8116);
    private static _DUAL_LUMINANCE16_SGIS                     := new InternalFormat($8117);
    private static _DUAL_INTENSITY4_SGIS                      := new InternalFormat($8118);
    private static _DUAL_INTENSITY8_SGIS                      := new InternalFormat($8119);
    private static _DUAL_INTENSITY12_SGIS                     := new InternalFormat($811A);
    private static _DUAL_INTENSITY16_SGIS                     := new InternalFormat($811B);
    private static _DUAL_LUMINANCE_ALPHA4_SGIS                := new InternalFormat($811C);
    private static _DUAL_LUMINANCE_ALPHA8_SGIS                := new InternalFormat($811D);
    private static _QUAD_ALPHA4_SGIS                          := new InternalFormat($811E);
    private static _QUAD_ALPHA8_SGIS                          := new InternalFormat($811F);
    private static _QUAD_LUMINANCE4_SGIS                      := new InternalFormat($8120);
    private static _QUAD_LUMINANCE8_SGIS                      := new InternalFormat($8121);
    private static _QUAD_INTENSITY4_SGIS                      := new InternalFormat($8122);
    private static _QUAD_INTENSITY8_SGIS                      := new InternalFormat($8123);
    private static _DEPTH_COMPONENT16                         := new InternalFormat($81A5);
    private static _DEPTH_COMPONENT16_ARB                     := new InternalFormat($81A5);
    private static _DEPTH_COMPONENT16_OES                     := new InternalFormat($81A5);
    private static _DEPTH_COMPONENT16_SGIX                    := new InternalFormat($81A5);
    private static _DEPTH_COMPONENT24_ARB                     := new InternalFormat($81A6);
    private static _DEPTH_COMPONENT24_OES                     := new InternalFormat($81A6);
    private static _DEPTH_COMPONENT24_SGIX                    := new InternalFormat($81A6);
    private static _DEPTH_COMPONENT32_ARB                     := new InternalFormat($81A7);
    private static _DEPTH_COMPONENT32_OES                     := new InternalFormat($81A7);
    private static _DEPTH_COMPONENT32_SGIX                    := new InternalFormat($81A7);
    private static _COMPRESSED_RED                            := new InternalFormat($8225);
    private static _COMPRESSED_RG                             := new InternalFormat($8226);
    private static _RG                                        := new InternalFormat($8227);
    private static _R8                                        := new InternalFormat($8229);
    private static _R8_EXT                                    := new InternalFormat($8229);
    private static _R16                                       := new InternalFormat($822A);
    private static _R16_EXT                                   := new InternalFormat($822A);
    private static _RG8                                       := new InternalFormat($822B);
    private static _RG8_EXT                                   := new InternalFormat($822B);
    private static _RG16                                      := new InternalFormat($822C);
    private static _RG16_EXT                                  := new InternalFormat($822C);
    private static _R16F                                      := new InternalFormat($822D);
    private static _R16F_EXT                                  := new InternalFormat($822D);
    private static _R32F                                      := new InternalFormat($822E);
    private static _R32F_EXT                                  := new InternalFormat($822E);
    private static _RG16F                                     := new InternalFormat($822F);
    private static _RG16F_EXT                                 := new InternalFormat($822F);
    private static _RG32F                                     := new InternalFormat($8230);
    private static _RG32F_EXT                                 := new InternalFormat($8230);
    private static _R8I                                       := new InternalFormat($8231);
    private static _R8UI                                      := new InternalFormat($8232);
    private static _R16I                                      := new InternalFormat($8233);
    private static _R16UI                                     := new InternalFormat($8234);
    private static _R32I                                      := new InternalFormat($8235);
    private static _R32UI                                     := new InternalFormat($8236);
    private static _RG8I                                      := new InternalFormat($8237);
    private static _RG8UI                                     := new InternalFormat($8238);
    private static _RG16I                                     := new InternalFormat($8239);
    private static _RG16UI                                    := new InternalFormat($823A);
    private static _RG32I                                     := new InternalFormat($823B);
    private static _RG32UI                                    := new InternalFormat($823C);
    private static _COMPRESSED_RGB_S3TC_DXT1_EXT              := new InternalFormat($83F0);
    private static _COMPRESSED_RGBA_S3TC_DXT1_EXT             := new InternalFormat($83F1);
    private static _COMPRESSED_RGBA_S3TC_DXT3_EXT             := new InternalFormat($83F2);
    private static _COMPRESSED_RGBA_S3TC_DXT5_EXT             := new InternalFormat($83F3);
    private static _COMPRESSED_RGB                            := new InternalFormat($84ED);
    private static _COMPRESSED_RGBA                           := new InternalFormat($84EE);
    private static _DEPTH_STENCIL                             := new InternalFormat($84F9);
    private static _DEPTH_STENCIL_EXT                         := new InternalFormat($84F9);
    private static _DEPTH_STENCIL_NV                          := new InternalFormat($84F9);
    private static _DEPTH_STENCIL_OES                         := new InternalFormat($84F9);
    private static _DEPTH_STENCIL_MESA                        := new InternalFormat($8750);
    private static _RGBA32F                                   := new InternalFormat($8814);
    private static _RGBA32F_ARB                               := new InternalFormat($8814);
    private static _RGBA32F_EXT                               := new InternalFormat($8814);
    private static _RGB32F                                    := new InternalFormat($8815);
    private static _RGBA16F                                   := new InternalFormat($881A);
    private static _RGBA16F_ARB                               := new InternalFormat($881A);
    private static _RGBA16F_EXT                               := new InternalFormat($881A);
    private static _RGB16F                                    := new InternalFormat($881B);
    private static _RGB16F_ARB                                := new InternalFormat($881B);
    private static _RGB16F_EXT                                := new InternalFormat($881B);
    private static _DEPTH24_STENCIL8                          := new InternalFormat($88F0);
    private static _DEPTH24_STENCIL8_EXT                      := new InternalFormat($88F0);
    private static _DEPTH24_STENCIL8_OES                      := new InternalFormat($88F0);
    private static _R11F_G11F_B10F                            := new InternalFormat($8C3A);
    private static _R11F_G11F_B10F_APPLE                      := new InternalFormat($8C3A);
    private static _R11F_G11F_B10F_EXT                        := new InternalFormat($8C3A);
    private static _RGB9_E5                                   := new InternalFormat($8C3D);
    private static _RGB9_E5_APPLE                             := new InternalFormat($8C3D);
    private static _RGB9_E5_EXT                               := new InternalFormat($8C3D);
    private static _SRGB                                      := new InternalFormat($8C40);
    private static _SRGB_EXT                                  := new InternalFormat($8C40);
    private static _SRGB8                                     := new InternalFormat($8C41);
    private static _SRGB8_EXT                                 := new InternalFormat($8C41);
    private static _SRGB8_NV                                  := new InternalFormat($8C41);
    private static _SRGB_ALPHA                                := new InternalFormat($8C42);
    private static _SRGB_ALPHA_EXT                            := new InternalFormat($8C42);
    private static _SRGB8_ALPHA8                              := new InternalFormat($8C43);
    private static _SRGB8_ALPHA8_EXT                          := new InternalFormat($8C43);
    private static _COMPRESSED_SRGB                           := new InternalFormat($8C48);
    private static _COMPRESSED_SRGB_ALPHA                     := new InternalFormat($8C49);
    private static _COMPRESSED_SRGB_S3TC_DXT1_EXT             := new InternalFormat($8C4C);
    private static _COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT       := new InternalFormat($8C4D);
    private static _COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT       := new InternalFormat($8C4E);
    private static _COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT       := new InternalFormat($8C4F);
    private static _DEPTH_COMPONENT32F                        := new InternalFormat($8CAC);
    private static _DEPTH32F_STENCIL8                         := new InternalFormat($8CAD);
    private static _STENCIL_INDEX1                            := new InternalFormat($8D46);
    private static _STENCIL_INDEX1_EXT                        := new InternalFormat($8D46);
    private static _STENCIL_INDEX1_OES                        := new InternalFormat($8D46);
    private static _STENCIL_INDEX4                            := new InternalFormat($8D47);
    private static _STENCIL_INDEX4_EXT                        := new InternalFormat($8D47);
    private static _STENCIL_INDEX4_OES                        := new InternalFormat($8D47);
    private static _STENCIL_INDEX8                            := new InternalFormat($8D48);
    private static _STENCIL_INDEX8_EXT                        := new InternalFormat($8D48);
    private static _STENCIL_INDEX8_OES                        := new InternalFormat($8D48);
    private static _STENCIL_INDEX16                           := new InternalFormat($8D49);
    private static _STENCIL_INDEX16_EXT                       := new InternalFormat($8D49);
    private static _RGBA32UI                                  := new InternalFormat($8D70);
    private static _RGB32UI                                   := new InternalFormat($8D71);
    private static _RGBA16UI                                  := new InternalFormat($8D76);
    private static _RGB16UI                                   := new InternalFormat($8D77);
    private static _RGBA8UI                                   := new InternalFormat($8D7C);
    private static _RGB8UI                                    := new InternalFormat($8D7D);
    private static _RGBA32I                                   := new InternalFormat($8D82);
    private static _RGB32I                                    := new InternalFormat($8D83);
    private static _RGBA16I                                   := new InternalFormat($8D88);
    private static _RGB16I                                    := new InternalFormat($8D89);
    private static _RGBA8I                                    := new InternalFormat($8D8E);
    private static _RGB8I                                     := new InternalFormat($8D8F);
    private static _DEPTH_COMPONENT32F_NV                     := new InternalFormat($8DAB);
    private static _DEPTH32F_STENCIL8_NV                      := new InternalFormat($8DAC);
    private static _COMPRESSED_RED_RGTC1                      := new InternalFormat($8DBB);
    private static _COMPRESSED_RED_RGTC1_EXT                  := new InternalFormat($8DBB);
    private static _COMPRESSED_SIGNED_RED_RGTC1               := new InternalFormat($8DBC);
    private static _COMPRESSED_SIGNED_RED_RGTC1_EXT           := new InternalFormat($8DBC);
    private static _COMPRESSED_RG_RGTC2                       := new InternalFormat($8DBD);
    private static _COMPRESSED_SIGNED_RG_RGTC2                := new InternalFormat($8DBE);
    private static _COMPRESSED_RGBA_BPTC_UNORM                := new InternalFormat($8E8C);
    private static _COMPRESSED_SRGB_ALPHA_BPTC_UNORM          := new InternalFormat($8E8D);
    private static _COMPRESSED_RGB_BPTC_SIGNED_FLOAT          := new InternalFormat($8E8E);
    private static _COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT        := new InternalFormat($8E8F);
    private static _R8_SNORM                                  := new InternalFormat($8F94);
    private static _RG8_SNORM                                 := new InternalFormat($8F95);
    private static _RGB8_SNORM                                := new InternalFormat($8F96);
    private static _RGBA8_SNORM                               := new InternalFormat($8F97);
    private static _R16_SNORM                                 := new InternalFormat($8F98);
    private static _R16_SNORM_EXT                             := new InternalFormat($8F98);
    private static _RG16_SNORM                                := new InternalFormat($8F99);
    private static _RG16_SNORM_EXT                            := new InternalFormat($8F99);
    private static _RGB16_SNORM                               := new InternalFormat($8F9A);
    private static _RGB16_SNORM_EXT                           := new InternalFormat($8F9A);
    private static _RGB10_A2UI                                := new InternalFormat($906F);
    private static _COMPRESSED_R11_EAC                        := new InternalFormat($9270);
    private static _COMPRESSED_SIGNED_R11_EAC                 := new InternalFormat($9271);
    private static _COMPRESSED_RG11_EAC                       := new InternalFormat($9272);
    private static _COMPRESSED_SIGNED_RG11_EAC                := new InternalFormat($9273);
    private static _COMPRESSED_RGB8_ETC2                      := new InternalFormat($9274);
    private static _COMPRESSED_SRGB8_ETC2                     := new InternalFormat($9275);
    private static _COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2  := new InternalFormat($9276);
    private static _COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2 := new InternalFormat($9277);
    private static _COMPRESSED_RGBA8_ETC2_EAC                 := new InternalFormat($9278);
    private static _COMPRESSED_SRGB8_ALPHA8_ETC2_EAC          := new InternalFormat($9279);
    private static _COMPRESSED_RGBA_ASTC_4x4                  := new InternalFormat($93B0);
    private static _COMPRESSED_RGBA_ASTC_4x4_KHR              := new InternalFormat($93B0);
    private static _COMPRESSED_RGBA_ASTC_5x4                  := new InternalFormat($93B1);
    private static _COMPRESSED_RGBA_ASTC_5x4_KHR              := new InternalFormat($93B1);
    private static _COMPRESSED_RGBA_ASTC_5x5                  := new InternalFormat($93B2);
    private static _COMPRESSED_RGBA_ASTC_5x5_KHR              := new InternalFormat($93B2);
    private static _COMPRESSED_RGBA_ASTC_6x5                  := new InternalFormat($93B3);
    private static _COMPRESSED_RGBA_ASTC_6x5_KHR              := new InternalFormat($93B3);
    private static _COMPRESSED_RGBA_ASTC_6x6                  := new InternalFormat($93B4);
    private static _COMPRESSED_RGBA_ASTC_6x6_KHR              := new InternalFormat($93B4);
    private static _COMPRESSED_RGBA_ASTC_8x5                  := new InternalFormat($93B5);
    private static _COMPRESSED_RGBA_ASTC_8x5_KHR              := new InternalFormat($93B5);
    private static _COMPRESSED_RGBA_ASTC_8x6                  := new InternalFormat($93B6);
    private static _COMPRESSED_RGBA_ASTC_8x6_KHR              := new InternalFormat($93B6);
    private static _COMPRESSED_RGBA_ASTC_8x8                  := new InternalFormat($93B7);
    private static _COMPRESSED_RGBA_ASTC_8x8_KHR              := new InternalFormat($93B7);
    private static _COMPRESSED_RGBA_ASTC_10x5                 := new InternalFormat($93B8);
    private static _COMPRESSED_RGBA_ASTC_10x5_KHR             := new InternalFormat($93B8);
    private static _COMPRESSED_RGBA_ASTC_10x6                 := new InternalFormat($93B9);
    private static _COMPRESSED_RGBA_ASTC_10x6_KHR             := new InternalFormat($93B9);
    private static _COMPRESSED_RGBA_ASTC_10x8                 := new InternalFormat($93BA);
    private static _COMPRESSED_RGBA_ASTC_10x8_KHR             := new InternalFormat($93BA);
    private static _COMPRESSED_RGBA_ASTC_10x10                := new InternalFormat($93BB);
    private static _COMPRESSED_RGBA_ASTC_10x10_KHR            := new InternalFormat($93BB);
    private static _COMPRESSED_RGBA_ASTC_12x10                := new InternalFormat($93BC);
    private static _COMPRESSED_RGBA_ASTC_12x10_KHR            := new InternalFormat($93BC);
    private static _COMPRESSED_RGBA_ASTC_12x12                := new InternalFormat($93BD);
    private static _COMPRESSED_RGBA_ASTC_12x12_KHR            := new InternalFormat($93BD);
    private static _COMPRESSED_RGBA_ASTC_3x3x3_OES            := new InternalFormat($93C0);
    private static _COMPRESSED_RGBA_ASTC_4x3x3_OES            := new InternalFormat($93C1);
    private static _COMPRESSED_RGBA_ASTC_4x4x3_OES            := new InternalFormat($93C2);
    private static _COMPRESSED_RGBA_ASTC_4x4x4_OES            := new InternalFormat($93C3);
    private static _COMPRESSED_RGBA_ASTC_5x4x4_OES            := new InternalFormat($93C4);
    private static _COMPRESSED_RGBA_ASTC_5x5x4_OES            := new InternalFormat($93C5);
    private static _COMPRESSED_RGBA_ASTC_5x5x5_OES            := new InternalFormat($93C6);
    private static _COMPRESSED_RGBA_ASTC_6x5x5_OES            := new InternalFormat($93C7);
    private static _COMPRESSED_RGBA_ASTC_6x6x5_OES            := new InternalFormat($93C8);
    private static _COMPRESSED_RGBA_ASTC_6x6x6_OES            := new InternalFormat($93C9);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4          := new InternalFormat($93D0);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR      := new InternalFormat($93D0);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4          := new InternalFormat($93D1);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR      := new InternalFormat($93D1);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5          := new InternalFormat($93D2);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR      := new InternalFormat($93D2);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5          := new InternalFormat($93D3);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR      := new InternalFormat($93D3);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6          := new InternalFormat($93D4);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR      := new InternalFormat($93D4);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x5          := new InternalFormat($93D5);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR      := new InternalFormat($93D5);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x6          := new InternalFormat($93D6);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR      := new InternalFormat($93D6);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x8          := new InternalFormat($93D7);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR      := new InternalFormat($93D7);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x5         := new InternalFormat($93D8);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR     := new InternalFormat($93D8);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x6         := new InternalFormat($93D9);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR     := new InternalFormat($93D9);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x8         := new InternalFormat($93DA);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR     := new InternalFormat($93DA);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x10        := new InternalFormat($93DB);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR    := new InternalFormat($93DB);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_12x10        := new InternalFormat($93DC);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR    := new InternalFormat($93DC);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_12x12        := new InternalFormat($93DD);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR    := new InternalFormat($93DD);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES    := new InternalFormat($93E0);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES    := new InternalFormat($93E1);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES    := new InternalFormat($93E2);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES    := new InternalFormat($93E3);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES    := new InternalFormat($93E4);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES    := new InternalFormat($93E5);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES    := new InternalFormat($93E6);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES    := new InternalFormat($93E7);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES    := new InternalFormat($93E8);
    private static _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES    := new InternalFormat($93E9);
    
    public static property STENCIL_INDEX:                             InternalFormat read _STENCIL_INDEX;
    public static property STENCIL_INDEX_OES:                         InternalFormat read _STENCIL_INDEX_OES;
    public static property DEPTH_COMPONENT:                           InternalFormat read _DEPTH_COMPONENT;
    public static property RED:                                       InternalFormat read _RED;
    public static property RED_EXT:                                   InternalFormat read _RED_EXT;
    public static property RGB:                                       InternalFormat read _RGB;
    public static property RGBA:                                      InternalFormat read _RGBA;
    public static property R3_G3_B2:                                  InternalFormat read _R3_G3_B2;
    public static property ALPHA4:                                    InternalFormat read _ALPHA4;
    public static property ALPHA8:                                    InternalFormat read _ALPHA8;
    public static property ALPHA12:                                   InternalFormat read _ALPHA12;
    public static property ALPHA16:                                   InternalFormat read _ALPHA16;
    public static property LUMINANCE4:                                InternalFormat read _LUMINANCE4;
    public static property LUMINANCE8:                                InternalFormat read _LUMINANCE8;
    public static property LUMINANCE12:                               InternalFormat read _LUMINANCE12;
    public static property LUMINANCE16:                               InternalFormat read _LUMINANCE16;
    public static property LUMINANCE4_ALPHA4:                         InternalFormat read _LUMINANCE4_ALPHA4;
    public static property LUMINANCE6_ALPHA2:                         InternalFormat read _LUMINANCE6_ALPHA2;
    public static property LUMINANCE8_ALPHA8:                         InternalFormat read _LUMINANCE8_ALPHA8;
    public static property LUMINANCE12_ALPHA4:                        InternalFormat read _LUMINANCE12_ALPHA4;
    public static property LUMINANCE12_ALPHA12:                       InternalFormat read _LUMINANCE12_ALPHA12;
    public static property LUMINANCE16_ALPHA16:                       InternalFormat read _LUMINANCE16_ALPHA16;
    public static property INTENSITY:                                 InternalFormat read _INTENSITY;
    public static property INTENSITY4:                                InternalFormat read _INTENSITY4;
    public static property INTENSITY8:                                InternalFormat read _INTENSITY8;
    public static property INTENSITY12:                               InternalFormat read _INTENSITY12;
    public static property INTENSITY16:                               InternalFormat read _INTENSITY16;
    public static property RGB2_EXT:                                  InternalFormat read _RGB2_EXT;
    public static property RGB4:                                      InternalFormat read _RGB4;
    public static property RGB4_EXT:                                  InternalFormat read _RGB4_EXT;
    public static property RGB5:                                      InternalFormat read _RGB5;
    public static property RGB5_EXT:                                  InternalFormat read _RGB5_EXT;
    public static property RGB8:                                      InternalFormat read _RGB8;
    public static property RGB8_EXT:                                  InternalFormat read _RGB8_EXT;
    public static property RGB8_OES:                                  InternalFormat read _RGB8_OES;
    public static property RGB10:                                     InternalFormat read _RGB10;
    public static property RGB10_EXT:                                 InternalFormat read _RGB10_EXT;
    public static property RGB12:                                     InternalFormat read _RGB12;
    public static property RGB12_EXT:                                 InternalFormat read _RGB12_EXT;
    public static property RGB16:                                     InternalFormat read _RGB16;
    public static property RGB16_EXT:                                 InternalFormat read _RGB16_EXT;
    public static property RGBA4:                                     InternalFormat read _RGBA4;
    public static property RGBA4_EXT:                                 InternalFormat read _RGBA4_EXT;
    public static property RGBA4_OES:                                 InternalFormat read _RGBA4_OES;
    public static property RGB5_A1:                                   InternalFormat read _RGB5_A1;
    public static property RGB5_A1_EXT:                               InternalFormat read _RGB5_A1_EXT;
    public static property RGB5_A1_OES:                               InternalFormat read _RGB5_A1_OES;
    public static property RGBA8:                                     InternalFormat read _RGBA8;
    public static property RGBA8_EXT:                                 InternalFormat read _RGBA8_EXT;
    public static property RGBA8_OES:                                 InternalFormat read _RGBA8_OES;
    public static property RGB10_A2:                                  InternalFormat read _RGB10_A2;
    public static property RGB10_A2_EXT:                              InternalFormat read _RGB10_A2_EXT;
    public static property RGBA12:                                    InternalFormat read _RGBA12;
    public static property RGBA12_EXT:                                InternalFormat read _RGBA12_EXT;
    public static property RGBA16:                                    InternalFormat read _RGBA16;
    public static property RGBA16_EXT:                                InternalFormat read _RGBA16_EXT;
    public static property DUAL_ALPHA4_SGIS:                          InternalFormat read _DUAL_ALPHA4_SGIS;
    public static property DUAL_ALPHA8_SGIS:                          InternalFormat read _DUAL_ALPHA8_SGIS;
    public static property DUAL_ALPHA12_SGIS:                         InternalFormat read _DUAL_ALPHA12_SGIS;
    public static property DUAL_ALPHA16_SGIS:                         InternalFormat read _DUAL_ALPHA16_SGIS;
    public static property DUAL_LUMINANCE4_SGIS:                      InternalFormat read _DUAL_LUMINANCE4_SGIS;
    public static property DUAL_LUMINANCE8_SGIS:                      InternalFormat read _DUAL_LUMINANCE8_SGIS;
    public static property DUAL_LUMINANCE12_SGIS:                     InternalFormat read _DUAL_LUMINANCE12_SGIS;
    public static property DUAL_LUMINANCE16_SGIS:                     InternalFormat read _DUAL_LUMINANCE16_SGIS;
    public static property DUAL_INTENSITY4_SGIS:                      InternalFormat read _DUAL_INTENSITY4_SGIS;
    public static property DUAL_INTENSITY8_SGIS:                      InternalFormat read _DUAL_INTENSITY8_SGIS;
    public static property DUAL_INTENSITY12_SGIS:                     InternalFormat read _DUAL_INTENSITY12_SGIS;
    public static property DUAL_INTENSITY16_SGIS:                     InternalFormat read _DUAL_INTENSITY16_SGIS;
    public static property DUAL_LUMINANCE_ALPHA4_SGIS:                InternalFormat read _DUAL_LUMINANCE_ALPHA4_SGIS;
    public static property DUAL_LUMINANCE_ALPHA8_SGIS:                InternalFormat read _DUAL_LUMINANCE_ALPHA8_SGIS;
    public static property QUAD_ALPHA4_SGIS:                          InternalFormat read _QUAD_ALPHA4_SGIS;
    public static property QUAD_ALPHA8_SGIS:                          InternalFormat read _QUAD_ALPHA8_SGIS;
    public static property QUAD_LUMINANCE4_SGIS:                      InternalFormat read _QUAD_LUMINANCE4_SGIS;
    public static property QUAD_LUMINANCE8_SGIS:                      InternalFormat read _QUAD_LUMINANCE8_SGIS;
    public static property QUAD_INTENSITY4_SGIS:                      InternalFormat read _QUAD_INTENSITY4_SGIS;
    public static property QUAD_INTENSITY8_SGIS:                      InternalFormat read _QUAD_INTENSITY8_SGIS;
    public static property DEPTH_COMPONENT16:                         InternalFormat read _DEPTH_COMPONENT16;
    public static property DEPTH_COMPONENT16_ARB:                     InternalFormat read _DEPTH_COMPONENT16_ARB;
    public static property DEPTH_COMPONENT16_OES:                     InternalFormat read _DEPTH_COMPONENT16_OES;
    public static property DEPTH_COMPONENT16_SGIX:                    InternalFormat read _DEPTH_COMPONENT16_SGIX;
    public static property DEPTH_COMPONENT24_ARB:                     InternalFormat read _DEPTH_COMPONENT24_ARB;
    public static property DEPTH_COMPONENT24_OES:                     InternalFormat read _DEPTH_COMPONENT24_OES;
    public static property DEPTH_COMPONENT24_SGIX:                    InternalFormat read _DEPTH_COMPONENT24_SGIX;
    public static property DEPTH_COMPONENT32_ARB:                     InternalFormat read _DEPTH_COMPONENT32_ARB;
    public static property DEPTH_COMPONENT32_OES:                     InternalFormat read _DEPTH_COMPONENT32_OES;
    public static property DEPTH_COMPONENT32_SGIX:                    InternalFormat read _DEPTH_COMPONENT32_SGIX;
    public static property COMPRESSED_RED:                            InternalFormat read _COMPRESSED_RED;
    public static property COMPRESSED_RG:                             InternalFormat read _COMPRESSED_RG;
    public static property RG:                                        InternalFormat read _RG;
    public static property R8:                                        InternalFormat read _R8;
    public static property R8_EXT:                                    InternalFormat read _R8_EXT;
    public static property R16:                                       InternalFormat read _R16;
    public static property R16_EXT:                                   InternalFormat read _R16_EXT;
    public static property RG8:                                       InternalFormat read _RG8;
    public static property RG8_EXT:                                   InternalFormat read _RG8_EXT;
    public static property RG16:                                      InternalFormat read _RG16;
    public static property RG16_EXT:                                  InternalFormat read _RG16_EXT;
    public static property R16F:                                      InternalFormat read _R16F;
    public static property R16F_EXT:                                  InternalFormat read _R16F_EXT;
    public static property R32F:                                      InternalFormat read _R32F;
    public static property R32F_EXT:                                  InternalFormat read _R32F_EXT;
    public static property RG16F:                                     InternalFormat read _RG16F;
    public static property RG16F_EXT:                                 InternalFormat read _RG16F_EXT;
    public static property RG32F:                                     InternalFormat read _RG32F;
    public static property RG32F_EXT:                                 InternalFormat read _RG32F_EXT;
    public static property R8I:                                       InternalFormat read _R8I;
    public static property R8UI:                                      InternalFormat read _R8UI;
    public static property R16I:                                      InternalFormat read _R16I;
    public static property R16UI:                                     InternalFormat read _R16UI;
    public static property R32I:                                      InternalFormat read _R32I;
    public static property R32UI:                                     InternalFormat read _R32UI;
    public static property RG8I:                                      InternalFormat read _RG8I;
    public static property RG8UI:                                     InternalFormat read _RG8UI;
    public static property RG16I:                                     InternalFormat read _RG16I;
    public static property RG16UI:                                    InternalFormat read _RG16UI;
    public static property RG32I:                                     InternalFormat read _RG32I;
    public static property RG32UI:                                    InternalFormat read _RG32UI;
    public static property COMPRESSED_RGB_S3TC_DXT1_EXT:              InternalFormat read _COMPRESSED_RGB_S3TC_DXT1_EXT;
    public static property COMPRESSED_RGBA_S3TC_DXT1_EXT:             InternalFormat read _COMPRESSED_RGBA_S3TC_DXT1_EXT;
    public static property COMPRESSED_RGBA_S3TC_DXT3_EXT:             InternalFormat read _COMPRESSED_RGBA_S3TC_DXT3_EXT;
    public static property COMPRESSED_RGBA_S3TC_DXT5_EXT:             InternalFormat read _COMPRESSED_RGBA_S3TC_DXT5_EXT;
    public static property COMPRESSED_RGB:                            InternalFormat read _COMPRESSED_RGB;
    public static property COMPRESSED_RGBA:                           InternalFormat read _COMPRESSED_RGBA;
    public static property DEPTH_STENCIL:                             InternalFormat read _DEPTH_STENCIL;
    public static property DEPTH_STENCIL_EXT:                         InternalFormat read _DEPTH_STENCIL_EXT;
    public static property DEPTH_STENCIL_NV:                          InternalFormat read _DEPTH_STENCIL_NV;
    public static property DEPTH_STENCIL_OES:                         InternalFormat read _DEPTH_STENCIL_OES;
    public static property DEPTH_STENCIL_MESA:                        InternalFormat read _DEPTH_STENCIL_MESA;
    public static property RGBA32F:                                   InternalFormat read _RGBA32F;
    public static property RGBA32F_ARB:                               InternalFormat read _RGBA32F_ARB;
    public static property RGBA32F_EXT:                               InternalFormat read _RGBA32F_EXT;
    public static property RGB32F:                                    InternalFormat read _RGB32F;
    public static property RGBA16F:                                   InternalFormat read _RGBA16F;
    public static property RGBA16F_ARB:                               InternalFormat read _RGBA16F_ARB;
    public static property RGBA16F_EXT:                               InternalFormat read _RGBA16F_EXT;
    public static property RGB16F:                                    InternalFormat read _RGB16F;
    public static property RGB16F_ARB:                                InternalFormat read _RGB16F_ARB;
    public static property RGB16F_EXT:                                InternalFormat read _RGB16F_EXT;
    public static property DEPTH24_STENCIL8:                          InternalFormat read _DEPTH24_STENCIL8;
    public static property DEPTH24_STENCIL8_EXT:                      InternalFormat read _DEPTH24_STENCIL8_EXT;
    public static property DEPTH24_STENCIL8_OES:                      InternalFormat read _DEPTH24_STENCIL8_OES;
    public static property R11F_G11F_B10F:                            InternalFormat read _R11F_G11F_B10F;
    public static property R11F_G11F_B10F_APPLE:                      InternalFormat read _R11F_G11F_B10F_APPLE;
    public static property R11F_G11F_B10F_EXT:                        InternalFormat read _R11F_G11F_B10F_EXT;
    public static property RGB9_E5:                                   InternalFormat read _RGB9_E5;
    public static property RGB9_E5_APPLE:                             InternalFormat read _RGB9_E5_APPLE;
    public static property RGB9_E5_EXT:                               InternalFormat read _RGB9_E5_EXT;
    public static property SRGB:                                      InternalFormat read _SRGB;
    public static property SRGB_EXT:                                  InternalFormat read _SRGB_EXT;
    public static property SRGB8:                                     InternalFormat read _SRGB8;
    public static property SRGB8_EXT:                                 InternalFormat read _SRGB8_EXT;
    public static property SRGB8_NV:                                  InternalFormat read _SRGB8_NV;
    public static property SRGB_ALPHA:                                InternalFormat read _SRGB_ALPHA;
    public static property SRGB_ALPHA_EXT:                            InternalFormat read _SRGB_ALPHA_EXT;
    public static property SRGB8_ALPHA8:                              InternalFormat read _SRGB8_ALPHA8;
    public static property SRGB8_ALPHA8_EXT:                          InternalFormat read _SRGB8_ALPHA8_EXT;
    public static property COMPRESSED_SRGB:                           InternalFormat read _COMPRESSED_SRGB;
    public static property COMPRESSED_SRGB_ALPHA:                     InternalFormat read _COMPRESSED_SRGB_ALPHA;
    public static property COMPRESSED_SRGB_S3TC_DXT1_EXT:             InternalFormat read _COMPRESSED_SRGB_S3TC_DXT1_EXT;
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT:       InternalFormat read _COMPRESSED_SRGB_ALPHA_S3TC_DXT1_EXT;
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT:       InternalFormat read _COMPRESSED_SRGB_ALPHA_S3TC_DXT3_EXT;
    public static property COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT:       InternalFormat read _COMPRESSED_SRGB_ALPHA_S3TC_DXT5_EXT;
    public static property DEPTH_COMPONENT32F:                        InternalFormat read _DEPTH_COMPONENT32F;
    public static property DEPTH32F_STENCIL8:                         InternalFormat read _DEPTH32F_STENCIL8;
    public static property STENCIL_INDEX1:                            InternalFormat read _STENCIL_INDEX1;
    public static property STENCIL_INDEX1_EXT:                        InternalFormat read _STENCIL_INDEX1_EXT;
    public static property STENCIL_INDEX1_OES:                        InternalFormat read _STENCIL_INDEX1_OES;
    public static property STENCIL_INDEX4:                            InternalFormat read _STENCIL_INDEX4;
    public static property STENCIL_INDEX4_EXT:                        InternalFormat read _STENCIL_INDEX4_EXT;
    public static property STENCIL_INDEX4_OES:                        InternalFormat read _STENCIL_INDEX4_OES;
    public static property STENCIL_INDEX8:                            InternalFormat read _STENCIL_INDEX8;
    public static property STENCIL_INDEX8_EXT:                        InternalFormat read _STENCIL_INDEX8_EXT;
    public static property STENCIL_INDEX8_OES:                        InternalFormat read _STENCIL_INDEX8_OES;
    public static property STENCIL_INDEX16:                           InternalFormat read _STENCIL_INDEX16;
    public static property STENCIL_INDEX16_EXT:                       InternalFormat read _STENCIL_INDEX16_EXT;
    public static property RGBA32UI:                                  InternalFormat read _RGBA32UI;
    public static property RGB32UI:                                   InternalFormat read _RGB32UI;
    public static property RGBA16UI:                                  InternalFormat read _RGBA16UI;
    public static property RGB16UI:                                   InternalFormat read _RGB16UI;
    public static property RGBA8UI:                                   InternalFormat read _RGBA8UI;
    public static property RGB8UI:                                    InternalFormat read _RGB8UI;
    public static property RGBA32I:                                   InternalFormat read _RGBA32I;
    public static property RGB32I:                                    InternalFormat read _RGB32I;
    public static property RGBA16I:                                   InternalFormat read _RGBA16I;
    public static property RGB16I:                                    InternalFormat read _RGB16I;
    public static property RGBA8I:                                    InternalFormat read _RGBA8I;
    public static property RGB8I:                                     InternalFormat read _RGB8I;
    public static property DEPTH_COMPONENT32F_NV:                     InternalFormat read _DEPTH_COMPONENT32F_NV;
    public static property DEPTH32F_STENCIL8_NV:                      InternalFormat read _DEPTH32F_STENCIL8_NV;
    public static property COMPRESSED_RED_RGTC1:                      InternalFormat read _COMPRESSED_RED_RGTC1;
    public static property COMPRESSED_RED_RGTC1_EXT:                  InternalFormat read _COMPRESSED_RED_RGTC1_EXT;
    public static property COMPRESSED_SIGNED_RED_RGTC1:               InternalFormat read _COMPRESSED_SIGNED_RED_RGTC1;
    public static property COMPRESSED_SIGNED_RED_RGTC1_EXT:           InternalFormat read _COMPRESSED_SIGNED_RED_RGTC1_EXT;
    public static property COMPRESSED_RG_RGTC2:                       InternalFormat read _COMPRESSED_RG_RGTC2;
    public static property COMPRESSED_SIGNED_RG_RGTC2:                InternalFormat read _COMPRESSED_SIGNED_RG_RGTC2;
    public static property COMPRESSED_RGBA_BPTC_UNORM:                InternalFormat read _COMPRESSED_RGBA_BPTC_UNORM;
    public static property COMPRESSED_SRGB_ALPHA_BPTC_UNORM:          InternalFormat read _COMPRESSED_SRGB_ALPHA_BPTC_UNORM;
    public static property COMPRESSED_RGB_BPTC_SIGNED_FLOAT:          InternalFormat read _COMPRESSED_RGB_BPTC_SIGNED_FLOAT;
    public static property COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT:        InternalFormat read _COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT;
    public static property R8_SNORM:                                  InternalFormat read _R8_SNORM;
    public static property RG8_SNORM:                                 InternalFormat read _RG8_SNORM;
    public static property RGB8_SNORM:                                InternalFormat read _RGB8_SNORM;
    public static property RGBA8_SNORM:                               InternalFormat read _RGBA8_SNORM;
    public static property R16_SNORM:                                 InternalFormat read _R16_SNORM;
    public static property R16_SNORM_EXT:                             InternalFormat read _R16_SNORM_EXT;
    public static property RG16_SNORM:                                InternalFormat read _RG16_SNORM;
    public static property RG16_SNORM_EXT:                            InternalFormat read _RG16_SNORM_EXT;
    public static property RGB16_SNORM:                               InternalFormat read _RGB16_SNORM;
    public static property RGB16_SNORM_EXT:                           InternalFormat read _RGB16_SNORM_EXT;
    public static property RGB10_A2UI:                                InternalFormat read _RGB10_A2UI;
    public static property COMPRESSED_R11_EAC:                        InternalFormat read _COMPRESSED_R11_EAC;
    public static property COMPRESSED_SIGNED_R11_EAC:                 InternalFormat read _COMPRESSED_SIGNED_R11_EAC;
    public static property COMPRESSED_RG11_EAC:                       InternalFormat read _COMPRESSED_RG11_EAC;
    public static property COMPRESSED_SIGNED_RG11_EAC:                InternalFormat read _COMPRESSED_SIGNED_RG11_EAC;
    public static property COMPRESSED_RGB8_ETC2:                      InternalFormat read _COMPRESSED_RGB8_ETC2;
    public static property COMPRESSED_SRGB8_ETC2:                     InternalFormat read _COMPRESSED_SRGB8_ETC2;
    public static property COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:  InternalFormat read _COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2;
    public static property COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2: InternalFormat read _COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2;
    public static property COMPRESSED_RGBA8_ETC2_EAC:                 InternalFormat read _COMPRESSED_RGBA8_ETC2_EAC;
    public static property COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ETC2_EAC;
    public static property COMPRESSED_RGBA_ASTC_4x4:                  InternalFormat read _COMPRESSED_RGBA_ASTC_4x4;
    public static property COMPRESSED_RGBA_ASTC_4x4_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_4x4_KHR;
    public static property COMPRESSED_RGBA_ASTC_5x4:                  InternalFormat read _COMPRESSED_RGBA_ASTC_5x4;
    public static property COMPRESSED_RGBA_ASTC_5x4_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_5x4_KHR;
    public static property COMPRESSED_RGBA_ASTC_5x5:                  InternalFormat read _COMPRESSED_RGBA_ASTC_5x5;
    public static property COMPRESSED_RGBA_ASTC_5x5_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_5x5_KHR;
    public static property COMPRESSED_RGBA_ASTC_6x5:                  InternalFormat read _COMPRESSED_RGBA_ASTC_6x5;
    public static property COMPRESSED_RGBA_ASTC_6x5_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_6x5_KHR;
    public static property COMPRESSED_RGBA_ASTC_6x6:                  InternalFormat read _COMPRESSED_RGBA_ASTC_6x6;
    public static property COMPRESSED_RGBA_ASTC_6x6_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_6x6_KHR;
    public static property COMPRESSED_RGBA_ASTC_8x5:                  InternalFormat read _COMPRESSED_RGBA_ASTC_8x5;
    public static property COMPRESSED_RGBA_ASTC_8x5_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_8x5_KHR;
    public static property COMPRESSED_RGBA_ASTC_8x6:                  InternalFormat read _COMPRESSED_RGBA_ASTC_8x6;
    public static property COMPRESSED_RGBA_ASTC_8x6_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_8x6_KHR;
    public static property COMPRESSED_RGBA_ASTC_8x8:                  InternalFormat read _COMPRESSED_RGBA_ASTC_8x8;
    public static property COMPRESSED_RGBA_ASTC_8x8_KHR:              InternalFormat read _COMPRESSED_RGBA_ASTC_8x8_KHR;
    public static property COMPRESSED_RGBA_ASTC_10x5:                 InternalFormat read _COMPRESSED_RGBA_ASTC_10x5;
    public static property COMPRESSED_RGBA_ASTC_10x5_KHR:             InternalFormat read _COMPRESSED_RGBA_ASTC_10x5_KHR;
    public static property COMPRESSED_RGBA_ASTC_10x6:                 InternalFormat read _COMPRESSED_RGBA_ASTC_10x6;
    public static property COMPRESSED_RGBA_ASTC_10x6_KHR:             InternalFormat read _COMPRESSED_RGBA_ASTC_10x6_KHR;
    public static property COMPRESSED_RGBA_ASTC_10x8:                 InternalFormat read _COMPRESSED_RGBA_ASTC_10x8;
    public static property COMPRESSED_RGBA_ASTC_10x8_KHR:             InternalFormat read _COMPRESSED_RGBA_ASTC_10x8_KHR;
    public static property COMPRESSED_RGBA_ASTC_10x10:                InternalFormat read _COMPRESSED_RGBA_ASTC_10x10;
    public static property COMPRESSED_RGBA_ASTC_10x10_KHR:            InternalFormat read _COMPRESSED_RGBA_ASTC_10x10_KHR;
    public static property COMPRESSED_RGBA_ASTC_12x10:                InternalFormat read _COMPRESSED_RGBA_ASTC_12x10;
    public static property COMPRESSED_RGBA_ASTC_12x10_KHR:            InternalFormat read _COMPRESSED_RGBA_ASTC_12x10_KHR;
    public static property COMPRESSED_RGBA_ASTC_12x12:                InternalFormat read _COMPRESSED_RGBA_ASTC_12x12;
    public static property COMPRESSED_RGBA_ASTC_12x12_KHR:            InternalFormat read _COMPRESSED_RGBA_ASTC_12x12_KHR;
    public static property COMPRESSED_RGBA_ASTC_3x3x3_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_3x3x3_OES;
    public static property COMPRESSED_RGBA_ASTC_4x3x3_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_4x3x3_OES;
    public static property COMPRESSED_RGBA_ASTC_4x4x3_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_4x4x3_OES;
    public static property COMPRESSED_RGBA_ASTC_4x4x4_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_4x4x4_OES;
    public static property COMPRESSED_RGBA_ASTC_5x4x4_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_5x4x4_OES;
    public static property COMPRESSED_RGBA_ASTC_5x5x4_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_5x5x4_OES;
    public static property COMPRESSED_RGBA_ASTC_5x5x5_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_5x5x5_OES;
    public static property COMPRESSED_RGBA_ASTC_6x5x5_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_6x5x5_OES;
    public static property COMPRESSED_RGBA_ASTC_6x6x5_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_6x6x5_OES;
    public static property COMPRESSED_RGBA_ASTC_6x6x6_OES:            InternalFormat read _COMPRESSED_RGBA_ASTC_6x6x6_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x5;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x6;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8:          InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x8;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR:      InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5:         InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x5;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR:     InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6:         InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x6;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR:     InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8:         InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x8;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR:     InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10:        InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x10;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10:        InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_12x10;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12:        InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_12x12;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_3x3x3_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_4x3x3_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x3_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_4x4x4_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x4x4_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x4_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_5x5x5_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x5x5_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x5_OES;
    public static property COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES:    InternalFormat read _COMPRESSED_SRGB8_ALPHA8_ASTC_6x6x6_OES;
    
    public function ToString: string; override;
    begin
      var res := typeof(InternalFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->InternalFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'InternalFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  InternalFormatPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SAMPLES                                := new InternalFormatPName($80A9);
    private static _GENERATE_MIPMAP                        := new InternalFormatPName($8191);
    private static _INTERNALFORMAT_SUPPORTED               := new InternalFormatPName($826F);
    private static _INTERNALFORMAT_PREFERRED               := new InternalFormatPName($8270);
    private static _INTERNALFORMAT_RED_SIZE                := new InternalFormatPName($8271);
    private static _INTERNALFORMAT_GREEN_SIZE              := new InternalFormatPName($8272);
    private static _INTERNALFORMAT_BLUE_SIZE               := new InternalFormatPName($8273);
    private static _INTERNALFORMAT_ALPHA_SIZE              := new InternalFormatPName($8274);
    private static _INTERNALFORMAT_DEPTH_SIZE              := new InternalFormatPName($8275);
    private static _INTERNALFORMAT_STENCIL_SIZE            := new InternalFormatPName($8276);
    private static _INTERNALFORMAT_SHARED_SIZE             := new InternalFormatPName($8277);
    private static _INTERNALFORMAT_RED_TYPE                := new InternalFormatPName($8278);
    private static _INTERNALFORMAT_GREEN_TYPE              := new InternalFormatPName($8279);
    private static _INTERNALFORMAT_BLUE_TYPE               := new InternalFormatPName($827A);
    private static _INTERNALFORMAT_ALPHA_TYPE              := new InternalFormatPName($827B);
    private static _INTERNALFORMAT_DEPTH_TYPE              := new InternalFormatPName($827C);
    private static _INTERNALFORMAT_STENCIL_TYPE            := new InternalFormatPName($827D);
    private static _MAX_WIDTH                              := new InternalFormatPName($827E);
    private static _MAX_HEIGHT                             := new InternalFormatPName($827F);
    private static _MAX_DEPTH                              := new InternalFormatPName($8280);
    private static _MAX_LAYERS                             := new InternalFormatPName($8281);
    private static _COLOR_COMPONENTS                       := new InternalFormatPName($8283);
    private static _COLOR_RENDERABLE                       := new InternalFormatPName($8286);
    private static _DEPTH_RENDERABLE                       := new InternalFormatPName($8287);
    private static _STENCIL_RENDERABLE                     := new InternalFormatPName($8288);
    private static _FRAMEBUFFER_RENDERABLE                 := new InternalFormatPName($8289);
    private static _FRAMEBUFFER_RENDERABLE_LAYERED         := new InternalFormatPName($828A);
    private static _FRAMEBUFFER_BLEND                      := new InternalFormatPName($828B);
    private static _READ_PIXELS                            := new InternalFormatPName($828C);
    private static _READ_PIXELS_FORMAT                     := new InternalFormatPName($828D);
    private static _READ_PIXELS_TYPE                       := new InternalFormatPName($828E);
    private static _TEXTURE_IMAGE_FORMAT                   := new InternalFormatPName($828F);
    private static _TEXTURE_IMAGE_TYPE                     := new InternalFormatPName($8290);
    private static _GET__TEXTURE_IMAGE_FORMAT              := new InternalFormatPName($8291);
    private static _GET__TEXTURE_IMAGE_TYPE                := new InternalFormatPName($8292);
    private static _MIPMAP                                 := new InternalFormatPName($8293);
    private static _AUTO_GENERATE_MIPMAP                   := new InternalFormatPName($8295);
    private static _COLOR_ENCODING                         := new InternalFormatPName($8296);
    private static _SRGB_READ                              := new InternalFormatPName($8297);
    private static _SRGB_WRITE                             := new InternalFormatPName($8298);
    private static _FILTER                                 := new InternalFormatPName($829A);
    private static _VERTEX_TEXTURE                         := new InternalFormatPName($829B);
    private static _TESS_CONTROL_TEXTURE                   := new InternalFormatPName($829C);
    private static _TESS_EVALUATION_TEXTURE                := new InternalFormatPName($829D);
    private static _GEOMETRY_TEXTURE                       := new InternalFormatPName($829E);
    private static _FRAGMENT_TEXTURE                       := new InternalFormatPName($829F);
    private static _COMPUTE_TEXTURE                        := new InternalFormatPName($82A0);
    private static _TEXTURE_SHADOW                         := new InternalFormatPName($82A1);
    private static _TEXTURE_GATHER                         := new InternalFormatPName($82A2);
    private static _TEXTURE_GATHER_SHADOW                  := new InternalFormatPName($82A3);
    private static _SHADER_IMAGE_LOAD                      := new InternalFormatPName($82A4);
    private static _SHADER_IMAGE_STORE                     := new InternalFormatPName($82A5);
    private static _SHADER_IMAGE_ATOMIC                    := new InternalFormatPName($82A6);
    private static _IMAGE_TEXEL_SIZE                       := new InternalFormatPName($82A7);
    private static _IMAGE_COMPATIBILITY_CLASS              := new InternalFormatPName($82A8);
    private static _IMAGE_PIXEL_FORMAT                     := new InternalFormatPName($82A9);
    private static _IMAGE_PIXEL_TYPE                       := new InternalFormatPName($82AA);
    private static _SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST    := new InternalFormatPName($82AC);
    private static _SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST  := new InternalFormatPName($82AD);
    private static _SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE   := new InternalFormatPName($82AE);
    private static _SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE := new InternalFormatPName($82AF);
    private static _TEXTURE_COMPRESSED_BLOCK_WIDTH         := new InternalFormatPName($82B1);
    private static _TEXTURE_COMPRESSED_BLOCK_HEIGHT        := new InternalFormatPName($82B2);
    private static _TEXTURE_COMPRESSED_BLOCK_SIZE          := new InternalFormatPName($82B3);
    private static _CLEAR_BUFFER                           := new InternalFormatPName($82B4);
    private static _TEXTURE_VIEW                           := new InternalFormatPName($82B5);
    private static _VIEW_COMPATIBILITY_CLASS               := new InternalFormatPName($82B6);
    private static _TEXTURE_COMPRESSED                     := new InternalFormatPName($86A1);
    private static _IMAGE_FORMAT_COMPATIBILITY_TYPE        := new InternalFormatPName($90C7);
    private static _CLEAR_TEXTURE                          := new InternalFormatPName($9365);
    private static _NUM_SAMPLE_COUNTS                      := new InternalFormatPName($9380);
    
    public static property SAMPLES:                                InternalFormatPName read _SAMPLES;
    public static property GENERATE_MIPMAP:                        InternalFormatPName read _GENERATE_MIPMAP;
    public static property INTERNALFORMAT_SUPPORTED:               InternalFormatPName read _INTERNALFORMAT_SUPPORTED;
    public static property INTERNALFORMAT_PREFERRED:               InternalFormatPName read _INTERNALFORMAT_PREFERRED;
    public static property INTERNALFORMAT_RED_SIZE:                InternalFormatPName read _INTERNALFORMAT_RED_SIZE;
    public static property INTERNALFORMAT_GREEN_SIZE:              InternalFormatPName read _INTERNALFORMAT_GREEN_SIZE;
    public static property INTERNALFORMAT_BLUE_SIZE:               InternalFormatPName read _INTERNALFORMAT_BLUE_SIZE;
    public static property INTERNALFORMAT_ALPHA_SIZE:              InternalFormatPName read _INTERNALFORMAT_ALPHA_SIZE;
    public static property INTERNALFORMAT_DEPTH_SIZE:              InternalFormatPName read _INTERNALFORMAT_DEPTH_SIZE;
    public static property INTERNALFORMAT_STENCIL_SIZE:            InternalFormatPName read _INTERNALFORMAT_STENCIL_SIZE;
    public static property INTERNALFORMAT_SHARED_SIZE:             InternalFormatPName read _INTERNALFORMAT_SHARED_SIZE;
    public static property INTERNALFORMAT_RED_TYPE:                InternalFormatPName read _INTERNALFORMAT_RED_TYPE;
    public static property INTERNALFORMAT_GREEN_TYPE:              InternalFormatPName read _INTERNALFORMAT_GREEN_TYPE;
    public static property INTERNALFORMAT_BLUE_TYPE:               InternalFormatPName read _INTERNALFORMAT_BLUE_TYPE;
    public static property INTERNALFORMAT_ALPHA_TYPE:              InternalFormatPName read _INTERNALFORMAT_ALPHA_TYPE;
    public static property INTERNALFORMAT_DEPTH_TYPE:              InternalFormatPName read _INTERNALFORMAT_DEPTH_TYPE;
    public static property INTERNALFORMAT_STENCIL_TYPE:            InternalFormatPName read _INTERNALFORMAT_STENCIL_TYPE;
    public static property MAX_WIDTH:                              InternalFormatPName read _MAX_WIDTH;
    public static property MAX_HEIGHT:                             InternalFormatPName read _MAX_HEIGHT;
    public static property MAX_DEPTH:                              InternalFormatPName read _MAX_DEPTH;
    public static property MAX_LAYERS:                             InternalFormatPName read _MAX_LAYERS;
    public static property COLOR_COMPONENTS:                       InternalFormatPName read _COLOR_COMPONENTS;
    public static property COLOR_RENDERABLE:                       InternalFormatPName read _COLOR_RENDERABLE;
    public static property DEPTH_RENDERABLE:                       InternalFormatPName read _DEPTH_RENDERABLE;
    public static property STENCIL_RENDERABLE:                     InternalFormatPName read _STENCIL_RENDERABLE;
    public static property FRAMEBUFFER_RENDERABLE:                 InternalFormatPName read _FRAMEBUFFER_RENDERABLE;
    public static property FRAMEBUFFER_RENDERABLE_LAYERED:         InternalFormatPName read _FRAMEBUFFER_RENDERABLE_LAYERED;
    public static property FRAMEBUFFER_BLEND:                      InternalFormatPName read _FRAMEBUFFER_BLEND;
    public static property READ_PIXELS:                            InternalFormatPName read _READ_PIXELS;
    public static property READ_PIXELS_FORMAT:                     InternalFormatPName read _READ_PIXELS_FORMAT;
    public static property READ_PIXELS_TYPE:                       InternalFormatPName read _READ_PIXELS_TYPE;
    public static property TEXTURE_IMAGE_FORMAT:                   InternalFormatPName read _TEXTURE_IMAGE_FORMAT;
    public static property TEXTURE_IMAGE_TYPE:                     InternalFormatPName read _TEXTURE_IMAGE_TYPE;
    public static property GET__TEXTURE_IMAGE_FORMAT:              InternalFormatPName read _GET__TEXTURE_IMAGE_FORMAT;
    public static property GET__TEXTURE_IMAGE_TYPE:                InternalFormatPName read _GET__TEXTURE_IMAGE_TYPE;
    public static property MIPMAP:                                 InternalFormatPName read _MIPMAP;
    public static property AUTO_GENERATE_MIPMAP:                   InternalFormatPName read _AUTO_GENERATE_MIPMAP;
    public static property COLOR_ENCODING:                         InternalFormatPName read _COLOR_ENCODING;
    public static property SRGB_READ:                              InternalFormatPName read _SRGB_READ;
    public static property SRGB_WRITE:                             InternalFormatPName read _SRGB_WRITE;
    public static property FILTER:                                 InternalFormatPName read _FILTER;
    public static property VERTEX_TEXTURE:                         InternalFormatPName read _VERTEX_TEXTURE;
    public static property TESS_CONTROL_TEXTURE:                   InternalFormatPName read _TESS_CONTROL_TEXTURE;
    public static property TESS_EVALUATION_TEXTURE:                InternalFormatPName read _TESS_EVALUATION_TEXTURE;
    public static property GEOMETRY_TEXTURE:                       InternalFormatPName read _GEOMETRY_TEXTURE;
    public static property FRAGMENT_TEXTURE:                       InternalFormatPName read _FRAGMENT_TEXTURE;
    public static property COMPUTE_TEXTURE:                        InternalFormatPName read _COMPUTE_TEXTURE;
    public static property TEXTURE_SHADOW:                         InternalFormatPName read _TEXTURE_SHADOW;
    public static property TEXTURE_GATHER:                         InternalFormatPName read _TEXTURE_GATHER;
    public static property TEXTURE_GATHER_SHADOW:                  InternalFormatPName read _TEXTURE_GATHER_SHADOW;
    public static property SHADER_IMAGE_LOAD:                      InternalFormatPName read _SHADER_IMAGE_LOAD;
    public static property SHADER_IMAGE_STORE:                     InternalFormatPName read _SHADER_IMAGE_STORE;
    public static property SHADER_IMAGE_ATOMIC:                    InternalFormatPName read _SHADER_IMAGE_ATOMIC;
    public static property IMAGE_TEXEL_SIZE:                       InternalFormatPName read _IMAGE_TEXEL_SIZE;
    public static property IMAGE_COMPATIBILITY_CLASS:              InternalFormatPName read _IMAGE_COMPATIBILITY_CLASS;
    public static property IMAGE_PIXEL_FORMAT:                     InternalFormatPName read _IMAGE_PIXEL_FORMAT;
    public static property IMAGE_PIXEL_TYPE:                       InternalFormatPName read _IMAGE_PIXEL_TYPE;
    public static property SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST:    InternalFormatPName read _SIMULTANEOUS_TEXTURE_AND_DEPTH_TEST;
    public static property SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST:  InternalFormatPName read _SIMULTANEOUS_TEXTURE_AND_STENCIL_TEST;
    public static property SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE:   InternalFormatPName read _SIMULTANEOUS_TEXTURE_AND_DEPTH_WRITE;
    public static property SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE: InternalFormatPName read _SIMULTANEOUS_TEXTURE_AND_STENCIL_WRITE;
    public static property TEXTURE_COMPRESSED_BLOCK_WIDTH:         InternalFormatPName read _TEXTURE_COMPRESSED_BLOCK_WIDTH;
    public static property TEXTURE_COMPRESSED_BLOCK_HEIGHT:        InternalFormatPName read _TEXTURE_COMPRESSED_BLOCK_HEIGHT;
    public static property TEXTURE_COMPRESSED_BLOCK_SIZE:          InternalFormatPName read _TEXTURE_COMPRESSED_BLOCK_SIZE;
    public static property CLEAR_BUFFER:                           InternalFormatPName read _CLEAR_BUFFER;
    public static property TEXTURE_VIEW:                           InternalFormatPName read _TEXTURE_VIEW;
    public static property VIEW_COMPATIBILITY_CLASS:               InternalFormatPName read _VIEW_COMPATIBILITY_CLASS;
    public static property TEXTURE_COMPRESSED:                     InternalFormatPName read _TEXTURE_COMPRESSED;
    public static property IMAGE_FORMAT_COMPATIBILITY_TYPE:        InternalFormatPName read _IMAGE_FORMAT_COMPATIBILITY_TYPE;
    public static property CLEAR_TEXTURE:                          InternalFormatPName read _CLEAR_TEXTURE;
    public static property NUM_SAMPLE_COUNTS:                      InternalFormatPName read _NUM_SAMPLE_COUNTS;
    
    public function ToString: string; override;
    begin
      var res := typeof(InternalFormatPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->InternalFormatPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'InternalFormatPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  InvalidateFramebufferAttachment = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR                    := new InvalidateFramebufferAttachment($1800);
    private static _DEPTH                    := new InvalidateFramebufferAttachment($1801);
    private static _STENCIL                  := new InvalidateFramebufferAttachment($1802);
    private static _DEPTH_STENCIL_ATTACHMENT := new InvalidateFramebufferAttachment($821A);
    private static _COLOR_ATTACHMENT0        := new InvalidateFramebufferAttachment($8CE0);
    private static _COLOR_ATTACHMENT0_EXT    := new InvalidateFramebufferAttachment($8CE0);
    private static _COLOR_ATTACHMENT0_NV     := new InvalidateFramebufferAttachment($8CE0);
    private static _COLOR_ATTACHMENT0_OES    := new InvalidateFramebufferAttachment($8CE0);
    private static _COLOR_ATTACHMENT1        := new InvalidateFramebufferAttachment($8CE1);
    private static _COLOR_ATTACHMENT1_EXT    := new InvalidateFramebufferAttachment($8CE1);
    private static _COLOR_ATTACHMENT1_NV     := new InvalidateFramebufferAttachment($8CE1);
    private static _COLOR_ATTACHMENT2        := new InvalidateFramebufferAttachment($8CE2);
    private static _COLOR_ATTACHMENT2_EXT    := new InvalidateFramebufferAttachment($8CE2);
    private static _COLOR_ATTACHMENT2_NV     := new InvalidateFramebufferAttachment($8CE2);
    private static _COLOR_ATTACHMENT3        := new InvalidateFramebufferAttachment($8CE3);
    private static _COLOR_ATTACHMENT3_EXT    := new InvalidateFramebufferAttachment($8CE3);
    private static _COLOR_ATTACHMENT3_NV     := new InvalidateFramebufferAttachment($8CE3);
    private static _COLOR_ATTACHMENT4        := new InvalidateFramebufferAttachment($8CE4);
    private static _COLOR_ATTACHMENT4_EXT    := new InvalidateFramebufferAttachment($8CE4);
    private static _COLOR_ATTACHMENT4_NV     := new InvalidateFramebufferAttachment($8CE4);
    private static _COLOR_ATTACHMENT5        := new InvalidateFramebufferAttachment($8CE5);
    private static _COLOR_ATTACHMENT5_EXT    := new InvalidateFramebufferAttachment($8CE5);
    private static _COLOR_ATTACHMENT5_NV     := new InvalidateFramebufferAttachment($8CE5);
    private static _COLOR_ATTACHMENT6        := new InvalidateFramebufferAttachment($8CE6);
    private static _COLOR_ATTACHMENT6_EXT    := new InvalidateFramebufferAttachment($8CE6);
    private static _COLOR_ATTACHMENT6_NV     := new InvalidateFramebufferAttachment($8CE6);
    private static _COLOR_ATTACHMENT7        := new InvalidateFramebufferAttachment($8CE7);
    private static _COLOR_ATTACHMENT7_EXT    := new InvalidateFramebufferAttachment($8CE7);
    private static _COLOR_ATTACHMENT7_NV     := new InvalidateFramebufferAttachment($8CE7);
    private static _COLOR_ATTACHMENT8        := new InvalidateFramebufferAttachment($8CE8);
    private static _COLOR_ATTACHMENT8_EXT    := new InvalidateFramebufferAttachment($8CE8);
    private static _COLOR_ATTACHMENT8_NV     := new InvalidateFramebufferAttachment($8CE8);
    private static _COLOR_ATTACHMENT9        := new InvalidateFramebufferAttachment($8CE9);
    private static _COLOR_ATTACHMENT9_EXT    := new InvalidateFramebufferAttachment($8CE9);
    private static _COLOR_ATTACHMENT9_NV     := new InvalidateFramebufferAttachment($8CE9);
    private static _COLOR_ATTACHMENT10       := new InvalidateFramebufferAttachment($8CEA);
    private static _COLOR_ATTACHMENT10_EXT   := new InvalidateFramebufferAttachment($8CEA);
    private static _COLOR_ATTACHMENT10_NV    := new InvalidateFramebufferAttachment($8CEA);
    private static _COLOR_ATTACHMENT11       := new InvalidateFramebufferAttachment($8CEB);
    private static _COLOR_ATTACHMENT11_EXT   := new InvalidateFramebufferAttachment($8CEB);
    private static _COLOR_ATTACHMENT11_NV    := new InvalidateFramebufferAttachment($8CEB);
    private static _COLOR_ATTACHMENT12       := new InvalidateFramebufferAttachment($8CEC);
    private static _COLOR_ATTACHMENT12_EXT   := new InvalidateFramebufferAttachment($8CEC);
    private static _COLOR_ATTACHMENT12_NV    := new InvalidateFramebufferAttachment($8CEC);
    private static _COLOR_ATTACHMENT13       := new InvalidateFramebufferAttachment($8CED);
    private static _COLOR_ATTACHMENT13_EXT   := new InvalidateFramebufferAttachment($8CED);
    private static _COLOR_ATTACHMENT13_NV    := new InvalidateFramebufferAttachment($8CED);
    private static _COLOR_ATTACHMENT14       := new InvalidateFramebufferAttachment($8CEE);
    private static _COLOR_ATTACHMENT14_EXT   := new InvalidateFramebufferAttachment($8CEE);
    private static _COLOR_ATTACHMENT14_NV    := new InvalidateFramebufferAttachment($8CEE);
    private static _COLOR_ATTACHMENT15       := new InvalidateFramebufferAttachment($8CEF);
    private static _COLOR_ATTACHMENT15_EXT   := new InvalidateFramebufferAttachment($8CEF);
    private static _COLOR_ATTACHMENT15_NV    := new InvalidateFramebufferAttachment($8CEF);
    private static _COLOR_ATTACHMENT16       := new InvalidateFramebufferAttachment($8CF0);
    private static _COLOR_ATTACHMENT17       := new InvalidateFramebufferAttachment($8CF1);
    private static _COLOR_ATTACHMENT18       := new InvalidateFramebufferAttachment($8CF2);
    private static _COLOR_ATTACHMENT19       := new InvalidateFramebufferAttachment($8CF3);
    private static _COLOR_ATTACHMENT20       := new InvalidateFramebufferAttachment($8CF4);
    private static _COLOR_ATTACHMENT21       := new InvalidateFramebufferAttachment($8CF5);
    private static _COLOR_ATTACHMENT22       := new InvalidateFramebufferAttachment($8CF6);
    private static _COLOR_ATTACHMENT23       := new InvalidateFramebufferAttachment($8CF7);
    private static _COLOR_ATTACHMENT24       := new InvalidateFramebufferAttachment($8CF8);
    private static _COLOR_ATTACHMENT25       := new InvalidateFramebufferAttachment($8CF9);
    private static _COLOR_ATTACHMENT26       := new InvalidateFramebufferAttachment($8CFA);
    private static _COLOR_ATTACHMENT27       := new InvalidateFramebufferAttachment($8CFB);
    private static _COLOR_ATTACHMENT28       := new InvalidateFramebufferAttachment($8CFC);
    private static _COLOR_ATTACHMENT29       := new InvalidateFramebufferAttachment($8CFD);
    private static _COLOR_ATTACHMENT30       := new InvalidateFramebufferAttachment($8CFE);
    private static _COLOR_ATTACHMENT31       := new InvalidateFramebufferAttachment($8CFF);
    private static _DEPTH_ATTACHMENT         := new InvalidateFramebufferAttachment($8D00);
    private static _DEPTH_ATTACHMENT_EXT     := new InvalidateFramebufferAttachment($8D00);
    private static _DEPTH_ATTACHMENT_OES     := new InvalidateFramebufferAttachment($8D00);
    private static _STENCIL_ATTACHMENT_EXT   := new InvalidateFramebufferAttachment($8D20);
    private static _STENCIL_ATTACHMENT_OES   := new InvalidateFramebufferAttachment($8D20);
    
    public static property COLOR:                    InvalidateFramebufferAttachment read _COLOR;
    public static property DEPTH:                    InvalidateFramebufferAttachment read _DEPTH;
    public static property STENCIL:                  InvalidateFramebufferAttachment read _STENCIL;
    public static property DEPTH_STENCIL_ATTACHMENT: InvalidateFramebufferAttachment read _DEPTH_STENCIL_ATTACHMENT;
    public static property COLOR_ATTACHMENT0:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT0;
    public static property COLOR_ATTACHMENT0_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT0_EXT;
    public static property COLOR_ATTACHMENT0_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT0_NV;
    public static property COLOR_ATTACHMENT0_OES:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT0_OES;
    public static property COLOR_ATTACHMENT1:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT1;
    public static property COLOR_ATTACHMENT1_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT1_EXT;
    public static property COLOR_ATTACHMENT1_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT1_NV;
    public static property COLOR_ATTACHMENT2:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT2;
    public static property COLOR_ATTACHMENT2_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT2_EXT;
    public static property COLOR_ATTACHMENT2_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT2_NV;
    public static property COLOR_ATTACHMENT3:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT3;
    public static property COLOR_ATTACHMENT3_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT3_EXT;
    public static property COLOR_ATTACHMENT3_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT3_NV;
    public static property COLOR_ATTACHMENT4:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT4;
    public static property COLOR_ATTACHMENT4_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT4_EXT;
    public static property COLOR_ATTACHMENT4_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT4_NV;
    public static property COLOR_ATTACHMENT5:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT5;
    public static property COLOR_ATTACHMENT5_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT5_EXT;
    public static property COLOR_ATTACHMENT5_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT5_NV;
    public static property COLOR_ATTACHMENT6:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT6;
    public static property COLOR_ATTACHMENT6_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT6_EXT;
    public static property COLOR_ATTACHMENT6_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT6_NV;
    public static property COLOR_ATTACHMENT7:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT7;
    public static property COLOR_ATTACHMENT7_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT7_EXT;
    public static property COLOR_ATTACHMENT7_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT7_NV;
    public static property COLOR_ATTACHMENT8:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT8;
    public static property COLOR_ATTACHMENT8_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT8_EXT;
    public static property COLOR_ATTACHMENT8_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT8_NV;
    public static property COLOR_ATTACHMENT9:        InvalidateFramebufferAttachment read _COLOR_ATTACHMENT9;
    public static property COLOR_ATTACHMENT9_EXT:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT9_EXT;
    public static property COLOR_ATTACHMENT9_NV:     InvalidateFramebufferAttachment read _COLOR_ATTACHMENT9_NV;
    public static property COLOR_ATTACHMENT10:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT10;
    public static property COLOR_ATTACHMENT10_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT10_EXT;
    public static property COLOR_ATTACHMENT10_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT10_NV;
    public static property COLOR_ATTACHMENT11:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT11;
    public static property COLOR_ATTACHMENT11_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT11_EXT;
    public static property COLOR_ATTACHMENT11_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT11_NV;
    public static property COLOR_ATTACHMENT12:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT12;
    public static property COLOR_ATTACHMENT12_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT12_EXT;
    public static property COLOR_ATTACHMENT12_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT12_NV;
    public static property COLOR_ATTACHMENT13:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT13;
    public static property COLOR_ATTACHMENT13_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT13_EXT;
    public static property COLOR_ATTACHMENT13_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT13_NV;
    public static property COLOR_ATTACHMENT14:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT14;
    public static property COLOR_ATTACHMENT14_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT14_EXT;
    public static property COLOR_ATTACHMENT14_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT14_NV;
    public static property COLOR_ATTACHMENT15:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT15;
    public static property COLOR_ATTACHMENT15_EXT:   InvalidateFramebufferAttachment read _COLOR_ATTACHMENT15_EXT;
    public static property COLOR_ATTACHMENT15_NV:    InvalidateFramebufferAttachment read _COLOR_ATTACHMENT15_NV;
    public static property COLOR_ATTACHMENT16:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT16;
    public static property COLOR_ATTACHMENT17:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT17;
    public static property COLOR_ATTACHMENT18:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT18;
    public static property COLOR_ATTACHMENT19:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT19;
    public static property COLOR_ATTACHMENT20:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT20;
    public static property COLOR_ATTACHMENT21:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT21;
    public static property COLOR_ATTACHMENT22:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT22;
    public static property COLOR_ATTACHMENT23:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT23;
    public static property COLOR_ATTACHMENT24:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT24;
    public static property COLOR_ATTACHMENT25:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT25;
    public static property COLOR_ATTACHMENT26:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT26;
    public static property COLOR_ATTACHMENT27:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT27;
    public static property COLOR_ATTACHMENT28:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT28;
    public static property COLOR_ATTACHMENT29:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT29;
    public static property COLOR_ATTACHMENT30:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT30;
    public static property COLOR_ATTACHMENT31:       InvalidateFramebufferAttachment read _COLOR_ATTACHMENT31;
    public static property DEPTH_ATTACHMENT:         InvalidateFramebufferAttachment read _DEPTH_ATTACHMENT;
    public static property DEPTH_ATTACHMENT_EXT:     InvalidateFramebufferAttachment read _DEPTH_ATTACHMENT_EXT;
    public static property DEPTH_ATTACHMENT_OES:     InvalidateFramebufferAttachment read _DEPTH_ATTACHMENT_OES;
    public static property STENCIL_ATTACHMENT_EXT:   InvalidateFramebufferAttachment read _STENCIL_ATTACHMENT_EXT;
    public static property STENCIL_ATTACHMENT_OES:   InvalidateFramebufferAttachment read _STENCIL_ATTACHMENT_OES;
    
    public function ToString: string; override;
    begin
      var res := typeof(InvalidateFramebufferAttachment).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->InvalidateFramebufferAttachment(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'InvalidateFramebufferAttachment[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightModelParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LIGHT_MODEL_LOCAL_VIEWER      := new LightModelParameter($0B51);
    private static _LIGHT_MODEL_TWO_SIDE          := new LightModelParameter($0B52);
    private static _LIGHT_MODEL_AMBIENT           := new LightModelParameter($0B53);
    private static _LIGHT_MODEL_COLOR_CONTROL     := new LightModelParameter($81F8);
    private static _LIGHT_MODEL_COLOR_CONTROL_EXT := new LightModelParameter($81F8);
    
    public static property LIGHT_MODEL_LOCAL_VIEWER:      LightModelParameter read _LIGHT_MODEL_LOCAL_VIEWER;
    public static property LIGHT_MODEL_TWO_SIDE:          LightModelParameter read _LIGHT_MODEL_TWO_SIDE;
    public static property LIGHT_MODEL_AMBIENT:           LightModelParameter read _LIGHT_MODEL_AMBIENT;
    public static property LIGHT_MODEL_COLOR_CONTROL:     LightModelParameter read _LIGHT_MODEL_COLOR_CONTROL;
    public static property LIGHT_MODEL_COLOR_CONTROL_EXT: LightModelParameter read _LIGHT_MODEL_COLOR_CONTROL_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightModelParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightModelParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightModelParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LIGHT0               := new LightName($4000);
    private static _LIGHT1               := new LightName($4001);
    private static _LIGHT2               := new LightName($4002);
    private static _LIGHT3               := new LightName($4003);
    private static _LIGHT4               := new LightName($4004);
    private static _LIGHT5               := new LightName($4005);
    private static _LIGHT6               := new LightName($4006);
    private static _LIGHT7               := new LightName($4007);
    private static _FRAGMENT_LIGHT0_SGIX := new LightName($840C);
    private static _FRAGMENT_LIGHT1_SGIX := new LightName($840D);
    private static _FRAGMENT_LIGHT2_SGIX := new LightName($840E);
    private static _FRAGMENT_LIGHT3_SGIX := new LightName($840F);
    private static _FRAGMENT_LIGHT4_SGIX := new LightName($8410);
    private static _FRAGMENT_LIGHT5_SGIX := new LightName($8411);
    private static _FRAGMENT_LIGHT6_SGIX := new LightName($8412);
    private static _FRAGMENT_LIGHT7_SGIX := new LightName($8413);
    
    public static property LIGHT0:               LightName read _LIGHT0;
    public static property LIGHT1:               LightName read _LIGHT1;
    public static property LIGHT2:               LightName read _LIGHT2;
    public static property LIGHT3:               LightName read _LIGHT3;
    public static property LIGHT4:               LightName read _LIGHT4;
    public static property LIGHT5:               LightName read _LIGHT5;
    public static property LIGHT6:               LightName read _LIGHT6;
    public static property LIGHT7:               LightName read _LIGHT7;
    public static property FRAGMENT_LIGHT0_SGIX: LightName read _FRAGMENT_LIGHT0_SGIX;
    public static property FRAGMENT_LIGHT1_SGIX: LightName read _FRAGMENT_LIGHT1_SGIX;
    public static property FRAGMENT_LIGHT2_SGIX: LightName read _FRAGMENT_LIGHT2_SGIX;
    public static property FRAGMENT_LIGHT3_SGIX: LightName read _FRAGMENT_LIGHT3_SGIX;
    public static property FRAGMENT_LIGHT4_SGIX: LightName read _FRAGMENT_LIGHT4_SGIX;
    public static property FRAGMENT_LIGHT5_SGIX: LightName read _FRAGMENT_LIGHT5_SGIX;
    public static property FRAGMENT_LIGHT6_SGIX: LightName read _FRAGMENT_LIGHT6_SGIX;
    public static property FRAGMENT_LIGHT7_SGIX: LightName read _FRAGMENT_LIGHT7_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POSITION              := new LightParameter($1203);
    private static _SPOT_DIRECTION        := new LightParameter($1204);
    private static _SPOT_EXPONENT         := new LightParameter($1205);
    private static _SPOT_CUTOFF           := new LightParameter($1206);
    private static _CONSTANT_ATTENUATION  := new LightParameter($1207);
    private static _LINEAR_ATTENUATION    := new LightParameter($1208);
    private static _QUADRATIC_ATTENUATION := new LightParameter($1209);
    
    public static property POSITION:              LightParameter read _POSITION;
    public static property SPOT_DIRECTION:        LightParameter read _SPOT_DIRECTION;
    public static property SPOT_EXPONENT:         LightParameter read _SPOT_EXPONENT;
    public static property SPOT_CUTOFF:           LightParameter read _SPOT_CUTOFF;
    public static property CONSTANT_ATTENUATION:  LightParameter read _CONSTANT_ATTENUATION;
    public static property LINEAR_ATTENUATION:    LightParameter read _LINEAR_ATTENUATION;
    public static property QUADRATIC_ATTENUATION: LightParameter read _QUADRATIC_ATTENUATION;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ListMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COMPILE             := new ListMode($1300);
    private static _COMPILE_AND_EXECUTE := new ListMode($1301);
    
    public static property COMPILE:             ListMode read _COMPILE;
    public static property COMPILE_AND_EXECUTE: ListMode read _COMPILE_AND_EXECUTE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ListMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ListMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ListMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ListNameType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE           := new ListNameType($1400);
    private static _UNSIGNED_BYTE  := new ListNameType($1401);
    private static _SHORT          := new ListNameType($1402);
    private static _UNSIGNED_SHORT := new ListNameType($1403);
    private static _INT            := new ListNameType($1404);
    private static _UNSIGNED_INT   := new ListNameType($1405);
    private static _FLOAT          := new ListNameType($1406);
    private static _GL_2_BYTES     := new ListNameType($1407);
    private static _GL_3_BYTES     := new ListNameType($1408);
    private static _GL_4_BYTES     := new ListNameType($1409);
    
    public static property BYTE:           ListNameType read _BYTE;
    public static property UNSIGNED_BYTE:  ListNameType read _UNSIGNED_BYTE;
    public static property SHORT:          ListNameType read _SHORT;
    public static property UNSIGNED_SHORT: ListNameType read _UNSIGNED_SHORT;
    public static property INT:            ListNameType read _INT;
    public static property UNSIGNED_INT:   ListNameType read _UNSIGNED_INT;
    public static property FLOAT:          ListNameType read _FLOAT;
    public static property GL_2_BYTES:     ListNameType read _GL_2_BYTES;
    public static property GL_3_BYTES:     ListNameType read _GL_3_BYTES;
    public static property GL_4_BYTES:     ListNameType read _GL_4_BYTES;
    
    public function ToString: string; override;
    begin
      var res := typeof(ListNameType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ListNameType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ListNameType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ListParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LIST_PRIORITY_SGIX := new ListParameterName($8182);
    
    public static property LIST_PRIORITY_SGIX: ListParameterName read _LIST_PRIORITY_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(ListParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ListParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ListParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LogicOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CLEAR         := new LogicOp($1500);
    private static _AND           := new LogicOp($1501);
    private static _AND_REVERSE   := new LogicOp($1502);
    private static _COPY          := new LogicOp($1503);
    private static _AND_INVERTED  := new LogicOp($1504);
    private static _NOOP          := new LogicOp($1505);
    private static _XOR           := new LogicOp($1506);
    private static _OR            := new LogicOp($1507);
    private static _NOR           := new LogicOp($1508);
    private static _EQUIV         := new LogicOp($1509);
    private static _INVERT        := new LogicOp($150A);
    private static _OR_REVERSE    := new LogicOp($150B);
    private static _COPY_INVERTED := new LogicOp($150C);
    private static _OR_INVERTED   := new LogicOp($150D);
    private static _NAND          := new LogicOp($150E);
    private static _SET           := new LogicOp($150F);
    
    public static property CLEAR:         LogicOp read _CLEAR;
    public static property &AND:          LogicOp read _AND;
    public static property AND_REVERSE:   LogicOp read _AND_REVERSE;
    public static property COPY:          LogicOp read _COPY;
    public static property AND_INVERTED:  LogicOp read _AND_INVERTED;
    public static property NOOP:          LogicOp read _NOOP;
    public static property &XOR:          LogicOp read _XOR;
    public static property &OR:           LogicOp read _OR;
    public static property NOR:           LogicOp read _NOR;
    public static property EQUIV:         LogicOp read _EQUIV;
    public static property INVERT:        LogicOp read _INVERT;
    public static property OR_REVERSE:    LogicOp read _OR_REVERSE;
    public static property COPY_INVERTED: LogicOp read _COPY_INVERTED;
    public static property OR_INVERTED:   LogicOp read _OR_INVERTED;
    public static property NAND:          LogicOp read _NAND;
    public static property &SET:          LogicOp read _SET;
    
    public function ToString: string; override;
    begin
      var res := typeof(LogicOp).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LogicOp(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LogicOp[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MapBufferAccessMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP_READ_BIT                  := new MapBufferAccessMask($0001);
    private static _MAP_READ_BIT_EXT              := new MapBufferAccessMask($0001);
    private static _MAP_WRITE_BIT                 := new MapBufferAccessMask($0002);
    private static _MAP_WRITE_BIT_EXT             := new MapBufferAccessMask($0002);
    private static _MAP_INVALIDATE_RANGE_BIT      := new MapBufferAccessMask($0004);
    private static _MAP_INVALIDATE_RANGE_BIT_EXT  := new MapBufferAccessMask($0004);
    private static _MAP_INVALIDATE_BUFFER_BIT     := new MapBufferAccessMask($0008);
    private static _MAP_INVALIDATE_BUFFER_BIT_EXT := new MapBufferAccessMask($0008);
    private static _MAP_FLUSH_EXPLICIT_BIT        := new MapBufferAccessMask($0010);
    private static _MAP_FLUSH_EXPLICIT_BIT_EXT    := new MapBufferAccessMask($0010);
    private static _MAP_UNSYNCHRONIZED_BIT        := new MapBufferAccessMask($0020);
    private static _MAP_UNSYNCHRONIZED_BIT_EXT    := new MapBufferAccessMask($0020);
    private static _MAP_PERSISTENT_BIT            := new MapBufferAccessMask($0040);
    private static _MAP_PERSISTENT_BIT_EXT        := new MapBufferAccessMask($0040);
    private static _MAP_COHERENT_BIT              := new MapBufferAccessMask($0080);
    private static _MAP_COHERENT_BIT_EXT          := new MapBufferAccessMask($0080);
    
    public static property MAP_READ_BIT:                  MapBufferAccessMask read _MAP_READ_BIT;
    public static property MAP_READ_BIT_EXT:              MapBufferAccessMask read _MAP_READ_BIT_EXT;
    public static property MAP_WRITE_BIT:                 MapBufferAccessMask read _MAP_WRITE_BIT;
    public static property MAP_WRITE_BIT_EXT:             MapBufferAccessMask read _MAP_WRITE_BIT_EXT;
    public static property MAP_INVALIDATE_RANGE_BIT:      MapBufferAccessMask read _MAP_INVALIDATE_RANGE_BIT;
    public static property MAP_INVALIDATE_RANGE_BIT_EXT:  MapBufferAccessMask read _MAP_INVALIDATE_RANGE_BIT_EXT;
    public static property MAP_INVALIDATE_BUFFER_BIT:     MapBufferAccessMask read _MAP_INVALIDATE_BUFFER_BIT;
    public static property MAP_INVALIDATE_BUFFER_BIT_EXT: MapBufferAccessMask read _MAP_INVALIDATE_BUFFER_BIT_EXT;
    public static property MAP_FLUSH_EXPLICIT_BIT:        MapBufferAccessMask read _MAP_FLUSH_EXPLICIT_BIT;
    public static property MAP_FLUSH_EXPLICIT_BIT_EXT:    MapBufferAccessMask read _MAP_FLUSH_EXPLICIT_BIT_EXT;
    public static property MAP_UNSYNCHRONIZED_BIT:        MapBufferAccessMask read _MAP_UNSYNCHRONIZED_BIT;
    public static property MAP_UNSYNCHRONIZED_BIT_EXT:    MapBufferAccessMask read _MAP_UNSYNCHRONIZED_BIT_EXT;
    public static property MAP_PERSISTENT_BIT:            MapBufferAccessMask read _MAP_PERSISTENT_BIT;
    public static property MAP_PERSISTENT_BIT_EXT:        MapBufferAccessMask read _MAP_PERSISTENT_BIT_EXT;
    public static property MAP_COHERENT_BIT:              MapBufferAccessMask read _MAP_COHERENT_BIT;
    public static property MAP_COHERENT_BIT_EXT:          MapBufferAccessMask read _MAP_COHERENT_BIT_EXT;
    
    public static function operator or(f1,f2: MapBufferAccessMask) := new MapBufferAccessMask(f1.val or f2.val);
    
    public property HAS_FLAG_MAP_READ_BIT:                  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_READ_BIT_EXT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT:                 boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_WRITE_BIT_EXT:             boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_RANGE_BIT:      boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_RANGE_BIT_EXT:  boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_BUFFER_BIT:     boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_MAP_INVALIDATE_BUFFER_BIT_EXT: boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_MAP_FLUSH_EXPLICIT_BIT:        boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_MAP_FLUSH_EXPLICIT_BIT_EXT:    boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_MAP_UNSYNCHRONIZED_BIT:        boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MAP_UNSYNCHRONIZED_BIT_EXT:    boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT:            boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_PERSISTENT_BIT_EXT:        boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT:              boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_MAP_COHERENT_BIT_EXT:          boolean read self.val and $0080 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapBufferAccessMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'MapBufferAccessMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  MapQuery = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COEFF  := new MapQuery($0A00);
    private static _ORDER  := new MapQuery($0A01);
    private static _DOMAIN := new MapQuery($0A02);
    
    public static property COEFF:  MapQuery read _COEFF;
    public static property ORDER:  MapQuery read _ORDER;
    public static property DOMAIN: MapQuery read _DOMAIN;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapQuery).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MapQuery(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MapQuery[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MapTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP1_COLOR_4              := new MapTarget($0D90);
    private static _MAP1_INDEX                := new MapTarget($0D91);
    private static _MAP1_NORMAL               := new MapTarget($0D92);
    private static _MAP1_TEXTURE_COORD_1      := new MapTarget($0D93);
    private static _MAP1_TEXTURE_COORD_2      := new MapTarget($0D94);
    private static _MAP1_TEXTURE_COORD_3      := new MapTarget($0D95);
    private static _MAP1_TEXTURE_COORD_4      := new MapTarget($0D96);
    private static _MAP1_VERTEX_3             := new MapTarget($0D97);
    private static _MAP1_VERTEX_4             := new MapTarget($0D98);
    private static _MAP2_COLOR_4              := new MapTarget($0DB0);
    private static _MAP2_INDEX                := new MapTarget($0DB1);
    private static _MAP2_NORMAL               := new MapTarget($0DB2);
    private static _MAP2_TEXTURE_COORD_1      := new MapTarget($0DB3);
    private static _MAP2_TEXTURE_COORD_2      := new MapTarget($0DB4);
    private static _MAP2_TEXTURE_COORD_3      := new MapTarget($0DB5);
    private static _MAP2_TEXTURE_COORD_4      := new MapTarget($0DB6);
    private static _MAP2_VERTEX_3             := new MapTarget($0DB7);
    private static _MAP2_VERTEX_4             := new MapTarget($0DB8);
    private static _GEOMETRY_DEFORMATION_SGIX := new MapTarget($8194);
    private static _TEXTURE_DEFORMATION_SGIX  := new MapTarget($8195);
    
    public static property MAP1_COLOR_4:              MapTarget read _MAP1_COLOR_4;
    public static property MAP1_INDEX:                MapTarget read _MAP1_INDEX;
    public static property MAP1_NORMAL:               MapTarget read _MAP1_NORMAL;
    public static property MAP1_TEXTURE_COORD_1:      MapTarget read _MAP1_TEXTURE_COORD_1;
    public static property MAP1_TEXTURE_COORD_2:      MapTarget read _MAP1_TEXTURE_COORD_2;
    public static property MAP1_TEXTURE_COORD_3:      MapTarget read _MAP1_TEXTURE_COORD_3;
    public static property MAP1_TEXTURE_COORD_4:      MapTarget read _MAP1_TEXTURE_COORD_4;
    public static property MAP1_VERTEX_3:             MapTarget read _MAP1_VERTEX_3;
    public static property MAP1_VERTEX_4:             MapTarget read _MAP1_VERTEX_4;
    public static property MAP2_COLOR_4:              MapTarget read _MAP2_COLOR_4;
    public static property MAP2_INDEX:                MapTarget read _MAP2_INDEX;
    public static property MAP2_NORMAL:               MapTarget read _MAP2_NORMAL;
    public static property MAP2_TEXTURE_COORD_1:      MapTarget read _MAP2_TEXTURE_COORD_1;
    public static property MAP2_TEXTURE_COORD_2:      MapTarget read _MAP2_TEXTURE_COORD_2;
    public static property MAP2_TEXTURE_COORD_3:      MapTarget read _MAP2_TEXTURE_COORD_3;
    public static property MAP2_TEXTURE_COORD_4:      MapTarget read _MAP2_TEXTURE_COORD_4;
    public static property MAP2_VERTEX_3:             MapTarget read _MAP2_VERTEX_3;
    public static property MAP2_VERTEX_4:             MapTarget read _MAP2_VERTEX_4;
    public static property GEOMETRY_DEFORMATION_SGIX: MapTarget read _GEOMETRY_DEFORMATION_SGIX;
    public static property TEXTURE_DEFORMATION_SGIX:  MapTarget read _TEXTURE_DEFORMATION_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MapTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MapTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MaterialParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _AMBIENT             := new MaterialParameter($1200);
    private static _DIFFUSE             := new MaterialParameter($1201);
    private static _SPECULAR            := new MaterialParameter($1202);
    private static _EMISSION            := new MaterialParameter($1600);
    private static _SHININESS           := new MaterialParameter($1601);
    private static _AMBIENT_AND_DIFFUSE := new MaterialParameter($1602);
    private static _COLOR_INDEXES       := new MaterialParameter($1603);
    
    public static property AMBIENT:             MaterialParameter read _AMBIENT;
    public static property DIFFUSE:             MaterialParameter read _DIFFUSE;
    public static property SPECULAR:            MaterialParameter read _SPECULAR;
    public static property EMISSION:            MaterialParameter read _EMISSION;
    public static property SHININESS:           MaterialParameter read _SHININESS;
    public static property AMBIENT_AND_DIFFUSE: MaterialParameter read _AMBIENT_AND_DIFFUSE;
    public static property COLOR_INDEXES:       MaterialParameter read _COLOR_INDEXES;
    
    public function ToString: string; override;
    begin
      var res := typeof(MaterialParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MaterialParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MaterialParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MatrixMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MODELVIEW      := new MatrixMode($1700);
    private static _MODELVIEW0_EXT := new MatrixMode($1700);
    private static _PROJECTION     := new MatrixMode($1701);
    private static _TEXTURE        := new MatrixMode($1702);
    
    public static property MODELVIEW:      MatrixMode read _MODELVIEW;
    public static property MODELVIEW0_EXT: MatrixMode read _MODELVIEW0_EXT;
    public static property PROJECTION:     MatrixMode read _PROJECTION;
    public static property TEXTURE:        MatrixMode read _TEXTURE;
    
    public function ToString: string; override;
    begin
      var res := typeof(MatrixMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MatrixMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MatrixMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MemoryBarrierMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_ATTRIB_ARRAY_BARRIER_BIT      := new MemoryBarrierMask($0001);
    private static _VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT  := new MemoryBarrierMask($0001);
    private static _ELEMENT_ARRAY_BARRIER_BIT            := new MemoryBarrierMask($0002);
    private static _ELEMENT_ARRAY_BARRIER_BIT_EXT        := new MemoryBarrierMask($0002);
    private static _UNIFORM_BARRIER_BIT                  := new MemoryBarrierMask($0004);
    private static _UNIFORM_BARRIER_BIT_EXT              := new MemoryBarrierMask($0004);
    private static _TEXTURE_FETCH_BARRIER_BIT            := new MemoryBarrierMask($0008);
    private static _TEXTURE_FETCH_BARRIER_BIT_EXT        := new MemoryBarrierMask($0008);
    private static _SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV  := new MemoryBarrierMask($0010);
    private static _SHADER_IMAGE_ACCESS_BARRIER_BIT      := new MemoryBarrierMask($0020);
    private static _SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT  := new MemoryBarrierMask($0020);
    private static _COMMAND_BARRIER_BIT                  := new MemoryBarrierMask($0040);
    private static _COMMAND_BARRIER_BIT_EXT              := new MemoryBarrierMask($0040);
    private static _PIXEL_BUFFER_BARRIER_BIT             := new MemoryBarrierMask($0080);
    private static _PIXEL_BUFFER_BARRIER_BIT_EXT         := new MemoryBarrierMask($0080);
    private static _TEXTURE_UPDATE_BARRIER_BIT           := new MemoryBarrierMask($0100);
    private static _TEXTURE_UPDATE_BARRIER_BIT_EXT       := new MemoryBarrierMask($0100);
    private static _BUFFER_UPDATE_BARRIER_BIT            := new MemoryBarrierMask($0200);
    private static _BUFFER_UPDATE_BARRIER_BIT_EXT        := new MemoryBarrierMask($0200);
    private static _FRAMEBUFFER_BARRIER_BIT              := new MemoryBarrierMask($0400);
    private static _FRAMEBUFFER_BARRIER_BIT_EXT          := new MemoryBarrierMask($0400);
    private static _TRANSFORM_FEEDBACK_BARRIER_BIT       := new MemoryBarrierMask($0800);
    private static _TRANSFORM_FEEDBACK_BARRIER_BIT_EXT   := new MemoryBarrierMask($0800);
    private static _ATOMIC_COUNTER_BARRIER_BIT           := new MemoryBarrierMask($1000);
    private static _ATOMIC_COUNTER_BARRIER_BIT_EXT       := new MemoryBarrierMask($1000);
    private static _SHADER_STORAGE_BARRIER_BIT           := new MemoryBarrierMask($2000);
    private static _CLIENT_MAPPED_BUFFER_BARRIER_BIT     := new MemoryBarrierMask($4000);
    private static _CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT := new MemoryBarrierMask($4000);
    private static _QUERY_BUFFER_BARRIER_BIT             := new MemoryBarrierMask($8000);
    private static _ALL_BARRIER_BITS                     := new MemoryBarrierMask($FFFFFFFF);
    private static _ALL_BARRIER_BITS_EXT                 := new MemoryBarrierMask($FFFFFFFF);
    
    public static property VERTEX_ATTRIB_ARRAY_BARRIER_BIT:      MemoryBarrierMask read _VERTEX_ATTRIB_ARRAY_BARRIER_BIT;
    public static property VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT:  MemoryBarrierMask read _VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT;
    public static property ELEMENT_ARRAY_BARRIER_BIT:            MemoryBarrierMask read _ELEMENT_ARRAY_BARRIER_BIT;
    public static property ELEMENT_ARRAY_BARRIER_BIT_EXT:        MemoryBarrierMask read _ELEMENT_ARRAY_BARRIER_BIT_EXT;
    public static property UNIFORM_BARRIER_BIT:                  MemoryBarrierMask read _UNIFORM_BARRIER_BIT;
    public static property UNIFORM_BARRIER_BIT_EXT:              MemoryBarrierMask read _UNIFORM_BARRIER_BIT_EXT;
    public static property TEXTURE_FETCH_BARRIER_BIT:            MemoryBarrierMask read _TEXTURE_FETCH_BARRIER_BIT;
    public static property TEXTURE_FETCH_BARRIER_BIT_EXT:        MemoryBarrierMask read _TEXTURE_FETCH_BARRIER_BIT_EXT;
    public static property SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV:  MemoryBarrierMask read _SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV;
    public static property SHADER_IMAGE_ACCESS_BARRIER_BIT:      MemoryBarrierMask read _SHADER_IMAGE_ACCESS_BARRIER_BIT;
    public static property SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT:  MemoryBarrierMask read _SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT;
    public static property COMMAND_BARRIER_BIT:                  MemoryBarrierMask read _COMMAND_BARRIER_BIT;
    public static property COMMAND_BARRIER_BIT_EXT:              MemoryBarrierMask read _COMMAND_BARRIER_BIT_EXT;
    public static property PIXEL_BUFFER_BARRIER_BIT:             MemoryBarrierMask read _PIXEL_BUFFER_BARRIER_BIT;
    public static property PIXEL_BUFFER_BARRIER_BIT_EXT:         MemoryBarrierMask read _PIXEL_BUFFER_BARRIER_BIT_EXT;
    public static property TEXTURE_UPDATE_BARRIER_BIT:           MemoryBarrierMask read _TEXTURE_UPDATE_BARRIER_BIT;
    public static property TEXTURE_UPDATE_BARRIER_BIT_EXT:       MemoryBarrierMask read _TEXTURE_UPDATE_BARRIER_BIT_EXT;
    public static property BUFFER_UPDATE_BARRIER_BIT:            MemoryBarrierMask read _BUFFER_UPDATE_BARRIER_BIT;
    public static property BUFFER_UPDATE_BARRIER_BIT_EXT:        MemoryBarrierMask read _BUFFER_UPDATE_BARRIER_BIT_EXT;
    public static property FRAMEBUFFER_BARRIER_BIT:              MemoryBarrierMask read _FRAMEBUFFER_BARRIER_BIT;
    public static property FRAMEBUFFER_BARRIER_BIT_EXT:          MemoryBarrierMask read _FRAMEBUFFER_BARRIER_BIT_EXT;
    public static property TRANSFORM_FEEDBACK_BARRIER_BIT:       MemoryBarrierMask read _TRANSFORM_FEEDBACK_BARRIER_BIT;
    public static property TRANSFORM_FEEDBACK_BARRIER_BIT_EXT:   MemoryBarrierMask read _TRANSFORM_FEEDBACK_BARRIER_BIT_EXT;
    public static property ATOMIC_COUNTER_BARRIER_BIT:           MemoryBarrierMask read _ATOMIC_COUNTER_BARRIER_BIT;
    public static property ATOMIC_COUNTER_BARRIER_BIT_EXT:       MemoryBarrierMask read _ATOMIC_COUNTER_BARRIER_BIT_EXT;
    public static property SHADER_STORAGE_BARRIER_BIT:           MemoryBarrierMask read _SHADER_STORAGE_BARRIER_BIT;
    public static property CLIENT_MAPPED_BUFFER_BARRIER_BIT:     MemoryBarrierMask read _CLIENT_MAPPED_BUFFER_BARRIER_BIT;
    public static property CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT: MemoryBarrierMask read _CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT;
    public static property QUERY_BUFFER_BARRIER_BIT:             MemoryBarrierMask read _QUERY_BUFFER_BARRIER_BIT;
    public static property ALL_BARRIER_BITS:                     MemoryBarrierMask read _ALL_BARRIER_BITS;
    public static property ALL_BARRIER_BITS_EXT:                 MemoryBarrierMask read _ALL_BARRIER_BITS_EXT;
    
    public static function operator or(f1,f2: MemoryBarrierMask) := new MemoryBarrierMask(f1.val or f2.val);
    
    public property HAS_FLAG_VERTEX_ATTRIB_ARRAY_BARRIER_BIT:      boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_VERTEX_ATTRIB_ARRAY_BARRIER_BIT_EXT:  boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_ELEMENT_ARRAY_BARRIER_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_ELEMENT_ARRAY_BARRIER_BIT_EXT:        boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_UNIFORM_BARRIER_BIT:                  boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_UNIFORM_BARRIER_BIT_EXT:              boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_TEXTURE_FETCH_BARRIER_BIT:            boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TEXTURE_FETCH_BARRIER_BIT_EXT:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_SHADER_GLOBAL_ACCESS_BARRIER_BIT_NV:  boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_SHADER_IMAGE_ACCESS_BARRIER_BIT:      boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_SHADER_IMAGE_ACCESS_BARRIER_BIT_EXT:  boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_COMMAND_BARRIER_BIT:                  boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_COMMAND_BARRIER_BIT_EXT:              boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_PIXEL_BUFFER_BARRIER_BIT:             boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_PIXEL_BUFFER_BARRIER_BIT_EXT:         boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_TEXTURE_UPDATE_BARRIER_BIT:           boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_TEXTURE_UPDATE_BARRIER_BIT_EXT:       boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_BUFFER_UPDATE_BARRIER_BIT:            boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_BUFFER_UPDATE_BARRIER_BIT_EXT:        boolean read self.val and $0200 <> 0;
    public property HAS_FLAG_FRAMEBUFFER_BARRIER_BIT:              boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_FRAMEBUFFER_BARRIER_BIT_EXT:          boolean read self.val and $0400 <> 0;
    public property HAS_FLAG_TRANSFORM_FEEDBACK_BARRIER_BIT:       boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_TRANSFORM_FEEDBACK_BARRIER_BIT_EXT:   boolean read self.val and $0800 <> 0;
    public property HAS_FLAG_ATOMIC_COUNTER_BARRIER_BIT:           boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_ATOMIC_COUNTER_BARRIER_BIT_EXT:       boolean read self.val and $1000 <> 0;
    public property HAS_FLAG_SHADER_STORAGE_BARRIER_BIT:           boolean read self.val and $2000 <> 0;
    public property HAS_FLAG_CLIENT_MAPPED_BUFFER_BARRIER_BIT:     boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_CLIENT_MAPPED_BUFFER_BARRIER_BIT_EXT: boolean read self.val and $4000 <> 0;
    public property HAS_FLAG_QUERY_BUFFER_BARRIER_BIT:             boolean read self.val and $8000 <> 0;
    public property HAS_FLAG_ALL_BARRIER_BITS:                     boolean read self.val and $FFFFFFFF <> 0;
    public property HAS_FLAG_ALL_BARRIER_BITS_EXT:                 boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(MemoryBarrierMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'MemoryBarrierMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  MemoryObjectParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DEDICATED_MEMORY_OBJECT_EXT := new MemoryObjectParameterName($9581);
    private static _PROTECTED_MEMORY_OBJECT_EXT := new MemoryObjectParameterName($959B);
    
    public static property DEDICATED_MEMORY_OBJECT_EXT: MemoryObjectParameterName read _DEDICATED_MEMORY_OBJECT_EXT;
    public static property PROTECTED_MEMORY_OBJECT_EXT: MemoryObjectParameterName read _PROTECTED_MEMORY_OBJECT_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(MemoryObjectParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MemoryObjectParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MemoryObjectParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MeshMode1 = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINT := new MeshMode1($1B00);
    private static _LINE  := new MeshMode1($1B01);
    
    public static property POINT: MeshMode1 read _POINT;
    public static property LINE:  MeshMode1 read _LINE;
    
    public function ToString: string; override;
    begin
      var res := typeof(MeshMode1).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MeshMode1(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MeshMode1[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MeshMode2 = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINT := new MeshMode2($1B00);
    private static _LINE  := new MeshMode2($1B01);
    private static _FILL  := new MeshMode2($1B02);
    
    public static property POINT: MeshMode2 read _POINT;
    public static property LINE:  MeshMode2 read _LINE;
    public static property FILL:  MeshMode2 read _FILL;
    
    public function ToString: string; override;
    begin
      var res := typeof(MeshMode2).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MeshMode2(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MeshMode2[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  NormalPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE   := new NormalPointerType($1400);
    private static _SHORT  := new NormalPointerType($1402);
    private static _INT    := new NormalPointerType($1404);
    private static _FLOAT  := new NormalPointerType($1406);
    private static _DOUBLE := new NormalPointerType($140A);
    
    public static property BYTE:   NormalPointerType read _BYTE;
    public static property SHORT:  NormalPointerType read _SHORT;
    public static property INT:    NormalPointerType read _INT;
    public static property FLOAT:  NormalPointerType read _FLOAT;
    public static property DOUBLE: NormalPointerType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(NormalPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->NormalPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'NormalPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ObjectIdentifier = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE            := new ObjectIdentifier($1702);
    private static _VERTEX_ARRAY       := new ObjectIdentifier($8074);
    private static _BUFFER             := new ObjectIdentifier($82E0);
    private static _SHADER             := new ObjectIdentifier($82E1);
    private static _PROGRAM            := new ObjectIdentifier($82E2);
    private static _QUERY              := new ObjectIdentifier($82E3);
    private static _PROGRAM_PIPELINE   := new ObjectIdentifier($82E4);
    private static _SAMPLER            := new ObjectIdentifier($82E6);
    private static _FRAMEBUFFER        := new ObjectIdentifier($8D40);
    private static _RENDERBUFFER       := new ObjectIdentifier($8D41);
    private static _TRANSFORM_FEEDBACK := new ObjectIdentifier($8E22);
    
    public static property TEXTURE:            ObjectIdentifier read _TEXTURE;
    public static property VERTEX_ARRAY:       ObjectIdentifier read _VERTEX_ARRAY;
    public static property BUFFER:             ObjectIdentifier read _BUFFER;
    public static property SHADER:             ObjectIdentifier read _SHADER;
    public static property &PROGRAM:           ObjectIdentifier read _PROGRAM;
    public static property QUERY:              ObjectIdentifier read _QUERY;
    public static property PROGRAM_PIPELINE:   ObjectIdentifier read _PROGRAM_PIPELINE;
    public static property SAMPLER:            ObjectIdentifier read _SAMPLER;
    public static property FRAMEBUFFER:        ObjectIdentifier read _FRAMEBUFFER;
    public static property RENDERBUFFER:       ObjectIdentifier read _RENDERBUFFER;
    public static property TRANSFORM_FEEDBACK: ObjectIdentifier read _TRANSFORM_FEEDBACK;
    
    public function ToString: string; override;
    begin
      var res := typeof(ObjectIdentifier).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ObjectIdentifier(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ObjectIdentifier[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PatchParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PATCH_VERTICES            := new PatchParameterName($8E72);
    private static _PATCH_DEFAULT_INNER_LEVEL := new PatchParameterName($8E73);
    private static _PATCH_DEFAULT_OUTER_LEVEL := new PatchParameterName($8E74);
    
    public static property PATCH_VERTICES:            PatchParameterName read _PATCH_VERTICES;
    public static property PATCH_DEFAULT_INNER_LEVEL: PatchParameterName read _PATCH_DEFAULT_INNER_LEVEL;
    public static property PATCH_DEFAULT_OUTER_LEVEL: PatchParameterName read _PATCH_DEFAULT_OUTER_LEVEL;
    
    public function ToString: string; override;
    begin
      var res := typeof(PatchParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PatchParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PatchParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathColor = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PRIMARY_COLOR_NV   := new PathColor($852C);
    private static _SECONDARY_COLOR_NV := new PathColor($852D);
    private static _PRIMARY_COLOR      := new PathColor($8577);
    
    public static property PRIMARY_COLOR_NV:   PathColor read _PRIMARY_COLOR_NV;
    public static property SECONDARY_COLOR_NV: PathColor read _SECONDARY_COLOR_NV;
    public static property PRIMARY_COLOR:      PathColor read _PRIMARY_COLOR;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathColor).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathColor(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathColor[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathColorFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE            := new PathColorFormat($0000);
    private static _ALPHA           := new PathColorFormat($1906);
    private static _RGB             := new PathColorFormat($1907);
    private static _RGBA            := new PathColorFormat($1908);
    private static _LUMINANCE       := new PathColorFormat($1909);
    private static _LUMINANCE_ALPHA := new PathColorFormat($190A);
    private static _INTENSITY       := new PathColorFormat($8049);
    
    public static property NONE:            PathColorFormat read _NONE;
    public static property ALPHA:           PathColorFormat read _ALPHA;
    public static property RGB:             PathColorFormat read _RGB;
    public static property RGBA:            PathColorFormat read _RGBA;
    public static property LUMINANCE:       PathColorFormat read _LUMINANCE;
    public static property LUMINANCE_ALPHA: PathColorFormat read _LUMINANCE_ALPHA;
    public static property INTENSITY:       PathColorFormat read _INTENSITY;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathColorFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathColorFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathColorFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathCoordType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CLOSE_PATH_NV                         := new PathCoordType($0000);
    private static _MOVE_TO_NV                            := new PathCoordType($0002);
    private static _RELATIVE_MOVE_TO_NV                   := new PathCoordType($0003);
    private static _LINE_TO_NV                            := new PathCoordType($0004);
    private static _RELATIVE_LINE_TO_NV                   := new PathCoordType($0005);
    private static _HORIZONTAL_LINE_TO_NV                 := new PathCoordType($0006);
    private static _RELATIVE_HORIZONTAL_LINE_TO_NV        := new PathCoordType($0007);
    private static _VERTICAL_LINE_TO_NV                   := new PathCoordType($0008);
    private static _RELATIVE_VERTICAL_LINE_TO_NV          := new PathCoordType($0009);
    private static _QUADRATIC_CURVE_TO_NV                 := new PathCoordType($000A);
    private static _RELATIVE_QUADRATIC_CURVE_TO_NV        := new PathCoordType($000B);
    private static _CUBIC_CURVE_TO_NV                     := new PathCoordType($000C);
    private static _RELATIVE_CUBIC_CURVE_TO_NV            := new PathCoordType($000D);
    private static _SMOOTH_QUADRATIC_CURVE_TO_NV          := new PathCoordType($000E);
    private static _RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV := new PathCoordType($000F);
    private static _SMOOTH_CUBIC_CURVE_TO_NV              := new PathCoordType($0010);
    private static _RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV     := new PathCoordType($0011);
    private static _SMALL_CCW_ARC_TO_NV                   := new PathCoordType($0012);
    private static _RELATIVE_SMALL_CCW_ARC_TO_NV          := new PathCoordType($0013);
    private static _SMALL_CW_ARC_TO_NV                    := new PathCoordType($0014);
    private static _RELATIVE_SMALL_CW_ARC_TO_NV           := new PathCoordType($0015);
    private static _LARGE_CCW_ARC_TO_NV                   := new PathCoordType($0016);
    private static _RELATIVE_LARGE_CCW_ARC_TO_NV          := new PathCoordType($0017);
    private static _LARGE_CW_ARC_TO_NV                    := new PathCoordType($0018);
    private static _RELATIVE_LARGE_CW_ARC_TO_NV           := new PathCoordType($0019);
    private static _CONIC_CURVE_TO_NV                     := new PathCoordType($001A);
    private static _RELATIVE_CONIC_CURVE_TO_NV            := new PathCoordType($001B);
    private static _ROUNDED_RECT_NV                       := new PathCoordType($00E8);
    private static _RELATIVE_ROUNDED_RECT_NV              := new PathCoordType($00E9);
    private static _ROUNDED_RECT2_NV                      := new PathCoordType($00EA);
    private static _RELATIVE_ROUNDED_RECT2_NV             := new PathCoordType($00EB);
    private static _ROUNDED_RECT4_NV                      := new PathCoordType($00EC);
    private static _RELATIVE_ROUNDED_RECT4_NV             := new PathCoordType($00ED);
    private static _ROUNDED_RECT8_NV                      := new PathCoordType($00EE);
    private static _RELATIVE_ROUNDED_RECT8_NV             := new PathCoordType($00EF);
    private static _RESTART_PATH_NV                       := new PathCoordType($00F0);
    private static _DUP_FIRST_CUBIC_CURVE_TO_NV           := new PathCoordType($00F2);
    private static _DUP_LAST_CUBIC_CURVE_TO_NV            := new PathCoordType($00F4);
    private static _RECT_NV                               := new PathCoordType($00F6);
    private static _RELATIVE_RECT_NV                      := new PathCoordType($00F7);
    private static _CIRCULAR_CCW_ARC_TO_NV                := new PathCoordType($00F8);
    private static _CIRCULAR_CW_ARC_TO_NV                 := new PathCoordType($00FA);
    private static _CIRCULAR_TANGENT_ARC_TO_NV            := new PathCoordType($00FC);
    private static _ARC_TO_NV                             := new PathCoordType($00FE);
    private static _RELATIVE_ARC_TO_NV                    := new PathCoordType($00FF);
    
    public static property CLOSE_PATH_NV:                         PathCoordType read _CLOSE_PATH_NV;
    public static property MOVE_TO_NV:                            PathCoordType read _MOVE_TO_NV;
    public static property RELATIVE_MOVE_TO_NV:                   PathCoordType read _RELATIVE_MOVE_TO_NV;
    public static property LINE_TO_NV:                            PathCoordType read _LINE_TO_NV;
    public static property RELATIVE_LINE_TO_NV:                   PathCoordType read _RELATIVE_LINE_TO_NV;
    public static property HORIZONTAL_LINE_TO_NV:                 PathCoordType read _HORIZONTAL_LINE_TO_NV;
    public static property RELATIVE_HORIZONTAL_LINE_TO_NV:        PathCoordType read _RELATIVE_HORIZONTAL_LINE_TO_NV;
    public static property VERTICAL_LINE_TO_NV:                   PathCoordType read _VERTICAL_LINE_TO_NV;
    public static property RELATIVE_VERTICAL_LINE_TO_NV:          PathCoordType read _RELATIVE_VERTICAL_LINE_TO_NV;
    public static property QUADRATIC_CURVE_TO_NV:                 PathCoordType read _QUADRATIC_CURVE_TO_NV;
    public static property RELATIVE_QUADRATIC_CURVE_TO_NV:        PathCoordType read _RELATIVE_QUADRATIC_CURVE_TO_NV;
    public static property CUBIC_CURVE_TO_NV:                     PathCoordType read _CUBIC_CURVE_TO_NV;
    public static property RELATIVE_CUBIC_CURVE_TO_NV:            PathCoordType read _RELATIVE_CUBIC_CURVE_TO_NV;
    public static property SMOOTH_QUADRATIC_CURVE_TO_NV:          PathCoordType read _SMOOTH_QUADRATIC_CURVE_TO_NV;
    public static property RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV: PathCoordType read _RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV;
    public static property SMOOTH_CUBIC_CURVE_TO_NV:              PathCoordType read _SMOOTH_CUBIC_CURVE_TO_NV;
    public static property RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV:     PathCoordType read _RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV;
    public static property SMALL_CCW_ARC_TO_NV:                   PathCoordType read _SMALL_CCW_ARC_TO_NV;
    public static property RELATIVE_SMALL_CCW_ARC_TO_NV:          PathCoordType read _RELATIVE_SMALL_CCW_ARC_TO_NV;
    public static property SMALL_CW_ARC_TO_NV:                    PathCoordType read _SMALL_CW_ARC_TO_NV;
    public static property RELATIVE_SMALL_CW_ARC_TO_NV:           PathCoordType read _RELATIVE_SMALL_CW_ARC_TO_NV;
    public static property LARGE_CCW_ARC_TO_NV:                   PathCoordType read _LARGE_CCW_ARC_TO_NV;
    public static property RELATIVE_LARGE_CCW_ARC_TO_NV:          PathCoordType read _RELATIVE_LARGE_CCW_ARC_TO_NV;
    public static property LARGE_CW_ARC_TO_NV:                    PathCoordType read _LARGE_CW_ARC_TO_NV;
    public static property RELATIVE_LARGE_CW_ARC_TO_NV:           PathCoordType read _RELATIVE_LARGE_CW_ARC_TO_NV;
    public static property CONIC_CURVE_TO_NV:                     PathCoordType read _CONIC_CURVE_TO_NV;
    public static property RELATIVE_CONIC_CURVE_TO_NV:            PathCoordType read _RELATIVE_CONIC_CURVE_TO_NV;
    public static property ROUNDED_RECT_NV:                       PathCoordType read _ROUNDED_RECT_NV;
    public static property RELATIVE_ROUNDED_RECT_NV:              PathCoordType read _RELATIVE_ROUNDED_RECT_NV;
    public static property ROUNDED_RECT2_NV:                      PathCoordType read _ROUNDED_RECT2_NV;
    public static property RELATIVE_ROUNDED_RECT2_NV:             PathCoordType read _RELATIVE_ROUNDED_RECT2_NV;
    public static property ROUNDED_RECT4_NV:                      PathCoordType read _ROUNDED_RECT4_NV;
    public static property RELATIVE_ROUNDED_RECT4_NV:             PathCoordType read _RELATIVE_ROUNDED_RECT4_NV;
    public static property ROUNDED_RECT8_NV:                      PathCoordType read _ROUNDED_RECT8_NV;
    public static property RELATIVE_ROUNDED_RECT8_NV:             PathCoordType read _RELATIVE_ROUNDED_RECT8_NV;
    public static property RESTART_PATH_NV:                       PathCoordType read _RESTART_PATH_NV;
    public static property DUP_FIRST_CUBIC_CURVE_TO_NV:           PathCoordType read _DUP_FIRST_CUBIC_CURVE_TO_NV;
    public static property DUP_LAST_CUBIC_CURVE_TO_NV:            PathCoordType read _DUP_LAST_CUBIC_CURVE_TO_NV;
    public static property RECT_NV:                               PathCoordType read _RECT_NV;
    public static property RELATIVE_RECT_NV:                      PathCoordType read _RELATIVE_RECT_NV;
    public static property CIRCULAR_CCW_ARC_TO_NV:                PathCoordType read _CIRCULAR_CCW_ARC_TO_NV;
    public static property CIRCULAR_CW_ARC_TO_NV:                 PathCoordType read _CIRCULAR_CW_ARC_TO_NV;
    public static property CIRCULAR_TANGENT_ARC_TO_NV:            PathCoordType read _CIRCULAR_TANGENT_ARC_TO_NV;
    public static property ARC_TO_NV:                             PathCoordType read _ARC_TO_NV;
    public static property RELATIVE_ARC_TO_NV:                    PathCoordType read _RELATIVE_ARC_TO_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathCoordType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathCoordType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathCoordType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathCoverMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PATH_FILL_COVER_MODE_NV           := new PathCoverMode($9082);
    private static _CONVEX_HULL_NV                    := new PathCoverMode($908B);
    private static _BOUNDING_BOX_NV                   := new PathCoverMode($908D);
    private static _BOUNDING_BOX_OF_BOUNDING_BOXES_NV := new PathCoverMode($909C);
    
    public static property PATH_FILL_COVER_MODE_NV:           PathCoverMode read _PATH_FILL_COVER_MODE_NV;
    public static property CONVEX_HULL_NV:                    PathCoverMode read _CONVEX_HULL_NV;
    public static property BOUNDING_BOX_NV:                   PathCoverMode read _BOUNDING_BOX_NV;
    public static property BOUNDING_BOX_OF_BOUNDING_BOXES_NV: PathCoverMode read _BOUNDING_BOX_OF_BOUNDING_BOXES_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathCoverMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathCoverMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathCoverMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathElementType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UTF8_NV  := new PathElementType($909A);
    private static _UTF16_NV := new PathElementType($909B);
    
    public static property UTF8_NV:  PathElementType read _UTF8_NV;
    public static property UTF16_NV: PathElementType read _UTF16_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathElementType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathElementType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathElementType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathFillMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INVERT            := new PathFillMode($150A);
    private static _PATH_FILL_MODE_NV := new PathFillMode($9080);
    private static _COUNT_UP_NV       := new PathFillMode($9088);
    private static _COUNT_DOWN_NV     := new PathFillMode($9089);
    
    public static property INVERT:            PathFillMode read _INVERT;
    public static property PATH_FILL_MODE_NV: PathFillMode read _PATH_FILL_MODE_NV;
    public static property COUNT_UP_NV:       PathFillMode read _COUNT_UP_NV;
    public static property COUNT_DOWN_NV:     PathFillMode read _COUNT_DOWN_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathFillMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathFillMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathFillMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathFontStyle = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE          := new PathFontStyle($0000);
    private static _BOLD_BIT_NV   := new PathFontStyle($0001);
    private static _ITALIC_BIT_NV := new PathFontStyle($0002);
    
    public static property NONE:          PathFontStyle read _NONE;
    public static property BOLD_BIT_NV:   PathFontStyle read _BOLD_BIT_NV;
    public static property ITALIC_BIT_NV: PathFontStyle read _ITALIC_BIT_NV;
    
    public static function operator or(f1,f2: PathFontStyle) := new PathFontStyle(f1.val or f2.val);
    
    public property ANY_FLAGS: boolean read self.val<>0;
    public property HAS_FLAG_BOLD_BIT_NV:   boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_ITALIC_BIT_NV: boolean read self.val and $0002 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathFontStyle).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'PathFontStyle[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  PathFontTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STANDARD_FONT_NAME_NV := new PathFontTarget($9072);
    private static _SYSTEM_FONT_NAME_NV   := new PathFontTarget($9073);
    private static _FILE_NAME_NV          := new PathFontTarget($9074);
    
    public static property STANDARD_FONT_NAME_NV: PathFontTarget read _STANDARD_FONT_NAME_NV;
    public static property SYSTEM_FONT_NAME_NV:   PathFontTarget read _SYSTEM_FONT_NAME_NV;
    public static property FILE_NAME_NV:          PathFontTarget read _FILE_NAME_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathFontTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathFontTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathFontTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathGenMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE                        := new PathGenMode($0000);
    private static _EYE_LINEAR                  := new PathGenMode($2400);
    private static _OBJECT_LINEAR               := new PathGenMode($2401);
    private static _CONSTANT                    := new PathGenMode($8576);
    private static _PATH_OBJECT_BOUNDING_BOX_NV := new PathGenMode($908A);
    
    public static property NONE:                        PathGenMode read _NONE;
    public static property EYE_LINEAR:                  PathGenMode read _EYE_LINEAR;
    public static property OBJECT_LINEAR:               PathGenMode read _OBJECT_LINEAR;
    public static property CONSTANT:                    PathGenMode read _CONSTANT;
    public static property PATH_OBJECT_BOUNDING_BOX_NV: PathGenMode read _PATH_OBJECT_BOUNDING_BOX_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathGenMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathGenMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathGenMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathHandleMissingGlyphs = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SKIP_MISSING_GLYPH_NV := new PathHandleMissingGlyphs($90A9);
    private static _USE_MISSING_GLYPH_NV  := new PathHandleMissingGlyphs($90AA);
    
    public static property SKIP_MISSING_GLYPH_NV: PathHandleMissingGlyphs read _SKIP_MISSING_GLYPH_NV;
    public static property USE_MISSING_GLYPH_NV:  PathHandleMissingGlyphs read _USE_MISSING_GLYPH_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathHandleMissingGlyphs).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathHandleMissingGlyphs(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathHandleMissingGlyphs[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathListMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ACCUM_ADJACENT_PAIRS_NV := new PathListMode($90AD);
    private static _ADJACENT_PAIRS_NV       := new PathListMode($90AE);
    private static _FIRST_TO_REST_NV        := new PathListMode($90AF);
    
    public static property ACCUM_ADJACENT_PAIRS_NV: PathListMode read _ACCUM_ADJACENT_PAIRS_NV;
    public static property ADJACENT_PAIRS_NV:       PathListMode read _ADJACENT_PAIRS_NV;
    public static property FIRST_TO_REST_NV:        PathListMode read _FIRST_TO_REST_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathListMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathListMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathListMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathMetricMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _GLYPH_WIDTH_BIT_NV                      := new PathMetricMask($0001);
    private static _GLYPH_HEIGHT_BIT_NV                     := new PathMetricMask($0002);
    private static _GLYPH_HORIZONTAL_BEARING_X_BIT_NV       := new PathMetricMask($0004);
    private static _GLYPH_HORIZONTAL_BEARING_Y_BIT_NV       := new PathMetricMask($0008);
    private static _GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV := new PathMetricMask($0010);
    private static _GLYPH_VERTICAL_BEARING_X_BIT_NV         := new PathMetricMask($0020);
    private static _GLYPH_VERTICAL_BEARING_Y_BIT_NV         := new PathMetricMask($0040);
    private static _GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV   := new PathMetricMask($0080);
    private static _GLYPH_HAS_KERNING_BIT_NV                := new PathMetricMask($0100);
    private static _FONT_X_MIN_BOUNDS_BIT_NV                := new PathMetricMask($10000);
    private static _FONT_Y_MIN_BOUNDS_BIT_NV                := new PathMetricMask($20000);
    private static _FONT_X_MAX_BOUNDS_BIT_NV                := new PathMetricMask($40000);
    private static _FONT_Y_MAX_BOUNDS_BIT_NV                := new PathMetricMask($80000);
    private static _FONT_UNITS_PER_EM_BIT_NV                := new PathMetricMask($100000);
    private static _FONT_ASCENDER_BIT_NV                    := new PathMetricMask($200000);
    private static _FONT_DESCENDER_BIT_NV                   := new PathMetricMask($400000);
    private static _FONT_HEIGHT_BIT_NV                      := new PathMetricMask($800000);
    private static _FONT_MAX_ADVANCE_WIDTH_BIT_NV           := new PathMetricMask($1000000);
    private static _FONT_MAX_ADVANCE_HEIGHT_BIT_NV          := new PathMetricMask($2000000);
    private static _FONT_UNDERLINE_POSITION_BIT_NV          := new PathMetricMask($4000000);
    private static _FONT_UNDERLINE_THICKNESS_BIT_NV         := new PathMetricMask($8000000);
    private static _FONT_HAS_KERNING_BIT_NV                 := new PathMetricMask($10000000);
    private static _FONT_NUM_GLYPH_INDICES_BIT_NV           := new PathMetricMask($20000000);
    
    public static property GLYPH_WIDTH_BIT_NV:                      PathMetricMask read _GLYPH_WIDTH_BIT_NV;
    public static property GLYPH_HEIGHT_BIT_NV:                     PathMetricMask read _GLYPH_HEIGHT_BIT_NV;
    public static property GLYPH_HORIZONTAL_BEARING_X_BIT_NV:       PathMetricMask read _GLYPH_HORIZONTAL_BEARING_X_BIT_NV;
    public static property GLYPH_HORIZONTAL_BEARING_Y_BIT_NV:       PathMetricMask read _GLYPH_HORIZONTAL_BEARING_Y_BIT_NV;
    public static property GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV: PathMetricMask read _GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV;
    public static property GLYPH_VERTICAL_BEARING_X_BIT_NV:         PathMetricMask read _GLYPH_VERTICAL_BEARING_X_BIT_NV;
    public static property GLYPH_VERTICAL_BEARING_Y_BIT_NV:         PathMetricMask read _GLYPH_VERTICAL_BEARING_Y_BIT_NV;
    public static property GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV:   PathMetricMask read _GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV;
    public static property GLYPH_HAS_KERNING_BIT_NV:                PathMetricMask read _GLYPH_HAS_KERNING_BIT_NV;
    public static property FONT_X_MIN_BOUNDS_BIT_NV:                PathMetricMask read _FONT_X_MIN_BOUNDS_BIT_NV;
    public static property FONT_Y_MIN_BOUNDS_BIT_NV:                PathMetricMask read _FONT_Y_MIN_BOUNDS_BIT_NV;
    public static property FONT_X_MAX_BOUNDS_BIT_NV:                PathMetricMask read _FONT_X_MAX_BOUNDS_BIT_NV;
    public static property FONT_Y_MAX_BOUNDS_BIT_NV:                PathMetricMask read _FONT_Y_MAX_BOUNDS_BIT_NV;
    public static property FONT_UNITS_PER_EM_BIT_NV:                PathMetricMask read _FONT_UNITS_PER_EM_BIT_NV;
    public static property FONT_ASCENDER_BIT_NV:                    PathMetricMask read _FONT_ASCENDER_BIT_NV;
    public static property FONT_DESCENDER_BIT_NV:                   PathMetricMask read _FONT_DESCENDER_BIT_NV;
    public static property FONT_HEIGHT_BIT_NV:                      PathMetricMask read _FONT_HEIGHT_BIT_NV;
    public static property FONT_MAX_ADVANCE_WIDTH_BIT_NV:           PathMetricMask read _FONT_MAX_ADVANCE_WIDTH_BIT_NV;
    public static property FONT_MAX_ADVANCE_HEIGHT_BIT_NV:          PathMetricMask read _FONT_MAX_ADVANCE_HEIGHT_BIT_NV;
    public static property FONT_UNDERLINE_POSITION_BIT_NV:          PathMetricMask read _FONT_UNDERLINE_POSITION_BIT_NV;
    public static property FONT_UNDERLINE_THICKNESS_BIT_NV:         PathMetricMask read _FONT_UNDERLINE_THICKNESS_BIT_NV;
    public static property FONT_HAS_KERNING_BIT_NV:                 PathMetricMask read _FONT_HAS_KERNING_BIT_NV;
    public static property FONT_NUM_GLYPH_INDICES_BIT_NV:           PathMetricMask read _FONT_NUM_GLYPH_INDICES_BIT_NV;
    
    public static function operator or(f1,f2: PathMetricMask) := new PathMetricMask(f1.val or f2.val);
    
    public property HAS_FLAG_GLYPH_WIDTH_BIT_NV:                      boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_GLYPH_HEIGHT_BIT_NV:                     boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_X_BIT_NV:       boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_Y_BIT_NV:       boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_X_BIT_NV:         boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_Y_BIT_NV:         boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV:   boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_GLYPH_HAS_KERNING_BIT_NV:                boolean read self.val and $0100 <> 0;
    public property HAS_FLAG_FONT_X_MIN_BOUNDS_BIT_NV:                boolean read self.val and $10000 <> 0;
    public property HAS_FLAG_FONT_Y_MIN_BOUNDS_BIT_NV:                boolean read self.val and $20000 <> 0;
    public property HAS_FLAG_FONT_X_MAX_BOUNDS_BIT_NV:                boolean read self.val and $40000 <> 0;
    public property HAS_FLAG_FONT_Y_MAX_BOUNDS_BIT_NV:                boolean read self.val and $80000 <> 0;
    public property HAS_FLAG_FONT_UNITS_PER_EM_BIT_NV:                boolean read self.val and $100000 <> 0;
    public property HAS_FLAG_FONT_ASCENDER_BIT_NV:                    boolean read self.val and $200000 <> 0;
    public property HAS_FLAG_FONT_DESCENDER_BIT_NV:                   boolean read self.val and $400000 <> 0;
    public property HAS_FLAG_FONT_HEIGHT_BIT_NV:                      boolean read self.val and $800000 <> 0;
    public property HAS_FLAG_FONT_MAX_ADVANCE_WIDTH_BIT_NV:           boolean read self.val and $1000000 <> 0;
    public property HAS_FLAG_FONT_MAX_ADVANCE_HEIGHT_BIT_NV:          boolean read self.val and $2000000 <> 0;
    public property HAS_FLAG_FONT_UNDERLINE_POSITION_BIT_NV:          boolean read self.val and $4000000 <> 0;
    public property HAS_FLAG_FONT_UNDERLINE_THICKNESS_BIT_NV:         boolean read self.val and $8000000 <> 0;
    public property HAS_FLAG_FONT_HAS_KERNING_BIT_NV:                 boolean read self.val and $10000000 <> 0;
    public property HAS_FLAG_FONT_NUM_GLYPH_INDICES_BIT_NV:           boolean read self.val and $20000000 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathMetricMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'PathMetricMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  PathParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PATH_STROKE_WIDTH_NV        := new PathParameter($9075);
    private static _PATH_END_CAPS_NV            := new PathParameter($9076);
    private static _PATH_INITIAL_END_CAP_NV     := new PathParameter($9077);
    private static _PATH_TERMINAL_END_CAP_NV    := new PathParameter($9078);
    private static _PATH_JOIN_STYLE_NV          := new PathParameter($9079);
    private static _PATH_MITER_LIMIT_NV         := new PathParameter($907A);
    private static _PATH_DASH_CAPS_NV           := new PathParameter($907B);
    private static _PATH_INITIAL_DASH_CAP_NV    := new PathParameter($907C);
    private static _PATH_TERMINAL_DASH_CAP_NV   := new PathParameter($907D);
    private static _PATH_DASH_OFFSET_NV         := new PathParameter($907E);
    private static _PATH_CLIENT_LENGTH_NV       := new PathParameter($907F);
    private static _PATH_FILL_MODE_NV           := new PathParameter($9080);
    private static _PATH_FILL_MASK_NV           := new PathParameter($9081);
    private static _PATH_FILL_COVER_MODE_NV     := new PathParameter($9082);
    private static _PATH_STROKE_COVER_MODE_NV   := new PathParameter($9083);
    private static _PATH_STROKE_MASK_NV         := new PathParameter($9084);
    private static _PATH_OBJECT_BOUNDING_BOX_NV := new PathParameter($908A);
    private static _PATH_COMMAND_COUNT_NV       := new PathParameter($909D);
    private static _PATH_COORD_COUNT_NV         := new PathParameter($909E);
    private static _PATH_DASH_ARRAY_COUNT_NV    := new PathParameter($909F);
    private static _PATH_COMPUTED_LENGTH_NV     := new PathParameter($90A0);
    private static _PATH_FILL_BOUNDING_BOX_NV   := new PathParameter($90A1);
    private static _PATH_STROKE_BOUNDING_BOX_NV := new PathParameter($90A2);
    private static _PATH_DASH_OFFSET_RESET_NV   := new PathParameter($90B4);
    
    public static property PATH_STROKE_WIDTH_NV:        PathParameter read _PATH_STROKE_WIDTH_NV;
    public static property PATH_END_CAPS_NV:            PathParameter read _PATH_END_CAPS_NV;
    public static property PATH_INITIAL_END_CAP_NV:     PathParameter read _PATH_INITIAL_END_CAP_NV;
    public static property PATH_TERMINAL_END_CAP_NV:    PathParameter read _PATH_TERMINAL_END_CAP_NV;
    public static property PATH_JOIN_STYLE_NV:          PathParameter read _PATH_JOIN_STYLE_NV;
    public static property PATH_MITER_LIMIT_NV:         PathParameter read _PATH_MITER_LIMIT_NV;
    public static property PATH_DASH_CAPS_NV:           PathParameter read _PATH_DASH_CAPS_NV;
    public static property PATH_INITIAL_DASH_CAP_NV:    PathParameter read _PATH_INITIAL_DASH_CAP_NV;
    public static property PATH_TERMINAL_DASH_CAP_NV:   PathParameter read _PATH_TERMINAL_DASH_CAP_NV;
    public static property PATH_DASH_OFFSET_NV:         PathParameter read _PATH_DASH_OFFSET_NV;
    public static property PATH_CLIENT_LENGTH_NV:       PathParameter read _PATH_CLIENT_LENGTH_NV;
    public static property PATH_FILL_MODE_NV:           PathParameter read _PATH_FILL_MODE_NV;
    public static property PATH_FILL_MASK_NV:           PathParameter read _PATH_FILL_MASK_NV;
    public static property PATH_FILL_COVER_MODE_NV:     PathParameter read _PATH_FILL_COVER_MODE_NV;
    public static property PATH_STROKE_COVER_MODE_NV:   PathParameter read _PATH_STROKE_COVER_MODE_NV;
    public static property PATH_STROKE_MASK_NV:         PathParameter read _PATH_STROKE_MASK_NV;
    public static property PATH_OBJECT_BOUNDING_BOX_NV: PathParameter read _PATH_OBJECT_BOUNDING_BOX_NV;
    public static property PATH_COMMAND_COUNT_NV:       PathParameter read _PATH_COMMAND_COUNT_NV;
    public static property PATH_COORD_COUNT_NV:         PathParameter read _PATH_COORD_COUNT_NV;
    public static property PATH_DASH_ARRAY_COUNT_NV:    PathParameter read _PATH_DASH_ARRAY_COUNT_NV;
    public static property PATH_COMPUTED_LENGTH_NV:     PathParameter read _PATH_COMPUTED_LENGTH_NV;
    public static property PATH_FILL_BOUNDING_BOX_NV:   PathParameter read _PATH_FILL_BOUNDING_BOX_NV;
    public static property PATH_STROKE_BOUNDING_BOX_NV: PathParameter read _PATH_STROKE_BOUNDING_BOX_NV;
    public static property PATH_DASH_OFFSET_RESET_NV:   PathParameter read _PATH_DASH_OFFSET_RESET_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathStringFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PATH_FORMAT_SVG_NV := new PathStringFormat($9070);
    private static _PATH_FORMAT_PS_NV  := new PathStringFormat($9071);
    
    public static property PATH_FORMAT_SVG_NV: PathStringFormat read _PATH_FORMAT_SVG_NV;
    public static property PATH_FORMAT_PS_NV:  PathStringFormat read _PATH_FORMAT_PS_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathStringFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathStringFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathStringFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PathTransformType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE                   := new PathTransformType($0000);
    private static _TRANSLATE_X_NV         := new PathTransformType($908E);
    private static _TRANSLATE_Y_NV         := new PathTransformType($908F);
    private static _TRANSLATE_2D_NV        := new PathTransformType($9090);
    private static _TRANSLATE_3D_NV        := new PathTransformType($9091);
    private static _AFFINE_2D_NV           := new PathTransformType($9092);
    private static _AFFINE_3D_NV           := new PathTransformType($9094);
    private static _TRANSPOSE_AFFINE_2D_NV := new PathTransformType($9096);
    private static _TRANSPOSE_AFFINE_3D_NV := new PathTransformType($9098);
    
    public static property NONE:                   PathTransformType read _NONE;
    public static property TRANSLATE_X_NV:         PathTransformType read _TRANSLATE_X_NV;
    public static property TRANSLATE_Y_NV:         PathTransformType read _TRANSLATE_Y_NV;
    public static property TRANSLATE_2D_NV:        PathTransformType read _TRANSLATE_2D_NV;
    public static property TRANSLATE_3D_NV:        PathTransformType read _TRANSLATE_3D_NV;
    public static property AFFINE_2D_NV:           PathTransformType read _AFFINE_2D_NV;
    public static property AFFINE_3D_NV:           PathTransformType read _AFFINE_3D_NV;
    public static property TRANSPOSE_AFFINE_2D_NV: PathTransformType read _TRANSPOSE_AFFINE_2D_NV;
    public static property TRANSPOSE_AFFINE_3D_NV: PathTransformType read _TRANSPOSE_AFFINE_3D_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PathTransformType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PathTransformType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PathTransformType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PipelineParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ACTIVE_PROGRAM         := new PipelineParameterName($8259);
    private static _FRAGMENT_SHADER        := new PipelineParameterName($8B30);
    private static _VERTEX_SHADER          := new PipelineParameterName($8B31);
    private static _INFO_LOG_LENGTH        := new PipelineParameterName($8B84);
    private static _GEOMETRY_SHADER        := new PipelineParameterName($8DD9);
    private static _TESS_EVALUATION_SHADER := new PipelineParameterName($8E87);
    private static _TESS_CONTROL_SHADER    := new PipelineParameterName($8E88);
    
    public static property ACTIVE_PROGRAM:         PipelineParameterName read _ACTIVE_PROGRAM;
    public static property FRAGMENT_SHADER:        PipelineParameterName read _FRAGMENT_SHADER;
    public static property VERTEX_SHADER:          PipelineParameterName read _VERTEX_SHADER;
    public static property INFO_LOG_LENGTH:        PipelineParameterName read _INFO_LOG_LENGTH;
    public static property GEOMETRY_SHADER:        PipelineParameterName read _GEOMETRY_SHADER;
    public static property TESS_EVALUATION_SHADER: PipelineParameterName read _TESS_EVALUATION_SHADER;
    public static property TESS_CONTROL_SHADER:    PipelineParameterName read _TESS_CONTROL_SHADER;
    
    public function ToString: string; override;
    begin
      var res := typeof(PipelineParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PipelineParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PipelineParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelCopyType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR       := new PixelCopyType($1800);
    private static _COLOR_EXT   := new PixelCopyType($1800);
    private static _DEPTH       := new PixelCopyType($1801);
    private static _DEPTH_EXT   := new PixelCopyType($1801);
    private static _STENCIL     := new PixelCopyType($1802);
    private static _STENCIL_EXT := new PixelCopyType($1802);
    
    public static property COLOR:       PixelCopyType read _COLOR;
    public static property COLOR_EXT:   PixelCopyType read _COLOR_EXT;
    public static property DEPTH:       PixelCopyType read _DEPTH;
    public static property DEPTH_EXT:   PixelCopyType read _DEPTH_EXT;
    public static property STENCIL:     PixelCopyType read _STENCIL;
    public static property STENCIL_EXT: PixelCopyType read _STENCIL_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelCopyType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelCopyType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelCopyType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_SHORT  := new PixelFormat($1403);
    private static _UNSIGNED_INT    := new PixelFormat($1405);
    private static _COLOR_INDEX     := new PixelFormat($1900);
    private static _STENCIL_INDEX   := new PixelFormat($1901);
    private static _DEPTH_COMPONENT := new PixelFormat($1902);
    private static _RED             := new PixelFormat($1903);
    private static _RED_EXT         := new PixelFormat($1903);
    private static _GREEN           := new PixelFormat($1904);
    private static _BLUE            := new PixelFormat($1905);
    private static _ALPHA           := new PixelFormat($1906);
    private static _RGB             := new PixelFormat($1907);
    private static _RGBA            := new PixelFormat($1908);
    private static _LUMINANCE       := new PixelFormat($1909);
    private static _LUMINANCE_ALPHA := new PixelFormat($190A);
    private static _ABGR_EXT        := new PixelFormat($8000);
    private static _CMYK_EXT        := new PixelFormat($800C);
    private static _CMYKA_EXT       := new PixelFormat($800D);
    private static _BGR             := new PixelFormat($80E0);
    private static _BGRA            := new PixelFormat($80E1);
    private static _YCRCB_422_SGIX  := new PixelFormat($81BB);
    private static _YCRCB_444_SGIX  := new PixelFormat($81BC);
    private static _RG              := new PixelFormat($8227);
    private static _RG_INTEGER      := new PixelFormat($8228);
    private static _DEPTH_STENCIL   := new PixelFormat($84F9);
    private static _RED_INTEGER     := new PixelFormat($8D94);
    private static _GREEN_INTEGER   := new PixelFormat($8D95);
    private static _BLUE_INTEGER    := new PixelFormat($8D96);
    private static _RGB_INTEGER     := new PixelFormat($8D98);
    private static _RGBA_INTEGER    := new PixelFormat($8D99);
    private static _BGR_INTEGER     := new PixelFormat($8D9A);
    private static _BGRA_INTEGER    := new PixelFormat($8D9B);
    
    public static property UNSIGNED_SHORT:  PixelFormat read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:    PixelFormat read _UNSIGNED_INT;
    public static property COLOR_INDEX:     PixelFormat read _COLOR_INDEX;
    public static property STENCIL_INDEX:   PixelFormat read _STENCIL_INDEX;
    public static property DEPTH_COMPONENT: PixelFormat read _DEPTH_COMPONENT;
    public static property RED:             PixelFormat read _RED;
    public static property RED_EXT:         PixelFormat read _RED_EXT;
    public static property GREEN:           PixelFormat read _GREEN;
    public static property BLUE:            PixelFormat read _BLUE;
    public static property ALPHA:           PixelFormat read _ALPHA;
    public static property RGB:             PixelFormat read _RGB;
    public static property RGBA:            PixelFormat read _RGBA;
    public static property LUMINANCE:       PixelFormat read _LUMINANCE;
    public static property LUMINANCE_ALPHA: PixelFormat read _LUMINANCE_ALPHA;
    public static property ABGR_EXT:        PixelFormat read _ABGR_EXT;
    public static property CMYK_EXT:        PixelFormat read _CMYK_EXT;
    public static property CMYKA_EXT:       PixelFormat read _CMYKA_EXT;
    public static property BGR:             PixelFormat read _BGR;
    public static property BGRA:            PixelFormat read _BGRA;
    public static property YCRCB_422_SGIX:  PixelFormat read _YCRCB_422_SGIX;
    public static property YCRCB_444_SGIX:  PixelFormat read _YCRCB_444_SGIX;
    public static property RG:              PixelFormat read _RG;
    public static property RG_INTEGER:      PixelFormat read _RG_INTEGER;
    public static property DEPTH_STENCIL:   PixelFormat read _DEPTH_STENCIL;
    public static property RED_INTEGER:     PixelFormat read _RED_INTEGER;
    public static property GREEN_INTEGER:   PixelFormat read _GREEN_INTEGER;
    public static property BLUE_INTEGER:    PixelFormat read _BLUE_INTEGER;
    public static property RGB_INTEGER:     PixelFormat read _RGB_INTEGER;
    public static property RGBA_INTEGER:    PixelFormat read _RGBA_INTEGER;
    public static property BGR_INTEGER:     PixelFormat read _BGR_INTEGER;
    public static property BGRA_INTEGER:    PixelFormat read _BGRA_INTEGER;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelMap = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_MAP_I_TO_I := new PixelMap($0C70);
    private static _PIXEL_MAP_S_TO_S := new PixelMap($0C71);
    private static _PIXEL_MAP_I_TO_R := new PixelMap($0C72);
    private static _PIXEL_MAP_I_TO_G := new PixelMap($0C73);
    private static _PIXEL_MAP_I_TO_B := new PixelMap($0C74);
    private static _PIXEL_MAP_I_TO_A := new PixelMap($0C75);
    private static _PIXEL_MAP_R_TO_R := new PixelMap($0C76);
    private static _PIXEL_MAP_G_TO_G := new PixelMap($0C77);
    private static _PIXEL_MAP_B_TO_B := new PixelMap($0C78);
    private static _PIXEL_MAP_A_TO_A := new PixelMap($0C79);
    
    public static property PIXEL_MAP_I_TO_I: PixelMap read _PIXEL_MAP_I_TO_I;
    public static property PIXEL_MAP_S_TO_S: PixelMap read _PIXEL_MAP_S_TO_S;
    public static property PIXEL_MAP_I_TO_R: PixelMap read _PIXEL_MAP_I_TO_R;
    public static property PIXEL_MAP_I_TO_G: PixelMap read _PIXEL_MAP_I_TO_G;
    public static property PIXEL_MAP_I_TO_B: PixelMap read _PIXEL_MAP_I_TO_B;
    public static property PIXEL_MAP_I_TO_A: PixelMap read _PIXEL_MAP_I_TO_A;
    public static property PIXEL_MAP_R_TO_R: PixelMap read _PIXEL_MAP_R_TO_R;
    public static property PIXEL_MAP_G_TO_G: PixelMap read _PIXEL_MAP_G_TO_G;
    public static property PIXEL_MAP_B_TO_B: PixelMap read _PIXEL_MAP_B_TO_B;
    public static property PIXEL_MAP_A_TO_A: PixelMap read _PIXEL_MAP_A_TO_A;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelMap).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelMap(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelMap[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelStoreParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNPACK_SWAP_BYTES           := new PixelStoreParameter($0CF0);
    private static _UNPACK_LSB_FIRST            := new PixelStoreParameter($0CF1);
    private static _UNPACK_ROW_LENGTH           := new PixelStoreParameter($0CF2);
    private static _UNPACK_ROW_LENGTH_EXT       := new PixelStoreParameter($0CF2);
    private static _UNPACK_SKIP_ROWS            := new PixelStoreParameter($0CF3);
    private static _UNPACK_SKIP_ROWS_EXT        := new PixelStoreParameter($0CF3);
    private static _UNPACK_SKIP_PIXELS          := new PixelStoreParameter($0CF4);
    private static _UNPACK_SKIP_PIXELS_EXT      := new PixelStoreParameter($0CF4);
    private static _UNPACK_ALIGNMENT            := new PixelStoreParameter($0CF5);
    private static _PACK_SWAP_BYTES             := new PixelStoreParameter($0D00);
    private static _PACK_LSB_FIRST              := new PixelStoreParameter($0D01);
    private static _PACK_ROW_LENGTH             := new PixelStoreParameter($0D02);
    private static _PACK_SKIP_ROWS              := new PixelStoreParameter($0D03);
    private static _PACK_SKIP_PIXELS            := new PixelStoreParameter($0D04);
    private static _PACK_ALIGNMENT              := new PixelStoreParameter($0D05);
    private static _PACK_SKIP_IMAGES            := new PixelStoreParameter($806B);
    private static _PACK_SKIP_IMAGES_EXT        := new PixelStoreParameter($806B);
    private static _PACK_IMAGE_HEIGHT           := new PixelStoreParameter($806C);
    private static _PACK_IMAGE_HEIGHT_EXT       := new PixelStoreParameter($806C);
    private static _UNPACK_SKIP_IMAGES          := new PixelStoreParameter($806D);
    private static _UNPACK_SKIP_IMAGES_EXT      := new PixelStoreParameter($806D);
    private static _UNPACK_IMAGE_HEIGHT         := new PixelStoreParameter($806E);
    private static _UNPACK_IMAGE_HEIGHT_EXT     := new PixelStoreParameter($806E);
    private static _PACK_SKIP_VOLUMES_SGIS      := new PixelStoreParameter($8130);
    private static _PACK_IMAGE_DEPTH_SGIS       := new PixelStoreParameter($8131);
    private static _UNPACK_SKIP_VOLUMES_SGIS    := new PixelStoreParameter($8132);
    private static _UNPACK_IMAGE_DEPTH_SGIS     := new PixelStoreParameter($8133);
    private static _PIXEL_TILE_WIDTH_SGIX       := new PixelStoreParameter($8140);
    private static _PIXEL_TILE_HEIGHT_SGIX      := new PixelStoreParameter($8141);
    private static _PIXEL_TILE_GRID_WIDTH_SGIX  := new PixelStoreParameter($8142);
    private static _PIXEL_TILE_GRID_HEIGHT_SGIX := new PixelStoreParameter($8143);
    private static _PIXEL_TILE_GRID_DEPTH_SGIX  := new PixelStoreParameter($8144);
    private static _PIXEL_TILE_CACHE_SIZE_SGIX  := new PixelStoreParameter($8145);
    private static _PACK_RESAMPLE_SGIX          := new PixelStoreParameter($842E);
    private static _UNPACK_RESAMPLE_SGIX        := new PixelStoreParameter($842F);
    private static _PACK_SUBSAMPLE_RATE_SGIX    := new PixelStoreParameter($85A0);
    private static _UNPACK_SUBSAMPLE_RATE_SGIX  := new PixelStoreParameter($85A1);
    private static _PACK_RESAMPLE_OML           := new PixelStoreParameter($8984);
    private static _UNPACK_RESAMPLE_OML         := new PixelStoreParameter($8985);
    
    public static property UNPACK_SWAP_BYTES:           PixelStoreParameter read _UNPACK_SWAP_BYTES;
    public static property UNPACK_LSB_FIRST:            PixelStoreParameter read _UNPACK_LSB_FIRST;
    public static property UNPACK_ROW_LENGTH:           PixelStoreParameter read _UNPACK_ROW_LENGTH;
    public static property UNPACK_ROW_LENGTH_EXT:       PixelStoreParameter read _UNPACK_ROW_LENGTH_EXT;
    public static property UNPACK_SKIP_ROWS:            PixelStoreParameter read _UNPACK_SKIP_ROWS;
    public static property UNPACK_SKIP_ROWS_EXT:        PixelStoreParameter read _UNPACK_SKIP_ROWS_EXT;
    public static property UNPACK_SKIP_PIXELS:          PixelStoreParameter read _UNPACK_SKIP_PIXELS;
    public static property UNPACK_SKIP_PIXELS_EXT:      PixelStoreParameter read _UNPACK_SKIP_PIXELS_EXT;
    public static property UNPACK_ALIGNMENT:            PixelStoreParameter read _UNPACK_ALIGNMENT;
    public static property PACK_SWAP_BYTES:             PixelStoreParameter read _PACK_SWAP_BYTES;
    public static property PACK_LSB_FIRST:              PixelStoreParameter read _PACK_LSB_FIRST;
    public static property PACK_ROW_LENGTH:             PixelStoreParameter read _PACK_ROW_LENGTH;
    public static property PACK_SKIP_ROWS:              PixelStoreParameter read _PACK_SKIP_ROWS;
    public static property PACK_SKIP_PIXELS:            PixelStoreParameter read _PACK_SKIP_PIXELS;
    public static property PACK_ALIGNMENT:              PixelStoreParameter read _PACK_ALIGNMENT;
    public static property PACK_SKIP_IMAGES:            PixelStoreParameter read _PACK_SKIP_IMAGES;
    public static property PACK_SKIP_IMAGES_EXT:        PixelStoreParameter read _PACK_SKIP_IMAGES_EXT;
    public static property PACK_IMAGE_HEIGHT:           PixelStoreParameter read _PACK_IMAGE_HEIGHT;
    public static property PACK_IMAGE_HEIGHT_EXT:       PixelStoreParameter read _PACK_IMAGE_HEIGHT_EXT;
    public static property UNPACK_SKIP_IMAGES:          PixelStoreParameter read _UNPACK_SKIP_IMAGES;
    public static property UNPACK_SKIP_IMAGES_EXT:      PixelStoreParameter read _UNPACK_SKIP_IMAGES_EXT;
    public static property UNPACK_IMAGE_HEIGHT:         PixelStoreParameter read _UNPACK_IMAGE_HEIGHT;
    public static property UNPACK_IMAGE_HEIGHT_EXT:     PixelStoreParameter read _UNPACK_IMAGE_HEIGHT_EXT;
    public static property PACK_SKIP_VOLUMES_SGIS:      PixelStoreParameter read _PACK_SKIP_VOLUMES_SGIS;
    public static property PACK_IMAGE_DEPTH_SGIS:       PixelStoreParameter read _PACK_IMAGE_DEPTH_SGIS;
    public static property UNPACK_SKIP_VOLUMES_SGIS:    PixelStoreParameter read _UNPACK_SKIP_VOLUMES_SGIS;
    public static property UNPACK_IMAGE_DEPTH_SGIS:     PixelStoreParameter read _UNPACK_IMAGE_DEPTH_SGIS;
    public static property PIXEL_TILE_WIDTH_SGIX:       PixelStoreParameter read _PIXEL_TILE_WIDTH_SGIX;
    public static property PIXEL_TILE_HEIGHT_SGIX:      PixelStoreParameter read _PIXEL_TILE_HEIGHT_SGIX;
    public static property PIXEL_TILE_GRID_WIDTH_SGIX:  PixelStoreParameter read _PIXEL_TILE_GRID_WIDTH_SGIX;
    public static property PIXEL_TILE_GRID_HEIGHT_SGIX: PixelStoreParameter read _PIXEL_TILE_GRID_HEIGHT_SGIX;
    public static property PIXEL_TILE_GRID_DEPTH_SGIX:  PixelStoreParameter read _PIXEL_TILE_GRID_DEPTH_SGIX;
    public static property PIXEL_TILE_CACHE_SIZE_SGIX:  PixelStoreParameter read _PIXEL_TILE_CACHE_SIZE_SGIX;
    public static property PACK_RESAMPLE_SGIX:          PixelStoreParameter read _PACK_RESAMPLE_SGIX;
    public static property UNPACK_RESAMPLE_SGIX:        PixelStoreParameter read _UNPACK_RESAMPLE_SGIX;
    public static property PACK_SUBSAMPLE_RATE_SGIX:    PixelStoreParameter read _PACK_SUBSAMPLE_RATE_SGIX;
    public static property UNPACK_SUBSAMPLE_RATE_SGIX:  PixelStoreParameter read _UNPACK_SUBSAMPLE_RATE_SGIX;
    public static property PACK_RESAMPLE_OML:           PixelStoreParameter read _PACK_RESAMPLE_OML;
    public static property UNPACK_RESAMPLE_OML:         PixelStoreParameter read _UNPACK_RESAMPLE_OML;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelStoreParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelStoreParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelStoreParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelTransferParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP_COLOR                         := new PixelTransferParameter($0D10);
    private static _MAP_STENCIL                       := new PixelTransferParameter($0D11);
    private static _INDEX_SHIFT                       := new PixelTransferParameter($0D12);
    private static _INDEX_OFFSET                      := new PixelTransferParameter($0D13);
    private static _RED_SCALE                         := new PixelTransferParameter($0D14);
    private static _RED_BIAS                          := new PixelTransferParameter($0D15);
    private static _GREEN_SCALE                       := new PixelTransferParameter($0D18);
    private static _GREEN_BIAS                        := new PixelTransferParameter($0D19);
    private static _BLUE_SCALE                        := new PixelTransferParameter($0D1A);
    private static _BLUE_BIAS                         := new PixelTransferParameter($0D1B);
    private static _ALPHA_SCALE                       := new PixelTransferParameter($0D1C);
    private static _ALPHA_BIAS                        := new PixelTransferParameter($0D1D);
    private static _DEPTH_SCALE                       := new PixelTransferParameter($0D1E);
    private static _DEPTH_BIAS                        := new PixelTransferParameter($0D1F);
    private static _POST_CONVOLUTION_RED_SCALE        := new PixelTransferParameter($801C);
    private static _POST_CONVOLUTION_RED_SCALE_EXT    := new PixelTransferParameter($801C);
    private static _POST_CONVOLUTION_GREEN_SCALE      := new PixelTransferParameter($801D);
    private static _POST_CONVOLUTION_GREEN_SCALE_EXT  := new PixelTransferParameter($801D);
    private static _POST_CONVOLUTION_BLUE_SCALE       := new PixelTransferParameter($801E);
    private static _POST_CONVOLUTION_BLUE_SCALE_EXT   := new PixelTransferParameter($801E);
    private static _POST_CONVOLUTION_ALPHA_SCALE      := new PixelTransferParameter($801F);
    private static _POST_CONVOLUTION_ALPHA_SCALE_EXT  := new PixelTransferParameter($801F);
    private static _POST_CONVOLUTION_RED_BIAS         := new PixelTransferParameter($8020);
    private static _POST_CONVOLUTION_RED_BIAS_EXT     := new PixelTransferParameter($8020);
    private static _POST_CONVOLUTION_GREEN_BIAS       := new PixelTransferParameter($8021);
    private static _POST_CONVOLUTION_GREEN_BIAS_EXT   := new PixelTransferParameter($8021);
    private static _POST_CONVOLUTION_BLUE_BIAS        := new PixelTransferParameter($8022);
    private static _POST_CONVOLUTION_BLUE_BIAS_EXT    := new PixelTransferParameter($8022);
    private static _POST_CONVOLUTION_ALPHA_BIAS       := new PixelTransferParameter($8023);
    private static _POST_CONVOLUTION_ALPHA_BIAS_EXT   := new PixelTransferParameter($8023);
    private static _POST_COLOR_MATRIX_RED_SCALE       := new PixelTransferParameter($80B4);
    private static _POST_COLOR_MATRIX_RED_SCALE_SGI   := new PixelTransferParameter($80B4);
    private static _POST_COLOR_MATRIX_GREEN_SCALE     := new PixelTransferParameter($80B5);
    private static _POST_COLOR_MATRIX_GREEN_SCALE_SGI := new PixelTransferParameter($80B5);
    private static _POST_COLOR_MATRIX_BLUE_SCALE      := new PixelTransferParameter($80B6);
    private static _POST_COLOR_MATRIX_BLUE_SCALE_SGI  := new PixelTransferParameter($80B6);
    private static _POST_COLOR_MATRIX_ALPHA_SCALE     := new PixelTransferParameter($80B7);
    private static _POST_COLOR_MATRIX_ALPHA_SCALE_SGI := new PixelTransferParameter($80B7);
    private static _POST_COLOR_MATRIX_RED_BIAS        := new PixelTransferParameter($80B8);
    private static _POST_COLOR_MATRIX_RED_BIAS_SGI    := new PixelTransferParameter($80B8);
    private static _POST_COLOR_MATRIX_GREEN_BIAS      := new PixelTransferParameter($80B9);
    private static _POST_COLOR_MATRIX_GREEN_BIAS_SGI  := new PixelTransferParameter($80B9);
    private static _POST_COLOR_MATRIX_BLUE_BIAS       := new PixelTransferParameter($80BA);
    private static _POST_COLOR_MATRIX_BLUE_BIAS_SGI   := new PixelTransferParameter($80BA);
    private static _POST_COLOR_MATRIX_ALPHA_BIAS      := new PixelTransferParameter($80BB);
    private static _POST_COLOR_MATRIX_ALPHA_BIAS_SGI  := new PixelTransferParameter($80BB);
    
    public static property MAP_COLOR:                         PixelTransferParameter read _MAP_COLOR;
    public static property MAP_STENCIL:                       PixelTransferParameter read _MAP_STENCIL;
    public static property INDEX_SHIFT:                       PixelTransferParameter read _INDEX_SHIFT;
    public static property INDEX_OFFSET:                      PixelTransferParameter read _INDEX_OFFSET;
    public static property RED_SCALE:                         PixelTransferParameter read _RED_SCALE;
    public static property RED_BIAS:                          PixelTransferParameter read _RED_BIAS;
    public static property GREEN_SCALE:                       PixelTransferParameter read _GREEN_SCALE;
    public static property GREEN_BIAS:                        PixelTransferParameter read _GREEN_BIAS;
    public static property BLUE_SCALE:                        PixelTransferParameter read _BLUE_SCALE;
    public static property BLUE_BIAS:                         PixelTransferParameter read _BLUE_BIAS;
    public static property ALPHA_SCALE:                       PixelTransferParameter read _ALPHA_SCALE;
    public static property ALPHA_BIAS:                        PixelTransferParameter read _ALPHA_BIAS;
    public static property DEPTH_SCALE:                       PixelTransferParameter read _DEPTH_SCALE;
    public static property DEPTH_BIAS:                        PixelTransferParameter read _DEPTH_BIAS;
    public static property POST_CONVOLUTION_RED_SCALE:        PixelTransferParameter read _POST_CONVOLUTION_RED_SCALE;
    public static property POST_CONVOLUTION_RED_SCALE_EXT:    PixelTransferParameter read _POST_CONVOLUTION_RED_SCALE_EXT;
    public static property POST_CONVOLUTION_GREEN_SCALE:      PixelTransferParameter read _POST_CONVOLUTION_GREEN_SCALE;
    public static property POST_CONVOLUTION_GREEN_SCALE_EXT:  PixelTransferParameter read _POST_CONVOLUTION_GREEN_SCALE_EXT;
    public static property POST_CONVOLUTION_BLUE_SCALE:       PixelTransferParameter read _POST_CONVOLUTION_BLUE_SCALE;
    public static property POST_CONVOLUTION_BLUE_SCALE_EXT:   PixelTransferParameter read _POST_CONVOLUTION_BLUE_SCALE_EXT;
    public static property POST_CONVOLUTION_ALPHA_SCALE:      PixelTransferParameter read _POST_CONVOLUTION_ALPHA_SCALE;
    public static property POST_CONVOLUTION_ALPHA_SCALE_EXT:  PixelTransferParameter read _POST_CONVOLUTION_ALPHA_SCALE_EXT;
    public static property POST_CONVOLUTION_RED_BIAS:         PixelTransferParameter read _POST_CONVOLUTION_RED_BIAS;
    public static property POST_CONVOLUTION_RED_BIAS_EXT:     PixelTransferParameter read _POST_CONVOLUTION_RED_BIAS_EXT;
    public static property POST_CONVOLUTION_GREEN_BIAS:       PixelTransferParameter read _POST_CONVOLUTION_GREEN_BIAS;
    public static property POST_CONVOLUTION_GREEN_BIAS_EXT:   PixelTransferParameter read _POST_CONVOLUTION_GREEN_BIAS_EXT;
    public static property POST_CONVOLUTION_BLUE_BIAS:        PixelTransferParameter read _POST_CONVOLUTION_BLUE_BIAS;
    public static property POST_CONVOLUTION_BLUE_BIAS_EXT:    PixelTransferParameter read _POST_CONVOLUTION_BLUE_BIAS_EXT;
    public static property POST_CONVOLUTION_ALPHA_BIAS:       PixelTransferParameter read _POST_CONVOLUTION_ALPHA_BIAS;
    public static property POST_CONVOLUTION_ALPHA_BIAS_EXT:   PixelTransferParameter read _POST_CONVOLUTION_ALPHA_BIAS_EXT;
    public static property POST_COLOR_MATRIX_RED_SCALE:       PixelTransferParameter read _POST_COLOR_MATRIX_RED_SCALE;
    public static property POST_COLOR_MATRIX_RED_SCALE_SGI:   PixelTransferParameter read _POST_COLOR_MATRIX_RED_SCALE_SGI;
    public static property POST_COLOR_MATRIX_GREEN_SCALE:     PixelTransferParameter read _POST_COLOR_MATRIX_GREEN_SCALE;
    public static property POST_COLOR_MATRIX_GREEN_SCALE_SGI: PixelTransferParameter read _POST_COLOR_MATRIX_GREEN_SCALE_SGI;
    public static property POST_COLOR_MATRIX_BLUE_SCALE:      PixelTransferParameter read _POST_COLOR_MATRIX_BLUE_SCALE;
    public static property POST_COLOR_MATRIX_BLUE_SCALE_SGI:  PixelTransferParameter read _POST_COLOR_MATRIX_BLUE_SCALE_SGI;
    public static property POST_COLOR_MATRIX_ALPHA_SCALE:     PixelTransferParameter read _POST_COLOR_MATRIX_ALPHA_SCALE;
    public static property POST_COLOR_MATRIX_ALPHA_SCALE_SGI: PixelTransferParameter read _POST_COLOR_MATRIX_ALPHA_SCALE_SGI;
    public static property POST_COLOR_MATRIX_RED_BIAS:        PixelTransferParameter read _POST_COLOR_MATRIX_RED_BIAS;
    public static property POST_COLOR_MATRIX_RED_BIAS_SGI:    PixelTransferParameter read _POST_COLOR_MATRIX_RED_BIAS_SGI;
    public static property POST_COLOR_MATRIX_GREEN_BIAS:      PixelTransferParameter read _POST_COLOR_MATRIX_GREEN_BIAS;
    public static property POST_COLOR_MATRIX_GREEN_BIAS_SGI:  PixelTransferParameter read _POST_COLOR_MATRIX_GREEN_BIAS_SGI;
    public static property POST_COLOR_MATRIX_BLUE_BIAS:       PixelTransferParameter read _POST_COLOR_MATRIX_BLUE_BIAS;
    public static property POST_COLOR_MATRIX_BLUE_BIAS_SGI:   PixelTransferParameter read _POST_COLOR_MATRIX_BLUE_BIAS_SGI;
    public static property POST_COLOR_MATRIX_ALPHA_BIAS:      PixelTransferParameter read _POST_COLOR_MATRIX_ALPHA_BIAS;
    public static property POST_COLOR_MATRIX_ALPHA_BIAS_SGI:  PixelTransferParameter read _POST_COLOR_MATRIX_ALPHA_BIAS_SGI;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelTransferParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelTransferParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelTransferParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE                        := new PixelType($1400);
    private static _UNSIGNED_BYTE               := new PixelType($1401);
    private static _SHORT                       := new PixelType($1402);
    private static _UNSIGNED_SHORT              := new PixelType($1403);
    private static _INT                         := new PixelType($1404);
    private static _UNSIGNED_INT                := new PixelType($1405);
    private static _FLOAT                       := new PixelType($1406);
    private static _BITMAP                      := new PixelType($1A00);
    private static _UNSIGNED_BYTE_3_3_2         := new PixelType($8032);
    private static _UNSIGNED_BYTE_3_3_2_EXT     := new PixelType($8032);
    private static _UNSIGNED_SHORT_4_4_4_4      := new PixelType($8033);
    private static _UNSIGNED_SHORT_4_4_4_4_EXT  := new PixelType($8033);
    private static _UNSIGNED_SHORT_5_5_5_1      := new PixelType($8034);
    private static _UNSIGNED_SHORT_5_5_5_1_EXT  := new PixelType($8034);
    private static _UNSIGNED_INT_8_8_8_8        := new PixelType($8035);
    private static _UNSIGNED_INT_8_8_8_8_EXT    := new PixelType($8035);
    private static _UNSIGNED_INT_10_10_10_2     := new PixelType($8036);
    private static _UNSIGNED_INT_10_10_10_2_EXT := new PixelType($8036);
    
    public static property BYTE:                        PixelType read _BYTE;
    public static property UNSIGNED_BYTE:               PixelType read _UNSIGNED_BYTE;
    public static property SHORT:                       PixelType read _SHORT;
    public static property UNSIGNED_SHORT:              PixelType read _UNSIGNED_SHORT;
    public static property INT:                         PixelType read _INT;
    public static property UNSIGNED_INT:                PixelType read _UNSIGNED_INT;
    public static property FLOAT:                       PixelType read _FLOAT;
    public static property BITMAP:                      PixelType read _BITMAP;
    public static property UNSIGNED_BYTE_3_3_2:         PixelType read _UNSIGNED_BYTE_3_3_2;
    public static property UNSIGNED_BYTE_3_3_2_EXT:     PixelType read _UNSIGNED_BYTE_3_3_2_EXT;
    public static property UNSIGNED_SHORT_4_4_4_4:      PixelType read _UNSIGNED_SHORT_4_4_4_4;
    public static property UNSIGNED_SHORT_4_4_4_4_EXT:  PixelType read _UNSIGNED_SHORT_4_4_4_4_EXT;
    public static property UNSIGNED_SHORT_5_5_5_1:      PixelType read _UNSIGNED_SHORT_5_5_5_1;
    public static property UNSIGNED_SHORT_5_5_5_1_EXT:  PixelType read _UNSIGNED_SHORT_5_5_5_1_EXT;
    public static property UNSIGNED_INT_8_8_8_8:        PixelType read _UNSIGNED_INT_8_8_8_8;
    public static property UNSIGNED_INT_8_8_8_8_EXT:    PixelType read _UNSIGNED_INT_8_8_8_8_EXT;
    public static property UNSIGNED_INT_10_10_10_2:     PixelType read _UNSIGNED_INT_10_10_10_2;
    public static property UNSIGNED_INT_10_10_10_2_EXT: PixelType read _UNSIGNED_INT_10_10_10_2_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PolygonMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINT := new PolygonMode($1B00);
    private static _LINE  := new PolygonMode($1B01);
    private static _FILL  := new PolygonMode($1B02);
    
    public static property POINT: PolygonMode read _POINT;
    public static property LINE:  PolygonMode read _LINE;
    public static property FILL:  PolygonMode read _FILL;
    
    public function ToString: string; override;
    begin
      var res := typeof(PolygonMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PolygonMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PolygonMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PrecisionType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LOW_FLOAT    := new PrecisionType($8DF0);
    private static _MEDIUM_FLOAT := new PrecisionType($8DF1);
    private static _HIGH_FLOAT   := new PrecisionType($8DF2);
    private static _LOW_INT      := new PrecisionType($8DF3);
    private static _MEDIUM_INT   := new PrecisionType($8DF4);
    private static _HIGH_INT     := new PrecisionType($8DF5);
    
    public static property LOW_FLOAT:    PrecisionType read _LOW_FLOAT;
    public static property MEDIUM_FLOAT: PrecisionType read _MEDIUM_FLOAT;
    public static property HIGH_FLOAT:   PrecisionType read _HIGH_FLOAT;
    public static property LOW_INT:      PrecisionType read _LOW_INT;
    public static property MEDIUM_INT:   PrecisionType read _MEDIUM_INT;
    public static property HIGH_INT:     PrecisionType read _HIGH_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PrecisionType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PrecisionType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PrecisionType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PrimitiveType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINTS                       := new PrimitiveType($0000);
    private static _LINES                        := new PrimitiveType($0001);
    private static _LINE_LOOP                    := new PrimitiveType($0002);
    private static _LINE_STRIP                   := new PrimitiveType($0003);
    private static _TRIANGLES                    := new PrimitiveType($0004);
    private static _TRIANGLE_STRIP               := new PrimitiveType($0005);
    private static _TRIANGLE_FAN                 := new PrimitiveType($0006);
    private static _QUADS                        := new PrimitiveType($0007);
    private static _QUADS_EXT                    := new PrimitiveType($0007);
    private static _QUAD_STRIP                   := new PrimitiveType($0008);
    private static _POLYGON                      := new PrimitiveType($0009);
    private static _LINES_ADJACENCY              := new PrimitiveType($000A);
    private static _LINES_ADJACENCY_ARB          := new PrimitiveType($000A);
    private static _LINES_ADJACENCY_EXT          := new PrimitiveType($000A);
    private static _LINE_STRIP_ADJACENCY         := new PrimitiveType($000B);
    private static _LINE_STRIP_ADJACENCY_ARB     := new PrimitiveType($000B);
    private static _LINE_STRIP_ADJACENCY_EXT     := new PrimitiveType($000B);
    private static _TRIANGLES_ADJACENCY          := new PrimitiveType($000C);
    private static _TRIANGLES_ADJACENCY_ARB      := new PrimitiveType($000C);
    private static _TRIANGLES_ADJACENCY_EXT      := new PrimitiveType($000C);
    private static _TRIANGLE_STRIP_ADJACENCY     := new PrimitiveType($000D);
    private static _TRIANGLE_STRIP_ADJACENCY_ARB := new PrimitiveType($000D);
    private static _TRIANGLE_STRIP_ADJACENCY_EXT := new PrimitiveType($000D);
    private static _PATCHES                      := new PrimitiveType($000E);
    private static _PATCHES_EXT                  := new PrimitiveType($000E);
    
    public static property POINTS:                       PrimitiveType read _POINTS;
    public static property LINES:                        PrimitiveType read _LINES;
    public static property LINE_LOOP:                    PrimitiveType read _LINE_LOOP;
    public static property LINE_STRIP:                   PrimitiveType read _LINE_STRIP;
    public static property TRIANGLES:                    PrimitiveType read _TRIANGLES;
    public static property TRIANGLE_STRIP:               PrimitiveType read _TRIANGLE_STRIP;
    public static property TRIANGLE_FAN:                 PrimitiveType read _TRIANGLE_FAN;
    public static property QUADS:                        PrimitiveType read _QUADS;
    public static property QUADS_EXT:                    PrimitiveType read _QUADS_EXT;
    public static property QUAD_STRIP:                   PrimitiveType read _QUAD_STRIP;
    public static property POLYGON:                      PrimitiveType read _POLYGON;
    public static property LINES_ADJACENCY:              PrimitiveType read _LINES_ADJACENCY;
    public static property LINES_ADJACENCY_ARB:          PrimitiveType read _LINES_ADJACENCY_ARB;
    public static property LINES_ADJACENCY_EXT:          PrimitiveType read _LINES_ADJACENCY_EXT;
    public static property LINE_STRIP_ADJACENCY:         PrimitiveType read _LINE_STRIP_ADJACENCY;
    public static property LINE_STRIP_ADJACENCY_ARB:     PrimitiveType read _LINE_STRIP_ADJACENCY_ARB;
    public static property LINE_STRIP_ADJACENCY_EXT:     PrimitiveType read _LINE_STRIP_ADJACENCY_EXT;
    public static property TRIANGLES_ADJACENCY:          PrimitiveType read _TRIANGLES_ADJACENCY;
    public static property TRIANGLES_ADJACENCY_ARB:      PrimitiveType read _TRIANGLES_ADJACENCY_ARB;
    public static property TRIANGLES_ADJACENCY_EXT:      PrimitiveType read _TRIANGLES_ADJACENCY_EXT;
    public static property TRIANGLE_STRIP_ADJACENCY:     PrimitiveType read _TRIANGLE_STRIP_ADJACENCY;
    public static property TRIANGLE_STRIP_ADJACENCY_ARB: PrimitiveType read _TRIANGLE_STRIP_ADJACENCY_ARB;
    public static property TRIANGLE_STRIP_ADJACENCY_EXT: PrimitiveType read _TRIANGLE_STRIP_ADJACENCY_EXT;
    public static property PATCHES:                      PrimitiveType read _PATCHES;
    public static property PATCHES_EXT:                  PrimitiveType read _PATCHES_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PrimitiveType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PrimitiveType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PrimitiveType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramFormat = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PROGRAM_FORMAT_ASCII_ARB := new ProgramFormat($8875);
    
    public static property PROGRAM_FORMAT_ASCII_ARB: ProgramFormat read _PROGRAM_FORMAT_ASCII_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramFormat).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramFormat(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramFormat[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramInterface = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TRANSFORM_FEEDBACK_BUFFER          := new ProgramInterface($8C8E);
    private static _UNIFORM                            := new ProgramInterface($92E1);
    private static _UNIFORM_BLOCK                      := new ProgramInterface($92E2);
    private static _PROGRAM_INPUT                      := new ProgramInterface($92E3);
    private static _PROGRAM_OUTPUT                     := new ProgramInterface($92E4);
    private static _BUFFER_VARIABLE                    := new ProgramInterface($92E5);
    private static _SHADER_STORAGE_BLOCK               := new ProgramInterface($92E6);
    private static _VERTEX_SUBROUTINE                  := new ProgramInterface($92E8);
    private static _TESS_CONTROL_SUBROUTINE            := new ProgramInterface($92E9);
    private static _TESS_EVALUATION_SUBROUTINE         := new ProgramInterface($92EA);
    private static _GEOMETRY_SUBROUTINE                := new ProgramInterface($92EB);
    private static _FRAGMENT_SUBROUTINE                := new ProgramInterface($92EC);
    private static _COMPUTE_SUBROUTINE                 := new ProgramInterface($92ED);
    private static _VERTEX_SUBROUTINE_UNIFORM          := new ProgramInterface($92EE);
    private static _TESS_CONTROL_SUBROUTINE_UNIFORM    := new ProgramInterface($92EF);
    private static _TESS_EVALUATION_SUBROUTINE_UNIFORM := new ProgramInterface($92F0);
    private static _GEOMETRY_SUBROUTINE_UNIFORM        := new ProgramInterface($92F1);
    private static _FRAGMENT_SUBROUTINE_UNIFORM        := new ProgramInterface($92F2);
    private static _COMPUTE_SUBROUTINE_UNIFORM         := new ProgramInterface($92F3);
    private static _TRANSFORM_FEEDBACK_VARYING         := new ProgramInterface($92F4);
    
    public static property TRANSFORM_FEEDBACK_BUFFER:          ProgramInterface read _TRANSFORM_FEEDBACK_BUFFER;
    public static property UNIFORM:                            ProgramInterface read _UNIFORM;
    public static property UNIFORM_BLOCK:                      ProgramInterface read _UNIFORM_BLOCK;
    public static property PROGRAM_INPUT:                      ProgramInterface read _PROGRAM_INPUT;
    public static property PROGRAM_OUTPUT:                     ProgramInterface read _PROGRAM_OUTPUT;
    public static property BUFFER_VARIABLE:                    ProgramInterface read _BUFFER_VARIABLE;
    public static property SHADER_STORAGE_BLOCK:               ProgramInterface read _SHADER_STORAGE_BLOCK;
    public static property VERTEX_SUBROUTINE:                  ProgramInterface read _VERTEX_SUBROUTINE;
    public static property TESS_CONTROL_SUBROUTINE:            ProgramInterface read _TESS_CONTROL_SUBROUTINE;
    public static property TESS_EVALUATION_SUBROUTINE:         ProgramInterface read _TESS_EVALUATION_SUBROUTINE;
    public static property GEOMETRY_SUBROUTINE:                ProgramInterface read _GEOMETRY_SUBROUTINE;
    public static property FRAGMENT_SUBROUTINE:                ProgramInterface read _FRAGMENT_SUBROUTINE;
    public static property COMPUTE_SUBROUTINE:                 ProgramInterface read _COMPUTE_SUBROUTINE;
    public static property VERTEX_SUBROUTINE_UNIFORM:          ProgramInterface read _VERTEX_SUBROUTINE_UNIFORM;
    public static property TESS_CONTROL_SUBROUTINE_UNIFORM:    ProgramInterface read _TESS_CONTROL_SUBROUTINE_UNIFORM;
    public static property TESS_EVALUATION_SUBROUTINE_UNIFORM: ProgramInterface read _TESS_EVALUATION_SUBROUTINE_UNIFORM;
    public static property GEOMETRY_SUBROUTINE_UNIFORM:        ProgramInterface read _GEOMETRY_SUBROUTINE_UNIFORM;
    public static property FRAGMENT_SUBROUTINE_UNIFORM:        ProgramInterface read _FRAGMENT_SUBROUTINE_UNIFORM;
    public static property COMPUTE_SUBROUTINE_UNIFORM:         ProgramInterface read _COMPUTE_SUBROUTINE_UNIFORM;
    public static property TRANSFORM_FEEDBACK_VARYING:         ProgramInterface read _TRANSFORM_FEEDBACK_VARYING;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramInterface).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramInterface(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramInterface[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramInterfacePName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ACTIVE_RESOURCES               := new ProgramInterfacePName($92F5);
    private static _MAX_NAME_LENGTH                := new ProgramInterfacePName($92F6);
    private static _MAX_NUM_ACTIVE_VARIABLES       := new ProgramInterfacePName($92F7);
    private static _MAX_NUM_COMPATIBLE_SUBROUTINES := new ProgramInterfacePName($92F8);
    
    public static property ACTIVE_RESOURCES:               ProgramInterfacePName read _ACTIVE_RESOURCES;
    public static property MAX_NAME_LENGTH:                ProgramInterfacePName read _MAX_NAME_LENGTH;
    public static property MAX_NUM_ACTIVE_VARIABLES:       ProgramInterfacePName read _MAX_NUM_ACTIVE_VARIABLES;
    public static property MAX_NUM_COMPATIBLE_SUBROUTINES: ProgramInterfacePName read _MAX_NUM_COMPATIBLE_SUBROUTINES;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramInterfacePName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramInterfacePName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramInterfacePName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramParameterPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PROGRAM_BINARY_RETRIEVABLE_HINT := new ProgramParameterPName($8257);
    private static _PROGRAM_SEPARABLE               := new ProgramParameterPName($8258);
    
    public static property PROGRAM_BINARY_RETRIEVABLE_HINT: ProgramParameterPName read _PROGRAM_BINARY_RETRIEVABLE_HINT;
    public static property PROGRAM_SEPARABLE:               ProgramParameterPName read _PROGRAM_SEPARABLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramParameterPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramParameterPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramParameterPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramResourceProperty = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NUM_COMPATIBLE_SUBROUTINES           := new ProgramResourceProperty($8E4A);
    private static _COMPATIBLE_SUBROUTINES               := new ProgramResourceProperty($8E4B);
    private static _UNIFORM                              := new ProgramResourceProperty($92E1);
    private static _IS_PER_PATCH                         := new ProgramResourceProperty($92E7);
    private static _NAME_LENGTH                          := new ProgramResourceProperty($92F9);
    private static _TYPE                                 := new ProgramResourceProperty($92FA);
    private static _ARRAY_SIZE                           := new ProgramResourceProperty($92FB);
    private static _OFFSET                               := new ProgramResourceProperty($92FC);
    private static _BLOCK_INDEX                          := new ProgramResourceProperty($92FD);
    private static _ARRAY_STRIDE                         := new ProgramResourceProperty($92FE);
    private static _MATRIX_STRIDE                        := new ProgramResourceProperty($92FF);
    private static _IS_ROW_MAJOR                         := new ProgramResourceProperty($9300);
    private static _ATOMIC_COUNTER_BUFFER_INDEX          := new ProgramResourceProperty($9301);
    private static _BUFFER_BINDING                       := new ProgramResourceProperty($9302);
    private static _BUFFER_DATA_SIZE                     := new ProgramResourceProperty($9303);
    private static _NUM_ACTIVE_VARIABLES                 := new ProgramResourceProperty($9304);
    private static _ACTIVE_VARIABLES                     := new ProgramResourceProperty($9305);
    private static _REFERENCED_BY_VERTEX_SHADER          := new ProgramResourceProperty($9306);
    private static _REFERENCED_BY_TESS_CONTROL_SHADER    := new ProgramResourceProperty($9307);
    private static _REFERENCED_BY_TESS_EVALUATION_SHADER := new ProgramResourceProperty($9308);
    private static _REFERENCED_BY_GEOMETRY_SHADER        := new ProgramResourceProperty($9309);
    private static _REFERENCED_BY_FRAGMENT_SHADER        := new ProgramResourceProperty($930A);
    private static _REFERENCED_BY_COMPUTE_SHADER         := new ProgramResourceProperty($930B);
    private static _TOP_LEVEL_ARRAY_SIZE                 := new ProgramResourceProperty($930C);
    private static _TOP_LEVEL_ARRAY_STRIDE               := new ProgramResourceProperty($930D);
    private static _LOCATION                             := new ProgramResourceProperty($930E);
    private static _LOCATION_INDEX                       := new ProgramResourceProperty($930F);
    private static _LOCATION_COMPONENT                   := new ProgramResourceProperty($934A);
    private static _TRANSFORM_FEEDBACK_BUFFER_INDEX      := new ProgramResourceProperty($934B);
    private static _TRANSFORM_FEEDBACK_BUFFER_STRIDE     := new ProgramResourceProperty($934C);
    
    public static property NUM_COMPATIBLE_SUBROUTINES:           ProgramResourceProperty read _NUM_COMPATIBLE_SUBROUTINES;
    public static property COMPATIBLE_SUBROUTINES:               ProgramResourceProperty read _COMPATIBLE_SUBROUTINES;
    public static property UNIFORM:                              ProgramResourceProperty read _UNIFORM;
    public static property IS_PER_PATCH:                         ProgramResourceProperty read _IS_PER_PATCH;
    public static property NAME_LENGTH:                          ProgramResourceProperty read _NAME_LENGTH;
    public static property &TYPE:                                ProgramResourceProperty read _TYPE;
    public static property ARRAY_SIZE:                           ProgramResourceProperty read _ARRAY_SIZE;
    public static property OFFSET:                               ProgramResourceProperty read _OFFSET;
    public static property BLOCK_INDEX:                          ProgramResourceProperty read _BLOCK_INDEX;
    public static property ARRAY_STRIDE:                         ProgramResourceProperty read _ARRAY_STRIDE;
    public static property MATRIX_STRIDE:                        ProgramResourceProperty read _MATRIX_STRIDE;
    public static property IS_ROW_MAJOR:                         ProgramResourceProperty read _IS_ROW_MAJOR;
    public static property ATOMIC_COUNTER_BUFFER_INDEX:          ProgramResourceProperty read _ATOMIC_COUNTER_BUFFER_INDEX;
    public static property BUFFER_BINDING:                       ProgramResourceProperty read _BUFFER_BINDING;
    public static property BUFFER_DATA_SIZE:                     ProgramResourceProperty read _BUFFER_DATA_SIZE;
    public static property NUM_ACTIVE_VARIABLES:                 ProgramResourceProperty read _NUM_ACTIVE_VARIABLES;
    public static property ACTIVE_VARIABLES:                     ProgramResourceProperty read _ACTIVE_VARIABLES;
    public static property REFERENCED_BY_VERTEX_SHADER:          ProgramResourceProperty read _REFERENCED_BY_VERTEX_SHADER;
    public static property REFERENCED_BY_TESS_CONTROL_SHADER:    ProgramResourceProperty read _REFERENCED_BY_TESS_CONTROL_SHADER;
    public static property REFERENCED_BY_TESS_EVALUATION_SHADER: ProgramResourceProperty read _REFERENCED_BY_TESS_EVALUATION_SHADER;
    public static property REFERENCED_BY_GEOMETRY_SHADER:        ProgramResourceProperty read _REFERENCED_BY_GEOMETRY_SHADER;
    public static property REFERENCED_BY_FRAGMENT_SHADER:        ProgramResourceProperty read _REFERENCED_BY_FRAGMENT_SHADER;
    public static property REFERENCED_BY_COMPUTE_SHADER:         ProgramResourceProperty read _REFERENCED_BY_COMPUTE_SHADER;
    public static property TOP_LEVEL_ARRAY_SIZE:                 ProgramResourceProperty read _TOP_LEVEL_ARRAY_SIZE;
    public static property TOP_LEVEL_ARRAY_STRIDE:               ProgramResourceProperty read _TOP_LEVEL_ARRAY_STRIDE;
    public static property LOCATION:                             ProgramResourceProperty read _LOCATION;
    public static property LOCATION_INDEX:                       ProgramResourceProperty read _LOCATION_INDEX;
    public static property LOCATION_COMPONENT:                   ProgramResourceProperty read _LOCATION_COMPONENT;
    public static property TRANSFORM_FEEDBACK_BUFFER_INDEX:      ProgramResourceProperty read _TRANSFORM_FEEDBACK_BUFFER_INDEX;
    public static property TRANSFORM_FEEDBACK_BUFFER_STRIDE:     ProgramResourceProperty read _TRANSFORM_FEEDBACK_BUFFER_STRIDE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramResourceProperty).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramResourceProperty(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramResourceProperty[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramStagePName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ACTIVE_SUBROUTINES                   := new ProgramStagePName($8DE5);
    private static _ACTIVE_SUBROUTINE_UNIFORMS           := new ProgramStagePName($8DE6);
    private static _ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS  := new ProgramStagePName($8E47);
    private static _ACTIVE_SUBROUTINE_MAX_LENGTH         := new ProgramStagePName($8E48);
    private static _ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH := new ProgramStagePName($8E49);
    
    public static property ACTIVE_SUBROUTINES:                   ProgramStagePName read _ACTIVE_SUBROUTINES;
    public static property ACTIVE_SUBROUTINE_UNIFORMS:           ProgramStagePName read _ACTIVE_SUBROUTINE_UNIFORMS;
    public static property ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS:  ProgramStagePName read _ACTIVE_SUBROUTINE_UNIFORM_LOCATIONS;
    public static property ACTIVE_SUBROUTINE_MAX_LENGTH:         ProgramStagePName read _ACTIVE_SUBROUTINE_MAX_LENGTH;
    public static property ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH: ProgramStagePName read _ACTIVE_SUBROUTINE_UNIFORM_MAX_LENGTH;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramStagePName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramStagePName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramStagePName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramStringProperty = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PROGRAM_STRING_ARB := new ProgramStringProperty($8628);
    
    public static property PROGRAM_STRING_ARB: ProgramStringProperty read _PROGRAM_STRING_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramStringProperty).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramStringProperty(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramStringProperty[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXT_FRAGMENT_SHADER_ATI   := new ProgramTarget($8200);
    private static _VERTEX_PROGRAM_ARB         := new ProgramTarget($8620);
    private static _FRAGMENT_PROGRAM_ARB       := new ProgramTarget($8804);
    private static _TESS_CONTROL_PROGRAM_NV    := new ProgramTarget($891E);
    private static _TESS_EVALUATION_PROGRAM_NV := new ProgramTarget($891F);
    private static _GEOMETRY_PROGRAM_NV        := new ProgramTarget($8C26);
    private static _COMPUTE_PROGRAM_NV         := new ProgramTarget($90FB);
    
    public static property TEXT_FRAGMENT_SHADER_ATI:   ProgramTarget read _TEXT_FRAGMENT_SHADER_ATI;
    public static property VERTEX_PROGRAM_ARB:         ProgramTarget read _VERTEX_PROGRAM_ARB;
    public static property FRAGMENT_PROGRAM_ARB:       ProgramTarget read _FRAGMENT_PROGRAM_ARB;
    public static property TESS_CONTROL_PROGRAM_NV:    ProgramTarget read _TESS_CONTROL_PROGRAM_NV;
    public static property TESS_EVALUATION_PROGRAM_NV: ProgramTarget read _TESS_EVALUATION_PROGRAM_NV;
    public static property GEOMETRY_PROGRAM_NV:        ProgramTarget read _GEOMETRY_PROGRAM_NV;
    public static property COMPUTE_PROGRAM_NV:         ProgramTarget read _COMPUTE_PROGRAM_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  QueryCounterTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TIMESTAMP := new QueryCounterTarget($8E28);
    
    public static property TIMESTAMP: QueryCounterTarget read _TIMESTAMP;
    
    public function ToString: string; override;
    begin
      var res := typeof(QueryCounterTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->QueryCounterTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'QueryCounterTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  QueryObjectParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _QUERY_TARGET           := new QueryObjectParameterName($82EA);
    private static _QUERY_RESULT           := new QueryObjectParameterName($8866);
    private static _QUERY_RESULT_AVAILABLE := new QueryObjectParameterName($8867);
    private static _QUERY_RESULT_NO_WAIT   := new QueryObjectParameterName($9194);
    
    public static property QUERY_TARGET:           QueryObjectParameterName read _QUERY_TARGET;
    public static property QUERY_RESULT:           QueryObjectParameterName read _QUERY_RESULT;
    public static property QUERY_RESULT_AVAILABLE: QueryObjectParameterName read _QUERY_RESULT_AVAILABLE;
    public static property QUERY_RESULT_NO_WAIT:   QueryObjectParameterName read _QUERY_RESULT_NO_WAIT;
    
    public function ToString: string; override;
    begin
      var res := typeof(QueryObjectParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->QueryObjectParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'QueryObjectParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  QueryParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _QUERY_COUNTER_BITS := new QueryParameterName($8864);
    private static _CURRENT_QUERY      := new QueryParameterName($8865);
    
    public static property QUERY_COUNTER_BITS: QueryParameterName read _QUERY_COUNTER_BITS;
    public static property CURRENT_QUERY:      QueryParameterName read _CURRENT_QUERY;
    
    public function ToString: string; override;
    begin
      var res := typeof(QueryParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->QueryParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'QueryParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  QueryTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TRANSFORM_FEEDBACK_OVERFLOW           := new QueryTarget($82EC);
    private static _VERTICES_SUBMITTED                    := new QueryTarget($82EE);
    private static _PRIMITIVES_SUBMITTED                  := new QueryTarget($82EF);
    private static _VERTEX_SHADER_INVOCATIONS             := new QueryTarget($82F0);
    private static _TIME_ELAPSED                          := new QueryTarget($88BF);
    private static _SAMPLES_PASSED                        := new QueryTarget($8914);
    private static _ANY_SAMPLES_PASSED                    := new QueryTarget($8C2F);
    private static _PRIMITIVES_GENERATED                  := new QueryTarget($8C87);
    private static _TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN := new QueryTarget($8C88);
    private static _ANY_SAMPLES_PASSED_CONSERVATIVE       := new QueryTarget($8D6A);
    
    public static property TRANSFORM_FEEDBACK_OVERFLOW:           QueryTarget read _TRANSFORM_FEEDBACK_OVERFLOW;
    public static property VERTICES_SUBMITTED:                    QueryTarget read _VERTICES_SUBMITTED;
    public static property PRIMITIVES_SUBMITTED:                  QueryTarget read _PRIMITIVES_SUBMITTED;
    public static property VERTEX_SHADER_INVOCATIONS:             QueryTarget read _VERTEX_SHADER_INVOCATIONS;
    public static property TIME_ELAPSED:                          QueryTarget read _TIME_ELAPSED;
    public static property SAMPLES_PASSED:                        QueryTarget read _SAMPLES_PASSED;
    public static property ANY_SAMPLES_PASSED:                    QueryTarget read _ANY_SAMPLES_PASSED;
    public static property PRIMITIVES_GENERATED:                  QueryTarget read _PRIMITIVES_GENERATED;
    public static property TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN: QueryTarget read _TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN;
    public static property ANY_SAMPLES_PASSED_CONSERVATIVE:       QueryTarget read _ANY_SAMPLES_PASSED_CONSERVATIVE;
    
    public function ToString: string; override;
    begin
      var res := typeof(QueryTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->QueryTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'QueryTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ReadBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE               := new ReadBufferMode($0000);
    private static _NONE_OES           := new ReadBufferMode($0000);
    private static _FRONT_LEFT         := new ReadBufferMode($0400);
    private static _FRONT_RIGHT        := new ReadBufferMode($0401);
    private static _BACK_LEFT          := new ReadBufferMode($0402);
    private static _BACK_RIGHT         := new ReadBufferMode($0403);
    private static _FRONT              := new ReadBufferMode($0404);
    private static _BACK               := new ReadBufferMode($0405);
    private static _LEFT               := new ReadBufferMode($0406);
    private static _RIGHT              := new ReadBufferMode($0407);
    private static _AUX0               := new ReadBufferMode($0409);
    private static _AUX1               := new ReadBufferMode($040A);
    private static _AUX2               := new ReadBufferMode($040B);
    private static _AUX3               := new ReadBufferMode($040C);
    private static _COLOR_ATTACHMENT0  := new ReadBufferMode($8CE0);
    private static _COLOR_ATTACHMENT1  := new ReadBufferMode($8CE1);
    private static _COLOR_ATTACHMENT2  := new ReadBufferMode($8CE2);
    private static _COLOR_ATTACHMENT3  := new ReadBufferMode($8CE3);
    private static _COLOR_ATTACHMENT4  := new ReadBufferMode($8CE4);
    private static _COLOR_ATTACHMENT5  := new ReadBufferMode($8CE5);
    private static _COLOR_ATTACHMENT6  := new ReadBufferMode($8CE6);
    private static _COLOR_ATTACHMENT7  := new ReadBufferMode($8CE7);
    private static _COLOR_ATTACHMENT8  := new ReadBufferMode($8CE8);
    private static _COLOR_ATTACHMENT9  := new ReadBufferMode($8CE9);
    private static _COLOR_ATTACHMENT10 := new ReadBufferMode($8CEA);
    private static _COLOR_ATTACHMENT11 := new ReadBufferMode($8CEB);
    private static _COLOR_ATTACHMENT12 := new ReadBufferMode($8CEC);
    private static _COLOR_ATTACHMENT13 := new ReadBufferMode($8CED);
    private static _COLOR_ATTACHMENT14 := new ReadBufferMode($8CEE);
    private static _COLOR_ATTACHMENT15 := new ReadBufferMode($8CEF);
    
    public static property NONE:               ReadBufferMode read _NONE;
    public static property NONE_OES:           ReadBufferMode read _NONE_OES;
    public static property FRONT_LEFT:         ReadBufferMode read _FRONT_LEFT;
    public static property FRONT_RIGHT:        ReadBufferMode read _FRONT_RIGHT;
    public static property BACK_LEFT:          ReadBufferMode read _BACK_LEFT;
    public static property BACK_RIGHT:         ReadBufferMode read _BACK_RIGHT;
    public static property FRONT:              ReadBufferMode read _FRONT;
    public static property BACK:               ReadBufferMode read _BACK;
    public static property LEFT:               ReadBufferMode read _LEFT;
    public static property RIGHT:              ReadBufferMode read _RIGHT;
    public static property AUX0:               ReadBufferMode read _AUX0;
    public static property AUX1:               ReadBufferMode read _AUX1;
    public static property AUX2:               ReadBufferMode read _AUX2;
    public static property AUX3:               ReadBufferMode read _AUX3;
    public static property COLOR_ATTACHMENT0:  ReadBufferMode read _COLOR_ATTACHMENT0;
    public static property COLOR_ATTACHMENT1:  ReadBufferMode read _COLOR_ATTACHMENT1;
    public static property COLOR_ATTACHMENT2:  ReadBufferMode read _COLOR_ATTACHMENT2;
    public static property COLOR_ATTACHMENT3:  ReadBufferMode read _COLOR_ATTACHMENT3;
    public static property COLOR_ATTACHMENT4:  ReadBufferMode read _COLOR_ATTACHMENT4;
    public static property COLOR_ATTACHMENT5:  ReadBufferMode read _COLOR_ATTACHMENT5;
    public static property COLOR_ATTACHMENT6:  ReadBufferMode read _COLOR_ATTACHMENT6;
    public static property COLOR_ATTACHMENT7:  ReadBufferMode read _COLOR_ATTACHMENT7;
    public static property COLOR_ATTACHMENT8:  ReadBufferMode read _COLOR_ATTACHMENT8;
    public static property COLOR_ATTACHMENT9:  ReadBufferMode read _COLOR_ATTACHMENT9;
    public static property COLOR_ATTACHMENT10: ReadBufferMode read _COLOR_ATTACHMENT10;
    public static property COLOR_ATTACHMENT11: ReadBufferMode read _COLOR_ATTACHMENT11;
    public static property COLOR_ATTACHMENT12: ReadBufferMode read _COLOR_ATTACHMENT12;
    public static property COLOR_ATTACHMENT13: ReadBufferMode read _COLOR_ATTACHMENT13;
    public static property COLOR_ATTACHMENT14: ReadBufferMode read _COLOR_ATTACHMENT14;
    public static property COLOR_ATTACHMENT15: ReadBufferMode read _COLOR_ATTACHMENT15;
    
    public function ToString: string; override;
    begin
      var res := typeof(ReadBufferMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ReadBufferMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ReadBufferMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  RenderbufferParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _RENDERBUFFER_COVERAGE_SAMPLES_NV := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_SAMPLES             := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_SAMPLES_ANGLE       := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_SAMPLES_APPLE       := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_SAMPLES_EXT         := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_SAMPLES_NV          := new RenderbufferParameterName($8CAB);
    private static _RENDERBUFFER_WIDTH               := new RenderbufferParameterName($8D42);
    private static _RENDERBUFFER_WIDTH_EXT           := new RenderbufferParameterName($8D42);
    private static _RENDERBUFFER_WIDTH_OES           := new RenderbufferParameterName($8D42);
    private static _RENDERBUFFER_HEIGHT              := new RenderbufferParameterName($8D43);
    private static _RENDERBUFFER_HEIGHT_EXT          := new RenderbufferParameterName($8D43);
    private static _RENDERBUFFER_HEIGHT_OES          := new RenderbufferParameterName($8D43);
    private static _RENDERBUFFER_INTERNAL_FORMAT     := new RenderbufferParameterName($8D44);
    private static _RENDERBUFFER_INTERNAL_FORMAT_EXT := new RenderbufferParameterName($8D44);
    private static _RENDERBUFFER_INTERNAL_FORMAT_OES := new RenderbufferParameterName($8D44);
    private static _RENDERBUFFER_RED_SIZE            := new RenderbufferParameterName($8D50);
    private static _RENDERBUFFER_RED_SIZE_EXT        := new RenderbufferParameterName($8D50);
    private static _RENDERBUFFER_RED_SIZE_OES        := new RenderbufferParameterName($8D50);
    private static _RENDERBUFFER_GREEN_SIZE          := new RenderbufferParameterName($8D51);
    private static _RENDERBUFFER_GREEN_SIZE_EXT      := new RenderbufferParameterName($8D51);
    private static _RENDERBUFFER_GREEN_SIZE_OES      := new RenderbufferParameterName($8D51);
    private static _RENDERBUFFER_BLUE_SIZE           := new RenderbufferParameterName($8D52);
    private static _RENDERBUFFER_BLUE_SIZE_EXT       := new RenderbufferParameterName($8D52);
    private static _RENDERBUFFER_BLUE_SIZE_OES       := new RenderbufferParameterName($8D52);
    private static _RENDERBUFFER_ALPHA_SIZE          := new RenderbufferParameterName($8D53);
    private static _RENDERBUFFER_ALPHA_SIZE_EXT      := new RenderbufferParameterName($8D53);
    private static _RENDERBUFFER_ALPHA_SIZE_OES      := new RenderbufferParameterName($8D53);
    private static _RENDERBUFFER_DEPTH_SIZE          := new RenderbufferParameterName($8D54);
    private static _RENDERBUFFER_DEPTH_SIZE_EXT      := new RenderbufferParameterName($8D54);
    private static _RENDERBUFFER_DEPTH_SIZE_OES      := new RenderbufferParameterName($8D54);
    private static _RENDERBUFFER_STENCIL_SIZE        := new RenderbufferParameterName($8D55);
    private static _RENDERBUFFER_STENCIL_SIZE_EXT    := new RenderbufferParameterName($8D55);
    private static _RENDERBUFFER_STENCIL_SIZE_OES    := new RenderbufferParameterName($8D55);
    private static _RENDERBUFFER_COLOR_SAMPLES_NV    := new RenderbufferParameterName($8E10);
    private static _RENDERBUFFER_SAMPLES_IMG         := new RenderbufferParameterName($9133);
    private static _RENDERBUFFER_STORAGE_SAMPLES_AMD := new RenderbufferParameterName($91B2);
    
    public static property RENDERBUFFER_COVERAGE_SAMPLES_NV: RenderbufferParameterName read _RENDERBUFFER_COVERAGE_SAMPLES_NV;
    public static property RENDERBUFFER_SAMPLES:             RenderbufferParameterName read _RENDERBUFFER_SAMPLES;
    public static property RENDERBUFFER_SAMPLES_ANGLE:       RenderbufferParameterName read _RENDERBUFFER_SAMPLES_ANGLE;
    public static property RENDERBUFFER_SAMPLES_APPLE:       RenderbufferParameterName read _RENDERBUFFER_SAMPLES_APPLE;
    public static property RENDERBUFFER_SAMPLES_EXT:         RenderbufferParameterName read _RENDERBUFFER_SAMPLES_EXT;
    public static property RENDERBUFFER_SAMPLES_NV:          RenderbufferParameterName read _RENDERBUFFER_SAMPLES_NV;
    public static property RENDERBUFFER_WIDTH:               RenderbufferParameterName read _RENDERBUFFER_WIDTH;
    public static property RENDERBUFFER_WIDTH_EXT:           RenderbufferParameterName read _RENDERBUFFER_WIDTH_EXT;
    public static property RENDERBUFFER_WIDTH_OES:           RenderbufferParameterName read _RENDERBUFFER_WIDTH_OES;
    public static property RENDERBUFFER_HEIGHT:              RenderbufferParameterName read _RENDERBUFFER_HEIGHT;
    public static property RENDERBUFFER_HEIGHT_EXT:          RenderbufferParameterName read _RENDERBUFFER_HEIGHT_EXT;
    public static property RENDERBUFFER_HEIGHT_OES:          RenderbufferParameterName read _RENDERBUFFER_HEIGHT_OES;
    public static property RENDERBUFFER_INTERNAL_FORMAT:     RenderbufferParameterName read _RENDERBUFFER_INTERNAL_FORMAT;
    public static property RENDERBUFFER_INTERNAL_FORMAT_EXT: RenderbufferParameterName read _RENDERBUFFER_INTERNAL_FORMAT_EXT;
    public static property RENDERBUFFER_INTERNAL_FORMAT_OES: RenderbufferParameterName read _RENDERBUFFER_INTERNAL_FORMAT_OES;
    public static property RENDERBUFFER_RED_SIZE:            RenderbufferParameterName read _RENDERBUFFER_RED_SIZE;
    public static property RENDERBUFFER_RED_SIZE_EXT:        RenderbufferParameterName read _RENDERBUFFER_RED_SIZE_EXT;
    public static property RENDERBUFFER_RED_SIZE_OES:        RenderbufferParameterName read _RENDERBUFFER_RED_SIZE_OES;
    public static property RENDERBUFFER_GREEN_SIZE:          RenderbufferParameterName read _RENDERBUFFER_GREEN_SIZE;
    public static property RENDERBUFFER_GREEN_SIZE_EXT:      RenderbufferParameterName read _RENDERBUFFER_GREEN_SIZE_EXT;
    public static property RENDERBUFFER_GREEN_SIZE_OES:      RenderbufferParameterName read _RENDERBUFFER_GREEN_SIZE_OES;
    public static property RENDERBUFFER_BLUE_SIZE:           RenderbufferParameterName read _RENDERBUFFER_BLUE_SIZE;
    public static property RENDERBUFFER_BLUE_SIZE_EXT:       RenderbufferParameterName read _RENDERBUFFER_BLUE_SIZE_EXT;
    public static property RENDERBUFFER_BLUE_SIZE_OES:       RenderbufferParameterName read _RENDERBUFFER_BLUE_SIZE_OES;
    public static property RENDERBUFFER_ALPHA_SIZE:          RenderbufferParameterName read _RENDERBUFFER_ALPHA_SIZE;
    public static property RENDERBUFFER_ALPHA_SIZE_EXT:      RenderbufferParameterName read _RENDERBUFFER_ALPHA_SIZE_EXT;
    public static property RENDERBUFFER_ALPHA_SIZE_OES:      RenderbufferParameterName read _RENDERBUFFER_ALPHA_SIZE_OES;
    public static property RENDERBUFFER_DEPTH_SIZE:          RenderbufferParameterName read _RENDERBUFFER_DEPTH_SIZE;
    public static property RENDERBUFFER_DEPTH_SIZE_EXT:      RenderbufferParameterName read _RENDERBUFFER_DEPTH_SIZE_EXT;
    public static property RENDERBUFFER_DEPTH_SIZE_OES:      RenderbufferParameterName read _RENDERBUFFER_DEPTH_SIZE_OES;
    public static property RENDERBUFFER_STENCIL_SIZE:        RenderbufferParameterName read _RENDERBUFFER_STENCIL_SIZE;
    public static property RENDERBUFFER_STENCIL_SIZE_EXT:    RenderbufferParameterName read _RENDERBUFFER_STENCIL_SIZE_EXT;
    public static property RENDERBUFFER_STENCIL_SIZE_OES:    RenderbufferParameterName read _RENDERBUFFER_STENCIL_SIZE_OES;
    public static property RENDERBUFFER_COLOR_SAMPLES_NV:    RenderbufferParameterName read _RENDERBUFFER_COLOR_SAMPLES_NV;
    public static property RENDERBUFFER_SAMPLES_IMG:         RenderbufferParameterName read _RENDERBUFFER_SAMPLES_IMG;
    public static property RENDERBUFFER_STORAGE_SAMPLES_AMD: RenderbufferParameterName read _RENDERBUFFER_STORAGE_SAMPLES_AMD;
    
    public function ToString: string; override;
    begin
      var res := typeof(RenderbufferParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->RenderbufferParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'RenderbufferParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  RenderbufferTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _RENDERBUFFER     := new RenderbufferTarget($8D41);
    private static _RENDERBUFFER_OES := new RenderbufferTarget($8D41);
    
    public static property RENDERBUFFER:     RenderbufferTarget read _RENDERBUFFER;
    public static property RENDERBUFFER_OES: RenderbufferTarget read _RENDERBUFFER_OES;
    
    public function ToString: string; override;
    begin
      var res := typeof(RenderbufferTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->RenderbufferTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'RenderbufferTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  RenderingMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _RENDER   := new RenderingMode($1C00);
    private static _FEEDBACK := new RenderingMode($1C01);
    private static _SELECT   := new RenderingMode($1C02);
    
    public static property RENDER:   RenderingMode read _RENDER;
    public static property FEEDBACK: RenderingMode read _FEEDBACK;
    public static property SELECT:   RenderingMode read _SELECT;
    
    public function ToString: string; override;
    begin
      var res := typeof(RenderingMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->RenderingMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'RenderingMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SamplerParameterF = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_BORDER_COLOR                 := new SamplerParameterF($1004);
    private static _TEXTURE_MIN_LOD                      := new SamplerParameterF($813A);
    private static _TEXTURE_MAX_LOD                      := new SamplerParameterF($813B);
    private static _TEXTURE_MAX_ANISOTROPY               := new SamplerParameterF($84FE);
    private static _TEXTURE_UNNORMALIZED_COORDINATES_ARM := new SamplerParameterF($8F6A);
    
    public static property TEXTURE_BORDER_COLOR:                 SamplerParameterF read _TEXTURE_BORDER_COLOR;
    public static property TEXTURE_MIN_LOD:                      SamplerParameterF read _TEXTURE_MIN_LOD;
    public static property TEXTURE_MAX_LOD:                      SamplerParameterF read _TEXTURE_MAX_LOD;
    public static property TEXTURE_MAX_ANISOTROPY:               SamplerParameterF read _TEXTURE_MAX_ANISOTROPY;
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: SamplerParameterF read _TEXTURE_UNNORMALIZED_COORDINATES_ARM;
    
    public function ToString: string; override;
    begin
      var res := typeof(SamplerParameterF).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SamplerParameterF(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SamplerParameterF[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SamplerParameterI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_MAG_FILTER                   := new SamplerParameterI($2800);
    private static _TEXTURE_MIN_FILTER                   := new SamplerParameterI($2801);
    private static _TEXTURE_WRAP_S                       := new SamplerParameterI($2802);
    private static _TEXTURE_WRAP_T                       := new SamplerParameterI($2803);
    private static _TEXTURE_WRAP_R                       := new SamplerParameterI($8072);
    private static _TEXTURE_COMPARE_MODE                 := new SamplerParameterI($884C);
    private static _TEXTURE_COMPARE_FUNC                 := new SamplerParameterI($884D);
    private static _TEXTURE_UNNORMALIZED_COORDINATES_ARM := new SamplerParameterI($8F6A);
    
    public static property TEXTURE_MAG_FILTER:                   SamplerParameterI read _TEXTURE_MAG_FILTER;
    public static property TEXTURE_MIN_FILTER:                   SamplerParameterI read _TEXTURE_MIN_FILTER;
    public static property TEXTURE_WRAP_S:                       SamplerParameterI read _TEXTURE_WRAP_S;
    public static property TEXTURE_WRAP_T:                       SamplerParameterI read _TEXTURE_WRAP_T;
    public static property TEXTURE_WRAP_R:                       SamplerParameterI read _TEXTURE_WRAP_R;
    public static property TEXTURE_COMPARE_MODE:                 SamplerParameterI read _TEXTURE_COMPARE_MODE;
    public static property TEXTURE_COMPARE_FUNC:                 SamplerParameterI read _TEXTURE_COMPARE_FUNC;
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: SamplerParameterI read _TEXTURE_UNNORMALIZED_COORDINATES_ARM;
    
    public function ToString: string; override;
    begin
      var res := typeof(SamplerParameterI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SamplerParameterI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SamplerParameterI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ScalarType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_BYTE  := new ScalarType($1401);
    private static _UNSIGNED_SHORT := new ScalarType($1403);
    private static _UNSIGNED_INT   := new ScalarType($1405);
    
    public static property UNSIGNED_BYTE:  ScalarType read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: ScalarType read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   ScalarType read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ScalarType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ScalarType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ScalarType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SemaphoreParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _D3D12_FENCE_VALUE_EXT := new SemaphoreParameterName($9595);
    
    public static property D3D12_FENCE_VALUE_EXT: SemaphoreParameterName read _D3D12_FENCE_VALUE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(SemaphoreParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SemaphoreParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SemaphoreParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ShaderParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SHADER_TYPE          := new ShaderParameterName($8B4F);
    private static _DELETE_STATUS        := new ShaderParameterName($8B80);
    private static _COMPILE_STATUS       := new ShaderParameterName($8B81);
    private static _INFO_LOG_LENGTH      := new ShaderParameterName($8B84);
    private static _SHADER_SOURCE_LENGTH := new ShaderParameterName($8B88);
    
    public static property SHADER_TYPE:          ShaderParameterName read _SHADER_TYPE;
    public static property DELETE_STATUS:        ShaderParameterName read _DELETE_STATUS;
    public static property COMPILE_STATUS:       ShaderParameterName read _COMPILE_STATUS;
    public static property INFO_LOG_LENGTH:      ShaderParameterName read _INFO_LOG_LENGTH;
    public static property SHADER_SOURCE_LENGTH: ShaderParameterName read _SHADER_SOURCE_LENGTH;
    
    public function ToString: string; override;
    begin
      var res := typeof(ShaderParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ShaderParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ShaderParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ShaderType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAGMENT_SHADER        := new ShaderType($8B30);
    private static _FRAGMENT_SHADER_ARB    := new ShaderType($8B30);
    private static _VERTEX_SHADER          := new ShaderType($8B31);
    private static _VERTEX_SHADER_ARB      := new ShaderType($8B31);
    private static _GEOMETRY_SHADER        := new ShaderType($8DD9);
    private static _TESS_EVALUATION_SHADER := new ShaderType($8E87);
    private static _TESS_CONTROL_SHADER    := new ShaderType($8E88);
    private static _COMPUTE_SHADER         := new ShaderType($91B9);
    
    public static property FRAGMENT_SHADER:        ShaderType read _FRAGMENT_SHADER;
    public static property FRAGMENT_SHADER_ARB:    ShaderType read _FRAGMENT_SHADER_ARB;
    public static property VERTEX_SHADER:          ShaderType read _VERTEX_SHADER;
    public static property VERTEX_SHADER_ARB:      ShaderType read _VERTEX_SHADER_ARB;
    public static property GEOMETRY_SHADER:        ShaderType read _GEOMETRY_SHADER;
    public static property TESS_EVALUATION_SHADER: ShaderType read _TESS_EVALUATION_SHADER;
    public static property TESS_CONTROL_SHADER:    ShaderType read _TESS_CONTROL_SHADER;
    public static property COMPUTE_SHADER:         ShaderType read _COMPUTE_SHADER;
    
    public function ToString: string; override;
    begin
      var res := typeof(ShaderType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ShaderType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ShaderType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ShadingModel = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLAT   := new ShadingModel($1D00);
    private static _SMOOTH := new ShadingModel($1D01);
    
    public static property FLAT:   ShadingModel read _FLAT;
    public static property SMOOTH: ShadingModel read _SMOOTH;
    
    public function ToString: string; override;
    begin
      var res := typeof(ShadingModel).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ShadingModel(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ShadingModel[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  StencilFaceDirection = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRONT          := new StencilFaceDirection($0404);
    private static _BACK           := new StencilFaceDirection($0405);
    private static _FRONT_AND_BACK := new StencilFaceDirection($0408);
    
    public static property FRONT:          StencilFaceDirection read _FRONT;
    public static property BACK:           StencilFaceDirection read _BACK;
    public static property FRONT_AND_BACK: StencilFaceDirection read _FRONT_AND_BACK;
    
    public function ToString: string; override;
    begin
      var res := typeof(StencilFaceDirection).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->StencilFaceDirection(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'StencilFaceDirection[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  StencilFunction = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEVER    := new StencilFunction($0200);
    private static _LESS     := new StencilFunction($0201);
    private static _EQUAL    := new StencilFunction($0202);
    private static _LEQUAL   := new StencilFunction($0203);
    private static _GREATER  := new StencilFunction($0204);
    private static _NOTEQUAL := new StencilFunction($0205);
    private static _GEQUAL   := new StencilFunction($0206);
    private static _ALWAYS   := new StencilFunction($0207);
    
    public static property NEVER:    StencilFunction read _NEVER;
    public static property LESS:     StencilFunction read _LESS;
    public static property EQUAL:    StencilFunction read _EQUAL;
    public static property LEQUAL:   StencilFunction read _LEQUAL;
    public static property GREATER:  StencilFunction read _GREATER;
    public static property NOTEQUAL: StencilFunction read _NOTEQUAL;
    public static property GEQUAL:   StencilFunction read _GEQUAL;
    public static property ALWAYS:   StencilFunction read _ALWAYS;
    
    public function ToString: string; override;
    begin
      var res := typeof(StencilFunction).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->StencilFunction(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'StencilFunction[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  StencilOp = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ZERO      := new StencilOp($0000);
    private static _INVERT    := new StencilOp($150A);
    private static _KEEP      := new StencilOp($1E00);
    private static _REPLACE   := new StencilOp($1E01);
    private static _INCR      := new StencilOp($1E02);
    private static _DECR      := new StencilOp($1E03);
    private static _INCR_WRAP := new StencilOp($8507);
    private static _DECR_WRAP := new StencilOp($8508);
    
    public static property ZERO:      StencilOp read _ZERO;
    public static property INVERT:    StencilOp read _INVERT;
    public static property KEEP:      StencilOp read _KEEP;
    public static property REPLACE:   StencilOp read _REPLACE;
    public static property INCR:      StencilOp read _INCR;
    public static property DECR:      StencilOp read _DECR;
    public static property INCR_WRAP: StencilOp read _INCR_WRAP;
    public static property DECR_WRAP: StencilOp read _DECR_WRAP;
    
    public function ToString: string; override;
    begin
      var res := typeof(StencilOp).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->StencilOp(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'StencilOp[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  StringName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VENDOR                   := new StringName($1F00);
    private static _RENDERER                 := new StringName($1F01);
    private static _VERSION                  := new StringName($1F02);
    private static _EXTENSIONS               := new StringName($1F03);
    private static _SHADING_LANGUAGE_VERSION := new StringName($8B8C);
    
    public static property VENDOR:                   StringName read _VENDOR;
    public static property RENDERER:                 StringName read _RENDERER;
    public static property VERSION:                  StringName read _VERSION;
    public static property EXTENSIONS:               StringName read _EXTENSIONS;
    public static property SHADING_LANGUAGE_VERSION: StringName read _SHADING_LANGUAGE_VERSION;
    
    public function ToString: string; override;
    begin
      var res := typeof(StringName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->StringName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'StringName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SubroutineParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNIFORM_SIZE               := new SubroutineParameterName($8A38);
    private static _UNIFORM_NAME_LENGTH        := new SubroutineParameterName($8A39);
    private static _NUM_COMPATIBLE_SUBROUTINES := new SubroutineParameterName($8E4A);
    private static _COMPATIBLE_SUBROUTINES     := new SubroutineParameterName($8E4B);
    
    public static property UNIFORM_SIZE:               SubroutineParameterName read _UNIFORM_SIZE;
    public static property UNIFORM_NAME_LENGTH:        SubroutineParameterName read _UNIFORM_NAME_LENGTH;
    public static property NUM_COMPATIBLE_SUBROUTINES: SubroutineParameterName read _NUM_COMPATIBLE_SUBROUTINES;
    public static property COMPATIBLE_SUBROUTINES:     SubroutineParameterName read _COMPATIBLE_SUBROUTINES;
    
    public function ToString: string; override;
    begin
      var res := typeof(SubroutineParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SubroutineParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SubroutineParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SyncCondition = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SYNC_GPU_COMMANDS_COMPLETE := new SyncCondition($9117);
    
    public static property SYNC_GPU_COMMANDS_COMPLETE: SyncCondition read _SYNC_GPU_COMMANDS_COMPLETE;
    
    public function ToString: string; override;
    begin
      var res := typeof(SyncCondition).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SyncCondition(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SyncCondition[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SyncObjectMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SYNC_FLUSH_COMMANDS_BIT       := new SyncObjectMask($0001);
    private static _SYNC_FLUSH_COMMANDS_BIT_APPLE := new SyncObjectMask($0001);
    
    public static property SYNC_FLUSH_COMMANDS_BIT:       SyncObjectMask read _SYNC_FLUSH_COMMANDS_BIT;
    public static property SYNC_FLUSH_COMMANDS_BIT_APPLE: SyncObjectMask read _SYNC_FLUSH_COMMANDS_BIT_APPLE;
    
    public static function operator or(f1,f2: SyncObjectMask) := new SyncObjectMask(f1.val or f2.val);
    
    public property HAS_FLAG_SYNC_FLUSH_COMMANDS_BIT:       boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_SYNC_FLUSH_COMMANDS_BIT_APPLE: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(SyncObjectMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'SyncObjectMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  SyncParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _OBJECT_TYPE    := new SyncParameterName($9112);
    private static _SYNC_CONDITION := new SyncParameterName($9113);
    private static _SYNC_STATUS    := new SyncParameterName($9114);
    private static _SYNC_FLAGS     := new SyncParameterName($9115);
    
    public static property OBJECT_TYPE:    SyncParameterName read _OBJECT_TYPE;
    public static property SYNC_CONDITION: SyncParameterName read _SYNC_CONDITION;
    public static property SYNC_STATUS:    SyncParameterName read _SYNC_STATUS;
    public static property SYNC_FLAGS:     SyncParameterName read _SYNC_FLAGS;
    
    public function ToString: string; override;
    begin
      var res := typeof(SyncParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SyncParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SyncParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SyncStatus = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ALREADY_SIGNALED    := new SyncStatus($911A);
    private static _TIMEOUT_EXPIRED     := new SyncStatus($911B);
    private static _CONDITION_SATISFIED := new SyncStatus($911C);
    private static _WAIT_FAILED         := new SyncStatus($911D);
    
    public static property ALREADY_SIGNALED:    SyncStatus read _ALREADY_SIGNALED;
    public static property TIMEOUT_EXPIRED:     SyncStatus read _TIMEOUT_EXPIRED;
    public static property CONDITION_SATISFIED: SyncStatus read _CONDITION_SATISFIED;
    public static property WAIT_FAILED:         SyncStatus read _WAIT_FAILED;
    
    public function ToString: string; override;
    begin
      var res := typeof(SyncStatus).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SyncStatus(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SyncStatus[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TexCoordPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SHORT  := new TexCoordPointerType($1402);
    private static _INT    := new TexCoordPointerType($1404);
    private static _FLOAT  := new TexCoordPointerType($1406);
    private static _DOUBLE := new TexCoordPointerType($140A);
    
    public static property SHORT:  TexCoordPointerType read _SHORT;
    public static property INT:    TexCoordPointerType read _INT;
    public static property FLOAT:  TexCoordPointerType read _FLOAT;
    public static property DOUBLE: TexCoordPointerType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(TexCoordPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TexCoordPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TexCoordPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureCoordName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _S := new TextureCoordName($2000);
    private static _T := new TextureCoordName($2001);
    private static _R := new TextureCoordName($2002);
    private static _Q := new TextureCoordName($2003);
    
    public static property S: TextureCoordName read _S;
    public static property T: TextureCoordName read _T;
    public static property R: TextureCoordName read _R;
    public static property Q: TextureCoordName read _Q;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureCoordName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureCoordName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureCoordName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureEnvParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_ENV_MODE  := new TextureEnvParameter($2200);
    private static _TEXTURE_ENV_COLOR := new TextureEnvParameter($2201);
    
    public static property TEXTURE_ENV_MODE:  TextureEnvParameter read _TEXTURE_ENV_MODE;
    public static property TEXTURE_ENV_COLOR: TextureEnvParameter read _TEXTURE_ENV_COLOR;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureEnvParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureEnvParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureEnvParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureEnvTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_ENV := new TextureEnvTarget($2300);
    
    public static property TEXTURE_ENV: TextureEnvTarget read _TEXTURE_ENV;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureEnvTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureEnvTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureEnvTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureGenParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_GEN_MODE  := new TextureGenParameter($2500);
    private static _OBJECT_PLANE      := new TextureGenParameter($2501);
    private static _EYE_PLANE         := new TextureGenParameter($2502);
    private static _EYE_POINT_SGIS    := new TextureGenParameter($81F4);
    private static _OBJECT_POINT_SGIS := new TextureGenParameter($81F5);
    private static _EYE_LINE_SGIS     := new TextureGenParameter($81F6);
    private static _OBJECT_LINE_SGIS  := new TextureGenParameter($81F7);
    
    public static property TEXTURE_GEN_MODE:  TextureGenParameter read _TEXTURE_GEN_MODE;
    public static property OBJECT_PLANE:      TextureGenParameter read _OBJECT_PLANE;
    public static property EYE_PLANE:         TextureGenParameter read _EYE_PLANE;
    public static property EYE_POINT_SGIS:    TextureGenParameter read _EYE_POINT_SGIS;
    public static property OBJECT_POINT_SGIS: TextureGenParameter read _OBJECT_POINT_SGIS;
    public static property EYE_LINE_SGIS:     TextureGenParameter read _EYE_LINE_SGIS;
    public static property OBJECT_LINE_SGIS:  TextureGenParameter read _OBJECT_LINE_SGIS;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureGenParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureGenParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureGenParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureLayout = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT := new TextureLayout($9530);
    private static _LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT := new TextureLayout($9531);
    private static _LAYOUT_GENERAL_EXT                            := new TextureLayout($958D);
    private static _LAYOUT_COLOR_ATTACHMENT_EXT                   := new TextureLayout($958E);
    private static _LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT           := new TextureLayout($958F);
    private static _LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT            := new TextureLayout($9590);
    private static _LAYOUT_SHADER_READ_ONLY_EXT                   := new TextureLayout($9591);
    private static _LAYOUT_TRANSFER_SRC_EXT                       := new TextureLayout($9592);
    private static _LAYOUT_TRANSFER_DST_EXT                       := new TextureLayout($9593);
    
    public static property LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT: TextureLayout read _LAYOUT_DEPTH_READ_ONLY_STENCIL_ATTACHMENT_EXT;
    public static property LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT: TextureLayout read _LAYOUT_DEPTH_ATTACHMENT_STENCIL_READ_ONLY_EXT;
    public static property LAYOUT_GENERAL_EXT:                            TextureLayout read _LAYOUT_GENERAL_EXT;
    public static property LAYOUT_COLOR_ATTACHMENT_EXT:                   TextureLayout read _LAYOUT_COLOR_ATTACHMENT_EXT;
    public static property LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT:           TextureLayout read _LAYOUT_DEPTH_STENCIL_ATTACHMENT_EXT;
    public static property LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT:            TextureLayout read _LAYOUT_DEPTH_STENCIL_READ_ONLY_EXT;
    public static property LAYOUT_SHADER_READ_ONLY_EXT:                   TextureLayout read _LAYOUT_SHADER_READ_ONLY_EXT;
    public static property LAYOUT_TRANSFER_SRC_EXT:                       TextureLayout read _LAYOUT_TRANSFER_SRC_EXT;
    public static property LAYOUT_TRANSFER_DST_EXT:                       TextureLayout read _LAYOUT_TRANSFER_DST_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureLayout).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureLayout(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureLayout[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureParameterName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_WIDTH                        := new TextureParameterName($1000);
    private static _TEXTURE_HEIGHT                       := new TextureParameterName($1001);
    private static _TEXTURE_COMPONENTS                   := new TextureParameterName($1003);
    private static _TEXTURE_INTERNAL_FORMAT              := new TextureParameterName($1003);
    private static _TEXTURE_BORDER_COLOR                 := new TextureParameterName($1004);
    private static _TEXTURE_BORDER_COLOR_NV              := new TextureParameterName($1004);
    private static _TEXTURE_BORDER                       := new TextureParameterName($1005);
    private static _TEXTURE_MAG_FILTER                   := new TextureParameterName($2800);
    private static _TEXTURE_MIN_FILTER                   := new TextureParameterName($2801);
    private static _TEXTURE_WRAP_S                       := new TextureParameterName($2802);
    private static _TEXTURE_WRAP_T                       := new TextureParameterName($2803);
    private static _TEXTURE_RED_SIZE                     := new TextureParameterName($805C);
    private static _TEXTURE_GREEN_SIZE                   := new TextureParameterName($805D);
    private static _TEXTURE_BLUE_SIZE                    := new TextureParameterName($805E);
    private static _TEXTURE_ALPHA_SIZE                   := new TextureParameterName($805F);
    private static _TEXTURE_LUMINANCE_SIZE               := new TextureParameterName($8060);
    private static _TEXTURE_INTENSITY_SIZE               := new TextureParameterName($8061);
    private static _TEXTURE_PRIORITY                     := new TextureParameterName($8066);
    private static _TEXTURE_PRIORITY_EXT                 := new TextureParameterName($8066);
    private static _TEXTURE_RESIDENT                     := new TextureParameterName($8067);
    private static _TEXTURE_DEPTH_EXT                    := new TextureParameterName($8071);
    private static _TEXTURE_WRAP_R                       := new TextureParameterName($8072);
    private static _TEXTURE_WRAP_R_EXT                   := new TextureParameterName($8072);
    private static _TEXTURE_WRAP_R_OES                   := new TextureParameterName($8072);
    private static _DETAIL_TEXTURE_LEVEL_SGIS            := new TextureParameterName($809A);
    private static _DETAIL_TEXTURE_MODE_SGIS             := new TextureParameterName($809B);
    private static _DETAIL_TEXTURE_FUNC_POINTS_SGIS      := new TextureParameterName($809C);
    private static _SHARPEN_TEXTURE_FUNC_POINTS_SGIS     := new TextureParameterName($80B0);
    private static _SHADOW_AMBIENT_SGIX                  := new TextureParameterName($80BF);
    private static _DUAL_TEXTURE_SELECT_SGIS             := new TextureParameterName($8124);
    private static _QUAD_TEXTURE_SELECT_SGIS             := new TextureParameterName($8125);
    private static _TEXTURE_4DSIZE_SGIS                  := new TextureParameterName($8136);
    private static _TEXTURE_WRAP_Q_SGIS                  := new TextureParameterName($8137);
    private static _TEXTURE_MIN_LOD                      := new TextureParameterName($813A);
    private static _TEXTURE_MIN_LOD_SGIS                 := new TextureParameterName($813A);
    private static _TEXTURE_MAX_LOD                      := new TextureParameterName($813B);
    private static _TEXTURE_MAX_LOD_SGIS                 := new TextureParameterName($813B);
    private static _TEXTURE_BASE_LEVEL                   := new TextureParameterName($813C);
    private static _TEXTURE_BASE_LEVEL_SGIS              := new TextureParameterName($813C);
    private static _TEXTURE_MAX_LEVEL                    := new TextureParameterName($813D);
    private static _TEXTURE_MAX_LEVEL_SGIS               := new TextureParameterName($813D);
    private static _TEXTURE_FILTER4_SIZE_SGIS            := new TextureParameterName($8147);
    private static _TEXTURE_CLIPMAP_CENTER_SGIX          := new TextureParameterName($8171);
    private static _TEXTURE_CLIPMAP_FRAME_SGIX           := new TextureParameterName($8172);
    private static _TEXTURE_CLIPMAP_OFFSET_SGIX          := new TextureParameterName($8173);
    private static _TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX   := new TextureParameterName($8174);
    private static _TEXTURE_CLIPMAP_LOD_OFFSET_SGIX      := new TextureParameterName($8175);
    private static _TEXTURE_CLIPMAP_DEPTH_SGIX           := new TextureParameterName($8176);
    private static _POST_TEXTURE_FILTER_BIAS_SGIX        := new TextureParameterName($8179);
    private static _POST_TEXTURE_FILTER_SCALE_SGIX       := new TextureParameterName($817A);
    private static _TEXTURE_LOD_BIAS_S_SGIX              := new TextureParameterName($818E);
    private static _TEXTURE_LOD_BIAS_T_SGIX              := new TextureParameterName($818F);
    private static _TEXTURE_LOD_BIAS_R_SGIX              := new TextureParameterName($8190);
    private static _GENERATE_MIPMAP                      := new TextureParameterName($8191);
    private static _GENERATE_MIPMAP_SGIS                 := new TextureParameterName($8191);
    private static _TEXTURE_COMPARE_SGIX                 := new TextureParameterName($819A);
    private static _TEXTURE_COMPARE_OPERATOR_SGIX        := new TextureParameterName($819B);
    private static _TEXTURE_LEQUAL_R_SGIX                := new TextureParameterName($819C);
    private static _TEXTURE_GEQUAL_R_SGIX                := new TextureParameterName($819D);
    private static _TEXTURE_MAX_CLAMP_S_SGIX             := new TextureParameterName($8369);
    private static _TEXTURE_MAX_CLAMP_T_SGIX             := new TextureParameterName($836A);
    private static _TEXTURE_MAX_CLAMP_R_SGIX             := new TextureParameterName($836B);
    private static _TEXTURE_LOD_BIAS                     := new TextureParameterName($8501);
    private static _TEXTURE_COMPARE_MODE                 := new TextureParameterName($884C);
    private static _TEXTURE_COMPARE_FUNC                 := new TextureParameterName($884D);
    private static _TEXTURE_SWIZZLE_R                    := new TextureParameterName($8E42);
    private static _TEXTURE_SWIZZLE_G                    := new TextureParameterName($8E43);
    private static _TEXTURE_SWIZZLE_B                    := new TextureParameterName($8E44);
    private static _TEXTURE_SWIZZLE_A                    := new TextureParameterName($8E45);
    private static _TEXTURE_SWIZZLE_RGBA                 := new TextureParameterName($8E46);
    private static _TEXTURE_UNNORMALIZED_COORDINATES_ARM := new TextureParameterName($8F6A);
    private static _DEPTH_STENCIL_TEXTURE_MODE           := new TextureParameterName($90EA);
    private static _TEXTURE_TILING_EXT                   := new TextureParameterName($9580);
    
    public static property TEXTURE_WIDTH:                        TextureParameterName read _TEXTURE_WIDTH;
    public static property TEXTURE_HEIGHT:                       TextureParameterName read _TEXTURE_HEIGHT;
    public static property TEXTURE_COMPONENTS:                   TextureParameterName read _TEXTURE_COMPONENTS;
    public static property TEXTURE_INTERNAL_FORMAT:              TextureParameterName read _TEXTURE_INTERNAL_FORMAT;
    public static property TEXTURE_BORDER_COLOR:                 TextureParameterName read _TEXTURE_BORDER_COLOR;
    public static property TEXTURE_BORDER_COLOR_NV:              TextureParameterName read _TEXTURE_BORDER_COLOR_NV;
    public static property TEXTURE_BORDER:                       TextureParameterName read _TEXTURE_BORDER;
    public static property TEXTURE_MAG_FILTER:                   TextureParameterName read _TEXTURE_MAG_FILTER;
    public static property TEXTURE_MIN_FILTER:                   TextureParameterName read _TEXTURE_MIN_FILTER;
    public static property TEXTURE_WRAP_S:                       TextureParameterName read _TEXTURE_WRAP_S;
    public static property TEXTURE_WRAP_T:                       TextureParameterName read _TEXTURE_WRAP_T;
    public static property TEXTURE_RED_SIZE:                     TextureParameterName read _TEXTURE_RED_SIZE;
    public static property TEXTURE_GREEN_SIZE:                   TextureParameterName read _TEXTURE_GREEN_SIZE;
    public static property TEXTURE_BLUE_SIZE:                    TextureParameterName read _TEXTURE_BLUE_SIZE;
    public static property TEXTURE_ALPHA_SIZE:                   TextureParameterName read _TEXTURE_ALPHA_SIZE;
    public static property TEXTURE_LUMINANCE_SIZE:               TextureParameterName read _TEXTURE_LUMINANCE_SIZE;
    public static property TEXTURE_INTENSITY_SIZE:               TextureParameterName read _TEXTURE_INTENSITY_SIZE;
    public static property TEXTURE_PRIORITY:                     TextureParameterName read _TEXTURE_PRIORITY;
    public static property TEXTURE_PRIORITY_EXT:                 TextureParameterName read _TEXTURE_PRIORITY_EXT;
    public static property TEXTURE_RESIDENT:                     TextureParameterName read _TEXTURE_RESIDENT;
    public static property TEXTURE_DEPTH_EXT:                    TextureParameterName read _TEXTURE_DEPTH_EXT;
    public static property TEXTURE_WRAP_R:                       TextureParameterName read _TEXTURE_WRAP_R;
    public static property TEXTURE_WRAP_R_EXT:                   TextureParameterName read _TEXTURE_WRAP_R_EXT;
    public static property TEXTURE_WRAP_R_OES:                   TextureParameterName read _TEXTURE_WRAP_R_OES;
    public static property DETAIL_TEXTURE_LEVEL_SGIS:            TextureParameterName read _DETAIL_TEXTURE_LEVEL_SGIS;
    public static property DETAIL_TEXTURE_MODE_SGIS:             TextureParameterName read _DETAIL_TEXTURE_MODE_SGIS;
    public static property DETAIL_TEXTURE_FUNC_POINTS_SGIS:      TextureParameterName read _DETAIL_TEXTURE_FUNC_POINTS_SGIS;
    public static property SHARPEN_TEXTURE_FUNC_POINTS_SGIS:     TextureParameterName read _SHARPEN_TEXTURE_FUNC_POINTS_SGIS;
    public static property SHADOW_AMBIENT_SGIX:                  TextureParameterName read _SHADOW_AMBIENT_SGIX;
    public static property DUAL_TEXTURE_SELECT_SGIS:             TextureParameterName read _DUAL_TEXTURE_SELECT_SGIS;
    public static property QUAD_TEXTURE_SELECT_SGIS:             TextureParameterName read _QUAD_TEXTURE_SELECT_SGIS;
    public static property TEXTURE_4DSIZE_SGIS:                  TextureParameterName read _TEXTURE_4DSIZE_SGIS;
    public static property TEXTURE_WRAP_Q_SGIS:                  TextureParameterName read _TEXTURE_WRAP_Q_SGIS;
    public static property TEXTURE_MIN_LOD:                      TextureParameterName read _TEXTURE_MIN_LOD;
    public static property TEXTURE_MIN_LOD_SGIS:                 TextureParameterName read _TEXTURE_MIN_LOD_SGIS;
    public static property TEXTURE_MAX_LOD:                      TextureParameterName read _TEXTURE_MAX_LOD;
    public static property TEXTURE_MAX_LOD_SGIS:                 TextureParameterName read _TEXTURE_MAX_LOD_SGIS;
    public static property TEXTURE_BASE_LEVEL:                   TextureParameterName read _TEXTURE_BASE_LEVEL;
    public static property TEXTURE_BASE_LEVEL_SGIS:              TextureParameterName read _TEXTURE_BASE_LEVEL_SGIS;
    public static property TEXTURE_MAX_LEVEL:                    TextureParameterName read _TEXTURE_MAX_LEVEL;
    public static property TEXTURE_MAX_LEVEL_SGIS:               TextureParameterName read _TEXTURE_MAX_LEVEL_SGIS;
    public static property TEXTURE_FILTER4_SIZE_SGIS:            TextureParameterName read _TEXTURE_FILTER4_SIZE_SGIS;
    public static property TEXTURE_CLIPMAP_CENTER_SGIX:          TextureParameterName read _TEXTURE_CLIPMAP_CENTER_SGIX;
    public static property TEXTURE_CLIPMAP_FRAME_SGIX:           TextureParameterName read _TEXTURE_CLIPMAP_FRAME_SGIX;
    public static property TEXTURE_CLIPMAP_OFFSET_SGIX:          TextureParameterName read _TEXTURE_CLIPMAP_OFFSET_SGIX;
    public static property TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX:   TextureParameterName read _TEXTURE_CLIPMAP_VIRTUAL_DEPTH_SGIX;
    public static property TEXTURE_CLIPMAP_LOD_OFFSET_SGIX:      TextureParameterName read _TEXTURE_CLIPMAP_LOD_OFFSET_SGIX;
    public static property TEXTURE_CLIPMAP_DEPTH_SGIX:           TextureParameterName read _TEXTURE_CLIPMAP_DEPTH_SGIX;
    public static property POST_TEXTURE_FILTER_BIAS_SGIX:        TextureParameterName read _POST_TEXTURE_FILTER_BIAS_SGIX;
    public static property POST_TEXTURE_FILTER_SCALE_SGIX:       TextureParameterName read _POST_TEXTURE_FILTER_SCALE_SGIX;
    public static property TEXTURE_LOD_BIAS_S_SGIX:              TextureParameterName read _TEXTURE_LOD_BIAS_S_SGIX;
    public static property TEXTURE_LOD_BIAS_T_SGIX:              TextureParameterName read _TEXTURE_LOD_BIAS_T_SGIX;
    public static property TEXTURE_LOD_BIAS_R_SGIX:              TextureParameterName read _TEXTURE_LOD_BIAS_R_SGIX;
    public static property GENERATE_MIPMAP:                      TextureParameterName read _GENERATE_MIPMAP;
    public static property GENERATE_MIPMAP_SGIS:                 TextureParameterName read _GENERATE_MIPMAP_SGIS;
    public static property TEXTURE_COMPARE_SGIX:                 TextureParameterName read _TEXTURE_COMPARE_SGIX;
    public static property TEXTURE_COMPARE_OPERATOR_SGIX:        TextureParameterName read _TEXTURE_COMPARE_OPERATOR_SGIX;
    public static property TEXTURE_LEQUAL_R_SGIX:                TextureParameterName read _TEXTURE_LEQUAL_R_SGIX;
    public static property TEXTURE_GEQUAL_R_SGIX:                TextureParameterName read _TEXTURE_GEQUAL_R_SGIX;
    public static property TEXTURE_MAX_CLAMP_S_SGIX:             TextureParameterName read _TEXTURE_MAX_CLAMP_S_SGIX;
    public static property TEXTURE_MAX_CLAMP_T_SGIX:             TextureParameterName read _TEXTURE_MAX_CLAMP_T_SGIX;
    public static property TEXTURE_MAX_CLAMP_R_SGIX:             TextureParameterName read _TEXTURE_MAX_CLAMP_R_SGIX;
    public static property TEXTURE_LOD_BIAS:                     TextureParameterName read _TEXTURE_LOD_BIAS;
    public static property TEXTURE_COMPARE_MODE:                 TextureParameterName read _TEXTURE_COMPARE_MODE;
    public static property TEXTURE_COMPARE_FUNC:                 TextureParameterName read _TEXTURE_COMPARE_FUNC;
    public static property TEXTURE_SWIZZLE_R:                    TextureParameterName read _TEXTURE_SWIZZLE_R;
    public static property TEXTURE_SWIZZLE_G:                    TextureParameterName read _TEXTURE_SWIZZLE_G;
    public static property TEXTURE_SWIZZLE_B:                    TextureParameterName read _TEXTURE_SWIZZLE_B;
    public static property TEXTURE_SWIZZLE_A:                    TextureParameterName read _TEXTURE_SWIZZLE_A;
    public static property TEXTURE_SWIZZLE_RGBA:                 TextureParameterName read _TEXTURE_SWIZZLE_RGBA;
    public static property TEXTURE_UNNORMALIZED_COORDINATES_ARM: TextureParameterName read _TEXTURE_UNNORMALIZED_COORDINATES_ARM;
    public static property DEPTH_STENCIL_TEXTURE_MODE:           TextureParameterName read _DEPTH_STENCIL_TEXTURE_MODE;
    public static property TEXTURE_TILING_EXT:                   TextureParameterName read _TEXTURE_TILING_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureParameterName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureParameterName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureParameterName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureTarget = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_1D                         := new TextureTarget($0DE0);
    private static _TEXTURE_2D                         := new TextureTarget($0DE1);
    private static _PROXY_TEXTURE_1D                   := new TextureTarget($8063);
    private static _PROXY_TEXTURE_1D_EXT               := new TextureTarget($8063);
    private static _PROXY_TEXTURE_2D                   := new TextureTarget($8064);
    private static _PROXY_TEXTURE_2D_EXT               := new TextureTarget($8064);
    private static _TEXTURE_3D                         := new TextureTarget($806F);
    private static _TEXTURE_3D_EXT                     := new TextureTarget($806F);
    private static _TEXTURE_3D_OES                     := new TextureTarget($806F);
    private static _PROXY_TEXTURE_3D                   := new TextureTarget($8070);
    private static _PROXY_TEXTURE_3D_EXT               := new TextureTarget($8070);
    private static _DETAIL_TEXTURE_2D_SGIS             := new TextureTarget($8095);
    private static _TEXTURE_4D_SGIS                    := new TextureTarget($8134);
    private static _PROXY_TEXTURE_4D_SGIS              := new TextureTarget($8135);
    private static _TEXTURE_RECTANGLE                  := new TextureTarget($84F5);
    private static _PROXY_TEXTURE_RECTANGLE            := new TextureTarget($84F7);
    private static _PROXY_TEXTURE_RECTANGLE_ARB        := new TextureTarget($84F7);
    private static _PROXY_TEXTURE_RECTANGLE_NV         := new TextureTarget($84F7);
    private static _TEXTURE_CUBE_MAP                   := new TextureTarget($8513);
    private static _TEXTURE_CUBE_MAP_POSITIVE_X        := new TextureTarget($8515);
    private static _TEXTURE_CUBE_MAP_NEGATIVE_X        := new TextureTarget($8516);
    private static _TEXTURE_CUBE_MAP_POSITIVE_Y        := new TextureTarget($8517);
    private static _TEXTURE_CUBE_MAP_NEGATIVE_Y        := new TextureTarget($8518);
    private static _TEXTURE_CUBE_MAP_POSITIVE_Z        := new TextureTarget($8519);
    private static _TEXTURE_CUBE_MAP_NEGATIVE_Z        := new TextureTarget($851A);
    private static _PROXY_TEXTURE_CUBE_MAP             := new TextureTarget($851B);
    private static _PROXY_TEXTURE_CUBE_MAP_ARB         := new TextureTarget($851B);
    private static _PROXY_TEXTURE_CUBE_MAP_EXT         := new TextureTarget($851B);
    private static _TEXTURE_1D_ARRAY                   := new TextureTarget($8C18);
    private static _PROXY_TEXTURE_1D_ARRAY             := new TextureTarget($8C19);
    private static _PROXY_TEXTURE_1D_ARRAY_EXT         := new TextureTarget($8C19);
    private static _TEXTURE_2D_ARRAY                   := new TextureTarget($8C1A);
    private static _PROXY_TEXTURE_2D_ARRAY             := new TextureTarget($8C1B);
    private static _PROXY_TEXTURE_2D_ARRAY_EXT         := new TextureTarget($8C1B);
    private static _TEXTURE_CUBE_MAP_ARRAY             := new TextureTarget($9009);
    private static _TEXTURE_CUBE_MAP_ARRAY_ARB         := new TextureTarget($9009);
    private static _TEXTURE_CUBE_MAP_ARRAY_EXT         := new TextureTarget($9009);
    private static _TEXTURE_CUBE_MAP_ARRAY_OES         := new TextureTarget($9009);
    private static _PROXY_TEXTURE_CUBE_MAP_ARRAY       := new TextureTarget($900B);
    private static _PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB   := new TextureTarget($900B);
    private static _TEXTURE_2D_MULTISAMPLE             := new TextureTarget($9100);
    private static _PROXY_TEXTURE_2D_MULTISAMPLE       := new TextureTarget($9101);
    private static _TEXTURE_2D_MULTISAMPLE_ARRAY       := new TextureTarget($9102);
    private static _PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY := new TextureTarget($9103);
    
    public static property TEXTURE_1D:                         TextureTarget read _TEXTURE_1D;
    public static property TEXTURE_2D:                         TextureTarget read _TEXTURE_2D;
    public static property PROXY_TEXTURE_1D:                   TextureTarget read _PROXY_TEXTURE_1D;
    public static property PROXY_TEXTURE_1D_EXT:               TextureTarget read _PROXY_TEXTURE_1D_EXT;
    public static property PROXY_TEXTURE_2D:                   TextureTarget read _PROXY_TEXTURE_2D;
    public static property PROXY_TEXTURE_2D_EXT:               TextureTarget read _PROXY_TEXTURE_2D_EXT;
    public static property TEXTURE_3D:                         TextureTarget read _TEXTURE_3D;
    public static property TEXTURE_3D_EXT:                     TextureTarget read _TEXTURE_3D_EXT;
    public static property TEXTURE_3D_OES:                     TextureTarget read _TEXTURE_3D_OES;
    public static property PROXY_TEXTURE_3D:                   TextureTarget read _PROXY_TEXTURE_3D;
    public static property PROXY_TEXTURE_3D_EXT:               TextureTarget read _PROXY_TEXTURE_3D_EXT;
    public static property DETAIL_TEXTURE_2D_SGIS:             TextureTarget read _DETAIL_TEXTURE_2D_SGIS;
    public static property TEXTURE_4D_SGIS:                    TextureTarget read _TEXTURE_4D_SGIS;
    public static property PROXY_TEXTURE_4D_SGIS:              TextureTarget read _PROXY_TEXTURE_4D_SGIS;
    public static property TEXTURE_RECTANGLE:                  TextureTarget read _TEXTURE_RECTANGLE;
    public static property PROXY_TEXTURE_RECTANGLE:            TextureTarget read _PROXY_TEXTURE_RECTANGLE;
    public static property PROXY_TEXTURE_RECTANGLE_ARB:        TextureTarget read _PROXY_TEXTURE_RECTANGLE_ARB;
    public static property PROXY_TEXTURE_RECTANGLE_NV:         TextureTarget read _PROXY_TEXTURE_RECTANGLE_NV;
    public static property TEXTURE_CUBE_MAP:                   TextureTarget read _TEXTURE_CUBE_MAP;
    public static property TEXTURE_CUBE_MAP_POSITIVE_X:        TextureTarget read _TEXTURE_CUBE_MAP_POSITIVE_X;
    public static property TEXTURE_CUBE_MAP_NEGATIVE_X:        TextureTarget read _TEXTURE_CUBE_MAP_NEGATIVE_X;
    public static property TEXTURE_CUBE_MAP_POSITIVE_Y:        TextureTarget read _TEXTURE_CUBE_MAP_POSITIVE_Y;
    public static property TEXTURE_CUBE_MAP_NEGATIVE_Y:        TextureTarget read _TEXTURE_CUBE_MAP_NEGATIVE_Y;
    public static property TEXTURE_CUBE_MAP_POSITIVE_Z:        TextureTarget read _TEXTURE_CUBE_MAP_POSITIVE_Z;
    public static property TEXTURE_CUBE_MAP_NEGATIVE_Z:        TextureTarget read _TEXTURE_CUBE_MAP_NEGATIVE_Z;
    public static property PROXY_TEXTURE_CUBE_MAP:             TextureTarget read _PROXY_TEXTURE_CUBE_MAP;
    public static property PROXY_TEXTURE_CUBE_MAP_ARB:         TextureTarget read _PROXY_TEXTURE_CUBE_MAP_ARB;
    public static property PROXY_TEXTURE_CUBE_MAP_EXT:         TextureTarget read _PROXY_TEXTURE_CUBE_MAP_EXT;
    public static property TEXTURE_1D_ARRAY:                   TextureTarget read _TEXTURE_1D_ARRAY;
    public static property PROXY_TEXTURE_1D_ARRAY:             TextureTarget read _PROXY_TEXTURE_1D_ARRAY;
    public static property PROXY_TEXTURE_1D_ARRAY_EXT:         TextureTarget read _PROXY_TEXTURE_1D_ARRAY_EXT;
    public static property TEXTURE_2D_ARRAY:                   TextureTarget read _TEXTURE_2D_ARRAY;
    public static property PROXY_TEXTURE_2D_ARRAY:             TextureTarget read _PROXY_TEXTURE_2D_ARRAY;
    public static property PROXY_TEXTURE_2D_ARRAY_EXT:         TextureTarget read _PROXY_TEXTURE_2D_ARRAY_EXT;
    public static property TEXTURE_CUBE_MAP_ARRAY:             TextureTarget read _TEXTURE_CUBE_MAP_ARRAY;
    public static property TEXTURE_CUBE_MAP_ARRAY_ARB:         TextureTarget read _TEXTURE_CUBE_MAP_ARRAY_ARB;
    public static property TEXTURE_CUBE_MAP_ARRAY_EXT:         TextureTarget read _TEXTURE_CUBE_MAP_ARRAY_EXT;
    public static property TEXTURE_CUBE_MAP_ARRAY_OES:         TextureTarget read _TEXTURE_CUBE_MAP_ARRAY_OES;
    public static property PROXY_TEXTURE_CUBE_MAP_ARRAY:       TextureTarget read _PROXY_TEXTURE_CUBE_MAP_ARRAY;
    public static property PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB:   TextureTarget read _PROXY_TEXTURE_CUBE_MAP_ARRAY_ARB;
    public static property TEXTURE_2D_MULTISAMPLE:             TextureTarget read _TEXTURE_2D_MULTISAMPLE;
    public static property PROXY_TEXTURE_2D_MULTISAMPLE:       TextureTarget read _PROXY_TEXTURE_2D_MULTISAMPLE;
    public static property TEXTURE_2D_MULTISAMPLE_ARRAY:       TextureTarget read _TEXTURE_2D_MULTISAMPLE_ARRAY;
    public static property PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY: TextureTarget read _PROXY_TEXTURE_2D_MULTISAMPLE_ARRAY;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureTarget).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureTarget(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureTarget[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureUnit = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE0  := new TextureUnit($84C0);
    private static _TEXTURE1  := new TextureUnit($84C1);
    private static _TEXTURE2  := new TextureUnit($84C2);
    private static _TEXTURE3  := new TextureUnit($84C3);
    private static _TEXTURE4  := new TextureUnit($84C4);
    private static _TEXTURE5  := new TextureUnit($84C5);
    private static _TEXTURE6  := new TextureUnit($84C6);
    private static _TEXTURE7  := new TextureUnit($84C7);
    private static _TEXTURE8  := new TextureUnit($84C8);
    private static _TEXTURE9  := new TextureUnit($84C9);
    private static _TEXTURE10 := new TextureUnit($84CA);
    private static _TEXTURE11 := new TextureUnit($84CB);
    private static _TEXTURE12 := new TextureUnit($84CC);
    private static _TEXTURE13 := new TextureUnit($84CD);
    private static _TEXTURE14 := new TextureUnit($84CE);
    private static _TEXTURE15 := new TextureUnit($84CF);
    private static _TEXTURE16 := new TextureUnit($84D0);
    private static _TEXTURE17 := new TextureUnit($84D1);
    private static _TEXTURE18 := new TextureUnit($84D2);
    private static _TEXTURE19 := new TextureUnit($84D3);
    private static _TEXTURE20 := new TextureUnit($84D4);
    private static _TEXTURE21 := new TextureUnit($84D5);
    private static _TEXTURE22 := new TextureUnit($84D6);
    private static _TEXTURE23 := new TextureUnit($84D7);
    private static _TEXTURE24 := new TextureUnit($84D8);
    private static _TEXTURE25 := new TextureUnit($84D9);
    private static _TEXTURE26 := new TextureUnit($84DA);
    private static _TEXTURE27 := new TextureUnit($84DB);
    private static _TEXTURE28 := new TextureUnit($84DC);
    private static _TEXTURE29 := new TextureUnit($84DD);
    private static _TEXTURE30 := new TextureUnit($84DE);
    private static _TEXTURE31 := new TextureUnit($84DF);
    
    public static property TEXTURE0:  TextureUnit read _TEXTURE0;
    public static property TEXTURE1:  TextureUnit read _TEXTURE1;
    public static property TEXTURE2:  TextureUnit read _TEXTURE2;
    public static property TEXTURE3:  TextureUnit read _TEXTURE3;
    public static property TEXTURE4:  TextureUnit read _TEXTURE4;
    public static property TEXTURE5:  TextureUnit read _TEXTURE5;
    public static property TEXTURE6:  TextureUnit read _TEXTURE6;
    public static property TEXTURE7:  TextureUnit read _TEXTURE7;
    public static property TEXTURE8:  TextureUnit read _TEXTURE8;
    public static property TEXTURE9:  TextureUnit read _TEXTURE9;
    public static property TEXTURE10: TextureUnit read _TEXTURE10;
    public static property TEXTURE11: TextureUnit read _TEXTURE11;
    public static property TEXTURE12: TextureUnit read _TEXTURE12;
    public static property TEXTURE13: TextureUnit read _TEXTURE13;
    public static property TEXTURE14: TextureUnit read _TEXTURE14;
    public static property TEXTURE15: TextureUnit read _TEXTURE15;
    public static property TEXTURE16: TextureUnit read _TEXTURE16;
    public static property TEXTURE17: TextureUnit read _TEXTURE17;
    public static property TEXTURE18: TextureUnit read _TEXTURE18;
    public static property TEXTURE19: TextureUnit read _TEXTURE19;
    public static property TEXTURE20: TextureUnit read _TEXTURE20;
    public static property TEXTURE21: TextureUnit read _TEXTURE21;
    public static property TEXTURE22: TextureUnit read _TEXTURE22;
    public static property TEXTURE23: TextureUnit read _TEXTURE23;
    public static property TEXTURE24: TextureUnit read _TEXTURE24;
    public static property TEXTURE25: TextureUnit read _TEXTURE25;
    public static property TEXTURE26: TextureUnit read _TEXTURE26;
    public static property TEXTURE27: TextureUnit read _TEXTURE27;
    public static property TEXTURE28: TextureUnit read _TEXTURE28;
    public static property TEXTURE29: TextureUnit read _TEXTURE29;
    public static property TEXTURE30: TextureUnit read _TEXTURE30;
    public static property TEXTURE31: TextureUnit read _TEXTURE31;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureUnit).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureUnit(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureUnit[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TransformFeedbackBufferMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INTERLEAVED_ATTRIBS := new TransformFeedbackBufferMode($8C8C);
    private static _SEPARATE_ATTRIBS    := new TransformFeedbackBufferMode($8C8D);
    
    public static property INTERLEAVED_ATTRIBS: TransformFeedbackBufferMode read _INTERLEAVED_ATTRIBS;
    public static property SEPARATE_ATTRIBS:    TransformFeedbackBufferMode read _SEPARATE_ATTRIBS;
    
    public function ToString: string; override;
    begin
      var res := typeof(TransformFeedbackBufferMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TransformFeedbackBufferMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TransformFeedbackBufferMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TransformFeedbackPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TRANSFORM_FEEDBACK_BUFFER_START   := new TransformFeedbackPName($8C84);
    private static _TRANSFORM_FEEDBACK_BUFFER_SIZE    := new TransformFeedbackPName($8C85);
    private static _TRANSFORM_FEEDBACK_BUFFER_BINDING := new TransformFeedbackPName($8C8F);
    private static _TRANSFORM_FEEDBACK_PAUSED         := new TransformFeedbackPName($8E23);
    private static _TRANSFORM_FEEDBACK_ACTIVE         := new TransformFeedbackPName($8E24);
    
    public static property TRANSFORM_FEEDBACK_BUFFER_START:   TransformFeedbackPName read _TRANSFORM_FEEDBACK_BUFFER_START;
    public static property TRANSFORM_FEEDBACK_BUFFER_SIZE:    TransformFeedbackPName read _TRANSFORM_FEEDBACK_BUFFER_SIZE;
    public static property TRANSFORM_FEEDBACK_BUFFER_BINDING: TransformFeedbackPName read _TRANSFORM_FEEDBACK_BUFFER_BINDING;
    public static property TRANSFORM_FEEDBACK_PAUSED:         TransformFeedbackPName read _TRANSFORM_FEEDBACK_PAUSED;
    public static property TRANSFORM_FEEDBACK_ACTIVE:         TransformFeedbackPName read _TRANSFORM_FEEDBACK_ACTIVE;
    
    public function ToString: string; override;
    begin
      var res := typeof(TransformFeedbackPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TransformFeedbackPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TransformFeedbackPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  UniformBlockPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER    := new UniformBlockPName($84F0);
    private static _UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER := new UniformBlockPName($84F1);
    private static _UNIFORM_BLOCK_BINDING                              := new UniformBlockPName($8A3F);
    private static _UNIFORM_BLOCK_DATA_SIZE                            := new UniformBlockPName($8A40);
    private static _UNIFORM_BLOCK_NAME_LENGTH                          := new UniformBlockPName($8A41);
    private static _UNIFORM_BLOCK_ACTIVE_UNIFORMS                      := new UniformBlockPName($8A42);
    private static _UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES               := new UniformBlockPName($8A43);
    private static _UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER          := new UniformBlockPName($8A44);
    private static _UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER        := new UniformBlockPName($8A45);
    private static _UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER        := new UniformBlockPName($8A46);
    private static _UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER         := new UniformBlockPName($90EC);
    
    public static property UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER:    UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_TESS_CONTROL_SHADER;
    public static property UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER: UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_TESS_EVALUATION_SHADER;
    public static property UNIFORM_BLOCK_BINDING:                              UniformBlockPName read _UNIFORM_BLOCK_BINDING;
    public static property UNIFORM_BLOCK_DATA_SIZE:                            UniformBlockPName read _UNIFORM_BLOCK_DATA_SIZE;
    public static property UNIFORM_BLOCK_NAME_LENGTH:                          UniformBlockPName read _UNIFORM_BLOCK_NAME_LENGTH;
    public static property UNIFORM_BLOCK_ACTIVE_UNIFORMS:                      UniformBlockPName read _UNIFORM_BLOCK_ACTIVE_UNIFORMS;
    public static property UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:               UniformBlockPName read _UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES;
    public static property UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:          UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER;
    public static property UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER:        UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_GEOMETRY_SHADER;
    public static property UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:        UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER;
    public static property UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER:         UniformBlockPName read _UNIFORM_BLOCK_REFERENCED_BY_COMPUTE_SHADER;
    
    public function ToString: string; override;
    begin
      var res := typeof(UniformBlockPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->UniformBlockPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'UniformBlockPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  UniformPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNIFORM_TYPE                        := new UniformPName($8A37);
    private static _UNIFORM_SIZE                        := new UniformPName($8A38);
    private static _UNIFORM_NAME_LENGTH                 := new UniformPName($8A39);
    private static _UNIFORM_BLOCK_INDEX                 := new UniformPName($8A3A);
    private static _UNIFORM_OFFSET                      := new UniformPName($8A3B);
    private static _UNIFORM_ARRAY_STRIDE                := new UniformPName($8A3C);
    private static _UNIFORM_MATRIX_STRIDE               := new UniformPName($8A3D);
    private static _UNIFORM_IS_ROW_MAJOR                := new UniformPName($8A3E);
    private static _UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX := new UniformPName($92DA);
    
    public static property UNIFORM_TYPE:                        UniformPName read _UNIFORM_TYPE;
    public static property UNIFORM_SIZE:                        UniformPName read _UNIFORM_SIZE;
    public static property UNIFORM_NAME_LENGTH:                 UniformPName read _UNIFORM_NAME_LENGTH;
    public static property UNIFORM_BLOCK_INDEX:                 UniformPName read _UNIFORM_BLOCK_INDEX;
    public static property UNIFORM_OFFSET:                      UniformPName read _UNIFORM_OFFSET;
    public static property UNIFORM_ARRAY_STRIDE:                UniformPName read _UNIFORM_ARRAY_STRIDE;
    public static property UNIFORM_MATRIX_STRIDE:               UniformPName read _UNIFORM_MATRIX_STRIDE;
    public static property UNIFORM_IS_ROW_MAJOR:                UniformPName read _UNIFORM_IS_ROW_MAJOR;
    public static property UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX: UniformPName read _UNIFORM_ATOMIC_COUNTER_BUFFER_INDEX;
    
    public function ToString: string; override;
    begin
      var res := typeof(UniformPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->UniformPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'UniformPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  UniformType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INT                                       := new UniformType($1404);
    private static _UNSIGNED_INT                              := new UniformType($1405);
    private static _FLOAT                                     := new UniformType($1406);
    private static _DOUBLE                                    := new UniformType($140A);
    private static _FLOAT_VEC2                                := new UniformType($8B50);
    private static _FLOAT_VEC3                                := new UniformType($8B51);
    private static _FLOAT_VEC4                                := new UniformType($8B52);
    private static _INT_VEC2                                  := new UniformType($8B53);
    private static _INT_VEC3                                  := new UniformType($8B54);
    private static _INT_VEC4                                  := new UniformType($8B55);
    private static _BOOL                                      := new UniformType($8B56);
    private static _BOOL_VEC2                                 := new UniformType($8B57);
    private static _BOOL_VEC3                                 := new UniformType($8B58);
    private static _BOOL_VEC4                                 := new UniformType($8B59);
    private static _FLOAT_MAT2                                := new UniformType($8B5A);
    private static _FLOAT_MAT3                                := new UniformType($8B5B);
    private static _FLOAT_MAT4                                := new UniformType($8B5C);
    private static _SAMPLER_1D                                := new UniformType($8B5D);
    private static _SAMPLER_2D                                := new UniformType($8B5E);
    private static _SAMPLER_3D                                := new UniformType($8B5F);
    private static _SAMPLER_CUBE                              := new UniformType($8B60);
    private static _SAMPLER_1D_SHADOW                         := new UniformType($8B61);
    private static _SAMPLER_2D_SHADOW                         := new UniformType($8B62);
    private static _SAMPLER_2D_RECT                           := new UniformType($8B63);
    private static _SAMPLER_2D_RECT_SHADOW                    := new UniformType($8B64);
    private static _FLOAT_MAT2x3                              := new UniformType($8B65);
    private static _FLOAT_MAT2x4                              := new UniformType($8B66);
    private static _FLOAT_MAT3x2                              := new UniformType($8B67);
    private static _FLOAT_MAT3x4                              := new UniformType($8B68);
    private static _FLOAT_MAT4x2                              := new UniformType($8B69);
    private static _FLOAT_MAT4x3                              := new UniformType($8B6A);
    private static _SAMPLER_1D_ARRAY                          := new UniformType($8DC0);
    private static _SAMPLER_2D_ARRAY                          := new UniformType($8DC1);
    private static _SAMPLER_BUFFER                            := new UniformType($8DC2);
    private static _SAMPLER_1D_ARRAY_SHADOW                   := new UniformType($8DC3);
    private static _SAMPLER_2D_ARRAY_SHADOW                   := new UniformType($8DC4);
    private static _SAMPLER_CUBE_SHADOW                       := new UniformType($8DC5);
    private static _UNSIGNED_INT_VEC2                         := new UniformType($8DC6);
    private static _UNSIGNED_INT_VEC3                         := new UniformType($8DC7);
    private static _UNSIGNED_INT_VEC4                         := new UniformType($8DC8);
    private static _INT_SAMPLER_1D                            := new UniformType($8DC9);
    private static _INT_SAMPLER_2D                            := new UniformType($8DCA);
    private static _INT_SAMPLER_3D                            := new UniformType($8DCB);
    private static _INT_SAMPLER_CUBE                          := new UniformType($8DCC);
    private static _INT_SAMPLER_2D_RECT                       := new UniformType($8DCD);
    private static _INT_SAMPLER_1D_ARRAY                      := new UniformType($8DCE);
    private static _INT_SAMPLER_2D_ARRAY                      := new UniformType($8DCF);
    private static _INT_SAMPLER_BUFFER                        := new UniformType($8DD0);
    private static _UNSIGNED_INT_SAMPLER_1D                   := new UniformType($8DD1);
    private static _UNSIGNED_INT_SAMPLER_2D                   := new UniformType($8DD2);
    private static _UNSIGNED_INT_SAMPLER_3D                   := new UniformType($8DD3);
    private static _UNSIGNED_INT_SAMPLER_CUBE                 := new UniformType($8DD4);
    private static _UNSIGNED_INT_SAMPLER_2D_RECT              := new UniformType($8DD5);
    private static _UNSIGNED_INT_SAMPLER_1D_ARRAY             := new UniformType($8DD6);
    private static _UNSIGNED_INT_SAMPLER_2D_ARRAY             := new UniformType($8DD7);
    private static _UNSIGNED_INT_SAMPLER_BUFFER               := new UniformType($8DD8);
    private static _DOUBLE_MAT2                               := new UniformType($8F46);
    private static _DOUBLE_MAT3                               := new UniformType($8F47);
    private static _DOUBLE_MAT4                               := new UniformType($8F48);
    private static _DOUBLE_MAT2x3                             := new UniformType($8F49);
    private static _DOUBLE_MAT2x4                             := new UniformType($8F4A);
    private static _DOUBLE_MAT3x2                             := new UniformType($8F4B);
    private static _DOUBLE_MAT3x4                             := new UniformType($8F4C);
    private static _DOUBLE_MAT4x2                             := new UniformType($8F4D);
    private static _DOUBLE_MAT4x3                             := new UniformType($8F4E);
    private static _DOUBLE_VEC2                               := new UniformType($8FFC);
    private static _DOUBLE_VEC3                               := new UniformType($8FFD);
    private static _DOUBLE_VEC4                               := new UniformType($8FFE);
    private static _SAMPLER_CUBE_MAP_ARRAY                    := new UniformType($900C);
    private static _SAMPLER_CUBE_MAP_ARRAY_SHADOW             := new UniformType($900D);
    private static _INT_SAMPLER_CUBE_MAP_ARRAY                := new UniformType($900E);
    private static _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY       := new UniformType($900F);
    private static _SAMPLER_2D_MULTISAMPLE                    := new UniformType($9108);
    private static _INT_SAMPLER_2D_MULTISAMPLE                := new UniformType($9109);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE       := new UniformType($910A);
    private static _SAMPLER_2D_MULTISAMPLE_ARRAY              := new UniformType($910B);
    private static _INT_SAMPLER_2D_MULTISAMPLE_ARRAY          := new UniformType($910C);
    private static _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY := new UniformType($910D);
    
    public static property INT:                                       UniformType read _INT;
    public static property UNSIGNED_INT:                              UniformType read _UNSIGNED_INT;
    public static property FLOAT:                                     UniformType read _FLOAT;
    public static property DOUBLE:                                    UniformType read _DOUBLE;
    public static property FLOAT_VEC2:                                UniformType read _FLOAT_VEC2;
    public static property FLOAT_VEC3:                                UniformType read _FLOAT_VEC3;
    public static property FLOAT_VEC4:                                UniformType read _FLOAT_VEC4;
    public static property INT_VEC2:                                  UniformType read _INT_VEC2;
    public static property INT_VEC3:                                  UniformType read _INT_VEC3;
    public static property INT_VEC4:                                  UniformType read _INT_VEC4;
    public static property BOOL:                                      UniformType read _BOOL;
    public static property BOOL_VEC2:                                 UniformType read _BOOL_VEC2;
    public static property BOOL_VEC3:                                 UniformType read _BOOL_VEC3;
    public static property BOOL_VEC4:                                 UniformType read _BOOL_VEC4;
    public static property FLOAT_MAT2:                                UniformType read _FLOAT_MAT2;
    public static property FLOAT_MAT3:                                UniformType read _FLOAT_MAT3;
    public static property FLOAT_MAT4:                                UniformType read _FLOAT_MAT4;
    public static property SAMPLER_1D:                                UniformType read _SAMPLER_1D;
    public static property SAMPLER_2D:                                UniformType read _SAMPLER_2D;
    public static property SAMPLER_3D:                                UniformType read _SAMPLER_3D;
    public static property SAMPLER_CUBE:                              UniformType read _SAMPLER_CUBE;
    public static property SAMPLER_1D_SHADOW:                         UniformType read _SAMPLER_1D_SHADOW;
    public static property SAMPLER_2D_SHADOW:                         UniformType read _SAMPLER_2D_SHADOW;
    public static property SAMPLER_2D_RECT:                           UniformType read _SAMPLER_2D_RECT;
    public static property SAMPLER_2D_RECT_SHADOW:                    UniformType read _SAMPLER_2D_RECT_SHADOW;
    public static property FLOAT_MAT2x3:                              UniformType read _FLOAT_MAT2x3;
    public static property FLOAT_MAT2x4:                              UniformType read _FLOAT_MAT2x4;
    public static property FLOAT_MAT3x2:                              UniformType read _FLOAT_MAT3x2;
    public static property FLOAT_MAT3x4:                              UniformType read _FLOAT_MAT3x4;
    public static property FLOAT_MAT4x2:                              UniformType read _FLOAT_MAT4x2;
    public static property FLOAT_MAT4x3:                              UniformType read _FLOAT_MAT4x3;
    public static property SAMPLER_1D_ARRAY:                          UniformType read _SAMPLER_1D_ARRAY;
    public static property SAMPLER_2D_ARRAY:                          UniformType read _SAMPLER_2D_ARRAY;
    public static property SAMPLER_BUFFER:                            UniformType read _SAMPLER_BUFFER;
    public static property SAMPLER_1D_ARRAY_SHADOW:                   UniformType read _SAMPLER_1D_ARRAY_SHADOW;
    public static property SAMPLER_2D_ARRAY_SHADOW:                   UniformType read _SAMPLER_2D_ARRAY_SHADOW;
    public static property SAMPLER_CUBE_SHADOW:                       UniformType read _SAMPLER_CUBE_SHADOW;
    public static property UNSIGNED_INT_VEC2:                         UniformType read _UNSIGNED_INT_VEC2;
    public static property UNSIGNED_INT_VEC3:                         UniformType read _UNSIGNED_INT_VEC3;
    public static property UNSIGNED_INT_VEC4:                         UniformType read _UNSIGNED_INT_VEC4;
    public static property INT_SAMPLER_1D:                            UniformType read _INT_SAMPLER_1D;
    public static property INT_SAMPLER_2D:                            UniformType read _INT_SAMPLER_2D;
    public static property INT_SAMPLER_3D:                            UniformType read _INT_SAMPLER_3D;
    public static property INT_SAMPLER_CUBE:                          UniformType read _INT_SAMPLER_CUBE;
    public static property INT_SAMPLER_2D_RECT:                       UniformType read _INT_SAMPLER_2D_RECT;
    public static property INT_SAMPLER_1D_ARRAY:                      UniformType read _INT_SAMPLER_1D_ARRAY;
    public static property INT_SAMPLER_2D_ARRAY:                      UniformType read _INT_SAMPLER_2D_ARRAY;
    public static property INT_SAMPLER_BUFFER:                        UniformType read _INT_SAMPLER_BUFFER;
    public static property UNSIGNED_INT_SAMPLER_1D:                   UniformType read _UNSIGNED_INT_SAMPLER_1D;
    public static property UNSIGNED_INT_SAMPLER_2D:                   UniformType read _UNSIGNED_INT_SAMPLER_2D;
    public static property UNSIGNED_INT_SAMPLER_3D:                   UniformType read _UNSIGNED_INT_SAMPLER_3D;
    public static property UNSIGNED_INT_SAMPLER_CUBE:                 UniformType read _UNSIGNED_INT_SAMPLER_CUBE;
    public static property UNSIGNED_INT_SAMPLER_2D_RECT:              UniformType read _UNSIGNED_INT_SAMPLER_2D_RECT;
    public static property UNSIGNED_INT_SAMPLER_1D_ARRAY:             UniformType read _UNSIGNED_INT_SAMPLER_1D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_ARRAY:             UniformType read _UNSIGNED_INT_SAMPLER_2D_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_BUFFER:               UniformType read _UNSIGNED_INT_SAMPLER_BUFFER;
    public static property DOUBLE_MAT2:                               UniformType read _DOUBLE_MAT2;
    public static property DOUBLE_MAT3:                               UniformType read _DOUBLE_MAT3;
    public static property DOUBLE_MAT4:                               UniformType read _DOUBLE_MAT4;
    public static property DOUBLE_MAT2x3:                             UniformType read _DOUBLE_MAT2x3;
    public static property DOUBLE_MAT2x4:                             UniformType read _DOUBLE_MAT2x4;
    public static property DOUBLE_MAT3x2:                             UniformType read _DOUBLE_MAT3x2;
    public static property DOUBLE_MAT3x4:                             UniformType read _DOUBLE_MAT3x4;
    public static property DOUBLE_MAT4x2:                             UniformType read _DOUBLE_MAT4x2;
    public static property DOUBLE_MAT4x3:                             UniformType read _DOUBLE_MAT4x3;
    public static property DOUBLE_VEC2:                               UniformType read _DOUBLE_VEC2;
    public static property DOUBLE_VEC3:                               UniformType read _DOUBLE_VEC3;
    public static property DOUBLE_VEC4:                               UniformType read _DOUBLE_VEC4;
    public static property SAMPLER_CUBE_MAP_ARRAY:                    UniformType read _SAMPLER_CUBE_MAP_ARRAY;
    public static property SAMPLER_CUBE_MAP_ARRAY_SHADOW:             UniformType read _SAMPLER_CUBE_MAP_ARRAY_SHADOW;
    public static property INT_SAMPLER_CUBE_MAP_ARRAY:                UniformType read _INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY:       UniformType read _UNSIGNED_INT_SAMPLER_CUBE_MAP_ARRAY;
    public static property SAMPLER_2D_MULTISAMPLE:                    UniformType read _SAMPLER_2D_MULTISAMPLE;
    public static property INT_SAMPLER_2D_MULTISAMPLE:                UniformType read _INT_SAMPLER_2D_MULTISAMPLE;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE:       UniformType read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE;
    public static property SAMPLER_2D_MULTISAMPLE_ARRAY:              UniformType read _SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property INT_SAMPLER_2D_MULTISAMPLE_ARRAY:          UniformType read _INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    public static property UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY: UniformType read _UNSIGNED_INT_SAMPLER_2D_MULTISAMPLE_ARRAY;
    
    public function ToString: string; override;
    begin
      var res := typeof(UniformType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->UniformType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'UniformType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  UseProgramStageMask = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_SHADER_BIT              := new UseProgramStageMask($0001);
    private static _VERTEX_SHADER_BIT_EXT          := new UseProgramStageMask($0001);
    private static _FRAGMENT_SHADER_BIT            := new UseProgramStageMask($0002);
    private static _FRAGMENT_SHADER_BIT_EXT        := new UseProgramStageMask($0002);
    private static _GEOMETRY_SHADER_BIT            := new UseProgramStageMask($0004);
    private static _GEOMETRY_SHADER_BIT_EXT        := new UseProgramStageMask($0004);
    private static _GEOMETRY_SHADER_BIT_OES        := new UseProgramStageMask($0004);
    private static _TESS_CONTROL_SHADER_BIT        := new UseProgramStageMask($0008);
    private static _TESS_CONTROL_SHADER_BIT_EXT    := new UseProgramStageMask($0008);
    private static _TESS_CONTROL_SHADER_BIT_OES    := new UseProgramStageMask($0008);
    private static _TESS_EVALUATION_SHADER_BIT     := new UseProgramStageMask($0010);
    private static _TESS_EVALUATION_SHADER_BIT_EXT := new UseProgramStageMask($0010);
    private static _TESS_EVALUATION_SHADER_BIT_OES := new UseProgramStageMask($0010);
    private static _COMPUTE_SHADER_BIT             := new UseProgramStageMask($0020);
    private static _MESH_SHADER_BIT_NV             := new UseProgramStageMask($0040);
    private static _TASK_SHADER_BIT_NV             := new UseProgramStageMask($0080);
    private static _ALL_SHADER_BITS                := new UseProgramStageMask($FFFFFFFF);
    private static _ALL_SHADER_BITS_EXT            := new UseProgramStageMask($FFFFFFFF);
    
    public static property VERTEX_SHADER_BIT:              UseProgramStageMask read _VERTEX_SHADER_BIT;
    public static property VERTEX_SHADER_BIT_EXT:          UseProgramStageMask read _VERTEX_SHADER_BIT_EXT;
    public static property FRAGMENT_SHADER_BIT:            UseProgramStageMask read _FRAGMENT_SHADER_BIT;
    public static property FRAGMENT_SHADER_BIT_EXT:        UseProgramStageMask read _FRAGMENT_SHADER_BIT_EXT;
    public static property GEOMETRY_SHADER_BIT:            UseProgramStageMask read _GEOMETRY_SHADER_BIT;
    public static property GEOMETRY_SHADER_BIT_EXT:        UseProgramStageMask read _GEOMETRY_SHADER_BIT_EXT;
    public static property GEOMETRY_SHADER_BIT_OES:        UseProgramStageMask read _GEOMETRY_SHADER_BIT_OES;
    public static property TESS_CONTROL_SHADER_BIT:        UseProgramStageMask read _TESS_CONTROL_SHADER_BIT;
    public static property TESS_CONTROL_SHADER_BIT_EXT:    UseProgramStageMask read _TESS_CONTROL_SHADER_BIT_EXT;
    public static property TESS_CONTROL_SHADER_BIT_OES:    UseProgramStageMask read _TESS_CONTROL_SHADER_BIT_OES;
    public static property TESS_EVALUATION_SHADER_BIT:     UseProgramStageMask read _TESS_EVALUATION_SHADER_BIT;
    public static property TESS_EVALUATION_SHADER_BIT_EXT: UseProgramStageMask read _TESS_EVALUATION_SHADER_BIT_EXT;
    public static property TESS_EVALUATION_SHADER_BIT_OES: UseProgramStageMask read _TESS_EVALUATION_SHADER_BIT_OES;
    public static property COMPUTE_SHADER_BIT:             UseProgramStageMask read _COMPUTE_SHADER_BIT;
    public static property MESH_SHADER_BIT_NV:             UseProgramStageMask read _MESH_SHADER_BIT_NV;
    public static property TASK_SHADER_BIT_NV:             UseProgramStageMask read _TASK_SHADER_BIT_NV;
    public static property ALL_SHADER_BITS:                UseProgramStageMask read _ALL_SHADER_BITS;
    public static property ALL_SHADER_BITS_EXT:            UseProgramStageMask read _ALL_SHADER_BITS_EXT;
    
    public static function operator or(f1,f2: UseProgramStageMask) := new UseProgramStageMask(f1.val or f2.val);
    
    public property HAS_FLAG_VERTEX_SHADER_BIT:              boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_VERTEX_SHADER_BIT_EXT:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_FRAGMENT_SHADER_BIT:            boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_FRAGMENT_SHADER_BIT_EXT:        boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT:            boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT_EXT:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_GEOMETRY_SHADER_BIT_OES:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT_EXT:    boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_CONTROL_SHADER_BIT_OES:    boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT:     boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT_EXT: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_TESS_EVALUATION_SHADER_BIT_OES: boolean read self.val and $0010 <> 0;
    public property HAS_FLAG_COMPUTE_SHADER_BIT:             boolean read self.val and $0020 <> 0;
    public property HAS_FLAG_MESH_SHADER_BIT_NV:             boolean read self.val and $0040 <> 0;
    public property HAS_FLAG_TASK_SHADER_BIT_NV:             boolean read self.val and $0080 <> 0;
    public property HAS_FLAG_ALL_SHADER_BITS:                boolean read self.val and $FFFFFFFF <> 0;
    public property HAS_FLAG_ALL_SHADER_BITS_EXT:            boolean read self.val and $FFFFFFFF <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(UseProgramStageMask).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'UseProgramStageMask[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  VertexArrayPName = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_ATTRIB_RELATIVE_OFFSET  := new VertexArrayPName($82D5);
    private static _VERTEX_ATTRIB_ARRAY_ENABLED    := new VertexArrayPName($8622);
    private static _VERTEX_ATTRIB_ARRAY_SIZE       := new VertexArrayPName($8623);
    private static _VERTEX_ATTRIB_ARRAY_STRIDE     := new VertexArrayPName($8624);
    private static _VERTEX_ATTRIB_ARRAY_TYPE       := new VertexArrayPName($8625);
    private static _VERTEX_ATTRIB_ARRAY_LONG       := new VertexArrayPName($874E);
    private static _VERTEX_ATTRIB_ARRAY_NORMALIZED := new VertexArrayPName($886A);
    private static _VERTEX_ATTRIB_ARRAY_INTEGER    := new VertexArrayPName($88FD);
    private static _VERTEX_ATTRIB_ARRAY_DIVISOR    := new VertexArrayPName($88FE);
    
    public static property VERTEX_ATTRIB_RELATIVE_OFFSET:  VertexArrayPName read _VERTEX_ATTRIB_RELATIVE_OFFSET;
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:    VertexArrayPName read _VERTEX_ATTRIB_ARRAY_ENABLED;
    public static property VERTEX_ATTRIB_ARRAY_SIZE:       VertexArrayPName read _VERTEX_ATTRIB_ARRAY_SIZE;
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:     VertexArrayPName read _VERTEX_ATTRIB_ARRAY_STRIDE;
    public static property VERTEX_ATTRIB_ARRAY_TYPE:       VertexArrayPName read _VERTEX_ATTRIB_ARRAY_TYPE;
    public static property VERTEX_ATTRIB_ARRAY_LONG:       VertexArrayPName read _VERTEX_ATTRIB_ARRAY_LONG;
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED: VertexArrayPName read _VERTEX_ATTRIB_ARRAY_NORMALIZED;
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:    VertexArrayPName read _VERTEX_ATTRIB_ARRAY_INTEGER;
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:    VertexArrayPName read _VERTEX_ATTRIB_ARRAY_DIVISOR;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexArrayPName).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexArrayPName(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexArrayPName[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribEnum = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_ATTRIB_ARRAY_ENABLED        := new VertexAttribEnum($8622);
    private static _VERTEX_ATTRIB_ARRAY_SIZE           := new VertexAttribEnum($8623);
    private static _VERTEX_ATTRIB_ARRAY_STRIDE         := new VertexAttribEnum($8624);
    private static _VERTEX_ATTRIB_ARRAY_TYPE           := new VertexAttribEnum($8625);
    private static _CURRENT_VERTEX_ATTRIB              := new VertexAttribEnum($8626);
    private static _VERTEX_ATTRIB_ARRAY_NORMALIZED     := new VertexAttribEnum($886A);
    private static _VERTEX_ATTRIB_ARRAY_BUFFER_BINDING := new VertexAttribEnum($889F);
    private static _VERTEX_ATTRIB_ARRAY_INTEGER        := new VertexAttribEnum($88FD);
    private static _VERTEX_ATTRIB_ARRAY_DIVISOR        := new VertexAttribEnum($88FE);
    
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:        VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_ENABLED;
    public static property VERTEX_ATTRIB_ARRAY_SIZE:           VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_SIZE;
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:         VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_STRIDE;
    public static property VERTEX_ATTRIB_ARRAY_TYPE:           VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_TYPE;
    public static property CURRENT_VERTEX_ATTRIB:              VertexAttribEnum read _CURRENT_VERTEX_ATTRIB;
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED:     VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_NORMALIZED;
    public static property VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_BUFFER_BINDING;
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:        VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_INTEGER;
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:        VertexAttribEnum read _VERTEX_ATTRIB_ARRAY_DIVISOR;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribEnum).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribEnum(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribEnum[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribIType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE           := new VertexAttribIType($1400);
    private static _UNSIGNED_BYTE  := new VertexAttribIType($1401);
    private static _SHORT          := new VertexAttribIType($1402);
    private static _UNSIGNED_SHORT := new VertexAttribIType($1403);
    private static _INT            := new VertexAttribIType($1404);
    private static _UNSIGNED_INT   := new VertexAttribIType($1405);
    
    public static property BYTE:           VertexAttribIType read _BYTE;
    public static property UNSIGNED_BYTE:  VertexAttribIType read _UNSIGNED_BYTE;
    public static property SHORT:          VertexAttribIType read _SHORT;
    public static property UNSIGNED_SHORT: VertexAttribIType read _UNSIGNED_SHORT;
    public static property INT:            VertexAttribIType read _INT;
    public static property UNSIGNED_INT:   VertexAttribIType read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribIType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribIType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribIType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribLType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DOUBLE := new VertexAttribLType($140A);
    
    public static property DOUBLE: VertexAttribLType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribLType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribLType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribLType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE                         := new VertexAttribPointerType($1400);
    private static _UNSIGNED_BYTE                := new VertexAttribPointerType($1401);
    private static _SHORT                        := new VertexAttribPointerType($1402);
    private static _UNSIGNED_SHORT               := new VertexAttribPointerType($1403);
    private static _INT                          := new VertexAttribPointerType($1404);
    private static _UNSIGNED_INT                 := new VertexAttribPointerType($1405);
    private static _FLOAT                        := new VertexAttribPointerType($1406);
    private static _DOUBLE                       := new VertexAttribPointerType($140A);
    private static _HALF_FLOAT                   := new VertexAttribPointerType($140B);
    private static _FIXED                        := new VertexAttribPointerType($140C);
    private static _INT64_ARB                    := new VertexAttribPointerType($140E);
    private static _INT64_NV                     := new VertexAttribPointerType($140E);
    private static _UNSIGNED_INT64_ARB           := new VertexAttribPointerType($140F);
    private static _UNSIGNED_INT64_NV            := new VertexAttribPointerType($140F);
    private static _UNSIGNED_INT_2_10_10_10_REV  := new VertexAttribPointerType($8368);
    private static _UNSIGNED_INT_10F_11F_11F_REV := new VertexAttribPointerType($8C3B);
    private static _INT_2_10_10_10_REV           := new VertexAttribPointerType($8D9F);
    
    public static property BYTE:                         VertexAttribPointerType read _BYTE;
    public static property UNSIGNED_BYTE:                VertexAttribPointerType read _UNSIGNED_BYTE;
    public static property SHORT:                        VertexAttribPointerType read _SHORT;
    public static property UNSIGNED_SHORT:               VertexAttribPointerType read _UNSIGNED_SHORT;
    public static property INT:                          VertexAttribPointerType read _INT;
    public static property UNSIGNED_INT:                 VertexAttribPointerType read _UNSIGNED_INT;
    public static property FLOAT:                        VertexAttribPointerType read _FLOAT;
    public static property DOUBLE:                       VertexAttribPointerType read _DOUBLE;
    public static property HALF_FLOAT:                   VertexAttribPointerType read _HALF_FLOAT;
    public static property FIXED:                        VertexAttribPointerType read _FIXED;
    public static property INT64_ARB:                    VertexAttribPointerType read _INT64_ARB;
    public static property INT64_NV:                     VertexAttribPointerType read _INT64_NV;
    public static property UNSIGNED_INT64_ARB:           VertexAttribPointerType read _UNSIGNED_INT64_ARB;
    public static property UNSIGNED_INT64_NV:            VertexAttribPointerType read _UNSIGNED_INT64_NV;
    public static property UNSIGNED_INT_2_10_10_10_REV:  VertexAttribPointerType read _UNSIGNED_INT_2_10_10_10_REV;
    public static property UNSIGNED_INT_10F_11F_11F_REV: VertexAttribPointerType read _UNSIGNED_INT_10F_11F_11F_REV;
    public static property INT_2_10_10_10_REV:           VertexAttribPointerType read _INT_2_10_10_10_REV;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE                         := new VertexAttribType($1400);
    private static _UNSIGNED_BYTE                := new VertexAttribType($1401);
    private static _SHORT                        := new VertexAttribType($1402);
    private static _UNSIGNED_SHORT               := new VertexAttribType($1403);
    private static _INT                          := new VertexAttribType($1404);
    private static _UNSIGNED_INT                 := new VertexAttribType($1405);
    private static _FLOAT                        := new VertexAttribType($1406);
    private static _DOUBLE                       := new VertexAttribType($140A);
    private static _HALF_FLOAT                   := new VertexAttribType($140B);
    private static _FIXED                        := new VertexAttribType($140C);
    private static _UNSIGNED_INT_2_10_10_10_REV  := new VertexAttribType($8368);
    private static _UNSIGNED_INT_10F_11F_11F_REV := new VertexAttribType($8C3B);
    private static _INT_2_10_10_10_REV           := new VertexAttribType($8D9F);
    
    public static property BYTE:                         VertexAttribType read _BYTE;
    public static property UNSIGNED_BYTE:                VertexAttribType read _UNSIGNED_BYTE;
    public static property SHORT:                        VertexAttribType read _SHORT;
    public static property UNSIGNED_SHORT:               VertexAttribType read _UNSIGNED_SHORT;
    public static property INT:                          VertexAttribType read _INT;
    public static property UNSIGNED_INT:                 VertexAttribType read _UNSIGNED_INT;
    public static property FLOAT:                        VertexAttribType read _FLOAT;
    public static property DOUBLE:                       VertexAttribType read _DOUBLE;
    public static property HALF_FLOAT:                   VertexAttribType read _HALF_FLOAT;
    public static property FIXED:                        VertexAttribType read _FIXED;
    public static property UNSIGNED_INT_2_10_10_10_REV:  VertexAttribType read _UNSIGNED_INT_2_10_10_10_REV;
    public static property UNSIGNED_INT_10F_11F_11F_REV: VertexAttribType read _UNSIGNED_INT_10F_11F_11F_REV;
    public static property INT_2_10_10_10_REV:           VertexAttribType read _INT_2_10_10_10_REV;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexBufferObjectParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BUFFER_IMMUTABLE_STORAGE := new VertexBufferObjectParameter($821F);
    private static _BUFFER_STORAGE_FLAGS     := new VertexBufferObjectParameter($8220);
    private static _BUFFER_SIZE              := new VertexBufferObjectParameter($8764);
    private static _BUFFER_USAGE             := new VertexBufferObjectParameter($8765);
    private static _BUFFER_ACCESS            := new VertexBufferObjectParameter($88BB);
    private static _BUFFER_MAPPED            := new VertexBufferObjectParameter($88BC);
    private static _BUFFER_ACCESS_FLAGS      := new VertexBufferObjectParameter($911F);
    private static _BUFFER_MAP_LENGTH        := new VertexBufferObjectParameter($9120);
    private static _BUFFER_MAP_OFFSET        := new VertexBufferObjectParameter($9121);
    
    public static property BUFFER_IMMUTABLE_STORAGE: VertexBufferObjectParameter read _BUFFER_IMMUTABLE_STORAGE;
    public static property BUFFER_STORAGE_FLAGS:     VertexBufferObjectParameter read _BUFFER_STORAGE_FLAGS;
    public static property BUFFER_SIZE:              VertexBufferObjectParameter read _BUFFER_SIZE;
    public static property BUFFER_USAGE:             VertexBufferObjectParameter read _BUFFER_USAGE;
    public static property BUFFER_ACCESS:            VertexBufferObjectParameter read _BUFFER_ACCESS;
    public static property BUFFER_MAPPED:            VertexBufferObjectParameter read _BUFFER_MAPPED;
    public static property BUFFER_ACCESS_FLAGS:      VertexBufferObjectParameter read _BUFFER_ACCESS_FLAGS;
    public static property BUFFER_MAP_LENGTH:        VertexBufferObjectParameter read _BUFFER_MAP_LENGTH;
    public static property BUFFER_MAP_OFFSET:        VertexBufferObjectParameter read _BUFFER_MAP_OFFSET;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexBufferObjectParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexBufferObjectParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexBufferObjectParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexBufferObjectUsage = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STREAM_DRAW  := new VertexBufferObjectUsage($88E0);
    private static _STREAM_READ  := new VertexBufferObjectUsage($88E1);
    private static _STREAM_COPY  := new VertexBufferObjectUsage($88E2);
    private static _STATIC_DRAW  := new VertexBufferObjectUsage($88E4);
    private static _STATIC_READ  := new VertexBufferObjectUsage($88E5);
    private static _STATIC_COPY  := new VertexBufferObjectUsage($88E6);
    private static _DYNAMIC_DRAW := new VertexBufferObjectUsage($88E8);
    private static _DYNAMIC_READ := new VertexBufferObjectUsage($88E9);
    private static _DYNAMIC_COPY := new VertexBufferObjectUsage($88EA);
    
    public static property STREAM_DRAW:  VertexBufferObjectUsage read _STREAM_DRAW;
    public static property STREAM_READ:  VertexBufferObjectUsage read _STREAM_READ;
    public static property STREAM_COPY:  VertexBufferObjectUsage read _STREAM_COPY;
    public static property STATIC_DRAW:  VertexBufferObjectUsage read _STATIC_DRAW;
    public static property STATIC_READ:  VertexBufferObjectUsage read _STATIC_READ;
    public static property STATIC_COPY:  VertexBufferObjectUsage read _STATIC_COPY;
    public static property DYNAMIC_DRAW: VertexBufferObjectUsage read _DYNAMIC_DRAW;
    public static property DYNAMIC_READ: VertexBufferObjectUsage read _DYNAMIC_READ;
    public static property DYNAMIC_COPY: VertexBufferObjectUsage read _DYNAMIC_COPY;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexBufferObjectUsage).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexBufferObjectUsage(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexBufferObjectUsage[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexPointerType = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SHORT  := new VertexPointerType($1402);
    private static _INT    := new VertexPointerType($1404);
    private static _FLOAT  := new VertexPointerType($1406);
    private static _DOUBLE := new VertexPointerType($140A);
    
    public static property SHORT:  VertexPointerType read _SHORT;
    public static property INT:    VertexPointerType read _INT;
    public static property FLOAT:  VertexPointerType read _FLOAT;
    public static property DOUBLE: VertexPointerType read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexPointerType).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexPointerType(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexPointerType[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexProvokingMode = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FIRST_VERTEX_CONVENTION := new VertexProvokingMode($8E4D);
    private static _LAST_VERTEX_CONVENTION  := new VertexProvokingMode($8E4E);
    
    public static property FIRST_VERTEX_CONVENTION: VertexProvokingMode read _FIRST_VERTEX_CONVENTION;
    public static property LAST_VERTEX_CONVENTION:  VertexProvokingMode read _LAST_VERTEX_CONVENTION;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexProvokingMode).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexProvokingMode(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexProvokingMode[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderTextureUnitParameter = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CURRENT_TEXTURE_COORDS := new VertexShaderTextureUnitParameter($0B03);
    private static _TEXTURE_MATRIX         := new VertexShaderTextureUnitParameter($0BA8);
    
    public static property CURRENT_TEXTURE_COORDS: VertexShaderTextureUnitParameter read _CURRENT_TEXTURE_COORDS;
    public static property TEXTURE_MATRIX:         VertexShaderTextureUnitParameter read _TEXTURE_MATRIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderTextureUnitParameter).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderTextureUnitParameter(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderTextureUnitParameter[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion Core}
  
  {$region ARB}
  
  BufferAccessARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _READ_ONLY  := new BufferAccessARB($88B8);
    private static _WRITE_ONLY := new BufferAccessARB($88B9);
    private static _READ_WRITE := new BufferAccessARB($88BA);
    
    public static property READ_ONLY:  BufferAccessARB read _READ_ONLY;
    public static property WRITE_ONLY: BufferAccessARB read _WRITE_ONLY;
    public static property READ_WRITE: BufferAccessARB read _READ_WRITE;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferAccessARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferAccessARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferAccessARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BufferPNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BUFFER_IMMUTABLE_STORAGE := new BufferPNameARB($821F);
    private static _BUFFER_STORAGE_FLAGS     := new BufferPNameARB($8220);
    private static _BUFFER_SIZE              := new BufferPNameARB($8764);
    private static _BUFFER_SIZE_ARB          := new BufferPNameARB($8764);
    private static _BUFFER_USAGE             := new BufferPNameARB($8765);
    private static _BUFFER_USAGE_ARB         := new BufferPNameARB($8765);
    private static _BUFFER_ACCESS            := new BufferPNameARB($88BB);
    private static _BUFFER_ACCESS_ARB        := new BufferPNameARB($88BB);
    private static _BUFFER_MAPPED            := new BufferPNameARB($88BC);
    private static _BUFFER_MAPPED_ARB        := new BufferPNameARB($88BC);
    private static _BUFFER_ACCESS_FLAGS      := new BufferPNameARB($911F);
    private static _BUFFER_MAP_LENGTH        := new BufferPNameARB($9120);
    private static _BUFFER_MAP_OFFSET        := new BufferPNameARB($9121);
    
    public static property BUFFER_IMMUTABLE_STORAGE: BufferPNameARB read _BUFFER_IMMUTABLE_STORAGE;
    public static property BUFFER_STORAGE_FLAGS:     BufferPNameARB read _BUFFER_STORAGE_FLAGS;
    public static property BUFFER_SIZE:              BufferPNameARB read _BUFFER_SIZE;
    public static property BUFFER_SIZE_ARB:          BufferPNameARB read _BUFFER_SIZE_ARB;
    public static property BUFFER_USAGE:             BufferPNameARB read _BUFFER_USAGE;
    public static property BUFFER_USAGE_ARB:         BufferPNameARB read _BUFFER_USAGE_ARB;
    public static property BUFFER_ACCESS:            BufferPNameARB read _BUFFER_ACCESS;
    public static property BUFFER_ACCESS_ARB:        BufferPNameARB read _BUFFER_ACCESS_ARB;
    public static property BUFFER_MAPPED:            BufferPNameARB read _BUFFER_MAPPED;
    public static property BUFFER_MAPPED_ARB:        BufferPNameARB read _BUFFER_MAPPED_ARB;
    public static property BUFFER_ACCESS_FLAGS:      BufferPNameARB read _BUFFER_ACCESS_FLAGS;
    public static property BUFFER_MAP_LENGTH:        BufferPNameARB read _BUFFER_MAP_LENGTH;
    public static property BUFFER_MAP_OFFSET:        BufferPNameARB read _BUFFER_MAP_OFFSET;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferPNameARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferPNameARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferPNameARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BufferPointerNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BUFFER_MAP_POINTER     := new BufferPointerNameARB($88BD);
    private static _BUFFER_MAP_POINTER_ARB := new BufferPointerNameARB($88BD);
    
    public static property BUFFER_MAP_POINTER:     BufferPointerNameARB read _BUFFER_MAP_POINTER;
    public static property BUFFER_MAP_POINTER_ARB: BufferPointerNameARB read _BUFFER_MAP_POINTER_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferPointerNameARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferPointerNameARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferPointerNameARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BufferTargetARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PARAMETER_BUFFER          := new BufferTargetARB($80EE);
    private static _ARRAY_BUFFER              := new BufferTargetARB($8892);
    private static _ELEMENT_ARRAY_BUFFER      := new BufferTargetARB($8893);
    private static _PIXEL_PACK_BUFFER         := new BufferTargetARB($88EB);
    private static _PIXEL_UNPACK_BUFFER       := new BufferTargetARB($88EC);
    private static _UNIFORM_BUFFER            := new BufferTargetARB($8A11);
    private static _TEXTURE_BUFFER            := new BufferTargetARB($8C2A);
    private static _TRANSFORM_FEEDBACK_BUFFER := new BufferTargetARB($8C8E);
    private static _COPY_READ_BUFFER          := new BufferTargetARB($8F36);
    private static _COPY_WRITE_BUFFER         := new BufferTargetARB($8F37);
    private static _DRAW_INDIRECT_BUFFER      := new BufferTargetARB($8F3F);
    private static _SHADER_STORAGE_BUFFER     := new BufferTargetARB($90D2);
    private static _DISPATCH_INDIRECT_BUFFER  := new BufferTargetARB($90EE);
    private static _QUERY_BUFFER              := new BufferTargetARB($9192);
    private static _ATOMIC_COUNTER_BUFFER     := new BufferTargetARB($92C0);
    
    public static property PARAMETER_BUFFER:          BufferTargetARB read _PARAMETER_BUFFER;
    public static property ARRAY_BUFFER:              BufferTargetARB read _ARRAY_BUFFER;
    public static property ELEMENT_ARRAY_BUFFER:      BufferTargetARB read _ELEMENT_ARRAY_BUFFER;
    public static property PIXEL_PACK_BUFFER:         BufferTargetARB read _PIXEL_PACK_BUFFER;
    public static property PIXEL_UNPACK_BUFFER:       BufferTargetARB read _PIXEL_UNPACK_BUFFER;
    public static property UNIFORM_BUFFER:            BufferTargetARB read _UNIFORM_BUFFER;
    public static property TEXTURE_BUFFER:            BufferTargetARB read _TEXTURE_BUFFER;
    public static property TRANSFORM_FEEDBACK_BUFFER: BufferTargetARB read _TRANSFORM_FEEDBACK_BUFFER;
    public static property COPY_READ_BUFFER:          BufferTargetARB read _COPY_READ_BUFFER;
    public static property COPY_WRITE_BUFFER:         BufferTargetARB read _COPY_WRITE_BUFFER;
    public static property DRAW_INDIRECT_BUFFER:      BufferTargetARB read _DRAW_INDIRECT_BUFFER;
    public static property SHADER_STORAGE_BUFFER:     BufferTargetARB read _SHADER_STORAGE_BUFFER;
    public static property DISPATCH_INDIRECT_BUFFER:  BufferTargetARB read _DISPATCH_INDIRECT_BUFFER;
    public static property QUERY_BUFFER:              BufferTargetARB read _QUERY_BUFFER;
    public static property ATOMIC_COUNTER_BUFFER:     BufferTargetARB read _ATOMIC_COUNTER_BUFFER;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferTargetARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferTargetARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferTargetARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BufferUsageARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STREAM_DRAW  := new BufferUsageARB($88E0);
    private static _STREAM_READ  := new BufferUsageARB($88E1);
    private static _STREAM_COPY  := new BufferUsageARB($88E2);
    private static _STATIC_DRAW  := new BufferUsageARB($88E4);
    private static _STATIC_READ  := new BufferUsageARB($88E5);
    private static _STATIC_COPY  := new BufferUsageARB($88E6);
    private static _DYNAMIC_DRAW := new BufferUsageARB($88E8);
    private static _DYNAMIC_READ := new BufferUsageARB($88E9);
    private static _DYNAMIC_COPY := new BufferUsageARB($88EA);
    
    public static property STREAM_DRAW:  BufferUsageARB read _STREAM_DRAW;
    public static property STREAM_READ:  BufferUsageARB read _STREAM_READ;
    public static property STREAM_COPY:  BufferUsageARB read _STREAM_COPY;
    public static property STATIC_DRAW:  BufferUsageARB read _STATIC_DRAW;
    public static property STATIC_READ:  BufferUsageARB read _STATIC_READ;
    public static property STATIC_COPY:  BufferUsageARB read _STATIC_COPY;
    public static property DYNAMIC_DRAW: BufferUsageARB read _DYNAMIC_DRAW;
    public static property DYNAMIC_READ: BufferUsageARB read _DYNAMIC_READ;
    public static property DYNAMIC_COPY: BufferUsageARB read _DYNAMIC_COPY;
    
    public function ToString: string; override;
    begin
      var res := typeof(BufferUsageARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BufferUsageARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BufferUsageARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ClampColorModeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FALSE          := new ClampColorModeARB($0000);
    private static _TRUE           := new ClampColorModeARB($0001);
    private static _FIXED_ONLY     := new ClampColorModeARB($891D);
    private static _FIXED_ONLY_ARB := new ClampColorModeARB($891D);
    
    public static property FALSE:          ClampColorModeARB read _FALSE;
    public static property TRUE:           ClampColorModeARB read _TRUE;
    public static property FIXED_ONLY:     ClampColorModeARB read _FIXED_ONLY;
    public static property FIXED_ONLY_ARB: ClampColorModeARB read _FIXED_ONLY_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClampColorModeARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ClampColorModeARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ClampColorModeARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ClampColorTargetARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CLAMP_VERTEX_COLOR_ARB   := new ClampColorTargetARB($891A);
    private static _CLAMP_FRAGMENT_COLOR_ARB := new ClampColorTargetARB($891B);
    private static _CLAMP_READ_COLOR         := new ClampColorTargetARB($891C);
    private static _CLAMP_READ_COLOR_ARB     := new ClampColorTargetARB($891C);
    
    public static property CLAMP_VERTEX_COLOR_ARB:   ClampColorTargetARB read _CLAMP_VERTEX_COLOR_ARB;
    public static property CLAMP_FRAGMENT_COLOR_ARB: ClampColorTargetARB read _CLAMP_FRAGMENT_COLOR_ARB;
    public static property CLAMP_READ_COLOR:         ClampColorTargetARB read _CLAMP_READ_COLOR;
    public static property CLAMP_READ_COLOR_ARB:     ClampColorTargetARB read _CLAMP_READ_COLOR_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(ClampColorTargetARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ClampColorTargetARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ClampColorTargetARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MatrixIndexPointerTypeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_BYTE  := new MatrixIndexPointerTypeARB($1401);
    private static _UNSIGNED_SHORT := new MatrixIndexPointerTypeARB($1403);
    private static _UNSIGNED_INT   := new MatrixIndexPointerTypeARB($1405);
    
    public static property UNSIGNED_BYTE:  MatrixIndexPointerTypeARB read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: MatrixIndexPointerTypeARB read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   MatrixIndexPointerTypeARB read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(MatrixIndexPointerTypeARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MatrixIndexPointerTypeARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MatrixIndexPointerTypeARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PointParameterNameARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _POINT_SIZE_MIN_EXT            := new PointParameterNameARB($8126);
    private static _POINT_SIZE_MAX_EXT            := new PointParameterNameARB($8127);
    private static _POINT_FADE_THRESHOLD_SIZE     := new PointParameterNameARB($8128);
    private static _POINT_FADE_THRESHOLD_SIZE_EXT := new PointParameterNameARB($8128);
    
    public static property POINT_SIZE_MIN_EXT:            PointParameterNameARB read _POINT_SIZE_MIN_EXT;
    public static property POINT_SIZE_MAX_EXT:            PointParameterNameARB read _POINT_SIZE_MAX_EXT;
    public static property POINT_FADE_THRESHOLD_SIZE:     PointParameterNameARB read _POINT_FADE_THRESHOLD_SIZE;
    public static property POINT_FADE_THRESHOLD_SIZE_EXT: PointParameterNameARB read _POINT_FADE_THRESHOLD_SIZE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PointParameterNameARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PointParameterNameARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PointParameterNameARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ProgramPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COMPUTE_WORK_GROUP_SIZE               := new ProgramPropertyARB($8267);
    private static _PROGRAM_BINARY_LENGTH                 := new ProgramPropertyARB($8741);
    private static _GEOMETRY_VERTICES_OUT                 := new ProgramPropertyARB($8916);
    private static _GEOMETRY_INPUT_TYPE                   := new ProgramPropertyARB($8917);
    private static _GEOMETRY_OUTPUT_TYPE                  := new ProgramPropertyARB($8918);
    private static _ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH  := new ProgramPropertyARB($8A35);
    private static _ACTIVE_UNIFORM_BLOCKS                 := new ProgramPropertyARB($8A36);
    private static _DELETE_STATUS                         := new ProgramPropertyARB($8B80);
    private static _LINK_STATUS                           := new ProgramPropertyARB($8B82);
    private static _VALIDATE_STATUS                       := new ProgramPropertyARB($8B83);
    private static _INFO_LOG_LENGTH                       := new ProgramPropertyARB($8B84);
    private static _ATTACHED_SHADERS                      := new ProgramPropertyARB($8B85);
    private static _ACTIVE_UNIFORMS                       := new ProgramPropertyARB($8B86);
    private static _ACTIVE_UNIFORM_MAX_LENGTH             := new ProgramPropertyARB($8B87);
    private static _ACTIVE_ATTRIBUTES                     := new ProgramPropertyARB($8B89);
    private static _ACTIVE_ATTRIBUTE_MAX_LENGTH           := new ProgramPropertyARB($8B8A);
    private static _TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH := new ProgramPropertyARB($8C76);
    private static _TRANSFORM_FEEDBACK_BUFFER_MODE        := new ProgramPropertyARB($8C7F);
    private static _TRANSFORM_FEEDBACK_VARYINGS           := new ProgramPropertyARB($8C83);
    private static _ACTIVE_ATOMIC_COUNTER_BUFFERS         := new ProgramPropertyARB($92D9);
    
    public static property COMPUTE_WORK_GROUP_SIZE:               ProgramPropertyARB read _COMPUTE_WORK_GROUP_SIZE;
    public static property PROGRAM_BINARY_LENGTH:                 ProgramPropertyARB read _PROGRAM_BINARY_LENGTH;
    public static property GEOMETRY_VERTICES_OUT:                 ProgramPropertyARB read _GEOMETRY_VERTICES_OUT;
    public static property GEOMETRY_INPUT_TYPE:                   ProgramPropertyARB read _GEOMETRY_INPUT_TYPE;
    public static property GEOMETRY_OUTPUT_TYPE:                  ProgramPropertyARB read _GEOMETRY_OUTPUT_TYPE;
    public static property ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH:  ProgramPropertyARB read _ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH;
    public static property ACTIVE_UNIFORM_BLOCKS:                 ProgramPropertyARB read _ACTIVE_UNIFORM_BLOCKS;
    public static property DELETE_STATUS:                         ProgramPropertyARB read _DELETE_STATUS;
    public static property LINK_STATUS:                           ProgramPropertyARB read _LINK_STATUS;
    public static property VALIDATE_STATUS:                       ProgramPropertyARB read _VALIDATE_STATUS;
    public static property INFO_LOG_LENGTH:                       ProgramPropertyARB read _INFO_LOG_LENGTH;
    public static property ATTACHED_SHADERS:                      ProgramPropertyARB read _ATTACHED_SHADERS;
    public static property ACTIVE_UNIFORMS:                       ProgramPropertyARB read _ACTIVE_UNIFORMS;
    public static property ACTIVE_UNIFORM_MAX_LENGTH:             ProgramPropertyARB read _ACTIVE_UNIFORM_MAX_LENGTH;
    public static property ACTIVE_ATTRIBUTES:                     ProgramPropertyARB read _ACTIVE_ATTRIBUTES;
    public static property ACTIVE_ATTRIBUTE_MAX_LENGTH:           ProgramPropertyARB read _ACTIVE_ATTRIBUTE_MAX_LENGTH;
    public static property TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH: ProgramPropertyARB read _TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH;
    public static property TRANSFORM_FEEDBACK_BUFFER_MODE:        ProgramPropertyARB read _TRANSFORM_FEEDBACK_BUFFER_MODE;
    public static property TRANSFORM_FEEDBACK_VARYINGS:           ProgramPropertyARB read _TRANSFORM_FEEDBACK_VARYINGS;
    public static property ACTIVE_ATOMIC_COUNTER_BUFFERS:         ProgramPropertyARB read _ACTIVE_ATOMIC_COUNTER_BUFFERS;
    
    public function ToString: string; override;
    begin
      var res := typeof(ProgramPropertyARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ProgramPropertyARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ProgramPropertyARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribPointerPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_ATTRIB_ARRAY_POINTER     := new VertexAttribPointerPropertyARB($8645);
    private static _VERTEX_ATTRIB_ARRAY_POINTER_ARB := new VertexAttribPointerPropertyARB($8645);
    
    public static property VERTEX_ATTRIB_ARRAY_POINTER:     VertexAttribPointerPropertyARB read _VERTEX_ATTRIB_ARRAY_POINTER;
    public static property VERTEX_ATTRIB_ARRAY_POINTER_ARB: VertexAttribPointerPropertyARB read _VERTEX_ATTRIB_ARRAY_POINTER_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribPointerPropertyARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribPointerPropertyARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribPointerPropertyARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribPropertyARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_ATTRIB_BINDING              := new VertexAttribPropertyARB($82D4);
    private static _VERTEX_ATTRIB_RELATIVE_OFFSET      := new VertexAttribPropertyARB($82D5);
    private static _VERTEX_ATTRIB_ARRAY_ENABLED        := new VertexAttribPropertyARB($8622);
    private static _VERTEX_ATTRIB_ARRAY_SIZE           := new VertexAttribPropertyARB($8623);
    private static _VERTEX_ATTRIB_ARRAY_STRIDE         := new VertexAttribPropertyARB($8624);
    private static _VERTEX_ATTRIB_ARRAY_TYPE           := new VertexAttribPropertyARB($8625);
    private static _CURRENT_VERTEX_ATTRIB              := new VertexAttribPropertyARB($8626);
    private static _VERTEX_ATTRIB_ARRAY_LONG           := new VertexAttribPropertyARB($874E);
    private static _VERTEX_ATTRIB_ARRAY_NORMALIZED     := new VertexAttribPropertyARB($886A);
    private static _VERTEX_ATTRIB_ARRAY_BUFFER_BINDING := new VertexAttribPropertyARB($889F);
    private static _VERTEX_ATTRIB_ARRAY_INTEGER        := new VertexAttribPropertyARB($88FD);
    private static _VERTEX_ATTRIB_ARRAY_INTEGER_EXT    := new VertexAttribPropertyARB($88FD);
    private static _VERTEX_ATTRIB_ARRAY_DIVISOR        := new VertexAttribPropertyARB($88FE);
    
    public static property VERTEX_ATTRIB_BINDING:              VertexAttribPropertyARB read _VERTEX_ATTRIB_BINDING;
    public static property VERTEX_ATTRIB_RELATIVE_OFFSET:      VertexAttribPropertyARB read _VERTEX_ATTRIB_RELATIVE_OFFSET;
    public static property VERTEX_ATTRIB_ARRAY_ENABLED:        VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_ENABLED;
    public static property VERTEX_ATTRIB_ARRAY_SIZE:           VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_SIZE;
    public static property VERTEX_ATTRIB_ARRAY_STRIDE:         VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_STRIDE;
    public static property VERTEX_ATTRIB_ARRAY_TYPE:           VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_TYPE;
    public static property CURRENT_VERTEX_ATTRIB:              VertexAttribPropertyARB read _CURRENT_VERTEX_ATTRIB;
    public static property VERTEX_ATTRIB_ARRAY_LONG:           VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_LONG;
    public static property VERTEX_ATTRIB_ARRAY_NORMALIZED:     VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_NORMALIZED;
    public static property VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_BUFFER_BINDING;
    public static property VERTEX_ATTRIB_ARRAY_INTEGER:        VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_INTEGER;
    public static property VERTEX_ATTRIB_ARRAY_INTEGER_EXT:    VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_INTEGER_EXT;
    public static property VERTEX_ATTRIB_ARRAY_DIVISOR:        VertexAttribPropertyARB read _VERTEX_ATTRIB_ARRAY_DIVISOR;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribPropertyARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribPropertyARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribPropertyARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  WeightPointerTypeARB = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE           := new WeightPointerTypeARB($1400);
    private static _UNSIGNED_BYTE  := new WeightPointerTypeARB($1401);
    private static _SHORT          := new WeightPointerTypeARB($1402);
    private static _UNSIGNED_SHORT := new WeightPointerTypeARB($1403);
    private static _INT            := new WeightPointerTypeARB($1404);
    private static _UNSIGNED_INT   := new WeightPointerTypeARB($1405);
    private static _FLOAT          := new WeightPointerTypeARB($1406);
    private static _DOUBLE         := new WeightPointerTypeARB($140A);
    
    public static property BYTE:           WeightPointerTypeARB read _BYTE;
    public static property UNSIGNED_BYTE:  WeightPointerTypeARB read _UNSIGNED_BYTE;
    public static property SHORT:          WeightPointerTypeARB read _SHORT;
    public static property UNSIGNED_SHORT: WeightPointerTypeARB read _UNSIGNED_SHORT;
    public static property INT:            WeightPointerTypeARB read _INT;
    public static property UNSIGNED_INT:   WeightPointerTypeARB read _UNSIGNED_INT;
    public static property FLOAT:          WeightPointerTypeARB read _FLOAT;
    public static property DOUBLE:         WeightPointerTypeARB read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(WeightPointerTypeARB).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->WeightPointerTypeARB(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'WeightPointerTypeARB[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion ARB}
  
  {$region EXT}
  
  BinormalPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE       := new BinormalPointerTypeEXT($1400);
    private static _SHORT      := new BinormalPointerTypeEXT($1402);
    private static _INT        := new BinormalPointerTypeEXT($1404);
    private static _FLOAT      := new BinormalPointerTypeEXT($1406);
    private static _DOUBLE     := new BinormalPointerTypeEXT($140A);
    private static _DOUBLE_EXT := new BinormalPointerTypeEXT($140A);
    
    public static property BYTE:       BinormalPointerTypeEXT read _BYTE;
    public static property SHORT:      BinormalPointerTypeEXT read _SHORT;
    public static property INT:        BinormalPointerTypeEXT read _INT;
    public static property FLOAT:      BinormalPointerTypeEXT read _FLOAT;
    public static property DOUBLE:     BinormalPointerTypeEXT read _DOUBLE;
    public static property DOUBLE_EXT: BinormalPointerTypeEXT read _DOUBLE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(BinormalPointerTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BinormalPointerTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BinormalPointerTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  BlendEquationModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FUNC_ADD                  := new BlendEquationModeEXT($8006);
    private static _FUNC_ADD_EXT              := new BlendEquationModeEXT($8006);
    private static _MIN                       := new BlendEquationModeEXT($8007);
    private static _MIN_EXT                   := new BlendEquationModeEXT($8007);
    private static _MAX                       := new BlendEquationModeEXT($8008);
    private static _MAX_EXT                   := new BlendEquationModeEXT($8008);
    private static _FUNC_SUBTRACT             := new BlendEquationModeEXT($800A);
    private static _FUNC_SUBTRACT_EXT         := new BlendEquationModeEXT($800A);
    private static _FUNC_REVERSE_SUBTRACT     := new BlendEquationModeEXT($800B);
    private static _FUNC_REVERSE_SUBTRACT_EXT := new BlendEquationModeEXT($800B);
    private static _ALPHA_MIN_SGIX            := new BlendEquationModeEXT($8320);
    private static _ALPHA_MAX_SGIX            := new BlendEquationModeEXT($8321);
    
    public static property FUNC_ADD:                  BlendEquationModeEXT read _FUNC_ADD;
    public static property FUNC_ADD_EXT:              BlendEquationModeEXT read _FUNC_ADD_EXT;
    public static property MIN:                       BlendEquationModeEXT read _MIN;
    public static property MIN_EXT:                   BlendEquationModeEXT read _MIN_EXT;
    public static property MAX:                       BlendEquationModeEXT read _MAX;
    public static property MAX_EXT:                   BlendEquationModeEXT read _MAX_EXT;
    public static property FUNC_SUBTRACT:             BlendEquationModeEXT read _FUNC_SUBTRACT;
    public static property FUNC_SUBTRACT_EXT:         BlendEquationModeEXT read _FUNC_SUBTRACT_EXT;
    public static property FUNC_REVERSE_SUBTRACT:     BlendEquationModeEXT read _FUNC_REVERSE_SUBTRACT;
    public static property FUNC_REVERSE_SUBTRACT_EXT: BlendEquationModeEXT read _FUNC_REVERSE_SUBTRACT_EXT;
    public static property ALPHA_MIN_SGIX:            BlendEquationModeEXT read _ALPHA_MIN_SGIX;
    public static property ALPHA_MAX_SGIX:            BlendEquationModeEXT read _ALPHA_MAX_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(BlendEquationModeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->BlendEquationModeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'BlendEquationModeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ConvolutionParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CONVOLUTION_BORDER_MODE      := new ConvolutionParameterEXT($8013);
    private static _CONVOLUTION_BORDER_MODE_EXT  := new ConvolutionParameterEXT($8013);
    private static _CONVOLUTION_FILTER_SCALE     := new ConvolutionParameterEXT($8014);
    private static _CONVOLUTION_FILTER_SCALE_EXT := new ConvolutionParameterEXT($8014);
    private static _CONVOLUTION_FILTER_BIAS      := new ConvolutionParameterEXT($8015);
    private static _CONVOLUTION_FILTER_BIAS_EXT  := new ConvolutionParameterEXT($8015);
    
    public static property CONVOLUTION_BORDER_MODE:      ConvolutionParameterEXT read _CONVOLUTION_BORDER_MODE;
    public static property CONVOLUTION_BORDER_MODE_EXT:  ConvolutionParameterEXT read _CONVOLUTION_BORDER_MODE_EXT;
    public static property CONVOLUTION_FILTER_SCALE:     ConvolutionParameterEXT read _CONVOLUTION_FILTER_SCALE;
    public static property CONVOLUTION_FILTER_SCALE_EXT: ConvolutionParameterEXT read _CONVOLUTION_FILTER_SCALE_EXT;
    public static property CONVOLUTION_FILTER_BIAS:      ConvolutionParameterEXT read _CONVOLUTION_FILTER_BIAS;
    public static property CONVOLUTION_FILTER_BIAS_EXT:  ConvolutionParameterEXT read _CONVOLUTION_FILTER_BIAS_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ConvolutionParameterEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ConvolutionParameterEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ConvolutionParameterEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ConvolutionTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CONVOLUTION_1D     := new ConvolutionTargetEXT($8010);
    private static _CONVOLUTION_1D_EXT := new ConvolutionTargetEXT($8010);
    private static _CONVOLUTION_2D     := new ConvolutionTargetEXT($8011);
    private static _CONVOLUTION_2D_EXT := new ConvolutionTargetEXT($8011);
    
    public static property CONVOLUTION_1D:     ConvolutionTargetEXT read _CONVOLUTION_1D;
    public static property CONVOLUTION_1D_EXT: ConvolutionTargetEXT read _CONVOLUTION_1D_EXT;
    public static property CONVOLUTION_2D:     ConvolutionTargetEXT read _CONVOLUTION_2D;
    public static property CONVOLUTION_2D_EXT: ConvolutionTargetEXT read _CONVOLUTION_2D_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ConvolutionTargetEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ConvolutionTargetEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ConvolutionTargetEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CullParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CULL_VERTEX_EYE_POSITION_EXT    := new CullParameterEXT($81AB);
    private static _CULL_VERTEX_OBJECT_POSITION_EXT := new CullParameterEXT($81AC);
    
    public static property CULL_VERTEX_EYE_POSITION_EXT:    CullParameterEXT read _CULL_VERTEX_EYE_POSITION_EXT;
    public static property CULL_VERTEX_OBJECT_POSITION_EXT: CullParameterEXT read _CULL_VERTEX_OBJECT_POSITION_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(CullParameterEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CullParameterEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CullParameterEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  DataTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SCALAR_EXT := new DataTypeEXT($87BE);
    private static _VECTOR_EXT := new DataTypeEXT($87BF);
    private static _MATRIX_EXT := new DataTypeEXT($87C0);
    
    public static property SCALAR_EXT: DataTypeEXT read _SCALAR_EXT;
    public static property VECTOR_EXT: DataTypeEXT read _VECTOR_EXT;
    public static property MATRIX_EXT: DataTypeEXT read _MATRIX_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(DataTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->DataTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'DataTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FogPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLOAT  := new FogPointerTypeEXT($1406);
    private static _DOUBLE := new FogPointerTypeEXT($140A);
    
    public static property FLOAT:  FogPointerTypeEXT read _FLOAT;
    public static property DOUBLE: FogPointerTypeEXT read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(FogPointerTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FogPointerTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FogPointerTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetHistogramParameterPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _HISTOGRAM_WIDTH              := new GetHistogramParameterPNameEXT($8026);
    private static _HISTOGRAM_WIDTH_EXT          := new GetHistogramParameterPNameEXT($8026);
    private static _HISTOGRAM_FORMAT             := new GetHistogramParameterPNameEXT($8027);
    private static _HISTOGRAM_FORMAT_EXT         := new GetHistogramParameterPNameEXT($8027);
    private static _HISTOGRAM_RED_SIZE           := new GetHistogramParameterPNameEXT($8028);
    private static _HISTOGRAM_RED_SIZE_EXT       := new GetHistogramParameterPNameEXT($8028);
    private static _HISTOGRAM_GREEN_SIZE         := new GetHistogramParameterPNameEXT($8029);
    private static _HISTOGRAM_GREEN_SIZE_EXT     := new GetHistogramParameterPNameEXT($8029);
    private static _HISTOGRAM_BLUE_SIZE          := new GetHistogramParameterPNameEXT($802A);
    private static _HISTOGRAM_BLUE_SIZE_EXT      := new GetHistogramParameterPNameEXT($802A);
    private static _HISTOGRAM_ALPHA_SIZE         := new GetHistogramParameterPNameEXT($802B);
    private static _HISTOGRAM_ALPHA_SIZE_EXT     := new GetHistogramParameterPNameEXT($802B);
    private static _HISTOGRAM_LUMINANCE_SIZE     := new GetHistogramParameterPNameEXT($802C);
    private static _HISTOGRAM_LUMINANCE_SIZE_EXT := new GetHistogramParameterPNameEXT($802C);
    private static _HISTOGRAM_SINK               := new GetHistogramParameterPNameEXT($802D);
    private static _HISTOGRAM_SINK_EXT           := new GetHistogramParameterPNameEXT($802D);
    
    public static property HISTOGRAM_WIDTH:              GetHistogramParameterPNameEXT read _HISTOGRAM_WIDTH;
    public static property HISTOGRAM_WIDTH_EXT:          GetHistogramParameterPNameEXT read _HISTOGRAM_WIDTH_EXT;
    public static property HISTOGRAM_FORMAT:             GetHistogramParameterPNameEXT read _HISTOGRAM_FORMAT;
    public static property HISTOGRAM_FORMAT_EXT:         GetHistogramParameterPNameEXT read _HISTOGRAM_FORMAT_EXT;
    public static property HISTOGRAM_RED_SIZE:           GetHistogramParameterPNameEXT read _HISTOGRAM_RED_SIZE;
    public static property HISTOGRAM_RED_SIZE_EXT:       GetHistogramParameterPNameEXT read _HISTOGRAM_RED_SIZE_EXT;
    public static property HISTOGRAM_GREEN_SIZE:         GetHistogramParameterPNameEXT read _HISTOGRAM_GREEN_SIZE;
    public static property HISTOGRAM_GREEN_SIZE_EXT:     GetHistogramParameterPNameEXT read _HISTOGRAM_GREEN_SIZE_EXT;
    public static property HISTOGRAM_BLUE_SIZE:          GetHistogramParameterPNameEXT read _HISTOGRAM_BLUE_SIZE;
    public static property HISTOGRAM_BLUE_SIZE_EXT:      GetHistogramParameterPNameEXT read _HISTOGRAM_BLUE_SIZE_EXT;
    public static property HISTOGRAM_ALPHA_SIZE:         GetHistogramParameterPNameEXT read _HISTOGRAM_ALPHA_SIZE;
    public static property HISTOGRAM_ALPHA_SIZE_EXT:     GetHistogramParameterPNameEXT read _HISTOGRAM_ALPHA_SIZE_EXT;
    public static property HISTOGRAM_LUMINANCE_SIZE:     GetHistogramParameterPNameEXT read _HISTOGRAM_LUMINANCE_SIZE;
    public static property HISTOGRAM_LUMINANCE_SIZE_EXT: GetHistogramParameterPNameEXT read _HISTOGRAM_LUMINANCE_SIZE_EXT;
    public static property HISTOGRAM_SINK:               GetHistogramParameterPNameEXT read _HISTOGRAM_SINK;
    public static property HISTOGRAM_SINK_EXT:           GetHistogramParameterPNameEXT read _HISTOGRAM_SINK_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetHistogramParameterPNameEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetHistogramParameterPNameEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetHistogramParameterPNameEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetMinmaxParameterPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MINMAX_FORMAT     := new GetMinmaxParameterPNameEXT($802F);
    private static _MINMAX_FORMAT_EXT := new GetMinmaxParameterPNameEXT($802F);
    private static _MINMAX_SINK       := new GetMinmaxParameterPNameEXT($8030);
    private static _MINMAX_SINK_EXT   := new GetMinmaxParameterPNameEXT($8030);
    
    public static property MINMAX_FORMAT:     GetMinmaxParameterPNameEXT read _MINMAX_FORMAT;
    public static property MINMAX_FORMAT_EXT: GetMinmaxParameterPNameEXT read _MINMAX_FORMAT_EXT;
    public static property MINMAX_SINK:       GetMinmaxParameterPNameEXT read _MINMAX_SINK;
    public static property MINMAX_SINK_EXT:   GetMinmaxParameterPNameEXT read _MINMAX_SINK_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetMinmaxParameterPNameEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetMinmaxParameterPNameEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetMinmaxParameterPNameEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetVariantValueEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VARIANT_VALUE_EXT        := new GetVariantValueEXT($87E4);
    private static _VARIANT_DATATYPE_EXT     := new GetVariantValueEXT($87E5);
    private static _VARIANT_ARRAY_STRIDE_EXT := new GetVariantValueEXT($87E6);
    private static _VARIANT_ARRAY_TYPE_EXT   := new GetVariantValueEXT($87E7);
    
    public static property VARIANT_VALUE_EXT:        GetVariantValueEXT read _VARIANT_VALUE_EXT;
    public static property VARIANT_DATATYPE_EXT:     GetVariantValueEXT read _VARIANT_DATATYPE_EXT;
    public static property VARIANT_ARRAY_STRIDE_EXT: GetVariantValueEXT read _VARIANT_ARRAY_STRIDE_EXT;
    public static property VARIANT_ARRAY_TYPE_EXT:   GetVariantValueEXT read _VARIANT_ARRAY_TYPE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetVariantValueEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetVariantValueEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetVariantValueEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  HistogramTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _HISTOGRAM           := new HistogramTargetEXT($8024);
    private static _HISTOGRAM_EXT       := new HistogramTargetEXT($8024);
    private static _PROXY_HISTOGRAM     := new HistogramTargetEXT($8025);
    private static _PROXY_HISTOGRAM_EXT := new HistogramTargetEXT($8025);
    
    public static property HISTOGRAM:           HistogramTargetEXT read _HISTOGRAM;
    public static property HISTOGRAM_EXT:       HistogramTargetEXT read _HISTOGRAM_EXT;
    public static property PROXY_HISTOGRAM:     HistogramTargetEXT read _PROXY_HISTOGRAM;
    public static property PROXY_HISTOGRAM_EXT: HistogramTargetEXT read _PROXY_HISTOGRAM_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(HistogramTargetEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->HistogramTargetEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'HistogramTargetEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  IndexFunctionEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NEVER    := new IndexFunctionEXT($0200);
    private static _LESS     := new IndexFunctionEXT($0201);
    private static _EQUAL    := new IndexFunctionEXT($0202);
    private static _LEQUAL   := new IndexFunctionEXT($0203);
    private static _GREATER  := new IndexFunctionEXT($0204);
    private static _NOTEQUAL := new IndexFunctionEXT($0205);
    private static _GEQUAL   := new IndexFunctionEXT($0206);
    private static _ALWAYS   := new IndexFunctionEXT($0207);
    
    public static property NEVER:    IndexFunctionEXT read _NEVER;
    public static property LESS:     IndexFunctionEXT read _LESS;
    public static property EQUAL:    IndexFunctionEXT read _EQUAL;
    public static property LEQUAL:   IndexFunctionEXT read _LEQUAL;
    public static property GREATER:  IndexFunctionEXT read _GREATER;
    public static property NOTEQUAL: IndexFunctionEXT read _NOTEQUAL;
    public static property GEQUAL:   IndexFunctionEXT read _GEQUAL;
    public static property ALWAYS:   IndexFunctionEXT read _ALWAYS;
    
    public function ToString: string; override;
    begin
      var res := typeof(IndexFunctionEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->IndexFunctionEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'IndexFunctionEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  IndexMaterialParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _INDEX_OFFSET := new IndexMaterialParameterEXT($0D13);
    
    public static property INDEX_OFFSET: IndexMaterialParameterEXT read _INDEX_OFFSET;
    
    public function ToString: string; override;
    begin
      var res := typeof(IndexMaterialParameterEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->IndexMaterialParameterEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'IndexMaterialParameterEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightTextureModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAGMENT_MATERIAL_EXT := new LightTextureModeEXT($8349);
    private static _FRAGMENT_NORMAL_EXT   := new LightTextureModeEXT($834A);
    private static _FRAGMENT_COLOR_EXT    := new LightTextureModeEXT($834C);
    private static _FRAGMENT_DEPTH_EXT    := new LightTextureModeEXT($8452);
    
    public static property FRAGMENT_MATERIAL_EXT: LightTextureModeEXT read _FRAGMENT_MATERIAL_EXT;
    public static property FRAGMENT_NORMAL_EXT:   LightTextureModeEXT read _FRAGMENT_NORMAL_EXT;
    public static property FRAGMENT_COLOR_EXT:    LightTextureModeEXT read _FRAGMENT_COLOR_EXT;
    public static property FRAGMENT_DEPTH_EXT:    LightTextureModeEXT read _FRAGMENT_DEPTH_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightTextureModeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightTextureModeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightTextureModeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightTexturePNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ATTENUATION_EXT        := new LightTexturePNameEXT($834D);
    private static _SHADOW_ATTENUATION_EXT := new LightTexturePNameEXT($834E);
    
    public static property ATTENUATION_EXT:        LightTexturePNameEXT read _ATTENUATION_EXT;
    public static property SHADOW_ATTENUATION_EXT: LightTexturePNameEXT read _SHADOW_ATTENUATION_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightTexturePNameEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightTexturePNameEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightTexturePNameEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MinmaxTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MINMAX     := new MinmaxTargetEXT($802E);
    private static _MINMAX_EXT := new MinmaxTargetEXT($802E);
    
    public static property MINMAX:     MinmaxTargetEXT read _MINMAX;
    public static property MINMAX_EXT: MinmaxTargetEXT read _MINMAX_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(MinmaxTargetEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MinmaxTargetEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MinmaxTargetEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ParameterRangeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NORMALIZED_RANGE_EXT := new ParameterRangeEXT($87E0);
    private static _FULL_RANGE_EXT       := new ParameterRangeEXT($87E1);
    
    public static property NORMALIZED_RANGE_EXT: ParameterRangeEXT read _NORMALIZED_RANGE_EXT;
    public static property FULL_RANGE_EXT:       ParameterRangeEXT read _FULL_RANGE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ParameterRangeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ParameterRangeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ParameterRangeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelTransformPNameEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_MAG_FILTER_EXT   := new PixelTransformPNameEXT($8331);
    private static _PIXEL_MIN_FILTER_EXT   := new PixelTransformPNameEXT($8332);
    private static _PIXEL_CUBIC_WEIGHT_EXT := new PixelTransformPNameEXT($8333);
    
    public static property PIXEL_MAG_FILTER_EXT:   PixelTransformPNameEXT read _PIXEL_MAG_FILTER_EXT;
    public static property PIXEL_MIN_FILTER_EXT:   PixelTransformPNameEXT read _PIXEL_MIN_FILTER_EXT;
    public static property PIXEL_CUBIC_WEIGHT_EXT: PixelTransformPNameEXT read _PIXEL_CUBIC_WEIGHT_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelTransformPNameEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelTransformPNameEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelTransformPNameEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelTransformTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_TRANSFORM_2D_EXT := new PixelTransformTargetEXT($8330);
    
    public static property PIXEL_TRANSFORM_2D_EXT: PixelTransformTargetEXT read _PIXEL_TRANSFORM_2D_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelTransformTargetEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelTransformTargetEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelTransformTargetEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SamplePatternEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _GL_1PASS_EXT   := new SamplePatternEXT($80A1);
    private static _GL_2PASS_0_EXT := new SamplePatternEXT($80A2);
    private static _GL_2PASS_1_EXT := new SamplePatternEXT($80A3);
    private static _GL_4PASS_0_EXT := new SamplePatternEXT($80A4);
    private static _GL_4PASS_1_EXT := new SamplePatternEXT($80A5);
    private static _GL_4PASS_2_EXT := new SamplePatternEXT($80A6);
    private static _GL_4PASS_3_EXT := new SamplePatternEXT($80A7);
    
    public static property GL_1PASS_EXT:   SamplePatternEXT read _GL_1PASS_EXT;
    public static property GL_2PASS_0_EXT: SamplePatternEXT read _GL_2PASS_0_EXT;
    public static property GL_2PASS_1_EXT: SamplePatternEXT read _GL_2PASS_1_EXT;
    public static property GL_4PASS_0_EXT: SamplePatternEXT read _GL_4PASS_0_EXT;
    public static property GL_4PASS_1_EXT: SamplePatternEXT read _GL_4PASS_1_EXT;
    public static property GL_4PASS_2_EXT: SamplePatternEXT read _GL_4PASS_2_EXT;
    public static property GL_4PASS_3_EXT: SamplePatternEXT read _GL_4PASS_3_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(SamplePatternEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SamplePatternEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SamplePatternEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SeparableTargetEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SEPARABLE_2D     := new SeparableTargetEXT($8012);
    private static _SEPARABLE_2D_EXT := new SeparableTargetEXT($8012);
    
    public static property SEPARABLE_2D:     SeparableTargetEXT read _SEPARABLE_2D;
    public static property SEPARABLE_2D_EXT: SeparableTargetEXT read _SEPARABLE_2D_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(SeparableTargetEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SeparableTargetEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SeparableTargetEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TangentPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BYTE       := new TangentPointerTypeEXT($1400);
    private static _SHORT      := new TangentPointerTypeEXT($1402);
    private static _INT        := new TangentPointerTypeEXT($1404);
    private static _FLOAT      := new TangentPointerTypeEXT($1406);
    private static _DOUBLE     := new TangentPointerTypeEXT($140A);
    private static _DOUBLE_EXT := new TangentPointerTypeEXT($140A);
    
    public static property BYTE:       TangentPointerTypeEXT read _BYTE;
    public static property SHORT:      TangentPointerTypeEXT read _SHORT;
    public static property INT:        TangentPointerTypeEXT read _INT;
    public static property FLOAT:      TangentPointerTypeEXT read _FLOAT;
    public static property DOUBLE:     TangentPointerTypeEXT read _DOUBLE;
    public static property DOUBLE_EXT: TangentPointerTypeEXT read _DOUBLE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(TangentPointerTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TangentPointerTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TangentPointerTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureNormalModeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PERTURB_EXT := new TextureNormalModeEXT($85AE);
    
    public static property PERTURB_EXT: TextureNormalModeEXT read _PERTURB_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureNormalModeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureNormalModeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureNormalModeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VariantCapEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VARIANT_ARRAY_EXT := new VariantCapEXT($87E8);
    
    public static property VARIANT_ARRAY_EXT: VariantCapEXT read _VARIANT_ARRAY_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VariantCapEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VariantCapEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VariantCapEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderCoordOutEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _X_EXT            := new VertexShaderCoordOutEXT($87D5);
    private static _Y_EXT            := new VertexShaderCoordOutEXT($87D6);
    private static _Z_EXT            := new VertexShaderCoordOutEXT($87D7);
    private static _W_EXT            := new VertexShaderCoordOutEXT($87D8);
    private static _NEGATIVE_X_EXT   := new VertexShaderCoordOutEXT($87D9);
    private static _NEGATIVE_Y_EXT   := new VertexShaderCoordOutEXT($87DA);
    private static _NEGATIVE_Z_EXT   := new VertexShaderCoordOutEXT($87DB);
    private static _NEGATIVE_W_EXT   := new VertexShaderCoordOutEXT($87DC);
    private static _ZERO_EXT         := new VertexShaderCoordOutEXT($87DD);
    private static _ONE_EXT          := new VertexShaderCoordOutEXT($87DE);
    private static _NEGATIVE_ONE_EXT := new VertexShaderCoordOutEXT($87DF);
    
    public static property X_EXT:            VertexShaderCoordOutEXT read _X_EXT;
    public static property Y_EXT:            VertexShaderCoordOutEXT read _Y_EXT;
    public static property Z_EXT:            VertexShaderCoordOutEXT read _Z_EXT;
    public static property W_EXT:            VertexShaderCoordOutEXT read _W_EXT;
    public static property NEGATIVE_X_EXT:   VertexShaderCoordOutEXT read _NEGATIVE_X_EXT;
    public static property NEGATIVE_Y_EXT:   VertexShaderCoordOutEXT read _NEGATIVE_Y_EXT;
    public static property NEGATIVE_Z_EXT:   VertexShaderCoordOutEXT read _NEGATIVE_Z_EXT;
    public static property NEGATIVE_W_EXT:   VertexShaderCoordOutEXT read _NEGATIVE_W_EXT;
    public static property ZERO_EXT:         VertexShaderCoordOutEXT read _ZERO_EXT;
    public static property ONE_EXT:          VertexShaderCoordOutEXT read _ONE_EXT;
    public static property NEGATIVE_ONE_EXT: VertexShaderCoordOutEXT read _NEGATIVE_ONE_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderCoordOutEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderCoordOutEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderCoordOutEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderOpEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _OP_INDEX_EXT           := new VertexShaderOpEXT($8782);
    private static _OP_NEGATE_EXT          := new VertexShaderOpEXT($8783);
    private static _OP_DOT3_EXT            := new VertexShaderOpEXT($8784);
    private static _OP_DOT4_EXT            := new VertexShaderOpEXT($8785);
    private static _OP_MUL_EXT             := new VertexShaderOpEXT($8786);
    private static _OP_ADD_EXT             := new VertexShaderOpEXT($8787);
    private static _OP_MADD_EXT            := new VertexShaderOpEXT($8788);
    private static _OP_FRAC_EXT            := new VertexShaderOpEXT($8789);
    private static _OP_MAX_EXT             := new VertexShaderOpEXT($878A);
    private static _OP_MIN_EXT             := new VertexShaderOpEXT($878B);
    private static _OP_SET_GE_EXT          := new VertexShaderOpEXT($878C);
    private static _OP_SET_LT_EXT          := new VertexShaderOpEXT($878D);
    private static _OP_CLAMP_EXT           := new VertexShaderOpEXT($878E);
    private static _OP_FLOOR_EXT           := new VertexShaderOpEXT($878F);
    private static _OP_ROUND_EXT           := new VertexShaderOpEXT($8790);
    private static _OP_EXP_BASE_2_EXT      := new VertexShaderOpEXT($8791);
    private static _OP_LOG_BASE_2_EXT      := new VertexShaderOpEXT($8792);
    private static _OP_POWER_EXT           := new VertexShaderOpEXT($8793);
    private static _OP_RECIP_EXT           := new VertexShaderOpEXT($8794);
    private static _OP_RECIP_SQRT_EXT      := new VertexShaderOpEXT($8795);
    private static _OP_SUB_EXT             := new VertexShaderOpEXT($8796);
    private static _OP_CROSS_PRODUCT_EXT   := new VertexShaderOpEXT($8797);
    private static _OP_MULTIPLY_MATRIX_EXT := new VertexShaderOpEXT($8798);
    private static _OP_MOV_EXT             := new VertexShaderOpEXT($8799);
    
    public static property OP_INDEX_EXT:           VertexShaderOpEXT read _OP_INDEX_EXT;
    public static property OP_NEGATE_EXT:          VertexShaderOpEXT read _OP_NEGATE_EXT;
    public static property OP_DOT3_EXT:            VertexShaderOpEXT read _OP_DOT3_EXT;
    public static property OP_DOT4_EXT:            VertexShaderOpEXT read _OP_DOT4_EXT;
    public static property OP_MUL_EXT:             VertexShaderOpEXT read _OP_MUL_EXT;
    public static property OP_ADD_EXT:             VertexShaderOpEXT read _OP_ADD_EXT;
    public static property OP_MADD_EXT:            VertexShaderOpEXT read _OP_MADD_EXT;
    public static property OP_FRAC_EXT:            VertexShaderOpEXT read _OP_FRAC_EXT;
    public static property OP_MAX_EXT:             VertexShaderOpEXT read _OP_MAX_EXT;
    public static property OP_MIN_EXT:             VertexShaderOpEXT read _OP_MIN_EXT;
    public static property OP_SET_GE_EXT:          VertexShaderOpEXT read _OP_SET_GE_EXT;
    public static property OP_SET_LT_EXT:          VertexShaderOpEXT read _OP_SET_LT_EXT;
    public static property OP_CLAMP_EXT:           VertexShaderOpEXT read _OP_CLAMP_EXT;
    public static property OP_FLOOR_EXT:           VertexShaderOpEXT read _OP_FLOOR_EXT;
    public static property OP_ROUND_EXT:           VertexShaderOpEXT read _OP_ROUND_EXT;
    public static property OP_EXP_BASE_2_EXT:      VertexShaderOpEXT read _OP_EXP_BASE_2_EXT;
    public static property OP_LOG_BASE_2_EXT:      VertexShaderOpEXT read _OP_LOG_BASE_2_EXT;
    public static property OP_POWER_EXT:           VertexShaderOpEXT read _OP_POWER_EXT;
    public static property OP_RECIP_EXT:           VertexShaderOpEXT read _OP_RECIP_EXT;
    public static property OP_RECIP_SQRT_EXT:      VertexShaderOpEXT read _OP_RECIP_SQRT_EXT;
    public static property OP_SUB_EXT:             VertexShaderOpEXT read _OP_SUB_EXT;
    public static property OP_CROSS_PRODUCT_EXT:   VertexShaderOpEXT read _OP_CROSS_PRODUCT_EXT;
    public static property OP_MULTIPLY_MATRIX_EXT: VertexShaderOpEXT read _OP_MULTIPLY_MATRIX_EXT;
    public static property OP_MOV_EXT:             VertexShaderOpEXT read _OP_MOV_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderOpEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderOpEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderOpEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderParameterEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _CURRENT_VERTEX_EXT := new VertexShaderParameterEXT($87E2);
    private static _MVP_MATRIX_EXT     := new VertexShaderParameterEXT($87E3);
    
    public static property CURRENT_VERTEX_EXT: VertexShaderParameterEXT read _CURRENT_VERTEX_EXT;
    public static property MVP_MATRIX_EXT:     VertexShaderParameterEXT read _MVP_MATRIX_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderParameterEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderParameterEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderParameterEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderStorageTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VARIANT_EXT        := new VertexShaderStorageTypeEXT($87C1);
    private static _INVARIANT_EXT      := new VertexShaderStorageTypeEXT($87C2);
    private static _LOCAL_CONSTANT_EXT := new VertexShaderStorageTypeEXT($87C3);
    private static _LOCAL_EXT          := new VertexShaderStorageTypeEXT($87C4);
    
    public static property VARIANT_EXT:        VertexShaderStorageTypeEXT read _VARIANT_EXT;
    public static property INVARIANT_EXT:      VertexShaderStorageTypeEXT read _INVARIANT_EXT;
    public static property LOCAL_CONSTANT_EXT: VertexShaderStorageTypeEXT read _LOCAL_CONSTANT_EXT;
    public static property LOCAL_EXT:          VertexShaderStorageTypeEXT read _LOCAL_EXT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderStorageTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderStorageTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderStorageTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexShaderWriteMaskEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FALSE := new VertexShaderWriteMaskEXT($0000);
    private static _TRUE  := new VertexShaderWriteMaskEXT($0001);
    
    public static property FALSE: VertexShaderWriteMaskEXT read _FALSE;
    public static property TRUE:  VertexShaderWriteMaskEXT read _TRUE;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexShaderWriteMaskEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexShaderWriteMaskEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexShaderWriteMaskEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexWeightPointerTypeEXT = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLOAT := new VertexWeightPointerTypeEXT($1406);
    
    public static property FLOAT: VertexWeightPointerTypeEXT read _FLOAT;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexWeightPointerTypeEXT).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexWeightPointerTypeEXT(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexWeightPointerTypeEXT[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion EXT}
  
  {$region AMD}
  
  TextureStorageMaskAMD = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_STORAGE_SPARSE_BIT_AMD := new TextureStorageMaskAMD($0001);
    
    public static property TEXTURE_STORAGE_SPARSE_BIT_AMD: TextureStorageMaskAMD read _TEXTURE_STORAGE_SPARSE_BIT_AMD;
    
    public static function operator or(f1,f2: TextureStorageMaskAMD) := new TextureStorageMaskAMD(f1.val or f2.val);
    
    public property HAS_FLAG_TEXTURE_STORAGE_SPARSE_BIT_AMD: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureStorageMaskAMD).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'TextureStorageMaskAMD[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  {$endregion AMD}
  
  {$region APPLE}
  
  ObjectTypeAPPLE = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DRAW_PIXELS_APPLE := new ObjectTypeAPPLE($8A0A);
    private static _FENCE_APPLE       := new ObjectTypeAPPLE($8A0B);
    
    public static property DRAW_PIXELS_APPLE: ObjectTypeAPPLE read _DRAW_PIXELS_APPLE;
    public static property FENCE_APPLE:       ObjectTypeAPPLE read _FENCE_APPLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(ObjectTypeAPPLE).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ObjectTypeAPPLE(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ObjectTypeAPPLE[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexArrayPNameAPPLE = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STORAGE_CLIENT_APPLE := new VertexArrayPNameAPPLE($85B4);
    private static _STORAGE_CACHED_APPLE := new VertexArrayPNameAPPLE($85BE);
    private static _STORAGE_SHARED_APPLE := new VertexArrayPNameAPPLE($85BF);
    
    public static property STORAGE_CLIENT_APPLE: VertexArrayPNameAPPLE read _STORAGE_CLIENT_APPLE;
    public static property STORAGE_CACHED_APPLE: VertexArrayPNameAPPLE read _STORAGE_CACHED_APPLE;
    public static property STORAGE_SHARED_APPLE: VertexArrayPNameAPPLE read _STORAGE_SHARED_APPLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexArrayPNameAPPLE).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexArrayPNameAPPLE(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexArrayPNameAPPLE[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion APPLE}
  
  {$region ATI}
  
  ArrayObjectPNameATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _OBJECT_BUFFER_SIZE_ATI  := new ArrayObjectPNameATI($8764);
    private static _OBJECT_BUFFER_USAGE_ATI := new ArrayObjectPNameATI($8765);
    
    public static property OBJECT_BUFFER_SIZE_ATI:  ArrayObjectPNameATI read _OBJECT_BUFFER_SIZE_ATI;
    public static property OBJECT_BUFFER_USAGE_ATI: ArrayObjectPNameATI read _OBJECT_BUFFER_USAGE_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(ArrayObjectPNameATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ArrayObjectPNameATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ArrayObjectPNameATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ArrayObjectUsageATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _STATIC_ATI  := new ArrayObjectUsageATI($8760);
    private static _DYNAMIC_ATI := new ArrayObjectUsageATI($8761);
    
    public static property STATIC_ATI:  ArrayObjectUsageATI read _STATIC_ATI;
    public static property DYNAMIC_ATI: ArrayObjectUsageATI read _DYNAMIC_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(ArrayObjectUsageATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ArrayObjectUsageATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ArrayObjectUsageATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ElementPointerTypeATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_BYTE  := new ElementPointerTypeATI($1401);
    private static _UNSIGNED_SHORT := new ElementPointerTypeATI($1403);
    private static _UNSIGNED_INT   := new ElementPointerTypeATI($1405);
    
    public static property UNSIGNED_BYTE:  ElementPointerTypeATI read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: ElementPointerTypeATI read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   ElementPointerTypeATI read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ElementPointerTypeATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ElementPointerTypeATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ElementPointerTypeATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FragmentOpATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MOV_ATI      := new FragmentOpATI($8961);
    private static _ADD_ATI      := new FragmentOpATI($8963);
    private static _MUL_ATI      := new FragmentOpATI($8964);
    private static _SUB_ATI      := new FragmentOpATI($8965);
    private static _DOT3_ATI     := new FragmentOpATI($8966);
    private static _DOT4_ATI     := new FragmentOpATI($8967);
    private static _MAD_ATI      := new FragmentOpATI($8968);
    private static _LERP_ATI     := new FragmentOpATI($8969);
    private static _CND_ATI      := new FragmentOpATI($896A);
    private static _CND0_ATI     := new FragmentOpATI($896B);
    private static _DOT2_ADD_ATI := new FragmentOpATI($896C);
    
    public static property MOV_ATI:      FragmentOpATI read _MOV_ATI;
    public static property ADD_ATI:      FragmentOpATI read _ADD_ATI;
    public static property MUL_ATI:      FragmentOpATI read _MUL_ATI;
    public static property SUB_ATI:      FragmentOpATI read _SUB_ATI;
    public static property DOT3_ATI:     FragmentOpATI read _DOT3_ATI;
    public static property DOT4_ATI:     FragmentOpATI read _DOT4_ATI;
    public static property MAD_ATI:      FragmentOpATI read _MAD_ATI;
    public static property LERP_ATI:     FragmentOpATI read _LERP_ATI;
    public static property CND_ATI:      FragmentOpATI read _CND_ATI;
    public static property CND0_ATI:     FragmentOpATI read _CND0_ATI;
    public static property DOT2_ADD_ATI: FragmentOpATI read _DOT2_ADD_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(FragmentOpATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FragmentOpATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FragmentOpATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetTexBumpParameterATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BUMP_ROT_MATRIX_ATI      := new GetTexBumpParameterATI($8775);
    private static _BUMP_ROT_MATRIX_SIZE_ATI := new GetTexBumpParameterATI($8776);
    private static _BUMP_NUM_TEX_UNITS_ATI   := new GetTexBumpParameterATI($8777);
    private static _BUMP_TEX_UNITS_ATI       := new GetTexBumpParameterATI($8778);
    
    public static property BUMP_ROT_MATRIX_ATI:      GetTexBumpParameterATI read _BUMP_ROT_MATRIX_ATI;
    public static property BUMP_ROT_MATRIX_SIZE_ATI: GetTexBumpParameterATI read _BUMP_ROT_MATRIX_SIZE_ATI;
    public static property BUMP_NUM_TEX_UNITS_ATI:   GetTexBumpParameterATI read _BUMP_NUM_TEX_UNITS_ATI;
    public static property BUMP_TEX_UNITS_ATI:       GetTexBumpParameterATI read _BUMP_TEX_UNITS_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetTexBumpParameterATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetTexBumpParameterATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetTexBumpParameterATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PNTrianglesPNameATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PN_TRIANGLES_POINT_MODE_ATI        := new PNTrianglesPNameATI($87F2);
    private static _PN_TRIANGLES_NORMAL_MODE_ATI       := new PNTrianglesPNameATI($87F3);
    private static _PN_TRIANGLES_TESSELATION_LEVEL_ATI := new PNTrianglesPNameATI($87F4);
    
    public static property PN_TRIANGLES_POINT_MODE_ATI:        PNTrianglesPNameATI read _PN_TRIANGLES_POINT_MODE_ATI;
    public static property PN_TRIANGLES_NORMAL_MODE_ATI:       PNTrianglesPNameATI read _PN_TRIANGLES_NORMAL_MODE_ATI;
    public static property PN_TRIANGLES_TESSELATION_LEVEL_ATI: PNTrianglesPNameATI read _PN_TRIANGLES_TESSELATION_LEVEL_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(PNTrianglesPNameATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PNTrianglesPNameATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PNTrianglesPNameATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PreserveModeATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PRESERVE_ATI := new PreserveModeATI($8762);
    private static _DISCARD_ATI  := new PreserveModeATI($8763);
    
    public static property PRESERVE_ATI: PreserveModeATI read _PRESERVE_ATI;
    public static property DISCARD_ATI:  PreserveModeATI read _DISCARD_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(PreserveModeATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PreserveModeATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PreserveModeATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SwizzleOpATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SWIZZLE_STR_ATI    := new SwizzleOpATI($8976);
    private static _SWIZZLE_STQ_ATI    := new SwizzleOpATI($8977);
    private static _SWIZZLE_STR_DR_ATI := new SwizzleOpATI($8978);
    private static _SWIZZLE_STQ_DQ_ATI := new SwizzleOpATI($8979);
    
    public static property SWIZZLE_STR_ATI:    SwizzleOpATI read _SWIZZLE_STR_ATI;
    public static property SWIZZLE_STQ_ATI:    SwizzleOpATI read _SWIZZLE_STQ_ATI;
    public static property SWIZZLE_STR_DR_ATI: SwizzleOpATI read _SWIZZLE_STR_DR_ATI;
    public static property SWIZZLE_STQ_DQ_ATI: SwizzleOpATI read _SWIZZLE_STQ_DQ_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(SwizzleOpATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SwizzleOpATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SwizzleOpATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexStreamATI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_STREAM0_ATI := new VertexStreamATI($876C);
    private static _VERTEX_STREAM1_ATI := new VertexStreamATI($876D);
    private static _VERTEX_STREAM2_ATI := new VertexStreamATI($876E);
    private static _VERTEX_STREAM3_ATI := new VertexStreamATI($876F);
    private static _VERTEX_STREAM4_ATI := new VertexStreamATI($8770);
    private static _VERTEX_STREAM5_ATI := new VertexStreamATI($8771);
    private static _VERTEX_STREAM6_ATI := new VertexStreamATI($8772);
    private static _VERTEX_STREAM7_ATI := new VertexStreamATI($8773);
    
    public static property VERTEX_STREAM0_ATI: VertexStreamATI read _VERTEX_STREAM0_ATI;
    public static property VERTEX_STREAM1_ATI: VertexStreamATI read _VERTEX_STREAM1_ATI;
    public static property VERTEX_STREAM2_ATI: VertexStreamATI read _VERTEX_STREAM2_ATI;
    public static property VERTEX_STREAM3_ATI: VertexStreamATI read _VERTEX_STREAM3_ATI;
    public static property VERTEX_STREAM4_ATI: VertexStreamATI read _VERTEX_STREAM4_ATI;
    public static property VERTEX_STREAM5_ATI: VertexStreamATI read _VERTEX_STREAM5_ATI;
    public static property VERTEX_STREAM6_ATI: VertexStreamATI read _VERTEX_STREAM6_ATI;
    public static property VERTEX_STREAM7_ATI: VertexStreamATI read _VERTEX_STREAM7_ATI;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexStreamATI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexStreamATI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexStreamATI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion ATI}
  
  {$region GDI}
  
  PixelDataTypeGDI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _RGBA       := new PixelDataTypeGDI($0000);
    private static _COLORINDEX := new PixelDataTypeGDI($0001);
    
    public static property RGBA:       PixelDataTypeGDI read _RGBA;
    public static property COLORINDEX: PixelDataTypeGDI read _COLORINDEX;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelDataTypeGDI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelDataTypeGDI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelDataTypeGDI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelFormatFlagsGDI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _DOUBLEBUFFER          := new PixelFormatFlagsGDI($0001);
    private static _STEREO                := new PixelFormatFlagsGDI($0002);
    private static _DRAW_TO_WINDOW        := new PixelFormatFlagsGDI($0004);
    private static _DRAW_TO_BITMAP        := new PixelFormatFlagsGDI($0008);
    private static _SUPPORT_GDI           := new PixelFormatFlagsGDI($000A);
    private static _SUPPORT_OPENGL        := new PixelFormatFlagsGDI($0014);
    private static _GENERIC_FORMAT        := new PixelFormatFlagsGDI($0028);
    private static _NEED_PALETTE          := new PixelFormatFlagsGDI($0050);
    private static _NEED_SYSTEM_PALETTE   := new PixelFormatFlagsGDI($0064);
    private static _SWAP_EXCHANGE         := new PixelFormatFlagsGDI($00C8);
    private static _SWAP_COPY             := new PixelFormatFlagsGDI($0190);
    private static _SWAP_LAYER_BUFFERS    := new PixelFormatFlagsGDI($0320);
    private static _GENERIC_ACCELERATED   := new PixelFormatFlagsGDI($03E8);
    private static _SUPPORT_DIRECTDRAW    := new PixelFormatFlagsGDI($07D0);
    private static _DEPTH_DONTCARE        := new PixelFormatFlagsGDI($1312D00);
    private static _DOUBLEBUFFER_DONTCARE := new PixelFormatFlagsGDI($2625A00);
    private static _STEREO_DONTCARE       := new PixelFormatFlagsGDI($4C4B400);
    
    public static property DOUBLEBUFFER:          PixelFormatFlagsGDI read _DOUBLEBUFFER;
    public static property STEREO:                PixelFormatFlagsGDI read _STEREO;
    public static property DRAW_TO_WINDOW:        PixelFormatFlagsGDI read _DRAW_TO_WINDOW;
    public static property DRAW_TO_BITMAP:        PixelFormatFlagsGDI read _DRAW_TO_BITMAP;
    public static property SUPPORT_GDI:           PixelFormatFlagsGDI read _SUPPORT_GDI;
    public static property SUPPORT_OPENGL:        PixelFormatFlagsGDI read _SUPPORT_OPENGL;
    public static property GENERIC_FORMAT:        PixelFormatFlagsGDI read _GENERIC_FORMAT;
    public static property NEED_PALETTE:          PixelFormatFlagsGDI read _NEED_PALETTE;
    public static property NEED_SYSTEM_PALETTE:   PixelFormatFlagsGDI read _NEED_SYSTEM_PALETTE;
    public static property SWAP_EXCHANGE:         PixelFormatFlagsGDI read _SWAP_EXCHANGE;
    public static property SWAP_COPY:             PixelFormatFlagsGDI read _SWAP_COPY;
    public static property SWAP_LAYER_BUFFERS:    PixelFormatFlagsGDI read _SWAP_LAYER_BUFFERS;
    public static property GENERIC_ACCELERATED:   PixelFormatFlagsGDI read _GENERIC_ACCELERATED;
    public static property SUPPORT_DIRECTDRAW:    PixelFormatFlagsGDI read _SUPPORT_DIRECTDRAW;
    public static property DEPTH_DONTCARE:        PixelFormatFlagsGDI read _DEPTH_DONTCARE;
    public static property DOUBLEBUFFER_DONTCARE: PixelFormatFlagsGDI read _DOUBLEBUFFER_DONTCARE;
    public static property STEREO_DONTCARE:       PixelFormatFlagsGDI read _STEREO_DONTCARE;
    
    public static function operator or(f1,f2: PixelFormatFlagsGDI) := new PixelFormatFlagsGDI(f1.val or f2.val);
    
    public property HAS_FLAG_DOUBLEBUFFER:          boolean read self.val and $0001 <> 0;
    public property HAS_FLAG_STEREO:                boolean read self.val and $0002 <> 0;
    public property HAS_FLAG_DRAW_TO_WINDOW:        boolean read self.val and $0004 <> 0;
    public property HAS_FLAG_DRAW_TO_BITMAP:        boolean read self.val and $0008 <> 0;
    public property HAS_FLAG_SUPPORT_GDI:           boolean read self.val and $000A <> 0;
    public property HAS_FLAG_SUPPORT_OPENGL:        boolean read self.val and $0014 <> 0;
    public property HAS_FLAG_GENERIC_FORMAT:        boolean read self.val and $0028 <> 0;
    public property HAS_FLAG_NEED_PALETTE:          boolean read self.val and $0050 <> 0;
    public property HAS_FLAG_NEED_SYSTEM_PALETTE:   boolean read self.val and $0064 <> 0;
    public property HAS_FLAG_SWAP_EXCHANGE:         boolean read self.val and $00C8 <> 0;
    public property HAS_FLAG_SWAP_COPY:             boolean read self.val and $0190 <> 0;
    public property HAS_FLAG_SWAP_LAYER_BUFFERS:    boolean read self.val and $0320 <> 0;
    public property HAS_FLAG_GENERIC_ACCELERATED:   boolean read self.val and $03E8 <> 0;
    public property HAS_FLAG_SUPPORT_DIRECTDRAW:    boolean read self.val and $07D0 <> 0;
    public property HAS_FLAG_DEPTH_DONTCARE:        boolean read self.val and $1312D00 <> 0;
    public property HAS_FLAG_DOUBLEBUFFER_DONTCARE: boolean read self.val and $2625A00 <> 0;
    public property HAS_FLAG_STEREO_DONTCARE:       boolean read self.val and $4C4B400 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelFormatFlagsGDI).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'PixelFormatFlagsGDI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  {$endregion GDI}
  
  {$region HP}
  
  ImageTransformPNameHP = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _IMAGE_SCALE_X_HP         := new ImageTransformPNameHP($8155);
    private static _IMAGE_SCALE_Y_HP         := new ImageTransformPNameHP($8156);
    private static _IMAGE_TRANSLATE_X_HP     := new ImageTransformPNameHP($8157);
    private static _IMAGE_TRANSLATE_Y_HP     := new ImageTransformPNameHP($8158);
    private static _IMAGE_ROTATE_ANGLE_HP    := new ImageTransformPNameHP($8159);
    private static _IMAGE_ROTATE_ORIGIN_X_HP := new ImageTransformPNameHP($815A);
    private static _IMAGE_ROTATE_ORIGIN_Y_HP := new ImageTransformPNameHP($815B);
    private static _IMAGE_MAG_FILTER_HP      := new ImageTransformPNameHP($815C);
    private static _IMAGE_MIN_FILTER_HP      := new ImageTransformPNameHP($815D);
    private static _IMAGE_CUBIC_WEIGHT_HP    := new ImageTransformPNameHP($815E);
    
    public static property IMAGE_SCALE_X_HP:         ImageTransformPNameHP read _IMAGE_SCALE_X_HP;
    public static property IMAGE_SCALE_Y_HP:         ImageTransformPNameHP read _IMAGE_SCALE_Y_HP;
    public static property IMAGE_TRANSLATE_X_HP:     ImageTransformPNameHP read _IMAGE_TRANSLATE_X_HP;
    public static property IMAGE_TRANSLATE_Y_HP:     ImageTransformPNameHP read _IMAGE_TRANSLATE_Y_HP;
    public static property IMAGE_ROTATE_ANGLE_HP:    ImageTransformPNameHP read _IMAGE_ROTATE_ANGLE_HP;
    public static property IMAGE_ROTATE_ORIGIN_X_HP: ImageTransformPNameHP read _IMAGE_ROTATE_ORIGIN_X_HP;
    public static property IMAGE_ROTATE_ORIGIN_Y_HP: ImageTransformPNameHP read _IMAGE_ROTATE_ORIGIN_Y_HP;
    public static property IMAGE_MAG_FILTER_HP:      ImageTransformPNameHP read _IMAGE_MAG_FILTER_HP;
    public static property IMAGE_MIN_FILTER_HP:      ImageTransformPNameHP read _IMAGE_MIN_FILTER_HP;
    public static property IMAGE_CUBIC_WEIGHT_HP:    ImageTransformPNameHP read _IMAGE_CUBIC_WEIGHT_HP;
    
    public function ToString: string; override;
    begin
      var res := typeof(ImageTransformPNameHP).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ImageTransformPNameHP(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ImageTransformPNameHP[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  ImageTransformTargetHP = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _IMAGE_TRANSFORM_2D_HP := new ImageTransformTargetHP($8161);
    
    public static property IMAGE_TRANSFORM_2D_HP: ImageTransformTargetHP read _IMAGE_TRANSFORM_2D_HP;
    
    public function ToString: string; override;
    begin
      var res := typeof(ImageTransformTargetHP).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ImageTransformTargetHP(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ImageTransformTargetHP[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion HP}
  
  {$region IBM}
  
  FogPointerTypeIBM = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLOAT  := new FogPointerTypeIBM($1406);
    private static _DOUBLE := new FogPointerTypeIBM($140A);
    
    public static property FLOAT:  FogPointerTypeIBM read _FLOAT;
    public static property DOUBLE: FogPointerTypeIBM read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(FogPointerTypeIBM).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FogPointerTypeIBM(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FogPointerTypeIBM[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SecondaryColorPointerTypeIBM = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SHORT  := new SecondaryColorPointerTypeIBM($1402);
    private static _INT    := new SecondaryColorPointerTypeIBM($1404);
    private static _FLOAT  := new SecondaryColorPointerTypeIBM($1406);
    private static _DOUBLE := new SecondaryColorPointerTypeIBM($140A);
    
    public static property SHORT:  SecondaryColorPointerTypeIBM read _SHORT;
    public static property INT:    SecondaryColorPointerTypeIBM read _INT;
    public static property FLOAT:  SecondaryColorPointerTypeIBM read _FLOAT;
    public static property DOUBLE: SecondaryColorPointerTypeIBM read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(SecondaryColorPointerTypeIBM).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SecondaryColorPointerTypeIBM(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SecondaryColorPointerTypeIBM[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion IBM}
  
  {$region INTEL}
  
  PerfQueryCapFlagsINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PERFQUERY_SINGLE_CONTEXT_INTEL := new PerfQueryCapFlagsINTEL($0000);
    private static _PERFQUERY_GLOBAL_CONTEXT_INTEL := new PerfQueryCapFlagsINTEL($0001);
    
    public static property PERFQUERY_SINGLE_CONTEXT_INTEL: PerfQueryCapFlagsINTEL read _PERFQUERY_SINGLE_CONTEXT_INTEL;
    public static property PERFQUERY_GLOBAL_CONTEXT_INTEL: PerfQueryCapFlagsINTEL read _PERFQUERY_GLOBAL_CONTEXT_INTEL;
    
    public static function operator or(f1,f2: PerfQueryCapFlagsINTEL) := new PerfQueryCapFlagsINTEL(f1.val or f2.val);
    
    public property ANY_FLAGS: boolean read self.val<>0;
    public property HAS_FLAG_PERFQUERY_GLOBAL_CONTEXT_INTEL: boolean read self.val and $0001 <> 0;
    
    public function ToString: string; override;
    begin
      var res := typeof(PerfQueryCapFlagsINTEL).GetProperties.Where(prop->prop.Name.StartsWith('HAS_FLAG_') and boolean(prop.GetValue(self))).Select(prop->prop.Name.TrimStart('&')).ToList;
      Result := res.Count=0?
        $'PerfQueryCapFlagsINTEL[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.JoinToString('+');
    end;
    
  end;
  
  PerfQueryDataFlagsINTEL = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PERFQUERY_DONOT_FLUSH_INTEL := new PerfQueryDataFlagsINTEL($83F9);
    private static _PERFQUERY_FLUSH_INTEL       := new PerfQueryDataFlagsINTEL($83FA);
    private static _PERFQUERY_WAIT_INTEL        := new PerfQueryDataFlagsINTEL($83FB);
    
    public static property PERFQUERY_DONOT_FLUSH_INTEL: PerfQueryDataFlagsINTEL read _PERFQUERY_DONOT_FLUSH_INTEL;
    public static property PERFQUERY_FLUSH_INTEL:       PerfQueryDataFlagsINTEL read _PERFQUERY_FLUSH_INTEL;
    public static property PERFQUERY_WAIT_INTEL:        PerfQueryDataFlagsINTEL read _PERFQUERY_WAIT_INTEL;
    
    public function ToString: string; override;
    begin
      var res := typeof(PerfQueryDataFlagsINTEL).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PerfQueryDataFlagsINTEL(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PerfQueryDataFlagsINTEL[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion INTEL}
  
  {$region NV}
  
  CombinerBiasNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE                         := new CombinerBiasNV($0000);
    private static _BIAS_BY_NEGATIVE_ONE_HALF_NV := new CombinerBiasNV($8541);
    
    public static property NONE:                         CombinerBiasNV read _NONE;
    public static property BIAS_BY_NEGATIVE_ONE_HALF_NV: CombinerBiasNV read _BIAS_BY_NEGATIVE_ONE_HALF_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerBiasNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerBiasNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerBiasNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerComponentUsageNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _BLUE  := new CombinerComponentUsageNV($1905);
    private static _ALPHA := new CombinerComponentUsageNV($1906);
    private static _RGB   := new CombinerComponentUsageNV($1907);
    
    public static property BLUE:  CombinerComponentUsageNV read _BLUE;
    public static property ALPHA: CombinerComponentUsageNV read _ALPHA;
    public static property RGB:   CombinerComponentUsageNV read _RGB;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerComponentUsageNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerComponentUsageNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerComponentUsageNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerMappingNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_IDENTITY_NV := new CombinerMappingNV($8536);
    private static _UNSIGNED_INVERT_NV   := new CombinerMappingNV($8537);
    private static _EXPAND_NORMAL_NV     := new CombinerMappingNV($8538);
    private static _EXPAND_NEGATE_NV     := new CombinerMappingNV($8539);
    private static _HALF_BIAS_NORMAL_NV  := new CombinerMappingNV($853A);
    private static _HALF_BIAS_NEGATE_NV  := new CombinerMappingNV($853B);
    private static _SIGNED_IDENTITY_NV   := new CombinerMappingNV($853C);
    private static _SIGNED_NEGATE_NV     := new CombinerMappingNV($853D);
    
    public static property UNSIGNED_IDENTITY_NV: CombinerMappingNV read _UNSIGNED_IDENTITY_NV;
    public static property UNSIGNED_INVERT_NV:   CombinerMappingNV read _UNSIGNED_INVERT_NV;
    public static property EXPAND_NORMAL_NV:     CombinerMappingNV read _EXPAND_NORMAL_NV;
    public static property EXPAND_NEGATE_NV:     CombinerMappingNV read _EXPAND_NEGATE_NV;
    public static property HALF_BIAS_NORMAL_NV:  CombinerMappingNV read _HALF_BIAS_NORMAL_NV;
    public static property HALF_BIAS_NEGATE_NV:  CombinerMappingNV read _HALF_BIAS_NEGATE_NV;
    public static property SIGNED_IDENTITY_NV:   CombinerMappingNV read _SIGNED_IDENTITY_NV;
    public static property SIGNED_NEGATE_NV:     CombinerMappingNV read _SIGNED_NEGATE_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerMappingNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerMappingNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerMappingNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COMBINER_INPUT_NV           := new CombinerParameterNV($8542);
    private static _COMBINER_MAPPING_NV         := new CombinerParameterNV($8543);
    private static _COMBINER_COMPONENT_USAGE_NV := new CombinerParameterNV($8544);
    
    public static property COMBINER_INPUT_NV:           CombinerParameterNV read _COMBINER_INPUT_NV;
    public static property COMBINER_MAPPING_NV:         CombinerParameterNV read _COMBINER_MAPPING_NV;
    public static property COMBINER_COMPONENT_USAGE_NV: CombinerParameterNV read _COMBINER_COMPONENT_USAGE_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerParameterNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerParameterNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerParameterNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerPortionNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ALPHA := new CombinerPortionNV($1906);
    private static _RGB   := new CombinerPortionNV($1907);
    
    public static property ALPHA: CombinerPortionNV read _ALPHA;
    public static property RGB:   CombinerPortionNV read _RGB;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerPortionNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerPortionNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerPortionNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerRegisterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE0_ARB       := new CombinerRegisterNV($84C0);
    private static _TEXTURE1_ARB       := new CombinerRegisterNV($84C1);
    private static _PRIMARY_COLOR_NV   := new CombinerRegisterNV($852C);
    private static _SECONDARY_COLOR_NV := new CombinerRegisterNV($852D);
    private static _SPARE0_NV          := new CombinerRegisterNV($852E);
    private static _SPARE1_NV          := new CombinerRegisterNV($852F);
    private static _DISCARD_NV         := new CombinerRegisterNV($8530);
    
    public static property TEXTURE0_ARB:       CombinerRegisterNV read _TEXTURE0_ARB;
    public static property TEXTURE1_ARB:       CombinerRegisterNV read _TEXTURE1_ARB;
    public static property PRIMARY_COLOR_NV:   CombinerRegisterNV read _PRIMARY_COLOR_NV;
    public static property SECONDARY_COLOR_NV: CombinerRegisterNV read _SECONDARY_COLOR_NV;
    public static property SPARE0_NV:          CombinerRegisterNV read _SPARE0_NV;
    public static property SPARE1_NV:          CombinerRegisterNV read _SPARE1_NV;
    public static property DISCARD_NV:         CombinerRegisterNV read _DISCARD_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerRegisterNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerRegisterNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerRegisterNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerScaleNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _NONE                 := new CombinerScaleNV($0000);
    private static _SCALE_BY_TWO_NV      := new CombinerScaleNV($853E);
    private static _SCALE_BY_FOUR_NV     := new CombinerScaleNV($853F);
    private static _SCALE_BY_ONE_HALF_NV := new CombinerScaleNV($8540);
    
    public static property NONE:                 CombinerScaleNV read _NONE;
    public static property SCALE_BY_TWO_NV:      CombinerScaleNV read _SCALE_BY_TWO_NV;
    public static property SCALE_BY_FOUR_NV:     CombinerScaleNV read _SCALE_BY_FOUR_NV;
    public static property SCALE_BY_ONE_HALF_NV: CombinerScaleNV read _SCALE_BY_ONE_HALF_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerScaleNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerScaleNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerScaleNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerStageNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COMBINER0_NV := new CombinerStageNV($8550);
    private static _COMBINER1_NV := new CombinerStageNV($8551);
    private static _COMBINER2_NV := new CombinerStageNV($8552);
    private static _COMBINER3_NV := new CombinerStageNV($8553);
    private static _COMBINER4_NV := new CombinerStageNV($8554);
    private static _COMBINER5_NV := new CombinerStageNV($8555);
    private static _COMBINER6_NV := new CombinerStageNV($8556);
    private static _COMBINER7_NV := new CombinerStageNV($8557);
    
    public static property COMBINER0_NV: CombinerStageNV read _COMBINER0_NV;
    public static property COMBINER1_NV: CombinerStageNV read _COMBINER1_NV;
    public static property COMBINER2_NV: CombinerStageNV read _COMBINER2_NV;
    public static property COMBINER3_NV: CombinerStageNV read _COMBINER3_NV;
    public static property COMBINER4_NV: CombinerStageNV read _COMBINER4_NV;
    public static property COMBINER5_NV: CombinerStageNV read _COMBINER5_NV;
    public static property COMBINER6_NV: CombinerStageNV read _COMBINER6_NV;
    public static property COMBINER7_NV: CombinerStageNV read _COMBINER7_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerStageNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerStageNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerStageNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  CombinerVariableNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VARIABLE_A_NV := new CombinerVariableNV($8523);
    private static _VARIABLE_B_NV := new CombinerVariableNV($8524);
    private static _VARIABLE_C_NV := new CombinerVariableNV($8525);
    private static _VARIABLE_D_NV := new CombinerVariableNV($8526);
    private static _VARIABLE_E_NV := new CombinerVariableNV($8527);
    private static _VARIABLE_F_NV := new CombinerVariableNV($8528);
    private static _VARIABLE_G_NV := new CombinerVariableNV($8529);
    
    public static property VARIABLE_A_NV: CombinerVariableNV read _VARIABLE_A_NV;
    public static property VARIABLE_B_NV: CombinerVariableNV read _VARIABLE_B_NV;
    public static property VARIABLE_C_NV: CombinerVariableNV read _VARIABLE_C_NV;
    public static property VARIABLE_D_NV: CombinerVariableNV read _VARIABLE_D_NV;
    public static property VARIABLE_E_NV: CombinerVariableNV read _VARIABLE_E_NV;
    public static property VARIABLE_F_NV: CombinerVariableNV read _VARIABLE_F_NV;
    public static property VARIABLE_G_NV: CombinerVariableNV read _VARIABLE_G_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(CombinerVariableNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->CombinerVariableNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'CombinerVariableNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  EvalMapsModeNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FILL_NV := new EvalMapsModeNV($1B02);
    
    public static property FILL_NV: EvalMapsModeNV read _FILL_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(EvalMapsModeNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->EvalMapsModeNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'EvalMapsModeNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  EvalTargetNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _EVAL_2D_NV            := new EvalTargetNV($86C0);
    private static _EVAL_TRIANGULAR_2D_NV := new EvalTargetNV($86C1);
    
    public static property EVAL_2D_NV:            EvalTargetNV read _EVAL_2D_NV;
    public static property EVAL_TRIANGULAR_2D_NV: EvalTargetNV read _EVAL_TRIANGULAR_2D_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(EvalTargetNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->EvalTargetNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'EvalTargetNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FenceConditionNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _ALL_COMPLETED_NV := new FenceConditionNV($84F2);
    
    public static property ALL_COMPLETED_NV: FenceConditionNV read _ALL_COMPLETED_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(FenceConditionNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FenceConditionNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FenceConditionNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FenceParameterNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FENCE_STATUS_NV    := new FenceParameterNameNV($84F3);
    private static _FENCE_CONDITION_NV := new FenceParameterNameNV($84F4);
    
    public static property FENCE_STATUS_NV:    FenceParameterNameNV read _FENCE_STATUS_NV;
    public static property FENCE_CONDITION_NV: FenceParameterNameNV read _FENCE_CONDITION_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(FenceParameterNameNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FenceParameterNameNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FenceParameterNameNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetMultisamplePNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SAMPLE_LOCATION_ARB              := new GetMultisamplePNameNV($8E50);
    private static _SAMPLE_POSITION                  := new GetMultisamplePNameNV($8E50);
    private static _PROGRAMMABLE_SAMPLE_LOCATION_ARB := new GetMultisamplePNameNV($9341);
    
    public static property SAMPLE_LOCATION_ARB:              GetMultisamplePNameNV read _SAMPLE_LOCATION_ARB;
    public static property SAMPLE_POSITION:                  GetMultisamplePNameNV read _SAMPLE_POSITION;
    public static property PROGRAMMABLE_SAMPLE_LOCATION_ARB: GetMultisamplePNameNV read _PROGRAMMABLE_SAMPLE_LOCATION_ARB;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetMultisamplePNameNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetMultisamplePNameNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetMultisamplePNameNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MapAttribParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP_ATTRIB_U_ORDER_NV := new MapAttribParameterNV($86C3);
    private static _MAP_ATTRIB_V_ORDER_NV := new MapAttribParameterNV($86C4);
    
    public static property MAP_ATTRIB_U_ORDER_NV: MapAttribParameterNV read _MAP_ATTRIB_U_ORDER_NV;
    public static property MAP_ATTRIB_V_ORDER_NV: MapAttribParameterNV read _MAP_ATTRIB_V_ORDER_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapAttribParameterNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MapAttribParameterNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MapAttribParameterNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MapParameterNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _MAP_TESSELLATION_NV := new MapParameterNV($86C2);
    
    public static property MAP_TESSELLATION_NV: MapParameterNV read _MAP_TESSELLATION_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapParameterNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MapParameterNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MapParameterNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  MapTypeNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FLOAT  := new MapTypeNV($1406);
    private static _DOUBLE := new MapTypeNV($140A);
    
    public static property FLOAT:  MapTypeNV read _FLOAT;
    public static property DOUBLE: MapTypeNV read _DOUBLE;
    
    public function ToString: string; override;
    begin
      var res := typeof(MapTypeNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->MapTypeNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'MapTypeNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  OcclusionQueryParameterNameNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_COUNT_NV           := new OcclusionQueryParameterNameNV($8866);
    private static _PIXEL_COUNT_AVAILABLE_NV := new OcclusionQueryParameterNameNV($8867);
    
    public static property PIXEL_COUNT_NV:           OcclusionQueryParameterNameNV read _PIXEL_COUNT_NV;
    public static property PIXEL_COUNT_AVAILABLE_NV: OcclusionQueryParameterNameNV read _PIXEL_COUNT_AVAILABLE_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(OcclusionQueryParameterNameNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->OcclusionQueryParameterNameNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'OcclusionQueryParameterNameNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelDataRangeTargetNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _WRITE_PIXEL_DATA_RANGE_NV := new PixelDataRangeTargetNV($8878);
    private static _READ_PIXEL_DATA_RANGE_NV  := new PixelDataRangeTargetNV($8879);
    
    public static property WRITE_PIXEL_DATA_RANGE_NV: PixelDataRangeTargetNV read _WRITE_PIXEL_DATA_RANGE_NV;
    public static property READ_PIXEL_DATA_RANGE_NV:  PixelDataRangeTargetNV read _READ_PIXEL_DATA_RANGE_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelDataRangeTargetNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelDataRangeTargetNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelDataRangeTargetNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  VertexAttribEnumNV = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PROGRAM_PARAMETER_NV := new VertexAttribEnumNV($8644);
    
    public static property PROGRAM_PARAMETER_NV: VertexAttribEnumNV read _PROGRAM_PARAMETER_NV;
    
    public function ToString: string; override;
    begin
      var res := typeof(VertexAttribEnumNV).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->VertexAttribEnumNV(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'VertexAttribEnumNV[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion NV}
  
  {$region PGI}
  
  HintTargetPGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _VERTEX_DATA_HINT_PGI       := new HintTargetPGI($1A22A);
    private static _VERTEX_CONSISTENT_HINT_PGI := new HintTargetPGI($1A22B);
    private static _MATERIAL_SIDE_HINT_PGI     := new HintTargetPGI($1A22C);
    private static _MAX_VERTEX_HINT_PGI        := new HintTargetPGI($1A22D);
    
    public static property VERTEX_DATA_HINT_PGI:       HintTargetPGI read _VERTEX_DATA_HINT_PGI;
    public static property VERTEX_CONSISTENT_HINT_PGI: HintTargetPGI read _VERTEX_CONSISTENT_HINT_PGI;
    public static property MATERIAL_SIDE_HINT_PGI:     HintTargetPGI read _MATERIAL_SIDE_HINT_PGI;
    public static property MAX_VERTEX_HINT_PGI:        HintTargetPGI read _MAX_VERTEX_HINT_PGI;
    
    public function ToString: string; override;
    begin
      var res := typeof(HintTargetPGI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->HintTargetPGI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'HintTargetPGI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion PGI}
  
  {$region SGI}
  
  ColorTableTargetSGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _TEXTURE_COLOR_TABLE_SGI                 := new ColorTableTargetSGI($80BC);
    private static _PROXY_TEXTURE_COLOR_TABLE_SGI           := new ColorTableTargetSGI($80BD);
    private static _COLOR_TABLE                             := new ColorTableTargetSGI($80D0);
    private static _COLOR_TABLE_SGI                         := new ColorTableTargetSGI($80D0);
    private static _POST_CONVOLUTION_COLOR_TABLE            := new ColorTableTargetSGI($80D1);
    private static _POST_CONVOLUTION_COLOR_TABLE_SGI        := new ColorTableTargetSGI($80D1);
    private static _POST_COLOR_MATRIX_COLOR_TABLE           := new ColorTableTargetSGI($80D2);
    private static _POST_COLOR_MATRIX_COLOR_TABLE_SGI       := new ColorTableTargetSGI($80D2);
    private static _PROXY_COLOR_TABLE                       := new ColorTableTargetSGI($80D3);
    private static _PROXY_COLOR_TABLE_SGI                   := new ColorTableTargetSGI($80D3);
    private static _PROXY_POST_CONVOLUTION_COLOR_TABLE      := new ColorTableTargetSGI($80D4);
    private static _PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI  := new ColorTableTargetSGI($80D4);
    private static _PROXY_POST_COLOR_MATRIX_COLOR_TABLE     := new ColorTableTargetSGI($80D5);
    private static _PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI := new ColorTableTargetSGI($80D5);
    
    public static property TEXTURE_COLOR_TABLE_SGI:                 ColorTableTargetSGI read _TEXTURE_COLOR_TABLE_SGI;
    public static property PROXY_TEXTURE_COLOR_TABLE_SGI:           ColorTableTargetSGI read _PROXY_TEXTURE_COLOR_TABLE_SGI;
    public static property COLOR_TABLE:                             ColorTableTargetSGI read _COLOR_TABLE;
    public static property COLOR_TABLE_SGI:                         ColorTableTargetSGI read _COLOR_TABLE_SGI;
    public static property POST_CONVOLUTION_COLOR_TABLE:            ColorTableTargetSGI read _POST_CONVOLUTION_COLOR_TABLE;
    public static property POST_CONVOLUTION_COLOR_TABLE_SGI:        ColorTableTargetSGI read _POST_CONVOLUTION_COLOR_TABLE_SGI;
    public static property POST_COLOR_MATRIX_COLOR_TABLE:           ColorTableTargetSGI read _POST_COLOR_MATRIX_COLOR_TABLE;
    public static property POST_COLOR_MATRIX_COLOR_TABLE_SGI:       ColorTableTargetSGI read _POST_COLOR_MATRIX_COLOR_TABLE_SGI;
    public static property PROXY_COLOR_TABLE:                       ColorTableTargetSGI read _PROXY_COLOR_TABLE;
    public static property PROXY_COLOR_TABLE_SGI:                   ColorTableTargetSGI read _PROXY_COLOR_TABLE_SGI;
    public static property PROXY_POST_CONVOLUTION_COLOR_TABLE:      ColorTableTargetSGI read _PROXY_POST_CONVOLUTION_COLOR_TABLE;
    public static property PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI:  ColorTableTargetSGI read _PROXY_POST_CONVOLUTION_COLOR_TABLE_SGI;
    public static property PROXY_POST_COLOR_MATRIX_COLOR_TABLE:     ColorTableTargetSGI read _PROXY_POST_COLOR_MATRIX_COLOR_TABLE;
    public static property PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI: ColorTableTargetSGI read _PROXY_POST_COLOR_MATRIX_COLOR_TABLE_SGI;
    
    public function ToString: string; override;
    begin
      var res := typeof(ColorTableTargetSGI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ColorTableTargetSGI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ColorTableTargetSGI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  GetColorTableParameterPNameSGI = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _COLOR_TABLE_SCALE              := new GetColorTableParameterPNameSGI($80D6);
    private static _COLOR_TABLE_SCALE_SGI          := new GetColorTableParameterPNameSGI($80D6);
    private static _COLOR_TABLE_BIAS               := new GetColorTableParameterPNameSGI($80D7);
    private static _COLOR_TABLE_BIAS_SGI           := new GetColorTableParameterPNameSGI($80D7);
    private static _COLOR_TABLE_FORMAT             := new GetColorTableParameterPNameSGI($80D8);
    private static _COLOR_TABLE_FORMAT_SGI         := new GetColorTableParameterPNameSGI($80D8);
    private static _COLOR_TABLE_WIDTH              := new GetColorTableParameterPNameSGI($80D9);
    private static _COLOR_TABLE_WIDTH_SGI          := new GetColorTableParameterPNameSGI($80D9);
    private static _COLOR_TABLE_RED_SIZE           := new GetColorTableParameterPNameSGI($80DA);
    private static _COLOR_TABLE_RED_SIZE_SGI       := new GetColorTableParameterPNameSGI($80DA);
    private static _COLOR_TABLE_GREEN_SIZE         := new GetColorTableParameterPNameSGI($80DB);
    private static _COLOR_TABLE_GREEN_SIZE_SGI     := new GetColorTableParameterPNameSGI($80DB);
    private static _COLOR_TABLE_BLUE_SIZE          := new GetColorTableParameterPNameSGI($80DC);
    private static _COLOR_TABLE_BLUE_SIZE_SGI      := new GetColorTableParameterPNameSGI($80DC);
    private static _COLOR_TABLE_ALPHA_SIZE         := new GetColorTableParameterPNameSGI($80DD);
    private static _COLOR_TABLE_ALPHA_SIZE_SGI     := new GetColorTableParameterPNameSGI($80DD);
    private static _COLOR_TABLE_LUMINANCE_SIZE     := new GetColorTableParameterPNameSGI($80DE);
    private static _COLOR_TABLE_LUMINANCE_SIZE_SGI := new GetColorTableParameterPNameSGI($80DE);
    private static _COLOR_TABLE_INTENSITY_SIZE     := new GetColorTableParameterPNameSGI($80DF);
    private static _COLOR_TABLE_INTENSITY_SIZE_SGI := new GetColorTableParameterPNameSGI($80DF);
    
    public static property COLOR_TABLE_SCALE:              GetColorTableParameterPNameSGI read _COLOR_TABLE_SCALE;
    public static property COLOR_TABLE_SCALE_SGI:          GetColorTableParameterPNameSGI read _COLOR_TABLE_SCALE_SGI;
    public static property COLOR_TABLE_BIAS:               GetColorTableParameterPNameSGI read _COLOR_TABLE_BIAS;
    public static property COLOR_TABLE_BIAS_SGI:           GetColorTableParameterPNameSGI read _COLOR_TABLE_BIAS_SGI;
    public static property COLOR_TABLE_FORMAT:             GetColorTableParameterPNameSGI read _COLOR_TABLE_FORMAT;
    public static property COLOR_TABLE_FORMAT_SGI:         GetColorTableParameterPNameSGI read _COLOR_TABLE_FORMAT_SGI;
    public static property COLOR_TABLE_WIDTH:              GetColorTableParameterPNameSGI read _COLOR_TABLE_WIDTH;
    public static property COLOR_TABLE_WIDTH_SGI:          GetColorTableParameterPNameSGI read _COLOR_TABLE_WIDTH_SGI;
    public static property COLOR_TABLE_RED_SIZE:           GetColorTableParameterPNameSGI read _COLOR_TABLE_RED_SIZE;
    public static property COLOR_TABLE_RED_SIZE_SGI:       GetColorTableParameterPNameSGI read _COLOR_TABLE_RED_SIZE_SGI;
    public static property COLOR_TABLE_GREEN_SIZE:         GetColorTableParameterPNameSGI read _COLOR_TABLE_GREEN_SIZE;
    public static property COLOR_TABLE_GREEN_SIZE_SGI:     GetColorTableParameterPNameSGI read _COLOR_TABLE_GREEN_SIZE_SGI;
    public static property COLOR_TABLE_BLUE_SIZE:          GetColorTableParameterPNameSGI read _COLOR_TABLE_BLUE_SIZE;
    public static property COLOR_TABLE_BLUE_SIZE_SGI:      GetColorTableParameterPNameSGI read _COLOR_TABLE_BLUE_SIZE_SGI;
    public static property COLOR_TABLE_ALPHA_SIZE:         GetColorTableParameterPNameSGI read _COLOR_TABLE_ALPHA_SIZE;
    public static property COLOR_TABLE_ALPHA_SIZE_SGI:     GetColorTableParameterPNameSGI read _COLOR_TABLE_ALPHA_SIZE_SGI;
    public static property COLOR_TABLE_LUMINANCE_SIZE:     GetColorTableParameterPNameSGI read _COLOR_TABLE_LUMINANCE_SIZE;
    public static property COLOR_TABLE_LUMINANCE_SIZE_SGI: GetColorTableParameterPNameSGI read _COLOR_TABLE_LUMINANCE_SIZE_SGI;
    public static property COLOR_TABLE_INTENSITY_SIZE:     GetColorTableParameterPNameSGI read _COLOR_TABLE_INTENSITY_SIZE;
    public static property COLOR_TABLE_INTENSITY_SIZE_SGI: GetColorTableParameterPNameSGI read _COLOR_TABLE_INTENSITY_SIZE_SGI;
    
    public function ToString: string; override;
    begin
      var res := typeof(GetColorTableParameterPNameSGI).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->GetColorTableParameterPNameSGI(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'GetColorTableParameterPNameSGI[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion SGI}
  
  {$region SGIS}
  
  PixelTexGenParameterNameSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_FRAGMENT_RGB_SOURCE_SGIS   := new PixelTexGenParameterNameSGIS($8354);
    private static _PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS := new PixelTexGenParameterNameSGIS($8355);
    
    public static property PIXEL_FRAGMENT_RGB_SOURCE_SGIS:   PixelTexGenParameterNameSGIS read _PIXEL_FRAGMENT_RGB_SOURCE_SGIS;
    public static property PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS: PixelTexGenParameterNameSGIS read _PIXEL_FRAGMENT_ALPHA_SOURCE_SGIS;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelTexGenParameterNameSGIS).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelTexGenParameterNameSGIS(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelTexGenParameterNameSGIS[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SamplePatternSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _GL_1PASS_EXT    := new SamplePatternSGIS($80A1);
    private static _GL_1PASS_SGIS   := new SamplePatternSGIS($80A1);
    private static _GL_2PASS_0_EXT  := new SamplePatternSGIS($80A2);
    private static _GL_2PASS_0_SGIS := new SamplePatternSGIS($80A2);
    private static _GL_2PASS_1_EXT  := new SamplePatternSGIS($80A3);
    private static _GL_2PASS_1_SGIS := new SamplePatternSGIS($80A3);
    private static _GL_4PASS_0_EXT  := new SamplePatternSGIS($80A4);
    private static _GL_4PASS_0_SGIS := new SamplePatternSGIS($80A4);
    private static _GL_4PASS_1_EXT  := new SamplePatternSGIS($80A5);
    private static _GL_4PASS_1_SGIS := new SamplePatternSGIS($80A5);
    private static _GL_4PASS_2_EXT  := new SamplePatternSGIS($80A6);
    private static _GL_4PASS_2_SGIS := new SamplePatternSGIS($80A6);
    private static _GL_4PASS_3_EXT  := new SamplePatternSGIS($80A7);
    private static _GL_4PASS_3_SGIS := new SamplePatternSGIS($80A7);
    
    public static property GL_1PASS_EXT:    SamplePatternSGIS read _GL_1PASS_EXT;
    public static property GL_1PASS_SGIS:   SamplePatternSGIS read _GL_1PASS_SGIS;
    public static property GL_2PASS_0_EXT:  SamplePatternSGIS read _GL_2PASS_0_EXT;
    public static property GL_2PASS_0_SGIS: SamplePatternSGIS read _GL_2PASS_0_SGIS;
    public static property GL_2PASS_1_EXT:  SamplePatternSGIS read _GL_2PASS_1_EXT;
    public static property GL_2PASS_1_SGIS: SamplePatternSGIS read _GL_2PASS_1_SGIS;
    public static property GL_4PASS_0_EXT:  SamplePatternSGIS read _GL_4PASS_0_EXT;
    public static property GL_4PASS_0_SGIS: SamplePatternSGIS read _GL_4PASS_0_SGIS;
    public static property GL_4PASS_1_EXT:  SamplePatternSGIS read _GL_4PASS_1_EXT;
    public static property GL_4PASS_1_SGIS: SamplePatternSGIS read _GL_4PASS_1_SGIS;
    public static property GL_4PASS_2_EXT:  SamplePatternSGIS read _GL_4PASS_2_EXT;
    public static property GL_4PASS_2_SGIS: SamplePatternSGIS read _GL_4PASS_2_SGIS;
    public static property GL_4PASS_3_EXT:  SamplePatternSGIS read _GL_4PASS_3_EXT;
    public static property GL_4PASS_3_SGIS: SamplePatternSGIS read _GL_4PASS_3_SGIS;
    
    public function ToString: string; override;
    begin
      var res := typeof(SamplePatternSGIS).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SamplePatternSGIS(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SamplePatternSGIS[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  TextureFilterSGIS = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FILTER4_SGIS := new TextureFilterSGIS($8146);
    
    public static property FILTER4_SGIS: TextureFilterSGIS read _FILTER4_SGIS;
    
    public function ToString: string; override;
    begin
      var res := typeof(TextureFilterSGIS).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->TextureFilterSGIS(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'TextureFilterSGIS[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion SGIS}
  
  {$region SGIX}
  
  FfdTargetSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _GEOMETRY_DEFORMATION_SGIX := new FfdTargetSGIX($8194);
    private static _TEXTURE_DEFORMATION_SGIX  := new FfdTargetSGIX($8195);
    
    public static property GEOMETRY_DEFORMATION_SGIX: FfdTargetSGIX read _GEOMETRY_DEFORMATION_SGIX;
    public static property TEXTURE_DEFORMATION_SGIX:  FfdTargetSGIX read _TEXTURE_DEFORMATION_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(FfdTargetSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FfdTargetSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FfdTargetSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FragmentLightModelParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX         := new FragmentLightModelParameterSGIX($8408);
    private static _FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX             := new FragmentLightModelParameterSGIX($8409);
    private static _FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX              := new FragmentLightModelParameterSGIX($840A);
    private static _FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX := new FragmentLightModelParameterSGIX($840B);
    
    public static property FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX:         FragmentLightModelParameterSGIX read _FRAGMENT_LIGHT_MODEL_LOCAL_VIEWER_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX:             FragmentLightModelParameterSGIX read _FRAGMENT_LIGHT_MODEL_TWO_SIDE_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX:              FragmentLightModelParameterSGIX read _FRAGMENT_LIGHT_MODEL_AMBIENT_SGIX;
    public static property FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX: FragmentLightModelParameterSGIX read _FRAGMENT_LIGHT_MODEL_NORMAL_INTERPOLATION_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(FragmentLightModelParameterSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FragmentLightModelParameterSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FragmentLightModelParameterSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FragmentLightNameSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _FRAGMENT_LIGHT0_SGIX := new FragmentLightNameSGIX($840C);
    private static _FRAGMENT_LIGHT1_SGIX := new FragmentLightNameSGIX($840D);
    private static _FRAGMENT_LIGHT2_SGIX := new FragmentLightNameSGIX($840E);
    private static _FRAGMENT_LIGHT3_SGIX := new FragmentLightNameSGIX($840F);
    private static _FRAGMENT_LIGHT4_SGIX := new FragmentLightNameSGIX($8410);
    private static _FRAGMENT_LIGHT5_SGIX := new FragmentLightNameSGIX($8411);
    private static _FRAGMENT_LIGHT6_SGIX := new FragmentLightNameSGIX($8412);
    private static _FRAGMENT_LIGHT7_SGIX := new FragmentLightNameSGIX($8413);
    
    public static property FRAGMENT_LIGHT0_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT0_SGIX;
    public static property FRAGMENT_LIGHT1_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT1_SGIX;
    public static property FRAGMENT_LIGHT2_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT2_SGIX;
    public static property FRAGMENT_LIGHT3_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT3_SGIX;
    public static property FRAGMENT_LIGHT4_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT4_SGIX;
    public static property FRAGMENT_LIGHT5_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT5_SGIX;
    public static property FRAGMENT_LIGHT6_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT6_SGIX;
    public static property FRAGMENT_LIGHT7_SGIX: FragmentLightNameSGIX read _FRAGMENT_LIGHT7_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(FragmentLightNameSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FragmentLightNameSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FragmentLightNameSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  FragmentLightParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _AMBIENT               := new FragmentLightParameterSGIX($1200);
    private static _DIFFUSE               := new FragmentLightParameterSGIX($1201);
    private static _SPECULAR              := new FragmentLightParameterSGIX($1202);
    private static _POSITION              := new FragmentLightParameterSGIX($1203);
    private static _SPOT_DIRECTION        := new FragmentLightParameterSGIX($1204);
    private static _SPOT_EXPONENT         := new FragmentLightParameterSGIX($1205);
    private static _SPOT_CUTOFF           := new FragmentLightParameterSGIX($1206);
    private static _CONSTANT_ATTENUATION  := new FragmentLightParameterSGIX($1207);
    private static _LINEAR_ATTENUATION    := new FragmentLightParameterSGIX($1208);
    private static _QUADRATIC_ATTENUATION := new FragmentLightParameterSGIX($1209);
    
    public static property AMBIENT:               FragmentLightParameterSGIX read _AMBIENT;
    public static property DIFFUSE:               FragmentLightParameterSGIX read _DIFFUSE;
    public static property SPECULAR:              FragmentLightParameterSGIX read _SPECULAR;
    public static property POSITION:              FragmentLightParameterSGIX read _POSITION;
    public static property SPOT_DIRECTION:        FragmentLightParameterSGIX read _SPOT_DIRECTION;
    public static property SPOT_EXPONENT:         FragmentLightParameterSGIX read _SPOT_EXPONENT;
    public static property SPOT_CUTOFF:           FragmentLightParameterSGIX read _SPOT_CUTOFF;
    public static property CONSTANT_ATTENUATION:  FragmentLightParameterSGIX read _CONSTANT_ATTENUATION;
    public static property LINEAR_ATTENUATION:    FragmentLightParameterSGIX read _LINEAR_ATTENUATION;
    public static property QUADRATIC_ATTENUATION: FragmentLightParameterSGIX read _QUADRATIC_ATTENUATION;
    
    public function ToString: string; override;
    begin
      var res := typeof(FragmentLightParameterSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->FragmentLightParameterSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'FragmentLightParameterSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  LightEnvParameterSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _LIGHT_ENV_MODE_SGIX := new LightEnvParameterSGIX($8407);
    
    public static property LIGHT_ENV_MODE_SGIX: LightEnvParameterSGIX read _LIGHT_ENV_MODE_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(LightEnvParameterSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->LightEnvParameterSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'LightEnvParameterSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  PixelTexGenModeSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _PIXEL_TEX_GEN_Q_CEILING_SGIX := new PixelTexGenModeSGIX($8184);
    private static _PIXEL_TEX_GEN_Q_ROUND_SGIX   := new PixelTexGenModeSGIX($8185);
    private static _PIXEL_TEX_GEN_Q_FLOOR_SGIX   := new PixelTexGenModeSGIX($8186);
    private static _PIXEL_TEX_GEN_ALPHA_LS_SGIX  := new PixelTexGenModeSGIX($8189);
    private static _PIXEL_TEX_GEN_ALPHA_MS_SGIX  := new PixelTexGenModeSGIX($818A);
    
    public static property PIXEL_TEX_GEN_Q_CEILING_SGIX: PixelTexGenModeSGIX read _PIXEL_TEX_GEN_Q_CEILING_SGIX;
    public static property PIXEL_TEX_GEN_Q_ROUND_SGIX:   PixelTexGenModeSGIX read _PIXEL_TEX_GEN_Q_ROUND_SGIX;
    public static property PIXEL_TEX_GEN_Q_FLOOR_SGIX:   PixelTexGenModeSGIX read _PIXEL_TEX_GEN_Q_FLOOR_SGIX;
    public static property PIXEL_TEX_GEN_ALPHA_LS_SGIX:  PixelTexGenModeSGIX read _PIXEL_TEX_GEN_ALPHA_LS_SGIX;
    public static property PIXEL_TEX_GEN_ALPHA_MS_SGIX:  PixelTexGenModeSGIX read _PIXEL_TEX_GEN_ALPHA_MS_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(PixelTexGenModeSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->PixelTexGenModeSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'PixelTexGenModeSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  SpriteParameterNameSGIX = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _SPRITE_MODE_SGIX := new SpriteParameterNameSGIX($8149);
    
    public static property SPRITE_MODE_SGIX: SpriteParameterNameSGIX read _SPRITE_MODE_SGIX;
    
    public function ToString: string; override;
    begin
      var res := typeof(SpriteParameterNameSGIX).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->SpriteParameterNameSGIX(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'SpriteParameterNameSGIX[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion SGIX}
  
  {$region SUN}
  
  ReplacementCodeTypeSUN = record
    public val: UInt32;
    public constructor(val: UInt32) := self.val := val;
    
    private static _UNSIGNED_BYTE  := new ReplacementCodeTypeSUN($1401);
    private static _UNSIGNED_SHORT := new ReplacementCodeTypeSUN($1403);
    private static _UNSIGNED_INT   := new ReplacementCodeTypeSUN($1405);
    
    public static property UNSIGNED_BYTE:  ReplacementCodeTypeSUN read _UNSIGNED_BYTE;
    public static property UNSIGNED_SHORT: ReplacementCodeTypeSUN read _UNSIGNED_SHORT;
    public static property UNSIGNED_INT:   ReplacementCodeTypeSUN read _UNSIGNED_INT;
    
    public function ToString: string; override;
    begin
      var res := typeof(ReplacementCodeTypeSUN).GetFields(System.Reflection.BindingFlags.Static or System.Reflection.BindingFlags.NonPublic).FirstOrDefault(fld->ReplacementCodeTypeSUN(fld.GetValue(nil)).val=self.val);
      Result := res=nil?
        $'ReplacementCodeTypeSUN[{ self.val=default(UInt32) ? ''NONE'' : self.val.ToString(''X'') }]':
        res.Name.SubString(1);
    end;
    
  end;
  
  {$endregion SUN}
  
{$endregion Перечисления}

{$region Делегаты} type
  
  [UnmanagedFunctionPointer(CallingConvention.StdCall)]
  GLDEBUGPROC = procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; message_text: IntPtr; userParam: pointer);
  
  [UnmanagedFunctionPointer(CallingConvention.StdCall)]
  GLVULKANPROCNV = procedure;
  
{$endregion Делегаты}

{$region Записи} type
  
  {$region Vec}
  
  {$region Vec1}
  
  Vec1b = record
    public val0: SByte;
    
    public constructor(val0: SByte);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1b): Vec1b := new Vec1b(-v.val0);
    public static function operator+(v: Vec1b): Vec1b := v;
    public static function operator*(v: Vec1b; k: SByte): Vec1b := new Vec1b(v.val0*k);
    public static function operator div(v: Vec1b; k: SByte): Vec1b := new Vec1b(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1b): SByte := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1b): Vec1b := new Vec1b(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1b): Vec1b := new Vec1b(v1.val0-v2.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ub = record
    public val0: Byte;
    
    public constructor(val0: Byte);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ub): Vec1ub := v;
    public static function operator*(v: Vec1ub; k: Byte): Vec1ub := new Vec1ub(v.val0*k);
    public static function operator div(v: Vec1ub; k: Byte): Vec1ub := new Vec1ub(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ub): Byte := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ub): Vec1ub := new Vec1ub(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ub): Vec1ub := new Vec1ub(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ub := new Vec1ub(v.val0);
    public static function operator implicit(v: Vec1ub): Vec1b := new Vec1b(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1s = record
    public val0: Int16;
    
    public constructor(val0: Int16);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1s): Vec1s := new Vec1s(-v.val0);
    public static function operator+(v: Vec1s): Vec1s := v;
    public static function operator*(v: Vec1s; k: Int16): Vec1s := new Vec1s(v.val0*k);
    public static function operator div(v: Vec1s; k: Int16): Vec1s := new Vec1s(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1s): Int16 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1s): Vec1s := new Vec1s(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1s): Vec1s := new Vec1s(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1s := new Vec1s(v.val0);
    public static function operator implicit(v: Vec1s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1s := new Vec1s(v.val0);
    public static function operator implicit(v: Vec1s): Vec1ub := new Vec1ub(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1us = record
    public val0: UInt16;
    
    public constructor(val0: UInt16);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1us): Vec1us := v;
    public static function operator*(v: Vec1us; k: UInt16): Vec1us := new Vec1us(v.val0*k);
    public static function operator div(v: Vec1us; k: UInt16): Vec1us := new Vec1us(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1us): UInt16 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1us): Vec1us := new Vec1us(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1us): Vec1us := new Vec1us(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1us := new Vec1us(v.val0);
    public static function operator implicit(v: Vec1us): Vec1s := new Vec1s(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1i = record
    public val0: Int32;
    
    public constructor(val0: Int32);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1i): Vec1i := new Vec1i(-v.val0);
    public static function operator+(v: Vec1i): Vec1i := v;
    public static function operator*(v: Vec1i; k: Int32): Vec1i := new Vec1i(v.val0*k);
    public static function operator div(v: Vec1i; k: Int32): Vec1i := new Vec1i(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1i): Int32 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1i): Vec1i := new Vec1i(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1i): Vec1i := new Vec1i(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1i := new Vec1i(v.val0);
    public static function operator implicit(v: Vec1i): Vec1us := new Vec1us(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ui = record
    public val0: UInt32;
    
    public constructor(val0: UInt32);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ui): Vec1ui := v;
    public static function operator*(v: Vec1ui; k: UInt32): Vec1ui := new Vec1ui(v.val0*k);
    public static function operator div(v: Vec1ui; k: UInt32): Vec1ui := new Vec1ui(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ui): UInt32 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ui): Vec1ui := new Vec1ui(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ui): Vec1ui := new Vec1ui(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1ui := new Vec1ui(v.val0);
    public static function operator implicit(v: Vec1ui): Vec1i := new Vec1i(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1i64 = record
    public val0: Int64;
    
    public constructor(val0: Int64);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1i64): Vec1i64 := new Vec1i64(-v.val0);
    public static function operator+(v: Vec1i64): Vec1i64 := v;
    public static function operator*(v: Vec1i64; k: Int64): Vec1i64 := new Vec1i64(v.val0*k);
    public static function operator div(v: Vec1i64; k: Int64): Vec1i64 := new Vec1i64(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1i64): Int64 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1i64): Vec1i64 := new Vec1i64(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1i64): Vec1i64 := new Vec1i64(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec1i64 := new Vec1i64(v.val0);
    public static function operator implicit(v: Vec1i64): Vec1ui := new Vec1ui(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1ui64 = record
    public val0: UInt64;
    
    public constructor(val0: UInt64);
    begin
      self.val0 := val0;
    end;
    
    public static function operator+(v: Vec1ui64): Vec1ui64 := v;
    public static function operator*(v: Vec1ui64; k: UInt64): Vec1ui64 := new Vec1ui64(v.val0*k);
    public static function operator div(v: Vec1ui64; k: UInt64): Vec1ui64 := new Vec1ui64(v.val0 div k);
    
    public static function operator*(v1, v2: Vec1ui64): UInt64 := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1ui64): Vec1ui64 := new Vec1ui64(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1ui64): Vec1ui64 := new Vec1ui64(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec1ui64 := new Vec1ui64(v.val0);
    public static function operator implicit(v: Vec1ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec1f = record
    public val0: single;
    
    public constructor(val0: single);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1f): Vec1f := new Vec1f(-v.val0);
    public static function operator+(v: Vec1f): Vec1f := v;
    public static function operator*(v: Vec1f; k: single): Vec1f := new Vec1f(v.val0*k);
    public static function operator/(v: Vec1f; k: single): Vec1f := new Vec1f(v.val0/k);
    
    public static function operator*(v1, v2: Vec1f): single := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1f): Vec1f := new Vec1f(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1f): Vec1f := new Vec1f(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec1f := new Vec1f(v.val0);
    public static function operator implicit(v: Vec1f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public function SqrLength := val0*val0;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec1fPtrCallbackP = procedure(var ptr: Vec1f);
  UseVec1fPtrCallbackF<T> = function(var ptr: Vec1f): T;
  
  Vec1d = record
    public val0: double;
    
    public constructor(val0: double);
    begin
      self.val0 := val0;
    end;
    
    public static function operator-(v: Vec1d): Vec1d := new Vec1d(-v.val0);
    public static function operator+(v: Vec1d): Vec1d := v;
    public static function operator*(v: Vec1d; k: double): Vec1d := new Vec1d(v.val0*k);
    public static function operator/(v: Vec1d; k: double): Vec1d := new Vec1d(v.val0/k);
    
    public static function operator*(v1, v2: Vec1d): double := ( v1.val0*v2.val0 );
    public static function operator+(v1, v2: Vec1d): Vec1d := new Vec1d(v1.val0+v2.val0);
    public static function operator-(v1, v2: Vec1d): Vec1d := new Vec1d(v1.val0-v2.val0);
    
    public static function operator implicit(v: Vec1b): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec1d := new Vec1d(v.val0);
    public static function operator implicit(v: Vec1d): Vec1f := new Vec1f(v.val0);
    
    public function SqrLength := val0*val0;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec1d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec1dPtrCallbackP = procedure(var ptr: Vec1d);
  UseVec1dPtrCallbackF<T> = function(var ptr: Vec1d): T;
  
  {$endregion Vec1}
  
  {$region Vec2}
  
  Vec2b = record
    public val0: SByte;
    public val1: SByte;
    
    public constructor(val0, val1: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2b): Vec2b := new Vec2b(-v.val0, -v.val1);
    public static function operator+(v: Vec2b): Vec2b := v;
    public static function operator*(v: Vec2b; k: SByte): Vec2b := new Vec2b(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2b; k: SByte): Vec2b := new Vec2b(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2b): Vec2b := new Vec2b(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2b): Vec2b := new Vec2b(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2b := new Vec2b(v.val0, 0);
    public static function operator implicit(v: Vec2b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), 0);
    public static function operator implicit(v: Vec2b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), 0);
    public static function operator implicit(v: Vec2b): Vec1d := new Vec1d(v.val0);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ub = record
    public val0: Byte;
    public val1: Byte;
    
    public constructor(val0, val1: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ub): Vec2ub := v;
    public static function operator*(v: Vec2ub; k: Byte): Vec2ub := new Vec2ub(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ub; k: Byte): Vec2ub := new Vec2ub(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ub): Vec2ub := new Vec2ub(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ub): Vec2ub := new Vec2ub(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ub := new Vec2ub(v.val0, 0);
    public static function operator implicit(v: Vec2ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), 0);
    public static function operator implicit(v: Vec2ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), 0);
    public static function operator implicit(v: Vec2ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ub := new Vec2ub(v.val0, v.val1);
    public static function operator implicit(v: Vec2ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2s = record
    public val0: Int16;
    public val1: Int16;
    
    public constructor(val0, val1: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2s): Vec2s := new Vec2s(-v.val0, -v.val1);
    public static function operator+(v: Vec2s): Vec2s := v;
    public static function operator*(v: Vec2s; k: Int16): Vec2s := new Vec2s(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2s; k: Int16): Vec2s := new Vec2s(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2s): Vec2s := new Vec2s(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2s): Vec2s := new Vec2s(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2s := new Vec2s(v.val0, 0);
    public static function operator implicit(v: Vec2s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), 0);
    public static function operator implicit(v: Vec2s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), 0);
    public static function operator implicit(v: Vec2s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2s := new Vec2s(v.val0, v.val1);
    public static function operator implicit(v: Vec2s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2s := new Vec2s(v.val0, v.val1);
    public static function operator implicit(v: Vec2s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2us = record
    public val0: UInt16;
    public val1: UInt16;
    
    public constructor(val0, val1: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2us): Vec2us := v;
    public static function operator*(v: Vec2us; k: UInt16): Vec2us := new Vec2us(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2us; k: UInt16): Vec2us := new Vec2us(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2us): Vec2us := new Vec2us(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2us): Vec2us := new Vec2us(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2us := new Vec2us(v.val0, 0);
    public static function operator implicit(v: Vec2us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), 0);
    public static function operator implicit(v: Vec2us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), 0);
    public static function operator implicit(v: Vec2us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2us := new Vec2us(v.val0, v.val1);
    public static function operator implicit(v: Vec2us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2i = record
    public val0: Int32;
    public val1: Int32;
    
    public constructor(val0, val1: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2i): Vec2i := new Vec2i(-v.val0, -v.val1);
    public static function operator+(v: Vec2i): Vec2i := v;
    public static function operator*(v: Vec2i; k: Int32): Vec2i := new Vec2i(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2i; k: Int32): Vec2i := new Vec2i(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2i): Vec2i := new Vec2i(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2i): Vec2i := new Vec2i(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2i := new Vec2i(v.val0, 0);
    public static function operator implicit(v: Vec2i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), 0);
    public static function operator implicit(v: Vec2i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), 0);
    public static function operator implicit(v: Vec2i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2i := new Vec2i(v.val0, v.val1);
    public static function operator implicit(v: Vec2i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ui = record
    public val0: UInt32;
    public val1: UInt32;
    
    public constructor(val0, val1: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ui): Vec2ui := v;
    public static function operator*(v: Vec2ui; k: UInt32): Vec2ui := new Vec2ui(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ui; k: UInt32): Vec2ui := new Vec2ui(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ui): Vec2ui := new Vec2ui(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ui): Vec2ui := new Vec2ui(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ui := new Vec2ui(v.val0, 0);
    public static function operator implicit(v: Vec2ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), 0);
    public static function operator implicit(v: Vec2ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), 0);
    public static function operator implicit(v: Vec2ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2ui := new Vec2ui(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2i64 = record
    public val0: Int64;
    public val1: Int64;
    
    public constructor(val0, val1: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2i64): Vec2i64 := new Vec2i64(-v.val0, -v.val1);
    public static function operator+(v: Vec2i64): Vec2i64 := v;
    public static function operator*(v: Vec2i64; k: Int64): Vec2i64 := new Vec2i64(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2i64; k: Int64): Vec2i64 := new Vec2i64(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2i64): Vec2i64 := new Vec2i64(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2i64): Vec2i64 := new Vec2i64(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2i64 := new Vec2i64(v.val0, 0);
    public static function operator implicit(v: Vec2i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), 0);
    public static function operator implicit(v: Vec2i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), 0);
    public static function operator implicit(v: Vec2i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    public static function operator implicit(v: Vec2i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    
    public constructor(val0, val1: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator+(v: Vec2ui64): Vec2ui64 := v;
    public static function operator*(v: Vec2ui64; k: UInt64): Vec2ui64 := new Vec2ui64(v.val0*k, v.val1*k);
    public static function operator div(v: Vec2ui64; k: UInt64): Vec2ui64 := new Vec2ui64(v.val0 div k, v.val1 div k);
    
    public static function operator*(v1, v2: Vec2ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2ui64): Vec2ui64 := new Vec2ui64(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2ui64): Vec2ui64 := new Vec2ui64(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec2ui64 := new Vec2ui64(v.val0, 0);
    public static function operator implicit(v: Vec2ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), 0);
    public static function operator implicit(v: Vec2ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), 0);
    public static function operator implicit(v: Vec2ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    public static function operator implicit(v: Vec2ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec2f = record
    public val0: single;
    public val1: single;
    
    public constructor(val0, val1: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2f): Vec2f := new Vec2f(-v.val0, -v.val1);
    public static function operator+(v: Vec2f): Vec2f := v;
    public static function operator*(v: Vec2f; k: single): Vec2f := new Vec2f(v.val0*k, v.val1*k);
    public static function operator/(v: Vec2f; k: single): Vec2f := new Vec2f(v.val0/k, v.val1/k);
    
    public static function operator*(v1, v2: Vec2f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2f): Vec2f := new Vec2f(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2f): Vec2f := new Vec2f(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2f := new Vec2f(v.val0, 0);
    public static function operator implicit(v: Vec2f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec2f := new Vec2f(v.val0, v.val1);
    public static function operator implicit(v: Vec2f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec2fPtrCallbackP = procedure(var ptr: Vec2f);
  UseVec2fPtrCallbackF<T> = function(var ptr: Vec2f): T;
  
  Vec2d = record
    public val0: double;
    public val1: double;
    
    public constructor(val0, val1: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
    end;
    
    public static function operator-(v: Vec2d): Vec2d := new Vec2d(-v.val0, -v.val1);
    public static function operator+(v: Vec2d): Vec2d := v;
    public static function operator*(v: Vec2d; k: double): Vec2d := new Vec2d(v.val0*k, v.val1*k);
    public static function operator/(v: Vec2d; k: double): Vec2d := new Vec2d(v.val0/k, v.val1/k);
    
    public static function operator*(v1, v2: Vec2d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 );
    public static function operator+(v1, v2: Vec2d): Vec2d := new Vec2d(v1.val0+v2.val0, v1.val1+v2.val1);
    public static function operator-(v1, v2: Vec2d): Vec2d := new Vec2d(v1.val0-v2.val0, v1.val1-v2.val1);
    
    public static function operator implicit(v: Vec1b): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec2d := new Vec2d(v.val0, 0);
    public static function operator implicit(v: Vec2d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec2d := new Vec2d(v.val0, v.val1);
    public static function operator implicit(v: Vec2d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec2dPtrCallbackP = procedure(var ptr: Vec2d);
  UseVec2dPtrCallbackF<T> = function(var ptr: Vec2d): T;
  
  {$endregion Vec2}
  
  {$region Vec3}
  
  Vec3b = record
    public val0: SByte;
    public val1: SByte;
    public val2: SByte;
    
    public constructor(val0, val1, val2: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3b): Vec3b := new Vec3b(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3b): Vec3b := v;
    public static function operator*(v: Vec3b; k: SByte): Vec3b := new Vec3b(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3b; k: SByte): Vec3b := new Vec3b(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3b): Vec3b := new Vec3b(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3b): Vec3b := new Vec3b(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3b := new Vec3b(v.val0, 0, 0);
    public static function operator implicit(v: Vec3b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3b): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3b := new Vec3b(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0);
    public static function operator implicit(v: Vec3b): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0);
    public static function operator implicit(v: Vec3b): Vec2d := new Vec2d(v.val0, v.val1);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3b) :=
    new Vec3b(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3b) :=
    new Vec3b(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ub = record
    public val0: Byte;
    public val1: Byte;
    public val2: Byte;
    
    public constructor(val0, val1, val2: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ub): Vec3ub := v;
    public static function operator*(v: Vec3ub; k: Byte): Vec3ub := new Vec3ub(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ub; k: Byte): Vec3ub := new Vec3ub(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ub): Vec3ub := new Vec3ub(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ub): Vec3ub := new Vec3ub(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ub := new Vec3ub(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ub := new Vec3ub(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0);
    public static function operator implicit(v: Vec3ub): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0);
    public static function operator implicit(v: Vec3ub): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ub): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3s = record
    public val0: Int16;
    public val1: Int16;
    public val2: Int16;
    
    public constructor(val0, val1, val2: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3s): Vec3s := new Vec3s(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3s): Vec3s := v;
    public static function operator*(v: Vec3s; k: Int16): Vec3s := new Vec3s(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3s; k: Int16): Vec3s := new Vec3s(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3s): Vec3s := new Vec3s(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3s): Vec3s := new Vec3s(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3s := new Vec3s(v.val0, 0, 0);
    public static function operator implicit(v: Vec3s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3s := new Vec3s(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0);
    public static function operator implicit(v: Vec3s): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0);
    public static function operator implicit(v: Vec3s): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3s): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3s): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3s) :=
    new Vec3s(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3s) :=
    new Vec3s(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3us = record
    public val0: UInt16;
    public val1: UInt16;
    public val2: UInt16;
    
    public constructor(val0, val1, val2: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3us): Vec3us := v;
    public static function operator*(v: Vec3us; k: UInt16): Vec3us := new Vec3us(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3us; k: UInt16): Vec3us := new Vec3us(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3us): Vec3us := new Vec3us(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3us): Vec3us := new Vec3us(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3us := new Vec3us(v.val0, 0, 0);
    public static function operator implicit(v: Vec3us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), 0, 0);
    public static function operator implicit(v: Vec3us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3us := new Vec3us(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0);
    public static function operator implicit(v: Vec3us): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0);
    public static function operator implicit(v: Vec3us): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3us): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3i = record
    public val0: Int32;
    public val1: Int32;
    public val2: Int32;
    
    public constructor(val0, val1, val2: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3i): Vec3i := new Vec3i(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3i): Vec3i := v;
    public static function operator*(v: Vec3i; k: Int32): Vec3i := new Vec3i(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3i; k: Int32): Vec3i := new Vec3i(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3i): Vec3i := new Vec3i(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3i): Vec3i := new Vec3i(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3i := new Vec3i(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3i := new Vec3i(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0);
    public static function operator implicit(v: Vec3i): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0);
    public static function operator implicit(v: Vec3i): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3i) :=
    new Vec3i(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3i) :=
    new Vec3i(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ui = record
    public val0: UInt32;
    public val1: UInt32;
    public val2: UInt32;
    
    public constructor(val0, val1, val2: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ui): Vec3ui := v;
    public static function operator*(v: Vec3ui; k: UInt32): Vec3ui := new Vec3ui(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ui; k: UInt32): Vec3ui := new Vec3ui(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ui): Vec3ui := new Vec3ui(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ui): Vec3ui := new Vec3ui(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ui := new Vec3ui(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ui := new Vec3ui(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0);
    public static function operator implicit(v: Vec3ui): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0);
    public static function operator implicit(v: Vec3ui): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3i64 = record
    public val0: Int64;
    public val1: Int64;
    public val2: Int64;
    
    public constructor(val0, val1, val2: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3i64): Vec3i64 := new Vec3i64(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3i64): Vec3i64 := v;
    public static function operator*(v: Vec3i64; k: Int64): Vec3i64 := new Vec3i64(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3i64; k: Int64): Vec3i64 := new Vec3i64(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3i64): Vec3i64 := new Vec3i64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3i64): Vec3i64 := new Vec3i64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3i64 := new Vec3i64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0);
    public static function operator implicit(v: Vec3i64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0);
    public static function operator implicit(v: Vec3i64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3i64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public static function CrossCW(v1,v2: Vec3i64) :=
    new Vec3i64(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3i64) :=
    new Vec3i64(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    public val2: UInt64;
    
    public constructor(val0, val1, val2: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator+(v: Vec3ui64): Vec3ui64 := v;
    public static function operator*(v: Vec3ui64; k: UInt64): Vec3ui64 := new Vec3ui64(v.val0*k, v.val1*k, v.val2*k);
    public static function operator div(v: Vec3ui64; k: UInt64): Vec3ui64 := new Vec3ui64(v.val0 div k, v.val1 div k, v.val2 div k);
    
    public static function operator*(v1, v2: Vec3ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3ui64): Vec3ui64 := new Vec3ui64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3ui64): Vec3ui64 := new Vec3ui64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec3ui64 := new Vec3ui64(v.val0, 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), 0, 0);
    public static function operator implicit(v: Vec3ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3ui64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0);
    public static function operator implicit(v: Vec3ui64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0);
    public static function operator implicit(v: Vec3ui64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec3f = record
    public val0: single;
    public val1: single;
    public val2: single;
    
    public constructor(val0, val1, val2: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3f): Vec3f := new Vec3f(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3f): Vec3f := v;
    public static function operator*(v: Vec3f; k: single): Vec3f := new Vec3f(v.val0*k, v.val1*k, v.val2*k);
    public static function operator/(v: Vec3f; k: single): Vec3f := new Vec3f(v.val0/k, v.val1/k, v.val2/k);
    
    public static function operator*(v1, v2: Vec3f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3f): Vec3f := new Vec3f(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3f): Vec3f := new Vec3f(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3f := new Vec3f(v.val0, 0, 0);
    public static function operator implicit(v: Vec3f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3f := new Vec3f(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3f): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public static function CrossCW(v1,v2: Vec3f) :=
    new Vec3f(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3f) :=
    new Vec3f(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec3fPtrCallbackP = procedure(var ptr: Vec3f);
  UseVec3fPtrCallbackF<T> = function(var ptr: Vec3f): T;
  
  Vec3d = record
    public val0: double;
    public val1: double;
    public val2: double;
    
    public constructor(val0, val1, val2: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
    end;
    
    public static function operator-(v: Vec3d): Vec3d := new Vec3d(-v.val0, -v.val1, -v.val2);
    public static function operator+(v: Vec3d): Vec3d := v;
    public static function operator*(v: Vec3d; k: double): Vec3d := new Vec3d(v.val0*k, v.val1*k, v.val2*k);
    public static function operator/(v: Vec3d; k: double): Vec3d := new Vec3d(v.val0/k, v.val1/k, v.val2/k);
    
    public static function operator*(v1, v2: Vec3d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 );
    public static function operator+(v1, v2: Vec3d): Vec3d := new Vec3d(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2);
    public static function operator-(v1, v2: Vec3d): Vec3d := new Vec3d(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2);
    
    public static function operator implicit(v: Vec1b): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec3d := new Vec3d(v.val0, 0, 0);
    public static function operator implicit(v: Vec3d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec3d := new Vec3d(v.val0, v.val1, 0);
    public static function operator implicit(v: Vec3d): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    public static function operator implicit(v: Vec3d): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public static function CrossCW(v1,v2: Vec3d) :=
    new Vec3d(v1.val2*v2.val1 - v2.val2*v1.val1, v1.val0*v2.val2 - v2.val0*v1.val2, v1.val1*v2.val0 - v2.val1*v1.val0);
    
    public static function CrossCCW(v1,v2: Vec3d) :=
    new Vec3d(v1.val1*v2.val2 - v2.val1*v1.val2, v1.val2*v2.val0 - v2.val2*v1.val0, v1.val0*v2.val1 - v2.val0*v1.val1);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec3dPtrCallbackP = procedure(var ptr: Vec3d);
  UseVec3dPtrCallbackF<T> = function(var ptr: Vec3d): T;
  
  {$endregion Vec3}
  
  {$region Vec4}
  
  Vec4b = record
    public val0: SByte;
    public val1: SByte;
    public val2: SByte;
    public val3: SByte;
    
    public constructor(val0, val1, val2, val3: SByte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4b): Vec4b := new Vec4b(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4b): Vec4b := v;
    public static function operator*(v: Vec4b; k: SByte): Vec4b := new Vec4b(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4b; k: SByte): Vec4b := new Vec4b(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4b): SByte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4b): Vec4b := new Vec4b(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4b): Vec4b := new Vec4b(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4b := new Vec4b(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4b): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4b := new Vec4b(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4b): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4b): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4b): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4b): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), 0);
    public static function operator implicit(v: Vec4b): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), 0);
    public static function operator implicit(v: Vec4b): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4b;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ub = record
    public val0: Byte;
    public val1: Byte;
    public val2: Byte;
    public val3: Byte;
    
    public constructor(val0, val1, val2, val3: Byte);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ub): Vec4ub := v;
    public static function operator*(v: Vec4ub; k: Byte): Vec4ub := new Vec4ub(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ub; k: Byte): Vec4ub := new Vec4ub(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ub): Byte := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ub): Vec4ub := new Vec4ub(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ub): Vec4ub := new Vec4ub(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ub := new Vec4ub(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ub := new Vec4ub(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ub): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ub): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), 0);
    public static function operator implicit(v: Vec4ub): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), 0);
    public static function operator implicit(v: Vec4ub): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ub): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ub;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4s = record
    public val0: Int16;
    public val1: Int16;
    public val2: Int16;
    public val3: Int16;
    
    public constructor(val0, val1, val2, val3: Int16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4s): Vec4s := new Vec4s(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4s): Vec4s := v;
    public static function operator*(v: Vec4s; k: Int16): Vec4s := new Vec4s(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4s; k: Int16): Vec4s := new Vec4s(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4s): Int16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4s): Vec4s := new Vec4s(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4s): Vec4s := new Vec4s(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4s := new Vec4s(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4s): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4s := new Vec4s(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4s): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4s): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4s): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4s): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), 0);
    public static function operator implicit(v: Vec4s): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), 0);
    public static function operator implicit(v: Vec4s): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4s): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4s): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4s;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4us = record
    public val0: UInt16;
    public val1: UInt16;
    public val2: UInt16;
    public val3: UInt16;
    
    public constructor(val0, val1, val2, val3: UInt16);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4us): Vec4us := v;
    public static function operator*(v: Vec4us; k: UInt16): Vec4us := new Vec4us(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4us; k: UInt16): Vec4us := new Vec4us(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4us): UInt16 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4us): Vec4us := new Vec4us(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4us): Vec4us := new Vec4us(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4us := new Vec4us(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4us): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4us := new Vec4us(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4us): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4us): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), 0, 0);
    public static function operator implicit(v: Vec4us): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4us): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), 0);
    public static function operator implicit(v: Vec4us): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), 0);
    public static function operator implicit(v: Vec4us): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4us): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4us;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4i = record
    public val0: Int32;
    public val1: Int32;
    public val2: Int32;
    public val3: Int32;
    
    public constructor(val0, val1, val2, val3: Int32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4i): Vec4i := new Vec4i(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4i): Vec4i := v;
    public static function operator*(v: Vec4i; k: Int32): Vec4i := new Vec4i(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4i; k: Int32): Vec4i := new Vec4i(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4i): Int32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4i): Vec4i := new Vec4i(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4i): Vec4i := new Vec4i(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4i := new Vec4i(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4i := new Vec4i(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), 0);
    public static function operator implicit(v: Vec4i): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), 0);
    public static function operator implicit(v: Vec4i): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4i;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ui = record
    public val0: UInt32;
    public val1: UInt32;
    public val2: UInt32;
    public val3: UInt32;
    
    public constructor(val0, val1, val2, val3: UInt32);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ui): Vec4ui := v;
    public static function operator*(v: Vec4ui; k: UInt32): Vec4ui := new Vec4ui(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ui; k: UInt32): Vec4ui := new Vec4ui(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ui): UInt32 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ui): Vec4ui := new Vec4ui(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ui): Vec4ui := new Vec4ui(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ui := new Vec4ui(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ui := new Vec4ui(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), 0);
    public static function operator implicit(v: Vec4ui): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), 0);
    public static function operator implicit(v: Vec4ui): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ui;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4i64 = record
    public val0: Int64;
    public val1: Int64;
    public val2: Int64;
    public val3: Int64;
    
    public constructor(val0, val1, val2, val3: Int64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4i64): Vec4i64 := new Vec4i64(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4i64): Vec4i64 := v;
    public static function operator*(v: Vec4i64; k: Int64): Vec4i64 := new Vec4i64(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4i64; k: Int64): Vec4i64 := new Vec4i64(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4i64): Int64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4i64): Vec4i64 := new Vec4i64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4i64): Vec4i64 := new Vec4i64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4i64 := new Vec4i64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4i64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4i64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), 0);
    public static function operator implicit(v: Vec4i64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), 0);
    public static function operator implicit(v: Vec4i64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ui): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4i64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4i64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4ui64 = record
    public val0: UInt64;
    public val1: UInt64;
    public val2: UInt64;
    public val3: UInt64;
    
    public constructor(val0, val1, val2, val3: UInt64);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator+(v: Vec4ui64): Vec4ui64 := v;
    public static function operator*(v: Vec4ui64; k: UInt64): Vec4ui64 := new Vec4ui64(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator div(v: Vec4ui64; k: UInt64): Vec4ui64 := new Vec4ui64(v.val0 div k, v.val1 div k, v.val2 div k, v.val3 div k);
    
    public static function operator*(v1, v2: Vec4ui64): UInt64 := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4ui64): Vec4ui64 := new Vec4ui64(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4ui64): Vec4ui64 := new Vec4ui64(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1b := new Vec1b(v.val0);
    
    public static function operator implicit(v: Vec1ub): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ub := new Vec1ub(v.val0);
    
    public static function operator implicit(v: Vec1s): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1s := new Vec1s(v.val0);
    
    public static function operator implicit(v: Vec1us): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1us := new Vec1us(v.val0);
    
    public static function operator implicit(v: Vec1i): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1i := new Vec1i(v.val0);
    
    public static function operator implicit(v: Vec1ui): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ui := new Vec1ui(v.val0);
    
    public static function operator implicit(v: Vec1i64): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1i64 := new Vec1i64(v.val0);
    
    public static function operator implicit(v: Vec1ui64): Vec4ui64 := new Vec4ui64(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1ui64 := new Vec1ui64(v.val0);
    
    public static function operator implicit(v: Vec1f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), 0, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2b := new Vec2b(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ub := new Vec2ub(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2s := new Vec2s(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2us := new Vec2us(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2i := new Vec2i(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ui := new Vec2ui(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2i64 := new Vec2i64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2ui64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2ui64 := new Vec2ui64(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), 0, 0);
    public static function operator implicit(v: Vec4ui64): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3b := new Vec3b(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ub := new Vec3ub(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3s := new Vec3s(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3us := new Vec3us(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3i := new Vec3i(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ui := new Vec3ui(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3i64 := new Vec3i64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3ui64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4ui64): Vec3ui64 := new Vec3ui64(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), 0);
    public static function operator implicit(v: Vec4ui64): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), 0);
    public static function operator implicit(v: Vec4ui64): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4b := new Vec4b(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ub): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4ub := new Vec4ub(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4s): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4s := new Vec4s(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4us): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4us := new Vec4us(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4i := new Vec4i(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4ui): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4ui := new Vec4ui(v.val0, v.val1, v.val2, v.val3);
    
    public static function operator implicit(v: Vec4i64): Vec4ui64 := new Vec4ui64(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4ui64): Vec4i64 := new Vec4i64(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4ui64;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  
  Vec4f = record
    public val0: single;
    public val1: single;
    public val2: single;
    public val3: single;
    
    public constructor(val0, val1, val2, val3: single);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4f): Vec4f := new Vec4f(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4f): Vec4f := v;
    public static function operator*(v: Vec4f; k: single): Vec4f := new Vec4f(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator/(v: Vec4f; k: single): Vec4f := new Vec4f(v.val0/k, v.val1/k, v.val2/k, v.val3/k);
    
    public static function operator*(v1, v2: Vec4f): single := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4f): Vec4f := new Vec4f(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4f): Vec4f := new Vec4f(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4f := new Vec4f(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4f): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4f := new Vec4f(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4f): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4f := new Vec4f(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4f): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), Convert.ToSByte(v.val3));
    
    public static function operator implicit(v: Vec4ub): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), Convert.ToByte(v.val3));
    
    public static function operator implicit(v: Vec4s): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), Convert.ToInt16(v.val3));
    
    public static function operator implicit(v: Vec4us): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), Convert.ToUInt16(v.val3));
    
    public static function operator implicit(v: Vec4i): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), Convert.ToInt32(v.val3));
    
    public static function operator implicit(v: Vec4ui): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), Convert.ToUInt32(v.val3));
    
    public static function operator implicit(v: Vec4i64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), Convert.ToInt64(v.val3));
    
    public static function operator implicit(v: Vec4ui64): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4f): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), Convert.ToUInt64(v.val3));
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function Normalized := self / single(Sqrt(self.SqrLength));
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec4fPtrCallbackP = procedure(var ptr: Vec4f);
  UseVec4fPtrCallbackF<T> = function(var ptr: Vec4f): T;
  
  Vec4d = record
    public val0: double;
    public val1: double;
    public val2: double;
    public val3: double;
    
    public constructor(val0, val1, val2, val3: double);
    begin
      self.val0 := val0;
      self.val1 := val1;
      self.val2 := val2;
      self.val3 := val3;
    end;
    
    public static function operator-(v: Vec4d): Vec4d := new Vec4d(-v.val0, -v.val1, -v.val2, -v.val3);
    public static function operator+(v: Vec4d): Vec4d := v;
    public static function operator*(v: Vec4d; k: double): Vec4d := new Vec4d(v.val0*k, v.val1*k, v.val2*k, v.val3*k);
    public static function operator/(v: Vec4d; k: double): Vec4d := new Vec4d(v.val0/k, v.val1/k, v.val2/k, v.val3/k);
    
    public static function operator*(v1, v2: Vec4d): double := ( v1.val0*v2.val0 + v1.val1*v2.val1 + v1.val2*v2.val2 + v1.val3*v2.val3 );
    public static function operator+(v1, v2: Vec4d): Vec4d := new Vec4d(v1.val0+v2.val0, v1.val1+v2.val1, v1.val2+v2.val2, v1.val3+v2.val3);
    public static function operator-(v1, v2: Vec4d): Vec4d := new Vec4d(v1.val0-v2.val0, v1.val1-v2.val1, v1.val2-v2.val2, v1.val3-v2.val3);
    
    public static function operator implicit(v: Vec1b): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1b := new Vec1b(Convert.ToSByte(v.val0));
    
    public static function operator implicit(v: Vec1ub): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ub := new Vec1ub(Convert.ToByte(v.val0));
    
    public static function operator implicit(v: Vec1s): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1s := new Vec1s(Convert.ToInt16(v.val0));
    
    public static function operator implicit(v: Vec1us): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1us := new Vec1us(Convert.ToUInt16(v.val0));
    
    public static function operator implicit(v: Vec1i): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1i := new Vec1i(Convert.ToInt32(v.val0));
    
    public static function operator implicit(v: Vec1ui): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ui := new Vec1ui(Convert.ToUInt32(v.val0));
    
    public static function operator implicit(v: Vec1i64): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1i64 := new Vec1i64(Convert.ToInt64(v.val0));
    
    public static function operator implicit(v: Vec1ui64): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1ui64 := new Vec1ui64(Convert.ToUInt64(v.val0));
    
    public static function operator implicit(v: Vec1f): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1f := new Vec1f(v.val0);
    
    public static function operator implicit(v: Vec1d): Vec4d := new Vec4d(v.val0, 0, 0, 0);
    public static function operator implicit(v: Vec4d): Vec1d := new Vec1d(v.val0);
    
    public static function operator implicit(v: Vec2b): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2b := new Vec2b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1));
    
    public static function operator implicit(v: Vec2ub): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ub := new Vec2ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1));
    
    public static function operator implicit(v: Vec2s): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2s := new Vec2s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1));
    
    public static function operator implicit(v: Vec2us): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2us := new Vec2us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1));
    
    public static function operator implicit(v: Vec2i): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2i := new Vec2i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1));
    
    public static function operator implicit(v: Vec2ui): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ui := new Vec2ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1));
    
    public static function operator implicit(v: Vec2i64): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2i64 := new Vec2i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1));
    
    public static function operator implicit(v: Vec2ui64): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2ui64 := new Vec2ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1));
    
    public static function operator implicit(v: Vec2f): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2f := new Vec2f(v.val0, v.val1);
    
    public static function operator implicit(v: Vec2d): Vec4d := new Vec4d(v.val0, v.val1, 0, 0);
    public static function operator implicit(v: Vec4d): Vec2d := new Vec2d(v.val0, v.val1);
    
    public static function operator implicit(v: Vec3b): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3b := new Vec3b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2));
    
    public static function operator implicit(v: Vec3ub): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ub := new Vec3ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2));
    
    public static function operator implicit(v: Vec3s): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3s := new Vec3s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2));
    
    public static function operator implicit(v: Vec3us): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3us := new Vec3us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2));
    
    public static function operator implicit(v: Vec3i): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3i := new Vec3i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2));
    
    public static function operator implicit(v: Vec3ui): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ui := new Vec3ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2));
    
    public static function operator implicit(v: Vec3i64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3i64 := new Vec3i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2));
    
    public static function operator implicit(v: Vec3ui64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3ui64 := new Vec3ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2));
    
    public static function operator implicit(v: Vec3f): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3f := new Vec3f(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec3d): Vec4d := new Vec4d(v.val0, v.val1, v.val2, 0);
    public static function operator implicit(v: Vec4d): Vec3d := new Vec3d(v.val0, v.val1, v.val2);
    
    public static function operator implicit(v: Vec4b): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4b := new Vec4b(Convert.ToSByte(v.val0), Convert.ToSByte(v.val1), Convert.ToSByte(v.val2), Convert.ToSByte(v.val3));
    
    public static function operator implicit(v: Vec4ub): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ub := new Vec4ub(Convert.ToByte(v.val0), Convert.ToByte(v.val1), Convert.ToByte(v.val2), Convert.ToByte(v.val3));
    
    public static function operator implicit(v: Vec4s): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4s := new Vec4s(Convert.ToInt16(v.val0), Convert.ToInt16(v.val1), Convert.ToInt16(v.val2), Convert.ToInt16(v.val3));
    
    public static function operator implicit(v: Vec4us): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4us := new Vec4us(Convert.ToUInt16(v.val0), Convert.ToUInt16(v.val1), Convert.ToUInt16(v.val2), Convert.ToUInt16(v.val3));
    
    public static function operator implicit(v: Vec4i): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4i := new Vec4i(Convert.ToInt32(v.val0), Convert.ToInt32(v.val1), Convert.ToInt32(v.val2), Convert.ToInt32(v.val3));
    
    public static function operator implicit(v: Vec4ui): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ui := new Vec4ui(Convert.ToUInt32(v.val0), Convert.ToUInt32(v.val1), Convert.ToUInt32(v.val2), Convert.ToUInt32(v.val3));
    
    public static function operator implicit(v: Vec4i64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4i64 := new Vec4i64(Convert.ToInt64(v.val0), Convert.ToInt64(v.val1), Convert.ToInt64(v.val2), Convert.ToInt64(v.val3));
    
    public static function operator implicit(v: Vec4ui64): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4ui64 := new Vec4ui64(Convert.ToUInt64(v.val0), Convert.ToUInt64(v.val1), Convert.ToUInt64(v.val2), Convert.ToUInt64(v.val3));
    
    public static function operator implicit(v: Vec4f): Vec4d := new Vec4d(v.val0, v.val1, v.val2, v.val3);
    public static function operator implicit(v: Vec4d): Vec4f := new Vec4f(v.val0, v.val1, v.val2, v.val3);
    
    public function SqrLength := val0*val0 + val1*val1 + val2*val2 + val3*val3;
    
    public function Normalized := self / self.SqrLength.Sqrt;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      res += '[ ';
      res += val0.ToString('f2');
      res += ', ';
      res += val1.ToString('f2');
      res += ', ';
      res += val2.ToString('f2');
      res += ', ';
      res += val3.ToString('f2');
      res += ' ]';
      Result := res.ToString;
    end;
    
    public function Println: Vec4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
  end;
  UseVec4dPtrCallbackP = procedure(var ptr: Vec4d);
  UseVec4dPtrCallbackF<T> = function(var ptr: Vec4d): T;
  
  {$endregion Vec4}
  
  {$endregion Vec}
  
  {$region Mtr}
  
  Mtr2x2f = record
    public val00, val10: single;
    public val01, val11: single;
    
    public constructor(val00, val01, val10, val11: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
    end;
    
    public static property Identity: Mtr2x2f read new Mtr2x2f(1.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr2x2f := new Mtr2x2f(k, 0.0, 0.0, k);
    
    public static function Traslate(X: single): Mtr2x2f := new Mtr2x2f(1.0, X, 0.0, 1.0);
    public static function TraslateTransposed(X: single): Mtr2x2f := new Mtr2x2f(1.0, 0.0, X, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr2x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x2f(
         cr, +sr,
        -sr,  cr
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x2f(
         cr, -sr,
        +sr,  cr
      );
    end;
    
    public function Det: single :=
    val00*val11 - val10*val01;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x2f; v: Vec2f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1);
    public static function operator*(v: Vec2f; m: Mtr2x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1);
    
  end;
  Mtr2f = Mtr2x2f;
  
  Mtr3x3f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    public val02, val12, val22: single;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
    end;
    
    public static property Identity: Mtr3x3f read new Mtr3x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3f read new Vec3f(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3f read new Vec3f(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr2: ^Vec3f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr3x3f := new Mtr3x3f(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y: single): Mtr3x3f := new Mtr3x3f(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y: single): Mtr3x3f := new Mtr3x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x3f(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr3x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr3x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function Det: single :=
    val00 * (val11*val22 - val21*val12) - val01 * (val10*val22 - val20*val12) + val02 * (val10*val21 - val20*val11);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x3f; v: Vec3f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2);
    public static function operator*(v: Vec3f; m: Mtr3x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
  end;
  Mtr3f = Mtr3x3f;
  
  Mtr4x4f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    public val02, val12, val22, val32: single;
    public val03, val13, val23, val33: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23, val30, val31, val32, val33: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
      self.val33 := val33;
    end;
    
    public static property Identity: Mtr4x4f read new Mtr4x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4f read new Vec4f(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    public property Row3: Vec4f read new Vec4f(self.val30, self.val31, self.val32, self.val33) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; self.val33 := value.val3; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4f read new Vec4f(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    public property Col3: Vec4f read new Vec4f(self.val03, self.val13, self.val23, self.val33) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; self.val33 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr2: ^Vec4f read pointer(@val02);
    public property ColPtr3: ^Vec4f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr4x4f := new Mtr4x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y, Z: single): Mtr4x4f := new Mtr4x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z, 0.0, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y, Z: single): Mtr4x4f := new Mtr4x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, Z, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x4f(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr4x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr4x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public function Det: single :=
    val00 * (val11 * (val21*val32 - val31*val22) - val12 * (val22*val33 - val32*val23) + val13 * (val21*val33 - val31*val23)) - val01 * (val10 * (val22*val33 - val32*val23) - val12 * (val20*val32 - val30*val22) + val13 * (val20*val33 - val30*val23)) + val02 * (val10 * (val21*val33 - val31*val23) - val11 * (val20*val33 - val30*val23) + val13 * (val20*val31 - val30*val21)) - val03 * (val10 * (val21*val32 - val31*val22) - val11 * (val20*val32 - val30*val22) + val12 * (val20*val31 - val30*val21));
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      ElStrs[3,3] := (Sign(val33)=-1?'-':'+') + Abs(val33).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x4f; v: Vec4f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2+m.val33*v.val3);
    public static function operator*(v: Vec4f; m: Mtr4x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2+m.val33*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
  end;
  Mtr4f = Mtr4x4f;
  
  Mtr2x3f = record
    public val00, val10: single;
    public val01, val11: single;
    public val02, val12: single;
    
    public constructor(val00, val01, val02, val10, val11, val12: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
    end;
    
    public static property Identity: Mtr2x3f read new Mtr2x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2f read new Vec2f(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr2: ^Vec2f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr2x3f := new Mtr2x3f(k, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y: single): Mtr2x3f := new Mtr2x3f(1.0, 0.0, X, 0.0, 1.0, Y);
    public static function TraslateTransposed(X: single): Mtr2x3f := new Mtr2x3f(1.0, 0.0, 0.0, X, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x3f; v: Vec3f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2);
    public static function operator*(v: Vec2f; m: Mtr2x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
  end;
  
  Mtr3x2f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    
    public constructor(val00, val01, val10, val11, val20, val21: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
    end;
    
    public static property Identity: Mtr3x2f read new Mtr3x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2f read new Vec2f(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr3x2f := new Mtr3x2f(k, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X: single): Mtr3x2f := new Mtr3x2f(1.0, X, 0.0, 1.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: single): Mtr3x2f := new Mtr3x2f(1.0, 0.0, 0.0, 1.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr3x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x2f(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x2f(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x2f; v: Vec2f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1);
    public static function operator*(v: Vec3f; m: Mtr3x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
  end;
  
  Mtr2x4f = record
    public val00, val10: single;
    public val01, val11: single;
    public val02, val12: single;
    public val03, val13: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
    end;
    
    public static property Identity: Mtr2x4f read new Mtr2x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    
    public property Col0: Vec2f read new Vec2f(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2f read new Vec2f(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2f read new Vec2f(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    public property Col3: Vec2f read new Vec2f(self.val03, self.val13) write begin self.val03 := value.val0; self.val13 := value.val1; end;
    
    public property ColPtr0: ^Vec2f read pointer(@val00);
    public property ColPtr1: ^Vec2f read pointer(@val01);
    public property ColPtr2: ^Vec2f read pointer(@val02);
    public property ColPtr3: ^Vec2f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec2f read pointer(IntPtr(pointer(@self)) + x*8);
    
    public procedure UseColPtr0(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec2fPtrCallbackP);
    type PVec2f = ^Vec2f;
    begin callback(PVec2f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec2fPtrCallbackF<T>): T;
    type PVec2f = ^Vec2f;
    begin Result := callback(PVec2f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr2x4f := new Mtr2x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X, Y: single): Mtr2x4f := new Mtr2x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y);
    public static function TraslateTransposed(X: single): Mtr2x4f := new Mtr2x4f(1.0, 0.0, 0.0, 0.0, X, 1.0, 0.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr2x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x4f; v: Vec4f): Vec2f := new Vec2f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3);
    public static function operator*(v: Vec2f; m: Mtr2x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1, m.val03*v.val0+m.val13*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr4x2f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    
    public constructor(val00, val01, val10, val11, val20, val21, val30, val31: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
      self.val30 := val30;
      self.val31 := val31;
    end;
    
    public static property Identity: Mtr4x2f read new Mtr4x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec2f read new Vec2f(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2f read new Vec2f(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2f read new Vec2f(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    public property Row3: Vec2f read new Vec2f(self.val30, self.val31) write begin self.val30 := value.val0; self.val31 := value.val1; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    
    public static function Scale(k: single): Mtr4x2f := new Mtr4x2f(k, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0);
    
    public static function Traslate(X: single): Mtr4x2f := new Mtr4x2f(1.0, X, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: single): Mtr4x2f := new Mtr4x2f(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr4x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x2f(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x2f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x2f(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x2f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x2f; v: Vec2f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1, m.val30*v.val0+m.val31*v.val1);
    public static function operator*(v: Vec4f; m: Mtr4x2f): Vec2f := new Vec2f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr3x4f = record
    public val00, val10, val20: single;
    public val01, val11, val21: single;
    public val02, val12, val22: single;
    public val03, val13, val23: single;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
    end;
    
    public static property Identity: Mtr3x4f read new Mtr3x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec4f read new Vec4f(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4f read new Vec4f(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4f read new Vec4f(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    
    public property Col0: Vec3f read new Vec3f(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3f read new Vec3f(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3f read new Vec3f(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    public property Col3: Vec3f read new Vec3f(self.val03, self.val13, self.val23) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; end;
    
    public property ColPtr0: ^Vec3f read pointer(@val00);
    public property ColPtr1: ^Vec3f read pointer(@val01);
    public property ColPtr2: ^Vec3f read pointer(@val02);
    public property ColPtr3: ^Vec3f read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec3f read pointer(IntPtr(pointer(@self)) + x*12);
    
    public procedure UseColPtr0(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec3fPtrCallbackP);
    type PVec3f = ^Vec3f;
    begin callback(PVec3f(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec3fPtrCallbackF<T>): T;
    type PVec3f = ^Vec3f;
    begin Result := callback(PVec3f(pointer(@val03))^); end;
    
    public static function Scale(k: single): Mtr3x4f := new Mtr3x4f(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y, Z: single): Mtr3x4f := new Mtr3x4f(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z);
    public static function TraslateTransposed(X, Y: single): Mtr3x4f := new Mtr3x4f(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x4f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr3x4f(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr3x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr3x4f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x4f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x4f; v: Vec4f): Vec3f := new Vec3f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3);
    public static function operator*(v: Vec3f; m: Mtr3x4f): Vec4f := new Vec4f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
  end;
  
  Mtr4x3f = record
    public val00, val10, val20, val30: single;
    public val01, val11, val21, val31: single;
    public val02, val12, val22, val32: single;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22, val30, val31, val32: single);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
    end;
    
    public static property Identity: Mtr4x3f read new Mtr4x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec3f read new Vec3f(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3f read new Vec3f(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3f read new Vec3f(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    public property Row3: Vec3f read new Vec3f(self.val30, self.val31, self.val32) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; end;
    
    public property Col0: Vec4f read new Vec4f(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4f read new Vec4f(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4f read new Vec4f(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    
    public property ColPtr0: ^Vec4f read pointer(@val00);
    public property ColPtr1: ^Vec4f read pointer(@val01);
    public property ColPtr2: ^Vec4f read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec4f read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4fPtrCallbackP);
    type PVec4f = ^Vec4f;
    begin callback(PVec4f(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4fPtrCallbackF<T>): T;
    type PVec4f = ^Vec4f;
    begin Result := callback(PVec4f(pointer(@val02))^); end;
    
    public static function Scale(k: single): Mtr4x3f := new Mtr4x3f(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0);
    
    public static function Traslate(X, Y: single): Mtr4x3f := new Mtr4x3f(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y, Z: single): Mtr4x3f := new Mtr4x3f(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, X, Y, Z);
    
    public static function RotateXYcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x3f;
    begin
      var sr: single := Sin(rot);
      var cr: single := Cos(rot);
      Result := new Mtr4x3f(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3f; rot: double): Mtr4x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3f; rot: double): Mtr4x3f;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x3f;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x3f; v: Vec3f): Vec4f := new Vec4f(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2);
    public static function operator*(v: Vec4f; m: Mtr4x3f): Vec3f := new Vec3f(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3f): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3f): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
  end;
  
  Mtr2x2d = record
    public val00, val10: double;
    public val01, val11: double;
    
    public constructor(val00, val01, val10, val11: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
    end;
    
    public static property Identity: Mtr2x2d read new Mtr2x2d(1.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr2x2d := new Mtr2x2d(k, 0.0, 0.0, k);
    
    public static function Traslate(X: double): Mtr2x2d := new Mtr2x2d(1.0, X, 0.0, 1.0);
    public static function TraslateTransposed(X: double): Mtr2x2d := new Mtr2x2d(1.0, 0.0, X, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr2x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x2d(
         cr, +sr,
        -sr,  cr
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x2d(
         cr, -sr,
        +sr,  cr
      );
    end;
    
    public function Det: double :=
    val00*val11 - val10*val01;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x2d; v: Vec2d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1);
    public static function operator*(v: Vec2d; m: Mtr2x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    public static function operator implicit(m: Mtr2x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
  end;
  Mtr2d = Mtr2x2d;
  
  Mtr3x3d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    public val02, val12, val22: double;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
    end;
    
    public static property Identity: Mtr3x3d read new Mtr3x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3d read new Vec3d(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3d read new Vec3d(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr2: ^Vec3d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr3x3d := new Mtr3x3d(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y: double): Mtr3x3d := new Mtr3x3d(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y: double): Mtr3x3d := new Mtr3x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x3d(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr3x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr3x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function Det: double :=
    val00 * (val11*val22 - val21*val12) - val01 * (val10*val22 - val20*val12) + val02 * (val10*val21 - val20*val11);
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x3d; v: Vec3d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2);
    public static function operator*(v: Vec3d; m: Mtr3x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    public static function operator implicit(m: Mtr3x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr3x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
  end;
  Mtr3d = Mtr3x3d;
  
  Mtr4x4d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    public val02, val12, val22, val32: double;
    public val03, val13, val23, val33: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23, val30, val31, val32, val33: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
      self.val33 := val33;
    end;
    
    public static property Identity: Mtr4x4d read new Mtr4x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4d read new Vec4d(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    public property Row3: Vec4d read new Vec4d(self.val30, self.val31, self.val32, self.val33) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; self.val33 := value.val3; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4d read new Vec4d(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    public property Col3: Vec4d read new Vec4d(self.val03, self.val13, self.val23, self.val33) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; self.val33 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr2: ^Vec4d read pointer(@val02);
    public property ColPtr3: ^Vec4d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr4x4d := new Mtr4x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k);
    
    public static function Traslate(X, Y, Z: double): Mtr4x4d := new Mtr4x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z, 0.0, 0.0, 0.0, 1.0);
    public static function TraslateTransposed(X, Y, Z: double): Mtr4x4d := new Mtr4x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, X, Y, Z, 1.0);
    
    public static function RotateXYcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x4d(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0,
        0.0, 0.0, 0.0, 1.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr4x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr4x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
      Result.val33 := 1;
    end;
    
    public function Det: double :=
    val00 * (val11 * (val21*val32 - val31*val22) - val12 * (val22*val33 - val32*val23) + val13 * (val21*val33 - val31*val23)) - val01 * (val10 * (val22*val33 - val32*val23) - val12 * (val20*val32 - val30*val22) + val13 * (val20*val33 - val30*val23)) + val02 * (val10 * (val21*val33 - val31*val23) - val11 * (val20*val33 - val30*val23) + val13 * (val20*val31 - val30*val21)) - val03 * (val10 * (val21*val32 - val31*val22) - val11 * (val20*val32 - val30*val22) + val12 * (val20*val31 - val30*val21));
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      ElStrs[3,3] := (Sign(val33)=-1?'-':'+') + Abs(val33).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x4d; v: Vec4d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2+m.val33*v.val3);
    public static function operator*(v: Vec4d; m: Mtr4x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2+m.val33*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, m.val30, m.val31, m.val32, m.val33);
    public static function operator implicit(m: Mtr4x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, m.val30, m.val31, m.val32, m.val33);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0, 0.0, 1.0);
    public static function operator implicit(m: Mtr4x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
  end;
  Mtr4d = Mtr4x4d;
  
  Mtr2x3d = record
    public val00, val10: double;
    public val01, val11: double;
    public val02, val12: double;
    
    public constructor(val00, val01, val02, val10, val11, val12: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
    end;
    
    public static property Identity: Mtr2x3d read new Mtr2x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2d read new Vec2d(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr2: ^Vec2d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr2x3d := new Mtr2x3d(k, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y: double): Mtr2x3d := new Mtr2x3d(1.0, 0.0, X, 0.0, 1.0, Y);
    public static function TraslateTransposed(X: double): Mtr2x3d := new Mtr2x3d(1.0, 0.0, 0.0, X, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x3d; v: Vec3d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2);
    public static function operator*(v: Vec2d; m: Mtr2x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    public static function operator implicit(m: Mtr2x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    public static function operator implicit(m: Mtr2x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
  end;
  
  Mtr3x2d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    
    public constructor(val00, val01, val10, val11, val20, val21: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
    end;
    
    public static property Identity: Mtr3x2d read new Mtr3x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2d read new Vec2d(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr3x2d := new Mtr3x2d(k, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X: double): Mtr3x2d := new Mtr3x2d(1.0, X, 0.0, 1.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: double): Mtr3x2d := new Mtr3x2d(1.0, 0.0, 0.0, 1.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr3x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x2d(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x2d(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x2d; v: Vec2d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1);
    public static function operator*(v: Vec3d; m: Mtr3x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    public static function operator implicit(m: Mtr3x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr3x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
  end;
  
  Mtr2x4d = record
    public val00, val10: double;
    public val01, val11: double;
    public val02, val12: double;
    public val03, val13: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
    end;
    
    public static property Identity: Mtr2x4d read new Mtr2x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    
    public property Col0: Vec2d read new Vec2d(self.val00, self.val10) write begin self.val00 := value.val0; self.val10 := value.val1; end;
    public property Col1: Vec2d read new Vec2d(self.val01, self.val11) write begin self.val01 := value.val0; self.val11 := value.val1; end;
    public property Col2: Vec2d read new Vec2d(self.val02, self.val12) write begin self.val02 := value.val0; self.val12 := value.val1; end;
    public property Col3: Vec2d read new Vec2d(self.val03, self.val13) write begin self.val03 := value.val0; self.val13 := value.val1; end;
    
    public property ColPtr0: ^Vec2d read pointer(@val00);
    public property ColPtr1: ^Vec2d read pointer(@val01);
    public property ColPtr2: ^Vec2d read pointer(@val02);
    public property ColPtr3: ^Vec2d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec2d read pointer(IntPtr(pointer(@self)) + x*16);
    
    public procedure UseColPtr0(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec2dPtrCallbackP);
    type PVec2d = ^Vec2d;
    begin callback(PVec2d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec2dPtrCallbackF<T>): T;
    type PVec2d = ^Vec2d;
    begin Result := callback(PVec2d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr2x4d := new Mtr2x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0);
    
    public static function Traslate(X, Y: double): Mtr2x4d := new Mtr2x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y);
    public static function TraslateTransposed(X: double): Mtr2x4d := new Mtr2x4d(1.0, 0.0, 0.0, 0.0, X, 1.0, 0.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr2x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr2x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr2x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[2,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr2x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr2x4d; v: Vec4d): Vec2d := new Vec2d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3);
    public static function operator*(v: Vec2d; m: Mtr2x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1, m.val01*v.val0+m.val11*v.val1, m.val02*v.val0+m.val12*v.val1, m.val03*v.val0+m.val13*v.val1);
    
    public static function operator implicit(m: Mtr2x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    public static function operator implicit(m: Mtr2x4d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    public static function operator implicit(m: Mtr2x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr4x2d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    
    public constructor(val00, val01, val10, val11, val20, val21, val30, val31: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val10 := val10;
      self.val11 := val11;
      self.val20 := val20;
      self.val21 := val21;
      self.val30 := val30;
      self.val31 := val31;
    end;
    
    public static property Identity: Mtr4x2d read new Mtr4x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec2d read new Vec2d(self.val00, self.val01) write begin self.val00 := value.val0; self.val01 := value.val1; end;
    public property Row1: Vec2d read new Vec2d(self.val10, self.val11) write begin self.val10 := value.val0; self.val11 := value.val1; end;
    public property Row2: Vec2d read new Vec2d(self.val20, self.val21) write begin self.val20 := value.val0; self.val21 := value.val1; end;
    public property Row3: Vec2d read new Vec2d(self.val30, self.val31) write begin self.val30 := value.val0; self.val31 := value.val1; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    
    public static function Scale(k: double): Mtr4x2d := new Mtr4x2d(k, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0);
    
    public static function Traslate(X: double): Mtr4x2d := new Mtr4x2d(1.0, X, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y: double): Mtr4x2d := new Mtr4x2d(1.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y);
    
    public static function RotateXYcw(rot: double): Mtr4x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x2d(
         cr, +sr,
        -sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x2d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x2d(
         cr, -sr,
        +sr,  cr,
        0.0, 0.0,
        0.0, 0.0
      );
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,2];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*2 + 4; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x2d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x2d; v: Vec2d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1, m.val10*v.val0+m.val11*v.val1, m.val20*v.val0+m.val21*v.val1, m.val30*v.val0+m.val31*v.val1);
    public static function operator*(v: Vec4d; m: Mtr4x2d): Vec2d := new Vec2d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0);
    
    public static function operator implicit(m: Mtr4x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    public static function operator implicit(m: Mtr4x2d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0, m.val30, m.val31, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0);
    
    public static function operator implicit(m: Mtr3x2d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x2d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0);
    
  end;
  
  Mtr3x4d = record
    public val00, val10, val20: double;
    public val01, val11, val21: double;
    public val02, val12, val22: double;
    public val03, val13, val23: double;
    
    public constructor(val00, val01, val02, val03, val10, val11, val12, val13, val20, val21, val22, val23: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val03 := val03;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val13 := val13;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val23 := val23;
    end;
    
    public static property Identity: Mtr3x4d read new Mtr3x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    
    public property Row0: Vec4d read new Vec4d(self.val00, self.val01, self.val02, self.val03) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; self.val03 := value.val3; end;
    public property Row1: Vec4d read new Vec4d(self.val10, self.val11, self.val12, self.val13) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; self.val13 := value.val3; end;
    public property Row2: Vec4d read new Vec4d(self.val20, self.val21, self.val22, self.val23) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; self.val23 := value.val3; end;
    
    public property Col0: Vec3d read new Vec3d(self.val00, self.val10, self.val20) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; end;
    public property Col1: Vec3d read new Vec3d(self.val01, self.val11, self.val21) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; end;
    public property Col2: Vec3d read new Vec3d(self.val02, self.val12, self.val22) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; end;
    public property Col3: Vec3d read new Vec3d(self.val03, self.val13, self.val23) write begin self.val03 := value.val0; self.val13 := value.val1; self.val23 := value.val2; end;
    
    public property ColPtr0: ^Vec3d read pointer(@val00);
    public property ColPtr1: ^Vec3d read pointer(@val01);
    public property ColPtr2: ^Vec3d read pointer(@val02);
    public property ColPtr3: ^Vec3d read pointer(@val03);
    public property ColPtr[x: integer]: ^Vec3d read pointer(IntPtr(pointer(@self)) + x*24);
    
    public procedure UseColPtr0(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val02))^); end;
    public procedure UseColPtr3(callback: UseVec3dPtrCallbackP);
    type PVec3d = ^Vec3d;
    begin callback(PVec3d(pointer(@val03))^); end;
    
    public function UseColPtr0<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val02))^); end;
    public function UseColPtr3<T>(callback: UseVec3dPtrCallbackF<T>): T;
    type PVec3d = ^Vec3d;
    begin Result := callback(PVec3d(pointer(@val03))^); end;
    
    public static function Scale(k: double): Mtr3x4d := new Mtr3x4d(k, 0.0, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, 0.0, k, 0.0);
    
    public static function Traslate(X, Y, Z: double): Mtr3x4d := new Mtr3x4d(1.0, 0.0, 0.0, X, 0.0, 1.0, 0.0, Y, 0.0, 0.0, 1.0, Z);
    public static function TraslateTransposed(X, Y: double): Mtr3x4d := new Mtr3x4d(1.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, X, Y, 1.0, 0.0);
    
    public static function RotateXYcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, +sr, 0.0, 0.0,
        -sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, -sr, 0.0, 0.0,
        +sr,  cr, 0.0, 0.0,
        0.0, 0.0, 1.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, +sr, 0.0,
        0.0, -sr,  cr, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
        1.0, 0.0, 0.0, 0.0,
        0.0,  cr, -sr, 0.0,
        0.0, +sr,  cr, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, 0.0, -sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        +sr, 0.0,  cr, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr3x4d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr3x4d(
         cr, 0.0, +sr, 0.0,
        0.0, 1.0, 0.0, 0.0,
        -sr, 0.0,  cr, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr3x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr3x4d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[3,4];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[0,3] := (Sign(val03)=-1?'-':'+') + Abs(val03).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[1,3] := (Sign(val13)=-1?'-':'+') + Abs(val13).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[2,3] := (Sign(val23)=-1?'-':'+') + Abs(val23).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*4 + 8; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,3].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr3x4d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr3x4d; v: Vec4d): Vec3d := new Vec3d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2+m.val03*v.val3, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2+m.val13*v.val3, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2+m.val23*v.val3);
    public static function operator*(v: Vec3d; m: Mtr3x4d): Vec4d := new Vec4d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2, m.val03*v.val0+m.val13*v.val1+m.val23*v.val2);
    
    public static function operator implicit(m: Mtr2x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr3x4f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    
    public static function operator implicit(m: Mtr4x3f): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    
    public static function operator implicit(m: Mtr2x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23);
    public static function operator implicit(m: Mtr3x4d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, m.val20, m.val21, m.val22, m.val23, 0.0, 0.0, 0.0, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13, 0.0, 0.0, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, m.val03, m.val10, m.val11, m.val12, m.val13);
    
    public static function operator implicit(m: Mtr4x2d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, 0.0, 0.0, m.val10, m.val11, 0.0, 0.0, m.val20, m.val21, 1.0, 0.0);
    public static function operator implicit(m: Mtr3x4d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, 0.0, 0.0);
    
  end;
  
  Mtr4x3d = record
    public val00, val10, val20, val30: double;
    public val01, val11, val21, val31: double;
    public val02, val12, val22, val32: double;
    
    public constructor(val00, val01, val02, val10, val11, val12, val20, val21, val22, val30, val31, val32: double);
    begin
      self.val00 := val00;
      self.val01 := val01;
      self.val02 := val02;
      self.val10 := val10;
      self.val11 := val11;
      self.val12 := val12;
      self.val20 := val20;
      self.val21 := val21;
      self.val22 := val22;
      self.val30 := val30;
      self.val31 := val31;
      self.val32 := val32;
    end;
    
    public static property Identity: Mtr4x3d read new Mtr4x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    
    public property Row0: Vec3d read new Vec3d(self.val00, self.val01, self.val02) write begin self.val00 := value.val0; self.val01 := value.val1; self.val02 := value.val2; end;
    public property Row1: Vec3d read new Vec3d(self.val10, self.val11, self.val12) write begin self.val10 := value.val0; self.val11 := value.val1; self.val12 := value.val2; end;
    public property Row2: Vec3d read new Vec3d(self.val20, self.val21, self.val22) write begin self.val20 := value.val0; self.val21 := value.val1; self.val22 := value.val2; end;
    public property Row3: Vec3d read new Vec3d(self.val30, self.val31, self.val32) write begin self.val30 := value.val0; self.val31 := value.val1; self.val32 := value.val2; end;
    
    public property Col0: Vec4d read new Vec4d(self.val00, self.val10, self.val20, self.val30) write begin self.val00 := value.val0; self.val10 := value.val1; self.val20 := value.val2; self.val30 := value.val3; end;
    public property Col1: Vec4d read new Vec4d(self.val01, self.val11, self.val21, self.val31) write begin self.val01 := value.val0; self.val11 := value.val1; self.val21 := value.val2; self.val31 := value.val3; end;
    public property Col2: Vec4d read new Vec4d(self.val02, self.val12, self.val22, self.val32) write begin self.val02 := value.val0; self.val12 := value.val1; self.val22 := value.val2; self.val32 := value.val3; end;
    
    public property ColPtr0: ^Vec4d read pointer(@val00);
    public property ColPtr1: ^Vec4d read pointer(@val01);
    public property ColPtr2: ^Vec4d read pointer(@val02);
    public property ColPtr[x: integer]: ^Vec4d read pointer(IntPtr(pointer(@self)) + x*32);
    
    public procedure UseColPtr0(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val00))^); end;
    public procedure UseColPtr1(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val01))^); end;
    public procedure UseColPtr2(callback: UseVec4dPtrCallbackP);
    type PVec4d = ^Vec4d;
    begin callback(PVec4d(pointer(@val02))^); end;
    
    public function UseColPtr0<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val00))^); end;
    public function UseColPtr1<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val01))^); end;
    public function UseColPtr2<T>(callback: UseVec4dPtrCallbackF<T>): T;
    type PVec4d = ^Vec4d;
    begin Result := callback(PVec4d(pointer(@val02))^); end;
    
    public static function Scale(k: double): Mtr4x3d := new Mtr4x3d(k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0, k, 0.0, 0.0, 0.0);
    
    public static function Traslate(X, Y: double): Mtr4x3d := new Mtr4x3d(1.0, 0.0, X, 0.0, 1.0, Y, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function TraslateTransposed(X, Y, Z: double): Mtr4x3d := new Mtr4x3d(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, X, Y, Z);
    
    public static function RotateXYcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, +sr, 0.0,
        -sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateXYccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, -sr, 0.0,
        +sr,  cr, 0.0,
        0.0, 0.0, 1.0,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateYZcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, +sr,
        0.0, -sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateYZccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
        1.0, 0.0, 0.0,
        0.0,  cr, -sr,
        0.0, +sr,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function RotateZXcw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, 0.0, -sr,
        0.0, 1.0, 0.0,
        +sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    public static function RotateZXccw(rot: double): Mtr4x3d;
    begin
      var sr: double := Sin(rot);
      var cr: double := Cos(rot);
      Result := new Mtr4x3d(
         cr, 0.0, +sr,
        0.0, 1.0, 0.0,
        -sr, 0.0,  cr,
        0.0, 0.0, 0.0
      );
    end;
    
    public static function Rotate3Dcw(u: Vec3d; rot: double): Mtr4x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := -k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := -k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := -k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public static function Rotate3Dccw(u: Vec3d; rot: double): Mtr4x3d;
    begin
      var k1 := Sin(rot);
      var k2 := 2*Sqr(Sin(rot/2));
      
      Result.val00 := 1 + k2*( -u.val2*u.val2 - u.val1*u.val1 );
      Result.val01 := -k1*u.val2 + k2*( u.val1*u.val0 );
      Result.val02 := k1*u.val1 + k2*( u.val2*u.val0 );
      Result.val10 := k1*u.val2 + k2*( u.val0*u.val1 );
      Result.val11 := 1 + k2*( -u.val2*u.val2 - u.val0*u.val0 );
      Result.val12 := -k1*u.val0 + k2*( u.val2*u.val1 );
      Result.val20 := -k1*u.val1 + k2*( u.val0*u.val2 );
      Result.val21 := k1*u.val0 + k2*( u.val1*u.val2 );
      Result.val22 := 1 + k2*( -u.val1*u.val1 - u.val0*u.val0 );
      
    end;
    
    public function ToString: string; override;
    begin
      var res := new StringBuilder;
      
      var ElStrs := new string[4,3];
      ElStrs[0,0] := (Sign(val00)=-1?'-':'+') + Abs(val00).ToString('f2');
      ElStrs[0,1] := (Sign(val01)=-1?'-':'+') + Abs(val01).ToString('f2');
      ElStrs[0,2] := (Sign(val02)=-1?'-':'+') + Abs(val02).ToString('f2');
      ElStrs[1,0] := (Sign(val10)=-1?'-':'+') + Abs(val10).ToString('f2');
      ElStrs[1,1] := (Sign(val11)=-1?'-':'+') + Abs(val11).ToString('f2');
      ElStrs[1,2] := (Sign(val12)=-1?'-':'+') + Abs(val12).ToString('f2');
      ElStrs[2,0] := (Sign(val20)=-1?'-':'+') + Abs(val20).ToString('f2');
      ElStrs[2,1] := (Sign(val21)=-1?'-':'+') + Abs(val21).ToString('f2');
      ElStrs[2,2] := (Sign(val22)=-1?'-':'+') + Abs(val22).ToString('f2');
      ElStrs[3,0] := (Sign(val30)=-1?'-':'+') + Abs(val30).ToString('f2');
      ElStrs[3,1] := (Sign(val31)=-1?'-':'+') + Abs(val31).ToString('f2');
      ElStrs[3,2] := (Sign(val32)=-1?'-':'+') + Abs(val32).ToString('f2');
      var MtrElTextW := ElStrs.OfType&<string>.Max(s->s.Length);
      var PrintlnMtrW := MtrElTextW*3 + 6; // +2*(Width-1) + 2;
      
      res += '┌';
      res.Append(#32, PrintlnMtrW);
      res += '┐'#10;
      res += '│ ';
      res += ElStrs[0,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[0,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[1,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[1,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[2,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[2,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '│ ';
      res += ElStrs[3,0].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,1].PadLeft(MtrElTextW);
      res += ', ';
      res += ElStrs[3,2].PadLeft(MtrElTextW);
      res += ' │'#10;
      res += '└';
      res.Append(#32, PrintlnMtrW);
      res += '┘';
      
      Result := res.ToString;
    end;
    
    public function Println: Mtr4x3d;
    begin
      Writeln(self.ToString);
      Result := self;
    end;
    
    public static function operator*(m: Mtr4x3d; v: Vec3d): Vec4d := new Vec4d(m.val00*v.val0+m.val01*v.val1+m.val02*v.val2, m.val10*v.val0+m.val11*v.val1+m.val12*v.val2, m.val20*v.val0+m.val21*v.val1+m.val22*v.val2, m.val30*v.val0+m.val31*v.val1+m.val32*v.val2);
    public static function operator*(v: Vec4d; m: Mtr4x3d): Vec3d := new Vec3d(m.val00*v.val0+m.val10*v.val1+m.val20*v.val2+m.val30*v.val3, m.val01*v.val0+m.val11*v.val1+m.val21*v.val2+m.val31*v.val3, m.val02*v.val0+m.val12*v.val1+m.val22*v.val2+m.val32*v.val3);
    
    public static function operator implicit(m: Mtr2x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x2f := new Mtr2x2f(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x3f := new Mtr3x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x4f := new Mtr4x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x3f := new Mtr2x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x2f := new Mtr3x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x4f := new Mtr2x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr4x2f := new Mtr4x2f(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x4f := new Mtr3x4f(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
    public static function operator implicit(m: Mtr4x3f): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x3f := new Mtr4x3f(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    
    public static function operator implicit(m: Mtr2x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x2d := new Mtr2x2d(m.val00, m.val01, m.val10, m.val11);
    
    public static function operator implicit(m: Mtr3x3d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x3d := new Mtr3x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22);
    
    public static function operator implicit(m: Mtr4x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, m.val30, m.val31, m.val32);
    public static function operator implicit(m: Mtr4x3d): Mtr4x4d := new Mtr4x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0, m.val30, m.val31, m.val32, 1.0);
    
    public static function operator implicit(m: Mtr2x3d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x3d := new Mtr2x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12);
    
    public static function operator implicit(m: Mtr3x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x2d := new Mtr3x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21);
    
    public static function operator implicit(m: Mtr2x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr2x4d := new Mtr2x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0);
    
    public static function operator implicit(m: Mtr4x2d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, 0.0, m.val10, m.val11, 0.0, m.val20, m.val21, 1.0, m.val30, m.val31, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr4x2d := new Mtr4x2d(m.val00, m.val01, m.val10, m.val11, m.val20, m.val21, m.val30, m.val31);
    
    public static function operator implicit(m: Mtr3x4d): Mtr4x3d := new Mtr4x3d(m.val00, m.val01, m.val02, m.val10, m.val11, m.val12, m.val20, m.val21, m.val22, 0.0, 0.0, 0.0);
    public static function operator implicit(m: Mtr4x3d): Mtr3x4d := new Mtr3x4d(m.val00, m.val01, m.val02, 0.0, m.val10, m.val11, m.val12, 0.0, m.val20, m.val21, m.val22, 0.0);
    
  end;
  
  {$endregion Mtr}
  
  {$region Misc}
  
  Fixed = record
    public val: UInt32;
    
    public constructor(val: UInt32);
    begin
      self.val := val;
    end;
    
  end;
  
  GDI_COLORREF = record
    private a: byte := 0;
    public r: byte;
    public g: byte;
    public b: byte;
    
    public constructor(r: byte; g: byte; b: byte);
    begin
      self.r := r;
      self.g := g;
      self.b := b;
    end;
    
  end;
  
  GDI_GlyphmetricsFloat = record
    public gmfBlackBoxX: single;
    public gmfBlackBoxY: single;
    public gmfptGlyphOriginX: single;
    public gmfptGlyphOriginY: single;
    public gmfCellIncX: single;
    public gmfCellIncY: single;
    
    public constructor(gmfBlackBoxX: single; gmfBlackBoxY: single; gmfptGlyphOriginX: single; gmfptGlyphOriginY: single; gmfCellIncX: single; gmfCellIncY: single);
    begin
      self.gmfBlackBoxX := gmfBlackBoxX;
      self.gmfBlackBoxY := gmfBlackBoxY;
      self.gmfptGlyphOriginX := gmfptGlyphOriginX;
      self.gmfptGlyphOriginY := gmfptGlyphOriginY;
      self.gmfCellIncX := gmfCellIncX;
      self.gmfCellIncY := gmfCellIncY;
    end;
    
  end;
  
  GDI_PixelFormatDescriptor = record
    private nSize: UInt16 := sizeof(GDI_PixelFormatDescriptor);
    public nVersion: UInt16 := 1;
    
    public dwFlags: PixelFormatFlagsGDI;
    public iPixelType: PixelDataTypeGDI;
    
    public cColorBits: Byte; // Кол-во бит для R+G+B
    public cRedBits: Byte; // Если оставить эти 6 нулями - их заполнит автоматически
    public cRedShift: Byte;
    public cGreenBits: Byte;
    public cGreenShift: Byte;
    public cBlueBits: Byte;
    public cBlueShift: Byte;
    public cAlphaBits: Byte; // Последние 2 не работают на Windows
    public cAlphaShift: Byte;
    
    public cAccumBits: Byte;
    public cAccumRedBits: Byte;
    public cAccumGreenBits: Byte;
    public cAccumBlueBits: Byte;
    public cAccumAlphaBits: Byte;
    
    public cDepthBits: Byte;
    public cStencilBits: Byte;
    public cAuxBuffers: Byte; // Устарело
    
    public iLayerType: Byte; // Устарело
    public bLayersSize: Byte; // Устарело
    
    public dwLayerMask: UInt32; // Не могу найти нормальное описание последних 3, но все оставляют их нулями
    public dwVisibleMask: UInt32;
    public dwDamageMask: UInt32;
    
    public constructor(dwFlags: PixelFormatFlagsGDI; iPixelType: PixelDataTypeGDI; cColorBits: Byte; cRedBits: Byte; cRedShift: Byte; cGreenBits: Byte; cGreenShift: Byte; cBlueBits: Byte; cBlueShift: Byte; cAlphaBits: Byte; cAlphaShift: Byte; cAccumBits: Byte; cAccumRedBits: Byte; cAccumGreenBits: Byte; cAccumBlueBits: Byte; cAccumAlphaBits: Byte; cDepthBits: Byte; cStencilBits: Byte; cAuxBuffers: Byte; iLayerType: Byte; bLayersSize: Byte; dwLayerMask: UInt32; dwVisibleMask: UInt32; dwDamageMask: UInt32);
    begin
      self.dwFlags := dwFlags;
      self.iPixelType := iPixelType;
      self.cColorBits := cColorBits;
      self.cRedBits := cRedBits;
      self.cRedShift := cRedShift;
      self.cGreenBits := cGreenBits;
      self.cGreenShift := cGreenShift;
      self.cBlueBits := cBlueBits;
      self.cBlueShift := cBlueShift;
      self.cAlphaBits := cAlphaBits;
      self.cAlphaShift := cAlphaShift;
      self.cAccumBits := cAccumBits;
      self.cAccumRedBits := cAccumRedBits;
      self.cAccumGreenBits := cAccumGreenBits;
      self.cAccumBlueBits := cAccumBlueBits;
      self.cAccumAlphaBits := cAccumAlphaBits;
      self.cDepthBits := cDepthBits;
      self.cStencilBits := cStencilBits;
      self.cAuxBuffers := cAuxBuffers;
      self.iLayerType := iLayerType;
      self.bLayersSize := bLayersSize;
      self.dwLayerMask := dwLayerMask;
      self.dwVisibleMask := dwVisibleMask;
      self.dwDamageMask := dwDamageMask;
    end;
    
  end;
  
  Half = record
    public val: UInt16;
    
    public constructor(val: UInt16);
    begin
      self.val := val;
    end;
    
  end;
  
  {$endregion Misc}
  
{$endregion Записи}

type
  
  gl = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    // added in gl4.1
    private z_ActiveShaderProgram_adr := GetFuncAdr('glActiveShaderProgram');
    private z_ActiveShaderProgram_ovr_0 := GetFuncOrNil&<procedure(pipeline: ProgramPipelineName; &program: ProgramName)>(z_ActiveShaderProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveShaderProgram(pipeline: ProgramPipelineName; &program: ProgramName) :=
    z_ActiveShaderProgram_ovr_0(pipeline, &program);
    
    // added in gl1.3
    private z_ActiveTexture_adr := GetFuncAdr('glActiveTexture');
    private z_ActiveTexture_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit)>(z_ActiveTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveTexture(texture: TextureUnit) :=
    z_ActiveTexture_ovr_0(texture);
    
    // added in gl2.0
    private z_AttachShader_adr := GetFuncAdr('glAttachShader');
    private z_AttachShader_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; shader: ShaderName)>(z_AttachShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AttachShader(&program: ProgramName; shader: ShaderName) :=
    z_AttachShader_ovr_0(&program, shader);
    
    // added in gl3.0
    private z_BeginConditionalRender_adr := GetFuncAdr('glBeginConditionalRender');
    private z_BeginConditionalRender_ovr_0 := GetFuncOrNil&<procedure(id: UInt32; mode: ConditionalRenderMode)>(z_BeginConditionalRender_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRender(id: UInt32; mode: ConditionalRenderMode) :=
    z_BeginConditionalRender_ovr_0(id, mode);
    
    // added in gl1.5
    private z_BeginQuery_adr := GetFuncAdr('glBeginQuery');
    private z_BeginQuery_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; id: QueryName)>(z_BeginQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQuery(target: QueryTarget; id: QueryName) :=
    z_BeginQuery_ovr_0(target, id);
    
    // added in gl4.0
    private z_BeginQueryIndexed_adr := GetFuncAdr('glBeginQueryIndexed');
    private z_BeginQueryIndexed_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; index: UInt32; id: QueryName)>(z_BeginQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryIndexed(target: QueryTarget; index: UInt32; id: QueryName) :=
    z_BeginQueryIndexed_ovr_0(target, index, id);
    
    // added in gl3.0
    private z_BeginTransformFeedback_adr := GetFuncAdr('glBeginTransformFeedback');
    private z_BeginTransformFeedback_ovr_0 := GetFuncOrNil&<procedure(primitiveMode: PrimitiveType)>(z_BeginTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedback(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedback_ovr_0(primitiveMode);
    
    // added in gl2.0
    private z_BindAttribLocation_adr := GetFuncAdr('glBindAttribLocation');
    private z_BindAttribLocation_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; index: UInt32; name: IntPtr)>(z_BindAttribLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocation(&program: ProgramName; index: UInt32; name: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindAttribLocation_ovr_0(&program, index, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocation(&program: ProgramName; index: UInt32; name: IntPtr) :=
    z_BindAttribLocation_ovr_0(&program, index, name);
    
    // added in gl1.5
    private z_BindBuffer_adr := GetFuncAdr('glBindBuffer');
    private z_BindBuffer_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; buffer: BufferName)>(z_BindBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffer(target: BufferTargetARB; buffer: BufferName) :=
    z_BindBuffer_ovr_0(target, buffer);
    
    // added in gl3.0
    private z_BindBufferBase_adr := GetFuncAdr('glBindBufferBase');
    private z_BindBufferBase_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; index: UInt32; buffer: BufferName)>(z_BindBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBase(target: BufferTargetARB; index: UInt32; buffer: BufferName) :=
    z_BindBufferBase_ovr_0(target, index, buffer);
    
    // added in gl3.0
    private z_BindBufferRange_adr := GetFuncAdr('glBindBufferRange');
    private z_BindBufferRange_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr)>(z_BindBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRange(target: BufferTargetARB; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRange_ovr_0(target, index, buffer, offset, size);
    
    // added in gl4.4
    private z_BindBuffersBase_adr := GetFuncAdr('glBindBuffersBase');
    private z_BindBuffersBase_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32)>(z_BindBuffersBase_adr);
    private z_BindBuffersBase_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersBase_ovr_0(target, first, count, buffers[0]) else
      z_BindBuffersBase_ovr_0_anh00001(target, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32) :=
    z_BindBuffersBase_ovr_0(target, first, count, buffers);
    private z_BindBuffersBase_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr)>(z_BindBuffersBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr) :=
    z_BindBuffersBase_ovr_2(target, first, count, buffers);
    
    // added in gl4.4
    private z_BindBuffersRange_adr := GetFuncAdr('glBindBuffersRange');
    private z_BindBuffersRange_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000110 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000101 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000011 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_0_anh0000111 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000111(target, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_1_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_1_anh0000110 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_2_anh0000110 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_3_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_3_anh0000101 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_4_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_5_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_6 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_6_anh0000101 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindBuffersRange_ovr_7_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_8 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_8_anh0000100 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_8(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_8_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private z_BindBuffersRange_ovr_9_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_9_anh0000011 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_10_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_11_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_12_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_15_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_8(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_18 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_18_anh0000011 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindBuffersRange_ovr_19_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_20 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_20_anh0000010 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_20_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private z_BindBuffersRange_ovr_21_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_24 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr)>(z_BindBuffersRange_adr);
    private z_BindBuffersRange_ovr_24_anh0000001 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_24_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes);
    private z_BindBuffersRange_ovr_26 := GetFuncOrNil&<procedure(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer)>(z_BindBuffersRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_26(target, first, count, buffers, offsets, sizes);
    
    // added in gl3.0
    private z_BindFragDataLocation_adr := GetFuncAdr('glBindFragDataLocation');
    private z_BindFragDataLocation_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; color: UInt32; name: IntPtr)>(z_BindFragDataLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocation(&program: ProgramName; color: UInt32; name: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindFragDataLocation_ovr_0(&program, color, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocation(&program: ProgramName; color: UInt32; name: IntPtr) :=
    z_BindFragDataLocation_ovr_0(&program, color, name);
    
    // added in gl3.3
    private z_BindFragDataLocationIndexed_adr := GetFuncAdr('glBindFragDataLocationIndexed');
    private z_BindFragDataLocationIndexed_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: IntPtr)>(z_BindFragDataLocationIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: IntPtr) :=
    z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, name);
    
    // added in gl3.0
    private z_BindFramebuffer_adr := GetFuncAdr('glBindFramebuffer');
    private z_BindFramebuffer_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; framebuffer: FramebufferName)>(z_BindFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebuffer(target: FramebufferTarget; framebuffer: FramebufferName) :=
    z_BindFramebuffer_ovr_0(target, framebuffer);
    
    // added in gl4.2
    private z_BindImageTexture_adr := GetFuncAdr('glBindImageTexture');
    private z_BindImageTexture_ovr_0 := GetFuncOrNil&<procedure(&unit: UInt32; texture: TextureName; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat)>(z_BindImageTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTexture(&unit: UInt32; texture: TextureName; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat) :=
    z_BindImageTexture_ovr_0(&unit, texture, level, layered, layer, access, format);
    
    // added in gl4.4
    private z_BindImageTextures_adr := GetFuncAdr('glBindImageTextures');
    private z_BindImageTextures_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var textures: UInt32)>(z_BindImageTextures_adr);
    private z_BindImageTextures_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindImageTextures_ovr_0(first, count, textures[0]) else
      z_BindImageTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; var textures: UInt32) :=
    z_BindImageTextures_ovr_0(first, count, textures);
    private z_BindImageTextures_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindImageTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindImageTextures_ovr_2(first, count, textures);
    
    // added in gl4.1
    private z_BindProgramPipeline_adr := GetFuncAdr('glBindProgramPipeline');
    private z_BindProgramPipeline_ovr_0 := GetFuncOrNil&<procedure(pipeline: ProgramPipelineName)>(z_BindProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramPipeline(pipeline: ProgramPipelineName) :=
    z_BindProgramPipeline_ovr_0(pipeline);
    
    // added in gl3.0
    private z_BindRenderbuffer_adr := GetFuncAdr('glBindRenderbuffer');
    private z_BindRenderbuffer_ovr_0 := GetFuncOrNil&<procedure(target: RenderbufferTarget; renderbuffer: RenderbufferName)>(z_BindRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbuffer(target: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_BindRenderbuffer_ovr_0(target, renderbuffer);
    
    // added in gl3.3
    private z_BindSampler_adr := GetFuncAdr('glBindSampler');
    private z_BindSampler_ovr_0 := GetFuncOrNil&<procedure(&unit: UInt32; sampler: SamplerName)>(z_BindSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSampler(&unit: UInt32; sampler: SamplerName) :=
    z_BindSampler_ovr_0(&unit, sampler);
    
    // added in gl4.4
    private z_BindSamplers_adr := GetFuncAdr('glBindSamplers');
    private z_BindSamplers_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var samplers: UInt32)>(z_BindSamplers_adr);
    private z_BindSamplers_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_BindSamplers_ovr_0(first, count, samplers[0]) else
      z_BindSamplers_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; var samplers: UInt32) :=
    z_BindSamplers_ovr_0(first, count, samplers);
    private z_BindSamplers_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; samplers: IntPtr)>(z_BindSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: IntPtr) :=
    z_BindSamplers_ovr_2(first, count, samplers);
    
    // added in gl1.1
    private static procedure z_BindTexture_ovr_0(target: TextureTarget; texture: TextureName);
    external 'opengl32.dll' name 'glBindTexture';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTexture(target: TextureTarget; texture: TextureName) :=
    z_BindTexture_ovr_0(target, texture);
    
    // added in gl4.4
    private z_BindTextures_adr := GetFuncAdr('glBindTextures');
    private z_BindTextures_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var textures: UInt32)>(z_BindTextures_adr);
    private z_BindTextures_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindTextures_ovr_0(first, count, textures[0]) else
      z_BindTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; var textures: UInt32) :=
    z_BindTextures_ovr_0(first, count, textures);
    private z_BindTextures_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; textures: IntPtr)>(z_BindTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindTextures_ovr_2(first, count, textures);
    
    // added in gl4.5
    private z_BindTextureUnit_adr := GetFuncAdr('glBindTextureUnit');
    private z_BindTextureUnit_ovr_0 := GetFuncOrNil&<procedure(&unit: UInt32; texture: TextureName)>(z_BindTextureUnit_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureUnit(&unit: UInt32; texture: TextureName) :=
    z_BindTextureUnit_ovr_0(&unit, texture);
    
    // added in gl4.0
    private z_BindTransformFeedback_adr := GetFuncAdr('glBindTransformFeedback');
    private z_BindTransformFeedback_ovr_0 := GetFuncOrNil&<procedure(target: BindTransformFeedbackTarget; id: TransformFeedbackName)>(z_BindTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedback(target: BindTransformFeedbackTarget; id: TransformFeedbackName) :=
    z_BindTransformFeedback_ovr_0(target, id);
    
    // added in gl3.0
    private z_BindVertexArray_adr := GetFuncAdr('glBindVertexArray');
    private z_BindVertexArray_ovr_0 := GetFuncOrNil&<procedure(&array: VertexArrayName)>(z_BindVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArray(&array: VertexArrayName) :=
    z_BindVertexArray_ovr_0(&array);
    
    // added in gl4.3
    private z_BindVertexBuffer_adr := GetFuncAdr('glBindVertexBuffer');
    private z_BindVertexBuffer_ovr_0 := GetFuncOrNil&<procedure(bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32)>(z_BindVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffer(bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32) :=
    z_BindVertexBuffer_ovr_0(bindingindex, buffer, offset, stride);
    
    // added in gl4.4
    private z_BindVertexBuffers_adr := GetFuncAdr('glBindVertexBuffers');
    private z_BindVertexBuffers_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000110 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000101 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000011 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_0_anh000111 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000111(first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_1_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_1_anh000110 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_2_anh000110 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_3_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_3_anh000101 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_4_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_5_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_6 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_6_anh000101 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_7_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_8 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_8_anh000100 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_8(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_8_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private z_BindVertexBuffers_ovr_9_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_9_anh000011 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_10_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_11_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_2(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_8(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_18 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_18_anh000011 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_BindVertexBuffers_ovr_19_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private z_BindVertexBuffers_ovr_20 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_20_anh000010 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_20(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_20_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_20(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_24 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_BindVertexBuffers_adr);
    private z_BindVertexBuffers_ovr_24_anh000001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_24_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides);
    private z_BindVertexBuffers_ovr_26 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_BindVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_26(first, count, buffers, offsets, strides);
    
    // added in gl1.4
    private z_BlendColor_adr := GetFuncAdr('glBlendColor');
    private z_BlendColor_ovr_0 := GetFuncOrNil&<procedure(red: single; green: single; blue: single; alpha: single)>(z_BlendColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColor(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColor_ovr_0(red, green, blue, alpha);
    
    // added in gl1.4
    private z_BlendEquation_adr := GetFuncAdr('glBlendEquation');
    private z_BlendEquation_ovr_0 := GetFuncOrNil&<procedure(mode: BlendEquationModeEXT)>(z_BlendEquation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquation(mode: BlendEquationModeEXT) :=
    z_BlendEquation_ovr_0(mode);
    
    // added in gl4.0
    private z_BlendEquationi_adr := GetFuncAdr('glBlendEquationi');
    private z_BlendEquationi_ovr_0 := GetFuncOrNil&<procedure(buf: UInt32; mode: BlendEquationModeEXT)>(z_BlendEquationi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationi(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationi_ovr_0(buf, mode);
    
    // added in gl2.0
    private z_BlendEquationSeparate_adr := GetFuncAdr('glBlendEquationSeparate');
    private z_BlendEquationSeparate_ovr_0 := GetFuncOrNil&<procedure(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparate(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparate_ovr_0(modeRGB, modeAlpha);
    
    // added in gl4.0
    private z_BlendEquationSeparatei_adr := GetFuncAdr('glBlendEquationSeparatei');
    private z_BlendEquationSeparatei_ovr_0 := GetFuncOrNil&<procedure(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT)>(z_BlendEquationSeparatei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparatei(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparatei_ovr_0(buf, modeRGB, modeAlpha);
    
    // added in gl1.0
    private static procedure z_BlendFunc_ovr_0(sfactor: BlendingFactor; dfactor: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFunc';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunc(sfactor: BlendingFactor; dfactor: BlendingFactor) :=
    z_BlendFunc_ovr_0(sfactor, dfactor);
    
    // added in gl4.0
    private z_BlendFunci_adr := GetFuncAdr('glBlendFunci');
    private z_BlendFunci_ovr_0 := GetFuncOrNil&<procedure(buf: UInt32; src: BlendingFactor; dst: BlendingFactor)>(z_BlendFunci_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunci(buf: UInt32; src: BlendingFactor; dst: BlendingFactor) :=
    z_BlendFunci_ovr_0(buf, src, dst);
    
    // added in gl1.4
    private z_BlendFuncSeparate_adr := GetFuncAdr('glBlendFuncSeparate');
    private z_BlendFuncSeparate_ovr_0 := GetFuncOrNil&<procedure(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor)>(z_BlendFuncSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparate(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparate_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
    // added in gl4.0
    private z_BlendFuncSeparatei_adr := GetFuncAdr('glBlendFuncSeparatei');
    private z_BlendFuncSeparatei_ovr_0 := GetFuncOrNil&<procedure(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor)>(z_BlendFuncSeparatei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparatei(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparatei_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
    // added in gl3.0
    private z_BlitFramebuffer_adr := GetFuncAdr('glBlitFramebuffer');
    private z_BlitFramebuffer_ovr_0 := GetFuncOrNil&<procedure(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebuffer(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebuffer_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    // added in gl4.5
    private z_BlitNamedFramebuffer_adr := GetFuncAdr('glBlitNamedFramebuffer');
    private z_BlitNamedFramebuffer_ovr_0 := GetFuncOrNil&<procedure(readFramebuffer: UInt32; drawFramebuffer: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter)>(z_BlitNamedFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitNamedFramebuffer(readFramebuffer: UInt32; drawFramebuffer: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitNamedFramebuffer_ovr_0(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    // added in gl1.5
    private z_BufferData_adr := GetFuncAdr('glBufferData');
    private z_BufferData_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; size: IntPtr; data: IntPtr; usage: BufferUsageARB)>(z_BufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferData(target: BufferTargetARB; size: IntPtr; data: IntPtr; usage: BufferUsageARB) :=
    z_BufferData_ovr_0(target, size, data, usage);
    
    // added in gl4.4
    private z_BufferStorage_adr := GetFuncAdr('glBufferStorage');
    private z_BufferStorage_ovr_0 := GetFuncOrNil&<procedure(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_BufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorage(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_BufferStorage_ovr_0(target, size, data, flags);
    
    // added in gl1.5
    private z_BufferSubData_adr := GetFuncAdr('glBufferSubData');
    private z_BufferSubData_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_BufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferSubData(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_BufferSubData_ovr_0(target, offset, size, data);
    
    // added in gl3.0
    private z_CheckFramebufferStatus_adr := GetFuncAdr('glCheckFramebufferStatus');
    private z_CheckFramebufferStatus_ovr_0 := GetFuncOrNil&<function(target: FramebufferTarget): FramebufferStatus>(z_CheckFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatus(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatus_ovr_0(target);
    
    // added in gl4.5
    private z_CheckNamedFramebufferStatus_adr := GetFuncAdr('glCheckNamedFramebufferStatus');
    private z_CheckNamedFramebufferStatus_ovr_0 := GetFuncOrNil&<function(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus>(z_CheckNamedFramebufferStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatus(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatus_ovr_0(framebuffer, target);
    
    // added in gl3.0
    private z_ClampColor_adr := GetFuncAdr('glClampColor');
    private z_ClampColor_ovr_0 := GetFuncOrNil&<procedure(target: ClampColorTargetARB; clamp: ClampColorModeARB)>(z_ClampColor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClampColor(target: ClampColorTargetARB; clamp: ClampColorModeARB) :=
    z_ClampColor_ovr_0(target, clamp);
    
    // added in gl1.0
    private static procedure z_Clear_ovr_0(mask: ClearBufferMask);
    external 'opengl32.dll' name 'glClear';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Clear(mask: ClearBufferMask) :=
    z_Clear_ovr_0(mask);
    
    // added in gl4.3
    private z_ClearBufferData_adr := GetFuncAdr('glClearBufferData');
    private z_ClearBufferData_ovr_0 := GetFuncOrNil&<procedure(target: BufferStorageTarget; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferData(target: BufferStorageTarget; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferData_ovr_0(target, _internalformat, format, &type, data);
    
    // added in gl3.0
    private z_ClearBufferfi_adr := GetFuncAdr('glClearBufferfi');
    private z_ClearBufferfi_ovr_0 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32)>(z_ClearBufferfi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfi(_buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearBufferfi_ovr_0(_buffer, drawbuffer, depth, stencil);
    
    // added in gl3.0
    private z_ClearBufferfv_adr := GetFuncAdr('glClearBufferfv');
    private z_ClearBufferfv_ovr_0 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: single)>(z_ClearBufferfv_adr);
    private z_ClearBufferfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferfv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferfv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearBufferfv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferfv_ovr_2 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferfv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferfv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl3.0
    private z_ClearBufferiv_adr := GetFuncAdr('glClearBufferiv');
    private z_ClearBufferiv_ovr_0 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: Int32)>(z_ClearBufferiv_adr);
    private z_ClearBufferiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferiv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferiv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearBufferiv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferiv_ovr_2 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferiv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferiv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl4.3
    private z_ClearBufferSubData_adr := GetFuncAdr('glClearBufferSubData');
    private z_ClearBufferSubData_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferSubData(target: BufferTargetARB; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferSubData_ovr_0(target, _internalformat, offset, size, format, &type, data);
    
    // added in gl3.0
    private z_ClearBufferuiv_adr := GetFuncAdr('glClearBufferuiv');
    private z_ClearBufferuiv_ovr_0 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; var value: UInt32)>(z_ClearBufferuiv_adr);
    private z_ClearBufferuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearBufferuiv_ovr_0(_buffer, drawbuffer, value[0]) else
      z_ClearBufferuiv_ovr_0_anh0001(_buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearBufferuiv_ovr_0(_buffer, drawbuffer, value);
    private z_ClearBufferuiv_ovr_2 := GetFuncOrNil&<procedure(_buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearBufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferuiv(_buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearBufferuiv_ovr_2(_buffer, drawbuffer, value);
    
    // added in gl1.0
    private static procedure z_ClearColor_ovr_0(red: single; green: single; blue: single; alpha: single);
    external 'opengl32.dll' name 'glClearColor';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColor(red: single; green: single; blue: single; alpha: single) :=
    z_ClearColor_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0
    private static procedure z_ClearDepth_ovr_0(depth: real);
    external 'opengl32.dll' name 'glClearDepth';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepth(depth: real) :=
    z_ClearDepth_ovr_0(depth);
    
    // added in gl4.1
    private z_ClearDepthf_adr := GetFuncAdr('glClearDepthf');
    private z_ClearDepthf_ovr_0 := GetFuncOrNil&<procedure(d: single)>(z_ClearDepthf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthf(d: single) :=
    z_ClearDepthf_ovr_0(d);
    
    // added in gl4.5
    private z_ClearNamedBufferData_adr := GetFuncAdr('glClearNamedBufferData');
    private z_ClearNamedBufferData_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferData(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferData_ovr_0(buffer, _internalformat, format, &type, data);
    
    // added in gl4.5
    private z_ClearNamedBufferSubData_adr := GetFuncAdr('glClearNamedBufferSubData');
    private z_ClearNamedBufferSubData_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubData(buffer: UInt32; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubData_ovr_0(buffer, _internalformat, offset, size, format, &type, data);
    
    // added in gl4.5
    private z_ClearNamedFramebufferfi_adr := GetFuncAdr('glClearNamedFramebufferfi');
    private z_ClearNamedFramebufferfi_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32)>(z_ClearNamedFramebufferfi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfi(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearNamedFramebufferfi_ovr_0(framebuffer, _buffer, drawbuffer, depth, stencil);
    
    // added in gl4.5
    private z_ClearNamedFramebufferfv_adr := GetFuncAdr('glClearNamedFramebufferfv');
    private z_ClearNamedFramebufferfv_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: single)>(z_ClearNamedFramebufferfv_adr);
    private z_ClearNamedFramebufferfv_ovr_0_anh00001 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferfv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferfv_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferfv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl4.5
    private z_ClearNamedFramebufferiv_adr := GetFuncAdr('glClearNamedFramebufferiv');
    private z_ClearNamedFramebufferiv_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: Int32)>(z_ClearNamedFramebufferiv_adr);
    private z_ClearNamedFramebufferiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferiv_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl4.5
    private z_ClearNamedFramebufferuiv_adr := GetFuncAdr('glClearNamedFramebufferuiv');
    private z_ClearNamedFramebufferuiv_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: UInt32)>(z_ClearNamedFramebufferuiv_adr);
    private z_ClearNamedFramebufferuiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferuiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private z_ClearNamedFramebufferuiv_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr)>(z_ClearNamedFramebufferuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferuiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    // added in gl1.0
    private static procedure z_ClearStencil_ovr_0(s: Int32);
    external 'opengl32.dll' name 'glClearStencil';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearStencil(s: Int32) :=
    z_ClearStencil_ovr_0(s);
    
    // added in gl4.4
    private z_ClearTexImage_adr := GetFuncAdr('glClearTexImage');
    private z_ClearTexImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexImage(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexImage_ovr_0(texture, level, format, &type, data);
    
    // added in gl4.4
    private z_ClearTexSubImage_adr := GetFuncAdr('glClearTexSubImage');
    private z_ClearTexSubImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr)>(z_ClearTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, data);
    
    // added in gl3.2
    private z_ClientWaitSync_adr := GetFuncAdr('glClientWaitSync');
    private z_ClientWaitSync_ovr_0 := GetFuncOrNil&<function(sync: GLsync; flags: SyncObjectMask; timeout: UInt64): SyncStatus>(z_ClientWaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ClientWaitSync(sync: GLsync; flags: SyncObjectMask; timeout: UInt64): SyncStatus :=
    z_ClientWaitSync_ovr_0(sync, flags, timeout);
    
    // added in gl4.5
    private z_ClipControl_adr := GetFuncAdr('glClipControl');
    private z_ClipControl_ovr_0 := GetFuncOrNil&<procedure(origin: ClipControlOrigin; depth: ClipControlDepth)>(z_ClipControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipControl(origin: ClipControlOrigin; depth: ClipControlDepth) :=
    z_ClipControl_ovr_0(origin, depth);
    
    // added in gl1.0
    private static procedure z_ColorMask_ovr_0(red: boolean; green: boolean; blue: boolean; alpha: boolean);
    external 'opengl32.dll' name 'glColorMask';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMask(red: boolean; green: boolean; blue: boolean; alpha: boolean) :=
    z_ColorMask_ovr_0(red, green, blue, alpha);
    
    // added in gl3.0
    private z_ColorMaski_adr := GetFuncAdr('glColorMaski');
    private z_ColorMaski_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean)>(z_ColorMaski_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaski(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean) :=
    z_ColorMaski_ovr_0(index, r, g, b, a);
    
    // added in gl3.3
    private z_ColorP3ui_adr := GetFuncAdr('glColorP3ui');
    private z_ColorP3ui_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP3ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_ColorP3uiv_adr := GetFuncAdr('glColorP3uiv');
    private z_ColorP3uiv_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP3uiv_adr);
    private z_ColorP3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_ColorP3uiv_ovr_0(&type, color[0]) else
      z_ColorP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP3uiv_ovr_0(&type, color);
    private z_ColorP3uiv_ovr_2 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP3uiv_ovr_2(&type, color);
    
    // added in gl3.3
    private z_ColorP4ui_adr := GetFuncAdr('glColorP4ui');
    private z_ColorP4ui_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_ColorP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP4ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_ColorP4uiv_adr := GetFuncAdr('glColorP4uiv');
    private z_ColorP4uiv_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_ColorP4uiv_adr);
    private z_ColorP4uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_ColorP4uiv_ovr_0(&type, color[0]) else
      z_ColorP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP4uiv_ovr_0(&type, color);
    private z_ColorP4uiv_ovr_2 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_ColorP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP4uiv_ovr_2(&type, color);
    
    // added in gl2.0
    private z_CompileShader_adr := GetFuncAdr('glCompileShader');
    private z_CompileShader_ovr_0 := GetFuncOrNil&<procedure(shader: ShaderName)>(z_CompileShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShader(shader: ShaderName) :=
    z_CompileShader_ovr_0(shader);
    
    // added in gl1.3
    private z_CompressedTexImage1D_adr := GetFuncAdr('glCompressedTexImage1D');
    private z_CompressedTexImage1D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage1D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage1D_ovr_0(target, level, _internalformat, width, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexImage2D_adr := GetFuncAdr('glCompressedTexImage2D');
    private z_CompressedTexImage2D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage2D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage2D_ovr_0(target, level, _internalformat, width, height, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexImage3D_adr := GetFuncAdr('glCompressedTexImage3D');
    private z_CompressedTexImage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr)>(z_CompressedTexImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage3D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage3D_ovr_0(target, level, _internalformat, width, height, depth, border, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage1D_adr := GetFuncAdr('glCompressedTexSubImage1D');
    private z_CompressedTexSubImage1D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage1D_ovr_0(target, level, xoffset, width, format, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage2D_adr := GetFuncAdr('glCompressedTexSubImage2D');
    private z_CompressedTexSubImage2D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage2D_ovr_0(target, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    // added in gl1.3
    private z_CompressedTexSubImage3D_adr := GetFuncAdr('glCompressedTexSubImage3D');
    private z_CompressedTexSubImage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage1D_adr := GetFuncAdr('glCompressedTextureSubImage1D');
    private z_CompressedTextureSubImage1D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1D(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage1D_ovr_0(texture, level, xoffset, width, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage2D_adr := GetFuncAdr('glCompressedTextureSubImage2D');
    private z_CompressedTextureSubImage2D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    // added in gl4.5
    private z_CompressedTextureSubImage3D_adr := GetFuncAdr('glCompressedTextureSubImage3D');
    private z_CompressedTextureSubImage3D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr)>(z_CompressedTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    // added in gl3.1
    private z_CopyBufferSubData_adr := GetFuncAdr('glCopyBufferSubData');
    private z_CopyBufferSubData_ovr_0 := GetFuncOrNil&<procedure(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyBufferSubData(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyBufferSubData_ovr_0(readTarget, writeTarget, readOffset, writeOffset, size);
    
    // added in gl4.3
    private z_CopyImageSubData_adr := GetFuncAdr('glCopyImageSubData');
    private z_CopyImageSubData_ovr_0 := GetFuncOrNil&<procedure(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32)>(z_CopyImageSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubData(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_CopyImageSubData_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
    // added in gl4.5
    private z_CopyNamedBufferSubData_adr := GetFuncAdr('glCopyNamedBufferSubData');
    private z_CopyNamedBufferSubData_ovr_0 := GetFuncOrNil&<procedure(readBuffer: BufferName; writeBuffer: BufferName; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr)>(z_CopyNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyNamedBufferSubData(readBuffer: BufferName; writeBuffer: BufferName; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyNamedBufferSubData_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    // added in gl1.1
    private static procedure z_CopyTexImage1D_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTexImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage1D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTexImage1D_ovr_0(target, level, _internalformat, x, y, width, border);
    
    // added in gl1.1
    private static procedure z_CopyTexImage2D_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTexImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage2D(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTexImage2D_ovr_0(target, level, _internalformat, x, y, width, height, border);
    
    // added in gl1.1
    private static procedure z_CopyTexSubImage1D_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyTexSubImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTexSubImage1D_ovr_0(target, level, xoffset, x, y, width);
    
    // added in gl1.1
    private static procedure z_CopyTexSubImage2D_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTexSubImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage2D_ovr_0(target, level, xoffset, yoffset, x, y, width, height);
    
    // added in gl1.2
    private z_CopyTexSubImage3D_adr := GetFuncAdr('glCopyTexSubImage3D');
    private z_CopyTexSubImage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CopyTextureSubImage1D_adr := GetFuncAdr('glCopyTextureSubImage1D');
    private z_CopyTextureSubImage1D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32)>(z_CopyTextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1D(texture: TextureName; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1D_ovr_0(texture, level, xoffset, x, y, width);
    
    // added in gl4.5
    private z_CopyTextureSubImage2D_adr := GetFuncAdr('glCopyTextureSubImage2D');
    private z_CopyTextureSubImage2D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2D(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CopyTextureSubImage3D_adr := GetFuncAdr('glCopyTextureSubImage3D');
    private z_CopyTextureSubImage3D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32)>(z_CopyTextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3D(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    // added in gl4.5
    private z_CreateBuffers_adr := GetFuncAdr('glCreateBuffers');
    private z_CreateBuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var buffers: BufferName)>(z_CreateBuffers_adr);
    private z_CreateBuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: array of BufferName) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_CreateBuffers_ovr_0(n, buffers[0]) else
      z_CreateBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; var buffers: BufferName) :=
    z_CreateBuffers_ovr_0(n, buffers);
    private z_CreateBuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_CreateBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: IntPtr) :=
    z_CreateBuffers_ovr_2(n, buffers);
    
    // added in gl4.5
    private z_CreateFramebuffers_adr := GetFuncAdr('glCreateFramebuffers');
    private z_CreateFramebuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var framebuffers: UInt32)>(z_CreateFramebuffers_adr);
    private z_CreateFramebuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_CreateFramebuffers_ovr_0(n, framebuffers[0]) else
      z_CreateFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_CreateFramebuffers_ovr_0(n, framebuffers);
    private z_CreateFramebuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_CreateFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_CreateFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl2.0
    private z_CreateProgram_adr := GetFuncAdr('glCreateProgram');
    private z_CreateProgram_ovr_0 := GetFuncOrNil&<function: ProgramName>(z_CreateProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgram: ProgramName :=
    z_CreateProgram_ovr_0;
    
    // added in gl4.5
    private z_CreateProgramPipelines_adr := GetFuncAdr('glCreateProgramPipelines');
    private z_CreateProgramPipelines_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var pipelines: UInt32)>(z_CreateProgramPipelines_adr);
    private z_CreateProgramPipelines_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_CreateProgramPipelines_ovr_0(n, pipelines[0]) else
      z_CreateProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_CreateProgramPipelines_ovr_0(n, pipelines);
    private z_CreateProgramPipelines_ovr_2 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_CreateProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_CreateProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl4.5
    private z_CreateQueries_adr := GetFuncAdr('glCreateQueries');
    private z_CreateQueries_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; n: Int32; var ids: UInt32)>(z_CreateQueries_adr);
    private z_CreateQueries_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateQueries_ovr_0(target, n, ids[0]) else
      z_CreateQueries_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; var ids: UInt32) :=
    z_CreateQueries_ovr_0(target, n, ids);
    private z_CreateQueries_ovr_2 := GetFuncOrNil&<procedure(target: QueryTarget; n: Int32; ids: IntPtr)>(z_CreateQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: IntPtr) :=
    z_CreateQueries_ovr_2(target, n, ids);
    
    // added in gl4.5
    private z_CreateRenderbuffers_adr := GetFuncAdr('glCreateRenderbuffers');
    private z_CreateRenderbuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var renderbuffers: UInt32)>(z_CreateRenderbuffers_adr);
    private z_CreateRenderbuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_CreateRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_CreateRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_CreateRenderbuffers_ovr_0(n, renderbuffers);
    private z_CreateRenderbuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_CreateRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_CreateRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl4.5
    private z_CreateSamplers_adr := GetFuncAdr('glCreateSamplers');
    private z_CreateSamplers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var samplers: UInt32)>(z_CreateSamplers_adr);
    private z_CreateSamplers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_CreateSamplers_ovr_0(n, samplers[0]) else
      z_CreateSamplers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; var samplers: UInt32) :=
    z_CreateSamplers_ovr_0(n, samplers);
    private z_CreateSamplers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; samplers: IntPtr)>(z_CreateSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: IntPtr) :=
    z_CreateSamplers_ovr_2(n, samplers);
    
    // added in gl2.0
    private z_CreateShader_adr := GetFuncAdr('glCreateShader');
    private z_CreateShader_ovr_0 := GetFuncOrNil&<function(&type: ShaderType): ShaderName>(z_CreateShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShader(&type: ShaderType): ShaderName :=
    z_CreateShader_ovr_0(&type);
    
    // added in gl4.1
    private z_CreateShaderProgramv_adr := GetFuncAdr('glCreateShaderProgramv');
    private z_CreateShaderProgramv_ovr_0 := GetFuncOrNil&<function(&type: ShaderType; count: Int32; var strings: IntPtr): ProgramName>(z_CreateShaderProgramv_adr);
    private z_CreateShaderProgramv_ovr_0_anh0001 := GetFuncOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of string): ProgramName;
    begin
      var par_3_str_ptr := strings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        Result := z_CreateShaderProgramv_ovr_0(&type, count, par_3_str_ptr[0]) else
        Result := z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_CreateShaderProgramv_ovr_1_anh0001 := GetFuncOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of IntPtr): ProgramName :=
    if (strings<>nil) and (strings.Length<>0) then
      z_CreateShaderProgramv_ovr_0(&type, count, strings[0]) else
      z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
    private z_CreateShaderProgramv_ovr_2 := GetFuncOrNil&<function(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName>(z_CreateShaderProgramv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName :=
    z_CreateShaderProgramv_ovr_2(&type, count, strings);
    
    // added in gl4.5
    private z_CreateTextures_adr := GetFuncAdr('glCreateTextures');
    private z_CreateTextures_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; n: Int32; var textures: UInt32)>(z_CreateTextures_adr);
    private z_CreateTextures_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_CreateTextures_ovr_0(target, n, textures[0]) else
      z_CreateTextures_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; var textures: UInt32) :=
    z_CreateTextures_ovr_0(target, n, textures);
    private z_CreateTextures_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; n: Int32; textures: IntPtr)>(z_CreateTextures_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: IntPtr) :=
    z_CreateTextures_ovr_2(target, n, textures);
    
    // added in gl4.5
    private z_CreateTransformFeedbacks_adr := GetFuncAdr('glCreateTransformFeedbacks');
    private z_CreateTransformFeedbacks_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var ids: UInt32)>(z_CreateTransformFeedbacks_adr);
    private z_CreateTransformFeedbacks_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateTransformFeedbacks_ovr_0(n, ids[0]) else
      z_CreateTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_CreateTransformFeedbacks_ovr_0(n, ids);
    private z_CreateTransformFeedbacks_ovr_2 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_CreateTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_CreateTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl4.5
    private z_CreateVertexArrays_adr := GetFuncAdr('glCreateVertexArrays');
    private z_CreateVertexArrays_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var arrays: UInt32)>(z_CreateVertexArrays_adr);
    private z_CreateVertexArrays_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_CreateVertexArrays_ovr_0(n, arrays[0]) else
      z_CreateVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; var arrays: UInt32) :=
    z_CreateVertexArrays_ovr_0(n, arrays);
    private z_CreateVertexArrays_ovr_2 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_CreateVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: IntPtr) :=
    z_CreateVertexArrays_ovr_2(n, arrays);
    
    // added in gl1.0
    private static procedure z_CullFace_ovr_0(mode: CullFaceMode);
    external 'opengl32.dll' name 'glCullFace';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullFace(mode: CullFaceMode) :=
    z_CullFace_ovr_0(mode);
    
    // added in gl4.3
    private z_DebugMessageCallback_adr := GetFuncAdr('glDebugMessageCallback');
    private z_DebugMessageCallback_ovr_0 := GetFuncOrNil&<procedure(callback: GLDEBUGPROC; userParam: IntPtr)>(z_DebugMessageCallback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallback(callback: GLDEBUGPROC; userParam: IntPtr) :=
    z_DebugMessageCallback_ovr_0(callback, userParam);
    
    // added in gl4.3
    private z_DebugMessageControl_adr := GetFuncAdr('glDebugMessageControl');
    private z_DebugMessageControl_ovr_0 := GetFuncOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean)>(z_DebugMessageControl_adr);
    private z_DebugMessageControl_ovr_0_anh0000010 := GetFuncOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControl_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControl_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControl_ovr_0(source, &type, severity, count, ids, enabled);
    private z_DebugMessageControl_ovr_2 := GetFuncOrNil&<procedure(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean)>(z_DebugMessageControl_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControl_ovr_2(source, &type, severity, count, ids, enabled);
    
    // added in gl4.3
    private z_DebugMessageInsert_adr := GetFuncAdr('glDebugMessageInsert');
    private z_DebugMessageInsert_ovr_0 := GetFuncOrNil&<procedure(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr)>(z_DebugMessageInsert_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
      z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      Marshal.FreeHGlobal(par_6_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, buf);
    
    // added in gl1.5
    private z_DeleteBuffers_adr := GetFuncAdr('glDeleteBuffers');
    private z_DeleteBuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var buffers: UInt32)>(z_DeleteBuffers_adr);
    private z_DeleteBuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; buffers: array of UInt32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_DeleteBuffers_ovr_0(n, buffers[0]) else
      z_DeleteBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; var buffers: UInt32) :=
    z_DeleteBuffers_ovr_0(n, buffers);
    private z_DeleteBuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_DeleteBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffers(n: Int32; buffers: IntPtr) :=
    z_DeleteBuffers_ovr_2(n, buffers);
    
    // added in gl3.0
    private z_DeleteFramebuffers_adr := GetFuncAdr('glDeleteFramebuffers');
    private z_DeleteFramebuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var framebuffers: UInt32)>(z_DeleteFramebuffers_adr);
    private z_DeleteFramebuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffers_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_DeleteFramebuffers_ovr_0(n, framebuffers);
    private z_DeleteFramebuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_DeleteFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl2.0
    private z_DeleteProgram_adr := GetFuncAdr('glDeleteProgram');
    private z_DeleteProgram_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName)>(z_DeleteProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgram(&program: ProgramName) :=
    z_DeleteProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_DeleteProgramPipelines_adr := GetFuncAdr('glDeleteProgramPipelines');
    private z_DeleteProgramPipelines_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var pipelines: UInt32)>(z_DeleteProgramPipelines_adr);
    private z_DeleteProgramPipelines_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_DeleteProgramPipelines_ovr_0(n, pipelines[0]) else
      z_DeleteProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_DeleteProgramPipelines_ovr_0(n, pipelines);
    private z_DeleteProgramPipelines_ovr_2 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_DeleteProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_DeleteProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl1.5
    private z_DeleteQueries_adr := GetFuncAdr('glDeleteQueries');
    private z_DeleteQueries_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var ids: UInt32)>(z_DeleteQueries_adr);
    private z_DeleteQueries_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteQueries_ovr_0(n, ids[0]) else
      z_DeleteQueries_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; var ids: UInt32) :=
    z_DeleteQueries_ovr_0(n, ids);
    private z_DeleteQueries_ovr_2 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueries(n: Int32; ids: IntPtr) :=
    z_DeleteQueries_ovr_2(n, ids);
    
    // added in gl3.0
    private z_DeleteRenderbuffers_adr := GetFuncAdr('glDeleteRenderbuffers');
    private z_DeleteRenderbuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var renderbuffers: UInt32)>(z_DeleteRenderbuffers_adr);
    private z_DeleteRenderbuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_DeleteRenderbuffers_ovr_0(n, renderbuffers);
    private z_DeleteRenderbuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_DeleteRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl3.3
    private z_DeleteSamplers_adr := GetFuncAdr('glDeleteSamplers');
    private z_DeleteSamplers_ovr_0 := GetFuncOrNil&<procedure(count: Int32; var samplers: UInt32)>(z_DeleteSamplers_adr);
    private z_DeleteSamplers_ovr_0_anh001 := GetFuncOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_DeleteSamplers_ovr_0(count, samplers[0]) else
      z_DeleteSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; var samplers: UInt32) :=
    z_DeleteSamplers_ovr_0(count, samplers);
    private z_DeleteSamplers_ovr_2 := GetFuncOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_DeleteSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: IntPtr) :=
    z_DeleteSamplers_ovr_2(count, samplers);
    
    // added in gl2.0
    private z_DeleteShader_adr := GetFuncAdr('glDeleteShader');
    private z_DeleteShader_ovr_0 := GetFuncOrNil&<procedure(shader: ShaderName)>(z_DeleteShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteShader(shader: ShaderName) :=
    z_DeleteShader_ovr_0(shader);
    
    // added in gl3.2
    private z_DeleteSync_adr := GetFuncAdr('glDeleteSync');
    private z_DeleteSync_ovr_0 := GetFuncOrNil&<procedure(sync: GLsync)>(z_DeleteSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSync(sync: GLsync) :=
    z_DeleteSync_ovr_0(sync);
    
    // added in gl1.1
    private static procedure z_DeleteTextures_ovr_0(n: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glDeleteTextures';
    private static procedure z_DeleteTextures_ovr_0_anh001(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glDeleteTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_DeleteTextures_ovr_0(n, textures[0]) else
      z_DeleteTextures_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; var textures: UInt32) :=
    z_DeleteTextures_ovr_0(n, textures);
    private static procedure z_DeleteTextures_ovr_2(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glDeleteTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTextures(n: Int32; textures: IntPtr) :=
    z_DeleteTextures_ovr_2(n, textures);
    
    // added in gl4.0
    private z_DeleteTransformFeedbacks_adr := GetFuncAdr('glDeleteTransformFeedbacks');
    private z_DeleteTransformFeedbacks_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var ids: UInt32)>(z_DeleteTransformFeedbacks_adr);
    private z_DeleteTransformFeedbacks_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacks_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_DeleteTransformFeedbacks_ovr_0(n, ids);
    private z_DeleteTransformFeedbacks_ovr_2 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_DeleteTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl3.0
    private z_DeleteVertexArrays_adr := GetFuncAdr('glDeleteVertexArrays');
    private z_DeleteVertexArrays_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var arrays: UInt32)>(z_DeleteVertexArrays_adr);
    private z_DeleteVertexArrays_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArrays_ovr_0(n, arrays[0]) else
      z_DeleteVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; var arrays: UInt32) :=
    z_DeleteVertexArrays_ovr_0(n, arrays);
    private z_DeleteVertexArrays_ovr_2 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_DeleteVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArrays_ovr_2(n, arrays);
    
    // added in gl1.0
    private static procedure z_DepthFunc_ovr_0(func: DepthFunction);
    external 'opengl32.dll' name 'glDepthFunc';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthFunc(func: DepthFunction) :=
    z_DepthFunc_ovr_0(func);
    
    // added in gl1.0
    private static procedure z_DepthMask_ovr_0(flag: boolean);
    external 'opengl32.dll' name 'glDepthMask';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthMask(flag: boolean) :=
    z_DepthMask_ovr_0(flag);
    
    // added in gl1.0
    private static procedure z_DepthRange_ovr_0(n: real; f: real);
    external 'opengl32.dll' name 'glDepthRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRange(n: real; f: real) :=
    z_DepthRange_ovr_0(n, f);
    
    // added in gl4.1
    private z_DepthRangeArrayv_adr := GetFuncAdr('glDepthRangeArrayv');
    private z_DepthRangeArrayv_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var v: real)>(z_DepthRangeArrayv_adr);
    private z_DepthRangeArrayv_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArrayv_ovr_0(first, count, v[0]) else
      z_DepthRangeArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArrayv_ovr_0(first, count, v);
    private z_DepthRangeArrayv_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_DepthRangeArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_DepthRangef_adr := GetFuncAdr('glDepthRangef');
    private z_DepthRangef_ovr_0 := GetFuncOrNil&<procedure(n: single; f: single)>(z_DepthRangef_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangef(n: single; f: single) :=
    z_DepthRangef_ovr_0(n, f);
    
    // added in gl4.1
    private z_DepthRangeIndexed_adr := GetFuncAdr('glDepthRangeIndexed');
    private z_DepthRangeIndexed_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; n: real; f: real)>(z_DepthRangeIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexed(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexed_ovr_0(index, n, f);
    
    // added in gl2.0
    private z_DetachShader_adr := GetFuncAdr('glDetachShader');
    private z_DetachShader_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; shader: ShaderName)>(z_DetachShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetachShader(&program: ProgramName; shader: ShaderName) :=
    z_DetachShader_ovr_0(&program, shader);
    
    // added in gl1.0
    private static procedure z_Disable_ovr_0(cap: EnableCap);
    external 'opengl32.dll' name 'glDisable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Disable(cap: EnableCap) :=
    z_Disable_ovr_0(cap);
    
    // added in gl3.0
    private z_Disablei_adr := GetFuncAdr('glDisablei');
    private z_Disablei_ovr_0 := GetFuncOrNil&<procedure(target: EnableCap; index: UInt32)>(z_Disablei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Disablei(target: EnableCap; index: UInt32) :=
    z_Disablei_ovr_0(target, index);
    
    // added in gl4.5
    private z_DisableVertexArrayAttrib_adr := GetFuncAdr('glDisableVertexArrayAttrib');
    private z_DisableVertexArrayAttrib_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; index: UInt32)>(z_DisableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttrib(vaobj: VertexArrayName; index: UInt32) :=
    z_DisableVertexArrayAttrib_ovr_0(vaobj, index);
    
    // added in gl2.0
    private z_DisableVertexAttribArray_adr := GetFuncAdr('glDisableVertexAttribArray');
    private z_DisableVertexAttribArray_ovr_0 := GetFuncOrNil&<procedure(index: UInt32)>(z_DisableVertexAttribArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArray(index: UInt32) :=
    z_DisableVertexAttribArray_ovr_0(index);
    
    // added in gl4.3
    private z_DispatchCompute_adr := GetFuncAdr('glDispatchCompute');
    private z_DispatchCompute_ovr_0 := GetFuncOrNil&<procedure(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32)>(z_DispatchCompute_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchCompute(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32) :=
    z_DispatchCompute_ovr_0(num_groups_x, num_groups_y, num_groups_z);
    
    // added in gl4.3
    private z_DispatchComputeIndirect_adr := GetFuncAdr('glDispatchComputeIndirect');
    private z_DispatchComputeIndirect_ovr_0 := GetFuncOrNil&<procedure(indirect: IntPtr)>(z_DispatchComputeIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeIndirect(indirect: IntPtr) :=
    z_DispatchComputeIndirect_ovr_0(indirect);
    
    // added in gl1.1
    private static procedure z_DrawArrays_ovr_0(mode: PrimitiveType; first: Int32; count: Int32);
    external 'opengl32.dll' name 'glDrawArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArrays(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawArrays_ovr_0(mode, first, count);
    
    // added in gl4.0
    private z_DrawArraysIndirect_adr := GetFuncAdr('glDrawArraysIndirect');
    private z_DrawArraysIndirect_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr)>(z_DrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr) :=
    z_DrawArraysIndirect_ovr_0(mode, indirect);
    
    // added in gl3.1
    private z_DrawArraysInstanced_adr := GetFuncAdr('glDrawArraysInstanced');
    private z_DrawArraysInstanced_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32)>(z_DrawArraysInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstanced(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32) :=
    z_DrawArraysInstanced_ovr_0(mode, first, count, instancecount);
    
    // added in gl4.2
    private z_DrawArraysInstancedBaseInstance_adr := GetFuncAdr('glDrawArraysInstancedBaseInstance');
    private z_DrawArraysInstancedBaseInstance_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32)>(z_DrawArraysInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedBaseInstance(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawArraysInstancedBaseInstance_ovr_0(mode, first, count, instancecount, baseinstance);
    
    // added in gl1.0
    private static procedure z_DrawBuffer_ovr_0(buf: DrawBufferMode);
    external 'opengl32.dll' name 'glDrawBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffer(buf: DrawBufferMode) :=
    z_DrawBuffer_ovr_0(buf);
    
    // added in gl2.0
    private z_DrawBuffers_adr := GetFuncAdr('glDrawBuffers');
    private z_DrawBuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var bufs: DrawBufferMode)>(z_DrawBuffers_adr);
    private z_DrawBuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffers_ovr_0(n, bufs[0]) else
      z_DrawBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffers_ovr_0(n, bufs);
    private z_DrawBuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; bufs: IntPtr)>(z_DrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffers(n: Int32; bufs: IntPtr) :=
    z_DrawBuffers_ovr_2(n, bufs);
    
    // added in gl1.1
    private static procedure z_DrawElements_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr);
    external 'opengl32.dll' name 'glDrawElements';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElements(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawElements_ovr_0(mode, count, &type, indices);
    
    // added in gl3.2
    private z_DrawElementsBaseVertex_adr := GetFuncAdr('glDrawElementsBaseVertex');
    private z_DrawElementsBaseVertex_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawElementsBaseVertex_ovr_0(mode, count, &type, indices, basevertex);
    
    // added in gl4.0
    private z_DrawElementsIndirect_adr := GetFuncAdr('glDrawElementsIndirect');
    private z_DrawElementsIndirect_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr)>(z_DrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr) :=
    z_DrawElementsIndirect_ovr_0(mode, &type, indirect);
    
    // added in gl3.1
    private z_DrawElementsInstanced_adr := GetFuncAdr('glDrawElementsInstanced');
    private z_DrawElementsInstanced_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32)>(z_DrawElementsInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstanced(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32) :=
    z_DrawElementsInstanced_ovr_0(mode, count, &type, indices, instancecount);
    
    // added in gl4.2
    private z_DrawElementsInstancedBaseInstance_adr := GetFuncAdr('glDrawElementsInstancedBaseInstance');
    private z_DrawElementsInstancedBaseInstance_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseInstance(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseInstance_ovr_0(mode, count, &type, indices, instancecount, baseinstance);
    
    // added in gl3.2
    private z_DrawElementsInstancedBaseVertex_adr := GetFuncAdr('glDrawElementsInstancedBaseVertex');
    private z_DrawElementsInstancedBaseVertex_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32)>(z_DrawElementsInstancedBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32) :=
    z_DrawElementsInstancedBaseVertex_ovr_0(mode, count, &type, indices, instancecount, basevertex);
    
    // added in gl4.2
    private z_DrawElementsInstancedBaseVertexBaseInstance_adr := GetFuncAdr('glDrawElementsInstancedBaseVertexBaseInstance');
    private z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32)>(z_DrawElementsInstancedBaseVertexBaseInstance_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertexBaseInstance(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0(mode, count, &type, indices, instancecount, basevertex, baseinstance);
    
    // added in gl1.2
    private z_DrawRangeElements_adr := GetFuncAdr('glDrawRangeElements');
    private z_DrawRangeElements_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr)>(z_DrawRangeElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElements(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawRangeElements_ovr_0(mode, start, &end, count, &type, indices);
    
    // added in gl3.2
    private z_DrawRangeElementsBaseVertex_adr := GetFuncAdr('glDrawRangeElementsBaseVertex');
    private z_DrawRangeElementsBaseVertex_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32)>(z_DrawRangeElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsBaseVertex(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawRangeElementsBaseVertex_ovr_0(mode, start, &end, count, &type, indices, basevertex);
    
    // added in gl4.0
    private z_DrawTransformFeedback_adr := GetFuncAdr('glDrawTransformFeedback');
    private z_DrawTransformFeedback_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; id: TransformFeedbackName)>(z_DrawTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedback(mode: PrimitiveType; id: TransformFeedbackName) :=
    z_DrawTransformFeedback_ovr_0(mode, id);
    
    // added in gl4.2
    private z_DrawTransformFeedbackInstanced_adr := GetFuncAdr('glDrawTransformFeedbackInstanced');
    private z_DrawTransformFeedbackInstanced_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; id: TransformFeedbackName; instancecount: Int32)>(z_DrawTransformFeedbackInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackInstanced(mode: PrimitiveType; id: TransformFeedbackName; instancecount: Int32) :=
    z_DrawTransformFeedbackInstanced_ovr_0(mode, id, instancecount);
    
    // added in gl4.0
    private z_DrawTransformFeedbackStream_adr := GetFuncAdr('glDrawTransformFeedbackStream');
    private z_DrawTransformFeedbackStream_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32)>(z_DrawTransformFeedbackStream_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStream(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32) :=
    z_DrawTransformFeedbackStream_ovr_0(mode, id, stream);
    
    // added in gl4.2
    private z_DrawTransformFeedbackStreamInstanced_adr := GetFuncAdr('glDrawTransformFeedbackStreamInstanced');
    private z_DrawTransformFeedbackStreamInstanced_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32; instancecount: Int32)>(z_DrawTransformFeedbackStreamInstanced_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStreamInstanced(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32; instancecount: Int32) :=
    z_DrawTransformFeedbackStreamInstanced_ovr_0(mode, id, stream, instancecount);
    
    // added in gl1.0
    private static procedure z_Enable_ovr_0(cap: EnableCap);
    external 'opengl32.dll' name 'glEnable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Enable(cap: EnableCap) :=
    z_Enable_ovr_0(cap);
    
    // added in gl3.0
    private z_Enablei_adr := GetFuncAdr('glEnablei');
    private z_Enablei_ovr_0 := GetFuncOrNil&<procedure(target: EnableCap; index: UInt32)>(z_Enablei_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Enablei(target: EnableCap; index: UInt32) :=
    z_Enablei_ovr_0(target, index);
    
    // added in gl4.5
    private z_EnableVertexArrayAttrib_adr := GetFuncAdr('glEnableVertexArrayAttrib');
    private z_EnableVertexArrayAttrib_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; index: UInt32)>(z_EnableVertexArrayAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttrib(vaobj: VertexArrayName; index: UInt32) :=
    z_EnableVertexArrayAttrib_ovr_0(vaobj, index);
    
    // added in gl2.0
    private z_EnableVertexAttribArray_adr := GetFuncAdr('glEnableVertexAttribArray');
    private z_EnableVertexAttribArray_ovr_0 := GetFuncOrNil&<procedure(index: UInt32)>(z_EnableVertexAttribArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArray(index: UInt32) :=
    z_EnableVertexAttribArray_ovr_0(index);
    
    // added in gl3.0
    private z_EndConditionalRender_adr := GetFuncAdr('glEndConditionalRender');
    private z_EndConditionalRender_ovr_0 := GetFuncOrNil&<procedure>(z_EndConditionalRender_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRender :=
    z_EndConditionalRender_ovr_0;
    
    // added in gl1.5
    private z_EndQuery_adr := GetFuncAdr('glEndQuery');
    private z_EndQuery_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget)>(z_EndQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQuery(target: QueryTarget) :=
    z_EndQuery_ovr_0(target);
    
    // added in gl4.0
    private z_EndQueryIndexed_adr := GetFuncAdr('glEndQueryIndexed');
    private z_EndQueryIndexed_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; index: UInt32)>(z_EndQueryIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryIndexed(target: QueryTarget; index: UInt32) :=
    z_EndQueryIndexed_ovr_0(target, index);
    
    // added in gl3.0
    private z_EndTransformFeedback_adr := GetFuncAdr('glEndTransformFeedback');
    private z_EndTransformFeedback_ovr_0 := GetFuncOrNil&<procedure>(z_EndTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedback :=
    z_EndTransformFeedback_ovr_0;
    
    // added in gl3.2
    private z_FenceSync_adr := GetFuncAdr('glFenceSync');
    private z_FenceSync_ovr_0 := GetFuncOrNil&<function(condition: SyncCondition; flags: DummyFlags): GLsync>(z_FenceSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FenceSync(condition: SyncCondition; flags: DummyFlags): GLsync :=
    z_FenceSync_ovr_0(condition, flags);
    
    // added in gl1.0
    private static procedure z_Finish_ovr_0;
    external 'opengl32.dll' name 'glFinish';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Finish :=
    z_Finish_ovr_0;
    
    // added in gl1.0
    private static procedure z_Flush_ovr_0;
    external 'opengl32.dll' name 'glFlush';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Flush :=
    z_Flush_ovr_0;
    
    // added in gl3.0
    private z_FlushMappedBufferRange_adr := GetFuncAdr('glFlushMappedBufferRange');
    private z_FlushMappedBufferRange_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; offset: IntPtr; length: IntPtr)>(z_FlushMappedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRange(target: BufferTargetARB; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedBufferRange_ovr_0(target, offset, length);
    
    // added in gl4.5
    private z_FlushMappedNamedBufferRange_adr := GetFuncAdr('glFlushMappedNamedBufferRange');
    private z_FlushMappedNamedBufferRange_ovr_0 := GetFuncOrNil&<procedure(buffer: BufferName; offset: IntPtr; length: IntPtr)>(z_FlushMappedNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRange(buffer: BufferName; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRange_ovr_0(buffer, offset, length);
    
    // added in gl4.3
    private z_FramebufferParameteri_adr := GetFuncAdr('glFramebufferParameteri');
    private z_FramebufferParameteri_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32)>(z_FramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteri(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteri_ovr_0(target, pname, param);
    
    // added in gl3.0
    private z_FramebufferRenderbuffer_adr := GetFuncAdr('glFramebufferRenderbuffer');
    private z_FramebufferRenderbuffer_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName)>(z_FramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbuffer(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_FramebufferRenderbuffer_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    // added in gl3.2
    private z_FramebufferTexture_adr := GetFuncAdr('glFramebufferTexture');
    private z_FramebufferTexture_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32)>(z_FramebufferTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32) :=
    z_FramebufferTexture_ovr_0(target, attachment, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture1D_adr := GetFuncAdr('glFramebufferTexture1D');
    private z_FramebufferTexture1D_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32)>(z_FramebufferTexture1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture1D_ovr_0(target, attachment, textarget, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture2D_adr := GetFuncAdr('glFramebufferTexture2D');
    private z_FramebufferTexture2D_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32)>(z_FramebufferTexture2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture2D_ovr_0(target, attachment, textarget, texture, level);
    
    // added in gl3.0
    private z_FramebufferTexture3D_adr := GetFuncAdr('glFramebufferTexture3D');
    private z_FramebufferTexture3D_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32)>(z_FramebufferTexture3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3D_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    // added in gl3.0
    private z_FramebufferTextureLayer_adr := GetFuncAdr('glFramebufferTextureLayer');
    private z_FramebufferTextureLayer_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32)>(z_FramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayer(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayer_ovr_0(target, attachment, texture, level, layer);
    
    // added in gl1.0
    private static procedure z_FrontFace_ovr_0(mode: FrontFaceDirection);
    external 'opengl32.dll' name 'glFrontFace';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrontFace(mode: FrontFaceDirection) :=
    z_FrontFace_ovr_0(mode);
    
    // added in gl1.5
    private z_GenBuffers_adr := GetFuncAdr('glGenBuffers');
    private z_GenBuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var buffers: BufferName)>(z_GenBuffers_adr);
    private z_GenBuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; buffers: array of BufferName) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_GenBuffers_ovr_0(n, buffers[0]) else
      z_GenBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; var buffers: BufferName) :=
    z_GenBuffers_ovr_0(n, buffers);
    private z_GenBuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; buffers: IntPtr)>(z_GenBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffers(n: Int32; buffers: IntPtr) :=
    z_GenBuffers_ovr_2(n, buffers);
    
    // added in gl3.0
    private z_GenerateMipmap_adr := GetFuncAdr('glGenerateMipmap');
    private z_GenerateMipmap_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget)>(z_GenerateMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmap(target: TextureTarget) :=
    z_GenerateMipmap_ovr_0(target);
    
    // added in gl4.5
    private z_GenerateTextureMipmap_adr := GetFuncAdr('glGenerateTextureMipmap');
    private z_GenerateTextureMipmap_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName)>(z_GenerateTextureMipmap_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmap(texture: TextureName) :=
    z_GenerateTextureMipmap_ovr_0(texture);
    
    // added in gl3.0
    private z_GenFramebuffers_adr := GetFuncAdr('glGenFramebuffers');
    private z_GenFramebuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var framebuffers: UInt32)>(z_GenFramebuffers_adr);
    private z_GenFramebuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffers_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_GenFramebuffers_ovr_0(n, framebuffers);
    private z_GenFramebuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; framebuffers: IntPtr)>(z_GenFramebuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffers_ovr_2(n, framebuffers);
    
    // added in gl4.1
    private z_GenProgramPipelines_adr := GetFuncAdr('glGenProgramPipelines');
    private z_GenProgramPipelines_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var pipelines: UInt32)>(z_GenProgramPipelines_adr);
    private z_GenProgramPipelines_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_GenProgramPipelines_ovr_0(n, pipelines[0]) else
      z_GenProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_GenProgramPipelines_ovr_0(n, pipelines);
    private z_GenProgramPipelines_ovr_2 := GetFuncOrNil&<procedure(n: Int32; pipelines: IntPtr)>(z_GenProgramPipelines_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_GenProgramPipelines_ovr_2(n, pipelines);
    
    // added in gl1.5
    private z_GenQueries_adr := GetFuncAdr('glGenQueries');
    private z_GenQueries_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var ids: UInt32)>(z_GenQueries_adr);
    private z_GenQueries_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenQueries_ovr_0(n, ids[0]) else
      z_GenQueries_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; var ids: UInt32) :=
    z_GenQueries_ovr_0(n, ids);
    private z_GenQueries_ovr_2 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenQueries_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueries(n: Int32; ids: IntPtr) :=
    z_GenQueries_ovr_2(n, ids);
    
    // added in gl3.0
    private z_GenRenderbuffers_adr := GetFuncAdr('glGenRenderbuffers');
    private z_GenRenderbuffers_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var renderbuffers: UInt32)>(z_GenRenderbuffers_adr);
    private z_GenRenderbuffers_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_GenRenderbuffers_ovr_0(n, renderbuffers);
    private z_GenRenderbuffers_ovr_2 := GetFuncOrNil&<procedure(n: Int32; renderbuffers: IntPtr)>(z_GenRenderbuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffers_ovr_2(n, renderbuffers);
    
    // added in gl3.3
    private z_GenSamplers_adr := GetFuncAdr('glGenSamplers');
    private z_GenSamplers_ovr_0 := GetFuncOrNil&<procedure(count: Int32; var samplers: UInt32)>(z_GenSamplers_adr);
    private z_GenSamplers_ovr_0_anh001 := GetFuncOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_GenSamplers_ovr_0(count, samplers[0]) else
      z_GenSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; var samplers: UInt32) :=
    z_GenSamplers_ovr_0(count, samplers);
    private z_GenSamplers_ovr_2 := GetFuncOrNil&<procedure(count: Int32; samplers: IntPtr)>(z_GenSamplers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: IntPtr) :=
    z_GenSamplers_ovr_2(count, samplers);
    
    // added in gl1.1
    private static procedure z_GenTextures_ovr_0(n: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glGenTextures';
    private static procedure z_GenTextures_ovr_0_anh001(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glGenTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_GenTextures_ovr_0(n, textures[0]) else
      z_GenTextures_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; var textures: UInt32) :=
    z_GenTextures_ovr_0(n, textures);
    private static procedure z_GenTextures_ovr_2(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glGenTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTextures(n: Int32; textures: IntPtr) :=
    z_GenTextures_ovr_2(n, textures);
    
    // added in gl4.0
    private z_GenTransformFeedbacks_adr := GetFuncAdr('glGenTransformFeedbacks');
    private z_GenTransformFeedbacks_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var ids: UInt32)>(z_GenTransformFeedbacks_adr);
    private z_GenTransformFeedbacks_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacks_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_GenTransformFeedbacks_ovr_0(n, ids);
    private z_GenTransformFeedbacks_ovr_2 := GetFuncOrNil&<procedure(n: Int32; ids: IntPtr)>(z_GenTransformFeedbacks_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacks_ovr_2(n, ids);
    
    // added in gl3.0
    private z_GenVertexArrays_adr := GetFuncAdr('glGenVertexArrays');
    private z_GenVertexArrays_ovr_0 := GetFuncOrNil&<procedure(n: Int32; var arrays: UInt32)>(z_GenVertexArrays_adr);
    private z_GenVertexArrays_ovr_0_anh001 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArrays_ovr_0(n, arrays[0]) else
      z_GenVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; var arrays: UInt32) :=
    z_GenVertexArrays_ovr_0(n, arrays);
    private z_GenVertexArrays_ovr_2 := GetFuncOrNil&<procedure(n: Int32; arrays: IntPtr)>(z_GenVertexArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: IntPtr) :=
    z_GenVertexArrays_ovr_2(n, arrays);
    
    // added in gl4.2
    private z_GetActiveAtomicCounterBufferiv_adr := GetFuncAdr('glGetActiveAtomicCounterBufferiv');
    private z_GetActiveAtomicCounterBufferiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32)>(z_GetActiveAtomicCounterBufferiv_adr);
    private z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params[0]) else
      z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001(&program, bufferIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32) :=
    z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params);
    private z_GetActiveAtomicCounterBufferiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr)>(z_GetActiveAtomicCounterBufferiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr) :=
    z_GetActiveAtomicCounterBufferiv_ovr_2(&program, bufferIndex, pname, &params);
    
    // added in gl2.0
    private z_GetActiveAttrib_adr := GetFuncAdr('glGetActiveAttrib');
    private z_GetActiveAttrib_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_0_anh00001110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttrib_ovr_0(&program, index, bufSize, length[0], size[0], &type[0], name) else
          z_GetActiveAttrib_ovr_0_anh00000010(&program, index, bufSize, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttrib_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type[0], name) else
          z_GetActiveAttrib_ovr_0_anh00000110(&program, index, bufSize, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttrib_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type[0], name) else
          z_GetActiveAttrib_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttrib_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetActiveAttrib_ovr_0_anh00001110(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetActiveAttrib_ovr_1_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_1_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_1_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttrib_ovr_0(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveAttrib_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttrib_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveAttrib_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetActiveAttrib_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_2_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_2_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_2_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttrib_ovr_2(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveAttrib_ovr_2_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttrib_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveAttrib_ovr_2_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetActiveAttrib_ovr_3_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_3_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_0(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveAttrib_ovr_0_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveAttrib_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetActiveAttrib_ovr_4_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttrib_ovr_0(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveAttrib_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveAttrib_ovr_5_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttrib_ovr_2(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveAttrib_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveAttrib_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_6_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_6_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_6_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_6(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveAttrib_ovr_6_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveAttrib_ovr_6_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetActiveAttrib_ovr_7_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttrib_ovr_6(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveAttrib_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveAttrib_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_8_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttrib_ovr_8(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveAttrib_ovr_8_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_0(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveAttrib_ovr_0_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveAttrib_ovr_0_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttrib_ovr_0(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveAttrib_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttrib_ovr_2(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveAttrib_ovr_2_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttrib_ovr_0(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveAttrib_ovr_0_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_0(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_2(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttrib_ovr_6(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveAttrib_ovr_6_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_6(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_8(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_18 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_18_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_18_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_18_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_18(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveAttrib_ovr_18_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttrib_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveAttrib_ovr_18_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetActiveAttrib_ovr_19_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttrib_ovr_18(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveAttrib_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    private z_GetActiveAttrib_ovr_20 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_20_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttrib_ovr_20(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveAttrib_ovr_20_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttrib_ovr_18(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveAttrib_ovr_18_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_18(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_20(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_24 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr)>(z_GetActiveAttrib_adr);
    private z_GetActiveAttrib_ovr_24_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttrib_ovr_24(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveAttrib_ovr_24_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttrib_ovr_24(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveAttrib_ovr_26 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveAttrib_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttrib(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttrib_ovr_26(&program, index, bufSize, length, size, &type, name);
    
    // added in gl4.0
    private z_GetActiveSubroutineName_adr := GetFuncAdr('glGetActiveSubroutineName');
    private z_GetActiveSubroutineName_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    private z_GetActiveSubroutineName_ovr_0_anh0000010 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length[0], name) else
      z_GetActiveSubroutineName_ovr_0_anh0000010(&program, _shadertype, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineName_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_2(&program, _shadertype, index, bufSize, length, name);
    
    // added in gl4.0
    private z_GetActiveSubroutineUniformiv_adr := GetFuncAdr('glGetActiveSubroutineUniformiv');
    private z_GetActiveSubroutineUniformiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32)>(z_GetActiveSubroutineUniformiv_adr);
    private z_GetActiveSubroutineUniformiv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values[0]) else
      z_GetActiveSubroutineUniformiv_ovr_0_anh000001(&program, _shadertype, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32) :=
    z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values);
    private z_GetActiveSubroutineUniformiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr)>(z_GetActiveSubroutineUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr) :=
    z_GetActiveSubroutineUniformiv_ovr_2(&program, _shadertype, index, pname, values);
    
    // added in gl4.0
    private z_GetActiveSubroutineUniformName_adr := GetFuncAdr('glGetActiveSubroutineUniformName');
    private z_GetActiveSubroutineUniformName_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    private z_GetActiveSubroutineUniformName_ovr_0_anh0000010 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length[0], name) else
      z_GetActiveSubroutineUniformName_ovr_0_anh0000010(&program, _shadertype, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private z_GetActiveSubroutineUniformName_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetActiveSubroutineUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_2(&program, _shadertype, index, bufSize, length, name);
    
    // added in gl2.0
    private z_GetActiveUniform_adr := GetFuncAdr('glGetActiveUniform');
    private z_GetActiveUniform_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_0_anh00001110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniform_ovr_0(&program, index, bufSize, length[0], size[0], &type[0], name) else
          z_GetActiveUniform_ovr_0_anh00000010(&program, index, bufSize, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniform_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type[0], name) else
          z_GetActiveUniform_ovr_0_anh00000110(&program, index, bufSize, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniform_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type[0], name) else
          z_GetActiveUniform_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniform_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetActiveUniform_ovr_0_anh00001110(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetActiveUniform_ovr_1_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_1_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_1_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniform_ovr_0(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveUniform_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniform_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveUniform_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetActiveUniform_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_2_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_2_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_2_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniform_ovr_2(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveUniform_ovr_2_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniform_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveUniform_ovr_2_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetActiveUniform_ovr_3_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_3_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_0(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveUniform_ovr_0_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveUniform_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetActiveUniform_ovr_4_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniform_ovr_0(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveUniform_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveUniform_ovr_5_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniform_ovr_2(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveUniform_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveUniform_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_6_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_6_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_6_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_6(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveUniform_ovr_6_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveUniform_ovr_6_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetActiveUniform_ovr_7_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniform_ovr_6(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveUniform_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetActiveUniform_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_8_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniform_ovr_8(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveUniform_ovr_8_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_0(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveUniform_ovr_0_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveUniform_ovr_0_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniform_ovr_0(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveUniform_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniform_ovr_2(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveUniform_ovr_2_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniform_ovr_0(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveUniform_ovr_0_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_0(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_2(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniform_ovr_6(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveUniform_ovr_6_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_6(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_8(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_18 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_18_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_18_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_18_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_18(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveUniform_ovr_18_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniform_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveUniform_ovr_18_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetActiveUniform_ovr_19_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniform_ovr_18(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveUniform_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    private z_GetActiveUniform_ovr_20 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_20_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniform_ovr_20(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveUniform_ovr_20_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniform_ovr_18(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveUniform_ovr_18_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_18(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_20(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_24 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr)>(z_GetActiveUniform_adr);
    private z_GetActiveUniform_ovr_24_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniform_ovr_24(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveUniform_ovr_24_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniform_ovr_24(&program, index, bufSize, length, size, &type, name);
    private z_GetActiveUniform_ovr_26 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetActiveUniform_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniform(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniform_ovr_26(&program, index, bufSize, length, size, &type, name);
    
    // added in gl3.1
    private z_GetActiveUniformBlockiv_adr := GetFuncAdr('glGetActiveUniformBlockiv');
    private z_GetActiveUniformBlockiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32)>(z_GetActiveUniformBlockiv_adr);
    private z_GetActiveUniformBlockiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params[0]) else
      z_GetActiveUniformBlockiv_ovr_0_anh00001(&program, uniformBlockIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32) :=
    z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params);
    private z_GetActiveUniformBlockiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr)>(z_GetActiveUniformBlockiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr) :=
    z_GetActiveUniformBlockiv_ovr_2(&program, uniformBlockIndex, pname, &params);
    
    // added in gl3.1
    private z_GetActiveUniformBlockName_adr := GetFuncAdr('glGetActiveUniformBlockName');
    private z_GetActiveUniformBlockName_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    private z_GetActiveUniformBlockName_ovr_0_anh000010 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: array of Int32; uniformBlockName: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length[0], uniformBlockName) else
      z_GetActiveUniformBlockName_ovr_0_anh000010(&program, uniformBlockIndex, bufSize, IntPtr.Zero, uniformBlockName);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    private z_GetActiveUniformBlockName_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr)>(z_GetActiveUniformBlockName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_2(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    
    // added in gl3.1
    private z_GetActiveUniformName_adr := GetFuncAdr('glGetActiveUniformName');
    private z_GetActiveUniformName_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    private z_GetActiveUniformName_ovr_0_anh000010 := GetFuncOrNil&<procedure(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: array of Int32; uniformName: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length[0], uniformName) else
      z_GetActiveUniformName_ovr_0_anh000010(&program, uniformIndex, bufSize, IntPtr.Zero, uniformName);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length, uniformName);
    private z_GetActiveUniformName_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr)>(z_GetActiveUniformName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_2(&program, uniformIndex, bufSize, length, uniformName);
    
    // added in gl3.1
    private z_GetActiveUniformsiv_adr := GetFuncAdr('glGetActiveUniformsiv');
    private z_GetActiveUniformsiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_0_anh000101 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: array of Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices[0], pname, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000101(&program, uniformCount, IntPtr.Zero, pname, IntPtr.Zero);
    private z_GetActiveUniformsiv_ovr_1_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; var &params: Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    private z_GetActiveUniformsiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_2_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: IntPtr) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_2_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32)>(z_GetActiveUniformsiv_adr);
    private z_GetActiveUniformsiv_ovr_6_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_6_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params);
    private z_GetActiveUniformsiv_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr)>(z_GetActiveUniformsiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_8(&program, uniformCount, uniformIndices, pname, &params);
    
    // added in gl2.0
    private z_GetAttachedShaders_adr := GetFuncAdr('glGetAttachedShaders');
    private z_GetAttachedShaders_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; var count: Int32; var shaders: UInt32)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_0_anh00010 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; var shaders: UInt32)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; var count: Int32; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_0_anh00011 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: array of Int32; shaders: array of UInt32) :=
    if (count<>nil) and (count.Length<>0) then
      if (shaders<>nil) and (shaders.Length<>0) then
        z_GetAttachedShaders_ovr_0(&program, maxCount, count[0], shaders[0]) else
        z_GetAttachedShaders_ovr_0_anh00001(&program, maxCount, count[0], IntPtr.Zero) else
      if (shaders<>nil) and (shaders.Length<>0) then
        z_GetAttachedShaders_ovr_0_anh00010(&program, maxCount, IntPtr.Zero, shaders[0]) else
        z_GetAttachedShaders_ovr_0_anh00011(&program, maxCount, IntPtr.Zero, IntPtr.Zero);
    private z_GetAttachedShaders_ovr_1_anh00010 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; var shaders: UInt32)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: array of Int32; var shaders: UInt32) :=
    if (count<>nil) and (count.Length<>0) then
      z_GetAttachedShaders_ovr_0(&program, maxCount, count[0], shaders) else
      z_GetAttachedShaders_ovr_0_anh00010(&program, maxCount, IntPtr.Zero, shaders);
    private z_GetAttachedShaders_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; var count: Int32; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_2_anh00010 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: array of Int32; shaders: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_GetAttachedShaders_ovr_2(&program, maxCount, count[0], shaders) else
      z_GetAttachedShaders_ovr_2_anh00010(&program, maxCount, IntPtr.Zero, shaders);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; var count: Int32; shaders: array of UInt32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_GetAttachedShaders_ovr_0(&program, maxCount, count, shaders[0]) else
      z_GetAttachedShaders_ovr_0_anh00001(&program, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; var count: Int32; var shaders: UInt32) :=
    z_GetAttachedShaders_ovr_0(&program, maxCount, count, shaders);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; var count: Int32; shaders: IntPtr) :=
    z_GetAttachedShaders_ovr_2(&program, maxCount, count, shaders);
    private z_GetAttachedShaders_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; var shaders: UInt32)>(z_GetAttachedShaders_adr);
    private z_GetAttachedShaders_ovr_6_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: array of UInt32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_GetAttachedShaders_ovr_6(&program, maxCount, count, shaders[0]) else
      z_GetAttachedShaders_ovr_6_anh00001(&program, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: IntPtr; var shaders: UInt32) :=
    z_GetAttachedShaders_ovr_6(&program, maxCount, count, shaders);
    private z_GetAttachedShaders_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: IntPtr)>(z_GetAttachedShaders_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedShaders(&program: UInt32; maxCount: Int32; count: IntPtr; shaders: IntPtr) :=
    z_GetAttachedShaders_ovr_8(&program, maxCount, count, shaders);
    
    // added in gl2.0
    private z_GetAttribLocation_adr := GetFuncAdr('glGetAttribLocation');
    private z_GetAttribLocation_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; name: IntPtr): Int32>(z_GetAttribLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocation(&program: ProgramName; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetAttribLocation_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocation(&program: ProgramName; name: IntPtr): Int32 :=
    z_GetAttribLocation_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetBooleani_v_adr := GetFuncAdr('glGetBooleani_v');
    private z_GetBooleani_v_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; index: UInt32; var data: boolean)>(z_GetBooleani_v_adr);
    private z_GetBooleani_v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: BufferTargetARB; index: UInt32; data: IntPtr)>(z_GetBooleani_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTargetARB; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleani_v_ovr_0(target, index, data[0]) else
      z_GetBooleani_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTargetARB; index: UInt32; var data: boolean) :=
    z_GetBooleani_v_ovr_0(target, index, data);
    private z_GetBooleani_v_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; index: UInt32; data: IntPtr)>(z_GetBooleani_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleani_v(target: BufferTargetARB; index: UInt32; data: IntPtr) :=
    z_GetBooleani_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private static procedure z_GetBooleanv_ovr_0(pname: GetPName; var data: boolean);
    external 'opengl32.dll' name 'glGetBooleanv';
    private static procedure z_GetBooleanv_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanv_ovr_0(pname, data[0]) else
      z_GetBooleanv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; var data: boolean) :=
    z_GetBooleanv_ovr_0(pname, data);
    private static procedure z_GetBooleanv_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanv(pname: GetPName; data: IntPtr) :=
    z_GetBooleanv_ovr_2(pname, data);
    
    // added in gl3.2
    private z_GetBufferParameteri64v_adr := GetFuncAdr('glGetBufferParameteri64v');
    private z_GetBufferParameteri64v_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int64)>(z_GetBufferParameteri64v_adr);
    private z_GetBufferParameteri64v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTargetARB; pname: BufferPNameARB; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameteri64v_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameteri64v_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int64) :=
    z_GetBufferParameteri64v_ovr_0(target, pname, &params);
    private z_GetBufferParameteri64v_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteri64v(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameteri64v_ovr_2(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferParameteriv_adr := GetFuncAdr('glGetBufferParameteriv');
    private z_GetBufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int32)>(z_GetBufferParameteriv_adr);
    private z_GetBufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTargetARB; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int32) :=
    z_GetBufferParameteriv_ovr_0(target, pname, &params);
    private z_GetBufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr)>(z_GetBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameteriv(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferPointerv_adr := GetFuncAdr('glGetBufferPointerv');
    private z_GetBufferPointerv_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPointerNameARB; var &params: IntPtr)>(z_GetBufferPointerv_adr);
    private z_GetBufferPointerv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPointerNameARB; &params: IntPtr)>(z_GetBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointerv(target: BufferTargetARB; pname: BufferPointerNameARB; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferPointerv_ovr_0(target, pname, &params[0]) else
      z_GetBufferPointerv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointerv(target: BufferTargetARB; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetBufferPointerv_ovr_0(target, pname, &params);
    private z_GetBufferPointerv_ovr_2 := GetFuncOrNil&<procedure(target: BufferTargetARB; pname: BufferPointerNameARB; &params: pointer)>(z_GetBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointerv(target: BufferTargetARB; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetBufferPointerv_ovr_2(target, pname, &params);
    
    // added in gl1.5
    private z_GetBufferSubData_adr := GetFuncAdr('glGetBufferSubData');
    private z_GetBufferSubData_ovr_0 := GetFuncOrNil&<procedure(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferSubData(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetBufferSubData_ovr_0(target, offset, size, data);
    
    // added in gl1.3
    private z_GetCompressedTexImage_adr := GetFuncAdr('glGetCompressedTexImage');
    private z_GetCompressedTexImage_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; img: IntPtr)>(z_GetCompressedTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTexImage(target: TextureTarget; level: Int32; img: IntPtr) :=
    z_GetCompressedTexImage_ovr_0(target, level, img);
    
    // added in gl4.5
    private z_GetCompressedTextureImage_adr := GetFuncAdr('glGetCompressedTextureImage');
    private z_GetCompressedTextureImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImage(texture: UInt32; level: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureImage_ovr_0(texture, level, bufSize, pixels);
    
    // added in gl4.5
    private z_GetCompressedTextureSubImage_adr := GetFuncAdr('glGetCompressedTextureSubImage');
    private z_GetCompressedTextureSubImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetCompressedTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, bufSize, pixels);
    
    // added in gl4.3
    private z_GetDebugMessageLog_adr := GetFuncAdr('glGetDebugMessageLog');
    private z_GetDebugMessageLog_ovr_0 := GetFuncOrNil&<function(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private z_GetDebugMessageLog_ovr_1 := GetFuncOrNil&<function(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32>(z_GetDebugMessageLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
    // added in gl4.1
    private z_GetDoublei_v_adr := GetFuncAdr('glGetDoublei_v');
    private z_GetDoublei_v_ovr_0 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; var data: real)>(z_GetDoublei_v_adr);
    private z_GetDoublei_v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublei_v_ovr_0(target, index, data[0]) else
      z_GetDoublei_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; var data: real) :=
    z_GetDoublei_v_ovr_0(target, index, data);
    private z_GetDoublei_v_ovr_2 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetDoublei_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetDoublei_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private static procedure z_GetDoublev_ovr_0(pname: GetPName; var data: real);
    external 'opengl32.dll' name 'glGetDoublev';
    private static procedure z_GetDoublev_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoublev';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublev_ovr_0(pname, data[0]) else
      z_GetDoublev_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; var data: real) :=
    z_GetDoublev_ovr_0(pname, data);
    private static procedure z_GetDoublev_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoublev';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublev(pname: GetPName; data: IntPtr) :=
    z_GetDoublev_ovr_2(pname, data);
    
    // added in gl1.0
    private static function z_GetError_ovr_0: ErrorCode;
    external 'opengl32.dll' name 'glGetError';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetError: ErrorCode :=
    z_GetError_ovr_0;
    
    // added in gl4.1
    private z_GetFloati_v_adr := GetFuncAdr('glGetFloati_v');
    private z_GetFloati_v_ovr_0 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; var data: single)>(z_GetFloati_v_adr);
    private z_GetFloati_v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloati_v_ovr_0(target, index, data[0]) else
      z_GetFloati_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; var data: single) :=
    z_GetFloati_v_ovr_0(target, index, data);
    private z_GetFloati_v_ovr_2 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetFloati_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetFloati_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private static procedure z_GetFloatv_ovr_0(pname: GetPName; var data: single);
    external 'opengl32.dll' name 'glGetFloatv';
    private static procedure z_GetFloatv_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloatv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloatv_ovr_0(pname, data[0]) else
      z_GetFloatv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; var data: single) :=
    z_GetFloatv_ovr_0(pname, data);
    private static procedure z_GetFloatv_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloatv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatv(pname: GetPName; data: IntPtr) :=
    z_GetFloatv_ovr_2(pname, data);
    
    // added in gl3.3
    private z_GetFragDataIndex_adr := GetFuncAdr('glGetFragDataIndex');
    private z_GetFragDataIndex_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; name: IntPtr): Int32>(z_GetFragDataIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: ProgramName; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetFragDataIndex_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: ProgramName; name: IntPtr): Int32 :=
    z_GetFragDataIndex_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetFragDataLocation_adr := GetFuncAdr('glGetFragDataLocation');
    private z_GetFragDataLocation_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; name: IntPtr): Int32>(z_GetFragDataLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocation(&program: ProgramName; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetFragDataLocation_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocation(&program: ProgramName; name: IntPtr): Int32 :=
    z_GetFragDataLocation_ovr_0(&program, name);
    
    // added in gl3.0
    private z_GetFramebufferAttachmentParameteriv_adr := GetFuncAdr('glGetFramebufferAttachmentParameteriv');
    private z_GetFramebufferAttachmentParameteriv_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferAttachmentParameteriv_adr);
    private z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params);
    private z_GetFramebufferAttachmentParameteriv_ovr_2 := GetFuncOrNil&<procedure(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameteriv_ovr_2(target, attachment, pname, &params);
    
    // added in gl4.3
    private z_GetFramebufferParameteriv_adr := GetFuncAdr('glGetFramebufferParameteriv');
    private z_GetFramebufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetFramebufferParameteriv_adr);
    private z_GetFramebufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameteriv_ovr_0(target, pname, &params);
    private z_GetFramebufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.5
    private z_GetGraphicsResetStatus_adr := GetFuncAdr('glGetGraphicsResetStatus');
    private z_GetGraphicsResetStatus_ovr_0 := GetFuncOrNil&<function: GraphicsResetStatus>(z_GetGraphicsResetStatus_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatus: GraphicsResetStatus :=
    z_GetGraphicsResetStatus_ovr_0;
    
    // added in gl3.2
    private z_GetInteger64i_v_adr := GetFuncAdr('glGetInteger64i_v');
    private z_GetInteger64i_v_ovr_0 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; var data: Int64)>(z_GetInteger64i_v_adr);
    private z_GetInteger64i_v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetInteger64i_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: DummyEnum; index: UInt32; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64i_v_ovr_0(target, index, data[0]) else
      z_GetInteger64i_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: DummyEnum; index: UInt32; var data: Int64) :=
    z_GetInteger64i_v_ovr_0(target, index, data);
    private z_GetInteger64i_v_ovr_2 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetInteger64i_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64i_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetInteger64i_v_ovr_2(target, index, data);
    
    // added in gl3.2
    private z_GetInteger64v_adr := GetFuncAdr('glGetInteger64v');
    private z_GetInteger64v_ovr_0 := GetFuncOrNil&<procedure(pname: GetPName; var data: Int64)>(z_GetInteger64v_adr);
    private z_GetInteger64v_ovr_0_anh001 := GetFuncOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64v_ovr_0(pname, data[0]) else
      z_GetInteger64v_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; var data: Int64) :=
    z_GetInteger64v_ovr_0(pname, data);
    private z_GetInteger64v_ovr_2 := GetFuncOrNil&<procedure(pname: GetPName; data: IntPtr)>(z_GetInteger64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: IntPtr) :=
    z_GetInteger64v_ovr_2(pname, data);
    
    // added in gl3.0
    private z_GetIntegeri_v_adr := GetFuncAdr('glGetIntegeri_v');
    private z_GetIntegeri_v_ovr_0 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; var data: Int32)>(z_GetIntegeri_v_adr);
    private z_GetIntegeri_v_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegeri_v_ovr_0(target, index, data[0]) else
      z_GetIntegeri_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; var data: Int32) :=
    z_GetIntegeri_v_ovr_0(target, index, data);
    private z_GetIntegeri_v_ovr_2 := GetFuncOrNil&<procedure(target: DummyEnum; index: UInt32; data: IntPtr)>(z_GetIntegeri_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetIntegeri_v_ovr_2(target, index, data);
    
    // added in gl1.0
    private static procedure z_GetIntegerv_ovr_0(pname: GetPName; var data: Int32);
    external 'opengl32.dll' name 'glGetIntegerv';
    private static procedure z_GetIntegerv_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerv_ovr_0(pname, data[0]) else
      z_GetIntegerv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; var data: Int32) :=
    z_GetIntegerv_ovr_0(pname, data);
    private static procedure z_GetIntegerv_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerv(pname: GetPName; data: IntPtr) :=
    z_GetIntegerv_ovr_2(pname, data);
    
    // added in gl4.3
    private z_GetInternalformati64v_adr := GetFuncAdr('glGetInternalformati64v');
    private z_GetInternalformati64v_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64)>(z_GetInternalformati64v_adr);
    private z_GetInternalformati64v_ovr_0_anh000001 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformati64v_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64) :=
    z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformati64v_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformati64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformati64v_ovr_2(target, _internalformat, pname, count, &params);
    
    // added in gl4.2
    private z_GetInternalformativ_adr := GetFuncAdr('glGetInternalformativ');
    private z_GetInternalformativ_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32)>(z_GetInternalformativ_adr);
    private z_GetInternalformativ_ovr_0_anh000001 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformativ_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params);
    private z_GetInternalformativ_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr)>(z_GetInternalformativ_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformativ_ovr_2(target, _internalformat, pname, count, &params);
    
    // added in gl3.2
    private z_GetMultisamplefv_adr := GetFuncAdr('glGetMultisamplefv');
    private z_GetMultisamplefv_ovr_0 := GetFuncOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; var val: single)>(z_GetMultisamplefv_adr);
    private z_GetMultisamplefv_ovr_0_anh0001 := GetFuncOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefv_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefv_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefv_ovr_0(pname, index, val);
    private z_GetMultisamplefv_ovr_2 := GetFuncOrNil&<procedure(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr)>(z_GetMultisamplefv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefv_ovr_2(pname, index, val);
    
    // added in gl4.5
    private z_GetNamedBufferParameteri64v_adr := GetFuncAdr('glGetNamedBufferParameteri64v');
    private z_GetNamedBufferParameteri64v_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int64)>(z_GetNamedBufferParameteri64v_adr);
    private z_GetNamedBufferParameteri64v_ovr_0_anh0001 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteri64v_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int64) :=
    z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteri64v_ovr_2 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr)>(z_GetNamedBufferParameteri64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameteri64v_ovr_2(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferParameteriv_adr := GetFuncAdr('glGetNamedBufferParameteriv');
    private z_GetNamedBufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32)>(z_GetNamedBufferParameteriv_adr);
    private z_GetNamedBufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteriv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32) :=
    z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr)>(z_GetNamedBufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameteriv_ovr_2(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferPointerv_adr := GetFuncAdr('glGetNamedBufferPointerv');
    private z_GetNamedBufferPointerv_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr)>(z_GetNamedBufferPointerv_adr);
    private z_GetNamedBufferPointerv_ovr_0_anh0001 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferPointerv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr) :=
    z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params);
    private z_GetNamedBufferPointerv_ovr_2 := GetFuncOrNil&<procedure(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer)>(z_GetNamedBufferPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer) :=
    z_GetNamedBufferPointerv_ovr_2(buffer, pname, &params);
    
    // added in gl4.5
    private z_GetNamedBufferSubData_adr := GetFuncAdr('glGetNamedBufferSubData');
    private z_GetNamedBufferSubData_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_GetNamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubData_ovr_0(buffer, offset, size, data);
    
    // added in gl4.5
    private z_GetNamedFramebufferAttachmentParameteriv_adr := GetFuncAdr('glGetNamedFramebufferAttachmentParameteriv');
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001 := GetFuncOrNil&<procedure(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params);
    private z_GetNamedFramebufferAttachmentParameteriv_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr)>(z_GetNamedFramebufferAttachmentParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_2(framebuffer, attachment, pname, &params);
    
    // added in gl4.5
    private z_GetNamedFramebufferParameteriv_adr := GetFuncAdr('glGetNamedFramebufferParameteriv');
    private z_GetNamedFramebufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; pname: GetFramebufferParameter; var param: Int32)>(z_GetNamedFramebufferParameteriv_adr);
    private z_GetNamedFramebufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param[0]) else
      z_GetNamedFramebufferParameteriv_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; var param: Int32) :=
    z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param);
    private z_GetNamedFramebufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr)>(z_GetNamedFramebufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr) :=
    z_GetNamedFramebufferParameteriv_ovr_2(framebuffer, pname, param);
    
    // added in gl4.5
    private z_GetNamedRenderbufferParameteriv_adr := GetFuncAdr('glGetNamedRenderbufferParameteriv');
    private z_GetNamedRenderbufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32)>(z_GetNamedRenderbufferParameteriv_adr);
    private z_GetNamedRenderbufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameteriv_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params);
    private z_GetNamedRenderbufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetNamedRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameteriv_ovr_2(renderbuffer, pname, &params);
    
    // added in gl4.5
    private z_GetnColorTable_adr := GetFuncAdr('glGetnColorTable');
    private z_GetnColorTable_ovr_0 := GetFuncOrNil&<procedure(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr)>(z_GetnColorTable_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnColorTable(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr) :=
    z_GetnColorTable_ovr_0(target, format, &type, bufSize, table);
    
    // added in gl4.5
    private z_GetnCompressedTexImage_adr := GetFuncAdr('glGetnCompressedTexImage');
    private z_GetnCompressedTexImage_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; lod: Int32; bufSize: Int32; pixels: IntPtr)>(z_GetnCompressedTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnCompressedTexImage(target: TextureTarget; lod: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetnCompressedTexImage_ovr_0(target, lod, bufSize, pixels);
    
    // added in gl4.5
    private z_GetnConvolutionFilter_adr := GetFuncAdr('glGetnConvolutionFilter');
    private z_GetnConvolutionFilter_ovr_0 := GetFuncOrNil&<procedure(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr)>(z_GetnConvolutionFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnConvolutionFilter(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr) :=
    z_GetnConvolutionFilter_ovr_0(target, format, &type, bufSize, image);
    
    // added in gl4.5
    private z_GetnHistogram_adr := GetFuncAdr('glGetnHistogram');
    private z_GetnHistogram_ovr_0 := GetFuncOrNil&<procedure(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnHistogram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnHistogram(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnHistogram_ovr_0(target, reset, format, &type, bufSize, values);
    
    // added in gl4.5
    private z_GetnMapdv_adr := GetFuncAdr('glGetnMapdv');
    private z_GetnMapdv_ovr_0 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real)>(z_GetnMapdv_adr);
    private z_GetnMapdv_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapdv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapdv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real) :=
    z_GetnMapdv_ovr_0(target, query, bufSize, v);
    private z_GetnMapdv_ovr_2 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapdv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMapfv_adr := GetFuncAdr('glGetnMapfv');
    private z_GetnMapfv_ovr_0 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single)>(z_GetnMapfv_adr);
    private z_GetnMapfv_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapfv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapfv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single) :=
    z_GetnMapfv_ovr_0(target, query, bufSize, v);
    private z_GetnMapfv_ovr_2 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapfv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMapiv_adr := GetFuncAdr('glGetnMapiv');
    private z_GetnMapiv_ovr_0 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32)>(z_GetnMapiv_adr);
    private z_GetnMapiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapiv_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapiv_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32) :=
    z_GetnMapiv_ovr_0(target, query, bufSize, v);
    private z_GetnMapiv_ovr_2 := GetFuncOrNil&<procedure(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr)>(z_GetnMapiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapiv(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapiv_ovr_2(target, query, bufSize, v);
    
    // added in gl4.5
    private z_GetnMinmax_adr := GetFuncAdr('glGetnMinmax');
    private z_GetnMinmax_ovr_0 := GetFuncOrNil&<procedure(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr)>(z_GetnMinmax_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMinmax(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnMinmax_ovr_0(target, reset, format, &type, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapfv_adr := GetFuncAdr('glGetnPixelMapfv');
    private z_GetnPixelMapfv_ovr_0 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: single)>(z_GetnPixelMapfv_adr);
    private z_GetnPixelMapfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapfv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapfv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; var values: single) :=
    z_GetnPixelMapfv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapfv_ovr_2 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapfv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapuiv_adr := GetFuncAdr('glGetnPixelMapuiv');
    private z_GetnPixelMapuiv_ovr_0 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt32)>(z_GetnPixelMapuiv_adr);
    private z_GetnPixelMapuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapuiv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapuiv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; var values: UInt32) :=
    z_GetnPixelMapuiv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapuiv_ovr_2 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuiv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapuiv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPixelMapusv_adr := GetFuncAdr('glGetnPixelMapusv');
    private z_GetnPixelMapusv_ovr_0 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; var values: UInt16)>(z_GetnPixelMapusv_adr);
    private z_GetnPixelMapusv_ovr_0_anh0001 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapusv_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapusv_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; var values: UInt16) :=
    z_GetnPixelMapusv_ovr_0(map, bufSize, values);
    private z_GetnPixelMapusv_ovr_2 := GetFuncOrNil&<procedure(map: PixelMap; bufSize: Int32; values: IntPtr)>(z_GetnPixelMapusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusv(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapusv_ovr_2(map, bufSize, values);
    
    // added in gl4.5
    private z_GetnPolygonStipple_adr := GetFuncAdr('glGetnPolygonStipple');
    private z_GetnPolygonStipple_ovr_0 := GetFuncOrNil&<procedure(bufSize: Int32; var pattern: Byte)>(z_GetnPolygonStipple_adr);
    private z_GetnPolygonStipple_ovr_0_anh001 := GetFuncOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; pattern: array of Byte) :=
    if (pattern<>nil) and (pattern.Length<>0) then
      z_GetnPolygonStipple_ovr_0(bufSize, pattern[0]) else
      z_GetnPolygonStipple_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; var pattern: Byte) :=
    z_GetnPolygonStipple_ovr_0(bufSize, pattern);
    private z_GetnPolygonStipple_ovr_2 := GetFuncOrNil&<procedure(bufSize: Int32; pattern: IntPtr)>(z_GetnPolygonStipple_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStipple(bufSize: Int32; pattern: IntPtr) :=
    z_GetnPolygonStipple_ovr_2(bufSize, pattern);
    
    // added in gl4.5
    private z_GetnSeparableFilter_adr := GetFuncAdr('glGetnSeparableFilter');
    private z_GetnSeparableFilter_ovr_0 := GetFuncOrNil&<procedure(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr)>(z_GetnSeparableFilter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnSeparableFilter(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr) :=
    z_GetnSeparableFilter_ovr_0(target, format, &type, rowBufSize, row, columnBufSize, column, span);
    
    // added in gl4.5
    private z_GetnTexImage_adr := GetFuncAdr('glGetnTexImage');
    private z_GetnTexImage_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetnTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnTexImage(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetnTexImage_ovr_0(target, level, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetnUniformdv_adr := GetFuncAdr('glGetnUniformdv');
    private z_GetnUniformdv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; var &params: real)>(z_GetnUniformdv_adr);
    private z_GetnUniformdv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformdv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformdv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: real) :=
    z_GetnUniformdv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformdv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformdv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformfv_adr := GetFuncAdr('glGetnUniformfv');
    private z_GetnUniformfv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; var &params: single)>(z_GetnUniformfv_adr);
    private z_GetnUniformfv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformfv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformiv_adr := GetFuncAdr('glGetnUniformiv');
    private z_GetnUniformiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; var &params: Int32)>(z_GetnUniformiv_adr);
    private z_GetnUniformiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformiv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.5
    private z_GetnUniformuiv_adr := GetFuncAdr('glGetnUniformuiv');
    private z_GetnUniformuiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; var &params: UInt32)>(z_GetnUniformuiv_adr);
    private z_GetnUniformuiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params);
    private z_GetnUniformuiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr)>(z_GetnUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuiv_ovr_2(&program, location, bufSize, &params);
    
    // added in gl4.3
    private z_GetObjectLabel_adr := GetFuncAdr('glGetObjectLabel');
    private z_GetObjectLabel_ovr_0 := GetFuncOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectLabel_adr);
    private z_GetObjectLabel_ovr_0_anh000010 := GetFuncOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: array of Int32; &label: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetObjectLabel_ovr_0(identifier, name, bufSize, length[0], &label) else
      z_GetObjectLabel_ovr_0_anh000010(identifier, name, bufSize, IntPtr.Zero, &label);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabel_ovr_0(identifier, name, bufSize, length, &label);
    private z_GetObjectLabel_ovr_2 := GetFuncOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabel_ovr_2(identifier, name, bufSize, length, &label);
    
    // added in gl4.3
    private z_GetObjectPtrLabel_adr := GetFuncAdr('glGetObjectPtrLabel');
    private z_GetObjectPtrLabel_ovr_0 := GetFuncOrNil&<procedure(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    private z_GetObjectPtrLabel_ovr_0_anh00010 := GetFuncOrNil&<procedure(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: array of Int32; &label: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length[0], &label) else
      z_GetObjectPtrLabel_ovr_0_anh00010(ptr, bufSize, IntPtr.Zero, &label);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length, &label);
    private z_GetObjectPtrLabel_ovr_2 := GetFuncOrNil&<procedure(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr)>(z_GetObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_2(ptr, bufSize, length, &label);
    
    // added in gl4.3
    private z_GetPointerv_adr := GetFuncAdr('glGetPointerv');
    private z_GetPointerv_ovr_0 := GetFuncOrNil&<procedure(pname: GetPointervPName; var &params: IntPtr)>(z_GetPointerv_adr);
    private z_GetPointerv_ovr_0_anh001 := GetFuncOrNil&<procedure(pname: GetPointervPName; &params: IntPtr)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPointerv_ovr_0(pname, &params[0]) else
      z_GetPointerv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointerv_ovr_0(pname, &params);
    private z_GetPointerv_ovr_2 := GetFuncOrNil&<procedure(pname: GetPointervPName; &params: pointer)>(z_GetPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: pointer) :=
    z_GetPointerv_ovr_2(pname, &params);
    
    // added in gl4.1
    private z_GetProgramBinary_adr := GetFuncAdr('glGetProgramBinary');
    private z_GetProgramBinary_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    private z_GetProgramBinary_ovr_0_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    private z_GetProgramBinary_ovr_0_anh000010 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    private z_GetProgramBinary_ovr_0_anh000110 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
        z_GetProgramBinary_ovr_0(&program, bufSize, length[0], binaryFormat[0], binary) else
        z_GetProgramBinary_ovr_0_anh000010(&program, bufSize, length[0], IntPtr.Zero, binary) else
      if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
        z_GetProgramBinary_ovr_0_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat[0], binary) else
        z_GetProgramBinary_ovr_0_anh000110(&program, bufSize, IntPtr.Zero, IntPtr.Zero, binary);
    private z_GetProgramBinary_ovr_1_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramBinary_ovr_0(&program, bufSize, length[0], binaryFormat, binary) else
      z_GetProgramBinary_ovr_0_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat, binary);
    private z_GetProgramBinary_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    private z_GetProgramBinary_ovr_2_anh000100 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramBinary_ovr_2(&program, bufSize, length[0], binaryFormat, binary) else
      z_GetProgramBinary_ovr_2_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
      z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat[0], binary) else
      z_GetProgramBinary_ovr_0_anh000010(&program, bufSize, length, IntPtr.Zero, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_2(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr)>(z_GetProgramBinary_adr);
    private z_GetProgramBinary_ovr_6_anh000010 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
      z_GetProgramBinary_ovr_6(&program, bufSize, length, binaryFormat[0], binary) else
      z_GetProgramBinary_ovr_6_anh000010(&program, bufSize, length, IntPtr.Zero, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_6(&program, bufSize, length, binaryFormat, binary);
    private z_GetProgramBinary_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr)>(z_GetProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_8(&program, bufSize, length, binaryFormat, binary);
    
    // added in gl2.0
    private z_GetProgramInfoLog_adr := GetFuncAdr('glGetProgramInfoLog');
    private z_GetProgramInfoLog_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetProgramInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInfoLog(&program: ProgramName; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramInfoLog_ovr_0(&program, bufSize, length, infoLog);
    private z_GetProgramInfoLog_ovr_1 := GetFuncOrNil&<procedure(&program: ProgramName; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInfoLog(&program: ProgramName; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramInfoLog_ovr_1(&program, bufSize, length, infoLog);
    
    // added in gl4.3
    private z_GetProgramInterfaceiv_adr := GetFuncAdr('glGetProgramInterfaceiv');
    private z_GetProgramInterfaceiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32)>(z_GetProgramInterfaceiv_adr);
    private z_GetProgramInterfaceiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params[0]) else
      z_GetProgramInterfaceiv_ovr_0_anh00001(&program, _programInterface, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32) :=
    z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params);
    private z_GetProgramInterfaceiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr)>(z_GetProgramInterfaceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr) :=
    z_GetProgramInterfaceiv_ovr_2(&program, _programInterface, pname, &params);
    
    // added in gl2.0
    private z_GetProgramiv_adr := GetFuncAdr('glGetProgramiv');
    private z_GetProgramiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; pname: ProgramPropertyARB; var &params: Int32)>(z_GetProgramiv_adr);
    private z_GetProgramiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(&program: ProgramName; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: ProgramName; pname: ProgramPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramiv_ovr_0(&program, pname, &params[0]) else
      z_GetProgramiv_ovr_0_anh0001(&program, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: ProgramName; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramiv_ovr_0(&program, pname, &params);
    private z_GetProgramiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; pname: ProgramPropertyARB; &params: IntPtr)>(z_GetProgramiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramiv(&program: ProgramName; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramiv_ovr_2(&program, pname, &params);
    
    // added in gl4.1
    private z_GetProgramPipelineInfoLog_adr := GetFuncAdr('glGetProgramPipelineInfoLog');
    private z_GetProgramPipelineInfoLog_ovr_0 := GetFuncOrNil&<procedure(pipeline: UInt32; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    private z_GetProgramPipelineInfoLog_ovr_0_anh00010 := GetFuncOrNil&<procedure(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; length: array of Int32; infoLog: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length[0], infoLog) else
      z_GetProgramPipelineInfoLog_ovr_0_anh00010(pipeline, bufSize, IntPtr.Zero, infoLog);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length, infoLog);
    private z_GetProgramPipelineInfoLog_ovr_2 := GetFuncOrNil&<procedure(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetProgramPipelineInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_2(pipeline, bufSize, length, infoLog);
    
    // added in gl4.1
    private z_GetProgramPipelineiv_adr := GetFuncAdr('glGetProgramPipelineiv');
    private z_GetProgramPipelineiv_ovr_0 := GetFuncOrNil&<procedure(pipeline: UInt32; pname: PipelineParameterName; var &params: Int32)>(z_GetProgramPipelineiv_adr);
    private z_GetProgramPipelineiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params[0]) else
      z_GetProgramPipelineiv_ovr_0_anh0001(pipeline, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; var &params: Int32) :=
    z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params);
    private z_GetProgramPipelineiv_ovr_2 := GetFuncOrNil&<procedure(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr)>(z_GetProgramPipelineiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr) :=
    z_GetProgramPipelineiv_ovr_2(pipeline, pname, &params);
    
    // added in gl4.3
    private z_GetProgramResourceIndex_adr := GetFuncAdr('glGetProgramResourceIndex');
    private z_GetProgramResourceIndex_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): UInt32>(z_GetProgramResourceIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: ProgramName; _programInterface: ProgramInterface; name: string): UInt32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): UInt32 :=
    z_GetProgramResourceIndex_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceiv_adr := GetFuncAdr('glGetProgramResourceiv');
    private z_GetProgramResourceiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000000001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000000011 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_0_anh000001011 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000000011(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000001011(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_1_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_1_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_1_anh000001010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourceiv_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private z_GetProgramResourceiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_2_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_2_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_2_anh000001010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourceiv_ovr_2_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourceiv_ovr_2_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private z_GetProgramResourceiv_ovr_3_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_3_anh000001001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_4_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_5_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_6_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_6_anh000000001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_6_anh000001001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_6_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_6_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_7_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private z_GetProgramResourceiv_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_8_anh000001000 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_8(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_8_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; var &params: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_2_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_6_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_8(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_18 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_18_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_18_anh000000001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_18_anh000000011 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourceiv_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourceiv_ovr_18_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    private z_GetProgramResourceiv_ovr_19_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; var &params: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    private z_GetProgramResourceiv_ovr_20 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_20_anh000000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_20(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_20_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_20(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_24 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32)>(z_GetProgramResourceiv_adr);
    private z_GetProgramResourceiv_ovr_24_anh000000001 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_24_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params);
    private z_GetProgramResourceiv_ovr_26 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr)>(z_GetProgramResourceiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_26(&program, _programInterface, index, propCount, props, count, length, &params);
    
    // added in gl4.3
    private z_GetProgramResourceLocation_adr := GetFuncAdr('glGetProgramResourceLocation');
    private z_GetProgramResourceLocation_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: ProgramName; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceLocation_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocation_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceLocationIndex_adr := GetFuncAdr('glGetProgramResourceLocationIndex');
    private z_GetProgramResourceLocationIndex_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32>(z_GetProgramResourceLocationIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: ProgramName; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, name);
    
    // added in gl4.3
    private z_GetProgramResourceName_adr := GetFuncAdr('glGetProgramResourceName');
    private z_GetProgramResourceName_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr)>(z_GetProgramResourceName_adr);
    private z_GetProgramResourceName_ovr_0_anh0000010 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length[0], name) else
      z_GetProgramResourceName_ovr_0_anh0000010(&program, _programInterface, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length, name);
    private z_GetProgramResourceName_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr)>(z_GetProgramResourceName_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetProgramResourceName_ovr_2(&program, _programInterface, index, bufSize, length, name);
    
    // added in gl4.0
    private z_GetProgramStageiv_adr := GetFuncAdr('glGetProgramStageiv');
    private z_GetProgramStageiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32)>(z_GetProgramStageiv_adr);
    private z_GetProgramStageiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values[0]) else
      z_GetProgramStageiv_ovr_0_anh00001(&program, _shadertype, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32) :=
    z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values);
    private z_GetProgramStageiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr)>(z_GetProgramStageiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr) :=
    z_GetProgramStageiv_ovr_2(&program, _shadertype, pname, values);
    
    // added in gl4.5
    private z_GetQueryBufferObjecti64v_adr := GetFuncAdr('glGetQueryBufferObjecti64v');
    private z_GetQueryBufferObjecti64v_ovr_0 := GetFuncOrNil&<procedure(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjecti64v(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjecti64v_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectiv_adr := GetFuncAdr('glGetQueryBufferObjectiv');
    private z_GetQueryBufferObjectiv_ovr_0 := GetFuncOrNil&<procedure(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectiv(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectiv_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectui64v_adr := GetFuncAdr('glGetQueryBufferObjectui64v');
    private z_GetQueryBufferObjectui64v_ovr_0 := GetFuncOrNil&<procedure(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectui64v(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectui64v_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.5
    private z_GetQueryBufferObjectuiv_adr := GetFuncAdr('glGetQueryBufferObjectuiv');
    private z_GetQueryBufferObjectuiv_ovr_0 := GetFuncOrNil&<procedure(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr)>(z_GetQueryBufferObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectuiv(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectuiv_ovr_0(id, buffer, pname, offset);
    
    // added in gl4.0
    private z_GetQueryIndexediv_adr := GetFuncAdr('glGetQueryIndexediv');
    private z_GetQueryIndexediv_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32)>(z_GetQueryIndexediv_adr);
    private z_GetQueryIndexediv_ovr_0_anh00001 := GetFuncOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryIndexediv_ovr_0(target, index, pname, &params[0]) else
      z_GetQueryIndexediv_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryIndexediv_ovr_0(target, index, pname, &params);
    private z_GetQueryIndexediv_ovr_2 := GetFuncOrNil&<procedure(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryIndexediv_ovr_2(target, index, pname, &params);
    
    // added in gl1.5
    private z_GetQueryiv_adr := GetFuncAdr('glGetQueryiv');
    private z_GetQueryiv_ovr_0 := GetFuncOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; var &params: Int32)>(z_GetQueryiv_adr);
    private z_GetQueryiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryiv_ovr_0(target, pname, &params[0]) else
      z_GetQueryiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryiv_ovr_0(target, pname, &params);
    private z_GetQueryiv_ovr_2 := GetFuncOrNil&<procedure(target: QueryTarget; pname: QueryParameterName; &params: IntPtr)>(z_GetQueryiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryiv(target: QueryTarget; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryiv_ovr_2(target, pname, &params);
    
    // added in gl3.3
    private z_GetQueryObjecti64v_adr := GetFuncAdr('glGetQueryObjecti64v');
    private z_GetQueryObjecti64v_ovr_0 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; var &params: Int64)>(z_GetQueryObjecti64v_adr);
    private z_GetQueryObjecti64v_ovr_0_anh0001 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64v_ovr_0(id, pname, &params);
    private z_GetQueryObjecti64v_ovr_2 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjecti64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64v_ovr_2(id, pname, &params);
    
    // added in gl1.5
    private z_GetQueryObjectiv_adr := GetFuncAdr('glGetQueryObjectiv');
    private z_GetQueryObjectiv_ovr_0 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; var &params: Int32)>(z_GetQueryObjectiv_adr);
    private z_GetQueryObjectiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: UInt32; pname: QueryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectiv_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectiv_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: UInt32; pname: QueryObjectParameterName; var &params: Int32) :=
    z_GetQueryObjectiv_ovr_0(id, pname, &params);
    private z_GetQueryObjectiv_ovr_2 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectiv(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectiv_ovr_2(id, pname, &params);
    
    // added in gl3.3
    private z_GetQueryObjectui64v_adr := GetFuncAdr('glGetQueryObjectui64v');
    private z_GetQueryObjectui64v_ovr_0 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64)>(z_GetQueryObjectui64v_adr);
    private z_GetQueryObjectui64v_ovr_0_anh0001 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64v_ovr_0(id, pname, &params);
    private z_GetQueryObjectui64v_ovr_2 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectui64v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64v_ovr_2(id, pname, &params);
    
    // added in gl1.5
    private z_GetQueryObjectuiv_adr := GetFuncAdr('glGetQueryObjectuiv');
    private z_GetQueryObjectuiv_ovr_0 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; var &params: UInt32)>(z_GetQueryObjectuiv_adr);
    private z_GetQueryObjectuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: UInt32; pname: QueryObjectParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectuiv_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectuiv_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: UInt32; pname: QueryObjectParameterName; var &params: UInt32) :=
    z_GetQueryObjectuiv_ovr_0(id, pname, &params);
    private z_GetQueryObjectuiv_ovr_2 := GetFuncOrNil&<procedure(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr)>(z_GetQueryObjectuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuiv(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectuiv_ovr_2(id, pname, &params);
    
    // added in gl3.0
    private z_GetRenderbufferParameteriv_adr := GetFuncAdr('glGetRenderbufferParameteriv');
    private z_GetRenderbufferParameteriv_ovr_0 := GetFuncOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32)>(z_GetRenderbufferParameteriv_adr);
    private z_GetRenderbufferParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameteriv_ovr_0(target, pname, &params);
    private z_GetRenderbufferParameteriv_ovr_2 := GetFuncOrNil&<procedure(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr)>(z_GetRenderbufferParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameteriv_ovr_2(target, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterfv_adr := GetFuncAdr('glGetSamplerParameterfv');
    private z_GetSamplerParameterfv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterF; var &params: single)>(z_GetSamplerParameterfv_adr);
    private z_GetSamplerParameterfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: SamplerParameterF; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterfv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: SamplerParameterF; var &params: single) :=
    z_GetSamplerParameterfv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterfv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterF; &params: IntPtr)>(z_GetSamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: SamplerParameterF; &params: IntPtr) :=
    z_GetSamplerParameterfv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterIiv_adr := GetFuncAdr('glGetSamplerParameterIiv');
    private z_GetSamplerParameterIiv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; var &params: Int32)>(z_GetSamplerParameterIiv_adr);
    private z_GetSamplerParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIiv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIiv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameterIuiv_adr := GetFuncAdr('glGetSamplerParameterIuiv');
    private z_GetSamplerParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; var &params: UInt32)>(z_GetSamplerParameterIuiv_adr);
    private z_GetSamplerParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: SamplerParameterI; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: SamplerParameterI; var &params: UInt32) :=
    z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIuiv_ovr_2(sampler, pname, &params);
    
    // added in gl3.3
    private z_GetSamplerParameteriv_adr := GetFuncAdr('glGetSamplerParameteriv');
    private z_GetSamplerParameteriv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; var &params: Int32)>(z_GetSamplerParameteriv_adr);
    private z_GetSamplerParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameteriv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameteriv_ovr_0(sampler, pname, &params);
    private z_GetSamplerParameteriv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr)>(z_GetSamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameteriv_ovr_2(sampler, pname, &params);
    
    // added in gl2.0
    private z_GetShaderInfoLog_adr := GetFuncAdr('glGetShaderInfoLog');
    private z_GetShaderInfoLog_ovr_0 := GetFuncOrNil&<procedure(shader: ShaderName; bufSize: Int32; var length: Int32; infoLog: IntPtr)>(z_GetShaderInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderInfoLog(shader: ShaderName; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetShaderInfoLog_ovr_0(shader, bufSize, length, infoLog);
    private z_GetShaderInfoLog_ovr_1 := GetFuncOrNil&<procedure(shader: ShaderName; bufSize: Int32; length: IntPtr; infoLog: IntPtr)>(z_GetShaderInfoLog_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderInfoLog(shader: ShaderName; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetShaderInfoLog_ovr_1(shader, bufSize, length, infoLog);
    
    // added in gl2.0
    private z_GetShaderiv_adr := GetFuncAdr('glGetShaderiv');
    private z_GetShaderiv_ovr_0 := GetFuncOrNil&<procedure(shader: ShaderName; pname: ShaderParameterName; var &params: Int32)>(z_GetShaderiv_adr);
    private z_GetShaderiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(shader: ShaderName; pname: ShaderParameterName; &params: IntPtr)>(z_GetShaderiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: ShaderName; pname: ShaderParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetShaderiv_ovr_0(shader, pname, &params[0]) else
      z_GetShaderiv_ovr_0_anh0001(shader, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: ShaderName; pname: ShaderParameterName; var &params: Int32) :=
    z_GetShaderiv_ovr_0(shader, pname, &params);
    private z_GetShaderiv_ovr_2 := GetFuncOrNil&<procedure(shader: ShaderName; pname: ShaderParameterName; &params: IntPtr)>(z_GetShaderiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderiv(shader: ShaderName; pname: ShaderParameterName; &params: IntPtr) :=
    z_GetShaderiv_ovr_2(shader, pname, &params);
    
    // added in gl4.1
    private z_GetShaderPrecisionFormat_adr := GetFuncAdr('glGetShaderPrecisionFormat');
    private z_GetShaderPrecisionFormat_ovr_0 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_0_anh00010 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_0_anh00001 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_0_anh00011 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: array of Int32) :=
    if (range<>nil) and (range.Length<>0) then
      if (precision<>nil) and (precision.Length<>0) then
        z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision[0]) else
        z_GetShaderPrecisionFormat_ovr_0_anh00001(_shadertype, _precisiontype, range[0], IntPtr.Zero) else
      if (precision<>nil) and (precision.Length<>0) then
        z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision[0]) else
        z_GetShaderPrecisionFormat_ovr_0_anh00011(_shadertype, _precisiontype, IntPtr.Zero, IntPtr.Zero);
    private z_GetShaderPrecisionFormat_ovr_1_anh00010 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; var precision: Int32) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    private z_GetShaderPrecisionFormat_ovr_2 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_2_anh00010 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: IntPtr) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_2(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_2_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: array of Int32) :=
    if (precision<>nil) and (precision.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision[0]) else
      z_GetShaderPrecisionFormat_ovr_0_anh00001(_shadertype, _precisiontype, range, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_2(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_6 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32)>(z_GetShaderPrecisionFormat_adr);
    private z_GetShaderPrecisionFormat_ovr_6_anh00001 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: array of Int32) :=
    if (precision<>nil) and (precision.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_6(_shadertype, _precisiontype, range, precision[0]) else
      z_GetShaderPrecisionFormat_ovr_6_anh00001(_shadertype, _precisiontype, range, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_6(_shadertype, _precisiontype, range, precision);
    private z_GetShaderPrecisionFormat_ovr_8 := GetFuncOrNil&<procedure(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr)>(z_GetShaderPrecisionFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_8(_shadertype, _precisiontype, range, precision);
    
    // added in gl2.0
    private z_GetShaderSource_adr := GetFuncAdr('glGetShaderSource');
    private z_GetShaderSource_ovr_0 := GetFuncOrNil&<procedure(shader: UInt32; bufSize: Int32; var length: Int32; source: IntPtr)>(z_GetShaderSource_adr);
    private z_GetShaderSource_ovr_0_anh00010 := GetFuncOrNil&<procedure(shader: UInt32; bufSize: Int32; length: IntPtr; source: IntPtr)>(z_GetShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSource(shader: UInt32; bufSize: Int32; length: array of Int32; source: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetShaderSource_ovr_0(shader, bufSize, length[0], source) else
      z_GetShaderSource_ovr_0_anh00010(shader, bufSize, IntPtr.Zero, source);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSource(shader: UInt32; bufSize: Int32; var length: Int32; source: IntPtr) :=
    z_GetShaderSource_ovr_0(shader, bufSize, length, source);
    private z_GetShaderSource_ovr_2 := GetFuncOrNil&<procedure(shader: UInt32; bufSize: Int32; length: IntPtr; source: IntPtr)>(z_GetShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSource(shader: UInt32; bufSize: Int32; length: IntPtr; source: IntPtr) :=
    z_GetShaderSource_ovr_2(shader, bufSize, length, source);
    
    // added in gl1.0
    private static function z_GetString_ovr_0(name: StringName): IntPtr;
    external 'opengl32.dll' name 'glGetString';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetString(name: StringName): string;
    begin
      var res_str_ptr := z_GetString_ovr_0(name);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in gl3.0
    private z_GetStringi_adr := GetFuncAdr('glGetStringi');
    private z_GetStringi_ovr_0 := GetFuncOrNil&<function(name: StringName; index: UInt32): IntPtr>(z_GetStringi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetStringi(name: StringName; index: UInt32): string;
    begin
      var res_str_ptr := z_GetStringi_ovr_0(name, index);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
    // added in gl4.0
    private z_GetSubroutineIndex_adr := GetFuncAdr('glGetSubroutineIndex');
    private z_GetSubroutineIndex_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): UInt32>(z_GetSubroutineIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: ProgramName; _shadertype: ShaderType; name: string): UInt32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetSubroutineIndex_ovr_0(&program, _shadertype, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): UInt32 :=
    z_GetSubroutineIndex_ovr_0(&program, _shadertype, name);
    
    // added in gl4.0
    private z_GetSubroutineUniformLocation_adr := GetFuncAdr('glGetSubroutineUniformLocation');
    private z_GetSubroutineUniformLocation_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): Int32>(z_GetSubroutineUniformLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: ProgramName; _shadertype: ShaderType; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): Int32 :=
    z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, name);
    
    // added in gl3.2
    private z_GetSynciv_adr := GetFuncAdr('glGetSynciv');
    private z_GetSynciv_ovr_0 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_0_anh000010 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_0_anh000001 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_0_anh000011 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; values: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (values<>nil) and (values.Length<>0) then
        z_GetSynciv_ovr_0(sync, pname, count, length[0], values[0]) else
        z_GetSynciv_ovr_0_anh000001(sync, pname, count, length[0], IntPtr.Zero) else
      if (values<>nil) and (values.Length<>0) then
        z_GetSynciv_ovr_0_anh000010(sync, pname, count, IntPtr.Zero, values[0]) else
        z_GetSynciv_ovr_0_anh000011(sync, pname, count, IntPtr.Zero, IntPtr.Zero);
    private z_GetSynciv_ovr_1_anh000010 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; var values: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length[0], values) else
      z_GetSynciv_ovr_0_anh000010(sync, pname, count, IntPtr.Zero, values);
    private z_GetSynciv_ovr_2 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_2_anh000010 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; values: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetSynciv_ovr_2(sync, pname, count, length[0], values) else
      z_GetSynciv_ovr_2_anh000010(sync, pname, count, IntPtr.Zero, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_0_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32) :=
    z_GetSynciv_ovr_0(sync, pname, count, length, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr) :=
    z_GetSynciv_ovr_2(sync, pname, count, length, values);
    private z_GetSynciv_ovr_6 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32)>(z_GetSynciv_adr);
    private z_GetSynciv_ovr_6_anh000001 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_6(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_6_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32) :=
    z_GetSynciv_ovr_6(sync, pname, count, length, values);
    private z_GetSynciv_ovr_8 := GetFuncOrNil&<procedure(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr)>(z_GetSynciv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr) :=
    z_GetSynciv_ovr_8(sync, pname, count, length, values);
    
    // added in gl1.0
    private static procedure z_GetTexImage_ovr_0(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetTexImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexImage(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetTexImage_ovr_0(target, level, format, &type, pixels);
    
    // added in gl1.0
    private static procedure z_GetTexLevelParameterfv_ovr_0(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTexLevelParameterfv';
    private static procedure z_GetTexLevelParameterfv_ovr_0_anh00001(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameterfv_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameterfv_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTexLevelParameterfv_ovr_0(target, level, pname, &params);
    private static procedure z_GetTexLevelParameterfv_ovr_2(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterfv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameterfv_ovr_2(target, level, pname, &params);
    
    // added in gl1.0
    private static procedure z_GetTexLevelParameteriv_ovr_0(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTexLevelParameteriv';
    private static procedure z_GetTexLevelParameteriv_ovr_0_anh00001(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameteriv_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameteriv_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexLevelParameteriv_ovr_0(target, level, pname, &params);
    private static procedure z_GetTexLevelParameteriv_ovr_2(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameteriv(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameteriv_ovr_2(target, level, pname, &params);
    
    // added in gl1.0
    private static procedure z_GetTexParameterfv_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTexParameterfv';
    private static procedure z_GetTexParameterfv_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetTexParameterfv_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameterfv_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterfv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterfv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_GetTexParameterIiv_adr := GetFuncAdr('glGetTexParameterIiv');
    private z_GetTexParameterIiv_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: Int32)>(z_GetTexParameterIiv_adr);
    private z_GetTexParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIiv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameterIiv_ovr_0(target, pname, &params);
    private z_GetTexParameterIiv_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIiv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIiv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_GetTexParameterIuiv_adr := GetFuncAdr('glGetTexParameterIuiv');
    private z_GetTexParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32)>(z_GetTexParameterIuiv_adr);
    private z_GetTexParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIuiv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIuiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTexParameterIuiv_ovr_0(target, pname, &params);
    private z_GetTexParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr)>(z_GetTexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuiv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIuiv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private static procedure z_GetTexParameteriv_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTexParameteriv';
    private static procedure z_GetTexParameteriv_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetTexParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameteriv_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameteriv(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.5
    private z_GetTextureImage_adr := GetFuncAdr('glGetTextureImage');
    private z_GetTextureImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImage(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureImage_ovr_0(texture, level, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetTextureLevelParameterfv_adr := GetFuncAdr('glGetTextureLevelParameterfv');
    private z_GetTextureLevelParameterfv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: single)>(z_GetTextureLevelParameterfv_adr);
    private z_GetTextureLevelParameterfv_ovr_0_anh00001 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameterfv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameterfv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfv_ovr_2(texture, level, pname, &params);
    
    // added in gl4.5
    private z_GetTextureLevelParameteriv_adr := GetFuncAdr('glGetTextureLevelParameteriv');
    private z_GetTextureLevelParameteriv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureLevelParameteriv_adr);
    private z_GetTextureLevelParameteriv_ovr_0_anh00001 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameteriv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params);
    private z_GetTextureLevelParameteriv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureLevelParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameteriv_ovr_2(texture, level, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterfv_adr := GetFuncAdr('glGetTextureParameterfv');
    private z_GetTextureParameterfv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; var &params: single)>(z_GetTextureParameterfv_adr);
    private z_GetTextureParameterfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterfv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterIiv_adr := GetFuncAdr('glGetTextureParameterIiv');
    private z_GetTextureParameterIiv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameterIiv_adr);
    private z_GetTextureParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIiv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameterIuiv_adr := GetFuncAdr('glGetTextureParameterIuiv');
    private z_GetTextureParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; var &params: UInt32)>(z_GetTextureParameterIuiv_adr);
    private z_GetTextureParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_GetTextureParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureParameteriv_adr := GetFuncAdr('glGetTextureParameteriv');
    private z_GetTextureParameteriv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; var &params: Int32)>(z_GetTextureParameteriv_adr);
    private z_GetTextureParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameteriv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameteriv_ovr_0(texture, pname, &params);
    private z_GetTextureParameteriv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: GetTextureParameter; &params: IntPtr)>(z_GetTextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameteriv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_GetTextureSubImage_adr := GetFuncAdr('glGetTextureSubImage');
    private z_GetTextureSubImage_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr)>(z_GetTextureSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, bufSize, pixels);
    
    // added in gl4.5
    private z_GetTransformFeedbacki_v_adr := GetFuncAdr('glGetTransformFeedbacki_v');
    private z_GetTransformFeedbacki_v_ovr_0 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int32)>(z_GetTransformFeedbacki_v_adr);
    private z_GetTransformFeedbacki_v_ovr_0_anh00001 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int32) :=
    z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki_v_ovr_2 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki_v_ovr_2(xfb, pname, index, param);
    
    // added in gl4.5
    private z_GetTransformFeedbacki64_v_adr := GetFuncAdr('glGetTransformFeedbacki64_v');
    private z_GetTransformFeedbacki64_v_ovr_0 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int64)>(z_GetTransformFeedbacki64_v_adr);
    private z_GetTransformFeedbacki64_v_ovr_0_anh00001 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki64_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int64) :=
    z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param);
    private z_GetTransformFeedbacki64_v_ovr_2 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr)>(z_GetTransformFeedbacki64_v_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki64_v_ovr_2(xfb, pname, index, param);
    
    // added in gl4.5
    private z_GetTransformFeedbackiv_adr := GetFuncAdr('glGetTransformFeedbackiv');
    private z_GetTransformFeedbackiv_ovr_0 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; var param: Int32)>(z_GetTransformFeedbackiv_adr);
    private z_GetTransformFeedbackiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbackiv_ovr_0(xfb, pname, param[0]) else
      z_GetTransformFeedbackiv_ovr_0_anh0001(xfb, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; var param: Int32) :=
    z_GetTransformFeedbackiv_ovr_0(xfb, pname, param);
    private z_GetTransformFeedbackiv_ovr_2 := GetFuncOrNil&<procedure(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr)>(z_GetTransformFeedbackiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr) :=
    z_GetTransformFeedbackiv_ovr_2(xfb, pname, param);
    
    // added in gl3.0
    private z_GetTransformFeedbackVarying_adr := GetFuncAdr('glGetTransformFeedbackVarying');
    private z_GetTransformFeedbackVarying_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_0_anh00001110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length[0], size[0], &type[0], name) else
          z_GetTransformFeedbackVarying_ovr_0_anh00000010(&program, index, bufSize, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVarying_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type[0], name) else
          z_GetTransformFeedbackVarying_ovr_0_anh00000110(&program, index, bufSize, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVarying_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type[0], name) else
          z_GetTransformFeedbackVarying_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVarying_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetTransformFeedbackVarying_ovr_0_anh00001110(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetTransformFeedbackVarying_ovr_1_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_1_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_1_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetTransformFeedbackVarying_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_2_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_2_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_2_anh00001100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_2(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetTransformFeedbackVarying_ovr_2_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetTransformFeedbackVarying_ovr_2_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private z_GetTransformFeedbackVarying_ovr_3_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_3_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetTransformFeedbackVarying_ovr_4_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVarying_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_5_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_2(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVarying_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_6 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_6_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_6_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_6_anh00001010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_6(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_6_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_6_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private z_GetTransformFeedbackVarying_ovr_7_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_6(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVarying_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_8 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_8_anh00001000 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_8(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVarying_ovr_8_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_0_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVarying_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_2(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVarying_ovr_2_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVarying_ovr_0_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_0(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_2(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_6(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVarying_ovr_6_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_6(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_8(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_18 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_18_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_18_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_18_anh00000110 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_18(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_18_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVarying_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetTransformFeedbackVarying_ovr_18_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    private z_GetTransformFeedbackVarying_ovr_19_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_18(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVarying_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    private z_GetTransformFeedbackVarying_ovr_20 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_20_anh00000100 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_20(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVarying_ovr_20_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_18(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVarying_ovr_18_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_18(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_20(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_24 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    private z_GetTransformFeedbackVarying_ovr_24_anh00000010 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVarying_ovr_24(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVarying_ovr_24_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_24(&program, index, bufSize, length, size, &type, name);
    private z_GetTransformFeedbackVarying_ovr_26 := GetFuncOrNil&<procedure(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr)>(z_GetTransformFeedbackVarying_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVarying(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVarying_ovr_26(&program, index, bufSize, length, size, &type, name);
    
    // added in gl3.1
    private z_GetUniformBlockIndex_adr := GetFuncAdr('glGetUniformBlockIndex');
    private z_GetUniformBlockIndex_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; uniformBlockName: IntPtr): UInt32>(z_GetUniformBlockIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: ProgramName; uniformBlockName: string): UInt32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(uniformBlockName);
      Result := z_GetUniformBlockIndex_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: ProgramName; uniformBlockName: IntPtr): UInt32 :=
    z_GetUniformBlockIndex_ovr_0(&program, uniformBlockName);
    
    // added in gl4.0
    private z_GetUniformdv_adr := GetFuncAdr('glGetUniformdv');
    private z_GetUniformdv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; var &params: real)>(z_GetUniformdv_adr);
    private z_GetUniformdv_ovr_0_anh0001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformdv_ovr_0(&program, location, &params[0]) else
      z_GetUniformdv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; var &params: real) :=
    z_GetUniformdv_ovr_0(&program, location, &params);
    private z_GetUniformdv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; &params: IntPtr) :=
    z_GetUniformdv_ovr_2(&program, location, &params);
    
    // added in gl2.0
    private z_GetUniformfv_adr := GetFuncAdr('glGetUniformfv');
    private z_GetUniformfv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; var &params: single)>(z_GetUniformfv_adr);
    private z_GetUniformfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: ProgramName; location: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformfv_ovr_0(&program, location, &params[0]) else
      z_GetUniformfv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: ProgramName; location: Int32; var &params: single) :=
    z_GetUniformfv_ovr_0(&program, location, &params);
    private z_GetUniformfv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfv(&program: ProgramName; location: Int32; &params: IntPtr) :=
    z_GetUniformfv_ovr_2(&program, location, &params);
    
    // added in gl3.1
    private z_GetUniformIndices_adr := GetFuncAdr('glGetUniformIndices');
    private z_GetUniformIndices_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_0_anh00011 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; uniformIndices: array of UInt32);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
          z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices[0]) else
          z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, par_3_str_ptr[0], IntPtr.Zero) else
        if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
          z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
          z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_GetUniformIndices_ovr_1_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; var uniformIndices: UInt32);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_GetUniformIndices_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_2_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; uniformIndices: IntPtr);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_GetUniformIndices_ovr_2(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
        z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_GetUniformIndices_ovr_3_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_3_anh00011 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: array of UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, uniformNames[0], IntPtr.Zero) else
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
    private z_GetUniformIndices_ovr_4_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; var uniformIndices: UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_5_anh00010 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: IntPtr) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_2(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private z_GetUniformIndices_ovr_6 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32)>(z_GetUniformIndices_adr);
    private z_GetUniformIndices_ovr_6_anh00001 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: array of UInt32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices[0]) else
      z_GetUniformIndices_ovr_6_anh00001(&program, uniformCount, uniformNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32) :=
    z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices);
    private z_GetUniformIndices_ovr_8 := GetFuncOrNil&<procedure(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr)>(z_GetUniformIndices_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr) :=
    z_GetUniformIndices_ovr_8(&program, uniformCount, uniformNames, uniformIndices);
    
    // added in gl2.0
    private z_GetUniformiv_adr := GetFuncAdr('glGetUniformiv');
    private z_GetUniformiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; var &params: Int32)>(z_GetUniformiv_adr);
    private z_GetUniformiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: ProgramName; location: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformiv_ovr_0(&program, location, &params[0]) else
      z_GetUniformiv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: ProgramName; location: Int32; var &params: Int32) :=
    z_GetUniformiv_ovr_0(&program, location, &params);
    private z_GetUniformiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformiv(&program: ProgramName; location: Int32; &params: IntPtr) :=
    z_GetUniformiv_ovr_2(&program, location, &params);
    
    // added in gl2.0
    private z_GetUniformLocation_adr := GetFuncAdr('glGetUniformLocation');
    private z_GetUniformLocation_ovr_0 := GetFuncOrNil&<function(&program: ProgramName; name: IntPtr): Int32>(z_GetUniformLocation_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocation(&program: ProgramName; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetUniformLocation_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocation(&program: ProgramName; name: IntPtr): Int32 :=
    z_GetUniformLocation_ovr_0(&program, name);
    
    // added in gl4.0
    private z_GetUniformSubroutineuiv_adr := GetFuncAdr('glGetUniformSubroutineuiv');
    private z_GetUniformSubroutineuiv_ovr_0 := GetFuncOrNil&<procedure(_shadertype: ShaderType; location: Int32; var &params: UInt32)>(z_GetUniformSubroutineuiv_adr);
    private z_GetUniformSubroutineuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(_shadertype: ShaderType; location: Int32; &params: IntPtr)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params[0]) else
      z_GetUniformSubroutineuiv_ovr_0_anh0001(_shadertype, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; var &params: UInt32) :=
    z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params);
    private z_GetUniformSubroutineuiv_ovr_2 := GetFuncOrNil&<procedure(_shadertype: ShaderType; location: Int32; &params: IntPtr)>(z_GetUniformSubroutineuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: IntPtr) :=
    z_GetUniformSubroutineuiv_ovr_2(_shadertype, location, &params);
    
    // added in gl3.0
    private z_GetUniformuiv_adr := GetFuncAdr('glGetUniformuiv');
    private z_GetUniformuiv_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; var &params: UInt32)>(z_GetUniformuiv_adr);
    private z_GetUniformuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: ProgramName; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformuiv_ovr_0(&program, location, &params[0]) else
      z_GetUniformuiv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: ProgramName; location: Int32; var &params: UInt32) :=
    z_GetUniformuiv_ovr_0(&program, location, &params);
    private z_GetUniformuiv_ovr_2 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; &params: IntPtr)>(z_GetUniformuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuiv(&program: ProgramName; location: Int32; &params: IntPtr) :=
    z_GetUniformuiv_ovr_2(&program, location, &params);
    
    // added in gl4.5
    private z_GetVertexArrayIndexed64iv_adr := GetFuncAdr('glGetVertexArrayIndexed64iv');
    private z_GetVertexArrayIndexed64iv_ovr_0 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int64)>(z_GetVertexArrayIndexed64iv_adr);
    private z_GetVertexArrayIndexed64iv_ovr_0_anh00001 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexed64iv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int64) :=
    z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexed64iv_ovr_2 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexed64iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexed64iv_ovr_2(vaobj, index, pname, param);
    
    // added in gl4.5
    private z_GetVertexArrayIndexediv_adr := GetFuncAdr('glGetVertexArrayIndexediv');
    private z_GetVertexArrayIndexediv_ovr_0 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayIndexediv_adr);
    private z_GetVertexArrayIndexediv_ovr_0_anh00001 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexediv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param);
    private z_GetVertexArrayIndexediv_ovr_2 := GetFuncOrNil&<procedure(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayIndexediv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexediv_ovr_2(vaobj, index, pname, param);
    
    // added in gl4.5
    private z_GetVertexArrayiv_adr := GetFuncAdr('glGetVertexArrayiv');
    private z_GetVertexArrayiv_ovr_0 := GetFuncOrNil&<procedure(vaobj: UInt32; pname: VertexArrayPName; var param: Int32)>(z_GetVertexArrayiv_adr);
    private z_GetVertexArrayiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayiv_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayiv_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayiv_ovr_0(vaobj, pname, param);
    private z_GetVertexArrayiv_ovr_2 := GetFuncOrNil&<procedure(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr)>(z_GetVertexArrayiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayiv_ovr_2(vaobj, pname, param);
    
    // added in gl2.0
    private z_GetVertexAttribdv_adr := GetFuncAdr('glGetVertexAttribdv');
    private z_GetVertexAttribdv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: real)>(z_GetVertexAttribdv_adr);
    private z_GetVertexAttribdv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdv_ovr_0(index, pname, &params);
    private z_GetVertexAttribdv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdv_ovr_2(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribfv_adr := GetFuncAdr('glGetVertexAttribfv');
    private z_GetVertexAttribfv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: single)>(z_GetVertexAttribfv_adr);
    private z_GetVertexAttribfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfv_ovr_0(index, pname, &params);
    private z_GetVertexAttribfv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfv_ovr_2(index, pname, &params);
    
    // added in gl3.0
    private z_GetVertexAttribIiv_adr := GetFuncAdr('glGetVertexAttribIiv');
    private z_GetVertexAttribIiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: Int32)>(z_GetVertexAttribIiv_adr);
    private z_GetVertexAttribIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIiv(index: UInt32; pname: VertexAttribEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribIiv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribIiv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIiv(index: UInt32; pname: VertexAttribEnum; var &params: Int32) :=
    z_GetVertexAttribIiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribIiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIiv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIiv_ovr_2(index, pname, &params);
    
    // added in gl3.0
    private z_GetVertexAttribIuiv_adr := GetFuncAdr('glGetVertexAttribIuiv');
    private z_GetVertexAttribIuiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: UInt32)>(z_GetVertexAttribIuiv_adr);
    private z_GetVertexAttribIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuiv(index: UInt32; pname: VertexAttribEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribIuiv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribIuiv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuiv(index: UInt32; pname: VertexAttribEnum; var &params: UInt32) :=
    z_GetVertexAttribIuiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribIuiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuiv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIuiv_ovr_2(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribiv_adr := GetFuncAdr('glGetVertexAttribiv');
    private z_GetVertexAttribiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32)>(z_GetVertexAttribiv_adr);
    private z_GetVertexAttribiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribiv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribiv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribiv_ovr_0(index, pname, &params);
    private z_GetVertexAttribiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr)>(z_GetVertexAttribiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribiv(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribiv_ovr_2(index, pname, &params);
    
    // added in gl4.1
    private z_GetVertexAttribLdv_adr := GetFuncAdr('glGetVertexAttribLdv');
    private z_GetVertexAttribLdv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; var &params: real)>(z_GetVertexAttribLdv_adr);
    private z_GetVertexAttribLdv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdv_ovr_0(index, pname, &params);
    private z_GetVertexAttribLdv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribEnum; &params: IntPtr)>(z_GetVertexAttribLdv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdv_ovr_2(index, pname, &params);
    
    // added in gl2.0
    private z_GetVertexAttribPointerv_adr := GetFuncAdr('glGetVertexAttribPointerv');
    private z_GetVertexAttribPointerv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr)>(z_GetVertexAttribPointerv_adr);
    private z_GetVertexAttribPointerv_ovr_0_anh0001 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: IntPtr)>(z_GetVertexAttribPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointerv(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_GetVertexAttribPointerv_ovr_0(index, pname, _pointer[0]) else
      z_GetVertexAttribPointerv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointerv(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointerv_ovr_0(index, pname, _pointer);
    private z_GetVertexAttribPointerv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer)>(z_GetVertexAttribPointerv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointerv(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointerv_ovr_2(index, pname, _pointer);
    
    // added in gl1.0
    private static procedure z_Hint_ovr_0(target: HintTarget; mode: HintMode);
    external 'opengl32.dll' name 'glHint';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Hint(target: HintTarget; mode: HintMode) :=
    z_Hint_ovr_0(target, mode);
    
    // added in gl4.3
    private z_InvalidateBufferData_adr := GetFuncAdr('glInvalidateBufferData');
    private z_InvalidateBufferData_ovr_0 := GetFuncOrNil&<procedure(buffer: BufferName)>(z_InvalidateBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferData(buffer: BufferName) :=
    z_InvalidateBufferData_ovr_0(buffer);
    
    // added in gl4.3
    private z_InvalidateBufferSubData_adr := GetFuncAdr('glInvalidateBufferSubData');
    private z_InvalidateBufferSubData_ovr_0 := GetFuncOrNil&<procedure(buffer: BufferName; offset: IntPtr; length: IntPtr)>(z_InvalidateBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferSubData(buffer: BufferName; offset: IntPtr; length: IntPtr) :=
    z_InvalidateBufferSubData_ovr_0(buffer, offset, length);
    
    // added in gl4.3
    private z_InvalidateFramebuffer_adr := GetFuncAdr('glInvalidateFramebuffer');
    private z_InvalidateFramebuffer_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment)>(z_InvalidateFramebuffer_adr);
    private z_InvalidateFramebuffer_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments[0]) else
      z_InvalidateFramebuffer_ovr_0_anh0001(target, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment) :=
    z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments);
    private z_InvalidateFramebuffer_ovr_2 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateFramebuffer_ovr_2(target, numAttachments, attachments);
    
    // added in gl4.5
    private z_InvalidateNamedFramebufferData_adr := GetFuncAdr('glInvalidateNamedFramebufferData');
    private z_InvalidateNamedFramebufferData_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment)>(z_InvalidateNamedFramebufferData_adr);
    private z_InvalidateNamedFramebufferData_ovr_0_anh0001 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; attachments: array of FramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments[0]) else
      z_InvalidateNamedFramebufferData_ovr_0_anh0001(framebuffer, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment) :=
    z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments);
    private z_InvalidateNamedFramebufferData_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr)>(z_InvalidateNamedFramebufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateNamedFramebufferData_ovr_2(framebuffer, numAttachments, attachments);
    
    // added in gl4.5
    private z_InvalidateNamedFramebufferSubData_adr := GetFuncAdr('glInvalidateNamedFramebufferSubData');
    private z_InvalidateNamedFramebufferSubData_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    private z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; attachments: array of FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000(framebuffer, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments, x, y, width, height);
    private z_InvalidateNamedFramebufferSubData_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateNamedFramebufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_2(framebuffer, numAttachments, attachments, x, y, width, height);
    
    // added in gl4.3
    private z_InvalidateSubFramebuffer_adr := GetFuncAdr('glInvalidateSubFramebuffer');
    private z_InvalidateSubFramebuffer_ovr_0 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    private z_InvalidateSubFramebuffer_ovr_0_anh00010000 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateSubFramebuffer_ovr_0_anh00010000(target, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments, x, y, width, height);
    private z_InvalidateSubFramebuffer_ovr_2 := GetFuncOrNil&<procedure(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32)>(z_InvalidateSubFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_2(target, numAttachments, attachments, x, y, width, height);
    
    // added in gl4.3
    private z_InvalidateTexImage_adr := GetFuncAdr('glInvalidateTexImage');
    private z_InvalidateTexImage_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; level: Int32)>(z_InvalidateTexImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexImage(texture: TextureName; level: Int32) :=
    z_InvalidateTexImage_ovr_0(texture, level);
    
    // added in gl4.3
    private z_InvalidateTexSubImage_adr := GetFuncAdr('glInvalidateTexSubImage');
    private z_InvalidateTexSubImage_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32)>(z_InvalidateTexSubImage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexSubImage(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_InvalidateTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth);
    
    // added in gl1.5
    private z_IsBuffer_adr := GetFuncAdr('glIsBuffer');
    private z_IsBuffer_ovr_0 := GetFuncOrNil&<function(buffer: BufferName): boolean>(z_IsBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBuffer(buffer: BufferName): boolean :=
    z_IsBuffer_ovr_0(buffer);
    
    // added in gl1.0
    private static function z_IsEnabled_ovr_0(cap: EnableCap): boolean;
    external 'opengl32.dll' name 'glIsEnabled';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabled(cap: EnableCap): boolean :=
    z_IsEnabled_ovr_0(cap);
    
    // added in gl3.0
    private z_IsEnabledi_adr := GetFuncAdr('glIsEnabledi');
    private z_IsEnabledi_ovr_0 := GetFuncOrNil&<function(target: EnableCap; index: UInt32): boolean>(z_IsEnabledi_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledi(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledi_ovr_0(target, index);
    
    // added in gl3.0
    private z_IsFramebuffer_adr := GetFuncAdr('glIsFramebuffer');
    private z_IsFramebuffer_ovr_0 := GetFuncOrNil&<function(framebuffer: FramebufferName): boolean>(z_IsFramebuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebuffer(framebuffer: FramebufferName): boolean :=
    z_IsFramebuffer_ovr_0(framebuffer);
    
    // added in gl2.0
    private z_IsProgram_adr := GetFuncAdr('glIsProgram');
    private z_IsProgram_ovr_0 := GetFuncOrNil&<function(&program: ProgramName): boolean>(z_IsProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgram(&program: ProgramName): boolean :=
    z_IsProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_IsProgramPipeline_adr := GetFuncAdr('glIsProgramPipeline');
    private z_IsProgramPipeline_ovr_0 := GetFuncOrNil&<function(pipeline: ProgramPipelineName): boolean>(z_IsProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramPipeline(pipeline: ProgramPipelineName): boolean :=
    z_IsProgramPipeline_ovr_0(pipeline);
    
    // added in gl1.5
    private z_IsQuery_adr := GetFuncAdr('glIsQuery');
    private z_IsQuery_ovr_0 := GetFuncOrNil&<function(id: QueryName): boolean>(z_IsQuery_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsQuery(id: QueryName): boolean :=
    z_IsQuery_ovr_0(id);
    
    // added in gl3.0
    private z_IsRenderbuffer_adr := GetFuncAdr('glIsRenderbuffer');
    private z_IsRenderbuffer_ovr_0 := GetFuncOrNil&<function(renderbuffer: RenderbufferName): boolean>(z_IsRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbuffer(renderbuffer: RenderbufferName): boolean :=
    z_IsRenderbuffer_ovr_0(renderbuffer);
    
    // added in gl3.3
    private z_IsSampler_adr := GetFuncAdr('glIsSampler');
    private z_IsSampler_ovr_0 := GetFuncOrNil&<function(sampler: SamplerName): boolean>(z_IsSampler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSampler(sampler: SamplerName): boolean :=
    z_IsSampler_ovr_0(sampler);
    
    // added in gl2.0
    private z_IsShader_adr := GetFuncAdr('glIsShader');
    private z_IsShader_ovr_0 := GetFuncOrNil&<function(shader: ShaderName): boolean>(z_IsShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsShader(shader: ShaderName): boolean :=
    z_IsShader_ovr_0(shader);
    
    // added in gl3.2
    private z_IsSync_adr := GetFuncAdr('glIsSync');
    private z_IsSync_ovr_0 := GetFuncOrNil&<function(sync: GLsync): boolean>(z_IsSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSync(sync: GLsync): boolean :=
    z_IsSync_ovr_0(sync);
    
    // added in gl1.1
    private static function z_IsTexture_ovr_0(texture: TextureName): boolean;
    external 'opengl32.dll' name 'glIsTexture';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTexture(texture: TextureName): boolean :=
    z_IsTexture_ovr_0(texture);
    
    // added in gl4.0
    private z_IsTransformFeedback_adr := GetFuncAdr('glIsTransformFeedback');
    private z_IsTransformFeedback_ovr_0 := GetFuncOrNil&<function(id: TransformFeedbackName): boolean>(z_IsTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedback(id: TransformFeedbackName): boolean :=
    z_IsTransformFeedback_ovr_0(id);
    
    // added in gl3.0
    private z_IsVertexArray_adr := GetFuncAdr('glIsVertexArray');
    private z_IsVertexArray_ovr_0 := GetFuncOrNil&<function(&array: VertexArrayName): boolean>(z_IsVertexArray_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArray(&array: VertexArrayName): boolean :=
    z_IsVertexArray_ovr_0(&array);
    
    // added in gl1.0
    private static procedure z_LineWidth_ovr_0(width: single);
    external 'opengl32.dll' name 'glLineWidth';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineWidth(width: single) :=
    z_LineWidth_ovr_0(width);
    
    // added in gl2.0
    private z_LinkProgram_adr := GetFuncAdr('glLinkProgram');
    private z_LinkProgram_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName)>(z_LinkProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LinkProgram(&program: ProgramName) :=
    z_LinkProgram_ovr_0(&program);
    
    // added in gl1.0
    private static procedure z_LogicOp_ovr_0(opcode: OpenGL.LogicOp);
    external 'opengl32.dll' name 'glLogicOp';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LogicOp(opcode: OpenGL.LogicOp) :=
    z_LogicOp_ovr_0(opcode);
    
    // added in gl1.5
    private z_MapBuffer_adr := GetFuncAdr('glMapBuffer');
    private z_MapBuffer_ovr_0 := GetFuncOrNil&<function(target: BufferTargetARB; access: BufferAccessARB): IntPtr>(z_MapBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBuffer(target: BufferTargetARB; access: BufferAccessARB): IntPtr :=
    z_MapBuffer_ovr_0(target, access);
    
    // added in gl3.0
    private z_MapBufferRange_adr := GetFuncAdr('glMapBufferRange');
    private z_MapBufferRange_ovr_0 := GetFuncOrNil&<function(target: BufferTargetARB; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferRange(target: BufferTargetARB; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapBufferRange_ovr_0(target, offset, length, access);
    
    // added in gl4.5
    private z_MapNamedBuffer_adr := GetFuncAdr('glMapNamedBuffer');
    private z_MapNamedBuffer_ovr_0 := GetFuncOrNil&<function(buffer: BufferName; access: BufferAccessARB): IntPtr>(z_MapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBuffer(buffer: BufferName; access: BufferAccessARB): IntPtr :=
    z_MapNamedBuffer_ovr_0(buffer, access);
    
    // added in gl4.5
    private z_MapNamedBufferRange_adr := GetFuncAdr('glMapNamedBufferRange');
    private z_MapNamedBufferRange_ovr_0 := GetFuncOrNil&<function(buffer: BufferName; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr>(z_MapNamedBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRange(buffer: BufferName; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRange_ovr_0(buffer, offset, length, access);
    
    // added in gl4.2
    private z_MemoryBarrier_adr := GetFuncAdr('glMemoryBarrier');
    private z_MemoryBarrier_ovr_0 := GetFuncOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrier(barriers: MemoryBarrierMask) :=
    z_MemoryBarrier_ovr_0(barriers);
    
    // added in gl4.5
    private z_MemoryBarrierByRegion_adr := GetFuncAdr('glMemoryBarrierByRegion');
    private z_MemoryBarrierByRegion_ovr_0 := GetFuncOrNil&<procedure(barriers: MemoryBarrierMask)>(z_MemoryBarrierByRegion_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierByRegion(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierByRegion_ovr_0(barriers);
    
    // added in gl4.0
    private z_MinSampleShading_adr := GetFuncAdr('glMinSampleShading');
    private z_MinSampleShading_ovr_0 := GetFuncOrNil&<procedure(value: single)>(z_MinSampleShading_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinSampleShading(value: single) :=
    z_MinSampleShading_ovr_0(value);
    
    // added in gl1.4
    private z_MultiDrawArrays_adr := GetFuncAdr('glMultiDrawArrays');
    private z_MultiDrawArrays_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; var first: Int32; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00100 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00010 := GetFuncOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_0_anh00110 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; count: array of Int32; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArrays_ovr_0(mode, first[0], count[0], drawcount) else
        z_MultiDrawArrays_ovr_0_anh00010(mode, first[0], IntPtr.Zero, drawcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArrays_ovr_0_anh00100(mode, IntPtr.Zero, count[0], drawcount) else
        z_MultiDrawArrays_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, drawcount);
    private z_MultiDrawArrays_ovr_1_anh00100 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; var count: Int32; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArrays_ovr_0(mode, first[0], count, drawcount) else
      z_MultiDrawArrays_ovr_0_anh00100(mode, IntPtr.Zero, count, drawcount);
    private z_MultiDrawArrays_ovr_2 := GetFuncOrNil&<procedure(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_2_anh00100 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: array of Int32; count: IntPtr; drawcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArrays_ovr_2(mode, first[0], count, drawcount) else
      z_MultiDrawArrays_ovr_2_anh00100(mode, IntPtr.Zero, count, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; count: array of Int32; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArrays_ovr_0(mode, first, count[0], drawcount) else
      z_MultiDrawArrays_ovr_0_anh00010(mode, first, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; var count: Int32; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_0(mode, first, count, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; var first: Int32; count: IntPtr; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_2(mode, first, count, drawcount);
    private z_MultiDrawArrays_ovr_6 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32)>(z_MultiDrawArrays_adr);
    private z_MultiDrawArrays_ovr_6_anh00010 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; count: array of Int32; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArrays_ovr_6(mode, first, count[0], drawcount) else
      z_MultiDrawArrays_ovr_6_anh00010(mode, first, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; var count: Int32; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_6(mode, first, count, drawcount);
    private z_MultiDrawArrays_ovr_8 := GetFuncOrNil&<procedure(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32)>(z_MultiDrawArrays_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArrays(mode: PrimitiveType; first: IntPtr; count: IntPtr; drawcount: Int32) :=
    z_MultiDrawArrays_ovr_8(mode, first, count, drawcount);
    
    // added in gl4.3
    private z_MultiDrawArraysIndirect_adr := GetFuncAdr('glMultiDrawArraysIndirect');
    private z_MultiDrawArraysIndirect_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirect_ovr_0(mode, indirect, drawcount, stride);
    
    // added in gl4.6
    private z_MultiDrawArraysIndirectCount_adr := GetFuncAdr('glMultiDrawArraysIndirectCount');
    private z_MultiDrawArraysIndirectCount_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawArraysIndirectCount_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectCount(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectCount_ovr_0(mode, indirect, drawcount, maxdrawcount, stride);
    
    // added in gl1.4
    private z_MultiDrawElements_adr := GetFuncAdr('glMultiDrawElements');
    private z_MultiDrawElements_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh001000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh000010 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_0_anh001010 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElements_ovr_0(mode, count[0], &type, indices[0], drawcount) else
        z_MultiDrawElements_ovr_0_anh000010(mode, count[0], &type, IntPtr.Zero, drawcount) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElements_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices[0], drawcount) else
        z_MultiDrawElements_ovr_0_anh001010(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount);
    private z_MultiDrawElements_ovr_1_anh001000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElements_ovr_0(mode, count[0], &type, indices, drawcount) else
      z_MultiDrawElements_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_2 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_2_anh001000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElements_ovr_2(mode, count[0], &type, indices, drawcount) else
      z_MultiDrawElements_ovr_2_anh001000(mode, IntPtr.Zero, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_3_anh000010 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElements_ovr_0(mode, count, &type, indices[0], drawcount) else
      z_MultiDrawElements_ovr_0_anh000010(mode, count, &type, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    z_MultiDrawElements_ovr_0(mode, count, &type, indices, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    z_MultiDrawElements_ovr_2(mode, count, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_6 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    private z_MultiDrawElements_ovr_6_anh000010 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElements_ovr_6(mode, count, &type, indices[0], drawcount) else
      z_MultiDrawElements_ovr_6_anh000010(mode, count, &type, IntPtr.Zero, drawcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32) :=
    z_MultiDrawElements_ovr_6(mode, count, &type, indices, drawcount);
    private z_MultiDrawElements_ovr_8 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32)>(z_MultiDrawElements_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElements(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32) :=
    z_MultiDrawElements_ovr_8(mode, count, &type, indices, drawcount);
    
    // added in gl3.2
    private z_MultiDrawElementsBaseVertex_adr := GetFuncAdr('glMultiDrawElementsBaseVertex');
    private z_MultiDrawElementsBaseVertex_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000001 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010001 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0000101 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_0_anh0010101 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count[0], &type, IntPtr.Zero, drawcount, IntPtr.Zero) else
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010101(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_1_anh0010100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_2 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_2_anh0010100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_3_anh0010001 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_4_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_5_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_6 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0000001 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_6_anh0010001 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_7_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_8 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_8_anh0010000 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_8(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_8_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_9_anh0000101 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_10_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_11_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_8(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_18 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000001 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_18_anh0000101 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private z_MultiDrawElementsBaseVertex_ovr_19_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_20 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_20_anh0000100 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_20_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_24 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32)>(z_MultiDrawElementsBaseVertex_adr);
    private z_MultiDrawElementsBaseVertex_ovr_24_anh0000001 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_24_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex);
    private z_MultiDrawElementsBaseVertex_ovr_26 := GetFuncOrNil&<procedure(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr)>(z_MultiDrawElementsBaseVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_26(mode, count, &type, indices, drawcount, basevertex);
    
    // added in gl4.3
    private z_MultiDrawElementsIndirect_adr := GetFuncAdr('glMultiDrawElementsIndirect');
    private z_MultiDrawElementsIndirect_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirect_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirect_ovr_0(mode, &type, indirect, drawcount, stride);
    
    // added in gl4.6
    private z_MultiDrawElementsIndirectCount_adr := GetFuncAdr('glMultiDrawElementsIndirectCount');
    private z_MultiDrawElementsIndirectCount_ovr_0 := GetFuncOrNil&<procedure(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32)>(z_MultiDrawElementsIndirectCount_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectCount(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectCount_ovr_0(mode, &type, indirect, drawcount, maxdrawcount, stride);
    
    // added in gl3.3
    private z_MultiTexCoordP1ui_adr := GetFuncAdr('glMultiTexCoordP1ui');
    private z_MultiTexCoordP1ui_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP1ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP1uiv_adr := GetFuncAdr('glMultiTexCoordP1uiv');
    private z_MultiTexCoordP1uiv_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP1uiv_adr);
    private z_MultiTexCoordP1uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP1uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP1uiv_ovr_2 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP1uiv_ovr_2(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP2ui_adr := GetFuncAdr('glMultiTexCoordP2ui');
    private z_MultiTexCoordP2ui_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP2ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP2uiv_adr := GetFuncAdr('glMultiTexCoordP2uiv');
    private z_MultiTexCoordP2uiv_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP2uiv_adr);
    private z_MultiTexCoordP2uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP2uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP2uiv_ovr_2 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP2uiv_ovr_2(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP3ui_adr := GetFuncAdr('glMultiTexCoordP3ui');
    private z_MultiTexCoordP3ui_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP3ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP3uiv_adr := GetFuncAdr('glMultiTexCoordP3uiv');
    private z_MultiTexCoordP3uiv_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP3uiv_adr);
    private z_MultiTexCoordP3uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP3uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP3uiv_ovr_2 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP3uiv_ovr_2(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP4ui_adr := GetFuncAdr('glMultiTexCoordP4ui');
    private z_MultiTexCoordP4ui_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32)>(z_MultiTexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP4ui_ovr_0(texture, &type, coords);
    
    // added in gl3.3
    private z_MultiTexCoordP4uiv_adr := GetFuncAdr('glMultiTexCoordP4uiv');
    private z_MultiTexCoordP4uiv_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32)>(z_MultiTexCoordP4uiv_adr);
    private z_MultiTexCoordP4uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP4uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords);
    private z_MultiTexCoordP4uiv_ovr_2 := GetFuncOrNil&<procedure(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr)>(z_MultiTexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP4uiv_ovr_2(texture, &type, coords);
    
    // added in gl4.5
    private z_NamedBufferData_adr := GetFuncAdr('glNamedBufferData');
    private z_NamedBufferData_ovr_0 := GetFuncOrNil&<procedure(buffer: BufferName; size: IntPtr; var data: Byte; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0<T>(buffer: BufferName; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure temp_NamedBufferData_ovr_0_anh00010(buffer: BufferName; size: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_0(buffer, size, PByte(nil)^, usage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: BufferName; size: IntPtr; data: array of T; usage: VertexBufferObjectUsage); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferData_ovr_0(buffer, size, data[0], usage) else
        temp_NamedBufferData_ovr_0_anh00010(buffer, size, usage);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: BufferName; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private z_NamedBufferData_ovr_2 := GetFuncOrNil&<procedure(buffer: BufferName; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage)>(z_NamedBufferData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData(buffer: BufferName; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_2(buffer, size, data, usage);
    
    // added in gl4.5
    private z_NamedBufferStorage_adr := GetFuncAdr('glNamedBufferStorage');
    private z_NamedBufferStorage_ovr_0 := GetFuncOrNil&<procedure(buffer: BufferName; size: IntPtr; data: IntPtr; flags: BufferStorageMask)>(z_NamedBufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorage(buffer: BufferName; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorage_ovr_0(buffer, size, data, flags);
    
    // added in gl4.5
    private z_NamedBufferSubData_adr := GetFuncAdr('glNamedBufferSubData');
    private z_NamedBufferSubData_ovr_0 := GetFuncOrNil&<procedure(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr)>(z_NamedBufferSubData_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubData_ovr_0(buffer, offset, size, data);
    
    // added in gl4.5
    private z_NamedFramebufferDrawBuffer_adr := GetFuncAdr('glNamedFramebufferDrawBuffer');
    private z_NamedFramebufferDrawBuffer_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; buf: ColorBuffer)>(z_NamedFramebufferDrawBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffer(framebuffer: FramebufferName; buf: ColorBuffer) :=
    z_NamedFramebufferDrawBuffer_ovr_0(framebuffer, buf);
    
    // added in gl4.5
    private z_NamedFramebufferDrawBuffers_adr := GetFuncAdr('glNamedFramebufferDrawBuffers');
    private z_NamedFramebufferDrawBuffers_ovr_0 := GetFuncOrNil&<procedure(framebuffer: UInt32; n: Int32; var bufs: ColorBuffer)>(z_NamedFramebufferDrawBuffers_adr);
    private z_NamedFramebufferDrawBuffers_ovr_0_anh0001 := GetFuncOrNil&<procedure(framebuffer: UInt32; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; bufs: array of ColorBuffer) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs[0]) else
      z_NamedFramebufferDrawBuffers_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; var bufs: ColorBuffer) :=
    z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs);
    private z_NamedFramebufferDrawBuffers_ovr_2 := GetFuncOrNil&<procedure(framebuffer: UInt32; n: Int32; bufs: IntPtr)>(z_NamedFramebufferDrawBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; bufs: IntPtr) :=
    z_NamedFramebufferDrawBuffers_ovr_2(framebuffer, n, bufs);
    
    // added in gl4.5
    private z_NamedFramebufferParameteri_adr := GetFuncAdr('glNamedFramebufferParameteri');
    private z_NamedFramebufferParameteri_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; pname: FramebufferParameterName; param: Int32)>(z_NamedFramebufferParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteri(framebuffer: FramebufferName; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteri_ovr_0(framebuffer, pname, param);
    
    // added in gl4.5
    private z_NamedFramebufferReadBuffer_adr := GetFuncAdr('glNamedFramebufferReadBuffer');
    private z_NamedFramebufferReadBuffer_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; src: ColorBuffer)>(z_NamedFramebufferReadBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferReadBuffer(framebuffer: FramebufferName; src: ColorBuffer) :=
    z_NamedFramebufferReadBuffer_ovr_0(framebuffer, src);
    
    // added in gl4.5
    private z_NamedFramebufferRenderbuffer_adr := GetFuncAdr('glNamedFramebufferRenderbuffer');
    private z_NamedFramebufferRenderbuffer_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName)>(z_NamedFramebufferRenderbuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbuffer(framebuffer: FramebufferName; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_NamedFramebufferRenderbuffer_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    // added in gl4.5
    private z_NamedFramebufferTexture_adr := GetFuncAdr('glNamedFramebufferTexture');
    private z_NamedFramebufferTexture_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32)>(z_NamedFramebufferTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32) :=
    z_NamedFramebufferTexture_ovr_0(framebuffer, attachment, texture, level);
    
    // added in gl4.5
    private z_NamedFramebufferTextureLayer_adr := GetFuncAdr('glNamedFramebufferTextureLayer');
    private z_NamedFramebufferTextureLayer_ovr_0 := GetFuncOrNil&<procedure(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32)>(z_NamedFramebufferTextureLayer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayer(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayer_ovr_0(framebuffer, attachment, texture, level, layer);
    
    // added in gl4.5
    private z_NamedRenderbufferStorage_adr := GetFuncAdr('glNamedRenderbufferStorage');
    private z_NamedRenderbufferStorage_ovr_0 := GetFuncOrNil&<procedure(renderbuffer: RenderbufferName; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorage(renderbuffer: RenderbufferName; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorage_ovr_0(renderbuffer, _internalformat, width, height);
    
    // added in gl4.5
    private z_NamedRenderbufferStorageMultisample_adr := GetFuncAdr('glNamedRenderbufferStorageMultisample');
    private z_NamedRenderbufferStorageMultisample_ovr_0 := GetFuncOrNil&<procedure(renderbuffer: RenderbufferName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_NamedRenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisample(renderbuffer: RenderbufferName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisample_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    // added in gl3.3
    private z_NormalP3ui_adr := GetFuncAdr('glNormalP3ui');
    private z_NormalP3ui_ovr_0 := GetFuncOrNil&<procedure(&type: NormalPointerType; coords: UInt32)>(z_NormalP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3ui(&type: NormalPointerType; coords: UInt32) :=
    z_NormalP3ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_NormalP3uiv_adr := GetFuncAdr('glNormalP3uiv');
    private z_NormalP3uiv_ovr_0 := GetFuncOrNil&<procedure(&type: NormalPointerType; var coords: UInt32)>(z_NormalP3uiv_adr);
    private z_NormalP3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: NormalPointerType; coords: IntPtr)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalP3uiv_ovr_0(&type, coords[0]) else
      z_NormalP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; var coords: UInt32) :=
    z_NormalP3uiv_ovr_0(&type, coords);
    private z_NormalP3uiv_ovr_2 := GetFuncOrNil&<procedure(&type: NormalPointerType; coords: IntPtr)>(z_NormalP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: IntPtr) :=
    z_NormalP3uiv_ovr_2(&type, coords);
    
    // added in gl4.3
    private z_ObjectLabel_adr := GetFuncAdr('glObjectLabel');
    private z_ObjectLabel_ovr_0 := GetFuncOrNil&<procedure(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr)>(z_ObjectLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
      z_ObjectLabel_ovr_0(identifier, name, length, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr) :=
    z_ObjectLabel_ovr_0(identifier, name, length, &label);
    
    // added in gl4.3
    private z_ObjectPtrLabel_adr := GetFuncAdr('glObjectPtrLabel');
    private z_ObjectPtrLabel_ovr_0 := GetFuncOrNil&<procedure(ptr: IntPtr; length: Int32; &label: IntPtr)>(z_ObjectPtrLabel_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(&label);
      z_ObjectPtrLabel_ovr_0(ptr, length, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: IntPtr) :=
    z_ObjectPtrLabel_ovr_0(ptr, length, &label);
    
    // added in gl4.0
    private z_PatchParameterfv_adr := GetFuncAdr('glPatchParameterfv');
    private z_PatchParameterfv_ovr_0 := GetFuncOrNil&<procedure(pname: PatchParameterName; var values: single)>(z_PatchParameterfv_adr);
    private z_PatchParameterfv_ovr_0_anh001 := GetFuncOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PatchParameterfv_ovr_0(pname, values[0]) else
      z_PatchParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; var values: single) :=
    z_PatchParameterfv_ovr_0(pname, values);
    private z_PatchParameterfv_ovr_2 := GetFuncOrNil&<procedure(pname: PatchParameterName; values: IntPtr)>(z_PatchParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: IntPtr) :=
    z_PatchParameterfv_ovr_2(pname, values);
    
    // added in gl4.0
    private z_PatchParameteri_adr := GetFuncAdr('glPatchParameteri');
    private z_PatchParameteri_ovr_0 := GetFuncOrNil&<procedure(pname: PatchParameterName; value: Int32)>(z_PatchParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameteri(pname: PatchParameterName; value: Int32) :=
    z_PatchParameteri_ovr_0(pname, value);
    
    // added in gl4.0
    private z_PauseTransformFeedback_adr := GetFuncAdr('glPauseTransformFeedback');
    private z_PauseTransformFeedback_ovr_0 := GetFuncOrNil&<procedure>(z_PauseTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedback :=
    z_PauseTransformFeedback_ovr_0;
    
    // added in gl1.0
    private static procedure z_PixelStoref_ovr_0(pname: PixelStoreParameter; param: single);
    external 'opengl32.dll' name 'glPixelStoref';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStoref(pname: PixelStoreParameter; param: single) :=
    z_PixelStoref_ovr_0(pname, param);
    
    // added in gl1.0
    private static procedure z_PixelStorei_ovr_0(pname: PixelStoreParameter; param: Int32);
    external 'opengl32.dll' name 'glPixelStorei';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStorei(pname: PixelStoreParameter; param: Int32) :=
    z_PixelStorei_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameterf_adr := GetFuncAdr('glPointParameterf');
    private z_PointParameterf_ovr_0 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; param: single)>(z_PointParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterf(pname: PointParameterNameARB; param: single) :=
    z_PointParameterf_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameterfv_adr := GetFuncAdr('glPointParameterfv');
    private z_PointParameterfv_ovr_0 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; var &params: single)>(z_PointParameterfv_adr);
    private z_PointParameterfv_ovr_0_anh001 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfv_ovr_0(pname, &params[0]) else
      z_PointParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfv_ovr_0(pname, &params);
    private z_PointParameterfv_ovr_2 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfv(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfv_ovr_2(pname, &params);
    
    // added in gl1.4
    private z_PointParameteri_adr := GetFuncAdr('glPointParameteri');
    private z_PointParameteri_ovr_0 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; param: Int32)>(z_PointParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteri(pname: PointParameterNameARB; param: Int32) :=
    z_PointParameteri_ovr_0(pname, param);
    
    // added in gl1.4
    private z_PointParameteriv_adr := GetFuncAdr('glPointParameteriv');
    private z_PointParameteriv_ovr_0 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; var &params: Int32)>(z_PointParameteriv_adr);
    private z_PointParameteriv_ovr_0_anh001 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameteriv_ovr_0(pname, &params[0]) else
      z_PointParameteriv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; var &params: Int32) :=
    z_PointParameteriv_ovr_0(pname, &params);
    private z_PointParameteriv_ovr_2 := GetFuncOrNil&<procedure(pname: PointParameterNameARB; &params: IntPtr)>(z_PointParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriv(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameteriv_ovr_2(pname, &params);
    
    // added in gl1.0
    private static procedure z_PointSize_ovr_0(size: single);
    external 'opengl32.dll' name 'glPointSize';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointSize(size: single) :=
    z_PointSize_ovr_0(size);
    
    // added in gl1.0
    private static procedure z_PolygonMode_ovr_0(face: DummyEnum; mode: OpenGL.PolygonMode);
    external 'opengl32.dll' name 'glPolygonMode';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonMode(face: DummyEnum; mode: OpenGL.PolygonMode) :=
    z_PolygonMode_ovr_0(face, mode);
    
    // added in gl1.1
    private static procedure z_PolygonOffset_ovr_0(factor: single; units: single);
    external 'opengl32.dll' name 'glPolygonOffset';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffset(factor: single; units: single) :=
    z_PolygonOffset_ovr_0(factor, units);
    
    // added in gl4.6
    private z_PolygonOffsetClamp_adr := GetFuncAdr('glPolygonOffsetClamp');
    private z_PolygonOffsetClamp_ovr_0 := GetFuncOrNil&<procedure(factor: single; units: single; clamp: single)>(z_PolygonOffsetClamp_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClamp(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClamp_ovr_0(factor, units, clamp);
    
    // added in gl4.3
    private z_PopDebugGroup_adr := GetFuncAdr('glPopDebugGroup');
    private z_PopDebugGroup_ovr_0 := GetFuncOrNil&<procedure>(z_PopDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopDebugGroup :=
    z_PopDebugGroup_ovr_0;
    
    // added in gl3.1
    private z_PrimitiveRestartIndex_adr := GetFuncAdr('glPrimitiveRestartIndex');
    private z_PrimitiveRestartIndex_ovr_0 := GetFuncOrNil&<procedure(index: UInt32)>(z_PrimitiveRestartIndex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartIndex(index: UInt32) :=
    z_PrimitiveRestartIndex_ovr_0(index);
    
    // added in gl4.1
    private z_ProgramBinary_adr := GetFuncAdr('glProgramBinary');
    private z_ProgramBinary_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; binaryFormat: DummyEnum; binary: IntPtr; length: Int32)>(z_ProgramBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBinary(&program: UInt32; binaryFormat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ProgramBinary_ovr_0(&program, binaryFormat, binary, length);
    
    // added in gl4.1
    private z_ProgramParameteri_adr := GetFuncAdr('glProgramParameteri');
    private z_ProgramParameteri_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; pname: ProgramParameterPName; value: Int32)>(z_ProgramParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: ProgramName; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
    // added in gl4.1
    private z_ProgramUniform1d_adr := GetFuncAdr('glProgramUniform1d');
    private z_ProgramUniform1d_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: real)>(z_ProgramUniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1d(&program: ProgramName; location: Int32; v0: real) :=
    z_ProgramUniform1d_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1dv_adr := GetFuncAdr('glProgramUniform1dv');
    private z_ProgramUniform1dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: real)>(z_ProgramUniform1dv_adr);
    private z_ProgramUniform1dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1f_adr := GetFuncAdr('glProgramUniform1f');
    private z_ProgramUniform1f_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: single)>(z_ProgramUniform1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1f(&program: ProgramName; location: Int32; v0: single) :=
    z_ProgramUniform1f_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1fv_adr := GetFuncAdr('glProgramUniform1fv');
    private z_ProgramUniform1fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: single)>(z_ProgramUniform1fv_adr);
    private z_ProgramUniform1fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1i_adr := GetFuncAdr('glProgramUniform1i');
    private z_ProgramUniform1i_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: Int32)>(z_ProgramUniform1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i(&program: ProgramName; location: Int32; v0: Int32) :=
    z_ProgramUniform1i_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1iv_adr := GetFuncAdr('glProgramUniform1iv');
    private z_ProgramUniform1iv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform1iv_adr);
    private z_ProgramUniform1iv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1iv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform1ui_adr := GetFuncAdr('glProgramUniform1ui');
    private z_ProgramUniform1ui_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: UInt32)>(z_ProgramUniform1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui(&program: ProgramName; location: Int32; v0: UInt32) :=
    z_ProgramUniform1ui_ovr_0(&program, location, v0);
    
    // added in gl4.1
    private z_ProgramUniform1uiv_adr := GetFuncAdr('glProgramUniform1uiv');
    private z_ProgramUniform1uiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform1uiv_adr);
    private z_ProgramUniform1uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform1uiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2d_adr := GetFuncAdr('glProgramUniform2d');
    private z_ProgramUniform2d_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: real; v1: real)>(z_ProgramUniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2d(&program: ProgramName; location: Int32; v0: real; v1: real) :=
    z_ProgramUniform2d_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2dv_adr := GetFuncAdr('glProgramUniform2dv');
    private z_ProgramUniform2dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: real)>(z_ProgramUniform2dv_adr);
    private z_ProgramUniform2dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2f_adr := GetFuncAdr('glProgramUniform2f');
    private z_ProgramUniform2f_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: single; v1: single)>(z_ProgramUniform2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2f(&program: ProgramName; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2f_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2fv_adr := GetFuncAdr('glProgramUniform2fv');
    private z_ProgramUniform2fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: single)>(z_ProgramUniform2fv_adr);
    private z_ProgramUniform2fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2i_adr := GetFuncAdr('glProgramUniform2i');
    private z_ProgramUniform2i_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: Int32; v1: Int32)>(z_ProgramUniform2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2i_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2iv_adr := GetFuncAdr('glProgramUniform2iv');
    private z_ProgramUniform2iv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform2iv_adr);
    private z_ProgramUniform2iv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2iv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform2ui_adr := GetFuncAdr('glProgramUniform2ui');
    private z_ProgramUniform2ui_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32)>(z_ProgramUniform2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2ui_ovr_0(&program, location, v0, v1);
    
    // added in gl4.1
    private z_ProgramUniform2uiv_adr := GetFuncAdr('glProgramUniform2uiv');
    private z_ProgramUniform2uiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform2uiv_adr);
    private z_ProgramUniform2uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform2uiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3d_adr := GetFuncAdr('glProgramUniform3d');
    private z_ProgramUniform3d_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real)>(z_ProgramUniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3d(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real) :=
    z_ProgramUniform3d_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3dv_adr := GetFuncAdr('glProgramUniform3dv');
    private z_ProgramUniform3dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: real)>(z_ProgramUniform3dv_adr);
    private z_ProgramUniform3dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3f_adr := GetFuncAdr('glProgramUniform3f');
    private z_ProgramUniform3f_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single)>(z_ProgramUniform3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3f(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3f_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3fv_adr := GetFuncAdr('glProgramUniform3fv');
    private z_ProgramUniform3fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: single)>(z_ProgramUniform3fv_adr);
    private z_ProgramUniform3fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3i_adr := GetFuncAdr('glProgramUniform3i');
    private z_ProgramUniform3i_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_ProgramUniform3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3i_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3iv_adr := GetFuncAdr('glProgramUniform3iv');
    private z_ProgramUniform3iv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform3iv_adr);
    private z_ProgramUniform3iv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3iv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform3ui_adr := GetFuncAdr('glProgramUniform3ui');
    private z_ProgramUniform3ui_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_ProgramUniform3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3ui_ovr_0(&program, location, v0, v1, v2);
    
    // added in gl4.1
    private z_ProgramUniform3uiv_adr := GetFuncAdr('glProgramUniform3uiv');
    private z_ProgramUniform3uiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform3uiv_adr);
    private z_ProgramUniform3uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform3uiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4d_adr := GetFuncAdr('glProgramUniform4d');
    private z_ProgramUniform4d_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real; v3: real)>(z_ProgramUniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4d(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real; v3: real) :=
    z_ProgramUniform4d_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4dv_adr := GetFuncAdr('glProgramUniform4dv');
    private z_ProgramUniform4dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: real)>(z_ProgramUniform4dv_adr);
    private z_ProgramUniform4dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4f_adr := GetFuncAdr('glProgramUniform4f');
    private z_ProgramUniform4f_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_ProgramUniform4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4f(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4f_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4fv_adr := GetFuncAdr('glProgramUniform4fv');
    private z_ProgramUniform4fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: single)>(z_ProgramUniform4fv_adr);
    private z_ProgramUniform4fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4i_adr := GetFuncAdr('glProgramUniform4i');
    private z_ProgramUniform4i_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_ProgramUniform4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4i_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4iv_adr := GetFuncAdr('glProgramUniform4iv');
    private z_ProgramUniform4iv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: Int32)>(z_ProgramUniform4iv_adr);
    private z_ProgramUniform4iv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4iv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4iv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4iv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniform4ui_adr := GetFuncAdr('glProgramUniform4ui');
    private z_ProgramUniform4ui_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_ProgramUniform4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4ui_ovr_0(&program, location, v0, v1, v2, v3);
    
    // added in gl4.1
    private z_ProgramUniform4uiv_adr := GetFuncAdr('glProgramUniform4uiv');
    private z_ProgramUniform4uiv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; var value: UInt32)>(z_ProgramUniform4uiv_adr);
    private z_ProgramUniform4uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uiv_ovr_0(&program, location, count, value);
    private z_ProgramUniform4uiv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; value: IntPtr)>(z_ProgramUniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uiv_ovr_2(&program, location, count, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2dv_adr := GetFuncAdr('glProgramUniformMatrix2dv');
    private z_ProgramUniformMatrix2dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2dv_adr);
    private z_ProgramUniformMatrix2dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2fv_adr := GetFuncAdr('glProgramUniformMatrix2fv');
    private z_ProgramUniformMatrix2fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2fv_adr);
    private z_ProgramUniformMatrix2fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x3dv_adr := GetFuncAdr('glProgramUniformMatrix2x3dv');
    private z_ProgramUniformMatrix2x3dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x3dv_adr);
    private z_ProgramUniformMatrix2x3dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x3fv_adr := GetFuncAdr('glProgramUniformMatrix2x3fv');
    private z_ProgramUniformMatrix2x3fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x3fv_adr);
    private z_ProgramUniformMatrix2x3fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x3fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x4dv_adr := GetFuncAdr('glProgramUniformMatrix2x4dv');
    private z_ProgramUniformMatrix2x4dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix2x4dv_adr);
    private z_ProgramUniformMatrix2x4dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix2x4fv_adr := GetFuncAdr('glProgramUniformMatrix2x4fv');
    private z_ProgramUniformMatrix2x4fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix2x4fv_adr);
    private z_ProgramUniformMatrix2x4fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix2x4fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3dv_adr := GetFuncAdr('glProgramUniformMatrix3dv');
    private z_ProgramUniformMatrix3dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3dv_adr);
    private z_ProgramUniformMatrix3dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3fv_adr := GetFuncAdr('glProgramUniformMatrix3fv');
    private z_ProgramUniformMatrix3fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3fv_adr);
    private z_ProgramUniformMatrix3fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x2dv_adr := GetFuncAdr('glProgramUniformMatrix3x2dv');
    private z_ProgramUniformMatrix3x2dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x2dv_adr);
    private z_ProgramUniformMatrix3x2dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x2fv_adr := GetFuncAdr('glProgramUniformMatrix3x2fv');
    private z_ProgramUniformMatrix3x2fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x2fv_adr);
    private z_ProgramUniformMatrix3x2fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x2fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x4dv_adr := GetFuncAdr('glProgramUniformMatrix3x4dv');
    private z_ProgramUniformMatrix3x4dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix3x4dv_adr);
    private z_ProgramUniformMatrix3x4dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix3x4fv_adr := GetFuncAdr('glProgramUniformMatrix3x4fv');
    private z_ProgramUniformMatrix3x4fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix3x4fv_adr);
    private z_ProgramUniformMatrix3x4fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix3x4fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4dv_adr := GetFuncAdr('glProgramUniformMatrix4dv');
    private z_ProgramUniformMatrix4dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4dv_adr);
    private z_ProgramUniformMatrix4dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4fv_adr := GetFuncAdr('glProgramUniformMatrix4fv');
    private z_ProgramUniformMatrix4fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4fv_adr);
    private z_ProgramUniformMatrix4fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x2dv_adr := GetFuncAdr('glProgramUniformMatrix4x2dv');
    private z_ProgramUniformMatrix4x2dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x2dv_adr);
    private z_ProgramUniformMatrix4x2dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x2fv_adr := GetFuncAdr('glProgramUniformMatrix4x2fv');
    private z_ProgramUniformMatrix4x2fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x2fv_adr);
    private z_ProgramUniformMatrix4x2fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x2fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x3dv_adr := GetFuncAdr('glProgramUniformMatrix4x3dv');
    private z_ProgramUniformMatrix4x3dv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real)>(z_ProgramUniformMatrix4x3dv_adr);
    private z_ProgramUniformMatrix4x3dv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3dv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl4.1
    private z_ProgramUniformMatrix4x3fv_adr := GetFuncAdr('glProgramUniformMatrix4x3fv');
    private z_ProgramUniformMatrix4x3fv_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single)>(z_ProgramUniformMatrix4x3fv_adr);
    private z_ProgramUniformMatrix4x3fv_ovr_0_anh000001 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value);
    private z_ProgramUniformMatrix4x3fv_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_ProgramUniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fv_ovr_2(&program, location, count, transpose, value);
    
    // added in gl3.2
    private z_ProvokingVertex_adr := GetFuncAdr('glProvokingVertex');
    private z_ProvokingVertex_ovr_0 := GetFuncOrNil&<procedure(mode: VertexProvokingMode)>(z_ProvokingVertex_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertex(mode: VertexProvokingMode) :=
    z_ProvokingVertex_ovr_0(mode);
    
    // added in gl4.3
    private z_PushDebugGroup_adr := GetFuncAdr('glPushDebugGroup');
    private z_PushDebugGroup_ovr_0 := GetFuncOrNil&<procedure(source: DebugSource; id: UInt32; length: Int32; message: IntPtr)>(z_PushDebugGroup_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(message);
      z_PushDebugGroup_ovr_0(source, id, length, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: IntPtr) :=
    z_PushDebugGroup_ovr_0(source, id, length, message);
    
    // added in gl3.3
    private z_QueryCounter_adr := GetFuncAdr('glQueryCounter');
    private z_QueryCounter_ovr_0 := GetFuncOrNil&<procedure(id: QueryName; target: QueryCounterTarget)>(z_QueryCounter_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryCounter(id: QueryName; target: QueryCounterTarget) :=
    z_QueryCounter_ovr_0(id, target);
    
    // added in gl1.0
    private static procedure z_ReadBuffer_ovr_0(src: ReadBufferMode);
    external 'opengl32.dll' name 'glReadBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadBuffer(src: ReadBufferMode) :=
    z_ReadBuffer_ovr_0(src);
    
    // added in gl4.5
    private z_ReadnPixels_adr := GetFuncAdr('glReadnPixels');
    private z_ReadnPixels_ovr_0 := GetFuncOrNil&<procedure(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr)>(z_ReadnPixels_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixels_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    // added in gl1.0
    private static procedure z_ReadPixels_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glReadPixels';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_ReadPixels_ovr_0(x, y, width, height, format, &type, pixels);
    
    // added in gl4.1
    private z_ReleaseShaderCompiler_adr := GetFuncAdr('glReleaseShaderCompiler');
    private z_ReleaseShaderCompiler_ovr_0 := GetFuncOrNil&<procedure>(z_ReleaseShaderCompiler_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseShaderCompiler :=
    z_ReleaseShaderCompiler_ovr_0;
    
    // added in gl3.0
    private z_RenderbufferStorage_adr := GetFuncAdr('glRenderbufferStorage');
    private z_RenderbufferStorage_ovr_0 := GetFuncOrNil&<procedure(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorage(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorage_ovr_0(target, _internalformat, width, height);
    
    // added in gl3.0
    private z_RenderbufferStorageMultisample_adr := GetFuncAdr('glRenderbufferStorageMultisample');
    private z_RenderbufferStorageMultisample_ovr_0 := GetFuncOrNil&<procedure(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_RenderbufferStorageMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisample(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisample_ovr_0(target, samples, _internalformat, width, height);
    
    // added in gl4.0
    private z_ResumeTransformFeedback_adr := GetFuncAdr('glResumeTransformFeedback');
    private z_ResumeTransformFeedback_ovr_0 := GetFuncOrNil&<procedure>(z_ResumeTransformFeedback_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedback :=
    z_ResumeTransformFeedback_ovr_0;
    
    // added in gl1.3
    private z_SampleCoverage_adr := GetFuncAdr('glSampleCoverage');
    private z_SampleCoverage_ovr_0 := GetFuncOrNil&<procedure(value: single; invert: boolean)>(z_SampleCoverage_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleCoverage(value: single; invert: boolean) :=
    z_SampleCoverage_ovr_0(value, invert);
    
    // added in gl3.2
    private z_SampleMaski_adr := GetFuncAdr('glSampleMaski');
    private z_SampleMaski_ovr_0 := GetFuncOrNil&<procedure(maskNumber: UInt32; mask: DummyFlags)>(z_SampleMaski_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaski(maskNumber: UInt32; mask: DummyFlags) :=
    z_SampleMaski_ovr_0(maskNumber, mask);
    
    // added in gl3.3
    private z_SamplerParameterf_adr := GetFuncAdr('glSamplerParameterf');
    private z_SamplerParameterf_ovr_0 := GetFuncOrNil&<procedure(sampler: SamplerName; pname: OpenGL.SamplerParameterF; param: single)>(z_SamplerParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterf(sampler: SamplerName; pname: OpenGL.SamplerParameterF; param: single) :=
    z_SamplerParameterf_ovr_0(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterfv_adr := GetFuncAdr('glSamplerParameterfv');
    private z_SamplerParameterfv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterF; var param: single)>(z_SamplerParameterfv_adr);
    private z_SamplerParameterfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterfv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; var param: single) :=
    z_SamplerParameterfv_ovr_0(sampler, pname, param);
    private z_SamplerParameterfv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr)>(z_SamplerParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr) :=
    z_SamplerParameterfv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameteri_adr := GetFuncAdr('glSamplerParameteri');
    private z_SamplerParameteri_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: Int32)>(z_SamplerParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteri(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: Int32) :=
    z_SamplerParameteri_ovr_0(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterIiv_adr := GetFuncAdr('glSamplerParameterIiv');
    private z_SamplerParameterIiv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameterIiv_adr);
    private z_SamplerParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameterIiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIiv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIiv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameterIuiv_adr := GetFuncAdr('glSamplerParameterIuiv');
    private z_SamplerParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: UInt32)>(z_SamplerParameterIuiv_adr);
    private z_SamplerParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIuiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: UInt32) :=
    z_SamplerParameterIuiv_ovr_0(sampler, pname, param);
    private z_SamplerParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIuiv_ovr_2(sampler, pname, param);
    
    // added in gl3.3
    private z_SamplerParameteriv_adr := GetFuncAdr('glSamplerParameteriv');
    private z_SamplerParameteriv_ovr_0 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32)>(z_SamplerParameteriv_adr);
    private z_SamplerParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameteriv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameteriv_ovr_0(sampler, pname, param);
    private z_SamplerParameteriv_ovr_2 := GetFuncOrNil&<procedure(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr)>(z_SamplerParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameteriv_ovr_2(sampler, pname, param);
    
    // added in gl1.0
    private static procedure z_Scissor_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glScissor';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scissor(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_Scissor_ovr_0(x, y, width, height);
    
    // added in gl4.1
    private z_ScissorArrayv_adr := GetFuncAdr('glScissorArrayv');
    private z_ScissorArrayv_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var v: Int32)>(z_ScissorArrayv_adr);
    private z_ScissorArrayv_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorArrayv_ovr_0(first, count, v[0]) else
      z_ScissorArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorArrayv_ovr_0(first, count, v);
    private z_ScissorArrayv_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ScissorArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_ScissorIndexed_adr := GetFuncAdr('glScissorIndexed');
    private z_ScissorIndexed_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32)>(z_ScissorIndexed_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexed(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32) :=
    z_ScissorIndexed_ovr_0(index, left, bottom, width, height);
    
    // added in gl4.1
    private z_ScissorIndexedv_adr := GetFuncAdr('glScissorIndexedv');
    private z_ScissorIndexedv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_ScissorIndexedv_adr);
    private z_ScissorIndexedv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorIndexedv_ovr_0(index, v[0]) else
      z_ScissorIndexedv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; var v: Int32) :=
    z_ScissorIndexedv_ovr_0(index, v);
    private z_ScissorIndexedv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ScissorIndexedv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: IntPtr) :=
    z_ScissorIndexedv_ovr_2(index, v);
    
    // added in gl3.3
    private z_SecondaryColorP3ui_adr := GetFuncAdr('glSecondaryColorP3ui');
    private z_SecondaryColorP3ui_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: UInt32)>(z_SecondaryColorP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_SecondaryColorP3ui_ovr_0(&type, color);
    
    // added in gl3.3
    private z_SecondaryColorP3uiv_adr := GetFuncAdr('glSecondaryColorP3uiv');
    private z_SecondaryColorP3uiv_ovr_0 := GetFuncOrNil&<procedure(&type: ColorPointerType; var color: UInt32)>(z_SecondaryColorP3uiv_adr);
    private z_SecondaryColorP3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_SecondaryColorP3uiv_ovr_0(&type, color[0]) else
      z_SecondaryColorP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_SecondaryColorP3uiv_ovr_0(&type, color);
    private z_SecondaryColorP3uiv_ovr_2 := GetFuncOrNil&<procedure(&type: ColorPointerType; color: IntPtr)>(z_SecondaryColorP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_SecondaryColorP3uiv_ovr_2(&type, color);
    
    // added in gl4.1
    private z_ShaderBinary_adr := GetFuncAdr('glShaderBinary');
    private z_ShaderBinary_ovr_0 := GetFuncOrNil&<procedure(count: Int32; var shaders: UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    private z_ShaderBinary_ovr_0_anh001000 := GetFuncOrNil&<procedure(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: array of UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_ShaderBinary_ovr_0(count, shaders[0], binaryformat, binary, length) else
      z_ShaderBinary_ovr_0_anh001000(count, IntPtr.Zero, binaryformat, binary, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; var shaders: UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_0(count, shaders, binaryformat, binary, length);
    private z_ShaderBinary_ovr_2 := GetFuncOrNil&<procedure(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32)>(z_ShaderBinary_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_2(count, shaders, binaryformat, binary, length);
    
    // added in gl2.0
    private z_ShaderSource_adr := GetFuncAdr('glShaderSource');
    private z_ShaderSource_ovr_0 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; var _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00001 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_0_anh00011 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of string; length: array of Int32);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        if (length<>nil) and (length.Length<>0) then
          z_ShaderSource_ovr_0(shader, count, par_3_str_ptr[0], length[0]) else
          z_ShaderSource_ovr_0_anh00001(shader, count, par_3_str_ptr[0], IntPtr.Zero) else
        if (length<>nil) and (length.Length<>0) then
          z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
          z_ShaderSource_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_ShaderSource_ovr_1_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of string; var length: Int32);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_ShaderSource_ovr_0(shader, count, par_3_str_ptr[0], length) else
        z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_ShaderSource_ovr_2 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; var _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_2_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of string; length: IntPtr);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_ShaderSource_ovr_2(shader, count, par_3_str_ptr[0], length) else
        z_ShaderSource_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_ShaderSource_ovr_3_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_3_anh00011 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of IntPtr; length: array of Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSource_ovr_0(shader, count, _string[0], length[0]) else
        z_ShaderSource_ovr_0_anh00001(shader, count, _string[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
        z_ShaderSource_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
    private z_ShaderSource_ovr_4_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of IntPtr; var length: Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSource_ovr_0(shader, count, _string[0], length) else
      z_ShaderSource_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
    private z_ShaderSource_ovr_5_anh00010 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: array of IntPtr; length: IntPtr) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSource_ovr_2(shader, count, _string[0], length) else
      z_ShaderSource_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
    private z_ShaderSource_ovr_6 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32)>(z_ShaderSource_adr);
    private z_ShaderSource_ovr_6_anh00001 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_ShaderSource_ovr_6(shader, count, _string, length[0]) else
      z_ShaderSource_ovr_6_anh00001(shader, count, _string, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: IntPtr; var length: Int32) :=
    z_ShaderSource_ovr_6(shader, count, _string, length);
    private z_ShaderSource_ovr_8 := GetFuncOrNil&<procedure(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr)>(z_ShaderSource_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSource(shader: ShaderName; count: Int32; _string: IntPtr; length: IntPtr) :=
    z_ShaderSource_ovr_8(shader, count, _string, length);
    
    // added in gl4.3
    private z_ShaderStorageBlockBinding_adr := GetFuncAdr('glShaderStorageBlockBinding');
    private z_ShaderStorageBlockBinding_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; storageBlockIndex: UInt32; storageBlockBinding: UInt32)>(z_ShaderStorageBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderStorageBlockBinding(&program: ProgramName; storageBlockIndex: UInt32; storageBlockBinding: UInt32) :=
    z_ShaderStorageBlockBinding_ovr_0(&program, storageBlockIndex, storageBlockBinding);
    
    // added in gl4.6
    private z_SpecializeShader_adr := GetFuncAdr('glSpecializeShader');
    private z_SpecializeShader_ovr_0 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000010 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000001 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_0_anh000011 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
          z_SpecializeShader_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShader_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
          z_SpecializeShader_ovr_0_anh000011(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private z_SpecializeShader_ovr_1_anh000010 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
        z_SpecializeShader_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private z_SpecializeShader_ovr_2 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_2_anh000010 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        z_SpecializeShader_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
        z_SpecializeShader_ovr_2_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
        z_SpecializeShader_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShader_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShader_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private z_SpecializeShader_ovr_6 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32)>(z_SpecializeShader_adr);
    private z_SpecializeShader_ovr_6_anh000001 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
        z_SpecializeShader_ovr_6_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShader_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private z_SpecializeShader_ovr_8 := GetFuncOrNil&<procedure(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr)>(z_SpecializeShader_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShader_ovr_8(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
        z_SpecializeShader_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShader_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
        z_SpecializeShader_ovr_0_anh000011(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShader_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShader_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShader_ovr_2_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShader_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32) :=
    z_SpecializeShader_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr) :=
    z_SpecializeShader_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShader_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShader_ovr_6_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32) :=
    z_SpecializeShader_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShader(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr) :=
    z_SpecializeShader_ovr_8(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    
    // added in gl1.0
    private static procedure z_StencilFunc_ovr_0(func: StencilFunction; ref: Int32; mask: UInt32);
    external 'opengl32.dll' name 'glStencilFunc';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFunc(func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFunc_ovr_0(func, ref, mask);
    
    // added in gl2.0
    private z_StencilFuncSeparate_adr := GetFuncAdr('glStencilFuncSeparate');
    private z_StencilFuncSeparate_ovr_0 := GetFuncOrNil&<procedure(face: StencilFaceDirection; func: StencilFunction; ref: Int32; mask: UInt32)>(z_StencilFuncSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFuncSeparate(face: StencilFaceDirection; func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFuncSeparate_ovr_0(face, func, ref, mask);
    
    // added in gl1.0
    private static procedure z_StencilMask_ovr_0(mask: UInt32);
    external 'opengl32.dll' name 'glStencilMask';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilMask(mask: UInt32) :=
    z_StencilMask_ovr_0(mask);
    
    // added in gl2.0
    private z_StencilMaskSeparate_adr := GetFuncAdr('glStencilMaskSeparate');
    private z_StencilMaskSeparate_ovr_0 := GetFuncOrNil&<procedure(face: StencilFaceDirection; mask: UInt32)>(z_StencilMaskSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilMaskSeparate(face: StencilFaceDirection; mask: UInt32) :=
    z_StencilMaskSeparate_ovr_0(face, mask);
    
    // added in gl1.0
    private static procedure z_StencilOp_ovr_0(fail: OpenGL.StencilOp; zfail: OpenGL.StencilOp; zpass: OpenGL.StencilOp);
    external 'opengl32.dll' name 'glStencilOp';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOp(fail: OpenGL.StencilOp; zfail: OpenGL.StencilOp; zpass: OpenGL.StencilOp) :=
    z_StencilOp_ovr_0(fail, zfail, zpass);
    
    // added in gl2.0
    private z_StencilOpSeparate_adr := GetFuncAdr('glStencilOpSeparate');
    private z_StencilOpSeparate_ovr_0 := GetFuncOrNil&<procedure(face: StencilFaceDirection; sfail: OpenGL.StencilOp; dpfail: OpenGL.StencilOp; dppass: OpenGL.StencilOp)>(z_StencilOpSeparate_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpSeparate(face: StencilFaceDirection; sfail: OpenGL.StencilOp; dpfail: OpenGL.StencilOp; dppass: OpenGL.StencilOp) :=
    z_StencilOpSeparate_ovr_0(face, sfail, dpfail, dppass);
    
    // added in gl3.1
    private z_TexBuffer_adr := GetFuncAdr('glTexBuffer');
    private z_TexBuffer_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName)>(z_TexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBuffer(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName) :=
    z_TexBuffer_ovr_0(target, _internalformat, buffer);
    
    // added in gl4.3
    private z_TexBufferRange_adr := GetFuncAdr('glTexBufferRange');
    private z_TexBufferRange_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr)>(z_TexBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferRange(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TexBufferRange_ovr_0(target, _internalformat, buffer, offset, size);
    
    // added in gl3.3
    private z_TexCoordP1ui_adr := GetFuncAdr('glTexCoordP1ui');
    private z_TexCoordP1ui_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP1ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP1uiv_adr := GetFuncAdr('glTexCoordP1uiv');
    private z_TexCoordP1uiv_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP1uiv_adr);
    private z_TexCoordP1uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP1uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP1uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP1uiv_ovr_0(&type, coords);
    private z_TexCoordP1uiv_ovr_2 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP1uiv_ovr_2(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP2ui_adr := GetFuncAdr('glTexCoordP2ui');
    private z_TexCoordP2ui_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP2ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP2uiv_adr := GetFuncAdr('glTexCoordP2uiv');
    private z_TexCoordP2uiv_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP2uiv_adr);
    private z_TexCoordP2uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP2uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP2uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP2uiv_ovr_0(&type, coords);
    private z_TexCoordP2uiv_ovr_2 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP2uiv_ovr_2(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP3ui_adr := GetFuncAdr('glTexCoordP3ui');
    private z_TexCoordP3ui_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP3ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP3uiv_adr := GetFuncAdr('glTexCoordP3uiv');
    private z_TexCoordP3uiv_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP3uiv_adr);
    private z_TexCoordP3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP3uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP3uiv_ovr_0(&type, coords);
    private z_TexCoordP3uiv_ovr_2 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP3uiv_ovr_2(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP4ui_adr := GetFuncAdr('glTexCoordP4ui');
    private z_TexCoordP4ui_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: UInt32)>(z_TexCoordP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP4ui_ovr_0(&type, coords);
    
    // added in gl3.3
    private z_TexCoordP4uiv_adr := GetFuncAdr('glTexCoordP4uiv');
    private z_TexCoordP4uiv_ovr_0 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; var coords: UInt32)>(z_TexCoordP4uiv_adr);
    private z_TexCoordP4uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP4uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP4uiv_ovr_0(&type, coords);
    private z_TexCoordP4uiv_ovr_2 := GetFuncOrNil&<procedure(&type: TexCoordPointerType; coords: IntPtr)>(z_TexCoordP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP4uiv_ovr_2(&type, coords);
    
    // added in gl1.0
    private static procedure z_TexImage1D_ovr_0(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage1D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage1D_ovr_0(target, level, internalformat, width, border, format, &type, pixels);
    
    // added in gl1.0
    private static procedure z_TexImage2D_ovr_0(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage2D_ovr_0(target, level, internalformat, width, height, border, format, &type, pixels);
    
    // added in gl3.2
    private z_TexImage2DMultisample_adr := GetFuncAdr('glTexImage2DMultisample');
    private z_TexImage2DMultisample_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexImage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexImage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    // added in gl1.2
    private z_TexImage3D_adr := GetFuncAdr('glTexImage3D');
    private z_TexImage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3D(target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage3D_ovr_0(target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    // added in gl3.2
    private z_TexImage3DMultisample_adr := GetFuncAdr('glTexImage3DMultisample');
    private z_TexImage3DMultisample_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexImage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexImage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl1.0
    private static procedure z_TexParameterf_ovr_0(target: TextureTarget; pname: TextureParameterName; param: single);
    external 'opengl32.dll' name 'glTexParameterf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterf(target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_TexParameterf_ovr_0(target, pname, param);
    
    // added in gl1.0
    private static procedure z_TexParameterfv_ovr_0(target: TextureTarget; pname: TextureParameterName; var &params: single);
    external 'opengl32.dll' name 'glTexParameterfv';
    private static procedure z_TexParameterfv_ovr_0_anh0001(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterfv_ovr_0(target, pname, &params[0]) else
      z_TexParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_TexParameterfv_ovr_0(target, pname, &params);
    private static procedure z_TexParameterfv_ovr_2(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterfv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterfv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private static procedure z_TexParameteri_ovr_0(target: TextureTarget; pname: TextureParameterName; param: Int32);
    external 'opengl32.dll' name 'glTexParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteri(target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_TexParameteri_ovr_0(target, pname, param);
    
    // added in gl3.0
    private z_TexParameterIiv_adr := GetFuncAdr('glTexParameterIiv');
    private z_TexParameterIiv_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: Int32)>(z_TexParameterIiv_adr);
    private z_TexParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIiv_ovr_0(target, pname, &params[0]) else
      z_TexParameterIiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameterIiv_ovr_0(target, pname, &params);
    private z_TexParameterIiv_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIiv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIiv_ovr_2(target, pname, &params);
    
    // added in gl3.0
    private z_TexParameterIuiv_adr := GetFuncAdr('glTexParameterIuiv');
    private z_TexParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; var &params: UInt32)>(z_TexParameterIuiv_adr);
    private z_TexParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIuiv_ovr_0(target, pname, &params[0]) else
      z_TexParameterIuiv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TexParameterIuiv_ovr_0(target, pname, &params);
    private z_TexParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(target: TextureTarget; pname: TextureParameterName; &params: IntPtr)>(z_TexParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuiv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIuiv_ovr_2(target, pname, &params);
    
    // added in gl1.0
    private static procedure z_TexParameteriv_ovr_0(target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glTexParameteriv';
    private static procedure z_TexParameteriv_ovr_0_anh0001(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameteriv_ovr_0(target, pname, &params[0]) else
      z_TexParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameteriv_ovr_0(target, pname, &params);
    private static procedure z_TexParameteriv_ovr_2(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameteriv(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameteriv_ovr_2(target, pname, &params);
    
    // added in gl4.2
    private z_TexStorage1D_adr := GetFuncAdr('glTexStorage1D');
    private z_TexStorage1D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32)>(z_TexStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage1D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32) :=
    z_TexStorage1D_ovr_0(target, levels, _internalformat, width);
    
    // added in gl4.2
    private z_TexStorage2D_adr := GetFuncAdr('glTexStorage2D');
    private z_TexStorage2D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_TexStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_TexStorage2D_ovr_0(target, levels, _internalformat, width, height);
    
    // added in gl4.3
    private z_TexStorage2DMultisample_adr := GetFuncAdr('glTexStorage2DMultisample');
    private z_TexStorage2DMultisample_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TexStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    // added in gl4.2
    private z_TexStorage3D_adr := GetFuncAdr('glTexStorage3D');
    private z_TexStorage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TexStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TexStorage3D_ovr_0(target, levels, _internalformat, width, height, depth);
    
    // added in gl4.3
    private z_TexStorage3DMultisample_adr := GetFuncAdr('glTexStorage3DMultisample');
    private z_TexStorage3DMultisample_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TexStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl1.1
    private static procedure z_TexSubImage1D_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage1D(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage1D_ovr_0(target, level, xoffset, width, format, &type, pixels);
    
    // added in gl1.1
    private static procedure z_TexSubImage2D_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage2D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage2D_ovr_0(target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    // added in gl1.2
    private z_TexSubImage3D_adr := GetFuncAdr('glTexSubImage3D');
    private z_TexSubImage3D_ovr_0 := GetFuncOrNil&<procedure(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TexSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage3D(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage3D_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureBarrier_adr := GetFuncAdr('glTextureBarrier');
    private z_TextureBarrier_ovr_0 := GetFuncOrNil&<procedure>(z_TextureBarrier_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrier :=
    z_TextureBarrier_ovr_0;
    
    // added in gl4.5
    private z_TextureBuffer_adr := GetFuncAdr('glTextureBuffer');
    private z_TextureBuffer_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName)>(z_TextureBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBuffer(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName) :=
    z_TextureBuffer_ovr_0(texture, _internalformat, buffer);
    
    // added in gl4.5
    private z_TextureBufferRange_adr := GetFuncAdr('glTextureBufferRange');
    private z_TextureBufferRange_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr)>(z_TextureBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRange(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRange_ovr_0(texture, _internalformat, buffer, offset, size);
    
    // added in gl4.5
    private z_TextureParameterf_adr := GetFuncAdr('glTextureParameterf');
    private z_TextureParameterf_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; pname: TextureParameterName; param: single)>(z_TextureParameterf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterf(texture: TextureName; pname: TextureParameterName; param: single) :=
    z_TextureParameterf_ovr_0(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameterfv_adr := GetFuncAdr('glTextureParameterfv');
    private z_TextureParameterfv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; var param: single)>(z_TextureParameterfv_adr);
    private z_TextureParameterfv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameterfv_ovr_0(texture, pname, param[0]) else
      z_TextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; var param: single) :=
    z_TextureParameterfv_ovr_0(texture, pname, param);
    private z_TextureParameterfv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; param: IntPtr)>(z_TextureParameterfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameterfv_ovr_2(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameteri_adr := GetFuncAdr('glTextureParameteri');
    private z_TextureParameteri_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; param: Int32)>(z_TextureParameteri_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteri(texture: UInt32; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteri_ovr_0(texture, pname, param);
    
    // added in gl4.5
    private z_TextureParameterIiv_adr := GetFuncAdr('glTextureParameterIiv');
    private z_TextureParameterIiv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; var &params: Int32)>(z_TextureParameterIiv_adr);
    private z_TextureParameterIiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIiv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_TextureParameterIuiv_adr := GetFuncAdr('glTextureParameterIuiv');
    private z_TextureParameterIuiv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; var &params: UInt32)>(z_TextureParameterIuiv_adr);
    private z_TextureParameterIuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuiv_ovr_0(texture, pname, &params);
    private z_TextureParameterIuiv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; &params: IntPtr)>(z_TextureParameterIuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuiv_ovr_2(texture, pname, &params);
    
    // added in gl4.5
    private z_TextureParameteriv_adr := GetFuncAdr('glTextureParameteriv');
    private z_TextureParameteriv_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; var param: Int32)>(z_TextureParameteriv_adr);
    private z_TextureParameteriv_ovr_0_anh0001 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameteriv_ovr_0(texture, pname, param[0]) else
      z_TextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; var param: Int32) :=
    z_TextureParameteriv_ovr_0(texture, pname, param);
    private z_TextureParameteriv_ovr_2 := GetFuncOrNil&<procedure(texture: UInt32; pname: TextureParameterName; param: IntPtr)>(z_TextureParameteriv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameteriv_ovr_2(texture, pname, param);
    
    // added in gl4.5
    private z_TextureStorage1D_adr := GetFuncAdr('glTextureStorage1D');
    private z_TextureStorage1D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32)>(z_TextureStorage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32) :=
    z_TextureStorage1D_ovr_0(texture, levels, _internalformat, width);
    
    // added in gl4.5
    private z_TextureStorage2D_adr := GetFuncAdr('glTextureStorage2D');
    private z_TextureStorage2D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32)>(z_TextureStorage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2D_ovr_0(texture, levels, _internalformat, width, height);
    
    // added in gl4.5
    private z_TextureStorage2DMultisample_adr := GetFuncAdr('glTextureStorage2DMultisample');
    private z_TextureStorage2DMultisample_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean)>(z_TextureStorage2DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisample(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisample_ovr_0(texture, samples, _internalformat, width, height, fixedsamplelocations);
    
    // added in gl4.5
    private z_TextureStorage3D_adr := GetFuncAdr('glTextureStorage3D');
    private z_TextureStorage3D_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32)>(z_TextureStorage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3D_ovr_0(texture, levels, _internalformat, width, height, depth);
    
    // added in gl4.5
    private z_TextureStorage3DMultisample_adr := GetFuncAdr('glTextureStorage3DMultisample');
    private z_TextureStorage3DMultisample_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean)>(z_TextureStorage3DMultisample_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisample(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisample_ovr_0(texture, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    // added in gl4.5
    private z_TextureSubImage1D_adr := GetFuncAdr('glTextureSubImage1D');
    private z_TextureSubImage1D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage1D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1D(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1D_ovr_0(texture, level, xoffset, width, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureSubImage2D_adr := GetFuncAdr('glTextureSubImage2D');
    private z_TextureSubImage2D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage2D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    // added in gl4.5
    private z_TextureSubImage3D_adr := GetFuncAdr('glTextureSubImage3D');
    private z_TextureSubImage3D_ovr_0 := GetFuncOrNil&<procedure(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr)>(z_TextureSubImage3D_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    // added in gl4.3
    private z_TextureView_adr := GetFuncAdr('glTextureView');
    private z_TextureView_ovr_0 := GetFuncOrNil&<procedure(texture: TextureName; target: TextureTarget; origtexture: TextureName; _internalformat: InternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32)>(z_TextureView_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureView(texture: TextureName; target: TextureTarget; origtexture: TextureName; _internalformat: InternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32) :=
    z_TextureView_ovr_0(texture, target, origtexture, _internalformat, minlevel, numlevels, minlayer, numlayers);
    
    // added in gl4.5
    private z_TransformFeedbackBufferBase_adr := GetFuncAdr('glTransformFeedbackBufferBase');
    private z_TransformFeedbackBufferBase_ovr_0 := GetFuncOrNil&<procedure(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName)>(z_TransformFeedbackBufferBase_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferBase(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName) :=
    z_TransformFeedbackBufferBase_ovr_0(xfb, index, buffer);
    
    // added in gl4.5
    private z_TransformFeedbackBufferRange_adr := GetFuncAdr('glTransformFeedbackBufferRange');
    private z_TransformFeedbackBufferRange_ovr_0 := GetFuncOrNil&<procedure(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr)>(z_TransformFeedbackBufferRange_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferRange(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TransformFeedbackBufferRange_ovr_0(xfb, index, buffer, offset, size);
    
    // added in gl3.0
    private z_TransformFeedbackVaryings_adr := GetFuncAdr('glTransformFeedbackVaryings');
    private z_TransformFeedbackVaryings_ovr_0 := GetFuncOrNil&<procedure(&program: UInt32; count: Int32; var varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    private z_TransformFeedbackVaryings_ovr_0_anh00010 := GetFuncOrNil&<procedure(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: UInt32; count: Int32; varyings: array of string; bufferMode: TransformFeedbackBufferMode);
    begin
      var par_3_str_ptr := varyings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_TransformFeedbackVaryings_ovr_0(&program, count, par_3_str_ptr[0], bufferMode) else
        z_TransformFeedbackVaryings_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private z_TransformFeedbackVaryings_ovr_1_anh00010 := GetFuncOrNil&<procedure(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: UInt32; count: Int32; varyings: array of IntPtr; bufferMode: TransformFeedbackBufferMode) :=
    if (varyings<>nil) and (varyings.Length<>0) then
      z_TransformFeedbackVaryings_ovr_0(&program, count, varyings[0], bufferMode) else
      z_TransformFeedbackVaryings_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    private z_TransformFeedbackVaryings_ovr_2 := GetFuncOrNil&<procedure(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode)>(z_TransformFeedbackVaryings_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryings(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: TransformFeedbackBufferMode) :=
    z_TransformFeedbackVaryings_ovr_2(&program, count, varyings, bufferMode);
    
    // added in gl4.0
    private z_Uniform1d_adr := GetFuncAdr('glUniform1d');
    private z_Uniform1d_ovr_0 := GetFuncOrNil&<procedure(location: Int32; x: real)>(z_Uniform1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1d(location: Int32; x: real) :=
    z_Uniform1d_ovr_0(location, x);
    
    // added in gl4.0
    private z_Uniform1dv_adr := GetFuncAdr('glUniform1dv');
    private z_Uniform1dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform1dv_adr);
    private z_Uniform1dv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1dv_ovr_0(location, count, value[0]) else
      z_Uniform1dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform1dv_ovr_0(location, count, value);
    private z_Uniform1dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1dv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform1f_adr := GetFuncAdr('glUniform1f');
    private z_Uniform1f_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: single)>(z_Uniform1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1f(location: Int32; v0: single) :=
    z_Uniform1f_ovr_0(location, v0);
    
    // added in gl2.0
    private z_Uniform1fv_adr := GetFuncAdr('glUniform1fv');
    private z_Uniform1fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform1fv_adr);
    private z_Uniform1fv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1fv_ovr_0(location, count, value[0]) else
      z_Uniform1fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform1fv_ovr_0(location, count, value);
    private z_Uniform1fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1fv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform1i_adr := GetFuncAdr('glUniform1i');
    private z_Uniform1i_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: Int32)>(z_Uniform1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i(location: Int32; v0: Int32) :=
    z_Uniform1i_ovr_0(location, v0);
    
    // added in gl2.0
    private z_Uniform1iv_adr := GetFuncAdr('glUniform1iv');
    private z_Uniform1iv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform1iv_adr);
    private z_Uniform1iv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1iv_ovr_0(location, count, value[0]) else
      z_Uniform1iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform1iv_ovr_0(location, count, value);
    private z_Uniform1iv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1iv_ovr_2(location, count, value);
    
    // added in gl3.0
    private z_Uniform1ui_adr := GetFuncAdr('glUniform1ui');
    private z_Uniform1ui_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: UInt32)>(z_Uniform1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui(location: Int32; v0: UInt32) :=
    z_Uniform1ui_ovr_0(location, v0);
    
    // added in gl3.0
    private z_Uniform1uiv_adr := GetFuncAdr('glUniform1uiv');
    private z_Uniform1uiv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform1uiv_adr);
    private z_Uniform1uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1uiv_ovr_0(location, count, value[0]) else
      z_Uniform1uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform1uiv_ovr_0(location, count, value);
    private z_Uniform1uiv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1uiv_ovr_2(location, count, value);
    
    // added in gl4.0
    private z_Uniform2d_adr := GetFuncAdr('glUniform2d');
    private z_Uniform2d_ovr_0 := GetFuncOrNil&<procedure(location: Int32; x: real; y: real)>(z_Uniform2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2d(location: Int32; x: real; y: real) :=
    z_Uniform2d_ovr_0(location, x, y);
    
    // added in gl4.0
    private z_Uniform2dv_adr := GetFuncAdr('glUniform2dv');
    private z_Uniform2dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform2dv_adr);
    private z_Uniform2dv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2dv_ovr_0(location, count, value[0]) else
      z_Uniform2dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform2dv_ovr_0(location, count, value);
    private z_Uniform2dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2dv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform2f_adr := GetFuncAdr('glUniform2f');
    private z_Uniform2f_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: single; v1: single)>(z_Uniform2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2f(location: Int32; v0: single; v1: single) :=
    z_Uniform2f_ovr_0(location, v0, v1);
    
    // added in gl2.0
    private z_Uniform2fv_adr := GetFuncAdr('glUniform2fv');
    private z_Uniform2fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform2fv_adr);
    private z_Uniform2fv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2fv_ovr_0(location, count, value[0]) else
      z_Uniform2fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform2fv_ovr_0(location, count, value);
    private z_Uniform2fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2fv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform2i_adr := GetFuncAdr('glUniform2i');
    private z_Uniform2i_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: Int32; v1: Int32)>(z_Uniform2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i(location: Int32; v0: Int32; v1: Int32) :=
    z_Uniform2i_ovr_0(location, v0, v1);
    
    // added in gl2.0
    private z_Uniform2iv_adr := GetFuncAdr('glUniform2iv');
    private z_Uniform2iv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform2iv_adr);
    private z_Uniform2iv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2iv_ovr_0(location, count, value[0]) else
      z_Uniform2iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform2iv_ovr_0(location, count, value);
    private z_Uniform2iv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2iv_ovr_2(location, count, value);
    
    // added in gl3.0
    private z_Uniform2ui_adr := GetFuncAdr('glUniform2ui');
    private z_Uniform2ui_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32)>(z_Uniform2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui(location: Int32; v0: UInt32; v1: UInt32) :=
    z_Uniform2ui_ovr_0(location, v0, v1);
    
    // added in gl3.0
    private z_Uniform2uiv_adr := GetFuncAdr('glUniform2uiv');
    private z_Uniform2uiv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform2uiv_adr);
    private z_Uniform2uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2uiv_ovr_0(location, count, value[0]) else
      z_Uniform2uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform2uiv_ovr_0(location, count, value);
    private z_Uniform2uiv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2uiv_ovr_2(location, count, value);
    
    // added in gl4.0
    private z_Uniform3d_adr := GetFuncAdr('glUniform3d');
    private z_Uniform3d_ovr_0 := GetFuncOrNil&<procedure(location: Int32; x: real; y: real; z: real)>(z_Uniform3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3d(location: Int32; x: real; y: real; z: real) :=
    z_Uniform3d_ovr_0(location, x, y, z);
    
    // added in gl4.0
    private z_Uniform3dv_adr := GetFuncAdr('glUniform3dv');
    private z_Uniform3dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform3dv_adr);
    private z_Uniform3dv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3dv_ovr_0(location, count, value[0]) else
      z_Uniform3dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform3dv_ovr_0(location, count, value);
    private z_Uniform3dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3dv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform3f_adr := GetFuncAdr('glUniform3f');
    private z_Uniform3f_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single)>(z_Uniform3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3f(location: Int32; v0: single; v1: single; v2: single) :=
    z_Uniform3f_ovr_0(location, v0, v1, v2);
    
    // added in gl2.0
    private z_Uniform3fv_adr := GetFuncAdr('glUniform3fv');
    private z_Uniform3fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform3fv_adr);
    private z_Uniform3fv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3fv_ovr_0(location, count, value[0]) else
      z_Uniform3fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform3fv_ovr_0(location, count, value);
    private z_Uniform3fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3fv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform3i_adr := GetFuncAdr('glUniform3i');
    private z_Uniform3i_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32)>(z_Uniform3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i(location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_Uniform3i_ovr_0(location, v0, v1, v2);
    
    // added in gl2.0
    private z_Uniform3iv_adr := GetFuncAdr('glUniform3iv');
    private z_Uniform3iv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform3iv_adr);
    private z_Uniform3iv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3iv_ovr_0(location, count, value[0]) else
      z_Uniform3iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform3iv_ovr_0(location, count, value);
    private z_Uniform3iv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3iv_ovr_2(location, count, value);
    
    // added in gl3.0
    private z_Uniform3ui_adr := GetFuncAdr('glUniform3ui');
    private z_Uniform3ui_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32)>(z_Uniform3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_Uniform3ui_ovr_0(location, v0, v1, v2);
    
    // added in gl3.0
    private z_Uniform3uiv_adr := GetFuncAdr('glUniform3uiv');
    private z_Uniform3uiv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform3uiv_adr);
    private z_Uniform3uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3uiv_ovr_0(location, count, value[0]) else
      z_Uniform3uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform3uiv_ovr_0(location, count, value);
    private z_Uniform3uiv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3uiv_ovr_2(location, count, value);
    
    // added in gl4.0
    private z_Uniform4d_adr := GetFuncAdr('glUniform4d');
    private z_Uniform4d_ovr_0 := GetFuncOrNil&<procedure(location: Int32; x: real; y: real; z: real; w: real)>(z_Uniform4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4d(location: Int32; x: real; y: real; z: real; w: real) :=
    z_Uniform4d_ovr_0(location, x, y, z, w);
    
    // added in gl4.0
    private z_Uniform4dv_adr := GetFuncAdr('glUniform4dv');
    private z_Uniform4dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: real)>(z_Uniform4dv_adr);
    private z_Uniform4dv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4dv_ovr_0(location, count, value[0]) else
      z_Uniform4dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform4dv_ovr_0(location, count, value);
    private z_Uniform4dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4dv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform4f_adr := GetFuncAdr('glUniform4f');
    private z_Uniform4f_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: single; v1: single; v2: single; v3: single)>(z_Uniform4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4f(location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_Uniform4f_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl2.0
    private z_Uniform4fv_adr := GetFuncAdr('glUniform4fv');
    private z_Uniform4fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: single)>(z_Uniform4fv_adr);
    private z_Uniform4fv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4fv_ovr_0(location, count, value[0]) else
      z_Uniform4fv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; var value: single) :=
    z_Uniform4fv_ovr_0(location, count, value);
    private z_Uniform4fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4fv_ovr_2(location, count, value);
    
    // added in gl2.0
    private z_Uniform4i_adr := GetFuncAdr('glUniform4i');
    private z_Uniform4i_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32)>(z_Uniform4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_Uniform4i_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl2.0
    private z_Uniform4iv_adr := GetFuncAdr('glUniform4iv');
    private z_Uniform4iv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: Int32)>(z_Uniform4iv_adr);
    private z_Uniform4iv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4iv_ovr_0(location, count, value[0]) else
      z_Uniform4iv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform4iv_ovr_0(location, count, value);
    private z_Uniform4iv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4iv_ovr_2(location, count, value);
    
    // added in gl3.0
    private z_Uniform4ui_adr := GetFuncAdr('glUniform4ui');
    private z_Uniform4ui_ovr_0 := GetFuncOrNil&<procedure(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32)>(z_Uniform4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_Uniform4ui_ovr_0(location, v0, v1, v2, v3);
    
    // added in gl3.0
    private z_Uniform4uiv_adr := GetFuncAdr('glUniform4uiv');
    private z_Uniform4uiv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; var value: UInt32)>(z_Uniform4uiv_adr);
    private z_Uniform4uiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4uiv_ovr_0(location, count, value[0]) else
      z_Uniform4uiv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform4uiv_ovr_0(location, count, value);
    private z_Uniform4uiv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; value: IntPtr)>(z_Uniform4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4uiv_ovr_2(location, count, value);
    
    // added in gl3.1
    private z_UniformBlockBinding_adr := GetFuncAdr('glUniformBlockBinding');
    private z_UniformBlockBinding_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32)>(z_UniformBlockBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBlockBinding(&program: ProgramName; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32) :=
    z_UniformBlockBinding_ovr_0(&program, uniformBlockIndex, uniformBlockBinding);
    
    // added in gl4.0
    private z_UniformMatrix2dv_adr := GetFuncAdr('glUniformMatrix2dv');
    private z_UniformMatrix2dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2dv_adr);
    private z_UniformMatrix2dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix2fv_adr := GetFuncAdr('glUniformMatrix2fv');
    private z_UniformMatrix2fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2fv_adr);
    private z_UniformMatrix2fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix2x3dv_adr := GetFuncAdr('glUniformMatrix2x3dv');
    private z_UniformMatrix2x3dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x3dv_adr);
    private z_UniformMatrix2x3dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x3dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix2x3fv_adr := GetFuncAdr('glUniformMatrix2x3fv');
    private z_UniformMatrix2x3fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2x3fv_adr);
    private z_UniformMatrix2x3fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2x3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x3fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix2x4dv_adr := GetFuncAdr('glUniformMatrix2x4dv');
    private z_UniformMatrix2x4dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix2x4dv_adr);
    private z_UniformMatrix2x4dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x4dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix2x4fv_adr := GetFuncAdr('glUniformMatrix2x4fv');
    private z_UniformMatrix2x4fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix2x4fv_adr);
    private z_UniformMatrix2x4fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2x4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix2x4fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix2x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3dv_adr := GetFuncAdr('glUniformMatrix3dv');
    private z_UniformMatrix3dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3dv_adr);
    private z_UniformMatrix3dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix3fv_adr := GetFuncAdr('glUniformMatrix3fv');
    private z_UniformMatrix3fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3fv_adr);
    private z_UniformMatrix3fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3x2dv_adr := GetFuncAdr('glUniformMatrix3x2dv');
    private z_UniformMatrix3x2dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x2dv_adr);
    private z_UniformMatrix3x2dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x2dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix3x2fv_adr := GetFuncAdr('glUniformMatrix3x2fv');
    private z_UniformMatrix3x2fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3x2fv_adr);
    private z_UniformMatrix3x2fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3x2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x2fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix3x4dv_adr := GetFuncAdr('glUniformMatrix3x4dv');
    private z_UniformMatrix3x4dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix3x4dv_adr);
    private z_UniformMatrix3x4dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x4dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix3x4fv_adr := GetFuncAdr('glUniformMatrix3x4fv');
    private z_UniformMatrix3x4fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix3x4fv_adr);
    private z_UniformMatrix3x4fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3x4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix3x4fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix3x4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4dv_adr := GetFuncAdr('glUniformMatrix4dv');
    private z_UniformMatrix4dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4dv_adr);
    private z_UniformMatrix4dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.0
    private z_UniformMatrix4fv_adr := GetFuncAdr('glUniformMatrix4fv');
    private z_UniformMatrix4fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4fv_adr);
    private z_UniformMatrix4fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4x2dv_adr := GetFuncAdr('glUniformMatrix4x2dv');
    private z_UniformMatrix4x2dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x2dv_adr);
    private z_UniformMatrix4x2dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x2dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix4x2fv_adr := GetFuncAdr('glUniformMatrix4x2fv');
    private z_UniformMatrix4x2fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4x2fv_adr);
    private z_UniformMatrix4x2fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4x2fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x2fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformMatrix4x3dv_adr := GetFuncAdr('glUniformMatrix4x3dv');
    private z_UniformMatrix4x3dv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: real)>(z_UniformMatrix4x3dv_adr);
    private z_UniformMatrix4x3dv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x3dv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3dv_ovr_2(location, count, transpose, value);
    
    // added in gl2.1
    private z_UniformMatrix4x3fv_adr := GetFuncAdr('glUniformMatrix4x3fv');
    private z_UniformMatrix4x3fv_ovr_0 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; var value: single)>(z_UniformMatrix4x3fv_adr);
    private z_UniformMatrix4x3fv_ovr_0_anh00001 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3fv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3fv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4x3fv_ovr_0(location, count, transpose, value);
    private z_UniformMatrix4x3fv_ovr_2 := GetFuncOrNil&<procedure(location: Int32; count: Int32; transpose: boolean; value: IntPtr)>(z_UniformMatrix4x3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3fv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3fv_ovr_2(location, count, transpose, value);
    
    // added in gl4.0
    private z_UniformSubroutinesuiv_adr := GetFuncAdr('glUniformSubroutinesuiv');
    private z_UniformSubroutinesuiv_ovr_0 := GetFuncOrNil&<procedure(_shadertype: ShaderType; count: Int32; var indices: UInt32)>(z_UniformSubroutinesuiv_adr);
    private z_UniformSubroutinesuiv_ovr_0_anh0001 := GetFuncOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices[0]) else
      z_UniformSubroutinesuiv_ovr_0_anh0001(_shadertype, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; var indices: UInt32) :=
    z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices);
    private z_UniformSubroutinesuiv_ovr_2 := GetFuncOrNil&<procedure(_shadertype: ShaderType; count: Int32; indices: IntPtr)>(z_UniformSubroutinesuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: IntPtr) :=
    z_UniformSubroutinesuiv_ovr_2(_shadertype, count, indices);
    
    // added in gl1.5
    private z_UnmapBuffer_adr := GetFuncAdr('glUnmapBuffer');
    private z_UnmapBuffer_ovr_0 := GetFuncOrNil&<function(target: BufferTargetARB): boolean>(z_UnmapBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapBuffer(target: BufferTargetARB): boolean :=
    z_UnmapBuffer_ovr_0(target);
    
    // added in gl4.5
    private z_UnmapNamedBuffer_adr := GetFuncAdr('glUnmapNamedBuffer');
    private z_UnmapNamedBuffer_ovr_0 := GetFuncOrNil&<function(buffer: BufferName): boolean>(z_UnmapNamedBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBuffer(buffer: BufferName): boolean :=
    z_UnmapNamedBuffer_ovr_0(buffer);
    
    // added in gl2.0
    private z_UseProgram_adr := GetFuncAdr('glUseProgram');
    private z_UseProgram_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName)>(z_UseProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgram(&program: ProgramName) :=
    z_UseProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_UseProgramStages_adr := GetFuncAdr('glUseProgramStages');
    private z_UseProgramStages_ovr_0 := GetFuncOrNil&<procedure(pipeline: ProgramPipelineName; stages: UseProgramStageMask; &program: ProgramName)>(z_UseProgramStages_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramStages(pipeline: ProgramPipelineName; stages: UseProgramStageMask; &program: ProgramName) :=
    z_UseProgramStages_ovr_0(pipeline, stages, &program);
    
    // added in gl2.0
    private z_ValidateProgram_adr := GetFuncAdr('glValidateProgram');
    private z_ValidateProgram_ovr_0 := GetFuncOrNil&<procedure(&program: ProgramName)>(z_ValidateProgram_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgram(&program: ProgramName) :=
    z_ValidateProgram_ovr_0(&program);
    
    // added in gl4.1
    private z_ValidateProgramPipeline_adr := GetFuncAdr('glValidateProgramPipeline');
    private z_ValidateProgramPipeline_ovr_0 := GetFuncOrNil&<procedure(pipeline: ProgramPipelineName)>(z_ValidateProgramPipeline_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramPipeline(pipeline: ProgramPipelineName) :=
    z_ValidateProgramPipeline_ovr_0(pipeline);
    
    // added in gl4.5
    private z_VertexArrayAttribBinding_adr := GetFuncAdr('glVertexArrayAttribBinding');
    private z_VertexArrayAttribBinding_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; attribindex: UInt32; bindingindex: UInt32)>(z_VertexArrayAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribBinding(vaobj: VertexArrayName; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayAttribBinding_ovr_0(vaobj, attribindex, bindingindex);
    
    // added in gl4.5
    private z_VertexArrayAttribFormat_adr := GetFuncAdr('glVertexArrayAttribFormat');
    private z_VertexArrayAttribFormat_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexArrayAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayAttribFormat_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayAttribIFormat_adr := GetFuncAdr('glVertexArrayAttribIFormat');
    private z_VertexArrayAttribIFormat_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexArrayAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribIFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayAttribIFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayAttribLFormat_adr := GetFuncAdr('glVertexArrayAttribLFormat');
    private z_VertexArrayAttribLFormat_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexArrayAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribLFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayAttribLFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    // added in gl4.5
    private z_VertexArrayBindingDivisor_adr := GetFuncAdr('glVertexArrayBindingDivisor');
    private z_VertexArrayBindingDivisor_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; bindingindex: UInt32; divisor: UInt32)>(z_VertexArrayBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindingDivisor(vaobj: VertexArrayName; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayBindingDivisor_ovr_0(vaobj, bindingindex, divisor);
    
    // added in gl4.5
    private z_VertexArrayElementBuffer_adr := GetFuncAdr('glVertexArrayElementBuffer');
    private z_VertexArrayElementBuffer_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; buffer: BufferName)>(z_VertexArrayElementBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayElementBuffer(vaobj: VertexArrayName; buffer: BufferName) :=
    z_VertexArrayElementBuffer_ovr_0(vaobj, buffer);
    
    // added in gl4.5
    private z_VertexArrayVertexBuffer_adr := GetFuncAdr('glVertexArrayVertexBuffer');
    private z_VertexArrayVertexBuffer_ovr_0 := GetFuncOrNil&<procedure(vaobj: VertexArrayName; bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32)>(z_VertexArrayVertexBuffer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffer(vaobj: VertexArrayName; bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32) :=
    z_VertexArrayVertexBuffer_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    // added in gl4.5
    private z_VertexArrayVertexBuffers_adr := GetFuncAdr('glVertexArrayVertexBuffers');
    private z_VertexArrayVertexBuffers_ovr_0 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000110 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000001 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000101 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000011 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_0_anh0000111 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000111(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_1_anh0000110 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_2 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_2_anh0000110 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_3_anh0000101 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_4_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_5_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_6 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000001 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_6_anh0000101 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_7_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_8 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_8_anh0000100 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_8_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_9_anh0000011 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_10_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_11_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_18 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000001 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_18_anh0000011 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private z_VertexArrayVertexBuffers_ovr_19_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private z_VertexArrayVertexBuffers_ovr_20 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_20_anh0000010 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_20_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_24 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32)>(z_VertexArrayVertexBuffers_adr);
    private z_VertexArrayVertexBuffers_ovr_24_anh0000001 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_24_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides);
    private z_VertexArrayVertexBuffers_ovr_26 := GetFuncOrNil&<procedure(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr)>(z_VertexArrayVertexBuffers_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_26(vaobj, first, count, buffers, offsets, strides);
    
    // added in gl2.0
    private z_VertexAttrib1d_adr := GetFuncAdr('glVertexAttrib1d');
    private z_VertexAttrib1d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttrib1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1d(index: UInt32; x: real) :=
    z_VertexAttrib1d_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1dv_adr := GetFuncAdr('glVertexAttrib1dv');
    private z_VertexAttrib1dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib1dv_adr);
    private z_VertexAttrib1dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1dv_ovr_0(index, v[0]) else
      z_VertexAttrib1dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dv(index: UInt32; var v: real) :=
    z_VertexAttrib1dv_ovr_0(index, v);
    private z_VertexAttrib1dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib1f_adr := GetFuncAdr('glVertexAttrib1f');
    private z_VertexAttrib1f_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: single)>(z_VertexAttrib1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1f(index: UInt32; x: single) :=
    z_VertexAttrib1f_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1fv_adr := GetFuncAdr('glVertexAttrib1fv');
    private z_VertexAttrib1fv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib1fv_adr);
    private z_VertexAttrib1fv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1fv_ovr_0(index, v[0]) else
      z_VertexAttrib1fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fv(index: UInt32; var v: single) :=
    z_VertexAttrib1fv_ovr_0(index, v);
    private z_VertexAttrib1fv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib1s_adr := GetFuncAdr('glVertexAttrib1s');
    private z_VertexAttrib1s_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int16)>(z_VertexAttrib1s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1s(index: UInt32; x: Int16) :=
    z_VertexAttrib1s_ovr_0(index, x);
    
    // added in gl2.0
    private z_VertexAttrib1sv_adr := GetFuncAdr('glVertexAttrib1sv');
    private z_VertexAttrib1sv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib1sv_adr);
    private z_VertexAttrib1sv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1sv_ovr_0(index, v[0]) else
      z_VertexAttrib1sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib1sv_ovr_0(index, v);
    private z_VertexAttrib1sv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2d_adr := GetFuncAdr('glVertexAttrib2d');
    private z_VertexAttrib2d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttrib2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2d(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2d_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2dv_adr := GetFuncAdr('glVertexAttrib2dv');
    private z_VertexAttrib2dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib2dv_adr);
    private z_VertexAttrib2dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dv_ovr_0(index, v[0]) else
      z_VertexAttrib2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; var v: real) :=
    z_VertexAttrib2dv_ovr_0(index, v);
    private z_VertexAttrib2dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2f_adr := GetFuncAdr('glVertexAttrib2f');
    private z_VertexAttrib2f_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: single; y: single)>(z_VertexAttrib2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2f(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2f_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2fv_adr := GetFuncAdr('glVertexAttrib2fv');
    private z_VertexAttrib2fv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib2fv_adr);
    private z_VertexAttrib2fv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fv_ovr_0(index, v[0]) else
      z_VertexAttrib2fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; var v: single) :=
    z_VertexAttrib2fv_ovr_0(index, v);
    private z_VertexAttrib2fv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib2s_adr := GetFuncAdr('glVertexAttrib2s');
    private z_VertexAttrib2s_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int16; y: Int16)>(z_VertexAttrib2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2s(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2s_ovr_0(index, x, y);
    
    // added in gl2.0
    private z_VertexAttrib2sv_adr := GetFuncAdr('glVertexAttrib2sv');
    private z_VertexAttrib2sv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib2sv_adr);
    private z_VertexAttrib2sv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2sv_ovr_0(index, v[0]) else
      z_VertexAttrib2sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib2sv_ovr_0(index, v);
    private z_VertexAttrib2sv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3d_adr := GetFuncAdr('glVertexAttrib3d');
    private z_VertexAttrib3d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttrib3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3d_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3dv_adr := GetFuncAdr('glVertexAttrib3dv');
    private z_VertexAttrib3dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib3dv_adr);
    private z_VertexAttrib3dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dv_ovr_0(index, v[0]) else
      z_VertexAttrib3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; var v: real) :=
    z_VertexAttrib3dv_ovr_0(index, v);
    private z_VertexAttrib3dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3f_adr := GetFuncAdr('glVertexAttrib3f');
    private z_VertexAttrib3f_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: single; y: single; z: single)>(z_VertexAttrib3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3f(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3f_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3fv_adr := GetFuncAdr('glVertexAttrib3fv');
    private z_VertexAttrib3fv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib3fv_adr);
    private z_VertexAttrib3fv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fv_ovr_0(index, v[0]) else
      z_VertexAttrib3fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; var v: single) :=
    z_VertexAttrib3fv_ovr_0(index, v);
    private z_VertexAttrib3fv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib3s_adr := GetFuncAdr('glVertexAttrib3s');
    private z_VertexAttrib3s_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16)>(z_VertexAttrib3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3s(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3s_ovr_0(index, x, y, z);
    
    // added in gl2.0
    private z_VertexAttrib3sv_adr := GetFuncAdr('glVertexAttrib3sv');
    private z_VertexAttrib3sv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib3sv_adr);
    private z_VertexAttrib3sv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3sv_ovr_0(index, v[0]) else
      z_VertexAttrib3sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib3sv_ovr_0(index, v);
    private z_VertexAttrib3sv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4bv_adr := GetFuncAdr('glVertexAttrib4bv');
    private z_VertexAttrib4bv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4bv_adr);
    private z_VertexAttrib4bv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bv_ovr_0(index, v[0]) else
      z_VertexAttrib4bv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bv_ovr_0(index, v);
    private z_VertexAttrib4bv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4d_adr := GetFuncAdr('glVertexAttrib4d');
    private z_VertexAttrib4d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttrib4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4d_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4dv_adr := GetFuncAdr('glVertexAttrib4dv');
    private z_VertexAttrib4dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttrib4dv_adr);
    private z_VertexAttrib4dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dv_ovr_0(index, v[0]) else
      z_VertexAttrib4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; var v: real) :=
    z_VertexAttrib4dv_ovr_0(index, v);
    private z_VertexAttrib4dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4f_adr := GetFuncAdr('glVertexAttrib4f');
    private z_VertexAttrib4f_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: single; y: single; z: single; w: single)>(z_VertexAttrib4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4f(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4f_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4fv_adr := GetFuncAdr('glVertexAttrib4fv');
    private z_VertexAttrib4fv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: single)>(z_VertexAttrib4fv_adr);
    private z_VertexAttrib4fv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fv_ovr_0(index, v[0]) else
      z_VertexAttrib4fv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; var v: single) :=
    z_VertexAttrib4fv_ovr_0(index, v);
    private z_VertexAttrib4fv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4iv_adr := GetFuncAdr('glVertexAttrib4iv');
    private z_VertexAttrib4iv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4iv_adr);
    private z_VertexAttrib4iv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4iv_ovr_0(index, v[0]) else
      z_VertexAttrib4iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; var v: Int32) :=
    z_VertexAttrib4iv_ovr_0(index, v);
    private z_VertexAttrib4iv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4iv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4iv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nbv_adr := GetFuncAdr('glVertexAttrib4Nbv');
    private z_VertexAttrib4Nbv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttrib4Nbv_adr);
    private z_VertexAttrib4Nbv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nbv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nbv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nbv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; var v: SByte) :=
    z_VertexAttrib4Nbv_ovr_0(index, v);
    private z_VertexAttrib4Nbv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nbv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nbv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nbv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Niv_adr := GetFuncAdr('glVertexAttrib4Niv');
    private z_VertexAttrib4Niv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttrib4Niv_adr);
    private z_VertexAttrib4Niv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Niv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Niv_ovr_0(index, v[0]) else
      z_VertexAttrib4Niv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; var v: Int32) :=
    z_VertexAttrib4Niv_ovr_0(index, v);
    private z_VertexAttrib4Niv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Niv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Niv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Niv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nsv_adr := GetFuncAdr('glVertexAttrib4Nsv');
    private z_VertexAttrib4Nsv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4Nsv_adr);
    private z_VertexAttrib4Nsv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nsv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nsv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; var v: Int16) :=
    z_VertexAttrib4Nsv_ovr_0(index, v);
    private z_VertexAttrib4Nsv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nsv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nsv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nsv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nub_adr := GetFuncAdr('glVertexAttrib4Nub');
    private z_VertexAttrib4Nub_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte)>(z_VertexAttrib4Nub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nub(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4Nub_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4Nubv_adr := GetFuncAdr('glVertexAttrib4Nubv');
    private z_VertexAttrib4Nubv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4Nubv_adr);
    private z_VertexAttrib4Nubv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nubv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; var v: Byte) :=
    z_VertexAttrib4Nubv_ovr_0(index, v);
    private z_VertexAttrib4Nubv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nubv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nubv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nuiv_adr := GetFuncAdr('glVertexAttrib4Nuiv');
    private z_VertexAttrib4Nuiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4Nuiv_adr);
    private z_VertexAttrib4Nuiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nuiv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nuiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4Nuiv_ovr_0(index, v);
    private z_VertexAttrib4Nuiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nuiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nuiv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nuiv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4Nusv_adr := GetFuncAdr('glVertexAttrib4Nusv');
    private z_VertexAttrib4Nusv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4Nusv_adr);
    private z_VertexAttrib4Nusv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4Nusv_ovr_0(index, v[0]) else
      z_VertexAttrib4Nusv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4Nusv_ovr_0(index, v);
    private z_VertexAttrib4Nusv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4Nusv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4Nusv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4Nusv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4s_adr := GetFuncAdr('glVertexAttrib4s');
    private z_VertexAttrib4s_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16)>(z_VertexAttrib4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4s(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4s_ovr_0(index, x, y, z, w);
    
    // added in gl2.0
    private z_VertexAttrib4sv_adr := GetFuncAdr('glVertexAttrib4sv');
    private z_VertexAttrib4sv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttrib4sv_adr);
    private z_VertexAttrib4sv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4sv_ovr_0(index, v[0]) else
      z_VertexAttrib4sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; var v: Int16) :=
    z_VertexAttrib4sv_ovr_0(index, v);
    private z_VertexAttrib4sv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4sv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4ubv_adr := GetFuncAdr('glVertexAttrib4ubv');
    private z_VertexAttrib4ubv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttrib4ubv_adr);
    private z_VertexAttrib4ubv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubv_ovr_0(index, v[0]) else
      z_VertexAttrib4ubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubv_ovr_0(index, v);
    private z_VertexAttrib4ubv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4uiv_adr := GetFuncAdr('glVertexAttrib4uiv');
    private z_VertexAttrib4uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttrib4uiv_adr);
    private z_VertexAttrib4uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uiv_ovr_0(index, v[0]) else
      z_VertexAttrib4uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uiv_ovr_0(index, v);
    private z_VertexAttrib4uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uiv_ovr_2(index, v);
    
    // added in gl2.0
    private z_VertexAttrib4usv_adr := GetFuncAdr('glVertexAttrib4usv');
    private z_VertexAttrib4usv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttrib4usv_adr);
    private z_VertexAttrib4usv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usv_ovr_0(index, v[0]) else
      z_VertexAttrib4usv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usv_ovr_0(index, v);
    private z_VertexAttrib4usv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttrib4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usv(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribBinding_adr := GetFuncAdr('glVertexAttribBinding');
    private z_VertexAttribBinding_ovr_0 := GetFuncOrNil&<procedure(attribindex: UInt32; bindingindex: UInt32)>(z_VertexAttribBinding_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribBinding(attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexAttribBinding_ovr_0(attribindex, bindingindex);
    
    // added in gl3.3
    private z_VertexAttribDivisor_adr := GetFuncAdr('glVertexAttribDivisor');
    private z_VertexAttribDivisor_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; divisor: UInt32)>(z_VertexAttribDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribDivisor(index: UInt32; divisor: UInt32) :=
    z_VertexAttribDivisor_ovr_0(index, divisor);
    
    // added in gl4.3
    private z_VertexAttribFormat_adr := GetFuncAdr('glVertexAttribFormat');
    private z_VertexAttribFormat_ovr_0 := GetFuncOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32)>(z_VertexAttribFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormat(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexAttribFormat_ovr_0(attribindex, size, &type, normalized, relativeoffset);
    
    // added in gl3.0
    private z_VertexAttribI1i_adr := GetFuncAdr('glVertexAttribI1i');
    private z_VertexAttribI1i_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int32)>(z_VertexAttribI1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1i(index: UInt32; x: Int32) :=
    z_VertexAttribI1i_ovr_0(index, x);
    
    // added in gl3.0
    private z_VertexAttribI1iv_adr := GetFuncAdr('glVertexAttribI1iv');
    private z_VertexAttribI1iv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI1iv_adr);
    private z_VertexAttribI1iv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI1iv_ovr_0(index, v[0]) else
      z_VertexAttribI1iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI1iv_ovr_0(index, v);
    private z_VertexAttribI1iv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI1ui_adr := GetFuncAdr('glVertexAttribI1ui');
    private z_VertexAttribI1ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: UInt32)>(z_VertexAttribI1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ui(index: UInt32; x: UInt32) :=
    z_VertexAttribI1ui_ovr_0(index, x);
    
    // added in gl3.0
    private z_VertexAttribI1uiv_adr := GetFuncAdr('glVertexAttribI1uiv');
    private z_VertexAttribI1uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI1uiv_adr);
    private z_VertexAttribI1uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI1uiv_ovr_0(index, v[0]) else
      z_VertexAttribI1uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI1uiv_ovr_0(index, v);
    private z_VertexAttribI1uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI2i_adr := GetFuncAdr('glVertexAttribI2i');
    private z_VertexAttribI2i_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int32; y: Int32)>(z_VertexAttribI2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2i(index: UInt32; x: Int32; y: Int32) :=
    z_VertexAttribI2i_ovr_0(index, x, y);
    
    // added in gl3.0
    private z_VertexAttribI2iv_adr := GetFuncAdr('glVertexAttribI2iv');
    private z_VertexAttribI2iv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI2iv_adr);
    private z_VertexAttribI2iv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2iv_ovr_0(index, v[0]) else
      z_VertexAttribI2iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI2iv_ovr_0(index, v);
    private z_VertexAttribI2iv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI2ui_adr := GetFuncAdr('glVertexAttribI2ui');
    private z_VertexAttribI2ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32)>(z_VertexAttribI2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ui(index: UInt32; x: UInt32; y: UInt32) :=
    z_VertexAttribI2ui_ovr_0(index, x, y);
    
    // added in gl3.0
    private z_VertexAttribI2uiv_adr := GetFuncAdr('glVertexAttribI2uiv');
    private z_VertexAttribI2uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI2uiv_adr);
    private z_VertexAttribI2uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2uiv_ovr_0(index, v[0]) else
      z_VertexAttribI2uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI2uiv_ovr_0(index, v);
    private z_VertexAttribI2uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI3i_adr := GetFuncAdr('glVertexAttribI3i');
    private z_VertexAttribI3i_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32)>(z_VertexAttribI3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3i(index: UInt32; x: Int32; y: Int32; z: Int32) :=
    z_VertexAttribI3i_ovr_0(index, x, y, z);
    
    // added in gl3.0
    private z_VertexAttribI3iv_adr := GetFuncAdr('glVertexAttribI3iv');
    private z_VertexAttribI3iv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI3iv_adr);
    private z_VertexAttribI3iv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3iv_ovr_0(index, v[0]) else
      z_VertexAttribI3iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI3iv_ovr_0(index, v);
    private z_VertexAttribI3iv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI3ui_adr := GetFuncAdr('glVertexAttribI3ui');
    private z_VertexAttribI3ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32)>(z_VertexAttribI3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ui(index: UInt32; x: UInt32; y: UInt32; z: UInt32) :=
    z_VertexAttribI3ui_ovr_0(index, x, y, z);
    
    // added in gl3.0
    private z_VertexAttribI3uiv_adr := GetFuncAdr('glVertexAttribI3uiv');
    private z_VertexAttribI3uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI3uiv_adr);
    private z_VertexAttribI3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3uiv_ovr_0(index, v[0]) else
      z_VertexAttribI3uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI3uiv_ovr_0(index, v);
    private z_VertexAttribI3uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4bv_adr := GetFuncAdr('glVertexAttribI4bv');
    private z_VertexAttribI4bv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: SByte)>(z_VertexAttribI4bv_adr);
    private z_VertexAttribI4bv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4bv_ovr_0(index, v[0]) else
      z_VertexAttribI4bv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; var v: SByte) :=
    z_VertexAttribI4bv_ovr_0(index, v);
    private z_VertexAttribI4bv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4bv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4i_adr := GetFuncAdr('glVertexAttribI4i');
    private z_VertexAttribI4i_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32)>(z_VertexAttribI4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4i(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexAttribI4i_ovr_0(index, x, y, z, w);
    
    // added in gl3.0
    private z_VertexAttribI4iv_adr := GetFuncAdr('glVertexAttribI4iv');
    private z_VertexAttribI4iv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int32)>(z_VertexAttribI4iv_adr);
    private z_VertexAttribI4iv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4iv_ovr_0(index, v[0]) else
      z_VertexAttribI4iv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; var v: Int32) :=
    z_VertexAttribI4iv_ovr_0(index, v);
    private z_VertexAttribI4iv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4iv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4sv_adr := GetFuncAdr('glVertexAttribI4sv');
    private z_VertexAttribI4sv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Int16)>(z_VertexAttribI4sv_adr);
    private z_VertexAttribI4sv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4sv_ovr_0(index, v[0]) else
      z_VertexAttribI4sv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; var v: Int16) :=
    z_VertexAttribI4sv_ovr_0(index, v);
    private z_VertexAttribI4sv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4sv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4sv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4ubv_adr := GetFuncAdr('glVertexAttribI4ubv');
    private z_VertexAttribI4ubv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: Byte)>(z_VertexAttribI4ubv_adr);
    private z_VertexAttribI4ubv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ubv_ovr_0(index, v[0]) else
      z_VertexAttribI4ubv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; var v: Byte) :=
    z_VertexAttribI4ubv_ovr_0(index, v);
    private z_VertexAttribI4ubv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ubv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4ui_adr := GetFuncAdr('glVertexAttribI4ui');
    private z_VertexAttribI4ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32)>(z_VertexAttribI4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ui(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_VertexAttribI4ui_ovr_0(index, x, y, z, w);
    
    // added in gl3.0
    private z_VertexAttribI4uiv_adr := GetFuncAdr('glVertexAttribI4uiv');
    private z_VertexAttribI4uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt32)>(z_VertexAttribI4uiv_adr);
    private z_VertexAttribI4uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4uiv_ovr_0(index, v[0]) else
      z_VertexAttribI4uiv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; var v: UInt32) :=
    z_VertexAttribI4uiv_ovr_0(index, v);
    private z_VertexAttribI4uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4uiv_ovr_2(index, v);
    
    // added in gl3.0
    private z_VertexAttribI4usv_adr := GetFuncAdr('glVertexAttribI4usv');
    private z_VertexAttribI4usv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: UInt16)>(z_VertexAttribI4usv_adr);
    private z_VertexAttribI4usv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4usv_ovr_0(index, v[0]) else
      z_VertexAttribI4usv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; var v: UInt16) :=
    z_VertexAttribI4usv_ovr_0(index, v);
    private z_VertexAttribI4usv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribI4usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usv(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4usv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribIFormat_adr := GetFuncAdr('glVertexAttribIFormat');
    private z_VertexAttribIFormat_ovr_0 := GetFuncOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32)>(z_VertexAttribIFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormat(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexAttribIFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    // added in gl3.0
    private z_VertexAttribIPointer_adr := GetFuncAdr('glVertexAttribIPointer');
    private z_VertexAttribIPointer_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr)>(z_VertexAttribIPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIPointer(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribIPointer_ovr_0(index, size, &type, stride, pointer);
    
    // added in gl4.1
    private z_VertexAttribL1d_adr := GetFuncAdr('glVertexAttribL1d');
    private z_VertexAttribL1d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real)>(z_VertexAttribL1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1d(index: UInt32; x: real) :=
    z_VertexAttribL1d_ovr_0(index, x);
    
    // added in gl4.1
    private z_VertexAttribL1dv_adr := GetFuncAdr('glVertexAttribL1dv');
    private z_VertexAttribL1dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL1dv_adr);
    private z_VertexAttribL1dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1dv_ovr_0(index, v[0]) else
      z_VertexAttribL1dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; var v: real) :=
    z_VertexAttribL1dv_ovr_0(index, v);
    private z_VertexAttribL1dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dv_ovr_2(index, v);
    
    // added in gl4.1
    private z_VertexAttribL2d_adr := GetFuncAdr('glVertexAttribL2d');
    private z_VertexAttribL2d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real)>(z_VertexAttribL2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2d(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2d_ovr_0(index, x, y);
    
    // added in gl4.1
    private z_VertexAttribL2dv_adr := GetFuncAdr('glVertexAttribL2dv');
    private z_VertexAttribL2dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL2dv_adr);
    private z_VertexAttribL2dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dv_ovr_0(index, v[0]) else
      z_VertexAttribL2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; var v: real) :=
    z_VertexAttribL2dv_ovr_0(index, v);
    private z_VertexAttribL2dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dv_ovr_2(index, v);
    
    // added in gl4.1
    private z_VertexAttribL3d_adr := GetFuncAdr('glVertexAttribL3d');
    private z_VertexAttribL3d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real; z: real)>(z_VertexAttribL3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3d_ovr_0(index, x, y, z);
    
    // added in gl4.1
    private z_VertexAttribL3dv_adr := GetFuncAdr('glVertexAttribL3dv');
    private z_VertexAttribL3dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL3dv_adr);
    private z_VertexAttribL3dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dv_ovr_0(index, v[0]) else
      z_VertexAttribL3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; var v: real) :=
    z_VertexAttribL3dv_ovr_0(index, v);
    private z_VertexAttribL3dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dv_ovr_2(index, v);
    
    // added in gl4.1
    private z_VertexAttribL4d_adr := GetFuncAdr('glVertexAttribL4d');
    private z_VertexAttribL4d_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: real; y: real; z: real; w: real)>(z_VertexAttribL4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4d_ovr_0(index, x, y, z, w);
    
    // added in gl4.1
    private z_VertexAttribL4dv_adr := GetFuncAdr('glVertexAttribL4dv');
    private z_VertexAttribL4dv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: real)>(z_VertexAttribL4dv_adr);
    private z_VertexAttribL4dv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dv_ovr_0(index, v[0]) else
      z_VertexAttribL4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; var v: real) :=
    z_VertexAttribL4dv_ovr_0(index, v);
    private z_VertexAttribL4dv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_VertexAttribL4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dv_ovr_2(index, v);
    
    // added in gl4.3
    private z_VertexAttribLFormat_adr := GetFuncAdr('glVertexAttribLFormat');
    private z_VertexAttribLFormat_ovr_0 := GetFuncOrNil&<procedure(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32)>(z_VertexAttribLFormat_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormat(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexAttribLFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    // added in gl4.1
    private z_VertexAttribLPointer_adr := GetFuncAdr('glVertexAttribLPointer');
    private z_VertexAttribLPointer_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr)>(z_VertexAttribLPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointer(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointer_ovr_0(index, size, &type, stride, pointer);
    
    // added in gl3.3
    private z_VertexAttribP1ui_adr := GetFuncAdr('glVertexAttribP1ui');
    private z_VertexAttribP1ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP1ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP1ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP1uiv_adr := GetFuncAdr('glVertexAttribP1uiv');
    private z_VertexAttribP1uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP1uiv_adr);
    private z_VertexAttribP1uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP1uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP1uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP1uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP1uiv_ovr_2(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP2ui_adr := GetFuncAdr('glVertexAttribP2ui');
    private z_VertexAttribP2ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP2ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP2uiv_adr := GetFuncAdr('glVertexAttribP2uiv');
    private z_VertexAttribP2uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP2uiv_adr);
    private z_VertexAttribP2uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP2uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP2uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP2uiv_ovr_2(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP3ui_adr := GetFuncAdr('glVertexAttribP3ui');
    private z_VertexAttribP3ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP3ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP3uiv_adr := GetFuncAdr('glVertexAttribP3uiv');
    private z_VertexAttribP3uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP3uiv_adr);
    private z_VertexAttribP3uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP3uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP3uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP3uiv_ovr_2(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP4ui_adr := GetFuncAdr('glVertexAttribP4ui');
    private z_VertexAttribP4ui_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32)>(z_VertexAttribP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP4ui_ovr_0(index, &type, normalized, value);
    
    // added in gl3.3
    private z_VertexAttribP4uiv_adr := GetFuncAdr('glVertexAttribP4uiv');
    private z_VertexAttribP4uiv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32)>(z_VertexAttribP4uiv_adr);
    private z_VertexAttribP4uiv_ovr_0_anh00001 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP4uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value);
    private z_VertexAttribP4uiv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr)>(z_VertexAttribP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP4uiv_ovr_2(index, &type, normalized, value);
    
    // added in gl2.0
    private z_VertexAttribPointer_adr := GetFuncAdr('glVertexAttribPointer');
    private z_VertexAttribPointer_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr)>(z_VertexAttribPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointer(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointer_ovr_0(index, size, &type, normalized, stride, pointer);
    
    // added in gl4.3
    private z_VertexBindingDivisor_adr := GetFuncAdr('glVertexBindingDivisor');
    private z_VertexBindingDivisor_ovr_0 := GetFuncOrNil&<procedure(bindingindex: UInt32; divisor: UInt32)>(z_VertexBindingDivisor_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBindingDivisor(bindingindex: UInt32; divisor: UInt32) :=
    z_VertexBindingDivisor_ovr_0(bindingindex, divisor);
    
    // added in gl3.3
    private z_VertexP2ui_adr := GetFuncAdr('glVertexP2ui');
    private z_VertexP2ui_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP2ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP2ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP2uiv_adr := GetFuncAdr('glVertexP2uiv');
    private z_VertexP2uiv_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP2uiv_adr);
    private z_VertexP2uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP2uiv_ovr_0(&type, value[0]) else
      z_VertexP2uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP2uiv_ovr_0(&type, value);
    private z_VertexP2uiv_ovr_2 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP2uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP2uiv_ovr_2(&type, value);
    
    // added in gl3.3
    private z_VertexP3ui_adr := GetFuncAdr('glVertexP3ui');
    private z_VertexP3ui_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP3ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP3uiv_adr := GetFuncAdr('glVertexP3uiv');
    private z_VertexP3uiv_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP3uiv_adr);
    private z_VertexP3uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP3uiv_ovr_0(&type, value[0]) else
      z_VertexP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP3uiv_ovr_0(&type, value);
    private z_VertexP3uiv_ovr_2 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP3uiv_ovr_2(&type, value);
    
    // added in gl3.3
    private z_VertexP4ui_adr := GetFuncAdr('glVertexP4ui');
    private z_VertexP4ui_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: UInt32)>(z_VertexP4ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP4ui_ovr_0(&type, value);
    
    // added in gl3.3
    private z_VertexP4uiv_adr := GetFuncAdr('glVertexP4uiv');
    private z_VertexP4uiv_ovr_0 := GetFuncOrNil&<procedure(&type: VertexPointerType; var value: UInt32)>(z_VertexP4uiv_adr);
    private z_VertexP4uiv_ovr_0_anh001 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP4uiv_ovr_0(&type, value[0]) else
      z_VertexP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP4uiv_ovr_0(&type, value);
    private z_VertexP4uiv_ovr_2 := GetFuncOrNil&<procedure(&type: VertexPointerType; value: IntPtr)>(z_VertexP4uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP4uiv_ovr_2(&type, value);
    
    // added in gl1.0
    private static procedure z_Viewport_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glViewport';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Viewport(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_Viewport_ovr_0(x, y, width, height);
    
    // added in gl4.1
    private z_ViewportArrayv_adr := GetFuncAdr('glViewportArrayv');
    private z_ViewportArrayv_ovr_0 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; var v: single)>(z_ViewportArrayv_adr);
    private z_ViewportArrayv_ovr_0_anh0001 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportArrayv_ovr_0(first, count, v[0]) else
      z_ViewportArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; var v: single) :=
    z_ViewportArrayv_ovr_0(first, count, v);
    private z_ViewportArrayv_ovr_2 := GetFuncOrNil&<procedure(first: UInt32; count: Int32; v: IntPtr)>(z_ViewportArrayv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ViewportArrayv_ovr_2(first, count, v);
    
    // added in gl4.1
    private z_ViewportIndexedf_adr := GetFuncAdr('glViewportIndexedf');
    private z_ViewportIndexedf_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; x: single; y: single; w: single; h: single)>(z_ViewportIndexedf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedf(index: UInt32; x: single; y: single; w: single; h: single) :=
    z_ViewportIndexedf_ovr_0(index, x, y, w, h);
    
    // added in gl4.1
    private z_ViewportIndexedfv_adr := GetFuncAdr('glViewportIndexedfv');
    private z_ViewportIndexedfv_ovr_0 := GetFuncOrNil&<procedure(index: UInt32; var v: single)>(z_ViewportIndexedfv_adr);
    private z_ViewportIndexedfv_ovr_0_anh001 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportIndexedfv_ovr_0(index, v[0]) else
      z_ViewportIndexedfv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; var v: single) :=
    z_ViewportIndexedfv_ovr_0(index, v);
    private z_ViewportIndexedfv_ovr_2 := GetFuncOrNil&<procedure(index: UInt32; v: IntPtr)>(z_ViewportIndexedfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: IntPtr) :=
    z_ViewportIndexedfv_ovr_2(index, v);
    
    // added in gl3.2
    private z_WaitSync_adr := GetFuncAdr('glWaitSync');
    private z_WaitSync_ovr_0 := GetFuncOrNil&<procedure(sync: GLsync; flags: DummyFlags; timeout: UInt64)>(z_WaitSync_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSync(sync: GLsync; flags: DummyFlags; timeout: UInt64) :=
    z_WaitSync_ovr_0(sync, flags, timeout);
    
  end;
  
  glD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Accum_ovr_0(op: AccumOp; value: single);
    external 'opengl32.dll' name 'glAccum';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Accum(op: AccumOp; value: single) :=
    z_Accum_ovr_0(op, value);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_AlphaFunc_ovr_0(func: AlphaFunction; ref: single);
    external 'opengl32.dll' name 'glAlphaFunc';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFunc(func: AlphaFunction; ref: single) :=
    z_AlphaFunc_ovr_0(func, ref);
    
    // added in gl1.1, deprecated in gl3.2
    private static function z_AreTexturesResident_ovr_0(n: Int32; var textures: UInt32; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    private static function z_AreTexturesResident_ovr_0_anh0010(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    private static function z_AreTexturesResident_ovr_0_anh0001(n: Int32; var textures: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    private static function z_AreTexturesResident_ovr_0_anh0011(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of UInt32; residences: array of boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResident_ovr_0(n, textures[0], residences[0]) else
        z_AreTexturesResident_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResident_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreTexturesResident_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static function z_AreTexturesResident_ovr_1_anh0010(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of UInt32; var residences: boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResident_ovr_0(n, textures[0], residences) else
      z_AreTexturesResident_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private static function z_AreTexturesResident_ovr_2(n: Int32; var textures: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    private static function z_AreTexturesResident_ovr_2_anh0010(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: array of UInt32; residences: IntPtr): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResident_ovr_2(n, textures[0], residences) else
      z_AreTexturesResident_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: UInt32; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResident_ovr_0(n, textures, residences[0]) else
      z_AreTexturesResident_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: UInt32; var residences: boolean): boolean :=
    z_AreTexturesResident_ovr_0(n, textures, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; var textures: UInt32; residences: IntPtr): boolean :=
    z_AreTexturesResident_ovr_2(n, textures, residences);
    private static function z_AreTexturesResident_ovr_6(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    private static function z_AreTexturesResident_ovr_6_anh0001(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResident_ovr_6(n, textures, residences[0]) else
      z_AreTexturesResident_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; var residences: boolean): boolean :=
    z_AreTexturesResident_ovr_6(n, textures, residences);
    private static function z_AreTexturesResident_ovr_8(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResident';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResident(n: Int32; textures: IntPtr; residences: IntPtr): boolean :=
    z_AreTexturesResident_ovr_8(n, textures, residences);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_ArrayElement_ovr_0(i: Int32);
    external 'opengl32.dll' name 'glArrayElement';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayElement(i: Int32) :=
    z_ArrayElement_ovr_0(i);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Begin_ovr_0(mode: PrimitiveType);
    external 'opengl32.dll' name 'glBegin';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure &Begin(mode: PrimitiveType) :=
    z_Begin_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Bitmap_ovr_0(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; var bitmap: Byte);
    external 'opengl32.dll' name 'glBitmap';
    private static procedure z_Bitmap_ovr_0_anh00000001(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr);
    external 'opengl32.dll' name 'glBitmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: array of Byte) :=
    if (bitmap<>nil) and (bitmap.Length<>0) then
      z_Bitmap_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap[0]) else
      z_Bitmap_ovr_0_anh00000001(width, height, xorig, yorig, xmove, ymove, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; var bitmap: Byte) :=
    z_Bitmap_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap);
    private static procedure z_Bitmap_ovr_2(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr);
    external 'opengl32.dll' name 'glBitmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Bitmap(width: Int32; height: Int32; xorig: single; yorig: single; xmove: single; ymove: single; bitmap: IntPtr) :=
    z_Bitmap_ovr_2(width, height, xorig, yorig, xmove, ymove, bitmap);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_CallList_ovr_0(list: UInt32);
    external 'opengl32.dll' name 'glCallList';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallList(list: UInt32) :=
    z_CallList_ovr_0(list);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_CallLists_ovr_0(n: Int32; &type: ListNameType; lists: IntPtr);
    external 'opengl32.dll' name 'glCallLists';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallLists(n: Int32; &type: ListNameType; lists: IntPtr) :=
    z_CallLists_ovr_0(n, &type, lists);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ClearAccum_ovr_0(red: single; green: single; blue: single; alpha: single);
    external 'opengl32.dll' name 'glClearAccum';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearAccum(red: single; green: single; blue: single; alpha: single) :=
    z_ClearAccum_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ClearIndex_ovr_0(c: single);
    external 'opengl32.dll' name 'glClearIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearIndex(c: single) :=
    z_ClearIndex_ovr_0(c);
    
    // added in gl1.3, deprecated in gl3.2
    private z_ClientActiveTexture_adr := GetFuncAdr('glClientActiveTexture');
    private z_ClientActiveTexture_ovr_0 := GetFuncOrNil&<procedure(texture: TextureUnit)>(z_ClientActiveTexture_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveTexture(texture: TextureUnit) :=
    z_ClientActiveTexture_ovr_0(texture);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ClipPlane_ovr_0(plane: ClipPlaneName; var equation: real);
    external 'opengl32.dll' name 'glClipPlane';
    private static procedure z_ClipPlane_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlane_ovr_0(plane, equation[0]) else
      z_ClipPlane_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; var equation: real) :=
    z_ClipPlane_ovr_0(plane, equation);
    private static procedure z_ClipPlane_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlane(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlane_ovr_2(plane, equation);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3b_ovr_0(red: SByte; green: SByte; blue: SByte);
    external 'opengl32.dll' name 'glColor3b';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3b(red: SByte; green: SByte; blue: SByte) :=
    z_Color3b_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3bv_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glColor3bv';
    private static procedure z_Color3bv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3bv_ovr_0(v[0]) else
      z_Color3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(var v: SByte) :=
    z_Color3bv_ovr_0(v);
    private static procedure z_Color3bv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3bv(v: IntPtr) :=
    z_Color3bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3d_ovr_0(red: real; green: real; blue: real);
    external 'opengl32.dll' name 'glColor3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3d(red: real; green: real; blue: real) :=
    z_Color3d_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glColor3dv';
    private static procedure z_Color3dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3dv_ovr_0(v[0]) else
      z_Color3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(var v: real) :=
    z_Color3dv_ovr_0(v);
    private static procedure z_Color3dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3dv(v: IntPtr) :=
    z_Color3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3f_ovr_0(red: single; green: single; blue: single);
    external 'opengl32.dll' name 'glColor3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3f(red: single; green: single; blue: single) :=
    z_Color3f_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glColor3fv';
    private static procedure z_Color3fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3fv_ovr_0(v[0]) else
      z_Color3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(var v: single) :=
    z_Color3fv_ovr_0(v);
    private static procedure z_Color3fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fv(v: IntPtr) :=
    z_Color3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3i_ovr_0(red: Int32; green: Int32; blue: Int32);
    external 'opengl32.dll' name 'glColor3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3i(red: Int32; green: Int32; blue: Int32) :=
    z_Color3i_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glColor3iv';
    private static procedure z_Color3iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3iv_ovr_0(v[0]) else
      z_Color3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(var v: Int32) :=
    z_Color3iv_ovr_0(v);
    private static procedure z_Color3iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3iv(v: IntPtr) :=
    z_Color3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3s_ovr_0(red: Int16; green: Int16; blue: Int16);
    external 'opengl32.dll' name 'glColor3s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3s(red: Int16; green: Int16; blue: Int16) :=
    z_Color3s_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glColor3sv';
    private static procedure z_Color3sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3sv_ovr_0(v[0]) else
      z_Color3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(var v: Int16) :=
    z_Color3sv_ovr_0(v);
    private static procedure z_Color3sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3sv(v: IntPtr) :=
    z_Color3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3ub_ovr_0(red: Byte; green: Byte; blue: Byte);
    external 'opengl32.dll' name 'glColor3ub';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ub(red: Byte; green: Byte; blue: Byte) :=
    z_Color3ub_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3ubv_ovr_0(var v: Byte);
    external 'opengl32.dll' name 'glColor3ubv';
    private static procedure z_Color3ubv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3ubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3ubv_ovr_0(v[0]) else
      z_Color3ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(var v: Byte) :=
    z_Color3ubv_ovr_0(v);
    private static procedure z_Color3ubv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3ubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ubv(v: IntPtr) :=
    z_Color3ubv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3ui_ovr_0(red: UInt32; green: UInt32; blue: UInt32);
    external 'opengl32.dll' name 'glColor3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3ui(red: UInt32; green: UInt32; blue: UInt32) :=
    z_Color3ui_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3uiv_ovr_0(var v: UInt32);
    external 'opengl32.dll' name 'glColor3uiv';
    private static procedure z_Color3uiv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3uiv_ovr_0(v[0]) else
      z_Color3uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(var v: UInt32) :=
    z_Color3uiv_ovr_0(v);
    private static procedure z_Color3uiv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3uiv(v: IntPtr) :=
    z_Color3uiv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3us_ovr_0(red: UInt16; green: UInt16; blue: UInt16);
    external 'opengl32.dll' name 'glColor3us';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3us(red: UInt16; green: UInt16; blue: UInt16) :=
    z_Color3us_ovr_0(red, green, blue);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color3usv_ovr_0(var v: UInt16);
    external 'opengl32.dll' name 'glColor3usv';
    private static procedure z_Color3usv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3usv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3usv_ovr_0(v[0]) else
      z_Color3usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(var v: UInt16) :=
    z_Color3usv_ovr_0(v);
    private static procedure z_Color3usv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3usv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3usv(v: IntPtr) :=
    z_Color3usv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4b_ovr_0(red: SByte; green: SByte; blue: SByte; alpha: SByte);
    external 'opengl32.dll' name 'glColor4b';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4b(red: SByte; green: SByte; blue: SByte; alpha: SByte) :=
    z_Color4b_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4bv_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glColor4bv';
    private static procedure z_Color4bv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4bv_ovr_0(v[0]) else
      z_Color4bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(var v: SByte) :=
    z_Color4bv_ovr_0(v);
    private static procedure z_Color4bv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4bv(v: IntPtr) :=
    z_Color4bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4d_ovr_0(red: real; green: real; blue: real; alpha: real);
    external 'opengl32.dll' name 'glColor4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4d(red: real; green: real; blue: real; alpha: real) :=
    z_Color4d_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glColor4dv';
    private static procedure z_Color4dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4dv_ovr_0(v[0]) else
      z_Color4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(var v: real) :=
    z_Color4dv_ovr_0(v);
    private static procedure z_Color4dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4dv(v: IntPtr) :=
    z_Color4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4f_ovr_0(red: single; green: single; blue: single; alpha: single);
    external 'opengl32.dll' name 'glColor4f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4f(red: single; green: single; blue: single; alpha: single) :=
    z_Color4f_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glColor4fv';
    private static procedure z_Color4fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4fv_ovr_0(v[0]) else
      z_Color4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(var v: single) :=
    z_Color4fv_ovr_0(v);
    private static procedure z_Color4fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fv(v: IntPtr) :=
    z_Color4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4i_ovr_0(red: Int32; green: Int32; blue: Int32; alpha: Int32);
    external 'opengl32.dll' name 'glColor4i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4i(red: Int32; green: Int32; blue: Int32; alpha: Int32) :=
    z_Color4i_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glColor4iv';
    private static procedure z_Color4iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4iv_ovr_0(v[0]) else
      z_Color4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(var v: Int32) :=
    z_Color4iv_ovr_0(v);
    private static procedure z_Color4iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4iv(v: IntPtr) :=
    z_Color4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4s_ovr_0(red: Int16; green: Int16; blue: Int16; alpha: Int16);
    external 'opengl32.dll' name 'glColor4s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4s(red: Int16; green: Int16; blue: Int16; alpha: Int16) :=
    z_Color4s_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glColor4sv';
    private static procedure z_Color4sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4sv_ovr_0(v[0]) else
      z_Color4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(var v: Int16) :=
    z_Color4sv_ovr_0(v);
    private static procedure z_Color4sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4sv(v: IntPtr) :=
    z_Color4sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4ub_ovr_0(red: Byte; green: Byte; blue: Byte; alpha: Byte);
    external 'opengl32.dll' name 'glColor4ub';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ub(red: Byte; green: Byte; blue: Byte; alpha: Byte) :=
    z_Color4ub_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4ubv_ovr_0(var v: Byte);
    external 'opengl32.dll' name 'glColor4ubv';
    private static procedure z_Color4ubv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4ubv_ovr_0(v[0]) else
      z_Color4ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(var v: Byte) :=
    z_Color4ubv_ovr_0(v);
    private static procedure z_Color4ubv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubv(v: IntPtr) :=
    z_Color4ubv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4ui_ovr_0(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32);
    external 'opengl32.dll' name 'glColor4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ui(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32) :=
    z_Color4ui_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4uiv_ovr_0(var v: UInt32);
    external 'opengl32.dll' name 'glColor4uiv';
    private static procedure z_Color4uiv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4uiv_ovr_0(v[0]) else
      z_Color4uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(var v: UInt32) :=
    z_Color4uiv_ovr_0(v);
    private static procedure z_Color4uiv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4uiv(v: IntPtr) :=
    z_Color4uiv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4us_ovr_0(red: UInt16; green: UInt16; blue: UInt16; alpha: UInt16);
    external 'opengl32.dll' name 'glColor4us';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4us(red: UInt16; green: UInt16; blue: UInt16; alpha: UInt16) :=
    z_Color4us_ovr_0(red, green, blue, alpha);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Color4usv_ovr_0(var v: UInt16);
    external 'opengl32.dll' name 'glColor4usv';
    private static procedure z_Color4usv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4usv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4usv_ovr_0(v[0]) else
      z_Color4usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(var v: UInt16) :=
    z_Color4usv_ovr_0(v);
    private static procedure z_Color4usv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4usv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4usv(v: IntPtr) :=
    z_Color4usv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ColorMaterial_ovr_0(face: DummyEnum; mode: ColorMaterialParameter);
    external 'opengl32.dll' name 'glColorMaterial';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaterial(face: DummyEnum; mode: ColorMaterialParameter) :=
    z_ColorMaterial_ovr_0(face, mode);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_ColorPointer_ovr_0(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glColorPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointer(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_ColorPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_CopyPixels_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32; &type: PixelCopyType);
    external 'opengl32.dll' name 'glCopyPixels';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyPixels(x: Int32; y: Int32; width: Int32; height: Int32; &type: PixelCopyType) :=
    z_CopyPixels_ovr_0(x, y, width, height, &type);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_DeleteLists_ovr_0(list: UInt32; range: Int32);
    external 'opengl32.dll' name 'glDeleteLists';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteLists(list: UInt32; range: Int32) :=
    z_DeleteLists_ovr_0(list, range);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_DisableClientState_ovr_0(&array: EnableCap);
    external 'opengl32.dll' name 'glDisableClientState';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientState(&array: EnableCap) :=
    z_DisableClientState_ovr_0(&array);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_DrawPixels_ovr_0(width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glDrawPixels';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawPixels(width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_DrawPixels_ovr_0(width, height, format, &type, pixels);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EdgeFlag_ovr_0(flag: boolean);
    external 'opengl32.dll' name 'glEdgeFlag';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlag(flag: boolean) :=
    z_EdgeFlag_ovr_0(flag);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_EdgeFlagPointer_ovr_0(stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glEdgeFlagPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointer(stride: Int32; pointer: IntPtr) :=
    z_EdgeFlagPointer_ovr_0(stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EdgeFlagv_ovr_0(var flag: boolean);
    external 'opengl32.dll' name 'glEdgeFlagv';
    private static procedure z_EdgeFlagv_ovr_0_anh01(flag: IntPtr);
    external 'opengl32.dll' name 'glEdgeFlagv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagv(flag: array of boolean) :=
    if (flag<>nil) and (flag.Length<>0) then
      z_EdgeFlagv_ovr_0(flag[0]) else
      z_EdgeFlagv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagv(var flag: boolean) :=
    z_EdgeFlagv_ovr_0(flag);
    private static procedure z_EdgeFlagv_ovr_2(flag: IntPtr);
    external 'opengl32.dll' name 'glEdgeFlagv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagv(flag: IntPtr) :=
    z_EdgeFlagv_ovr_2(flag);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_EnableClientState_ovr_0(&array: EnableCap);
    external 'opengl32.dll' name 'glEnableClientState';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientState(&array: EnableCap) :=
    z_EnableClientState_ovr_0(&array);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_End_ovr_0;
    external 'opengl32.dll' name 'glEnd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure &End :=
    z_End_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EndList_ovr_0;
    external 'opengl32.dll' name 'glEndList';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndList :=
    z_EndList_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord1d_ovr_0(u: real);
    external 'opengl32.dll' name 'glEvalCoord1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1d(u: real) :=
    z_EvalCoord1d_ovr_0(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord1dv_ovr_0(var u: real);
    external 'opengl32.dll' name 'glEvalCoord1dv';
    private static procedure z_EvalCoord1dv_ovr_0_anh01(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1dv(u: array of real) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord1dv_ovr_0(u[0]) else
      z_EvalCoord1dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1dv(var u: real) :=
    z_EvalCoord1dv_ovr_0(u);
    private static procedure z_EvalCoord1dv_ovr_2(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1dv(u: IntPtr) :=
    z_EvalCoord1dv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord1f_ovr_0(u: single);
    external 'opengl32.dll' name 'glEvalCoord1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1f(u: single) :=
    z_EvalCoord1f_ovr_0(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord1fv_ovr_0(var u: single);
    external 'opengl32.dll' name 'glEvalCoord1fv';
    private static procedure z_EvalCoord1fv_ovr_0_anh01(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1fv(u: array of single) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord1fv_ovr_0(u[0]) else
      z_EvalCoord1fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1fv(var u: single) :=
    z_EvalCoord1fv_ovr_0(u);
    private static procedure z_EvalCoord1fv_ovr_2(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1fv(u: IntPtr) :=
    z_EvalCoord1fv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord2d_ovr_0(u: real; v: real);
    external 'opengl32.dll' name 'glEvalCoord2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2d(u: real; v: real) :=
    z_EvalCoord2d_ovr_0(u, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord2dv_ovr_0(var u: real);
    external 'opengl32.dll' name 'glEvalCoord2dv';
    private static procedure z_EvalCoord2dv_ovr_0_anh01(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(u: array of real) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord2dv_ovr_0(u[0]) else
      z_EvalCoord2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(var u: real) :=
    z_EvalCoord2dv_ovr_0(u);
    private static procedure z_EvalCoord2dv_ovr_2(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2dv(u: IntPtr) :=
    z_EvalCoord2dv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord2f_ovr_0(u: single; v: single);
    external 'opengl32.dll' name 'glEvalCoord2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2f(u: single; v: single) :=
    z_EvalCoord2f_ovr_0(u, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalCoord2fv_ovr_0(var u: single);
    external 'opengl32.dll' name 'glEvalCoord2fv';
    private static procedure z_EvalCoord2fv_ovr_0_anh01(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(u: array of single) :=
    if (u<>nil) and (u.Length<>0) then
      z_EvalCoord2fv_ovr_0(u[0]) else
      z_EvalCoord2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(var u: single) :=
    z_EvalCoord2fv_ovr_0(u);
    private static procedure z_EvalCoord2fv_ovr_2(u: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2fv(u: IntPtr) :=
    z_EvalCoord2fv_ovr_2(u);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalMesh1_ovr_0(mode: MeshMode1; i1: Int32; i2: Int32);
    external 'opengl32.dll' name 'glEvalMesh1';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMesh1(mode: MeshMode1; i1: Int32; i2: Int32) :=
    z_EvalMesh1_ovr_0(mode, i1, i2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalMesh2_ovr_0(mode: MeshMode2; i1: Int32; i2: Int32; j1: Int32; j2: Int32);
    external 'opengl32.dll' name 'glEvalMesh2';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMesh2(mode: MeshMode2; i1: Int32; i2: Int32; j1: Int32; j2: Int32) :=
    z_EvalMesh2_ovr_0(mode, i1, i2, j1, j2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalPoint1_ovr_0(i: Int32);
    external 'opengl32.dll' name 'glEvalPoint1';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalPoint1(i: Int32) :=
    z_EvalPoint1_ovr_0(i);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_EvalPoint2_ovr_0(i: Int32; j: Int32);
    external 'opengl32.dll' name 'glEvalPoint2';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalPoint2(i: Int32; j: Int32) :=
    z_EvalPoint2_ovr_0(i, j);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_FeedbackBuffer_ovr_0(size: Int32; &type: FeedbackType; var buffer: single);
    external 'opengl32.dll' name 'glFeedbackBuffer';
    private static procedure z_FeedbackBuffer_ovr_0_anh0001(size: Int32; &type: FeedbackType; buffer: IntPtr);
    external 'opengl32.dll' name 'glFeedbackBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; buffer: array of single) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_FeedbackBuffer_ovr_0(size, &type, buffer[0]) else
      z_FeedbackBuffer_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; var buffer: single) :=
    z_FeedbackBuffer_ovr_0(size, &type, buffer);
    private static procedure z_FeedbackBuffer_ovr_2(size: Int32; &type: FeedbackType; buffer: IntPtr);
    external 'opengl32.dll' name 'glFeedbackBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBuffer(size: Int32; &type: FeedbackType; buffer: IntPtr) :=
    z_FeedbackBuffer_ovr_2(size, &type, buffer);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordd_adr := GetFuncAdr('glFogCoordd');
    private z_FogCoordd_ovr_0 := GetFuncOrNil&<procedure(coord: real)>(z_FogCoordd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordd(coord: real) :=
    z_FogCoordd_ovr_0(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoorddv_adr := GetFuncAdr('glFogCoorddv');
    private z_FogCoorddv_ovr_0 := GetFuncOrNil&<procedure(var coord: real)>(z_FogCoorddv_adr);
    private z_FogCoorddv_ovr_0_anh01 := GetFuncOrNil&<procedure(coord: IntPtr)>(z_FogCoorddv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddv(coord: array of real) :=
    if (coord<>nil) and (coord.Length<>0) then
      z_FogCoorddv_ovr_0(coord[0]) else
      z_FogCoorddv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddv(var coord: real) :=
    z_FogCoorddv_ovr_0(coord);
    private z_FogCoorddv_ovr_2 := GetFuncOrNil&<procedure(coord: IntPtr)>(z_FogCoorddv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddv(coord: IntPtr) :=
    z_FogCoorddv_ovr_2(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordf_adr := GetFuncAdr('glFogCoordf');
    private z_FogCoordf_ovr_0 := GetFuncOrNil&<procedure(coord: single)>(z_FogCoordf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordf(coord: single) :=
    z_FogCoordf_ovr_0(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordfv_adr := GetFuncAdr('glFogCoordfv');
    private z_FogCoordfv_ovr_0 := GetFuncOrNil&<procedure(var coord: single)>(z_FogCoordfv_adr);
    private z_FogCoordfv_ovr_0_anh01 := GetFuncOrNil&<procedure(coord: IntPtr)>(z_FogCoordfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfv(coord: array of single) :=
    if (coord<>nil) and (coord.Length<>0) then
      z_FogCoordfv_ovr_0(coord[0]) else
      z_FogCoordfv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfv(var coord: single) :=
    z_FogCoordfv_ovr_0(coord);
    private z_FogCoordfv_ovr_2 := GetFuncOrNil&<procedure(coord: IntPtr)>(z_FogCoordfv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfv(coord: IntPtr) :=
    z_FogCoordfv_ovr_2(coord);
    
    // added in gl1.4, deprecated in gl3.2
    private z_FogCoordPointer_adr := GetFuncAdr('glFogCoordPointer');
    private z_FogCoordPointer_ovr_0 := GetFuncOrNil&<procedure(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr)>(z_FogCoordPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointer(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_FogCoordPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Fogf_ovr_0(pname: FogParameter; param: single);
    external 'opengl32.dll' name 'glFogf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogf(pname: FogParameter; param: single) :=
    z_Fogf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Fogfv_ovr_0(pname: FogParameter; var &params: single);
    external 'opengl32.dll' name 'glFogfv';
    private static procedure z_Fogfv_ovr_0_anh001(pname: FogParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFogfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Fogfv_ovr_0(pname, &params[0]) else
      z_Fogfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; var &params: single) :=
    z_Fogfv_ovr_0(pname, &params);
    private static procedure z_Fogfv_ovr_2(pname: FogParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFogfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogfv(pname: FogParameter; &params: IntPtr) :=
    z_Fogfv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Fogi_ovr_0(pname: FogParameter; param: Int32);
    external 'opengl32.dll' name 'glFogi';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogi(pname: FogParameter; param: Int32) :=
    z_Fogi_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Fogiv_ovr_0(pname: FogParameter; var &params: Int32);
    external 'opengl32.dll' name 'glFogiv';
    private static procedure z_Fogiv_ovr_0_anh001(pname: FogParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFogiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Fogiv_ovr_0(pname, &params[0]) else
      z_Fogiv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; var &params: Int32) :=
    z_Fogiv_ovr_0(pname, &params);
    private static procedure z_Fogiv_ovr_2(pname: FogParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFogiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Fogiv(pname: FogParameter; &params: IntPtr) :=
    z_Fogiv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Frustum_ovr_0(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glFrustum';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Frustum(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_Frustum_ovr_0(left, right, bottom, top, zNear, zFar);
    
    // added in gl1.0, deprecated in gl3.2
    private static function z_GenLists_ovr_0(range: Int32): UInt32;
    external 'opengl32.dll' name 'glGenLists';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenLists(range: Int32): UInt32 :=
    z_GenLists_ovr_0(range);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetClipPlane_ovr_0(plane: ClipPlaneName; var equation: real);
    external 'opengl32.dll' name 'glGetClipPlane';
    private static procedure z_GetClipPlane_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlane_ovr_0(plane, equation[0]) else
      z_GetClipPlane_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; var equation: real) :=
    z_GetClipPlane_ovr_0(plane, equation);
    private static procedure z_GetClipPlane_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlane(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlane_ovr_2(plane, equation);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetLightfv_ovr_0(light: LightName; pname: LightParameter; var &params: single);
    external 'opengl32.dll' name 'glGetLightfv';
    private static procedure z_GetLightfv_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightfv_ovr_0(light, pname, &params[0]) else
      z_GetLightfv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; var &params: single) :=
    z_GetLightfv_ovr_0(light, pname, &params);
    private static procedure z_GetLightfv_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightfv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightfv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetLightiv_ovr_0(light: LightName; pname: LightParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetLightiv';
    private static procedure z_GetLightiv_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightiv_ovr_0(light, pname, &params[0]) else
      z_GetLightiv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; var &params: Int32) :=
    z_GetLightiv_ovr_0(light, pname, &params);
    private static procedure z_GetLightiv_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightiv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightiv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetMapdv_ovr_0(target: MapTarget; query: GetMapQuery; var v: real);
    external 'opengl32.dll' name 'glGetMapdv';
    private static procedure z_GetMapdv_ovr_0_anh0001(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapdv_ovr_0(target, query, v[0]) else
      z_GetMapdv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; var v: real) :=
    z_GetMapdv_ovr_0(target, query, v);
    private static procedure z_GetMapdv_ovr_2(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapdv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapdv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetMapfv_ovr_0(target: MapTarget; query: GetMapQuery; var v: single);
    external 'opengl32.dll' name 'glGetMapfv';
    private static procedure z_GetMapfv_ovr_0_anh0001(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapfv_ovr_0(target, query, v[0]) else
      z_GetMapfv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; var v: single) :=
    z_GetMapfv_ovr_0(target, query, v);
    private static procedure z_GetMapfv_ovr_2(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapfv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapfv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetMapiv_ovr_0(target: MapTarget; query: GetMapQuery; var v: Int32);
    external 'opengl32.dll' name 'glGetMapiv';
    private static procedure z_GetMapiv_ovr_0_anh0001(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapiv_ovr_0(target, query, v[0]) else
      z_GetMapiv_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; var v: Int32) :=
    z_GetMapiv_ovr_0(target, query, v);
    private static procedure z_GetMapiv_ovr_2(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapiv(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapiv_ovr_2(target, query, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetMaterialfv_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: single);
    external 'opengl32.dll' name 'glGetMaterialfv';
    private static procedure z_GetMaterialfv_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMaterialfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: DummyEnum; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMaterialfv_ovr_0(face, pname, &params[0]) else
      z_GetMaterialfv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: DummyEnum; pname: MaterialParameter; var &params: single) :=
    z_GetMaterialfv_ovr_0(face, pname, &params);
    private static procedure z_GetMaterialfv_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMaterialfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialfv(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_GetMaterialfv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetMaterialiv_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMaterialiv';
    private static procedure z_GetMaterialiv_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMaterialiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: DummyEnum; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMaterialiv_ovr_0(face, pname, &params[0]) else
      z_GetMaterialiv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: DummyEnum; pname: MaterialParameter; var &params: Int32) :=
    z_GetMaterialiv_ovr_0(face, pname, &params);
    private static procedure z_GetMaterialiv_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMaterialiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialiv(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_GetMaterialiv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetPixelMapfv_ovr_0(map: PixelMap; var values: single);
    external 'opengl32.dll' name 'glGetPixelMapfv';
    private static procedure z_GetPixelMapfv_ovr_0_anh001(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapfv_ovr_0(map, values[0]) else
      z_GetPixelMapfv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; var values: single) :=
    z_GetPixelMapfv_ovr_0(map, values);
    private static procedure z_GetPixelMapfv_ovr_2(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapfv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapfv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetPixelMapuiv_ovr_0(map: PixelMap; var values: UInt32);
    external 'opengl32.dll' name 'glGetPixelMapuiv';
    private static procedure z_GetPixelMapuiv_ovr_0_anh001(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapuiv_ovr_0(map, values[0]) else
      z_GetPixelMapuiv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; var values: UInt32) :=
    z_GetPixelMapuiv_ovr_0(map, values);
    private static procedure z_GetPixelMapuiv_ovr_2(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapuiv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapuiv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetPixelMapusv_ovr_0(map: PixelMap; var values: UInt16);
    external 'opengl32.dll' name 'glGetPixelMapusv';
    private static procedure z_GetPixelMapusv_ovr_0_anh001(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapusv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapusv_ovr_0(map, values[0]) else
      z_GetPixelMapusv_ovr_0_anh001(map, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; var values: UInt16) :=
    z_GetPixelMapusv_ovr_0(map, values);
    private static procedure z_GetPixelMapusv_ovr_2(map: PixelMap; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapusv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapusv(map: PixelMap; values: IntPtr) :=
    z_GetPixelMapusv_ovr_2(map, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetPolygonStipple_ovr_0(var mask: Byte);
    external 'opengl32.dll' name 'glGetPolygonStipple';
    private static procedure z_GetPolygonStipple_ovr_0_anh01(mask: IntPtr);
    external 'opengl32.dll' name 'glGetPolygonStipple';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(mask: array of Byte) :=
    if (mask<>nil) and (mask.Length<>0) then
      z_GetPolygonStipple_ovr_0(mask[0]) else
      z_GetPolygonStipple_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(var mask: Byte) :=
    z_GetPolygonStipple_ovr_0(mask);
    private static procedure z_GetPolygonStipple_ovr_2(mask: IntPtr);
    external 'opengl32.dll' name 'glGetPolygonStipple';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPolygonStipple(mask: IntPtr) :=
    z_GetPolygonStipple_ovr_2(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetTexEnvfv_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTexEnvfv';
    private static procedure z_GetTexEnvfv_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnvfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnvfv_ovr_0(target, pname, &params[0]) else
      z_GetTexEnvfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_GetTexEnvfv_ovr_0(target, pname, &params);
    private static procedure z_GetTexEnvfv_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnvfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnvfv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetTexEnviv_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTexEnviv';
    private static procedure z_GetTexEnviv_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnviv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnviv_ovr_0(target, pname, &params[0]) else
      z_GetTexEnviv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_GetTexEnviv_ovr_0(target, pname, &params);
    private static procedure z_GetTexEnviv_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnviv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnviv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetTexGendv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: real);
    external 'opengl32.dll' name 'glGetTexGendv';
    private static procedure z_GetTexGendv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGendv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGendv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGendv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_GetTexGendv_ovr_0(coord, pname, &params);
    private static procedure z_GetTexGendv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGendv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGendv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetTexGenfv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTexGenfv';
    private static procedure z_GetTexGenfv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGenfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGenfv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGenfv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_GetTexGenfv_ovr_0(coord, pname, &params);
    private static procedure z_GetTexGenfv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGenfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGenfv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_GetTexGeniv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTexGeniv';
    private static procedure z_GetTexGeniv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGeniv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGeniv_ovr_0(coord, pname, &params[0]) else
      z_GetTexGeniv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_GetTexGeniv_ovr_0(coord, pname, &params);
    private static procedure z_GetTexGeniv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGeniv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGeniv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexd_ovr_0(c: real);
    external 'opengl32.dll' name 'glIndexd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexd(c: real) :=
    z_Indexd_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexdv_ovr_0(var c: real);
    external 'opengl32.dll' name 'glIndexdv';
    private static procedure z_Indexdv_ovr_0_anh01(c: IntPtr);
    external 'opengl32.dll' name 'glIndexdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexdv(c: array of real) :=
    if (c<>nil) and (c.Length<>0) then
      z_Indexdv_ovr_0(c[0]) else
      z_Indexdv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexdv(var c: real) :=
    z_Indexdv_ovr_0(c);
    private static procedure z_Indexdv_ovr_2(c: IntPtr);
    external 'opengl32.dll' name 'glIndexdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexdv(c: IntPtr) :=
    z_Indexdv_ovr_2(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexf_ovr_0(c: single);
    external 'opengl32.dll' name 'glIndexf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexf(c: single) :=
    z_Indexf_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexfv_ovr_0(var c: single);
    external 'opengl32.dll' name 'glIndexfv';
    private static procedure z_Indexfv_ovr_0_anh01(c: IntPtr);
    external 'opengl32.dll' name 'glIndexfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexfv(c: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      z_Indexfv_ovr_0(c[0]) else
      z_Indexfv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexfv(var c: single) :=
    z_Indexfv_ovr_0(c);
    private static procedure z_Indexfv_ovr_2(c: IntPtr);
    external 'opengl32.dll' name 'glIndexfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexfv(c: IntPtr) :=
    z_Indexfv_ovr_2(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexi_ovr_0(c: Int32);
    external 'opengl32.dll' name 'glIndexi';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexi(c: Int32) :=
    z_Indexi_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexiv_ovr_0(var c: Int32);
    external 'opengl32.dll' name 'glIndexiv';
    private static procedure z_Indexiv_ovr_0_anh01(c: IntPtr);
    external 'opengl32.dll' name 'glIndexiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexiv(c: array of Int32) :=
    if (c<>nil) and (c.Length<>0) then
      z_Indexiv_ovr_0(c[0]) else
      z_Indexiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexiv(var c: Int32) :=
    z_Indexiv_ovr_0(c);
    private static procedure z_Indexiv_ovr_2(c: IntPtr);
    external 'opengl32.dll' name 'glIndexiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexiv(c: IntPtr) :=
    z_Indexiv_ovr_2(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_IndexMask_ovr_0(mask: UInt32);
    external 'opengl32.dll' name 'glIndexMask';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexMask(mask: UInt32) :=
    z_IndexMask_ovr_0(mask);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_IndexPointer_ovr_0(&type: IndexPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glIndexPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointer(&type: IndexPointerType; stride: Int32; pointer: IntPtr) :=
    z_IndexPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexs_ovr_0(c: Int16);
    external 'opengl32.dll' name 'glIndexs';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexs(c: Int16) :=
    z_Indexs_ovr_0(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Indexsv_ovr_0(var c: Int16);
    external 'opengl32.dll' name 'glIndexsv';
    private static procedure z_Indexsv_ovr_0_anh01(c: IntPtr);
    external 'opengl32.dll' name 'glIndexsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexsv(c: array of Int16) :=
    if (c<>nil) and (c.Length<>0) then
      z_Indexsv_ovr_0(c[0]) else
      z_Indexsv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexsv(var c: Int16) :=
    z_Indexsv_ovr_0(c);
    private static procedure z_Indexsv_ovr_2(c: IntPtr);
    external 'opengl32.dll' name 'glIndexsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexsv(c: IntPtr) :=
    z_Indexsv_ovr_2(c);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_Indexub_ovr_0(c: Byte);
    external 'opengl32.dll' name 'glIndexub';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexub(c: Byte) :=
    z_Indexub_ovr_0(c);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_Indexubv_ovr_0(var c: Byte);
    external 'opengl32.dll' name 'glIndexubv';
    private static procedure z_Indexubv_ovr_0_anh01(c: IntPtr);
    external 'opengl32.dll' name 'glIndexubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexubv(c: array of Byte) :=
    if (c<>nil) and (c.Length<>0) then
      z_Indexubv_ovr_0(c[0]) else
      z_Indexubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexubv(var c: Byte) :=
    z_Indexubv_ovr_0(c);
    private static procedure z_Indexubv_ovr_2(c: IntPtr);
    external 'opengl32.dll' name 'glIndexubv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Indexubv(c: IntPtr) :=
    z_Indexubv_ovr_2(c);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_InitNames_ovr_0;
    external 'opengl32.dll' name 'glInitNames';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InitNames :=
    z_InitNames_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_InterleavedArrays_ovr_0(format: InterleavedArrayFormat; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glInterleavedArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InterleavedArrays(format: InterleavedArrayFormat; stride: Int32; pointer: IntPtr) :=
    z_InterleavedArrays_ovr_0(format, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static function z_IsList_ovr_0(list: UInt32): boolean;
    external 'opengl32.dll' name 'glIsList';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsList(list: UInt32): boolean :=
    z_IsList_ovr_0(list);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Lightf_ovr_0(light: LightName; pname: LightParameter; param: single);
    external 'opengl32.dll' name 'glLightf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightf(light: LightName; pname: LightParameter; param: single) :=
    z_Lightf_ovr_0(light, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Lightfv_ovr_0(light: LightName; pname: LightParameter; var &params: single);
    external 'opengl32.dll' name 'glLightfv';
    private static procedure z_Lightfv_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Lightfv_ovr_0(light, pname, &params[0]) else
      z_Lightfv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; var &params: single) :=
    z_Lightfv_ovr_0(light, pname, &params);
    private static procedure z_Lightfv_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightfv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_Lightfv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Lighti_ovr_0(light: LightName; pname: LightParameter; param: Int32);
    external 'opengl32.dll' name 'glLighti';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lighti(light: LightName; pname: LightParameter; param: Int32) :=
    z_Lighti_ovr_0(light, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Lightiv_ovr_0(light: LightName; pname: LightParameter; var &params: Int32);
    external 'opengl32.dll' name 'glLightiv';
    private static procedure z_Lightiv_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Lightiv_ovr_0(light, pname, &params[0]) else
      z_Lightiv_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; var &params: Int32) :=
    z_Lightiv_ovr_0(light, pname, &params);
    private static procedure z_Lightiv_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Lightiv(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_Lightiv_ovr_2(light, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LightModelf_ovr_0(pname: LightModelParameter; param: single);
    external 'opengl32.dll' name 'glLightModelf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelf(pname: LightModelParameter; param: single) :=
    z_LightModelf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LightModelfv_ovr_0(pname: LightModelParameter; var &params: single);
    external 'opengl32.dll' name 'glLightModelfv';
    private static procedure z_LightModelfv_ovr_0_anh001(pname: LightModelParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightModelfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightModelfv_ovr_0(pname, &params[0]) else
      z_LightModelfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; var &params: single) :=
    z_LightModelfv_ovr_0(pname, &params);
    private static procedure z_LightModelfv_ovr_2(pname: LightModelParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightModelfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelfv(pname: LightModelParameter; &params: IntPtr) :=
    z_LightModelfv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LightModeli_ovr_0(pname: LightModelParameter; param: Int32);
    external 'opengl32.dll' name 'glLightModeli';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeli(pname: LightModelParameter; param: Int32) :=
    z_LightModeli_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LightModeliv_ovr_0(pname: LightModelParameter; var &params: Int32);
    external 'opengl32.dll' name 'glLightModeliv';
    private static procedure z_LightModeliv_ovr_0_anh001(pname: LightModelParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightModeliv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightModeliv_ovr_0(pname, &params[0]) else
      z_LightModeliv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; var &params: Int32) :=
    z_LightModeliv_ovr_0(pname, &params);
    private static procedure z_LightModeliv_ovr_2(pname: LightModelParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightModeliv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModeliv(pname: LightModelParameter; &params: IntPtr) :=
    z_LightModeliv_ovr_2(pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LineStipple_ovr_0(factor: Int32; pattern: UInt16);
    external 'opengl32.dll' name 'glLineStipple';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineStipple(factor: Int32; pattern: UInt16) :=
    z_LineStipple_ovr_0(factor, pattern);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ListBase_ovr_0(base: UInt32);
    external 'opengl32.dll' name 'glListBase';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListBase(base: UInt32) :=
    z_ListBase_ovr_0(base);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LoadIdentity_ovr_0;
    external 'opengl32.dll' name 'glLoadIdentity';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadIdentity :=
    z_LoadIdentity_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LoadMatrixd_ovr_0(var m: real);
    external 'opengl32.dll' name 'glLoadMatrixd';
    private static procedure z_LoadMatrixd_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixd_ovr_0(m[0]) else
      z_LoadMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(var m: real) :=
    z_LoadMatrixd_ovr_0(m);
    private static procedure z_LoadMatrixd_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixd(m: IntPtr) :=
    z_LoadMatrixd_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LoadMatrixf_ovr_0(var m: single);
    external 'opengl32.dll' name 'glLoadMatrixf';
    private static procedure z_LoadMatrixf_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixf_ovr_0(m[0]) else
      z_LoadMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(var m: single) :=
    z_LoadMatrixf_ovr_0(m);
    private static procedure z_LoadMatrixf_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixf(m: IntPtr) :=
    z_LoadMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_LoadName_ovr_0(name: UInt32);
    external 'opengl32.dll' name 'glLoadName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadName(name: UInt32) :=
    z_LoadName_ovr_0(name);
    
    // added in gl1.3, deprecated in gl3.2
    private z_LoadTransposeMatrixd_adr := GetFuncAdr('glLoadTransposeMatrixd');
    private z_LoadTransposeMatrixd_ovr_0 := GetFuncOrNil&<procedure(var m: real)>(z_LoadTransposeMatrixd_adr);
    private z_LoadTransposeMatrixd_ovr_0_anh01 := GetFuncOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixd_ovr_0(m[0]) else
      z_LoadTransposeMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(var m: real) :=
    z_LoadTransposeMatrixd_ovr_0(m);
    private z_LoadTransposeMatrixd_ovr_2 := GetFuncOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixd(m: IntPtr) :=
    z_LoadTransposeMatrixd_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_LoadTransposeMatrixf_adr := GetFuncAdr('glLoadTransposeMatrixf');
    private z_LoadTransposeMatrixf_ovr_0 := GetFuncOrNil&<procedure(var m: single)>(z_LoadTransposeMatrixf_adr);
    private z_LoadTransposeMatrixf_ovr_0_anh01 := GetFuncOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixf_ovr_0(m[0]) else
      z_LoadTransposeMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(var m: single) :=
    z_LoadTransposeMatrixf_ovr_0(m);
    private z_LoadTransposeMatrixf_ovr_2 := GetFuncOrNil&<procedure(m: IntPtr)>(z_LoadTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixf(m: IntPtr) :=
    z_LoadTransposeMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Map1d_ovr_0(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; var points: real);
    external 'opengl32.dll' name 'glMap1d';
    private static procedure z_Map1d_ovr_0_anh0000001(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map1d_ovr_0(target, u1, u2, stride, order, points[0]) else
      z_Map1d_ovr_0_anh0000001(target, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; var points: real) :=
    z_Map1d_ovr_0(target, u1, u2, stride, order, points);
    private static procedure z_Map1d_ovr_2(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1d(target: MapTarget; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr) :=
    z_Map1d_ovr_2(target, u1, u2, stride, order, points);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Map1f_ovr_0(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; var points: single);
    external 'opengl32.dll' name 'glMap1f';
    private static procedure z_Map1f_ovr_0_anh0000001(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map1f_ovr_0(target, u1, u2, stride, order, points[0]) else
      z_Map1f_ovr_0_anh0000001(target, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; var points: single) :=
    z_Map1f_ovr_0(target, u1, u2, stride, order, points);
    private static procedure z_Map1f_ovr_2(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1f(target: MapTarget; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr) :=
    z_Map1f_ovr_2(target, u1, u2, stride, order, points);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Map2d_ovr_0(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real);
    external 'opengl32.dll' name 'glMap2d';
    private static procedure z_Map2d_ovr_0_anh00000000001(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map2d_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_Map2d_ovr_0_anh00000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real) :=
    z_Map2d_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private static procedure z_Map2d_ovr_2(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2d(target: MapTarget; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_Map2d_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Map2f_ovr_0(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single);
    external 'opengl32.dll' name 'glMap2f';
    private static procedure z_Map2f_ovr_0_anh00000000001(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_Map2f_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_Map2f_ovr_0_anh00000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single) :=
    z_Map2f_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private static procedure z_Map2f_ovr_2(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMap2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2f(target: MapTarget; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_Map2f_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MapGrid1d_ovr_0(un: Int32; u1: real; u2: real);
    external 'opengl32.dll' name 'glMapGrid1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1d(un: Int32; u1: real; u2: real) :=
    z_MapGrid1d_ovr_0(un, u1, u2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MapGrid1f_ovr_0(un: Int32; u1: single; u2: single);
    external 'opengl32.dll' name 'glMapGrid1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1f(un: Int32; u1: single; u2: single) :=
    z_MapGrid1f_ovr_0(un, u1, u2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MapGrid2d_ovr_0(un: Int32; u1: real; u2: real; vn: Int32; v1: real; v2: real);
    external 'opengl32.dll' name 'glMapGrid2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2d(un: Int32; u1: real; u2: real; vn: Int32; v1: real; v2: real) :=
    z_MapGrid2d_ovr_0(un, u1, u2, vn, v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MapGrid2f_ovr_0(un: Int32; u1: single; u2: single; vn: Int32; v1: single; v2: single);
    external 'opengl32.dll' name 'glMapGrid2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2f(un: Int32; u1: single; u2: single; vn: Int32; v1: single; v2: single) :=
    z_MapGrid2f_ovr_0(un, u1, u2, vn, v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Materialf_ovr_0(face: DummyEnum; pname: MaterialParameter; param: single);
    external 'opengl32.dll' name 'glMaterialf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialf(face: DummyEnum; pname: MaterialParameter; param: single) :=
    z_Materialf_ovr_0(face, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Materialfv_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: single);
    external 'opengl32.dll' name 'glMaterialfv';
    private static procedure z_Materialfv_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMaterialfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: DummyEnum; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Materialfv_ovr_0(face, pname, &params[0]) else
      z_Materialfv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: DummyEnum; pname: MaterialParameter; var &params: single) :=
    z_Materialfv_ovr_0(face, pname, &params);
    private static procedure z_Materialfv_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMaterialfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialfv(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_Materialfv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Materiali_ovr_0(face: DummyEnum; pname: MaterialParameter; param: Int32);
    external 'opengl32.dll' name 'glMateriali';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materiali(face: DummyEnum; pname: MaterialParameter; param: Int32) :=
    z_Materiali_ovr_0(face, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Materialiv_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: Int32);
    external 'opengl32.dll' name 'glMaterialiv';
    private static procedure z_Materialiv_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMaterialiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: DummyEnum; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_Materialiv_ovr_0(face, pname, &params[0]) else
      z_Materialiv_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: DummyEnum; pname: MaterialParameter; var &params: Int32) :=
    z_Materialiv_ovr_0(face, pname, &params);
    private static procedure z_Materialiv_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMaterialiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Materialiv(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_Materialiv_ovr_2(face, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MatrixMode_ovr_0(mode: OpenGL.MatrixMode);
    external 'opengl32.dll' name 'glMatrixMode';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMode(mode: OpenGL.MatrixMode) :=
    z_MatrixMode_ovr_0(mode);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1d_adr := GetFuncAdr('glMultiTexCoord1d');
    private z_MultiTexCoord1d_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: real)>(z_MultiTexCoord1d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1d(target: TextureUnit; s: real) :=
    z_MultiTexCoord1d_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1dv_adr := GetFuncAdr('glMultiTexCoord1dv');
    private z_MultiTexCoord1dv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord1dv_adr);
    private z_MultiTexCoord1dv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1dv_ovr_0(target, v[0]) else
      z_MultiTexCoord1dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord1dv_ovr_0(target, v);
    private z_MultiTexCoord1dv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1f_adr := GetFuncAdr('glMultiTexCoord1f');
    private z_MultiTexCoord1f_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: single)>(z_MultiTexCoord1f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1f(target: TextureUnit; s: single) :=
    z_MultiTexCoord1f_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1fv_adr := GetFuncAdr('glMultiTexCoord1fv');
    private z_MultiTexCoord1fv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord1fv_adr);
    private z_MultiTexCoord1fv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1fv_ovr_0(target, v[0]) else
      z_MultiTexCoord1fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord1fv_ovr_0(target, v);
    private z_MultiTexCoord1fv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1i_adr := GetFuncAdr('glMultiTexCoord1i');
    private z_MultiTexCoord1i_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int32)>(z_MultiTexCoord1i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1i(target: TextureUnit; s: Int32) :=
    z_MultiTexCoord1i_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1iv_adr := GetFuncAdr('glMultiTexCoord1iv');
    private z_MultiTexCoord1iv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord1iv_adr);
    private z_MultiTexCoord1iv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1iv_ovr_0(target, v[0]) else
      z_MultiTexCoord1iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord1iv_ovr_0(target, v);
    private z_MultiTexCoord1iv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1s_adr := GetFuncAdr('glMultiTexCoord1s');
    private z_MultiTexCoord1s_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int16)>(z_MultiTexCoord1s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1s(target: TextureUnit; s: Int16) :=
    z_MultiTexCoord1s_ovr_0(target, s);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord1sv_adr := GetFuncAdr('glMultiTexCoord1sv');
    private z_MultiTexCoord1sv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord1sv_adr);
    private z_MultiTexCoord1sv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1sv_ovr_0(target, v[0]) else
      z_MultiTexCoord1sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord1sv_ovr_0(target, v);
    private z_MultiTexCoord1sv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord1sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1sv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2d_adr := GetFuncAdr('glMultiTexCoord2d');
    private z_MultiTexCoord2d_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: real; t: real)>(z_MultiTexCoord2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2d(target: TextureUnit; s: real; t: real) :=
    z_MultiTexCoord2d_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2dv_adr := GetFuncAdr('glMultiTexCoord2dv');
    private z_MultiTexCoord2dv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord2dv_adr);
    private z_MultiTexCoord2dv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2dv_ovr_0(target, v[0]) else
      z_MultiTexCoord2dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord2dv_ovr_0(target, v);
    private z_MultiTexCoord2dv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2f_adr := GetFuncAdr('glMultiTexCoord2f');
    private z_MultiTexCoord2f_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: single; t: single)>(z_MultiTexCoord2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2f(target: TextureUnit; s: single; t: single) :=
    z_MultiTexCoord2f_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2fv_adr := GetFuncAdr('glMultiTexCoord2fv');
    private z_MultiTexCoord2fv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord2fv_adr);
    private z_MultiTexCoord2fv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2fv_ovr_0(target, v[0]) else
      z_MultiTexCoord2fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord2fv_ovr_0(target, v);
    private z_MultiTexCoord2fv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2i_adr := GetFuncAdr('glMultiTexCoord2i');
    private z_MultiTexCoord2i_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32)>(z_MultiTexCoord2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2i(target: TextureUnit; s: Int32; t: Int32) :=
    z_MultiTexCoord2i_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2iv_adr := GetFuncAdr('glMultiTexCoord2iv');
    private z_MultiTexCoord2iv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord2iv_adr);
    private z_MultiTexCoord2iv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2iv_ovr_0(target, v[0]) else
      z_MultiTexCoord2iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord2iv_ovr_0(target, v);
    private z_MultiTexCoord2iv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2s_adr := GetFuncAdr('glMultiTexCoord2s');
    private z_MultiTexCoord2s_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16)>(z_MultiTexCoord2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2s(target: TextureUnit; s: Int16; t: Int16) :=
    z_MultiTexCoord2s_ovr_0(target, s, t);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord2sv_adr := GetFuncAdr('glMultiTexCoord2sv');
    private z_MultiTexCoord2sv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord2sv_adr);
    private z_MultiTexCoord2sv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2sv_ovr_0(target, v[0]) else
      z_MultiTexCoord2sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord2sv_ovr_0(target, v);
    private z_MultiTexCoord2sv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2sv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3d_adr := GetFuncAdr('glMultiTexCoord3d');
    private z_MultiTexCoord3d_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real)>(z_MultiTexCoord3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3d(target: TextureUnit; s: real; t: real; r: real) :=
    z_MultiTexCoord3d_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3dv_adr := GetFuncAdr('glMultiTexCoord3dv');
    private z_MultiTexCoord3dv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord3dv_adr);
    private z_MultiTexCoord3dv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3dv_ovr_0(target, v[0]) else
      z_MultiTexCoord3dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord3dv_ovr_0(target, v);
    private z_MultiTexCoord3dv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3f_adr := GetFuncAdr('glMultiTexCoord3f');
    private z_MultiTexCoord3f_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single)>(z_MultiTexCoord3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3f(target: TextureUnit; s: single; t: single; r: single) :=
    z_MultiTexCoord3f_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3fv_adr := GetFuncAdr('glMultiTexCoord3fv');
    private z_MultiTexCoord3fv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord3fv_adr);
    private z_MultiTexCoord3fv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3fv_ovr_0(target, v[0]) else
      z_MultiTexCoord3fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord3fv_ovr_0(target, v);
    private z_MultiTexCoord3fv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3i_adr := GetFuncAdr('glMultiTexCoord3i');
    private z_MultiTexCoord3i_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32)>(z_MultiTexCoord3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3i(target: TextureUnit; s: Int32; t: Int32; r: Int32) :=
    z_MultiTexCoord3i_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3iv_adr := GetFuncAdr('glMultiTexCoord3iv');
    private z_MultiTexCoord3iv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord3iv_adr);
    private z_MultiTexCoord3iv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3iv_ovr_0(target, v[0]) else
      z_MultiTexCoord3iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord3iv_ovr_0(target, v);
    private z_MultiTexCoord3iv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3s_adr := GetFuncAdr('glMultiTexCoord3s');
    private z_MultiTexCoord3s_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16)>(z_MultiTexCoord3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3s(target: TextureUnit; s: Int16; t: Int16; r: Int16) :=
    z_MultiTexCoord3s_ovr_0(target, s, t, r);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord3sv_adr := GetFuncAdr('glMultiTexCoord3sv');
    private z_MultiTexCoord3sv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord3sv_adr);
    private z_MultiTexCoord3sv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3sv_ovr_0(target, v[0]) else
      z_MultiTexCoord3sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord3sv_ovr_0(target, v);
    private z_MultiTexCoord3sv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3sv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4d_adr := GetFuncAdr('glMultiTexCoord4d');
    private z_MultiTexCoord4d_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: real; t: real; r: real; q: real)>(z_MultiTexCoord4d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4d(target: TextureUnit; s: real; t: real; r: real; q: real) :=
    z_MultiTexCoord4d_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4dv_adr := GetFuncAdr('glMultiTexCoord4dv');
    private z_MultiTexCoord4dv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: real)>(z_MultiTexCoord4dv_adr);
    private z_MultiTexCoord4dv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4dv_ovr_0(target, v[0]) else
      z_MultiTexCoord4dv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; var v: real) :=
    z_MultiTexCoord4dv_ovr_0(target, v);
    private z_MultiTexCoord4dv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4dv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4f_adr := GetFuncAdr('glMultiTexCoord4f');
    private z_MultiTexCoord4f_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: single; t: single; r: single; q: single)>(z_MultiTexCoord4f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4f(target: TextureUnit; s: single; t: single; r: single; q: single) :=
    z_MultiTexCoord4f_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4fv_adr := GetFuncAdr('glMultiTexCoord4fv');
    private z_MultiTexCoord4fv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: single)>(z_MultiTexCoord4fv_adr);
    private z_MultiTexCoord4fv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4fv_ovr_0(target, v[0]) else
      z_MultiTexCoord4fv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; var v: single) :=
    z_MultiTexCoord4fv_ovr_0(target, v);
    private z_MultiTexCoord4fv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4fv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4i_adr := GetFuncAdr('glMultiTexCoord4i');
    private z_MultiTexCoord4i_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32)>(z_MultiTexCoord4i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4i(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_MultiTexCoord4i_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4iv_adr := GetFuncAdr('glMultiTexCoord4iv');
    private z_MultiTexCoord4iv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int32)>(z_MultiTexCoord4iv_adr);
    private z_MultiTexCoord4iv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4iv_ovr_0(target, v[0]) else
      z_MultiTexCoord4iv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord4iv_ovr_0(target, v);
    private z_MultiTexCoord4iv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4iv_ovr_2(target, v);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4s_adr := GetFuncAdr('glMultiTexCoord4s');
    private z_MultiTexCoord4s_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16)>(z_MultiTexCoord4s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4s(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_MultiTexCoord4s_ovr_0(target, s, t, r, q);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultiTexCoord4sv_adr := GetFuncAdr('glMultiTexCoord4sv');
    private z_MultiTexCoord4sv_ovr_0 := GetFuncOrNil&<procedure(target: TextureUnit; var v: Int16)>(z_MultiTexCoord4sv_adr);
    private z_MultiTexCoord4sv_ovr_0_anh001 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4sv_ovr_0(target, v[0]) else
      z_MultiTexCoord4sv_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord4sv_ovr_0(target, v);
    private z_MultiTexCoord4sv_ovr_2 := GetFuncOrNil&<procedure(target: TextureUnit; v: IntPtr)>(z_MultiTexCoord4sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sv(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4sv_ovr_2(target, v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MultMatrixd_ovr_0(var m: real);
    external 'opengl32.dll' name 'glMultMatrixd';
    private static procedure z_MultMatrixd_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixd_ovr_0(m[0]) else
      z_MultMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(var m: real) :=
    z_MultMatrixd_ovr_0(m);
    private static procedure z_MultMatrixd_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixd(m: IntPtr) :=
    z_MultMatrixd_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_MultMatrixf_ovr_0(var m: single);
    external 'opengl32.dll' name 'glMultMatrixf';
    private static procedure z_MultMatrixf_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixf_ovr_0(m[0]) else
      z_MultMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(var m: single) :=
    z_MultMatrixf_ovr_0(m);
    private static procedure z_MultMatrixf_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixf(m: IntPtr) :=
    z_MultMatrixf_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultTransposeMatrixd_adr := GetFuncAdr('glMultTransposeMatrixd');
    private z_MultTransposeMatrixd_ovr_0 := GetFuncOrNil&<procedure(var m: real)>(z_MultTransposeMatrixd_adr);
    private z_MultTransposeMatrixd_ovr_0_anh01 := GetFuncOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixd_ovr_0(m[0]) else
      z_MultTransposeMatrixd_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(var m: real) :=
    z_MultTransposeMatrixd_ovr_0(m);
    private z_MultTransposeMatrixd_ovr_2 := GetFuncOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixd_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixd(m: IntPtr) :=
    z_MultTransposeMatrixd_ovr_2(m);
    
    // added in gl1.3, deprecated in gl3.2
    private z_MultTransposeMatrixf_adr := GetFuncAdr('glMultTransposeMatrixf');
    private z_MultTransposeMatrixf_ovr_0 := GetFuncOrNil&<procedure(var m: single)>(z_MultTransposeMatrixf_adr);
    private z_MultTransposeMatrixf_ovr_0_anh01 := GetFuncOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixf_ovr_0(m[0]) else
      z_MultTransposeMatrixf_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(var m: single) :=
    z_MultTransposeMatrixf_ovr_0(m);
    private z_MultTransposeMatrixf_ovr_2 := GetFuncOrNil&<procedure(m: IntPtr)>(z_MultTransposeMatrixf_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixf(m: IntPtr) :=
    z_MultTransposeMatrixf_ovr_2(m);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_NewList_ovr_0(list: UInt32; mode: ListMode);
    external 'opengl32.dll' name 'glNewList';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NewList(list: UInt32; mode: ListMode) :=
    z_NewList_ovr_0(list, mode);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3b_ovr_0(nx: SByte; ny: SByte; nz: SByte);
    external 'opengl32.dll' name 'glNormal3b';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3b(nx: SByte; ny: SByte; nz: SByte) :=
    z_Normal3b_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3bv_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glNormal3bv';
    private static procedure z_Normal3bv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3bv_ovr_0(v[0]) else
      z_Normal3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(var v: SByte) :=
    z_Normal3bv_ovr_0(v);
    private static procedure z_Normal3bv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3bv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3bv(v: IntPtr) :=
    z_Normal3bv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3d_ovr_0(nx: real; ny: real; nz: real);
    external 'opengl32.dll' name 'glNormal3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3d(nx: real; ny: real; nz: real) :=
    z_Normal3d_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glNormal3dv';
    private static procedure z_Normal3dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3dv_ovr_0(v[0]) else
      z_Normal3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(var v: real) :=
    z_Normal3dv_ovr_0(v);
    private static procedure z_Normal3dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3dv(v: IntPtr) :=
    z_Normal3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3f_ovr_0(nx: single; ny: single; nz: single);
    external 'opengl32.dll' name 'glNormal3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3f(nx: single; ny: single; nz: single) :=
    z_Normal3f_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glNormal3fv';
    private static procedure z_Normal3fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3fv_ovr_0(v[0]) else
      z_Normal3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(var v: single) :=
    z_Normal3fv_ovr_0(v);
    private static procedure z_Normal3fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fv(v: IntPtr) :=
    z_Normal3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3i_ovr_0(nx: Int32; ny: Int32; nz: Int32);
    external 'opengl32.dll' name 'glNormal3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3i(nx: Int32; ny: Int32; nz: Int32) :=
    z_Normal3i_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glNormal3iv';
    private static procedure z_Normal3iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3iv_ovr_0(v[0]) else
      z_Normal3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(var v: Int32) :=
    z_Normal3iv_ovr_0(v);
    private static procedure z_Normal3iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3iv(v: IntPtr) :=
    z_Normal3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3s_ovr_0(nx: Int16; ny: Int16; nz: Int16);
    external 'opengl32.dll' name 'glNormal3s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3s(nx: Int16; ny: Int16; nz: Int16) :=
    z_Normal3s_ovr_0(nx, ny, nz);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Normal3sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glNormal3sv';
    private static procedure z_Normal3sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3sv_ovr_0(v[0]) else
      z_Normal3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(var v: Int16) :=
    z_Normal3sv_ovr_0(v);
    private static procedure z_Normal3sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3sv(v: IntPtr) :=
    z_Normal3sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_NormalPointer_ovr_0(&type: NormalPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glNormalPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointer(&type: NormalPointerType; stride: Int32; pointer: IntPtr) :=
    z_NormalPointer_ovr_0(&type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Ortho_ovr_0(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glOrtho';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Ortho(left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_Ortho_ovr_0(left, right, bottom, top, zNear, zFar);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PassThrough_ovr_0(token: single);
    external 'opengl32.dll' name 'glPassThrough';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassThrough(token: single) :=
    z_PassThrough_ovr_0(token);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelMapfv_ovr_0(map: PixelMap; mapsize: Int32; var values: single);
    external 'opengl32.dll' name 'glPixelMapfv';
    private static procedure z_PixelMapfv_ovr_0_anh0001(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapfv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapfv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; var values: single) :=
    z_PixelMapfv_ovr_0(map, mapsize, values);
    private static procedure z_PixelMapfv_ovr_2(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapfv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapfv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelMapuiv_ovr_0(map: PixelMap; mapsize: Int32; var values: UInt32);
    external 'opengl32.dll' name 'glPixelMapuiv';
    private static procedure z_PixelMapuiv_ovr_0_anh0001(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapuiv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapuiv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; var values: UInt32) :=
    z_PixelMapuiv_ovr_0(map, mapsize, values);
    private static procedure z_PixelMapuiv_ovr_2(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapuiv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapuiv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelMapusv_ovr_0(map: PixelMap; mapsize: Int32; var values: UInt16);
    external 'opengl32.dll' name 'glPixelMapusv';
    private static procedure z_PixelMapusv_ovr_0_anh0001(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapusv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapusv_ovr_0(map, mapsize, values[0]) else
      z_PixelMapusv_ovr_0_anh0001(map, mapsize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; var values: UInt16) :=
    z_PixelMapusv_ovr_0(map, mapsize, values);
    private static procedure z_PixelMapusv_ovr_2(map: PixelMap; mapsize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapusv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapusv(map: PixelMap; mapsize: Int32; values: IntPtr) :=
    z_PixelMapusv_ovr_2(map, mapsize, values);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelTransferf_ovr_0(pname: PixelTransferParameter; param: single);
    external 'opengl32.dll' name 'glPixelTransferf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferf(pname: PixelTransferParameter; param: single) :=
    z_PixelTransferf_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelTransferi_ovr_0(pname: PixelTransferParameter; param: Int32);
    external 'opengl32.dll' name 'glPixelTransferi';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferi(pname: PixelTransferParameter; param: Int32) :=
    z_PixelTransferi_ovr_0(pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PixelZoom_ovr_0(xfactor: single; yfactor: single);
    external 'opengl32.dll' name 'glPixelZoom';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelZoom(xfactor: single; yfactor: single) :=
    z_PixelZoom_ovr_0(xfactor, yfactor);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PolygonStipple_ovr_0(var mask: Byte);
    external 'opengl32.dll' name 'glPolygonStipple';
    private static procedure z_PolygonStipple_ovr_0_anh01(mask: IntPtr);
    external 'opengl32.dll' name 'glPolygonStipple';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(mask: array of Byte) :=
    if (mask<>nil) and (mask.Length<>0) then
      z_PolygonStipple_ovr_0(mask[0]) else
      z_PolygonStipple_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(var mask: Byte) :=
    z_PolygonStipple_ovr_0(mask);
    private static procedure z_PolygonStipple_ovr_2(mask: IntPtr);
    external 'opengl32.dll' name 'glPolygonStipple';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonStipple(mask: IntPtr) :=
    z_PolygonStipple_ovr_2(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PopAttrib_ovr_0;
    external 'opengl32.dll' name 'glPopAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopAttrib :=
    z_PopAttrib_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_PopClientAttrib_ovr_0;
    external 'opengl32.dll' name 'glPopClientAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopClientAttrib :=
    z_PopClientAttrib_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PopMatrix_ovr_0;
    external 'opengl32.dll' name 'glPopMatrix';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopMatrix :=
    z_PopMatrix_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PopName_ovr_0;
    external 'opengl32.dll' name 'glPopName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopName :=
    z_PopName_ovr_0;
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_PrioritizeTextures_ovr_0(n: Int32; var textures: UInt32; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    private static procedure z_PrioritizeTextures_ovr_0_anh0010(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    private static procedure z_PrioritizeTextures_ovr_0_anh0001(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    private static procedure z_PrioritizeTextures_ovr_0_anh0011(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of UInt32; priorities: array of single) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTextures_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTextures_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTextures_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTextures_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_PrioritizeTextures_ovr_1_anh0010(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of UInt32; var priorities: single) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTextures_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTextures_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private static procedure z_PrioritizeTextures_ovr_2(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    private static procedure z_PrioritizeTextures_ovr_2_anh0010(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: array of UInt32; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTextures_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTextures_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: UInt32; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTextures_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTextures_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: UInt32; var priorities: single) :=
    z_PrioritizeTextures_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; var textures: UInt32; priorities: IntPtr) :=
    z_PrioritizeTextures_ovr_2(n, textures, priorities);
    private static procedure z_PrioritizeTextures_ovr_6(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    private static procedure z_PrioritizeTextures_ovr_6_anh0001(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTextures_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTextures_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; var priorities: single) :=
    z_PrioritizeTextures_ovr_6(n, textures, priorities);
    private static procedure z_PrioritizeTextures_ovr_8(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTextures(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTextures_ovr_8(n, textures, priorities);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PushAttrib_ovr_0(mask: AttribMask);
    external 'opengl32.dll' name 'glPushAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushAttrib(mask: AttribMask) :=
    z_PushAttrib_ovr_0(mask);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_PushClientAttrib_ovr_0(mask: ClientAttribMask);
    external 'opengl32.dll' name 'glPushClientAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushClientAttrib(mask: ClientAttribMask) :=
    z_PushClientAttrib_ovr_0(mask);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PushMatrix_ovr_0;
    external 'opengl32.dll' name 'glPushMatrix';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushMatrix :=
    z_PushMatrix_ovr_0;
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_PushName_ovr_0(name: UInt32);
    external 'opengl32.dll' name 'glPushName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushName(name: UInt32) :=
    z_PushName_ovr_0(name);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2d_ovr_0(x: real; y: real);
    external 'opengl32.dll' name 'glRasterPos2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2d(x: real; y: real) :=
    z_RasterPos2d_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glRasterPos2dv';
    private static procedure z_RasterPos2dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2dv_ovr_0(v[0]) else
      z_RasterPos2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(var v: real) :=
    z_RasterPos2dv_ovr_0(v);
    private static procedure z_RasterPos2dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2dv(v: IntPtr) :=
    z_RasterPos2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2f_ovr_0(x: single; y: single);
    external 'opengl32.dll' name 'glRasterPos2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2f(x: single; y: single) :=
    z_RasterPos2f_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glRasterPos2fv';
    private static procedure z_RasterPos2fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2fv_ovr_0(v[0]) else
      z_RasterPos2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(var v: single) :=
    z_RasterPos2fv_ovr_0(v);
    private static procedure z_RasterPos2fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2fv(v: IntPtr) :=
    z_RasterPos2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2i_ovr_0(x: Int32; y: Int32);
    external 'opengl32.dll' name 'glRasterPos2i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2i(x: Int32; y: Int32) :=
    z_RasterPos2i_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glRasterPos2iv';
    private static procedure z_RasterPos2iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2iv_ovr_0(v[0]) else
      z_RasterPos2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(var v: Int32) :=
    z_RasterPos2iv_ovr_0(v);
    private static procedure z_RasterPos2iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2iv(v: IntPtr) :=
    z_RasterPos2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2s_ovr_0(x: Int16; y: Int16);
    external 'opengl32.dll' name 'glRasterPos2s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2s(x: Int16; y: Int16) :=
    z_RasterPos2s_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos2sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glRasterPos2sv';
    private static procedure z_RasterPos2sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos2sv_ovr_0(v[0]) else
      z_RasterPos2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(var v: Int16) :=
    z_RasterPos2sv_ovr_0(v);
    private static procedure z_RasterPos2sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2sv(v: IntPtr) :=
    z_RasterPos2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3d_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glRasterPos3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3d(x: real; y: real; z: real) :=
    z_RasterPos3d_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glRasterPos3dv';
    private static procedure z_RasterPos3dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3dv_ovr_0(v[0]) else
      z_RasterPos3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(var v: real) :=
    z_RasterPos3dv_ovr_0(v);
    private static procedure z_RasterPos3dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3dv(v: IntPtr) :=
    z_RasterPos3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3f_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glRasterPos3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3f(x: single; y: single; z: single) :=
    z_RasterPos3f_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glRasterPos3fv';
    private static procedure z_RasterPos3fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3fv_ovr_0(v[0]) else
      z_RasterPos3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(var v: single) :=
    z_RasterPos3fv_ovr_0(v);
    private static procedure z_RasterPos3fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3fv(v: IntPtr) :=
    z_RasterPos3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3i_ovr_0(x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glRasterPos3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3i(x: Int32; y: Int32; z: Int32) :=
    z_RasterPos3i_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glRasterPos3iv';
    private static procedure z_RasterPos3iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3iv_ovr_0(v[0]) else
      z_RasterPos3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(var v: Int32) :=
    z_RasterPos3iv_ovr_0(v);
    private static procedure z_RasterPos3iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3iv(v: IntPtr) :=
    z_RasterPos3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3s_ovr_0(x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glRasterPos3s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3s(x: Int16; y: Int16; z: Int16) :=
    z_RasterPos3s_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos3sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glRasterPos3sv';
    private static procedure z_RasterPos3sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos3sv_ovr_0(v[0]) else
      z_RasterPos3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(var v: Int16) :=
    z_RasterPos3sv_ovr_0(v);
    private static procedure z_RasterPos3sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3sv(v: IntPtr) :=
    z_RasterPos3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4d_ovr_0(x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glRasterPos4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4d(x: real; y: real; z: real; w: real) :=
    z_RasterPos4d_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glRasterPos4dv';
    private static procedure z_RasterPos4dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4dv_ovr_0(v[0]) else
      z_RasterPos4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(var v: real) :=
    z_RasterPos4dv_ovr_0(v);
    private static procedure z_RasterPos4dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4dv(v: IntPtr) :=
    z_RasterPos4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4f_ovr_0(x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glRasterPos4f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4f(x: single; y: single; z: single; w: single) :=
    z_RasterPos4f_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glRasterPos4fv';
    private static procedure z_RasterPos4fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4fv_ovr_0(v[0]) else
      z_RasterPos4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(var v: single) :=
    z_RasterPos4fv_ovr_0(v);
    private static procedure z_RasterPos4fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4fv(v: IntPtr) :=
    z_RasterPos4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4i_ovr_0(x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glRasterPos4i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4i(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_RasterPos4i_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glRasterPos4iv';
    private static procedure z_RasterPos4iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4iv_ovr_0(v[0]) else
      z_RasterPos4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(var v: Int32) :=
    z_RasterPos4iv_ovr_0(v);
    private static procedure z_RasterPos4iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4iv(v: IntPtr) :=
    z_RasterPos4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4s_ovr_0(x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glRasterPos4s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4s(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_RasterPos4s_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_RasterPos4sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glRasterPos4sv';
    private static procedure z_RasterPos4sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_RasterPos4sv_ovr_0(v[0]) else
      z_RasterPos4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(var v: Int16) :=
    z_RasterPos4sv_ovr_0(v);
    private static procedure z_RasterPos4sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4sv(v: IntPtr) :=
    z_RasterPos4sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectd_ovr_0(x1: real; y1: real; x2: real; y2: real);
    external 'opengl32.dll' name 'glRectd';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectd(x1: real; y1: real; x2: real; y2: real) :=
    z_Rectd_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectdv_ovr_0(var v1: real; var v2: real);
    external 'opengl32.dll' name 'glRectdv';
    private static procedure z_Rectdv_ovr_0_anh010(v1: IntPtr; var v2: real);
    external 'opengl32.dll' name 'glRectdv';
    private static procedure z_Rectdv_ovr_0_anh001(var v1: real; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    private static procedure z_Rectdv_ovr_0_anh011(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; v2: array of real) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectdv_ovr_0(v1[0], v2[0]) else
        z_Rectdv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectdv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectdv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static procedure z_Rectdv_ovr_1_anh010(v1: IntPtr; var v2: real);
    external 'opengl32.dll' name 'glRectdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; var v2: real) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectdv_ovr_0(v1[0], v2) else
      z_Rectdv_ovr_0_anh010(IntPtr.Zero, v2);
    private static procedure z_Rectdv_ovr_2(var v1: real; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    private static procedure z_Rectdv_ovr_2_anh010(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: array of real; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectdv_ovr_2(v1[0], v2) else
      z_Rectdv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; v2: array of real) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectdv_ovr_0(v1, v2[0]) else
      z_Rectdv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; var v2: real) :=
    z_Rectdv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(var v1: real; v2: IntPtr) :=
    z_Rectdv_ovr_2(v1, v2);
    private static procedure z_Rectdv_ovr_6(v1: IntPtr; var v2: real);
    external 'opengl32.dll' name 'glRectdv';
    private static procedure z_Rectdv_ovr_6_anh001(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; v2: array of real) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectdv_ovr_6(v1, v2[0]) else
      z_Rectdv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; var v2: real) :=
    z_Rectdv_ovr_6(v1, v2);
    private static procedure z_Rectdv_ovr_8(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectdv(v1: IntPtr; v2: IntPtr) :=
    z_Rectdv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectf_ovr_0(x1: single; y1: single; x2: single; y2: single);
    external 'opengl32.dll' name 'glRectf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectf(x1: single; y1: single; x2: single; y2: single) :=
    z_Rectf_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectfv_ovr_0(var v1: single; var v2: single);
    external 'opengl32.dll' name 'glRectfv';
    private static procedure z_Rectfv_ovr_0_anh010(v1: IntPtr; var v2: single);
    external 'opengl32.dll' name 'glRectfv';
    private static procedure z_Rectfv_ovr_0_anh001(var v1: single; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    private static procedure z_Rectfv_ovr_0_anh011(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; v2: array of single) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectfv_ovr_0(v1[0], v2[0]) else
        z_Rectfv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectfv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectfv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static procedure z_Rectfv_ovr_1_anh010(v1: IntPtr; var v2: single);
    external 'opengl32.dll' name 'glRectfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; var v2: single) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectfv_ovr_0(v1[0], v2) else
      z_Rectfv_ovr_0_anh010(IntPtr.Zero, v2);
    private static procedure z_Rectfv_ovr_2(var v1: single; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    private static procedure z_Rectfv_ovr_2_anh010(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: array of single; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectfv_ovr_2(v1[0], v2) else
      z_Rectfv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; v2: array of single) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectfv_ovr_0(v1, v2[0]) else
      z_Rectfv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; var v2: single) :=
    z_Rectfv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(var v1: single; v2: IntPtr) :=
    z_Rectfv_ovr_2(v1, v2);
    private static procedure z_Rectfv_ovr_6(v1: IntPtr; var v2: single);
    external 'opengl32.dll' name 'glRectfv';
    private static procedure z_Rectfv_ovr_6_anh001(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; v2: array of single) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectfv_ovr_6(v1, v2[0]) else
      z_Rectfv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; var v2: single) :=
    z_Rectfv_ovr_6(v1, v2);
    private static procedure z_Rectfv_ovr_8(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectfv(v1: IntPtr; v2: IntPtr) :=
    z_Rectfv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Recti_ovr_0(x1: Int32; y1: Int32; x2: Int32; y2: Int32);
    external 'opengl32.dll' name 'glRecti';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Recti(x1: Int32; y1: Int32; x2: Int32; y2: Int32) :=
    z_Recti_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectiv_ovr_0(var v1: Int32; var v2: Int32);
    external 'opengl32.dll' name 'glRectiv';
    private static procedure z_Rectiv_ovr_0_anh010(v1: IntPtr; var v2: Int32);
    external 'opengl32.dll' name 'glRectiv';
    private static procedure z_Rectiv_ovr_0_anh001(var v1: Int32; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    private static procedure z_Rectiv_ovr_0_anh011(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; v2: array of Int32) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectiv_ovr_0(v1[0], v2[0]) else
        z_Rectiv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectiv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectiv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static procedure z_Rectiv_ovr_1_anh010(v1: IntPtr; var v2: Int32);
    external 'opengl32.dll' name 'glRectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; var v2: Int32) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectiv_ovr_0(v1[0], v2) else
      z_Rectiv_ovr_0_anh010(IntPtr.Zero, v2);
    private static procedure z_Rectiv_ovr_2(var v1: Int32; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    private static procedure z_Rectiv_ovr_2_anh010(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: array of Int32; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectiv_ovr_2(v1[0], v2) else
      z_Rectiv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; v2: array of Int32) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectiv_ovr_0(v1, v2[0]) else
      z_Rectiv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; var v2: Int32) :=
    z_Rectiv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(var v1: Int32; v2: IntPtr) :=
    z_Rectiv_ovr_2(v1, v2);
    private static procedure z_Rectiv_ovr_6(v1: IntPtr; var v2: Int32);
    external 'opengl32.dll' name 'glRectiv';
    private static procedure z_Rectiv_ovr_6_anh001(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; v2: array of Int32) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectiv_ovr_6(v1, v2[0]) else
      z_Rectiv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; var v2: Int32) :=
    z_Rectiv_ovr_6(v1, v2);
    private static procedure z_Rectiv_ovr_8(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectiv(v1: IntPtr; v2: IntPtr) :=
    z_Rectiv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rects_ovr_0(x1: Int16; y1: Int16; x2: Int16; y2: Int16);
    external 'opengl32.dll' name 'glRects';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rects(x1: Int16; y1: Int16; x2: Int16; y2: Int16) :=
    z_Rects_ovr_0(x1, y1, x2, y2);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rectsv_ovr_0(var v1: Int16; var v2: Int16);
    external 'opengl32.dll' name 'glRectsv';
    private static procedure z_Rectsv_ovr_0_anh010(v1: IntPtr; var v2: Int16);
    external 'opengl32.dll' name 'glRectsv';
    private static procedure z_Rectsv_ovr_0_anh001(var v1: Int16; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    private static procedure z_Rectsv_ovr_0_anh011(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; v2: array of Int16) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectsv_ovr_0(v1[0], v2[0]) else
        z_Rectsv_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_Rectsv_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_Rectsv_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static procedure z_Rectsv_ovr_1_anh010(v1: IntPtr; var v2: Int16);
    external 'opengl32.dll' name 'glRectsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; var v2: Int16) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectsv_ovr_0(v1[0], v2) else
      z_Rectsv_ovr_0_anh010(IntPtr.Zero, v2);
    private static procedure z_Rectsv_ovr_2(var v1: Int16; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    private static procedure z_Rectsv_ovr_2_anh010(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: array of Int16; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_Rectsv_ovr_2(v1[0], v2) else
      z_Rectsv_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; v2: array of Int16) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectsv_ovr_0(v1, v2[0]) else
      z_Rectsv_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; var v2: Int16) :=
    z_Rectsv_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(var v1: Int16; v2: IntPtr) :=
    z_Rectsv_ovr_2(v1, v2);
    private static procedure z_Rectsv_ovr_6(v1: IntPtr; var v2: Int16);
    external 'opengl32.dll' name 'glRectsv';
    private static procedure z_Rectsv_ovr_6_anh001(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; v2: array of Int16) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_Rectsv_ovr_6(v1, v2[0]) else
      z_Rectsv_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; var v2: Int16) :=
    z_Rectsv_ovr_6(v1, v2);
    private static procedure z_Rectsv_ovr_8(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectsv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rectsv(v1: IntPtr; v2: IntPtr) :=
    z_Rectsv_ovr_8(v1, v2);
    
    // added in gl1.0, deprecated in gl3.2
    private static function z_RenderMode_ovr_0(mode: RenderingMode): Int32;
    external 'opengl32.dll' name 'glRenderMode';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function RenderMode(mode: RenderingMode): Int32 :=
    z_RenderMode_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rotated_ovr_0(angle: real; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glRotated';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rotated(angle: real; x: real; y: real; z: real) :=
    z_Rotated_ovr_0(angle, x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Rotatef_ovr_0(angle: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glRotatef';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Rotatef(angle: single; x: single; y: single; z: single) :=
    z_Rotatef_ovr_0(angle, x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Scaled_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glScaled';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scaled(x: real; y: real; z: real) :=
    z_Scaled_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Scalef_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glScalef';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Scalef(x: single; y: single; z: single) :=
    z_Scalef_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3b_adr := GetFuncAdr('glSecondaryColor3b');
    private z_SecondaryColor3b_ovr_0 := GetFuncOrNil&<procedure(red: SByte; green: SByte; blue: SByte)>(z_SecondaryColor3b_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3b(red: SByte; green: SByte; blue: SByte) :=
    z_SecondaryColor3b_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3bv_adr := GetFuncAdr('glSecondaryColor3bv');
    private z_SecondaryColor3bv_ovr_0 := GetFuncOrNil&<procedure(var v: SByte)>(z_SecondaryColor3bv_adr);
    private z_SecondaryColor3bv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3bv_ovr_0(v[0]) else
      z_SecondaryColor3bv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(var v: SByte) :=
    z_SecondaryColor3bv_ovr_0(v);
    private z_SecondaryColor3bv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3bv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bv(v: IntPtr) :=
    z_SecondaryColor3bv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3d_adr := GetFuncAdr('glSecondaryColor3d');
    private z_SecondaryColor3d_ovr_0 := GetFuncOrNil&<procedure(red: real; green: real; blue: real)>(z_SecondaryColor3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3d(red: real; green: real; blue: real) :=
    z_SecondaryColor3d_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3dv_adr := GetFuncAdr('glSecondaryColor3dv');
    private z_SecondaryColor3dv_ovr_0 := GetFuncOrNil&<procedure(var v: real)>(z_SecondaryColor3dv_adr);
    private z_SecondaryColor3dv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3dv_ovr_0(v[0]) else
      z_SecondaryColor3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(var v: real) :=
    z_SecondaryColor3dv_ovr_0(v);
    private z_SecondaryColor3dv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dv(v: IntPtr) :=
    z_SecondaryColor3dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3f_adr := GetFuncAdr('glSecondaryColor3f');
    private z_SecondaryColor3f_ovr_0 := GetFuncOrNil&<procedure(red: single; green: single; blue: single)>(z_SecondaryColor3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3f(red: single; green: single; blue: single) :=
    z_SecondaryColor3f_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3fv_adr := GetFuncAdr('glSecondaryColor3fv');
    private z_SecondaryColor3fv_ovr_0 := GetFuncOrNil&<procedure(var v: single)>(z_SecondaryColor3fv_adr);
    private z_SecondaryColor3fv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3fv_ovr_0(v[0]) else
      z_SecondaryColor3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(var v: single) :=
    z_SecondaryColor3fv_ovr_0(v);
    private z_SecondaryColor3fv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fv(v: IntPtr) :=
    z_SecondaryColor3fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3i_adr := GetFuncAdr('glSecondaryColor3i');
    private z_SecondaryColor3i_ovr_0 := GetFuncOrNil&<procedure(red: Int32; green: Int32; blue: Int32)>(z_SecondaryColor3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3i(red: Int32; green: Int32; blue: Int32) :=
    z_SecondaryColor3i_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3iv_adr := GetFuncAdr('glSecondaryColor3iv');
    private z_SecondaryColor3iv_ovr_0 := GetFuncOrNil&<procedure(var v: Int32)>(z_SecondaryColor3iv_adr);
    private z_SecondaryColor3iv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3iv_ovr_0(v[0]) else
      z_SecondaryColor3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(var v: Int32) :=
    z_SecondaryColor3iv_ovr_0(v);
    private z_SecondaryColor3iv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iv(v: IntPtr) :=
    z_SecondaryColor3iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3s_adr := GetFuncAdr('glSecondaryColor3s');
    private z_SecondaryColor3s_ovr_0 := GetFuncOrNil&<procedure(red: Int16; green: Int16; blue: Int16)>(z_SecondaryColor3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3s(red: Int16; green: Int16; blue: Int16) :=
    z_SecondaryColor3s_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3sv_adr := GetFuncAdr('glSecondaryColor3sv');
    private z_SecondaryColor3sv_ovr_0 := GetFuncOrNil&<procedure(var v: Int16)>(z_SecondaryColor3sv_adr);
    private z_SecondaryColor3sv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3sv_ovr_0(v[0]) else
      z_SecondaryColor3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(var v: Int16) :=
    z_SecondaryColor3sv_ovr_0(v);
    private z_SecondaryColor3sv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sv(v: IntPtr) :=
    z_SecondaryColor3sv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ub_adr := GetFuncAdr('glSecondaryColor3ub');
    private z_SecondaryColor3ub_ovr_0 := GetFuncOrNil&<procedure(red: Byte; green: Byte; blue: Byte)>(z_SecondaryColor3ub_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ub(red: Byte; green: Byte; blue: Byte) :=
    z_SecondaryColor3ub_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ubv_adr := GetFuncAdr('glSecondaryColor3ubv');
    private z_SecondaryColor3ubv_ovr_0 := GetFuncOrNil&<procedure(var v: Byte)>(z_SecondaryColor3ubv_adr);
    private z_SecondaryColor3ubv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ubv_ovr_0(v[0]) else
      z_SecondaryColor3ubv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(var v: Byte) :=
    z_SecondaryColor3ubv_ovr_0(v);
    private z_SecondaryColor3ubv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3ubv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubv(v: IntPtr) :=
    z_SecondaryColor3ubv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3ui_adr := GetFuncAdr('glSecondaryColor3ui');
    private z_SecondaryColor3ui_ovr_0 := GetFuncOrNil&<procedure(red: UInt32; green: UInt32; blue: UInt32)>(z_SecondaryColor3ui_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ui(red: UInt32; green: UInt32; blue: UInt32) :=
    z_SecondaryColor3ui_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3uiv_adr := GetFuncAdr('glSecondaryColor3uiv');
    private z_SecondaryColor3uiv_ovr_0 := GetFuncOrNil&<procedure(var v: UInt32)>(z_SecondaryColor3uiv_adr);
    private z_SecondaryColor3uiv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3uiv_ovr_0(v[0]) else
      z_SecondaryColor3uiv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(var v: UInt32) :=
    z_SecondaryColor3uiv_ovr_0(v);
    private z_SecondaryColor3uiv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3uiv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiv(v: IntPtr) :=
    z_SecondaryColor3uiv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3us_adr := GetFuncAdr('glSecondaryColor3us');
    private z_SecondaryColor3us_ovr_0 := GetFuncOrNil&<procedure(red: UInt16; green: UInt16; blue: UInt16)>(z_SecondaryColor3us_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3us(red: UInt16; green: UInt16; blue: UInt16) :=
    z_SecondaryColor3us_ovr_0(red, green, blue);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColor3usv_adr := GetFuncAdr('glSecondaryColor3usv');
    private z_SecondaryColor3usv_ovr_0 := GetFuncOrNil&<procedure(var v: UInt16)>(z_SecondaryColor3usv_adr);
    private z_SecondaryColor3usv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3usv_ovr_0(v[0]) else
      z_SecondaryColor3usv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(var v: UInt16) :=
    z_SecondaryColor3usv_ovr_0(v);
    private z_SecondaryColor3usv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_SecondaryColor3usv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usv(v: IntPtr) :=
    z_SecondaryColor3usv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_SecondaryColorPointer_adr := GetFuncAdr('glSecondaryColorPointer');
    private z_SecondaryColorPointer_ovr_0 := GetFuncOrNil&<procedure(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr)>(z_SecondaryColorPointer_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointer(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_SecondaryColorPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_SelectBuffer_ovr_0(size: Int32; var buffer: UInt32);
    external 'opengl32.dll' name 'glSelectBuffer';
    private static procedure z_SelectBuffer_ovr_0_anh001(size: Int32; buffer: IntPtr);
    external 'opengl32.dll' name 'glSelectBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; buffer: array of UInt32) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_SelectBuffer_ovr_0(size, buffer[0]) else
      z_SelectBuffer_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; var buffer: UInt32) :=
    z_SelectBuffer_ovr_0(size, buffer);
    private static procedure z_SelectBuffer_ovr_2(size: Int32; buffer: IntPtr);
    external 'opengl32.dll' name 'glSelectBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectBuffer(size: Int32; buffer: IntPtr) :=
    z_SelectBuffer_ovr_2(size, buffer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_ShadeModel_ovr_0(mode: ShadingModel);
    external 'opengl32.dll' name 'glShadeModel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadeModel(mode: ShadingModel) :=
    z_ShadeModel_ovr_0(mode);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1d_ovr_0(s: real);
    external 'opengl32.dll' name 'glTexCoord1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1d(s: real) :=
    z_TexCoord1d_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glTexCoord1dv';
    private static procedure z_TexCoord1dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord1dv_ovr_0(v[0]) else
      z_TexCoord1dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1dv(var v: real) :=
    z_TexCoord1dv_ovr_0(v);
    private static procedure z_TexCoord1dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1dv(v: IntPtr) :=
    z_TexCoord1dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1f_ovr_0(s: single);
    external 'opengl32.dll' name 'glTexCoord1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1f(s: single) :=
    z_TexCoord1f_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glTexCoord1fv';
    private static procedure z_TexCoord1fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord1fv_ovr_0(v[0]) else
      z_TexCoord1fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1fv(var v: single) :=
    z_TexCoord1fv_ovr_0(v);
    private static procedure z_TexCoord1fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1fv(v: IntPtr) :=
    z_TexCoord1fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1i_ovr_0(s: Int32);
    external 'opengl32.dll' name 'glTexCoord1i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1i(s: Int32) :=
    z_TexCoord1i_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glTexCoord1iv';
    private static procedure z_TexCoord1iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord1iv_ovr_0(v[0]) else
      z_TexCoord1iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1iv(var v: Int32) :=
    z_TexCoord1iv_ovr_0(v);
    private static procedure z_TexCoord1iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1iv(v: IntPtr) :=
    z_TexCoord1iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1s_ovr_0(s: Int16);
    external 'opengl32.dll' name 'glTexCoord1s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1s(s: Int16) :=
    z_TexCoord1s_ovr_0(s);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord1sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glTexCoord1sv';
    private static procedure z_TexCoord1sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord1sv_ovr_0(v[0]) else
      z_TexCoord1sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1sv(var v: Int16) :=
    z_TexCoord1sv_ovr_0(v);
    private static procedure z_TexCoord1sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1sv(v: IntPtr) :=
    z_TexCoord1sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2d_ovr_0(s: real; t: real);
    external 'opengl32.dll' name 'glTexCoord2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2d(s: real; t: real) :=
    z_TexCoord2d_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glTexCoord2dv';
    private static procedure z_TexCoord2dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2dv_ovr_0(v[0]) else
      z_TexCoord2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(var v: real) :=
    z_TexCoord2dv_ovr_0(v);
    private static procedure z_TexCoord2dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2dv(v: IntPtr) :=
    z_TexCoord2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2f_ovr_0(s: single; t: single);
    external 'opengl32.dll' name 'glTexCoord2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2f(s: single; t: single) :=
    z_TexCoord2f_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glTexCoord2fv';
    private static procedure z_TexCoord2fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2fv_ovr_0(v[0]) else
      z_TexCoord2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(var v: single) :=
    z_TexCoord2fv_ovr_0(v);
    private static procedure z_TexCoord2fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fv(v: IntPtr) :=
    z_TexCoord2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2i_ovr_0(s: Int32; t: Int32);
    external 'opengl32.dll' name 'glTexCoord2i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2i(s: Int32; t: Int32) :=
    z_TexCoord2i_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glTexCoord2iv';
    private static procedure z_TexCoord2iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2iv_ovr_0(v[0]) else
      z_TexCoord2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(var v: Int32) :=
    z_TexCoord2iv_ovr_0(v);
    private static procedure z_TexCoord2iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2iv(v: IntPtr) :=
    z_TexCoord2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2s_ovr_0(s: Int16; t: Int16);
    external 'opengl32.dll' name 'glTexCoord2s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2s(s: Int16; t: Int16) :=
    z_TexCoord2s_ovr_0(s, t);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord2sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glTexCoord2sv';
    private static procedure z_TexCoord2sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2sv_ovr_0(v[0]) else
      z_TexCoord2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(var v: Int16) :=
    z_TexCoord2sv_ovr_0(v);
    private static procedure z_TexCoord2sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2sv(v: IntPtr) :=
    z_TexCoord2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3d_ovr_0(s: real; t: real; r: real);
    external 'opengl32.dll' name 'glTexCoord3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3d(s: real; t: real; r: real) :=
    z_TexCoord3d_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glTexCoord3dv';
    private static procedure z_TexCoord3dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3dv_ovr_0(v[0]) else
      z_TexCoord3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(var v: real) :=
    z_TexCoord3dv_ovr_0(v);
    private static procedure z_TexCoord3dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3dv(v: IntPtr) :=
    z_TexCoord3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3f_ovr_0(s: single; t: single; r: single);
    external 'opengl32.dll' name 'glTexCoord3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3f(s: single; t: single; r: single) :=
    z_TexCoord3f_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glTexCoord3fv';
    private static procedure z_TexCoord3fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3fv_ovr_0(v[0]) else
      z_TexCoord3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(var v: single) :=
    z_TexCoord3fv_ovr_0(v);
    private static procedure z_TexCoord3fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3fv(v: IntPtr) :=
    z_TexCoord3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3i_ovr_0(s: Int32; t: Int32; r: Int32);
    external 'opengl32.dll' name 'glTexCoord3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3i(s: Int32; t: Int32; r: Int32) :=
    z_TexCoord3i_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glTexCoord3iv';
    private static procedure z_TexCoord3iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3iv_ovr_0(v[0]) else
      z_TexCoord3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(var v: Int32) :=
    z_TexCoord3iv_ovr_0(v);
    private static procedure z_TexCoord3iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3iv(v: IntPtr) :=
    z_TexCoord3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3s_ovr_0(s: Int16; t: Int16; r: Int16);
    external 'opengl32.dll' name 'glTexCoord3s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3s(s: Int16; t: Int16; r: Int16) :=
    z_TexCoord3s_ovr_0(s, t, r);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord3sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glTexCoord3sv';
    private static procedure z_TexCoord3sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3sv_ovr_0(v[0]) else
      z_TexCoord3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(var v: Int16) :=
    z_TexCoord3sv_ovr_0(v);
    private static procedure z_TexCoord3sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3sv(v: IntPtr) :=
    z_TexCoord3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4d_ovr_0(s: real; t: real; r: real; q: real);
    external 'opengl32.dll' name 'glTexCoord4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4d(s: real; t: real; r: real; q: real) :=
    z_TexCoord4d_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glTexCoord4dv';
    private static procedure z_TexCoord4dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4dv_ovr_0(v[0]) else
      z_TexCoord4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(var v: real) :=
    z_TexCoord4dv_ovr_0(v);
    private static procedure z_TexCoord4dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4dv(v: IntPtr) :=
    z_TexCoord4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4f_ovr_0(s: single; t: single; r: single; q: single);
    external 'opengl32.dll' name 'glTexCoord4f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4f(s: single; t: single; r: single; q: single) :=
    z_TexCoord4f_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glTexCoord4fv';
    private static procedure z_TexCoord4fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4fv_ovr_0(v[0]) else
      z_TexCoord4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(var v: single) :=
    z_TexCoord4fv_ovr_0(v);
    private static procedure z_TexCoord4fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fv(v: IntPtr) :=
    z_TexCoord4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4i_ovr_0(s: Int32; t: Int32; r: Int32; q: Int32);
    external 'opengl32.dll' name 'glTexCoord4i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4i(s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_TexCoord4i_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glTexCoord4iv';
    private static procedure z_TexCoord4iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4iv_ovr_0(v[0]) else
      z_TexCoord4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(var v: Int32) :=
    z_TexCoord4iv_ovr_0(v);
    private static procedure z_TexCoord4iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4iv(v: IntPtr) :=
    z_TexCoord4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4s_ovr_0(s: Int16; t: Int16; r: Int16; q: Int16);
    external 'opengl32.dll' name 'glTexCoord4s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4s(s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_TexCoord4s_ovr_0(s, t, r, q);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexCoord4sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glTexCoord4sv';
    private static procedure z_TexCoord4sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4sv_ovr_0(v[0]) else
      z_TexCoord4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(var v: Int16) :=
    z_TexCoord4sv_ovr_0(v);
    private static procedure z_TexCoord4sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4sv(v: IntPtr) :=
    z_TexCoord4sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_TexCoordPointer_ovr_0(size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glTexCoordPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointer(size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr) :=
    z_TexCoordPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexEnvf_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; param: single);
    external 'opengl32.dll' name 'glTexEnvf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvf(target: TextureEnvTarget; pname: TextureEnvParameter; param: single) :=
    z_TexEnvf_ovr_0(target, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexEnvfv_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single);
    external 'opengl32.dll' name 'glTexEnvfv';
    private static procedure z_TexEnvfv_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnvfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnvfv_ovr_0(target, pname, &params[0]) else
      z_TexEnvfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_TexEnvfv_ovr_0(target, pname, &params);
    private static procedure z_TexEnvfv_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnvfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvfv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnvfv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexEnvi_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32);
    external 'opengl32.dll' name 'glTexEnvi';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvi(target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32) :=
    z_TexEnvi_ovr_0(target, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexEnviv_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32);
    external 'opengl32.dll' name 'glTexEnviv';
    private static procedure z_TexEnviv_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnviv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnviv_ovr_0(target, pname, &params[0]) else
      z_TexEnviv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_TexEnviv_ovr_0(target, pname, &params);
    private static procedure z_TexEnviv_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnviv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnviv(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnviv_ovr_2(target, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGend_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; param: real);
    external 'opengl32.dll' name 'glTexGend';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGend(coord: TextureCoordName; pname: TextureGenParameter; param: real) :=
    z_TexGend_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGendv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: real);
    external 'opengl32.dll' name 'glTexGendv';
    private static procedure z_TexGendv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGendv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGendv_ovr_0(coord, pname, &params[0]) else
      z_TexGendv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_TexGendv_ovr_0(coord, pname, &params);
    private static procedure z_TexGendv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGendv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGendv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGendv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGenf_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; param: single);
    external 'opengl32.dll' name 'glTexGenf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenf(coord: TextureCoordName; pname: TextureGenParameter; param: single) :=
    z_TexGenf_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGenfv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: single);
    external 'opengl32.dll' name 'glTexGenfv';
    private static procedure z_TexGenfv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGenfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGenfv_ovr_0(coord, pname, &params[0]) else
      z_TexGenfv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_TexGenfv_ovr_0(coord, pname, &params);
    private static procedure z_TexGenfv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGenfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenfv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGenfv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGeni_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; param: Int32);
    external 'opengl32.dll' name 'glTexGeni';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeni(coord: TextureCoordName; pname: TextureGenParameter; param: Int32) :=
    z_TexGeni_ovr_0(coord, pname, param);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_TexGeniv_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32);
    external 'opengl32.dll' name 'glTexGeniv';
    private static procedure z_TexGeniv_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGeniv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGeniv_ovr_0(coord, pname, &params[0]) else
      z_TexGeniv_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_TexGeniv_ovr_0(coord, pname, &params);
    private static procedure z_TexGeniv_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGeniv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGeniv(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGeniv_ovr_2(coord, pname, &params);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Translated_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glTranslated';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Translated(x: real; y: real; z: real) :=
    z_Translated_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Translatef_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTranslatef';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Translatef(x: single; y: single; z: single) :=
    z_Translatef_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2d_ovr_0(x: real; y: real);
    external 'opengl32.dll' name 'glVertex2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2d(x: real; y: real) :=
    z_Vertex2d_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glVertex2dv';
    private static procedure z_Vertex2dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2dv_ovr_0(v[0]) else
      z_Vertex2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(var v: real) :=
    z_Vertex2dv_ovr_0(v);
    private static procedure z_Vertex2dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2dv(v: IntPtr) :=
    z_Vertex2dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2f_ovr_0(x: single; y: single);
    external 'opengl32.dll' name 'glVertex2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2f(x: single; y: single) :=
    z_Vertex2f_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glVertex2fv';
    private static procedure z_Vertex2fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2fv_ovr_0(v[0]) else
      z_Vertex2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(var v: single) :=
    z_Vertex2fv_ovr_0(v);
    private static procedure z_Vertex2fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2fv(v: IntPtr) :=
    z_Vertex2fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2i_ovr_0(x: Int32; y: Int32);
    external 'opengl32.dll' name 'glVertex2i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2i(x: Int32; y: Int32) :=
    z_Vertex2i_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glVertex2iv';
    private static procedure z_Vertex2iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2iv_ovr_0(v[0]) else
      z_Vertex2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(var v: Int32) :=
    z_Vertex2iv_ovr_0(v);
    private static procedure z_Vertex2iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2iv(v: IntPtr) :=
    z_Vertex2iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2s_ovr_0(x: Int16; y: Int16);
    external 'opengl32.dll' name 'glVertex2s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2s(x: Int16; y: Int16) :=
    z_Vertex2s_ovr_0(x, y);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex2sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glVertex2sv';
    private static procedure z_Vertex2sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2sv_ovr_0(v[0]) else
      z_Vertex2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(var v: Int16) :=
    z_Vertex2sv_ovr_0(v);
    private static procedure z_Vertex2sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2sv(v: IntPtr) :=
    z_Vertex2sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3d_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertex3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3d(x: real; y: real; z: real) :=
    z_Vertex3d_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glVertex3dv';
    private static procedure z_Vertex3dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3dv_ovr_0(v[0]) else
      z_Vertex3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(var v: real) :=
    z_Vertex3dv_ovr_0(v);
    private static procedure z_Vertex3dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3dv(v: IntPtr) :=
    z_Vertex3dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3f_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glVertex3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3f(x: single; y: single; z: single) :=
    z_Vertex3f_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glVertex3fv';
    private static procedure z_Vertex3fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3fv_ovr_0(v[0]) else
      z_Vertex3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(var v: single) :=
    z_Vertex3fv_ovr_0(v);
    private static procedure z_Vertex3fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3fv(v: IntPtr) :=
    z_Vertex3fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3i_ovr_0(x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glVertex3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3i(x: Int32; y: Int32; z: Int32) :=
    z_Vertex3i_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glVertex3iv';
    private static procedure z_Vertex3iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3iv_ovr_0(v[0]) else
      z_Vertex3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(var v: Int32) :=
    z_Vertex3iv_ovr_0(v);
    private static procedure z_Vertex3iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3iv(v: IntPtr) :=
    z_Vertex3iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3s_ovr_0(x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glVertex3s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3s(x: Int16; y: Int16; z: Int16) :=
    z_Vertex3s_ovr_0(x, y, z);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex3sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glVertex3sv';
    private static procedure z_Vertex3sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3sv_ovr_0(v[0]) else
      z_Vertex3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(var v: Int16) :=
    z_Vertex3sv_ovr_0(v);
    private static procedure z_Vertex3sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3sv(v: IntPtr) :=
    z_Vertex3sv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4d_ovr_0(x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertex4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4d(x: real; y: real; z: real; w: real) :=
    z_Vertex4d_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4dv_ovr_0(var v: real);
    external 'opengl32.dll' name 'glVertex4dv';
    private static procedure z_Vertex4dv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4dv_ovr_0(v[0]) else
      z_Vertex4dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(var v: real) :=
    z_Vertex4dv_ovr_0(v);
    private static procedure z_Vertex4dv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4dv(v: IntPtr) :=
    z_Vertex4dv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4f_ovr_0(x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glVertex4f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4f(x: single; y: single; z: single; w: single) :=
    z_Vertex4f_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4fv_ovr_0(var v: single);
    external 'opengl32.dll' name 'glVertex4fv';
    private static procedure z_Vertex4fv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4fv_ovr_0(v[0]) else
      z_Vertex4fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(var v: single) :=
    z_Vertex4fv_ovr_0(v);
    private static procedure z_Vertex4fv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4fv(v: IntPtr) :=
    z_Vertex4fv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4i_ovr_0(x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glVertex4i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4i(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_Vertex4i_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4iv_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glVertex4iv';
    private static procedure z_Vertex4iv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4iv_ovr_0(v[0]) else
      z_Vertex4iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(var v: Int32) :=
    z_Vertex4iv_ovr_0(v);
    private static procedure z_Vertex4iv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4iv(v: IntPtr) :=
    z_Vertex4iv_ovr_2(v);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4s_ovr_0(x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glVertex4s';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4s(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_Vertex4s_ovr_0(x, y, z, w);
    
    // added in gl1.0, deprecated in gl3.2
    private static procedure z_Vertex4sv_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glVertex4sv';
    private static procedure z_Vertex4sv_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4sv_ovr_0(v[0]) else
      z_Vertex4sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(var v: Int16) :=
    z_Vertex4sv_ovr_0(v);
    private static procedure z_Vertex4sv_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4sv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4sv(v: IntPtr) :=
    z_Vertex4sv_ovr_2(v);
    
    // added in gl1.1, deprecated in gl3.2
    private static procedure z_VertexPointer_ovr_0(size: Int32; &type: VertexPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointer(size: Int32; &type: VertexPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexPointer_ovr_0(size, &type, stride, pointer);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2d_adr := GetFuncAdr('glWindowPos2d');
    private z_WindowPos2d_ovr_0 := GetFuncOrNil&<procedure(x: real; y: real)>(z_WindowPos2d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2d(x: real; y: real) :=
    z_WindowPos2d_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2dv_adr := GetFuncAdr('glWindowPos2dv');
    private z_WindowPos2dv_ovr_0 := GetFuncOrNil&<procedure(var v: real)>(z_WindowPos2dv_adr);
    private z_WindowPos2dv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dv_ovr_0(v[0]) else
      z_WindowPos2dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(var v: real) :=
    z_WindowPos2dv_ovr_0(v);
    private z_WindowPos2dv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dv(v: IntPtr) :=
    z_WindowPos2dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2f_adr := GetFuncAdr('glWindowPos2f');
    private z_WindowPos2f_ovr_0 := GetFuncOrNil&<procedure(x: single; y: single)>(z_WindowPos2f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2f(x: single; y: single) :=
    z_WindowPos2f_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2fv_adr := GetFuncAdr('glWindowPos2fv');
    private z_WindowPos2fv_ovr_0 := GetFuncOrNil&<procedure(var v: single)>(z_WindowPos2fv_adr);
    private z_WindowPos2fv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fv_ovr_0(v[0]) else
      z_WindowPos2fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(var v: single) :=
    z_WindowPos2fv_ovr_0(v);
    private z_WindowPos2fv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fv(v: IntPtr) :=
    z_WindowPos2fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2i_adr := GetFuncAdr('glWindowPos2i');
    private z_WindowPos2i_ovr_0 := GetFuncOrNil&<procedure(x: Int32; y: Int32)>(z_WindowPos2i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2i(x: Int32; y: Int32) :=
    z_WindowPos2i_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2iv_adr := GetFuncAdr('glWindowPos2iv');
    private z_WindowPos2iv_ovr_0 := GetFuncOrNil&<procedure(var v: Int32)>(z_WindowPos2iv_adr);
    private z_WindowPos2iv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2iv_ovr_0(v[0]) else
      z_WindowPos2iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(var v: Int32) :=
    z_WindowPos2iv_ovr_0(v);
    private z_WindowPos2iv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iv(v: IntPtr) :=
    z_WindowPos2iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2s_adr := GetFuncAdr('glWindowPos2s');
    private z_WindowPos2s_ovr_0 := GetFuncOrNil&<procedure(x: Int16; y: Int16)>(z_WindowPos2s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2s(x: Int16; y: Int16) :=
    z_WindowPos2s_ovr_0(x, y);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos2sv_adr := GetFuncAdr('glWindowPos2sv');
    private z_WindowPos2sv_ovr_0 := GetFuncOrNil&<procedure(var v: Int16)>(z_WindowPos2sv_adr);
    private z_WindowPos2sv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2sv_ovr_0(v[0]) else
      z_WindowPos2sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(var v: Int16) :=
    z_WindowPos2sv_ovr_0(v);
    private z_WindowPos2sv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos2sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sv(v: IntPtr) :=
    z_WindowPos2sv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3d_adr := GetFuncAdr('glWindowPos3d');
    private z_WindowPos3d_ovr_0 := GetFuncOrNil&<procedure(x: real; y: real; z: real)>(z_WindowPos3d_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3d(x: real; y: real; z: real) :=
    z_WindowPos3d_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3dv_adr := GetFuncAdr('glWindowPos3dv');
    private z_WindowPos3dv_ovr_0 := GetFuncOrNil&<procedure(var v: real)>(z_WindowPos3dv_adr);
    private z_WindowPos3dv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dv_ovr_0(v[0]) else
      z_WindowPos3dv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(var v: real) :=
    z_WindowPos3dv_ovr_0(v);
    private z_WindowPos3dv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3dv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dv(v: IntPtr) :=
    z_WindowPos3dv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3f_adr := GetFuncAdr('glWindowPos3f');
    private z_WindowPos3f_ovr_0 := GetFuncOrNil&<procedure(x: single; y: single; z: single)>(z_WindowPos3f_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3f(x: single; y: single; z: single) :=
    z_WindowPos3f_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3fv_adr := GetFuncAdr('glWindowPos3fv');
    private z_WindowPos3fv_ovr_0 := GetFuncOrNil&<procedure(var v: single)>(z_WindowPos3fv_adr);
    private z_WindowPos3fv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fv_ovr_0(v[0]) else
      z_WindowPos3fv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(var v: single) :=
    z_WindowPos3fv_ovr_0(v);
    private z_WindowPos3fv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3fv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fv(v: IntPtr) :=
    z_WindowPos3fv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3i_adr := GetFuncAdr('glWindowPos3i');
    private z_WindowPos3i_ovr_0 := GetFuncOrNil&<procedure(x: Int32; y: Int32; z: Int32)>(z_WindowPos3i_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3i(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3i_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3iv_adr := GetFuncAdr('glWindowPos3iv');
    private z_WindowPos3iv_ovr_0 := GetFuncOrNil&<procedure(var v: Int32)>(z_WindowPos3iv_adr);
    private z_WindowPos3iv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3iv_ovr_0(v[0]) else
      z_WindowPos3iv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(var v: Int32) :=
    z_WindowPos3iv_ovr_0(v);
    private z_WindowPos3iv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3iv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iv(v: IntPtr) :=
    z_WindowPos3iv_ovr_2(v);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3s_adr := GetFuncAdr('glWindowPos3s');
    private z_WindowPos3s_ovr_0 := GetFuncOrNil&<procedure(x: Int16; y: Int16; z: Int16)>(z_WindowPos3s_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3s(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3s_ovr_0(x, y, z);
    
    // added in gl1.4, deprecated in gl3.2
    private z_WindowPos3sv_adr := GetFuncAdr('glWindowPos3sv');
    private z_WindowPos3sv_ovr_0 := GetFuncOrNil&<procedure(var v: Int16)>(z_WindowPos3sv_adr);
    private z_WindowPos3sv_ovr_0_anh01 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3sv_ovr_0(v[0]) else
      z_WindowPos3sv_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(var v: Int16) :=
    z_WindowPos3sv_ovr_0(v);
    private z_WindowPos3sv_ovr_2 := GetFuncOrNil&<procedure(v: IntPtr)>(z_WindowPos3sv_adr);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sv(v: IntPtr) :=
    z_WindowPos3sv_ovr_2(v);
    
  end;
  
  wgl = static class
    
    // added in wgl1.0
    private static function z_CopyContext_ovr_0(hglrcSrc: GLContext; hglrcDst: GLContext; mask: UInt32): UInt32;
    external 'opengl32.dll' name 'wglCopyContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CopyContext(hglrcSrc: GLContext; hglrcDst: GLContext; mask: UInt32): UInt32 :=
    z_CopyContext_ovr_0(hglrcSrc, hglrcDst, mask);
    
    // added in wgl1.0
    private static function z_CreateContext_ovr_0(hDc: GDI_DC): GLContext;
    external 'opengl32.dll' name 'wglCreateContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContext(hDc: GDI_DC): GLContext :=
    z_CreateContext_ovr_0(hDc);
    
    // added in wgl1.0
    private static function z_CreateLayerContext_ovr_0(hDc: GDI_DC; level: Int32): GLContext;
    external 'opengl32.dll' name 'wglCreateLayerContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateLayerContext(hDc: GDI_DC; level: Int32): GLContext :=
    z_CreateLayerContext_ovr_0(hDc, level);
    
    // added in wgl1.0
    private static function z_DeleteContext_ovr_0(oldContext: GLContext): UInt32;
    external 'opengl32.dll' name 'wglDeleteContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DeleteContext(oldContext: GLContext): UInt32 :=
    z_DeleteContext_ovr_0(oldContext);
    
    // added in wgl1.0
    private static function z_DescribeLayerPlane_ovr_0(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; var plpd: GDI_LayerPlaneDescriptor): UInt32;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    private static function z_DescribeLayerPlane_ovr_0_anh000001(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: array of GDI_LayerPlaneDescriptor): UInt32 :=
    if (plpd<>nil) and (plpd.Length<>0) then
      z_DescribeLayerPlane_ovr_0(hDc, pixelFormat, layerPlane, nBytes, plpd[0]) else
      z_DescribeLayerPlane_ovr_0_anh000001(hDc, pixelFormat, layerPlane, nBytes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; var plpd: GDI_LayerPlaneDescriptor): UInt32 :=
    z_DescribeLayerPlane_ovr_0(hDc, pixelFormat, layerPlane, nBytes, plpd);
    private static function z_DescribeLayerPlane_ovr_2(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDescribeLayerPlane';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribeLayerPlane(hDc: GDI_DC; pixelFormat: Int32; layerPlane: Int32; nBytes: UInt32; plpd: IntPtr): UInt32 :=
    z_DescribeLayerPlane_ovr_2(hDc, pixelFormat, layerPlane, nBytes, plpd);
    
    // added in wgl1.0
    private static function z_GetCurrentContext_ovr_0: GLContext;
    external 'opengl32.dll' name 'wglGetCurrentContext';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentContext: GLContext :=
    z_GetCurrentContext_ovr_0;
    
    // added in wgl1.0
    private static function z_GetCurrentDC_ovr_0: GDI_DC;
    external 'opengl32.dll' name 'wglGetCurrentDC';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentDC: GDI_DC :=
    z_GetCurrentDC_ovr_0;
    
    // added in wgl1.0
    private static function z_GetLayerPaletteEntries_ovr_0(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: GDI_COLORREF): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    private static function z_GetLayerPaletteEntries_ovr_0_anh000001(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: array of GDI_COLORREF): Int32 :=
    if (pcr<>nil) and (pcr.Length<>0) then
      z_GetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr[0]) else
      z_GetLayerPaletteEntries_ovr_0_anh000001(hdc, iLayerPlane, iStart, cEntries, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: GDI_COLORREF): Int32 :=
    z_GetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr);
    private static function z_GetLayerPaletteEntries_ovr_2(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglGetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32 :=
    z_GetLayerPaletteEntries_ovr_2(hdc, iLayerPlane, iStart, cEntries, pcr);
    
    // added in wgl1.0
    private static function z_GetProcAddress_ovr_0(lpszProc: IntPtr): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetProcAddress(lpszProc: IntPtr): IntPtr :=
    z_GetProcAddress_ovr_0(lpszProc);
    
    // added in wgl1.0
    private static function z_MakeCurrent_ovr_0(hDc: GDI_DC; newContext: GLContext): UInt32;
    external 'opengl32.dll' name 'wglMakeCurrent';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeCurrent(hDc: GDI_DC; newContext: GLContext): UInt32 :=
    z_MakeCurrent_ovr_0(hDc, newContext);
    
    // added in wgl1.0
    private static function z_RealizeLayerPalette_ovr_0(hdc: GDI_DC; iLayerPlane: Int32; bRealize: UInt32): UInt32;
    external 'opengl32.dll' name 'wglRealizeLayerPalette';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function RealizeLayerPalette(hdc: GDI_DC; iLayerPlane: Int32; bRealize: UInt32): UInt32 :=
    z_RealizeLayerPalette_ovr_0(hdc, iLayerPlane, bRealize);
    
    // added in wgl1.0
    private static function z_SetLayerPaletteEntries_ovr_0(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: GDI_COLORREF): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    private static function z_SetLayerPaletteEntries_ovr_0_anh000001(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: array of GDI_COLORREF): Int32 :=
    if (pcr<>nil) and (pcr.Length<>0) then
      z_SetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr[0]) else
      z_SetLayerPaletteEntries_ovr_0_anh000001(hdc, iLayerPlane, iStart, cEntries, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; var pcr: GDI_COLORREF): Int32 :=
    z_SetLayerPaletteEntries_ovr_0(hdc, iLayerPlane, iStart, cEntries, pcr);
    private static function z_SetLayerPaletteEntries_ovr_2(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32;
    external 'opengl32.dll' name 'wglSetLayerPaletteEntries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetLayerPaletteEntries(hdc: GDI_DC; iLayerPlane: Int32; iStart: Int32; cEntries: Int32; pcr: IntPtr): Int32 :=
    z_SetLayerPaletteEntries_ovr_2(hdc, iLayerPlane, iStart, cEntries, pcr);
    
    // added in wgl1.0
    private static function z_ShareLists_ovr_0(hrcSrvShare: GLContext; hrcSrvSource: GLContext): UInt32;
    external 'opengl32.dll' name 'wglShareLists';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ShareLists(hrcSrvShare: GLContext; hrcSrvSource: GLContext): UInt32 :=
    z_ShareLists_ovr_0(hrcSrvShare, hrcSrvSource);
    
    // added in wgl1.0
    private static function z_SwapLayerBuffers_ovr_0(hdc: GDI_DC; fuFlags: UInt32): UInt32;
    external 'opengl32.dll' name 'wglSwapLayerBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapLayerBuffers(hdc: GDI_DC; fuFlags: UInt32): UInt32 :=
    z_SwapLayerBuffers_ovr_0(hdc, fuFlags);
    
    // added in wgl1.0
    private static function z_UseFontBitmaps_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32;
    external 'opengl32.dll' name 'wglUseFontBitmaps';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmaps(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32 :=
    z_UseFontBitmaps_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontBitmapsA_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32;
    external 'opengl32.dll' name 'wglUseFontBitmapsA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmapsA(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32 :=
    z_UseFontBitmapsA_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontBitmapsW_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32;
    external 'opengl32.dll' name 'wglUseFontBitmapsW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontBitmapsW(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32): UInt32 :=
    z_UseFontBitmapsW_ovr_0(hDC, first, count, listBase);
    
    // added in wgl1.0
    private static function z_UseFontOutlines_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    private static function z_UseFontOutlines_ovr_0_anh000000001(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of GDI_GlyphmetricsFloat): UInt32 :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlines_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlines_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32 :=
    z_UseFontOutlines_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlines_ovr_2(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlines(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32 :=
    z_UseFontOutlines_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
    // added in wgl1.0
    private static function z_UseFontOutlinesA_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    private static function z_UseFontOutlinesA_ovr_0_anh000000001(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of GDI_GlyphmetricsFloat): UInt32 :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlinesA_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlinesA_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32 :=
    z_UseFontOutlinesA_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlinesA_ovr_2(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesA(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32 :=
    z_UseFontOutlinesA_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
    // added in wgl1.0
    private static function z_UseFontOutlinesW_ovr_0(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    private static function z_UseFontOutlinesW_ovr_0_anh000000001(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: array of GDI_GlyphmetricsFloat): UInt32 :=
    if (lpgmf<>nil) and (lpgmf.Length<>0) then
      z_UseFontOutlinesW_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf[0]) else
      z_UseFontOutlinesW_ovr_0_anh000000001(hDC, first, count, listBase, deviation, extrusion, format, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; var lpgmf: GDI_GlyphmetricsFloat): UInt32 :=
    z_UseFontOutlinesW_ovr_0(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    private static function z_UseFontOutlinesW_ovr_2(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglUseFontOutlinesW';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function UseFontOutlinesW(hDC: GDI_DC; first: UInt32; count: UInt32; listBase: UInt32; deviation: single; extrusion: single; format: Int32; lpgmf: IntPtr): UInt32 :=
    z_UseFontOutlinesW_ovr_2(hDC, first, count, listBase, deviation, extrusion, format, lpgmf);
    
  end;
  
  gdi = static class
    
    private static function z_ChoosePixelFormat_ovr_0(hDc: GDI_DC; var pPfd: GDI_PixelFormatDescriptor): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    private static function z_ChoosePixelFormat_ovr_0_anh001(hDc: GDI_DC; pPfd: IntPtr): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: GDI_DC; pPfd: array of GDI_PixelFormatDescriptor): Int32 :=
    if (pPfd<>nil) and (pPfd.Length<>0) then
      z_ChoosePixelFormat_ovr_0(hDc, pPfd[0]) else
      z_ChoosePixelFormat_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: GDI_DC; var pPfd: GDI_PixelFormatDescriptor): Int32 :=
    z_ChoosePixelFormat_ovr_0(hDc, pPfd);
    private static function z_ChoosePixelFormat_ovr_2(hDc: GDI_DC; pPfd: IntPtr): Int32;
    external 'gdi32.dll' name 'ChoosePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormat(hDc: GDI_DC; pPfd: IntPtr): Int32 :=
    z_ChoosePixelFormat_ovr_2(hDc, pPfd);
    
    private static function z_DescribePixelFormat_ovr_0(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; var ppfd: GDI_PixelFormatDescriptor): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    private static function z_DescribePixelFormat_ovr_0_anh00001(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; ppfd: array of GDI_PixelFormatDescriptor): Int32 :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_DescribePixelFormat_ovr_0(hdc, ipfd, cjpfd, ppfd[0]) else
      z_DescribePixelFormat_ovr_0_anh00001(hdc, ipfd, cjpfd, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; var ppfd: GDI_PixelFormatDescriptor): Int32 :=
    z_DescribePixelFormat_ovr_0(hdc, ipfd, cjpfd, ppfd);
    private static function z_DescribePixelFormat_ovr_2(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32;
    external 'gdi32.dll' name 'DescribePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DescribePixelFormat(hdc: GDI_DC; ipfd: Int32; cjpfd: UInt32; ppfd: IntPtr): Int32 :=
    z_DescribePixelFormat_ovr_2(hdc, ipfd, cjpfd, ppfd);
    
    private static function z_GetEnhMetaFilePixelFormat_ovr_0(hemf: GDI_HENHMetafile; var ppfd: GDI_PixelFormatDescriptor): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    private static function z_GetEnhMetaFilePixelFormat_ovr_0_anh001(hemf: GDI_HENHMetafile; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: GDI_HENHMetafile; ppfd: array of GDI_PixelFormatDescriptor): UInt32 :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_GetEnhMetaFilePixelFormat_ovr_0(hemf, ppfd[0]) else
      z_GetEnhMetaFilePixelFormat_ovr_0_anh001(hemf, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: GDI_HENHMetafile; var ppfd: GDI_PixelFormatDescriptor): UInt32 :=
    z_GetEnhMetaFilePixelFormat_ovr_0(hemf, ppfd);
    private static function z_GetEnhMetaFilePixelFormat_ovr_2(hemf: GDI_HENHMetafile; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'GetEnhMetaFilePixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetEnhMetaFilePixelFormat(hemf: GDI_HENHMetafile; ppfd: IntPtr): UInt32 :=
    z_GetEnhMetaFilePixelFormat_ovr_2(hemf, ppfd);
    
    private static function z_GetPixelFormat_ovr_0(hdc: GDI_DC): Int32;
    external 'gdi32.dll' name 'GetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormat(hdc: GDI_DC): Int32 :=
    z_GetPixelFormat_ovr_0(hdc);
    
    private static function z_SetPixelFormat_ovr_0(hdc: GDI_DC; ipfd: Int32; var ppfd: GDI_PixelFormatDescriptor): UInt32;
    external 'gdi32.dll' name 'SetPixelFormat';
    private static function z_SetPixelFormat_ovr_0_anh0001(hdc: GDI_DC; ipfd: Int32; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'SetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: GDI_DC; ipfd: Int32; ppfd: array of GDI_PixelFormatDescriptor): UInt32 :=
    if (ppfd<>nil) and (ppfd.Length<>0) then
      z_SetPixelFormat_ovr_0(hdc, ipfd, ppfd[0]) else
      z_SetPixelFormat_ovr_0_anh0001(hdc, ipfd, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: GDI_DC; ipfd: Int32; var ppfd: GDI_PixelFormatDescriptor): UInt32 :=
    z_SetPixelFormat_ovr_0(hdc, ipfd, ppfd);
    private static function z_SetPixelFormat_ovr_2(hdc: GDI_DC; ipfd: Int32; ppfd: IntPtr): UInt32;
    external 'gdi32.dll' name 'SetPixelFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPixelFormat(hdc: GDI_DC; ipfd: Int32; ppfd: IntPtr): UInt32 :=
    z_SetPixelFormat_ovr_2(hdc, ipfd, ppfd);
    
    private static function z_SwapBuffers_ovr_0(hdc: GDI_DC): UInt32;
    external 'gdi32.dll' name 'SwapBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapBuffers(hdc: GDI_DC): UInt32 :=
    z_SwapBuffers_ovr_0(hdc);
    
  end;
  
  {$region Extensions}
  
  glTbuffer3DFX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TbufferMask3DFX_ovr_0(mask: UInt32);
    external 'opengl32.dll' name 'glTbufferMask3DFX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TbufferMask3DFX(mask: UInt32) :=
    z_TbufferMask3DFX_ovr_0(mask);
    
  end;
  
  glDebugOutputAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DebugMessageEnableAMD_ovr_0(category: DummyEnum; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageEnableAMD';
    private static procedure z_DebugMessageEnableAMD_ovr_0_anh000010(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageEnableAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageEnableAMD_ovr_0(category, severity, count, ids[0], enabled) else
      z_DebugMessageEnableAMD_ovr_0_anh000010(category, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageEnableAMD_ovr_0(category, severity, count, ids, enabled);
    private static procedure z_DebugMessageEnableAMD_ovr_2(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageEnableAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageEnableAMD(category: DummyEnum; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageEnableAMD_ovr_2(category, severity, count, ids, enabled);
    
    private static procedure z_DebugMessageInsertAMD_ovr_0(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageInsertAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertAMD(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: string);
    begin
      var par_5_str_ptr := Marshal.StringToHGlobalAnsi(buf);
      z_DebugMessageInsertAMD_ovr_0(category, severity, id, length, par_5_str_ptr);
      Marshal.FreeHGlobal(par_5_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertAMD(category: DummyEnum; severity: DebugSeverity; id: UInt32; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsertAMD_ovr_0(category, severity, id, length, buf);
    
    private static procedure z_DebugMessageCallbackAMD_ovr_0(callback: GLDEBUGPROC; userParam: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageCallbackAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallbackAMD(callback: GLDEBUGPROC; userParam: IntPtr) :=
    z_DebugMessageCallbackAMD_ovr_0(callback, userParam);
    
    private static function z_GetDebugMessageLogAMD_ovr_0(count: UInt32; bufSize: Int32; var categories: DummyEnum; var severities: UInt32; var ids: UInt32; var lengths: Int32; message: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLogAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogAMD(count: UInt32; bufSize: Int32; var categories: DummyEnum; var severities: UInt32; var ids: UInt32; var lengths: Int32; message: IntPtr): UInt32 :=
    z_GetDebugMessageLogAMD_ovr_0(count, bufSize, categories, severities, ids, lengths, message);
    private static function z_GetDebugMessageLogAMD_ovr_1(count: UInt32; bufSize: Int32; categories: IntPtr; severities: IntPtr; ids: IntPtr; lengths: IntPtr; message: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLogAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogAMD(count: UInt32; bufSize: Int32; categories: IntPtr; severities: IntPtr; ids: IntPtr; lengths: IntPtr; message: IntPtr): UInt32 :=
    z_GetDebugMessageLogAMD_ovr_1(count, bufSize, categories, severities, ids, lengths, message);
    
  end;
  
  glDrawBuffersBlendAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendFuncIndexedAMD_ovr_0(buf: UInt32; src: DummyEnum; dst: DummyEnum);
    external 'opengl32.dll' name 'glBlendFuncIndexedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncIndexedAMD(buf: UInt32; src: DummyEnum; dst: DummyEnum) :=
    z_BlendFuncIndexedAMD_ovr_0(buf, src, dst);
    
    private static procedure z_BlendFuncSeparateIndexedAMD_ovr_0(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFuncSeparateIndexedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateIndexedAMD(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparateIndexedAMD_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
    private static procedure z_BlendEquationIndexedAMD_ovr_0(buf: UInt32; mode: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationIndexedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationIndexedAMD(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationIndexedAMD_ovr_0(buf, mode);
    
    private static procedure z_BlendEquationSeparateIndexedAMD_ovr_0(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationSeparateIndexedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateIndexedAMD(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateIndexedAMD_ovr_0(buf, modeRGB, modeAlpha);
    
  end;
  
  glFramebufferMultisampleAdvancedAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RenderbufferStorageMultisampleAdvancedAMD_ovr_0(target: RenderbufferTarget; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorageMultisampleAdvancedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleAdvancedAMD(target: RenderbufferTarget; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleAdvancedAMD_ovr_0(target, samples, storageSamples, _internalformat, width, height);
    
    private static procedure z_NamedRenderbufferStorageMultisampleAdvancedAMD_ovr_0(renderbuffer: UInt32; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorageMultisampleAdvancedAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleAdvancedAMD(renderbuffer: UInt32; samples: Int32; storageSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleAdvancedAMD_ovr_0(renderbuffer, samples, storageSamples, _internalformat, width, height);
    
  end;
  
  glFramebufferSamplePositionsAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferSamplePositionsfvAMD_ovr_0(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; var values: single);
    external 'opengl32.dll' name 'glFramebufferSamplePositionsfvAMD';
    private static procedure z_FramebufferSamplePositionsfvAMD_ovr_0_anh00001(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSamplePositionsfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_FramebufferSamplePositionsfvAMD_ovr_0(target, numsamples, pixelindex, values[0]) else
      z_FramebufferSamplePositionsfvAMD_ovr_0_anh00001(target, numsamples, pixelindex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; var values: single) :=
    z_FramebufferSamplePositionsfvAMD_ovr_0(target, numsamples, pixelindex, values);
    private static procedure z_FramebufferSamplePositionsfvAMD_ovr_2(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSamplePositionsfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSamplePositionsfvAMD(target: FramebufferTarget; numsamples: UInt32; pixelindex: UInt32; values: IntPtr) :=
    z_FramebufferSamplePositionsfvAMD_ovr_2(target, numsamples, pixelindex, values);
    
    private static procedure z_NamedFramebufferSamplePositionsfvAMD_ovr_0(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; var values: single);
    external 'opengl32.dll' name 'glNamedFramebufferSamplePositionsfvAMD';
    private static procedure z_NamedFramebufferSamplePositionsfvAMD_ovr_0_anh00001(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; values: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSamplePositionsfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_NamedFramebufferSamplePositionsfvAMD_ovr_0(framebuffer, numsamples, pixelindex, values[0]) else
      z_NamedFramebufferSamplePositionsfvAMD_ovr_0_anh00001(framebuffer, numsamples, pixelindex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; var values: single) :=
    z_NamedFramebufferSamplePositionsfvAMD_ovr_0(framebuffer, numsamples, pixelindex, values);
    private static procedure z_NamedFramebufferSamplePositionsfvAMD_ovr_2(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; values: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSamplePositionsfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSamplePositionsfvAMD(framebuffer: UInt32; numsamples: UInt32; pixelindex: UInt32; values: IntPtr) :=
    z_NamedFramebufferSamplePositionsfvAMD_ovr_2(framebuffer, numsamples, pixelindex, values);
    
    private static procedure z_GetFramebufferParameterfvAMD_ovr_0(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single);
    external 'opengl32.dll' name 'glGetFramebufferParameterfvAMD';
    private static procedure z_GetFramebufferParameterfvAMD_ovr_0_anh0000001(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetFramebufferParameterfvAMD_ovr_0(target, pname, numsamples, pixelindex, size, values[0]) else
      z_GetFramebufferParameterfvAMD_ovr_0_anh0000001(target, pname, numsamples, pixelindex, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single) :=
    z_GetFramebufferParameterfvAMD_ovr_0(target, pname, numsamples, pixelindex, size, values);
    private static procedure z_GetFramebufferParameterfvAMD_ovr_2(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterfvAMD(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr) :=
    z_GetFramebufferParameterfvAMD_ovr_2(target, pname, numsamples, pixelindex, size, values);
    
    private static procedure z_GetNamedFramebufferParameterfvAMD_ovr_0(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterfvAMD';
    private static procedure z_GetNamedFramebufferParameterfvAMD_ovr_0_anh0000001(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetNamedFramebufferParameterfvAMD_ovr_0(framebuffer, pname, numsamples, pixelindex, size, values[0]) else
      z_GetNamedFramebufferParameterfvAMD_ovr_0_anh0000001(framebuffer, pname, numsamples, pixelindex, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; var values: single) :=
    z_GetNamedFramebufferParameterfvAMD_ovr_0(framebuffer, pname, numsamples, pixelindex, size, values);
    private static procedure z_GetNamedFramebufferParameterfvAMD_ovr_2(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterfvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterfvAMD(framebuffer: UInt32; pname: DummyEnum; numsamples: UInt32; pixelindex: UInt32; size: Int32; values: IntPtr) :=
    z_GetNamedFramebufferParameterfvAMD_ovr_2(framebuffer, pname, numsamples, pixelindex, size, values);
    
  end;
  
  glGpuShaderInt64AMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Uniform1i64NV_ovr_0(location: Int32; x: Int64);
    external 'opengl32.dll' name 'glUniform1i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64NV(location: Int32; x: Int64) :=
    z_Uniform1i64NV_ovr_0(location, x);
    
    private static procedure z_Uniform2i64NV_ovr_0(location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glUniform2i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64NV(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64NV_ovr_0(location, x, y);
    
    private static procedure z_Uniform3i64NV_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glUniform3i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64NV(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64NV_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4i64NV_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glUniform4i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64NV(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64NV_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    private static procedure z_Uniform1i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform1i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform2i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    private static procedure z_Uniform2i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform2i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform3i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    private static procedure z_Uniform3i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform3i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform4i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    private static procedure z_Uniform4i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform4i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform1ui64NV_ovr_0(location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64NV(location: Int32; x: UInt64) :=
    z_Uniform1ui64NV_ovr_0(location, x);
    
    private static procedure z_Uniform2ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64NV(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64NV_ovr_0(location, x, y);
    
    private static procedure z_Uniform3ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64NV_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64NV_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    private static procedure z_Uniform1ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform1ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform2ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    private static procedure z_Uniform2ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform2ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform3ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    private static procedure z_Uniform3ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform3ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform4ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    private static procedure z_Uniform4ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform4ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_GetUniformi64vNV_ovr_0(&program: UInt32; location: Int32; var &params: Int64);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    private static procedure z_GetUniformi64vNV_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; var &params: Int64) :=
    z_GetUniformi64vNV_ovr_0(&program, location, &params);
    private static procedure z_GetUniformi64vNV_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vNV_ovr_2(&program, location, &params);
    
    private static procedure z_GetUniformui64vNV_ovr_0(&program: UInt32; location: Int32; var &params: UInt64);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    private static procedure z_GetUniformui64vNV_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vNV_ovr_0(&program, location, &params);
    private static procedure z_GetUniformui64vNV_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vNV_ovr_2(&program, location, &params);
    
    private static procedure z_ProgramUniform1i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64NV(&program: UInt32; location: Int32; x: Int64) :=
    z_ProgramUniform1i64NV_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64NV_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64NV_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64NV_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    private static procedure z_ProgramUniform1i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    private static procedure z_ProgramUniform2i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    private static procedure z_ProgramUniform3i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    private static procedure z_ProgramUniform4i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64NV(&program: UInt32; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64NV_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64NV_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64NV_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64NV_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    private static procedure z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    private static procedure z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    private static procedure z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    private static procedure z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  glInterleavedElementsAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribParameteriAMD_ovr_0(index: UInt32; pname: DummyEnum; param: Int32);
    external 'opengl32.dll' name 'glVertexAttribParameteriAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribParameteriAMD(index: UInt32; pname: DummyEnum; param: Int32) :=
    z_VertexAttribParameteriAMD_ovr_0(index, pname, param);
    
  end;
  
  glMultiDrawIndirectAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysIndirectAMD_ovr_0(mode: PrimitiveType; indirect: IntPtr; primcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysIndirectAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectAMD(mode: PrimitiveType; indirect: IntPtr; primcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectAMD_ovr_0(mode, indirect, primcount, stride);
    
    private static procedure z_MultiDrawElementsIndirectAMD_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; primcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsIndirectAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectAMD(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; primcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectAMD_ovr_0(mode, &type, indirect, primcount, stride);
    
  end;
  
  glNameGenDeleteAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenNamesAMD_ovr_0(identifier: DummyEnum; num: UInt32; var names: UInt32);
    external 'opengl32.dll' name 'glGenNamesAMD';
    private static procedure z_GenNamesAMD_ovr_0_anh0001(identifier: DummyEnum; num: UInt32; names: IntPtr);
    external 'opengl32.dll' name 'glGenNamesAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; names: array of UInt32) :=
    if (names<>nil) and (names.Length<>0) then
      z_GenNamesAMD_ovr_0(identifier, num, names[0]) else
      z_GenNamesAMD_ovr_0_anh0001(identifier, num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; var names: UInt32) :=
    z_GenNamesAMD_ovr_0(identifier, num, names);
    private static procedure z_GenNamesAMD_ovr_2(identifier: DummyEnum; num: UInt32; names: IntPtr);
    external 'opengl32.dll' name 'glGenNamesAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenNamesAMD(identifier: DummyEnum; num: UInt32; names: IntPtr) :=
    z_GenNamesAMD_ovr_2(identifier, num, names);
    
    private static procedure z_DeleteNamesAMD_ovr_0(identifier: DummyEnum; num: UInt32; var names: UInt32);
    external 'opengl32.dll' name 'glDeleteNamesAMD';
    private static procedure z_DeleteNamesAMD_ovr_0_anh0001(identifier: DummyEnum; num: UInt32; names: IntPtr);
    external 'opengl32.dll' name 'glDeleteNamesAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; names: array of UInt32) :=
    if (names<>nil) and (names.Length<>0) then
      z_DeleteNamesAMD_ovr_0(identifier, num, names[0]) else
      z_DeleteNamesAMD_ovr_0_anh0001(identifier, num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; var names: UInt32) :=
    z_DeleteNamesAMD_ovr_0(identifier, num, names);
    private static procedure z_DeleteNamesAMD_ovr_2(identifier: DummyEnum; num: UInt32; names: IntPtr);
    external 'opengl32.dll' name 'glDeleteNamesAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamesAMD(identifier: DummyEnum; num: UInt32; names: IntPtr) :=
    z_DeleteNamesAMD_ovr_2(identifier, num, names);
    
    private static function z_IsNameAMD_ovr_0(identifier: DummyEnum; name: UInt32): boolean;
    external 'opengl32.dll' name 'glIsNameAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNameAMD(identifier: DummyEnum; name: UInt32): boolean :=
    z_IsNameAMD_ovr_0(identifier, name);
    
  end;
  
  glOcclusionQueryEventAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_QueryObjectParameteruiAMD_ovr_0(target: QueryTarget; id: UInt32; pname: DummyEnum; param: UInt32);
    external 'opengl32.dll' name 'glQueryObjectParameteruiAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryObjectParameteruiAMD(target: QueryTarget; id: UInt32; pname: DummyEnum; param: UInt32) :=
    z_QueryObjectParameteruiAMD_ovr_0(target, id, pname, param);
    
  end;
  
  glPerformanceMonitorAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_0(var numGroups: Int32; groupsSize: Int32; var groups: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_0_anh0100(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_0_anh0001(var numGroups: Int32; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_0_anh0101(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: array of Int32; groupsSize: Int32; groups: array of UInt32) :=
    if (numGroups<>nil) and (numGroups.Length<>0) then
      if (groups<>nil) and (groups.Length<>0) then
        z_GetPerfMonitorGroupsAMD_ovr_0(numGroups[0], groupsSize, groups[0]) else
        z_GetPerfMonitorGroupsAMD_ovr_0_anh0001(numGroups[0], groupsSize, IntPtr.Zero) else
      if (groups<>nil) and (groups.Length<>0) then
        z_GetPerfMonitorGroupsAMD_ovr_0_anh0100(IntPtr.Zero, groupsSize, groups[0]) else
        z_GetPerfMonitorGroupsAMD_ovr_0_anh0101(IntPtr.Zero, groupsSize, IntPtr.Zero);
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_1_anh0100(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: array of Int32; groupsSize: Int32; var groups: UInt32) :=
    if (numGroups<>nil) and (numGroups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_0(numGroups[0], groupsSize, groups) else
      z_GetPerfMonitorGroupsAMD_ovr_0_anh0100(IntPtr.Zero, groupsSize, groups);
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_2(var numGroups: Int32; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_2_anh0100(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: array of Int32; groupsSize: Int32; groups: IntPtr) :=
    if (numGroups<>nil) and (numGroups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_2(numGroups[0], groupsSize, groups) else
      z_GetPerfMonitorGroupsAMD_ovr_2_anh0100(IntPtr.Zero, groupsSize, groups);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; groups: array of UInt32) :=
    if (groups<>nil) and (groups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_0(numGroups, groupsSize, groups[0]) else
      z_GetPerfMonitorGroupsAMD_ovr_0_anh0001(numGroups, groupsSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; var groups: UInt32) :=
    z_GetPerfMonitorGroupsAMD_ovr_0(numGroups, groupsSize, groups);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(var numGroups: Int32; groupsSize: Int32; groups: IntPtr) :=
    z_GetPerfMonitorGroupsAMD_ovr_2(numGroups, groupsSize, groups);
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_6(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_6_anh0001(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; groups: array of UInt32) :=
    if (groups<>nil) and (groups.Length<>0) then
      z_GetPerfMonitorGroupsAMD_ovr_6(numGroups, groupsSize, groups[0]) else
      z_GetPerfMonitorGroupsAMD_ovr_6_anh0001(numGroups, groupsSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; var groups: UInt32) :=
    z_GetPerfMonitorGroupsAMD_ovr_6(numGroups, groupsSize, groups);
    private static procedure z_GetPerfMonitorGroupsAMD_ovr_8(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupsAMD(numGroups: IntPtr; groupsSize: Int32; groups: IntPtr) :=
    z_GetPerfMonitorGroupsAMD_ovr_8(numGroups, groupsSize, groups);
    
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh000100(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh001100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh001001(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh000101(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_0_anh001101(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: array of Int32; counterSize: Int32; counters: array of UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        if (counters<>nil) and (counters.Length<>0) then
          z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters[0], maxActiveCounters[0], counterSize, counters[0]) else
          z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group, numCounters[0], maxActiveCounters[0], counterSize, IntPtr.Zero) else
        if (counters<>nil) and (counters.Length<>0) then
          z_GetPerfMonitorCountersAMD_ovr_0_anh000100(group, numCounters[0], IntPtr.Zero, counterSize, counters[0]) else
          z_GetPerfMonitorCountersAMD_ovr_0_anh000101(group, numCounters[0], IntPtr.Zero, counterSize, IntPtr.Zero) else
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        if (counters<>nil) and (counters.Length<>0) then
          z_GetPerfMonitorCountersAMD_ovr_0_anh001000(group, IntPtr.Zero, maxActiveCounters[0], counterSize, counters[0]) else
          z_GetPerfMonitorCountersAMD_ovr_0_anh001001(group, IntPtr.Zero, maxActiveCounters[0], counterSize, IntPtr.Zero) else
        if (counters<>nil) and (counters.Length<>0) then
          z_GetPerfMonitorCountersAMD_ovr_0_anh001100(group, IntPtr.Zero, IntPtr.Zero, counterSize, counters[0]) else
          z_GetPerfMonitorCountersAMD_ovr_0_anh001101(group, IntPtr.Zero, IntPtr.Zero, counterSize, IntPtr.Zero);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_1_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_1_anh000100(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_1_anh001100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: array of Int32; counterSize: Int32; var counters: UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters[0], maxActiveCounters[0], counterSize, counters) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh000100(group, numCounters[0], IntPtr.Zero, counterSize, counters) else
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0_anh001000(group, IntPtr.Zero, maxActiveCounters[0], counterSize, counters) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh001100(group, IntPtr.Zero, IntPtr.Zero, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_2(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_2_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_2_anh000100(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_2_anh001100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: array of Int32; counterSize: Int32; counters: IntPtr) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_2(group, numCounters[0], maxActiveCounters[0], counterSize, counters) else
        z_GetPerfMonitorCountersAMD_ovr_2_anh000100(group, numCounters[0], IntPtr.Zero, counterSize, counters) else
      if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_2_anh001000(group, IntPtr.Zero, maxActiveCounters[0], counterSize, counters) else
        z_GetPerfMonitorCountersAMD_ovr_2_anh001100(group, IntPtr.Zero, IntPtr.Zero, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_3_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_3_anh001001(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: array of UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters[0], maxActiveCounters, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group, numCounters[0], maxActiveCounters, counterSize, IntPtr.Zero) else
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh001001(group, IntPtr.Zero, maxActiveCounters, counterSize, IntPtr.Zero);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_4_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters[0], maxActiveCounters, counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_0_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_5_anh001000(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_2(group, numCounters[0], maxActiveCounters, counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_2_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_6(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_6_anh001000(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_6_anh000001(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_6_anh001001(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: array of UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters[0], maxActiveCounters, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_6_anh000001(group, numCounters[0], maxActiveCounters, counterSize, IntPtr.Zero) else
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_6_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_6_anh001001(group, IntPtr.Zero, maxActiveCounters, counterSize, IntPtr.Zero);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_7_anh001000(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters[0], maxActiveCounters, counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_6_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_8(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_8_anh001000(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: array of Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr) :=
    if (numCounters<>nil) and (numCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_8(group, numCounters[0], maxActiveCounters, counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_8_anh001000(group, IntPtr.Zero, maxActiveCounters, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: array of Int32; counterSize: Int32; counters: array of UInt32) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters[0], counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group, numCounters, maxActiveCounters[0], counterSize, IntPtr.Zero) else
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_0_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_0_anh000101(group, numCounters, IntPtr.Zero, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: array of Int32; counterSize: Int32; var counters: UInt32) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters[0], counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_0_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: array of Int32; counterSize: Int32; counters: IntPtr) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_2(group, numCounters, maxActiveCounters[0], counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_2_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_0_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_0(group, numCounters, maxActiveCounters, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_2(group, numCounters, maxActiveCounters, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_6_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_6(group, numCounters, maxActiveCounters, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; var numCounters: Int32; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_8(group, numCounters, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_18(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_18_anh000100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_18_anh000001(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_18_anh000101(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: array of Int32; counterSize: Int32; counters: array of UInt32) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_18(group, numCounters, maxActiveCounters[0], counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_18_anh000001(group, numCounters, maxActiveCounters[0], counterSize, IntPtr.Zero) else
      if (counters<>nil) and (counters.Length<>0) then
        z_GetPerfMonitorCountersAMD_ovr_18_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters[0]) else
        z_GetPerfMonitorCountersAMD_ovr_18_anh000101(group, numCounters, IntPtr.Zero, counterSize, IntPtr.Zero);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_19_anh000100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: array of Int32; counterSize: Int32; var counters: UInt32) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_18(group, numCounters, maxActiveCounters[0], counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_18_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_20(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_20_anh000100(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: array of Int32; counterSize: Int32; counters: IntPtr) :=
    if (maxActiveCounters<>nil) and (maxActiveCounters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_20(group, numCounters, maxActiveCounters[0], counterSize, counters) else
      z_GetPerfMonitorCountersAMD_ovr_20_anh000100(group, numCounters, IntPtr.Zero, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_18(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_18_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_18(group, numCounters, maxActiveCounters, counterSize, counters);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; var maxActiveCounters: Int32; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_20(group, numCounters, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_24(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    private static procedure z_GetPerfMonitorCountersAMD_ovr_24_anh000001(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: array of UInt32) :=
    if (counters<>nil) and (counters.Length<>0) then
      z_GetPerfMonitorCountersAMD_ovr_24(group, numCounters, maxActiveCounters, counterSize, counters[0]) else
      z_GetPerfMonitorCountersAMD_ovr_24_anh000001(group, numCounters, maxActiveCounters, counterSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; var counters: UInt32) :=
    z_GetPerfMonitorCountersAMD_ovr_24(group, numCounters, maxActiveCounters, counterSize, counters);
    private static procedure z_GetPerfMonitorCountersAMD_ovr_26(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCountersAMD(group: UInt32; numCounters: IntPtr; maxActiveCounters: IntPtr; counterSize: Int32; counters: IntPtr) :=
    z_GetPerfMonitorCountersAMD_ovr_26(group, numCounters, maxActiveCounters, counterSize, counters);
    
    private static procedure z_GetPerfMonitorGroupStringAMD_ovr_0(group: UInt32; bufSize: Int32; var length: Int32; groupString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupStringAMD';
    private static procedure z_GetPerfMonitorGroupStringAMD_ovr_0_anh00010(group: UInt32; bufSize: Int32; length: IntPtr; groupString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupStringAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupStringAMD(group: UInt32; bufSize: Int32; length: array of Int32; groupString: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetPerfMonitorGroupStringAMD_ovr_0(group, bufSize, length[0], groupString) else
      z_GetPerfMonitorGroupStringAMD_ovr_0_anh00010(group, bufSize, IntPtr.Zero, groupString);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupStringAMD(group: UInt32; bufSize: Int32; var length: Int32; groupString: IntPtr) :=
    z_GetPerfMonitorGroupStringAMD_ovr_0(group, bufSize, length, groupString);
    private static procedure z_GetPerfMonitorGroupStringAMD_ovr_2(group: UInt32; bufSize: Int32; length: IntPtr; groupString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorGroupStringAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorGroupStringAMD(group: UInt32; bufSize: Int32; length: IntPtr; groupString: IntPtr) :=
    z_GetPerfMonitorGroupStringAMD_ovr_2(group, bufSize, length, groupString);
    
    private static procedure z_GetPerfMonitorCounterStringAMD_ovr_0(group: UInt32; counter: UInt32; bufSize: Int32; var length: Int32; counterString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterStringAMD';
    private static procedure z_GetPerfMonitorCounterStringAMD_ovr_0_anh000010(group: UInt32; counter: UInt32; bufSize: Int32; length: IntPtr; counterString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterStringAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterStringAMD(group: UInt32; counter: UInt32; bufSize: Int32; length: array of Int32; counterString: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetPerfMonitorCounterStringAMD_ovr_0(group, counter, bufSize, length[0], counterString) else
      z_GetPerfMonitorCounterStringAMD_ovr_0_anh000010(group, counter, bufSize, IntPtr.Zero, counterString);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterStringAMD(group: UInt32; counter: UInt32; bufSize: Int32; var length: Int32; counterString: IntPtr) :=
    z_GetPerfMonitorCounterStringAMD_ovr_0(group, counter, bufSize, length, counterString);
    private static procedure z_GetPerfMonitorCounterStringAMD_ovr_2(group: UInt32; counter: UInt32; bufSize: Int32; length: IntPtr; counterString: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterStringAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterStringAMD(group: UInt32; counter: UInt32; bufSize: Int32; length: IntPtr; counterString: IntPtr) :=
    z_GetPerfMonitorCounterStringAMD_ovr_2(group, counter, bufSize, length, counterString);
    
    private static procedure z_GetPerfMonitorCounterInfoAMD_ovr_0(group: UInt32; counter: UInt32; pname: DummyEnum; data: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterInfoAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterInfoAMD(group: UInt32; counter: UInt32; pname: DummyEnum; data: IntPtr) :=
    z_GetPerfMonitorCounterInfoAMD_ovr_0(group, counter, pname, data);
    
    private static procedure z_GenPerfMonitorsAMD_ovr_0(n: Int32; var monitors: UInt32);
    external 'opengl32.dll' name 'glGenPerfMonitorsAMD';
    private static procedure z_GenPerfMonitorsAMD_ovr_0_anh001(n: Int32; monitors: IntPtr);
    external 'opengl32.dll' name 'glGenPerfMonitorsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; monitors: array of UInt32) :=
    if (monitors<>nil) and (monitors.Length<>0) then
      z_GenPerfMonitorsAMD_ovr_0(n, monitors[0]) else
      z_GenPerfMonitorsAMD_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; var monitors: UInt32) :=
    z_GenPerfMonitorsAMD_ovr_0(n, monitors);
    private static procedure z_GenPerfMonitorsAMD_ovr_2(n: Int32; monitors: IntPtr);
    external 'opengl32.dll' name 'glGenPerfMonitorsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenPerfMonitorsAMD(n: Int32; monitors: IntPtr) :=
    z_GenPerfMonitorsAMD_ovr_2(n, monitors);
    
    private static procedure z_DeletePerfMonitorsAMD_ovr_0(n: Int32; var monitors: UInt32);
    external 'opengl32.dll' name 'glDeletePerfMonitorsAMD';
    private static procedure z_DeletePerfMonitorsAMD_ovr_0_anh001(n: Int32; monitors: IntPtr);
    external 'opengl32.dll' name 'glDeletePerfMonitorsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; monitors: array of UInt32) :=
    if (monitors<>nil) and (monitors.Length<>0) then
      z_DeletePerfMonitorsAMD_ovr_0(n, monitors[0]) else
      z_DeletePerfMonitorsAMD_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; var monitors: UInt32) :=
    z_DeletePerfMonitorsAMD_ovr_0(n, monitors);
    private static procedure z_DeletePerfMonitorsAMD_ovr_2(n: Int32; monitors: IntPtr);
    external 'opengl32.dll' name 'glDeletePerfMonitorsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfMonitorsAMD(n: Int32; monitors: IntPtr) :=
    z_DeletePerfMonitorsAMD_ovr_2(n, monitors);
    
    private static procedure z_SelectPerfMonitorCountersAMD_ovr_0(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; var counterList: UInt32);
    external 'opengl32.dll' name 'glSelectPerfMonitorCountersAMD';
    private static procedure z_SelectPerfMonitorCountersAMD_ovr_0_anh000001(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr);
    external 'opengl32.dll' name 'glSelectPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: array of UInt32) :=
    if (counterList<>nil) and (counterList.Length<>0) then
      z_SelectPerfMonitorCountersAMD_ovr_0(monitor, enable, group, numCounters, counterList[0]) else
      z_SelectPerfMonitorCountersAMD_ovr_0_anh000001(monitor, enable, group, numCounters, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; var counterList: UInt32) :=
    z_SelectPerfMonitorCountersAMD_ovr_0(monitor, enable, group, numCounters, counterList);
    private static procedure z_SelectPerfMonitorCountersAMD_ovr_2(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr);
    external 'opengl32.dll' name 'glSelectPerfMonitorCountersAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SelectPerfMonitorCountersAMD(monitor: UInt32; enable: boolean; group: UInt32; numCounters: Int32; counterList: IntPtr) :=
    z_SelectPerfMonitorCountersAMD_ovr_2(monitor, enable, group, numCounters, counterList);
    
    private static procedure z_BeginPerfMonitorAMD_ovr_0(monitor: UInt32);
    external 'opengl32.dll' name 'glBeginPerfMonitorAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginPerfMonitorAMD(monitor: UInt32) :=
    z_BeginPerfMonitorAMD_ovr_0(monitor);
    
    private static procedure z_EndPerfMonitorAMD_ovr_0(monitor: UInt32);
    external 'opengl32.dll' name 'glEndPerfMonitorAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndPerfMonitorAMD(monitor: UInt32) :=
    z_EndPerfMonitorAMD_ovr_0(monitor);
    
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_0(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; var bytesWritten: Int32);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_0_anh000010(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_0_anh000001(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_0_anh000011(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: array of UInt32; bytesWritten: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      if (bytesWritten<>nil) and (bytesWritten.Length<>0) then
        z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data[0], bytesWritten[0]) else
        z_GetPerfMonitorCounterDataAMD_ovr_0_anh000001(monitor, pname, dataSize, data[0], IntPtr.Zero) else
      if (bytesWritten<>nil) and (bytesWritten.Length<>0) then
        z_GetPerfMonitorCounterDataAMD_ovr_0_anh000010(monitor, pname, dataSize, IntPtr.Zero, bytesWritten[0]) else
        z_GetPerfMonitorCounterDataAMD_ovr_0_anh000011(monitor, pname, dataSize, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_1_anh000010(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: array of UInt32; var bytesWritten: Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data[0], bytesWritten) else
      z_GetPerfMonitorCounterDataAMD_ovr_0_anh000010(monitor, pname, dataSize, IntPtr.Zero, bytesWritten);
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_2(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_2_anh000010(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: array of UInt32; bytesWritten: IntPtr) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_2(monitor, pname, dataSize, data[0], bytesWritten) else
      z_GetPerfMonitorCounterDataAMD_ovr_2_anh000010(monitor, pname, dataSize, IntPtr.Zero, bytesWritten);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: array of Int32) :=
    if (bytesWritten<>nil) and (bytesWritten.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data, bytesWritten[0]) else
      z_GetPerfMonitorCounterDataAMD_ovr_0_anh000001(monitor, pname, dataSize, data, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; var bytesWritten: Int32) :=
    z_GetPerfMonitorCounterDataAMD_ovr_0(monitor, pname, dataSize, data, bytesWritten);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; var data: UInt32; bytesWritten: IntPtr) :=
    z_GetPerfMonitorCounterDataAMD_ovr_2(monitor, pname, dataSize, data, bytesWritten);
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_6(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_6_anh000001(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: array of Int32) :=
    if (bytesWritten<>nil) and (bytesWritten.Length<>0) then
      z_GetPerfMonitorCounterDataAMD_ovr_6(monitor, pname, dataSize, data, bytesWritten[0]) else
      z_GetPerfMonitorCounterDataAMD_ovr_6_anh000001(monitor, pname, dataSize, data, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; var bytesWritten: Int32) :=
    z_GetPerfMonitorCounterDataAMD_ovr_6(monitor, pname, dataSize, data, bytesWritten);
    private static procedure z_GetPerfMonitorCounterDataAMD_ovr_8(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfMonitorCounterDataAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfMonitorCounterDataAMD(monitor: UInt32; pname: DummyEnum; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr) :=
    z_GetPerfMonitorCounterDataAMD_ovr_8(monitor, pname, dataSize, data, bytesWritten);
    
  end;
  
  glSamplePositionsAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SetMultisamplefvAMD_ovr_0(pname: DummyEnum; index: UInt32; var val: single);
    external 'opengl32.dll' name 'glSetMultisamplefvAMD';
    private static procedure z_SetMultisamplefvAMD_ovr_0_anh0001(pname: DummyEnum; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glSetMultisamplefvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_SetMultisamplefvAMD_ovr_0(pname, index, val[0]) else
      z_SetMultisamplefvAMD_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; var val: single) :=
    z_SetMultisamplefvAMD_ovr_0(pname, index, val);
    private static procedure z_SetMultisamplefvAMD_ovr_2(pname: DummyEnum; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glSetMultisamplefvAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetMultisamplefvAMD(pname: DummyEnum; index: UInt32; val: IntPtr) :=
    z_SetMultisamplefvAMD_ovr_2(pname, index, val);
    
  end;
  
  glSparseTextureAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexStorageSparseAMD_ovr_0(target: TextureTarget; _internalFormat: InternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD);
    external 'opengl32.dll' name 'glTexStorageSparseAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageSparseAMD(target: TextureTarget; _internalFormat: InternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD) :=
    z_TexStorageSparseAMD_ovr_0(target, _internalFormat, width, height, depth, layers, flags);
    
    private static procedure z_TextureStorageSparseAMD_ovr_0(texture: UInt32; target: DummyEnum; _internalFormat: InternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD);
    external 'opengl32.dll' name 'glTextureStorageSparseAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageSparseAMD(texture: UInt32; target: DummyEnum; _internalFormat: InternalFormat; width: Int32; height: Int32; depth: Int32; layers: Int32; flags: TextureStorageMaskAMD) :=
    z_TextureStorageSparseAMD_ovr_0(texture, target, _internalFormat, width, height, depth, layers, flags);
    
  end;
  
  glStencilOperationExtendedAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_StencilOpValueAMD_ovr_0(face: StencilFaceDirection; value: UInt32);
    external 'opengl32.dll' name 'glStencilOpValueAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpValueAMD(face: StencilFaceDirection; value: UInt32) :=
    z_StencilOpValueAMD_ovr_0(face, value);
    
  end;
  
  glVertexShaderTessellatorAMD = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TessellationFactorAMD_ovr_0(factor: single);
    external 'opengl32.dll' name 'glTessellationFactorAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TessellationFactorAMD(factor: single) :=
    z_TessellationFactorAMD_ovr_0(factor);
    
    private static procedure z_TessellationModeAMD_ovr_0(mode: DummyEnum);
    external 'opengl32.dll' name 'glTessellationModeAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TessellationModeAMD(mode: DummyEnum) :=
    z_TessellationModeAMD_ovr_0(mode);
    
  end;
  
  glElementArrayAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ElementPointerAPPLE_ovr_0(&type: ElementPointerTypeATI; pointer: IntPtr);
    external 'opengl32.dll' name 'glElementPointerAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ElementPointerAPPLE(&type: ElementPointerTypeATI; pointer: IntPtr) :=
    z_ElementPointerAPPLE_ovr_0(&type, pointer);
    
    private static procedure z_DrawElementArrayAPPLE_ovr_0(mode: PrimitiveType; first: Int32; count: Int32);
    external 'opengl32.dll' name 'glDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementArrayAPPLE(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawElementArrayAPPLE_ovr_0(mode, first, count);
    
    private static procedure z_DrawRangeElementArrayAPPLE_ovr_0(mode: PrimitiveType; start: UInt32; &end: UInt32; first: Int32; count: Int32);
    external 'opengl32.dll' name 'glDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: Int32; count: Int32) :=
    z_DrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count);
    
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_0(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_0_anh00100(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_0_anh00010(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_0_anh00110(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawElementArrayAPPLE_ovr_0(mode, first[0], count[0], primcount) else
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00010(mode, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00100(mode, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawElementArrayAPPLE_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, primcount);
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_1_anh00100(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_0(mode, first[0], count, primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_0_anh00100(mode, IntPtr.Zero, count, primcount);
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_2(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_2_anh00100(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_2(mode, first[0], count, primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_2_anh00100(mode, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_0(mode, first, count[0], primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_0_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_0(mode, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_2(mode, first, count, primcount);
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_6(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_6_anh00010(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementArrayAPPLE_ovr_6(mode, first, count[0], primcount) else
      z_MultiDrawElementArrayAPPLE_ovr_6_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_6(mode, first, count, primcount);
    private static procedure z_MultiDrawElementArrayAPPLE_ovr_8(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementArrayAPPLE(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawElementArrayAPPLE_ovr_8(mode, first, count, primcount);
    
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000110(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first[0], count[0], primcount) else
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010(mode, start, &end, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100(mode, start, &end, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000110(mode, start, &end, IntPtr.Zero, IntPtr.Zero, primcount);
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_1_anh0000100(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first[0], count, primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000100(mode, start, &end, IntPtr.Zero, count, primcount);
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_2(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_2_anh0000100(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_2(mode, start, &end, first[0], count, primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_2_anh0000100(mode, start, &end, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count[0], primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_0_anh0000010(mode, start, &end, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_0(mode, start, &end, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_2(mode, start, &end, first, count, primcount);
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_6(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_6_anh0000010(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawRangeElementArrayAPPLE_ovr_6(mode, start, &end, first, count[0], primcount) else
      z_MultiDrawRangeElementArrayAPPLE_ovr_6_anh0000010(mode, start, &end, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_6(mode, start, &end, first, count, primcount);
    private static procedure z_MultiDrawRangeElementArrayAPPLE_ovr_8(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawRangeElementArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawRangeElementArrayAPPLE(mode: PrimitiveType; start: UInt32; &end: UInt32; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawRangeElementArrayAPPLE_ovr_8(mode, start, &end, first, count, primcount);
    
  end;
  
  glFenceAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenFencesAPPLE_ovr_0(n: Int32; var fences: UInt32);
    external 'opengl32.dll' name 'glGenFencesAPPLE';
    private static procedure z_GenFencesAPPLE_ovr_0_anh001(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glGenFencesAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_GenFencesAPPLE_ovr_0(n, fences[0]) else
      z_GenFencesAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; var fences: UInt32) :=
    z_GenFencesAPPLE_ovr_0(n, fences);
    private static procedure z_GenFencesAPPLE_ovr_2(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glGenFencesAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesAPPLE(n: Int32; fences: IntPtr) :=
    z_GenFencesAPPLE_ovr_2(n, fences);
    
    private static procedure z_DeleteFencesAPPLE_ovr_0(n: Int32; var fences: UInt32);
    external 'opengl32.dll' name 'glDeleteFencesAPPLE';
    private static procedure z_DeleteFencesAPPLE_ovr_0_anh001(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glDeleteFencesAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_DeleteFencesAPPLE_ovr_0(n, fences[0]) else
      z_DeleteFencesAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; var fences: UInt32) :=
    z_DeleteFencesAPPLE_ovr_0(n, fences);
    private static procedure z_DeleteFencesAPPLE_ovr_2(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glDeleteFencesAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesAPPLE(n: Int32; fences: IntPtr) :=
    z_DeleteFencesAPPLE_ovr_2(n, fences);
    
    private static procedure z_SetFenceAPPLE_ovr_0(fence: UInt32);
    external 'opengl32.dll' name 'glSetFenceAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFenceAPPLE(fence: UInt32) :=
    z_SetFenceAPPLE_ovr_0(fence);
    
    private static function z_IsFenceAPPLE_ovr_0(fence: UInt32): boolean;
    external 'opengl32.dll' name 'glIsFenceAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFenceAPPLE(fence: UInt32): boolean :=
    z_IsFenceAPPLE_ovr_0(fence);
    
    private static function z_TestFenceAPPLE_ovr_0(fence: UInt32): boolean;
    external 'opengl32.dll' name 'glTestFenceAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestFenceAPPLE(fence: UInt32): boolean :=
    z_TestFenceAPPLE_ovr_0(fence);
    
    private static procedure z_FinishFenceAPPLE_ovr_0(fence: UInt32);
    external 'opengl32.dll' name 'glFinishFenceAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishFenceAPPLE(fence: UInt32) :=
    z_FinishFenceAPPLE_ovr_0(fence);
    
    private static function z_TestObjectAPPLE_ovr_0(object: ObjectTypeAPPLE; name: UInt32): boolean;
    external 'opengl32.dll' name 'glTestObjectAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestObjectAPPLE(object: ObjectTypeAPPLE; name: UInt32): boolean :=
    z_TestObjectAPPLE_ovr_0(object, name);
    
    private static procedure z_FinishObjectAPPLE_ovr_0(object: ObjectTypeAPPLE; name: Int32);
    external 'opengl32.dll' name 'glFinishObjectAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishObjectAPPLE(object: ObjectTypeAPPLE; name: Int32) :=
    z_FinishObjectAPPLE_ovr_0(object, name);
    
  end;
  
  glFlushBufferRangeAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BufferParameteriAPPLE_ovr_0(target: DummyEnum; pname: DummyEnum; param: Int32);
    external 'opengl32.dll' name 'glBufferParameteriAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferParameteriAPPLE(target: DummyEnum; pname: DummyEnum; param: Int32) :=
    z_BufferParameteriAPPLE_ovr_0(target, pname, param);
    
    private static procedure z_FlushMappedBufferRangeAPPLE_ovr_0(target: BufferTargetARB; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glFlushMappedBufferRangeAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRangeAPPLE(target: BufferTargetARB; offset: IntPtr; size: IntPtr) :=
    z_FlushMappedBufferRangeAPPLE_ovr_0(target, offset, size);
    
  end;
  
  glObjectPurgeableAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_ObjectPurgeableAPPLE_ovr_0(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum;
    external 'opengl32.dll' name 'glObjectPurgeableAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ObjectPurgeableAPPLE(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum :=
    z_ObjectPurgeableAPPLE_ovr_0(objectType, name, option);
    
    private static function z_ObjectUnpurgeableAPPLE_ovr_0(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum;
    external 'opengl32.dll' name 'glObjectUnpurgeableAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ObjectUnpurgeableAPPLE(objectType: DummyEnum; name: UInt32; option: DummyEnum): DummyEnum :=
    z_ObjectUnpurgeableAPPLE_ovr_0(objectType, name, option);
    
    private static procedure z_GetObjectParameterivAPPLE_ovr_0(objectType: DummyEnum; name: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetObjectParameterivAPPLE';
    private static procedure z_GetObjectParameterivAPPLE_ovr_0_anh00001(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterivAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterivAPPLE_ovr_0(objectType, name, pname, &params[0]) else
      z_GetObjectParameterivAPPLE_ovr_0_anh00001(objectType, name, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetObjectParameterivAPPLE_ovr_0(objectType, name, pname, &params);
    private static procedure z_GetObjectParameterivAPPLE_ovr_2(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterivAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivAPPLE(objectType: DummyEnum; name: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterivAPPLE_ovr_2(objectType, name, pname, &params);
    
  end;
  
  glTextureRangeAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureRangeAPPLE_ovr_0(target: DummyEnum; length: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glTextureRangeAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureRangeAPPLE(target: DummyEnum; length: Int32; pointer: IntPtr) :=
    z_TextureRangeAPPLE_ovr_0(target, length, pointer);
    
    private static procedure z_GetTexParameterPointervAPPLE_ovr_0(target: DummyEnum; pname: DummyEnum; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterPointervAPPLE';
    private static procedure z_GetTexParameterPointervAPPLE_ovr_0_anh0001(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterPointervAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterPointervAPPLE(target: DummyEnum; pname: DummyEnum; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterPointervAPPLE_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterPointervAPPLE_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterPointervAPPLE(target: DummyEnum; pname: DummyEnum; var &params: IntPtr) :=
    z_GetTexParameterPointervAPPLE_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameterPointervAPPLE_ovr_2(target: DummyEnum; pname: DummyEnum; &params: pointer);
    external 'opengl32.dll' name 'glGetTexParameterPointervAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterPointervAPPLE(target: DummyEnum; pname: DummyEnum; &params: pointer) :=
    z_GetTexParameterPointervAPPLE_ovr_2(target, pname, &params);
    
  end;
  
  glVertexArrayObjectAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindVertexArrayAPPLE_ovr_0(&array: UInt32);
    external 'opengl32.dll' name 'glBindVertexArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArrayAPPLE(&array: UInt32) :=
    z_BindVertexArrayAPPLE_ovr_0(&array);
    
    private static procedure z_DeleteVertexArraysAPPLE_ovr_0(n: Int32; var arrays: UInt32);
    external 'opengl32.dll' name 'glDeleteVertexArraysAPPLE';
    private static procedure z_DeleteVertexArraysAPPLE_ovr_0_anh001(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glDeleteVertexArraysAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArraysAPPLE_ovr_0(n, arrays[0]) else
      z_DeleteVertexArraysAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; var arrays: UInt32) :=
    z_DeleteVertexArraysAPPLE_ovr_0(n, arrays);
    private static procedure z_DeleteVertexArraysAPPLE_ovr_2(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glDeleteVertexArraysAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArraysAPPLE(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArraysAPPLE_ovr_2(n, arrays);
    
    private static procedure z_GenVertexArraysAPPLE_ovr_0(n: Int32; var arrays: UInt32);
    external 'opengl32.dll' name 'glGenVertexArraysAPPLE';
    private static procedure z_GenVertexArraysAPPLE_ovr_0_anh001(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glGenVertexArraysAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArraysAPPLE_ovr_0(n, arrays[0]) else
      z_GenVertexArraysAPPLE_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; var arrays: UInt32) :=
    z_GenVertexArraysAPPLE_ovr_0(n, arrays);
    private static procedure z_GenVertexArraysAPPLE_ovr_2(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glGenVertexArraysAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArraysAPPLE(n: Int32; arrays: IntPtr) :=
    z_GenVertexArraysAPPLE_ovr_2(n, arrays);
    
    private static function z_IsVertexArrayAPPLE_ovr_0(&array: UInt32): boolean;
    external 'opengl32.dll' name 'glIsVertexArrayAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArrayAPPLE(&array: UInt32): boolean :=
    z_IsVertexArrayAPPLE_ovr_0(&array);
    
  end;
  
  glVertexArrayRangeAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexArrayRangeAPPLE_ovr_0(length: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayRangeAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayRangeAPPLE(length: Int32; pointer: IntPtr) :=
    z_VertexArrayRangeAPPLE_ovr_0(length, pointer);
    
    private static procedure z_FlushVertexArrayRangeAPPLE_ovr_0(length: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glFlushVertexArrayRangeAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushVertexArrayRangeAPPLE(length: Int32; pointer: IntPtr) :=
    z_FlushVertexArrayRangeAPPLE_ovr_0(length, pointer);
    
    private static procedure z_VertexArrayParameteriAPPLE_ovr_0(pname: VertexArrayPNameAPPLE; param: Int32);
    external 'opengl32.dll' name 'glVertexArrayParameteriAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayParameteriAPPLE(pname: VertexArrayPNameAPPLE; param: Int32) :=
    z_VertexArrayParameteriAPPLE_ovr_0(pname, param);
    
  end;
  
  glVertexProgramEvaluatorsAPPLE = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_EnableVertexAttribAPPLE_ovr_0(index: UInt32; pname: DummyEnum);
    external 'opengl32.dll' name 'glEnableVertexAttribAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribAPPLE(index: UInt32; pname: DummyEnum) :=
    z_EnableVertexAttribAPPLE_ovr_0(index, pname);
    
    private static procedure z_DisableVertexAttribAPPLE_ovr_0(index: UInt32; pname: DummyEnum);
    external 'opengl32.dll' name 'glDisableVertexAttribAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribAPPLE(index: UInt32; pname: DummyEnum) :=
    z_DisableVertexAttribAPPLE_ovr_0(index, pname);
    
    private static function z_IsVertexAttribEnabledAPPLE_ovr_0(index: UInt32; pname: DummyEnum): boolean;
    external 'opengl32.dll' name 'glIsVertexAttribEnabledAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexAttribEnabledAPPLE(index: UInt32; pname: DummyEnum): boolean :=
    z_IsVertexAttribEnabledAPPLE_ovr_0(index, pname);
    
    private static procedure z_MapVertexAttrib1dAPPLE_ovr_0(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; var points: real);
    external 'opengl32.dll' name 'glMapVertexAttrib1dAPPLE';
    private static procedure z_MapVertexAttrib1dAPPLE_ovr_0_anh00000001(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib1dAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib1dAPPLE_ovr_0(index, size, u1, u2, stride, order, points[0]) else
      z_MapVertexAttrib1dAPPLE_ovr_0_anh00000001(index, size, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; var points: real) :=
    z_MapVertexAttrib1dAPPLE_ovr_0(index, size, u1, u2, stride, order, points);
    private static procedure z_MapVertexAttrib1dAPPLE_ovr_2(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib1dAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; stride: Int32; order: Int32; points: IntPtr) :=
    z_MapVertexAttrib1dAPPLE_ovr_2(index, size, u1, u2, stride, order, points);
    
    private static procedure z_MapVertexAttrib1fAPPLE_ovr_0(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; var points: single);
    external 'opengl32.dll' name 'glMapVertexAttrib1fAPPLE';
    private static procedure z_MapVertexAttrib1fAPPLE_ovr_0_anh00000001(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib1fAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib1fAPPLE_ovr_0(index, size, u1, u2, stride, order, points[0]) else
      z_MapVertexAttrib1fAPPLE_ovr_0_anh00000001(index, size, u1, u2, stride, order, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; var points: single) :=
    z_MapVertexAttrib1fAPPLE_ovr_0(index, size, u1, u2, stride, order, points);
    private static procedure z_MapVertexAttrib1fAPPLE_ovr_2(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib1fAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib1fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; stride: Int32; order: Int32; points: IntPtr) :=
    z_MapVertexAttrib1fAPPLE_ovr_2(index, size, u1, u2, stride, order, points);
    
    private static procedure z_MapVertexAttrib2dAPPLE_ovr_0(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real);
    external 'opengl32.dll' name 'glMapVertexAttrib2dAPPLE';
    private static procedure z_MapVertexAttrib2dAPPLE_ovr_0_anh000000000001(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib2dAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib2dAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_MapVertexAttrib2dAPPLE_ovr_0_anh000000000001(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; var points: real) :=
    z_MapVertexAttrib2dAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private static procedure z_MapVertexAttrib2dAPPLE_ovr_2(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib2dAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2dAPPLE(index: UInt32; size: UInt32; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_MapVertexAttrib2dAPPLE_ovr_2(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    private static procedure z_MapVertexAttrib2fAPPLE_ovr_0(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single);
    external 'opengl32.dll' name 'glMapVertexAttrib2fAPPLE';
    private static procedure z_MapVertexAttrib2fAPPLE_ovr_0_anh000000000001(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib2fAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_MapVertexAttrib2fAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points[0]) else
      z_MapVertexAttrib2fAPPLE_ovr_0_anh000000000001(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; var points: single) :=
    z_MapVertexAttrib2fAPPLE_ovr_0(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    private static procedure z_MapVertexAttrib2fAPPLE_ovr_2(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glMapVertexAttrib2fAPPLE';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapVertexAttrib2fAPPLE(index: UInt32; size: UInt32; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; points: IntPtr) :=
    z_MapVertexAttrib2fAPPLE_ovr_2(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
  end;
  
  glES2CompatibilityARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ReleaseShaderCompiler_ovr_0;
    external 'opengl32.dll' name 'glReleaseShaderCompiler';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReleaseShaderCompiler :=
    z_ReleaseShaderCompiler_ovr_0;
    
    private static procedure z_ShaderBinary_ovr_0(count: Int32; var shaders: UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32);
    external 'opengl32.dll' name 'glShaderBinary';
    private static procedure z_ShaderBinary_ovr_0_anh001000(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32);
    external 'opengl32.dll' name 'glShaderBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: array of UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    if (shaders<>nil) and (shaders.Length<>0) then
      z_ShaderBinary_ovr_0(count, shaders[0], binaryformat, binary, length) else
      z_ShaderBinary_ovr_0_anh001000(count, IntPtr.Zero, binaryformat, binary, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; var shaders: UInt32; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_0(count, shaders, binaryformat, binary, length);
    private static procedure z_ShaderBinary_ovr_2(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32);
    external 'opengl32.dll' name 'glShaderBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderBinary(count: Int32; shaders: IntPtr; binaryformat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ShaderBinary_ovr_2(count, shaders, binaryformat, binary, length);
    
    private static procedure z_GetShaderPrecisionFormat_ovr_0(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    private static procedure z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    private static procedure z_GetShaderPrecisionFormat_ovr_0_anh00001(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    private static procedure z_GetShaderPrecisionFormat_ovr_0_anh00011(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: array of Int32) :=
    if (range<>nil) and (range.Length<>0) then
      if (precision<>nil) and (precision.Length<>0) then
        z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision[0]) else
        z_GetShaderPrecisionFormat_ovr_0_anh00001(_shadertype, _precisiontype, range[0], IntPtr.Zero) else
      if (precision<>nil) and (precision.Length<>0) then
        z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision[0]) else
        z_GetShaderPrecisionFormat_ovr_0_anh00011(_shadertype, _precisiontype, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetShaderPrecisionFormat_ovr_1_anh00010(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; var precision: Int32) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_0_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    private static procedure z_GetShaderPrecisionFormat_ovr_2(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    private static procedure z_GetShaderPrecisionFormat_ovr_2_anh00010(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: array of Int32; precision: IntPtr) :=
    if (range<>nil) and (range.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_2(_shadertype, _precisiontype, range[0], precision) else
      z_GetShaderPrecisionFormat_ovr_2_anh00010(_shadertype, _precisiontype, IntPtr.Zero, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: array of Int32) :=
    if (precision<>nil) and (precision.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision[0]) else
      z_GetShaderPrecisionFormat_ovr_0_anh00001(_shadertype, _precisiontype, range, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_0(_shadertype, _precisiontype, range, precision);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; var range: Int32; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_2(_shadertype, _precisiontype, range, precision);
    private static procedure z_GetShaderPrecisionFormat_ovr_6(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    private static procedure z_GetShaderPrecisionFormat_ovr_6_anh00001(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: array of Int32) :=
    if (precision<>nil) and (precision.Length<>0) then
      z_GetShaderPrecisionFormat_ovr_6(_shadertype, _precisiontype, range, precision[0]) else
      z_GetShaderPrecisionFormat_ovr_6_anh00001(_shadertype, _precisiontype, range, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; var precision: Int32) :=
    z_GetShaderPrecisionFormat_ovr_6(_shadertype, _precisiontype, range, precision);
    private static procedure z_GetShaderPrecisionFormat_ovr_8(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr);
    external 'opengl32.dll' name 'glGetShaderPrecisionFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderPrecisionFormat(_shadertype: ShaderType; _precisiontype: PrecisionType; range: IntPtr; precision: IntPtr) :=
    z_GetShaderPrecisionFormat_ovr_8(_shadertype, _precisiontype, range, precision);
    
    private static procedure z_DepthRangef_ovr_0(n: single; f: single);
    external 'opengl32.dll' name 'glDepthRangef';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangef(n: single; f: single) :=
    z_DepthRangef_ovr_0(n, f);
    
    private static procedure z_ClearDepthf_ovr_0(d: single);
    external 'opengl32.dll' name 'glClearDepthf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthf(d: single) :=
    z_ClearDepthf_ovr_0(d);
    
  end;
  
  glES31CompatibilityARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MemoryBarrierByRegion_ovr_0(barriers: MemoryBarrierMask);
    external 'opengl32.dll' name 'glMemoryBarrierByRegion';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierByRegion(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierByRegion_ovr_0(barriers);
    
  end;
  
  glES32CompatibilityARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PrimitiveBoundingBoxARB_ovr_0(minX: single; minY: single; minZ: single; minW: single; maxX: single; maxY: single; maxZ: single; maxW: single);
    external 'opengl32.dll' name 'glPrimitiveBoundingBoxARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveBoundingBoxARB(minX: single; minY: single; minZ: single; minW: single; maxX: single; maxY: single; maxZ: single; maxW: single) :=
    z_PrimitiveBoundingBoxARB_ovr_0(minX, minY, minZ, minW, maxX, maxY, maxZ, maxW);
    
  end;
  
  glBaseInstanceARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawArraysInstancedBaseInstance_ovr_0(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32);
    external 'opengl32.dll' name 'glDrawArraysInstancedBaseInstance';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedBaseInstance(mode: PrimitiveType; first: Int32; count: Int32; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawArraysInstancedBaseInstance_ovr_0(mode, first, count, instancecount, baseinstance);
    
    private static procedure z_DrawElementsInstancedBaseInstance_ovr_0(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32);
    external 'opengl32.dll' name 'glDrawElementsInstancedBaseInstance';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseInstance(mode: PrimitiveType; count: Int32; &type: PrimitiveType; indices: IntPtr; instancecount: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseInstance_ovr_0(mode, count, &type, indices, instancecount, baseinstance);
    
    private static procedure z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32);
    external 'opengl32.dll' name 'glDrawElementsInstancedBaseVertexBaseInstance';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertexBaseInstance(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32; baseinstance: UInt32) :=
    z_DrawElementsInstancedBaseVertexBaseInstance_ovr_0(mode, count, &type, indices, instancecount, basevertex, baseinstance);
    
  end;
  
  glBindlessTextureARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetTextureHandleARB_ovr_0(texture: UInt32): UInt64;
    external 'opengl32.dll' name 'glGetTextureHandleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureHandleARB(texture: UInt32): UInt64 :=
    z_GetTextureHandleARB_ovr_0(texture);
    
    private static function z_GetTextureSamplerHandleARB_ovr_0(texture: UInt32; sampler: UInt32): UInt64;
    external 'opengl32.dll' name 'glGetTextureSamplerHandleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureSamplerHandleARB(texture: UInt32; sampler: UInt32): UInt64 :=
    z_GetTextureSamplerHandleARB_ovr_0(texture, sampler);
    
    private static procedure z_MakeTextureHandleResidentARB_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeTextureHandleResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleResidentARB(handle: UInt64) :=
    z_MakeTextureHandleResidentARB_ovr_0(handle);
    
    private static procedure z_MakeTextureHandleNonResidentARB_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeTextureHandleNonResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleNonResidentARB(handle: UInt64) :=
    z_MakeTextureHandleNonResidentARB_ovr_0(handle);
    
    private static function z_GetImageHandleARB_ovr_0(texture: UInt32; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64;
    external 'opengl32.dll' name 'glGetImageHandleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetImageHandleARB(texture: UInt32; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64 :=
    z_GetImageHandleARB_ovr_0(texture, level, layered, layer, format);
    
    private static procedure z_MakeImageHandleResidentARB_ovr_0(handle: UInt64; access: DummyEnum);
    external 'opengl32.dll' name 'glMakeImageHandleResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleResidentARB(handle: UInt64; access: DummyEnum) :=
    z_MakeImageHandleResidentARB_ovr_0(handle, access);
    
    private static procedure z_MakeImageHandleNonResidentARB_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeImageHandleNonResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleNonResidentARB(handle: UInt64) :=
    z_MakeImageHandleNonResidentARB_ovr_0(handle);
    
    private static procedure z_UniformHandleui64ARB_ovr_0(location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glUniformHandleui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64ARB(location: Int32; value: UInt64) :=
    z_UniformHandleui64ARB_ovr_0(location, value);
    
    private static procedure z_UniformHandleui64vARB_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniformHandleui64vARB';
    private static procedure z_UniformHandleui64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformHandleui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformHandleui64vARB_ovr_0(location, count, value[0]) else
      z_UniformHandleui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_UniformHandleui64vARB_ovr_0(location, count, value);
    private static procedure z_UniformHandleui64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformHandleui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_UniformHandleui64vARB_ovr_2(location, count, value);
    
    private static procedure z_ProgramUniformHandleui64ARB_ovr_0(&program: UInt32; location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glProgramUniformHandleui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64ARB(&program: UInt32; location: Int32; value: UInt64) :=
    z_ProgramUniformHandleui64ARB_ovr_0(&program, location, value);
    
    private static procedure z_ProgramUniformHandleui64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var values: UInt64);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vARB';
    private static procedure z_ProgramUniformHandleui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: UInt32; location: Int32; count: Int32; values: array of UInt64) :=
    if (values<>nil) and (values.Length<>0) then
      z_ProgramUniformHandleui64vARB_ovr_0(&program, location, count, values[0]) else
      z_ProgramUniformHandleui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: UInt32; location: Int32; count: Int32; var values: UInt64) :=
    z_ProgramUniformHandleui64vARB_ovr_0(&program, location, count, values);
    private static procedure z_ProgramUniformHandleui64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vARB(&program: UInt32; location: Int32; count: Int32; values: IntPtr) :=
    z_ProgramUniformHandleui64vARB_ovr_2(&program, location, count, values);
    
    private static function z_IsTextureHandleResidentARB_ovr_0(handle: UInt64): boolean;
    external 'opengl32.dll' name 'glIsTextureHandleResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureHandleResidentARB(handle: UInt64): boolean :=
    z_IsTextureHandleResidentARB_ovr_0(handle);
    
    private static function z_IsImageHandleResidentARB_ovr_0(handle: UInt64): boolean;
    external 'opengl32.dll' name 'glIsImageHandleResidentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsImageHandleResidentARB(handle: UInt64): boolean :=
    z_IsImageHandleResidentARB_ovr_0(handle);
    
    private static procedure z_VertexAttribL1ui64ARB_ovr_0(index: UInt32; x: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL1ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64ARB(index: UInt32; x: UInt64) :=
    z_VertexAttribL1ui64ARB_ovr_0(index, x);
    
    private static procedure z_VertexAttribL1ui64vARB_ovr_0(index: UInt32; var v: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vARB';
    private static procedure z_VertexAttribL1ui64vARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1ui64vARB_ovr_0(index, v[0]) else
      z_VertexAttribL1ui64vARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; var v: UInt64) :=
    z_VertexAttribL1ui64vARB_ovr_0(index, v);
    private static procedure z_VertexAttribL1ui64vARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vARB(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1ui64vARB_ovr_2(index, v);
    
    private static procedure z_GetVertexAttribLui64vARB_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: UInt64);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vARB';
    private static procedure z_GetVertexAttribLui64vARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLui64vARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLui64vARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; var &params: UInt64) :=
    z_GetVertexAttribLui64vARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribLui64vARB_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vARB(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLui64vARB_ovr_2(index, pname, &params);
    
  end;
  
  glBlendFuncExtendedARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindFragDataLocationIndexed_ovr_0(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: IntPtr);
    external 'opengl32.dll' name 'glBindFragDataLocationIndexed';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationIndexed(&program: ProgramName; colorNumber: UInt32; index: UInt32; name: IntPtr) :=
    z_BindFragDataLocationIndexed_ovr_0(&program, colorNumber, index, name);
    
    private static function z_GetFragDataIndex_ovr_0(&program: ProgramName; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetFragDataIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: ProgramName; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetFragDataIndex_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataIndex(&program: ProgramName; name: IntPtr): Int32 :=
    z_GetFragDataIndex_ovr_0(&program, name);
    
  end;
  
  glBufferStorageARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BufferStorage_ovr_0(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask);
    external 'opengl32.dll' name 'glBufferStorage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorage(target: BufferStorageTarget; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_BufferStorage_ovr_0(target, size, data, flags);
    
  end;
  
  glClEventARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_CreateSyncFromCLeventARB_ovr_0(var context: cl_context; var &event: cl_event; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    private static function z_CreateSyncFromCLeventARB_ovr_0_anh0100(context: IntPtr; var &event: cl_event; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    private static function z_CreateSyncFromCLeventARB_ovr_0_anh0010(var context: cl_context; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    private static function z_CreateSyncFromCLeventARB_ovr_0_anh0110(context: IntPtr; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of cl_context; &event: array of cl_event; flags: DummyFlags): GLsync :=
    if (context<>nil) and (context.Length<>0) then
      if (&event<>nil) and (&event.Length<>0) then
        z_CreateSyncFromCLeventARB_ovr_0(context[0], &event[0], flags) else
        z_CreateSyncFromCLeventARB_ovr_0_anh0010(context[0], IntPtr.Zero, flags) else
      if (&event<>nil) and (&event.Length<>0) then
        z_CreateSyncFromCLeventARB_ovr_0_anh0100(IntPtr.Zero, &event[0], flags) else
        z_CreateSyncFromCLeventARB_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, flags);
    private static function z_CreateSyncFromCLeventARB_ovr_1_anh0100(context: IntPtr; var &event: cl_event; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of cl_context; var &event: cl_event; flags: DummyFlags): GLsync :=
    if (context<>nil) and (context.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_0(context[0], &event, flags) else
      z_CreateSyncFromCLeventARB_ovr_0_anh0100(IntPtr.Zero, &event, flags);
    private static function z_CreateSyncFromCLeventARB_ovr_2(var context: cl_context; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    private static function z_CreateSyncFromCLeventARB_ovr_2_anh0100(context: IntPtr; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: array of cl_context; &event: IntPtr; flags: DummyFlags): GLsync :=
    if (context<>nil) and (context.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_2(context[0], &event, flags) else
      z_CreateSyncFromCLeventARB_ovr_2_anh0100(IntPtr.Zero, &event, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: cl_context; &event: array of cl_event; flags: DummyFlags): GLsync :=
    if (&event<>nil) and (&event.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_0(context, &event[0], flags) else
      z_CreateSyncFromCLeventARB_ovr_0_anh0010(context, IntPtr.Zero, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: cl_context; var &event: cl_event; flags: DummyFlags): GLsync :=
    z_CreateSyncFromCLeventARB_ovr_0(context, &event, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(var context: cl_context; &event: IntPtr; flags: DummyFlags): GLsync :=
    z_CreateSyncFromCLeventARB_ovr_2(context, &event, flags);
    private static function z_CreateSyncFromCLeventARB_ovr_6(context: IntPtr; var &event: cl_event; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    private static function z_CreateSyncFromCLeventARB_ovr_6_anh0010(context: IntPtr; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; &event: array of cl_event; flags: DummyFlags): GLsync :=
    if (&event<>nil) and (&event.Length<>0) then
      z_CreateSyncFromCLeventARB_ovr_6(context, &event[0], flags) else
      z_CreateSyncFromCLeventARB_ovr_6_anh0010(context, IntPtr.Zero, flags);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; var &event: cl_event; flags: DummyFlags): GLsync :=
    z_CreateSyncFromCLeventARB_ovr_6(context, &event, flags);
    private static function z_CreateSyncFromCLeventARB_ovr_8(context: IntPtr; &event: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glCreateSyncFromCLeventARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateSyncFromCLeventARB(context: IntPtr; &event: IntPtr; flags: DummyFlags): GLsync :=
    z_CreateSyncFromCLeventARB_ovr_8(context, &event, flags);
    
  end;
  
  glClearBufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ClearBufferData_ovr_0(target: BufferStorageTarget; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearBufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferData(target: BufferStorageTarget; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferData_ovr_0(target, _internalformat, format, &type, data);
    
    private static procedure z_ClearBufferSubData_ovr_0(target: BufferTargetARB; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearBufferSubData(target: BufferTargetARB; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearBufferSubData_ovr_0(target, _internalformat, offset, size, format, &type, data);
    
  end;
  
  glClearTextureARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ClearTexImage_ovr_0(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearTexImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexImage(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexImage_ovr_0(texture, level, format, &type, data);
    
    private static procedure z_ClearTexSubImage_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearTexSubImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearTexSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, data);
    
  end;
  
  glClipControlARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ClipControl_ovr_0(origin: ClipControlOrigin; depth: ClipControlDepth);
    external 'opengl32.dll' name 'glClipControl';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipControl(origin: ClipControlOrigin; depth: ClipControlDepth) :=
    z_ClipControl_ovr_0(origin, depth);
    
  end;
  
  glColorBufferFloatARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ClampColorARB_ovr_0(target: ClampColorTargetARB; clamp: ClampColorModeARB);
    external 'opengl32.dll' name 'glClampColorARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClampColorARB(target: ClampColorTargetARB; clamp: ClampColorModeARB) :=
    z_ClampColorARB_ovr_0(target, clamp);
    
  end;
  
  glComputeShaderARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DispatchCompute_ovr_0(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32);
    external 'opengl32.dll' name 'glDispatchCompute';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchCompute(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32) :=
    z_DispatchCompute_ovr_0(num_groups_x, num_groups_y, num_groups_z);
    
    private static procedure z_DispatchComputeIndirect_ovr_0(indirect: IntPtr);
    external 'opengl32.dll' name 'glDispatchComputeIndirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeIndirect(indirect: IntPtr) :=
    z_DispatchComputeIndirect_ovr_0(indirect);
    
  end;
  
  glComputeVariableGroupSizeARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DispatchComputeGroupSizeARB_ovr_0(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32; group_size_x: UInt32; group_size_y: UInt32; group_size_z: UInt32);
    external 'opengl32.dll' name 'glDispatchComputeGroupSizeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DispatchComputeGroupSizeARB(num_groups_x: UInt32; num_groups_y: UInt32; num_groups_z: UInt32; group_size_x: UInt32; group_size_y: UInt32; group_size_z: UInt32) :=
    z_DispatchComputeGroupSizeARB_ovr_0(num_groups_x, num_groups_y, num_groups_z, group_size_x, group_size_y, group_size_z);
    
  end;
  
  glCopyBufferARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CopyBufferSubData_ovr_0(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glCopyBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyBufferSubData(readTarget: CopyBufferSubDataTarget; writeTarget: CopyBufferSubDataTarget; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyBufferSubData_ovr_0(readTarget, writeTarget, readOffset, writeOffset, size);
    
  end;
  
  glCopyImageARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CopyImageSubData_ovr_0(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32);
    external 'opengl32.dll' name 'glCopyImageSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubData(srcName: UInt32; srcTarget: CopyImageSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyImageSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_CopyImageSubData_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
  end;
  
  glDebugOutputARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DebugMessageControlARB_ovr_0(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControlARB';
    private static procedure z_DebugMessageControlARB_ovr_0_anh0000010(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControlARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControlARB_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControlARB_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControlARB_ovr_0(source, &type, severity, count, ids, enabled);
    private static procedure z_DebugMessageControlARB_ovr_2(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControlARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControlARB(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControlARB_ovr_2(source, &type, severity, count, ids, enabled);
    
    private static procedure z_DebugMessageInsertARB_ovr_0(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageInsertARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertARB(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
      z_DebugMessageInsertARB_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      Marshal.FreeHGlobal(par_6_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsertARB(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsertARB_ovr_0(source, &type, id, severity, length, buf);
    
    private static procedure z_DebugMessageCallbackARB_ovr_0(callback: GLDEBUGPROC; userParam: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageCallbackARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallbackARB(callback: GLDEBUGPROC; userParam: IntPtr) :=
    z_DebugMessageCallbackARB_ovr_0(callback, userParam);
    
    private static function z_GetDebugMessageLogARB_ovr_0(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLogARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogARB(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLogARB_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private static function z_GetDebugMessageLogARB_ovr_1(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLogARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLogARB(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLogARB_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
  end;
  
  glDirectStateAccessARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CreateTransformFeedbacks_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glCreateTransformFeedbacks';
    private static procedure z_CreateTransformFeedbacks_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glCreateTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateTransformFeedbacks_ovr_0(n, ids[0]) else
      z_CreateTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_CreateTransformFeedbacks_ovr_0(n, ids);
    private static procedure z_CreateTransformFeedbacks_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glCreateTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_CreateTransformFeedbacks_ovr_2(n, ids);
    
    private static procedure z_TransformFeedbackBufferBase_ovr_0(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName);
    external 'opengl32.dll' name 'glTransformFeedbackBufferBase';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferBase(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName) :=
    z_TransformFeedbackBufferBase_ovr_0(xfb, index, buffer);
    
    private static procedure z_TransformFeedbackBufferRange_ovr_0(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glTransformFeedbackBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackBufferRange(xfb: TransformFeedbackName; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TransformFeedbackBufferRange_ovr_0(xfb, index, buffer, offset, size);
    
    private static procedure z_GetTransformFeedbackiv_ovr_0(xfb: UInt32; pname: TransformFeedbackPName; var param: Int32);
    external 'opengl32.dll' name 'glGetTransformFeedbackiv';
    private static procedure z_GetTransformFeedbackiv_ovr_0_anh0001(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbackiv_ovr_0(xfb, pname, param[0]) else
      z_GetTransformFeedbackiv_ovr_0_anh0001(xfb, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; var param: Int32) :=
    z_GetTransformFeedbackiv_ovr_0(xfb, pname, param);
    private static procedure z_GetTransformFeedbackiv_ovr_2(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackiv(xfb: UInt32; pname: TransformFeedbackPName; param: IntPtr) :=
    z_GetTransformFeedbackiv_ovr_2(xfb, pname, param);
    
    private static procedure z_GetTransformFeedbacki_v_ovr_0(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int32);
    external 'opengl32.dll' name 'glGetTransformFeedbacki_v';
    private static procedure z_GetTransformFeedbacki_v_ovr_0_anh00001(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbacki_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int32) :=
    z_GetTransformFeedbacki_v_ovr_0(xfb, pname, index, param);
    private static procedure z_GetTransformFeedbacki_v_ovr_2(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbacki_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki_v_ovr_2(xfb, pname, index, param);
    
    private static procedure z_GetTransformFeedbacki64_v_ovr_0(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int64);
    external 'opengl32.dll' name 'glGetTransformFeedbacki64_v';
    private static procedure z_GetTransformFeedbacki64_v_ovr_0_anh00001(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbacki64_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param[0]) else
      z_GetTransformFeedbacki64_v_ovr_0_anh00001(xfb, pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; var param: Int64) :=
    z_GetTransformFeedbacki64_v_ovr_0(xfb, pname, index, param);
    private static procedure z_GetTransformFeedbacki64_v_ovr_2(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbacki64_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbacki64_v(xfb: UInt32; pname: TransformFeedbackPName; index: UInt32; param: IntPtr) :=
    z_GetTransformFeedbacki64_v_ovr_2(xfb, pname, index, param);
    
    private static procedure z_CreateBuffers_ovr_0(n: Int32; var buffers: BufferName);
    external 'opengl32.dll' name 'glCreateBuffers';
    private static procedure z_CreateBuffers_ovr_0_anh001(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glCreateBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: array of BufferName) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_CreateBuffers_ovr_0(n, buffers[0]) else
      z_CreateBuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; var buffers: BufferName) :=
    z_CreateBuffers_ovr_0(n, buffers);
    private static procedure z_CreateBuffers_ovr_2(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glCreateBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateBuffers(n: Int32; buffers: IntPtr) :=
    z_CreateBuffers_ovr_2(n, buffers);
    
    private static procedure z_NamedBufferStorage_ovr_0(buffer: BufferName; size: IntPtr; data: IntPtr; flags: BufferStorageMask);
    external 'opengl32.dll' name 'glNamedBufferStorage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorage(buffer: BufferName; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorage_ovr_0(buffer, size, data, flags);
    
    private static procedure z_NamedBufferData_ovr_0(buffer: BufferName; size: IntPtr; var data: Byte; usage: VertexBufferObjectUsage);
    external 'opengl32.dll' name 'glNamedBufferData';
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure temp_NamedBufferData_ovr_0<T>(buffer: BufferName; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure temp_NamedBufferData_ovr_0_anh00010(buffer: BufferName; size: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_0(buffer, size, PByte(nil)^, usage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: BufferName; size: IntPtr; data: array of T; usage: VertexBufferObjectUsage); where T: record;
    begin
      if (data<>nil) and (data.Length<>0) then
        temp_NamedBufferData_ovr_0(buffer, size, data[0], usage) else
        temp_NamedBufferData_ovr_0_anh00010(buffer, size, usage);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData<T>(buffer: BufferName; size: IntPtr; var data: T; usage: VertexBufferObjectUsage); where T: record;
    begin
      z_NamedBufferData_ovr_0(buffer, size, PByte(pointer(@data))^, usage);
    end;
    private static procedure z_NamedBufferData_ovr_2(buffer: BufferName; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage);
    external 'opengl32.dll' name 'glNamedBufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferData(buffer: BufferName; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferData_ovr_2(buffer, size, data, usage);
    
    private static procedure z_NamedBufferSubData_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glNamedBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubData(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubData_ovr_0(buffer, offset, size, data);
    
    private static procedure z_CopyNamedBufferSubData_ovr_0(readBuffer: BufferName; writeBuffer: BufferName; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glCopyNamedBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyNamedBufferSubData(readBuffer: BufferName; writeBuffer: BufferName; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_CopyNamedBufferSubData_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private static procedure z_ClearNamedBufferData_ovr_0(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearNamedBufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferData(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferData_ovr_0(buffer, _internalformat, format, &type, data);
    
    private static procedure z_ClearNamedBufferSubData_ovr_0(buffer: UInt32; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearNamedBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubData(buffer: UInt32; _internalformat: InternalFormat; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubData_ovr_0(buffer, _internalformat, offset, size, format, &type, data);
    
    private static function z_MapNamedBuffer_ovr_0(buffer: BufferName; access: BufferAccessARB): IntPtr;
    external 'opengl32.dll' name 'glMapNamedBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBuffer(buffer: BufferName; access: BufferAccessARB): IntPtr :=
    z_MapNamedBuffer_ovr_0(buffer, access);
    
    private static function z_MapNamedBufferRange_ovr_0(buffer: BufferName; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr;
    external 'opengl32.dll' name 'glMapNamedBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRange(buffer: BufferName; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRange_ovr_0(buffer, offset, length, access);
    
    private static function z_UnmapNamedBuffer_ovr_0(buffer: BufferName): boolean;
    external 'opengl32.dll' name 'glUnmapNamedBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBuffer(buffer: BufferName): boolean :=
    z_UnmapNamedBuffer_ovr_0(buffer);
    
    private static procedure z_FlushMappedNamedBufferRange_ovr_0(buffer: BufferName; offset: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glFlushMappedNamedBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRange(buffer: BufferName; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRange_ovr_0(buffer, offset, length);
    
    private static procedure z_GetNamedBufferParameteriv_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedBufferParameteriv';
    private static procedure z_GetNamedBufferParameteriv_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteriv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32) :=
    z_GetNamedBufferParameteriv_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferParameteriv_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteriv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameteriv_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetNamedBufferParameteri64v_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int64);
    external 'opengl32.dll' name 'glGetNamedBufferParameteri64v';
    private static procedure z_GetNamedBufferParameteri64v_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameteri64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameteri64v_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int64) :=
    z_GetNamedBufferParameteri64v_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferParameteri64v_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameteri64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameteri64v(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameteri64v_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetNamedBufferPointerv_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferPointerv';
    private static procedure z_GetNamedBufferPointerv_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferPointerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferPointerv_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr) :=
    z_GetNamedBufferPointerv_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferPointerv_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer);
    external 'opengl32.dll' name 'glGetNamedBufferPointerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointerv(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer) :=
    z_GetNamedBufferPointerv_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetNamedBufferSubData_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubData(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubData_ovr_0(buffer, offset, size, data);
    
    private static procedure z_CreateFramebuffers_ovr_0(n: Int32; var framebuffers: UInt32);
    external 'opengl32.dll' name 'glCreateFramebuffers';
    private static procedure z_CreateFramebuffers_ovr_0_anh001(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glCreateFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_CreateFramebuffers_ovr_0(n, framebuffers[0]) else
      z_CreateFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_CreateFramebuffers_ovr_0(n, framebuffers);
    private static procedure z_CreateFramebuffers_ovr_2(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glCreateFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_CreateFramebuffers_ovr_2(n, framebuffers);
    
    private static procedure z_NamedFramebufferRenderbuffer_ovr_0(framebuffer: FramebufferName; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName);
    external 'opengl32.dll' name 'glNamedFramebufferRenderbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbuffer(framebuffer: FramebufferName; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_NamedFramebufferRenderbuffer_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    private static procedure z_NamedFramebufferParameteri_ovr_0(framebuffer: FramebufferName; pname: FramebufferParameterName; param: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteri(framebuffer: FramebufferName; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteri_ovr_0(framebuffer, pname, param);
    
    private static procedure z_NamedFramebufferTexture_ovr_0(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTexture';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32) :=
    z_NamedFramebufferTexture_ovr_0(framebuffer, attachment, texture, level);
    
    private static procedure z_NamedFramebufferTextureLayer_ovr_0(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTextureLayer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayer(framebuffer: FramebufferName; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayer_ovr_0(framebuffer, attachment, texture, level, layer);
    
    private static procedure z_NamedFramebufferDrawBuffer_ovr_0(framebuffer: FramebufferName; buf: ColorBuffer);
    external 'opengl32.dll' name 'glNamedFramebufferDrawBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffer(framebuffer: FramebufferName; buf: ColorBuffer) :=
    z_NamedFramebufferDrawBuffer_ovr_0(framebuffer, buf);
    
    private static procedure z_NamedFramebufferDrawBuffers_ovr_0(framebuffer: UInt32; n: Int32; var bufs: ColorBuffer);
    external 'opengl32.dll' name 'glNamedFramebufferDrawBuffers';
    private static procedure z_NamedFramebufferDrawBuffers_ovr_0_anh0001(framebuffer: UInt32; n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferDrawBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; bufs: array of ColorBuffer) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs[0]) else
      z_NamedFramebufferDrawBuffers_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; var bufs: ColorBuffer) :=
    z_NamedFramebufferDrawBuffers_ovr_0(framebuffer, n, bufs);
    private static procedure z_NamedFramebufferDrawBuffers_ovr_2(framebuffer: UInt32; n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferDrawBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferDrawBuffers(framebuffer: UInt32; n: Int32; bufs: IntPtr) :=
    z_NamedFramebufferDrawBuffers_ovr_2(framebuffer, n, bufs);
    
    private static procedure z_NamedFramebufferReadBuffer_ovr_0(framebuffer: FramebufferName; src: ColorBuffer);
    external 'opengl32.dll' name 'glNamedFramebufferReadBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferReadBuffer(framebuffer: FramebufferName; src: ColorBuffer) :=
    z_NamedFramebufferReadBuffer_ovr_0(framebuffer, src);
    
    private static procedure z_InvalidateNamedFramebufferData_ovr_0(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferData';
    private static procedure z_InvalidateNamedFramebufferData_ovr_0_anh0001(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; attachments: array of FramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments[0]) else
      z_InvalidateNamedFramebufferData_ovr_0_anh0001(framebuffer, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment) :=
    z_InvalidateNamedFramebufferData_ovr_0(framebuffer, numAttachments, attachments);
    private static procedure z_InvalidateNamedFramebufferData_ovr_2(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferData(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateNamedFramebufferData_ovr_2(framebuffer, numAttachments, attachments);
    
    private static procedure z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferSubData';
    private static procedure z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; attachments: array of FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateNamedFramebufferSubData_ovr_0_anh00010000(framebuffer, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; var attachments: FramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_0(framebuffer, numAttachments, attachments, x, y, width, height);
    private static procedure z_InvalidateNamedFramebufferSubData_ovr_2(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateNamedFramebufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateNamedFramebufferSubData(framebuffer: UInt32; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateNamedFramebufferSubData_ovr_2(framebuffer, numAttachments, attachments, x, y, width, height);
    
    private static procedure z_ClearNamedFramebufferiv_ovr_0(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: Int32);
    external 'opengl32.dll' name 'glClearNamedFramebufferiv';
    private static procedure z_ClearNamedFramebufferiv_ovr_0_anh00001(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: Int32) :=
    z_ClearNamedFramebufferiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private static procedure z_ClearNamedFramebufferiv_ovr_2(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private static procedure z_ClearNamedFramebufferuiv_ovr_0(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glClearNamedFramebufferuiv';
    private static procedure z_ClearNamedFramebufferuiv_ovr_0_anh00001(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferuiv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: UInt32) :=
    z_ClearNamedFramebufferuiv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private static procedure z_ClearNamedFramebufferuiv_ovr_2(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferuiv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferuiv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private static procedure z_ClearNamedFramebufferfv_ovr_0(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: single);
    external 'opengl32.dll' name 'glClearNamedFramebufferfv';
    private static procedure z_ClearNamedFramebufferfv_ovr_0_anh00001(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value[0]) else
      z_ClearNamedFramebufferfv_ovr_0_anh00001(framebuffer, _buffer, drawbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; var value: single) :=
    z_ClearNamedFramebufferfv_ovr_0(framebuffer, _buffer, drawbuffer, value);
    private static procedure z_ClearNamedFramebufferfv_ovr_2(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glClearNamedFramebufferfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfv(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; value: IntPtr) :=
    z_ClearNamedFramebufferfv_ovr_2(framebuffer, _buffer, drawbuffer, value);
    
    private static procedure z_ClearNamedFramebufferfi_ovr_0(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32);
    external 'opengl32.dll' name 'glClearNamedFramebufferfi';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedFramebufferfi(framebuffer: UInt32; _buffer: Buffer; drawbuffer: Int32; depth: single; stencil: Int32) :=
    z_ClearNamedFramebufferfi_ovr_0(framebuffer, _buffer, drawbuffer, depth, stencil);
    
    private static procedure z_BlitNamedFramebuffer_ovr_0(readFramebuffer: UInt32; drawFramebuffer: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter);
    external 'opengl32.dll' name 'glBlitNamedFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitNamedFramebuffer(readFramebuffer: UInt32; drawFramebuffer: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitNamedFramebuffer_ovr_0(readFramebuffer, drawFramebuffer, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private static function z_CheckNamedFramebufferStatus_ovr_0(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus;
    external 'opengl32.dll' name 'glCheckNamedFramebufferStatus';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatus(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatus_ovr_0(framebuffer, target);
    
    private static procedure z_GetNamedFramebufferParameteriv_ovr_0(framebuffer: UInt32; pname: GetFramebufferParameter; var param: Int32);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameteriv';
    private static procedure z_GetNamedFramebufferParameteriv_ovr_0_anh0001(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param[0]) else
      z_GetNamedFramebufferParameteriv_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; var param: Int32) :=
    z_GetNamedFramebufferParameteriv_ovr_0(framebuffer, pname, param);
    private static procedure z_GetNamedFramebufferParameteriv_ovr_2(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameteriv(framebuffer: UInt32; pname: GetFramebufferParameter; param: IntPtr) :=
    z_GetNamedFramebufferParameteriv_ovr_2(framebuffer, pname, param);
    
    private static procedure z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameteriv';
    private static procedure z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameteriv_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_0(framebuffer, attachment, pname, &params);
    private static procedure z_GetNamedFramebufferAttachmentParameteriv_ovr_2(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameteriv(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameteriv_ovr_2(framebuffer, attachment, pname, &params);
    
    private static procedure z_CreateRenderbuffers_ovr_0(n: Int32; var renderbuffers: UInt32);
    external 'opengl32.dll' name 'glCreateRenderbuffers';
    private static procedure z_CreateRenderbuffers_ovr_0_anh001(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glCreateRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_CreateRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_CreateRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_CreateRenderbuffers_ovr_0(n, renderbuffers);
    private static procedure z_CreateRenderbuffers_ovr_2(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glCreateRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_CreateRenderbuffers_ovr_2(n, renderbuffers);
    
    private static procedure z_NamedRenderbufferStorage_ovr_0(renderbuffer: RenderbufferName; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorage(renderbuffer: RenderbufferName; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorage_ovr_0(renderbuffer, _internalformat, width, height);
    
    private static procedure z_NamedRenderbufferStorageMultisample_ovr_0(renderbuffer: RenderbufferName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorageMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisample(renderbuffer: RenderbufferName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisample_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    private static procedure z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameteriv';
    private static procedure z_GetNamedRenderbufferParameteriv_ovr_0_anh0001(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameteriv_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameteriv_ovr_0(renderbuffer, pname, &params);
    private static procedure z_GetNamedRenderbufferParameteriv_ovr_2(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameteriv(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameteriv_ovr_2(renderbuffer, pname, &params);
    
    private static procedure z_CreateTextures_ovr_0(target: TextureTarget; n: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glCreateTextures';
    private static procedure z_CreateTextures_ovr_0_anh0001(target: TextureTarget; n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glCreateTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_CreateTextures_ovr_0(target, n, textures[0]) else
      z_CreateTextures_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; var textures: UInt32) :=
    z_CreateTextures_ovr_0(target, n, textures);
    private static procedure z_CreateTextures_ovr_2(target: TextureTarget; n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glCreateTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateTextures(target: TextureTarget; n: Int32; textures: IntPtr) :=
    z_CreateTextures_ovr_2(target, n, textures);
    
    private static procedure z_TextureBuffer_ovr_0(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName);
    external 'opengl32.dll' name 'glTextureBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBuffer(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName) :=
    z_TextureBuffer_ovr_0(texture, _internalformat, buffer);
    
    private static procedure z_TextureBufferRange_ovr_0(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glTextureBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRange(texture: TextureName; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRange_ovr_0(texture, _internalformat, buffer, offset, size);
    
    private static procedure z_TextureStorage1D_ovr_0(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32);
    external 'opengl32.dll' name 'glTextureStorage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32) :=
    z_TextureStorage1D_ovr_0(texture, levels, _internalformat, width);
    
    private static procedure z_TextureStorage2D_ovr_0(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glTextureStorage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2D_ovr_0(texture, levels, _internalformat, width, height);
    
    private static procedure z_TextureStorage3D_ovr_0(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glTextureStorage3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3D(texture: TextureName; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3D_ovr_0(texture, levels, _internalformat, width, height, depth);
    
    private static procedure z_TextureStorage2DMultisample_ovr_0(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTextureStorage2DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisample(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisample_ovr_0(texture, samples, _internalformat, width, height, fixedsamplelocations);
    
    private static procedure z_TextureStorage3DMultisample_ovr_0(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTextureStorage3DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisample(texture: TextureName; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisample_ovr_0(texture, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    private static procedure z_TextureSubImage1D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1D(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1D_ovr_0(texture, level, xoffset, width, format, &type, pixels);
    
    private static procedure z_TextureSubImage2D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private static procedure z_TextureSubImage3D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private static procedure z_CompressedTextureSubImage1D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1D(texture: UInt32; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage1D_ovr_0(texture, level, xoffset, width, format, imageSize, data);
    
    private static procedure z_CompressedTextureSubImage2D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    private static procedure z_CompressedTextureSubImage3D_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3D(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    private static procedure z_CopyTextureSubImage1D_ovr_0(texture: TextureName; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1D(texture: TextureName; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1D_ovr_0(texture, level, xoffset, x, y, width);
    
    private static procedure z_CopyTextureSubImage2D_ovr_0(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2D(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2D_ovr_0(texture, level, xoffset, yoffset, x, y, width, height);
    
    private static procedure z_CopyTextureSubImage3D_ovr_0(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3D(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3D_ovr_0(texture, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private static procedure z_TextureParameterf_ovr_0(texture: TextureName; pname: TextureParameterName; param: single);
    external 'opengl32.dll' name 'glTextureParameterf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterf(texture: TextureName; pname: TextureParameterName; param: single) :=
    z_TextureParameterf_ovr_0(texture, pname, param);
    
    private static procedure z_TextureParameterfv_ovr_0(texture: UInt32; pname: TextureParameterName; var param: single);
    external 'opengl32.dll' name 'glTextureParameterfv';
    private static procedure z_TextureParameterfv_ovr_0_anh0001(texture: UInt32; pname: TextureParameterName; param: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameterfv_ovr_0(texture, pname, param[0]) else
      z_TextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; var param: single) :=
    z_TextureParameterfv_ovr_0(texture, pname, param);
    private static procedure z_TextureParameterfv_ovr_2(texture: UInt32; pname: TextureParameterName; param: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfv(texture: UInt32; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameterfv_ovr_2(texture, pname, param);
    
    private static procedure z_TextureParameteri_ovr_0(texture: UInt32; pname: TextureParameterName; param: Int32);
    external 'opengl32.dll' name 'glTextureParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteri(texture: UInt32; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteri_ovr_0(texture, pname, param);
    
    private static procedure z_TextureParameterIiv_ovr_0(texture: UInt32; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glTextureParameterIiv';
    private static procedure z_TextureParameterIiv_ovr_0_anh0001(texture: UInt32; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIiv_ovr_0(texture, pname, &params);
    private static procedure z_TextureParameterIiv_ovr_2(texture: UInt32; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIiv(texture: UInt32; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIiv_ovr_2(texture, pname, &params);
    
    private static procedure z_TextureParameterIuiv_ovr_0(texture: UInt32; pname: TextureParameterName; var &params: UInt32);
    external 'opengl32.dll' name 'glTextureParameterIuiv';
    private static procedure z_TextureParameterIuiv_ovr_0_anh0001(texture: UInt32; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_TextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuiv_ovr_0(texture, pname, &params);
    private static procedure z_TextureParameterIuiv_ovr_2(texture: UInt32; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuiv(texture: UInt32; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuiv_ovr_2(texture, pname, &params);
    
    private static procedure z_TextureParameteriv_ovr_0(texture: UInt32; pname: TextureParameterName; var param: Int32);
    external 'opengl32.dll' name 'glTextureParameteriv';
    private static procedure z_TextureParameteriv_ovr_0_anh0001(texture: UInt32; pname: TextureParameterName; param: IntPtr);
    external 'opengl32.dll' name 'glTextureParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TextureParameteriv_ovr_0(texture, pname, param[0]) else
      z_TextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; var param: Int32) :=
    z_TextureParameteriv_ovr_0(texture, pname, param);
    private static procedure z_TextureParameteriv_ovr_2(texture: UInt32; pname: TextureParameterName; param: IntPtr);
    external 'opengl32.dll' name 'glTextureParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriv(texture: UInt32; pname: TextureParameterName; param: IntPtr) :=
    z_TextureParameteriv_ovr_2(texture, pname, param);
    
    private static procedure z_GenerateTextureMipmap_ovr_0(texture: TextureName);
    external 'opengl32.dll' name 'glGenerateTextureMipmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmap(texture: TextureName) :=
    z_GenerateTextureMipmap_ovr_0(texture);
    
    private static procedure z_BindTextureUnit_ovr_0(&unit: UInt32; texture: TextureName);
    external 'opengl32.dll' name 'glBindTextureUnit';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureUnit(&unit: UInt32; texture: TextureName) :=
    z_BindTextureUnit_ovr_0(&unit, texture);
    
    private static procedure z_GetTextureImage_ovr_0(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetTextureImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImage(texture: UInt32; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureImage_ovr_0(texture, level, format, &type, bufSize, pixels);
    
    private static procedure z_GetCompressedTextureImage_ovr_0(texture: UInt32; level: Int32; bufSize: Int32; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetCompressedTextureImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImage(texture: UInt32; level: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureImage_ovr_0(texture, level, bufSize, pixels);
    
    private static procedure z_GetTextureLevelParameterfv_ovr_0(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfv';
    private static procedure z_GetTextureLevelParameterfv_ovr_0_anh00001(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameterfv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfv_ovr_0(texture, level, pname, &params);
    private static procedure z_GetTextureLevelParameterfv_ovr_2(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfv_ovr_2(texture, level, pname, &params);
    
    private static procedure z_GetTextureLevelParameteriv_ovr_0(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureLevelParameteriv';
    private static procedure z_GetTextureLevelParameteriv_ovr_0_anh00001(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params[0]) else
      z_GetTextureLevelParameteriv_ovr_0_anh00001(texture, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameteriv_ovr_0(texture, level, pname, &params);
    private static procedure z_GetTextureLevelParameteriv_ovr_2(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameteriv(texture: UInt32; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameteriv_ovr_2(texture, level, pname, &params);
    
    private static procedure z_GetTextureParameterfv_ovr_0(texture: UInt32; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTextureParameterfv';
    private static procedure z_GetTextureParameterfv_ovr_0_anh0001(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterfv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfv_ovr_0(texture, pname, &params);
    private static procedure z_GetTextureParameterfv_ovr_2(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfv_ovr_2(texture, pname, &params);
    
    private static procedure z_GetTextureParameterIiv_ovr_0(texture: UInt32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureParameterIiv';
    private static procedure z_GetTextureParameterIiv_ovr_0_anh0001(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIiv_ovr_0(texture, pname, &params);
    private static procedure z_GetTextureParameterIiv_ovr_2(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIiv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIiv_ovr_2(texture, pname, &params);
    
    private static procedure z_GetTextureParameterIuiv_ovr_0(texture: UInt32; pname: GetTextureParameter; var &params: UInt32);
    external 'opengl32.dll' name 'glGetTextureParameterIuiv';
    private static procedure z_GetTextureParameterIuiv_ovr_0_anh0001(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuiv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameterIuiv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuiv_ovr_0(texture, pname, &params);
    private static procedure z_GetTextureParameterIuiv_ovr_2(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuiv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuiv_ovr_2(texture, pname, &params);
    
    private static procedure z_GetTextureParameteriv_ovr_0(texture: UInt32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureParameteriv';
    private static procedure z_GetTextureParameteriv_ovr_0_anh0001(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameteriv_ovr_0(texture, pname, &params[0]) else
      z_GetTextureParameteriv_ovr_0_anh0001(texture, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameteriv_ovr_0(texture, pname, &params);
    private static procedure z_GetTextureParameteriv_ovr_2(texture: UInt32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameteriv(texture: UInt32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameteriv_ovr_2(texture, pname, &params);
    
    private static procedure z_CreateVertexArrays_ovr_0(n: Int32; var arrays: UInt32);
    external 'opengl32.dll' name 'glCreateVertexArrays';
    private static procedure z_CreateVertexArrays_ovr_0_anh001(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glCreateVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_CreateVertexArrays_ovr_0(n, arrays[0]) else
      z_CreateVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; var arrays: UInt32) :=
    z_CreateVertexArrays_ovr_0(n, arrays);
    private static procedure z_CreateVertexArrays_ovr_2(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glCreateVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateVertexArrays(n: Int32; arrays: IntPtr) :=
    z_CreateVertexArrays_ovr_2(n, arrays);
    
    private static procedure z_DisableVertexArrayAttrib_ovr_0(vaobj: VertexArrayName; index: UInt32);
    external 'opengl32.dll' name 'glDisableVertexArrayAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttrib(vaobj: VertexArrayName; index: UInt32) :=
    z_DisableVertexArrayAttrib_ovr_0(vaobj, index);
    
    private static procedure z_EnableVertexArrayAttrib_ovr_0(vaobj: VertexArrayName; index: UInt32);
    external 'opengl32.dll' name 'glEnableVertexArrayAttrib';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttrib(vaobj: VertexArrayName; index: UInt32) :=
    z_EnableVertexArrayAttrib_ovr_0(vaobj, index);
    
    private static procedure z_VertexArrayElementBuffer_ovr_0(vaobj: VertexArrayName; buffer: BufferName);
    external 'opengl32.dll' name 'glVertexArrayElementBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayElementBuffer(vaobj: VertexArrayName; buffer: BufferName) :=
    z_VertexArrayElementBuffer_ovr_0(vaobj, buffer);
    
    private static procedure z_VertexArrayVertexBuffer_ovr_0(vaobj: VertexArrayName; bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffer(vaobj: VertexArrayName; bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32) :=
    z_VertexArrayVertexBuffer_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    private static procedure z_VertexArrayVertexBuffers_ovr_0(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_0_anh0000111(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_VertexArrayVertexBuffers_ovr_0_anh0000111(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_VertexArrayVertexBuffers_ovr_1_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_1_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_1_anh0000110(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_2(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_2_anh0000110(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets[0], strides) else
        z_VertexArrayVertexBuffers_ovr_2_anh0000110(vaobj, first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_3_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_3_anh0000101(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_VertexArrayVertexBuffers_ovr_4_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_5_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_6(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_6_anh0000101(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_6_anh0000101(vaobj, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_VertexArrayVertexBuffers_ovr_7_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_8(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_8_anh0000100(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers[0], offsets, strides) else
      z_VertexArrayVertexBuffers_ovr_8_anh0000100(vaobj, first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_9_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_9_anh0000011(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_0_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_VertexArrayVertexBuffers_ovr_10_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_11_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_2_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_0_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_0(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_2(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_6_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_6(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_8(vaobj, first, count, buffers, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_18(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_18_anh0000011(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides[0]) else
        z_VertexArrayVertexBuffers_ovr_18_anh0000011(vaobj, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_VertexArrayVertexBuffers_ovr_19_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_20(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_20_anh0000010(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets[0], strides) else
      z_VertexArrayVertexBuffers_ovr_20_anh0000010(vaobj, first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_18_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_18(vaobj, first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_20(vaobj, first, count, buffers, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_24(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    private static procedure z_VertexArrayVertexBuffers_ovr_24_anh0000001(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides[0]) else
      z_VertexArrayVertexBuffers_ovr_24_anh0000001(vaobj, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_VertexArrayVertexBuffers_ovr_24(vaobj, first, count, buffers, offsets, strides);
    private static procedure z_VertexArrayVertexBuffers_ovr_26(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBuffers(vaobj: UInt32; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_VertexArrayVertexBuffers_ovr_26(vaobj, first, count, buffers, offsets, strides);
    
    private static procedure z_VertexArrayAttribBinding_ovr_0(vaobj: VertexArrayName; attribindex: UInt32; bindingindex: UInt32);
    external 'opengl32.dll' name 'glVertexArrayAttribBinding';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribBinding(vaobj: VertexArrayName; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayAttribBinding_ovr_0(vaobj, attribindex, bindingindex);
    
    private static procedure z_VertexArrayAttribFormat_ovr_0(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayAttribFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayAttribFormat_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    private static procedure z_VertexArrayAttribIFormat_ovr_0(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayAttribIFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribIFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayAttribIFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexArrayAttribLFormat_ovr_0(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayAttribLFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayAttribLFormat(vaobj: VertexArrayName; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayAttribLFormat_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexArrayBindingDivisor_ovr_0(vaobj: VertexArrayName; bindingindex: UInt32; divisor: UInt32);
    external 'opengl32.dll' name 'glVertexArrayBindingDivisor';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindingDivisor(vaobj: VertexArrayName; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayBindingDivisor_ovr_0(vaobj, bindingindex, divisor);
    
    private static procedure z_GetVertexArrayiv_ovr_0(vaobj: UInt32; pname: VertexArrayPName; var param: Int32);
    external 'opengl32.dll' name 'glGetVertexArrayiv';
    private static procedure z_GetVertexArrayiv_ovr_0_anh0001(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayiv_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayiv_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayiv_ovr_0(vaobj, pname, param);
    private static procedure z_GetVertexArrayiv_ovr_2(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayiv(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayiv_ovr_2(vaobj, pname, param);
    
    private static procedure z_GetVertexArrayIndexediv_ovr_0(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32);
    external 'opengl32.dll' name 'glGetVertexArrayIndexediv';
    private static procedure z_GetVertexArrayIndexediv_ovr_0_anh00001(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIndexediv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexediv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIndexediv_ovr_0(vaobj, index, pname, param);
    private static procedure z_GetVertexArrayIndexediv_ovr_2(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIndexediv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexediv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexediv_ovr_2(vaobj, index, pname, param);
    
    private static procedure z_GetVertexArrayIndexed64iv_ovr_0(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int64);
    external 'opengl32.dll' name 'glGetVertexArrayIndexed64iv';
    private static procedure z_GetVertexArrayIndexed64iv_ovr_0_anh00001(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIndexed64iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of Int64) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIndexed64iv_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int64) :=
    z_GetVertexArrayIndexed64iv_ovr_0(vaobj, index, pname, param);
    private static procedure z_GetVertexArrayIndexed64iv_ovr_2(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIndexed64iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIndexed64iv(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIndexed64iv_ovr_2(vaobj, index, pname, param);
    
    private static procedure z_CreateSamplers_ovr_0(n: Int32; var samplers: UInt32);
    external 'opengl32.dll' name 'glCreateSamplers';
    private static procedure z_CreateSamplers_ovr_0_anh001(n: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glCreateSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_CreateSamplers_ovr_0(n, samplers[0]) else
      z_CreateSamplers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; var samplers: UInt32) :=
    z_CreateSamplers_ovr_0(n, samplers);
    private static procedure z_CreateSamplers_ovr_2(n: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glCreateSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateSamplers(n: Int32; samplers: IntPtr) :=
    z_CreateSamplers_ovr_2(n, samplers);
    
    private static procedure z_CreateProgramPipelines_ovr_0(n: Int32; var pipelines: UInt32);
    external 'opengl32.dll' name 'glCreateProgramPipelines';
    private static procedure z_CreateProgramPipelines_ovr_0_anh001(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glCreateProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_CreateProgramPipelines_ovr_0(n, pipelines[0]) else
      z_CreateProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_CreateProgramPipelines_ovr_0(n, pipelines);
    private static procedure z_CreateProgramPipelines_ovr_2(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glCreateProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_CreateProgramPipelines_ovr_2(n, pipelines);
    
    private static procedure z_CreateQueries_ovr_0(target: QueryTarget; n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glCreateQueries';
    private static procedure z_CreateQueries_ovr_0_anh0001(target: QueryTarget; n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glCreateQueries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_CreateQueries_ovr_0(target, n, ids[0]) else
      z_CreateQueries_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; var ids: UInt32) :=
    z_CreateQueries_ovr_0(target, n, ids);
    private static procedure z_CreateQueries_ovr_2(target: QueryTarget; n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glCreateQueries';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateQueries(target: QueryTarget; n: Int32; ids: IntPtr) :=
    z_CreateQueries_ovr_2(target, n, ids);
    
    private static procedure z_GetQueryBufferObjecti64v_ovr_0(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr);
    external 'opengl32.dll' name 'glGetQueryBufferObjecti64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjecti64v(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjecti64v_ovr_0(id, buffer, pname, offset);
    
    private static procedure z_GetQueryBufferObjectiv_ovr_0(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr);
    external 'opengl32.dll' name 'glGetQueryBufferObjectiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectiv(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectiv_ovr_0(id, buffer, pname, offset);
    
    private static procedure z_GetQueryBufferObjectui64v_ovr_0(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr);
    external 'opengl32.dll' name 'glGetQueryBufferObjectui64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectui64v(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectui64v_ovr_0(id, buffer, pname, offset);
    
    private static procedure z_GetQueryBufferObjectuiv_ovr_0(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr);
    external 'opengl32.dll' name 'glGetQueryBufferObjectuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryBufferObjectuiv(id: QueryName; buffer: BufferName; pname: QueryObjectParameterName; offset: IntPtr) :=
    z_GetQueryBufferObjectuiv_ovr_0(id, buffer, pname, offset);
    
  end;
  
  glDrawBuffersARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawBuffersARB_ovr_0(n: Int32; var bufs: DrawBufferMode);
    external 'opengl32.dll' name 'glDrawBuffersARB';
    private static procedure z_DrawBuffersARB_ovr_0_anh001(n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glDrawBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffersARB_ovr_0(n, bufs[0]) else
      z_DrawBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffersARB_ovr_0(n, bufs);
    private static procedure z_DrawBuffersARB_ovr_2(n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glDrawBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersARB(n: Int32; bufs: IntPtr) :=
    z_DrawBuffersARB_ovr_2(n, bufs);
    
  end;
  
  glDrawBuffersBlendARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendEquationiARB_ovr_0(buf: UInt32; mode: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationiARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationiARB(buf: UInt32; mode: BlendEquationModeEXT) :=
    z_BlendEquationiARB_ovr_0(buf, mode);
    
    private static procedure z_BlendEquationSeparateiARB_ovr_0(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationSeparateiARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateiARB(buf: UInt32; modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateiARB_ovr_0(buf, modeRGB, modeAlpha);
    
    private static procedure z_BlendFunciARB_ovr_0(buf: UInt32; src: BlendingFactor; dst: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFunciARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFunciARB(buf: UInt32; src: BlendingFactor; dst: BlendingFactor) :=
    z_BlendFunciARB_ovr_0(buf, src, dst);
    
    private static procedure z_BlendFuncSeparateiARB_ovr_0(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFuncSeparateiARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateiARB(buf: UInt32; srcRGB: BlendingFactor; dstRGB: BlendingFactor; srcAlpha: BlendingFactor; dstAlpha: BlendingFactor) :=
    z_BlendFuncSeparateiARB_ovr_0(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
    
  end;
  
  glDrawElementsBaseVertexARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawElementsBaseVertex_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32);
    external 'opengl32.dll' name 'glDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawElementsBaseVertex_ovr_0(mode, count, &type, indices, basevertex);
    
    private static procedure z_DrawRangeElementsBaseVertex_ovr_0(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32);
    external 'opengl32.dll' name 'glDrawRangeElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsBaseVertex(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr; basevertex: Int32) :=
    z_DrawRangeElementsBaseVertex_ovr_0(mode, start, &end, count, &type, indices, basevertex);
    
    private static procedure z_DrawElementsInstancedBaseVertex_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32);
    external 'opengl32.dll' name 'glDrawElementsInstancedBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedBaseVertex(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; instancecount: Int32; basevertex: Int32) :=
    z_DrawElementsInstancedBaseVertex_ovr_0(mode, count, &type, indices, instancecount, basevertex);
    
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_0_anh0010101(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count[0], &type, IntPtr.Zero, drawcount, IntPtr.Zero) else
      if (indices<>nil) and (indices.Length<>0) then
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices[0], drawcount, IntPtr.Zero) else
        if (basevertex<>nil) and (basevertex.Length<>0) then
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex[0]) else
          z_MultiDrawElementsBaseVertex_ovr_0_anh0010101(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_1_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_1_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_1_anh0010100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_2(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_2_anh0010100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count[0], &type, IntPtr.Zero, drawcount, basevertex) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices[0], drawcount, basevertex) else
        z_MultiDrawElementsBaseVertex_ovr_2_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_3_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_3_anh0010001(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_4_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_5_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_6(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_6_anh0010001(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count[0], &type, indices, drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_6_anh0010001(mode, IntPtr.Zero, &type, indices, drawcount, IntPtr.Zero);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_7_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_8(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_8_anh0010000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_8(mode, count[0], &type, indices, drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_8_anh0010000(mode, IntPtr.Zero, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_9_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_9_anh0000101(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_0_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_10_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_11_anh0000100(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_2_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_0_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_0(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_2(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_6_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_6(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_8(mode, count, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_18(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_18_anh0000101(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices[0], drawcount, IntPtr.Zero) else
      if (basevertex<>nil) and (basevertex.Length<>0) then
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex[0]) else
        z_MultiDrawElementsBaseVertex_ovr_18_anh0000101(mode, count, &type, IntPtr.Zero, drawcount, IntPtr.Zero);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_19_anh0000100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; var basevertex: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_20(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_20_anh0000100(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices[0], drawcount, basevertex) else
      z_MultiDrawElementsBaseVertex_ovr_20_anh0000100(mode, count, &type, IntPtr.Zero, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_18_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_18(mode, count, &type, indices, drawcount, basevertex);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_20(mode, count, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_24(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    private static procedure z_MultiDrawElementsBaseVertex_ovr_24_anh0000001(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: array of Int32) :=
    if (basevertex<>nil) and (basevertex.Length<>0) then
      z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex[0]) else
      z_MultiDrawElementsBaseVertex_ovr_24_anh0000001(mode, count, &type, indices, drawcount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; var basevertex: Int32) :=
    z_MultiDrawElementsBaseVertex_ovr_24(mode, count, &type, indices, drawcount, basevertex);
    private static procedure z_MultiDrawElementsBaseVertex_ovr_26(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr);
    external 'opengl32.dll' name 'glMultiDrawElementsBaseVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsBaseVertex(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; drawcount: Int32; basevertex: IntPtr) :=
    z_MultiDrawElementsBaseVertex_ovr_26(mode, count, &type, indices, drawcount, basevertex);
    
  end;
  
  glDrawIndirectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawArraysIndirect_ovr_0(mode: PrimitiveType; indirect: IntPtr);
    external 'opengl32.dll' name 'glDrawArraysIndirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr) :=
    z_DrawArraysIndirect_ovr_0(mode, indirect);
    
    private static procedure z_DrawElementsIndirect_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr);
    external 'opengl32.dll' name 'glDrawElementsIndirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr) :=
    z_DrawElementsIndirect_ovr_0(mode, &type, indirect);
    
  end;
  
  glDrawInstancedARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawArraysInstancedARB_ovr_0(mode: PrimitiveType; first: Int32; count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glDrawArraysInstancedARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedARB(mode: PrimitiveType; first: Int32; count: Int32; primcount: Int32) :=
    z_DrawArraysInstancedARB_ovr_0(mode, first, count, primcount);
    
    private static procedure z_DrawElementsInstancedARB_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glDrawElementsInstancedARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedARB(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32) :=
    z_DrawElementsInstancedARB_ovr_0(mode, count, &type, indices, primcount);
    
  end;
  
  glFragmentProgramARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramStringARB_ovr_0(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr);
    external 'opengl32.dll' name 'glProgramStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramStringARB(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_ProgramStringARB_ovr_0(target, format, len, string);
    
    private static procedure z_BindProgramARB_ovr_0(target: ProgramTarget; &program: UInt32);
    external 'opengl32.dll' name 'glBindProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramARB(target: ProgramTarget; &program: UInt32) :=
    z_BindProgramARB_ovr_0(target, &program);
    
    private static procedure z_DeleteProgramsARB_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    private static procedure z_DeleteProgramsARB_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsARB_ovr_0(n, programs[0]) else
      z_DeleteProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; var programs: UInt32) :=
    z_DeleteProgramsARB_ovr_0(n, programs);
    private static procedure z_DeleteProgramsARB_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsARB_ovr_2(n, programs);
    
    private static procedure z_GenProgramsARB_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glGenProgramsARB';
    private static procedure z_GenProgramsARB_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsARB_ovr_0(n, programs[0]) else
      z_GenProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; var programs: UInt32) :=
    z_GenProgramsARB_ovr_0(n, programs);
    private static procedure z_GenProgramsARB_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: IntPtr) :=
    z_GenProgramsARB_ovr_2(n, programs);
    
    private static procedure z_ProgramEnvParameter4dARB_ovr_0(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramEnvParameter4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramEnvParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameter4dvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    private static procedure z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameter4dvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4dvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramEnvParameter4fARB_ovr_0(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramEnvParameter4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramEnvParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameter4fvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    private static procedure z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameter4fvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4fvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParameter4dARB_ovr_0(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramLocalParameter4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramLocalParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameter4dvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    private static procedure z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameter4dvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4dvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParameter4fARB_ovr_0(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramLocalParameter4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramLocalParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameter4fvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    private static procedure z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameter4fvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4fvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterdvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    private static procedure z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterdvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterdvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterfvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    private static procedure z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterfvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterfvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramLocalParameterdvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    private static procedure z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterdvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterdvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramLocalParameterfvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    private static procedure z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterfvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterfvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramivARB_ovr_0(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramivARB';
    private static procedure z_GetProgramivARB_ovr_0_anh0001(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramivARB_ovr_0(target, pname, &params[0]) else
      z_GetProgramivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramivARB_ovr_0(target, pname, &params);
    private static procedure z_GetProgramivARB_ovr_2(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramivARB_ovr_2(target, pname, &params);
    
    private static procedure z_GetProgramStringARB_ovr_0(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringARB(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetProgramStringARB_ovr_0(target, pname, string);
    
    private static function z_IsProgramARB_ovr_0(&program: UInt32): boolean;
    external 'opengl32.dll' name 'glIsProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramARB(&program: UInt32): boolean :=
    z_IsProgramARB_ovr_0(&program);
    
  end;
  
  glFramebufferNoAttachmentsARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferParameteri_ovr_0(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32);
    external 'opengl32.dll' name 'glFramebufferParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteri(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteri_ovr_0(target, pname, param);
    
    private static procedure z_GetFramebufferParameteriv_ovr_0(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetFramebufferParameteriv';
    private static procedure z_GetFramebufferParameteriv_ovr_0_anh0001(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetFramebufferParameteriv_ovr_2(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameteriv(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameteriv_ovr_2(target, pname, &params);
    
  end;
  
  glFramebufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_IsRenderbuffer_ovr_0(renderbuffer: RenderbufferName): boolean;
    external 'opengl32.dll' name 'glIsRenderbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbuffer(renderbuffer: RenderbufferName): boolean :=
    z_IsRenderbuffer_ovr_0(renderbuffer);
    
    private static procedure z_BindRenderbuffer_ovr_0(target: RenderbufferTarget; renderbuffer: RenderbufferName);
    external 'opengl32.dll' name 'glBindRenderbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbuffer(target: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_BindRenderbuffer_ovr_0(target, renderbuffer);
    
    private static procedure z_DeleteRenderbuffers_ovr_0(n: Int32; var renderbuffers: UInt32);
    external 'opengl32.dll' name 'glDeleteRenderbuffers';
    private static procedure z_DeleteRenderbuffers_ovr_0_anh001(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_DeleteRenderbuffers_ovr_0(n, renderbuffers);
    private static procedure z_DeleteRenderbuffers_ovr_2(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffers_ovr_2(n, renderbuffers);
    
    private static procedure z_GenRenderbuffers_ovr_0(n: Int32; var renderbuffers: UInt32);
    external 'opengl32.dll' name 'glGenRenderbuffers';
    private static procedure z_GenRenderbuffers_ovr_0_anh001(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glGenRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffers_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; var renderbuffers: UInt32) :=
    z_GenRenderbuffers_ovr_0(n, renderbuffers);
    private static procedure z_GenRenderbuffers_ovr_2(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glGenRenderbuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffers(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffers_ovr_2(n, renderbuffers);
    
    private static procedure z_RenderbufferStorage_ovr_0(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorage(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorage_ovr_0(target, _internalformat, width, height);
    
    private static procedure z_GetRenderbufferParameteriv_ovr_0(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetRenderbufferParameteriv';
    private static procedure z_GetRenderbufferParameteriv_ovr_0_anh0001(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetRenderbufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetRenderbufferParameteriv_ovr_2(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetRenderbufferParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameteriv(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameteriv_ovr_2(target, pname, &params);
    
    private static function z_IsFramebuffer_ovr_0(framebuffer: FramebufferName): boolean;
    external 'opengl32.dll' name 'glIsFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebuffer(framebuffer: FramebufferName): boolean :=
    z_IsFramebuffer_ovr_0(framebuffer);
    
    private static procedure z_BindFramebuffer_ovr_0(target: FramebufferTarget; framebuffer: FramebufferName);
    external 'opengl32.dll' name 'glBindFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebuffer(target: FramebufferTarget; framebuffer: FramebufferName) :=
    z_BindFramebuffer_ovr_0(target, framebuffer);
    
    private static procedure z_DeleteFramebuffers_ovr_0(n: Int32; var framebuffers: UInt32);
    external 'opengl32.dll' name 'glDeleteFramebuffers';
    private static procedure z_DeleteFramebuffers_ovr_0_anh001(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffers_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_DeleteFramebuffers_ovr_0(n, framebuffers);
    private static procedure z_DeleteFramebuffers_ovr_2(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffers_ovr_2(n, framebuffers);
    
    private static procedure z_GenFramebuffers_ovr_0(n: Int32; var framebuffers: UInt32);
    external 'opengl32.dll' name 'glGenFramebuffers';
    private static procedure z_GenFramebuffers_ovr_0_anh001(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glGenFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffers_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffers_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; var framebuffers: UInt32) :=
    z_GenFramebuffers_ovr_0(n, framebuffers);
    private static procedure z_GenFramebuffers_ovr_2(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glGenFramebuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffers(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffers_ovr_2(n, framebuffers);
    
    private static function z_CheckFramebufferStatus_ovr_0(target: FramebufferTarget): FramebufferStatus;
    external 'opengl32.dll' name 'glCheckFramebufferStatus';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatus(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatus_ovr_0(target);
    
    private static procedure z_FramebufferTexture1D_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture1D_ovr_0(target, attachment, textarget, texture, level);
    
    private static procedure z_FramebufferTexture2D_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture2D_ovr_0(target, attachment, textarget, texture, level);
    
    private static procedure z_FramebufferTexture3D_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3D(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3D_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    private static procedure z_FramebufferRenderbuffer_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName);
    external 'opengl32.dll' name 'glFramebufferRenderbuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbuffer(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: RenderbufferName) :=
    z_FramebufferRenderbuffer_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    private static procedure z_GetFramebufferAttachmentParameteriv_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameteriv';
    private static procedure z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameteriv_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameteriv_ovr_0(target, attachment, pname, &params);
    private static procedure z_GetFramebufferAttachmentParameteriv_ovr_2(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameteriv(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameteriv_ovr_2(target, attachment, pname, &params);
    
    private static procedure z_GenerateMipmap_ovr_0(target: TextureTarget);
    external 'opengl32.dll' name 'glGenerateMipmap';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmap(target: TextureTarget) :=
    z_GenerateMipmap_ovr_0(target);
    
    private static procedure z_BlitFramebuffer_ovr_0(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter);
    external 'opengl32.dll' name 'glBlitFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebuffer(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebuffer_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private static procedure z_RenderbufferStorageMultisample_ovr_0(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorageMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisample(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisample_ovr_0(target, samples, _internalformat, width, height);
    
    private static procedure z_FramebufferTextureLayer_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureLayer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayer(target: FramebufferTarget; attachment: FramebufferAttachment; texture: TextureName; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayer_ovr_0(target, attachment, texture, level, layer);
    
  end;
  
  glGeometryShader4ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramParameteriARB_ovr_0(&program: UInt32; pname: ProgramParameterPName; value: Int32);
    external 'opengl32.dll' name 'glProgramParameteriARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteriARB(&program: UInt32; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteriARB_ovr_0(&program, pname, value);
    
    private static procedure z_FramebufferTextureARB_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32) :=
    z_FramebufferTextureARB_ovr_0(target, attachment, texture, level);
    
    private static procedure z_FramebufferTextureLayerARB_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureLayerARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerARB_ovr_0(target, attachment, texture, level, layer);
    
    private static procedure z_FramebufferTextureFaceARB_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget);
    external 'opengl32.dll' name 'glFramebufferTextureFaceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureFaceARB(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget) :=
    z_FramebufferTextureFaceARB_ovr_0(target, attachment, texture, level, face);
    
  end;
  
  glGetProgramBinaryARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetProgramBinary_ovr_0(&program: UInt32; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    private static procedure z_GetProgramBinary_ovr_0_anh000100(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    private static procedure z_GetProgramBinary_ovr_0_anh000010(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    private static procedure z_GetProgramBinary_ovr_0_anh000110(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
        z_GetProgramBinary_ovr_0(&program, bufSize, length[0], binaryFormat[0], binary) else
        z_GetProgramBinary_ovr_0_anh000010(&program, bufSize, length[0], IntPtr.Zero, binary) else
      if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
        z_GetProgramBinary_ovr_0_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat[0], binary) else
        z_GetProgramBinary_ovr_0_anh000110(&program, bufSize, IntPtr.Zero, IntPtr.Zero, binary);
    private static procedure z_GetProgramBinary_ovr_1_anh000100(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramBinary_ovr_0(&program, bufSize, length[0], binaryFormat, binary) else
      z_GetProgramBinary_ovr_0_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat, binary);
    private static procedure z_GetProgramBinary_ovr_2(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    private static procedure z_GetProgramBinary_ovr_2_anh000100(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: array of Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramBinary_ovr_2(&program, bufSize, length[0], binaryFormat, binary) else
      z_GetProgramBinary_ovr_2_anh000100(&program, bufSize, IntPtr.Zero, binaryFormat, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
      z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat[0], binary) else
      z_GetProgramBinary_ovr_0_anh000010(&program, bufSize, length, IntPtr.Zero, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_0(&program, bufSize, length, binaryFormat, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; var length: Int32; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_2(&program, bufSize, length, binaryFormat, binary);
    private static procedure z_GetProgramBinary_ovr_6(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    private static procedure z_GetProgramBinary_ovr_6_anh000010(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: array of DummyEnum; binary: IntPtr) :=
    if (binaryFormat<>nil) and (binaryFormat.Length<>0) then
      z_GetProgramBinary_ovr_6(&program, bufSize, length, binaryFormat[0], binary) else
      z_GetProgramBinary_ovr_6_anh000010(&program, bufSize, length, IntPtr.Zero, binary);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; var binaryFormat: DummyEnum; binary: IntPtr) :=
    z_GetProgramBinary_ovr_6(&program, bufSize, length, binaryFormat, binary);
    private static procedure z_GetProgramBinary_ovr_8(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr);
    external 'opengl32.dll' name 'glGetProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramBinary(&program: UInt32; bufSize: Int32; length: IntPtr; binaryFormat: IntPtr; binary: IntPtr) :=
    z_GetProgramBinary_ovr_8(&program, bufSize, length, binaryFormat, binary);
    
    private static procedure z_ProgramBinary_ovr_0(&program: UInt32; binaryFormat: DummyEnum; binary: IntPtr; length: Int32);
    external 'opengl32.dll' name 'glProgramBinary';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBinary(&program: UInt32; binaryFormat: DummyEnum; binary: IntPtr; length: Int32) :=
    z_ProgramBinary_ovr_0(&program, binaryFormat, binary, length);
    
    private static procedure z_ProgramParameteri_ovr_0(&program: ProgramName; pname: ProgramParameterPName; value: Int32);
    external 'opengl32.dll' name 'glProgramParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: ProgramName; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
  end;
  
  glGetTextureSubImageARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetTextureSubImage_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetTextureSubImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; pixels: IntPtr) :=
    z_GetTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, bufSize, pixels);
    
    private static procedure z_GetCompressedTextureSubImage_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetCompressedTextureSubImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureSubImage(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; bufSize: Int32; pixels: IntPtr) :=
    z_GetCompressedTextureSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, bufSize, pixels);
    
  end;
  
  glGlSpirvARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SpecializeShaderARB_ovr_0(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    private static procedure z_SpecializeShaderARB_ovr_0_anh000010(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    private static procedure z_SpecializeShaderARB_ovr_0_anh000001(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    private static procedure z_SpecializeShaderARB_ovr_0_anh000011(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
          z_SpecializeShaderARB_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
        if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
          z_SpecializeShaderARB_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
          z_SpecializeShaderARB_ovr_0_anh000011(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_SpecializeShaderARB_ovr_1_anh000010(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
        z_SpecializeShaderARB_ovr_0_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_SpecializeShaderARB_ovr_2(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    private static procedure z_SpecializeShaderARB_ovr_2_anh000010(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
        z_SpecializeShaderARB_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
        z_SpecializeShaderARB_ovr_2_anh000010(shader, par_2_str_ptr, numSpecializationConstants, IntPtr.Zero, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_0_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShaderARB_ovr_0(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShaderARB_ovr_2(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_SpecializeShaderARB_ovr_6(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    private static procedure z_SpecializeShaderARB_ovr_6_anh000001(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_6_anh000001(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShaderARB_ovr_6(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_SpecializeShaderARB_ovr_8(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    external 'opengl32.dll' name 'glSpecializeShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: string; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(pEntryPoint);
      z_SpecializeShaderARB_ovr_8(shader, par_2_str_ptr, numSpecializationConstants, pConstantIndex, pConstantValue);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: array of UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], IntPtr.Zero) else
      if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
        z_SpecializeShaderARB_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue[0]) else
        z_SpecializeShaderARB_ovr_0_anh000011(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; var pConstantValue: UInt32) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShaderARB_ovr_0_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: array of UInt32; pConstantValue: IntPtr) :=
    if (pConstantIndex<>nil) and (pConstantIndex.Length<>0) then
      z_SpecializeShaderARB_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex[0], pConstantValue) else
      z_SpecializeShaderARB_ovr_2_anh000010(shader, pEntryPoint, numSpecializationConstants, IntPtr.Zero, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShaderARB_ovr_0_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; var pConstantValue: UInt32) :=
    z_SpecializeShaderARB_ovr_0(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; var pConstantIndex: UInt32; pConstantValue: IntPtr) :=
    z_SpecializeShaderARB_ovr_2(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: array of UInt32) :=
    if (pConstantValue<>nil) and (pConstantValue.Length<>0) then
      z_SpecializeShaderARB_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue[0]) else
      z_SpecializeShaderARB_ovr_6_anh000001(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; var pConstantValue: UInt32) :=
    z_SpecializeShaderARB_ovr_6(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpecializeShaderARB(shader: UInt32; pEntryPoint: IntPtr; numSpecializationConstants: UInt32; pConstantIndex: IntPtr; pConstantValue: IntPtr) :=
    z_SpecializeShaderARB_ovr_8(shader, pEntryPoint, numSpecializationConstants, pConstantIndex, pConstantValue);
    
  end;
  
  glGpuShaderFp64ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Uniform1d_ovr_0(location: Int32; x: real);
    external 'opengl32.dll' name 'glUniform1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1d(location: Int32; x: real) :=
    z_Uniform1d_ovr_0(location, x);
    
    private static procedure z_Uniform2d_ovr_0(location: Int32; x: real; y: real);
    external 'opengl32.dll' name 'glUniform2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2d(location: Int32; x: real; y: real) :=
    z_Uniform2d_ovr_0(location, x, y);
    
    private static procedure z_Uniform3d_ovr_0(location: Int32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glUniform3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3d(location: Int32; x: real; y: real; z: real) :=
    z_Uniform3d_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4d_ovr_0(location: Int32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glUniform4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4d(location: Int32; x: real; y: real; z: real; w: real) :=
    z_Uniform4d_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1dv_ovr_0(location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glUniform1dv';
    private static procedure z_Uniform1dv_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1dv_ovr_0(location, count, value[0]) else
      z_Uniform1dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform1dv_ovr_0(location, count, value);
    private static procedure z_Uniform1dv_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1dv_ovr_2(location, count, value);
    
    private static procedure z_Uniform2dv_ovr_0(location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glUniform2dv';
    private static procedure z_Uniform2dv_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2dv_ovr_0(location, count, value[0]) else
      z_Uniform2dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform2dv_ovr_0(location, count, value);
    private static procedure z_Uniform2dv_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2dv_ovr_2(location, count, value);
    
    private static procedure z_Uniform3dv_ovr_0(location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glUniform3dv';
    private static procedure z_Uniform3dv_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3dv_ovr_0(location, count, value[0]) else
      z_Uniform3dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform3dv_ovr_0(location, count, value);
    private static procedure z_Uniform3dv_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3dv_ovr_2(location, count, value);
    
    private static procedure z_Uniform4dv_ovr_0(location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glUniform4dv';
    private static procedure z_Uniform4dv_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4dv_ovr_0(location, count, value[0]) else
      z_Uniform4dv_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; var value: real) :=
    z_Uniform4dv_ovr_0(location, count, value);
    private static procedure z_Uniform4dv_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4dv(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4dv_ovr_2(location, count, value);
    
    private static procedure z_UniformMatrix2dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix2dv';
    private static procedure z_UniformMatrix2dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix2dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix3dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix3dv';
    private static procedure z_UniformMatrix3dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix3dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix4dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix4dv';
    private static procedure z_UniformMatrix4dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix4dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix2x3dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix2x3dv';
    private static procedure z_UniformMatrix2x3dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x3dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix2x3dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x3dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix2x4dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix2x4dv';
    private static procedure z_UniformMatrix2x4dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix2x4dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix2x4dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2x4dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix3x2dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix3x2dv';
    private static procedure z_UniformMatrix3x2dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x2dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix3x2dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x2dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix3x4dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix3x4dv';
    private static procedure z_UniformMatrix3x4dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3x4dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix3x4dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix3x4dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3x4dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3x4dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix4x2dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix4x2dv';
    private static procedure z_UniformMatrix4x2dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x2dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x2dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix4x2dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x2dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x2dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix4x3dv_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glUniformMatrix4x3dv';
    private static procedure z_UniformMatrix4x3dv_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4x3dv_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_UniformMatrix4x3dv_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix4x3dv_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4x3dv(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4x3dv_ovr_2(location, count, transpose, value);
    
    private static procedure z_GetUniformdv_ovr_0(&program: ProgramName; location: Int32; var &params: real);
    external 'opengl32.dll' name 'glGetUniformdv';
    private static procedure z_GetUniformdv_ovr_0_anh0001(&program: ProgramName; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformdv_ovr_0(&program, location, &params[0]) else
      z_GetUniformdv_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; var &params: real) :=
    z_GetUniformdv_ovr_0(&program, location, &params);
    private static procedure z_GetUniformdv_ovr_2(&program: ProgramName; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformdv(&program: ProgramName; location: Int32; &params: IntPtr) :=
    z_GetUniformdv_ovr_2(&program, location, &params);
    
  end;
  
  glGpuShaderInt64ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Uniform1i64ARB_ovr_0(location: Int32; x: Int64);
    external 'opengl32.dll' name 'glUniform1i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64ARB(location: Int32; x: Int64) :=
    z_Uniform1i64ARB_ovr_0(location, x);
    
    private static procedure z_Uniform2i64ARB_ovr_0(location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glUniform2i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64ARB(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64ARB_ovr_0(location, x, y);
    
    private static procedure z_Uniform3i64ARB_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glUniform3i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64ARB(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64ARB_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4i64ARB_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glUniform4i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64ARB(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64ARB_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1i64vARB_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform1i64vARB';
    private static procedure z_Uniform1i64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform1i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform1i64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform2i64vARB_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform2i64vARB';
    private static procedure z_Uniform2i64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform2i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform2i64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform3i64vARB_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform3i64vARB';
    private static procedure z_Uniform3i64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform3i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform3i64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform4i64vARB_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform4i64vARB';
    private static procedure z_Uniform4i64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vARB_ovr_0(location, count, value[0]) else
      z_Uniform4i64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform4i64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform1ui64ARB_ovr_0(location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64ARB(location: Int32; x: UInt64) :=
    z_Uniform1ui64ARB_ovr_0(location, x);
    
    private static procedure z_Uniform2ui64ARB_ovr_0(location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64ARB(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64ARB_ovr_0(location, x, y);
    
    private static procedure z_Uniform3ui64ARB_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64ARB(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64ARB_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4ui64ARB_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64ARB(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64ARB_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1ui64vARB_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64vARB';
    private static procedure z_Uniform1ui64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform1ui64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform2ui64vARB_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64vARB';
    private static procedure z_Uniform2ui64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform2ui64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform3ui64vARB_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64vARB';
    private static procedure z_Uniform3ui64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform3ui64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform4ui64vARB_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64vARB';
    private static procedure z_Uniform4ui64vARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vARB_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vARB_ovr_0(location, count, value);
    private static procedure z_Uniform4ui64vARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vARB_ovr_2(location, count, value);
    
    private static procedure z_GetUniformi64vARB_ovr_0(&program: UInt32; location: Int32; var &params: Int64);
    external 'opengl32.dll' name 'glGetUniformi64vARB';
    private static procedure z_GetUniformi64vARB_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: UInt32; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vARB_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vARB_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: UInt32; location: Int32; var &params: Int64) :=
    z_GetUniformi64vARB_ovr_0(&program, location, &params);
    private static procedure z_GetUniformi64vARB_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vARB(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vARB_ovr_2(&program, location, &params);
    
    private static procedure z_GetUniformui64vARB_ovr_0(&program: UInt32; location: Int32; var &params: UInt64);
    external 'opengl32.dll' name 'glGetUniformui64vARB';
    private static procedure z_GetUniformui64vARB_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: UInt32; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vARB_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vARB_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: UInt32; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vARB_ovr_0(&program, location, &params);
    private static procedure z_GetUniformui64vARB_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vARB(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vARB_ovr_2(&program, location, &params);
    
    private static procedure z_GetnUniformi64vARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: Int64);
    external 'opengl32.dll' name 'glGetnUniformi64vARB';
    private static procedure z_GetnUniformi64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformi64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformi64vARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformi64vARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: Int64) :=
    z_GetnUniformi64vARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformi64vARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformi64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformi64vARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformi64vARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformui64vARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: UInt64);
    external 'opengl32.dll' name 'glGetnUniformui64vARB';
    private static procedure z_GetnUniformui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformui64vARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformui64vARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: UInt64) :=
    z_GetnUniformui64vARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformui64vARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformui64vARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformui64vARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_ProgramUniform1i64ARB_ovr_0(&program: UInt32; location: Int32; x: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64ARB(&program: UInt32; location: Int32; x: Int64) :=
    z_ProgramUniform1i64ARB_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2i64ARB_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64ARB(&program: UInt32; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64ARB_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3i64ARB_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64ARB(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64ARB_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4i64ARB_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64ARB(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64ARB_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1i64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64vARB';
    private static procedure z_ProgramUniform1i64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1i64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2i64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64vARB';
    private static procedure z_ProgramUniform2i64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2i64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3i64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64vARB';
    private static procedure z_ProgramUniform3i64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3i64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4i64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64vARB';
    private static procedure z_ProgramUniform4i64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4i64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1ui64ARB_ovr_0(&program: UInt32; location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64ARB(&program: UInt32; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64ARB_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2ui64ARB_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64ARB(&program: UInt32; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64ARB_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3ui64ARB_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64ARB(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64ARB_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4ui64ARB_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64ARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64ARB(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64ARB_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1ui64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64vARB';
    private static procedure z_ProgramUniform1ui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1ui64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2ui64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64vARB';
    private static procedure z_ProgramUniform2ui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2ui64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3ui64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64vARB';
    private static procedure z_ProgramUniform3ui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3ui64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vARB_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4ui64vARB_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64vARB';
    private static procedure z_ProgramUniform4ui64vARB_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vARB_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vARB_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vARB_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4ui64vARB_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vARB(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vARB_ovr_2(&program, location, count, value);
    
  end;
  
  glImagingARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendColor_ovr_0(red: single; green: single; blue: single; alpha: single);
    external 'opengl32.dll' name 'glBlendColor';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColor(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColor_ovr_0(red, green, blue, alpha);
    
    private static procedure z_BlendEquation_ovr_0(mode: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquation';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquation(mode: BlendEquationModeEXT) :=
    z_BlendEquation_ovr_0(mode);
    
    private static procedure z_ColorTable_ovr_0(target: ColorTableTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr);
    external 'opengl32.dll' name 'glColorTable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTable(target: ColorTableTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTable_ovr_0(target, _internalformat, width, format, &type, table);
    
    private static procedure z_ColorTableParameterfv_ovr_0(target: ColorTableTarget; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glColorTableParameterfv';
    private static procedure z_ColorTableParameterfv_ovr_0_anh0001(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterfv_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: DummyEnum; var &params: single) :=
    z_ColorTableParameterfv_ovr_0(target, pname, &params);
    private static procedure z_ColorTableParameterfv_ovr_2(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfv(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr) :=
    z_ColorTableParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_ColorTableParameteriv_ovr_0(target: ColorTableTarget; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glColorTableParameteriv';
    private static procedure z_ColorTableParameteriv_ovr_0_anh0001(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameteriv_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: DummyEnum; var &params: Int32) :=
    z_ColorTableParameteriv_ovr_0(target, pname, &params);
    private static procedure z_ColorTableParameteriv_ovr_2(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameteriv(target: ColorTableTarget; pname: DummyEnum; &params: IntPtr) :=
    z_ColorTableParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_CopyColorTable_ovr_0(target: ColorTableTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyColorTable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorTable(target: ColorTableTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorTable_ovr_0(target, _internalformat, x, y, width);
    
    private static procedure z_GetColorTable_ovr_0(target: ColorTableTarget; format: PixelFormat; &type: PixelType; table: IntPtr);
    external 'opengl32.dll' name 'glGetColorTable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTable(target: ColorTableTarget; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_GetColorTable_ovr_0(target, format, &type, table);
    
    private static procedure z_GetColorTableParameterfv_ovr_0(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single);
    external 'opengl32.dll' name 'glGetColorTableParameterfv';
    private static procedure z_GetColorTableParameterfv_ovr_0_anh0001(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfv_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameterfv_ovr_2(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_GetColorTableParameteriv_ovr_0(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32);
    external 'opengl32.dll' name 'glGetColorTableParameteriv';
    private static procedure z_GetColorTableParameteriv_ovr_0_anh0001(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameteriv_ovr_2(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameteriv(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_ColorSubTable_ovr_0(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glColorSubTable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorSubTable(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ColorSubTable_ovr_0(target, start, count, format, &type, data);
    
    private static procedure z_CopyColorSubTable_ovr_0(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyColorSubTable';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorSubTable(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorSubTable_ovr_0(target, start, x, y, width);
    
    private static procedure z_ConvolutionFilter1D_ovr_0(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glConvolutionFilter1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter1D(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter1D_ovr_0(target, _internalformat, width, format, &type, image);
    
    private static procedure z_ConvolutionFilter2D_ovr_0(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glConvolutionFilter2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter2D(target: ConvolutionTarget; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter2D_ovr_0(target, _internalformat, width, height, format, &type, image);
    
    private static procedure z_ConvolutionParameterf_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: single);
    external 'opengl32.dll' name 'glConvolutionParameterf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterf(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: single) :=
    z_ConvolutionParameterf_ovr_0(target, pname, &params);
    
    private static procedure z_ConvolutionParameterfv_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single);
    external 'opengl32.dll' name 'glConvolutionParameterfv';
    private static procedure z_ConvolutionParameterfv_ovr_0_anh0001(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterfv_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single) :=
    z_ConvolutionParameterfv_ovr_0(target, pname, &params);
    private static procedure z_ConvolutionParameterfv_ovr_2(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_ConvolutionParameteri_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: Int32);
    external 'opengl32.dll' name 'glConvolutionParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteri(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: Int32) :=
    z_ConvolutionParameteri_ovr_0(target, pname, &params);
    
    private static procedure z_ConvolutionParameteriv_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32);
    external 'opengl32.dll' name 'glConvolutionParameteriv';
    private static procedure z_ConvolutionParameteriv_ovr_0_anh0001(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameteriv_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_ConvolutionParameteriv_ovr_0(target, pname, &params);
    private static procedure z_ConvolutionParameteriv_ovr_2(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_CopyConvolutionFilter1D_ovr_0(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyConvolutionFilter1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter1D(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyConvolutionFilter1D_ovr_0(target, _internalformat, x, y, width);
    
    private static procedure z_CopyConvolutionFilter2D_ovr_0(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyConvolutionFilter2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter2D(target: ConvolutionTarget; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyConvolutionFilter2D_ovr_0(target, _internalformat, x, y, width, height);
    
    private static procedure z_GetConvolutionFilter_ovr_0(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionFilter';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionFilter(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_GetConvolutionFilter_ovr_0(target, format, &type, image);
    
    private static procedure z_GetConvolutionParameterfv_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single);
    external 'opengl32.dll' name 'glGetConvolutionParameterfv';
    private static procedure z_GetConvolutionParameterfv_ovr_0_anh0001(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: single) :=
    z_GetConvolutionParameterfv_ovr_0(target, pname, &params);
    private static procedure z_GetConvolutionParameterfv_ovr_2(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_GetConvolutionParameteriv_ovr_0(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetConvolutionParameteriv';
    private static procedure z_GetConvolutionParameteriv_ovr_0_anh0001(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_GetConvolutionParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetConvolutionParameteriv_ovr_2(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameteriv(target: ConvolutionTarget; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_GetSeparableFilter_ovr_0(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr);
    external 'opengl32.dll' name 'glGetSeparableFilter';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSeparableFilter(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr) :=
    z_GetSeparableFilter_ovr_0(target, format, &type, row, column, span);
    
    private static procedure z_SeparableFilter2D_ovr_0(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr);
    external 'opengl32.dll' name 'glSeparableFilter2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SeparableFilter2D(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr) :=
    z_SeparableFilter2D_ovr_0(target, _internalformat, width, height, format, &type, row, column);
    
    private static procedure z_GetHistogram_ovr_0(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr);
    external 'opengl32.dll' name 'glGetHistogram';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogram(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetHistogram_ovr_0(target, reset, format, &type, values);
    
    private static procedure z_GetHistogramParameterfv_ovr_0(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single);
    external 'opengl32.dll' name 'glGetHistogramParameterfv';
    private static procedure z_GetHistogramParameterfv_ovr_0_anh0001(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single) :=
    z_GetHistogramParameterfv_ovr_0(target, pname, &params);
    private static procedure z_GetHistogramParameterfv_ovr_2(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_GetHistogramParameteriv_ovr_0(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetHistogramParameteriv';
    private static procedure z_GetHistogramParameteriv_ovr_0_anh0001(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32) :=
    z_GetHistogramParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetHistogramParameteriv_ovr_2(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameteriv(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_GetMinmax_ovr_0(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr);
    external 'opengl32.dll' name 'glGetMinmax';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmax(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetMinmax_ovr_0(target, reset, format, &type, values);
    
    private static procedure z_GetMinmaxParameterfv_ovr_0(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single);
    external 'opengl32.dll' name 'glGetMinmaxParameterfv';
    private static procedure z_GetMinmaxParameterfv_ovr_0_anh0001(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterfv_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterfv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single) :=
    z_GetMinmaxParameterfv_ovr_0(target, pname, &params);
    private static procedure z_GetMinmaxParameterfv_ovr_2(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterfv_ovr_2(target, pname, &params);
    
    private static procedure z_GetMinmaxParameteriv_ovr_0(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetMinmaxParameteriv';
    private static procedure z_GetMinmaxParameteriv_ovr_0_anh0001(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameteriv_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameteriv_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32) :=
    z_GetMinmaxParameteriv_ovr_0(target, pname, &params);
    private static procedure z_GetMinmaxParameteriv_ovr_2(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameteriv(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameteriv_ovr_2(target, pname, &params);
    
    private static procedure z_Histogram_ovr_0(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean);
    external 'opengl32.dll' name 'glHistogram';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Histogram(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean) :=
    z_Histogram_ovr_0(target, width, _internalformat, sink);
    
    private static procedure z_Minmax_ovr_0(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean);
    external 'opengl32.dll' name 'glMinmax';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Minmax(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean) :=
    z_Minmax_ovr_0(target, _internalformat, sink);
    
    private static procedure z_ResetHistogram_ovr_0(target: HistogramTargetEXT);
    external 'opengl32.dll' name 'glResetHistogram';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetHistogram(target: HistogramTargetEXT) :=
    z_ResetHistogram_ovr_0(target);
    
    private static procedure z_ResetMinmax_ovr_0(target: MinmaxTargetEXT);
    external 'opengl32.dll' name 'glResetMinmax';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMinmax(target: MinmaxTargetEXT) :=
    z_ResetMinmax_ovr_0(target);
    
  end;
  
  glIndirectParametersARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysIndirectCountARB_ovr_0(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysIndirectCountARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectCountARB(mode: PrimitiveType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirectCountARB_ovr_0(mode, indirect, drawcount, maxdrawcount, stride);
    
    private static procedure z_MultiDrawElementsIndirectCountARB_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsIndirectCountARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectCountARB(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirectCountARB_ovr_0(mode, &type, indirect, drawcount, maxdrawcount, stride);
    
  end;
  
  glInstancedArraysARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribDivisorARB_ovr_0(index: UInt32; divisor: UInt32);
    external 'opengl32.dll' name 'glVertexAttribDivisorARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribDivisorARB(index: UInt32; divisor: UInt32) :=
    z_VertexAttribDivisorARB_ovr_0(index, divisor);
    
  end;
  
  glInternalformatQueryARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetInternalformativ_ovr_0(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetInternalformativ';
    private static procedure z_GetInternalformativ_ovr_0_anh000001(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformativ';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformativ_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformativ_ovr_0(target, _internalformat, pname, count, &params);
    private static procedure z_GetInternalformativ_ovr_2(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformativ';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformativ(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformativ_ovr_2(target, _internalformat, pname, count, &params);
    
  end;
  
  glInternalformatQuery2ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetInternalformati64v_ovr_0(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64);
    external 'opengl32.dll' name 'glGetInternalformati64v';
    private static procedure z_GetInternalformati64v_ovr_0_anh000001(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformati64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params[0]) else
      z_GetInternalformati64v_ovr_0_anh000001(target, _internalformat, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; var &params: Int64) :=
    z_GetInternalformati64v_ovr_0(target, _internalformat, pname, count, &params);
    private static procedure z_GetInternalformati64v_ovr_2(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformati64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformati64v(target: TextureTarget; _internalformat: InternalFormat; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformati64v_ovr_2(target, _internalformat, pname, count, &params);
    
  end;
  
  glInvalidateSubdataARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_InvalidateTexSubImage_ovr_0(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glInvalidateTexSubImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexSubImage(texture: TextureName; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_InvalidateTexSubImage_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth);
    
    private static procedure z_InvalidateTexImage_ovr_0(texture: TextureName; level: Int32);
    external 'opengl32.dll' name 'glInvalidateTexImage';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateTexImage(texture: TextureName; level: Int32) :=
    z_InvalidateTexImage_ovr_0(texture, level);
    
    private static procedure z_InvalidateBufferSubData_ovr_0(buffer: BufferName; offset: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glInvalidateBufferSubData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferSubData(buffer: BufferName; offset: IntPtr; length: IntPtr) :=
    z_InvalidateBufferSubData_ovr_0(buffer, offset, length);
    
    private static procedure z_InvalidateBufferData_ovr_0(buffer: BufferName);
    external 'opengl32.dll' name 'glInvalidateBufferData';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateBufferData(buffer: BufferName) :=
    z_InvalidateBufferData_ovr_0(buffer);
    
    private static procedure z_InvalidateFramebuffer_ovr_0(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment);
    external 'opengl32.dll' name 'glInvalidateFramebuffer';
    private static procedure z_InvalidateFramebuffer_ovr_0_anh0001(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr);
    external 'opengl32.dll' name 'glInvalidateFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments[0]) else
      z_InvalidateFramebuffer_ovr_0_anh0001(target, numAttachments, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment) :=
    z_InvalidateFramebuffer_ovr_0(target, numAttachments, attachments);
    private static procedure z_InvalidateFramebuffer_ovr_2(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr);
    external 'opengl32.dll' name 'glInvalidateFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr) :=
    z_InvalidateFramebuffer_ovr_2(target, numAttachments, attachments);
    
    private static procedure z_InvalidateSubFramebuffer_ovr_0(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateSubFramebuffer';
    private static procedure z_InvalidateSubFramebuffer_ovr_0_anh00010000(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateSubFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: array of InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    if (attachments<>nil) and (attachments.Length<>0) then
      z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments[0], x, y, width, height) else
      z_InvalidateSubFramebuffer_ovr_0_anh00010000(target, numAttachments, IntPtr.Zero, x, y, width, height);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; var attachments: InvalidateFramebufferAttachment; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_0(target, numAttachments, attachments, x, y, width, height);
    private static procedure z_InvalidateSubFramebuffer_ovr_2(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glInvalidateSubFramebuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InvalidateSubFramebuffer(target: FramebufferTarget; numAttachments: Int32; attachments: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_InvalidateSubFramebuffer_ovr_2(target, numAttachments, attachments, x, y, width, height);
    
  end;
  
  glMapBufferRangeARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_MapBufferRange_ovr_0(target: BufferTargetARB; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr;
    external 'opengl32.dll' name 'glMapBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferRange(target: BufferTargetARB; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapBufferRange_ovr_0(target, offset, length, access);
    
    private static procedure z_FlushMappedBufferRange_ovr_0(target: BufferTargetARB; offset: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glFlushMappedBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedBufferRange(target: BufferTargetARB; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedBufferRange_ovr_0(target, offset, length);
    
  end;
  
  glMatrixPaletteARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CurrentPaletteMatrixARB_ovr_0(index: Int32);
    external 'opengl32.dll' name 'glCurrentPaletteMatrixARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CurrentPaletteMatrixARB(index: Int32) :=
    z_CurrentPaletteMatrixARB_ovr_0(index);
    
    private static procedure z_MatrixIndexubvARB_ovr_0(size: Int32; var indices: Byte);
    external 'opengl32.dll' name 'glMatrixIndexubvARB';
    private static procedure z_MatrixIndexubvARB_ovr_0_anh001(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; indices: array of Byte) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexubvARB_ovr_0(size, indices[0]) else
      z_MatrixIndexubvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; var indices: Byte) :=
    z_MatrixIndexubvARB_ovr_0(size, indices);
    private static procedure z_MatrixIndexubvARB_ovr_2(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexubvARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexubvARB_ovr_2(size, indices);
    
    private static procedure z_MatrixIndexusvARB_ovr_0(size: Int32; var indices: UInt16);
    external 'opengl32.dll' name 'glMatrixIndexusvARB';
    private static procedure z_MatrixIndexusvARB_ovr_0_anh001(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; indices: array of UInt16) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexusvARB_ovr_0(size, indices[0]) else
      z_MatrixIndexusvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; var indices: UInt16) :=
    z_MatrixIndexusvARB_ovr_0(size, indices);
    private static procedure z_MatrixIndexusvARB_ovr_2(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexusvARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexusvARB_ovr_2(size, indices);
    
    private static procedure z_MatrixIndexuivARB_ovr_0(size: Int32; var indices: UInt32);
    external 'opengl32.dll' name 'glMatrixIndexuivARB';
    private static procedure z_MatrixIndexuivARB_ovr_0_anh001(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MatrixIndexuivARB_ovr_0(size, indices[0]) else
      z_MatrixIndexuivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; var indices: UInt32) :=
    z_MatrixIndexuivARB_ovr_0(size, indices);
    private static procedure z_MatrixIndexuivARB_ovr_2(size: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexuivARB(size: Int32; indices: IntPtr) :=
    z_MatrixIndexuivARB_ovr_2(size, indices);
    
    private static procedure z_MatrixIndexPointerARB_ovr_0(size: Int32; &type: MatrixIndexPointerTypeARB; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glMatrixIndexPointerARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixIndexPointerARB(size: Int32; &type: MatrixIndexPointerTypeARB; stride: Int32; pointer: IntPtr) :=
    z_MatrixIndexPointerARB_ovr_0(size, &type, stride, pointer);
    
  end;
  
  glMultiBindARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindBuffersBase_ovr_0(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32);
    external 'opengl32.dll' name 'glBindBuffersBase';
    private static procedure z_BindBuffersBase_ovr_0_anh00001(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersBase';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersBase_ovr_0(target, first, count, buffers[0]) else
      z_BindBuffersBase_ovr_0_anh00001(target, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32) :=
    z_BindBuffersBase_ovr_0(target, first, count, buffers);
    private static procedure z_BindBuffersBase_ovr_2(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersBase';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersBase(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr) :=
    z_BindBuffersBase_ovr_2(target, first, count, buffers);
    
    private static procedure z_BindBuffersRange_ovr_0(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000110(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000101(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000011(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_0_anh0000111(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (sizes<>nil) and (sizes.Length<>0) then
          z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes[0]) else
          z_BindBuffersRange_ovr_0_anh0000111(target, first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindBuffersRange_ovr_1_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_1_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_1_anh0000110(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_0_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_2(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_2_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_2_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_2_anh0000110(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers[0], IntPtr.Zero, sizes) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets[0], sizes) else
        z_BindBuffersRange_ovr_2_anh0000110(target, first, count, IntPtr.Zero, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_3_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_3_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_3_anh0000101(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_BindBuffersRange_ovr_4_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_0_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_5_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_2_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_6(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_6_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_6_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_6_anh0000101(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; sizes: array of IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers[0], offsets, IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes[0]) else
        z_BindBuffersRange_ovr_6_anh0000101(target, first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_BindBuffersRange_ovr_7_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var sizes: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_6_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_8(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_8_anh0000100(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; sizes: pointer) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindBuffersRange_ovr_8(target, first, count, buffers[0], offsets, sizes) else
      z_BindBuffersRange_ovr_8_anh0000100(target, first, count, IntPtr.Zero, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_9_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_9_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_9_anh0000011(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_0_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindBuffersRange_ovr_10_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_0_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_11_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_2_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_12_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_0_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_0(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_2(target, first, count, buffers, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_15_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_6_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_6(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_8(target, first, count, buffers, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_18(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_18_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_18_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_18_anh0000011(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: array of IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets[0], IntPtr.Zero) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes[0]) else
        z_BindBuffersRange_ovr_18_anh0000011(target, first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindBuffersRange_ovr_19_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var sizes: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_18_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_20(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_20_anh0000010(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; sizes: pointer) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets[0], sizes) else
      z_BindBuffersRange_ovr_20_anh0000010(target, first, count, buffers, IntPtr.Zero, sizes);
    private static procedure z_BindBuffersRange_ovr_21_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_18_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_18(target, first, count, buffers, offsets, sizes);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; sizes: pointer) :=
    z_BindBuffersRange_ovr_20(target, first, count, buffers, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_24(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    private static procedure z_BindBuffersRange_ovr_24_anh0000001(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: IntPtr);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: array of IntPtr) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes[0]) else
      z_BindBuffersRange_ovr_24_anh0000001(target, first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var sizes: IntPtr) :=
    z_BindBuffersRange_ovr_24(target, first, count, buffers, offsets, sizes);
    private static procedure z_BindBuffersRange_ovr_26(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer);
    external 'opengl32.dll' name 'glBindBuffersRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBuffersRange(target: BufferTargetARB; first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; sizes: pointer) :=
    z_BindBuffersRange_ovr_26(target, first, count, buffers, offsets, sizes);
    
    private static procedure z_BindTextures_ovr_0(first: UInt32; count: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glBindTextures';
    private static procedure z_BindTextures_ovr_0_anh0001(first: UInt32; count: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glBindTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindTextures_ovr_0(first, count, textures[0]) else
      z_BindTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; var textures: UInt32) :=
    z_BindTextures_ovr_0(first, count, textures);
    private static procedure z_BindTextures_ovr_2(first: UInt32; count: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glBindTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindTextures_ovr_2(first, count, textures);
    
    private static procedure z_BindSamplers_ovr_0(first: UInt32; count: Int32; var samplers: UInt32);
    external 'opengl32.dll' name 'glBindSamplers';
    private static procedure z_BindSamplers_ovr_0_anh0001(first: UInt32; count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glBindSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_BindSamplers_ovr_0(first, count, samplers[0]) else
      z_BindSamplers_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; var samplers: UInt32) :=
    z_BindSamplers_ovr_0(first, count, samplers);
    private static procedure z_BindSamplers_ovr_2(first: UInt32; count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glBindSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSamplers(first: UInt32; count: Int32; samplers: IntPtr) :=
    z_BindSamplers_ovr_2(first, count, samplers);
    
    private static procedure z_BindImageTextures_ovr_0(first: UInt32; count: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glBindImageTextures';
    private static procedure z_BindImageTextures_ovr_0_anh0001(first: UInt32; count: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glBindImageTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_BindImageTextures_ovr_0(first, count, textures[0]) else
      z_BindImageTextures_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; var textures: UInt32) :=
    z_BindImageTextures_ovr_0(first, count, textures);
    private static procedure z_BindImageTextures_ovr_2(first: UInt32; count: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glBindImageTextures';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextures(first: UInt32; count: Int32; textures: IntPtr) :=
    z_BindImageTextures_ovr_2(first, count, textures);
    
    private static procedure z_BindVertexBuffers_ovr_0(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000110(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000001(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000101(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000011(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_0_anh000111(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers[0], IntPtr.Zero, IntPtr.Zero) else
      if (offsets<>nil) and (offsets.Length<>0) then
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets[0], IntPtr.Zero) else
        if (strides<>nil) and (strides.Length<>0) then
          z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides[0]) else
          z_BindVertexBuffers_ovr_0_anh000111(first, count, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindVertexBuffers_ovr_1_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_1_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_1_anh000110(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_0_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private static procedure z_BindVertexBuffers_ovr_2(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_2_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_2_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_2_anh000110(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers[0], IntPtr.Zero, strides) else
      if (offsets<>nil) and (offsets.Length<>0) then
        z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets[0], strides) else
        z_BindVertexBuffers_ovr_2_anh000110(first, count, IntPtr.Zero, IntPtr.Zero, strides);
    private static procedure z_BindVertexBuffers_ovr_3_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_3_anh000101(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_BindVertexBuffers_ovr_4_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_0_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_5_anh000100(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; var offsets: IntPtr; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_2_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_6(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_6_anh000100(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_6_anh000001(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_6_anh000101(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: array of Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers[0], offsets, IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides[0]) else
        z_BindVertexBuffers_ovr_6_anh000101(first, count, IntPtr.Zero, offsets, IntPtr.Zero);
    private static procedure z_BindVertexBuffers_ovr_7_anh000100(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; var strides: Int32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_6_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_8(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_8_anh000100(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: array of UInt32; offsets: pointer; strides: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_BindVertexBuffers_ovr_8(first, count, buffers[0], offsets, strides) else
      z_BindVertexBuffers_ovr_8_anh000100(first, count, IntPtr.Zero, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_9_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_9_anh000011(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_0_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindVertexBuffers_ovr_10_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_0_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private static procedure z_BindVertexBuffers_ovr_11_anh000010(first: UInt32; count: Int32; var buffers: UInt32; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_2(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_2_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_0_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_0(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_2(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_6_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_6(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; var buffers: UInt32; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_8(first, count, buffers, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_18(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_18_anh000010(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_18_anh000001(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_18_anh000011(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: array of Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets[0], IntPtr.Zero) else
      if (strides<>nil) and (strides.Length<>0) then
        z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides[0]) else
        z_BindVertexBuffers_ovr_18_anh000011(first, count, buffers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_BindVertexBuffers_ovr_19_anh000010(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; var strides: Int32) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_18_anh000010(first, count, buffers, IntPtr.Zero, strides);
    private static procedure z_BindVertexBuffers_ovr_20(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_20_anh000010(first: UInt32; count: Int32; buffers: IntPtr; offsets: IntPtr; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: array of IntPtr; strides: IntPtr) :=
    if (offsets<>nil) and (offsets.Length<>0) then
      z_BindVertexBuffers_ovr_20(first, count, buffers, offsets[0], strides) else
      z_BindVertexBuffers_ovr_20_anh000010(first, count, buffers, IntPtr.Zero, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_18_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; var strides: Int32) :=
    z_BindVertexBuffers_ovr_18(first, count, buffers, offsets, strides);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; var offsets: IntPtr; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_20(first, count, buffers, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_24(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    private static procedure z_BindVertexBuffers_ovr_24_anh000001(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: array of Int32) :=
    if (strides<>nil) and (strides.Length<>0) then
      z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides[0]) else
      z_BindVertexBuffers_ovr_24_anh000001(first, count, buffers, offsets, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; var strides: Int32) :=
    z_BindVertexBuffers_ovr_24(first, count, buffers, offsets, strides);
    private static procedure z_BindVertexBuffers_ovr_26(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr);
    external 'opengl32.dll' name 'glBindVertexBuffers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffers(first: UInt32; count: Int32; buffers: IntPtr; offsets: pointer; strides: IntPtr) :=
    z_BindVertexBuffers_ovr_26(first, count, buffers, offsets, strides);
    
  end;
  
  glMultiDrawIndirectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysIndirect_ovr_0(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysIndirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirect(mode: PrimitiveType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawArraysIndirect_ovr_0(mode, indirect, drawcount, stride);
    
    private static procedure z_MultiDrawElementsIndirect_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsIndirect';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirect(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawElementsIndirect_ovr_0(mode, &type, indirect, drawcount, stride);
    
  end;
  
  glMultisampleARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SampleCoverageARB_ovr_0(value: single; invert: boolean);
    external 'opengl32.dll' name 'glSampleCoverageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleCoverageARB(value: single; invert: boolean) :=
    z_SampleCoverageARB_ovr_0(value, invert);
    
  end;
  
  glMultitextureARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ActiveTextureARB_ovr_0(texture: TextureUnit);
    external 'opengl32.dll' name 'glActiveTextureARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveTextureARB(texture: TextureUnit) :=
    z_ActiveTextureARB_ovr_0(texture);
    
    private static procedure z_ClientActiveTextureARB_ovr_0(texture: TextureUnit);
    external 'opengl32.dll' name 'glClientActiveTextureARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveTextureARB(texture: TextureUnit) :=
    z_ClientActiveTextureARB_ovr_0(texture);
    
    private static procedure z_MultiTexCoord1dARB_ovr_0(target: TextureUnit; s: real);
    external 'opengl32.dll' name 'glMultiTexCoord1dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dARB(target: TextureUnit; s: real) :=
    z_MultiTexCoord1dARB_ovr_0(target, s);
    
    private static procedure z_MultiTexCoord1dvARB_ovr_0(target: TextureUnit; var v: real);
    external 'opengl32.dll' name 'glMultiTexCoord1dvARB';
    private static procedure z_MultiTexCoord1dvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord1dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord1dvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord1dvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1dvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord1fARB_ovr_0(target: TextureUnit; s: single);
    external 'opengl32.dll' name 'glMultiTexCoord1fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fARB(target: TextureUnit; s: single) :=
    z_MultiTexCoord1fARB_ovr_0(target, s);
    
    private static procedure z_MultiTexCoord1fvARB_ovr_0(target: TextureUnit; var v: single);
    external 'opengl32.dll' name 'glMultiTexCoord1fvARB';
    private static procedure z_MultiTexCoord1fvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord1fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord1fvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord1fvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1fvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord1iARB_ovr_0(target: TextureUnit; s: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord1iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1iARB(target: TextureUnit; s: Int32) :=
    z_MultiTexCoord1iARB_ovr_0(target, s);
    
    private static procedure z_MultiTexCoord1ivARB_ovr_0(target: TextureUnit; var v: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord1ivARB';
    private static procedure z_MultiTexCoord1ivARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord1ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord1ivARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord1ivARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1ivARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord1sARB_ovr_0(target: TextureUnit; s: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord1sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1sARB(target: TextureUnit; s: Int16) :=
    z_MultiTexCoord1sARB_ovr_0(target, s);
    
    private static procedure z_MultiTexCoord1svARB_ovr_0(target: TextureUnit; var v: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord1svARB';
    private static procedure z_MultiTexCoord1svARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord1svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord1svARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord1svARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1svARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord2dARB_ovr_0(target: TextureUnit; s: real; t: real);
    external 'opengl32.dll' name 'glMultiTexCoord2dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dARB(target: TextureUnit; s: real; t: real) :=
    z_MultiTexCoord2dARB_ovr_0(target, s, t);
    
    private static procedure z_MultiTexCoord2dvARB_ovr_0(target: TextureUnit; var v: real);
    external 'opengl32.dll' name 'glMultiTexCoord2dvARB';
    private static procedure z_MultiTexCoord2dvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord2dvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord2dvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2dvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord2fARB_ovr_0(target: TextureUnit; s: single; t: single);
    external 'opengl32.dll' name 'glMultiTexCoord2fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fARB(target: TextureUnit; s: single; t: single) :=
    z_MultiTexCoord2fARB_ovr_0(target, s, t);
    
    private static procedure z_MultiTexCoord2fvARB_ovr_0(target: TextureUnit; var v: single);
    external 'opengl32.dll' name 'glMultiTexCoord2fvARB';
    private static procedure z_MultiTexCoord2fvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord2fvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord2fvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2fvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord2iARB_ovr_0(target: TextureUnit; s: Int32; t: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord2iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2iARB(target: TextureUnit; s: Int32; t: Int32) :=
    z_MultiTexCoord2iARB_ovr_0(target, s, t);
    
    private static procedure z_MultiTexCoord2ivARB_ovr_0(target: TextureUnit; var v: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord2ivARB';
    private static procedure z_MultiTexCoord2ivARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord2ivARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord2ivARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2ivARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord2sARB_ovr_0(target: TextureUnit; s: Int16; t: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord2sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2sARB(target: TextureUnit; s: Int16; t: Int16) :=
    z_MultiTexCoord2sARB_ovr_0(target, s, t);
    
    private static procedure z_MultiTexCoord2svARB_ovr_0(target: TextureUnit; var v: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord2svARB';
    private static procedure z_MultiTexCoord2svARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord2svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord2svARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord2svARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2svARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord3dARB_ovr_0(target: TextureUnit; s: real; t: real; r: real);
    external 'opengl32.dll' name 'glMultiTexCoord3dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dARB(target: TextureUnit; s: real; t: real; r: real) :=
    z_MultiTexCoord3dARB_ovr_0(target, s, t, r);
    
    private static procedure z_MultiTexCoord3dvARB_ovr_0(target: TextureUnit; var v: real);
    external 'opengl32.dll' name 'glMultiTexCoord3dvARB';
    private static procedure z_MultiTexCoord3dvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord3dvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord3dvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3dvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord3fARB_ovr_0(target: TextureUnit; s: single; t: single; r: single);
    external 'opengl32.dll' name 'glMultiTexCoord3fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fARB(target: TextureUnit; s: single; t: single; r: single) :=
    z_MultiTexCoord3fARB_ovr_0(target, s, t, r);
    
    private static procedure z_MultiTexCoord3fvARB_ovr_0(target: TextureUnit; var v: single);
    external 'opengl32.dll' name 'glMultiTexCoord3fvARB';
    private static procedure z_MultiTexCoord3fvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord3fvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord3fvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3fvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord3iARB_ovr_0(target: TextureUnit; s: Int32; t: Int32; r: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord3iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3iARB(target: TextureUnit; s: Int32; t: Int32; r: Int32) :=
    z_MultiTexCoord3iARB_ovr_0(target, s, t, r);
    
    private static procedure z_MultiTexCoord3ivARB_ovr_0(target: TextureUnit; var v: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord3ivARB';
    private static procedure z_MultiTexCoord3ivARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord3ivARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord3ivARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3ivARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord3sARB_ovr_0(target: TextureUnit; s: Int16; t: Int16; r: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord3sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3sARB(target: TextureUnit; s: Int16; t: Int16; r: Int16) :=
    z_MultiTexCoord3sARB_ovr_0(target, s, t, r);
    
    private static procedure z_MultiTexCoord3svARB_ovr_0(target: TextureUnit; var v: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord3svARB';
    private static procedure z_MultiTexCoord3svARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord3svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord3svARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord3svARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3svARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord4dARB_ovr_0(target: TextureUnit; s: real; t: real; r: real; q: real);
    external 'opengl32.dll' name 'glMultiTexCoord4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dARB(target: TextureUnit; s: real; t: real; r: real; q: real) :=
    z_MultiTexCoord4dARB_ovr_0(target, s, t, r, q);
    
    private static procedure z_MultiTexCoord4dvARB_ovr_0(target: TextureUnit; var v: real);
    external 'opengl32.dll' name 'glMultiTexCoord4dvARB';
    private static procedure z_MultiTexCoord4dvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4dvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4dvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; var v: real) :=
    z_MultiTexCoord4dvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord4dvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4dvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4dvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord4fARB_ovr_0(target: TextureUnit; s: single; t: single; r: single; q: single);
    external 'opengl32.dll' name 'glMultiTexCoord4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fARB(target: TextureUnit; s: single; t: single; r: single; q: single) :=
    z_MultiTexCoord4fARB_ovr_0(target, s, t, r, q);
    
    private static procedure z_MultiTexCoord4fvARB_ovr_0(target: TextureUnit; var v: single);
    external 'opengl32.dll' name 'glMultiTexCoord4fvARB';
    private static procedure z_MultiTexCoord4fvARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4fvARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4fvARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; var v: single) :=
    z_MultiTexCoord4fvARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord4fvARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4fvARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4fvARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord4iARB_ovr_0(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord4iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4iARB(target: TextureUnit; s: Int32; t: Int32; r: Int32; q: Int32) :=
    z_MultiTexCoord4iARB_ovr_0(target, s, t, r, q);
    
    private static procedure z_MultiTexCoord4ivARB_ovr_0(target: TextureUnit; var v: Int32);
    external 'opengl32.dll' name 'glMultiTexCoord4ivARB';
    private static procedure z_MultiTexCoord4ivARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4ivARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4ivARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; var v: Int32) :=
    z_MultiTexCoord4ivARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord4ivARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4ivARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4ivARB_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord4sARB_ovr_0(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord4sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4sARB(target: TextureUnit; s: Int16; t: Int16; r: Int16; q: Int16) :=
    z_MultiTexCoord4sARB_ovr_0(target, s, t, r, q);
    
    private static procedure z_MultiTexCoord4svARB_ovr_0(target: TextureUnit; var v: Int16);
    external 'opengl32.dll' name 'glMultiTexCoord4svARB';
    private static procedure z_MultiTexCoord4svARB_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4svARB_ovr_0(target, v[0]) else
      z_MultiTexCoord4svARB_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; var v: Int16) :=
    z_MultiTexCoord4svARB_ovr_0(target, v);
    private static procedure z_MultiTexCoord4svARB_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4svARB(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4svARB_ovr_2(target, v);
    
  end;
  
  glOcclusionQueryARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenQueriesARB_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glGenQueriesARB';
    private static procedure z_GenQueriesARB_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenQueriesARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenQueriesARB_ovr_0(n, ids[0]) else
      z_GenQueriesARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; var ids: UInt32) :=
    z_GenQueriesARB_ovr_0(n, ids);
    private static procedure z_GenQueriesARB_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenQueriesARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueriesARB(n: Int32; ids: IntPtr) :=
    z_GenQueriesARB_ovr_2(n, ids);
    
    private static procedure z_DeleteQueriesARB_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glDeleteQueriesARB';
    private static procedure z_DeleteQueriesARB_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteQueriesARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteQueriesARB_ovr_0(n, ids[0]) else
      z_DeleteQueriesARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; var ids: UInt32) :=
    z_DeleteQueriesARB_ovr_0(n, ids);
    private static procedure z_DeleteQueriesARB_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteQueriesARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueriesARB(n: Int32; ids: IntPtr) :=
    z_DeleteQueriesARB_ovr_2(n, ids);
    
    private static function z_IsQueryARB_ovr_0(id: UInt32): boolean;
    external 'opengl32.dll' name 'glIsQueryARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsQueryARB(id: UInt32): boolean :=
    z_IsQueryARB_ovr_0(id);
    
    private static procedure z_BeginQueryARB_ovr_0(target: DummyEnum; id: UInt32);
    external 'opengl32.dll' name 'glBeginQueryARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryARB(target: DummyEnum; id: UInt32) :=
    z_BeginQueryARB_ovr_0(target, id);
    
    private static procedure z_EndQueryARB_ovr_0(target: QueryTarget);
    external 'opengl32.dll' name 'glEndQueryARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryARB(target: QueryTarget) :=
    z_EndQueryARB_ovr_0(target);
    
    private static procedure z_GetQueryivARB_ovr_0(target: QueryTarget; pname: QueryParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetQueryivARB';
    private static procedure z_GetQueryivARB_ovr_0_anh0001(target: QueryTarget; pname: QueryParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryivARB_ovr_0(target, pname, &params[0]) else
      z_GetQueryivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryivARB_ovr_0(target, pname, &params);
    private static procedure z_GetQueryivARB_ovr_2(target: QueryTarget; pname: QueryParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryivARB(target: QueryTarget; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryivARB_ovr_2(target, pname, &params);
    
    private static procedure z_GetQueryObjectivARB_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetQueryObjectivARB';
    private static procedure z_GetQueryObjectivARB_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: UInt32; pname: QueryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectivARB_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectivARB_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: UInt32; pname: QueryObjectParameterName; var &params: Int32) :=
    z_GetQueryObjectivARB_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjectivARB_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectivARB(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectivARB_ovr_2(id, pname, &params);
    
    private static procedure z_GetQueryObjectuivARB_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: UInt32);
    external 'opengl32.dll' name 'glGetQueryObjectuivARB';
    private static procedure z_GetQueryObjectuivARB_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: UInt32; pname: QueryObjectParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectuivARB_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectuivARB_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: UInt32; pname: QueryObjectParameterName; var &params: UInt32) :=
    z_GetQueryObjectuivARB_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjectuivARB_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectuivARB(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectuivARB_ovr_2(id, pname, &params);
    
  end;
  
  glParallelShaderCompileARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MaxShaderCompilerThreadsARB_ovr_0(count: UInt32);
    external 'opengl32.dll' name 'glMaxShaderCompilerThreadsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaxShaderCompilerThreadsARB(count: UInt32) :=
    z_MaxShaderCompilerThreadsARB_ovr_0(count);
    
  end;
  
  glPointParametersARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PointParameterfARB_ovr_0(pname: PointParameterNameARB; param: single);
    external 'opengl32.dll' name 'glPointParameterfARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfARB(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfARB_ovr_0(pname, param);
    
    private static procedure z_PointParameterfvARB_ovr_0(pname: PointParameterNameARB; var &params: single);
    external 'opengl32.dll' name 'glPointParameterfvARB';
    private static procedure z_PointParameterfvARB_ovr_0_anh001(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvARB_ovr_0(pname, &params[0]) else
      z_PointParameterfvARB_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvARB_ovr_0(pname, &params);
    private static procedure z_PointParameterfvARB_ovr_2(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvARB(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvARB_ovr_2(pname, &params);
    
  end;
  
  glPolygonOffsetClampARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PolygonOffsetClamp_ovr_0(factor: single; units: single; clamp: single);
    external 'opengl32.dll' name 'glPolygonOffsetClamp';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClamp(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClamp_ovr_0(factor, units, clamp);
    
  end;
  
  glProgramInterfaceQueryARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetProgramInterfaceiv_ovr_0(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramInterfaceiv';
    private static procedure z_GetProgramInterfaceiv_ovr_0_anh00001(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramInterfaceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params[0]) else
      z_GetProgramInterfaceiv_ovr_0_anh00001(&program, _programInterface, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; var &params: Int32) :=
    z_GetProgramInterfaceiv_ovr_0(&program, _programInterface, pname, &params);
    private static procedure z_GetProgramInterfaceiv_ovr_2(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramInterfaceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramInterfaceiv(&program: ProgramName; _programInterface: ProgramInterface; pname: ProgramInterfacePName; &params: IntPtr) :=
    z_GetProgramInterfaceiv_ovr_2(&program, _programInterface, pname, &params);
    
    private static function z_GetProgramResourceIndex_ovr_0(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetProgramResourceIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: ProgramName; _programInterface: ProgramInterface; name: string): UInt32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceIndex(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): UInt32 :=
    z_GetProgramResourceIndex_ovr_0(&program, _programInterface, name);
    
    private static procedure z_GetProgramResourceName_ovr_0(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceName';
    private static procedure z_GetProgramResourceName_ovr_0_anh0000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length[0], name) else
      z_GetProgramResourceName_ovr_0_anh0000010(&program, _programInterface, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetProgramResourceName_ovr_0(&program, _programInterface, index, bufSize, length, name);
    private static procedure z_GetProgramResourceName_ovr_2(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceName(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetProgramResourceName_ovr_2(&program, _programInterface, index, bufSize, length, name);
    
    private static procedure z_GetProgramResourceiv_ovr_0(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000000011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_0_anh000001011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000000011(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourceiv_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourceiv_ovr_0_anh000001011(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramResourceiv_ovr_1_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_1_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_1_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourceiv_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourceiv_ovr_2(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_2_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_2_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_2_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourceiv_ovr_2_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourceiv_ovr_2_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourceiv_ovr_3_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_3_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private static procedure z_GetProgramResourceiv_ovr_4_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_5_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_6(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_6_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_6_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_6_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_6_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourceiv_ovr_6_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private static procedure z_GetProgramResourceiv_ovr_7_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_8(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_8_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourceiv_ovr_8(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourceiv_ovr_8_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourceiv_ovr_0_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; var &params: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_2_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_6_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: ProgramResourceProperty; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_8(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_18(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_18_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_18_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_18_anh000000011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourceiv_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourceiv_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourceiv_ovr_18_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramResourceiv_ovr_19_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; var &params: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourceiv_ovr_20(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_20_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourceiv_ovr_20(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourceiv_ovr_20_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_20(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_24(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    private static procedure z_GetProgramResourceiv_ovr_24_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourceiv_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourceiv_ovr_24_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: Int32) :=
    z_GetProgramResourceiv_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourceiv_ovr_26(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourceiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourceiv(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourceiv_ovr_26(&program, _programInterface, index, propCount, props, count, length, &params);
    
    private static function z_GetProgramResourceLocation_ovr_0(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetProgramResourceLocation';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: ProgramName; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceLocation_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocation(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocation_ovr_0(&program, _programInterface, name);
    
    private static function z_GetProgramResourceLocationIndex_ovr_0(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetProgramResourceLocationIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: ProgramName; _programInterface: ProgramInterface; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetProgramResourceLocationIndex(&program: ProgramName; _programInterface: ProgramInterface; name: IntPtr): Int32 :=
    z_GetProgramResourceLocationIndex_ovr_0(&program, _programInterface, name);
    
  end;
  
  glProvokingVertexARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProvokingVertex_ovr_0(mode: VertexProvokingMode);
    external 'opengl32.dll' name 'glProvokingVertex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertex(mode: VertexProvokingMode) :=
    z_ProvokingVertex_ovr_0(mode);
    
  end;
  
  glRobustnessARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetGraphicsResetStatusARB_ovr_0: GraphicsResetStatus;
    external 'opengl32.dll' name 'glGetGraphicsResetStatusARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatusARB: GraphicsResetStatus :=
    z_GetGraphicsResetStatusARB_ovr_0;
    
    private static procedure z_GetnTexImageARB_ovr_0(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; img: IntPtr);
    external 'opengl32.dll' name 'glGetnTexImageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnTexImageARB(target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; img: IntPtr) :=
    z_GetnTexImageARB_ovr_0(target, level, format, &type, bufSize, img);
    
    private static procedure z_ReadnPixelsARB_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glReadnPixelsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixelsARB(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixelsARB_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    private static procedure z_GetnCompressedTexImageARB_ovr_0(target: TextureTarget; lod: Int32; bufSize: Int32; img: IntPtr);
    external 'opengl32.dll' name 'glGetnCompressedTexImageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnCompressedTexImageARB(target: TextureTarget; lod: Int32; bufSize: Int32; img: IntPtr) :=
    z_GetnCompressedTexImageARB_ovr_0(target, lod, bufSize, img);
    
    private static procedure z_GetnUniformfvARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetnUniformfvARB';
    private static procedure z_GetnUniformfvARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfvARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfvARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfvARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformfvARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfvARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfvARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformivARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetnUniformivARB';
    private static procedure z_GetnUniformivARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformivARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformivARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformivARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformivARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformivARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformivARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformuivARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetnUniformuivARB';
    private static procedure z_GetnUniformuivARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuivARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuivARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuivARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformuivARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuivARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuivARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformdvARB_ovr_0(&program: UInt32; location: Int32; bufSize: Int32; var &params: real);
    external 'opengl32.dll' name 'glGetnUniformdvARB';
    private static procedure z_GetnUniformdvARB_ovr_0_anh00001(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: UInt32; location: Int32; bufSize: Int32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformdvARB_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformdvARB_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: UInt32; location: Int32; bufSize: Int32; var &params: real) :=
    z_GetnUniformdvARB_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformdvARB_ovr_2(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformdvARB(&program: UInt32; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformdvARB_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnMapdvARB_ovr_0(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real);
    external 'opengl32.dll' name 'glGetnMapdvARB';
    private static procedure z_GetnMapdvARB_ovr_0_anh00001(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapdvARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapdvARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: real) :=
    z_GetnMapdvARB_ovr_0(target, query, bufSize, v);
    private static procedure z_GetnMapdvARB_ovr_2(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapdvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapdvARB_ovr_2(target, query, bufSize, v);
    
    private static procedure z_GetnMapfvARB_ovr_0(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single);
    external 'opengl32.dll' name 'glGetnMapfvARB';
    private static procedure z_GetnMapfvARB_ovr_0_anh00001(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapfvARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapfvARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: single) :=
    z_GetnMapfvARB_ovr_0(target, query, bufSize, v);
    private static procedure z_GetnMapfvARB_ovr_2(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapfvARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapfvARB_ovr_2(target, query, bufSize, v);
    
    private static procedure z_GetnMapivARB_ovr_0(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32);
    external 'opengl32.dll' name 'glGetnMapivARB';
    private static procedure z_GetnMapivARB_ovr_0_anh00001(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetnMapivARB_ovr_0(target, query, bufSize, v[0]) else
      z_GetnMapivARB_ovr_0_anh00001(target, query, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; var v: Int32) :=
    z_GetnMapivARB_ovr_0(target, query, bufSize, v);
    private static procedure z_GetnMapivARB_ovr_2(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetnMapivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMapivARB(target: MapTarget; query: MapQuery; bufSize: Int32; v: IntPtr) :=
    z_GetnMapivARB_ovr_2(target, query, bufSize, v);
    
    private static procedure z_GetnPixelMapfvARB_ovr_0(map: PixelMap; bufSize: Int32; var values: single);
    external 'opengl32.dll' name 'glGetnPixelMapfvARB';
    private static procedure z_GetnPixelMapfvARB_ovr_0_anh0001(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapfvARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapfvARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; var values: single) :=
    z_GetnPixelMapfvARB_ovr_0(map, bufSize, values);
    private static procedure z_GetnPixelMapfvARB_ovr_2(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapfvARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapfvARB_ovr_2(map, bufSize, values);
    
    private static procedure z_GetnPixelMapuivARB_ovr_0(map: PixelMap; bufSize: Int32; var values: UInt32);
    external 'opengl32.dll' name 'glGetnPixelMapuivARB';
    private static procedure z_GetnPixelMapuivARB_ovr_0_anh0001(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; values: array of UInt32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapuivARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapuivARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; var values: UInt32) :=
    z_GetnPixelMapuivARB_ovr_0(map, bufSize, values);
    private static procedure z_GetnPixelMapuivARB_ovr_2(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapuivARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapuivARB_ovr_2(map, bufSize, values);
    
    private static procedure z_GetnPixelMapusvARB_ovr_0(map: PixelMap; bufSize: Int32; var values: UInt16);
    external 'opengl32.dll' name 'glGetnPixelMapusvARB';
    private static procedure z_GetnPixelMapusvARB_ovr_0_anh0001(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; values: array of UInt16) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetnPixelMapusvARB_ovr_0(map, bufSize, values[0]) else
      z_GetnPixelMapusvARB_ovr_0_anh0001(map, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; var values: UInt16) :=
    z_GetnPixelMapusvARB_ovr_0(map, bufSize, values);
    private static procedure z_GetnPixelMapusvARB_ovr_2(map: PixelMap; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnPixelMapusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPixelMapusvARB(map: PixelMap; bufSize: Int32; values: IntPtr) :=
    z_GetnPixelMapusvARB_ovr_2(map, bufSize, values);
    
    private static procedure z_GetnPolygonStippleARB_ovr_0(bufSize: Int32; var pattern: Byte);
    external 'opengl32.dll' name 'glGetnPolygonStippleARB';
    private static procedure z_GetnPolygonStippleARB_ovr_0_anh001(bufSize: Int32; pattern: IntPtr);
    external 'opengl32.dll' name 'glGetnPolygonStippleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; pattern: array of Byte) :=
    if (pattern<>nil) and (pattern.Length<>0) then
      z_GetnPolygonStippleARB_ovr_0(bufSize, pattern[0]) else
      z_GetnPolygonStippleARB_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; var pattern: Byte) :=
    z_GetnPolygonStippleARB_ovr_0(bufSize, pattern);
    private static procedure z_GetnPolygonStippleARB_ovr_2(bufSize: Int32; pattern: IntPtr);
    external 'opengl32.dll' name 'glGetnPolygonStippleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnPolygonStippleARB(bufSize: Int32; pattern: IntPtr) :=
    z_GetnPolygonStippleARB_ovr_2(bufSize, pattern);
    
    private static procedure z_GetnColorTableARB_ovr_0(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr);
    external 'opengl32.dll' name 'glGetnColorTableARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnColorTableARB(target: ColorTableTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; table: IntPtr) :=
    z_GetnColorTableARB_ovr_0(target, format, &type, bufSize, table);
    
    private static procedure z_GetnConvolutionFilterARB_ovr_0(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr);
    external 'opengl32.dll' name 'glGetnConvolutionFilterARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnConvolutionFilterARB(target: ConvolutionTarget; format: PixelFormat; &type: PixelType; bufSize: Int32; image: IntPtr) :=
    z_GetnConvolutionFilterARB_ovr_0(target, format, &type, bufSize, image);
    
    private static procedure z_GetnSeparableFilterARB_ovr_0(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr);
    external 'opengl32.dll' name 'glGetnSeparableFilterARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnSeparableFilterARB(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; rowBufSize: Int32; row: IntPtr; columnBufSize: Int32; column: IntPtr; span: IntPtr) :=
    z_GetnSeparableFilterARB_ovr_0(target, format, &type, rowBufSize, row, columnBufSize, column, span);
    
    private static procedure z_GetnHistogramARB_ovr_0(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnHistogramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnHistogramARB(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnHistogramARB_ovr_0(target, reset, format, &type, bufSize, values);
    
    private static procedure z_GetnMinmaxARB_ovr_0(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetnMinmaxARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnMinmaxARB(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; bufSize: Int32; values: IntPtr) :=
    z_GetnMinmaxARB_ovr_0(target, reset, format, &type, bufSize, values);
    
  end;
  
  glSampleLocationsARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferSampleLocationsfvARB_ovr_0(target: FramebufferTarget; start: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvARB';
    private static procedure z_FramebufferSampleLocationsfvARB_ovr_0_anh00001(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_FramebufferSampleLocationsfvARB_ovr_0(target, start, count, v[0]) else
      z_FramebufferSampleLocationsfvARB_ovr_0_anh00001(target, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; var v: single) :=
    z_FramebufferSampleLocationsfvARB_ovr_0(target, start, count, v);
    private static procedure z_FramebufferSampleLocationsfvARB_ovr_2(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvARB(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr) :=
    z_FramebufferSampleLocationsfvARB_ovr_2(target, start, count, v);
    
    private static procedure z_NamedFramebufferSampleLocationsfvARB_ovr_0(framebuffer: UInt32; start: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvARB';
    private static procedure z_NamedFramebufferSampleLocationsfvARB_ovr_0_anh00001(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: UInt32; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_NamedFramebufferSampleLocationsfvARB_ovr_0(framebuffer, start, count, v[0]) else
      z_NamedFramebufferSampleLocationsfvARB_ovr_0_anh00001(framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: UInt32; start: UInt32; count: Int32; var v: single) :=
    z_NamedFramebufferSampleLocationsfvARB_ovr_0(framebuffer, start, count, v);
    private static procedure z_NamedFramebufferSampleLocationsfvARB_ovr_2(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvARB(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr) :=
    z_NamedFramebufferSampleLocationsfvARB_ovr_2(framebuffer, start, count, v);
    
    private static procedure z_EvaluateDepthValuesARB_ovr_0;
    external 'opengl32.dll' name 'glEvaluateDepthValuesARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvaluateDepthValuesARB :=
    z_EvaluateDepthValuesARB_ovr_0;
    
  end;
  
  glSampleShadingARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MinSampleShadingARB_ovr_0(value: single);
    external 'opengl32.dll' name 'glMinSampleShadingARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinSampleShadingARB(value: single) :=
    z_MinSampleShadingARB_ovr_0(value);
    
  end;
  
  glSamplerObjectsARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenSamplers_ovr_0(count: Int32; var samplers: UInt32);
    external 'opengl32.dll' name 'glGenSamplers';
    private static procedure z_GenSamplers_ovr_0_anh001(count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glGenSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_GenSamplers_ovr_0(count, samplers[0]) else
      z_GenSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; var samplers: UInt32) :=
    z_GenSamplers_ovr_0(count, samplers);
    private static procedure z_GenSamplers_ovr_2(count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glGenSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSamplers(count: Int32; samplers: IntPtr) :=
    z_GenSamplers_ovr_2(count, samplers);
    
    private static procedure z_DeleteSamplers_ovr_0(count: Int32; var samplers: UInt32);
    external 'opengl32.dll' name 'glDeleteSamplers';
    private static procedure z_DeleteSamplers_ovr_0_anh001(count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glDeleteSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: array of UInt32) :=
    if (samplers<>nil) and (samplers.Length<>0) then
      z_DeleteSamplers_ovr_0(count, samplers[0]) else
      z_DeleteSamplers_ovr_0_anh001(count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; var samplers: UInt32) :=
    z_DeleteSamplers_ovr_0(count, samplers);
    private static procedure z_DeleteSamplers_ovr_2(count: Int32; samplers: IntPtr);
    external 'opengl32.dll' name 'glDeleteSamplers';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSamplers(count: Int32; samplers: IntPtr) :=
    z_DeleteSamplers_ovr_2(count, samplers);
    
    private static function z_IsSampler_ovr_0(sampler: SamplerName): boolean;
    external 'opengl32.dll' name 'glIsSampler';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSampler(sampler: SamplerName): boolean :=
    z_IsSampler_ovr_0(sampler);
    
    private static procedure z_BindSampler_ovr_0(&unit: UInt32; sampler: SamplerName);
    external 'opengl32.dll' name 'glBindSampler';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindSampler(&unit: UInt32; sampler: SamplerName) :=
    z_BindSampler_ovr_0(&unit, sampler);
    
    private static procedure z_SamplerParameteri_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: Int32);
    external 'opengl32.dll' name 'glSamplerParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteri(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: Int32) :=
    z_SamplerParameteri_ovr_0(sampler, pname, param);
    
    private static procedure z_SamplerParameteriv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32);
    external 'opengl32.dll' name 'glSamplerParameteriv';
    private static procedure z_SamplerParameteriv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameteriv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameteriv_ovr_0(sampler, pname, param);
    private static procedure z_SamplerParameteriv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameteriv_ovr_2(sampler, pname, param);
    
    private static procedure z_SamplerParameterf_ovr_0(sampler: SamplerName; pname: OpenGL.SamplerParameterF; param: single);
    external 'opengl32.dll' name 'glSamplerParameterf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterf(sampler: SamplerName; pname: OpenGL.SamplerParameterF; param: single) :=
    z_SamplerParameterf_ovr_0(sampler, pname, param);
    
    private static procedure z_SamplerParameterfv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterF; var param: single);
    external 'opengl32.dll' name 'glSamplerParameterfv';
    private static procedure z_SamplerParameterfv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterfv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; var param: single) :=
    z_SamplerParameterfv_ovr_0(sampler, pname, param);
    private static procedure z_SamplerParameterfv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; param: IntPtr) :=
    z_SamplerParameterfv_ovr_2(sampler, pname, param);
    
    private static procedure z_SamplerParameterIiv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32);
    external 'opengl32.dll' name 'glSamplerParameterIiv';
    private static procedure z_SamplerParameterIiv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: Int32) :=
    z_SamplerParameterIiv_ovr_0(sampler, pname, param);
    private static procedure z_SamplerParameterIiv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIiv_ovr_2(sampler, pname, param);
    
    private static procedure z_SamplerParameterIuiv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: UInt32);
    external 'opengl32.dll' name 'glSamplerParameterIuiv';
    private static procedure z_SamplerParameterIuiv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_SamplerParameterIuiv_ovr_0(sampler, pname, param[0]) else
      z_SamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var param: UInt32) :=
    z_SamplerParameterIuiv_ovr_0(sampler, pname, param);
    private static procedure z_SamplerParameterIuiv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr);
    external 'opengl32.dll' name 'glSamplerParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; param: IntPtr) :=
    z_SamplerParameterIuiv_ovr_2(sampler, pname, param);
    
    private static procedure z_GetSamplerParameteriv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: Int32);
    external 'opengl32.dll' name 'glGetSamplerParameteriv';
    private static procedure z_GetSamplerParameteriv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameteriv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameteriv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameteriv_ovr_0(sampler, pname, &params);
    private static procedure z_GetSamplerParameteriv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameteriv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameteriv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameteriv_ovr_2(sampler, pname, &params);
    
    private static procedure z_GetSamplerParameterIiv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: Int32);
    external 'opengl32.dll' name 'glGetSamplerParameterIiv';
    private static procedure z_GetSamplerParameterIiv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: Int32) :=
    z_GetSamplerParameterIiv_ovr_0(sampler, pname, &params);
    private static procedure z_GetSamplerParameterIiv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterIiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIiv_ovr_2(sampler, pname, &params);
    
    private static procedure z_GetSamplerParameterfv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterF; var &params: single);
    external 'opengl32.dll' name 'glGetSamplerParameterfv';
    private static procedure z_GetSamplerParameterfv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterF; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterfv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterfv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; var &params: single) :=
    z_GetSamplerParameterfv_ovr_0(sampler, pname, &params);
    private static procedure z_GetSamplerParameterfv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterF; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterfv(sampler: UInt32; pname: OpenGL.SamplerParameterF; &params: IntPtr) :=
    z_GetSamplerParameterfv_ovr_2(sampler, pname, &params);
    
    private static procedure z_GetSamplerParameterIuiv_ovr_0(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: UInt32);
    external 'opengl32.dll' name 'glGetSamplerParameterIuiv';
    private static procedure z_GetSamplerParameterIuiv_ovr_0_anh0001(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params[0]) else
      z_GetSamplerParameterIuiv_ovr_0_anh0001(sampler, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; var &params: UInt32) :=
    z_GetSamplerParameterIuiv_ovr_0(sampler, pname, &params);
    private static procedure z_GetSamplerParameterIuiv_ovr_2(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSamplerParameterIuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSamplerParameterIuiv(sampler: UInt32; pname: OpenGL.SamplerParameterI; &params: IntPtr) :=
    z_GetSamplerParameterIuiv_ovr_2(sampler, pname, &params);
    
  end;
  
  glSeparateShaderObjectsARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_UseProgramStages_ovr_0(pipeline: ProgramPipelineName; stages: UseProgramStageMask; &program: ProgramName);
    external 'opengl32.dll' name 'glUseProgramStages';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramStages(pipeline: ProgramPipelineName; stages: UseProgramStageMask; &program: ProgramName) :=
    z_UseProgramStages_ovr_0(pipeline, stages, &program);
    
    private static procedure z_ActiveShaderProgram_ovr_0(pipeline: ProgramPipelineName; &program: ProgramName);
    external 'opengl32.dll' name 'glActiveShaderProgram';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveShaderProgram(pipeline: ProgramPipelineName; &program: ProgramName) :=
    z_ActiveShaderProgram_ovr_0(pipeline, &program);
    
    private static function z_CreateShaderProgramv_ovr_0(&type: ShaderType; count: Int32; var strings: IntPtr): ProgramName;
    external 'opengl32.dll' name 'glCreateShaderProgramv';
    private static function z_CreateShaderProgramv_ovr_0_anh0001(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName;
    external 'opengl32.dll' name 'glCreateShaderProgramv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of string): ProgramName;
    begin
      var par_3_str_ptr := strings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        Result := z_CreateShaderProgramv_ovr_0(&type, count, par_3_str_ptr[0]) else
        Result := z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static function z_CreateShaderProgramv_ovr_1_anh0001(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName;
    external 'opengl32.dll' name 'glCreateShaderProgramv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: array of IntPtr): ProgramName :=
    if (strings<>nil) and (strings.Length<>0) then
      z_CreateShaderProgramv_ovr_0(&type, count, strings[0]) else
      z_CreateShaderProgramv_ovr_0_anh0001(&type, count, IntPtr.Zero);
    private static function z_CreateShaderProgramv_ovr_2(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName;
    external 'opengl32.dll' name 'glCreateShaderProgramv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramv(&type: ShaderType; count: Int32; strings: IntPtr): ProgramName :=
    z_CreateShaderProgramv_ovr_2(&type, count, strings);
    
    private static procedure z_BindProgramPipeline_ovr_0(pipeline: ProgramPipelineName);
    external 'opengl32.dll' name 'glBindProgramPipeline';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramPipeline(pipeline: ProgramPipelineName) :=
    z_BindProgramPipeline_ovr_0(pipeline);
    
    private static procedure z_DeleteProgramPipelines_ovr_0(n: Int32; var pipelines: UInt32);
    external 'opengl32.dll' name 'glDeleteProgramPipelines';
    private static procedure z_DeleteProgramPipelines_ovr_0_anh001(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_DeleteProgramPipelines_ovr_0(n, pipelines[0]) else
      z_DeleteProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_DeleteProgramPipelines_ovr_0(n, pipelines);
    private static procedure z_DeleteProgramPipelines_ovr_2(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_DeleteProgramPipelines_ovr_2(n, pipelines);
    
    private static procedure z_GenProgramPipelines_ovr_0(n: Int32; var pipelines: UInt32);
    external 'opengl32.dll' name 'glGenProgramPipelines';
    private static procedure z_GenProgramPipelines_ovr_0_anh001(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glGenProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: array of UInt32) :=
    if (pipelines<>nil) and (pipelines.Length<>0) then
      z_GenProgramPipelines_ovr_0(n, pipelines[0]) else
      z_GenProgramPipelines_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; var pipelines: UInt32) :=
    z_GenProgramPipelines_ovr_0(n, pipelines);
    private static procedure z_GenProgramPipelines_ovr_2(n: Int32; pipelines: IntPtr);
    external 'opengl32.dll' name 'glGenProgramPipelines';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramPipelines(n: Int32; pipelines: IntPtr) :=
    z_GenProgramPipelines_ovr_2(n, pipelines);
    
    private static function z_IsProgramPipeline_ovr_0(pipeline: ProgramPipelineName): boolean;
    external 'opengl32.dll' name 'glIsProgramPipeline';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramPipeline(pipeline: ProgramPipelineName): boolean :=
    z_IsProgramPipeline_ovr_0(pipeline);
    
    private static procedure z_GetProgramPipelineiv_ovr_0(pipeline: UInt32; pname: PipelineParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramPipelineiv';
    private static procedure z_GetProgramPipelineiv_ovr_0_anh0001(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramPipelineiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params[0]) else
      z_GetProgramPipelineiv_ovr_0_anh0001(pipeline, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; var &params: Int32) :=
    z_GetProgramPipelineiv_ovr_0(pipeline, pname, &params);
    private static procedure z_GetProgramPipelineiv_ovr_2(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramPipelineiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineiv(pipeline: UInt32; pname: PipelineParameterName; &params: IntPtr) :=
    z_GetProgramPipelineiv_ovr_2(pipeline, pname, &params);
    
    private static procedure z_ProgramParameteri_ovr_0(&program: ProgramName; pname: ProgramParameterPName; value: Int32);
    external 'opengl32.dll' name 'glProgramParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteri(&program: ProgramName; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteri_ovr_0(&program, pname, value);
    
    private static procedure z_ProgramUniform1i_ovr_0(&program: ProgramName; location: Int32; v0: Int32);
    external 'opengl32.dll' name 'glProgramUniform1i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i(&program: ProgramName; location: Int32; v0: Int32) :=
    z_ProgramUniform1i_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform1iv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform1iv';
    private static procedure z_ProgramUniform1iv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1iv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1iv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1iv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1f_ovr_0(&program: ProgramName; location: Int32; v0: single);
    external 'opengl32.dll' name 'glProgramUniform1f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1f(&program: ProgramName; location: Int32; v0: single) :=
    z_ProgramUniform1f_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform1fv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform1fv';
    private static procedure z_ProgramUniform1fv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1fv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1d_ovr_0(&program: ProgramName; location: Int32; v0: real);
    external 'opengl32.dll' name 'glProgramUniform1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1d(&program: ProgramName; location: Int32; v0: real) :=
    z_ProgramUniform1d_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform1dv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform1dv';
    private static procedure z_ProgramUniform1dv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1dv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1ui_ovr_0(&program: ProgramName; location: Int32; v0: UInt32);
    external 'opengl32.dll' name 'glProgramUniform1ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui(&program: ProgramName; location: Int32; v0: UInt32) :=
    z_ProgramUniform1ui_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform1uiv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform1uiv';
    private static procedure z_ProgramUniform1uiv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uiv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1uiv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uiv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2i_ovr_0(&program: ProgramName; location: Int32; v0: Int32; v1: Int32);
    external 'opengl32.dll' name 'glProgramUniform2i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2i_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform2iv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform2iv';
    private static procedure z_ProgramUniform2iv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2iv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2iv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2iv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2f_ovr_0(&program: ProgramName; location: Int32; v0: single; v1: single);
    external 'opengl32.dll' name 'glProgramUniform2f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2f(&program: ProgramName; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2f_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform2fv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform2fv';
    private static procedure z_ProgramUniform2fv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2fv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2d_ovr_0(&program: ProgramName; location: Int32; v0: real; v1: real);
    external 'opengl32.dll' name 'glProgramUniform2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2d(&program: ProgramName; location: Int32; v0: real; v1: real) :=
    z_ProgramUniform2d_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform2dv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform2dv';
    private static procedure z_ProgramUniform2dv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2dv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2ui_ovr_0(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32);
    external 'opengl32.dll' name 'glProgramUniform2ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2ui_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform2uiv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform2uiv';
    private static procedure z_ProgramUniform2uiv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uiv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2uiv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uiv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3i_ovr_0(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32);
    external 'opengl32.dll' name 'glProgramUniform3i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3i_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform3iv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform3iv';
    private static procedure z_ProgramUniform3iv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3iv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3iv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3iv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3f_ovr_0(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single);
    external 'opengl32.dll' name 'glProgramUniform3f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3f(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3f_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform3fv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform3fv';
    private static procedure z_ProgramUniform3fv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3fv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3d_ovr_0(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real);
    external 'opengl32.dll' name 'glProgramUniform3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3d(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real) :=
    z_ProgramUniform3d_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform3dv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform3dv';
    private static procedure z_ProgramUniform3dv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3dv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3ui_ovr_0(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32);
    external 'opengl32.dll' name 'glProgramUniform3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3ui_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform3uiv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform3uiv';
    private static procedure z_ProgramUniform3uiv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uiv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3uiv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uiv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4i_ovr_0(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32);
    external 'opengl32.dll' name 'glProgramUniform4i';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i(&program: ProgramName; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4i_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform4iv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform4iv';
    private static procedure z_ProgramUniform4iv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4iv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4iv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4iv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4iv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4iv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4iv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4f_ovr_0(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single; v3: single);
    external 'opengl32.dll' name 'glProgramUniform4f';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4f(&program: ProgramName; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4f_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform4fv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform4fv';
    private static procedure z_ProgramUniform4fv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4fv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4d_ovr_0(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real; v3: real);
    external 'opengl32.dll' name 'glProgramUniform4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4d(&program: ProgramName; location: Int32; v0: real; v1: real; v2: real; v3: real) :=
    z_ProgramUniform4d_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform4dv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform4dv';
    private static procedure z_ProgramUniform4dv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4dv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4ui_ovr_0(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32);
    external 'opengl32.dll' name 'glProgramUniform4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui(&program: ProgramName; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4ui_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform4uiv_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform4uiv';
    private static procedure z_ProgramUniform4uiv_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uiv_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uiv_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uiv_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4uiv_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiv(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uiv_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniformMatrix2fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fv';
    private static procedure z_ProgramUniformMatrix2fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fv';
    private static procedure z_ProgramUniformMatrix3fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fv';
    private static procedure z_ProgramUniformMatrix4fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dv';
    private static procedure z_ProgramUniformMatrix2dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dv';
    private static procedure z_ProgramUniformMatrix3dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dv';
    private static procedure z_ProgramUniformMatrix4dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x3fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fv';
    private static procedure z_ProgramUniformMatrix2x3fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x3fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x2fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fv';
    private static procedure z_ProgramUniformMatrix3x2fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x2fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x4fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fv';
    private static procedure z_ProgramUniformMatrix2x4fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x4fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x2fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fv';
    private static procedure z_ProgramUniformMatrix4x2fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x2fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x4fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fv';
    private static procedure z_ProgramUniformMatrix3x4fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x4fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x3fv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fv';
    private static procedure z_ProgramUniformMatrix4x3fv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x3fv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x3dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dv';
    private static procedure z_ProgramUniformMatrix2x3dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x3dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x2dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dv';
    private static procedure z_ProgramUniformMatrix3x2dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x2dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x4dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dv';
    private static procedure z_ProgramUniformMatrix2x4dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x4dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x2dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dv';
    private static procedure z_ProgramUniformMatrix4x2dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x2dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x4dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dv';
    private static procedure z_ProgramUniformMatrix3x4dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x4dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x3dv_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dv';
    private static procedure z_ProgramUniformMatrix4x3dv_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dv_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dv_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x3dv_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dv(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dv_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ValidateProgramPipeline_ovr_0(pipeline: ProgramPipelineName);
    external 'opengl32.dll' name 'glValidateProgramPipeline';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramPipeline(pipeline: ProgramPipelineName) :=
    z_ValidateProgramPipeline_ovr_0(pipeline);
    
    private static procedure z_GetProgramPipelineInfoLog_ovr_0(pipeline: UInt32; bufSize: Int32; var length: Int32; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetProgramPipelineInfoLog';
    private static procedure z_GetProgramPipelineInfoLog_ovr_0_anh00010(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetProgramPipelineInfoLog';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; length: array of Int32; infoLog: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length[0], infoLog) else
      z_GetProgramPipelineInfoLog_ovr_0_anh00010(pipeline, bufSize, IntPtr.Zero, infoLog);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_0(pipeline, bufSize, length, infoLog);
    private static procedure z_GetProgramPipelineInfoLog_ovr_2(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetProgramPipelineInfoLog';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramPipelineInfoLog(pipeline: UInt32; bufSize: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetProgramPipelineInfoLog_ovr_2(pipeline, bufSize, length, infoLog);
    
  end;
  
  glShaderAtomicCountersARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetActiveAtomicCounterBufferiv_ovr_0(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveAtomicCounterBufferiv';
    private static procedure z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAtomicCounterBufferiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params[0]) else
      z_GetActiveAtomicCounterBufferiv_ovr_0_anh00001(&program, bufferIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; var &params: Int32) :=
    z_GetActiveAtomicCounterBufferiv_ovr_0(&program, bufferIndex, pname, &params);
    private static procedure z_GetActiveAtomicCounterBufferiv_ovr_2(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAtomicCounterBufferiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAtomicCounterBufferiv(&program: UInt32; bufferIndex: UInt32; pname: AtomicCounterBufferPName; &params: IntPtr) :=
    z_GetActiveAtomicCounterBufferiv_ovr_2(&program, bufferIndex, pname, &params);
    
  end;
  
  glShaderImageLoadStoreARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindImageTexture_ovr_0(&unit: UInt32; texture: TextureName; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat);
    external 'opengl32.dll' name 'glBindImageTexture';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTexture(&unit: UInt32; texture: TextureName; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: InternalFormat) :=
    z_BindImageTexture_ovr_0(&unit, texture, level, layered, layer, access, format);
    
    private static procedure z_MemoryBarrier_ovr_0(barriers: MemoryBarrierMask);
    external 'opengl32.dll' name 'glMemoryBarrier';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrier(barriers: MemoryBarrierMask) :=
    z_MemoryBarrier_ovr_0(barriers);
    
  end;
  
  glShaderObjectsARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DeleteObjectARB_ovr_0(obj: GLhandleARB);
    external 'opengl32.dll' name 'glDeleteObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteObjectARB(obj: GLhandleARB) :=
    z_DeleteObjectARB_ovr_0(obj);
    
    private static function z_GetHandleARB_ovr_0(pname: DummyEnum): GLhandleARB;
    external 'opengl32.dll' name 'glGetHandleARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetHandleARB(pname: DummyEnum): GLhandleARB :=
    z_GetHandleARB_ovr_0(pname);
    
    private static procedure z_DetachObjectARB_ovr_0(containerObj: GLhandleARB; attachedObj: GLhandleARB);
    external 'opengl32.dll' name 'glDetachObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetachObjectARB(containerObj: GLhandleARB; attachedObj: GLhandleARB) :=
    z_DetachObjectARB_ovr_0(containerObj, attachedObj);
    
    private static function z_CreateShaderObjectARB_ovr_0(_shaderType: ShaderType): GLhandleARB;
    external 'opengl32.dll' name 'glCreateShaderObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderObjectARB(_shaderType: ShaderType): GLhandleARB :=
    z_CreateShaderObjectARB_ovr_0(_shaderType);
    
    private static procedure z_ShaderSourceARB_ovr_0(shaderObj: GLhandleARB; count: Int32; var _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_0_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_0_anh00001(shaderObj: GLhandleARB; count: Int32; var _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_0_anh00011(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of string; length: array of Int32);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        if (length<>nil) and (length.Length<>0) then
          z_ShaderSourceARB_ovr_0(shaderObj, count, par_3_str_ptr[0], length[0]) else
          z_ShaderSourceARB_ovr_0_anh00001(shaderObj, count, par_3_str_ptr[0], IntPtr.Zero) else
        if (length<>nil) and (length.Length<>0) then
          z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length[0]) else
          z_ShaderSourceARB_ovr_0_anh00011(shaderObj, count, IntPtr.Zero, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_ShaderSourceARB_ovr_1_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of string; var length: Int32);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_ShaderSourceARB_ovr_0(shaderObj, count, par_3_str_ptr[0], length) else
        z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_ShaderSourceARB_ovr_2(shaderObj: GLhandleARB; count: Int32; var _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_2_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of string; length: IntPtr);
    begin
      var par_3_str_ptr := _string?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_ShaderSourceARB_ovr_2(shaderObj, count, par_3_str_ptr[0], length) else
        z_ShaderSourceARB_ovr_2_anh00010(shaderObj, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_ShaderSourceARB_ovr_3_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_3_anh00011(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of IntPtr; length: array of Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSourceARB_ovr_0(shaderObj, count, _string[0], length[0]) else
        z_ShaderSourceARB_ovr_0_anh00001(shaderObj, count, _string[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length[0]) else
        z_ShaderSourceARB_ovr_0_anh00011(shaderObj, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_ShaderSourceARB_ovr_4_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of IntPtr; var length: Int32) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSourceARB_ovr_0(shaderObj, count, _string[0], length) else
      z_ShaderSourceARB_ovr_0_anh00010(shaderObj, count, IntPtr.Zero, length);
    private static procedure z_ShaderSourceARB_ovr_5_anh00010(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: array of IntPtr; length: IntPtr) :=
    if (_string<>nil) and (_string.Length<>0) then
      z_ShaderSourceARB_ovr_2(shaderObj, count, _string[0], length) else
      z_ShaderSourceARB_ovr_2_anh00010(shaderObj, count, IntPtr.Zero, length);
    private static procedure z_ShaderSourceARB_ovr_6(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glShaderSourceARB';
    private static procedure z_ShaderSourceARB_ovr_6_anh00001(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_ShaderSourceARB_ovr_6(shaderObj, count, _string, length[0]) else
      z_ShaderSourceARB_ovr_6_anh00001(shaderObj, count, _string, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; var length: Int32) :=
    z_ShaderSourceARB_ovr_6(shaderObj, count, _string, length);
    private static procedure z_ShaderSourceARB_ovr_8(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderSourceARB(shaderObj: GLhandleARB; count: Int32; _string: IntPtr; length: IntPtr) :=
    z_ShaderSourceARB_ovr_8(shaderObj, count, _string, length);
    
    private static procedure z_CompileShaderARB_ovr_0(shaderObj: GLhandleARB);
    external 'opengl32.dll' name 'glCompileShaderARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderARB(shaderObj: GLhandleARB) :=
    z_CompileShaderARB_ovr_0(shaderObj);
    
    private static function z_CreateProgramObjectARB_ovr_0: GLhandleARB;
    external 'opengl32.dll' name 'glCreateProgramObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgramObjectARB: GLhandleARB :=
    z_CreateProgramObjectARB_ovr_0;
    
    private static procedure z_AttachObjectARB_ovr_0(containerObj: GLhandleARB; obj: GLhandleARB);
    external 'opengl32.dll' name 'glAttachObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AttachObjectARB(containerObj: GLhandleARB; obj: GLhandleARB) :=
    z_AttachObjectARB_ovr_0(containerObj, obj);
    
    private static procedure z_LinkProgramARB_ovr_0(programObj: GLhandleARB);
    external 'opengl32.dll' name 'glLinkProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LinkProgramARB(programObj: GLhandleARB) :=
    z_LinkProgramARB_ovr_0(programObj);
    
    private static procedure z_UseProgramObjectARB_ovr_0(programObj: GLhandleARB);
    external 'opengl32.dll' name 'glUseProgramObjectARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseProgramObjectARB(programObj: GLhandleARB) :=
    z_UseProgramObjectARB_ovr_0(programObj);
    
    private static procedure z_ValidateProgramARB_ovr_0(programObj: GLhandleARB);
    external 'opengl32.dll' name 'glValidateProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ValidateProgramARB(programObj: GLhandleARB) :=
    z_ValidateProgramARB_ovr_0(programObj);
    
    private static procedure z_Uniform1fARB_ovr_0(location: Int32; v0: single);
    external 'opengl32.dll' name 'glUniform1fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fARB(location: Int32; v0: single) :=
    z_Uniform1fARB_ovr_0(location, v0);
    
    private static procedure z_Uniform2fARB_ovr_0(location: Int32; v0: single; v1: single);
    external 'opengl32.dll' name 'glUniform2fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fARB(location: Int32; v0: single; v1: single) :=
    z_Uniform2fARB_ovr_0(location, v0, v1);
    
    private static procedure z_Uniform3fARB_ovr_0(location: Int32; v0: single; v1: single; v2: single);
    external 'opengl32.dll' name 'glUniform3fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fARB(location: Int32; v0: single; v1: single; v2: single) :=
    z_Uniform3fARB_ovr_0(location, v0, v1, v2);
    
    private static procedure z_Uniform4fARB_ovr_0(location: Int32; v0: single; v1: single; v2: single; v3: single);
    external 'opengl32.dll' name 'glUniform4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fARB(location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_Uniform4fARB_ovr_0(location, v0, v1, v2, v3);
    
    private static procedure z_Uniform1iARB_ovr_0(location: Int32; v0: Int32);
    external 'opengl32.dll' name 'glUniform1iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1iARB(location: Int32; v0: Int32) :=
    z_Uniform1iARB_ovr_0(location, v0);
    
    private static procedure z_Uniform2iARB_ovr_0(location: Int32; v0: Int32; v1: Int32);
    external 'opengl32.dll' name 'glUniform2iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2iARB(location: Int32; v0: Int32; v1: Int32) :=
    z_Uniform2iARB_ovr_0(location, v0, v1);
    
    private static procedure z_Uniform3iARB_ovr_0(location: Int32; v0: Int32; v1: Int32; v2: Int32);
    external 'opengl32.dll' name 'glUniform3iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3iARB(location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_Uniform3iARB_ovr_0(location, v0, v1, v2);
    
    private static procedure z_Uniform4iARB_ovr_0(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32);
    external 'opengl32.dll' name 'glUniform4iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4iARB(location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_Uniform4iARB_ovr_0(location, v0, v1, v2, v3);
    
    private static procedure z_Uniform1fvARB_ovr_0(location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glUniform1fvARB';
    private static procedure z_Uniform1fvARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1fvARB_ovr_0(location, count, value[0]) else
      z_Uniform1fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform1fvARB_ovr_0(location, count, value);
    private static procedure z_Uniform1fvARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1fvARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform2fvARB_ovr_0(location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glUniform2fvARB';
    private static procedure z_Uniform2fvARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2fvARB_ovr_0(location, count, value[0]) else
      z_Uniform2fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform2fvARB_ovr_0(location, count, value);
    private static procedure z_Uniform2fvARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2fvARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform3fvARB_ovr_0(location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glUniform3fvARB';
    private static procedure z_Uniform3fvARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3fvARB_ovr_0(location, count, value[0]) else
      z_Uniform3fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform3fvARB_ovr_0(location, count, value);
    private static procedure z_Uniform3fvARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3fvARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform4fvARB_ovr_0(location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glUniform4fvARB';
    private static procedure z_Uniform4fvARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4fvARB_ovr_0(location, count, value[0]) else
      z_Uniform4fvARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; var value: single) :=
    z_Uniform4fvARB_ovr_0(location, count, value);
    private static procedure z_Uniform4fvARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4fvARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4fvARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform1ivARB_ovr_0(location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glUniform1ivARB';
    private static procedure z_Uniform1ivARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ivARB_ovr_0(location, count, value[0]) else
      z_Uniform1ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform1ivARB_ovr_0(location, count, value);
    private static procedure z_Uniform1ivARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ivARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform2ivARB_ovr_0(location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glUniform2ivARB';
    private static procedure z_Uniform2ivARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ivARB_ovr_0(location, count, value[0]) else
      z_Uniform2ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform2ivARB_ovr_0(location, count, value);
    private static procedure z_Uniform2ivARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ivARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform3ivARB_ovr_0(location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glUniform3ivARB';
    private static procedure z_Uniform3ivARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ivARB_ovr_0(location, count, value[0]) else
      z_Uniform3ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform3ivARB_ovr_0(location, count, value);
    private static procedure z_Uniform3ivARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ivARB_ovr_2(location, count, value);
    
    private static procedure z_Uniform4ivARB_ovr_0(location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glUniform4ivARB';
    private static procedure z_Uniform4ivARB_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ivARB_ovr_0(location, count, value[0]) else
      z_Uniform4ivARB_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; var value: Int32) :=
    z_Uniform4ivARB_ovr_0(location, count, value);
    private static procedure z_Uniform4ivARB_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ivARB(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ivARB_ovr_2(location, count, value);
    
    private static procedure z_UniformMatrix2fvARB_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glUniformMatrix2fvARB';
    private static procedure z_UniformMatrix2fvARB_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix2fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix2fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix2fvARB_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix2fvARB_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix2fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix2fvARB_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix3fvARB_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glUniformMatrix3fvARB';
    private static procedure z_UniformMatrix3fvARB_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix3fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix3fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix3fvARB_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix3fvARB_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix3fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix3fvARB_ovr_2(location, count, transpose, value);
    
    private static procedure z_UniformMatrix4fvARB_ovr_0(location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glUniformMatrix4fvARB';
    private static procedure z_UniformMatrix4fvARB_ovr_0_anh00001(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformMatrix4fvARB_ovr_0(location, count, transpose, value[0]) else
      z_UniformMatrix4fvARB_ovr_0_anh00001(location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_UniformMatrix4fvARB_ovr_0(location, count, transpose, value);
    private static procedure z_UniformMatrix4fvARB_ovr_2(location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glUniformMatrix4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformMatrix4fvARB(location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_UniformMatrix4fvARB_ovr_2(location, count, transpose, value);
    
    private static procedure z_GetObjectParameterfvARB_ovr_0(obj: GLhandleARB; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glGetObjectParameterfvARB';
    private static procedure z_GetObjectParameterfvARB_ovr_0_anh0001(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: GLhandleARB; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterfvARB_ovr_0(obj, pname, &params[0]) else
      z_GetObjectParameterfvARB_ovr_0_anh0001(obj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: GLhandleARB; pname: DummyEnum; var &params: single) :=
    z_GetObjectParameterfvARB_ovr_0(obj, pname, &params);
    private static procedure z_GetObjectParameterfvARB_ovr_2(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterfvARB(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterfvARB_ovr_2(obj, pname, &params);
    
    private static procedure z_GetObjectParameterivARB_ovr_0(obj: GLhandleARB; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetObjectParameterivARB';
    private static procedure z_GetObjectParameterivARB_ovr_0_anh0001(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: GLhandleARB; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectParameterivARB_ovr_0(obj, pname, &params[0]) else
      z_GetObjectParameterivARB_ovr_0_anh0001(obj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: GLhandleARB; pname: DummyEnum; var &params: Int32) :=
    z_GetObjectParameterivARB_ovr_0(obj, pname, &params);
    private static procedure z_GetObjectParameterivARB_ovr_2(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectParameterivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectParameterivARB(obj: GLhandleARB; pname: DummyEnum; &params: IntPtr) :=
    z_GetObjectParameterivARB_ovr_2(obj, pname, &params);
    
    private static procedure z_GetInfoLogARB_ovr_0(obj: GLhandleARB; maxLength: Int32; var length: Int32; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetInfoLogARB';
    private static procedure z_GetInfoLogARB_ovr_0_anh00010(obj: GLhandleARB; maxLength: Int32; length: IntPtr; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetInfoLogARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInfoLogARB(obj: GLhandleARB; maxLength: Int32; length: array of Int32; infoLog: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetInfoLogARB_ovr_0(obj, maxLength, length[0], infoLog) else
      z_GetInfoLogARB_ovr_0_anh00010(obj, maxLength, IntPtr.Zero, infoLog);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInfoLogARB(obj: GLhandleARB; maxLength: Int32; var length: Int32; infoLog: IntPtr) :=
    z_GetInfoLogARB_ovr_0(obj, maxLength, length, infoLog);
    private static procedure z_GetInfoLogARB_ovr_2(obj: GLhandleARB; maxLength: Int32; length: IntPtr; infoLog: IntPtr);
    external 'opengl32.dll' name 'glGetInfoLogARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInfoLogARB(obj: GLhandleARB; maxLength: Int32; length: IntPtr; infoLog: IntPtr) :=
    z_GetInfoLogARB_ovr_2(obj, maxLength, length, infoLog);
    
    private static procedure z_GetAttachedObjectsARB_ovr_0(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; var obj: GLhandleARB);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    private static procedure z_GetAttachedObjectsARB_ovr_0_anh00010(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; var obj: GLhandleARB);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    private static procedure z_GetAttachedObjectsARB_ovr_0_anh00001(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    private static procedure z_GetAttachedObjectsARB_ovr_0_anh00011(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: array of Int32; obj: array of GLhandleARB) :=
    if (count<>nil) and (count.Length<>0) then
      if (obj<>nil) and (obj.Length<>0) then
        z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count[0], obj[0]) else
        z_GetAttachedObjectsARB_ovr_0_anh00001(containerObj, maxCount, count[0], IntPtr.Zero) else
      if (obj<>nil) and (obj.Length<>0) then
        z_GetAttachedObjectsARB_ovr_0_anh00010(containerObj, maxCount, IntPtr.Zero, obj[0]) else
        z_GetAttachedObjectsARB_ovr_0_anh00011(containerObj, maxCount, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetAttachedObjectsARB_ovr_1_anh00010(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; var obj: GLhandleARB);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: array of Int32; var obj: GLhandleARB) :=
    if (count<>nil) and (count.Length<>0) then
      z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count[0], obj) else
      z_GetAttachedObjectsARB_ovr_0_anh00010(containerObj, maxCount, IntPtr.Zero, obj);
    private static procedure z_GetAttachedObjectsARB_ovr_2(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    private static procedure z_GetAttachedObjectsARB_ovr_2_anh00010(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: array of Int32; obj: IntPtr) :=
    if (count<>nil) and (count.Length<>0) then
      z_GetAttachedObjectsARB_ovr_2(containerObj, maxCount, count[0], obj) else
      z_GetAttachedObjectsARB_ovr_2_anh00010(containerObj, maxCount, IntPtr.Zero, obj);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; obj: array of GLhandleARB) :=
    if (obj<>nil) and (obj.Length<>0) then
      z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count, obj[0]) else
      z_GetAttachedObjectsARB_ovr_0_anh00001(containerObj, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; var obj: GLhandleARB) :=
    z_GetAttachedObjectsARB_ovr_0(containerObj, maxCount, count, obj);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; var count: Int32; obj: IntPtr) :=
    z_GetAttachedObjectsARB_ovr_2(containerObj, maxCount, count, obj);
    private static procedure z_GetAttachedObjectsARB_ovr_6(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; var obj: GLhandleARB);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    private static procedure z_GetAttachedObjectsARB_ovr_6_anh00001(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: array of GLhandleARB) :=
    if (obj<>nil) and (obj.Length<>0) then
      z_GetAttachedObjectsARB_ovr_6(containerObj, maxCount, count, obj[0]) else
      z_GetAttachedObjectsARB_ovr_6_anh00001(containerObj, maxCount, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; var obj: GLhandleARB) :=
    z_GetAttachedObjectsARB_ovr_6(containerObj, maxCount, count, obj);
    private static procedure z_GetAttachedObjectsARB_ovr_8(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: IntPtr);
    external 'opengl32.dll' name 'glGetAttachedObjectsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetAttachedObjectsARB(containerObj: GLhandleARB; maxCount: Int32; count: IntPtr; obj: IntPtr) :=
    z_GetAttachedObjectsARB_ovr_8(containerObj, maxCount, count, obj);
    
    private static function z_GetUniformLocationARB_ovr_0(programObj: GLhandleARB; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetUniformLocationARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocationARB(programObj: GLhandleARB; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetUniformLocationARB_ovr_0(programObj, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformLocationARB(programObj: GLhandleARB; name: IntPtr): Int32 :=
    z_GetUniformLocationARB_ovr_0(programObj, name);
    
    private static procedure z_GetActiveUniformARB_ovr_0(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00000110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_0_anh00001110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length[0], size[0], &type[0], name) else
          z_GetActiveUniformARB_ovr_0_anh00000010(programObj, index, maxLength, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniformARB_ovr_0_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type[0], name) else
          z_GetActiveUniformARB_ovr_0_anh00000110(programObj, index, maxLength, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniformARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type[0], name) else
          z_GetActiveUniformARB_ovr_0_anh00001010(programObj, index, maxLength, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveUniformARB_ovr_0_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetActiveUniformARB_ovr_0_anh00001110(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveUniformARB_ovr_1_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_1_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_1_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length[0], size[0], &type, name) else
        z_GetActiveUniformARB_ovr_0_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniformARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveUniformARB_ovr_0_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_2(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_2_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_2_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_2_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniformARB_ovr_2(programObj, index, maxLength, length[0], size[0], &type, name) else
        z_GetActiveUniformARB_ovr_2_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveUniformARB_ovr_2_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveUniformARB_ovr_2_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_3_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_3_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length[0], size, &type[0], name) else
        z_GetActiveUniformARB_ovr_0_anh00000010(programObj, index, maxLength, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveUniformARB_ovr_0_anh00001010(programObj, index, maxLength, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveUniformARB_ovr_4_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveUniformARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_5_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformARB_ovr_2(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveUniformARB_ovr_2_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_6(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_6_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_6_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_6_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_6(programObj, index, maxLength, length[0], size, &type[0], name) else
        z_GetActiveUniformARB_ovr_6_anh00000010(programObj, index, maxLength, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_6_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveUniformARB_ovr_6_anh00001010(programObj, index, maxLength, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveUniformARB_ovr_7_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformARB_ovr_6(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveUniformARB_ovr_6_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_8(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_8_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformARB_ovr_8(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveUniformARB_ovr_8_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length, size[0], &type[0], name) else
        z_GetActiveUniformARB_ovr_0_anh00000010(programObj, index, maxLength, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_0_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveUniformARB_ovr_0_anh00000110(programObj, index, maxLength, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveUniformARB_ovr_0_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniformARB_ovr_2(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveUniformARB_ovr_2_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveUniformARB_ovr_0_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_0(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_2(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniformARB_ovr_6(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveUniformARB_ovr_6_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_6(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_8(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_18(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_18_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_18_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_18_anh00000110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; &type: array of UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_18(programObj, index, maxLength, length, size[0], &type[0], name) else
        z_GetActiveUniformARB_ovr_18_anh00000010(programObj, index, maxLength, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveUniformARB_ovr_18_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveUniformARB_ovr_18_anh00000110(programObj, index, maxLength, length, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveUniformARB_ovr_19_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; var &type: UniformType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniformARB_ovr_18(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveUniformARB_ovr_18_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_20(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_20_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveUniformARB_ovr_20(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveUniformARB_ovr_20_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniformARB_ovr_18(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveUniformARB_ovr_18_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_18(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_20(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_24(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    private static procedure z_GetActiveUniformARB_ovr_24_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: array of UniformType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveUniformARB_ovr_24(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveUniformARB_ovr_24_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: UniformType; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_24(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveUniformARB_ovr_26(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveUniformARB_ovr_26(programObj, index, maxLength, length, size, &type, name);
    
    private static procedure z_GetUniformfvARB_ovr_0(programObj: GLhandleARB; location: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetUniformfvARB';
    private static procedure z_GetUniformfvARB_ovr_0_anh0001(programObj: GLhandleARB; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: GLhandleARB; location: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformfvARB_ovr_0(programObj, location, &params[0]) else
      z_GetUniformfvARB_ovr_0_anh0001(programObj, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: GLhandleARB; location: Int32; var &params: single) :=
    z_GetUniformfvARB_ovr_0(programObj, location, &params);
    private static procedure z_GetUniformfvARB_ovr_2(programObj: GLhandleARB; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformfvARB(programObj: GLhandleARB; location: Int32; &params: IntPtr) :=
    z_GetUniformfvARB_ovr_2(programObj, location, &params);
    
    private static procedure z_GetUniformivARB_ovr_0(programObj: GLhandleARB; location: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetUniformivARB';
    private static procedure z_GetUniformivARB_ovr_0_anh0001(programObj: GLhandleARB; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: GLhandleARB; location: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformivARB_ovr_0(programObj, location, &params[0]) else
      z_GetUniformivARB_ovr_0_anh0001(programObj, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: GLhandleARB; location: Int32; var &params: Int32) :=
    z_GetUniformivARB_ovr_0(programObj, location, &params);
    private static procedure z_GetUniformivARB_ovr_2(programObj: GLhandleARB; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformivARB(programObj: GLhandleARB; location: Int32; &params: IntPtr) :=
    z_GetUniformivARB_ovr_2(programObj, location, &params);
    
    private static procedure z_GetShaderSourceARB_ovr_0(obj: GLhandleARB; maxLength: Int32; var length: Int32; source: IntPtr);
    external 'opengl32.dll' name 'glGetShaderSourceARB';
    private static procedure z_GetShaderSourceARB_ovr_0_anh00010(obj: GLhandleARB; maxLength: Int32; length: IntPtr; source: IntPtr);
    external 'opengl32.dll' name 'glGetShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSourceARB(obj: GLhandleARB; maxLength: Int32; length: array of Int32; source: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetShaderSourceARB_ovr_0(obj, maxLength, length[0], source) else
      z_GetShaderSourceARB_ovr_0_anh00010(obj, maxLength, IntPtr.Zero, source);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSourceARB(obj: GLhandleARB; maxLength: Int32; var length: Int32; source: IntPtr) :=
    z_GetShaderSourceARB_ovr_0(obj, maxLength, length, source);
    private static procedure z_GetShaderSourceARB_ovr_2(obj: GLhandleARB; maxLength: Int32; length: IntPtr; source: IntPtr);
    external 'opengl32.dll' name 'glGetShaderSourceARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShaderSourceARB(obj: GLhandleARB; maxLength: Int32; length: IntPtr; source: IntPtr) :=
    z_GetShaderSourceARB_ovr_2(obj, maxLength, length, source);
    
  end;
  
  glShaderStorageBufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ShaderStorageBlockBinding_ovr_0(&program: ProgramName; storageBlockIndex: UInt32; storageBlockBinding: UInt32);
    external 'opengl32.dll' name 'glShaderStorageBlockBinding';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderStorageBlockBinding(&program: ProgramName; storageBlockIndex: UInt32; storageBlockBinding: UInt32) :=
    z_ShaderStorageBlockBinding_ovr_0(&program, storageBlockIndex, storageBlockBinding);
    
  end;
  
  glShaderSubroutineARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetSubroutineUniformLocation_ovr_0(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetSubroutineUniformLocation';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: ProgramName; _shadertype: ShaderType; name: string): Int32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineUniformLocation(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): Int32 :=
    z_GetSubroutineUniformLocation_ovr_0(&program, _shadertype, name);
    
    private static function z_GetSubroutineIndex_ovr_0(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetSubroutineIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: ProgramName; _shadertype: ShaderType; name: string): UInt32;
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetSubroutineIndex_ovr_0(&program, _shadertype, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetSubroutineIndex(&program: ProgramName; _shadertype: ShaderType; name: IntPtr): UInt32 :=
    z_GetSubroutineIndex_ovr_0(&program, _shadertype, name);
    
    private static procedure z_GetActiveSubroutineUniformiv_ovr_0(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformiv';
    private static procedure z_GetActiveSubroutineUniformiv_ovr_0_anh000001(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values[0]) else
      z_GetActiveSubroutineUniformiv_ovr_0_anh000001(&program, _shadertype, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; var values: Int32) :=
    z_GetActiveSubroutineUniformiv_ovr_0(&program, _shadertype, index, pname, values);
    private static procedure z_GetActiveSubroutineUniformiv_ovr_2(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformiv(&program: ProgramName; _shadertype: ShaderType; index: UInt32; pname: SubroutineParameterName; values: IntPtr) :=
    z_GetActiveSubroutineUniformiv_ovr_2(&program, _shadertype, index, pname, values);
    
    private static procedure z_GetActiveSubroutineUniformName_ovr_0(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformName';
    private static procedure z_GetActiveSubroutineUniformName_ovr_0_anh0000010(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length[0], name) else
      z_GetActiveSubroutineUniformName_ovr_0_anh0000010(&program, _shadertype, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private static procedure z_GetActiveSubroutineUniformName_ovr_2(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineUniformName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineUniformName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineUniformName_ovr_2(&program, _shadertype, index, bufSize, length, name);
    
    private static procedure z_GetActiveSubroutineName_ovr_0(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineName';
    private static procedure z_GetActiveSubroutineName_ovr_0_anh0000010(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: array of Int32; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length[0], name) else
      z_GetActiveSubroutineName_ovr_0_anh0000010(&program, _shadertype, index, bufSize, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; var length: Int32; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_0(&program, _shadertype, index, bufSize, length, name);
    private static procedure z_GetActiveSubroutineName_ovr_2(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveSubroutineName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveSubroutineName(&program: UInt32; _shadertype: ShaderType; index: UInt32; bufSize: Int32; length: IntPtr; name: IntPtr) :=
    z_GetActiveSubroutineName_ovr_2(&program, _shadertype, index, bufSize, length, name);
    
    private static procedure z_UniformSubroutinesuiv_ovr_0(_shadertype: ShaderType; count: Int32; var indices: UInt32);
    external 'opengl32.dll' name 'glUniformSubroutinesuiv';
    private static procedure z_UniformSubroutinesuiv_ovr_0_anh0001(_shadertype: ShaderType; count: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glUniformSubroutinesuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: array of UInt32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices[0]) else
      z_UniformSubroutinesuiv_ovr_0_anh0001(_shadertype, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; var indices: UInt32) :=
    z_UniformSubroutinesuiv_ovr_0(_shadertype, count, indices);
    private static procedure z_UniformSubroutinesuiv_ovr_2(_shadertype: ShaderType; count: Int32; indices: IntPtr);
    external 'opengl32.dll' name 'glUniformSubroutinesuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformSubroutinesuiv(_shadertype: ShaderType; count: Int32; indices: IntPtr) :=
    z_UniformSubroutinesuiv_ovr_2(_shadertype, count, indices);
    
    private static procedure z_GetUniformSubroutineuiv_ovr_0(_shadertype: ShaderType; location: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetUniformSubroutineuiv';
    private static procedure z_GetUniformSubroutineuiv_ovr_0_anh0001(_shadertype: ShaderType; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformSubroutineuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params[0]) else
      z_GetUniformSubroutineuiv_ovr_0_anh0001(_shadertype, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; var &params: UInt32) :=
    z_GetUniformSubroutineuiv_ovr_0(_shadertype, location, &params);
    private static procedure z_GetUniformSubroutineuiv_ovr_2(_shadertype: ShaderType; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformSubroutineuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformSubroutineuiv(_shadertype: ShaderType; location: Int32; &params: IntPtr) :=
    z_GetUniformSubroutineuiv_ovr_2(_shadertype, location, &params);
    
    private static procedure z_GetProgramStageiv_ovr_0(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32);
    external 'opengl32.dll' name 'glGetProgramStageiv';
    private static procedure z_GetProgramStageiv_ovr_0_anh00001(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStageiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values[0]) else
      z_GetProgramStageiv_ovr_0_anh00001(&program, _shadertype, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; var values: Int32) :=
    z_GetProgramStageiv_ovr_0(&program, _shadertype, pname, values);
    private static procedure z_GetProgramStageiv_ovr_2(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStageiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStageiv(&program: ProgramName; _shadertype: ShaderType; pname: ProgramStagePName; values: IntPtr) :=
    z_GetProgramStageiv_ovr_2(&program, _shadertype, pname, values);
    
  end;
  
  glShadingLanguageIncludeARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_NamedStringARB_ovr_0(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: IntPtr);
    external 'opengl32.dll' name 'glNamedStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: string; stringlen: Int32; _string: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      var par_5_str_ptr := Marshal.StringToHGlobalAnsi(_string);
      z_NamedStringARB_ovr_0(&type, namelen, par_3_str_ptr, stringlen, par_5_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
      Marshal.FreeHGlobal(par_5_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: string; stringlen: Int32; _string: IntPtr);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_NamedStringARB_ovr_0(&type, namelen, par_3_str_ptr, stringlen, _string);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: string);
    begin
      var par_5_str_ptr := Marshal.StringToHGlobalAnsi(_string);
      z_NamedStringARB_ovr_0(&type, namelen, name, stringlen, par_5_str_ptr);
      Marshal.FreeHGlobal(par_5_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedStringARB(&type: DummyEnum; namelen: Int32; name: IntPtr; stringlen: Int32; _string: IntPtr) :=
    z_NamedStringARB_ovr_0(&type, namelen, name, stringlen, _string);
    
    private static procedure z_DeleteNamedStringARB_ovr_0(namelen: Int32; name: IntPtr);
    external 'opengl32.dll' name 'glDeleteNamedStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamedStringARB(namelen: Int32; name: string);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_DeleteNamedStringARB_ovr_0(namelen, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteNamedStringARB(namelen: Int32; name: IntPtr) :=
    z_DeleteNamedStringARB_ovr_0(namelen, name);
    
    private static procedure z_CompileShaderIncludeARB_ovr_0(shader: UInt32; count: Int32; var path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_0_anh00010(shader: UInt32; count: Int32; path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_0_anh00001(shader: UInt32; count: Int32; var path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_0_anh00011(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of string; length: array of Int32);
    begin
      var par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        if (length<>nil) and (length.Length<>0) then
          z_CompileShaderIncludeARB_ovr_0(shader, count, par_3_str_ptr[0], length[0]) else
          z_CompileShaderIncludeARB_ovr_0_anh00001(shader, count, par_3_str_ptr[0], IntPtr.Zero) else
        if (length<>nil) and (length.Length<>0) then
          z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
          z_CompileShaderIncludeARB_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_CompileShaderIncludeARB_ovr_1_anh00010(shader: UInt32; count: Int32; path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of string; var length: Int32);
    begin
      var par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_CompileShaderIncludeARB_ovr_0(shader, count, par_3_str_ptr[0], length) else
        z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_CompileShaderIncludeARB_ovr_2(shader: UInt32; count: Int32; var path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_2_anh00010(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of string; length: IntPtr);
    begin
      var par_3_str_ptr := path?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_CompileShaderIncludeARB_ovr_2(shader, count, par_3_str_ptr[0], length) else
        z_CompileShaderIncludeARB_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_CompileShaderIncludeARB_ovr_3_anh00010(shader: UInt32; count: Int32; path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_3_anh00011(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of IntPtr; length: array of Int32) :=
    if (path<>nil) and (path.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_CompileShaderIncludeARB_ovr_0(shader, count, path[0], length[0]) else
        z_CompileShaderIncludeARB_ovr_0_anh00001(shader, count, path[0], IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length[0]) else
        z_CompileShaderIncludeARB_ovr_0_anh00011(shader, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_CompileShaderIncludeARB_ovr_4_anh00010(shader: UInt32; count: Int32; path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of IntPtr; var length: Int32) :=
    if (path<>nil) and (path.Length<>0) then
      z_CompileShaderIncludeARB_ovr_0(shader, count, path[0], length) else
      z_CompileShaderIncludeARB_ovr_0_anh00010(shader, count, IntPtr.Zero, length);
    private static procedure z_CompileShaderIncludeARB_ovr_5_anh00010(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: array of IntPtr; length: IntPtr) :=
    if (path<>nil) and (path.Length<>0) then
      z_CompileShaderIncludeARB_ovr_2(shader, count, path[0], length) else
      z_CompileShaderIncludeARB_ovr_2_anh00010(shader, count, IntPtr.Zero, length);
    private static procedure z_CompileShaderIncludeARB_ovr_6(shader: UInt32; count: Int32; path: IntPtr; var length: Int32);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    private static procedure z_CompileShaderIncludeARB_ovr_6_anh00001(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: IntPtr; length: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_CompileShaderIncludeARB_ovr_6(shader, count, path, length[0]) else
      z_CompileShaderIncludeARB_ovr_6_anh00001(shader, count, path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: IntPtr; var length: Int32) :=
    z_CompileShaderIncludeARB_ovr_6(shader, count, path, length);
    private static procedure z_CompileShaderIncludeARB_ovr_8(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glCompileShaderIncludeARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileShaderIncludeARB(shader: UInt32; count: Int32; path: IntPtr; length: IntPtr) :=
    z_CompileShaderIncludeARB_ovr_8(shader, count, path, length);
    
    private static function z_IsNamedStringARB_ovr_0(namelen: Int32; name: IntPtr): boolean;
    external 'opengl32.dll' name 'glIsNamedStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedStringARB(namelen: Int32; name: string): boolean;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_IsNamedStringARB_ovr_0(namelen, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedStringARB(namelen: Int32; name: IntPtr): boolean :=
    z_IsNamedStringARB_ovr_0(namelen, name);
    
    private static procedure z_GetNamedStringARB_ovr_0(namelen: Int32; name: IntPtr; bufSize: Int32; var stringlen: Int32; string: IntPtr);
    external 'opengl32.dll' name 'glGetNamedStringARB';
    private static procedure z_GetNamedStringARB_ovr_0_anh000010(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: IntPtr; string: IntPtr);
    external 'opengl32.dll' name 'glGetNamedStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: string; bufSize: Int32; stringlen: array of Int32; string: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      if (stringlen<>nil) and (stringlen.Length<>0) then
        z_GetNamedStringARB_ovr_0(namelen, par_2_str_ptr, bufSize, stringlen[0], string) else
        z_GetNamedStringARB_ovr_0_anh000010(namelen, par_2_str_ptr, bufSize, IntPtr.Zero, string);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: string; bufSize: Int32; var stringlen: Int32; string: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_GetNamedStringARB_ovr_0(namelen, par_2_str_ptr, bufSize, stringlen, string);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_GetNamedStringARB_ovr_2(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: IntPtr; string: IntPtr);
    external 'opengl32.dll' name 'glGetNamedStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: string; bufSize: Int32; stringlen: IntPtr; string: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_GetNamedStringARB_ovr_2(namelen, par_2_str_ptr, bufSize, stringlen, string);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: array of Int32; string: IntPtr) :=
    if (stringlen<>nil) and (stringlen.Length<>0) then
      z_GetNamedStringARB_ovr_0(namelen, name, bufSize, stringlen[0], string) else
      z_GetNamedStringARB_ovr_0_anh000010(namelen, name, bufSize, IntPtr.Zero, string);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: IntPtr; bufSize: Int32; var stringlen: Int32; string: IntPtr) :=
    z_GetNamedStringARB_ovr_0(namelen, name, bufSize, stringlen, string);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringARB(namelen: Int32; name: IntPtr; bufSize: Int32; stringlen: IntPtr; string: IntPtr) :=
    z_GetNamedStringARB_ovr_2(namelen, name, bufSize, stringlen, string);
    
    private static procedure z_GetNamedStringivARB_ovr_0(namelen: Int32; name: IntPtr; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedStringivARB';
    private static procedure z_GetNamedStringivARB_ovr_0_anh00001(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedStringivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; &params: array of Int32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      if (&params<>nil) and (&params.Length<>0) then
        z_GetNamedStringivARB_ovr_0(namelen, par_2_str_ptr, pname, &params[0]) else
        z_GetNamedStringivARB_ovr_0_anh00001(namelen, par_2_str_ptr, pname, IntPtr.Zero);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; var &params: Int32);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_GetNamedStringivARB_ovr_0(namelen, par_2_str_ptr, pname, &params);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    private static procedure z_GetNamedStringivARB_ovr_2(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedStringivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: string; pname: DummyEnum; &params: IntPtr);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_GetNamedStringivARB_ovr_2(namelen, par_2_str_ptr, pname, &params);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedStringivARB_ovr_0(namelen, name, pname, &params[0]) else
      z_GetNamedStringivARB_ovr_0_anh00001(namelen, name, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; var &params: Int32) :=
    z_GetNamedStringivARB_ovr_0(namelen, name, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedStringivARB(namelen: Int32; name: IntPtr; pname: DummyEnum; &params: IntPtr) :=
    z_GetNamedStringivARB_ovr_2(namelen, name, pname, &params);
    
  end;
  
  glSparseBufferARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BufferPageCommitmentARB_ovr_0(target: DummyEnum; offset: IntPtr; size: IntPtr; commit: boolean);
    external 'opengl32.dll' name 'glBufferPageCommitmentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferPageCommitmentARB(target: DummyEnum; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_BufferPageCommitmentARB_ovr_0(target, offset, size, commit);
    
    private static procedure z_NamedBufferPageCommitmentEXT_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; commit: boolean);
    external 'opengl32.dll' name 'glNamedBufferPageCommitmentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferPageCommitmentEXT(buffer: UInt32; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_NamedBufferPageCommitmentEXT_ovr_0(buffer, offset, size, commit);
    
    private static procedure z_NamedBufferPageCommitmentARB_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; commit: boolean);
    external 'opengl32.dll' name 'glNamedBufferPageCommitmentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferPageCommitmentARB(buffer: UInt32; offset: IntPtr; size: IntPtr; commit: boolean) :=
    z_NamedBufferPageCommitmentARB_ovr_0(buffer, offset, size, commit);
    
  end;
  
  glSparseTextureARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexPageCommitmentARB_ovr_0(target: DummyEnum; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean);
    external 'opengl32.dll' name 'glTexPageCommitmentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexPageCommitmentARB(target: DummyEnum; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean) :=
    z_TexPageCommitmentARB_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, commit);
    
  end;
  
  glSyncARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_FenceSync_ovr_0(condition: SyncCondition; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glFenceSync';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FenceSync(condition: SyncCondition; flags: DummyFlags): GLsync :=
    z_FenceSync_ovr_0(condition, flags);
    
    private static function z_IsSync_ovr_0(sync: GLsync): boolean;
    external 'opengl32.dll' name 'glIsSync';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSync(sync: GLsync): boolean :=
    z_IsSync_ovr_0(sync);
    
    private static procedure z_DeleteSync_ovr_0(sync: GLsync);
    external 'opengl32.dll' name 'glDeleteSync';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSync(sync: GLsync) :=
    z_DeleteSync_ovr_0(sync);
    
    private static function z_ClientWaitSync_ovr_0(sync: GLsync; flags: SyncObjectMask; timeout: UInt64): SyncStatus;
    external 'opengl32.dll' name 'glClientWaitSync';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ClientWaitSync(sync: GLsync; flags: SyncObjectMask; timeout: UInt64): SyncStatus :=
    z_ClientWaitSync_ovr_0(sync, flags, timeout);
    
    private static procedure z_WaitSync_ovr_0(sync: GLsync; flags: DummyFlags; timeout: UInt64);
    external 'opengl32.dll' name 'glWaitSync';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSync(sync: GLsync; flags: DummyFlags; timeout: UInt64) :=
    z_WaitSync_ovr_0(sync, flags, timeout);
    
    private static procedure z_GetInteger64v_ovr_0(pname: GetPName; var data: Int64);
    external 'opengl32.dll' name 'glGetInteger64v';
    private static procedure z_GetInteger64v_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetInteger64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: array of Int64) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInteger64v_ovr_0(pname, data[0]) else
      z_GetInteger64v_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; var data: Int64) :=
    z_GetInteger64v_ovr_0(pname, data);
    private static procedure z_GetInteger64v_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetInteger64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInteger64v(pname: GetPName; data: IntPtr) :=
    z_GetInteger64v_ovr_2(pname, data);
    
    private static procedure z_GetSynciv_ovr_0(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32);
    external 'opengl32.dll' name 'glGetSynciv';
    private static procedure z_GetSynciv_ovr_0_anh000010(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glGetSynciv';
    private static procedure z_GetSynciv_ovr_0_anh000001(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    private static procedure z_GetSynciv_ovr_0_anh000011(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; values: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (values<>nil) and (values.Length<>0) then
        z_GetSynciv_ovr_0(sync, pname, count, length[0], values[0]) else
        z_GetSynciv_ovr_0_anh000001(sync, pname, count, length[0], IntPtr.Zero) else
      if (values<>nil) and (values.Length<>0) then
        z_GetSynciv_ovr_0_anh000010(sync, pname, count, IntPtr.Zero, values[0]) else
        z_GetSynciv_ovr_0_anh000011(sync, pname, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetSynciv_ovr_1_anh000010(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glGetSynciv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; var values: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length[0], values) else
      z_GetSynciv_ovr_0_anh000010(sync, pname, count, IntPtr.Zero, values);
    private static procedure z_GetSynciv_ovr_2(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    private static procedure z_GetSynciv_ovr_2_anh000010(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: array of Int32; values: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetSynciv_ovr_2(sync, pname, count, length[0], values) else
      z_GetSynciv_ovr_2_anh000010(sync, pname, count, IntPtr.Zero, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_0(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_0_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; var values: Int32) :=
    z_GetSynciv_ovr_0(sync, pname, count, length, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; var length: Int32; values: IntPtr) :=
    z_GetSynciv_ovr_2(sync, pname, count, length, values);
    private static procedure z_GetSynciv_ovr_6(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glGetSynciv';
    private static procedure z_GetSynciv_ovr_6_anh000001(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetSynciv_ovr_6(sync, pname, count, length, values[0]) else
      z_GetSynciv_ovr_6_anh000001(sync, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; var values: Int32) :=
    z_GetSynciv_ovr_6(sync, pname, count, length, values);
    private static procedure z_GetSynciv_ovr_8(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glGetSynciv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSynciv(sync: GLsync; pname: SyncParameterName; count: Int32; length: IntPtr; values: IntPtr) :=
    z_GetSynciv_ovr_8(sync, pname, count, length, values);
    
  end;
  
  glTessellationShaderARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PatchParameteri_ovr_0(pname: PatchParameterName; value: Int32);
    external 'opengl32.dll' name 'glPatchParameteri';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameteri(pname: PatchParameterName; value: Int32) :=
    z_PatchParameteri_ovr_0(pname, value);
    
    private static procedure z_PatchParameterfv_ovr_0(pname: PatchParameterName; var values: single);
    external 'opengl32.dll' name 'glPatchParameterfv';
    private static procedure z_PatchParameterfv_ovr_0_anh001(pname: PatchParameterName; values: IntPtr);
    external 'opengl32.dll' name 'glPatchParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: array of single) :=
    if (values<>nil) and (values.Length<>0) then
      z_PatchParameterfv_ovr_0(pname, values[0]) else
      z_PatchParameterfv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; var values: single) :=
    z_PatchParameterfv_ovr_0(pname, values);
    private static procedure z_PatchParameterfv_ovr_2(pname: PatchParameterName; values: IntPtr);
    external 'opengl32.dll' name 'glPatchParameterfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PatchParameterfv(pname: PatchParameterName; values: IntPtr) :=
    z_PatchParameterfv_ovr_2(pname, values);
    
  end;
  
  glTextureBarrierARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureBarrier_ovr_0;
    external 'opengl32.dll' name 'glTextureBarrier';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrier :=
    z_TextureBarrier_ovr_0;
    
  end;
  
  glTextureBufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexBufferARB_ovr_0(target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32);
    external 'opengl32.dll' name 'glTexBufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferARB(target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32) :=
    z_TexBufferARB_ovr_0(target, _internalformat, buffer);
    
  end;
  
  glTextureBufferRangeARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexBufferRange_ovr_0(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glTexBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferRange(target: TextureTarget; _internalformat: InternalFormat; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_TexBufferRange_ovr_0(target, _internalformat, buffer, offset, size);
    
  end;
  
  glTextureCompressionARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CompressedTexImage3DARB_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexImage3DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage3DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage3DARB_ovr_0(target, level, _internalformat, width, height, depth, border, imageSize, data);
    
    private static procedure z_CompressedTexImage2DARB_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexImage2DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage2DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage2DARB_ovr_0(target, level, _internalformat, width, height, border, imageSize, data);
    
    private static procedure z_CompressedTexImage1DARB_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexImage1DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexImage1DARB(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexImage1DARB_ovr_0(target, level, _internalformat, width, border, imageSize, data);
    
    private static procedure z_CompressedTexSubImage3DARB_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexSubImage3DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage3DARB(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage3DARB_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
    
    private static procedure z_CompressedTexSubImage2DARB_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexSubImage2DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage2DARB(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage2DARB_ovr_0(target, level, xoffset, yoffset, width, height, format, imageSize, data);
    
    private static procedure z_CompressedTexSubImage1DARB_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glCompressedTexSubImage1DARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTexSubImage1DARB(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; data: IntPtr) :=
    z_CompressedTexSubImage1DARB_ovr_0(target, level, xoffset, width, format, imageSize, data);
    
    private static procedure z_GetCompressedTexImageARB_ovr_0(target: TextureTarget; level: Int32; img: IntPtr);
    external 'opengl32.dll' name 'glGetCompressedTexImageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTexImageARB(target: TextureTarget; level: Int32; img: IntPtr) :=
    z_GetCompressedTexImageARB_ovr_0(target, level, img);
    
  end;
  
  glTextureMultisampleARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexImage2DMultisample_ovr_0(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTexImage2DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexImage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    private static procedure z_TexImage3DMultisample_ovr_0(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTexImage3DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexImage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    private static procedure z_GetMultisamplefv_ovr_0(pname: GetMultisamplePNameNV; index: UInt32; var val: single);
    external 'opengl32.dll' name 'glGetMultisamplefv';
    private static procedure z_GetMultisamplefv_ovr_0_anh0001(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glGetMultisamplefv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefv_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefv_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefv_ovr_0(pname, index, val);
    private static procedure z_GetMultisamplefv_ovr_2(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glGetMultisamplefv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefv(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefv_ovr_2(pname, index, val);
    
    private static procedure z_SampleMaski_ovr_0(maskNumber: UInt32; mask: DummyFlags);
    external 'opengl32.dll' name 'glSampleMaski';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaski(maskNumber: UInt32; mask: DummyFlags) :=
    z_SampleMaski_ovr_0(maskNumber, mask);
    
  end;
  
  glTextureStorageARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexStorage1D_ovr_0(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32);
    external 'opengl32.dll' name 'glTexStorage1D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage1D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32) :=
    z_TexStorage1D_ovr_0(target, levels, _internalformat, width);
    
    private static procedure z_TexStorage2D_ovr_0(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glTexStorage2D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_TexStorage2D_ovr_0(target, levels, _internalformat, width, height);
    
    private static procedure z_TexStorage3D_ovr_0(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glTexStorage3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3D(target: TextureTarget; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TexStorage3D_ovr_0(target, levels, _internalformat, width, height, depth);
    
  end;
  
  glTextureStorageMultisampleARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexStorage2DMultisample_ovr_0(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTexStorage2DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage2DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage2DMultisample_ovr_0(target, samples, _internalformat, width, height, fixedsamplelocations);
    
    private static procedure z_TexStorage3DMultisample_ovr_0(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTexStorage3DMultisample';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorage3DMultisample(target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TexStorage3DMultisample_ovr_0(target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
  end;
  
  glTextureViewARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureView_ovr_0(texture: TextureName; target: TextureTarget; origtexture: TextureName; _internalformat: InternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32);
    external 'opengl32.dll' name 'glTextureView';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureView(texture: TextureName; target: TextureTarget; origtexture: TextureName; _internalformat: InternalFormat; minlevel: UInt32; numlevels: UInt32; minlayer: UInt32; numlayers: UInt32) :=
    z_TextureView_ovr_0(texture, target, origtexture, _internalformat, minlevel, numlevels, minlayer, numlayers);
    
  end;
  
  glTimerQueryARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_QueryCounter_ovr_0(id: QueryName; target: QueryCounterTarget);
    external 'opengl32.dll' name 'glQueryCounter';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryCounter(id: QueryName; target: QueryCounterTarget) :=
    z_QueryCounter_ovr_0(id, target);
    
    private static procedure z_GetQueryObjecti64v_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: Int64);
    external 'opengl32.dll' name 'glGetQueryObjecti64v';
    private static procedure z_GetQueryObjecti64v_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjecti64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64v_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjecti64v_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjecti64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64v(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64v_ovr_2(id, pname, &params);
    
    private static procedure z_GetQueryObjectui64v_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64);
    external 'opengl32.dll' name 'glGetQueryObjectui64v';
    private static procedure z_GetQueryObjectui64v_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectui64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64v_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64v_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64v_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjectui64v_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectui64v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64v(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64v_ovr_2(id, pname, &params);
    
  end;
  
  glTransformFeedback2ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindTransformFeedback_ovr_0(target: BindTransformFeedbackTarget; id: TransformFeedbackName);
    external 'opengl32.dll' name 'glBindTransformFeedback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedback(target: BindTransformFeedbackTarget; id: TransformFeedbackName) :=
    z_BindTransformFeedback_ovr_0(target, id);
    
    private static procedure z_DeleteTransformFeedbacks_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacks';
    private static procedure z_DeleteTransformFeedbacks_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacks_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_DeleteTransformFeedbacks_ovr_0(n, ids);
    private static procedure z_DeleteTransformFeedbacks_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacks_ovr_2(n, ids);
    
    private static procedure z_GenTransformFeedbacks_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glGenTransformFeedbacks';
    private static procedure z_GenTransformFeedbacks_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacks_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacks_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; var ids: UInt32) :=
    z_GenTransformFeedbacks_ovr_0(n, ids);
    private static procedure z_GenTransformFeedbacks_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenTransformFeedbacks';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacks(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacks_ovr_2(n, ids);
    
    private static function z_IsTransformFeedback_ovr_0(id: TransformFeedbackName): boolean;
    external 'opengl32.dll' name 'glIsTransformFeedback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedback(id: TransformFeedbackName): boolean :=
    z_IsTransformFeedback_ovr_0(id);
    
    private static procedure z_PauseTransformFeedback_ovr_0;
    external 'opengl32.dll' name 'glPauseTransformFeedback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedback :=
    z_PauseTransformFeedback_ovr_0;
    
    private static procedure z_ResumeTransformFeedback_ovr_0;
    external 'opengl32.dll' name 'glResumeTransformFeedback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedback :=
    z_ResumeTransformFeedback_ovr_0;
    
    private static procedure z_DrawTransformFeedback_ovr_0(mode: PrimitiveType; id: TransformFeedbackName);
    external 'opengl32.dll' name 'glDrawTransformFeedback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedback(mode: PrimitiveType; id: TransformFeedbackName) :=
    z_DrawTransformFeedback_ovr_0(mode, id);
    
  end;
  
  glTransformFeedback3ARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawTransformFeedbackStream_ovr_0(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32);
    external 'opengl32.dll' name 'glDrawTransformFeedbackStream';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStream(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32) :=
    z_DrawTransformFeedbackStream_ovr_0(mode, id, stream);
    
    private static procedure z_BeginQueryIndexed_ovr_0(target: QueryTarget; index: UInt32; id: QueryName);
    external 'opengl32.dll' name 'glBeginQueryIndexed';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginQueryIndexed(target: QueryTarget; index: UInt32; id: QueryName) :=
    z_BeginQueryIndexed_ovr_0(target, index, id);
    
    private static procedure z_EndQueryIndexed_ovr_0(target: QueryTarget; index: UInt32);
    external 'opengl32.dll' name 'glEndQueryIndexed';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndQueryIndexed(target: QueryTarget; index: UInt32) :=
    z_EndQueryIndexed_ovr_0(target, index);
    
    private static procedure z_GetQueryIndexediv_ovr_0(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetQueryIndexediv';
    private static procedure z_GetQueryIndexediv_ovr_0_anh00001(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryIndexediv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryIndexediv_ovr_0(target, index, pname, &params[0]) else
      z_GetQueryIndexediv_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; var &params: Int32) :=
    z_GetQueryIndexediv_ovr_0(target, index, pname, &params);
    private static procedure z_GetQueryIndexediv_ovr_2(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryIndexediv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryIndexediv(target: QueryTarget; index: UInt32; pname: QueryParameterName; &params: IntPtr) :=
    z_GetQueryIndexediv_ovr_2(target, index, pname, &params);
    
  end;
  
  glTransformFeedbackInstancedARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawTransformFeedbackInstanced_ovr_0(mode: PrimitiveType; id: TransformFeedbackName; instancecount: Int32);
    external 'opengl32.dll' name 'glDrawTransformFeedbackInstanced';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackInstanced(mode: PrimitiveType; id: TransformFeedbackName; instancecount: Int32) :=
    z_DrawTransformFeedbackInstanced_ovr_0(mode, id, instancecount);
    
    private static procedure z_DrawTransformFeedbackStreamInstanced_ovr_0(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32; instancecount: Int32);
    external 'opengl32.dll' name 'glDrawTransformFeedbackStreamInstanced';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackStreamInstanced(mode: PrimitiveType; id: TransformFeedbackName; stream: UInt32; instancecount: Int32) :=
    z_DrawTransformFeedbackStreamInstanced_ovr_0(mode, id, stream, instancecount);
    
  end;
  
  glTransposeMatrixARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_LoadTransposeMatrixfARB_ovr_0(var m: single);
    external 'opengl32.dll' name 'glLoadTransposeMatrixfARB';
    private static procedure z_LoadTransposeMatrixfARB_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixfARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixfARB_ovr_0(m[0]) else
      z_LoadTransposeMatrixfARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(var m: single) :=
    z_LoadTransposeMatrixfARB_ovr_0(m);
    private static procedure z_LoadTransposeMatrixfARB_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixfARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixfARB(m: IntPtr) :=
    z_LoadTransposeMatrixfARB_ovr_2(m);
    
    private static procedure z_LoadTransposeMatrixdARB_ovr_0(var m: real);
    external 'opengl32.dll' name 'glLoadTransposeMatrixdARB';
    private static procedure z_LoadTransposeMatrixdARB_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixdARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixdARB_ovr_0(m[0]) else
      z_LoadTransposeMatrixdARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(var m: real) :=
    z_LoadTransposeMatrixdARB_ovr_0(m);
    private static procedure z_LoadTransposeMatrixdARB_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixdARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixdARB(m: IntPtr) :=
    z_LoadTransposeMatrixdARB_ovr_2(m);
    
    private static procedure z_MultTransposeMatrixfARB_ovr_0(var m: single);
    external 'opengl32.dll' name 'glMultTransposeMatrixfARB';
    private static procedure z_MultTransposeMatrixfARB_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixfARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixfARB_ovr_0(m[0]) else
      z_MultTransposeMatrixfARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(var m: single) :=
    z_MultTransposeMatrixfARB_ovr_0(m);
    private static procedure z_MultTransposeMatrixfARB_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixfARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixfARB(m: IntPtr) :=
    z_MultTransposeMatrixfARB_ovr_2(m);
    
    private static procedure z_MultTransposeMatrixdARB_ovr_0(var m: real);
    external 'opengl32.dll' name 'glMultTransposeMatrixdARB';
    private static procedure z_MultTransposeMatrixdARB_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixdARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixdARB_ovr_0(m[0]) else
      z_MultTransposeMatrixdARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(var m: real) :=
    z_MultTransposeMatrixdARB_ovr_0(m);
    private static procedure z_MultTransposeMatrixdARB_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixdARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixdARB(m: IntPtr) :=
    z_MultTransposeMatrixdARB_ovr_2(m);
    
  end;
  
  glUniformBufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetUniformIndices_ovr_0(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_0_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_0_anh00001(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_0_anh00011(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; uniformIndices: array of UInt32);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
          z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices[0]) else
          z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, par_3_str_ptr[0], IntPtr.Zero) else
        if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
          z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
          z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_GetUniformIndices_ovr_1_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; var uniformIndices: UInt32);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_GetUniformIndices_ovr_2(&program: ProgramName; uniformCount: Int32; var uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_2_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of string; uniformIndices: IntPtr);
    begin
      var par_3_str_ptr := uniformNames?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_GetUniformIndices_ovr_2(&program, uniformCount, par_3_str_ptr[0], uniformIndices) else
        z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_GetUniformIndices_ovr_3_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_3_anh00011(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: array of UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00001(&program, uniformCount, uniformNames[0], IntPtr.Zero) else
      if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
        z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices[0]) else
        z_GetUniformIndices_ovr_0_anh00011(&program, uniformCount, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetUniformIndices_ovr_4_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; var uniformIndices: UInt32) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_0(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_0_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private static procedure z_GetUniformIndices_ovr_5_anh00010(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: array of IntPtr; uniformIndices: IntPtr) :=
    if (uniformNames<>nil) and (uniformNames.Length<>0) then
      z_GetUniformIndices_ovr_2(&program, uniformCount, uniformNames[0], uniformIndices) else
      z_GetUniformIndices_ovr_2_anh00010(&program, uniformCount, IntPtr.Zero, uniformIndices);
    private static procedure z_GetUniformIndices_ovr_6(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32);
    external 'opengl32.dll' name 'glGetUniformIndices';
    private static procedure z_GetUniformIndices_ovr_6_anh00001(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: array of UInt32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices[0]) else
      z_GetUniformIndices_ovr_6_anh00001(&program, uniformCount, uniformNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; var uniformIndices: UInt32) :=
    z_GetUniformIndices_ovr_6(&program, uniformCount, uniformNames, uniformIndices);
    private static procedure z_GetUniformIndices_ovr_8(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr);
    external 'opengl32.dll' name 'glGetUniformIndices';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformIndices(&program: ProgramName; uniformCount: Int32; uniformNames: IntPtr; uniformIndices: IntPtr) :=
    z_GetUniformIndices_ovr_8(&program, uniformCount, uniformNames, uniformIndices);
    
    private static procedure z_GetActiveUniformsiv_ovr_0(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    private static procedure z_GetActiveUniformsiv_ovr_0_anh000100(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    private static procedure z_GetActiveUniformsiv_ovr_0_anh000001(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    private static procedure z_GetActiveUniformsiv_ovr_0_anh000101(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: array of Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices[0], pname, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params[0]) else
        z_GetActiveUniformsiv_ovr_0_anh000101(&program, uniformCount, IntPtr.Zero, pname, IntPtr.Zero);
    private static procedure z_GetActiveUniformsiv_ovr_1_anh000100(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; var &params: Int32) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_0_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    private static procedure z_GetActiveUniformsiv_ovr_2(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    private static procedure z_GetActiveUniformsiv_ovr_2_anh000100(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: array of UInt32; pname: UniformPName; &params: IntPtr) :=
    if (uniformIndices<>nil) and (uniformIndices.Length<>0) then
      z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices[0], pname, &params) else
      z_GetActiveUniformsiv_ovr_2_anh000100(&program, uniformCount, IntPtr.Zero, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_0_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_0(&program, uniformCount, uniformIndices, pname, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; var uniformIndices: UInt32; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_2(&program, uniformCount, uniformIndices, pname, &params);
    private static procedure z_GetActiveUniformsiv_ovr_6(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    private static procedure z_GetActiveUniformsiv_ovr_6_anh000001(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params[0]) else
      z_GetActiveUniformsiv_ovr_6_anh000001(&program, uniformCount, uniformIndices, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; var &params: Int32) :=
    z_GetActiveUniformsiv_ovr_6(&program, uniformCount, uniformIndices, pname, &params);
    private static procedure z_GetActiveUniformsiv_ovr_8(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformsiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformsiv(&program: UInt32; uniformCount: Int32; uniformIndices: IntPtr; pname: UniformPName; &params: IntPtr) :=
    z_GetActiveUniformsiv_ovr_8(&program, uniformCount, uniformIndices, pname, &params);
    
    private static procedure z_GetActiveUniformName_ovr_0(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformName';
    private static procedure z_GetActiveUniformName_ovr_0_anh000010(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: array of Int32; uniformName: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length[0], uniformName) else
      z_GetActiveUniformName_ovr_0_anh000010(&program, uniformIndex, bufSize, IntPtr.Zero, uniformName);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; var length: Int32; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_0(&program, uniformIndex, bufSize, length, uniformName);
    private static procedure z_GetActiveUniformName_ovr_2(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformName(&program: UInt32; uniformIndex: UInt32; bufSize: Int32; length: IntPtr; uniformName: IntPtr) :=
    z_GetActiveUniformName_ovr_2(&program, uniformIndex, bufSize, length, uniformName);
    
    private static function z_GetUniformBlockIndex_ovr_0(&program: ProgramName; uniformBlockName: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetUniformBlockIndex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: ProgramName; uniformBlockName: string): UInt32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(uniformBlockName);
      Result := z_GetUniformBlockIndex_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBlockIndex(&program: ProgramName; uniformBlockName: IntPtr): UInt32 :=
    z_GetUniformBlockIndex_ovr_0(&program, uniformBlockName);
    
    private static procedure z_GetActiveUniformBlockiv_ovr_0(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32);
    external 'opengl32.dll' name 'glGetActiveUniformBlockiv';
    private static procedure z_GetActiveUniformBlockiv_ovr_0_anh00001(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformBlockiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params[0]) else
      z_GetActiveUniformBlockiv_ovr_0_anh00001(&program, uniformBlockIndex, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; var &params: Int32) :=
    z_GetActiveUniformBlockiv_ovr_0(&program, uniformBlockIndex, pname, &params);
    private static procedure z_GetActiveUniformBlockiv_ovr_2(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformBlockiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockiv(&program: UInt32; uniformBlockIndex: UInt32; pname: UniformBlockPName; &params: IntPtr) :=
    z_GetActiveUniformBlockiv_ovr_2(&program, uniformBlockIndex, pname, &params);
    
    private static procedure z_GetActiveUniformBlockName_ovr_0(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformBlockName';
    private static procedure z_GetActiveUniformBlockName_ovr_0_anh000010(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformBlockName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: array of Int32; uniformBlockName: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length[0], uniformBlockName) else
      z_GetActiveUniformBlockName_ovr_0_anh000010(&program, uniformBlockIndex, bufSize, IntPtr.Zero, uniformBlockName);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; var length: Int32; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_0(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    private static procedure z_GetActiveUniformBlockName_ovr_2(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr);
    external 'opengl32.dll' name 'glGetActiveUniformBlockName';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveUniformBlockName(&program: UInt32; uniformBlockIndex: UInt32; bufSize: Int32; length: IntPtr; uniformBlockName: IntPtr) :=
    z_GetActiveUniformBlockName_ovr_2(&program, uniformBlockIndex, bufSize, length, uniformBlockName);
    
    private static procedure z_UniformBlockBinding_ovr_0(&program: ProgramName; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32);
    external 'opengl32.dll' name 'glUniformBlockBinding';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBlockBinding(&program: ProgramName; uniformBlockIndex: UInt32; uniformBlockBinding: UInt32) :=
    z_UniformBlockBinding_ovr_0(&program, uniformBlockIndex, uniformBlockBinding);
    
    private static procedure z_BindBufferRange_ovr_0(target: BufferTargetARB; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glBindBufferRange';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRange(target: BufferTargetARB; index: UInt32; buffer: BufferName; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRange_ovr_0(target, index, buffer, offset, size);
    
    private static procedure z_BindBufferBase_ovr_0(target: BufferTargetARB; index: UInt32; buffer: BufferName);
    external 'opengl32.dll' name 'glBindBufferBase';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBase(target: BufferTargetARB; index: UInt32; buffer: BufferName) :=
    z_BindBufferBase_ovr_0(target, index, buffer);
    
    private static procedure z_GetIntegeri_v_ovr_0(target: DummyEnum; index: UInt32; var data: Int32);
    external 'opengl32.dll' name 'glGetIntegeri_v';
    private static procedure z_GetIntegeri_v_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegeri_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegeri_v_ovr_0(target, index, data[0]) else
      z_GetIntegeri_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; var data: Int32) :=
    z_GetIntegeri_v_ovr_0(target, index, data);
    private static procedure z_GetIntegeri_v_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegeri_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegeri_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetIntegeri_v_ovr_2(target, index, data);
    
  end;
  
  glVertexArrayObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindVertexArray_ovr_0(&array: VertexArrayName);
    external 'opengl32.dll' name 'glBindVertexArray';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexArray(&array: VertexArrayName) :=
    z_BindVertexArray_ovr_0(&array);
    
    private static procedure z_DeleteVertexArrays_ovr_0(n: Int32; var arrays: UInt32);
    external 'opengl32.dll' name 'glDeleteVertexArrays';
    private static procedure z_DeleteVertexArrays_ovr_0_anh001(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glDeleteVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_DeleteVertexArrays_ovr_0(n, arrays[0]) else
      z_DeleteVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; var arrays: UInt32) :=
    z_DeleteVertexArrays_ovr_0(n, arrays);
    private static procedure z_DeleteVertexArrays_ovr_2(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glDeleteVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexArrays(n: Int32; arrays: IntPtr) :=
    z_DeleteVertexArrays_ovr_2(n, arrays);
    
    private static procedure z_GenVertexArrays_ovr_0(n: Int32; var arrays: UInt32);
    external 'opengl32.dll' name 'glGenVertexArrays';
    private static procedure z_GenVertexArrays_ovr_0_anh001(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glGenVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: array of UInt32) :=
    if (arrays<>nil) and (arrays.Length<>0) then
      z_GenVertexArrays_ovr_0(n, arrays[0]) else
      z_GenVertexArrays_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; var arrays: UInt32) :=
    z_GenVertexArrays_ovr_0(n, arrays);
    private static procedure z_GenVertexArrays_ovr_2(n: Int32; arrays: IntPtr);
    external 'opengl32.dll' name 'glGenVertexArrays';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenVertexArrays(n: Int32; arrays: IntPtr) :=
    z_GenVertexArrays_ovr_2(n, arrays);
    
    private static function z_IsVertexArray_ovr_0(&array: VertexArrayName): boolean;
    external 'opengl32.dll' name 'glIsVertexArray';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVertexArray(&array: VertexArrayName): boolean :=
    z_IsVertexArray_ovr_0(&array);
    
  end;
  
  glVertexAttrib64bitARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribL1d_ovr_0(index: UInt32; x: real);
    external 'opengl32.dll' name 'glVertexAttribL1d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1d(index: UInt32; x: real) :=
    z_VertexAttribL1d_ovr_0(index, x);
    
    private static procedure z_VertexAttribL2d_ovr_0(index: UInt32; x: real; y: real);
    external 'opengl32.dll' name 'glVertexAttribL2d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2d(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2d_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribL3d_ovr_0(index: UInt32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexAttribL3d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3d(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3d_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribL4d_ovr_0(index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexAttribL4d';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4d(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4d_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribL1dv_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL1dv';
    private static procedure z_VertexAttribL1dv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1dv_ovr_0(index, v[0]) else
      z_VertexAttribL1dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; var v: real) :=
    z_VertexAttribL1dv_ovr_0(index, v);
    private static procedure z_VertexAttribL1dv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dv_ovr_2(index, v);
    
    private static procedure z_VertexAttribL2dv_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL2dv';
    private static procedure z_VertexAttribL2dv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dv_ovr_0(index, v[0]) else
      z_VertexAttribL2dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; var v: real) :=
    z_VertexAttribL2dv_ovr_0(index, v);
    private static procedure z_VertexAttribL2dv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dv_ovr_2(index, v);
    
    private static procedure z_VertexAttribL3dv_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL3dv';
    private static procedure z_VertexAttribL3dv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dv_ovr_0(index, v[0]) else
      z_VertexAttribL3dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; var v: real) :=
    z_VertexAttribL3dv_ovr_0(index, v);
    private static procedure z_VertexAttribL3dv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dv_ovr_2(index, v);
    
    private static procedure z_VertexAttribL4dv_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL4dv';
    private static procedure z_VertexAttribL4dv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dv_ovr_0(index, v[0]) else
      z_VertexAttribL4dv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; var v: real) :=
    z_VertexAttribL4dv_ovr_0(index, v);
    private static procedure z_VertexAttribL4dv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4dv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dv(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dv_ovr_2(index, v);
    
    private static procedure z_VertexAttribLPointer_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribLPointer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointer(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointer_ovr_0(index, size, &type, stride, pointer);
    
    private static procedure z_GetVertexAttribLdv_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: real);
    external 'opengl32.dll' name 'glGetVertexAttribLdv';
    private static procedure z_GetVertexAttribLdv_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdv_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdv_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdv_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribLdv_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLdv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdv(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdv_ovr_2(index, pname, &params);
    
  end;
  
  glVertexAttribBindingARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindVertexBuffer_ovr_0(bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32);
    external 'opengl32.dll' name 'glBindVertexBuffer';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexBuffer(bindingindex: UInt32; buffer: BufferName; offset: IntPtr; stride: Int32) :=
    z_BindVertexBuffer_ovr_0(bindingindex, buffer, offset, stride);
    
    private static procedure z_VertexAttribFormat_ovr_0(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexAttribFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormat(attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexAttribFormat_ovr_0(attribindex, size, &type, normalized, relativeoffset);
    
    private static procedure z_VertexAttribIFormat_ovr_0(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexAttribIFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormat(attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexAttribIFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexAttribLFormat_ovr_0(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexAttribLFormat';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormat(attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexAttribLFormat_ovr_0(attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexAttribBinding_ovr_0(attribindex: UInt32; bindingindex: UInt32);
    external 'opengl32.dll' name 'glVertexAttribBinding';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribBinding(attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexAttribBinding_ovr_0(attribindex, bindingindex);
    
    private static procedure z_VertexBindingDivisor_ovr_0(bindingindex: UInt32; divisor: UInt32);
    external 'opengl32.dll' name 'glVertexBindingDivisor';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBindingDivisor(bindingindex: UInt32; divisor: UInt32) :=
    z_VertexBindingDivisor_ovr_0(bindingindex, divisor);
    
  end;
  
  glVertexBlendARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_WeightbvARB_ovr_0(size: Int32; var weights: SByte);
    external 'opengl32.dll' name 'glWeightbvARB';
    private static procedure z_WeightbvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; weights: array of SByte) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightbvARB_ovr_0(size, weights[0]) else
      z_WeightbvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; var weights: SByte) :=
    z_WeightbvARB_ovr_0(size, weights);
    private static procedure z_WeightbvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightbvARB(size: Int32; weights: IntPtr) :=
    z_WeightbvARB_ovr_2(size, weights);
    
    private static procedure z_WeightsvARB_ovr_0(size: Int32; var weights: Int16);
    external 'opengl32.dll' name 'glWeightsvARB';
    private static procedure z_WeightsvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; weights: array of Int16) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightsvARB_ovr_0(size, weights[0]) else
      z_WeightsvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; var weights: Int16) :=
    z_WeightsvARB_ovr_0(size, weights);
    private static procedure z_WeightsvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightsvARB(size: Int32; weights: IntPtr) :=
    z_WeightsvARB_ovr_2(size, weights);
    
    private static procedure z_WeightivARB_ovr_0(size: Int32; var weights: Int32);
    external 'opengl32.dll' name 'glWeightivARB';
    private static procedure z_WeightivARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; weights: array of Int32) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightivARB_ovr_0(size, weights[0]) else
      z_WeightivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; var weights: Int32) :=
    z_WeightivARB_ovr_0(size, weights);
    private static procedure z_WeightivARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightivARB(size: Int32; weights: IntPtr) :=
    z_WeightivARB_ovr_2(size, weights);
    
    private static procedure z_WeightfvARB_ovr_0(size: Int32; var weights: single);
    external 'opengl32.dll' name 'glWeightfvARB';
    private static procedure z_WeightfvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightfvARB_ovr_0(size, weights[0]) else
      z_WeightfvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; var weights: single) :=
    z_WeightfvARB_ovr_0(size, weights);
    private static procedure z_WeightfvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightfvARB(size: Int32; weights: IntPtr) :=
    z_WeightfvARB_ovr_2(size, weights);
    
    private static procedure z_WeightdvARB_ovr_0(size: Int32; var weights: real);
    external 'opengl32.dll' name 'glWeightdvARB';
    private static procedure z_WeightdvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; weights: array of real) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightdvARB_ovr_0(size, weights[0]) else
      z_WeightdvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; var weights: real) :=
    z_WeightdvARB_ovr_0(size, weights);
    private static procedure z_WeightdvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightdvARB(size: Int32; weights: IntPtr) :=
    z_WeightdvARB_ovr_2(size, weights);
    
    private static procedure z_WeightubvARB_ovr_0(size: Int32; var weights: Byte);
    external 'opengl32.dll' name 'glWeightubvARB';
    private static procedure z_WeightubvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; weights: array of Byte) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightubvARB_ovr_0(size, weights[0]) else
      z_WeightubvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; var weights: Byte) :=
    z_WeightubvARB_ovr_0(size, weights);
    private static procedure z_WeightubvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightubvARB(size: Int32; weights: IntPtr) :=
    z_WeightubvARB_ovr_2(size, weights);
    
    private static procedure z_WeightusvARB_ovr_0(size: Int32; var weights: UInt16);
    external 'opengl32.dll' name 'glWeightusvARB';
    private static procedure z_WeightusvARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; weights: array of UInt16) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightusvARB_ovr_0(size, weights[0]) else
      z_WeightusvARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; var weights: UInt16) :=
    z_WeightusvARB_ovr_0(size, weights);
    private static procedure z_WeightusvARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightusvARB(size: Int32; weights: IntPtr) :=
    z_WeightusvARB_ovr_2(size, weights);
    
    private static procedure z_WeightuivARB_ovr_0(size: Int32; var weights: UInt32);
    external 'opengl32.dll' name 'glWeightuivARB';
    private static procedure z_WeightuivARB_ovr_0_anh001(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; weights: array of UInt32) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightuivARB_ovr_0(size, weights[0]) else
      z_WeightuivARB_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; var weights: UInt32) :=
    z_WeightuivARB_ovr_0(size, weights);
    private static procedure z_WeightuivARB_ovr_2(size: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightuivARB(size: Int32; weights: IntPtr) :=
    z_WeightuivARB_ovr_2(size, weights);
    
    private static procedure z_WeightPointerARB_ovr_0(size: Int32; &type: WeightPointerTypeARB; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glWeightPointerARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPointerARB(size: Int32; &type: WeightPointerTypeARB; stride: Int32; pointer: IntPtr) :=
    z_WeightPointerARB_ovr_0(size, &type, stride, pointer);
    
    private static procedure z_VertexBlendARB_ovr_0(count: Int32);
    external 'opengl32.dll' name 'glVertexBlendARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendARB(count: Int32) :=
    z_VertexBlendARB_ovr_0(count);
    
  end;
  
  glVertexBufferObjectARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindBufferARB_ovr_0(target: BufferTargetARB; buffer: UInt32);
    external 'opengl32.dll' name 'glBindBufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferARB(target: BufferTargetARB; buffer: UInt32) :=
    z_BindBufferARB_ovr_0(target, buffer);
    
    private static procedure z_DeleteBuffersARB_ovr_0(n: Int32; var buffers: UInt32);
    external 'opengl32.dll' name 'glDeleteBuffersARB';
    private static procedure z_DeleteBuffersARB_ovr_0_anh001(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; buffers: array of UInt32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_DeleteBuffersARB_ovr_0(n, buffers[0]) else
      z_DeleteBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; var buffers: UInt32) :=
    z_DeleteBuffersARB_ovr_0(n, buffers);
    private static procedure z_DeleteBuffersARB_ovr_2(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteBuffersARB(n: Int32; buffers: IntPtr) :=
    z_DeleteBuffersARB_ovr_2(n, buffers);
    
    private static procedure z_GenBuffersARB_ovr_0(n: Int32; var buffers: UInt32);
    external 'opengl32.dll' name 'glGenBuffersARB';
    private static procedure z_GenBuffersARB_ovr_0_anh001(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glGenBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; buffers: array of UInt32) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_GenBuffersARB_ovr_0(n, buffers[0]) else
      z_GenBuffersARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; var buffers: UInt32) :=
    z_GenBuffersARB_ovr_0(n, buffers);
    private static procedure z_GenBuffersARB_ovr_2(n: Int32; buffers: IntPtr);
    external 'opengl32.dll' name 'glGenBuffersARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenBuffersARB(n: Int32; buffers: IntPtr) :=
    z_GenBuffersARB_ovr_2(n, buffers);
    
    private static function z_IsBufferARB_ovr_0(buffer: UInt32): boolean;
    external 'opengl32.dll' name 'glIsBufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBufferARB(buffer: UInt32): boolean :=
    z_IsBufferARB_ovr_0(buffer);
    
    private static procedure z_BufferDataARB_ovr_0(target: BufferTargetARB; size: IntPtr; data: IntPtr; usage: BufferUsageARB);
    external 'opengl32.dll' name 'glBufferDataARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferDataARB(target: BufferTargetARB; size: IntPtr; data: IntPtr; usage: BufferUsageARB) :=
    z_BufferDataARB_ovr_0(target, size, data, usage);
    
    private static procedure z_BufferSubDataARB_ovr_0(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glBufferSubDataARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferSubDataARB(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_BufferSubDataARB_ovr_0(target, offset, size, data);
    
    private static procedure z_GetBufferSubDataARB_ovr_0(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glGetBufferSubDataARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferSubDataARB(target: BufferTargetARB; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetBufferSubDataARB_ovr_0(target, offset, size, data);
    
    private static function z_MapBufferARB_ovr_0(target: BufferTargetARB; access: BufferAccessARB): IntPtr;
    external 'opengl32.dll' name 'glMapBufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapBufferARB(target: BufferTargetARB; access: BufferAccessARB): IntPtr :=
    z_MapBufferARB_ovr_0(target, access);
    
    private static function z_UnmapBufferARB_ovr_0(target: BufferTargetARB): boolean;
    external 'opengl32.dll' name 'glUnmapBufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapBufferARB(target: BufferTargetARB): boolean :=
    z_UnmapBufferARB_ovr_0(target);
    
    private static procedure z_GetBufferParameterivARB_ovr_0(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetBufferParameterivARB';
    private static procedure z_GetBufferParameterivARB_ovr_0_anh0001(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferParameterivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTargetARB; pname: BufferPNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameterivARB_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameterivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTargetARB; pname: BufferPNameARB; var &params: Int32) :=
    z_GetBufferParameterivARB_ovr_0(target, pname, &params);
    private static procedure z_GetBufferParameterivARB_ovr_2(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferParameterivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterivARB(target: BufferTargetARB; pname: BufferPNameARB; &params: IntPtr) :=
    z_GetBufferParameterivARB_ovr_2(target, pname, &params);
    
    private static procedure z_GetBufferPointervARB_ovr_0(target: BufferTargetARB; pname: BufferPointerNameARB; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferPointervARB';
    private static procedure z_GetBufferPointervARB_ovr_0_anh0001(target: BufferTargetARB; pname: BufferPointerNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointervARB(target: BufferTargetARB; pname: BufferPointerNameARB; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferPointervARB_ovr_0(target, pname, &params[0]) else
      z_GetBufferPointervARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointervARB(target: BufferTargetARB; pname: BufferPointerNameARB; var &params: IntPtr) :=
    z_GetBufferPointervARB_ovr_0(target, pname, &params);
    private static procedure z_GetBufferPointervARB_ovr_2(target: BufferTargetARB; pname: BufferPointerNameARB; &params: pointer);
    external 'opengl32.dll' name 'glGetBufferPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferPointervARB(target: BufferTargetARB; pname: BufferPointerNameARB; &params: pointer) :=
    z_GetBufferPointervARB_ovr_2(target, pname, &params);
    
  end;
  
  glVertexProgramARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttrib1dARB_ovr_0(index: UInt32; x: real);
    external 'opengl32.dll' name 'glVertexAttrib1dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dARB(index: UInt32; x: real) :=
    z_VertexAttrib1dARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    private static procedure z_VertexAttrib1dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib1dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib1dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1fARB_ovr_0(index: UInt32; x: single);
    external 'opengl32.dll' name 'glVertexAttrib1fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fARB(index: UInt32; x: single) :=
    z_VertexAttrib1fARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    private static procedure z_VertexAttrib1fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib1fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib1fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1sARB_ovr_0(index: UInt32; x: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sARB(index: UInt32; x: Int16) :=
    z_VertexAttrib1sARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    private static procedure z_VertexAttrib1svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1svARB_ovr_0(index, v[0]) else
      z_VertexAttrib1svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2dARB_ovr_0(index: UInt32; x: real; y: real);
    external 'opengl32.dll' name 'glVertexAttrib2dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dARB(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    private static procedure z_VertexAttrib2dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib2dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2fARB_ovr_0(index: UInt32; x: single; y: single);
    external 'opengl32.dll' name 'glVertexAttrib2fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fARB(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    private static procedure z_VertexAttrib2fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib2fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2sARB_ovr_0(index: UInt32; x: Int16; y: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sARB(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    private static procedure z_VertexAttrib2svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svARB_ovr_0(index, v[0]) else
      z_VertexAttrib2svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3dARB_ovr_0(index: UInt32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexAttrib3dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dARB(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    private static procedure z_VertexAttrib3dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib3dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3fARB_ovr_0(index: UInt32; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glVertexAttrib3fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fARB(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    private static procedure z_VertexAttrib3fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib3fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3sARB_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sARB(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    private static procedure z_VertexAttrib3svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svARB_ovr_0(index, v[0]) else
      z_VertexAttrib3svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NbvARB_ovr_0(index: UInt32; var v: SByte);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    private static procedure z_VertexAttrib4NbvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NbvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NbvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4NbvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NbvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NbvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NivARB_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    private static procedure z_VertexAttrib4NivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4NivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NsvARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    private static procedure z_VertexAttrib4NsvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NsvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NsvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4NsvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NsvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NsvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NubARB_ovr_0(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4NubARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubARB(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4NubARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4NubvARB_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    private static procedure z_VertexAttrib4NubvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4NubvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NubvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NubvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NuivARB_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    private static procedure z_VertexAttrib4NuivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NuivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NuivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4NuivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NuivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NuivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NusvARB_ovr_0(index: UInt32; var v: UInt16);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    private static procedure z_VertexAttrib4NusvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NusvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NusvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4NusvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NusvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NusvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4bvARB_ovr_0(index: UInt32; var v: SByte);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    private static procedure z_VertexAttrib4bvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4bvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4bvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4dARB_ovr_0(index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexAttrib4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dARB(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    private static procedure z_VertexAttrib4dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib4dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4fARB_ovr_0(index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glVertexAttrib4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fARB(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    private static procedure z_VertexAttrib4fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib4fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4ivARB_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    private static procedure z_VertexAttrib4ivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4ivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4ivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4sARB_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sARB(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    private static procedure z_VertexAttrib4svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svARB_ovr_0(index, v[0]) else
      z_VertexAttrib4svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4ubvARB_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    private static procedure z_VertexAttrib4ubvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4ubvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4uivARB_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    private static procedure z_VertexAttrib4uivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4uivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4uivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4usvARB_ovr_0(index: UInt32; var v: UInt16);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    private static procedure z_VertexAttrib4usvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4usvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4usvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttribPointerARB_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribPointerARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerARB(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerARB_ovr_0(index, size, &type, normalized, stride, pointer);
    
    private static procedure z_EnableVertexAttribArrayARB_ovr_0(index: UInt32);
    external 'opengl32.dll' name 'glEnableVertexAttribArrayARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArrayARB(index: UInt32) :=
    z_EnableVertexAttribArrayARB_ovr_0(index);
    
    private static procedure z_DisableVertexAttribArrayARB_ovr_0(index: UInt32);
    external 'opengl32.dll' name 'glDisableVertexAttribArrayARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArrayARB(index: UInt32) :=
    z_DisableVertexAttribArrayARB_ovr_0(index);
    
    private static procedure z_ProgramStringARB_ovr_0(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr);
    external 'opengl32.dll' name 'glProgramStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramStringARB(target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_ProgramStringARB_ovr_0(target, format, len, string);
    
    private static procedure z_BindProgramARB_ovr_0(target: ProgramTarget; &program: UInt32);
    external 'opengl32.dll' name 'glBindProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramARB(target: ProgramTarget; &program: UInt32) :=
    z_BindProgramARB_ovr_0(target, &program);
    
    private static procedure z_DeleteProgramsARB_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    private static procedure z_DeleteProgramsARB_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsARB_ovr_0(n, programs[0]) else
      z_DeleteProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; var programs: UInt32) :=
    z_DeleteProgramsARB_ovr_0(n, programs);
    private static procedure z_DeleteProgramsARB_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsARB(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsARB_ovr_2(n, programs);
    
    private static procedure z_GenProgramsARB_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glGenProgramsARB';
    private static procedure z_GenProgramsARB_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsARB_ovr_0(n, programs[0]) else
      z_GenProgramsARB_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; var programs: UInt32) :=
    z_GenProgramsARB_ovr_0(n, programs);
    private static procedure z_GenProgramsARB_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsARB(n: Int32; programs: IntPtr) :=
    z_GenProgramsARB_ovr_2(n, programs);
    
    private static procedure z_ProgramEnvParameter4dARB_ovr_0(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramEnvParameter4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramEnvParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameter4dvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    private static procedure z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramEnvParameter4dvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameter4dvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4dvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramEnvParameter4fARB_ovr_0(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramEnvParameter4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramEnvParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameter4fvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    private static procedure z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramEnvParameter4fvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameter4fvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameter4fvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParameter4dARB_ovr_0(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramLocalParameter4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dARB(target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramLocalParameter4dARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameter4dvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    private static procedure z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4dvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_ProgramLocalParameter4dvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameter4dvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4dvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4dvARB_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParameter4fARB_ovr_0(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramLocalParameter4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fARB(target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramLocalParameter4fARB_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameter4fvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    private static procedure z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameter4fvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_ProgramLocalParameter4fvARB_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameter4fvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameter4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameter4fvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameter4fvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterdvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    private static procedure z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramEnvParameterdvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterdvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterdvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterfvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    private static procedure z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramEnvParameterfvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterfvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterfvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramLocalParameterdvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    private static procedure z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterdvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetProgramLocalParameterdvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterdvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterdvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterdvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramLocalParameterfvARB_ovr_0(target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    private static procedure z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterfvARB_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetProgramLocalParameterfvARB_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterfvARB_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterfvARB(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterfvARB_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramivARB_ovr_0(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramivARB';
    private static procedure z_GetProgramivARB_ovr_0_anh0001(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramivARB_ovr_0(target, pname, &params[0]) else
      z_GetProgramivARB_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetProgramivARB_ovr_0(target, pname, &params);
    private static procedure z_GetProgramivARB_ovr_2(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivARB(target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetProgramivARB_ovr_2(target, pname, &params);
    
    private static procedure z_GetProgramStringARB_ovr_0(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringARB(target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetProgramStringARB_ovr_0(target, pname, string);
    
    private static procedure z_GetVertexAttribdvARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: real);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    private static procedure z_GetVertexAttribdvARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdvARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribdvARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdvARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribfvARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: single);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    private static procedure z_GetVertexAttribfvARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfvARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribfvARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfvARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribivARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    private static procedure z_GetVertexAttribivARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribivARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribivARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribivARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribivARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribivARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribPointervARB_ovr_0(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    private static procedure z_GetVertexAttribPointervARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer[0]) else
      z_GetVertexAttribPointervARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer);
    private static procedure z_GetVertexAttribPointervARB_ovr_2(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointervARB_ovr_2(index, pname, _pointer);
    
    private static function z_IsProgramARB_ovr_0(&program: UInt32): boolean;
    external 'opengl32.dll' name 'glIsProgramARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramARB(&program: UInt32): boolean :=
    z_IsProgramARB_ovr_0(&program);
    
  end;
  
  glVertexShaderARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttrib1fARB_ovr_0(index: UInt32; x: single);
    external 'opengl32.dll' name 'glVertexAttrib1fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fARB(index: UInt32; x: single) :=
    z_VertexAttrib1fARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1sARB_ovr_0(index: UInt32; x: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sARB(index: UInt32; x: Int16) :=
    z_VertexAttrib1sARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1dARB_ovr_0(index: UInt32; x: real);
    external 'opengl32.dll' name 'glVertexAttrib1dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dARB(index: UInt32; x: real) :=
    z_VertexAttrib1dARB_ovr_0(index, x);
    
    private static procedure z_VertexAttrib2fARB_ovr_0(index: UInt32; x: single; y: single);
    external 'opengl32.dll' name 'glVertexAttrib2fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fARB(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2sARB_ovr_0(index: UInt32; x: Int16; y: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sARB(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2dARB_ovr_0(index: UInt32; x: real; y: real);
    external 'opengl32.dll' name 'glVertexAttrib2dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dARB(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dARB_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib3fARB_ovr_0(index: UInt32; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glVertexAttrib3fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fARB(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3sARB_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sARB(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3dARB_ovr_0(index: UInt32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexAttrib3dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dARB(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dARB_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib4fARB_ovr_0(index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glVertexAttrib4fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fARB(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4sARB_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sARB(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4dARB_ovr_0(index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexAttrib4dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dARB(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4NubARB_ovr_0(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4NubARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubARB(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4NubARB_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib1fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    private static procedure z_VertexAttrib1fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib1fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib1fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    private static procedure z_VertexAttrib1svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1svARB_ovr_0(index, v[0]) else
      z_VertexAttrib1svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    private static procedure z_VertexAttrib1dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib1dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib1dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib1dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    private static procedure z_VertexAttrib2fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib2fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    private static procedure z_VertexAttrib2svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svARB_ovr_0(index, v[0]) else
      z_VertexAttrib2svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    private static procedure z_VertexAttrib2dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib2dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib2dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib2dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    private static procedure z_VertexAttrib3fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib3fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    private static procedure z_VertexAttrib3svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svARB_ovr_0(index, v[0]) else
      z_VertexAttrib3svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    private static procedure z_VertexAttrib3dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib3dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib3dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib3dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4fvARB_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    private static procedure z_VertexAttrib4fvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4fvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; var v: single) :=
    z_VertexAttrib4fvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4fvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4svARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    private static procedure z_VertexAttrib4svARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svARB_ovr_0(index, v[0]) else
      z_VertexAttrib4svARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4svARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4dvARB_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    private static procedure z_VertexAttrib4dvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4dvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; var v: real) :=
    z_VertexAttrib4dvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4dvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4ivARB_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    private static procedure z_VertexAttrib4ivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4ivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4ivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4bvARB_ovr_0(index: UInt32; var v: SByte);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    private static procedure z_VertexAttrib4bvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4bvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4bvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4bvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4bvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4bvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4bvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4bvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4ubvARB_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    private static procedure z_VertexAttrib4ubvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4ubvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4usvARB_ovr_0(index: UInt32; var v: UInt16);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    private static procedure z_VertexAttrib4usvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4usvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4usvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4usvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4usvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4usvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4usvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4usvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4uivARB_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    private static procedure z_VertexAttrib4uivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4uivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4uivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4uivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4uivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4uivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4uivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4uivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NbvARB_ovr_0(index: UInt32; var v: SByte);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    private static procedure z_VertexAttrib4NbvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NbvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NbvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; var v: SByte) :=
    z_VertexAttrib4NbvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NbvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NbvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NbvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NbvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NsvARB_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    private static procedure z_VertexAttrib4NsvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NsvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NsvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; var v: Int16) :=
    z_VertexAttrib4NsvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NsvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NsvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NsvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NsvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NivARB_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    private static procedure z_VertexAttrib4NivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; var v: Int32) :=
    z_VertexAttrib4NivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NubvARB_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    private static procedure z_VertexAttrib4NubvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NubvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NubvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; var v: Byte) :=
    z_VertexAttrib4NubvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NubvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NubvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NubvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NubvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NusvARB_ovr_0(index: UInt32; var v: UInt16);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    private static procedure z_VertexAttrib4NusvARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NusvARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NusvARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; var v: UInt16) :=
    z_VertexAttrib4NusvARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NusvARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NusvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NusvARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NusvARB_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4NuivARB_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    private static procedure z_VertexAttrib4NuivARB_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4NuivARB_ovr_0(index, v[0]) else
      z_VertexAttrib4NuivARB_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; var v: UInt32) :=
    z_VertexAttrib4NuivARB_ovr_0(index, v);
    private static procedure z_VertexAttrib4NuivARB_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4NuivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4NuivARB(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4NuivARB_ovr_2(index, v);
    
    private static procedure z_VertexAttribPointerARB_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribPointerARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerARB(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerARB_ovr_0(index, size, &type, normalized, stride, pointer);
    
    private static procedure z_EnableVertexAttribArrayARB_ovr_0(index: UInt32);
    external 'opengl32.dll' name 'glEnableVertexAttribArrayARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexAttribArrayARB(index: UInt32) :=
    z_EnableVertexAttribArrayARB_ovr_0(index);
    
    private static procedure z_DisableVertexAttribArrayARB_ovr_0(index: UInt32);
    external 'opengl32.dll' name 'glDisableVertexAttribArrayARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexAttribArrayARB(index: UInt32) :=
    z_DisableVertexAttribArrayARB_ovr_0(index);
    
    private static procedure z_BindAttribLocationARB_ovr_0(programObj: GLhandleARB; index: UInt32; name: IntPtr);
    external 'opengl32.dll' name 'glBindAttribLocationARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocationARB(programObj: GLhandleARB; index: UInt32; name: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindAttribLocationARB_ovr_0(programObj, index, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindAttribLocationARB(programObj: GLhandleARB; index: UInt32; name: IntPtr) :=
    z_BindAttribLocationARB_ovr_0(programObj, index, name);
    
    private static procedure z_GetActiveAttribARB_ovr_0(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00000110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_0_anh00001110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length[0], size[0], &type[0], name) else
          z_GetActiveAttribARB_ovr_0_anh00000010(programObj, index, maxLength, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttribARB_ovr_0_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type[0], name) else
          z_GetActiveAttribARB_ovr_0_anh00000110(programObj, index, maxLength, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttribARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type[0], name) else
          z_GetActiveAttribARB_ovr_0_anh00001010(programObj, index, maxLength, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveAttribARB_ovr_0_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetActiveAttribARB_ovr_0_anh00001110(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveAttribARB_ovr_1_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_1_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_1_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length[0], size[0], &type, name) else
        z_GetActiveAttribARB_ovr_0_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttribARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveAttribARB_ovr_0_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_2(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_2_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_2_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_2_anh00001100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttribARB_ovr_2(programObj, index, maxLength, length[0], size[0], &type, name) else
        z_GetActiveAttribARB_ovr_2_anh00000100(programObj, index, maxLength, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveAttribARB_ovr_2_anh00001000(programObj, index, maxLength, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveAttribARB_ovr_2_anh00001100(programObj, index, maxLength, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_3_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_3_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length[0], size, &type[0], name) else
        z_GetActiveAttribARB_ovr_0_anh00000010(programObj, index, maxLength, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveAttribARB_ovr_0_anh00001010(programObj, index, maxLength, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveAttribARB_ovr_4_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveAttribARB_ovr_0_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_5_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttribARB_ovr_2(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveAttribARB_ovr_2_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_6(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_6_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_6_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_6_anh00001010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_6(programObj, index, maxLength, length[0], size, &type[0], name) else
        z_GetActiveAttribARB_ovr_6_anh00000010(programObj, index, maxLength, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_6_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveAttribARB_ovr_6_anh00001010(programObj, index, maxLength, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveAttribARB_ovr_7_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttribARB_ovr_6(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveAttribARB_ovr_6_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_8(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_8_anh00001000(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveAttribARB_ovr_8(programObj, index, maxLength, length[0], size, &type, name) else
      z_GetActiveAttribARB_ovr_8_anh00001000(programObj, index, maxLength, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length, size[0], &type[0], name) else
        z_GetActiveAttribARB_ovr_0_anh00000010(programObj, index, maxLength, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_0_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveAttribARB_ovr_0_anh00000110(programObj, index, maxLength, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveAttribARB_ovr_0_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttribARB_ovr_2(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveAttribARB_ovr_2_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveAttribARB_ovr_0_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_0(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_2(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttribARB_ovr_6(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveAttribARB_ovr_6_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_6(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_8(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_18(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_18_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_18_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_18_anh00000110(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; &type: array of AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_18(programObj, index, maxLength, length, size[0], &type[0], name) else
        z_GetActiveAttribARB_ovr_18_anh00000010(programObj, index, maxLength, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveAttribARB_ovr_18_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveAttribARB_ovr_18_anh00000110(programObj, index, maxLength, length, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveAttribARB_ovr_19_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; var &type: AttributeType; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttribARB_ovr_18(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveAttribARB_ovr_18_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_20(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_20_anh00000100(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveAttribARB_ovr_20(programObj, index, maxLength, length, size[0], &type, name) else
      z_GetActiveAttribARB_ovr_20_anh00000100(programObj, index, maxLength, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttribARB_ovr_18(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveAttribARB_ovr_18_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_18(programObj, index, maxLength, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_20(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_24(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    private static procedure z_GetActiveAttribARB_ovr_24_anh00000010(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: array of AttributeType; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveAttribARB_ovr_24(programObj, index, maxLength, length, size, &type[0], name) else
      z_GetActiveAttribARB_ovr_24_anh00000010(programObj, index, maxLength, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; var &type: AttributeType; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_24(programObj, index, maxLength, length, size, &type, name);
    private static procedure z_GetActiveAttribARB_ovr_26(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveAttribARB(programObj: GLhandleARB; index: UInt32; maxLength: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveAttribARB_ovr_26(programObj, index, maxLength, length, size, &type, name);
    
    private static function z_GetAttribLocationARB_ovr_0(programObj: GLhandleARB; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetAttribLocationARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocationARB(programObj: GLhandleARB; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetAttribLocationARB_ovr_0(programObj, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetAttribLocationARB(programObj: GLhandleARB; name: IntPtr): Int32 :=
    z_GetAttribLocationARB_ovr_0(programObj, name);
    
    private static procedure z_GetVertexAttribdvARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: real);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    private static procedure z_GetVertexAttribdvARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: real) :=
    z_GetVertexAttribdvARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribdvARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribdvARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribfvARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: single);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    private static procedure z_GetVertexAttribfvARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfvARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfvARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: single) :=
    z_GetVertexAttribfvARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribfvARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribfvARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribivARB_ovr_0(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    private static procedure z_GetVertexAttribivARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribivARB_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribivARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; var &params: Int32) :=
    z_GetVertexAttribivARB_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribivARB_ovr_2(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivARB(index: UInt32; pname: VertexAttribPropertyARB; &params: IntPtr) :=
    z_GetVertexAttribivARB_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribPointervARB_ovr_0(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    private static procedure z_GetVertexAttribPointervARB_ovr_0_anh0001(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer[0]) else
      z_GetVertexAttribPointervARB_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervARB_ovr_0(index, pname, _pointer);
    private static procedure z_GetVertexAttribPointervARB_ovr_2(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer);
    external 'opengl32.dll' name 'glGetVertexAttribPointervARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervARB(index: UInt32; pname: VertexAttribPointerPropertyARB; _pointer: pointer) :=
    z_GetVertexAttribPointervARB_ovr_2(index, pname, _pointer);
    
  end;
  
  glVertexType2101010RevARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribP1ui_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP1ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP1ui_ovr_0(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP1uiv_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP1uiv';
    private static procedure z_VertexAttribP1uiv_ovr_0_anh00001(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP1uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP1uiv_ovr_0(index, &type, normalized, value);
    private static procedure z_VertexAttribP1uiv_ovr_2(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP1uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP1uiv_ovr_2(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP2ui_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP2ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP2ui_ovr_0(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP2uiv_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP2uiv';
    private static procedure z_VertexAttribP2uiv_ovr_0_anh00001(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP2uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP2uiv_ovr_0(index, &type, normalized, value);
    private static procedure z_VertexAttribP2uiv_ovr_2(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP2uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP2uiv_ovr_2(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP3ui_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP3ui_ovr_0(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP3uiv_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP3uiv';
    private static procedure z_VertexAttribP3uiv_ovr_0_anh00001(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP3uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP3uiv_ovr_0(index, &type, normalized, value);
    private static procedure z_VertexAttribP3uiv_ovr_2(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP3uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP3uiv_ovr_2(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP4ui_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4ui(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: UInt32) :=
    z_VertexAttribP4ui_ovr_0(index, &type, normalized, value);
    
    private static procedure z_VertexAttribP4uiv_ovr_0(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32);
    external 'opengl32.dll' name 'glVertexAttribP4uiv';
    private static procedure z_VertexAttribP4uiv_ovr_0_anh00001(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value[0]) else
      z_VertexAttribP4uiv_ovr_0_anh00001(index, &type, normalized, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; var value: UInt32) :=
    z_VertexAttribP4uiv_ovr_0(index, &type, normalized, value);
    private static procedure z_VertexAttribP4uiv_ovr_2(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribP4uiv(index: UInt32; &type: VertexAttribPointerType; normalized: boolean; value: IntPtr) :=
    z_VertexAttribP4uiv_ovr_2(index, &type, normalized, value);
    
    private static procedure z_VertexP2ui_ovr_0(&type: VertexPointerType; value: UInt32);
    external 'opengl32.dll' name 'glVertexP2ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP2ui_ovr_0(&type, value);
    
    private static procedure z_VertexP2uiv_ovr_0(&type: VertexPointerType; var value: UInt32);
    external 'opengl32.dll' name 'glVertexP2uiv';
    private static procedure z_VertexP2uiv_ovr_0_anh001(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP2uiv_ovr_0(&type, value[0]) else
      z_VertexP2uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP2uiv_ovr_0(&type, value);
    private static procedure z_VertexP2uiv_ovr_2(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP2uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP2uiv_ovr_2(&type, value);
    
    private static procedure z_VertexP3ui_ovr_0(&type: VertexPointerType; value: UInt32);
    external 'opengl32.dll' name 'glVertexP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP3ui_ovr_0(&type, value);
    
    private static procedure z_VertexP3uiv_ovr_0(&type: VertexPointerType; var value: UInt32);
    external 'opengl32.dll' name 'glVertexP3uiv';
    private static procedure z_VertexP3uiv_ovr_0_anh001(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP3uiv_ovr_0(&type, value[0]) else
      z_VertexP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP3uiv_ovr_0(&type, value);
    private static procedure z_VertexP3uiv_ovr_2(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP3uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP3uiv_ovr_2(&type, value);
    
    private static procedure z_VertexP4ui_ovr_0(&type: VertexPointerType; value: UInt32);
    external 'opengl32.dll' name 'glVertexP4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4ui(&type: VertexPointerType; value: UInt32) :=
    z_VertexP4ui_ovr_0(&type, value);
    
    private static procedure z_VertexP4uiv_ovr_0(&type: VertexPointerType; var value: UInt32);
    external 'opengl32.dll' name 'glVertexP4uiv';
    private static procedure z_VertexP4uiv_ovr_0_anh001(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_VertexP4uiv_ovr_0(&type, value[0]) else
      z_VertexP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; var value: UInt32) :=
    z_VertexP4uiv_ovr_0(&type, value);
    private static procedure z_VertexP4uiv_ovr_2(&type: VertexPointerType; value: IntPtr);
    external 'opengl32.dll' name 'glVertexP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexP4uiv(&type: VertexPointerType; value: IntPtr) :=
    z_VertexP4uiv_ovr_2(&type, value);
    
    private static procedure z_TexCoordP1ui_ovr_0(&type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP1ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP1ui_ovr_0(&type, coords);
    
    private static procedure z_TexCoordP1uiv_ovr_0(&type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP1uiv';
    private static procedure z_TexCoordP1uiv_ovr_0_anh001(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP1uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP1uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP1uiv_ovr_0(&type, coords);
    private static procedure z_TexCoordP1uiv_ovr_2(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP1uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP1uiv_ovr_2(&type, coords);
    
    private static procedure z_TexCoordP2ui_ovr_0(&type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP2ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP2ui_ovr_0(&type, coords);
    
    private static procedure z_TexCoordP2uiv_ovr_0(&type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP2uiv';
    private static procedure z_TexCoordP2uiv_ovr_0_anh001(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP2uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP2uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP2uiv_ovr_0(&type, coords);
    private static procedure z_TexCoordP2uiv_ovr_2(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP2uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP2uiv_ovr_2(&type, coords);
    
    private static procedure z_TexCoordP3ui_ovr_0(&type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP3ui_ovr_0(&type, coords);
    
    private static procedure z_TexCoordP3uiv_ovr_0(&type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP3uiv';
    private static procedure z_TexCoordP3uiv_ovr_0_anh001(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP3uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP3uiv_ovr_0(&type, coords);
    private static procedure z_TexCoordP3uiv_ovr_2(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP3uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP3uiv_ovr_2(&type, coords);
    
    private static procedure z_TexCoordP4ui_ovr_0(&type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4ui(&type: TexCoordPointerType; coords: UInt32) :=
    z_TexCoordP4ui_ovr_0(&type, coords);
    
    private static procedure z_TexCoordP4uiv_ovr_0(&type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glTexCoordP4uiv';
    private static procedure z_TexCoordP4uiv_ovr_0_anh001(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoordP4uiv_ovr_0(&type, coords[0]) else
      z_TexCoordP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; var coords: UInt32) :=
    z_TexCoordP4uiv_ovr_0(&type, coords);
    private static procedure z_TexCoordP4uiv_ovr_2(&type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoordP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordP4uiv(&type: TexCoordPointerType; coords: IntPtr) :=
    z_TexCoordP4uiv_ovr_2(&type, coords);
    
    private static procedure z_MultiTexCoordP1ui_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP1ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP1ui_ovr_0(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP1uiv_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP1uiv';
    private static procedure z_MultiTexCoordP1uiv_ovr_0_anh0001(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP1uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP1uiv_ovr_0(texture, &type, coords);
    private static procedure z_MultiTexCoordP1uiv_ovr_2(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP1uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP1uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP1uiv_ovr_2(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP2ui_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP2ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP2ui_ovr_0(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP2uiv_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP2uiv';
    private static procedure z_MultiTexCoordP2uiv_ovr_0_anh0001(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP2uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP2uiv_ovr_0(texture, &type, coords);
    private static procedure z_MultiTexCoordP2uiv_ovr_2(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP2uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP2uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP2uiv_ovr_2(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP3ui_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP3ui_ovr_0(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP3uiv_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP3uiv';
    private static procedure z_MultiTexCoordP3uiv_ovr_0_anh0001(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP3uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP3uiv_ovr_0(texture, &type, coords);
    private static procedure z_MultiTexCoordP3uiv_ovr_2(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP3uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP3uiv_ovr_2(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP4ui_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4ui(texture: TextureUnit; &type: TexCoordPointerType; coords: UInt32) :=
    z_MultiTexCoordP4ui_ovr_0(texture, &type, coords);
    
    private static procedure z_MultiTexCoordP4uiv_ovr_0(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glMultiTexCoordP4uiv';
    private static procedure z_MultiTexCoordP4uiv_ovr_0_anh0001(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords[0]) else
      z_MultiTexCoordP4uiv_ovr_0_anh0001(texture, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; var coords: UInt32) :=
    z_MultiTexCoordP4uiv_ovr_0(texture, &type, coords);
    private static procedure z_MultiTexCoordP4uiv_ovr_2(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordP4uiv(texture: TextureUnit; &type: TexCoordPointerType; coords: IntPtr) :=
    z_MultiTexCoordP4uiv_ovr_2(texture, &type, coords);
    
    private static procedure z_NormalP3ui_ovr_0(&type: NormalPointerType; coords: UInt32);
    external 'opengl32.dll' name 'glNormalP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3ui(&type: NormalPointerType; coords: UInt32) :=
    z_NormalP3ui_ovr_0(&type, coords);
    
    private static procedure z_NormalP3uiv_ovr_0(&type: NormalPointerType; var coords: UInt32);
    external 'opengl32.dll' name 'glNormalP3uiv';
    private static procedure z_NormalP3uiv_ovr_0_anh001(&type: NormalPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: array of UInt32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalP3uiv_ovr_0(&type, coords[0]) else
      z_NormalP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; var coords: UInt32) :=
    z_NormalP3uiv_ovr_0(&type, coords);
    private static procedure z_NormalP3uiv_ovr_2(&type: NormalPointerType; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalP3uiv(&type: NormalPointerType; coords: IntPtr) :=
    z_NormalP3uiv_ovr_2(&type, coords);
    
    private static procedure z_ColorP3ui_ovr_0(&type: ColorPointerType; color: UInt32);
    external 'opengl32.dll' name 'glColorP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP3ui_ovr_0(&type, color);
    
    private static procedure z_ColorP3uiv_ovr_0(&type: ColorPointerType; var color: UInt32);
    external 'opengl32.dll' name 'glColorP3uiv';
    private static procedure z_ColorP3uiv_ovr_0_anh001(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glColorP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_ColorP3uiv_ovr_0(&type, color[0]) else
      z_ColorP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP3uiv_ovr_0(&type, color);
    private static procedure z_ColorP3uiv_ovr_2(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glColorP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP3uiv_ovr_2(&type, color);
    
    private static procedure z_ColorP4ui_ovr_0(&type: ColorPointerType; color: UInt32);
    external 'opengl32.dll' name 'glColorP4ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4ui(&type: ColorPointerType; color: UInt32) :=
    z_ColorP4ui_ovr_0(&type, color);
    
    private static procedure z_ColorP4uiv_ovr_0(&type: ColorPointerType; var color: UInt32);
    external 'opengl32.dll' name 'glColorP4uiv';
    private static procedure z_ColorP4uiv_ovr_0_anh001(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glColorP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_ColorP4uiv_ovr_0(&type, color[0]) else
      z_ColorP4uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; var color: UInt32) :=
    z_ColorP4uiv_ovr_0(&type, color);
    private static procedure z_ColorP4uiv_ovr_2(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glColorP4uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorP4uiv(&type: ColorPointerType; color: IntPtr) :=
    z_ColorP4uiv_ovr_2(&type, color);
    
    private static procedure z_SecondaryColorP3ui_ovr_0(&type: ColorPointerType; color: UInt32);
    external 'opengl32.dll' name 'glSecondaryColorP3ui';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3ui(&type: ColorPointerType; color: UInt32) :=
    z_SecondaryColorP3ui_ovr_0(&type, color);
    
    private static procedure z_SecondaryColorP3uiv_ovr_0(&type: ColorPointerType; var color: UInt32);
    external 'opengl32.dll' name 'glSecondaryColorP3uiv';
    private static procedure z_SecondaryColorP3uiv_ovr_0_anh001(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColorP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: array of UInt32) :=
    if (color<>nil) and (color.Length<>0) then
      z_SecondaryColorP3uiv_ovr_0(&type, color[0]) else
      z_SecondaryColorP3uiv_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; var color: UInt32) :=
    z_SecondaryColorP3uiv_ovr_0(&type, color);
    private static procedure z_SecondaryColorP3uiv_ovr_2(&type: ColorPointerType; color: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColorP3uiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorP3uiv(&type: ColorPointerType; color: IntPtr) :=
    z_SecondaryColorP3uiv_ovr_2(&type, color);
    
  end;
  
  glViewportArrayARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ViewportArrayv_ovr_0(first: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glViewportArrayv';
    private static procedure z_ViewportArrayv_ovr_0_anh0001(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glViewportArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportArrayv_ovr_0(first, count, v[0]) else
      z_ViewportArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; var v: single) :=
    z_ViewportArrayv_ovr_0(first, count, v);
    private static procedure z_ViewportArrayv_ovr_2(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glViewportArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ViewportArrayv_ovr_2(first, count, v);
    
    private static procedure z_ViewportIndexedf_ovr_0(index: UInt32; x: single; y: single; w: single; h: single);
    external 'opengl32.dll' name 'glViewportIndexedf';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedf(index: UInt32; x: single; y: single; w: single; h: single) :=
    z_ViewportIndexedf_ovr_0(index, x, y, w, h);
    
    private static procedure z_ViewportIndexedfv_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glViewportIndexedfv';
    private static procedure z_ViewportIndexedfv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glViewportIndexedfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ViewportIndexedfv_ovr_0(index, v[0]) else
      z_ViewportIndexedfv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; var v: single) :=
    z_ViewportIndexedfv_ovr_0(index, v);
    private static procedure z_ViewportIndexedfv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glViewportIndexedfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportIndexedfv(index: UInt32; v: IntPtr) :=
    z_ViewportIndexedfv_ovr_2(index, v);
    
    private static procedure z_ScissorArrayv_ovr_0(first: UInt32; count: Int32; var v: Int32);
    external 'opengl32.dll' name 'glScissorArrayv';
    private static procedure z_ScissorArrayv_ovr_0_anh0001(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorArrayv_ovr_0(first, count, v[0]) else
      z_ScissorArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorArrayv_ovr_0(first, count, v);
    private static procedure z_ScissorArrayv_ovr_2(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorArrayv_ovr_2(first, count, v);
    
    private static procedure z_ScissorIndexed_ovr_0(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glScissorIndexed';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexed(index: UInt32; left: Int32; bottom: Int32; width: Int32; height: Int32) :=
    z_ScissorIndexed_ovr_0(index, left, bottom, width, height);
    
    private static procedure z_ScissorIndexedv_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glScissorIndexedv';
    private static procedure z_ScissorIndexedv_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorIndexedv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorIndexedv_ovr_0(index, v[0]) else
      z_ScissorIndexedv_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; var v: Int32) :=
    z_ScissorIndexedv_ovr_0(index, v);
    private static procedure z_ScissorIndexedv_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorIndexedv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorIndexedv(index: UInt32; v: IntPtr) :=
    z_ScissorIndexedv_ovr_2(index, v);
    
    private static procedure z_DepthRangeArrayv_ovr_0(first: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glDepthRangeArrayv';
    private static procedure z_DepthRangeArrayv_ovr_0_anh0001(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glDepthRangeArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArrayv_ovr_0(first, count, v[0]) else
      z_DepthRangeArrayv_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArrayv_ovr_0(first, count, v);
    private static procedure z_DepthRangeArrayv_ovr_2(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glDepthRangeArrayv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArrayv(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArrayv_ovr_2(first, count, v);
    
    private static procedure z_DepthRangeIndexed_ovr_0(index: UInt32; n: real; f: real);
    external 'opengl32.dll' name 'glDepthRangeIndexed';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexed(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexed_ovr_0(index, n, f);
    
    private static procedure z_GetFloati_v_ovr_0(target: DummyEnum; index: UInt32; var data: single);
    external 'opengl32.dll' name 'glGetFloati_v';
    private static procedure z_GetFloati_v_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloati_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloati_v_ovr_0(target, index, data[0]) else
      z_GetFloati_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; var data: single) :=
    z_GetFloati_v_ovr_0(target, index, data);
    private static procedure z_GetFloati_v_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloati_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetFloati_v_ovr_2(target, index, data);
    
    private static procedure z_GetDoublei_v_ovr_0(target: DummyEnum; index: UInt32; var data: real);
    external 'opengl32.dll' name 'glGetDoublei_v';
    private static procedure z_GetDoublei_v_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoublei_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoublei_v_ovr_0(target, index, data[0]) else
      z_GetDoublei_v_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; var data: real) :=
    z_GetDoublei_v_ovr_0(target, index, data);
    private static procedure z_GetDoublei_v_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoublei_v';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_v(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetDoublei_v_ovr_2(target, index, data);
    
    private static procedure z_DepthRangeArraydvNV_ovr_0(first: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glDepthRangeArraydvNV';
    private static procedure z_DepthRangeArraydvNV_ovr_0_anh0001(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glDepthRangeArraydvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_DepthRangeArraydvNV_ovr_0(first, count, v[0]) else
      z_DepthRangeArraydvNV_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; var v: real) :=
    z_DepthRangeArraydvNV_ovr_0(first, count, v);
    private static procedure z_DepthRangeArraydvNV_ovr_2(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glDepthRangeArraydvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeArraydvNV(first: UInt32; count: Int32; v: IntPtr) :=
    z_DepthRangeArraydvNV_ovr_2(first, count, v);
    
    private static procedure z_DepthRangeIndexeddNV_ovr_0(index: UInt32; n: real; f: real);
    external 'opengl32.dll' name 'glDepthRangeIndexeddNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangeIndexeddNV(index: UInt32; n: real; f: real) :=
    z_DepthRangeIndexeddNV_ovr_0(index, n, f);
    
  end;
  
  glWindowPosARB = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_WindowPos2dARB_ovr_0(x: real; y: real);
    external 'opengl32.dll' name 'glWindowPos2dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dARB(x: real; y: real) :=
    z_WindowPos2dARB_ovr_0(x, y);
    
    private static procedure z_WindowPos2dvARB_ovr_0(var v: real);
    external 'opengl32.dll' name 'glWindowPos2dvARB';
    private static procedure z_WindowPos2dvARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dvARB_ovr_0(v[0]) else
      z_WindowPos2dvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(var v: real) :=
    z_WindowPos2dvARB_ovr_0(v);
    private static procedure z_WindowPos2dvARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvARB(v: IntPtr) :=
    z_WindowPos2dvARB_ovr_2(v);
    
    private static procedure z_WindowPos2fARB_ovr_0(x: single; y: single);
    external 'opengl32.dll' name 'glWindowPos2fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fARB(x: single; y: single) :=
    z_WindowPos2fARB_ovr_0(x, y);
    
    private static procedure z_WindowPos2fvARB_ovr_0(var v: single);
    external 'opengl32.dll' name 'glWindowPos2fvARB';
    private static procedure z_WindowPos2fvARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fvARB_ovr_0(v[0]) else
      z_WindowPos2fvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(var v: single) :=
    z_WindowPos2fvARB_ovr_0(v);
    private static procedure z_WindowPos2fvARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvARB(v: IntPtr) :=
    z_WindowPos2fvARB_ovr_2(v);
    
    private static procedure z_WindowPos2iARB_ovr_0(x: Int32; y: Int32);
    external 'opengl32.dll' name 'glWindowPos2iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iARB(x: Int32; y: Int32) :=
    z_WindowPos2iARB_ovr_0(x, y);
    
    private static procedure z_WindowPos2ivARB_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glWindowPos2ivARB';
    private static procedure z_WindowPos2ivARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2ivARB_ovr_0(v[0]) else
      z_WindowPos2ivARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(var v: Int32) :=
    z_WindowPos2ivARB_ovr_0(v);
    private static procedure z_WindowPos2ivARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivARB(v: IntPtr) :=
    z_WindowPos2ivARB_ovr_2(v);
    
    private static procedure z_WindowPos2sARB_ovr_0(x: Int16; y: Int16);
    external 'opengl32.dll' name 'glWindowPos2sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sARB(x: Int16; y: Int16) :=
    z_WindowPos2sARB_ovr_0(x, y);
    
    private static procedure z_WindowPos2svARB_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glWindowPos2svARB';
    private static procedure z_WindowPos2svARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2svARB_ovr_0(v[0]) else
      z_WindowPos2svARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(var v: Int16) :=
    z_WindowPos2svARB_ovr_0(v);
    private static procedure z_WindowPos2svARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svARB(v: IntPtr) :=
    z_WindowPos2svARB_ovr_2(v);
    
    private static procedure z_WindowPos3dARB_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glWindowPos3dARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dARB(x: real; y: real; z: real) :=
    z_WindowPos3dARB_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3dvARB_ovr_0(var v: real);
    external 'opengl32.dll' name 'glWindowPos3dvARB';
    private static procedure z_WindowPos3dvARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dvARB_ovr_0(v[0]) else
      z_WindowPos3dvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(var v: real) :=
    z_WindowPos3dvARB_ovr_0(v);
    private static procedure z_WindowPos3dvARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3dvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvARB(v: IntPtr) :=
    z_WindowPos3dvARB_ovr_2(v);
    
    private static procedure z_WindowPos3fARB_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glWindowPos3fARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fARB(x: single; y: single; z: single) :=
    z_WindowPos3fARB_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3fvARB_ovr_0(var v: single);
    external 'opengl32.dll' name 'glWindowPos3fvARB';
    private static procedure z_WindowPos3fvARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fvARB_ovr_0(v[0]) else
      z_WindowPos3fvARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(var v: single) :=
    z_WindowPos3fvARB_ovr_0(v);
    private static procedure z_WindowPos3fvARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3fvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvARB(v: IntPtr) :=
    z_WindowPos3fvARB_ovr_2(v);
    
    private static procedure z_WindowPos3iARB_ovr_0(x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glWindowPos3iARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iARB(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3iARB_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3ivARB_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glWindowPos3ivARB';
    private static procedure z_WindowPos3ivARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3ivARB_ovr_0(v[0]) else
      z_WindowPos3ivARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(var v: Int32) :=
    z_WindowPos3ivARB_ovr_0(v);
    private static procedure z_WindowPos3ivARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3ivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivARB(v: IntPtr) :=
    z_WindowPos3ivARB_ovr_2(v);
    
    private static procedure z_WindowPos3sARB_ovr_0(x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glWindowPos3sARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sARB(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3sARB_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3svARB_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glWindowPos3svARB';
    private static procedure z_WindowPos3svARB_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3svARB_ovr_0(v[0]) else
      z_WindowPos3svARB_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(var v: Int16) :=
    z_WindowPos3svARB_ovr_0(v);
    private static procedure z_WindowPos3svARB_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3svARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svARB(v: IntPtr) :=
    z_WindowPos3svARB_ovr_2(v);
    
  end;
  
  glDrawBuffersATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawBuffersATI_ovr_0(n: Int32; var bufs: DrawBufferMode);
    external 'opengl32.dll' name 'glDrawBuffersATI';
    private static procedure z_DrawBuffersATI_ovr_0_anh001(n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glDrawBuffersATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_DrawBuffersATI_ovr_0(n, bufs[0]) else
      z_DrawBuffersATI_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; var bufs: DrawBufferMode) :=
    z_DrawBuffersATI_ovr_0(n, bufs);
    private static procedure z_DrawBuffersATI_ovr_2(n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glDrawBuffersATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawBuffersATI(n: Int32; bufs: IntPtr) :=
    z_DrawBuffersATI_ovr_2(n, bufs);
    
  end;
  
  glElementArrayATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ElementPointerATI_ovr_0(&type: ElementPointerTypeATI; pointer: IntPtr);
    external 'opengl32.dll' name 'glElementPointerATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ElementPointerATI(&type: ElementPointerTypeATI; pointer: IntPtr) :=
    z_ElementPointerATI_ovr_0(&type, pointer);
    
    private static procedure z_DrawElementArrayATI_ovr_0(mode: PrimitiveType; count: Int32);
    external 'opengl32.dll' name 'glDrawElementArrayATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementArrayATI(mode: PrimitiveType; count: Int32) :=
    z_DrawElementArrayATI_ovr_0(mode, count);
    
    private static procedure z_DrawRangeElementArrayATI_ovr_0(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32);
    external 'opengl32.dll' name 'glDrawRangeElementArrayATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementArrayATI(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32) :=
    z_DrawRangeElementArrayATI_ovr_0(mode, start, &end, count);
    
  end;
  
  glEnvmapBumpmapATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexBumpParameterivATI_ovr_0(pname: DummyEnum; var param: Int32);
    external 'opengl32.dll' name 'glTexBumpParameterivATI';
    private static procedure z_TexBumpParameterivATI_ovr_0_anh001(pname: DummyEnum; param: IntPtr);
    external 'opengl32.dll' name 'glTexBumpParameterivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: DummyEnum; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_TexBumpParameterivATI_ovr_0(pname, param[0]) else
      z_TexBumpParameterivATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: DummyEnum; var param: Int32) :=
    z_TexBumpParameterivATI_ovr_0(pname, param);
    private static procedure z_TexBumpParameterivATI_ovr_2(pname: DummyEnum; param: IntPtr);
    external 'opengl32.dll' name 'glTexBumpParameterivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterivATI(pname: DummyEnum; param: IntPtr) :=
    z_TexBumpParameterivATI_ovr_2(pname, param);
    
    private static procedure z_TexBumpParameterfvATI_ovr_0(pname: DummyEnum; var param: single);
    external 'opengl32.dll' name 'glTexBumpParameterfvATI';
    private static procedure z_TexBumpParameterfvATI_ovr_0_anh001(pname: DummyEnum; param: IntPtr);
    external 'opengl32.dll' name 'glTexBumpParameterfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: DummyEnum; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_TexBumpParameterfvATI_ovr_0(pname, param[0]) else
      z_TexBumpParameterfvATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: DummyEnum; var param: single) :=
    z_TexBumpParameterfvATI_ovr_0(pname, param);
    private static procedure z_TexBumpParameterfvATI_ovr_2(pname: DummyEnum; param: IntPtr);
    external 'opengl32.dll' name 'glTexBumpParameterfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBumpParameterfvATI(pname: DummyEnum; param: IntPtr) :=
    z_TexBumpParameterfvATI_ovr_2(pname, param);
    
    private static procedure z_GetTexBumpParameterivATI_ovr_0(pname: GetTexBumpParameterATI; var param: Int32);
    external 'opengl32.dll' name 'glGetTexBumpParameterivATI';
    private static procedure z_GetTexBumpParameterivATI_ovr_0_anh001(pname: GetTexBumpParameterATI; param: IntPtr);
    external 'opengl32.dll' name 'glGetTexBumpParameterivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTexBumpParameterivATI_ovr_0(pname, param[0]) else
      z_GetTexBumpParameterivATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; var param: Int32) :=
    z_GetTexBumpParameterivATI_ovr_0(pname, param);
    private static procedure z_GetTexBumpParameterivATI_ovr_2(pname: GetTexBumpParameterATI; param: IntPtr);
    external 'opengl32.dll' name 'glGetTexBumpParameterivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterivATI(pname: GetTexBumpParameterATI; param: IntPtr) :=
    z_GetTexBumpParameterivATI_ovr_2(pname, param);
    
    private static procedure z_GetTexBumpParameterfvATI_ovr_0(pname: GetTexBumpParameterATI; var param: single);
    external 'opengl32.dll' name 'glGetTexBumpParameterfvATI';
    private static procedure z_GetTexBumpParameterfvATI_ovr_0_anh001(pname: GetTexBumpParameterATI; param: IntPtr);
    external 'opengl32.dll' name 'glGetTexBumpParameterfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; param: array of single) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetTexBumpParameterfvATI_ovr_0(pname, param[0]) else
      z_GetTexBumpParameterfvATI_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; var param: single) :=
    z_GetTexBumpParameterfvATI_ovr_0(pname, param);
    private static procedure z_GetTexBumpParameterfvATI_ovr_2(pname: GetTexBumpParameterATI; param: IntPtr);
    external 'opengl32.dll' name 'glGetTexBumpParameterfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexBumpParameterfvATI(pname: GetTexBumpParameterATI; param: IntPtr) :=
    z_GetTexBumpParameterfvATI_ovr_2(pname, param);
    
  end;
  
  glFragmentShaderATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GenFragmentShadersATI_ovr_0(range: UInt32): UInt32;
    external 'opengl32.dll' name 'glGenFragmentShadersATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenFragmentShadersATI(range: UInt32): UInt32 :=
    z_GenFragmentShadersATI_ovr_0(range);
    
    private static procedure z_BindFragmentShaderATI_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glBindFragmentShaderATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragmentShaderATI(id: UInt32) :=
    z_BindFragmentShaderATI_ovr_0(id);
    
    private static procedure z_DeleteFragmentShaderATI_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glDeleteFragmentShaderATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFragmentShaderATI(id: UInt32) :=
    z_DeleteFragmentShaderATI_ovr_0(id);
    
    private static procedure z_BeginFragmentShaderATI_ovr_0;
    external 'opengl32.dll' name 'glBeginFragmentShaderATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginFragmentShaderATI :=
    z_BeginFragmentShaderATI_ovr_0;
    
    private static procedure z_EndFragmentShaderATI_ovr_0;
    external 'opengl32.dll' name 'glEndFragmentShaderATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndFragmentShaderATI :=
    z_EndFragmentShaderATI_ovr_0;
    
    private static procedure z_PassTexCoordATI_ovr_0(dst: UInt32; coord: UInt32; swizzle: SwizzleOpATI);
    external 'opengl32.dll' name 'glPassTexCoordATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassTexCoordATI(dst: UInt32; coord: UInt32; swizzle: SwizzleOpATI) :=
    z_PassTexCoordATI_ovr_0(dst, coord, swizzle);
    
    private static procedure z_SampleMapATI_ovr_0(dst: UInt32; interp: UInt32; swizzle: SwizzleOpATI);
    external 'opengl32.dll' name 'glSampleMapATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMapATI(dst: UInt32; interp: UInt32; swizzle: SwizzleOpATI) :=
    z_SampleMapATI_ovr_0(dst, interp, swizzle);
    
    private static procedure z_ColorFragmentOp1ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32);
    external 'opengl32.dll' name 'glColorFragmentOp1ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp1ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32) :=
    z_ColorFragmentOp1ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod);
    
    private static procedure z_ColorFragmentOp2ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32);
    external 'opengl32.dll' name 'glColorFragmentOp2ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp2ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32) :=
    z_ColorFragmentOp2ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
    
    private static procedure z_ColorFragmentOp3ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32);
    external 'opengl32.dll' name 'glColorFragmentOp3ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFragmentOp3ATI(op: FragmentOpATI; dst: UInt32; dstMask: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32) :=
    z_ColorFragmentOp3ATI_ovr_0(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
    
    private static procedure z_AlphaFragmentOp1ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32);
    external 'opengl32.dll' name 'glAlphaFragmentOp1ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp1ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32) :=
    z_AlphaFragmentOp1ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod);
    
    private static procedure z_AlphaFragmentOp2ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32);
    external 'opengl32.dll' name 'glAlphaFragmentOp2ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp2ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32) :=
    z_AlphaFragmentOp2ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
    
    private static procedure z_AlphaFragmentOp3ATI_ovr_0(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32);
    external 'opengl32.dll' name 'glAlphaFragmentOp3ATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFragmentOp3ATI(op: FragmentOpATI; dst: UInt32; dstMod: UInt32; arg1: UInt32; arg1Rep: UInt32; arg1Mod: UInt32; arg2: UInt32; arg2Rep: UInt32; arg2Mod: UInt32; arg3: UInt32; arg3Rep: UInt32; arg3Mod: UInt32) :=
    z_AlphaFragmentOp3ATI_ovr_0(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
    
    private static procedure z_SetFragmentShaderConstantATI_ovr_0(dst: UInt32; var value: single);
    external 'opengl32.dll' name 'glSetFragmentShaderConstantATI';
    private static procedure z_SetFragmentShaderConstantATI_ovr_0_anh001(dst: UInt32; value: IntPtr);
    external 'opengl32.dll' name 'glSetFragmentShaderConstantATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_SetFragmentShaderConstantATI_ovr_0(dst, value[0]) else
      z_SetFragmentShaderConstantATI_ovr_0_anh001(dst, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; var value: single) :=
    z_SetFragmentShaderConstantATI_ovr_0(dst, value);
    private static procedure z_SetFragmentShaderConstantATI_ovr_2(dst: UInt32; value: IntPtr);
    external 'opengl32.dll' name 'glSetFragmentShaderConstantATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFragmentShaderConstantATI(dst: UInt32; value: IntPtr) :=
    z_SetFragmentShaderConstantATI_ovr_2(dst, value);
    
  end;
  
  glMapObjectBufferATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_MapObjectBufferATI_ovr_0(buffer: UInt32): IntPtr;
    external 'opengl32.dll' name 'glMapObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapObjectBufferATI(buffer: UInt32): IntPtr :=
    z_MapObjectBufferATI_ovr_0(buffer);
    
    private static procedure z_UnmapObjectBufferATI_ovr_0(buffer: UInt32);
    external 'opengl32.dll' name 'glUnmapObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnmapObjectBufferATI(buffer: UInt32) :=
    z_UnmapObjectBufferATI_ovr_0(buffer);
    
  end;
  
  glPnTrianglesATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PNTrianglesiATI_ovr_0(pname: PNTrianglesPNameATI; param: Int32);
    external 'opengl32.dll' name 'glPNTrianglesiATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PNTrianglesiATI(pname: PNTrianglesPNameATI; param: Int32) :=
    z_PNTrianglesiATI_ovr_0(pname, param);
    
    private static procedure z_PNTrianglesfATI_ovr_0(pname: PNTrianglesPNameATI; param: single);
    external 'opengl32.dll' name 'glPNTrianglesfATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PNTrianglesfATI(pname: PNTrianglesPNameATI; param: single) :=
    z_PNTrianglesfATI_ovr_0(pname, param);
    
  end;
  
  glSeparateStencilATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_StencilOpSeparateATI_ovr_0(face: StencilFaceDirection; sfail: StencilOp; dpfail: StencilOp; dppass: StencilOp);
    external 'opengl32.dll' name 'glStencilOpSeparateATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilOpSeparateATI(face: StencilFaceDirection; sfail: StencilOp; dpfail: StencilOp; dppass: StencilOp) :=
    z_StencilOpSeparateATI_ovr_0(face, sfail, dpfail, dppass);
    
    private static procedure z_StencilFuncSeparateATI_ovr_0(frontfunc: StencilFunction; backfunc: StencilFunction; ref: Int32; mask: UInt32);
    external 'opengl32.dll' name 'glStencilFuncSeparateATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFuncSeparateATI(frontfunc: StencilFunction; backfunc: StencilFunction; ref: Int32; mask: UInt32) :=
    z_StencilFuncSeparateATI_ovr_0(frontfunc, backfunc, ref, mask);
    
  end;
  
  glVertexArrayObjectATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_NewObjectBufferATI_ovr_0(size: Int32; pointer: IntPtr; usage: ArrayObjectUsageATI): UInt32;
    external 'opengl32.dll' name 'glNewObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function NewObjectBufferATI(size: Int32; pointer: IntPtr; usage: ArrayObjectUsageATI): UInt32 :=
    z_NewObjectBufferATI_ovr_0(size, pointer, usage);
    
    private static function z_IsObjectBufferATI_ovr_0(buffer: UInt32): boolean;
    external 'opengl32.dll' name 'glIsObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsObjectBufferATI(buffer: UInt32): boolean :=
    z_IsObjectBufferATI_ovr_0(buffer);
    
    private static procedure z_UpdateObjectBufferATI_ovr_0(buffer: UInt32; offset: UInt32; size: Int32; pointer: IntPtr; preserve: PreserveModeATI);
    external 'opengl32.dll' name 'glUpdateObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UpdateObjectBufferATI(buffer: UInt32; offset: UInt32; size: Int32; pointer: IntPtr; preserve: PreserveModeATI) :=
    z_UpdateObjectBufferATI_ovr_0(buffer, offset, size, pointer, preserve);
    
    private static procedure z_GetObjectBufferfvATI_ovr_0(buffer: UInt32; pname: ArrayObjectPNameATI; var &params: single);
    external 'opengl32.dll' name 'glGetObjectBufferfvATI';
    private static procedure z_GetObjectBufferfvATI_ovr_0_anh0001(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectBufferfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferfvATI(buffer: UInt32; pname: ArrayObjectPNameATI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectBufferfvATI_ovr_0(buffer, pname, &params[0]) else
      z_GetObjectBufferfvATI_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferfvATI(buffer: UInt32; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetObjectBufferfvATI_ovr_0(buffer, pname, &params);
    private static procedure z_GetObjectBufferfvATI_ovr_2(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectBufferfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferfvATI(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetObjectBufferfvATI_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetObjectBufferivATI_ovr_0(buffer: UInt32; pname: ArrayObjectPNameATI; var &params: Int32);
    external 'opengl32.dll' name 'glGetObjectBufferivATI';
    private static procedure z_GetObjectBufferivATI_ovr_0_anh0001(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectBufferivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferivATI(buffer: UInt32; pname: ArrayObjectPNameATI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetObjectBufferivATI_ovr_0(buffer, pname, &params[0]) else
      z_GetObjectBufferivATI_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferivATI(buffer: UInt32; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetObjectBufferivATI_ovr_0(buffer, pname, &params);
    private static procedure z_GetObjectBufferivATI_ovr_2(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetObjectBufferivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectBufferivATI(buffer: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetObjectBufferivATI_ovr_2(buffer, pname, &params);
    
    private static procedure z_FreeObjectBufferATI_ovr_0(buffer: UInt32);
    external 'opengl32.dll' name 'glFreeObjectBufferATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FreeObjectBufferATI(buffer: UInt32) :=
    z_FreeObjectBufferATI_ovr_0(buffer);
    
    private static procedure z_ArrayObjectATI_ovr_0(&array: EnableCap; size: Int32; &type: ScalarType; stride: Int32; buffer: UInt32; offset: UInt32);
    external 'opengl32.dll' name 'glArrayObjectATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayObjectATI(&array: EnableCap; size: Int32; &type: ScalarType; stride: Int32; buffer: UInt32; offset: UInt32) :=
    z_ArrayObjectATI_ovr_0(&array, size, &type, stride, buffer, offset);
    
    private static procedure z_GetArrayObjectfvATI_ovr_0(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: single);
    external 'opengl32.dll' name 'glGetArrayObjectfvATI';
    private static procedure z_GetArrayObjectfvATI_ovr_0_anh0001(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectfvATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetArrayObjectfvATI_ovr_0(&array, pname, &params[0]) else
      z_GetArrayObjectfvATI_ovr_0_anh0001(&array, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectfvATI(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetArrayObjectfvATI_ovr_0(&array, pname, &params);
    private static procedure z_GetArrayObjectfvATI_ovr_2(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectfvATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetArrayObjectfvATI_ovr_2(&array, pname, &params);
    
    private static procedure z_GetArrayObjectivATI_ovr_0(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: Int32);
    external 'opengl32.dll' name 'glGetArrayObjectivATI';
    private static procedure z_GetArrayObjectivATI_ovr_0_anh0001(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectivATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetArrayObjectivATI_ovr_0(&array, pname, &params[0]) else
      z_GetArrayObjectivATI_ovr_0_anh0001(&array, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectivATI(&array: EnableCap; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetArrayObjectivATI_ovr_0(&array, pname, &params);
    private static procedure z_GetArrayObjectivATI_ovr_2(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetArrayObjectivATI(&array: EnableCap; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetArrayObjectivATI_ovr_2(&array, pname, &params);
    
    private static procedure z_VariantArrayObjectATI_ovr_0(id: UInt32; &type: ScalarType; stride: Int32; buffer: UInt32; offset: UInt32);
    external 'opengl32.dll' name 'glVariantArrayObjectATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantArrayObjectATI(id: UInt32; &type: ScalarType; stride: Int32; buffer: UInt32; offset: UInt32) :=
    z_VariantArrayObjectATI_ovr_0(id, &type, stride, buffer, offset);
    
    private static procedure z_GetVariantArrayObjectfvATI_ovr_0(id: UInt32; pname: ArrayObjectPNameATI; var &params: single);
    external 'opengl32.dll' name 'glGetVariantArrayObjectfvATI';
    private static procedure z_GetVariantArrayObjectfvATI_ovr_0_anh0001(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVariantArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectfvATI(id: UInt32; pname: ArrayObjectPNameATI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVariantArrayObjectfvATI_ovr_0(id, pname, &params[0]) else
      z_GetVariantArrayObjectfvATI_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectfvATI(id: UInt32; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetVariantArrayObjectfvATI_ovr_0(id, pname, &params);
    private static procedure z_GetVariantArrayObjectfvATI_ovr_2(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVariantArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectfvATI(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVariantArrayObjectfvATI_ovr_2(id, pname, &params);
    
    private static procedure z_GetVariantArrayObjectivATI_ovr_0(id: UInt32; pname: ArrayObjectPNameATI; var &params: Int32);
    external 'opengl32.dll' name 'glGetVariantArrayObjectivATI';
    private static procedure z_GetVariantArrayObjectivATI_ovr_0_anh0001(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVariantArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectivATI(id: UInt32; pname: ArrayObjectPNameATI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVariantArrayObjectivATI_ovr_0(id, pname, &params[0]) else
      z_GetVariantArrayObjectivATI_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectivATI(id: UInt32; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetVariantArrayObjectivATI_ovr_0(id, pname, &params);
    private static procedure z_GetVariantArrayObjectivATI_ovr_2(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVariantArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantArrayObjectivATI(id: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVariantArrayObjectivATI_ovr_2(id, pname, &params);
    
  end;
  
  glVertexAttribArrayObjectATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribArrayObjectATI_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; buffer: UInt32; offset: UInt32);
    external 'opengl32.dll' name 'glVertexAttribArrayObjectATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribArrayObjectATI(index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; buffer: UInt32; offset: UInt32) :=
    z_VertexAttribArrayObjectATI_ovr_0(index, size, &type, normalized, stride, buffer, offset);
    
    private static procedure z_GetVertexAttribArrayObjectfvATI_ovr_0(index: UInt32; pname: ArrayObjectPNameATI; var &params: single);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectfvATI';
    private static procedure z_GetVertexAttribArrayObjectfvATI_ovr_0_anh0001(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribArrayObjectfvATI_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribArrayObjectfvATI_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; var &params: single) :=
    z_GetVertexAttribArrayObjectfvATI_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribArrayObjectfvATI_ovr_2(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectfvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectfvATI(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVertexAttribArrayObjectfvATI_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribArrayObjectivATI_ovr_0(index: UInt32; pname: ArrayObjectPNameATI; var &params: Int32);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectivATI';
    private static procedure z_GetVertexAttribArrayObjectivATI_ovr_0_anh0001(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribArrayObjectivATI_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribArrayObjectivATI_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; var &params: Int32) :=
    z_GetVertexAttribArrayObjectivATI_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribArrayObjectivATI_ovr_2(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribArrayObjectivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribArrayObjectivATI(index: UInt32; pname: ArrayObjectPNameATI; &params: IntPtr) :=
    z_GetVertexAttribArrayObjectivATI_ovr_2(index, pname, &params);
    
  end;
  
  glVertexStreamsATI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexStream1sATI_ovr_0(stream: VertexStreamATI; x: Int16);
    external 'opengl32.dll' name 'glVertexStream1sATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1sATI(stream: VertexStreamATI; x: Int16) :=
    z_VertexStream1sATI_ovr_0(stream, x);
    
    private static procedure z_VertexStream1svATI_ovr_0(stream: VertexStreamATI; var coords: Int16);
    external 'opengl32.dll' name 'glVertexStream1svATI';
    private static procedure z_VertexStream1svATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream1svATI_ovr_0(stream, coords[0]) else
      z_VertexStream1svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream1svATI_ovr_0(stream, coords);
    private static procedure z_VertexStream1svATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1svATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream1iATI_ovr_0(stream: VertexStreamATI; x: Int32);
    external 'opengl32.dll' name 'glVertexStream1iATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1iATI(stream: VertexStreamATI; x: Int32) :=
    z_VertexStream1iATI_ovr_0(stream, x);
    
    private static procedure z_VertexStream1ivATI_ovr_0(stream: VertexStreamATI; var coords: Int32);
    external 'opengl32.dll' name 'glVertexStream1ivATI';
    private static procedure z_VertexStream1ivATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream1ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream1ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream1ivATI_ovr_0(stream, coords);
    private static procedure z_VertexStream1ivATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1ivATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream1fATI_ovr_0(stream: VertexStreamATI; x: single);
    external 'opengl32.dll' name 'glVertexStream1fATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fATI(stream: VertexStreamATI; x: single) :=
    z_VertexStream1fATI_ovr_0(stream, x);
    
    private static procedure z_VertexStream1fvATI_ovr_0(stream: VertexStreamATI; var coords: single);
    external 'opengl32.dll' name 'glVertexStream1fvATI';
    private static procedure z_VertexStream1fvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream1fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream1fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream1fvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream1fvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1fvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream1dATI_ovr_0(stream: VertexStreamATI; x: real);
    external 'opengl32.dll' name 'glVertexStream1dATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dATI(stream: VertexStreamATI; x: real) :=
    z_VertexStream1dATI_ovr_0(stream, x);
    
    private static procedure z_VertexStream1dvATI_ovr_0(stream: VertexStreamATI; var coords: real);
    external 'opengl32.dll' name 'glVertexStream1dvATI';
    private static procedure z_VertexStream1dvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream1dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream1dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream1dvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream1dvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream1dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream1dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream1dvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream2sATI_ovr_0(stream: VertexStreamATI; x: Int16; y: Int16);
    external 'opengl32.dll' name 'glVertexStream2sATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2sATI(stream: VertexStreamATI; x: Int16; y: Int16) :=
    z_VertexStream2sATI_ovr_0(stream, x, y);
    
    private static procedure z_VertexStream2svATI_ovr_0(stream: VertexStreamATI; var coords: Int16);
    external 'opengl32.dll' name 'glVertexStream2svATI';
    private static procedure z_VertexStream2svATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2svATI_ovr_0(stream, coords[0]) else
      z_VertexStream2svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream2svATI_ovr_0(stream, coords);
    private static procedure z_VertexStream2svATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2svATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream2iATI_ovr_0(stream: VertexStreamATI; x: Int32; y: Int32);
    external 'opengl32.dll' name 'glVertexStream2iATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2iATI(stream: VertexStreamATI; x: Int32; y: Int32) :=
    z_VertexStream2iATI_ovr_0(stream, x, y);
    
    private static procedure z_VertexStream2ivATI_ovr_0(stream: VertexStreamATI; var coords: Int32);
    external 'opengl32.dll' name 'glVertexStream2ivATI';
    private static procedure z_VertexStream2ivATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream2ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream2ivATI_ovr_0(stream, coords);
    private static procedure z_VertexStream2ivATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2ivATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream2fATI_ovr_0(stream: VertexStreamATI; x: single; y: single);
    external 'opengl32.dll' name 'glVertexStream2fATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fATI(stream: VertexStreamATI; x: single; y: single) :=
    z_VertexStream2fATI_ovr_0(stream, x, y);
    
    private static procedure z_VertexStream2fvATI_ovr_0(stream: VertexStreamATI; var coords: single);
    external 'opengl32.dll' name 'glVertexStream2fvATI';
    private static procedure z_VertexStream2fvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream2fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream2fvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream2fvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2fvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream2dATI_ovr_0(stream: VertexStreamATI; x: real; y: real);
    external 'opengl32.dll' name 'glVertexStream2dATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dATI(stream: VertexStreamATI; x: real; y: real) :=
    z_VertexStream2dATI_ovr_0(stream, x, y);
    
    private static procedure z_VertexStream2dvATI_ovr_0(stream: VertexStreamATI; var coords: real);
    external 'opengl32.dll' name 'glVertexStream2dvATI';
    private static procedure z_VertexStream2dvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream2dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream2dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream2dvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream2dvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream2dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream2dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream2dvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream3sATI_ovr_0(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glVertexStream3sATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3sATI(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16) :=
    z_VertexStream3sATI_ovr_0(stream, x, y, z);
    
    private static procedure z_VertexStream3svATI_ovr_0(stream: VertexStreamATI; var coords: Int16);
    external 'opengl32.dll' name 'glVertexStream3svATI';
    private static procedure z_VertexStream3svATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3svATI_ovr_0(stream, coords[0]) else
      z_VertexStream3svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream3svATI_ovr_0(stream, coords);
    private static procedure z_VertexStream3svATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3svATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream3iATI_ovr_0(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glVertexStream3iATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3iATI(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32) :=
    z_VertexStream3iATI_ovr_0(stream, x, y, z);
    
    private static procedure z_VertexStream3ivATI_ovr_0(stream: VertexStreamATI; var coords: Int32);
    external 'opengl32.dll' name 'glVertexStream3ivATI';
    private static procedure z_VertexStream3ivATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream3ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream3ivATI_ovr_0(stream, coords);
    private static procedure z_VertexStream3ivATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3ivATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream3fATI_ovr_0(stream: VertexStreamATI; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glVertexStream3fATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fATI(stream: VertexStreamATI; x: single; y: single; z: single) :=
    z_VertexStream3fATI_ovr_0(stream, x, y, z);
    
    private static procedure z_VertexStream3fvATI_ovr_0(stream: VertexStreamATI; var coords: single);
    external 'opengl32.dll' name 'glVertexStream3fvATI';
    private static procedure z_VertexStream3fvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream3fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream3fvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream3fvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3fvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream3dATI_ovr_0(stream: VertexStreamATI; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexStream3dATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dATI(stream: VertexStreamATI; x: real; y: real; z: real) :=
    z_VertexStream3dATI_ovr_0(stream, x, y, z);
    
    private static procedure z_VertexStream3dvATI_ovr_0(stream: VertexStreamATI; var coords: real);
    external 'opengl32.dll' name 'glVertexStream3dvATI';
    private static procedure z_VertexStream3dvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream3dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream3dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream3dvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream3dvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream3dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream3dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream3dvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream4sATI_ovr_0(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glVertexStream4sATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4sATI(stream: VertexStreamATI; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexStream4sATI_ovr_0(stream, x, y, z, w);
    
    private static procedure z_VertexStream4svATI_ovr_0(stream: VertexStreamATI; var coords: Int16);
    external 'opengl32.dll' name 'glVertexStream4svATI';
    private static procedure z_VertexStream4svATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4svATI_ovr_0(stream, coords[0]) else
      z_VertexStream4svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_VertexStream4svATI_ovr_0(stream, coords);
    private static procedure z_VertexStream4svATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4svATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream4iATI_ovr_0(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glVertexStream4iATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4iATI(stream: VertexStreamATI; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexStream4iATI_ovr_0(stream, x, y, z, w);
    
    private static procedure z_VertexStream4ivATI_ovr_0(stream: VertexStreamATI; var coords: Int32);
    external 'opengl32.dll' name 'glVertexStream4ivATI';
    private static procedure z_VertexStream4ivATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4ivATI_ovr_0(stream, coords[0]) else
      z_VertexStream4ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_VertexStream4ivATI_ovr_0(stream, coords);
    private static procedure z_VertexStream4ivATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4ivATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream4fATI_ovr_0(stream: VertexStreamATI; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glVertexStream4fATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fATI(stream: VertexStreamATI; x: single; y: single; z: single; w: single) :=
    z_VertexStream4fATI_ovr_0(stream, x, y, z, w);
    
    private static procedure z_VertexStream4fvATI_ovr_0(stream: VertexStreamATI; var coords: single);
    external 'opengl32.dll' name 'glVertexStream4fvATI';
    private static procedure z_VertexStream4fvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4fvATI_ovr_0(stream, coords[0]) else
      z_VertexStream4fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; var coords: single) :=
    z_VertexStream4fvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream4fvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4fvATI_ovr_2(stream, coords);
    
    private static procedure z_VertexStream4dATI_ovr_0(stream: VertexStreamATI; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexStream4dATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dATI(stream: VertexStreamATI; x: real; y: real; z: real; w: real) :=
    z_VertexStream4dATI_ovr_0(stream, x, y, z, w);
    
    private static procedure z_VertexStream4dvATI_ovr_0(stream: VertexStreamATI; var coords: real);
    external 'opengl32.dll' name 'glVertexStream4dvATI';
    private static procedure z_VertexStream4dvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_VertexStream4dvATI_ovr_0(stream, coords[0]) else
      z_VertexStream4dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; var coords: real) :=
    z_VertexStream4dvATI_ovr_0(stream, coords);
    private static procedure z_VertexStream4dvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glVertexStream4dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexStream4dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_VertexStream4dvATI_ovr_2(stream, coords);
    
    private static procedure z_NormalStream3bATI_ovr_0(stream: VertexStreamATI; nx: SByte; ny: SByte; nz: SByte);
    external 'opengl32.dll' name 'glNormalStream3bATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bATI(stream: VertexStreamATI; nx: SByte; ny: SByte; nz: SByte) :=
    z_NormalStream3bATI_ovr_0(stream, nx, ny, nz);
    
    private static procedure z_NormalStream3bvATI_ovr_0(stream: VertexStreamATI; var coords: SByte);
    external 'opengl32.dll' name 'glNormalStream3bvATI';
    private static procedure z_NormalStream3bvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3bvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3bvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3bvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; var coords: SByte) :=
    z_NormalStream3bvATI_ovr_0(stream, coords);
    private static procedure z_NormalStream3bvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3bvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3bvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3bvATI_ovr_2(stream, coords);
    
    private static procedure z_NormalStream3sATI_ovr_0(stream: VertexStreamATI; nx: Int16; ny: Int16; nz: Int16);
    external 'opengl32.dll' name 'glNormalStream3sATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3sATI(stream: VertexStreamATI; nx: Int16; ny: Int16; nz: Int16) :=
    z_NormalStream3sATI_ovr_0(stream, nx, ny, nz);
    
    private static procedure z_NormalStream3svATI_ovr_0(stream: VertexStreamATI; var coords: Int16);
    external 'opengl32.dll' name 'glNormalStream3svATI';
    private static procedure z_NormalStream3svATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; coords: array of Int16) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3svATI_ovr_0(stream, coords[0]) else
      z_NormalStream3svATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; var coords: Int16) :=
    z_NormalStream3svATI_ovr_0(stream, coords);
    private static procedure z_NormalStream3svATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3svATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3svATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3svATI_ovr_2(stream, coords);
    
    private static procedure z_NormalStream3iATI_ovr_0(stream: VertexStreamATI; nx: Int32; ny: Int32; nz: Int32);
    external 'opengl32.dll' name 'glNormalStream3iATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3iATI(stream: VertexStreamATI; nx: Int32; ny: Int32; nz: Int32) :=
    z_NormalStream3iATI_ovr_0(stream, nx, ny, nz);
    
    private static procedure z_NormalStream3ivATI_ovr_0(stream: VertexStreamATI; var coords: Int32);
    external 'opengl32.dll' name 'glNormalStream3ivATI';
    private static procedure z_NormalStream3ivATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; coords: array of Int32) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3ivATI_ovr_0(stream, coords[0]) else
      z_NormalStream3ivATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; var coords: Int32) :=
    z_NormalStream3ivATI_ovr_0(stream, coords);
    private static procedure z_NormalStream3ivATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3ivATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3ivATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3ivATI_ovr_2(stream, coords);
    
    private static procedure z_NormalStream3fATI_ovr_0(stream: VertexStreamATI; nx: single; ny: single; nz: single);
    external 'opengl32.dll' name 'glNormalStream3fATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fATI(stream: VertexStreamATI; nx: single; ny: single; nz: single) :=
    z_NormalStream3fATI_ovr_0(stream, nx, ny, nz);
    
    private static procedure z_NormalStream3fvATI_ovr_0(stream: VertexStreamATI; var coords: single);
    external 'opengl32.dll' name 'glNormalStream3fvATI';
    private static procedure z_NormalStream3fvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3fvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3fvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; var coords: single) :=
    z_NormalStream3fvATI_ovr_0(stream, coords);
    private static procedure z_NormalStream3fvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3fvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3fvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3fvATI_ovr_2(stream, coords);
    
    private static procedure z_NormalStream3dATI_ovr_0(stream: VertexStreamATI; nx: real; ny: real; nz: real);
    external 'opengl32.dll' name 'glNormalStream3dATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dATI(stream: VertexStreamATI; nx: real; ny: real; nz: real) :=
    z_NormalStream3dATI_ovr_0(stream, nx, ny, nz);
    
    private static procedure z_NormalStream3dvATI_ovr_0(stream: VertexStreamATI; var coords: real);
    external 'opengl32.dll' name 'glNormalStream3dvATI';
    private static procedure z_NormalStream3dvATI_ovr_0_anh001(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; coords: array of real) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_NormalStream3dvATI_ovr_0(stream, coords[0]) else
      z_NormalStream3dvATI_ovr_0_anh001(stream, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; var coords: real) :=
    z_NormalStream3dvATI_ovr_0(stream, coords);
    private static procedure z_NormalStream3dvATI_ovr_2(stream: VertexStreamATI; coords: IntPtr);
    external 'opengl32.dll' name 'glNormalStream3dvATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalStream3dvATI(stream: VertexStreamATI; coords: IntPtr) :=
    z_NormalStream3dvATI_ovr_2(stream, coords);
    
    private static procedure z_ClientActiveVertexStreamATI_ovr_0(stream: VertexStreamATI);
    external 'opengl32.dll' name 'glClientActiveVertexStreamATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientActiveVertexStreamATI(stream: VertexStreamATI) :=
    z_ClientActiveVertexStreamATI_ovr_0(stream);
    
    private static procedure z_VertexBlendEnviATI_ovr_0(pname: VertexStreamATI; param: Int32);
    external 'opengl32.dll' name 'glVertexBlendEnviATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendEnviATI(pname: VertexStreamATI; param: Int32) :=
    z_VertexBlendEnviATI_ovr_0(pname, param);
    
    private static procedure z_VertexBlendEnvfATI_ovr_0(pname: VertexStreamATI; param: single);
    external 'opengl32.dll' name 'glVertexBlendEnvfATI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexBlendEnvfATI(pname: VertexStreamATI; param: single) :=
    z_VertexBlendEnvfATI_ovr_0(pname, param);
    
  end;
  
  glEGLImageStorageEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_EGLImageTargetTexStorageEXT_ovr_0(target: DummyEnum; image: GLeglImageOES; var attrib_list: Int32);
    external 'opengl32.dll' name 'glEGLImageTargetTexStorageEXT';
    private static procedure z_EGLImageTargetTexStorageEXT_ovr_0_anh0001(target: DummyEnum; image: GLeglImageOES; attrib_list: IntPtr);
    external 'opengl32.dll' name 'glEGLImageTargetTexStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: GLeglImageOES; attrib_list: array of Int32) :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_EGLImageTargetTexStorageEXT_ovr_0(target, image, attrib_list[0]) else
      z_EGLImageTargetTexStorageEXT_ovr_0_anh0001(target, image, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: GLeglImageOES; var attrib_list: Int32) :=
    z_EGLImageTargetTexStorageEXT_ovr_0(target, image, attrib_list);
    private static procedure z_EGLImageTargetTexStorageEXT_ovr_2(target: DummyEnum; image: GLeglImageOES; attrib_list: IntPtr);
    external 'opengl32.dll' name 'glEGLImageTargetTexStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTexStorageEXT(target: DummyEnum; image: GLeglImageOES; attrib_list: IntPtr) :=
    z_EGLImageTargetTexStorageEXT_ovr_2(target, image, attrib_list);
    
    private static procedure z_EGLImageTargetTextureStorageEXT_ovr_0(texture: UInt32; image: GLeglImageOES; var attrib_list: Int32);
    external 'opengl32.dll' name 'glEGLImageTargetTextureStorageEXT';
    private static procedure z_EGLImageTargetTextureStorageEXT_ovr_0_anh0001(texture: UInt32; image: GLeglImageOES; attrib_list: IntPtr);
    external 'opengl32.dll' name 'glEGLImageTargetTextureStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: UInt32; image: GLeglImageOES; attrib_list: array of Int32) :=
    if (attrib_list<>nil) and (attrib_list.Length<>0) then
      z_EGLImageTargetTextureStorageEXT_ovr_0(texture, image, attrib_list[0]) else
      z_EGLImageTargetTextureStorageEXT_ovr_0_anh0001(texture, image, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: UInt32; image: GLeglImageOES; var attrib_list: Int32) :=
    z_EGLImageTargetTextureStorageEXT_ovr_0(texture, image, attrib_list);
    private static procedure z_EGLImageTargetTextureStorageEXT_ovr_2(texture: UInt32; image: GLeglImageOES; attrib_list: IntPtr);
    external 'opengl32.dll' name 'glEGLImageTargetTextureStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EGLImageTargetTextureStorageEXT(texture: UInt32; image: GLeglImageOES; attrib_list: IntPtr) :=
    z_EGLImageTargetTextureStorageEXT_ovr_2(texture, image, attrib_list);
    
  end;
  
  glBindableUniformEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_UniformBufferEXT_ovr_0(&program: UInt32; location: Int32; buffer: UInt32);
    external 'opengl32.dll' name 'glUniformBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformBufferEXT(&program: UInt32; location: Int32; buffer: UInt32) :=
    z_UniformBufferEXT_ovr_0(&program, location, buffer);
    
    private static function z_GetUniformBufferSizeEXT_ovr_0(&program: UInt32; location: Int32): Int32;
    external 'opengl32.dll' name 'glGetUniformBufferSizeEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformBufferSizeEXT(&program: UInt32; location: Int32): Int32 :=
    z_GetUniformBufferSizeEXT_ovr_0(&program, location);
    
    private static function z_GetUniformOffsetEXT_ovr_0(&program: UInt32; location: Int32): IntPtr;
    external 'opengl32.dll' name 'glGetUniformOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetUniformOffsetEXT(&program: UInt32; location: Int32): IntPtr :=
    z_GetUniformOffsetEXT_ovr_0(&program, location);
    
  end;
  
  glBlendColorEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendColorEXT_ovr_0(red: single; green: single; blue: single; alpha: single);
    external 'opengl32.dll' name 'glBlendColorEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColorEXT(red: single; green: single; blue: single; alpha: single) :=
    z_BlendColorEXT_ovr_0(red, green, blue, alpha);
    
  end;
  
  glBlendEquationSeparateEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendEquationSeparateEXT_ovr_0(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationSeparateEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationSeparateEXT(modeRGB: BlendEquationModeEXT; modeAlpha: BlendEquationModeEXT) :=
    z_BlendEquationSeparateEXT_ovr_0(modeRGB, modeAlpha);
    
  end;
  
  glBlendFuncSeparateEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendFuncSeparateEXT_ovr_0(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFuncSeparateEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateEXT(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparateEXT_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
  end;
  
  glBlendMinmaxEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendEquationEXT_ovr_0(mode: BlendEquationModeEXT);
    external 'opengl32.dll' name 'glBlendEquationEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendEquationEXT(mode: BlendEquationModeEXT) :=
    z_BlendEquationEXT_ovr_0(mode);
    
  end;
  
  glColorSubtableEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ColorSubTableEXT_ovr_0(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glColorSubTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorSubTableEXT(target: ColorTableTarget; start: Int32; count: Int32; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ColorSubTableEXT_ovr_0(target, start, count, format, &type, data);
    
    private static procedure z_CopyColorSubTableEXT_ovr_0(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyColorSubTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorSubTableEXT(target: ColorTableTarget; start: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorSubTableEXT_ovr_0(target, start, x, y, width);
    
  end;
  
  glCompiledVertexArrayEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_LockArraysEXT_ovr_0(first: Int32; count: Int32);
    external 'opengl32.dll' name 'glLockArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LockArraysEXT(first: Int32; count: Int32) :=
    z_LockArraysEXT_ovr_0(first, count);
    
    private static procedure z_UnlockArraysEXT_ovr_0;
    external 'opengl32.dll' name 'glUnlockArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnlockArraysEXT :=
    z_UnlockArraysEXT_ovr_0;
    
  end;
  
  glConvolutionEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ConvolutionFilter1DEXT_ovr_0(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glConvolutionFilter1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter1DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter1DEXT_ovr_0(target, _internalformat, width, format, &type, image);
    
    private static procedure z_ConvolutionFilter2DEXT_ovr_0(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glConvolutionFilter2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionFilter2DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_ConvolutionFilter2DEXT_ovr_0(target, _internalformat, width, height, format, &type, image);
    
    private static procedure z_ConvolutionParameterfEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: single);
    external 'opengl32.dll' name 'glConvolutionParameterfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: single) :=
    z_ConvolutionParameterfEXT_ovr_0(target, pname, &params);
    
    private static procedure z_ConvolutionParameterfvEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single);
    external 'opengl32.dll' name 'glConvolutionParameterfvEXT';
    private static procedure z_ConvolutionParameterfvEXT_ovr_0_anh0001(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single) :=
    z_ConvolutionParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_ConvolutionParameterfvEXT_ovr_2(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterfvEXT_ovr_2(target, pname, &params);
    
    private static procedure z_ConvolutionParameteriEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: Int32);
    external 'opengl32.dll' name 'glConvolutionParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameteriEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: Int32) :=
    z_ConvolutionParameteriEXT_ovr_0(target, pname, &params);
    
    private static procedure z_ConvolutionParameterivEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32);
    external 'opengl32.dll' name 'glConvolutionParameterivEXT';
    private static procedure z_ConvolutionParameterivEXT_ovr_0_anh0001(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_ConvolutionParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_ConvolutionParameterivEXT_ovr_2(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_CopyConvolutionFilter1DEXT_ovr_0(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyConvolutionFilter1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter1DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyConvolutionFilter1DEXT_ovr_0(target, _internalformat, x, y, width);
    
    private static procedure z_CopyConvolutionFilter2DEXT_ovr_0(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyConvolutionFilter2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyConvolutionFilter2DEXT(target: ConvolutionTargetEXT; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyConvolutionFilter2DEXT_ovr_0(target, _internalformat, x, y, width, height);
    
    private static procedure z_GetConvolutionFilterEXT_ovr_0(target: ConvolutionTargetEXT; format: PixelFormat; &type: PixelType; image: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionFilterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionFilterEXT(target: ConvolutionTargetEXT; format: PixelFormat; &type: PixelType; image: IntPtr) :=
    z_GetConvolutionFilterEXT_ovr_0(target, format, &type, image);
    
    private static procedure z_GetConvolutionParameterfvEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single);
    external 'opengl32.dll' name 'glGetConvolutionParameterfvEXT';
    private static procedure z_GetConvolutionParameterfvEXT_ovr_0_anh0001(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: single) :=
    z_GetConvolutionParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_GetConvolutionParameterfvEXT_ovr_2(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterfvEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterfvEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetConvolutionParameterivEXT_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetConvolutionParameterivEXT';
    private static procedure z_GetConvolutionParameterivEXT_ovr_0_anh0001(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Int32) :=
    z_GetConvolutionParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetConvolutionParameterivEXT_ovr_2(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterivEXT(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_GetConvolutionParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetSeparableFilterEXT_ovr_0(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr);
    external 'opengl32.dll' name 'glGetSeparableFilterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSeparableFilterEXT(target: SeparableTargetEXT; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr; span: IntPtr) :=
    z_GetSeparableFilterEXT_ovr_0(target, format, &type, row, column, span);
    
    private static procedure z_SeparableFilter2DEXT_ovr_0(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr);
    external 'opengl32.dll' name 'glSeparableFilter2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SeparableFilter2DEXT(target: SeparableTargetEXT; _internalformat: InternalFormat; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; row: IntPtr; column: IntPtr) :=
    z_SeparableFilter2DEXT_ovr_0(target, _internalformat, width, height, format, &type, row, column);
    
  end;
  
  glCoordinateFrameEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Tangent3bEXT_ovr_0(tx: SByte; ty: SByte; tz: SByte);
    external 'opengl32.dll' name 'glTangent3bEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bEXT(tx: SByte; ty: SByte; tz: SByte) :=
    z_Tangent3bEXT_ovr_0(tx, ty, tz);
    
    private static procedure z_Tangent3bvEXT_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glTangent3bvEXT';
    private static procedure z_Tangent3bvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3bvEXT_ovr_0(v[0]) else
      z_Tangent3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(var v: SByte) :=
    z_Tangent3bvEXT_ovr_0(v);
    private static procedure z_Tangent3bvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3bvEXT(v: IntPtr) :=
    z_Tangent3bvEXT_ovr_2(v);
    
    private static procedure z_Tangent3dEXT_ovr_0(tx: real; ty: real; tz: real);
    external 'opengl32.dll' name 'glTangent3dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dEXT(tx: real; ty: real; tz: real) :=
    z_Tangent3dEXT_ovr_0(tx, ty, tz);
    
    private static procedure z_Tangent3dvEXT_ovr_0(var v: real);
    external 'opengl32.dll' name 'glTangent3dvEXT';
    private static procedure z_Tangent3dvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3dvEXT_ovr_0(v[0]) else
      z_Tangent3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(var v: real) :=
    z_Tangent3dvEXT_ovr_0(v);
    private static procedure z_Tangent3dvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3dvEXT(v: IntPtr) :=
    z_Tangent3dvEXT_ovr_2(v);
    
    private static procedure z_Tangent3fEXT_ovr_0(tx: single; ty: single; tz: single);
    external 'opengl32.dll' name 'glTangent3fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fEXT(tx: single; ty: single; tz: single) :=
    z_Tangent3fEXT_ovr_0(tx, ty, tz);
    
    private static procedure z_Tangent3fvEXT_ovr_0(var v: single);
    external 'opengl32.dll' name 'glTangent3fvEXT';
    private static procedure z_Tangent3fvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3fvEXT_ovr_0(v[0]) else
      z_Tangent3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(var v: single) :=
    z_Tangent3fvEXT_ovr_0(v);
    private static procedure z_Tangent3fvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3fvEXT(v: IntPtr) :=
    z_Tangent3fvEXT_ovr_2(v);
    
    private static procedure z_Tangent3iEXT_ovr_0(tx: Int32; ty: Int32; tz: Int32);
    external 'opengl32.dll' name 'glTangent3iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3iEXT(tx: Int32; ty: Int32; tz: Int32) :=
    z_Tangent3iEXT_ovr_0(tx, ty, tz);
    
    private static procedure z_Tangent3ivEXT_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glTangent3ivEXT';
    private static procedure z_Tangent3ivEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3ivEXT_ovr_0(v[0]) else
      z_Tangent3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(var v: Int32) :=
    z_Tangent3ivEXT_ovr_0(v);
    private static procedure z_Tangent3ivEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3ivEXT(v: IntPtr) :=
    z_Tangent3ivEXT_ovr_2(v);
    
    private static procedure z_Tangent3sEXT_ovr_0(tx: Int16; ty: Int16; tz: Int16);
    external 'opengl32.dll' name 'glTangent3sEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3sEXT(tx: Int16; ty: Int16; tz: Int16) :=
    z_Tangent3sEXT_ovr_0(tx, ty, tz);
    
    private static procedure z_Tangent3svEXT_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glTangent3svEXT';
    private static procedure z_Tangent3svEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Tangent3svEXT_ovr_0(v[0]) else
      z_Tangent3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(var v: Int16) :=
    z_Tangent3svEXT_ovr_0(v);
    private static procedure z_Tangent3svEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTangent3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Tangent3svEXT(v: IntPtr) :=
    z_Tangent3svEXT_ovr_2(v);
    
    private static procedure z_Binormal3bEXT_ovr_0(bx: SByte; by: SByte; bz: SByte);
    external 'opengl32.dll' name 'glBinormal3bEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bEXT(bx: SByte; by: SByte; bz: SByte) :=
    z_Binormal3bEXT_ovr_0(bx, by, bz);
    
    private static procedure z_Binormal3bvEXT_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glBinormal3bvEXT';
    private static procedure z_Binormal3bvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3bvEXT_ovr_0(v[0]) else
      z_Binormal3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(var v: SByte) :=
    z_Binormal3bvEXT_ovr_0(v);
    private static procedure z_Binormal3bvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3bvEXT(v: IntPtr) :=
    z_Binormal3bvEXT_ovr_2(v);
    
    private static procedure z_Binormal3dEXT_ovr_0(bx: real; by: real; bz: real);
    external 'opengl32.dll' name 'glBinormal3dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dEXT(bx: real; by: real; bz: real) :=
    z_Binormal3dEXT_ovr_0(bx, by, bz);
    
    private static procedure z_Binormal3dvEXT_ovr_0(var v: real);
    external 'opengl32.dll' name 'glBinormal3dvEXT';
    private static procedure z_Binormal3dvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3dvEXT_ovr_0(v[0]) else
      z_Binormal3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(var v: real) :=
    z_Binormal3dvEXT_ovr_0(v);
    private static procedure z_Binormal3dvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3dvEXT(v: IntPtr) :=
    z_Binormal3dvEXT_ovr_2(v);
    
    private static procedure z_Binormal3fEXT_ovr_0(bx: single; by: single; bz: single);
    external 'opengl32.dll' name 'glBinormal3fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fEXT(bx: single; by: single; bz: single) :=
    z_Binormal3fEXT_ovr_0(bx, by, bz);
    
    private static procedure z_Binormal3fvEXT_ovr_0(var v: single);
    external 'opengl32.dll' name 'glBinormal3fvEXT';
    private static procedure z_Binormal3fvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3fvEXT_ovr_0(v[0]) else
      z_Binormal3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(var v: single) :=
    z_Binormal3fvEXT_ovr_0(v);
    private static procedure z_Binormal3fvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3fvEXT(v: IntPtr) :=
    z_Binormal3fvEXT_ovr_2(v);
    
    private static procedure z_Binormal3iEXT_ovr_0(bx: Int32; by: Int32; bz: Int32);
    external 'opengl32.dll' name 'glBinormal3iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3iEXT(bx: Int32; by: Int32; bz: Int32) :=
    z_Binormal3iEXT_ovr_0(bx, by, bz);
    
    private static procedure z_Binormal3ivEXT_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glBinormal3ivEXT';
    private static procedure z_Binormal3ivEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3ivEXT_ovr_0(v[0]) else
      z_Binormal3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(var v: Int32) :=
    z_Binormal3ivEXT_ovr_0(v);
    private static procedure z_Binormal3ivEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3ivEXT(v: IntPtr) :=
    z_Binormal3ivEXT_ovr_2(v);
    
    private static procedure z_Binormal3sEXT_ovr_0(bx: Int16; by: Int16; bz: Int16);
    external 'opengl32.dll' name 'glBinormal3sEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3sEXT(bx: Int16; by: Int16; bz: Int16) :=
    z_Binormal3sEXT_ovr_0(bx, by, bz);
    
    private static procedure z_Binormal3svEXT_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glBinormal3svEXT';
    private static procedure z_Binormal3svEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_Binormal3svEXT_ovr_0(v[0]) else
      z_Binormal3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(var v: Int16) :=
    z_Binormal3svEXT_ovr_0(v);
    private static procedure z_Binormal3svEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glBinormal3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Binormal3svEXT(v: IntPtr) :=
    z_Binormal3svEXT_ovr_2(v);
    
    private static procedure z_TangentPointerEXT_ovr_0(&type: TangentPointerTypeEXT; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glTangentPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TangentPointerEXT(&type: TangentPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_TangentPointerEXT_ovr_0(&type, stride, pointer);
    
    private static procedure z_BinormalPointerEXT_ovr_0(&type: BinormalPointerTypeEXT; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glBinormalPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BinormalPointerEXT(&type: BinormalPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_BinormalPointerEXT_ovr_0(&type, stride, pointer);
    
  end;
  
  glCopyTextureEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CopyTexImage1DEXT_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTexImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage1DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTexImage1DEXT_ovr_0(target, level, _internalformat, x, y, width, border);
    
    private static procedure z_CopyTexImage2DEXT_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTexImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexImage2DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTexImage2DEXT_ovr_0(target, level, _internalformat, x, y, width, height, border);
    
    private static procedure z_CopyTexSubImage1DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyTexSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage1DEXT(target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTexSubImage1DEXT_ovr_0(target, level, xoffset, x, y, width);
    
    private static procedure z_CopyTexSubImage2DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTexSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage2DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage2DEXT_ovr_0(target, level, xoffset, yoffset, x, y, width, height);
    
    private static procedure z_CopyTexSubImage3DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTexSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTexSubImage3DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTexSubImage3DEXT_ovr_0(target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
  end;
  
  glCullVertexEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CullParameterdvEXT_ovr_0(pname: CullParameterEXT; var &params: real);
    external 'opengl32.dll' name 'glCullParameterdvEXT';
    private static procedure z_CullParameterdvEXT_ovr_0_anh001(pname: CullParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glCullParameterdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CullParameterdvEXT_ovr_0(pname, &params[0]) else
      z_CullParameterdvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; var &params: real) :=
    z_CullParameterdvEXT_ovr_0(pname, &params);
    private static procedure z_CullParameterdvEXT_ovr_2(pname: CullParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glCullParameterdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterdvEXT(pname: CullParameterEXT; &params: IntPtr) :=
    z_CullParameterdvEXT_ovr_2(pname, &params);
    
    private static procedure z_CullParameterfvEXT_ovr_0(pname: CullParameterEXT; var &params: single);
    external 'opengl32.dll' name 'glCullParameterfvEXT';
    private static procedure z_CullParameterfvEXT_ovr_0_anh001(pname: CullParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glCullParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CullParameterfvEXT_ovr_0(pname, &params[0]) else
      z_CullParameterfvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; var &params: single) :=
    z_CullParameterfvEXT_ovr_0(pname, &params);
    private static procedure z_CullParameterfvEXT_ovr_2(pname: CullParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glCullParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CullParameterfvEXT(pname: CullParameterEXT; &params: IntPtr) :=
    z_CullParameterfvEXT_ovr_2(pname, &params);
    
  end;
  
  glDebugLabelEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_LabelObjectEXT_ovr_0(&type: DummyEnum; object: UInt32; length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glLabelObjectEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LabelObjectEXT(&type: DummyEnum; object: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
      z_LabelObjectEXT_ovr_0(&type, object, length, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LabelObjectEXT(&type: DummyEnum; object: UInt32; length: Int32; &label: IntPtr) :=
    z_LabelObjectEXT_ovr_0(&type, object, length, &label);
    
    private static procedure z_GetObjectLabelEXT_ovr_0(&type: DummyEnum; object: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabelEXT';
    private static procedure z_GetObjectLabelEXT_ovr_0_anh000010(&type: DummyEnum; object: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabelEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabelEXT(&type: DummyEnum; object: UInt32; bufSize: Int32; length: array of Int32; &label: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetObjectLabelEXT_ovr_0(&type, object, bufSize, length[0], &label) else
      z_GetObjectLabelEXT_ovr_0_anh000010(&type, object, bufSize, IntPtr.Zero, &label);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabelEXT(&type: DummyEnum; object: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabelEXT_ovr_0(&type, object, bufSize, length, &label);
    private static procedure z_GetObjectLabelEXT_ovr_2(&type: DummyEnum; object: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabelEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabelEXT(&type: DummyEnum; object: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabelEXT_ovr_2(&type, object, bufSize, length, &label);
    
  end;
  
  glDebugMarkerEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_InsertEventMarkerEXT_ovr_0(length: Int32; marker: IntPtr);
    external 'opengl32.dll' name 'glInsertEventMarkerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertEventMarkerEXT(length: Int32; marker: string);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(marker);
      z_InsertEventMarkerEXT_ovr_0(length, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertEventMarkerEXT(length: Int32; marker: IntPtr) :=
    z_InsertEventMarkerEXT_ovr_0(length, marker);
    
    private static procedure z_PushGroupMarkerEXT_ovr_0(length: Int32; marker: IntPtr);
    external 'opengl32.dll' name 'glPushGroupMarkerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushGroupMarkerEXT(length: Int32; marker: string);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(marker);
      z_PushGroupMarkerEXT_ovr_0(length, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushGroupMarkerEXT(length: Int32; marker: IntPtr) :=
    z_PushGroupMarkerEXT_ovr_0(length, marker);
    
    private static procedure z_PopGroupMarkerEXT_ovr_0;
    external 'opengl32.dll' name 'glPopGroupMarkerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopGroupMarkerEXT :=
    z_PopGroupMarkerEXT_ovr_0;
    
  end;
  
  glDepthBoundsTestEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DepthBoundsEXT_ovr_0(zmin: real; zmax: real);
    external 'opengl32.dll' name 'glDepthBoundsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthBoundsEXT(zmin: real; zmax: real) :=
    z_DepthBoundsEXT_ovr_0(zmin, zmax);
    
  end;
  
  glDirectStateAccessEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MatrixLoadfEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    private static procedure z_MatrixLoadfEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadfEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadfEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadfEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadfEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoaddEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    private static procedure z_MatrixLoaddEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoaddEXT_ovr_0(mode, m[0]) else
      z_MatrixLoaddEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoaddEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoaddEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoaddEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultfEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    private static procedure z_MatrixMultfEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultfEXT_ovr_0(mode, m[0]) else
      z_MatrixMultfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultfEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultfEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultfEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultdEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    private static procedure z_MatrixMultdEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultdEXT_ovr_0(mode, m[0]) else
      z_MatrixMultdEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultdEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultdEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultdEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoadIdentityEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixLoadIdentityEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadIdentityEXT(mode: MatrixMode) :=
    z_MatrixLoadIdentityEXT_ovr_0(mode);
    
    private static procedure z_MatrixRotatefEXT_ovr_0(mode: MatrixMode; angle: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixRotatefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatefEXT(mode: MatrixMode; angle: single; x: single; y: single; z: single) :=
    z_MatrixRotatefEXT_ovr_0(mode, angle, x, y, z);
    
    private static procedure z_MatrixRotatedEXT_ovr_0(mode: MatrixMode; angle: real; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixRotatedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatedEXT(mode: MatrixMode; angle: real; x: real; y: real; z: real) :=
    z_MatrixRotatedEXT_ovr_0(mode, angle, x, y, z);
    
    private static procedure z_MatrixScalefEXT_ovr_0(mode: MatrixMode; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixScalefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScalefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixScalefEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixScaledEXT_ovr_0(mode: MatrixMode; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixScaledEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScaledEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixScaledEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixTranslatefEXT_ovr_0(mode: MatrixMode; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixTranslatefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixTranslatefEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixTranslatedEXT_ovr_0(mode: MatrixMode; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixTranslatedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatedEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixTranslatedEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixFrustumEXT_ovr_0(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glMatrixFrustumEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixFrustumEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixFrustumEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private static procedure z_MatrixOrthoEXT_ovr_0(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glMatrixOrthoEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixOrthoEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixOrthoEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private static procedure z_MatrixPopEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixPopEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPopEXT(mode: MatrixMode) :=
    z_MatrixPopEXT_ovr_0(mode);
    
    private static procedure z_MatrixPushEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixPushEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPushEXT(mode: MatrixMode) :=
    z_MatrixPushEXT_ovr_0(mode);
    
    private static procedure z_ClientAttribDefaultEXT_ovr_0(mask: ClientAttribMask);
    external 'opengl32.dll' name 'glClientAttribDefaultEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientAttribDefaultEXT(mask: ClientAttribMask) :=
    z_ClientAttribDefaultEXT_ovr_0(mask);
    
    private static procedure z_PushClientAttribDefaultEXT_ovr_0(mask: ClientAttribMask);
    external 'opengl32.dll' name 'glPushClientAttribDefaultEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushClientAttribDefaultEXT(mask: ClientAttribMask) :=
    z_PushClientAttribDefaultEXT_ovr_0(mask);
    
    private static procedure z_TextureParameterfEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; param: single);
    external 'opengl32.dll' name 'glTextureParameterfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_TextureParameterfEXT_ovr_0(texture, target, pname, param);
    
    private static procedure z_TextureParameterfvEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: single);
    external 'opengl32.dll' name 'glTextureParameterfvEXT';
    private static procedure z_TextureParameterfvEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterfvEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterfvEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_TextureParameterfvEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_TextureParameterfvEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterfvEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_TextureParameteriEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; param: Int32);
    external 'opengl32.dll' name 'glTextureParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameteriEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_TextureParameteriEXT_ovr_0(texture, target, pname, param);
    
    private static procedure z_TextureParameterivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glTextureParameterivEXT';
    private static procedure z_TextureParameterivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_TextureParameterivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_TextureImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage1DEXT_ovr_0(texture, target, level, internalformat, width, border, format, &type, pixels);
    
    private static procedure z_TextureImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage2DEXT_ovr_0(texture, target, level, internalformat, width, height, border, format, &type, pixels);
    
    private static procedure z_TextureSubImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, width, format, &type, pixels);
    
    private static procedure z_TextureSubImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private static procedure z_CopyTextureImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTextureImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyTextureImage1DEXT_ovr_0(texture, target, level, _internalformat, x, y, width, border);
    
    private static procedure z_CopyTextureImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyTextureImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyTextureImage2DEXT_ovr_0(texture, target, level, _internalformat, x, y, width, height, border);
    
    private static procedure z_CopyTextureSubImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyTextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, x, y, width);
    
    private static procedure z_CopyTextureSubImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, x, y, width, height);
    
    private static procedure z_GetTextureImageEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetTextureImageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureImageEXT(texture: UInt32; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetTextureImageEXT_ovr_0(texture, target, level, format, &type, pixels);
    
    private static procedure z_GetTextureParameterfvEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTextureParameterfvEXT';
    private static procedure z_GetTextureParameterfvEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterfvEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterfvEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureParameterfvEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_GetTextureParameterfvEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterfvEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterfvEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_GetTextureParameterivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureParameterivEXT';
    private static procedure z_GetTextureParameterivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_GetTextureParameterivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_GetTextureLevelParameterfvEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfvEXT';
    private static procedure z_GetTextureLevelParameterfvEXT_ovr_0_anh000001(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterfvEXT_ovr_0(texture, target, level, pname, &params[0]) else
      z_GetTextureLevelParameterfvEXT_ovr_0_anh000001(texture, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetTextureLevelParameterfvEXT_ovr_0(texture, target, level, pname, &params);
    private static procedure z_GetTextureLevelParameterfvEXT_ovr_2(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterfvEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterfvEXT_ovr_2(texture, target, level, pname, &params);
    
    private static procedure z_GetTextureLevelParameterivEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureLevelParameterivEXT';
    private static procedure z_GetTextureLevelParameterivEXT_ovr_0_anh000001(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureLevelParameterivEXT_ovr_0(texture, target, level, pname, &params[0]) else
      z_GetTextureLevelParameterivEXT_ovr_0_anh000001(texture, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureLevelParameterivEXT_ovr_0(texture, target, level, pname, &params);
    private static procedure z_GetTextureLevelParameterivEXT_ovr_2(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureLevelParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureLevelParameterivEXT(texture: UInt32; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureLevelParameterivEXT_ovr_2(texture, target, level, pname, &params);
    
    private static procedure z_TextureImage3DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DEXT(texture: UInt32; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureImage3DEXT_ovr_0(texture, target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    private static procedure z_TextureSubImage3DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTextureSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureSubImage3DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private static procedure z_CopyTextureSubImage3DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyTextureSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyTextureSubImage3DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyTextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private static procedure z_BindMultiTextureEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; texture: UInt32);
    external 'opengl32.dll' name 'glBindMultiTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindMultiTextureEXT(texunit: TextureUnit; target: TextureTarget; texture: UInt32) :=
    z_BindMultiTextureEXT_ovr_0(texunit, target, texture);
    
    private static procedure z_MultiTexCoordPointerEXT_ovr_0(texunit: TextureUnit; size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoordPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoordPointerEXT(texunit: TextureUnit; size: Int32; &type: TexCoordPointerType; stride: Int32; pointer: IntPtr) :=
    z_MultiTexCoordPointerEXT_ovr_0(texunit, size, &type, stride, pointer);
    
    private static procedure z_MultiTexEnvfEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: single);
    external 'opengl32.dll' name 'glMultiTexEnvfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: single) :=
    z_MultiTexEnvfEXT_ovr_0(texunit, target, pname, param);
    
    private static procedure z_MultiTexEnvfvEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single);
    external 'opengl32.dll' name 'glMultiTexEnvfvEXT';
    private static procedure z_MultiTexEnvfvEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexEnvfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexEnvfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_MultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexEnvfvEXT_ovr_2(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexEnvfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_MultiTexEnvfvEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_MultiTexEnviEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32);
    external 'opengl32.dll' name 'glMultiTexEnviEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnviEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; param: Int32) :=
    z_MultiTexEnviEXT_ovr_0(texunit, target, pname, param);
    
    private static procedure z_MultiTexEnvivEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32);
    external 'opengl32.dll' name 'glMultiTexEnvivEXT';
    private static procedure z_MultiTexEnvivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexEnvivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexEnvivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexEnvivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_MultiTexEnvivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexEnvivEXT_ovr_2(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexEnvivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_MultiTexEnvivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_MultiTexGendEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: real);
    external 'opengl32.dll' name 'glMultiTexGendEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: real) :=
    z_MultiTexGendEXT_ovr_0(texunit, coord, pname, param);
    
    private static procedure z_MultiTexGendvEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real);
    external 'opengl32.dll' name 'glMultiTexGendvEXT';
    private static procedure z_MultiTexGendvEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGendvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGendvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGendvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_MultiTexGendvEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_MultiTexGendvEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGendvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGendvEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_MultiTexGenfEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: single);
    external 'opengl32.dll' name 'glMultiTexGenfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: single) :=
    z_MultiTexGenfEXT_ovr_0(texunit, coord, pname, param);
    
    private static procedure z_MultiTexGenfvEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single);
    external 'opengl32.dll' name 'glMultiTexGenfvEXT';
    private static procedure z_MultiTexGenfvEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGenfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGenfvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_MultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_MultiTexGenfvEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGenfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGenfvEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_MultiTexGeniEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: Int32);
    external 'opengl32.dll' name 'glMultiTexGeniEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGeniEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; param: Int32) :=
    z_MultiTexGeniEXT_ovr_0(texunit, coord, pname, param);
    
    private static procedure z_MultiTexGenivEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32);
    external 'opengl32.dll' name 'glMultiTexGenivEXT';
    private static procedure z_MultiTexGenivEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGenivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexGenivEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_MultiTexGenivEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_MultiTexGenivEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_MultiTexGenivEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexGenivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_MultiTexGenivEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_GetMultiTexEnvfvEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single);
    external 'opengl32.dll' name 'glGetMultiTexEnvfvEXT';
    private static procedure z_GetMultiTexEnvfvEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexEnvfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexEnvfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: single) :=
    z_GetMultiTexEnvfvEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexEnvfvEXT_ovr_2(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexEnvfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvfvEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetMultiTexEnvfvEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexEnvivEXT_ovr_0(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMultiTexEnvivEXT';
    private static procedure z_GetMultiTexEnvivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexEnvivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexEnvivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexEnvivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Int32) :=
    z_GetMultiTexEnvivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexEnvivEXT_ovr_2(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexEnvivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexEnvivEXT(texunit: TextureUnit; target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetMultiTexEnvivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexGendvEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real);
    external 'opengl32.dll' name 'glGetMultiTexGendvEXT';
    private static procedure z_GetMultiTexGendvEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGendvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGendvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGendvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: real) :=
    z_GetMultiTexGendvEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_GetMultiTexGendvEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGendvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGendvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGendvEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_GetMultiTexGenfvEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single);
    external 'opengl32.dll' name 'glGetMultiTexGenfvEXT';
    private static procedure z_GetMultiTexGenfvEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGenfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGenfvEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: single) :=
    z_GetMultiTexGenfvEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_GetMultiTexGenfvEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGenfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenfvEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGenfvEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_GetMultiTexGenivEXT_ovr_0(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMultiTexGenivEXT';
    private static procedure z_GetMultiTexGenivEXT_ovr_0_anh00001(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGenivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexGenivEXT_ovr_0(texunit, coord, pname, &params[0]) else
      z_GetMultiTexGenivEXT_ovr_0_anh00001(texunit, coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; var &params: Int32) :=
    z_GetMultiTexGenivEXT_ovr_0(texunit, coord, pname, &params);
    private static procedure z_GetMultiTexGenivEXT_ovr_2(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexGenivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexGenivEXT(texunit: TextureUnit; coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetMultiTexGenivEXT_ovr_2(texunit, coord, pname, &params);
    
    private static procedure z_MultiTexParameteriEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: Int32);
    external 'opengl32.dll' name 'glMultiTexParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameteriEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: Int32) :=
    z_MultiTexParameteriEXT_ovr_0(texunit, target, pname, param);
    
    private static procedure z_MultiTexParameterivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glMultiTexParameterivEXT';
    private static procedure z_MultiTexParameterivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_MultiTexParameterivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexParameterivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_MultiTexParameterfEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: single);
    external 'opengl32.dll' name 'glMultiTexParameterfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; param: single) :=
    z_MultiTexParameterfEXT_ovr_0(texunit, target, pname, param);
    
    private static procedure z_MultiTexParameterfvEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: single);
    external 'opengl32.dll' name 'glMultiTexParameterfvEXT';
    private static procedure z_MultiTexParameterfvEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: single) :=
    z_MultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexParameterfvEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterfvEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_MultiTexImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage1DEXT_ovr_0(texunit, target, level, internalformat, width, border, format, &type, pixels);
    
    private static procedure z_MultiTexImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage2DEXT_ovr_0(texunit, target, level, internalformat, width, height, border, format, &type, pixels);
    
    private static procedure z_MultiTexSubImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, width, format, &type, pixels);
    
    private static procedure z_MultiTexSubImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
    private static procedure z_CopyMultiTexImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyMultiTexImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; border: Int32) :=
    z_CopyMultiTexImage1DEXT_ovr_0(texunit, target, level, _internalformat, x, y, width, border);
    
    private static procedure z_CopyMultiTexImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32);
    external 'opengl32.dll' name 'glCopyMultiTexImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32; height: Int32; border: Int32) :=
    z_CopyMultiTexImage2DEXT_ovr_0(texunit, target, level, _internalformat, x, y, width, height, border);
    
    private static procedure z_CopyMultiTexSubImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyMultiTexSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; x: Int32; y: Int32; width: Int32) :=
    z_CopyMultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, x, y, width);
    
    private static procedure z_CopyMultiTexSubImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyMultiTexSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyMultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, x, y, width, height);
    
    private static procedure z_GetMultiTexImageEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexImageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexImageEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_GetMultiTexImageEXT_ovr_0(texunit, target, level, format, &type, pixels);
    
    private static procedure z_GetMultiTexParameterfvEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetMultiTexParameterfvEXT';
    private static procedure z_GetMultiTexParameterfvEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterfvEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: single) :=
    z_GetMultiTexParameterfvEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexParameterfvEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterfvEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterfvEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexParameterivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMultiTexParameterivEXT';
    private static procedure z_GetMultiTexParameterivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexParameterivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexParameterivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexLevelParameterfvEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterfvEXT';
    private static procedure z_GetMultiTexLevelParameterfvEXT_ovr_0_anh000001(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexLevelParameterfvEXT_ovr_0(texunit, target, level, pname, &params[0]) else
      z_GetMultiTexLevelParameterfvEXT_ovr_0_anh000001(texunit, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: single) :=
    z_GetMultiTexLevelParameterfvEXT_ovr_0(texunit, target, level, pname, &params);
    private static procedure z_GetMultiTexLevelParameterfvEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterfvEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexLevelParameterfvEXT_ovr_2(texunit, target, level, pname, &params);
    
    private static procedure z_GetMultiTexLevelParameterivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterivEXT';
    private static procedure z_GetMultiTexLevelParameterivEXT_ovr_0_anh000001(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexLevelParameterivEXT_ovr_0(texunit, target, level, pname, &params[0]) else
      z_GetMultiTexLevelParameterivEXT_ovr_0_anh000001(texunit, target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexLevelParameterivEXT_ovr_0(texunit, target, level, pname, &params);
    private static procedure z_GetMultiTexLevelParameterivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexLevelParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexLevelParameterivEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexLevelParameterivEXT_ovr_2(texunit, target, level, pname, &params);
    
    private static procedure z_MultiTexImage3DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; internalformat: Int32; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexImage3DEXT_ovr_0(texunit, target, level, internalformat, width, height, depth, border, format, &type, pixels);
    
    private static procedure z_MultiTexSubImage3DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glMultiTexSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_MultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
    private static procedure z_CopyMultiTexSubImage3DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glCopyMultiTexSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyMultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_CopyMultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height);
    
    private static procedure z_EnableClientStateIndexedEXT_ovr_0(&array: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glEnableClientStateIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientStateIndexedEXT(&array: EnableCap; index: UInt32) :=
    z_EnableClientStateIndexedEXT_ovr_0(&array, index);
    
    private static procedure z_DisableClientStateIndexedEXT_ovr_0(&array: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glDisableClientStateIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientStateIndexedEXT(&array: EnableCap; index: UInt32) :=
    z_DisableClientStateIndexedEXT_ovr_0(&array, index);
    
    private static procedure z_GetFloatIndexedvEXT_ovr_0(target: DummyEnum; index: UInt32; var data: single);
    external 'opengl32.dll' name 'glGetFloatIndexedvEXT';
    private static procedure z_GetFloatIndexedvEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloatIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: DummyEnum; index: UInt32; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetFloatIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetFloatIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: DummyEnum; index: UInt32; var data: single) :=
    z_GetFloatIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetFloatIndexedvEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetFloatIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloatIndexedvEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetFloatIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_GetDoubleIndexedvEXT_ovr_0(target: DummyEnum; index: UInt32; var data: real);
    external 'opengl32.dll' name 'glGetDoubleIndexedvEXT';
    private static procedure z_GetDoubleIndexedvEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoubleIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: DummyEnum; index: UInt32; data: array of real) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetDoubleIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetDoubleIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: DummyEnum; index: UInt32; var data: real) :=
    z_GetDoubleIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetDoubleIndexedvEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetDoubleIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoubleIndexedvEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetDoubleIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_GetPointerIndexedvEXT_ovr_0(target: DummyEnum; index: UInt32; var data: IntPtr);
    external 'opengl32.dll' name 'glGetPointerIndexedvEXT';
    private static procedure z_GetPointerIndexedvEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetPointerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerIndexedvEXT(target: DummyEnum; index: UInt32; data: array of IntPtr) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetPointerIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetPointerIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerIndexedvEXT(target: DummyEnum; index: UInt32; var data: IntPtr) :=
    z_GetPointerIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetPointerIndexedvEXT_ovr_2(target: DummyEnum; index: UInt32; data: pointer);
    external 'opengl32.dll' name 'glGetPointerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerIndexedvEXT(target: DummyEnum; index: UInt32; data: pointer) :=
    z_GetPointerIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_EnableIndexedEXT_ovr_0(target: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glEnableIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_EnableIndexedEXT_ovr_0(target, index);
    
    private static procedure z_DisableIndexedEXT_ovr_0(target: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glDisableIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_DisableIndexedEXT_ovr_0(target, index);
    
    private static function z_IsEnabledIndexedEXT_ovr_0(target: EnableCap; index: UInt32): boolean;
    external 'opengl32.dll' name 'glIsEnabledIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledIndexedEXT(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledIndexedEXT_ovr_0(target, index);
    
    private static procedure z_GetIntegerIndexedvEXT_ovr_0(target: DummyEnum; index: UInt32; var data: Int32);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    private static procedure z_GetIntegerIndexedvEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetIntegerIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; var data: Int32) :=
    z_GetIntegerIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetIntegerIndexedvEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetIntegerIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_GetBooleanIndexedvEXT_ovr_0(target: BufferTargetARB; index: UInt32; var data: boolean);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    private static procedure z_GetBooleanIndexedvEXT_ovr_0_anh0001(target: BufferTargetARB; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetBooleanIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; var data: boolean) :=
    z_GetBooleanIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetBooleanIndexedvEXT_ovr_2(target: BufferTargetARB; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; data: IntPtr) :=
    z_GetBooleanIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_CompressedTextureImage3DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage3DEXT(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage3DEXT_ovr_0(texture, target, level, _internalformat, width, height, depth, border, imageSize, bits);
    
    private static procedure z_CompressedTextureImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage2DEXT_ovr_0(texture, target, level, _internalformat, width, height, border, imageSize, bits);
    
    private static procedure z_CompressedTextureImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureImage1DEXT_ovr_0(texture, target, level, _internalformat, width, border, imageSize, bits);
    
    private static procedure z_CompressedTextureSubImage3DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage3DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage3DEXT_ovr_0(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
    
    private static procedure z_CompressedTextureSubImage2DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage2DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage2DEXT_ovr_0(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
    
    private static procedure z_CompressedTextureSubImage1DEXT_ovr_0(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedTextureSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedTextureSubImage1DEXT(texture: UInt32; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedTextureSubImage1DEXT_ovr_0(texture, target, level, xoffset, width, format, imageSize, bits);
    
    private static procedure z_GetCompressedTextureImageEXT_ovr_0(texture: UInt32; target: TextureTarget; lod: Int32; img: IntPtr);
    external 'opengl32.dll' name 'glGetCompressedTextureImageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedTextureImageEXT(texture: UInt32; target: TextureTarget; lod: Int32; img: IntPtr) :=
    z_GetCompressedTextureImageEXT_ovr_0(texture, target, lod, img);
    
    private static procedure z_CompressedMultiTexImage3DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage3DEXT_ovr_0(texunit, target, level, _internalformat, width, height, depth, border, imageSize, bits);
    
    private static procedure z_CompressedMultiTexImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage2DEXT_ovr_0(texunit, target, level, _internalformat, width, height, border, imageSize, bits);
    
    private static procedure z_CompressedMultiTexImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; border: Int32; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexImage1DEXT_ovr_0(texunit, target, level, _internalformat, width, border, imageSize, bits);
    
    private static procedure z_CompressedMultiTexSubImage3DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage3DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage3DEXT_ovr_0(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
    
    private static procedure z_CompressedMultiTexSubImage2DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage2DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage2DEXT_ovr_0(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
    
    private static procedure z_CompressedMultiTexSubImage1DEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr);
    external 'opengl32.dll' name 'glCompressedMultiTexSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompressedMultiTexSubImage1DEXT(texunit: TextureUnit; target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; imageSize: Int32; bits: IntPtr) :=
    z_CompressedMultiTexSubImage1DEXT_ovr_0(texunit, target, level, xoffset, width, format, imageSize, bits);
    
    private static procedure z_GetCompressedMultiTexImageEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; lod: Int32; img: IntPtr);
    external 'opengl32.dll' name 'glGetCompressedMultiTexImageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCompressedMultiTexImageEXT(texunit: TextureUnit; target: TextureTarget; lod: Int32; img: IntPtr) :=
    z_GetCompressedMultiTexImageEXT_ovr_0(texunit, target, lod, img);
    
    private static procedure z_MatrixLoadTransposefEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    private static procedure z_MatrixLoadTransposefEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadTransposefEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadTransposefEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposefEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoadTransposedEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    private static procedure z_MatrixLoadTransposedEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoadTransposedEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadTransposedEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposedEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultTransposefEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    private static procedure z_MatrixMultTransposefEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultTransposefEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultTransposefEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposefEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultTransposedEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    private static procedure z_MatrixMultTransposedEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultTransposedEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultTransposedEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposedEXT_ovr_2(mode, m);
    
    private static procedure z_NamedBufferDataEXT_ovr_0(buffer: UInt32; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage);
    external 'opengl32.dll' name 'glNamedBufferDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferDataEXT(buffer: UInt32; size: IntPtr; data: IntPtr; usage: VertexBufferObjectUsage) :=
    z_NamedBufferDataEXT_ovr_0(buffer, size, data, usage);
    
    private static procedure z_NamedBufferSubDataEXT_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glNamedBufferSubDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferSubDataEXT(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_NamedBufferSubDataEXT_ovr_0(buffer, offset, size, data);
    
    private static function z_MapNamedBufferEXT_ovr_0(buffer: UInt32; access: BufferAccessARB): IntPtr;
    external 'opengl32.dll' name 'glMapNamedBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferEXT(buffer: UInt32; access: BufferAccessARB): IntPtr :=
    z_MapNamedBufferEXT_ovr_0(buffer, access);
    
    private static function z_UnmapNamedBufferEXT_ovr_0(buffer: UInt32): boolean;
    external 'opengl32.dll' name 'glUnmapNamedBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function UnmapNamedBufferEXT(buffer: UInt32): boolean :=
    z_UnmapNamedBufferEXT_ovr_0(buffer);
    
    private static procedure z_GetNamedBufferParameterivEXT_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedBufferParameterivEXT';
    private static procedure z_GetNamedBufferParameterivEXT_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameterivEXT_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameterivEXT_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: Int32) :=
    z_GetNamedBufferParameterivEXT_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferParameterivEXT_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterivEXT(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameterivEXT_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetNamedBufferPointervEXT_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferPointervEXT';
    private static procedure z_GetNamedBufferPointervEXT_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointervEXT(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferPointervEXT_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferPointervEXT_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointervEXT(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: IntPtr) :=
    z_GetNamedBufferPointervEXT_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferPointervEXT_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer);
    external 'opengl32.dll' name 'glGetNamedBufferPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferPointervEXT(buffer: UInt32; pname: VertexBufferObjectParameter; &params: pointer) :=
    z_GetNamedBufferPointervEXT_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetNamedBufferSubDataEXT_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferSubDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferSubDataEXT(buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_GetNamedBufferSubDataEXT_ovr_0(buffer, offset, size, data);
    
    private static procedure z_ProgramUniform1fEXT_ovr_0(&program: UInt32; location: Int32; v0: single);
    external 'opengl32.dll' name 'glProgramUniform1fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fEXT(&program: UInt32; location: Int32; v0: single) :=
    z_ProgramUniform1fEXT_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform2fEXT_ovr_0(&program: UInt32; location: Int32; v0: single; v1: single);
    external 'opengl32.dll' name 'glProgramUniform2fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fEXT(&program: UInt32; location: Int32; v0: single; v1: single) :=
    z_ProgramUniform2fEXT_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform3fEXT_ovr_0(&program: UInt32; location: Int32; v0: single; v1: single; v2: single);
    external 'opengl32.dll' name 'glProgramUniform3fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fEXT(&program: UInt32; location: Int32; v0: single; v1: single; v2: single) :=
    z_ProgramUniform3fEXT_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform4fEXT_ovr_0(&program: UInt32; location: Int32; v0: single; v1: single; v2: single; v3: single);
    external 'opengl32.dll' name 'glProgramUniform4fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fEXT(&program: UInt32; location: Int32; v0: single; v1: single; v2: single; v3: single) :=
    z_ProgramUniform4fEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform1iEXT_ovr_0(&program: UInt32; location: Int32; v0: Int32);
    external 'opengl32.dll' name 'glProgramUniform1iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1iEXT(&program: UInt32; location: Int32; v0: Int32) :=
    z_ProgramUniform1iEXT_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform2iEXT_ovr_0(&program: UInt32; location: Int32; v0: Int32; v1: Int32);
    external 'opengl32.dll' name 'glProgramUniform2iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2iEXT(&program: UInt32; location: Int32; v0: Int32; v1: Int32) :=
    z_ProgramUniform2iEXT_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform3iEXT_ovr_0(&program: UInt32; location: Int32; v0: Int32; v1: Int32; v2: Int32);
    external 'opengl32.dll' name 'glProgramUniform3iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3iEXT(&program: UInt32; location: Int32; v0: Int32; v1: Int32; v2: Int32) :=
    z_ProgramUniform3iEXT_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform4iEXT_ovr_0(&program: UInt32; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32);
    external 'opengl32.dll' name 'glProgramUniform4iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4iEXT(&program: UInt32; location: Int32; v0: Int32; v1: Int32; v2: Int32; v3: Int32) :=
    z_ProgramUniform4iEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform1fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform1fvEXT';
    private static procedure z_ProgramUniform1fvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform1fvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1fvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1fvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform2fvEXT';
    private static procedure z_ProgramUniform2fvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform2fvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2fvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2fvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform3fvEXT';
    private static procedure z_ProgramUniform3fvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform3fvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3fvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3fvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: single);
    external 'opengl32.dll' name 'glProgramUniform4fvEXT';
    private static procedure z_ProgramUniform4fvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: UInt32; location: Int32; count: Int32; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4fvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4fvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: UInt32; location: Int32; count: Int32; var value: single) :=
    z_ProgramUniform4fvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4fvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4fvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1ivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform1ivEXT';
    private static procedure z_ProgramUniform1ivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform1ivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1ivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2ivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform2ivEXT';
    private static procedure z_ProgramUniform2ivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform2ivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2ivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3ivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform3ivEXT';
    private static procedure z_ProgramUniform3ivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform3ivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3ivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4ivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int32);
    external 'opengl32.dll' name 'glProgramUniform4ivEXT';
    private static procedure z_ProgramUniform4ivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: UInt32; location: Int32; count: Int32; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: UInt32; location: Int32; count: Int32; var value: Int32) :=
    z_ProgramUniform4ivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4ivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniformMatrix2fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fvEXT';
    private static procedure z_ProgramUniformMatrix2fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fvEXT';
    private static procedure z_ProgramUniformMatrix3fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fvEXT';
    private static procedure z_ProgramUniformMatrix4fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x3fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fvEXT';
    private static procedure z_ProgramUniformMatrix2x3fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x3fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x3fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x2fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fvEXT';
    private static procedure z_ProgramUniformMatrix3x2fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x2fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x2fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x4fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fvEXT';
    private static procedure z_ProgramUniformMatrix2x4fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix2x4fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x4fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x2fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fvEXT';
    private static procedure z_ProgramUniformMatrix4x2fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x2fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x2fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x4fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fvEXT';
    private static procedure z_ProgramUniformMatrix3x4fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix3x4fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x4fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x3fvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fvEXT';
    private static procedure z_ProgramUniformMatrix4x3fvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3fvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3fvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: single) :=
    z_ProgramUniformMatrix4x3fvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x3fvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3fvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3fvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_TextureBufferEXT_ovr_0(texture: UInt32; target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32);
    external 'opengl32.dll' name 'glTextureBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferEXT(texture: UInt32; target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32) :=
    z_TextureBufferEXT_ovr_0(texture, target, _internalformat, buffer);
    
    private static procedure z_MultiTexBufferEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; internalformat: DummyEnum; buffer: UInt32);
    external 'opengl32.dll' name 'glMultiTexBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexBufferEXT(texunit: TextureUnit; target: TextureTarget; internalformat: DummyEnum; buffer: UInt32) :=
    z_MultiTexBufferEXT_ovr_0(texunit, target, internalformat, buffer);
    
    private static procedure z_TextureParameterIivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glTextureParameterIivEXT';
    private static procedure z_TextureParameterIivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterIivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TextureParameterIivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_TextureParameterIivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_TextureParameterIuivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: UInt32);
    external 'opengl32.dll' name 'glTextureParameterIuivEXT';
    private static procedure z_TextureParameterIuivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TextureParameterIuivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_TextureParameterIuivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TextureParameterIuivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_TextureParameterIuivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTextureParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TextureParameterIuivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_GetTextureParameterIivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTextureParameterIivEXT';
    private static procedure z_GetTextureParameterIivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterIivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTextureParameterIivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_GetTextureParameterIivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_GetTextureParameterIuivEXT_ovr_0(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32);
    external 'opengl32.dll' name 'glGetTextureParameterIuivEXT';
    private static procedure z_GetTextureParameterIuivEXT_ovr_0_anh00001(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTextureParameterIuivEXT_ovr_0(texture, target, pname, &params[0]) else
      z_GetTextureParameterIuivEXT_ovr_0_anh00001(texture, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTextureParameterIuivEXT_ovr_0(texture, target, pname, &params);
    private static procedure z_GetTextureParameterIuivEXT_ovr_2(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTextureParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTextureParameterIuivEXT(texture: UInt32; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTextureParameterIuivEXT_ovr_2(texture, target, pname, &params);
    
    private static procedure z_MultiTexParameterIivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glMultiTexParameterIivEXT';
    private static procedure z_MultiTexParameterIivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterIivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_MultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexParameterIivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterIivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_MultiTexParameterIuivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: UInt32);
    external 'opengl32.dll' name 'glMultiTexParameterIuivEXT';
    private static procedure z_MultiTexParameterIuivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_MultiTexParameterIuivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_MultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_MultiTexParameterIuivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMultiTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_MultiTexParameterIuivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexParameterIivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetMultiTexParameterIivEXT';
    private static procedure z_GetMultiTexParameterIivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterIivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetMultiTexParameterIivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexParameterIivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterIivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_GetMultiTexParameterIuivEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32);
    external 'opengl32.dll' name 'glGetMultiTexParameterIuivEXT';
    private static procedure z_GetMultiTexParameterIuivEXT_ovr_0_anh00001(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params[0]) else
      z_GetMultiTexParameterIuivEXT_ovr_0_anh00001(texunit, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetMultiTexParameterIuivEXT_ovr_0(texunit, target, pname, &params);
    private static procedure z_GetMultiTexParameterIuivEXT_ovr_2(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMultiTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultiTexParameterIuivEXT(texunit: TextureUnit; target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetMultiTexParameterIuivEXT_ovr_2(texunit, target, pname, &params);
    
    private static procedure z_ProgramUniform1uiEXT_ovr_0(&program: UInt32; location: Int32; v0: UInt32);
    external 'opengl32.dll' name 'glProgramUniform1uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uiEXT(&program: UInt32; location: Int32; v0: UInt32) :=
    z_ProgramUniform1uiEXT_ovr_0(&program, location, v0);
    
    private static procedure z_ProgramUniform2uiEXT_ovr_0(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32);
    external 'opengl32.dll' name 'glProgramUniform2uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uiEXT(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32) :=
    z_ProgramUniform2uiEXT_ovr_0(&program, location, v0, v1);
    
    private static procedure z_ProgramUniform3uiEXT_ovr_0(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32);
    external 'opengl32.dll' name 'glProgramUniform3uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uiEXT(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_ProgramUniform3uiEXT_ovr_0(&program, location, v0, v1, v2);
    
    private static procedure z_ProgramUniform4uiEXT_ovr_0(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32);
    external 'opengl32.dll' name 'glProgramUniform4uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uiEXT(&program: UInt32; location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_ProgramUniform4uiEXT_ovr_0(&program, location, v0, v1, v2, v3);
    
    private static procedure z_ProgramUniform1uivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform1uivEXT';
    private static procedure z_ProgramUniform1uivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform1uivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1uivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1uivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1uivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2uivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform2uivEXT';
    private static procedure z_ProgramUniform2uivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform2uivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2uivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2uivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2uivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3uivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform3uivEXT';
    private static procedure z_ProgramUniform3uivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform3uivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3uivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3uivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3uivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4uivEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glProgramUniform4uivEXT';
    private static procedure z_ProgramUniform4uivEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: UInt32; location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4uivEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4uivEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: UInt32; location: Int32; count: Int32; var value: UInt32) :=
    z_ProgramUniform4uivEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4uivEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4uivEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4uivEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_NamedProgramLocalParameters4fvEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: single);
    external 'opengl32.dll' name 'glNamedProgramLocalParameters4fvEXT';
    private static procedure z_NamedProgramLocalParameters4fvEXT_ovr_0_anh000001(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameters4fvEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParameters4fvEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_NamedProgramLocalParameters4fvEXT_ovr_0(&program, target, index, count, &params);
    private static procedure z_NamedProgramLocalParameters4fvEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameters4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParameters4fvEXT_ovr_2(&program, target, index, count, &params);
    
    private static procedure z_NamedProgramLocalParameterI4iEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4iEXT(&program: UInt32; target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_NamedProgramLocalParameterI4iEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private static procedure z_NamedProgramLocalParameterI4ivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4ivEXT';
    private static procedure z_NamedProgramLocalParameterI4ivEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameterI4ivEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameterI4ivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_NamedProgramLocalParameterI4ivEXT_ovr_0(&program, target, index, &params);
    private static procedure z_NamedProgramLocalParameterI4ivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameterI4ivEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_NamedProgramLocalParametersI4ivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4ivEXT';
    private static procedure z_NamedProgramLocalParametersI4ivEXT_ovr_0_anh000001(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParametersI4ivEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParametersI4ivEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_NamedProgramLocalParametersI4ivEXT_ovr_0(&program, target, index, count, &params);
    private static procedure z_NamedProgramLocalParametersI4ivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4ivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParametersI4ivEXT_ovr_2(&program, target, index, count, &params);
    
    private static procedure z_NamedProgramLocalParameterI4uiEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uiEXT(&program: UInt32; target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_NamedProgramLocalParameterI4uiEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private static procedure z_NamedProgramLocalParameterI4uivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4uivEXT';
    private static procedure z_NamedProgramLocalParameterI4uivEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameterI4uivEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameterI4uivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_NamedProgramLocalParameterI4uivEXT_ovr_0(&program, target, index, &params);
    private static procedure z_NamedProgramLocalParameterI4uivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameterI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameterI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameterI4uivEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_NamedProgramLocalParametersI4uivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4uivEXT';
    private static procedure z_NamedProgramLocalParametersI4uivEXT_ovr_0_anh000001(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParametersI4uivEXT_ovr_0(&program, target, index, count, &params[0]) else
      z_NamedProgramLocalParametersI4uivEXT_ovr_0_anh000001(&program, target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_NamedProgramLocalParametersI4uivEXT_ovr_0(&program, target, index, count, &params);
    private static procedure z_NamedProgramLocalParametersI4uivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParametersI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParametersI4uivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_NamedProgramLocalParametersI4uivEXT_ovr_2(&program, target, index, count, &params);
    
    private static procedure z_GetNamedProgramLocalParameterIivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIivEXT';
    private static procedure z_GetNamedProgramLocalParameterIivEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterIivEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterIivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetNamedProgramLocalParameterIivEXT_ovr_0(&program, target, index, &params);
    private static procedure z_GetNamedProgramLocalParameterIivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterIivEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_GetNamedProgramLocalParameterIuivEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIuivEXT';
    private static procedure z_GetNamedProgramLocalParameterIuivEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterIuivEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterIuivEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetNamedProgramLocalParameterIuivEXT_ovr_0(&program, target, index, &params);
    private static procedure z_GetNamedProgramLocalParameterIuivEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterIuivEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterIuivEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_EnableClientStateiEXT_ovr_0(&array: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glEnableClientStateiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableClientStateiEXT(&array: EnableCap; index: UInt32) :=
    z_EnableClientStateiEXT_ovr_0(&array, index);
    
    private static procedure z_DisableClientStateiEXT_ovr_0(&array: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glDisableClientStateiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableClientStateiEXT(&array: EnableCap; index: UInt32) :=
    z_DisableClientStateiEXT_ovr_0(&array, index);
    
    private static procedure z_GetFloati_vEXT_ovr_0(pname: DummyEnum; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetFloati_vEXT';
    private static procedure z_GetFloati_vEXT_ovr_0_anh0001(pname: DummyEnum; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFloati_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: DummyEnum; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFloati_vEXT_ovr_0(pname, index, &params[0]) else
      z_GetFloati_vEXT_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: DummyEnum; index: UInt32; var &params: single) :=
    z_GetFloati_vEXT_ovr_0(pname, index, &params);
    private static procedure z_GetFloati_vEXT_ovr_2(pname: DummyEnum; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFloati_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFloati_vEXT(pname: DummyEnum; index: UInt32; &params: IntPtr) :=
    z_GetFloati_vEXT_ovr_2(pname, index, &params);
    
    private static procedure z_GetDoublei_vEXT_ovr_0(pname: DummyEnum; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetDoublei_vEXT';
    private static procedure z_GetDoublei_vEXT_ovr_0_anh0001(pname: DummyEnum; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetDoublei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: DummyEnum; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetDoublei_vEXT_ovr_0(pname, index, &params[0]) else
      z_GetDoublei_vEXT_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: DummyEnum; index: UInt32; var &params: real) :=
    z_GetDoublei_vEXT_ovr_0(pname, index, &params);
    private static procedure z_GetDoublei_vEXT_ovr_2(pname: DummyEnum; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetDoublei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDoublei_vEXT(pname: DummyEnum; index: UInt32; &params: IntPtr) :=
    z_GetDoublei_vEXT_ovr_2(pname, index, &params);
    
    private static procedure z_GetPointeri_vEXT_ovr_0(pname: DummyEnum; index: UInt32; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointeri_vEXT';
    private static procedure z_GetPointeri_vEXT_ovr_0_anh0001(pname: DummyEnum; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointeri_vEXT(pname: DummyEnum; index: UInt32; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPointeri_vEXT_ovr_0(pname, index, &params[0]) else
      z_GetPointeri_vEXT_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointeri_vEXT(pname: DummyEnum; index: UInt32; var &params: IntPtr) :=
    z_GetPointeri_vEXT_ovr_0(pname, index, &params);
    private static procedure z_GetPointeri_vEXT_ovr_2(pname: DummyEnum; index: UInt32; &params: pointer);
    external 'opengl32.dll' name 'glGetPointeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointeri_vEXT(pname: DummyEnum; index: UInt32; &params: pointer) :=
    z_GetPointeri_vEXT_ovr_2(pname, index, &params);
    
    private static procedure z_NamedProgramStringEXT_ovr_0(&program: UInt32; target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramStringEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramStringEXT(&program: UInt32; target: ProgramTarget; format: ProgramFormat; len: Int32; string: IntPtr) :=
    z_NamedProgramStringEXT_ovr_0(&program, target, format, len, string);
    
    private static procedure z_NamedProgramLocalParameter4dEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dEXT(&program: UInt32; target: ProgramTarget; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_NamedProgramLocalParameter4dEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private static procedure z_NamedProgramLocalParameter4dvEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4dvEXT';
    private static procedure z_NamedProgramLocalParameter4dvEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameter4dvEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameter4dvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: real) :=
    z_NamedProgramLocalParameter4dvEXT_ovr_0(&program, target, index, &params);
    private static procedure z_NamedProgramLocalParameter4dvEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4dvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameter4dvEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_NamedProgramLocalParameter4fEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fEXT(&program: UInt32; target: ProgramTarget; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_NamedProgramLocalParameter4fEXT_ovr_0(&program, target, index, x, y, z, w);
    
    private static procedure z_NamedProgramLocalParameter4fvEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4fvEXT';
    private static procedure z_NamedProgramLocalParameter4fvEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_NamedProgramLocalParameter4fvEXT_ovr_0(&program, target, index, &params[0]) else
      z_NamedProgramLocalParameter4fvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: single) :=
    z_NamedProgramLocalParameter4fvEXT_ovr_0(&program, target, index, &params);
    private static procedure z_NamedProgramLocalParameter4fvEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glNamedProgramLocalParameter4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedProgramLocalParameter4fvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_NamedProgramLocalParameter4fvEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_GetNamedProgramLocalParameterdvEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: real);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterdvEXT';
    private static procedure z_GetNamedProgramLocalParameterdvEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterdvEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterdvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: real) :=
    z_GetNamedProgramLocalParameterdvEXT_ovr_0(&program, target, index, &params);
    private static procedure z_GetNamedProgramLocalParameterdvEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterdvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterdvEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_GetNamedProgramLocalParameterfvEXT_ovr_0(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: single);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterfvEXT';
    private static procedure z_GetNamedProgramLocalParameterfvEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramLocalParameterfvEXT_ovr_0(&program, target, index, &params[0]) else
      z_GetNamedProgramLocalParameterfvEXT_ovr_0_anh00001(&program, target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; var &params: single) :=
    z_GetNamedProgramLocalParameterfvEXT_ovr_0(&program, target, index, &params);
    private static procedure z_GetNamedProgramLocalParameterfvEXT_ovr_2(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramLocalParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramLocalParameterfvEXT(&program: UInt32; target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetNamedProgramLocalParameterfvEXT_ovr_2(&program, target, index, &params);
    
    private static procedure z_GetNamedProgramivEXT_ovr_0(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedProgramivEXT';
    private static procedure z_GetNamedProgramivEXT_ovr_0_anh00001(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramivEXT(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedProgramivEXT_ovr_0(&program, target, pname, &params[0]) else
      z_GetNamedProgramivEXT_ovr_0_anh00001(&program, target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramivEXT(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; var &params: Int32) :=
    z_GetNamedProgramivEXT_ovr_0(&program, target, pname, &params);
    private static procedure z_GetNamedProgramivEXT_ovr_2(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramivEXT(&program: UInt32; target: ProgramTarget; pname: ProgramPropertyARB; &params: IntPtr) :=
    z_GetNamedProgramivEXT_ovr_2(&program, target, pname, &params);
    
    private static procedure z_GetNamedProgramStringEXT_ovr_0(&program: UInt32; target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr);
    external 'opengl32.dll' name 'glGetNamedProgramStringEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedProgramStringEXT(&program: UInt32; target: ProgramTarget; pname: ProgramStringProperty; string: IntPtr) :=
    z_GetNamedProgramStringEXT_ovr_0(&program, target, pname, string);
    
    private static procedure z_NamedRenderbufferStorageEXT_ovr_0(renderbuffer: UInt32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageEXT(renderbuffer: UInt32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageEXT_ovr_0(renderbuffer, _internalformat, width, height);
    
    private static procedure z_GetNamedRenderbufferParameterivEXT_ovr_0(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameterivEXT';
    private static procedure z_GetNamedRenderbufferParameterivEXT_ovr_0_anh0001(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedRenderbufferParameterivEXT_ovr_0(renderbuffer, pname, &params[0]) else
      z_GetNamedRenderbufferParameterivEXT_ovr_0_anh0001(renderbuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: UInt32; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetNamedRenderbufferParameterivEXT_ovr_0(renderbuffer, pname, &params);
    private static procedure z_GetNamedRenderbufferParameterivEXT_ovr_2(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedRenderbufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedRenderbufferParameterivEXT(renderbuffer: UInt32; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetNamedRenderbufferParameterivEXT_ovr_2(renderbuffer, pname, &params);
    
    private static procedure z_NamedRenderbufferStorageMultisampleEXT_ovr_0(renderbuffer: UInt32; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorageMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleEXT(renderbuffer: UInt32; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleEXT_ovr_0(renderbuffer, samples, _internalformat, width, height);
    
    private static procedure z_NamedRenderbufferStorageMultisampleCoverageEXT_ovr_0(renderbuffer: UInt32; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glNamedRenderbufferStorageMultisampleCoverageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedRenderbufferStorageMultisampleCoverageEXT(renderbuffer: UInt32; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_NamedRenderbufferStorageMultisampleCoverageEXT_ovr_0(renderbuffer, coverageSamples, colorSamples, _internalformat, width, height);
    
    private static function z_CheckNamedFramebufferStatusEXT_ovr_0(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus;
    external 'opengl32.dll' name 'glCheckNamedFramebufferStatusEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckNamedFramebufferStatusEXT(framebuffer: UInt32; target: FramebufferTarget): FramebufferStatus :=
    z_CheckNamedFramebufferStatusEXT_ovr_0(framebuffer, target);
    
    private static procedure z_NamedFramebufferTexture1DEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTexture1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture1DEXT(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_NamedFramebufferTexture1DEXT_ovr_0(framebuffer, attachment, textarget, texture, level);
    
    private static procedure z_NamedFramebufferTexture2DEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTexture2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture2DEXT(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_NamedFramebufferTexture2DEXT_ovr_0(framebuffer, attachment, textarget, texture, level);
    
    private static procedure z_NamedFramebufferTexture3DEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTexture3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTexture3DEXT(framebuffer: UInt32; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32) :=
    z_NamedFramebufferTexture3DEXT_ovr_0(framebuffer, attachment, textarget, texture, level, zoffset);
    
    private static procedure z_NamedFramebufferRenderbufferEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glNamedFramebufferRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferRenderbufferEXT(framebuffer: UInt32; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: UInt32) :=
    z_NamedFramebufferRenderbufferEXT_ovr_0(framebuffer, attachment, _renderbuffertarget, renderbuffer);
    
    private static procedure z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameterivEXT';
    private static procedure z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0_anh00001(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0(framebuffer, attachment, pname, &params[0]) else
      z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0_anh00001(framebuffer, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetNamedFramebufferAttachmentParameterivEXT_ovr_0(framebuffer, attachment, pname, &params);
    private static procedure z_GetNamedFramebufferAttachmentParameterivEXT_ovr_2(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferAttachmentParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferAttachmentParameterivEXT(framebuffer: UInt32; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetNamedFramebufferAttachmentParameterivEXT_ovr_2(framebuffer, attachment, pname, &params);
    
    private static procedure z_GenerateTextureMipmapEXT_ovr_0(texture: UInt32; target: TextureTarget);
    external 'opengl32.dll' name 'glGenerateTextureMipmapEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateTextureMipmapEXT(texture: UInt32; target: TextureTarget) :=
    z_GenerateTextureMipmapEXT_ovr_0(texture, target);
    
    private static procedure z_GenerateMultiTexMipmapEXT_ovr_0(texunit: TextureUnit; target: TextureTarget);
    external 'opengl32.dll' name 'glGenerateMultiTexMipmapEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMultiTexMipmapEXT(texunit: TextureUnit; target: TextureTarget) :=
    z_GenerateMultiTexMipmapEXT_ovr_0(texunit, target);
    
    private static procedure z_FramebufferDrawBufferEXT_ovr_0(framebuffer: UInt32; mode: DrawBufferMode);
    external 'opengl32.dll' name 'glFramebufferDrawBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBufferEXT(framebuffer: UInt32; mode: DrawBufferMode) :=
    z_FramebufferDrawBufferEXT_ovr_0(framebuffer, mode);
    
    private static procedure z_FramebufferDrawBuffersEXT_ovr_0(framebuffer: UInt32; n: Int32; var bufs: DrawBufferMode);
    external 'opengl32.dll' name 'glFramebufferDrawBuffersEXT';
    private static procedure z_FramebufferDrawBuffersEXT_ovr_0_anh0001(framebuffer: UInt32; n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glFramebufferDrawBuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: UInt32; n: Int32; bufs: array of DrawBufferMode) :=
    if (bufs<>nil) and (bufs.Length<>0) then
      z_FramebufferDrawBuffersEXT_ovr_0(framebuffer, n, bufs[0]) else
      z_FramebufferDrawBuffersEXT_ovr_0_anh0001(framebuffer, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: UInt32; n: Int32; var bufs: DrawBufferMode) :=
    z_FramebufferDrawBuffersEXT_ovr_0(framebuffer, n, bufs);
    private static procedure z_FramebufferDrawBuffersEXT_ovr_2(framebuffer: UInt32; n: Int32; bufs: IntPtr);
    external 'opengl32.dll' name 'glFramebufferDrawBuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferDrawBuffersEXT(framebuffer: UInt32; n: Int32; bufs: IntPtr) :=
    z_FramebufferDrawBuffersEXT_ovr_2(framebuffer, n, bufs);
    
    private static procedure z_FramebufferReadBufferEXT_ovr_0(framebuffer: UInt32; mode: ReadBufferMode);
    external 'opengl32.dll' name 'glFramebufferReadBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferReadBufferEXT(framebuffer: UInt32; mode: ReadBufferMode) :=
    z_FramebufferReadBufferEXT_ovr_0(framebuffer, mode);
    
    private static procedure z_GetFramebufferParameterivEXT_ovr_0(framebuffer: UInt32; pname: GetFramebufferParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetFramebufferParameterivEXT';
    private static procedure z_GetFramebufferParameterivEXT_ovr_0_anh0001(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params[0]) else
      z_GetFramebufferParameterivEXT_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; var &params: Int32) :=
    z_GetFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params);
    private static procedure z_GetFramebufferParameterivEXT_ovr_2(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr) :=
    z_GetFramebufferParameterivEXT_ovr_2(framebuffer, pname, &params);
    
    private static procedure z_NamedCopyBufferSubDataEXT_ovr_0(readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glNamedCopyBufferSubDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedCopyBufferSubDataEXT(readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_NamedCopyBufferSubDataEXT_ovr_0(readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private static procedure z_NamedFramebufferTextureEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureEXT(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32) :=
    z_NamedFramebufferTextureEXT_ovr_0(framebuffer, attachment, texture, level);
    
    private static procedure z_NamedFramebufferTextureLayerEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferTextureLayerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureLayerEXT(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32) :=
    z_NamedFramebufferTextureLayerEXT_ovr_0(framebuffer, attachment, texture, level, layer);
    
    private static procedure z_NamedFramebufferTextureFaceEXT_ovr_0(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget);
    external 'opengl32.dll' name 'glNamedFramebufferTextureFaceEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferTextureFaceEXT(framebuffer: UInt32; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget) :=
    z_NamedFramebufferTextureFaceEXT_ovr_0(framebuffer, attachment, texture, level, face);
    
    private static procedure z_TextureRenderbufferEXT_ovr_0(texture: UInt32; target: TextureTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glTextureRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureRenderbufferEXT(texture: UInt32; target: TextureTarget; renderbuffer: UInt32) :=
    z_TextureRenderbufferEXT_ovr_0(texture, target, renderbuffer);
    
    private static procedure z_MultiTexRenderbufferEXT_ovr_0(texunit: TextureUnit; target: TextureTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glMultiTexRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexRenderbufferEXT(texunit: TextureUnit; target: TextureTarget; renderbuffer: UInt32) :=
    z_MultiTexRenderbufferEXT_ovr_0(texunit, target, renderbuffer);
    
    private static procedure z_VertexArrayVertexOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; size: Int32; &type: VertexPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexOffsetEXT(vaobj: UInt32; buffer: UInt32; size: Int32; &type: VertexPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private static procedure z_VertexArrayColorOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayColorOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayColorOffsetEXT(vaobj: UInt32; buffer: UInt32; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayColorOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private static procedure z_VertexArrayEdgeFlagOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayEdgeFlagOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayEdgeFlagOffsetEXT(vaobj: UInt32; buffer: UInt32; stride: Int32; offset: IntPtr) :=
    z_VertexArrayEdgeFlagOffsetEXT_ovr_0(vaobj, buffer, stride, offset);
    
    private static procedure z_VertexArrayIndexOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; &type: IndexPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayIndexOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayIndexOffsetEXT(vaobj: UInt32; buffer: UInt32; &type: IndexPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayIndexOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private static procedure z_VertexArrayNormalOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; &type: NormalPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayNormalOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayNormalOffsetEXT(vaobj: UInt32; buffer: UInt32; &type: NormalPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayNormalOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private static procedure z_VertexArrayTexCoordOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayTexCoordOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayTexCoordOffsetEXT(vaobj: UInt32; buffer: UInt32; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayTexCoordOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private static procedure z_VertexArrayMultiTexCoordOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; texunit: DummyEnum; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayMultiTexCoordOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayMultiTexCoordOffsetEXT(vaobj: UInt32; buffer: UInt32; texunit: DummyEnum; size: Int32; &type: TexCoordPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayMultiTexCoordOffsetEXT_ovr_0(vaobj, buffer, texunit, size, &type, stride, offset);
    
    private static procedure z_VertexArrayFogCoordOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; &type: FogCoordinatePointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayFogCoordOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayFogCoordOffsetEXT(vaobj: UInt32; buffer: UInt32; &type: FogCoordinatePointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayFogCoordOffsetEXT_ovr_0(vaobj, buffer, &type, stride, offset);
    
    private static procedure z_VertexArraySecondaryColorOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArraySecondaryColorOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArraySecondaryColorOffsetEXT(vaobj: UInt32; buffer: UInt32; size: Int32; &type: ColorPointerType; stride: Int32; offset: IntPtr) :=
    z_VertexArraySecondaryColorOffsetEXT_ovr_0(vaobj, buffer, size, &type, stride, offset);
    
    private static procedure z_VertexArrayVertexAttribOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribOffsetEXT(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribPointerType; normalized: boolean; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, normalized, stride, offset);
    
    private static procedure z_VertexArrayVertexAttribIOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribIOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribIOffsetEXT(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribIOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, stride, offset);
    
    private static procedure z_EnableVertexArrayEXT_ovr_0(vaobj: UInt32; &array: EnableCap);
    external 'opengl32.dll' name 'glEnableVertexArrayEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayEXT(vaobj: UInt32; &array: EnableCap) :=
    z_EnableVertexArrayEXT_ovr_0(vaobj, &array);
    
    private static procedure z_DisableVertexArrayEXT_ovr_0(vaobj: UInt32; &array: EnableCap);
    external 'opengl32.dll' name 'glDisableVertexArrayEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayEXT(vaobj: UInt32; &array: EnableCap) :=
    z_DisableVertexArrayEXT_ovr_0(vaobj, &array);
    
    private static procedure z_EnableVertexArrayAttribEXT_ovr_0(vaobj: UInt32; index: UInt32);
    external 'opengl32.dll' name 'glEnableVertexArrayAttribEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVertexArrayAttribEXT(vaobj: UInt32; index: UInt32) :=
    z_EnableVertexArrayAttribEXT_ovr_0(vaobj, index);
    
    private static procedure z_DisableVertexArrayAttribEXT_ovr_0(vaobj: UInt32; index: UInt32);
    external 'opengl32.dll' name 'glDisableVertexArrayAttribEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVertexArrayAttribEXT(vaobj: UInt32; index: UInt32) :=
    z_DisableVertexArrayAttribEXT_ovr_0(vaobj, index);
    
    private static procedure z_GetVertexArrayIntegervEXT_ovr_0(vaobj: UInt32; pname: VertexArrayPName; var param: Int32);
    external 'opengl32.dll' name 'glGetVertexArrayIntegervEXT';
    private static procedure z_GetVertexArrayIntegervEXT_ovr_0_anh0001(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIntegervEXT_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayIntegervEXT_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIntegervEXT_ovr_0(vaobj, pname, param);
    private static procedure z_GetVertexArrayIntegervEXT_ovr_2(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegervEXT(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIntegervEXT_ovr_2(vaobj, pname, param);
    
    private static procedure z_GetVertexArrayPointervEXT_ovr_0(vaobj: UInt32; pname: VertexArrayPName; var param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayPointervEXT';
    private static procedure z_GetVertexArrayPointervEXT_ovr_0_anh0001(vaobj: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointervEXT(vaobj: UInt32; pname: VertexArrayPName; param: array of IntPtr) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayPointervEXT_ovr_0(vaobj, pname, param[0]) else
      z_GetVertexArrayPointervEXT_ovr_0_anh0001(vaobj, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointervEXT(vaobj: UInt32; pname: VertexArrayPName; var param: IntPtr) :=
    z_GetVertexArrayPointervEXT_ovr_0(vaobj, pname, param);
    private static procedure z_GetVertexArrayPointervEXT_ovr_2(vaobj: UInt32; pname: VertexArrayPName; param: pointer);
    external 'opengl32.dll' name 'glGetVertexArrayPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointervEXT(vaobj: UInt32; pname: VertexArrayPName; param: pointer) :=
    z_GetVertexArrayPointervEXT_ovr_2(vaobj, pname, param);
    
    private static procedure z_GetVertexArrayIntegeri_vEXT_ovr_0(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32);
    external 'opengl32.dll' name 'glGetVertexArrayIntegeri_vEXT';
    private static procedure z_GetVertexArrayIntegeri_vEXT_ovr_0_anh00001(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIntegeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of Int32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayIntegeri_vEXT_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayIntegeri_vEXT_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: Int32) :=
    z_GetVertexArrayIntegeri_vEXT_ovr_0(vaobj, index, pname, param);
    private static procedure z_GetVertexArrayIntegeri_vEXT_ovr_2(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayIntegeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayIntegeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr) :=
    z_GetVertexArrayIntegeri_vEXT_ovr_2(vaobj, index, pname, param);
    
    private static procedure z_GetVertexArrayPointeri_vEXT_ovr_0(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayPointeri_vEXT';
    private static procedure z_GetVertexArrayPointeri_vEXT_ovr_0_anh00001(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: IntPtr);
    external 'opengl32.dll' name 'glGetVertexArrayPointeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: array of IntPtr) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetVertexArrayPointeri_vEXT_ovr_0(vaobj, index, pname, param[0]) else
      z_GetVertexArrayPointeri_vEXT_ovr_0_anh00001(vaobj, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; var param: IntPtr) :=
    z_GetVertexArrayPointeri_vEXT_ovr_0(vaobj, index, pname, param);
    private static procedure z_GetVertexArrayPointeri_vEXT_ovr_2(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: pointer);
    external 'opengl32.dll' name 'glGetVertexArrayPointeri_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexArrayPointeri_vEXT(vaobj: UInt32; index: UInt32; pname: VertexArrayPName; param: pointer) :=
    z_GetVertexArrayPointeri_vEXT_ovr_2(vaobj, index, pname, param);
    
    private static function z_MapNamedBufferRangeEXT_ovr_0(buffer: UInt32; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr;
    external 'opengl32.dll' name 'glMapNamedBufferRangeEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapNamedBufferRangeEXT(buffer: UInt32; offset: IntPtr; length: IntPtr; access: MapBufferAccessMask): IntPtr :=
    z_MapNamedBufferRangeEXT_ovr_0(buffer, offset, length, access);
    
    private static procedure z_FlushMappedNamedBufferRangeEXT_ovr_0(buffer: UInt32; offset: IntPtr; length: IntPtr);
    external 'opengl32.dll' name 'glFlushMappedNamedBufferRangeEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushMappedNamedBufferRangeEXT(buffer: UInt32; offset: IntPtr; length: IntPtr) :=
    z_FlushMappedNamedBufferRangeEXT_ovr_0(buffer, offset, length);
    
    private static procedure z_NamedBufferStorageEXT_ovr_0(buffer: UInt32; size: IntPtr; data: IntPtr; flags: BufferStorageMask);
    external 'opengl32.dll' name 'glNamedBufferStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageEXT(buffer: UInt32; size: IntPtr; data: IntPtr; flags: BufferStorageMask) :=
    z_NamedBufferStorageEXT_ovr_0(buffer, size, data, flags);
    
    private static procedure z_ClearNamedBufferDataEXT_ovr_0(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearNamedBufferDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferDataEXT(buffer: UInt32; _internalformat: InternalFormat; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferDataEXT_ovr_0(buffer, _internalformat, format, &type, data);
    
    private static procedure z_ClearNamedBufferSubDataEXT_ovr_0(buffer: UInt32; internalformat: DummyEnum; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glClearNamedBufferSubDataEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearNamedBufferSubDataEXT(buffer: UInt32; internalformat: DummyEnum; offset: IntPtr; size: IntPtr; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_ClearNamedBufferSubDataEXT_ovr_0(buffer, internalformat, offset, size, format, &type, data);
    
    private static procedure z_NamedFramebufferParameteriEXT_ovr_0(framebuffer: UInt32; pname: FramebufferParameterName; param: Int32);
    external 'opengl32.dll' name 'glNamedFramebufferParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferParameteriEXT(framebuffer: UInt32; pname: FramebufferParameterName; param: Int32) :=
    z_NamedFramebufferParameteriEXT_ovr_0(framebuffer, pname, param);
    
    private static procedure z_GetNamedFramebufferParameterivEXT_ovr_0(framebuffer: UInt32; pname: GetFramebufferParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterivEXT';
    private static procedure z_GetNamedFramebufferParameterivEXT_ovr_0_anh0001(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params[0]) else
      z_GetNamedFramebufferParameterivEXT_ovr_0_anh0001(framebuffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; var &params: Int32) :=
    z_GetNamedFramebufferParameterivEXT_ovr_0(framebuffer, pname, &params);
    private static procedure z_GetNamedFramebufferParameterivEXT_ovr_2(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedFramebufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedFramebufferParameterivEXT(framebuffer: UInt32; pname: GetFramebufferParameter; &params: IntPtr) :=
    z_GetNamedFramebufferParameterivEXT_ovr_2(framebuffer, pname, &params);
    
    private static procedure z_ProgramUniform1dEXT_ovr_0(&program: UInt32; location: Int32; x: real);
    external 'opengl32.dll' name 'glProgramUniform1dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dEXT(&program: UInt32; location: Int32; x: real) :=
    z_ProgramUniform1dEXT_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2dEXT_ovr_0(&program: UInt32; location: Int32; x: real; y: real);
    external 'opengl32.dll' name 'glProgramUniform2dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dEXT(&program: UInt32; location: Int32; x: real; y: real) :=
    z_ProgramUniform2dEXT_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3dEXT_ovr_0(&program: UInt32; location: Int32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glProgramUniform3dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dEXT(&program: UInt32; location: Int32; x: real; y: real; z: real) :=
    z_ProgramUniform3dEXT_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4dEXT_ovr_0(&program: UInt32; location: Int32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramUniform4dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dEXT(&program: UInt32; location: Int32; x: real; y: real; z: real; w: real) :=
    z_ProgramUniform4dEXT_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform1dvEXT';
    private static procedure z_ProgramUniform1dvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform1dvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1dvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1dvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform2dvEXT';
    private static procedure z_ProgramUniform2dvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform2dvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2dvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2dvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform3dvEXT';
    private static procedure z_ProgramUniform3dvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform3dvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3dvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3dvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: real);
    external 'opengl32.dll' name 'glProgramUniform4dvEXT';
    private static procedure z_ProgramUniform4dvEXT_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: UInt32; location: Int32; count: Int32; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4dvEXT_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4dvEXT_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: UInt32; location: Int32; count: Int32; var value: real) :=
    z_ProgramUniform4dvEXT_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4dvEXT(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4dvEXT_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniformMatrix2dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dvEXT';
    private static procedure z_ProgramUniformMatrix2dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dvEXT';
    private static procedure z_ProgramUniformMatrix3dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dvEXT';
    private static procedure z_ProgramUniformMatrix4dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x3dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dvEXT';
    private static procedure z_ProgramUniformMatrix2x3dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x3dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x3dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix2x4dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dvEXT';
    private static procedure z_ProgramUniformMatrix2x4dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix2x4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix2x4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix2x4dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix2x4dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix2x4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix2x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix2x4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x2dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dvEXT';
    private static procedure z_ProgramUniformMatrix3x2dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x2dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x2dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix3x4dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dvEXT';
    private static procedure z_ProgramUniformMatrix3x4dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix3x4dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix3x4dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix3x4dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix3x4dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix3x4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix3x4dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix3x4dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x2dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dvEXT';
    private static procedure z_ProgramUniformMatrix4x2dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x2dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x2dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x2dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x2dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x2dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x2dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_ProgramUniformMatrix4x3dvEXT_ovr_0(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dvEXT';
    private static procedure z_ProgramUniformMatrix4x3dvEXT_ovr_0_anh000001(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: array of real) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformMatrix4x3dvEXT_ovr_0(&program, location, count, transpose, value[0]) else
      z_ProgramUniformMatrix4x3dvEXT_ovr_0_anh000001(&program, location, count, transpose, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; var value: real) :=
    z_ProgramUniformMatrix4x3dvEXT_ovr_0(&program, location, count, transpose, value);
    private static procedure z_ProgramUniformMatrix4x3dvEXT_ovr_2(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformMatrix4x3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformMatrix4x3dvEXT(&program: UInt32; location: Int32; count: Int32; transpose: boolean; value: IntPtr) :=
    z_ProgramUniformMatrix4x3dvEXT_ovr_2(&program, location, count, transpose, value);
    
    private static procedure z_TextureBufferRangeEXT_ovr_0(texture: UInt32; target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glTextureBufferRangeEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBufferRangeEXT(texture: UInt32; target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32; offset: IntPtr; size: IntPtr) :=
    z_TextureBufferRangeEXT_ovr_0(texture, target, _internalformat, buffer, offset, size);
    
    private static procedure z_TextureStorage1DEXT_ovr_0(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32);
    external 'opengl32.dll' name 'glTextureStorage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage1DEXT(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32) :=
    z_TextureStorage1DEXT_ovr_0(texture, target, levels, _internalformat, width);
    
    private static procedure z_TextureStorage2DEXT_ovr_0(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glTextureStorage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DEXT(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_TextureStorage2DEXT_ovr_0(texture, target, levels, _internalformat, width, height);
    
    private static procedure z_TextureStorage3DEXT_ovr_0(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glTextureStorage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DEXT(texture: UInt32; target: DummyEnum; levels: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32) :=
    z_TextureStorage3DEXT_ovr_0(texture, target, levels, _internalformat, width, height, depth);
    
    private static procedure z_TextureStorage2DMultisampleEXT_ovr_0(texture: UInt32; target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTextureStorage2DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage2DMultisampleEXT(texture: UInt32; target: TextureTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage2DMultisampleEXT_ovr_0(texture, target, samples, _internalformat, width, height, fixedsamplelocations);
    
    private static procedure z_TextureStorage3DMultisampleEXT_ovr_0(texture: UInt32; target: DummyEnum; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glTextureStorage3DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorage3DMultisampleEXT(texture: UInt32; target: DummyEnum; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; fixedsamplelocations: boolean) :=
    z_TextureStorage3DMultisampleEXT_ovr_0(texture, target, samples, _internalformat, width, height, depth, fixedsamplelocations);
    
    private static procedure z_VertexArrayBindVertexBufferEXT_ovr_0(vaobj: UInt32; bindingindex: UInt32; buffer: UInt32; offset: IntPtr; stride: Int32);
    external 'opengl32.dll' name 'glVertexArrayBindVertexBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayBindVertexBufferEXT(vaobj: UInt32; bindingindex: UInt32; buffer: UInt32; offset: IntPtr; stride: Int32) :=
    z_VertexArrayBindVertexBufferEXT_ovr_0(vaobj, bindingindex, buffer, offset, stride);
    
    private static procedure z_VertexArrayVertexAttribFormatEXT_ovr_0(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribFormatEXT(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribFormatEXT_ovr_0(vaobj, attribindex, size, &type, normalized, relativeoffset);
    
    private static procedure z_VertexArrayVertexAttribIFormatEXT_ovr_0(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribIFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribIFormatEXT(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribIType; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribIFormatEXT_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexArrayVertexAttribLFormatEXT_ovr_0(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribLFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribLFormatEXT(vaobj: UInt32; attribindex: UInt32; size: Int32; &type: VertexAttribLType; relativeoffset: UInt32) :=
    z_VertexArrayVertexAttribLFormatEXT_ovr_0(vaobj, attribindex, size, &type, relativeoffset);
    
    private static procedure z_VertexArrayVertexAttribBindingEXT_ovr_0(vaobj: UInt32; attribindex: UInt32; bindingindex: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribBindingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribBindingEXT(vaobj: UInt32; attribindex: UInt32; bindingindex: UInt32) :=
    z_VertexArrayVertexAttribBindingEXT_ovr_0(vaobj, attribindex, bindingindex);
    
    private static procedure z_VertexArrayVertexBindingDivisorEXT_ovr_0(vaobj: UInt32; bindingindex: UInt32; divisor: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexBindingDivisorEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexBindingDivisorEXT(vaobj: UInt32; bindingindex: UInt32; divisor: UInt32) :=
    z_VertexArrayVertexBindingDivisorEXT_ovr_0(vaobj, bindingindex, divisor);
    
    private static procedure z_VertexArrayVertexAttribLOffsetEXT_ovr_0(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; offset: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribLOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribLOffsetEXT(vaobj: UInt32; buffer: UInt32; index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32; offset: IntPtr) :=
    z_VertexArrayVertexAttribLOffsetEXT_ovr_0(vaobj, buffer, index, size, &type, stride, offset);
    
    private static procedure z_TexturePageCommitmentEXT_ovr_0(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean);
    external 'opengl32.dll' name 'glTexturePageCommitmentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexturePageCommitmentEXT(texture: UInt32; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; commit: boolean) :=
    z_TexturePageCommitmentEXT_ovr_0(texture, level, xoffset, yoffset, zoffset, width, height, depth, commit);
    
    private static procedure z_VertexArrayVertexAttribDivisorEXT_ovr_0(vaobj: UInt32; index: UInt32; divisor: UInt32);
    external 'opengl32.dll' name 'glVertexArrayVertexAttribDivisorEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayVertexAttribDivisorEXT(vaobj: UInt32; index: UInt32; divisor: UInt32) :=
    z_VertexArrayVertexAttribDivisorEXT_ovr_0(vaobj, index, divisor);
    
  end;
  
  glDrawBuffers2EXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ColorMaskIndexedEXT_ovr_0(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean);
    external 'opengl32.dll' name 'glColorMaskIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorMaskIndexedEXT(index: UInt32; r: boolean; g: boolean; b: boolean; a: boolean) :=
    z_ColorMaskIndexedEXT_ovr_0(index, r, g, b, a);
    
    private static procedure z_GetBooleanIndexedvEXT_ovr_0(target: BufferTargetARB; index: UInt32; var data: boolean);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    private static procedure z_GetBooleanIndexedvEXT_ovr_0_anh0001(target: BufferTargetARB; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetBooleanIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetBooleanIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; var data: boolean) :=
    z_GetBooleanIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetBooleanIndexedvEXT_ovr_2(target: BufferTargetARB; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetBooleanIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBooleanIndexedvEXT(target: BufferTargetARB; index: UInt32; data: IntPtr) :=
    z_GetBooleanIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_GetIntegerIndexedvEXT_ovr_0(target: DummyEnum; index: UInt32; var data: Int32);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    private static procedure z_GetIntegerIndexedvEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetIntegerIndexedvEXT_ovr_0(target, index, data[0]) else
      z_GetIntegerIndexedvEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; var data: Int32) :=
    z_GetIntegerIndexedvEXT_ovr_0(target, index, data);
    private static procedure z_GetIntegerIndexedvEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerIndexedvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerIndexedvEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetIntegerIndexedvEXT_ovr_2(target, index, data);
    
    private static procedure z_EnableIndexedEXT_ovr_0(target: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glEnableIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_EnableIndexedEXT_ovr_0(target, index);
    
    private static procedure z_DisableIndexedEXT_ovr_0(target: EnableCap; index: UInt32);
    external 'opengl32.dll' name 'glDisableIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableIndexedEXT(target: EnableCap; index: UInt32) :=
    z_DisableIndexedEXT_ovr_0(target, index);
    
    private static function z_IsEnabledIndexedEXT_ovr_0(target: EnableCap; index: UInt32): boolean;
    external 'opengl32.dll' name 'glIsEnabledIndexedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsEnabledIndexedEXT(target: EnableCap; index: UInt32): boolean :=
    z_IsEnabledIndexedEXT_ovr_0(target, index);
    
  end;
  
  glDrawInstancedEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawArraysInstancedEXT_ovr_0(mode: PrimitiveType; start: Int32; count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glDrawArraysInstancedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysInstancedEXT(mode: PrimitiveType; start: Int32; count: Int32; primcount: Int32) :=
    z_DrawArraysInstancedEXT_ovr_0(mode, start, count, primcount);
    
    private static procedure z_DrawElementsInstancedEXT_ovr_0(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glDrawElementsInstancedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawElementsInstancedEXT(mode: PrimitiveType; count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32) :=
    z_DrawElementsInstancedEXT_ovr_0(mode, count, &type, indices, primcount);
    
  end;
  
  glDrawRangeElementsEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawRangeElementsEXT_ovr_0(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr);
    external 'opengl32.dll' name 'glDrawRangeElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawRangeElementsEXT(mode: PrimitiveType; start: UInt32; &end: UInt32; count: Int32; &type: DrawElementsType; indices: IntPtr) :=
    z_DrawRangeElementsEXT_ovr_0(mode, start, &end, count, &type, indices);
    
  end;
  
  glExternalBufferEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BufferStorageExternalEXT_ovr_0(target: DummyEnum; offset: IntPtr; size: IntPtr; clientBuffer: GLeglClientBufferEXT; flags: BufferStorageMask);
    external 'opengl32.dll' name 'glBufferStorageExternalEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorageExternalEXT(target: DummyEnum; offset: IntPtr; size: IntPtr; clientBuffer: GLeglClientBufferEXT; flags: BufferStorageMask) :=
    z_BufferStorageExternalEXT_ovr_0(target, offset, size, clientBuffer, flags);
    
    private static procedure z_NamedBufferStorageExternalEXT_ovr_0(buffer: UInt32; offset: IntPtr; size: IntPtr; clientBuffer: GLeglClientBufferEXT; flags: BufferStorageMask);
    external 'opengl32.dll' name 'glNamedBufferStorageExternalEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageExternalEXT(buffer: UInt32; offset: IntPtr; size: IntPtr; clientBuffer: GLeglClientBufferEXT; flags: BufferStorageMask) :=
    z_NamedBufferStorageExternalEXT_ovr_0(buffer, offset, size, clientBuffer, flags);
    
  end;
  
  glFogCoordEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FogCoordfEXT_ovr_0(coord: single);
    external 'opengl32.dll' name 'glFogCoordfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfEXT(coord: single) :=
    z_FogCoordfEXT_ovr_0(coord);
    
    private static procedure z_FogCoordfvEXT_ovr_0(var coord: single);
    external 'opengl32.dll' name 'glFogCoordfvEXT';
    private static procedure z_FogCoordfvEXT_ovr_0_anh01(coord: IntPtr);
    external 'opengl32.dll' name 'glFogCoordfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfvEXT(coord: array of single) :=
    if (coord<>nil) and (coord.Length<>0) then
      z_FogCoordfvEXT_ovr_0(coord[0]) else
      z_FogCoordfvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfvEXT(var coord: single) :=
    z_FogCoordfvEXT_ovr_0(coord);
    private static procedure z_FogCoordfvEXT_ovr_2(coord: IntPtr);
    external 'opengl32.dll' name 'glFogCoordfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordfvEXT(coord: IntPtr) :=
    z_FogCoordfvEXT_ovr_2(coord);
    
    private static procedure z_FogCoorddEXT_ovr_0(coord: real);
    external 'opengl32.dll' name 'glFogCoorddEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddEXT(coord: real) :=
    z_FogCoorddEXT_ovr_0(coord);
    
    private static procedure z_FogCoorddvEXT_ovr_0(var coord: real);
    external 'opengl32.dll' name 'glFogCoorddvEXT';
    private static procedure z_FogCoorddvEXT_ovr_0_anh01(coord: IntPtr);
    external 'opengl32.dll' name 'glFogCoorddvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddvEXT(coord: array of real) :=
    if (coord<>nil) and (coord.Length<>0) then
      z_FogCoorddvEXT_ovr_0(coord[0]) else
      z_FogCoorddvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddvEXT(var coord: real) :=
    z_FogCoorddvEXT_ovr_0(coord);
    private static procedure z_FogCoorddvEXT_ovr_2(coord: IntPtr);
    external 'opengl32.dll' name 'glFogCoorddvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoorddvEXT(coord: IntPtr) :=
    z_FogCoorddvEXT_ovr_2(coord);
    
    private static procedure z_FogCoordPointerEXT_ovr_0(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glFogCoordPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerEXT(&type: FogPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_FogCoordPointerEXT_ovr_0(&type, stride, pointer);
    
  end;
  
  glFramebufferBlitEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlitFramebufferEXT_ovr_0(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter);
    external 'opengl32.dll' name 'glBlitFramebufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlitFramebufferEXT(srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: BlitFramebufferFilter) :=
    z_BlitFramebufferEXT_ovr_0(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
  end;
  
  glFramebufferMultisampleEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RenderbufferStorageMultisampleEXT_ovr_0(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorageMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleEXT(target: RenderbufferTarget; samples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleEXT_ovr_0(target, samples, _internalformat, width, height);
    
  end;
  
  glFramebufferObjectEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_IsRenderbufferEXT_ovr_0(renderbuffer: UInt32): boolean;
    external 'opengl32.dll' name 'glIsRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsRenderbufferEXT(renderbuffer: UInt32): boolean :=
    z_IsRenderbufferEXT_ovr_0(renderbuffer);
    
    private static procedure z_BindRenderbufferEXT_ovr_0(target: RenderbufferTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glBindRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindRenderbufferEXT(target: RenderbufferTarget; renderbuffer: UInt32) :=
    z_BindRenderbufferEXT_ovr_0(target, renderbuffer);
    
    private static procedure z_DeleteRenderbuffersEXT_ovr_0(n: Int32; var renderbuffers: UInt32);
    external 'opengl32.dll' name 'glDeleteRenderbuffersEXT';
    private static procedure z_DeleteRenderbuffersEXT_ovr_0_anh001(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteRenderbuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_DeleteRenderbuffersEXT_ovr_0(n, renderbuffers[0]) else
      z_DeleteRenderbuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; var renderbuffers: UInt32) :=
    z_DeleteRenderbuffersEXT_ovr_0(n, renderbuffers);
    private static procedure z_DeleteRenderbuffersEXT_ovr_2(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteRenderbuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteRenderbuffersEXT(n: Int32; renderbuffers: IntPtr) :=
    z_DeleteRenderbuffersEXT_ovr_2(n, renderbuffers);
    
    private static procedure z_GenRenderbuffersEXT_ovr_0(n: Int32; var renderbuffers: UInt32);
    external 'opengl32.dll' name 'glGenRenderbuffersEXT';
    private static procedure z_GenRenderbuffersEXT_ovr_0_anh001(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glGenRenderbuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; renderbuffers: array of UInt32) :=
    if (renderbuffers<>nil) and (renderbuffers.Length<>0) then
      z_GenRenderbuffersEXT_ovr_0(n, renderbuffers[0]) else
      z_GenRenderbuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; var renderbuffers: UInt32) :=
    z_GenRenderbuffersEXT_ovr_0(n, renderbuffers);
    private static procedure z_GenRenderbuffersEXT_ovr_2(n: Int32; renderbuffers: IntPtr);
    external 'opengl32.dll' name 'glGenRenderbuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenRenderbuffersEXT(n: Int32; renderbuffers: IntPtr) :=
    z_GenRenderbuffersEXT_ovr_2(n, renderbuffers);
    
    private static procedure z_RenderbufferStorageEXT_ovr_0(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorageEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageEXT(target: RenderbufferTarget; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageEXT_ovr_0(target, _internalformat, width, height);
    
    private static procedure z_GetRenderbufferParameterivEXT_ovr_0(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetRenderbufferParameterivEXT';
    private static procedure z_GetRenderbufferParameterivEXT_ovr_0_anh0001(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetRenderbufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetRenderbufferParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetRenderbufferParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; var &params: Int32) :=
    z_GetRenderbufferParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetRenderbufferParameterivEXT_ovr_2(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetRenderbufferParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetRenderbufferParameterivEXT(target: RenderbufferTarget; pname: RenderbufferParameterName; &params: IntPtr) :=
    z_GetRenderbufferParameterivEXT_ovr_2(target, pname, &params);
    
    private static function z_IsFramebufferEXT_ovr_0(framebuffer: UInt32): boolean;
    external 'opengl32.dll' name 'glIsFramebufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFramebufferEXT(framebuffer: UInt32): boolean :=
    z_IsFramebufferEXT_ovr_0(framebuffer);
    
    private static procedure z_BindFramebufferEXT_ovr_0(target: FramebufferTarget; framebuffer: UInt32);
    external 'opengl32.dll' name 'glBindFramebufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFramebufferEXT(target: FramebufferTarget; framebuffer: UInt32) :=
    z_BindFramebufferEXT_ovr_0(target, framebuffer);
    
    private static procedure z_DeleteFramebuffersEXT_ovr_0(n: Int32; var framebuffers: UInt32);
    external 'opengl32.dll' name 'glDeleteFramebuffersEXT';
    private static procedure z_DeleteFramebuffersEXT_ovr_0_anh001(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteFramebuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_DeleteFramebuffersEXT_ovr_0(n, framebuffers[0]) else
      z_DeleteFramebuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; var framebuffers: UInt32) :=
    z_DeleteFramebuffersEXT_ovr_0(n, framebuffers);
    private static procedure z_DeleteFramebuffersEXT_ovr_2(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glDeleteFramebuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFramebuffersEXT(n: Int32; framebuffers: IntPtr) :=
    z_DeleteFramebuffersEXT_ovr_2(n, framebuffers);
    
    private static procedure z_GenFramebuffersEXT_ovr_0(n: Int32; var framebuffers: UInt32);
    external 'opengl32.dll' name 'glGenFramebuffersEXT';
    private static procedure z_GenFramebuffersEXT_ovr_0_anh001(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glGenFramebuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; framebuffers: array of UInt32) :=
    if (framebuffers<>nil) and (framebuffers.Length<>0) then
      z_GenFramebuffersEXT_ovr_0(n, framebuffers[0]) else
      z_GenFramebuffersEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; var framebuffers: UInt32) :=
    z_GenFramebuffersEXT_ovr_0(n, framebuffers);
    private static procedure z_GenFramebuffersEXT_ovr_2(n: Int32; framebuffers: IntPtr);
    external 'opengl32.dll' name 'glGenFramebuffersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFramebuffersEXT(n: Int32; framebuffers: IntPtr) :=
    z_GenFramebuffersEXT_ovr_2(n, framebuffers);
    
    private static function z_CheckFramebufferStatusEXT_ovr_0(target: FramebufferTarget): FramebufferStatus;
    external 'opengl32.dll' name 'glCheckFramebufferStatusEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CheckFramebufferStatusEXT(target: FramebufferTarget): FramebufferStatus :=
    z_CheckFramebufferStatusEXT_ovr_0(target);
    
    private static procedure z_FramebufferTexture1DEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture1DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture1DEXT_ovr_0(target, attachment, textarget, texture, level);
    
    private static procedure z_FramebufferTexture2DEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture2DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32) :=
    z_FramebufferTexture2DEXT_ovr_0(target, attachment, textarget, texture, level);
    
    private static procedure z_FramebufferTexture3DEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32);
    external 'opengl32.dll' name 'glFramebufferTexture3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTexture3DEXT(target: FramebufferTarget; attachment: FramebufferAttachment; textarget: TextureTarget; texture: UInt32; level: Int32; zoffset: Int32) :=
    z_FramebufferTexture3DEXT_ovr_0(target, attachment, textarget, texture, level, zoffset);
    
    private static procedure z_FramebufferRenderbufferEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glFramebufferRenderbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferRenderbufferEXT(target: FramebufferTarget; attachment: FramebufferAttachment; _renderbuffertarget: RenderbufferTarget; renderbuffer: UInt32) :=
    z_FramebufferRenderbufferEXT_ovr_0(target, attachment, _renderbuffertarget, renderbuffer);
    
    private static procedure z_GetFramebufferAttachmentParameterivEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameterivEXT';
    private static procedure z_GetFramebufferAttachmentParameterivEXT_ovr_0_anh00001(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferAttachmentParameterivEXT_ovr_0(target, attachment, pname, &params[0]) else
      z_GetFramebufferAttachmentParameterivEXT_ovr_0_anh00001(target, attachment, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferAttachmentParameterivEXT_ovr_0(target, attachment, pname, &params);
    private static procedure z_GetFramebufferAttachmentParameterivEXT_ovr_2(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferAttachmentParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferAttachmentParameterivEXT(target: FramebufferTarget; attachment: FramebufferAttachment; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferAttachmentParameterivEXT_ovr_2(target, attachment, pname, &params);
    
    private static procedure z_GenerateMipmapEXT_ovr_0(target: TextureTarget);
    external 'opengl32.dll' name 'glGenerateMipmapEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenerateMipmapEXT(target: TextureTarget) :=
    z_GenerateMipmapEXT_ovr_0(target);
    
  end;
  
  glGeometryShader4EXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramParameteriEXT_ovr_0(&program: UInt32; pname: ProgramParameterPName; value: Int32);
    external 'opengl32.dll' name 'glProgramParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameteriEXT(&program: UInt32; pname: ProgramParameterPName; value: Int32) :=
    z_ProgramParameteriEXT_ovr_0(&program, pname, value);
    
  end;
  
  glGpuProgramParametersEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramEnvParameters4fvEXT_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: single);
    external 'opengl32.dll' name 'glProgramEnvParameters4fvEXT';
    private static procedure z_ProgramEnvParameters4fvEXT_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameters4fvEXT_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParameters4fvEXT_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_ProgramEnvParameters4fvEXT_ovr_0(target, index, count, &params);
    private static procedure z_ProgramEnvParameters4fvEXT_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParameters4fvEXT_ovr_2(target, index, count, &params);
    
    private static procedure z_ProgramLocalParameters4fvEXT_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: single);
    external 'opengl32.dll' name 'glProgramLocalParameters4fvEXT';
    private static procedure z_ProgramLocalParameters4fvEXT_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameters4fvEXT_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParameters4fvEXT_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; var &params: single) :=
    z_ProgramLocalParameters4fvEXT_ovr_0(target, index, count, &params);
    private static procedure z_ProgramLocalParameters4fvEXT_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameters4fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameters4fvEXT(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParameters4fvEXT_ovr_2(target, index, count, &params);
    
  end;
  
  glGpuShader4EXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetUniformuivEXT_ovr_0(&program: UInt32; location: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetUniformuivEXT';
    private static procedure z_GetUniformuivEXT_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: UInt32; location: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformuivEXT_ovr_0(&program, location, &params[0]) else
      z_GetUniformuivEXT_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: UInt32; location: Int32; var &params: UInt32) :=
    z_GetUniformuivEXT_ovr_0(&program, location, &params);
    private static procedure z_GetUniformuivEXT_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformuivEXT(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformuivEXT_ovr_2(&program, location, &params);
    
    private static procedure z_BindFragDataLocationEXT_ovr_0(&program: UInt32; color: UInt32; name: IntPtr);
    external 'opengl32.dll' name 'glBindFragDataLocationEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationEXT(&program: UInt32; color: UInt32; name: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_BindFragDataLocationEXT_ovr_0(&program, color, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindFragDataLocationEXT(&program: UInt32; color: UInt32; name: IntPtr) :=
    z_BindFragDataLocationEXT_ovr_0(&program, color, name);
    
    private static function z_GetFragDataLocationEXT_ovr_0(&program: UInt32; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetFragDataLocationEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocationEXT(&program: UInt32; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetFragDataLocationEXT_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetFragDataLocationEXT(&program: UInt32; name: IntPtr): Int32 :=
    z_GetFragDataLocationEXT_ovr_0(&program, name);
    
    private static procedure z_Uniform1uiEXT_ovr_0(location: Int32; v0: UInt32);
    external 'opengl32.dll' name 'glUniform1uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uiEXT(location: Int32; v0: UInt32) :=
    z_Uniform1uiEXT_ovr_0(location, v0);
    
    private static procedure z_Uniform2uiEXT_ovr_0(location: Int32; v0: UInt32; v1: UInt32);
    external 'opengl32.dll' name 'glUniform2uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uiEXT(location: Int32; v0: UInt32; v1: UInt32) :=
    z_Uniform2uiEXT_ovr_0(location, v0, v1);
    
    private static procedure z_Uniform3uiEXT_ovr_0(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32);
    external 'opengl32.dll' name 'glUniform3uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uiEXT(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32) :=
    z_Uniform3uiEXT_ovr_0(location, v0, v1, v2);
    
    private static procedure z_Uniform4uiEXT_ovr_0(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32);
    external 'opengl32.dll' name 'glUniform4uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uiEXT(location: Int32; v0: UInt32; v1: UInt32; v2: UInt32; v3: UInt32) :=
    z_Uniform4uiEXT_ovr_0(location, v0, v1, v2, v3);
    
    private static procedure z_Uniform1uivEXT_ovr_0(location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glUniform1uivEXT';
    private static procedure z_Uniform1uivEXT_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform1uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform1uivEXT_ovr_0(location, count, value);
    private static procedure z_Uniform1uivEXT_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1uivEXT_ovr_2(location, count, value);
    
    private static procedure z_Uniform2uivEXT_ovr_0(location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glUniform2uivEXT';
    private static procedure z_Uniform2uivEXT_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform2uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform2uivEXT_ovr_0(location, count, value);
    private static procedure z_Uniform2uivEXT_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2uivEXT_ovr_2(location, count, value);
    
    private static procedure z_Uniform3uivEXT_ovr_0(location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glUniform3uivEXT';
    private static procedure z_Uniform3uivEXT_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform3uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform3uivEXT_ovr_0(location, count, value);
    private static procedure z_Uniform3uivEXT_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3uivEXT_ovr_2(location, count, value);
    
    private static procedure z_Uniform4uivEXT_ovr_0(location: Int32; count: Int32; var value: UInt32);
    external 'opengl32.dll' name 'glUniform4uivEXT';
    private static procedure z_Uniform4uivEXT_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; value: array of UInt32) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4uivEXT_ovr_0(location, count, value[0]) else
      z_Uniform4uivEXT_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; var value: UInt32) :=
    z_Uniform4uivEXT_ovr_0(location, count, value);
    private static procedure z_Uniform4uivEXT_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4uivEXT(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4uivEXT_ovr_2(location, count, value);
    
  end;
  
  glHistogramEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetHistogramEXT_ovr_0(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramEXT(target: HistogramTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetHistogramEXT_ovr_0(target, reset, format, &type, values);
    
    private static procedure z_GetHistogramParameterfvEXT_ovr_0(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single);
    external 'opengl32.dll' name 'glGetHistogramParameterfvEXT';
    private static procedure z_GetHistogramParameterfvEXT_ovr_0_anh0001(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: single) :=
    z_GetHistogramParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_GetHistogramParameterfvEXT_ovr_2(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterfvEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterfvEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetHistogramParameterivEXT_ovr_0(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetHistogramParameterivEXT';
    private static procedure z_GetHistogramParameterivEXT_ovr_0_anh0001(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Int32) :=
    z_GetHistogramParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetHistogramParameterivEXT_ovr_2(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterivEXT(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetMinmaxEXT_ovr_0(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxEXT(target: MinmaxTargetEXT; reset: boolean; format: PixelFormat; &type: PixelType; values: IntPtr) :=
    z_GetMinmaxEXT_ovr_0(target, reset, format, &type, values);
    
    private static procedure z_GetMinmaxParameterfvEXT_ovr_0(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single);
    external 'opengl32.dll' name 'glGetMinmaxParameterfvEXT';
    private static procedure z_GetMinmaxParameterfvEXT_ovr_0_anh0001(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: single) :=
    z_GetMinmaxParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_GetMinmaxParameterfvEXT_ovr_2(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterfvEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterfvEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetMinmaxParameterivEXT_ovr_0(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32);
    external 'opengl32.dll' name 'glGetMinmaxParameterivEXT';
    private static procedure z_GetMinmaxParameterivEXT_ovr_0_anh0001(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMinmaxParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetMinmaxParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; var &params: Int32) :=
    z_GetMinmaxParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetMinmaxParameterivEXT_ovr_2(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMinmaxParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMinmaxParameterivEXT(target: MinmaxTargetEXT; pname: GetMinmaxParameterPNameEXT; &params: IntPtr) :=
    z_GetMinmaxParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_HistogramEXT_ovr_0(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean);
    external 'opengl32.dll' name 'glHistogramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure HistogramEXT(target: HistogramTargetEXT; width: Int32; _internalformat: InternalFormat; sink: boolean) :=
    z_HistogramEXT_ovr_0(target, width, _internalformat, sink);
    
    private static procedure z_MinmaxEXT_ovr_0(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean);
    external 'opengl32.dll' name 'glMinmaxEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MinmaxEXT(target: MinmaxTargetEXT; _internalformat: InternalFormat; sink: boolean) :=
    z_MinmaxEXT_ovr_0(target, _internalformat, sink);
    
    private static procedure z_ResetHistogramEXT_ovr_0(target: HistogramTargetEXT);
    external 'opengl32.dll' name 'glResetHistogramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetHistogramEXT(target: HistogramTargetEXT) :=
    z_ResetHistogramEXT_ovr_0(target);
    
    private static procedure z_ResetMinmaxEXT_ovr_0(target: MinmaxTargetEXT);
    external 'opengl32.dll' name 'glResetMinmaxEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMinmaxEXT(target: MinmaxTargetEXT) :=
    z_ResetMinmaxEXT_ovr_0(target);
    
  end;
  
  glIndexFuncEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_IndexFuncEXT_ovr_0(func: IndexFunctionEXT; ref: single);
    external 'opengl32.dll' name 'glIndexFuncEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexFuncEXT(func: IndexFunctionEXT; ref: single) :=
    z_IndexFuncEXT_ovr_0(func, ref);
    
  end;
  
  glIndexMaterialEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_IndexMaterialEXT_ovr_0(face: DummyEnum; mode: IndexMaterialParameterEXT);
    external 'opengl32.dll' name 'glIndexMaterialEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexMaterialEXT(face: DummyEnum; mode: IndexMaterialParameterEXT) :=
    z_IndexMaterialEXT_ovr_0(face, mode);
    
  end;
  
  glLightTextureEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ApplyTextureEXT_ovr_0(mode: LightTextureModeEXT);
    external 'opengl32.dll' name 'glApplyTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ApplyTextureEXT(mode: LightTextureModeEXT) :=
    z_ApplyTextureEXT_ovr_0(mode);
    
    private static procedure z_TextureLightEXT_ovr_0(pname: LightTexturePNameEXT);
    external 'opengl32.dll' name 'glTextureLightEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureLightEXT(pname: LightTexturePNameEXT) :=
    z_TextureLightEXT_ovr_0(pname);
    
    private static procedure z_TextureMaterialEXT_ovr_0(face: DummyEnum; mode: MaterialParameter);
    external 'opengl32.dll' name 'glTextureMaterialEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureMaterialEXT(face: DummyEnum; mode: MaterialParameter) :=
    z_TextureMaterialEXT_ovr_0(face, mode);
    
  end;
  
  glMemoryObjectEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetUnsignedBytevEXT_ovr_0(pname: GetPName; var data: Byte);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    private static procedure z_GetUnsignedBytevEXT_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytevEXT_ovr_0(pname, data[0]) else
      z_GetUnsignedBytevEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; var data: Byte) :=
    z_GetUnsignedBytevEXT_ovr_0(pname, data);
    private static procedure z_GetUnsignedBytevEXT_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: IntPtr) :=
    z_GetUnsignedBytevEXT_ovr_2(pname, data);
    
    private static procedure z_GetUnsignedBytei_vEXT_ovr_0(target: DummyEnum; index: UInt32; var data: Byte);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    private static procedure z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytei_vEXT_ovr_0(target, index, data[0]) else
      z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; var data: Byte) :=
    z_GetUnsignedBytei_vEXT_ovr_0(target, index, data);
    private static procedure z_GetUnsignedBytei_vEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetUnsignedBytei_vEXT_ovr_2(target, index, data);
    
    private static procedure z_DeleteMemoryObjectsEXT_ovr_0(n: Int32; var memoryObjects: UInt32);
    external 'opengl32.dll' name 'glDeleteMemoryObjectsEXT';
    private static procedure z_DeleteMemoryObjectsEXT_ovr_0_anh001(n: Int32; memoryObjects: IntPtr);
    external 'opengl32.dll' name 'glDeleteMemoryObjectsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; memoryObjects: array of UInt32) :=
    if (memoryObjects<>nil) and (memoryObjects.Length<>0) then
      z_DeleteMemoryObjectsEXT_ovr_0(n, memoryObjects[0]) else
      z_DeleteMemoryObjectsEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; var memoryObjects: UInt32) :=
    z_DeleteMemoryObjectsEXT_ovr_0(n, memoryObjects);
    private static procedure z_DeleteMemoryObjectsEXT_ovr_2(n: Int32; memoryObjects: IntPtr);
    external 'opengl32.dll' name 'glDeleteMemoryObjectsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteMemoryObjectsEXT(n: Int32; memoryObjects: IntPtr) :=
    z_DeleteMemoryObjectsEXT_ovr_2(n, memoryObjects);
    
    private static function z_IsMemoryObjectEXT_ovr_0(memoryObject: UInt32): boolean;
    external 'opengl32.dll' name 'glIsMemoryObjectEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsMemoryObjectEXT(memoryObject: UInt32): boolean :=
    z_IsMemoryObjectEXT_ovr_0(memoryObject);
    
    private static procedure z_CreateMemoryObjectsEXT_ovr_0(n: Int32; var memoryObjects: UInt32);
    external 'opengl32.dll' name 'glCreateMemoryObjectsEXT';
    private static procedure z_CreateMemoryObjectsEXT_ovr_0_anh001(n: Int32; memoryObjects: IntPtr);
    external 'opengl32.dll' name 'glCreateMemoryObjectsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; memoryObjects: array of UInt32) :=
    if (memoryObjects<>nil) and (memoryObjects.Length<>0) then
      z_CreateMemoryObjectsEXT_ovr_0(n, memoryObjects[0]) else
      z_CreateMemoryObjectsEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; var memoryObjects: UInt32) :=
    z_CreateMemoryObjectsEXT_ovr_0(n, memoryObjects);
    private static procedure z_CreateMemoryObjectsEXT_ovr_2(n: Int32; memoryObjects: IntPtr);
    external 'opengl32.dll' name 'glCreateMemoryObjectsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateMemoryObjectsEXT(n: Int32; memoryObjects: IntPtr) :=
    z_CreateMemoryObjectsEXT_ovr_2(n, memoryObjects);
    
    private static procedure z_MemoryObjectParameterivEXT_ovr_0(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glMemoryObjectParameterivEXT';
    private static procedure z_MemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMemoryObjectParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params[0]) else
      z_MemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32) :=
    z_MemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params);
    private static procedure z_MemoryObjectParameterivEXT_ovr_2(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glMemoryObjectParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr) :=
    z_MemoryObjectParameterivEXT_ovr_2(memoryObject, pname, &params);
    
    private static procedure z_GetMemoryObjectParameterivEXT_ovr_0(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetMemoryObjectParameterivEXT';
    private static procedure z_GetMemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMemoryObjectParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params[0]) else
      z_GetMemoryObjectParameterivEXT_ovr_0_anh0001(memoryObject, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; var &params: Int32) :=
    z_GetMemoryObjectParameterivEXT_ovr_0(memoryObject, pname, &params);
    private static procedure z_GetMemoryObjectParameterivEXT_ovr_2(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMemoryObjectParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectParameterivEXT(memoryObject: UInt32; pname: MemoryObjectParameterName; &params: IntPtr) :=
    z_GetMemoryObjectParameterivEXT_ovr_2(memoryObject, pname, &params);
    
    private static procedure z_TexStorageMem2DEXT_ovr_0(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexStorageMem2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem2DEXT(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem2DEXT_ovr_0(target, levels, internalFormat, width, height, memory, offset);
    
    private static procedure z_TexStorageMem2DMultisampleEXT_ovr_0(target: TextureTarget; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexStorageMem2DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem2DMultisampleEXT(target: TextureTarget; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem2DMultisampleEXT_ovr_0(target, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
    
    private static procedure z_TexStorageMem3DEXT_ovr_0(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexStorageMem3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem3DEXT(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem3DEXT_ovr_0(target, levels, internalFormat, width, height, depth, memory, offset);
    
    private static procedure z_TexStorageMem3DMultisampleEXT_ovr_0(target: TextureTarget; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexStorageMem3DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem3DMultisampleEXT(target: TextureTarget; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem3DMultisampleEXT_ovr_0(target, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
    
    private static procedure z_BufferStorageMemEXT_ovr_0(target: BufferTargetARB; size: IntPtr; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glBufferStorageMemEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferStorageMemEXT(target: BufferTargetARB; size: IntPtr; memory: UInt32; offset: UInt64) :=
    z_BufferStorageMemEXT_ovr_0(target, size, memory, offset);
    
    private static procedure z_TextureStorageMem2DEXT_ovr_0(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureStorageMem2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem2DEXT(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem2DEXT_ovr_0(texture, levels, internalFormat, width, height, memory, offset);
    
    private static procedure z_TextureStorageMem2DMultisampleEXT_ovr_0(texture: UInt32; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureStorageMem2DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem2DMultisampleEXT(texture: UInt32; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem2DMultisampleEXT_ovr_0(texture, samples, internalFormat, width, height, fixedSampleLocations, memory, offset);
    
    private static procedure z_TextureStorageMem3DEXT_ovr_0(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureStorageMem3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem3DEXT(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem3DEXT_ovr_0(texture, levels, internalFormat, width, height, depth, memory, offset);
    
    private static procedure z_TextureStorageMem3DMultisampleEXT_ovr_0(texture: UInt32; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureStorageMem3DMultisampleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem3DMultisampleEXT(texture: UInt32; samples: Int32; internalFormat: DummyEnum; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem3DMultisampleEXT_ovr_0(texture, samples, internalFormat, width, height, depth, fixedSampleLocations, memory, offset);
    
    private static procedure z_NamedBufferStorageMemEXT_ovr_0(buffer: UInt32; size: IntPtr; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glNamedBufferStorageMemEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferStorageMemEXT(buffer: UInt32; size: IntPtr; memory: UInt32; offset: UInt64) :=
    z_NamedBufferStorageMemEXT_ovr_0(buffer, size, memory, offset);
    
    private static procedure z_TexStorageMem1DEXT_ovr_0(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexStorageMem1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexStorageMem1DEXT(target: TextureTarget; levels: Int32; internalFormat: DummyEnum; width: Int32; memory: UInt32; offset: UInt64) :=
    z_TexStorageMem1DEXT_ovr_0(target, levels, internalFormat, width, memory, offset);
    
    private static procedure z_TextureStorageMem1DEXT_ovr_0(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureStorageMem1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureStorageMem1DEXT(texture: UInt32; levels: Int32; internalFormat: DummyEnum; width: Int32; memory: UInt32; offset: UInt64) :=
    z_TextureStorageMem1DEXT_ovr_0(texture, levels, internalFormat, width, memory, offset);
    
  end;
  
  glMemoryObjectFdEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ImportMemoryFdEXT_ovr_0(memory: UInt32; size: UInt64; handleType: ExternalHandleType; fd: Int32);
    external 'opengl32.dll' name 'glImportMemoryFdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryFdEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; fd: Int32) :=
    z_ImportMemoryFdEXT_ovr_0(memory, size, handleType, fd);
    
  end;
  
  glMemoryObjectWin32EXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ImportMemoryWin32HandleEXT_ovr_0(memory: UInt32; size: UInt64; handleType: ExternalHandleType; handle: IntPtr);
    external 'opengl32.dll' name 'glImportMemoryWin32HandleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryWin32HandleEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; handle: IntPtr) :=
    z_ImportMemoryWin32HandleEXT_ovr_0(memory, size, handleType, handle);
    
    private static procedure z_ImportMemoryWin32NameEXT_ovr_0(memory: UInt32; size: UInt64; handleType: ExternalHandleType; name: IntPtr);
    external 'opengl32.dll' name 'glImportMemoryWin32NameEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportMemoryWin32NameEXT(memory: UInt32; size: UInt64; handleType: ExternalHandleType; name: IntPtr) :=
    z_ImportMemoryWin32NameEXT_ovr_0(memory, size, handleType, name);
    
  end;
  
  glMultiDrawArraysEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysEXT_ovr_0(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    private static procedure z_MultiDrawArraysEXT_ovr_0_anh00100(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    private static procedure z_MultiDrawArraysEXT_ovr_0_anh00010(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    private static procedure z_MultiDrawArraysEXT_ovr_0_anh00110(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArraysEXT_ovr_0(mode, first[0], count[0], primcount) else
        z_MultiDrawArraysEXT_ovr_0_anh00010(mode, first[0], IntPtr.Zero, primcount) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiDrawArraysEXT_ovr_0_anh00100(mode, IntPtr.Zero, count[0], primcount) else
        z_MultiDrawArraysEXT_ovr_0_anh00110(mode, IntPtr.Zero, IntPtr.Zero, primcount);
    private static procedure z_MultiDrawArraysEXT_ovr_1_anh00100(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArraysEXT_ovr_0(mode, first[0], count, primcount) else
      z_MultiDrawArraysEXT_ovr_0_anh00100(mode, IntPtr.Zero, count, primcount);
    private static procedure z_MultiDrawArraysEXT_ovr_2(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    private static procedure z_MultiDrawArraysEXT_ovr_2_anh00100(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiDrawArraysEXT_ovr_2(mode, first[0], count, primcount) else
      z_MultiDrawArraysEXT_ovr_2_anh00100(mode, IntPtr.Zero, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArraysEXT_ovr_0(mode, first, count[0], primcount) else
      z_MultiDrawArraysEXT_ovr_0_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_0(mode, first, count, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_2(mode, first, count, primcount);
    private static procedure z_MultiDrawArraysEXT_ovr_6(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    private static procedure z_MultiDrawArraysEXT_ovr_6_anh00010(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawArraysEXT_ovr_6(mode, first, count[0], primcount) else
      z_MultiDrawArraysEXT_ovr_6_anh00010(mode, first, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_6(mode, first, count, primcount);
    private static procedure z_MultiDrawArraysEXT_ovr_8(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysEXT(mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32) :=
    z_MultiDrawArraysEXT_ovr_8(mode, first, count, primcount);
    
    private static procedure z_MultiDrawElementsEXT_ovr_0(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    private static procedure z_MultiDrawElementsEXT_ovr_0_anh001000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    private static procedure z_MultiDrawElementsEXT_ovr_0_anh000010(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    private static procedure z_MultiDrawElementsEXT_ovr_0_anh001010(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsEXT_ovr_0(mode, count[0], &type, indices[0], primcount) else
        z_MultiDrawElementsEXT_ovr_0_anh000010(mode, count[0], &type, IntPtr.Zero, primcount) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiDrawElementsEXT_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices[0], primcount) else
        z_MultiDrawElementsEXT_ovr_0_anh001010(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount);
    private static procedure z_MultiDrawElementsEXT_ovr_1_anh001000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsEXT_ovr_0(mode, count[0], &type, indices, primcount) else
      z_MultiDrawElementsEXT_ovr_0_anh001000(mode, IntPtr.Zero, &type, indices, primcount);
    private static procedure z_MultiDrawElementsEXT_ovr_2(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    private static procedure z_MultiDrawElementsEXT_ovr_2_anh001000(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiDrawElementsEXT_ovr_2(mode, count[0], &type, indices, primcount) else
      z_MultiDrawElementsEXT_ovr_2_anh001000(mode, IntPtr.Zero, &type, indices, primcount);
    private static procedure z_MultiDrawElementsEXT_ovr_3_anh000010(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsEXT_ovr_0(mode, count, &type, indices[0], primcount) else
      z_MultiDrawElementsEXT_ovr_0_anh000010(mode, count, &type, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_0(mode, count, &type, indices, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_2(mode, count, &type, indices, primcount);
    private static procedure z_MultiDrawElementsEXT_ovr_6(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    private static procedure z_MultiDrawElementsEXT_ovr_6_anh000010(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiDrawElementsEXT_ovr_6(mode, count, &type, indices[0], primcount) else
      z_MultiDrawElementsEXT_ovr_6_anh000010(mode, count, &type, IntPtr.Zero, primcount);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_6(mode, count, &type, indices, primcount);
    private static procedure z_MultiDrawElementsEXT_ovr_8(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsEXT(mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32) :=
    z_MultiDrawElementsEXT_ovr_8(mode, count, &type, indices, primcount);
    
  end;
  
  glMultisampleEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SampleMaskEXT_ovr_0(value: single; invert: boolean);
    external 'opengl32.dll' name 'glSampleMaskEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskEXT(value: single; invert: boolean) :=
    z_SampleMaskEXT_ovr_0(value, invert);
    
    private static procedure z_SamplePatternEXT_ovr_0(pattern: OpenGL.SamplePatternEXT);
    external 'opengl32.dll' name 'glSamplePatternEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplePatternEXT(pattern: OpenGL.SamplePatternEXT) :=
    z_SamplePatternEXT_ovr_0(pattern);
    
  end;
  
  glPalettedTextureEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ColorTableEXT_ovr_0(target: ColorTableTarget; _internalFormat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr);
    external 'opengl32.dll' name 'glColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableEXT(target: ColorTableTarget; _internalFormat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTableEXT_ovr_0(target, _internalFormat, width, format, &type, table);
    
    private static procedure z_GetColorTableEXT_ovr_0(target: ColorTableTarget; format: PixelFormat; &type: PixelType; data: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableEXT(target: ColorTableTarget; format: PixelFormat; &type: PixelType; data: IntPtr) :=
    z_GetColorTableEXT_ovr_0(target, format, &type, data);
    
    private static procedure z_GetColorTableParameterivEXT_ovr_0(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32);
    external 'opengl32.dll' name 'glGetColorTableParameterivEXT';
    private static procedure z_GetColorTableParameterivEXT_ovr_0_anh0001(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameterivEXT_ovr_2(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetColorTableParameterfvEXT_ovr_0(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single);
    external 'opengl32.dll' name 'glGetColorTableParameterfvEXT';
    private static procedure z_GetColorTableParameterfvEXT_ovr_0_anh0001(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameterfvEXT_ovr_2(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvEXT(target: ColorTableTarget; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfvEXT_ovr_2(target, pname, &params);
    
  end;
  
  glPixelTransformEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PixelTransformParameteriEXT_ovr_0(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: Int32);
    external 'opengl32.dll' name 'glPixelTransformParameteriEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameteriEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: Int32) :=
    z_PixelTransformParameteriEXT_ovr_0(target, pname, param);
    
    private static procedure z_PixelTransformParameterfEXT_ovr_0(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: single);
    external 'opengl32.dll' name 'glPixelTransformParameterfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; param: single) :=
    z_PixelTransformParameterfEXT_ovr_0(target, pname, param);
    
    private static procedure z_PixelTransformParameterivEXT_ovr_0(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: Int32);
    external 'opengl32.dll' name 'glPixelTransformParameterivEXT';
    private static procedure z_PixelTransformParameterivEXT_ovr_0_anh0001(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTransformParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterivEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTransformParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_PixelTransformParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterivEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: Int32) :=
    z_PixelTransformParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_PixelTransformParameterivEXT_ovr_2(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTransformParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterivEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr) :=
    z_PixelTransformParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_PixelTransformParameterfvEXT_ovr_0(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: single);
    external 'opengl32.dll' name 'glPixelTransformParameterfvEXT';
    private static procedure z_PixelTransformParameterfvEXT_ovr_0_anh0001(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTransformParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfvEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTransformParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_PixelTransformParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfvEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; var &params: single) :=
    z_PixelTransformParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_PixelTransformParameterfvEXT_ovr_2(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTransformParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransformParameterfvEXT(target: PixelTransformTargetEXT; pname: PixelTransformPNameEXT; &params: IntPtr) :=
    z_PixelTransformParameterfvEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetPixelTransformParameterivEXT_ovr_0(target: DummyEnum; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetPixelTransformParameterivEXT';
    private static procedure z_GetPixelTransformParameterivEXT_ovr_0_anh0001(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTransformParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTransformParameterivEXT_ovr_0(target, pname, &params[0]) else
      z_GetPixelTransformParameterivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; var &params: Int32) :=
    z_GetPixelTransformParameterivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetPixelTransformParameterivEXT_ovr_2(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTransformParameterivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterivEXT(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetPixelTransformParameterivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetPixelTransformParameterfvEXT_ovr_0(target: DummyEnum; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glGetPixelTransformParameterfvEXT';
    private static procedure z_GetPixelTransformParameterfvEXT_ovr_0_anh0001(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTransformParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTransformParameterfvEXT_ovr_0(target, pname, &params[0]) else
      z_GetPixelTransformParameterfvEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; var &params: single) :=
    z_GetPixelTransformParameterfvEXT_ovr_0(target, pname, &params);
    private static procedure z_GetPixelTransformParameterfvEXT_ovr_2(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTransformParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTransformParameterfvEXT(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetPixelTransformParameterfvEXT_ovr_2(target, pname, &params);
    
  end;
  
  glPointParametersEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PointParameterfEXT_ovr_0(pname: PointParameterNameARB; param: single);
    external 'opengl32.dll' name 'glPointParameterfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfEXT(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfEXT_ovr_0(pname, param);
    
    private static procedure z_PointParameterfvEXT_ovr_0(pname: PointParameterNameARB; var &params: single);
    external 'opengl32.dll' name 'glPointParameterfvEXT';
    private static procedure z_PointParameterfvEXT_ovr_0_anh001(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvEXT_ovr_0(pname, &params[0]) else
      z_PointParameterfvEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvEXT_ovr_0(pname, &params);
    private static procedure z_PointParameterfvEXT_ovr_2(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvEXT(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvEXT_ovr_2(pname, &params);
    
  end;
  
  glPolygonOffsetEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PolygonOffsetEXT_ovr_0(factor: single; bias: single);
    external 'opengl32.dll' name 'glPolygonOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetEXT(factor: single; bias: single) :=
    z_PolygonOffsetEXT_ovr_0(factor, bias);
    
  end;
  
  glPolygonOffsetClampEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PolygonOffsetClampEXT_ovr_0(factor: single; units: single; clamp: single);
    external 'opengl32.dll' name 'glPolygonOffsetClampEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetClampEXT(factor: single; units: single; clamp: single) :=
    z_PolygonOffsetClampEXT_ovr_0(factor, units, clamp);
    
  end;
  
  glProvokingVertexEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProvokingVertexEXT_ovr_0(mode: VertexProvokingMode);
    external 'opengl32.dll' name 'glProvokingVertexEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProvokingVertexEXT(mode: VertexProvokingMode) :=
    z_ProvokingVertexEXT_ovr_0(mode);
    
  end;
  
  glRasterMultisampleEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RasterSamplesEXT_ovr_0(samples: UInt32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glRasterSamplesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterSamplesEXT(samples: UInt32; fixedsamplelocations: boolean) :=
    z_RasterSamplesEXT_ovr_0(samples, fixedsamplelocations);
    
  end;
  
  glSemaphoreEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetUnsignedBytevEXT_ovr_0(pname: GetPName; var data: Byte);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    private static procedure z_GetUnsignedBytevEXT_ovr_0_anh001(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytevEXT_ovr_0(pname, data[0]) else
      z_GetUnsignedBytevEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; var data: Byte) :=
    z_GetUnsignedBytevEXT_ovr_0(pname, data);
    private static procedure z_GetUnsignedBytevEXT_ovr_2(pname: GetPName; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytevEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytevEXT(pname: GetPName; data: IntPtr) :=
    z_GetUnsignedBytevEXT_ovr_2(pname, data);
    
    private static procedure z_GetUnsignedBytei_vEXT_ovr_0(target: DummyEnum; index: UInt32; var data: Byte);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    private static procedure z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: array of Byte) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetUnsignedBytei_vEXT_ovr_0(target, index, data[0]) else
      z_GetUnsignedBytei_vEXT_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; var data: Byte) :=
    z_GetUnsignedBytei_vEXT_ovr_0(target, index, data);
    private static procedure z_GetUnsignedBytei_vEXT_ovr_2(target: DummyEnum; index: UInt32; data: IntPtr);
    external 'opengl32.dll' name 'glGetUnsignedBytei_vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUnsignedBytei_vEXT(target: DummyEnum; index: UInt32; data: IntPtr) :=
    z_GetUnsignedBytei_vEXT_ovr_2(target, index, data);
    
    private static procedure z_GenSemaphoresEXT_ovr_0(n: Int32; var semaphores: UInt32);
    external 'opengl32.dll' name 'glGenSemaphoresEXT';
    private static procedure z_GenSemaphoresEXT_ovr_0_anh001(n: Int32; semaphores: IntPtr);
    external 'opengl32.dll' name 'glGenSemaphoresEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; semaphores: array of UInt32) :=
    if (semaphores<>nil) and (semaphores.Length<>0) then
      z_GenSemaphoresEXT_ovr_0(n, semaphores[0]) else
      z_GenSemaphoresEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; var semaphores: UInt32) :=
    z_GenSemaphoresEXT_ovr_0(n, semaphores);
    private static procedure z_GenSemaphoresEXT_ovr_2(n: Int32; semaphores: IntPtr);
    external 'opengl32.dll' name 'glGenSemaphoresEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenSemaphoresEXT(n: Int32; semaphores: IntPtr) :=
    z_GenSemaphoresEXT_ovr_2(n, semaphores);
    
    private static procedure z_DeleteSemaphoresEXT_ovr_0(n: Int32; var semaphores: UInt32);
    external 'opengl32.dll' name 'glDeleteSemaphoresEXT';
    private static procedure z_DeleteSemaphoresEXT_ovr_0_anh001(n: Int32; semaphores: IntPtr);
    external 'opengl32.dll' name 'glDeleteSemaphoresEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; semaphores: array of UInt32) :=
    if (semaphores<>nil) and (semaphores.Length<>0) then
      z_DeleteSemaphoresEXT_ovr_0(n, semaphores[0]) else
      z_DeleteSemaphoresEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; var semaphores: UInt32) :=
    z_DeleteSemaphoresEXT_ovr_0(n, semaphores);
    private static procedure z_DeleteSemaphoresEXT_ovr_2(n: Int32; semaphores: IntPtr);
    external 'opengl32.dll' name 'glDeleteSemaphoresEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteSemaphoresEXT(n: Int32; semaphores: IntPtr) :=
    z_DeleteSemaphoresEXT_ovr_2(n, semaphores);
    
    private static function z_IsSemaphoreEXT_ovr_0(semaphore: UInt32): boolean;
    external 'opengl32.dll' name 'glIsSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsSemaphoreEXT(semaphore: UInt32): boolean :=
    z_IsSemaphoreEXT_ovr_0(semaphore);
    
    private static procedure z_SemaphoreParameterui64vEXT_ovr_0(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64);
    external 'opengl32.dll' name 'glSemaphoreParameterui64vEXT';
    private static procedure z_SemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glSemaphoreParameterui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params[0]) else
      z_SemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64) :=
    z_SemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params);
    private static procedure z_SemaphoreParameterui64vEXT_ovr_2(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glSemaphoreParameterui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_SemaphoreParameterui64vEXT_ovr_2(semaphore, pname, &params);
    
    private static procedure z_GetSemaphoreParameterui64vEXT_ovr_0(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64);
    external 'opengl32.dll' name 'glGetSemaphoreParameterui64vEXT';
    private static procedure z_GetSemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSemaphoreParameterui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetSemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params[0]) else
      z_GetSemaphoreParameterui64vEXT_ovr_0_anh0001(semaphore, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; var &params: UInt64) :=
    z_GetSemaphoreParameterui64vEXT_ovr_0(semaphore, pname, &params);
    private static procedure z_GetSemaphoreParameterui64vEXT_ovr_2(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetSemaphoreParameterui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSemaphoreParameterui64vEXT(semaphore: UInt32; pname: SemaphoreParameterName; &params: IntPtr) :=
    z_GetSemaphoreParameterui64vEXT_ovr_2(semaphore, pname, &params);
    
    private static procedure z_WaitSemaphoreEXT_ovr_0(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0000011(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_0_anh0001011(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], IntPtr.Zero) else
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, IntPtr.Zero) else
      if (textures<>nil) and (textures.Length<>0) then
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], IntPtr.Zero) else
        if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
          z_WaitSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
          z_WaitSemaphoreEXT_ovr_0_anh0001011(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_WaitSemaphoreEXT_ovr_1_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_1_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_1_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_2(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_2_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_2_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_2_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, srcLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_WaitSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], srcLayouts) else
        z_WaitSemaphoreEXT_ovr_2_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_3_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_3_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private static procedure z_WaitSemaphoreEXT_ovr_4_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_5_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_6(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_6_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_6_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_6_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_6_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private static procedure z_WaitSemaphoreEXT_ovr_7_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_8(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_8_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_WaitSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, srcLayouts) else
      z_WaitSemaphoreEXT_ovr_8_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; var srcLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_18(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_18_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_18_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_18_anh0000011(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
        z_WaitSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts[0]) else
        z_WaitSemaphoreEXT_ovr_18_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_WaitSemaphoreEXT_ovr_19_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; var srcLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_20(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_20_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; srcLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_WaitSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], srcLayouts) else
      z_WaitSemaphoreEXT_ovr_20_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_24(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    private static procedure z_WaitSemaphoreEXT_ovr_24_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: array of TextureLayout) :=
    if (srcLayouts<>nil) and (srcLayouts.Length<>0) then
      z_WaitSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts[0]) else
      z_WaitSemaphoreEXT_ovr_24_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var srcLayouts: TextureLayout) :=
    z_WaitSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    private static procedure z_WaitSemaphoreEXT_ovr_26(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; srcLayouts: IntPtr) :=
    z_WaitSemaphoreEXT_ovr_26(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, srcLayouts);
    
    private static procedure z_SignalSemaphoreEXT_ovr_0(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0000011(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_0_anh0001011(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], IntPtr.Zero) else
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, IntPtr.Zero) else
      if (textures<>nil) and (textures.Length<>0) then
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], IntPtr.Zero) else
        if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
          z_SignalSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
          z_SignalSemaphoreEXT_ovr_0_anh0001011(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_SignalSemaphoreEXT_ovr_1_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_1_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_1_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_0_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_2(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_2_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_2_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_2_anh0001010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, IntPtr.Zero, dstLayouts) else
      if (textures<>nil) and (textures.Length<>0) then
        z_SignalSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures[0], dstLayouts) else
        z_SignalSemaphoreEXT_ovr_2_anh0001010(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_3_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_3_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private static procedure z_SignalSemaphoreEXT_ovr_4_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_0_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_5_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_2_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_6(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_6_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_6_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_6_anh0001001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_6_anh0001001(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, IntPtr.Zero);
    private static procedure z_SignalSemaphoreEXT_ovr_7_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_6_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_8(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_8_anh0001000(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: array of UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    if (buffers<>nil) and (buffers.Length<>0) then
      z_SignalSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers[0], numTextureBarriers, textures, dstLayouts) else
      z_SignalSemaphoreEXT_ovr_8_anh0001000(semaphore, numBufferBarriers, IntPtr.Zero, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_0_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; var dstLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_0_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_2_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_0_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_0(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_2(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_6_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_6(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; var buffers: UInt32; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_8(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_18(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_18_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_18_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_18_anh0000011(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: array of TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], IntPtr.Zero) else
      if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
        z_SignalSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts[0]) else
        z_SignalSemaphoreEXT_ovr_18_anh0000011(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_SignalSemaphoreEXT_ovr_19_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; var dstLayouts: TextureLayout) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_18_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_20(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_20_anh0000010(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: array of UInt32; dstLayouts: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_SignalSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures[0], dstLayouts) else
      z_SignalSemaphoreEXT_ovr_20_anh0000010(semaphore, numBufferBarriers, buffers, numTextureBarriers, IntPtr.Zero, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_18_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_18(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; var textures: UInt32; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_20(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_24(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    private static procedure z_SignalSemaphoreEXT_ovr_24_anh0000001(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: array of TextureLayout) :=
    if (dstLayouts<>nil) and (dstLayouts.Length<>0) then
      z_SignalSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts[0]) else
      z_SignalSemaphoreEXT_ovr_24_anh0000001(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; var dstLayouts: TextureLayout) :=
    z_SignalSemaphoreEXT_ovr_24(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    private static procedure z_SignalSemaphoreEXT_ovr_26(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreEXT(semaphore: UInt32; numBufferBarriers: UInt32; buffers: IntPtr; numTextureBarriers: UInt32; textures: IntPtr; dstLayouts: IntPtr) :=
    z_SignalSemaphoreEXT_ovr_26(semaphore, numBufferBarriers, buffers, numTextureBarriers, textures, dstLayouts);
    
  end;
  
  glSemaphoreFdEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ImportSemaphoreFdEXT_ovr_0(semaphore: UInt32; handleType: ExternalHandleType; fd: Int32);
    external 'opengl32.dll' name 'glImportSemaphoreFdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreFdEXT(semaphore: UInt32; handleType: ExternalHandleType; fd: Int32) :=
    z_ImportSemaphoreFdEXT_ovr_0(semaphore, handleType, fd);
    
  end;
  
  glSemaphoreWin32EXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ImportSemaphoreWin32HandleEXT_ovr_0(semaphore: UInt32; handleType: ExternalHandleType; handle: IntPtr);
    external 'opengl32.dll' name 'glImportSemaphoreWin32HandleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreWin32HandleEXT(semaphore: UInt32; handleType: ExternalHandleType; handle: IntPtr) :=
    z_ImportSemaphoreWin32HandleEXT_ovr_0(semaphore, handleType, handle);
    
    private static procedure z_ImportSemaphoreWin32NameEXT_ovr_0(semaphore: UInt32; handleType: ExternalHandleType; name: IntPtr);
    external 'opengl32.dll' name 'glImportSemaphoreWin32NameEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImportSemaphoreWin32NameEXT(semaphore: UInt32; handleType: ExternalHandleType; name: IntPtr) :=
    z_ImportSemaphoreWin32NameEXT_ovr_0(semaphore, handleType, name);
    
  end;
  
  glSecondaryColorEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SecondaryColor3bEXT_ovr_0(red: SByte; green: SByte; blue: SByte);
    external 'opengl32.dll' name 'glSecondaryColor3bEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bEXT(red: SByte; green: SByte; blue: SByte) :=
    z_SecondaryColor3bEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3bvEXT_ovr_0(var v: SByte);
    external 'opengl32.dll' name 'glSecondaryColor3bvEXT';
    private static procedure z_SecondaryColor3bvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3bvEXT_ovr_0(v[0]) else
      z_SecondaryColor3bvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(var v: SByte) :=
    z_SecondaryColor3bvEXT_ovr_0(v);
    private static procedure z_SecondaryColor3bvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3bvEXT(v: IntPtr) :=
    z_SecondaryColor3bvEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3dEXT_ovr_0(red: real; green: real; blue: real);
    external 'opengl32.dll' name 'glSecondaryColor3dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dEXT(red: real; green: real; blue: real) :=
    z_SecondaryColor3dEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3dvEXT_ovr_0(var v: real);
    external 'opengl32.dll' name 'glSecondaryColor3dvEXT';
    private static procedure z_SecondaryColor3dvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3dvEXT_ovr_0(v[0]) else
      z_SecondaryColor3dvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(var v: real) :=
    z_SecondaryColor3dvEXT_ovr_0(v);
    private static procedure z_SecondaryColor3dvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3dvEXT(v: IntPtr) :=
    z_SecondaryColor3dvEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3fEXT_ovr_0(red: single; green: single; blue: single);
    external 'opengl32.dll' name 'glSecondaryColor3fEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fEXT(red: single; green: single; blue: single) :=
    z_SecondaryColor3fEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3fvEXT_ovr_0(var v: single);
    external 'opengl32.dll' name 'glSecondaryColor3fvEXT';
    private static procedure z_SecondaryColor3fvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3fvEXT_ovr_0(v[0]) else
      z_SecondaryColor3fvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(var v: single) :=
    z_SecondaryColor3fvEXT_ovr_0(v);
    private static procedure z_SecondaryColor3fvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3fvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3fvEXT(v: IntPtr) :=
    z_SecondaryColor3fvEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3iEXT_ovr_0(red: Int32; green: Int32; blue: Int32);
    external 'opengl32.dll' name 'glSecondaryColor3iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3iEXT(red: Int32; green: Int32; blue: Int32) :=
    z_SecondaryColor3iEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3ivEXT_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glSecondaryColor3ivEXT';
    private static procedure z_SecondaryColor3ivEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ivEXT_ovr_0(v[0]) else
      z_SecondaryColor3ivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(var v: Int32) :=
    z_SecondaryColor3ivEXT_ovr_0(v);
    private static procedure z_SecondaryColor3ivEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ivEXT(v: IntPtr) :=
    z_SecondaryColor3ivEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3sEXT_ovr_0(red: Int16; green: Int16; blue: Int16);
    external 'opengl32.dll' name 'glSecondaryColor3sEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3sEXT(red: Int16; green: Int16; blue: Int16) :=
    z_SecondaryColor3sEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3svEXT_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glSecondaryColor3svEXT';
    private static procedure z_SecondaryColor3svEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3svEXT_ovr_0(v[0]) else
      z_SecondaryColor3svEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(var v: Int16) :=
    z_SecondaryColor3svEXT_ovr_0(v);
    private static procedure z_SecondaryColor3svEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3svEXT(v: IntPtr) :=
    z_SecondaryColor3svEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3ubEXT_ovr_0(red: Byte; green: Byte; blue: Byte);
    external 'opengl32.dll' name 'glSecondaryColor3ubEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubEXT(red: Byte; green: Byte; blue: Byte) :=
    z_SecondaryColor3ubEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3ubvEXT_ovr_0(var v: Byte);
    external 'opengl32.dll' name 'glSecondaryColor3ubvEXT';
    private static procedure z_SecondaryColor3ubvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3ubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3ubvEXT_ovr_0(v[0]) else
      z_SecondaryColor3ubvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(var v: Byte) :=
    z_SecondaryColor3ubvEXT_ovr_0(v);
    private static procedure z_SecondaryColor3ubvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3ubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3ubvEXT(v: IntPtr) :=
    z_SecondaryColor3ubvEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3uiEXT_ovr_0(red: UInt32; green: UInt32; blue: UInt32);
    external 'opengl32.dll' name 'glSecondaryColor3uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uiEXT(red: UInt32; green: UInt32; blue: UInt32) :=
    z_SecondaryColor3uiEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3uivEXT_ovr_0(var v: UInt32);
    external 'opengl32.dll' name 'glSecondaryColor3uivEXT';
    private static procedure z_SecondaryColor3uivEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3uivEXT_ovr_0(v[0]) else
      z_SecondaryColor3uivEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(var v: UInt32) :=
    z_SecondaryColor3uivEXT_ovr_0(v);
    private static procedure z_SecondaryColor3uivEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3uivEXT(v: IntPtr) :=
    z_SecondaryColor3uivEXT_ovr_2(v);
    
    private static procedure z_SecondaryColor3usEXT_ovr_0(red: UInt16; green: UInt16; blue: UInt16);
    external 'opengl32.dll' name 'glSecondaryColor3usEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usEXT(red: UInt16; green: UInt16; blue: UInt16) :=
    z_SecondaryColor3usEXT_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3usvEXT_ovr_0(var v: UInt16);
    external 'opengl32.dll' name 'glSecondaryColor3usvEXT';
    private static procedure z_SecondaryColor3usvEXT_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3usvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3usvEXT_ovr_0(v[0]) else
      z_SecondaryColor3usvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(var v: UInt16) :=
    z_SecondaryColor3usvEXT_ovr_0(v);
    private static procedure z_SecondaryColor3usvEXT_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3usvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3usvEXT(v: IntPtr) :=
    z_SecondaryColor3usvEXT_ovr_2(v);
    
    private static procedure z_SecondaryColorPointerEXT_ovr_0(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColorPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerEXT(size: Int32; &type: ColorPointerType; stride: Int32; pointer: IntPtr) :=
    z_SecondaryColorPointerEXT_ovr_0(size, &type, stride, pointer);
    
  end;
  
  glSeparateShaderObjectsEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_UseShaderProgramEXT_ovr_0(&type: DummyEnum; &program: UInt32);
    external 'opengl32.dll' name 'glUseShaderProgramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UseShaderProgramEXT(&type: DummyEnum; &program: UInt32) :=
    z_UseShaderProgramEXT_ovr_0(&type, &program);
    
    private static procedure z_ActiveProgramEXT_ovr_0(&program: UInt32);
    external 'opengl32.dll' name 'glActiveProgramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveProgramEXT(&program: UInt32) :=
    z_ActiveProgramEXT_ovr_0(&program);
    
    private static function z_CreateShaderProgramEXT_ovr_0(&type: ShaderType; _string: IntPtr): UInt32;
    external 'opengl32.dll' name 'glCreateShaderProgramEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramEXT(&type: ShaderType; _string: string): UInt32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(_string);
      Result := z_CreateShaderProgramEXT_ovr_0(&type, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateShaderProgramEXT(&type: ShaderType; _string: IntPtr): UInt32 :=
    z_CreateShaderProgramEXT_ovr_0(&type, _string);
    
  end;
  
  glShaderFramebufferFetchNonCoherentEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferFetchBarrierEXT_ovr_0;
    external 'opengl32.dll' name 'glFramebufferFetchBarrierEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferFetchBarrierEXT :=
    z_FramebufferFetchBarrierEXT_ovr_0;
    
  end;
  
  glShaderImageLoadStoreEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindImageTextureEXT_ovr_0(index: UInt32; texture: UInt32; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: Int32);
    external 'opengl32.dll' name 'glBindImageTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindImageTextureEXT(index: UInt32; texture: UInt32; level: Int32; layered: boolean; layer: Int32; access: BufferAccessARB; format: Int32) :=
    z_BindImageTextureEXT_ovr_0(index, texture, level, layered, layer, access, format);
    
    private static procedure z_MemoryBarrierEXT_ovr_0(barriers: MemoryBarrierMask);
    external 'opengl32.dll' name 'glMemoryBarrierEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MemoryBarrierEXT(barriers: MemoryBarrierMask) :=
    z_MemoryBarrierEXT_ovr_0(barriers);
    
  end;
  
  glStencilClearTagEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_StencilClearTagEXT_ovr_0(stencilTagBits: Int32; stencilClearTag: UInt32);
    external 'opengl32.dll' name 'glStencilClearTagEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilClearTagEXT(stencilTagBits: Int32; stencilClearTag: UInt32) :=
    z_StencilClearTagEXT_ovr_0(stencilTagBits, stencilClearTag);
    
  end;
  
  glStencilTwoSideEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ActiveStencilFaceEXT_ovr_0(face: StencilFaceDirection);
    external 'opengl32.dll' name 'glActiveStencilFaceEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveStencilFaceEXT(face: StencilFaceDirection) :=
    z_ActiveStencilFaceEXT_ovr_0(face);
    
  end;
  
  glSubtextureEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexSubImage1DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage1DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage1DEXT(target: TextureTarget; level: Int32; xoffset: Int32; width: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage1DEXT_ovr_0(target, level, xoffset, width, format, &type, pixels);
    
    private static procedure z_TexSubImage2DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage2DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage2DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage2DEXT_ovr_0(target, level, xoffset, yoffset, width, height, format, &type, pixels);
    
  end;
  
  glTexture3DEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexImage3DEXT_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DEXT(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage3DEXT_ovr_0(target, level, _internalformat, width, height, depth, border, format, &type, pixels);
    
    private static procedure z_TexSubImage3DEXT_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage3DEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage3DEXT(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; width: Int32; height: Int32; depth: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage3DEXT_ovr_0(target, level, xoffset, yoffset, zoffset, width, height, depth, format, &type, pixels);
    
  end;
  
  glTextureArrayEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferTextureLayerEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureLayerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerEXT_ovr_0(target, attachment, texture, level, layer);
    
  end;
  
  glTextureBufferObjectEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexBufferEXT_ovr_0(target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32);
    external 'opengl32.dll' name 'glTexBufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexBufferEXT(target: TextureTarget; _internalformat: InternalFormat; buffer: UInt32) :=
    z_TexBufferEXT_ovr_0(target, _internalformat, buffer);
    
  end;
  
  glTextureIntegerEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexParameterIivEXT_ovr_0(target: TextureTarget; pname: TextureParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glTexParameterIivEXT';
    private static procedure z_TexParameterIivEXT_ovr_0_anh0001(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIivEXT_ovr_0(target, pname, &params[0]) else
      z_TexParameterIivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; var &params: Int32) :=
    z_TexParameterIivEXT_ovr_0(target, pname, &params);
    private static procedure z_TexParameterIivEXT_ovr_2(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIivEXT(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_TexParameterIuivEXT_ovr_0(target: TextureTarget; pname: TextureParameterName; var &params: UInt32);
    external 'opengl32.dll' name 'glTexParameterIuivEXT';
    private static procedure z_TexParameterIuivEXT_ovr_0_anh0001(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterIuivEXT_ovr_0(target, pname, &params[0]) else
      z_TexParameterIuivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; var &params: UInt32) :=
    z_TexParameterIuivEXT_ovr_0(target, pname, &params);
    private static procedure z_TexParameterIuivEXT_ovr_2(target: TextureTarget; pname: TextureParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterIuivEXT(target: TextureTarget; pname: TextureParameterName; &params: IntPtr) :=
    z_TexParameterIuivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetTexParameterIivEXT_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetTexParameterIivEXT';
    private static procedure z_GetTexParameterIivEXT_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIivEXT_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; var &params: Int32) :=
    z_GetTexParameterIivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameterIivEXT_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIivEXT(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_GetTexParameterIuivEXT_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32);
    external 'opengl32.dll' name 'glGetTexParameterIuivEXT';
    private static procedure z_GetTexParameterIuivEXT_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterIuivEXT_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterIuivEXT_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; var &params: UInt32) :=
    z_GetTexParameterIuivEXT_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameterIuivEXT_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterIuivEXT(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterIuivEXT_ovr_2(target, pname, &params);
    
    private static procedure z_ClearColorIiEXT_ovr_0(red: Int32; green: Int32; blue: Int32; alpha: Int32);
    external 'opengl32.dll' name 'glClearColorIiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorIiEXT(red: Int32; green: Int32; blue: Int32; alpha: Int32) :=
    z_ClearColorIiEXT_ovr_0(red, green, blue, alpha);
    
    private static procedure z_ClearColorIuiEXT_ovr_0(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32);
    external 'opengl32.dll' name 'glClearColorIuiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorIuiEXT(red: UInt32; green: UInt32; blue: UInt32; alpha: UInt32) :=
    z_ClearColorIuiEXT_ovr_0(red, green, blue, alpha);
    
  end;
  
  glTextureObjectEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_AreTexturesResidentEXT_ovr_0(n: Int32; var textures: UInt32; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    private static function z_AreTexturesResidentEXT_ovr_0_anh0010(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    private static function z_AreTexturesResidentEXT_ovr_0_anh0001(n: Int32; var textures: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    private static function z_AreTexturesResidentEXT_ovr_0_anh0011(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of UInt32; residences: array of boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResidentEXT_ovr_0(n, textures[0], residences[0]) else
        z_AreTexturesResidentEXT_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreTexturesResidentEXT_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreTexturesResidentEXT_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static function z_AreTexturesResidentEXT_ovr_1_anh0010(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of UInt32; var residences: boolean): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResidentEXT_ovr_0(n, textures[0], residences) else
      z_AreTexturesResidentEXT_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private static function z_AreTexturesResidentEXT_ovr_2(n: Int32; var textures: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    private static function z_AreTexturesResidentEXT_ovr_2_anh0010(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: array of UInt32; residences: IntPtr): boolean :=
    if (textures<>nil) and (textures.Length<>0) then
      z_AreTexturesResidentEXT_ovr_2(n, textures[0], residences) else
      z_AreTexturesResidentEXT_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: UInt32; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResidentEXT_ovr_0(n, textures, residences[0]) else
      z_AreTexturesResidentEXT_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: UInt32; var residences: boolean): boolean :=
    z_AreTexturesResidentEXT_ovr_0(n, textures, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; var textures: UInt32; residences: IntPtr): boolean :=
    z_AreTexturesResidentEXT_ovr_2(n, textures, residences);
    private static function z_AreTexturesResidentEXT_ovr_6(n: Int32; textures: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    private static function z_AreTexturesResidentEXT_ovr_6_anh0001(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreTexturesResidentEXT_ovr_6(n, textures, residences[0]) else
      z_AreTexturesResidentEXT_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; var residences: boolean): boolean :=
    z_AreTexturesResidentEXT_ovr_6(n, textures, residences);
    private static function z_AreTexturesResidentEXT_ovr_8(n: Int32; textures: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreTexturesResidentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreTexturesResidentEXT(n: Int32; textures: IntPtr; residences: IntPtr): boolean :=
    z_AreTexturesResidentEXT_ovr_8(n, textures, residences);
    
    private static procedure z_BindTextureEXT_ovr_0(target: TextureTarget; texture: UInt32);
    external 'opengl32.dll' name 'glBindTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTextureEXT(target: TextureTarget; texture: UInt32) :=
    z_BindTextureEXT_ovr_0(target, texture);
    
    private static procedure z_DeleteTexturesEXT_ovr_0(n: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glDeleteTexturesEXT';
    private static procedure z_DeleteTexturesEXT_ovr_0_anh001(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glDeleteTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_DeleteTexturesEXT_ovr_0(n, textures[0]) else
      z_DeleteTexturesEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; var textures: UInt32) :=
    z_DeleteTexturesEXT_ovr_0(n, textures);
    private static procedure z_DeleteTexturesEXT_ovr_2(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glDeleteTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTexturesEXT(n: Int32; textures: IntPtr) :=
    z_DeleteTexturesEXT_ovr_2(n, textures);
    
    private static procedure z_GenTexturesEXT_ovr_0(n: Int32; var textures: UInt32);
    external 'opengl32.dll' name 'glGenTexturesEXT';
    private static procedure z_GenTexturesEXT_ovr_0_anh001(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glGenTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; textures: array of UInt32) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_GenTexturesEXT_ovr_0(n, textures[0]) else
      z_GenTexturesEXT_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; var textures: UInt32) :=
    z_GenTexturesEXT_ovr_0(n, textures);
    private static procedure z_GenTexturesEXT_ovr_2(n: Int32; textures: IntPtr);
    external 'opengl32.dll' name 'glGenTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTexturesEXT(n: Int32; textures: IntPtr) :=
    z_GenTexturesEXT_ovr_2(n, textures);
    
    private static function z_IsTextureEXT_ovr_0(texture: UInt32): boolean;
    external 'opengl32.dll' name 'glIsTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureEXT(texture: UInt32): boolean :=
    z_IsTextureEXT_ovr_0(texture);
    
    private static procedure z_PrioritizeTexturesEXT_ovr_0(n: Int32; var textures: UInt32; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    private static procedure z_PrioritizeTexturesEXT_ovr_0_anh0010(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    private static procedure z_PrioritizeTexturesEXT_ovr_0_anh0001(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    private static procedure z_PrioritizeTexturesEXT_ovr_0_anh0011(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of UInt32; priorities: array of single) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesEXT_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTexturesEXT_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesEXT_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTexturesEXT_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_PrioritizeTexturesEXT_ovr_1_anh0010(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of UInt32; var priorities: single) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTexturesEXT_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private static procedure z_PrioritizeTexturesEXT_ovr_2(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    private static procedure z_PrioritizeTexturesEXT_ovr_2_anh0010(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: array of UInt32; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTexturesEXT_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: UInt32; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTexturesEXT_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: UInt32; var priorities: single) :=
    z_PrioritizeTexturesEXT_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; var textures: UInt32; priorities: IntPtr) :=
    z_PrioritizeTexturesEXT_ovr_2(n, textures, priorities);
    private static procedure z_PrioritizeTexturesEXT_ovr_6(n: Int32; textures: IntPtr; var priorities: single);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    private static procedure z_PrioritizeTexturesEXT_ovr_6_anh0001(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; priorities: array of single) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesEXT_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTexturesEXT_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; var priorities: single) :=
    z_PrioritizeTexturesEXT_ovr_6(n, textures, priorities);
    private static procedure z_PrioritizeTexturesEXT_ovr_8(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesEXT(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTexturesEXT_ovr_8(n, textures, priorities);
    
  end;
  
  glTexturePerturbNormalEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureNormalEXT_ovr_0(mode: TextureNormalModeEXT);
    external 'opengl32.dll' name 'glTextureNormalEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureNormalEXT(mode: TextureNormalModeEXT) :=
    z_TextureNormalEXT_ovr_0(mode);
    
  end;
  
  glTimerQueryEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetQueryObjecti64vEXT_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: Int64);
    external 'opengl32.dll' name 'glGetQueryObjecti64vEXT';
    private static procedure z_GetQueryObjecti64vEXT_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjecti64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: UInt32; pname: QueryObjectParameterName; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjecti64vEXT_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjecti64vEXT_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: UInt32; pname: QueryObjectParameterName; var &params: Int64) :=
    z_GetQueryObjecti64vEXT_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjecti64vEXT_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjecti64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjecti64vEXT(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjecti64vEXT_ovr_2(id, pname, &params);
    
    private static procedure z_GetQueryObjectui64vEXT_ovr_0(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64);
    external 'opengl32.dll' name 'glGetQueryObjectui64vEXT';
    private static procedure z_GetQueryObjectui64vEXT_ovr_0_anh0001(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: UInt32; pname: QueryObjectParameterName; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetQueryObjectui64vEXT_ovr_0(id, pname, &params[0]) else
      z_GetQueryObjectui64vEXT_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: UInt32; pname: QueryObjectParameterName; var &params: UInt64) :=
    z_GetQueryObjectui64vEXT_ovr_0(id, pname, &params);
    private static procedure z_GetQueryObjectui64vEXT_ovr_2(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetQueryObjectui64vEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetQueryObjectui64vEXT(id: UInt32; pname: QueryObjectParameterName; &params: IntPtr) :=
    z_GetQueryObjectui64vEXT_ovr_2(id, pname, &params);
    
  end;
  
  glTransformFeedbackEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginTransformFeedbackEXT_ovr_0(primitiveMode: PrimitiveType);
    external 'opengl32.dll' name 'glBeginTransformFeedbackEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedbackEXT(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedbackEXT_ovr_0(primitiveMode);
    
    private static procedure z_EndTransformFeedbackEXT_ovr_0;
    external 'opengl32.dll' name 'glEndTransformFeedbackEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedbackEXT :=
    z_EndTransformFeedbackEXT_ovr_0;
    
    private static procedure z_BindBufferRangeEXT_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glBindBufferRangeEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRangeEXT(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRangeEXT_ovr_0(target, index, buffer, offset, size);
    
    private static procedure z_BindBufferOffsetEXT_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr);
    external 'opengl32.dll' name 'glBindBufferOffsetEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferOffsetEXT(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr) :=
    z_BindBufferOffsetEXT_ovr_0(target, index, buffer, offset);
    
    private static procedure z_BindBufferBaseEXT_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32);
    external 'opengl32.dll' name 'glBindBufferBaseEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBaseEXT(target: BufferTargetARB; index: UInt32; buffer: UInt32) :=
    z_BindBufferBaseEXT_ovr_0(target, index, buffer);
    
    private static procedure z_TransformFeedbackVaryingsEXT_ovr_0(&program: UInt32; count: Int32; var varyings: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsEXT';
    private static procedure z_TransformFeedbackVaryingsEXT_ovr_0_anh00010(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: UInt32; count: Int32; varyings: array of string; bufferMode: DummyEnum);
    begin
      var par_3_str_ptr := varyings?.ConvertAll(arr_el1->Marshal.StringToHGlobalAnsi(arr_el1));
      if (par_3_str_ptr<>nil) and (par_3_str_ptr.Length<>0) then
        z_TransformFeedbackVaryingsEXT_ovr_0(&program, count, par_3_str_ptr[0], bufferMode) else
        z_TransformFeedbackVaryingsEXT_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
      foreach var arr_el1 in par_3_str_ptr do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_TransformFeedbackVaryingsEXT_ovr_1_anh00010(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: UInt32; count: Int32; varyings: array of IntPtr; bufferMode: DummyEnum) :=
    if (varyings<>nil) and (varyings.Length<>0) then
      z_TransformFeedbackVaryingsEXT_ovr_0(&program, count, varyings[0], bufferMode) else
      z_TransformFeedbackVaryingsEXT_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    private static procedure z_TransformFeedbackVaryingsEXT_ovr_2(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsEXT(&program: UInt32; count: Int32; varyings: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsEXT_ovr_2(&program, count, varyings, bufferMode);
    
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000110(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001110(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length[0], size[0], &type[0], name) else
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000010(&program, index, bufSize, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type[0], name) else
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000110(&program, index, bufSize, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type[0], name) else
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001110(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_1_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_1_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_1_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_2(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_2_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_2_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_2_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_2(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetTransformFeedbackVaryingEXT_ovr_2_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetTransformFeedbackVaryingEXT_ovr_2_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_3_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_3_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_4_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_5_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_2(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_6(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_6_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_6_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_6_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_6(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_6_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_6_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_7_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_6(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_8(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_8_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_8(&program, index, bufSize, length[0], size, &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_8_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_2(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_2_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVaryingEXT_ovr_0_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_0(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_2(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_6(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVaryingEXT_ovr_6_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_6(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_8(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_18(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000110(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_18(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_19_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; var &type: GlslTypeToken; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_18(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_20(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_20_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_20(&program, index, bufSize, length, size[0], &type, name) else
      z_GetTransformFeedbackVaryingEXT_ovr_20_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_18(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVaryingEXT_ovr_18_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_18(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_20(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_24(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_24_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: array of GlslTypeToken; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetTransformFeedbackVaryingEXT_ovr_24(&program, index, bufSize, length, size, &type[0], name) else
      z_GetTransformFeedbackVaryingEXT_ovr_24_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: GlslTypeToken; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_24(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetTransformFeedbackVaryingEXT_ovr_26(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingEXT(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetTransformFeedbackVaryingEXT_ovr_26(&program, index, bufSize, length, size, &type, name);
    
  end;
  
  glVertexArrayEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ArrayElementEXT_ovr_0(i: Int32);
    external 'opengl32.dll' name 'glArrayElementEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ArrayElementEXT(i: Int32) :=
    z_ArrayElementEXT_ovr_0(i);
    
    private static procedure z_ColorPointerEXT_ovr_0(size: Int32; &type: ColorPointerType; stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glColorPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerEXT(size: Int32; &type: ColorPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_ColorPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
    private static procedure z_DrawArraysEXT_ovr_0(mode: PrimitiveType; first: Int32; count: Int32);
    external 'opengl32.dll' name 'glDrawArraysEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawArraysEXT(mode: PrimitiveType; first: Int32; count: Int32) :=
    z_DrawArraysEXT_ovr_0(mode, first, count);
    
    private static procedure z_EdgeFlagPointerEXT_ovr_0(stride: Int32; count: Int32; var pointer: boolean);
    external 'opengl32.dll' name 'glEdgeFlagPointerEXT';
    private static procedure z_EdgeFlagPointerEXT_ovr_0_anh0001(stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glEdgeFlagPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; pointer: array of boolean) :=
    if (pointer<>nil) and (pointer.Length<>0) then
      z_EdgeFlagPointerEXT_ovr_0(stride, count, pointer[0]) else
      z_EdgeFlagPointerEXT_ovr_0_anh0001(stride, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; var pointer: boolean) :=
    z_EdgeFlagPointerEXT_ovr_0(stride, count, pointer);
    private static procedure z_EdgeFlagPointerEXT_ovr_2(stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glEdgeFlagPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerEXT(stride: Int32; count: Int32; pointer: IntPtr) :=
    z_EdgeFlagPointerEXT_ovr_2(stride, count, pointer);
    
    private static procedure z_GetPointervEXT_ovr_0(pname: GetPointervPName; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointervEXT';
    private static procedure z_GetPointervEXT_ovr_0_anh001(pname: GetPointervPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointervEXT(pname: GetPointervPName; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPointervEXT_ovr_0(pname, &params[0]) else
      z_GetPointervEXT_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointervEXT(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointervEXT_ovr_0(pname, &params);
    private static procedure z_GetPointervEXT_ovr_2(pname: GetPointervPName; &params: pointer);
    external 'opengl32.dll' name 'glGetPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointervEXT(pname: GetPointervPName; &params: pointer) :=
    z_GetPointervEXT_ovr_2(pname, &params);
    
    private static procedure z_IndexPointerEXT_ovr_0(&type: IndexPointerType; stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glIndexPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerEXT(&type: IndexPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_IndexPointerEXT_ovr_0(&type, stride, count, pointer);
    
    private static procedure z_NormalPointerEXT_ovr_0(&type: NormalPointerType; stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glNormalPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerEXT(&type: NormalPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_NormalPointerEXT_ovr_0(&type, stride, count, pointer);
    
    private static procedure z_TexCoordPointerEXT_ovr_0(size: Int32; &type: TexCoordPointerType; stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glTexCoordPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerEXT(size: Int32; &type: TexCoordPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_TexCoordPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
    private static procedure z_VertexPointerEXT_ovr_0(size: Int32; &type: VertexPointerType; stride: Int32; count: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerEXT(size: Int32; &type: VertexPointerType; stride: Int32; count: Int32; pointer: IntPtr) :=
    z_VertexPointerEXT_ovr_0(size, &type, stride, count, pointer);
    
  end;
  
  glVertexAttrib64bitEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribL1dEXT_ovr_0(index: UInt32; x: real);
    external 'opengl32.dll' name 'glVertexAttribL1dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dEXT(index: UInt32; x: real) :=
    z_VertexAttribL1dEXT_ovr_0(index, x);
    
    private static procedure z_VertexAttribL2dEXT_ovr_0(index: UInt32; x: real; y: real);
    external 'opengl32.dll' name 'glVertexAttribL2dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dEXT(index: UInt32; x: real; y: real) :=
    z_VertexAttribL2dEXT_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribL3dEXT_ovr_0(index: UInt32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexAttribL3dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dEXT(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttribL3dEXT_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribL4dEXT_ovr_0(index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexAttribL4dEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dEXT(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttribL4dEXT_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribL1dvEXT_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL1dvEXT';
    private static procedure z_VertexAttribL1dvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL1dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL1dvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribL1dvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1dvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribL2dvEXT_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL2dvEXT';
    private static procedure z_VertexAttribL2dvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL2dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL2dvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribL2dvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2dvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribL3dvEXT_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL3dvEXT';
    private static procedure z_VertexAttribL3dvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL3dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL3dvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribL3dvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3dvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribL4dvEXT_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribL4dvEXT';
    private static procedure z_VertexAttribL4dvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4dvEXT_ovr_0(index, v[0]) else
      z_VertexAttribL4dvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; var v: real) :=
    z_VertexAttribL4dvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribL4dvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4dvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4dvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4dvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribLPointerEXT_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribLPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLPointerEXT(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribLPointerEXT_ovr_0(index, size, &type, stride, pointer);
    
    private static procedure z_GetVertexAttribLdvEXT_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: real);
    external 'opengl32.dll' name 'glGetVertexAttribLdvEXT';
    private static procedure z_GetVertexAttribLdvEXT_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLdvEXT_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLdvEXT_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; var &params: real) :=
    z_GetVertexAttribLdvEXT_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribLdvEXT_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLdvEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLdvEXT_ovr_2(index, pname, &params);
    
  end;
  
  glVertexShaderEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginVertexShaderEXT_ovr_0;
    external 'opengl32.dll' name 'glBeginVertexShaderEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginVertexShaderEXT :=
    z_BeginVertexShaderEXT_ovr_0;
    
    private static procedure z_EndVertexShaderEXT_ovr_0;
    external 'opengl32.dll' name 'glEndVertexShaderEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndVertexShaderEXT :=
    z_EndVertexShaderEXT_ovr_0;
    
    private static procedure z_BindVertexShaderEXT_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glBindVertexShaderEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVertexShaderEXT(id: UInt32) :=
    z_BindVertexShaderEXT_ovr_0(id);
    
    private static function z_GenVertexShadersEXT_ovr_0(range: UInt32): UInt32;
    external 'opengl32.dll' name 'glGenVertexShadersEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenVertexShadersEXT(range: UInt32): UInt32 :=
    z_GenVertexShadersEXT_ovr_0(range);
    
    private static procedure z_DeleteVertexShaderEXT_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glDeleteVertexShaderEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteVertexShaderEXT(id: UInt32) :=
    z_DeleteVertexShaderEXT_ovr_0(id);
    
    private static procedure z_ShaderOp1EXT_ovr_0(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32);
    external 'opengl32.dll' name 'glShaderOp1EXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp1EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32) :=
    z_ShaderOp1EXT_ovr_0(op, res, arg1);
    
    private static procedure z_ShaderOp2EXT_ovr_0(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32);
    external 'opengl32.dll' name 'glShaderOp2EXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp2EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32) :=
    z_ShaderOp2EXT_ovr_0(op, res, arg1, arg2);
    
    private static procedure z_ShaderOp3EXT_ovr_0(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32; arg3: UInt32);
    external 'opengl32.dll' name 'glShaderOp3EXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShaderOp3EXT(op: VertexShaderOpEXT; res: UInt32; arg1: UInt32; arg2: UInt32; arg3: UInt32) :=
    z_ShaderOp3EXT_ovr_0(op, res, arg1, arg2, arg3);
    
    private static procedure z_SwizzleEXT_ovr_0(res: UInt32; &in: UInt32; outX: VertexShaderCoordOutEXT; outY: VertexShaderCoordOutEXT; outZ: VertexShaderCoordOutEXT; outW: VertexShaderCoordOutEXT);
    external 'opengl32.dll' name 'glSwizzleEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SwizzleEXT(res: UInt32; &in: UInt32; outX: VertexShaderCoordOutEXT; outY: VertexShaderCoordOutEXT; outZ: VertexShaderCoordOutEXT; outW: VertexShaderCoordOutEXT) :=
    z_SwizzleEXT_ovr_0(res, &in, outX, outY, outZ, outW);
    
    private static procedure z_WriteMaskEXT_ovr_0(res: UInt32; &in: UInt32; outX: VertexShaderWriteMaskEXT; outY: VertexShaderWriteMaskEXT; outZ: VertexShaderWriteMaskEXT; outW: VertexShaderWriteMaskEXT);
    external 'opengl32.dll' name 'glWriteMaskEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WriteMaskEXT(res: UInt32; &in: UInt32; outX: VertexShaderWriteMaskEXT; outY: VertexShaderWriteMaskEXT; outZ: VertexShaderWriteMaskEXT; outW: VertexShaderWriteMaskEXT) :=
    z_WriteMaskEXT_ovr_0(res, &in, outX, outY, outZ, outW);
    
    private static procedure z_InsertComponentEXT_ovr_0(res: UInt32; src: UInt32; num: UInt32);
    external 'opengl32.dll' name 'glInsertComponentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InsertComponentEXT(res: UInt32; src: UInt32; num: UInt32) :=
    z_InsertComponentEXT_ovr_0(res, src, num);
    
    private static procedure z_ExtractComponentEXT_ovr_0(res: UInt32; src: UInt32; num: UInt32);
    external 'opengl32.dll' name 'glExtractComponentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExtractComponentEXT(res: UInt32; src: UInt32; num: UInt32) :=
    z_ExtractComponentEXT_ovr_0(res, src, num);
    
    private static function z_GenSymbolsEXT_ovr_0(datatype: DataTypeEXT; storagetype: VertexShaderStorageTypeEXT; range: ParameterRangeEXT; components: UInt32): UInt32;
    external 'opengl32.dll' name 'glGenSymbolsEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenSymbolsEXT(datatype: DataTypeEXT; storagetype: VertexShaderStorageTypeEXT; range: ParameterRangeEXT; components: UInt32): UInt32 :=
    z_GenSymbolsEXT_ovr_0(datatype, storagetype, range, components);
    
    private static procedure z_SetInvariantEXT_ovr_0(id: UInt32; &type: ScalarType; addr: IntPtr);
    external 'opengl32.dll' name 'glSetInvariantEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetInvariantEXT(id: UInt32; &type: ScalarType; addr: IntPtr) :=
    z_SetInvariantEXT_ovr_0(id, &type, addr);
    
    private static procedure z_SetLocalConstantEXT_ovr_0(id: UInt32; &type: ScalarType; addr: IntPtr);
    external 'opengl32.dll' name 'glSetLocalConstantEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetLocalConstantEXT(id: UInt32; &type: ScalarType; addr: IntPtr) :=
    z_SetLocalConstantEXT_ovr_0(id, &type, addr);
    
    private static procedure z_VariantbvEXT_ovr_0(id: UInt32; var addr: SByte);
    external 'opengl32.dll' name 'glVariantbvEXT';
    private static procedure z_VariantbvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantbvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; addr: array of SByte) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantbvEXT_ovr_0(id, addr[0]) else
      z_VariantbvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; var addr: SByte) :=
    z_VariantbvEXT_ovr_0(id, addr);
    private static procedure z_VariantbvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantbvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantbvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantbvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantsvEXT_ovr_0(id: UInt32; var addr: Int16);
    external 'opengl32.dll' name 'glVariantsvEXT';
    private static procedure z_VariantsvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantsvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; addr: array of Int16) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantsvEXT_ovr_0(id, addr[0]) else
      z_VariantsvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; var addr: Int16) :=
    z_VariantsvEXT_ovr_0(id, addr);
    private static procedure z_VariantsvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantsvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantsvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantsvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantivEXT_ovr_0(id: UInt32; var addr: Int32);
    external 'opengl32.dll' name 'glVariantivEXT';
    private static procedure z_VariantivEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; addr: array of Int32) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantivEXT_ovr_0(id, addr[0]) else
      z_VariantivEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; var addr: Int32) :=
    z_VariantivEXT_ovr_0(id, addr);
    private static procedure z_VariantivEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantivEXT(id: UInt32; addr: IntPtr) :=
    z_VariantivEXT_ovr_2(id, addr);
    
    private static procedure z_VariantfvEXT_ovr_0(id: UInt32; var addr: single);
    external 'opengl32.dll' name 'glVariantfvEXT';
    private static procedure z_VariantfvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; addr: array of single) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantfvEXT_ovr_0(id, addr[0]) else
      z_VariantfvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; var addr: single) :=
    z_VariantfvEXT_ovr_0(id, addr);
    private static procedure z_VariantfvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantfvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantfvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantdvEXT_ovr_0(id: UInt32; var addr: real);
    external 'opengl32.dll' name 'glVariantdvEXT';
    private static procedure z_VariantdvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; addr: array of real) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantdvEXT_ovr_0(id, addr[0]) else
      z_VariantdvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; var addr: real) :=
    z_VariantdvEXT_ovr_0(id, addr);
    private static procedure z_VariantdvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantdvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantdvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantdvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantubvEXT_ovr_0(id: UInt32; var addr: Byte);
    external 'opengl32.dll' name 'glVariantubvEXT';
    private static procedure z_VariantubvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; addr: array of Byte) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantubvEXT_ovr_0(id, addr[0]) else
      z_VariantubvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; var addr: Byte) :=
    z_VariantubvEXT_ovr_0(id, addr);
    private static procedure z_VariantubvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantubvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantubvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantusvEXT_ovr_0(id: UInt32; var addr: UInt16);
    external 'opengl32.dll' name 'glVariantusvEXT';
    private static procedure z_VariantusvEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantusvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; addr: array of UInt16) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantusvEXT_ovr_0(id, addr[0]) else
      z_VariantusvEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; var addr: UInt16) :=
    z_VariantusvEXT_ovr_0(id, addr);
    private static procedure z_VariantusvEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantusvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantusvEXT(id: UInt32; addr: IntPtr) :=
    z_VariantusvEXT_ovr_2(id, addr);
    
    private static procedure z_VariantuivEXT_ovr_0(id: UInt32; var addr: UInt32);
    external 'opengl32.dll' name 'glVariantuivEXT';
    private static procedure z_VariantuivEXT_ovr_0_anh001(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; addr: array of UInt32) :=
    if (addr<>nil) and (addr.Length<>0) then
      z_VariantuivEXT_ovr_0(id, addr[0]) else
      z_VariantuivEXT_ovr_0_anh001(id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; var addr: UInt32) :=
    z_VariantuivEXT_ovr_0(id, addr);
    private static procedure z_VariantuivEXT_ovr_2(id: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantuivEXT(id: UInt32; addr: IntPtr) :=
    z_VariantuivEXT_ovr_2(id, addr);
    
    private static procedure z_VariantPointerEXT_ovr_0(id: UInt32; &type: ScalarType; stride: UInt32; addr: IntPtr);
    external 'opengl32.dll' name 'glVariantPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VariantPointerEXT(id: UInt32; &type: ScalarType; stride: UInt32; addr: IntPtr) :=
    z_VariantPointerEXT_ovr_0(id, &type, stride, addr);
    
    private static procedure z_EnableVariantClientStateEXT_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glEnableVariantClientStateEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EnableVariantClientStateEXT(id: UInt32) :=
    z_EnableVariantClientStateEXT_ovr_0(id);
    
    private static procedure z_DisableVariantClientStateEXT_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glDisableVariantClientStateEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DisableVariantClientStateEXT(id: UInt32) :=
    z_DisableVariantClientStateEXT_ovr_0(id);
    
    private static function z_BindLightParameterEXT_ovr_0(light: LightName; value: LightParameter): UInt32;
    external 'opengl32.dll' name 'glBindLightParameterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindLightParameterEXT(light: LightName; value: LightParameter): UInt32 :=
    z_BindLightParameterEXT_ovr_0(light, value);
    
    private static function z_BindMaterialParameterEXT_ovr_0(face: DummyEnum; value: MaterialParameter): UInt32;
    external 'opengl32.dll' name 'glBindMaterialParameterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindMaterialParameterEXT(face: DummyEnum; value: MaterialParameter): UInt32 :=
    z_BindMaterialParameterEXT_ovr_0(face, value);
    
    private static function z_BindTexGenParameterEXT_ovr_0(&unit: TextureUnit; coord: TextureCoordName; value: TextureGenParameter): UInt32;
    external 'opengl32.dll' name 'glBindTexGenParameterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindTexGenParameterEXT(&unit: TextureUnit; coord: TextureCoordName; value: TextureGenParameter): UInt32 :=
    z_BindTexGenParameterEXT_ovr_0(&unit, coord, value);
    
    private static function z_BindTextureUnitParameterEXT_ovr_0(&unit: TextureUnit; value: VertexShaderTextureUnitParameter): UInt32;
    external 'opengl32.dll' name 'glBindTextureUnitParameterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindTextureUnitParameterEXT(&unit: TextureUnit; value: VertexShaderTextureUnitParameter): UInt32 :=
    z_BindTextureUnitParameterEXT_ovr_0(&unit, value);
    
    private static function z_BindParameterEXT_ovr_0(value: VertexShaderParameterEXT): UInt32;
    external 'opengl32.dll' name 'glBindParameterEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function BindParameterEXT(value: VertexShaderParameterEXT): UInt32 :=
    z_BindParameterEXT_ovr_0(value);
    
    private static function z_IsVariantEnabledEXT_ovr_0(id: UInt32; cap: VariantCapEXT): boolean;
    external 'opengl32.dll' name 'glIsVariantEnabledEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsVariantEnabledEXT(id: UInt32; cap: VariantCapEXT): boolean :=
    z_IsVariantEnabledEXT_ovr_0(id, cap);
    
    private static procedure z_GetVariantBooleanvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: boolean);
    external 'opengl32.dll' name 'glGetVariantBooleanvEXT';
    private static procedure z_GetVariantBooleanvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetVariantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetVariantBooleanvEXT_ovr_0(id, value, data);
    private static procedure z_GetVariantBooleanvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantBooleanvEXT_ovr_2(id, value, data);
    
    private static procedure z_GetVariantIntegervEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: Int32);
    external 'opengl32.dll' name 'glGetVariantIntegervEXT';
    private static procedure z_GetVariantIntegervEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetVariantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetVariantIntegervEXT_ovr_0(id, value, data);
    private static procedure z_GetVariantIntegervEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantIntegervEXT_ovr_2(id, value, data);
    
    private static procedure z_GetVariantFloatvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: single);
    external 'opengl32.dll' name 'glGetVariantFloatvEXT';
    private static procedure z_GetVariantFloatvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetVariantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetVariantFloatvEXT_ovr_0(id, value, data);
    private static procedure z_GetVariantFloatvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetVariantFloatvEXT_ovr_2(id, value, data);
    
    private static procedure z_GetVariantPointervEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantPointervEXT';
    private static procedure z_GetVariantPointervEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetVariantPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; data: array of IntPtr) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetVariantPointervEXT_ovr_0(id, value, data[0]) else
      z_GetVariantPointervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; var data: IntPtr) :=
    z_GetVariantPointervEXT_ovr_0(id, value, data);
    private static procedure z_GetVariantPointervEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: pointer);
    external 'opengl32.dll' name 'glGetVariantPointervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVariantPointervEXT(id: UInt32; value: GetVariantValueEXT; data: pointer) :=
    z_GetVariantPointervEXT_ovr_2(id, value, data);
    
    private static procedure z_GetInvariantBooleanvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: boolean);
    external 'opengl32.dll' name 'glGetInvariantBooleanvEXT';
    private static procedure z_GetInvariantBooleanvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetInvariantBooleanvEXT_ovr_0(id, value, data);
    private static procedure z_GetInvariantBooleanvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantBooleanvEXT_ovr_2(id, value, data);
    
    private static procedure z_GetInvariantIntegervEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: Int32);
    external 'opengl32.dll' name 'glGetInvariantIntegervEXT';
    private static procedure z_GetInvariantIntegervEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetInvariantIntegervEXT_ovr_0(id, value, data);
    private static procedure z_GetInvariantIntegervEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantIntegervEXT_ovr_2(id, value, data);
    
    private static procedure z_GetInvariantFloatvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: single);
    external 'opengl32.dll' name 'glGetInvariantFloatvEXT';
    private static procedure z_GetInvariantFloatvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetInvariantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetInvariantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetInvariantFloatvEXT_ovr_0(id, value, data);
    private static procedure z_GetInvariantFloatvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetInvariantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInvariantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetInvariantFloatvEXT_ovr_2(id, value, data);
    
    private static procedure z_GetLocalConstantBooleanvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: boolean);
    external 'opengl32.dll' name 'glGetLocalConstantBooleanvEXT';
    private static procedure z_GetLocalConstantBooleanvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: array of boolean) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantBooleanvEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantBooleanvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; var data: boolean) :=
    z_GetLocalConstantBooleanvEXT_ovr_0(id, value, data);
    private static procedure z_GetLocalConstantBooleanvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantBooleanvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantBooleanvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantBooleanvEXT_ovr_2(id, value, data);
    
    private static procedure z_GetLocalConstantIntegervEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: Int32);
    external 'opengl32.dll' name 'glGetLocalConstantIntegervEXT';
    private static procedure z_GetLocalConstantIntegervEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: array of Int32) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantIntegervEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantIntegervEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; var data: Int32) :=
    z_GetLocalConstantIntegervEXT_ovr_0(id, value, data);
    private static procedure z_GetLocalConstantIntegervEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantIntegervEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantIntegervEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantIntegervEXT_ovr_2(id, value, data);
    
    private static procedure z_GetLocalConstantFloatvEXT_ovr_0(id: UInt32; value: GetVariantValueEXT; var data: single);
    external 'opengl32.dll' name 'glGetLocalConstantFloatvEXT';
    private static procedure z_GetLocalConstantFloatvEXT_ovr_0_anh0001(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: array of single) :=
    if (data<>nil) and (data.Length<>0) then
      z_GetLocalConstantFloatvEXT_ovr_0(id, value, data[0]) else
      z_GetLocalConstantFloatvEXT_ovr_0_anh0001(id, value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; var data: single) :=
    z_GetLocalConstantFloatvEXT_ovr_0(id, value, data);
    private static procedure z_GetLocalConstantFloatvEXT_ovr_2(id: UInt32; value: GetVariantValueEXT; data: IntPtr);
    external 'opengl32.dll' name 'glGetLocalConstantFloatvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLocalConstantFloatvEXT(id: UInt32; value: GetVariantValueEXT; data: IntPtr) :=
    z_GetLocalConstantFloatvEXT_ovr_2(id, value, data);
    
  end;
  
  glVertexWeightingEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexWeightfEXT_ovr_0(weight: single);
    external 'opengl32.dll' name 'glVertexWeightfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfEXT(weight: single) :=
    z_VertexWeightfEXT_ovr_0(weight);
    
    private static procedure z_VertexWeightfvEXT_ovr_0(var weight: single);
    external 'opengl32.dll' name 'glVertexWeightfvEXT';
    private static procedure z_VertexWeightfvEXT_ovr_0_anh01(weight: IntPtr);
    external 'opengl32.dll' name 'glVertexWeightfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfvEXT(weight: array of single) :=
    if (weight<>nil) and (weight.Length<>0) then
      z_VertexWeightfvEXT_ovr_0(weight[0]) else
      z_VertexWeightfvEXT_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfvEXT(var weight: single) :=
    z_VertexWeightfvEXT_ovr_0(weight);
    private static procedure z_VertexWeightfvEXT_ovr_2(weight: IntPtr);
    external 'opengl32.dll' name 'glVertexWeightfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightfvEXT(weight: IntPtr) :=
    z_VertexWeightfvEXT_ovr_2(weight);
    
    private static procedure z_VertexWeightPointerEXT_ovr_0(size: Int32; &type: VertexWeightPointerTypeEXT; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexWeightPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeightPointerEXT(size: Int32; &type: VertexWeightPointerTypeEXT; stride: Int32; pointer: IntPtr) :=
    z_VertexWeightPointerEXT_ovr_0(size, &type, stride, pointer);
    
  end;
  
  glWin32KeyedMutexEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_AcquireKeyedMutexWin32EXT_ovr_0(memory: UInt32; key: UInt64; timeout: UInt32): boolean;
    external 'opengl32.dll' name 'glAcquireKeyedMutexWin32EXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AcquireKeyedMutexWin32EXT(memory: UInt32; key: UInt64; timeout: UInt32): boolean :=
    z_AcquireKeyedMutexWin32EXT_ovr_0(memory, key, timeout);
    
    private static function z_ReleaseKeyedMutexWin32EXT_ovr_0(memory: UInt32; key: UInt64): boolean;
    external 'opengl32.dll' name 'glReleaseKeyedMutexWin32EXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ReleaseKeyedMutexWin32EXT(memory: UInt32; key: UInt64): boolean :=
    z_ReleaseKeyedMutexWin32EXT_ovr_0(memory, key);
    
  end;
  
  glWindowRectanglesEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_WindowRectanglesEXT_ovr_0(mode: DummyEnum; count: Int32; var box: Int32);
    external 'opengl32.dll' name 'glWindowRectanglesEXT';
    private static procedure z_WindowRectanglesEXT_ovr_0_anh0001(mode: DummyEnum; count: Int32; box: IntPtr);
    external 'opengl32.dll' name 'glWindowRectanglesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; box: array of Int32) :=
    if (box<>nil) and (box.Length<>0) then
      z_WindowRectanglesEXT_ovr_0(mode, count, box[0]) else
      z_WindowRectanglesEXT_ovr_0_anh0001(mode, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; var box: Int32) :=
    z_WindowRectanglesEXT_ovr_0(mode, count, box);
    private static procedure z_WindowRectanglesEXT_ovr_2(mode: DummyEnum; count: Int32; box: IntPtr);
    external 'opengl32.dll' name 'glWindowRectanglesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowRectanglesEXT(mode: DummyEnum; count: Int32; box: IntPtr) :=
    z_WindowRectanglesEXT_ovr_2(mode, count, box);
    
  end;
  
  glX11SyncObjectEXT = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_ImportSyncEXT_ovr_0(external_sync_type: DummyEnum; external_sync: IntPtr; flags: DummyFlags): GLsync;
    external 'opengl32.dll' name 'glImportSyncEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function ImportSyncEXT(external_sync_type: DummyEnum; external_sync: IntPtr; flags: DummyFlags): GLsync :=
    z_ImportSyncEXT_ovr_0(external_sync_type, external_sync, flags);
    
  end;
  
  glFrameTerminatorGREMEDY = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FrameTerminatorGREMEDY_ovr_0;
    external 'opengl32.dll' name 'glFrameTerminatorGREMEDY';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrameTerminatorGREMEDY :=
    z_FrameTerminatorGREMEDY_ovr_0;
    
  end;
  
  glStringMarkerGREMEDY = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_StringMarkerGREMEDY_ovr_0(len: Int32; string: IntPtr);
    external 'opengl32.dll' name 'glStringMarkerGREMEDY';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StringMarkerGREMEDY(len: Int32; string: IntPtr) :=
    z_StringMarkerGREMEDY_ovr_0(len, string);
    
  end;
  
  glImageTransformHP = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ImageTransformParameteriHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: Int32);
    external 'opengl32.dll' name 'glImageTransformParameteriHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameteriHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: Int32) :=
    z_ImageTransformParameteriHP_ovr_0(target, pname, param);
    
    private static procedure z_ImageTransformParameterfHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: single);
    external 'opengl32.dll' name 'glImageTransformParameterfHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; param: single) :=
    z_ImageTransformParameterfHP_ovr_0(target, pname, param);
    
    private static procedure z_ImageTransformParameterivHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32);
    external 'opengl32.dll' name 'glImageTransformParameterivHP';
    private static procedure z_ImageTransformParameterivHP_ovr_0_anh0001(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glImageTransformParameterivHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ImageTransformParameterivHP_ovr_0(target, pname, &params[0]) else
      z_ImageTransformParameterivHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32) :=
    z_ImageTransformParameterivHP_ovr_0(target, pname, &params);
    private static procedure z_ImageTransformParameterivHP_ovr_2(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glImageTransformParameterivHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_ImageTransformParameterivHP_ovr_2(target, pname, &params);
    
    private static procedure z_ImageTransformParameterfvHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single);
    external 'opengl32.dll' name 'glImageTransformParameterfvHP';
    private static procedure z_ImageTransformParameterfvHP_ovr_0_anh0001(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glImageTransformParameterfvHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ImageTransformParameterfvHP_ovr_0(target, pname, &params[0]) else
      z_ImageTransformParameterfvHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single) :=
    z_ImageTransformParameterfvHP_ovr_0(target, pname, &params);
    private static procedure z_ImageTransformParameterfvHP_ovr_2(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glImageTransformParameterfvHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_ImageTransformParameterfvHP_ovr_2(target, pname, &params);
    
    private static procedure z_GetImageTransformParameterivHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32);
    external 'opengl32.dll' name 'glGetImageTransformParameterivHP';
    private static procedure z_GetImageTransformParameterivHP_ovr_0_anh0001(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glGetImageTransformParameterivHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetImageTransformParameterivHP_ovr_0(target, pname, &params[0]) else
      z_GetImageTransformParameterivHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: Int32) :=
    z_GetImageTransformParameterivHP_ovr_0(target, pname, &params);
    private static procedure z_GetImageTransformParameterivHP_ovr_2(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glGetImageTransformParameterivHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterivHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_GetImageTransformParameterivHP_ovr_2(target, pname, &params);
    
    private static procedure z_GetImageTransformParameterfvHP_ovr_0(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single);
    external 'opengl32.dll' name 'glGetImageTransformParameterfvHP';
    private static procedure z_GetImageTransformParameterfvHP_ovr_0_anh0001(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glGetImageTransformParameterfvHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetImageTransformParameterfvHP_ovr_0(target, pname, &params[0]) else
      z_GetImageTransformParameterfvHP_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; var &params: single) :=
    z_GetImageTransformParameterfvHP_ovr_0(target, pname, &params);
    private static procedure z_GetImageTransformParameterfvHP_ovr_2(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr);
    external 'opengl32.dll' name 'glGetImageTransformParameterfvHP';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetImageTransformParameterfvHP(target: ImageTransformTargetHP; pname: ImageTransformPNameHP; &params: IntPtr) :=
    z_GetImageTransformParameterfvHP_ovr_2(target, pname, &params);
    
  end;
  
  glMultimodeDrawArraysIBM = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiModeDrawArraysIBM_ovr_0(var mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh010000(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh001000(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh011000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh000100(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh010100(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh001100(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_0_anh011100(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0(mode[0], first[0], count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode[0], first[0], IntPtr.Zero, primcount, modestride) else
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode[0], IntPtr.Zero, count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh001100(mode[0], IntPtr.Zero, IntPtr.Zero, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first[0], count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh010100(IntPtr.Zero, first[0], IntPtr.Zero, primcount, modestride) else
        if (count<>nil) and (count.Length<>0) then
          z_MultiModeDrawArraysIBM_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, count[0], primcount, modestride) else
          z_MultiModeDrawArraysIBM_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_1_anh010000(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_1_anh001000(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_1_anh011000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode[0], first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode[0], IntPtr.Zero, count, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_2(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_2_anh010000(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_2_anh001000(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_2_anh011000(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_2(mode[0], first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_2_anh001000(mode[0], IntPtr.Zero, count, primcount, modestride) else
      if (first<>nil) and (first.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_2_anh010000(IntPtr.Zero, first[0], count, primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_3_anh010000(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_3_anh010100(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode[0], first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode[0], first, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh010100(IntPtr.Zero, first, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_4_anh010000(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_5_anh010000(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_2(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_2_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_6(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_6_anh010000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_6_anh000100(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_6_anh010100(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_6(mode[0], first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_6_anh000100(mode[0], first, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_6_anh010000(IntPtr.Zero, first, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_6_anh010100(IntPtr.Zero, first, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_7_anh010000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_6(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_6_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_8(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_8_anh010000(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: array of PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_8(mode[0], first, count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_8_anh010000(IntPtr.Zero, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0(mode, first[0], count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode, first[0], IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode, IntPtr.Zero, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_0_anh001100(mode, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_2(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_2_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_0(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_0_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_0(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_2(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_6(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_6_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_6(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(var mode: PrimitiveType; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_8(mode, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_18(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_18_anh001000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_18_anh000100(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_18_anh001100(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_18(mode, first[0], count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_18_anh000100(mode, first[0], IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawArraysIBM_ovr_18_anh001000(mode, IntPtr.Zero, count[0], primcount, modestride) else
        z_MultiModeDrawArraysIBM_ovr_18_anh001100(mode, IntPtr.Zero, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_19_anh001000(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_18(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_18_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_20(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_20_anh001000(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: array of Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    if (first<>nil) and (first.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_20(mode, first[0], count, primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_20_anh001000(mode, IntPtr.Zero, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_18(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_18_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_18(mode, first, count, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; var first: Int32; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_20(mode, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_24(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    private static procedure z_MultiModeDrawArraysIBM_ovr_24_anh000100(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; count: array of Int32; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawArraysIBM_ovr_24(mode, first, count[0], primcount, modestride) else
      z_MultiModeDrawArraysIBM_ovr_24_anh000100(mode, first, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; var count: Int32; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_24(mode, first, count, primcount, modestride);
    private static procedure z_MultiModeDrawArraysIBM_ovr_26(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawArraysIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawArraysIBM(mode: IntPtr; first: IntPtr; count: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawArraysIBM_ovr_26(mode, first, count, primcount, modestride);
    
    private static procedure z_MultiModeDrawElementsIBM_ovr_0(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0010000(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0110000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0000100(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0100100(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0010100(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_0_anh0110100(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0(mode[0], count[0], &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode[0], count[0], &type, IntPtr.Zero, primcount, modestride) else
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode[0], IntPtr.Zero, &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0010100(mode[0], IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count[0], &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0100100(IntPtr.Zero, count[0], &type, IntPtr.Zero, primcount, modestride) else
        if (indices<>nil) and (indices.Length<>0) then
          z_MultiModeDrawElementsIBM_ovr_0_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices[0], primcount, modestride) else
          z_MultiModeDrawElementsIBM_ovr_0_anh0110100(IntPtr.Zero, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_1_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_1_anh0010000(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_1_anh0110000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode[0], count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode[0], IntPtr.Zero, &type, indices, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_2(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_2_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_2_anh0010000(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_2_anh0110000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_2(mode[0], count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_2_anh0010000(mode[0], IntPtr.Zero, &type, indices, primcount, modestride) else
      if (count<>nil) and (count.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_2_anh0100000(IntPtr.Zero, count[0], &type, indices, primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_2_anh0110000(IntPtr.Zero, IntPtr.Zero, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_3_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_3_anh0000100(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_3_anh0100100(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode[0], count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode[0], count, &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0100100(IntPtr.Zero, count, &type, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_4_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_5_anh0100000(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_2(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_2_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_6(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_6_anh0100000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_6_anh0000100(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_6_anh0100100(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_6(mode[0], count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_6_anh0000100(mode[0], count, &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_6_anh0100000(IntPtr.Zero, count, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_6_anh0100100(IntPtr.Zero, count, &type, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_7_anh0100000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_6(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_6_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_8(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_8_anh0100000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: array of PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (mode<>nil) and (mode.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_8(mode[0], count, &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_8_anh0100000(IntPtr.Zero, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_9_anh0000100(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_9_anh0010100(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0(mode, count[0], &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode, count[0], &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_0_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_2(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_2_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_12_anh0000100(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_0(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_0_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_0(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_2(mode, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_15_anh0000100(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_6(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_6_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_6(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(var mode: PrimitiveType; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_8(mode, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_18(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_18_anh0010000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_18_anh0000100(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_18_anh0010100(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_18(mode, count[0], &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_18_anh0000100(mode, count[0], &type, IntPtr.Zero, primcount, modestride) else
      if (indices<>nil) and (indices.Length<>0) then
        z_MultiModeDrawElementsIBM_ovr_18_anh0010000(mode, IntPtr.Zero, &type, indices[0], primcount, modestride) else
        z_MultiModeDrawElementsIBM_ovr_18_anh0010100(mode, IntPtr.Zero, &type, IntPtr.Zero, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_19_anh0010000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_18(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_18_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_20(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_20_anh0010000(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: array of Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    if (count<>nil) and (count.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_20(mode, count[0], &type, indices, primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_20_anh0010000(mode, IntPtr.Zero, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_21_anh0000100(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_18(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_18_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_18(mode, count, &type, indices, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; var count: Int32; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_20(mode, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_24(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    private static procedure z_MultiModeDrawElementsIBM_ovr_24_anh0000100(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: IntPtr; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: array of IntPtr; primcount: Int32; modestride: Int32) :=
    if (indices<>nil) and (indices.Length<>0) then
      z_MultiModeDrawElementsIBM_ovr_24(mode, count, &type, indices[0], primcount, modestride) else
      z_MultiModeDrawElementsIBM_ovr_24_anh0000100(mode, count, &type, IntPtr.Zero, primcount, modestride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; var indices: IntPtr; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_24(mode, count, &type, indices, primcount, modestride);
    private static procedure z_MultiModeDrawElementsIBM_ovr_26(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32);
    external 'opengl32.dll' name 'glMultiModeDrawElementsIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiModeDrawElementsIBM(mode: IntPtr; count: IntPtr; &type: DrawElementsType; indices: pointer; primcount: Int32; modestride: Int32) :=
    z_MultiModeDrawElementsIBM_ovr_26(mode, count, &type, indices, primcount, modestride);
    
  end;
  
  glStaticDataIBM = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FlushStaticDataIBM_ovr_0(target: DummyEnum);
    external 'opengl32.dll' name 'glFlushStaticDataIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushStaticDataIBM(target: DummyEnum) :=
    z_FlushStaticDataIBM_ovr_0(target);
    
  end;
  
  glVertexArrayListsIBM = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ColorPointerListIBM_ovr_0(size: Int32; &type: ColorPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glColorPointerListIBM';
    private static procedure z_ColorPointerListIBM_ovr_0_anh000010(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glColorPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ColorPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_ColorPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_ColorPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private static procedure z_ColorPointerListIBM_ovr_2(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glColorPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointerListIBM(size: Int32; &type: ColorPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_ColorPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private static procedure z_SecondaryColorPointerListIBM_ovr_0(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glSecondaryColorPointerListIBM';
    private static procedure z_SecondaryColorPointerListIBM_ovr_0_anh000010(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glSecondaryColorPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_SecondaryColorPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_SecondaryColorPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_SecondaryColorPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private static procedure z_SecondaryColorPointerListIBM_ovr_2(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glSecondaryColorPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorPointerListIBM(size: Int32; &type: SecondaryColorPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_SecondaryColorPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private static procedure z_EdgeFlagPointerListIBM_ovr_0(stride: Int32; var pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glEdgeFlagPointerListIBM';
    private static procedure z_EdgeFlagPointerListIBM_ovr_0_anh0010(stride: Int32; pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glEdgeFlagPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: array of array of Byte; ptrstride: Int32);
    begin
      var par_2_temp_arr1 := pointer?.ConvertAll(arr_el1->begin
        if (arr_el1=nil) or (arr_el1.Length=0) then
          Result := IntPtr.Zero else
        begin
          var l := Marshal.SizeOf&<Byte>*arr_el1.Length;
          Result := Marshal.AllocHGlobal(l);
          Marshal.Copy(arr_el1,0,Result,l);
        end;
      end);
      if (par_2_temp_arr1<>nil) and (par_2_temp_arr1.Length<>0) then
        z_EdgeFlagPointerListIBM_ovr_0(stride, par_2_temp_arr1[0], ptrstride) else
        z_EdgeFlagPointerListIBM_ovr_0_anh0010(stride, IntPtr.Zero, ptrstride);
      foreach var arr_el1 in par_2_temp_arr1 do Marshal.FreeHGlobal(arr_el1);
    end;
    private static procedure z_EdgeFlagPointerListIBM_ovr_1_anh0010(stride: Int32; pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glEdgeFlagPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: array of IntPtr; ptrstride: Int32) :=
    if (pointer<>nil) and (pointer.Length<>0) then
      z_EdgeFlagPointerListIBM_ovr_0(stride, pointer[0], ptrstride) else
      z_EdgeFlagPointerListIBM_ovr_0_anh0010(stride, IntPtr.Zero, ptrstride);
    private static procedure z_EdgeFlagPointerListIBM_ovr_2(stride: Int32; pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glEdgeFlagPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagPointerListIBM(stride: Int32; pointer: IntPtr; ptrstride: Int32) :=
    z_EdgeFlagPointerListIBM_ovr_2(stride, pointer, ptrstride);
    
    private static procedure z_FogCoordPointerListIBM_ovr_0(&type: FogPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glFogCoordPointerListIBM';
    private static procedure z_FogCoordPointerListIBM_ovr_0_anh00010(&type: FogPointerTypeIBM; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glFogCoordPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_FogCoordPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_FogCoordPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_FogCoordPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private static procedure z_FogCoordPointerListIBM_ovr_2(&type: FogPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glFogCoordPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordPointerListIBM(&type: FogPointerTypeIBM; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_FogCoordPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private static procedure z_IndexPointerListIBM_ovr_0(&type: IndexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glIndexPointerListIBM';
    private static procedure z_IndexPointerListIBM_ovr_0_anh00010(&type: IndexPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glIndexPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_IndexPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_IndexPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_IndexPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private static procedure z_IndexPointerListIBM_ovr_2(&type: IndexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glIndexPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexPointerListIBM(&type: IndexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_IndexPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private static procedure z_NormalPointerListIBM_ovr_0(&type: NormalPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glNormalPointerListIBM';
    private static procedure z_NormalPointerListIBM_ovr_0_anh00010(&type: NormalPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glNormalPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_NormalPointerListIBM_ovr_0(&type, stride, _pointer[0], ptrstride) else
      z_NormalPointerListIBM_ovr_0_anh00010(&type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_NormalPointerListIBM_ovr_0(&type, stride, _pointer, ptrstride);
    private static procedure z_NormalPointerListIBM_ovr_2(&type: NormalPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glNormalPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointerListIBM(&type: NormalPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_NormalPointerListIBM_ovr_2(&type, stride, _pointer, ptrstride);
    
    private static procedure z_TexCoordPointerListIBM_ovr_0(size: Int32; &type: TexCoordPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glTexCoordPointerListIBM';
    private static procedure z_TexCoordPointerListIBM_ovr_0_anh000010(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glTexCoordPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_TexCoordPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_TexCoordPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_TexCoordPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private static procedure z_TexCoordPointerListIBM_ovr_2(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glTexCoordPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointerListIBM(size: Int32; &type: TexCoordPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_TexCoordPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
    private static procedure z_VertexPointerListIBM_ovr_0(size: Int32; &type: VertexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glVertexPointerListIBM';
    private static procedure z_VertexPointerListIBM_ovr_0_anh000010(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: IntPtr; ptrstride: Int32);
    external 'opengl32.dll' name 'glVertexPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: array of IntPtr; ptrstride: Int32) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_VertexPointerListIBM_ovr_0(size, &type, stride, _pointer[0], ptrstride) else
      z_VertexPointerListIBM_ovr_0_anh000010(size, &type, stride, IntPtr.Zero, ptrstride);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; var _pointer: IntPtr; ptrstride: Int32) :=
    z_VertexPointerListIBM_ovr_0(size, &type, stride, _pointer, ptrstride);
    private static procedure z_VertexPointerListIBM_ovr_2(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32);
    external 'opengl32.dll' name 'glVertexPointerListIBM';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointerListIBM(size: Int32; &type: VertexPointerType; stride: Int32; _pointer: pointer; ptrstride: Int32) :=
    z_VertexPointerListIBM_ovr_2(size, &type, stride, _pointer, ptrstride);
    
  end;
  
  glBlendFuncSeparateINGR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendFuncSeparateINGR_ovr_0(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor);
    external 'opengl32.dll' name 'glBlendFuncSeparateINGR';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendFuncSeparateINGR(sfactorRGB: BlendingFactor; dfactorRGB: BlendingFactor; sfactorAlpha: BlendingFactor; dfactorAlpha: BlendingFactor) :=
    z_BlendFuncSeparateINGR_ovr_0(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
    
  end;
  
  glFramebufferCMAAINTEL = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ApplyFramebufferAttachmentCMAAINTEL_ovr_0;
    external 'opengl32.dll' name 'glApplyFramebufferAttachmentCMAAINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ApplyFramebufferAttachmentCMAAINTEL :=
    z_ApplyFramebufferAttachmentCMAAINTEL_ovr_0;
    
  end;
  
  glMapTextureINTEL = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SyncTextureINTEL_ovr_0(texture: UInt32);
    external 'opengl32.dll' name 'glSyncTextureINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SyncTextureINTEL(texture: UInt32) :=
    z_SyncTextureINTEL_ovr_0(texture);
    
    private static procedure z_UnmapTexture2DINTEL_ovr_0(texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glUnmapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UnmapTexture2DINTEL(texture: UInt32; level: Int32) :=
    z_UnmapTexture2DINTEL_ovr_0(texture, level);
    
    private static function z_MapTexture2DINTEL_ovr_0(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; var layout: DummyEnum): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    private static function z_MapTexture2DINTEL_ovr_0_anh000010(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    private static function z_MapTexture2DINTEL_ovr_0_anh000001(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    private static function z_MapTexture2DINTEL_ovr_0_anh000011(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: array of Int32; layout: array of DummyEnum): IntPtr :=
    if (stride<>nil) and (stride.Length<>0) then
      if (layout<>nil) and (layout.Length<>0) then
        z_MapTexture2DINTEL_ovr_0(texture, level, access, stride[0], layout[0]) else
        z_MapTexture2DINTEL_ovr_0_anh000001(texture, level, access, stride[0], IntPtr.Zero) else
      if (layout<>nil) and (layout.Length<>0) then
        z_MapTexture2DINTEL_ovr_0_anh000010(texture, level, access, IntPtr.Zero, layout[0]) else
        z_MapTexture2DINTEL_ovr_0_anh000011(texture, level, access, IntPtr.Zero, IntPtr.Zero);
    private static function z_MapTexture2DINTEL_ovr_1_anh000010(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: array of Int32; var layout: DummyEnum): IntPtr :=
    if (stride<>nil) and (stride.Length<>0) then
      z_MapTexture2DINTEL_ovr_0(texture, level, access, stride[0], layout) else
      z_MapTexture2DINTEL_ovr_0_anh000010(texture, level, access, IntPtr.Zero, layout);
    private static function z_MapTexture2DINTEL_ovr_2(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    private static function z_MapTexture2DINTEL_ovr_2_anh000010(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: array of Int32; layout: IntPtr): IntPtr :=
    if (stride<>nil) and (stride.Length<>0) then
      z_MapTexture2DINTEL_ovr_2(texture, level, access, stride[0], layout) else
      z_MapTexture2DINTEL_ovr_2_anh000010(texture, level, access, IntPtr.Zero, layout);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; layout: array of DummyEnum): IntPtr :=
    if (layout<>nil) and (layout.Length<>0) then
      z_MapTexture2DINTEL_ovr_0(texture, level, access, stride, layout[0]) else
      z_MapTexture2DINTEL_ovr_0_anh000001(texture, level, access, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; var layout: DummyEnum): IntPtr :=
    z_MapTexture2DINTEL_ovr_0(texture, level, access, stride, layout);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; var stride: Int32; layout: IntPtr): IntPtr :=
    z_MapTexture2DINTEL_ovr_2(texture, level, access, stride, layout);
    private static function z_MapTexture2DINTEL_ovr_6(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    private static function z_MapTexture2DINTEL_ovr_6_anh000001(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: array of DummyEnum): IntPtr :=
    if (layout<>nil) and (layout.Length<>0) then
      z_MapTexture2DINTEL_ovr_6(texture, level, access, stride, layout[0]) else
      z_MapTexture2DINTEL_ovr_6_anh000001(texture, level, access, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; var layout: DummyEnum): IntPtr :=
    z_MapTexture2DINTEL_ovr_6(texture, level, access, stride, layout);
    private static function z_MapTexture2DINTEL_ovr_8(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr;
    external 'opengl32.dll' name 'glMapTexture2DINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function MapTexture2DINTEL(texture: UInt32; level: Int32; access: DummyFlags; stride: IntPtr; layout: IntPtr): IntPtr :=
    z_MapTexture2DINTEL_ovr_8(texture, level, access, stride, layout);
    
  end;
  
  glParallelArraysINTEL = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexPointervINTEL_ovr_0(size: Int32; &type: VertexPointerType; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexPointervINTEL';
    private static procedure z_VertexPointervINTEL_ovr_0_anh0001(size: Int32; &type: VertexPointerType; _pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_VertexPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_VertexPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_VertexPointervINTEL_ovr_0(size, &type, _pointer);
    private static procedure z_VertexPointervINTEL_ovr_2(size: Int32; &type: VertexPointerType; _pointer: pointer);
    external 'opengl32.dll' name 'glVertexPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_VertexPointervINTEL_ovr_2(size, &type, _pointer);
    
    private static procedure z_NormalPointervINTEL_ovr_0(&type: NormalPointerType; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glNormalPointervINTEL';
    private static procedure z_NormalPointervINTEL_ovr_0_anh001(&type: NormalPointerType; _pointer: IntPtr);
    external 'opengl32.dll' name 'glNormalPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_NormalPointervINTEL_ovr_0(&type, _pointer[0]) else
      z_NormalPointervINTEL_ovr_0_anh001(&type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; var _pointer: IntPtr) :=
    z_NormalPointervINTEL_ovr_0(&type, _pointer);
    private static procedure z_NormalPointervINTEL_ovr_2(&type: NormalPointerType; _pointer: pointer);
    external 'opengl32.dll' name 'glNormalPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalPointervINTEL(&type: NormalPointerType; _pointer: pointer) :=
    z_NormalPointervINTEL_ovr_2(&type, _pointer);
    
    private static procedure z_ColorPointervINTEL_ovr_0(size: Int32; &type: VertexPointerType; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glColorPointervINTEL';
    private static procedure z_ColorPointervINTEL_ovr_0_anh0001(size: Int32; &type: VertexPointerType; _pointer: IntPtr);
    external 'opengl32.dll' name 'glColorPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ColorPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_ColorPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_ColorPointervINTEL_ovr_0(size, &type, _pointer);
    private static procedure z_ColorPointervINTEL_ovr_2(size: Int32; &type: VertexPointerType; _pointer: pointer);
    external 'opengl32.dll' name 'glColorPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_ColorPointervINTEL_ovr_2(size, &type, _pointer);
    
    private static procedure z_TexCoordPointervINTEL_ovr_0(size: Int32; &type: VertexPointerType; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glTexCoordPointervINTEL';
    private static procedure z_TexCoordPointervINTEL_ovr_0_anh0001(size: Int32; &type: VertexPointerType; _pointer: IntPtr);
    external 'opengl32.dll' name 'glTexCoordPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_TexCoordPointervINTEL_ovr_0(size, &type, _pointer[0]) else
      z_TexCoordPointervINTEL_ovr_0_anh0001(size, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; var _pointer: IntPtr) :=
    z_TexCoordPointervINTEL_ovr_0(size, &type, _pointer);
    private static procedure z_TexCoordPointervINTEL_ovr_2(size: Int32; &type: VertexPointerType; _pointer: pointer);
    external 'opengl32.dll' name 'glTexCoordPointervINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordPointervINTEL(size: Int32; &type: VertexPointerType; _pointer: pointer) :=
    z_TexCoordPointervINTEL_ovr_2(size, &type, _pointer);
    
  end;
  
  glPerformanceQueryINTEL = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginPerfQueryINTEL_ovr_0(queryHandle: PerfQueryHandleINTEL);
    external 'opengl32.dll' name 'glBeginPerfQueryINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginPerfQueryINTEL(queryHandle: PerfQueryHandleINTEL) :=
    z_BeginPerfQueryINTEL_ovr_0(queryHandle);
    
    private static procedure z_CreatePerfQueryINTEL_ovr_0(queryId: PerfQueryIdINTEL; var queryHandle: PerfQueryHandleINTEL);
    external 'opengl32.dll' name 'glCreatePerfQueryINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreatePerfQueryINTEL(queryId: PerfQueryIdINTEL; var queryHandle: PerfQueryHandleINTEL) :=
    z_CreatePerfQueryINTEL_ovr_0(queryId, queryHandle);
    private static procedure z_CreatePerfQueryINTEL_ovr_1(queryId: PerfQueryIdINTEL; queryHandle: IntPtr);
    external 'opengl32.dll' name 'glCreatePerfQueryINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreatePerfQueryINTEL(queryId: PerfQueryIdINTEL; queryHandle: IntPtr) :=
    z_CreatePerfQueryINTEL_ovr_1(queryId, queryHandle);
    
    private static procedure z_DeletePerfQueryINTEL_ovr_0(queryHandle: PerfQueryHandleINTEL);
    external 'opengl32.dll' name 'glDeletePerfQueryINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePerfQueryINTEL(queryHandle: PerfQueryHandleINTEL) :=
    z_DeletePerfQueryINTEL_ovr_0(queryHandle);
    
    private static procedure z_EndPerfQueryINTEL_ovr_0(queryHandle: PerfQueryHandleINTEL);
    external 'opengl32.dll' name 'glEndPerfQueryINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndPerfQueryINTEL(queryHandle: PerfQueryHandleINTEL) :=
    z_EndPerfQueryINTEL_ovr_0(queryHandle);
    
    private static procedure z_GetFirstPerfQueryIdINTEL_ovr_0(var queryId: PerfQueryIdINTEL);
    external 'opengl32.dll' name 'glGetFirstPerfQueryIdINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFirstPerfQueryIdINTEL(var queryId: PerfQueryIdINTEL) :=
    z_GetFirstPerfQueryIdINTEL_ovr_0(queryId);
    private static procedure z_GetFirstPerfQueryIdINTEL_ovr_1(queryId: IntPtr);
    external 'opengl32.dll' name 'glGetFirstPerfQueryIdINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFirstPerfQueryIdINTEL(queryId: IntPtr) :=
    z_GetFirstPerfQueryIdINTEL_ovr_1(queryId);
    
    private static procedure z_GetNextPerfQueryIdINTEL_ovr_0(queryId: PerfQueryIdINTEL; nextQueryId: PerfQueryIdINTEL);
    external 'opengl32.dll' name 'glGetNextPerfQueryIdINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNextPerfQueryIdINTEL(queryId: PerfQueryIdINTEL; nextQueryId: PerfQueryIdINTEL) :=
    z_GetNextPerfQueryIdINTEL_ovr_0(queryId, nextQueryId);
    private static procedure z_GetNextPerfQueryIdINTEL_ovr_1(queryId: PerfQueryIdINTEL; nextQueryId: IntPtr);
    external 'opengl32.dll' name 'glGetNextPerfQueryIdINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNextPerfQueryIdINTEL(queryId: PerfQueryIdINTEL; nextQueryId: IntPtr) :=
    z_GetNextPerfQueryIdINTEL_ovr_1(queryId, nextQueryId);
    
    private static procedure z_GetPerfCounterInfoINTEL_ovr_0(queryId: PerfQueryIdINTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; var counterOffset: UInt32; var counterDataSize: UInt32; var counterTypeEnum: UInt32; var counterDataTypeEnum: UInt32; var rawCounterMaxValue: UInt64);
    external 'opengl32.dll' name 'glGetPerfCounterInfoINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfCounterInfoINTEL(queryId: PerfQueryIdINTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; var counterOffset: UInt32; var counterDataSize: UInt32; var counterTypeEnum: UInt32; var counterDataTypeEnum: UInt32; var rawCounterMaxValue: UInt64) :=
    z_GetPerfCounterInfoINTEL_ovr_0(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue);
    private static procedure z_GetPerfCounterInfoINTEL_ovr_1(queryId: PerfQueryIdINTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; counterOffset: IntPtr; counterDataSize: IntPtr; counterTypeEnum: IntPtr; counterDataTypeEnum: IntPtr; rawCounterMaxValue: IntPtr);
    external 'opengl32.dll' name 'glGetPerfCounterInfoINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfCounterInfoINTEL(queryId: PerfQueryIdINTEL; counterId: UInt32; counterNameLength: UInt32; counterName: IntPtr; counterDescLength: UInt32; counterDesc: IntPtr; counterOffset: IntPtr; counterDataSize: IntPtr; counterTypeEnum: IntPtr; counterDataTypeEnum: IntPtr; rawCounterMaxValue: IntPtr) :=
    z_GetPerfCounterInfoINTEL_ovr_1(queryId, counterId, counterNameLength, counterName, counterDescLength, counterDesc, counterOffset, counterDataSize, counterTypeEnum, counterDataTypeEnum, rawCounterMaxValue);
    
    private static procedure z_GetPerfQueryDataINTEL_ovr_0(queryHandle: PerfQueryHandleINTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; var bytesWritten: UInt32);
    external 'opengl32.dll' name 'glGetPerfQueryDataINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryDataINTEL(queryHandle: PerfQueryHandleINTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; var bytesWritten: UInt32) :=
    z_GetPerfQueryDataINTEL_ovr_0(queryHandle, flags, dataSize, data, bytesWritten);
    private static procedure z_GetPerfQueryDataINTEL_ovr_1(queryHandle: PerfQueryHandleINTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr);
    external 'opengl32.dll' name 'glGetPerfQueryDataINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryDataINTEL(queryHandle: PerfQueryHandleINTEL; flags: PerfQueryDataFlagsINTEL; dataSize: Int32; data: IntPtr; bytesWritten: IntPtr) :=
    z_GetPerfQueryDataINTEL_ovr_1(queryHandle, flags, dataSize, data, bytesWritten);
    
    private static procedure z_GetPerfQueryIdByNameINTEL_ovr_0(queryName: IntPtr; var queryId: PerfQueryIdINTEL);
    external 'opengl32.dll' name 'glGetPerfQueryIdByNameINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: string; var queryId: PerfQueryIdINTEL);
    begin
      var par_1_str_ptr := Marshal.StringToHGlobalAnsi(queryName);
      z_GetPerfQueryIdByNameINTEL_ovr_0(par_1_str_ptr, queryId);
      Marshal.FreeHGlobal(par_1_str_ptr);
    end;
    private static procedure z_GetPerfQueryIdByNameINTEL_ovr_1(queryName: IntPtr; queryId: IntPtr);
    external 'opengl32.dll' name 'glGetPerfQueryIdByNameINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: string; queryId: IntPtr);
    begin
      var par_1_str_ptr := Marshal.StringToHGlobalAnsi(queryName);
      z_GetPerfQueryIdByNameINTEL_ovr_1(par_1_str_ptr, queryId);
      Marshal.FreeHGlobal(par_1_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: IntPtr; var queryId: PerfQueryIdINTEL) :=
    z_GetPerfQueryIdByNameINTEL_ovr_0(queryName, queryId);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryIdByNameINTEL(queryName: IntPtr; queryId: IntPtr) :=
    z_GetPerfQueryIdByNameINTEL_ovr_1(queryName, queryId);
    
    private static procedure z_GetPerfQueryInfoINTEL_ovr_0(queryId: PerfQueryIdINTEL; queryNameLength: UInt32; queryName: IntPtr; var dataSize: UInt32; var noCounters: UInt32; var noInstances: UInt32; var capsMask: PerfQueryCapFlagsINTEL);
    external 'opengl32.dll' name 'glGetPerfQueryInfoINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryInfoINTEL(queryId: PerfQueryIdINTEL; queryNameLength: UInt32; queryName: IntPtr; var dataSize: UInt32; var noCounters: UInt32; var noInstances: UInt32; var capsMask: PerfQueryCapFlagsINTEL) :=
    z_GetPerfQueryInfoINTEL_ovr_0(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask);
    private static procedure z_GetPerfQueryInfoINTEL_ovr_1(queryId: PerfQueryIdINTEL; queryNameLength: UInt32; queryName: IntPtr; dataSize: IntPtr; noCounters: IntPtr; noInstances: IntPtr; capsMask: IntPtr);
    external 'opengl32.dll' name 'glGetPerfQueryInfoINTEL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPerfQueryInfoINTEL(queryId: PerfQueryIdINTEL; queryNameLength: UInt32; queryName: IntPtr; dataSize: IntPtr; noCounters: IntPtr; noInstances: IntPtr; capsMask: IntPtr) :=
    z_GetPerfQueryInfoINTEL_ovr_1(queryId, queryNameLength, queryName, dataSize, noCounters, noInstances, capsMask);
    
  end;
  
  glBlendEquationAdvancedKHR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendBarrierKHR_ovr_0;
    external 'opengl32.dll' name 'glBlendBarrierKHR';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendBarrierKHR :=
    z_BlendBarrierKHR_ovr_0;
    
  end;
  
  glDebugKHR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DebugMessageControl_ovr_0(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControl';
    private static procedure z_DebugMessageControl_ovr_0_anh0000010(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControl';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: array of UInt32; enabled: boolean) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DebugMessageControl_ovr_0(source, &type, severity, count, ids[0], enabled) else
      z_DebugMessageControl_ovr_0_anh0000010(source, &type, severity, count, IntPtr.Zero, enabled);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; var ids: UInt32; enabled: boolean) :=
    z_DebugMessageControl_ovr_0(source, &type, severity, count, ids, enabled);
    private static procedure z_DebugMessageControl_ovr_2(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean);
    external 'opengl32.dll' name 'glDebugMessageControl';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageControl(source: DebugSource; &type: DebugType; severity: DebugSeverity; count: Int32; ids: IntPtr; enabled: boolean) :=
    z_DebugMessageControl_ovr_2(source, &type, severity, count, ids, enabled);
    
    private static procedure z_DebugMessageInsert_ovr_0(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageInsert';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: string);
    begin
      var par_6_str_ptr := Marshal.StringToHGlobalAnsi(buf);
      z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, par_6_str_ptr);
      Marshal.FreeHGlobal(par_6_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageInsert(source: DebugSource; &type: DebugType; id: UInt32; severity: DebugSeverity; length: Int32; buf: IntPtr) :=
    z_DebugMessageInsert_ovr_0(source, &type, id, severity, length, buf);
    
    private static procedure z_DebugMessageCallback_ovr_0(callback: GLDEBUGPROC; userParam: IntPtr);
    external 'opengl32.dll' name 'glDebugMessageCallback';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DebugMessageCallback(callback: GLDEBUGPROC; userParam: IntPtr) :=
    z_DebugMessageCallback_ovr_0(callback, userParam);
    
    private static function z_GetDebugMessageLog_ovr_0(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLog';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; var sources: DebugSource; var types: DebugType; var ids: UInt32; var severities: DebugSeverity; var lengths: Int32; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_0(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    private static function z_GetDebugMessageLog_ovr_1(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32;
    external 'opengl32.dll' name 'glGetDebugMessageLog';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetDebugMessageLog(count: UInt32; bufSize: Int32; sources: IntPtr; types: IntPtr; ids: IntPtr; severities: IntPtr; lengths: IntPtr; messageLog: IntPtr): UInt32 :=
    z_GetDebugMessageLog_ovr_1(count, bufSize, sources, types, ids, severities, lengths, messageLog);
    
    private static procedure z_PushDebugGroup_ovr_0(source: DebugSource; id: UInt32; length: Int32; message: IntPtr);
    external 'opengl32.dll' name 'glPushDebugGroup';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(message);
      z_PushDebugGroup_ovr_0(source, id, length, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PushDebugGroup(source: DebugSource; id: UInt32; length: Int32; message: IntPtr) :=
    z_PushDebugGroup_ovr_0(source, id, length, message);
    
    private static procedure z_PopDebugGroup_ovr_0;
    external 'opengl32.dll' name 'glPopDebugGroup';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PopDebugGroup :=
    z_PopDebugGroup_ovr_0;
    
    private static procedure z_ObjectLabel_ovr_0(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glObjectLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: string);
    begin
      var par_4_str_ptr := Marshal.StringToHGlobalAnsi(&label);
      z_ObjectLabel_ovr_0(identifier, name, length, par_4_str_ptr);
      Marshal.FreeHGlobal(par_4_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectLabel(identifier: ObjectIdentifier; name: UInt32; length: Int32; &label: IntPtr) :=
    z_ObjectLabel_ovr_0(identifier, name, length, &label);
    
    private static procedure z_GetObjectLabel_ovr_0(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabel';
    private static procedure z_GetObjectLabel_ovr_0_anh000010(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: array of Int32; &label: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetObjectLabel_ovr_0(identifier, name, bufSize, length[0], &label) else
      z_GetObjectLabel_ovr_0_anh000010(identifier, name, bufSize, IntPtr.Zero, &label);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectLabel_ovr_0(identifier, name, bufSize, length, &label);
    private static procedure z_GetObjectLabel_ovr_2(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectLabel(identifier: ObjectIdentifier; name: UInt32; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectLabel_ovr_2(identifier, name, bufSize, length, &label);
    
    private static procedure z_ObjectPtrLabel_ovr_0(ptr: IntPtr; length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glObjectPtrLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: string);
    begin
      var par_3_str_ptr := Marshal.StringToHGlobalAnsi(&label);
      z_ObjectPtrLabel_ovr_0(ptr, length, par_3_str_ptr);
      Marshal.FreeHGlobal(par_3_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ObjectPtrLabel(ptr: IntPtr; length: Int32; &label: IntPtr) :=
    z_ObjectPtrLabel_ovr_0(ptr, length, &label);
    
    private static procedure z_GetObjectPtrLabel_ovr_0(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectPtrLabel';
    private static procedure z_GetObjectPtrLabel_ovr_0_anh00010(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectPtrLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: array of Int32; &label: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length[0], &label) else
      z_GetObjectPtrLabel_ovr_0_anh00010(ptr, bufSize, IntPtr.Zero, &label);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; var length: Int32; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_0(ptr, bufSize, length, &label);
    private static procedure z_GetObjectPtrLabel_ovr_2(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr);
    external 'opengl32.dll' name 'glGetObjectPtrLabel';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetObjectPtrLabel(ptr: IntPtr; bufSize: Int32; length: IntPtr; &label: IntPtr) :=
    z_GetObjectPtrLabel_ovr_2(ptr, bufSize, length, &label);
    
    private static procedure z_GetPointerv_ovr_0(pname: GetPointervPName; var &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointerv';
    private static procedure z_GetPointerv_ovr_0_anh001(pname: GetPointervPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPointerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: array of IntPtr) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPointerv_ovr_0(pname, &params[0]) else
      z_GetPointerv_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; var &params: IntPtr) :=
    z_GetPointerv_ovr_0(pname, &params);
    private static procedure z_GetPointerv_ovr_2(pname: GetPointervPName; &params: pointer);
    external 'opengl32.dll' name 'glGetPointerv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPointerv(pname: GetPointervPName; &params: pointer) :=
    z_GetPointerv_ovr_2(pname, &params);
    
  end;
  
  glRobustnessKHR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetGraphicsResetStatus_ovr_0: GraphicsResetStatus;
    external 'opengl32.dll' name 'glGetGraphicsResetStatus';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetGraphicsResetStatus: GraphicsResetStatus :=
    z_GetGraphicsResetStatus_ovr_0;
    
    private static procedure z_ReadnPixels_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr);
    external 'opengl32.dll' name 'glReadnPixels';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadnPixels(x: Int32; y: Int32; width: Int32; height: Int32; format: PixelFormat; &type: PixelType; bufSize: Int32; data: IntPtr) :=
    z_ReadnPixels_ovr_0(x, y, width, height, format, &type, bufSize, data);
    
    private static procedure z_GetnUniformfv_ovr_0(&program: ProgramName; location: Int32; bufSize: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetnUniformfv';
    private static procedure z_GetnUniformfv_ovr_0_anh00001(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformfv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformfv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: single) :=
    z_GetnUniformfv_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformfv_ovr_2(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformfv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformfv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformfv_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformiv_ovr_0(&program: ProgramName; location: Int32; bufSize: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetnUniformiv';
    private static procedure z_GetnUniformiv_ovr_0_anh00001(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: Int32) :=
    z_GetnUniformiv_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformiv_ovr_2(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformiv_ovr_2(&program, location, bufSize, &params);
    
    private static procedure z_GetnUniformuiv_ovr_0(&program: ProgramName; location: Int32; bufSize: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetnUniformuiv';
    private static procedure z_GetnUniformuiv_ovr_0_anh00001(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params[0]) else
      z_GetnUniformuiv_ovr_0_anh00001(&program, location, bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; var &params: UInt32) :=
    z_GetnUniformuiv_ovr_0(&program, location, bufSize, &params);
    private static procedure z_GetnUniformuiv_ovr_2(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetnUniformuiv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetnUniformuiv(&program: ProgramName; location: Int32; bufSize: Int32; &params: IntPtr) :=
    z_GetnUniformuiv_ovr_2(&program, location, bufSize, &params);
    
  end;
  
  glParallelShaderCompileKHR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MaxShaderCompilerThreadsKHR_ovr_0(count: UInt32);
    external 'opengl32.dll' name 'glMaxShaderCompilerThreadsKHR';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaxShaderCompilerThreadsKHR(count: UInt32) :=
    z_MaxShaderCompilerThreadsKHR_ovr_0(count);
    
  end;
  
  glFramebufferFlipYMESA = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferParameteriMESA_ovr_0(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32);
    external 'opengl32.dll' name 'glFramebufferParameteriMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferParameteriMESA(target: FramebufferTarget; pname: FramebufferParameterName; param: Int32) :=
    z_FramebufferParameteriMESA_ovr_0(target, pname, param);
    
    private static procedure z_GetFramebufferParameterivMESA_ovr_0(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetFramebufferParameterivMESA';
    private static procedure z_GetFramebufferParameterivMESA_ovr_0_anh0001(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFramebufferParameterivMESA_ovr_0(target, pname, &params[0]) else
      z_GetFramebufferParameterivMESA_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; var &params: Int32) :=
    z_GetFramebufferParameterivMESA_ovr_0(target, pname, &params);
    private static procedure z_GetFramebufferParameterivMESA_ovr_2(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFramebufferParameterivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFramebufferParameterivMESA(target: FramebufferTarget; pname: FramebufferAttachmentParameterName; &params: IntPtr) :=
    z_GetFramebufferParameterivMESA_ovr_2(target, pname, &params);
    
  end;
  
  glResizeBuffersMESA = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ResizeBuffersMESA_ovr_0;
    external 'opengl32.dll' name 'glResizeBuffersMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResizeBuffersMESA :=
    z_ResizeBuffersMESA_ovr_0;
    
  end;
  
  glWindowPosMESA = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_WindowPos2dMESA_ovr_0(x: real; y: real);
    external 'opengl32.dll' name 'glWindowPos2dMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dMESA(x: real; y: real) :=
    z_WindowPos2dMESA_ovr_0(x, y);
    
    private static procedure z_WindowPos2dvMESA_ovr_0(var v: real);
    external 'opengl32.dll' name 'glWindowPos2dvMESA';
    private static procedure z_WindowPos2dvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2dvMESA_ovr_0(v[0]) else
      z_WindowPos2dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(var v: real) :=
    z_WindowPos2dvMESA_ovr_0(v);
    private static procedure z_WindowPos2dvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2dvMESA(v: IntPtr) :=
    z_WindowPos2dvMESA_ovr_2(v);
    
    private static procedure z_WindowPos2fMESA_ovr_0(x: single; y: single);
    external 'opengl32.dll' name 'glWindowPos2fMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fMESA(x: single; y: single) :=
    z_WindowPos2fMESA_ovr_0(x, y);
    
    private static procedure z_WindowPos2fvMESA_ovr_0(var v: single);
    external 'opengl32.dll' name 'glWindowPos2fvMESA';
    private static procedure z_WindowPos2fvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2fvMESA_ovr_0(v[0]) else
      z_WindowPos2fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(var v: single) :=
    z_WindowPos2fvMESA_ovr_0(v);
    private static procedure z_WindowPos2fvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2fvMESA(v: IntPtr) :=
    z_WindowPos2fvMESA_ovr_2(v);
    
    private static procedure z_WindowPos2iMESA_ovr_0(x: Int32; y: Int32);
    external 'opengl32.dll' name 'glWindowPos2iMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2iMESA(x: Int32; y: Int32) :=
    z_WindowPos2iMESA_ovr_0(x, y);
    
    private static procedure z_WindowPos2ivMESA_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glWindowPos2ivMESA';
    private static procedure z_WindowPos2ivMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2ivMESA_ovr_0(v[0]) else
      z_WindowPos2ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(var v: Int32) :=
    z_WindowPos2ivMESA_ovr_0(v);
    private static procedure z_WindowPos2ivMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2ivMESA(v: IntPtr) :=
    z_WindowPos2ivMESA_ovr_2(v);
    
    private static procedure z_WindowPos2sMESA_ovr_0(x: Int16; y: Int16);
    external 'opengl32.dll' name 'glWindowPos2sMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2sMESA(x: Int16; y: Int16) :=
    z_WindowPos2sMESA_ovr_0(x, y);
    
    private static procedure z_WindowPos2svMESA_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glWindowPos2svMESA';
    private static procedure z_WindowPos2svMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos2svMESA_ovr_0(v[0]) else
      z_WindowPos2svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(var v: Int16) :=
    z_WindowPos2svMESA_ovr_0(v);
    private static procedure z_WindowPos2svMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos2svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos2svMESA(v: IntPtr) :=
    z_WindowPos2svMESA_ovr_2(v);
    
    private static procedure z_WindowPos3dMESA_ovr_0(x: real; y: real; z: real);
    external 'opengl32.dll' name 'glWindowPos3dMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dMESA(x: real; y: real; z: real) :=
    z_WindowPos3dMESA_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3dvMESA_ovr_0(var v: real);
    external 'opengl32.dll' name 'glWindowPos3dvMESA';
    private static procedure z_WindowPos3dvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3dvMESA_ovr_0(v[0]) else
      z_WindowPos3dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(var v: real) :=
    z_WindowPos3dvMESA_ovr_0(v);
    private static procedure z_WindowPos3dvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3dvMESA(v: IntPtr) :=
    z_WindowPos3dvMESA_ovr_2(v);
    
    private static procedure z_WindowPos3fMESA_ovr_0(x: single; y: single; z: single);
    external 'opengl32.dll' name 'glWindowPos3fMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fMESA(x: single; y: single; z: single) :=
    z_WindowPos3fMESA_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3fvMESA_ovr_0(var v: single);
    external 'opengl32.dll' name 'glWindowPos3fvMESA';
    private static procedure z_WindowPos3fvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3fvMESA_ovr_0(v[0]) else
      z_WindowPos3fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(var v: single) :=
    z_WindowPos3fvMESA_ovr_0(v);
    private static procedure z_WindowPos3fvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3fvMESA(v: IntPtr) :=
    z_WindowPos3fvMESA_ovr_2(v);
    
    private static procedure z_WindowPos3iMESA_ovr_0(x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glWindowPos3iMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3iMESA(x: Int32; y: Int32; z: Int32) :=
    z_WindowPos3iMESA_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3ivMESA_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glWindowPos3ivMESA';
    private static procedure z_WindowPos3ivMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3ivMESA_ovr_0(v[0]) else
      z_WindowPos3ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(var v: Int32) :=
    z_WindowPos3ivMESA_ovr_0(v);
    private static procedure z_WindowPos3ivMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3ivMESA(v: IntPtr) :=
    z_WindowPos3ivMESA_ovr_2(v);
    
    private static procedure z_WindowPos3sMESA_ovr_0(x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glWindowPos3sMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3sMESA(x: Int16; y: Int16; z: Int16) :=
    z_WindowPos3sMESA_ovr_0(x, y, z);
    
    private static procedure z_WindowPos3svMESA_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glWindowPos3svMESA';
    private static procedure z_WindowPos3svMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos3svMESA_ovr_0(v[0]) else
      z_WindowPos3svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(var v: Int16) :=
    z_WindowPos3svMESA_ovr_0(v);
    private static procedure z_WindowPos3svMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos3svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos3svMESA(v: IntPtr) :=
    z_WindowPos3svMESA_ovr_2(v);
    
    private static procedure z_WindowPos4dMESA_ovr_0(x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glWindowPos4dMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dMESA(x: real; y: real; z: real; w: real) :=
    z_WindowPos4dMESA_ovr_0(x, y, z, w);
    
    private static procedure z_WindowPos4dvMESA_ovr_0(var v: real);
    external 'opengl32.dll' name 'glWindowPos4dvMESA';
    private static procedure z_WindowPos4dvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4dvMESA_ovr_0(v[0]) else
      z_WindowPos4dvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(var v: real) :=
    z_WindowPos4dvMESA_ovr_0(v);
    private static procedure z_WindowPos4dvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4dvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4dvMESA(v: IntPtr) :=
    z_WindowPos4dvMESA_ovr_2(v);
    
    private static procedure z_WindowPos4fMESA_ovr_0(x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glWindowPos4fMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fMESA(x: single; y: single; z: single; w: single) :=
    z_WindowPos4fMESA_ovr_0(x, y, z, w);
    
    private static procedure z_WindowPos4fvMESA_ovr_0(var v: single);
    external 'opengl32.dll' name 'glWindowPos4fvMESA';
    private static procedure z_WindowPos4fvMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4fvMESA_ovr_0(v[0]) else
      z_WindowPos4fvMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(var v: single) :=
    z_WindowPos4fvMESA_ovr_0(v);
    private static procedure z_WindowPos4fvMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4fvMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4fvMESA(v: IntPtr) :=
    z_WindowPos4fvMESA_ovr_2(v);
    
    private static procedure z_WindowPos4iMESA_ovr_0(x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glWindowPos4iMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4iMESA(x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_WindowPos4iMESA_ovr_0(x, y, z, w);
    
    private static procedure z_WindowPos4ivMESA_ovr_0(var v: Int32);
    external 'opengl32.dll' name 'glWindowPos4ivMESA';
    private static procedure z_WindowPos4ivMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4ivMESA_ovr_0(v[0]) else
      z_WindowPos4ivMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(var v: Int32) :=
    z_WindowPos4ivMESA_ovr_0(v);
    private static procedure z_WindowPos4ivMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4ivMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4ivMESA(v: IntPtr) :=
    z_WindowPos4ivMESA_ovr_2(v);
    
    private static procedure z_WindowPos4sMESA_ovr_0(x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glWindowPos4sMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4sMESA(x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_WindowPos4sMESA_ovr_0(x, y, z, w);
    
    private static procedure z_WindowPos4svMESA_ovr_0(var v: Int16);
    external 'opengl32.dll' name 'glWindowPos4svMESA';
    private static procedure z_WindowPos4svMESA_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_WindowPos4svMESA_ovr_0(v[0]) else
      z_WindowPos4svMESA_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(var v: Int16) :=
    z_WindowPos4svMESA_ovr_0(v);
    private static procedure z_WindowPos4svMESA_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glWindowPos4svMESA';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WindowPos4svMESA(v: IntPtr) :=
    z_WindowPos4svMESA_ovr_2(v);
    
  end;
  
  glConditionalRenderNVX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginConditionalRenderNVX_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glBeginConditionalRenderNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRenderNVX(id: UInt32) :=
    z_BeginConditionalRenderNVX_ovr_0(id);
    
    private static procedure z_EndConditionalRenderNVX_ovr_0;
    external 'opengl32.dll' name 'glEndConditionalRenderNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRenderNVX :=
    z_EndConditionalRenderNVX_ovr_0;
    
  end;
  
  glLinkedGpuMulticastNVX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_LGPUNamedBufferSubDataNVX_ovr_0(gpuMask: DummyFlags; buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glLGPUNamedBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUNamedBufferSubDataNVX(gpuMask: DummyFlags; buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_LGPUNamedBufferSubDataNVX_ovr_0(gpuMask, buffer, offset, size, data);
    
    private static procedure z_LGPUCopyImageSubDataNVX_ovr_0(sourceGpu: UInt32; destinationGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srxY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glLGPUCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUCopyImageSubDataNVX(sourceGpu: UInt32; destinationGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srxY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_LGPUCopyImageSubDataNVX_ovr_0(sourceGpu, destinationGpuMask, srcName, srcTarget, srcLevel, srcX, srxY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
    private static procedure z_LGPUInterlockNVX_ovr_0;
    external 'opengl32.dll' name 'glLGPUInterlockNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LGPUInterlockNVX :=
    z_LGPUInterlockNVX_ovr_0;
    
  end;
  
  glAlphaToCoverageDitherControlNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_AlphaToCoverageDitherControlNV_ovr_0(mode: DummyEnum);
    external 'opengl32.dll' name 'glAlphaToCoverageDitherControlNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaToCoverageDitherControlNV(mode: DummyEnum) :=
    z_AlphaToCoverageDitherControlNV_ovr_0(mode);
    
  end;
  
  glBindlessMultiDrawIndirectNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysIndirectBindlessNV_ovr_0(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysIndirectBindlessNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectBindlessNV(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawArraysIndirectBindlessNV_ovr_0(mode, indirect, drawCount, stride, vertexBufferCount);
    
    private static procedure z_MultiDrawElementsIndirectBindlessNV_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsIndirectBindlessNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectBindlessNV(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawElementsIndirectBindlessNV_ovr_0(mode, &type, indirect, drawCount, stride, vertexBufferCount);
    
  end;
  
  glBindlessMultiDrawIndirectCountNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiDrawArraysIndirectBindlessCountNV_ovr_0(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32);
    external 'opengl32.dll' name 'glMultiDrawArraysIndirectBindlessCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawArraysIndirectBindlessCountNV(mode: PrimitiveType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawArraysIndirectBindlessCountNV_ovr_0(mode, indirect, drawCount, maxDrawCount, stride, vertexBufferCount);
    
    private static procedure z_MultiDrawElementsIndirectBindlessCountNV_ovr_0(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32);
    external 'opengl32.dll' name 'glMultiDrawElementsIndirectBindlessCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawElementsIndirectBindlessCountNV(mode: PrimitiveType; &type: DrawElementsType; indirect: IntPtr; drawCount: Int32; maxDrawCount: Int32; stride: Int32; vertexBufferCount: Int32) :=
    z_MultiDrawElementsIndirectBindlessCountNV_ovr_0(mode, &type, indirect, drawCount, maxDrawCount, stride, vertexBufferCount);
    
  end;
  
  glBindlessTextureNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetTextureHandleNV_ovr_0(texture: UInt32): UInt64;
    external 'opengl32.dll' name 'glGetTextureHandleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureHandleNV(texture: UInt32): UInt64 :=
    z_GetTextureHandleNV_ovr_0(texture);
    
    private static function z_GetTextureSamplerHandleNV_ovr_0(texture: UInt32; sampler: UInt32): UInt64;
    external 'opengl32.dll' name 'glGetTextureSamplerHandleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetTextureSamplerHandleNV(texture: UInt32; sampler: UInt32): UInt64 :=
    z_GetTextureSamplerHandleNV_ovr_0(texture, sampler);
    
    private static procedure z_MakeTextureHandleResidentNV_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeTextureHandleResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleResidentNV(handle: UInt64) :=
    z_MakeTextureHandleResidentNV_ovr_0(handle);
    
    private static procedure z_MakeTextureHandleNonResidentNV_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeTextureHandleNonResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeTextureHandleNonResidentNV(handle: UInt64) :=
    z_MakeTextureHandleNonResidentNV_ovr_0(handle);
    
    private static function z_GetImageHandleNV_ovr_0(texture: UInt32; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64;
    external 'opengl32.dll' name 'glGetImageHandleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetImageHandleNV(texture: UInt32; level: Int32; layered: boolean; layer: Int32; format: PixelFormat): UInt64 :=
    z_GetImageHandleNV_ovr_0(texture, level, layered, layer, format);
    
    private static procedure z_MakeImageHandleResidentNV_ovr_0(handle: UInt64; access: DummyEnum);
    external 'opengl32.dll' name 'glMakeImageHandleResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleResidentNV(handle: UInt64; access: DummyEnum) :=
    z_MakeImageHandleResidentNV_ovr_0(handle, access);
    
    private static procedure z_MakeImageHandleNonResidentNV_ovr_0(handle: UInt64);
    external 'opengl32.dll' name 'glMakeImageHandleNonResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeImageHandleNonResidentNV(handle: UInt64) :=
    z_MakeImageHandleNonResidentNV_ovr_0(handle);
    
    private static procedure z_UniformHandleui64NV_ovr_0(location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glUniformHandleui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64NV(location: Int32; value: UInt64) :=
    z_UniformHandleui64NV_ovr_0(location, value);
    
    private static procedure z_UniformHandleui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniformHandleui64vNV';
    private static procedure z_UniformHandleui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformHandleui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_UniformHandleui64vNV_ovr_0(location, count, value[0]) else
      z_UniformHandleui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_UniformHandleui64vNV_ovr_0(location, count, value);
    private static procedure z_UniformHandleui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformHandleui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UniformHandleui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_UniformHandleui64vNV_ovr_2(location, count, value);
    
    private static procedure z_ProgramUniformHandleui64NV_ovr_0(&program: UInt32; location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glProgramUniformHandleui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64NV(&program: UInt32; location: Int32; value: UInt64) :=
    z_ProgramUniformHandleui64NV_ovr_0(&program, location, value);
    
    private static procedure z_ProgramUniformHandleui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var values: UInt64);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vNV';
    private static procedure z_ProgramUniformHandleui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: UInt32; location: Int32; count: Int32; values: array of UInt64) :=
    if (values<>nil) and (values.Length<>0) then
      z_ProgramUniformHandleui64vNV_ovr_0(&program, location, count, values[0]) else
      z_ProgramUniformHandleui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: UInt32; location: Int32; count: Int32; var values: UInt64) :=
    z_ProgramUniformHandleui64vNV_ovr_0(&program, location, count, values);
    private static procedure z_ProgramUniformHandleui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformHandleui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformHandleui64vNV(&program: UInt32; location: Int32; count: Int32; values: IntPtr) :=
    z_ProgramUniformHandleui64vNV_ovr_2(&program, location, count, values);
    
    private static function z_IsTextureHandleResidentNV_ovr_0(handle: UInt64): boolean;
    external 'opengl32.dll' name 'glIsTextureHandleResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTextureHandleResidentNV(handle: UInt64): boolean :=
    z_IsTextureHandleResidentNV_ovr_0(handle);
    
    private static function z_IsImageHandleResidentNV_ovr_0(handle: UInt64): boolean;
    external 'opengl32.dll' name 'glIsImageHandleResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsImageHandleResidentNV(handle: UInt64): boolean :=
    z_IsImageHandleResidentNV_ovr_0(handle);
    
  end;
  
  glBlendEquationAdvancedNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BlendParameteriNV_ovr_0(pname: DummyEnum; value: Int32);
    external 'opengl32.dll' name 'glBlendParameteriNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendParameteriNV(pname: DummyEnum; value: Int32) :=
    z_BlendParameteriNV_ovr_0(pname, value);
    
    private static procedure z_BlendBarrierNV_ovr_0;
    external 'opengl32.dll' name 'glBlendBarrierNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendBarrierNV :=
    z_BlendBarrierNV_ovr_0;
    
  end;
  
  glClipSpaceWScalingNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ViewportPositionWScaleNV_ovr_0(index: UInt32; xcoeff: single; ycoeff: single);
    external 'opengl32.dll' name 'glViewportPositionWScaleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportPositionWScaleNV(index: UInt32; xcoeff: single; ycoeff: single) :=
    z_ViewportPositionWScaleNV_ovr_0(index, xcoeff, ycoeff);
    
  end;
  
  glCommandListNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CreateStatesNV_ovr_0(n: Int32; var states: UInt32);
    external 'opengl32.dll' name 'glCreateStatesNV';
    private static procedure z_CreateStatesNV_ovr_0_anh001(n: Int32; states: IntPtr);
    external 'opengl32.dll' name 'glCreateStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; states: array of UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_CreateStatesNV_ovr_0(n, states[0]) else
      z_CreateStatesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; var states: UInt32) :=
    z_CreateStatesNV_ovr_0(n, states);
    private static procedure z_CreateStatesNV_ovr_2(n: Int32; states: IntPtr);
    external 'opengl32.dll' name 'glCreateStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateStatesNV(n: Int32; states: IntPtr) :=
    z_CreateStatesNV_ovr_2(n, states);
    
    private static procedure z_DeleteStatesNV_ovr_0(n: Int32; var states: UInt32);
    external 'opengl32.dll' name 'glDeleteStatesNV';
    private static procedure z_DeleteStatesNV_ovr_0_anh001(n: Int32; states: IntPtr);
    external 'opengl32.dll' name 'glDeleteStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; states: array of UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DeleteStatesNV_ovr_0(n, states[0]) else
      z_DeleteStatesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; var states: UInt32) :=
    z_DeleteStatesNV_ovr_0(n, states);
    private static procedure z_DeleteStatesNV_ovr_2(n: Int32; states: IntPtr);
    external 'opengl32.dll' name 'glDeleteStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteStatesNV(n: Int32; states: IntPtr) :=
    z_DeleteStatesNV_ovr_2(n, states);
    
    private static function z_IsStateNV_ovr_0(state: UInt32): boolean;
    external 'opengl32.dll' name 'glIsStateNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsStateNV(state: UInt32): boolean :=
    z_IsStateNV_ovr_0(state);
    
    private static procedure z_StateCaptureNV_ovr_0(state: UInt32; mode: DummyEnum);
    external 'opengl32.dll' name 'glStateCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StateCaptureNV(state: UInt32; mode: DummyEnum) :=
    z_StateCaptureNV_ovr_0(state, mode);
    
    private static function z_GetCommandHeaderNV_ovr_0(tokenID: DummyEnum; size: UInt32): UInt32;
    external 'opengl32.dll' name 'glGetCommandHeaderNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetCommandHeaderNV(tokenID: DummyEnum; size: UInt32): UInt32 :=
    z_GetCommandHeaderNV_ovr_0(tokenID, size);
    
    private static function z_GetStageIndexNV_ovr_0(_shadertype: ShaderType): UInt16;
    external 'opengl32.dll' name 'glGetStageIndexNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetStageIndexNV(_shadertype: ShaderType): UInt16 :=
    z_GetStageIndexNV_ovr_0(_shadertype);
    
    private static procedure z_DrawCommandsNV_ovr_0(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    private static procedure z_DrawCommandsNV_ovr_0_anh000100(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    private static procedure z_DrawCommandsNV_ovr_0_anh000010(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    private static procedure z_DrawCommandsNV_ovr_0_anh000110(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects[0], sizes[0], count) else
        z_DrawCommandsNV_ovr_0_anh000010(primitiveMode, buffer, indirects[0], IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsNV_ovr_0_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes[0], count) else
        z_DrawCommandsNV_ovr_0_anh000110(primitiveMode, buffer, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsNV_ovr_1_anh000100(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects[0], sizes, count) else
      z_DrawCommandsNV_ovr_0_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes, count);
    private static procedure z_DrawCommandsNV_ovr_2(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    private static procedure z_DrawCommandsNV_ovr_2_anh000100(primitiveMode: DummyEnum; buffer: UInt32; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsNV_ovr_2(primitiveMode, buffer, indirects[0], sizes, count) else
      z_DrawCommandsNV_ovr_2_anh000100(primitiveMode, buffer, IntPtr.Zero, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects, sizes[0], count) else
      z_DrawCommandsNV_ovr_0_anh000010(primitiveMode, buffer, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsNV_ovr_0(primitiveMode, buffer, indirects, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsNV_ovr_2(primitiveMode, buffer, indirects, sizes, count);
    private static procedure z_DrawCommandsNV_ovr_6(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    private static procedure z_DrawCommandsNV_ovr_6_anh000010(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsNV_ovr_6(primitiveMode, buffer, indirects, sizes[0], count) else
      z_DrawCommandsNV_ovr_6_anh000010(primitiveMode, buffer, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsNV_ovr_6(primitiveMode, buffer, indirects, sizes, count);
    private static procedure z_DrawCommandsNV_ovr_8(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsNV(primitiveMode: DummyEnum; buffer: UInt32; indirects: pointer; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsNV_ovr_8(primitiveMode, buffer, indirects, sizes, count);
    
    private static procedure z_DrawCommandsAddressNV_ovr_0(primitiveMode: DummyEnum; var indirects: UInt64; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    private static procedure z_DrawCommandsAddressNV_ovr_0_anh00100(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    private static procedure z_DrawCommandsAddressNV_ovr_0_anh00010(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    private static procedure z_DrawCommandsAddressNV_ovr_0_anh00110(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; sizes: array of Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects[0], sizes[0], count) else
        z_DrawCommandsAddressNV_ovr_0_anh00010(primitiveMode, indirects[0], IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsAddressNV_ovr_0_anh00100(primitiveMode, IntPtr.Zero, sizes[0], count) else
        z_DrawCommandsAddressNV_ovr_0_anh00110(primitiveMode, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsAddressNV_ovr_1_anh00100(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; var sizes: Int32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects[0], sizes, count) else
      z_DrawCommandsAddressNV_ovr_0_anh00100(primitiveMode, IntPtr.Zero, sizes, count);
    private static procedure z_DrawCommandsAddressNV_ovr_2(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    private static procedure z_DrawCommandsAddressNV_ovr_2_anh00100(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: array of UInt64; sizes: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsAddressNV_ovr_2(primitiveMode, indirects[0], sizes, count) else
      z_DrawCommandsAddressNV_ovr_2_anh00100(primitiveMode, IntPtr.Zero, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects, sizes[0], count) else
      z_DrawCommandsAddressNV_ovr_0_anh00010(primitiveMode, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_0(primitiveMode, indirects, sizes, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; var indirects: UInt64; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_2(primitiveMode, indirects, sizes, count);
    private static procedure z_DrawCommandsAddressNV_ovr_6(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    private static procedure z_DrawCommandsAddressNV_ovr_6_anh00010(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; sizes: array of Int32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsAddressNV_ovr_6(primitiveMode, indirects, sizes[0], count) else
      z_DrawCommandsAddressNV_ovr_6_anh00010(primitiveMode, indirects, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; var sizes: Int32; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_6(primitiveMode, indirects, sizes, count);
    private static procedure z_DrawCommandsAddressNV_ovr_8(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsAddressNV(primitiveMode: DummyEnum; indirects: IntPtr; sizes: IntPtr; count: UInt32) :=
    z_DrawCommandsAddressNV_ovr_8(primitiveMode, indirects, sizes, count);
    
    private static procedure z_DrawCommandsStatesNV_ovr_0(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0011100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0011010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0010110(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0001110(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_0_anh0011110(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0001110(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0010110(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesNV_ovr_0_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesNV_ovr_0_anh0011110(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0000100(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0001100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_1_anh0011100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_0_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_2(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0001100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_2_anh0011100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0001100(buffer, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0010100(buffer, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesNV_ovr_2_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesNV_ovr_2_anh0011100(buffer, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0001010(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_3_anh0011010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_4_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_4_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_4_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_5_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_5_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_5_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_6(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0001010(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_6_anh0011010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0001010(buffer, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0010010(buffer, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_6_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_6_anh0011010(buffer, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_7_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_7_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_7_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_6_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_8(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_8_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_8_anh0001000(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_8_anh0011000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_8(buffer, indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_8_anh0001000(buffer, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesNV_ovr_8_anh0010000(buffer, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesNV_ovr_8_anh0011000(buffer, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_9_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_9_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_9_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_9_anh0010110(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0010110(buffer, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_10_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_10_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_11_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_11_anh0010100(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_12_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_12_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_13_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_14_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_15_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_15_anh0010010(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_16_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_6_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_17_anh0010000(buffer: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_8(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_8_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_18(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0010100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0010010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0000110(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_18_anh0010110(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0000110(buffer, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0010010(buffer, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_18_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_18_anh0010110(buffer, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_19_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_19_anh0000100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_19_anh0010100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_18_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_20(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_20_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_20_anh0000100(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_20_anh0010100(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_20(buffer, indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_20_anh0000100(buffer, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_20_anh0010000(buffer, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_20_anh0010100(buffer, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_21_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_21_anh0010010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_22_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_18_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_23_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_20(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_20_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_24(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_24_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_24_anh0000010(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_24_anh0010010(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_24(buffer, indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_24_anh0000010(buffer, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_24_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_24_anh0010010(buffer, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_25_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_24(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_24_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_26(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_26_anh0010000(buffer: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesNV_ovr_26(buffer, indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_26_anh0010000(buffer, IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_0_anh0001110(buffer, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_2_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_6_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_6_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_8(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_8_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_0_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_0_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_2_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_0_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_0(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_2(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_6_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_6(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_8(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_18_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_18_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_20(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_20_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_18_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_18(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_20(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_24(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_24_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_24(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_26(buffer, indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_54(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0001100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0001010(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0000110(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_54_anh0001110(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0000110(buffer, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0001010(buffer, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesNV_ovr_54_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesNV_ovr_54_anh0001110(buffer, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_55_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_55_anh0000100(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_55_anh0001100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_54_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_56(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_56_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_56_anh0000100(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_56_anh0001100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_56_anh0000100(buffer, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesNV_ovr_56_anh0001000(buffer, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesNV_ovr_56_anh0001100(buffer, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_57_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_57_anh0001010(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_58_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_54_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_59_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_56_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_60(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_60_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_60_anh0000010(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_60_anh0001010(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_60_anh0000010(buffer, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_60_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_60_anh0001010(buffer, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_61_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_60_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_62(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_62_anh0001000(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesNV_ovr_62(buffer, indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesNV_ovr_62_anh0001000(buffer, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_54_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_54_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_56_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_54_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_54(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_56(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_60_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_60(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_62(buffer, indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_72(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_72_anh0000100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_72_anh0000010(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_72_anh0000110(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_72_anh0000010(buffer, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesNV_ovr_72_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesNV_ovr_72_anh0000110(buffer, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesNV_ovr_73_anh0000100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_72_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_74(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_74_anh0000100(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesNV_ovr_74(buffer, indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesNV_ovr_74_anh0000100(buffer, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_72_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_72(buffer, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_74(buffer, indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_78(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    private static procedure z_DrawCommandsStatesNV_ovr_78_anh0000010(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesNV_ovr_78(buffer, indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesNV_ovr_78_anh0000010(buffer, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_78(buffer, indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesNV_ovr_80(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesNV(buffer: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesNV_ovr_80(buffer, indirects, sizes, states, fbos, count);
    
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0(var indirects: UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh000100(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh001100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh011100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh000010(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh010010(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh001010(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh011010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh000110(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh010110(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh001110(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_0_anh011110(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh001110(indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh010110(IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh011010(IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_DrawCommandsStatesAddressNV_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_DrawCommandsStatesAddressNV_ovr_0_anh011110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh000100(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh001100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_1_anh011100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh000100(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh001100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_2_anh011100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh001100(indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh010100(IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_DrawCommandsStatesAddressNV_ovr_2_anh011100(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh010010(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh001010(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_3_anh011010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh011010(IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_4_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_4_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_4_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_5_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_5_anh001000(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_5_anh011000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh001000(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh011000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh000010(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh010010(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh001010(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_6_anh011010(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh001010(indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh010010(IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_6_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_6_anh011010(IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_7_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_7_anh001000(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_7_anh011000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_8(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_8_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_8_anh001000(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_8_anh011000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_8(indirects[0], sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_8_anh001000(indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_8_anh010000(IntPtr.Zero, sizes[0], states, fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_8_anh011000(IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_9_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_9_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_9_anh010010(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_9_anh010110(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh010110(IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_10_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_10_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_11_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_11_anh010100(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_12_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_12_anh010010(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_13_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_14_anh010000(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_15_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_15_anh010010(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_16_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_17_anh010000(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_8(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_8_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh000100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh010100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh000010(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh010010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh000110(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_18_anh010110(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh000110(indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh010010(IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_18_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_18_anh010110(IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_19_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_19_anh000100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_19_anh010100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_20(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_20_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_20_anh000100(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_20_anh010100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_20(indirects[0], sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_20_anh000100(indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_20_anh010000(IntPtr.Zero, sizes, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_20_anh010100(IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_21_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_21_anh010010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_22_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_23_anh010000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_20(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_20_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_24(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_24_anh010000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_24_anh000010(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_24_anh010010(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_24(indirects[0], sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_24_anh000010(indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_24_anh010000(IntPtr.Zero, sizes, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_24_anh010010(IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_25_anh010000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_24(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_24_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_26(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_26_anh010000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: array of UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_26(indirects[0], sizes, states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_26_anh010000(IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_0_anh001110(indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_2_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_6_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_8(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_8_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_0_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_2_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_0_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_0(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_2(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_6_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_6(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_8(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_18_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_20(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_20_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_18_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_18(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_20(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_24(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_24_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_24(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(var indirects: UInt64; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_26(indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh001100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh001010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh000110(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_54_anh001110(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh000110(indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh001010(indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_DrawCommandsStatesAddressNV_ovr_54_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_DrawCommandsStatesAddressNV_ovr_54_anh001110(indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_55_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_55_anh000100(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_55_anh001100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_56(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_56_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_56_anh000100(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_56_anh001100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes[0], states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_56_anh000100(indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_56_anh001000(indirects, IntPtr.Zero, states[0], fbos, count) else
        z_DrawCommandsStatesAddressNV_ovr_56_anh001100(indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_57_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_57_anh001010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_58_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_59_anh001000(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_56_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_60(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_60_anh001000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_60_anh000010(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_60_anh001010(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes[0], states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_60_anh000010(indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_60_anh001000(indirects, IntPtr.Zero, states, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_60_anh001010(indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_61_anh001000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_60_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_62(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_62_anh001000(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_62(indirects, sizes[0], states, fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_62_anh001000(indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_54_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_56_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_54_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_54(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_56(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_60_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_60(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_62(indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_72(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_72_anh000100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_72_anh000010(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_72_anh000110(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states[0], fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_72_anh000010(indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_DrawCommandsStatesAddressNV_ovr_72_anh000100(indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_DrawCommandsStatesAddressNV_ovr_72_anh000110(indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_73_anh000100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_72_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_74(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_74_anh000100(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_74(indirects, sizes, states[0], fbos, count) else
      z_DrawCommandsStatesAddressNV_ovr_74_anh000100(indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_72_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_72(indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_74(indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_78(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    private static procedure z_DrawCommandsStatesAddressNV_ovr_78_anh000010(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_DrawCommandsStatesAddressNV_ovr_78(indirects, sizes, states, fbos[0], count) else
      z_DrawCommandsStatesAddressNV_ovr_78_anh000010(indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_78(indirects, sizes, states, fbos, count);
    private static procedure z_DrawCommandsStatesAddressNV_ovr_80(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glDrawCommandsStatesAddressNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawCommandsStatesAddressNV(indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_DrawCommandsStatesAddressNV_ovr_80(indirects, sizes, states, fbos, count);
    
    private static procedure z_CreateCommandListsNV_ovr_0(n: Int32; var lists: UInt32);
    external 'opengl32.dll' name 'glCreateCommandListsNV';
    private static procedure z_CreateCommandListsNV_ovr_0_anh001(n: Int32; lists: IntPtr);
    external 'opengl32.dll' name 'glCreateCommandListsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; lists: array of UInt32) :=
    if (lists<>nil) and (lists.Length<>0) then
      z_CreateCommandListsNV_ovr_0(n, lists[0]) else
      z_CreateCommandListsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; var lists: UInt32) :=
    z_CreateCommandListsNV_ovr_0(n, lists);
    private static procedure z_CreateCommandListsNV_ovr_2(n: Int32; lists: IntPtr);
    external 'opengl32.dll' name 'glCreateCommandListsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CreateCommandListsNV(n: Int32; lists: IntPtr) :=
    z_CreateCommandListsNV_ovr_2(n, lists);
    
    private static procedure z_DeleteCommandListsNV_ovr_0(n: Int32; var lists: UInt32);
    external 'opengl32.dll' name 'glDeleteCommandListsNV';
    private static procedure z_DeleteCommandListsNV_ovr_0_anh001(n: Int32; lists: IntPtr);
    external 'opengl32.dll' name 'glDeleteCommandListsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; lists: array of UInt32) :=
    if (lists<>nil) and (lists.Length<>0) then
      z_DeleteCommandListsNV_ovr_0(n, lists[0]) else
      z_DeleteCommandListsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; var lists: UInt32) :=
    z_DeleteCommandListsNV_ovr_0(n, lists);
    private static procedure z_DeleteCommandListsNV_ovr_2(n: Int32; lists: IntPtr);
    external 'opengl32.dll' name 'glDeleteCommandListsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteCommandListsNV(n: Int32; lists: IntPtr) :=
    z_DeleteCommandListsNV_ovr_2(n, lists);
    
    private static function z_IsCommandListNV_ovr_0(list: UInt32): boolean;
    external 'opengl32.dll' name 'glIsCommandListNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsCommandListNV(list: UInt32): boolean :=
    z_IsCommandListNV_ovr_0(list);
    
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_0_anh00011110(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects[0], sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects[0], IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes[0], states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
        if (states<>nil) and (states.Length<>0) then
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], IntPtr.Zero, count) else
          if (fbos<>nil) and (fbos.Length<>0) then
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
            z_ListDrawCommandsStatesClientNV_ovr_0_anh00011110(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00001100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_1_anh00011100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_2_anh00011100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects[0], sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects[0], IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100(list, segment, indirects[0], IntPtr.Zero, IntPtr.Zero, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes[0], states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100(list, segment, IntPtr.Zero, sizes[0], IntPtr.Zero, fbos, count) else
        if (states<>nil) and (states.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states[0], fbos, count) else
          z_ListDrawCommandsStatesClientNV_ovr_2_anh00011100(list, segment, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00001010(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_3_anh00011010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_4_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_4_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_4_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_5_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_5_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_5_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_6_anh00011010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects[0], sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010(list, segment, indirects[0], IntPtr.Zero, states, IntPtr.Zero, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010(list, segment, IntPtr.Zero, sizes[0], states, IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_6_anh00011010(list, segment, IntPtr.Zero, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_7_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_7_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_7_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_8(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_8_anh00011000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects[0], sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000(list, segment, indirects[0], IntPtr.Zero, states, fbos, count) else
      if (sizes<>nil) and (sizes.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000(list, segment, IntPtr.Zero, sizes[0], states, fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_8_anh00011000(list, segment, IntPtr.Zero, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_9_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_9_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_9_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_9_anh00010110(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00010110(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_10_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_10_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_11_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_11_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_12_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_12_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_13_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_14_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_15_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_15_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_16_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_17_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_8_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_18_anh00010110(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects[0], sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110(list, segment, indirects[0], sizes, IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010(list, segment, IntPtr.Zero, sizes, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_18_anh00010110(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_19_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_19_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_19_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_20(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_20_anh00010100(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects[0], sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100(list, segment, indirects[0], sizes, IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000(list, segment, IntPtr.Zero, sizes, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_20_anh00010100(list, segment, IntPtr.Zero, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_21_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_21_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_22_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_23_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_20_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_24(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_24_anh00010010(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects[0], sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010(list, segment, indirects[0], sizes, states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_24_anh00010010(list, segment, IntPtr.Zero, sizes, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_25_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_24_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_26(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_26_anh00010000(list: UInt32; segment: UInt32; indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: array of IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (indirects<>nil) and (indirects.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_26(list, segment, indirects[0], sizes, states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_26_anh00010000(list, segment, IntPtr.Zero, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_0_anh00001110(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_2_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_6_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_8_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_0_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_2_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_0_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_0(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_2(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_6_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_6(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_8(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_18_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_20_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_18_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_18(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_20(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_24_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_24(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; var indirects: IntPtr; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_26(list, segment, indirects, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_54_anh00001110(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes[0], states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110(list, segment, indirects, sizes[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (states<>nil) and (states.Length<>0) then
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010(list, segment, indirects, IntPtr.Zero, states[0], IntPtr.Zero, count) else
        if (fbos<>nil) and (fbos.Length<>0) then
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos[0], count) else
          z_ListDrawCommandsStatesClientNV_ovr_54_anh00001110(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_55_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_55_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_55_anh00001100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_56(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_56_anh00001100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes[0], states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100(list, segment, indirects, sizes[0], IntPtr.Zero, fbos, count) else
      if (states<>nil) and (states.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000(list, segment, indirects, IntPtr.Zero, states[0], fbos, count) else
        z_ListDrawCommandsStatesClientNV_ovr_56_anh00001100(list, segment, indirects, IntPtr.Zero, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_57_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_57_anh00001010(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_58_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_59_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_56_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_60(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_60_anh00001010(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes[0], states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010(list, segment, indirects, sizes[0], states, IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_60_anh00001010(list, segment, indirects, IntPtr.Zero, states, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_61_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_60_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_62(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_62_anh00001000(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: array of Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    if (sizes<>nil) and (sizes.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_62(list, segment, indirects, sizes[0], states, fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_62_anh00001000(list, segment, indirects, IntPtr.Zero, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_54_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_56_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_54_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_54(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_56(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_60_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_60(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; var sizes: Int32; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_62(list, segment, indirects, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_72(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_72_anh00000110(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: array of UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states[0], fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010(list, segment, indirects, sizes, states[0], IntPtr.Zero, count) else
      if (fbos<>nil) and (fbos.Length<>0) then
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos[0], count) else
        z_ListDrawCommandsStatesClientNV_ovr_72_anh00000110(list, segment, indirects, sizes, IntPtr.Zero, IntPtr.Zero, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_73_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; var fbos: UInt32; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_72_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_74(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_74_anh00000100(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: array of UInt32; fbos: IntPtr; count: UInt32) :=
    if (states<>nil) and (states.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_74(list, segment, indirects, sizes, states[0], fbos, count) else
      z_ListDrawCommandsStatesClientNV_ovr_74_anh00000100(list, segment, indirects, sizes, IntPtr.Zero, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_72_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_72(list, segment, indirects, sizes, states, fbos, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; var states: UInt32; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_74(list, segment, indirects, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_78(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_78_anh00000010(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: array of UInt32; count: UInt32) :=
    if (fbos<>nil) and (fbos.Length<>0) then
      z_ListDrawCommandsStatesClientNV_ovr_78(list, segment, indirects, sizes, states, fbos[0], count) else
      z_ListDrawCommandsStatesClientNV_ovr_78_anh00000010(list, segment, indirects, sizes, states, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; var fbos: UInt32; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_78(list, segment, indirects, sizes, states, fbos, count);
    private static procedure z_ListDrawCommandsStatesClientNV_ovr_80(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32);
    external 'opengl32.dll' name 'glListDrawCommandsStatesClientNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListDrawCommandsStatesClientNV(list: UInt32; segment: UInt32; indirects: pointer; sizes: IntPtr; states: IntPtr; fbos: IntPtr; count: UInt32) :=
    z_ListDrawCommandsStatesClientNV_ovr_80(list, segment, indirects, sizes, states, fbos, count);
    
    private static procedure z_CommandListSegmentsNV_ovr_0(list: UInt32; segments: UInt32);
    external 'opengl32.dll' name 'glCommandListSegmentsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CommandListSegmentsNV(list: UInt32; segments: UInt32) :=
    z_CommandListSegmentsNV_ovr_0(list, segments);
    
    private static procedure z_CompileCommandListNV_ovr_0(list: UInt32);
    external 'opengl32.dll' name 'glCompileCommandListNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CompileCommandListNV(list: UInt32) :=
    z_CompileCommandListNV_ovr_0(list);
    
    private static procedure z_CallCommandListNV_ovr_0(list: UInt32);
    external 'opengl32.dll' name 'glCallCommandListNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CallCommandListNV(list: UInt32) :=
    z_CallCommandListNV_ovr_0(list);
    
  end;
  
  glConditionalRenderNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginConditionalRenderNV_ovr_0(id: UInt32; mode: ConditionalRenderMode);
    external 'opengl32.dll' name 'glBeginConditionalRenderNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginConditionalRenderNV(id: UInt32; mode: ConditionalRenderMode) :=
    z_BeginConditionalRenderNV_ovr_0(id, mode);
    
    private static procedure z_EndConditionalRenderNV_ovr_0;
    external 'opengl32.dll' name 'glEndConditionalRenderNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndConditionalRenderNV :=
    z_EndConditionalRenderNV_ovr_0;
    
  end;
  
  glConservativeRasterNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SubpixelPrecisionBiasNV_ovr_0(xbits: UInt32; ybits: UInt32);
    external 'opengl32.dll' name 'glSubpixelPrecisionBiasNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SubpixelPrecisionBiasNV(xbits: UInt32; ybits: UInt32) :=
    z_SubpixelPrecisionBiasNV_ovr_0(xbits, ybits);
    
  end;
  
  glConservativeRasterDilateNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ConservativeRasterParameterfNV_ovr_0(pname: DummyEnum; value: single);
    external 'opengl32.dll' name 'glConservativeRasterParameterfNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConservativeRasterParameterfNV(pname: DummyEnum; value: single) :=
    z_ConservativeRasterParameterfNV_ovr_0(pname, value);
    
  end;
  
  glConservativeRasterPreSnapTrianglesNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ConservativeRasterParameteriNV_ovr_0(pname: DummyEnum; param: Int32);
    external 'opengl32.dll' name 'glConservativeRasterParameteriNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConservativeRasterParameteriNV(pname: DummyEnum; param: Int32) :=
    z_ConservativeRasterParameteriNV_ovr_0(pname, param);
    
  end;
  
  glCopyImageNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CopyImageSubDataNV_ovr_0(srcName: UInt32; srcTarget: CopyBufferSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyBufferSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32);
    external 'opengl32.dll' name 'glCopyImageSubDataNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyImageSubDataNV(srcName: UInt32; srcTarget: CopyBufferSubDataTarget; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: CopyBufferSubDataTarget; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32) :=
    z_CopyImageSubDataNV_ovr_0(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
  end;
  
  glDepthBufferFloatNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DepthRangedNV_ovr_0(zNear: real; zFar: real);
    external 'opengl32.dll' name 'glDepthRangedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangedNV(zNear: real; zFar: real) :=
    z_DepthRangedNV_ovr_0(zNear, zFar);
    
    private static procedure z_ClearDepthdNV_ovr_0(depth: real);
    external 'opengl32.dll' name 'glClearDepthdNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthdNV(depth: real) :=
    z_ClearDepthdNV_ovr_0(depth);
    
    private static procedure z_DepthBoundsdNV_ovr_0(zmin: real; zmax: real);
    external 'opengl32.dll' name 'glDepthBoundsdNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthBoundsdNV(zmin: real; zmax: real) :=
    z_DepthBoundsdNV_ovr_0(zmin, zmax);
    
  end;
  
  glDrawTextureNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawTextureNV_ovr_0(texture: UInt32; sampler: UInt32; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single);
    external 'opengl32.dll' name 'glDrawTextureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTextureNV(texture: UInt32; sampler: UInt32; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single) :=
    z_DrawTextureNV_ovr_0(texture, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
    
  end;
  
  glDrawVulkanImageNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawVkImageNV_ovr_0(vkImage: UInt64; sampler: UInt32; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single);
    external 'opengl32.dll' name 'glDrawVkImageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawVkImageNV(vkImage: UInt64; sampler: UInt32; x0: single; y0: single; x1: single; y1: single; z: single; s0: single; t0: single; s1: single; t1: single) :=
    z_DrawVkImageNV_ovr_0(vkImage, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
    
    private static function z_GetVkProcAddrNV_ovr_0(name: IntPtr): GLVULKANPROCNV;
    external 'opengl32.dll' name 'glGetVkProcAddrNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVkProcAddrNV(name: string): GLVULKANPROCNV;
    begin
      var par_1_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetVkProcAddrNV_ovr_0(par_1_str_ptr);
      Marshal.FreeHGlobal(par_1_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVkProcAddrNV(name: IntPtr): GLVULKANPROCNV :=
    z_GetVkProcAddrNV_ovr_0(name);
    
    private static procedure z_WaitVkSemaphoreNV_ovr_0(vkSemaphore: UInt64);
    external 'opengl32.dll' name 'glWaitVkSemaphoreNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitVkSemaphoreNV(vkSemaphore: UInt64) :=
    z_WaitVkSemaphoreNV_ovr_0(vkSemaphore);
    
    private static procedure z_SignalVkSemaphoreNV_ovr_0(vkSemaphore: UInt64);
    external 'opengl32.dll' name 'glSignalVkSemaphoreNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalVkSemaphoreNV(vkSemaphore: UInt64) :=
    z_SignalVkSemaphoreNV_ovr_0(vkSemaphore);
    
    private static procedure z_SignalVkFenceNV_ovr_0(vkFence: UInt64);
    external 'opengl32.dll' name 'glSignalVkFenceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalVkFenceNV(vkFence: UInt64) :=
    z_SignalVkFenceNV_ovr_0(vkFence);
    
  end;
  
  glEvaluatorsNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MapControlPointsNV_ovr_0(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; uorder: Int32; vorder: Int32; &packed: boolean; points: IntPtr);
    external 'opengl32.dll' name 'glMapControlPointsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapControlPointsNV(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; uorder: Int32; vorder: Int32; &packed: boolean; points: IntPtr) :=
    z_MapControlPointsNV_ovr_0(target, index, &type, ustride, vstride, uorder, vorder, &packed, points);
    
    private static procedure z_MapParameterivNV_ovr_0(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glMapParameterivNV';
    private static procedure z_MapParameterivNV_ovr_0_anh0001(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glMapParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MapParameterivNV_ovr_0(target, pname, &params[0]) else
      z_MapParameterivNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32) :=
    z_MapParameterivNV_ovr_0(target, pname, &params);
    private static procedure z_MapParameterivNV_ovr_2(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glMapParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_MapParameterivNV_ovr_2(target, pname, &params);
    
    private static procedure z_MapParameterfvNV_ovr_0(target: EvalTargetNV; pname: MapParameterNV; var &params: single);
    external 'opengl32.dll' name 'glMapParameterfvNV';
    private static procedure z_MapParameterfvNV_ovr_0_anh0001(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glMapParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MapParameterfvNV_ovr_0(target, pname, &params[0]) else
      z_MapParameterfvNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; var &params: single) :=
    z_MapParameterfvNV_ovr_0(target, pname, &params);
    private static procedure z_MapParameterfvNV_ovr_2(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glMapParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_MapParameterfvNV_ovr_2(target, pname, &params);
    
    private static procedure z_GetMapControlPointsNV_ovr_0(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; &packed: boolean; points: IntPtr);
    external 'opengl32.dll' name 'glGetMapControlPointsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapControlPointsNV(target: EvalTargetNV; index: UInt32; &type: MapTypeNV; ustride: Int32; vstride: Int32; &packed: boolean; points: IntPtr) :=
    z_GetMapControlPointsNV_ovr_0(target, index, &type, ustride, vstride, &packed, points);
    
    private static procedure z_GetMapParameterivNV_ovr_0(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetMapParameterivNV';
    private static procedure z_GetMapParameterivNV_ovr_0_anh0001(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapParameterivNV_ovr_0(target, pname, &params[0]) else
      z_GetMapParameterivNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; var &params: Int32) :=
    z_GetMapParameterivNV_ovr_0(target, pname, &params);
    private static procedure z_GetMapParameterivNV_ovr_2(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterivNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_GetMapParameterivNV_ovr_2(target, pname, &params);
    
    private static procedure z_GetMapParameterfvNV_ovr_0(target: EvalTargetNV; pname: MapParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetMapParameterfvNV';
    private static procedure z_GetMapParameterfvNV_ovr_0_anh0001(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapParameterfvNV_ovr_0(target, pname, &params[0]) else
      z_GetMapParameterfvNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; var &params: single) :=
    z_GetMapParameterfvNV_ovr_0(target, pname, &params);
    private static procedure z_GetMapParameterfvNV_ovr_2(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapParameterfvNV(target: EvalTargetNV; pname: MapParameterNV; &params: IntPtr) :=
    z_GetMapParameterfvNV_ovr_2(target, pname, &params);
    
    private static procedure z_GetMapAttribParameterivNV_ovr_0(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetMapAttribParameterivNV';
    private static procedure z_GetMapAttribParameterivNV_ovr_0_anh00001(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapAttribParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapAttribParameterivNV_ovr_0(target, index, pname, &params[0]) else
      z_GetMapAttribParameterivNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: Int32) :=
    z_GetMapAttribParameterivNV_ovr_0(target, index, pname, &params);
    private static procedure z_GetMapAttribParameterivNV_ovr_2(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapAttribParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterivNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr) :=
    z_GetMapAttribParameterivNV_ovr_2(target, index, pname, &params);
    
    private static procedure z_GetMapAttribParameterfvNV_ovr_0(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetMapAttribParameterfvNV';
    private static procedure z_GetMapAttribParameterfvNV_ovr_0_anh00001(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapAttribParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMapAttribParameterfvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetMapAttribParameterfvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; var &params: single) :=
    z_GetMapAttribParameterfvNV_ovr_0(target, index, pname, &params);
    private static procedure z_GetMapAttribParameterfvNV_ovr_2(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMapAttribParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapAttribParameterfvNV(target: EvalTargetNV; index: UInt32; pname: MapAttribParameterNV; &params: IntPtr) :=
    z_GetMapAttribParameterfvNV_ovr_2(target, index, pname, &params);
    
    private static procedure z_EvalMapsNV_ovr_0(target: EvalTargetNV; mode: EvalMapsModeNV);
    external 'opengl32.dll' name 'glEvalMapsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalMapsNV(target: EvalTargetNV; mode: EvalMapsModeNV) :=
    z_EvalMapsNV_ovr_0(target, mode);
    
  end;
  
  glExplicitMultisampleNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetMultisamplefvNV_ovr_0(pname: GetMultisamplePNameNV; index: UInt32; var val: single);
    external 'opengl32.dll' name 'glGetMultisamplefvNV';
    private static procedure z_GetMultisamplefvNV_ovr_0_anh0001(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glGetMultisamplefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; val: array of single) :=
    if (val<>nil) and (val.Length<>0) then
      z_GetMultisamplefvNV_ovr_0(pname, index, val[0]) else
      z_GetMultisamplefvNV_ovr_0_anh0001(pname, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; var val: single) :=
    z_GetMultisamplefvNV_ovr_0(pname, index, val);
    private static procedure z_GetMultisamplefvNV_ovr_2(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr);
    external 'opengl32.dll' name 'glGetMultisamplefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMultisamplefvNV(pname: GetMultisamplePNameNV; index: UInt32; val: IntPtr) :=
    z_GetMultisamplefvNV_ovr_2(pname, index, val);
    
    private static procedure z_SampleMaskIndexedNV_ovr_0(index: UInt32; mask: DummyFlags);
    external 'opengl32.dll' name 'glSampleMaskIndexedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskIndexedNV(index: UInt32; mask: DummyFlags) :=
    z_SampleMaskIndexedNV_ovr_0(index, mask);
    
    private static procedure z_TexRenderbufferNV_ovr_0(target: TextureTarget; renderbuffer: UInt32);
    external 'opengl32.dll' name 'glTexRenderbufferNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexRenderbufferNV(target: TextureTarget; renderbuffer: UInt32) :=
    z_TexRenderbufferNV_ovr_0(target, renderbuffer);
    
  end;
  
  glFenceNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DeleteFencesNV_ovr_0(n: Int32; var fences: UInt32);
    external 'opengl32.dll' name 'glDeleteFencesNV';
    private static procedure z_DeleteFencesNV_ovr_0_anh001(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glDeleteFencesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_DeleteFencesNV_ovr_0(n, fences[0]) else
      z_DeleteFencesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; var fences: UInt32) :=
    z_DeleteFencesNV_ovr_0(n, fences);
    private static procedure z_DeleteFencesNV_ovr_2(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glDeleteFencesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteFencesNV(n: Int32; fences: IntPtr) :=
    z_DeleteFencesNV_ovr_2(n, fences);
    
    private static procedure z_GenFencesNV_ovr_0(n: Int32; var fences: UInt32);
    external 'opengl32.dll' name 'glGenFencesNV';
    private static procedure z_GenFencesNV_ovr_0_anh001(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glGenFencesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; fences: array of UInt32) :=
    if (fences<>nil) and (fences.Length<>0) then
      z_GenFencesNV_ovr_0(n, fences[0]) else
      z_GenFencesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; var fences: UInt32) :=
    z_GenFencesNV_ovr_0(n, fences);
    private static procedure z_GenFencesNV_ovr_2(n: Int32; fences: IntPtr);
    external 'opengl32.dll' name 'glGenFencesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenFencesNV(n: Int32; fences: IntPtr) :=
    z_GenFencesNV_ovr_2(n, fences);
    
    private static function z_IsFenceNV_ovr_0(fence: UInt32): boolean;
    external 'opengl32.dll' name 'glIsFenceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsFenceNV(fence: UInt32): boolean :=
    z_IsFenceNV_ovr_0(fence);
    
    private static function z_TestFenceNV_ovr_0(fence: UInt32): boolean;
    external 'opengl32.dll' name 'glTestFenceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function TestFenceNV(fence: UInt32): boolean :=
    z_TestFenceNV_ovr_0(fence);
    
    private static procedure z_GetFenceivNV_ovr_0(fence: UInt32; pname: FenceParameterNameNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetFenceivNV';
    private static procedure z_GetFenceivNV_ovr_0_anh0001(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFenceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFenceivNV_ovr_0(fence, pname, &params[0]) else
      z_GetFenceivNV_ovr_0_anh0001(fence, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; var &params: Int32) :=
    z_GetFenceivNV_ovr_0(fence, pname, &params);
    private static procedure z_GetFenceivNV_ovr_2(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFenceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFenceivNV(fence: UInt32; pname: FenceParameterNameNV; &params: IntPtr) :=
    z_GetFenceivNV_ovr_2(fence, pname, &params);
    
    private static procedure z_FinishFenceNV_ovr_0(fence: UInt32);
    external 'opengl32.dll' name 'glFinishFenceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishFenceNV(fence: UInt32) :=
    z_FinishFenceNV_ovr_0(fence);
    
    private static procedure z_SetFenceNV_ovr_0(fence: UInt32; condition: FenceConditionNV);
    external 'opengl32.dll' name 'glSetFenceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SetFenceNV(fence: UInt32; condition: FenceConditionNV) :=
    z_SetFenceNV_ovr_0(fence, condition);
    
  end;
  
  glFragmentCoverageToColorNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FragmentCoverageColorNV_ovr_0(color: UInt32);
    external 'opengl32.dll' name 'glFragmentCoverageColorNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentCoverageColorNV(color: UInt32) :=
    z_FragmentCoverageColorNV_ovr_0(color);
    
  end;
  
  glFragmentProgramNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramNamedParameter4fNV_ovr_0(id: UInt32; len: Int32; var name: Byte; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fNV';
    private static procedure z_ProgramNamedParameter4fNV_ovr_0_anh00010000(id: UInt32; len: Int32; name: IntPtr; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fNV(id: UInt32; len: Int32; name: array of Byte; x: single; y: single; z: single; w: single) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4fNV_ovr_0(id, len, name[0], x, y, z, w) else
      z_ProgramNamedParameter4fNV_ovr_0_anh00010000(id, len, IntPtr.Zero, x, y, z, w);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fNV(id: UInt32; len: Int32; var name: Byte; x: single; y: single; z: single; w: single) :=
    z_ProgramNamedParameter4fNV_ovr_0(id, len, name, x, y, z, w);
    private static procedure z_ProgramNamedParameter4fNV_ovr_2(id: UInt32; len: Int32; name: IntPtr; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fNV(id: UInt32; len: Int32; name: IntPtr; x: single; y: single; z: single; w: single) :=
    z_ProgramNamedParameter4fNV_ovr_2(id, len, name, x, y, z, w);
    
    private static procedure z_ProgramNamedParameter4fvNV_ovr_0(id: UInt32; len: Int32; var name: Byte; var v: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    private static procedure z_ProgramNamedParameter4fvNV_ovr_0_anh00010(id: UInt32; len: Int32; name: IntPtr; var v: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    private static procedure z_ProgramNamedParameter4fvNV_ovr_0_anh00001(id: UInt32; len: Int32; var name: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    private static procedure z_ProgramNamedParameter4fvNV_ovr_0_anh00011(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: array of Byte; v: array of single) :=
    if (name<>nil) and (name.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ProgramNamedParameter4fvNV_ovr_0(id, len, name[0], v[0]) else
        z_ProgramNamedParameter4fvNV_ovr_0_anh00001(id, len, name[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ProgramNamedParameter4fvNV_ovr_0_anh00010(id, len, IntPtr.Zero, v[0]) else
        z_ProgramNamedParameter4fvNV_ovr_0_anh00011(id, len, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_ProgramNamedParameter4fvNV_ovr_1_anh00010(id: UInt32; len: Int32; name: IntPtr; var v: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: array of Byte; var v: single) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_0(id, len, name[0], v) else
      z_ProgramNamedParameter4fvNV_ovr_0_anh00010(id, len, IntPtr.Zero, v);
    private static procedure z_ProgramNamedParameter4fvNV_ovr_2(id: UInt32; len: Int32; var name: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    private static procedure z_ProgramNamedParameter4fvNV_ovr_2_anh00010(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: array of Byte; v: IntPtr) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_2(id, len, name[0], v) else
      z_ProgramNamedParameter4fvNV_ovr_2_anh00010(id, len, IntPtr.Zero, v);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; var name: Byte; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_0(id, len, name, v[0]) else
      z_ProgramNamedParameter4fvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; var name: Byte; var v: single) :=
    z_ProgramNamedParameter4fvNV_ovr_0(id, len, name, v);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; var name: Byte; v: IntPtr) :=
    z_ProgramNamedParameter4fvNV_ovr_2(id, len, name, v);
    private static procedure z_ProgramNamedParameter4fvNV_ovr_6(id: UInt32; len: Int32; name: IntPtr; var v: single);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    private static procedure z_ProgramNamedParameter4fvNV_ovr_6_anh00001(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: IntPtr; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4fvNV_ovr_6(id, len, name, v[0]) else
      z_ProgramNamedParameter4fvNV_ovr_6_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: IntPtr; var v: single) :=
    z_ProgramNamedParameter4fvNV_ovr_6(id, len, name, v);
    private static procedure z_ProgramNamedParameter4fvNV_ovr_8(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4fvNV(id: UInt32; len: Int32; name: IntPtr; v: IntPtr) :=
    z_ProgramNamedParameter4fvNV_ovr_8(id, len, name, v);
    
    private static procedure z_ProgramNamedParameter4dNV_ovr_0(id: UInt32; len: Int32; var name: Byte; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dNV';
    private static procedure z_ProgramNamedParameter4dNV_ovr_0_anh00010000(id: UInt32; len: Int32; name: IntPtr; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dNV(id: UInt32; len: Int32; name: array of Byte; x: real; y: real; z: real; w: real) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4dNV_ovr_0(id, len, name[0], x, y, z, w) else
      z_ProgramNamedParameter4dNV_ovr_0_anh00010000(id, len, IntPtr.Zero, x, y, z, w);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dNV(id: UInt32; len: Int32; var name: Byte; x: real; y: real; z: real; w: real) :=
    z_ProgramNamedParameter4dNV_ovr_0(id, len, name, x, y, z, w);
    private static procedure z_ProgramNamedParameter4dNV_ovr_2(id: UInt32; len: Int32; name: IntPtr; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dNV(id: UInt32; len: Int32; name: IntPtr; x: real; y: real; z: real; w: real) :=
    z_ProgramNamedParameter4dNV_ovr_2(id, len, name, x, y, z, w);
    
    private static procedure z_ProgramNamedParameter4dvNV_ovr_0(id: UInt32; len: Int32; var name: Byte; var v: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    private static procedure z_ProgramNamedParameter4dvNV_ovr_0_anh00010(id: UInt32; len: Int32; name: IntPtr; var v: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    private static procedure z_ProgramNamedParameter4dvNV_ovr_0_anh00001(id: UInt32; len: Int32; var name: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    private static procedure z_ProgramNamedParameter4dvNV_ovr_0_anh00011(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: array of Byte; v: array of real) :=
    if (name<>nil) and (name.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ProgramNamedParameter4dvNV_ovr_0(id, len, name[0], v[0]) else
        z_ProgramNamedParameter4dvNV_ovr_0_anh00001(id, len, name[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ProgramNamedParameter4dvNV_ovr_0_anh00010(id, len, IntPtr.Zero, v[0]) else
        z_ProgramNamedParameter4dvNV_ovr_0_anh00011(id, len, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_ProgramNamedParameter4dvNV_ovr_1_anh00010(id: UInt32; len: Int32; name: IntPtr; var v: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: array of Byte; var v: real) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_0(id, len, name[0], v) else
      z_ProgramNamedParameter4dvNV_ovr_0_anh00010(id, len, IntPtr.Zero, v);
    private static procedure z_ProgramNamedParameter4dvNV_ovr_2(id: UInt32; len: Int32; var name: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    private static procedure z_ProgramNamedParameter4dvNV_ovr_2_anh00010(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: array of Byte; v: IntPtr) :=
    if (name<>nil) and (name.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_2(id, len, name[0], v) else
      z_ProgramNamedParameter4dvNV_ovr_2_anh00010(id, len, IntPtr.Zero, v);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; var name: Byte; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_0(id, len, name, v[0]) else
      z_ProgramNamedParameter4dvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; var name: Byte; var v: real) :=
    z_ProgramNamedParameter4dvNV_ovr_0(id, len, name, v);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; var name: Byte; v: IntPtr) :=
    z_ProgramNamedParameter4dvNV_ovr_2(id, len, name, v);
    private static procedure z_ProgramNamedParameter4dvNV_ovr_6(id: UInt32; len: Int32; name: IntPtr; var v: real);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    private static procedure z_ProgramNamedParameter4dvNV_ovr_6_anh00001(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: IntPtr; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramNamedParameter4dvNV_ovr_6(id, len, name, v[0]) else
      z_ProgramNamedParameter4dvNV_ovr_6_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: IntPtr; var v: real) :=
    z_ProgramNamedParameter4dvNV_ovr_6(id, len, name, v);
    private static procedure z_ProgramNamedParameter4dvNV_ovr_8(id: UInt32; len: Int32; name: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glProgramNamedParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramNamedParameter4dvNV(id: UInt32; len: Int32; name: IntPtr; v: IntPtr) :=
    z_ProgramNamedParameter4dvNV_ovr_8(id, len, name, v);
    
    private static procedure z_GetProgramNamedParameterfvNV_ovr_0(id: UInt32; len: Int32; var name: Byte; var &params: single);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    private static procedure z_GetProgramNamedParameterfvNV_ovr_0_anh00010(id: UInt32; len: Int32; name: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    private static procedure z_GetProgramNamedParameterfvNV_ovr_0_anh00001(id: UInt32; len: Int32; var name: Byte; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    private static procedure z_GetProgramNamedParameterfvNV_ovr_0_anh00011(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: array of Byte; &params: array of single) :=
    if (name<>nil) and (name.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramNamedParameterfvNV_ovr_0(id, len, name[0], &params[0]) else
        z_GetProgramNamedParameterfvNV_ovr_0_anh00001(id, len, name[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramNamedParameterfvNV_ovr_0_anh00010(id, len, IntPtr.Zero, &params[0]) else
        z_GetProgramNamedParameterfvNV_ovr_0_anh00011(id, len, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramNamedParameterfvNV_ovr_1_anh00010(id: UInt32; len: Int32; name: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: array of Byte; var &params: single) :=
    if (name<>nil) and (name.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_0(id, len, name[0], &params) else
      z_GetProgramNamedParameterfvNV_ovr_0_anh00010(id, len, IntPtr.Zero, &params);
    private static procedure z_GetProgramNamedParameterfvNV_ovr_2(id: UInt32; len: Int32; var name: Byte; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    private static procedure z_GetProgramNamedParameterfvNV_ovr_2_anh00010(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: array of Byte; &params: IntPtr) :=
    if (name<>nil) and (name.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_2(id, len, name[0], &params) else
      z_GetProgramNamedParameterfvNV_ovr_2_anh00010(id, len, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; var name: Byte; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_0(id, len, name, &params[0]) else
      z_GetProgramNamedParameterfvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; var name: Byte; var &params: single) :=
    z_GetProgramNamedParameterfvNV_ovr_0(id, len, name, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; var name: Byte; &params: IntPtr) :=
    z_GetProgramNamedParameterfvNV_ovr_2(id, len, name, &params);
    private static procedure z_GetProgramNamedParameterfvNV_ovr_6(id: UInt32; len: Int32; name: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    private static procedure z_GetProgramNamedParameterfvNV_ovr_6_anh00001(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterfvNV_ovr_6(id, len, name, &params[0]) else
      z_GetProgramNamedParameterfvNV_ovr_6_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: IntPtr; var &params: single) :=
    z_GetProgramNamedParameterfvNV_ovr_6(id, len, name, &params);
    private static procedure z_GetProgramNamedParameterfvNV_ovr_8(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterfvNV(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr) :=
    z_GetProgramNamedParameterfvNV_ovr_8(id, len, name, &params);
    
    private static procedure z_GetProgramNamedParameterdvNV_ovr_0(id: UInt32; len: Int32; var name: Byte; var &params: real);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    private static procedure z_GetProgramNamedParameterdvNV_ovr_0_anh00010(id: UInt32; len: Int32; name: IntPtr; var &params: real);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    private static procedure z_GetProgramNamedParameterdvNV_ovr_0_anh00001(id: UInt32; len: Int32; var name: Byte; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    private static procedure z_GetProgramNamedParameterdvNV_ovr_0_anh00011(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: array of Byte; &params: array of real) :=
    if (name<>nil) and (name.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramNamedParameterdvNV_ovr_0(id, len, name[0], &params[0]) else
        z_GetProgramNamedParameterdvNV_ovr_0_anh00001(id, len, name[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramNamedParameterdvNV_ovr_0_anh00010(id, len, IntPtr.Zero, &params[0]) else
        z_GetProgramNamedParameterdvNV_ovr_0_anh00011(id, len, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramNamedParameterdvNV_ovr_1_anh00010(id: UInt32; len: Int32; name: IntPtr; var &params: real);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: array of Byte; var &params: real) :=
    if (name<>nil) and (name.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_0(id, len, name[0], &params) else
      z_GetProgramNamedParameterdvNV_ovr_0_anh00010(id, len, IntPtr.Zero, &params);
    private static procedure z_GetProgramNamedParameterdvNV_ovr_2(id: UInt32; len: Int32; var name: Byte; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    private static procedure z_GetProgramNamedParameterdvNV_ovr_2_anh00010(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: array of Byte; &params: IntPtr) :=
    if (name<>nil) and (name.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_2(id, len, name[0], &params) else
      z_GetProgramNamedParameterdvNV_ovr_2_anh00010(id, len, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; var name: Byte; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_0(id, len, name, &params[0]) else
      z_GetProgramNamedParameterdvNV_ovr_0_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; var name: Byte; var &params: real) :=
    z_GetProgramNamedParameterdvNV_ovr_0(id, len, name, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; var name: Byte; &params: IntPtr) :=
    z_GetProgramNamedParameterdvNV_ovr_2(id, len, name, &params);
    private static procedure z_GetProgramNamedParameterdvNV_ovr_6(id: UInt32; len: Int32; name: IntPtr; var &params: real);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    private static procedure z_GetProgramNamedParameterdvNV_ovr_6_anh00001(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: IntPtr; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramNamedParameterdvNV_ovr_6(id, len, name, &params[0]) else
      z_GetProgramNamedParameterdvNV_ovr_6_anh00001(id, len, name, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: IntPtr; var &params: real) :=
    z_GetProgramNamedParameterdvNV_ovr_6(id, len, name, &params);
    private static procedure z_GetProgramNamedParameterdvNV_ovr_8(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramNamedParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramNamedParameterdvNV(id: UInt32; len: Int32; name: IntPtr; &params: IntPtr) :=
    z_GetProgramNamedParameterdvNV_ovr_8(id, len, name, &params);
    
  end;
  
  glFramebufferMixedSamplesNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RasterSamplesEXT_ovr_0(samples: UInt32; fixedsamplelocations: boolean);
    external 'opengl32.dll' name 'glRasterSamplesEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterSamplesEXT(samples: UInt32; fixedsamplelocations: boolean) :=
    z_RasterSamplesEXT_ovr_0(samples, fixedsamplelocations);
    
    private static procedure z_CoverageModulationTableNV_ovr_0(n: Int32; var v: single);
    external 'opengl32.dll' name 'glCoverageModulationTableNV';
    private static procedure z_CoverageModulationTableNV_ovr_0_anh001(n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glCoverageModulationTableNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_CoverageModulationTableNV_ovr_0(n, v[0]) else
      z_CoverageModulationTableNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; var v: single) :=
    z_CoverageModulationTableNV_ovr_0(n, v);
    private static procedure z_CoverageModulationTableNV_ovr_2(n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glCoverageModulationTableNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationTableNV(n: Int32; v: IntPtr) :=
    z_CoverageModulationTableNV_ovr_2(n, v);
    
    private static procedure z_GetCoverageModulationTableNV_ovr_0(bufSize: Int32; var v: single);
    external 'opengl32.dll' name 'glGetCoverageModulationTableNV';
    private static procedure z_GetCoverageModulationTableNV_ovr_0_anh001(bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetCoverageModulationTableNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetCoverageModulationTableNV_ovr_0(bufSize, v[0]) else
      z_GetCoverageModulationTableNV_ovr_0_anh001(bufSize, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; var v: single) :=
    z_GetCoverageModulationTableNV_ovr_0(bufSize, v);
    private static procedure z_GetCoverageModulationTableNV_ovr_2(bufSize: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glGetCoverageModulationTableNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCoverageModulationTableNV(bufSize: Int32; v: IntPtr) :=
    z_GetCoverageModulationTableNV_ovr_2(bufSize, v);
    
    private static procedure z_CoverageModulationNV_ovr_0(components: DummyEnum);
    external 'opengl32.dll' name 'glCoverageModulationNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverageModulationNV(components: DummyEnum) :=
    z_CoverageModulationNV_ovr_0(components);
    
  end;
  
  glFramebufferMultisampleCoverageNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RenderbufferStorageMultisampleCoverageNV_ovr_0(target: RenderbufferTarget; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glRenderbufferStorageMultisampleCoverageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderbufferStorageMultisampleCoverageNV(target: RenderbufferTarget; coverageSamples: Int32; colorSamples: Int32; _internalformat: InternalFormat; width: Int32; height: Int32) :=
    z_RenderbufferStorageMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, _internalformat, width, height);
    
  end;
  
  glGeometryProgram4NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramVertexLimitNV_ovr_0(target: ProgramTarget; limit: Int32);
    external 'opengl32.dll' name 'glProgramVertexLimitNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramVertexLimitNV(target: ProgramTarget; limit: Int32) :=
    z_ProgramVertexLimitNV_ovr_0(target, limit);
    
    private static procedure z_FramebufferTextureEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32) :=
    z_FramebufferTextureEXT_ovr_0(target, attachment, texture, level);
    
    private static procedure z_FramebufferTextureLayerEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureLayerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureLayerEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; layer: Int32) :=
    z_FramebufferTextureLayerEXT_ovr_0(target, attachment, texture, level, layer);
    
    private static procedure z_FramebufferTextureFaceEXT_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget);
    external 'opengl32.dll' name 'glFramebufferTextureFaceEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureFaceEXT(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; face: TextureTarget) :=
    z_FramebufferTextureFaceEXT_ovr_0(target, attachment, texture, level, face);
    
  end;
  
  glGpuProgram4NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramLocalParameterI4iNV_ovr_0(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glProgramLocalParameterI4iNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4iNV(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_ProgramLocalParameterI4iNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameterI4ivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glProgramLocalParameterI4ivNV';
    private static procedure z_ProgramLocalParameterI4ivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameterI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameterI4ivNV_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameterI4ivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_ProgramLocalParameterI4ivNV_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameterI4ivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameterI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameterI4ivNV_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParametersI4ivNV_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glProgramLocalParametersI4ivNV';
    private static procedure z_ProgramLocalParametersI4ivNV_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParametersI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParametersI4ivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParametersI4ivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramLocalParametersI4ivNV_ovr_0(target, index, count, &params);
    private static procedure z_ProgramLocalParametersI4ivNV_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParametersI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParametersI4ivNV_ovr_2(target, index, count, &params);
    
    private static procedure z_ProgramLocalParameterI4uiNV_ovr_0(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32);
    external 'opengl32.dll' name 'glProgramLocalParameterI4uiNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uiNV(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_ProgramLocalParameterI4uiNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramLocalParameterI4uivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramLocalParameterI4uivNV';
    private static procedure z_ProgramLocalParameterI4uivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameterI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParameterI4uivNV_ovr_0(target, index, &params[0]) else
      z_ProgramLocalParameterI4uivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_ProgramLocalParameterI4uivNV_ovr_0(target, index, &params);
    private static procedure z_ProgramLocalParameterI4uivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParameterI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramLocalParameterI4uivNV_ovr_2(target, index, &params);
    
    private static procedure z_ProgramLocalParametersI4uivNV_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramLocalParametersI4uivNV';
    private static procedure z_ProgramLocalParametersI4uivNV_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParametersI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramLocalParametersI4uivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramLocalParametersI4uivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramLocalParametersI4uivNV_ovr_0(target, index, count, &params);
    private static procedure z_ProgramLocalParametersI4uivNV_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramLocalParametersI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramLocalParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramLocalParametersI4uivNV_ovr_2(target, index, count, &params);
    
    private static procedure z_ProgramEnvParameterI4iNV_ovr_0(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glProgramEnvParameterI4iNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4iNV(target: ProgramTarget; index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_ProgramEnvParameterI4iNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameterI4ivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glProgramEnvParameterI4ivNV';
    private static procedure z_ProgramEnvParameterI4ivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameterI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameterI4ivNV_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameterI4ivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_ProgramEnvParameterI4ivNV_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameterI4ivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameterI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4ivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameterI4ivNV_ovr_2(target, index, &params);
    
    private static procedure z_ProgramEnvParametersI4ivNV_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glProgramEnvParametersI4ivNV';
    private static procedure z_ProgramEnvParametersI4ivNV_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParametersI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParametersI4ivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParametersI4ivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramEnvParametersI4ivNV_ovr_0(target, index, count, &params);
    private static procedure z_ProgramEnvParametersI4ivNV_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParametersI4ivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4ivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParametersI4ivNV_ovr_2(target, index, count, &params);
    
    private static procedure z_ProgramEnvParameterI4uiNV_ovr_0(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32);
    external 'opengl32.dll' name 'glProgramEnvParameterI4uiNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uiNV(target: ProgramTarget; index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_ProgramEnvParameterI4uiNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramEnvParameterI4uivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramEnvParameterI4uivNV';
    private static procedure z_ProgramEnvParameterI4uivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameterI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParameterI4uivNV_ovr_0(target, index, &params[0]) else
      z_ProgramEnvParameterI4uivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_ProgramEnvParameterI4uivNV_ovr_0(target, index, &params);
    private static procedure z_ProgramEnvParameterI4uivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParameterI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParameterI4uivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_ProgramEnvParameterI4uivNV_ovr_2(target, index, &params);
    
    private static procedure z_ProgramEnvParametersI4uivNV_ovr_0(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramEnvParametersI4uivNV';
    private static procedure z_ProgramEnvParametersI4uivNV_ovr_0_anh00001(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParametersI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramEnvParametersI4uivNV_ovr_0(target, index, count, &params[0]) else
      z_ProgramEnvParametersI4uivNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramEnvParametersI4uivNV_ovr_0(target, index, count, &params);
    private static procedure z_ProgramEnvParametersI4uivNV_ovr_2(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramEnvParametersI4uivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramEnvParametersI4uivNV(target: ProgramTarget; index: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramEnvParametersI4uivNV_ovr_2(target, index, count, &params);
    
    private static procedure z_GetProgramLocalParameterIivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIivNV';
    private static procedure z_GetProgramLocalParameterIivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterIivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterIivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetProgramLocalParameterIivNV_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterIivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterIivNV_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramLocalParameterIuivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIuivNV';
    private static procedure z_GetProgramLocalParameterIuivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramLocalParameterIuivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramLocalParameterIuivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetProgramLocalParameterIuivNV_ovr_0(target, index, &params);
    private static procedure z_GetProgramLocalParameterIuivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramLocalParameterIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramLocalParameterIuivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramLocalParameterIuivNV_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterIivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIivNV';
    private static procedure z_GetProgramEnvParameterIivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterIivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterIivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; var &params: Int32) :=
    z_GetProgramEnvParameterIivNV_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterIivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterIivNV_ovr_2(target, index, &params);
    
    private static procedure z_GetProgramEnvParameterIuivNV_ovr_0(target: ProgramTarget; index: UInt32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIuivNV';
    private static procedure z_GetProgramEnvParameterIuivNV_ovr_0_anh0001(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramEnvParameterIuivNV_ovr_0(target, index, &params[0]) else
      z_GetProgramEnvParameterIuivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; var &params: UInt32) :=
    z_GetProgramEnvParameterIuivNV_ovr_0(target, index, &params);
    private static procedure z_GetProgramEnvParameterIuivNV_ovr_2(target: ProgramTarget; index: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramEnvParameterIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramEnvParameterIuivNV(target: ProgramTarget; index: UInt32; &params: IntPtr) :=
    z_GetProgramEnvParameterIuivNV_ovr_2(target, index, &params);
    
  end;
  
  glGpuProgram5NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramSubroutineParametersuivNV_ovr_0(target: DummyEnum; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramSubroutineParametersuivNV';
    private static procedure z_ProgramSubroutineParametersuivNV_ovr_0_anh0001(target: DummyEnum; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramSubroutineParametersuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramSubroutineParametersuivNV_ovr_0(target, count, &params[0]) else
      z_ProgramSubroutineParametersuivNV_ovr_0_anh0001(target, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; var &params: UInt32) :=
    z_ProgramSubroutineParametersuivNV_ovr_0(target, count, &params);
    private static procedure z_ProgramSubroutineParametersuivNV_ovr_2(target: DummyEnum; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramSubroutineParametersuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramSubroutineParametersuivNV(target: DummyEnum; count: Int32; &params: IntPtr) :=
    z_ProgramSubroutineParametersuivNV_ovr_2(target, count, &params);
    
    private static procedure z_GetProgramSubroutineParameteruivNV_ovr_0(target: DummyEnum; index: UInt32; var param: UInt32);
    external 'opengl32.dll' name 'glGetProgramSubroutineParameteruivNV';
    private static procedure z_GetProgramSubroutineParameteruivNV_ovr_0_anh0001(target: DummyEnum; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetProgramSubroutineParameteruivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; param: array of UInt32) :=
    if (param<>nil) and (param.Length<>0) then
      z_GetProgramSubroutineParameteruivNV_ovr_0(target, index, param[0]) else
      z_GetProgramSubroutineParameteruivNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; var param: UInt32) :=
    z_GetProgramSubroutineParameteruivNV_ovr_0(target, index, param);
    private static procedure z_GetProgramSubroutineParameteruivNV_ovr_2(target: DummyEnum; index: UInt32; param: IntPtr);
    external 'opengl32.dll' name 'glGetProgramSubroutineParameteruivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramSubroutineParameteruivNV(target: DummyEnum; index: UInt32; param: IntPtr) :=
    z_GetProgramSubroutineParameteruivNV_ovr_2(target, index, param);
    
  end;
  
  glGpuShader5NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Uniform1i64NV_ovr_0(location: Int32; x: Int64);
    external 'opengl32.dll' name 'glUniform1i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64NV(location: Int32; x: Int64) :=
    z_Uniform1i64NV_ovr_0(location, x);
    
    private static procedure z_Uniform2i64NV_ovr_0(location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glUniform2i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64NV(location: Int32; x: Int64; y: Int64) :=
    z_Uniform2i64NV_ovr_0(location, x, y);
    
    private static procedure z_Uniform3i64NV_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glUniform3i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64NV(location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_Uniform3i64NV_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4i64NV_ovr_0(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glUniform4i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64NV(location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_Uniform4i64NV_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    private static procedure z_Uniform1i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform1i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform1i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform2i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    private static procedure z_Uniform2i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform2i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform2i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform3i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    private static procedure z_Uniform3i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform3i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform3i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform4i64vNV_ovr_0(location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    private static procedure z_Uniform4i64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4i64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4i64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; var value: Int64) :=
    z_Uniform4i64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform4i64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4i64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4i64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform1ui64NV_ovr_0(location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64NV(location: Int32; x: UInt64) :=
    z_Uniform1ui64NV_ovr_0(location, x);
    
    private static procedure z_Uniform2ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64NV(location: Int32; x: UInt64; y: UInt64) :=
    z_Uniform2ui64NV_ovr_0(location, x, y);
    
    private static procedure z_Uniform3ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_Uniform3ui64NV_ovr_0(location, x, y, z);
    
    private static procedure z_Uniform4ui64NV_ovr_0(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64NV(location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_Uniform4ui64NV_ovr_0(location, x, y, z, w);
    
    private static procedure z_Uniform1ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    private static procedure z_Uniform1ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform1ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform1ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform1ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform1ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform1ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform1ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform2ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    private static procedure z_Uniform2ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform2ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform2ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform2ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform2ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform2ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform2ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform3ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    private static procedure z_Uniform3ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform3ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform3ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform3ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform3ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform3ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform3ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_Uniform4ui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    private static procedure z_Uniform4ui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniform4ui64vNV_ovr_0(location, count, value[0]) else
      z_Uniform4ui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniform4ui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniform4ui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniform4ui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniform4ui64vNV_ovr_2(location, count, value);
    
    private static procedure z_GetUniformi64vNV_ovr_0(&program: UInt32; location: Int32; var &params: Int64);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    private static procedure z_GetUniformi64vNV_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformi64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformi64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; var &params: Int64) :=
    z_GetUniformi64vNV_ovr_0(&program, location, &params);
    private static procedure z_GetUniformi64vNV_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformi64vNV(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformi64vNV_ovr_2(&program, location, &params);
    
    private static procedure z_ProgramUniform1i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64NV(&program: UInt32; location: Int32; x: Int64) :=
    z_ProgramUniform1i64NV_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64) :=
    z_ProgramUniform2i64NV_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64) :=
    z_ProgramUniform3i64NV_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4i64NV_ovr_0(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64NV(&program: UInt32; location: Int32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_ProgramUniform4i64NV_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    private static procedure z_ProgramUniform1i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform1i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    private static procedure z_ProgramUniform2i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform2i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    private static procedure z_ProgramUniform3i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform3i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4i64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: Int64);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    private static procedure z_ProgramUniform4i64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; value: array of Int64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4i64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; var value: Int64) :=
    z_ProgramUniform4i64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4i64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4i64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4i64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform1ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64NV(&program: UInt32; location: Int32; x: UInt64) :=
    z_ProgramUniform1ui64NV_ovr_0(&program, location, x);
    
    private static procedure z_ProgramUniform2ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64) :=
    z_ProgramUniform2ui64NV_ovr_0(&program, location, x, y);
    
    private static procedure z_ProgramUniform3ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64) :=
    z_ProgramUniform3ui64NV_ovr_0(&program, location, x, y, z);
    
    private static procedure z_ProgramUniform4ui64NV_ovr_0(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64NV(&program: UInt32; location: Int32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_ProgramUniform4ui64NV_ovr_0(&program, location, x, y, z, w);
    
    private static procedure z_ProgramUniform1ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    private static procedure z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform1ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform1ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform1ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform1ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform1ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform2ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    private static procedure z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform2ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform2ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform2ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform2ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform2ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform3ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    private static procedure z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform3ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform3ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform3ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform3ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform3ui64vNV_ovr_2(&program, location, count, value);
    
    private static procedure z_ProgramUniform4ui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    private static procedure z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniform4ui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniform4ui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniform4ui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniform4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniform4ui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniform4ui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  glHalfFloatNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Vertex2hNV_ovr_0(x: Half; y: Half);
    external 'opengl32.dll' name 'glVertex2hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hNV(x: Half; y: Half) :=
    z_Vertex2hNV_ovr_0(x, y);
    
    private static procedure z_Vertex2hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glVertex2hvNV';
    private static procedure z_Vertex2hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex2hvNV_ovr_0(v[0]) else
      z_Vertex2hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(var v: Half) :=
    z_Vertex2hvNV_ovr_0(v);
    private static procedure z_Vertex2hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2hvNV(v: IntPtr) :=
    z_Vertex2hvNV_ovr_2(v);
    
    private static procedure z_Vertex3hNV_ovr_0(x: Half; y: Half; z: Half);
    external 'opengl32.dll' name 'glVertex3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hNV(x: Half; y: Half; z: Half) :=
    z_Vertex3hNV_ovr_0(x, y, z);
    
    private static procedure z_Vertex3hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glVertex3hvNV';
    private static procedure z_Vertex3hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex3hvNV_ovr_0(v[0]) else
      z_Vertex3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(var v: Half) :=
    z_Vertex3hvNV_ovr_0(v);
    private static procedure z_Vertex3hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3hvNV(v: IntPtr) :=
    z_Vertex3hvNV_ovr_2(v);
    
    private static procedure z_Vertex4hNV_ovr_0(x: Half; y: Half; z: Half; w: Half);
    external 'opengl32.dll' name 'glVertex4hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hNV(x: Half; y: Half; z: Half; w: Half) :=
    z_Vertex4hNV_ovr_0(x, y, z, w);
    
    private static procedure z_Vertex4hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glVertex4hvNV';
    private static procedure z_Vertex4hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Vertex4hvNV_ovr_0(v[0]) else
      z_Vertex4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(var v: Half) :=
    z_Vertex4hvNV_ovr_0(v);
    private static procedure z_Vertex4hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glVertex4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4hvNV(v: IntPtr) :=
    z_Vertex4hvNV_ovr_2(v);
    
    private static procedure z_Normal3hNV_ovr_0(nx: Half; ny: Half; nz: Half);
    external 'opengl32.dll' name 'glNormal3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hNV(nx: Half; ny: Half; nz: Half) :=
    z_Normal3hNV_ovr_0(nx, ny, nz);
    
    private static procedure z_Normal3hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glNormal3hvNV';
    private static procedure z_Normal3hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Normal3hvNV_ovr_0(v[0]) else
      z_Normal3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(var v: Half) :=
    z_Normal3hvNV_ovr_0(v);
    private static procedure z_Normal3hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glNormal3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3hvNV(v: IntPtr) :=
    z_Normal3hvNV_ovr_2(v);
    
    private static procedure z_Color3hNV_ovr_0(red: Half; green: Half; blue: Half);
    external 'opengl32.dll' name 'glColor3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hNV(red: Half; green: Half; blue: Half) :=
    z_Color3hNV_ovr_0(red, green, blue);
    
    private static procedure z_Color3hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glColor3hvNV';
    private static procedure z_Color3hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color3hvNV_ovr_0(v[0]) else
      z_Color3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(var v: Half) :=
    z_Color3hvNV_ovr_0(v);
    private static procedure z_Color3hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3hvNV(v: IntPtr) :=
    z_Color3hvNV_ovr_2(v);
    
    private static procedure z_Color4hNV_ovr_0(red: Half; green: Half; blue: Half; alpha: Half);
    external 'opengl32.dll' name 'glColor4hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hNV(red: Half; green: Half; blue: Half; alpha: Half) :=
    z_Color4hNV_ovr_0(red, green, blue, alpha);
    
    private static procedure z_Color4hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glColor4hvNV';
    private static procedure z_Color4hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glColor4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_Color4hvNV_ovr_0(v[0]) else
      z_Color4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(var v: Half) :=
    z_Color4hvNV_ovr_0(v);
    private static procedure z_Color4hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glColor4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4hvNV(v: IntPtr) :=
    z_Color4hvNV_ovr_2(v);
    
    private static procedure z_TexCoord1hNV_ovr_0(s: Half);
    external 'opengl32.dll' name 'glTexCoord1hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hNV(s: Half) :=
    z_TexCoord1hNV_ovr_0(s);
    
    private static procedure z_TexCoord1hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glTexCoord1hvNV';
    private static procedure z_TexCoord1hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord1hvNV_ovr_0(v[0]) else
      z_TexCoord1hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hvNV(var v: Half) :=
    z_TexCoord1hvNV_ovr_0(v);
    private static procedure z_TexCoord1hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1hvNV(v: IntPtr) :=
    z_TexCoord1hvNV_ovr_2(v);
    
    private static procedure z_TexCoord2hNV_ovr_0(s: Half; t: Half);
    external 'opengl32.dll' name 'glTexCoord2hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hNV(s: Half; t: Half) :=
    z_TexCoord2hNV_ovr_0(s, t);
    
    private static procedure z_TexCoord2hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glTexCoord2hvNV';
    private static procedure z_TexCoord2hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord2hvNV_ovr_0(v[0]) else
      z_TexCoord2hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(var v: Half) :=
    z_TexCoord2hvNV_ovr_0(v);
    private static procedure z_TexCoord2hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2hvNV(v: IntPtr) :=
    z_TexCoord2hvNV_ovr_2(v);
    
    private static procedure z_TexCoord3hNV_ovr_0(s: Half; t: Half; r: Half);
    external 'opengl32.dll' name 'glTexCoord3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hNV(s: Half; t: Half; r: Half) :=
    z_TexCoord3hNV_ovr_0(s, t, r);
    
    private static procedure z_TexCoord3hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glTexCoord3hvNV';
    private static procedure z_TexCoord3hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord3hvNV_ovr_0(v[0]) else
      z_TexCoord3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(var v: Half) :=
    z_TexCoord3hvNV_ovr_0(v);
    private static procedure z_TexCoord3hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3hvNV(v: IntPtr) :=
    z_TexCoord3hvNV_ovr_2(v);
    
    private static procedure z_TexCoord4hNV_ovr_0(s: Half; t: Half; r: Half; q: Half);
    external 'opengl32.dll' name 'glTexCoord4hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hNV(s: Half; t: Half; r: Half; q: Half) :=
    z_TexCoord4hNV_ovr_0(s, t, r, q);
    
    private static procedure z_TexCoord4hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glTexCoord4hvNV';
    private static procedure z_TexCoord4hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_TexCoord4hvNV_ovr_0(v[0]) else
      z_TexCoord4hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(var v: Half) :=
    z_TexCoord4hvNV_ovr_0(v);
    private static procedure z_TexCoord4hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4hvNV(v: IntPtr) :=
    z_TexCoord4hvNV_ovr_2(v);
    
    private static procedure z_MultiTexCoord1hNV_ovr_0(target: TextureUnit; s: Half);
    external 'opengl32.dll' name 'glMultiTexCoord1hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hNV(target: TextureUnit; s: Half) :=
    z_MultiTexCoord1hNV_ovr_0(target, s);
    
    private static procedure z_MultiTexCoord1hvNV_ovr_0(target: TextureUnit; var v: Half);
    external 'opengl32.dll' name 'glMultiTexCoord1hvNV';
    private static procedure z_MultiTexCoord1hvNV_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord1hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord1hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord1hvNV_ovr_0(target, v);
    private static procedure z_MultiTexCoord1hvNV_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord1hvNV_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord2hNV_ovr_0(target: TextureUnit; s: Half; t: Half);
    external 'opengl32.dll' name 'glMultiTexCoord2hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hNV(target: TextureUnit; s: Half; t: Half) :=
    z_MultiTexCoord2hNV_ovr_0(target, s, t);
    
    private static procedure z_MultiTexCoord2hvNV_ovr_0(target: TextureUnit; var v: Half);
    external 'opengl32.dll' name 'glMultiTexCoord2hvNV';
    private static procedure z_MultiTexCoord2hvNV_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord2hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord2hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord2hvNV_ovr_0(target, v);
    private static procedure z_MultiTexCoord2hvNV_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord2hvNV_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord3hNV_ovr_0(target: TextureUnit; s: Half; t: Half; r: Half);
    external 'opengl32.dll' name 'glMultiTexCoord3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hNV(target: TextureUnit; s: Half; t: Half; r: Half) :=
    z_MultiTexCoord3hNV_ovr_0(target, s, t, r);
    
    private static procedure z_MultiTexCoord3hvNV_ovr_0(target: TextureUnit; var v: Half);
    external 'opengl32.dll' name 'glMultiTexCoord3hvNV';
    private static procedure z_MultiTexCoord3hvNV_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord3hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord3hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord3hvNV_ovr_0(target, v);
    private static procedure z_MultiTexCoord3hvNV_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord3hvNV_ovr_2(target, v);
    
    private static procedure z_MultiTexCoord4hNV_ovr_0(target: TextureUnit; s: Half; t: Half; r: Half; q: Half);
    external 'opengl32.dll' name 'glMultiTexCoord4hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hNV(target: TextureUnit; s: Half; t: Half; r: Half; q: Half) :=
    z_MultiTexCoord4hNV_ovr_0(target, s, t, r, q);
    
    private static procedure z_MultiTexCoord4hvNV_ovr_0(target: TextureUnit; var v: Half);
    external 'opengl32.dll' name 'glMultiTexCoord4hvNV';
    private static procedure z_MultiTexCoord4hvNV_ovr_0_anh001(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_MultiTexCoord4hvNV_ovr_0(target, v[0]) else
      z_MultiTexCoord4hvNV_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; var v: Half) :=
    z_MultiTexCoord4hvNV_ovr_0(target, v);
    private static procedure z_MultiTexCoord4hvNV_ovr_2(target: TextureUnit; v: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4hvNV(target: TextureUnit; v: IntPtr) :=
    z_MultiTexCoord4hvNV_ovr_2(target, v);
    
    private static procedure z_FogCoordhNV_ovr_0(fog: Half);
    external 'opengl32.dll' name 'glFogCoordhNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhNV(fog: Half) :=
    z_FogCoordhNV_ovr_0(fog);
    
    private static procedure z_FogCoordhvNV_ovr_0(var fog: Half);
    external 'opengl32.dll' name 'glFogCoordhvNV';
    private static procedure z_FogCoordhvNV_ovr_0_anh01(fog: IntPtr);
    external 'opengl32.dll' name 'glFogCoordhvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhvNV(fog: array of Half) :=
    if (fog<>nil) and (fog.Length<>0) then
      z_FogCoordhvNV_ovr_0(fog[0]) else
      z_FogCoordhvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhvNV(var fog: Half) :=
    z_FogCoordhvNV_ovr_0(fog);
    private static procedure z_FogCoordhvNV_ovr_2(fog: IntPtr);
    external 'opengl32.dll' name 'glFogCoordhvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordhvNV(fog: IntPtr) :=
    z_FogCoordhvNV_ovr_2(fog);
    
    private static procedure z_SecondaryColor3hNV_ovr_0(red: Half; green: Half; blue: Half);
    external 'opengl32.dll' name 'glSecondaryColor3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hNV(red: Half; green: Half; blue: Half) :=
    z_SecondaryColor3hNV_ovr_0(red, green, blue);
    
    private static procedure z_SecondaryColor3hvNV_ovr_0(var v: Half);
    external 'opengl32.dll' name 'glSecondaryColor3hvNV';
    private static procedure z_SecondaryColor3hvNV_ovr_0_anh01(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_SecondaryColor3hvNV_ovr_0(v[0]) else
      z_SecondaryColor3hvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(var v: Half) :=
    z_SecondaryColor3hvNV_ovr_0(v);
    private static procedure z_SecondaryColor3hvNV_ovr_2(v: IntPtr);
    external 'opengl32.dll' name 'glSecondaryColor3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColor3hvNV(v: IntPtr) :=
    z_SecondaryColor3hvNV_ovr_2(v);
    
    private static procedure z_VertexWeighthNV_ovr_0(weight: Half);
    external 'opengl32.dll' name 'glVertexWeighthNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthNV(weight: Half) :=
    z_VertexWeighthNV_ovr_0(weight);
    
    private static procedure z_VertexWeighthvNV_ovr_0(var weight: Half);
    external 'opengl32.dll' name 'glVertexWeighthvNV';
    private static procedure z_VertexWeighthvNV_ovr_0_anh01(weight: IntPtr);
    external 'opengl32.dll' name 'glVertexWeighthvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthvNV(weight: array of Half) :=
    if (weight<>nil) and (weight.Length<>0) then
      z_VertexWeighthvNV_ovr_0(weight[0]) else
      z_VertexWeighthvNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthvNV(var weight: Half) :=
    z_VertexWeighthvNV_ovr_0(weight);
    private static procedure z_VertexWeighthvNV_ovr_2(weight: IntPtr);
    external 'opengl32.dll' name 'glVertexWeighthvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexWeighthvNV(weight: IntPtr) :=
    z_VertexWeighthvNV_ovr_2(weight);
    
    private static procedure z_VertexAttrib1hNV_ovr_0(index: UInt32; x: Half);
    external 'opengl32.dll' name 'glVertexAttrib1hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hNV(index: UInt32; x: Half) :=
    z_VertexAttrib1hNV_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1hvNV_ovr_0(index: UInt32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttrib1hvNV';
    private static procedure z_VertexAttrib1hvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib1hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib1hvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib1hvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1hvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2hNV_ovr_0(index: UInt32; x: Half; y: Half);
    external 'opengl32.dll' name 'glVertexAttrib2hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hNV(index: UInt32; x: Half; y: Half) :=
    z_VertexAttrib2hNV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2hvNV_ovr_0(index: UInt32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttrib2hvNV';
    private static procedure z_VertexAttrib2hvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib2hvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib2hvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2hvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3hNV_ovr_0(index: UInt32; x: Half; y: Half; z: Half);
    external 'opengl32.dll' name 'glVertexAttrib3hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hNV(index: UInt32; x: Half; y: Half; z: Half) :=
    z_VertexAttrib3hNV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3hvNV_ovr_0(index: UInt32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttrib3hvNV';
    private static procedure z_VertexAttrib3hvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib3hvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib3hvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3hvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4hNV_ovr_0(index: UInt32; x: Half; y: Half; z: Half; w: Half);
    external 'opengl32.dll' name 'glVertexAttrib4hNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hNV(index: UInt32; x: Half; y: Half; z: Half; w: Half) :=
    z_VertexAttrib4hNV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4hvNV_ovr_0(index: UInt32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttrib4hvNV';
    private static procedure z_VertexAttrib4hvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4hvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4hvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; var v: Half) :=
    z_VertexAttrib4hvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib4hvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4hvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4hvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribs1hvNV_ovr_0(index: UInt32; n: Int32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttribs1hvNV';
    private static procedure z_VertexAttribs1hvNV_ovr_0_anh0001(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs1hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs1hvNV_ovr_0(index, n, v);
    private static procedure z_VertexAttribs1hvNV_ovr_2(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs1hvNV_ovr_2(index, n, v);
    
    private static procedure z_VertexAttribs2hvNV_ovr_0(index: UInt32; n: Int32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttribs2hvNV';
    private static procedure z_VertexAttribs2hvNV_ovr_0_anh0001(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs2hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs2hvNV_ovr_0(index, n, v);
    private static procedure z_VertexAttribs2hvNV_ovr_2(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs2hvNV_ovr_2(index, n, v);
    
    private static procedure z_VertexAttribs3hvNV_ovr_0(index: UInt32; n: Int32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttribs3hvNV';
    private static procedure z_VertexAttribs3hvNV_ovr_0_anh0001(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs3hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs3hvNV_ovr_0(index, n, v);
    private static procedure z_VertexAttribs3hvNV_ovr_2(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs3hvNV_ovr_2(index, n, v);
    
    private static procedure z_VertexAttribs4hvNV_ovr_0(index: UInt32; n: Int32; var v: Half);
    external 'opengl32.dll' name 'glVertexAttribs4hvNV';
    private static procedure z_VertexAttribs4hvNV_ovr_0_anh0001(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; v: array of Half) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4hvNV_ovr_0(index, n, v[0]) else
      z_VertexAttribs4hvNV_ovr_0_anh0001(index, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; var v: Half) :=
    z_VertexAttribs4hvNV_ovr_0(index, n, v);
    private static procedure z_VertexAttribs4hvNV_ovr_2(index: UInt32; n: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4hvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4hvNV(index: UInt32; n: Int32; v: IntPtr) :=
    z_VertexAttribs4hvNV_ovr_2(index, n, v);
    
  end;
  
  glInternalformatSampleQueryNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetInternalformatSampleivNV_ovr_0(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glGetInternalformatSampleivNV';
    private static procedure z_GetInternalformatSampleivNV_ovr_0_anh0000001(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformatSampleivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetInternalformatSampleivNV_ovr_0(target, _internalformat, samples, pname, count, &params[0]) else
      z_GetInternalformatSampleivNV_ovr_0_anh0000001(target, _internalformat, samples, pname, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; var &params: Int32) :=
    z_GetInternalformatSampleivNV_ovr_0(target, _internalformat, samples, pname, count, &params);
    private static procedure z_GetInternalformatSampleivNV_ovr_2(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetInternalformatSampleivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetInternalformatSampleivNV(target: TextureTarget; _internalformat: InternalFormat; samples: Int32; pname: InternalFormatPName; count: Int32; &params: IntPtr) :=
    z_GetInternalformatSampleivNV_ovr_2(target, _internalformat, samples, pname, count, &params);
    
  end;
  
  glGpuMulticastNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_RenderGpuMaskNV_ovr_0(mask: DummyFlags);
    external 'opengl32.dll' name 'glRenderGpuMaskNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RenderGpuMaskNV(mask: DummyFlags) :=
    z_RenderGpuMaskNV_ovr_0(mask);
    
    private static procedure z_MulticastBufferSubDataNV_ovr_0(gpuMask: DummyFlags; buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr);
    external 'opengl32.dll' name 'glMulticastBufferSubDataNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBufferSubDataNV(gpuMask: DummyFlags; buffer: UInt32; offset: IntPtr; size: IntPtr; data: IntPtr) :=
    z_MulticastBufferSubDataNV_ovr_0(gpuMask, buffer, offset, size, data);
    
    private static procedure z_MulticastCopyBufferSubDataNV_ovr_0(readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glMulticastCopyBufferSubDataNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastCopyBufferSubDataNV(readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr) :=
    z_MulticastCopyBufferSubDataNV_ovr_0(readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size);
    
    private static procedure z_MulticastCopyImageSubDataNV_ovr_0(srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32);
    external 'opengl32.dll' name 'glMulticastCopyImageSubDataNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastCopyImageSubDataNV(srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32) :=
    z_MulticastCopyImageSubDataNV_ovr_0(srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
    
    private static procedure z_MulticastBlitFramebufferNV_ovr_0(srcGpu: UInt32; dstGpu: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: DummyEnum);
    external 'opengl32.dll' name 'glMulticastBlitFramebufferNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBlitFramebufferNV(srcGpu: UInt32; dstGpu: UInt32; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: ClearBufferMask; filter: DummyEnum) :=
    z_MulticastBlitFramebufferNV_ovr_0(srcGpu, dstGpu, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
    private static procedure z_MulticastFramebufferSampleLocationsfvNV_ovr_0(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glMulticastFramebufferSampleLocationsfvNV';
    private static procedure z_MulticastFramebufferSampleLocationsfvNV_ovr_0_anh000001(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastFramebufferSampleLocationsfvNV_ovr_0(gpu, framebuffer, start, count, v[0]) else
      z_MulticastFramebufferSampleLocationsfvNV_ovr_0_anh000001(gpu, framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; var v: single) :=
    z_MulticastFramebufferSampleLocationsfvNV_ovr_0(gpu, framebuffer, start, count, v);
    private static procedure z_MulticastFramebufferSampleLocationsfvNV_ovr_2(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastFramebufferSampleLocationsfvNV(gpu: UInt32; framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastFramebufferSampleLocationsfvNV_ovr_2(gpu, framebuffer, start, count, v);
    
    private static procedure z_MulticastBarrierNV_ovr_0;
    external 'opengl32.dll' name 'glMulticastBarrierNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastBarrierNV :=
    z_MulticastBarrierNV_ovr_0;
    
    private static procedure z_MulticastWaitSyncNV_ovr_0(signalGpu: UInt32; waitGpuMask: DummyFlags);
    external 'opengl32.dll' name 'glMulticastWaitSyncNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastWaitSyncNV(signalGpu: UInt32; waitGpuMask: DummyFlags) :=
    z_MulticastWaitSyncNV_ovr_0(signalGpu, waitGpuMask);
    
    private static procedure z_MulticastGetQueryObjectivNV_ovr_0(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectivNV';
    private static procedure z_MulticastGetQueryObjectivNV_ovr_0_anh00001(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectivNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectivNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_MulticastGetQueryObjectivNV_ovr_0(gpu, id, pname, &params);
    private static procedure z_MulticastGetQueryObjectivNV_ovr_2(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectivNV_ovr_2(gpu, id, pname, &params);
    
    private static procedure z_MulticastGetQueryObjectuivNV_ovr_0(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt32);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectuivNV';
    private static procedure z_MulticastGetQueryObjectuivNV_ovr_0_anh00001(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectuivNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectuivNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt32) :=
    z_MulticastGetQueryObjectuivNV_ovr_0(gpu, id, pname, &params);
    private static procedure z_MulticastGetQueryObjectuivNV_ovr_2(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectuivNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectuivNV_ovr_2(gpu, id, pname, &params);
    
    private static procedure z_MulticastGetQueryObjecti64vNV_ovr_0(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int64);
    external 'opengl32.dll' name 'glMulticastGetQueryObjecti64vNV';
    private static procedure z_MulticastGetQueryObjecti64vNV_ovr_0_anh00001(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjecti64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjecti64vNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjecti64vNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: Int64) :=
    z_MulticastGetQueryObjecti64vNV_ovr_0(gpu, id, pname, &params);
    private static procedure z_MulticastGetQueryObjecti64vNV_ovr_2(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjecti64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjecti64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjecti64vNV_ovr_2(gpu, id, pname, &params);
    
    private static procedure z_MulticastGetQueryObjectui64vNV_ovr_0(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt64);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectui64vNV';
    private static procedure z_MulticastGetQueryObjectui64vNV_ovr_0_anh00001(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_MulticastGetQueryObjectui64vNV_ovr_0(gpu, id, pname, &params[0]) else
      z_MulticastGetQueryObjectui64vNV_ovr_0_anh00001(gpu, id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; var &params: UInt64) :=
    z_MulticastGetQueryObjectui64vNV_ovr_0(gpu, id, pname, &params);
    private static procedure z_MulticastGetQueryObjectui64vNV_ovr_2(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glMulticastGetQueryObjectui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastGetQueryObjectui64vNV(gpu: UInt32; id: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_MulticastGetQueryObjectui64vNV_ovr_2(gpu, id, pname, &params);
    
  end;
  
  glGpuMulticast2NVX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_UploadGpuMaskNVX_ovr_0(mask: DummyFlags);
    external 'opengl32.dll' name 'glUploadGpuMaskNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure UploadGpuMaskNVX(mask: DummyFlags) :=
    z_UploadGpuMaskNVX_ovr_0(mask);
    
    private static procedure z_MulticastViewportArrayvNVX_ovr_0(gpu: UInt32; first: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glMulticastViewportArrayvNVX';
    private static procedure z_MulticastViewportArrayvNVX_ovr_0_anh00001(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastViewportArrayvNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastViewportArrayvNVX_ovr_0(gpu, first, count, v[0]) else
      z_MulticastViewportArrayvNVX_ovr_0_anh00001(gpu, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; var v: single) :=
    z_MulticastViewportArrayvNVX_ovr_0(gpu, first, count, v);
    private static procedure z_MulticastViewportArrayvNVX_ovr_2(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastViewportArrayvNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastViewportArrayvNVX_ovr_2(gpu, first, count, v);
    
    private static procedure z_MulticastViewportPositionWScaleNVX_ovr_0(gpu: UInt32; index: UInt32; xcoeff: single; ycoeff: single);
    external 'opengl32.dll' name 'glMulticastViewportPositionWScaleNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastViewportPositionWScaleNVX(gpu: UInt32; index: UInt32; xcoeff: single; ycoeff: single) :=
    z_MulticastViewportPositionWScaleNVX_ovr_0(gpu, index, xcoeff, ycoeff);
    
    private static procedure z_MulticastScissorArrayvNVX_ovr_0(gpu: UInt32; first: UInt32; count: Int32; var v: Int32);
    external 'opengl32.dll' name 'glMulticastScissorArrayvNVX';
    private static procedure z_MulticastScissorArrayvNVX_ovr_0_anh00001(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastScissorArrayvNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_MulticastScissorArrayvNVX_ovr_0(gpu, first, count, v[0]) else
      z_MulticastScissorArrayvNVX_ovr_0_anh00001(gpu, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; var v: Int32) :=
    z_MulticastScissorArrayvNVX_ovr_0(gpu, first, count, v);
    private static procedure z_MulticastScissorArrayvNVX_ovr_2(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glMulticastScissorArrayvNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MulticastScissorArrayvNVX(gpu: UInt32; first: UInt32; count: Int32; v: IntPtr) :=
    z_MulticastScissorArrayvNVX_ovr_2(gpu, first, count, v);
    
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000011(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00010000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_1_anh00110000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00010000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_3_anh00110000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_4_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_4_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_4_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_5_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_5_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_5_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_7_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_7_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_7_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_8_anh00110000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_8_anh00110000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_9_anh00100000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_10_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_10_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_11_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_11_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_12_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_12_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_13_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_14_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_15_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_15_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_16_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_17_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_8_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000011(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_19_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_19_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_19_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000010(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_21_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_21_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_22_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_23_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_20_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000001(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_25_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_24_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_26(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_26_anh00100000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray[0], fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_26_anh00100000000000(waitSemaphoreCount, IntPtr.Zero, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_8_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_2_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_0_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_6_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_20_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_18_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_24_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_55_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_55_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_55_anh00010000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_57_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_57_anh00010000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_58_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_59_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_56_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_61_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_60_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_62(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_62_anh00010000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: array of UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray[0], readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_62_anh00010000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_56_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_54_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_60_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var fenceValueArray: UInt64; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000011(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_73_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_74(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_74_anh00000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyBufferSubDataNVX_ovr_74_anh00000000000010(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_72_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_78(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    private static function z_AsyncCopyBufferSubDataNVX_ovr_78_anh00000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyBufferSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyBufferSubDataNVX_ovr_78_anh00000000000001(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyBufferSubDataNVX_ovr_80(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyBufferSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyBufferSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; fenceValueArray: IntPtr; readGpu: UInt32; writeGpuMask: DummyFlags; readBuffer: UInt32; writeBuffer: UInt32; readOffset: IntPtr; writeOffset: IntPtr; size: IntPtr; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyBufferSubDataNVX_ovr_80(waitSemaphoreCount, waitSemaphoreArray, fenceValueArray, readGpu, writeGpuMask, readBuffer, writeBuffer, readOffset, writeOffset, size, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    
    private static function z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
          if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
            z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000011(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh000100000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_1_anh001100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
        if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
          z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000010(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh000100000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_3_anh001100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_4_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_4_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_4_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_5_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_5_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_5_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000001(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_7_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_7_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_7_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_8_anh001100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray[0], IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_8_anh001100000000000000000000(waitSemaphoreCount, IntPtr.Zero, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_9_anh001000000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_10_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_10_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_11_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_11_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_12_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_12_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_13_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_14_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_15_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_15_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_16_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_17_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_8_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000011(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_19_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_19_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_19_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000010(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_21_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_21_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_22_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_23_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_20_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000001(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_25_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_24_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_26(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_26_anh001000000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: array of UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitSemaphoreArray<>nil) and (waitSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray[0], waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_26_anh001000000000000000000000(waitSemaphoreCount, IntPtr.Zero, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_8_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_2_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_0_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_0(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_2(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_6_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_6(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_8(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_20_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_18_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_18(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_20(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_24_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_24(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; var waitSemaphoreArray: UInt32; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_26(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
        if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
          z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000011(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_55_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_55_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_55_anh000100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray) else
      if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
        z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000010(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_57_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_57_anh000100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_58_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_59_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_56_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000001(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_61_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_60_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_62(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_62_anh000100000000000000000000(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: array of UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    if (waitValueArray<>nil) and (waitValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, waitValueArray[0], srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_62_anh000100000000000000000000(waitSemaphoreCount, waitSemaphoreArray, IntPtr.Zero, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_56_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_54_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_54(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_56(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_60_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_60(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; var waitValueArray: UInt64; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_62(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000011(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], IntPtr.Zero) else
      if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray[0]) else
        z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000011(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_AsyncCopyImageSubDataNVX_ovr_73_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; var signalValueArray: UInt64): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_74(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_74_anh000000000000000000000010(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: array of UInt32; signalValueArray: IntPtr): UInt32 :=
    if (signalSemaphoreArray<>nil) and (signalSemaphoreArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray[0], signalValueArray) else
      z_AsyncCopyImageSubDataNVX_ovr_74_anh000000000000000000000010(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, IntPtr.Zero, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_72_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_72(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; var signalSemaphoreArray: UInt32; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_74(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_78(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    private static function z_AsyncCopyImageSubDataNVX_ovr_78_anh000000000000000000000001(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: array of UInt64): UInt32 :=
    if (signalValueArray<>nil) and (signalValueArray.Length<>0) then
      z_AsyncCopyImageSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray[0]) else
      z_AsyncCopyImageSubDataNVX_ovr_78_anh000000000000000000000001(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; var signalValueArray: UInt64): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_78(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    private static function z_AsyncCopyImageSubDataNVX_ovr_80(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32;
    external 'opengl32.dll' name 'glAsyncCopyImageSubDataNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AsyncCopyImageSubDataNVX(waitSemaphoreCount: Int32; waitSemaphoreArray: IntPtr; waitValueArray: IntPtr; srcGpu: UInt32; dstGpuMask: DummyFlags; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; srcWidth: Int32; srcHeight: Int32; srcDepth: Int32; signalSemaphoreCount: Int32; signalSemaphoreArray: IntPtr; signalValueArray: IntPtr): UInt32 :=
    z_AsyncCopyImageSubDataNVX_ovr_80(waitSemaphoreCount, waitSemaphoreArray, waitValueArray, srcGpu, dstGpuMask, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth, signalSemaphoreCount, signalSemaphoreArray, signalValueArray);
    
  end;
  
  glProgressFenceNVX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_CreateProgressFenceNVX_ovr_0: UInt32;
    external 'opengl32.dll' name 'glCreateProgressFenceNVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function CreateProgressFenceNVX: UInt32 :=
    z_CreateProgressFenceNVX_ovr_0;
    
    private static procedure z_SignalSemaphoreui64NVX_ovr_0(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    private static procedure z_SignalSemaphoreui64NVX_ovr_0_anh00010(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    private static procedure z_SignalSemaphoreui64NVX_ovr_0_anh00001(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    private static procedure z_SignalSemaphoreui64NVX_ovr_0_anh00011(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_SignalSemaphoreui64NVX_ovr_0_anh00001(signalGpu, fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_SignalSemaphoreui64NVX_ovr_0_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_SignalSemaphoreui64NVX_ovr_0_anh00011(signalGpu, fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_SignalSemaphoreui64NVX_ovr_1_anh00010(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_SignalSemaphoreui64NVX_ovr_0_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private static procedure z_SignalSemaphoreui64NVX_ovr_2(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    private static procedure z_SignalSemaphoreui64NVX_ovr_2_anh00010(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_2(signalGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_SignalSemaphoreui64NVX_ovr_2_anh00010(signalGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_SignalSemaphoreui64NVX_ovr_0_anh00001(signalGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_SignalSemaphoreui64NVX_ovr_0(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_SignalSemaphoreui64NVX_ovr_2(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_SignalSemaphoreui64NVX_ovr_6(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    private static procedure z_SignalSemaphoreui64NVX_ovr_6_anh00001(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_SignalSemaphoreui64NVX_ovr_6(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_SignalSemaphoreui64NVX_ovr_6_anh00001(signalGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_SignalSemaphoreui64NVX_ovr_6(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_SignalSemaphoreui64NVX_ovr_8(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glSignalSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SignalSemaphoreui64NVX(signalGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_SignalSemaphoreui64NVX_ovr_8(signalGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    
    private static procedure z_WaitSemaphoreui64NVX_ovr_0(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    private static procedure z_WaitSemaphoreui64NVX_ovr_0_anh00010(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    private static procedure z_WaitSemaphoreui64NVX_ovr_0_anh00001(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    private static procedure z_WaitSemaphoreui64NVX_ovr_0_anh00011(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_WaitSemaphoreui64NVX_ovr_0_anh00001(waitGpu, fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_WaitSemaphoreui64NVX_ovr_0_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_WaitSemaphoreui64NVX_ovr_0_anh00011(waitGpu, fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_WaitSemaphoreui64NVX_ovr_1_anh00010(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_WaitSemaphoreui64NVX_ovr_0_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private static procedure z_WaitSemaphoreui64NVX_ovr_2(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    private static procedure z_WaitSemaphoreui64NVX_ovr_2_anh00010(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_2(waitGpu, fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_WaitSemaphoreui64NVX_ovr_2_anh00010(waitGpu, fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_WaitSemaphoreui64NVX_ovr_0_anh00001(waitGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_WaitSemaphoreui64NVX_ovr_0(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_WaitSemaphoreui64NVX_ovr_2(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_WaitSemaphoreui64NVX_ovr_6(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    private static procedure z_WaitSemaphoreui64NVX_ovr_6_anh00001(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_WaitSemaphoreui64NVX_ovr_6(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_WaitSemaphoreui64NVX_ovr_6_anh00001(waitGpu, fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_WaitSemaphoreui64NVX_ovr_6(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_WaitSemaphoreui64NVX_ovr_8(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WaitSemaphoreui64NVX(waitGpu: UInt32; fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_WaitSemaphoreui64NVX_ovr_8(waitGpu, fenceObjectCount, semaphoreArray, fenceValueArray);
    
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_0_anh0011(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: array of UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray[0], fenceValueArray[0]) else
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001(fenceObjectCount, semaphoreArray[0], IntPtr.Zero) else
      if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray[0]) else
        z_ClientWaitSemaphoreui64NVX_ovr_0_anh0011(fenceObjectCount, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_1_anh0010(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; var fenceValueArray: UInt64) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_ClientWaitSemaphoreui64NVX_ovr_0_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray);
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_2(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_2_anh0010(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: array of UInt32; fenceValueArray: IntPtr) :=
    if (semaphoreArray<>nil) and (semaphoreArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_2(fenceObjectCount, semaphoreArray[0], fenceValueArray) else
      z_ClientWaitSemaphoreui64NVX_ovr_2_anh0010(fenceObjectCount, IntPtr.Zero, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_ClientWaitSemaphoreui64NVX_ovr_0_anh0001(fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; var fenceValueArray: UInt64) :=
    z_ClientWaitSemaphoreui64NVX_ovr_0(fenceObjectCount, semaphoreArray, fenceValueArray);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; var semaphoreArray: UInt32; fenceValueArray: IntPtr) :=
    z_ClientWaitSemaphoreui64NVX_ovr_2(fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_6(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_6_anh0001(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: array of UInt64) :=
    if (fenceValueArray<>nil) and (fenceValueArray.Length<>0) then
      z_ClientWaitSemaphoreui64NVX_ovr_6(fenceObjectCount, semaphoreArray, fenceValueArray[0]) else
      z_ClientWaitSemaphoreui64NVX_ovr_6_anh0001(fenceObjectCount, semaphoreArray, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; var fenceValueArray: UInt64) :=
    z_ClientWaitSemaphoreui64NVX_ovr_6(fenceObjectCount, semaphoreArray, fenceValueArray);
    private static procedure z_ClientWaitSemaphoreui64NVX_ovr_8(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr);
    external 'opengl32.dll' name 'glClientWaitSemaphoreui64NVX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClientWaitSemaphoreui64NVX(fenceObjectCount: Int32; semaphoreArray: IntPtr; fenceValueArray: IntPtr) :=
    z_ClientWaitSemaphoreui64NVX_ovr_8(fenceObjectCount, semaphoreArray, fenceValueArray);
    
  end;
  
  glMemoryAttachmentNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetMemoryObjectDetachedResourcesuivNV_ovr_0(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glGetMemoryObjectDetachedResourcesuivNV';
    private static procedure z_GetMemoryObjectDetachedResourcesuivNV_ovr_0_anh000001(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMemoryObjectDetachedResourcesuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetMemoryObjectDetachedResourcesuivNV_ovr_0(memory, pname, first, count, &params[0]) else
      z_GetMemoryObjectDetachedResourcesuivNV_ovr_0_anh000001(memory, pname, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; var &params: UInt32) :=
    z_GetMemoryObjectDetachedResourcesuivNV_ovr_0(memory, pname, first, count, &params);
    private static procedure z_GetMemoryObjectDetachedResourcesuivNV_ovr_2(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetMemoryObjectDetachedResourcesuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMemoryObjectDetachedResourcesuivNV(memory: UInt32; pname: DummyEnum; first: Int32; count: Int32; &params: IntPtr) :=
    z_GetMemoryObjectDetachedResourcesuivNV_ovr_2(memory, pname, first, count, &params);
    
    private static procedure z_ResetMemoryObjectParameterNV_ovr_0(memory: UInt32; pname: DummyEnum);
    external 'opengl32.dll' name 'glResetMemoryObjectParameterNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResetMemoryObjectParameterNV(memory: UInt32; pname: DummyEnum) :=
    z_ResetMemoryObjectParameterNV_ovr_0(memory, pname);
    
    private static procedure z_TexAttachMemoryNV_ovr_0(target: TextureTarget; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTexAttachMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexAttachMemoryNV(target: TextureTarget; memory: UInt32; offset: UInt64) :=
    z_TexAttachMemoryNV_ovr_0(target, memory, offset);
    
    private static procedure z_BufferAttachMemoryNV_ovr_0(target: BufferTargetARB; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glBufferAttachMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferAttachMemoryNV(target: BufferTargetARB; memory: UInt32; offset: UInt64) :=
    z_BufferAttachMemoryNV_ovr_0(target, memory, offset);
    
    private static procedure z_TextureAttachMemoryNV_ovr_0(texture: UInt32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glTextureAttachMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureAttachMemoryNV(texture: UInt32; memory: UInt32; offset: UInt64) :=
    z_TextureAttachMemoryNV_ovr_0(texture, memory, offset);
    
    private static procedure z_NamedBufferAttachMemoryNV_ovr_0(buffer: UInt32; memory: UInt32; offset: UInt64);
    external 'opengl32.dll' name 'glNamedBufferAttachMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedBufferAttachMemoryNV(buffer: UInt32; memory: UInt32; offset: UInt64) :=
    z_NamedBufferAttachMemoryNV_ovr_0(buffer, memory, offset);
    
  end;
  
  glMeshShaderNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawMeshTasksNV_ovr_0(first: UInt32; count: UInt32);
    external 'opengl32.dll' name 'glDrawMeshTasksNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshTasksNV(first: UInt32; count: UInt32) :=
    z_DrawMeshTasksNV_ovr_0(first, count);
    
    private static procedure z_DrawMeshTasksIndirectNV_ovr_0(indirect: IntPtr);
    external 'opengl32.dll' name 'glDrawMeshTasksIndirectNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshTasksIndirectNV(indirect: IntPtr) :=
    z_DrawMeshTasksIndirectNV_ovr_0(indirect);
    
    private static procedure z_MultiDrawMeshTasksIndirectNV_ovr_0(indirect: IntPtr; drawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawMeshTasksIndirectNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawMeshTasksIndirectNV(indirect: IntPtr; drawcount: Int32; stride: Int32) :=
    z_MultiDrawMeshTasksIndirectNV_ovr_0(indirect, drawcount, stride);
    
    private static procedure z_MultiDrawMeshTasksIndirectCountNV_ovr_0(indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32);
    external 'opengl32.dll' name 'glMultiDrawMeshTasksIndirectCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiDrawMeshTasksIndirectCountNV(indirect: IntPtr; drawcount: IntPtr; maxdrawcount: Int32; stride: Int32) :=
    z_MultiDrawMeshTasksIndirectCountNV_ovr_0(indirect, drawcount, maxdrawcount, stride);
    
  end;
  
  glOcclusionQueryNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenOcclusionQueriesNV_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glGenOcclusionQueriesNV';
    private static procedure z_GenOcclusionQueriesNV_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenOcclusionQueriesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenOcclusionQueriesNV_ovr_0(n, ids[0]) else
      z_GenOcclusionQueriesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; var ids: UInt32) :=
    z_GenOcclusionQueriesNV_ovr_0(n, ids);
    private static procedure z_GenOcclusionQueriesNV_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenOcclusionQueriesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenOcclusionQueriesNV(n: Int32; ids: IntPtr) :=
    z_GenOcclusionQueriesNV_ovr_2(n, ids);
    
    private static procedure z_DeleteOcclusionQueriesNV_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glDeleteOcclusionQueriesNV';
    private static procedure z_DeleteOcclusionQueriesNV_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteOcclusionQueriesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteOcclusionQueriesNV_ovr_0(n, ids[0]) else
      z_DeleteOcclusionQueriesNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; var ids: UInt32) :=
    z_DeleteOcclusionQueriesNV_ovr_0(n, ids);
    private static procedure z_DeleteOcclusionQueriesNV_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteOcclusionQueriesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteOcclusionQueriesNV(n: Int32; ids: IntPtr) :=
    z_DeleteOcclusionQueriesNV_ovr_2(n, ids);
    
    private static function z_IsOcclusionQueryNV_ovr_0(id: UInt32): boolean;
    external 'opengl32.dll' name 'glIsOcclusionQueryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsOcclusionQueryNV(id: UInt32): boolean :=
    z_IsOcclusionQueryNV_ovr_0(id);
    
    private static procedure z_BeginOcclusionQueryNV_ovr_0(id: UInt32);
    external 'opengl32.dll' name 'glBeginOcclusionQueryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginOcclusionQueryNV(id: UInt32) :=
    z_BeginOcclusionQueryNV_ovr_0(id);
    
    private static procedure z_EndOcclusionQueryNV_ovr_0;
    external 'opengl32.dll' name 'glEndOcclusionQueryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndOcclusionQueryNV :=
    z_EndOcclusionQueryNV_ovr_0;
    
    private static procedure z_GetOcclusionQueryivNV_ovr_0(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetOcclusionQueryivNV';
    private static procedure z_GetOcclusionQueryivNV_ovr_0_anh0001(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetOcclusionQueryivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetOcclusionQueryivNV_ovr_0(id, pname, &params[0]) else
      z_GetOcclusionQueryivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: Int32) :=
    z_GetOcclusionQueryivNV_ovr_0(id, pname, &params);
    private static procedure z_GetOcclusionQueryivNV_ovr_2(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetOcclusionQueryivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr) :=
    z_GetOcclusionQueryivNV_ovr_2(id, pname, &params);
    
    private static procedure z_GetOcclusionQueryuivNV_ovr_0(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: UInt32);
    external 'opengl32.dll' name 'glGetOcclusionQueryuivNV';
    private static procedure z_GetOcclusionQueryuivNV_ovr_0_anh0001(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetOcclusionQueryuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetOcclusionQueryuivNV_ovr_0(id, pname, &params[0]) else
      z_GetOcclusionQueryuivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; var &params: UInt32) :=
    z_GetOcclusionQueryuivNV_ovr_0(id, pname, &params);
    private static procedure z_GetOcclusionQueryuivNV_ovr_2(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetOcclusionQueryuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetOcclusionQueryuivNV(id: UInt32; pname: OcclusionQueryParameterNameNV; &params: IntPtr) :=
    z_GetOcclusionQueryuivNV_ovr_2(id, pname, &params);
    
  end;
  
  glParameterBufferObjectNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ProgramBufferParametersfvNV_ovr_0(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: single);
    external 'opengl32.dll' name 'glProgramBufferParametersfvNV';
    private static procedure z_ProgramBufferParametersfvNV_ovr_0_anh000001(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersfvNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersfvNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: single) :=
    z_ProgramBufferParametersfvNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private static procedure z_ProgramBufferParametersfvNV_ovr_2(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersfvNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersfvNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
    private static procedure z_ProgramBufferParametersIivNV_ovr_0(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: Int32);
    external 'opengl32.dll' name 'glProgramBufferParametersIivNV';
    private static procedure z_ProgramBufferParametersIivNV_ovr_0_anh000001(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersIivNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersIivNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: Int32) :=
    z_ProgramBufferParametersIivNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private static procedure z_ProgramBufferParametersIivNV_ovr_2(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersIivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersIivNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
    private static procedure z_ProgramBufferParametersIuivNV_ovr_0(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: UInt32);
    external 'opengl32.dll' name 'glProgramBufferParametersIuivNV';
    private static procedure z_ProgramBufferParametersIuivNV_ovr_0_anh000001(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ProgramBufferParametersIuivNV_ovr_0(target, bindingIndex, wordIndex, count, &params[0]) else
      z_ProgramBufferParametersIuivNV_ovr_0_anh000001(target, bindingIndex, wordIndex, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; var &params: UInt32) :=
    z_ProgramBufferParametersIuivNV_ovr_0(target, bindingIndex, wordIndex, count, &params);
    private static procedure z_ProgramBufferParametersIuivNV_ovr_2(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glProgramBufferParametersIuivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramBufferParametersIuivNV(target: ProgramTarget; bindingIndex: UInt32; wordIndex: UInt32; count: Int32; &params: IntPtr) :=
    z_ProgramBufferParametersIuivNV_ovr_2(target, bindingIndex, wordIndex, count, &params);
    
  end;
  
  glPathRenderingNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GenPathsNV_ovr_0(range: Int32): UInt32;
    external 'opengl32.dll' name 'glGenPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenPathsNV(range: Int32): UInt32 :=
    z_GenPathsNV_ovr_0(range);
    
    private static procedure z_DeletePathsNV_ovr_0(path: UInt32; range: Int32);
    external 'opengl32.dll' name 'glDeletePathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeletePathsNV(path: UInt32; range: Int32) :=
    z_DeletePathsNV_ovr_0(path, range);
    
    private static function z_IsPathNV_ovr_0(path: UInt32): boolean;
    external 'opengl32.dll' name 'glIsPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPathNV(path: UInt32): boolean :=
    z_IsPathNV_ovr_0(path);
    
    private static procedure z_PathCommandsNV_ovr_0(path: UInt32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathCommandsNV';
    private static procedure z_PathCommandsNV_ovr_0_anh0001000(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; commands: array of Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_PathCommandsNV_ovr_0(path, numCommands, commands[0], numCoords, coordType, coords) else
      z_PathCommandsNV_ovr_0_anh0001000(path, numCommands, IntPtr.Zero, numCoords, coordType, coords);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCommandsNV_ovr_0(path, numCommands, commands, numCoords, coordType, coords);
    private static procedure z_PathCommandsNV_ovr_2(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCommandsNV(path: UInt32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCommandsNV_ovr_2(path, numCommands, commands, numCoords, coordType, coords);
    
    private static procedure z_PathCoordsNV_ovr_0(path: UInt32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathCoordsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCoordsNV(path: UInt32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathCoordsNV_ovr_0(path, numCoords, coordType, coords);
    
    private static procedure z_PathSubCommandsNV_ovr_0(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathSubCommandsNV';
    private static procedure z_PathSubCommandsNV_ovr_0_anh000001000(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathSubCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: array of Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_PathSubCommandsNV_ovr_0(path, commandStart, commandsToDelete, numCommands, commands[0], numCoords, coordType, coords) else
      z_PathSubCommandsNV_ovr_0_anh000001000(path, commandStart, commandsToDelete, numCommands, IntPtr.Zero, numCoords, coordType, coords);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; var commands: Byte; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCommandsNV_ovr_0(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
    private static procedure z_PathSubCommandsNV_ovr_2(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathSubCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCommandsNV(path: UInt32; commandStart: Int32; commandsToDelete: Int32; numCommands: Int32; commands: IntPtr; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCommandsNV_ovr_2(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
    
    private static procedure z_PathSubCoordsNV_ovr_0(path: UInt32; coordStart: Int32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr);
    external 'opengl32.dll' name 'glPathSubCoordsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathSubCoordsNV(path: UInt32; coordStart: Int32; numCoords: Int32; coordType: PathCoordType; coords: IntPtr) :=
    z_PathSubCoordsNV_ovr_0(path, coordStart, numCoords, coordType, coords);
    
    private static procedure z_PathStringNV_ovr_0(path: UInt32; format: PathStringFormat; length: Int32; pathString: IntPtr);
    external 'opengl32.dll' name 'glPathStringNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStringNV(path: UInt32; format: PathStringFormat; length: Int32; pathString: IntPtr) :=
    z_PathStringNV_ovr_0(path, format, length, pathString);
    
    private static procedure z_PathGlyphsNV_ovr_0(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; numGlyphs: Int32; &type: PathElementType; charcodes: IntPtr; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single);
    external 'opengl32.dll' name 'glPathGlyphsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathGlyphsNV(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; numGlyphs: Int32; &type: PathElementType; charcodes: IntPtr; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single) :=
    z_PathGlyphsNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, numGlyphs, &type, charcodes, handleMissingGlyphs, pathParameterTemplate, emScale);
    
    private static procedure z_PathGlyphRangeNV_ovr_0(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyph: UInt32; numGlyphs: Int32; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single);
    external 'opengl32.dll' name 'glPathGlyphRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathGlyphRangeNV(firstPathName: UInt32; fontTarget: PathFontTarget; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyph: UInt32; numGlyphs: Int32; handleMissingGlyphs: PathHandleMissingGlyphs; pathParameterTemplate: UInt32; emScale: single) :=
    z_PathGlyphRangeNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, firstGlyph, numGlyphs, handleMissingGlyphs, pathParameterTemplate, emScale);
    
    private static procedure z_WeightPathsNV_ovr_0(resultPath: UInt32; numPaths: Int32; var paths: UInt32; var weights: single);
    external 'opengl32.dll' name 'glWeightPathsNV';
    private static procedure z_WeightPathsNV_ovr_0_anh00010(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single);
    external 'opengl32.dll' name 'glWeightPathsNV';
    private static procedure z_WeightPathsNV_ovr_0_anh00001(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    private static procedure z_WeightPathsNV_ovr_0_anh00011(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; weights: array of single) :=
    if (paths<>nil) and (paths.Length<>0) then
      if (weights<>nil) and (weights.Length<>0) then
        z_WeightPathsNV_ovr_0(resultPath, numPaths, paths[0], weights[0]) else
        z_WeightPathsNV_ovr_0_anh00001(resultPath, numPaths, paths[0], IntPtr.Zero) else
      if (weights<>nil) and (weights.Length<>0) then
        z_WeightPathsNV_ovr_0_anh00010(resultPath, numPaths, IntPtr.Zero, weights[0]) else
        z_WeightPathsNV_ovr_0_anh00011(resultPath, numPaths, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_WeightPathsNV_ovr_1_anh00010(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single);
    external 'opengl32.dll' name 'glWeightPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; var weights: single) :=
    if (paths<>nil) and (paths.Length<>0) then
      z_WeightPathsNV_ovr_0(resultPath, numPaths, paths[0], weights) else
      z_WeightPathsNV_ovr_0_anh00010(resultPath, numPaths, IntPtr.Zero, weights);
    private static procedure z_WeightPathsNV_ovr_2(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    private static procedure z_WeightPathsNV_ovr_2_anh00010(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: array of UInt32; weights: IntPtr) :=
    if (paths<>nil) and (paths.Length<>0) then
      z_WeightPathsNV_ovr_2(resultPath, numPaths, paths[0], weights) else
      z_WeightPathsNV_ovr_2_anh00010(resultPath, numPaths, IntPtr.Zero, weights);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightPathsNV_ovr_0(resultPath, numPaths, paths, weights[0]) else
      z_WeightPathsNV_ovr_0_anh00001(resultPath, numPaths, paths, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; var weights: single) :=
    z_WeightPathsNV_ovr_0(resultPath, numPaths, paths, weights);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; var paths: UInt32; weights: IntPtr) :=
    z_WeightPathsNV_ovr_2(resultPath, numPaths, paths, weights);
    private static procedure z_WeightPathsNV_ovr_6(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single);
    external 'opengl32.dll' name 'glWeightPathsNV';
    private static procedure z_WeightPathsNV_ovr_6_anh00001(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_WeightPathsNV_ovr_6(resultPath, numPaths, paths, weights[0]) else
      z_WeightPathsNV_ovr_6_anh00001(resultPath, numPaths, paths, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; var weights: single) :=
    z_WeightPathsNV_ovr_6(resultPath, numPaths, paths, weights);
    private static procedure z_WeightPathsNV_ovr_8(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr);
    external 'opengl32.dll' name 'glWeightPathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure WeightPathsNV(resultPath: UInt32; numPaths: Int32; paths: IntPtr; weights: IntPtr) :=
    z_WeightPathsNV_ovr_8(resultPath, numPaths, paths, weights);
    
    private static procedure z_CopyPathNV_ovr_0(resultPath: UInt32; srcPath: UInt32);
    external 'opengl32.dll' name 'glCopyPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyPathNV(resultPath: UInt32; srcPath: UInt32) :=
    z_CopyPathNV_ovr_0(resultPath, srcPath);
    
    private static procedure z_InterpolatePathsNV_ovr_0(resultPath: UInt32; pathA: UInt32; pathB: UInt32; weight: single);
    external 'opengl32.dll' name 'glInterpolatePathsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InterpolatePathsNV(resultPath: UInt32; pathA: UInt32; pathB: UInt32; weight: single) :=
    z_InterpolatePathsNV_ovr_0(resultPath, pathA, pathB, weight);
    
    private static procedure z_TransformPathNV_ovr_0(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; var transformValues: single);
    external 'opengl32.dll' name 'glTransformPathNV';
    private static procedure z_TransformPathNV_ovr_0_anh00001(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glTransformPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_TransformPathNV_ovr_0(resultPath, srcPath, transformType, transformValues[0]) else
      z_TransformPathNV_ovr_0_anh00001(resultPath, srcPath, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_TransformPathNV_ovr_0(resultPath, srcPath, transformType, transformValues);
    private static procedure z_TransformPathNV_ovr_2(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glTransformPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformPathNV(resultPath: UInt32; srcPath: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_TransformPathNV_ovr_2(resultPath, srcPath, transformType, transformValues);
    
    private static procedure z_PathParameterivNV_ovr_0(path: UInt32; pname: PathParameter; var value: Int32);
    external 'opengl32.dll' name 'glPathParameterivNV';
    private static procedure z_PathParameterivNV_ovr_0_anh0001(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glPathParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_PathParameterivNV_ovr_0(path, pname, value[0]) else
      z_PathParameterivNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; var value: Int32) :=
    z_PathParameterivNV_ovr_0(path, pname, value);
    private static procedure z_PathParameterivNV_ovr_2(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glPathParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterivNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_PathParameterivNV_ovr_2(path, pname, value);
    
    private static procedure z_PathParameteriNV_ovr_0(path: UInt32; pname: PathParameter; value: Int32);
    external 'opengl32.dll' name 'glPathParameteriNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameteriNV(path: UInt32; pname: PathParameter; value: Int32) :=
    z_PathParameteriNV_ovr_0(path, pname, value);
    
    private static procedure z_PathParameterfvNV_ovr_0(path: UInt32; pname: PathParameter; var value: single);
    external 'opengl32.dll' name 'glPathParameterfvNV';
    private static procedure z_PathParameterfvNV_ovr_0_anh0001(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glPathParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_PathParameterfvNV_ovr_0(path, pname, value[0]) else
      z_PathParameterfvNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; var value: single) :=
    z_PathParameterfvNV_ovr_0(path, pname, value);
    private static procedure z_PathParameterfvNV_ovr_2(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glPathParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfvNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_PathParameterfvNV_ovr_2(path, pname, value);
    
    private static procedure z_PathParameterfNV_ovr_0(path: UInt32; pname: PathParameter; value: single);
    external 'opengl32.dll' name 'glPathParameterfNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathParameterfNV(path: UInt32; pname: PathParameter; value: single) :=
    z_PathParameterfNV_ovr_0(path, pname, value);
    
    private static procedure z_PathDashArrayNV_ovr_0(path: UInt32; dashCount: Int32; var dashArray: single);
    external 'opengl32.dll' name 'glPathDashArrayNV';
    private static procedure z_PathDashArrayNV_ovr_0_anh0001(path: UInt32; dashCount: Int32; dashArray: IntPtr);
    external 'opengl32.dll' name 'glPathDashArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; dashArray: array of single) :=
    if (dashArray<>nil) and (dashArray.Length<>0) then
      z_PathDashArrayNV_ovr_0(path, dashCount, dashArray[0]) else
      z_PathDashArrayNV_ovr_0_anh0001(path, dashCount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; var dashArray: single) :=
    z_PathDashArrayNV_ovr_0(path, dashCount, dashArray);
    private static procedure z_PathDashArrayNV_ovr_2(path: UInt32; dashCount: Int32; dashArray: IntPtr);
    external 'opengl32.dll' name 'glPathDashArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathDashArrayNV(path: UInt32; dashCount: Int32; dashArray: IntPtr) :=
    z_PathDashArrayNV_ovr_2(path, dashCount, dashArray);
    
    private static procedure z_PathStencilFuncNV_ovr_0(func: StencilFunction; ref: Int32; mask: UInt32);
    external 'opengl32.dll' name 'glPathStencilFuncNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStencilFuncNV(func: StencilFunction; ref: Int32; mask: UInt32) :=
    z_PathStencilFuncNV_ovr_0(func, ref, mask);
    
    private static procedure z_PathStencilDepthOffsetNV_ovr_0(factor: single; units: single);
    external 'opengl32.dll' name 'glPathStencilDepthOffsetNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathStencilDepthOffsetNV(factor: single; units: single) :=
    z_PathStencilDepthOffsetNV_ovr_0(factor, units);
    
    private static procedure z_StencilFillPathNV_ovr_0(path: UInt32; fillMode: PathFillMode; mask: UInt32);
    external 'opengl32.dll' name 'glStencilFillPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathNV(path: UInt32; fillMode: PathFillMode; mask: UInt32) :=
    z_StencilFillPathNV_ovr_0(path, fillMode, mask);
    
    private static procedure z_StencilStrokePathNV_ovr_0(path: UInt32; reference: Int32; mask: UInt32);
    external 'opengl32.dll' name 'glStencilStrokePathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathNV(path: UInt32; reference: Int32; mask: UInt32) :=
    z_StencilStrokePathNV_ovr_0(path, reference, mask);
    
    private static procedure z_StencilFillPathInstancedNV_ovr_0(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; var transformValues: single);
    external 'opengl32.dll' name 'glStencilFillPathInstancedNV';
    private static procedure z_StencilFillPathInstancedNV_ovr_0_anh000000001(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues[0]) else
      z_StencilFillPathInstancedNV_ovr_0_anh000000001(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_StencilFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
    private static procedure z_StencilFillPathInstancedNV_ovr_2(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; fillMode: PathFillMode; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_StencilFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
    
    private static procedure z_StencilStrokePathInstancedNV_ovr_0(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; var transformValues: single);
    external 'opengl32.dll' name 'glStencilStrokePathInstancedNV';
    private static procedure z_StencilStrokePathInstancedNV_ovr_0_anh000000001(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues[0]) else
      z_StencilStrokePathInstancedNV_ovr_0_anh000000001(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; var transformValues: single) :=
    z_StencilStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
    private static procedure z_StencilStrokePathInstancedNV_ovr_2(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; transformType: PathTransformType; transformValues: IntPtr) :=
    z_StencilStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
    
    private static procedure z_PathCoverDepthFuncNV_ovr_0(func: DepthFunction);
    external 'opengl32.dll' name 'glPathCoverDepthFuncNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathCoverDepthFuncNV(func: DepthFunction) :=
    z_PathCoverDepthFuncNV_ovr_0(func);
    
    private static procedure z_CoverFillPathNV_ovr_0(path: UInt32; coverMode: PathCoverMode);
    external 'opengl32.dll' name 'glCoverFillPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathNV(path: UInt32; coverMode: PathCoverMode) :=
    z_CoverFillPathNV_ovr_0(path, coverMode);
    
    private static procedure z_CoverStrokePathNV_ovr_0(path: UInt32; coverMode: PathCoverMode);
    external 'opengl32.dll' name 'glCoverStrokePathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathNV(path: UInt32; coverMode: PathCoverMode) :=
    z_CoverStrokePathNV_ovr_0(path, coverMode);
    
    private static procedure z_CoverFillPathInstancedNV_ovr_0(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single);
    external 'opengl32.dll' name 'glCoverFillPathInstancedNV';
    private static procedure z_CoverFillPathInstancedNV_ovr_0_anh00000001(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glCoverFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_CoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues[0]) else
      z_CoverFillPathInstancedNV_ovr_0_anh00000001(numPaths, pathNameType, paths, pathBase, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single) :=
    z_CoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    private static procedure z_CoverFillPathInstancedNV_ovr_2(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glCoverFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverFillPathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr) :=
    z_CoverFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    
    private static procedure z_CoverStrokePathInstancedNV_ovr_0(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single);
    external 'opengl32.dll' name 'glCoverStrokePathInstancedNV';
    private static procedure z_CoverStrokePathInstancedNV_ovr_0_anh00000001(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glCoverStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_CoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues[0]) else
      z_CoverStrokePathInstancedNV_ovr_0_anh00000001(numPaths, pathNameType, paths, pathBase, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; var transformValues: single) :=
    z_CoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    private static procedure z_CoverStrokePathInstancedNV_ovr_2(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr);
    external 'opengl32.dll' name 'glCoverStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CoverStrokePathInstancedNV(numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; coverMode: PathCoverMode; transformType: PathTransformType; transformValues: IntPtr) :=
    z_CoverStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
    
    private static procedure z_GetPathParameterivNV_ovr_0(path: UInt32; pname: PathParameter; var value: Int32);
    external 'opengl32.dll' name 'glGetPathParameterivNV';
    private static procedure z_GetPathParameterivNV_ovr_0_anh0001(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathParameterivNV_ovr_0(path, pname, value[0]) else
      z_GetPathParameterivNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; var value: Int32) :=
    z_GetPathParameterivNV_ovr_0(path, pname, value);
    private static procedure z_GetPathParameterivNV_ovr_2(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterivNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_GetPathParameterivNV_ovr_2(path, pname, value);
    
    private static procedure z_GetPathParameterfvNV_ovr_0(path: UInt32; pname: PathParameter; var value: single);
    external 'opengl32.dll' name 'glGetPathParameterfvNV';
    private static procedure z_GetPathParameterfvNV_ovr_0_anh0001(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathParameterfvNV_ovr_0(path, pname, value[0]) else
      z_GetPathParameterfvNV_ovr_0_anh0001(path, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; var value: single) :=
    z_GetPathParameterfvNV_ovr_0(path, pname, value);
    private static procedure z_GetPathParameterfvNV_ovr_2(path: UInt32; pname: PathParameter; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathParameterfvNV(path: UInt32; pname: PathParameter; value: IntPtr) :=
    z_GetPathParameterfvNV_ovr_2(path, pname, value);
    
    private static procedure z_GetPathCommandsNV_ovr_0(path: UInt32; var commands: Byte);
    external 'opengl32.dll' name 'glGetPathCommandsNV';
    private static procedure z_GetPathCommandsNV_ovr_0_anh001(path: UInt32; commands: IntPtr);
    external 'opengl32.dll' name 'glGetPathCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; commands: array of Byte) :=
    if (commands<>nil) and (commands.Length<>0) then
      z_GetPathCommandsNV_ovr_0(path, commands[0]) else
      z_GetPathCommandsNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; var commands: Byte) :=
    z_GetPathCommandsNV_ovr_0(path, commands);
    private static procedure z_GetPathCommandsNV_ovr_2(path: UInt32; commands: IntPtr);
    external 'opengl32.dll' name 'glGetPathCommandsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCommandsNV(path: UInt32; commands: IntPtr) :=
    z_GetPathCommandsNV_ovr_2(path, commands);
    
    private static procedure z_GetPathCoordsNV_ovr_0(path: UInt32; var coords: single);
    external 'opengl32.dll' name 'glGetPathCoordsNV';
    private static procedure z_GetPathCoordsNV_ovr_0_anh001(path: UInt32; coords: IntPtr);
    external 'opengl32.dll' name 'glGetPathCoordsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; coords: array of single) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_GetPathCoordsNV_ovr_0(path, coords[0]) else
      z_GetPathCoordsNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; var coords: single) :=
    z_GetPathCoordsNV_ovr_0(path, coords);
    private static procedure z_GetPathCoordsNV_ovr_2(path: UInt32; coords: IntPtr);
    external 'opengl32.dll' name 'glGetPathCoordsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathCoordsNV(path: UInt32; coords: IntPtr) :=
    z_GetPathCoordsNV_ovr_2(path, coords);
    
    private static procedure z_GetPathDashArrayNV_ovr_0(path: UInt32; var dashArray: single);
    external 'opengl32.dll' name 'glGetPathDashArrayNV';
    private static procedure z_GetPathDashArrayNV_ovr_0_anh001(path: UInt32; dashArray: IntPtr);
    external 'opengl32.dll' name 'glGetPathDashArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; dashArray: array of single) :=
    if (dashArray<>nil) and (dashArray.Length<>0) then
      z_GetPathDashArrayNV_ovr_0(path, dashArray[0]) else
      z_GetPathDashArrayNV_ovr_0_anh001(path, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; var dashArray: single) :=
    z_GetPathDashArrayNV_ovr_0(path, dashArray);
    private static procedure z_GetPathDashArrayNV_ovr_2(path: UInt32; dashArray: IntPtr);
    external 'opengl32.dll' name 'glGetPathDashArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathDashArrayNV(path: UInt32; dashArray: IntPtr) :=
    z_GetPathDashArrayNV_ovr_2(path, dashArray);
    
    private static procedure z_GetPathMetricsNV_ovr_0(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; var metrics: single);
    external 'opengl32.dll' name 'glGetPathMetricsNV';
    private static procedure z_GetPathMetricsNV_ovr_0_anh00000001(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr);
    external 'opengl32.dll' name 'glGetPathMetricsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: array of single) :=
    if (metrics<>nil) and (metrics.Length<>0) then
      z_GetPathMetricsNV_ovr_0(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics[0]) else
      z_GetPathMetricsNV_ovr_0_anh00000001(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; var metrics: single) :=
    z_GetPathMetricsNV_ovr_0(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
    private static procedure z_GetPathMetricsNV_ovr_2(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr);
    external 'opengl32.dll' name 'glGetPathMetricsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricsNV(metricQueryMask: PathMetricMask; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; stride: Int32; metrics: IntPtr) :=
    z_GetPathMetricsNV_ovr_2(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
    
    private static procedure z_GetPathMetricRangeNV_ovr_0(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; var metrics: single);
    external 'opengl32.dll' name 'glGetPathMetricRangeNV';
    private static procedure z_GetPathMetricRangeNV_ovr_0_anh000001(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr);
    external 'opengl32.dll' name 'glGetPathMetricRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: array of single) :=
    if (metrics<>nil) and (metrics.Length<>0) then
      z_GetPathMetricRangeNV_ovr_0(metricQueryMask, firstPathName, numPaths, stride, metrics[0]) else
      z_GetPathMetricRangeNV_ovr_0_anh000001(metricQueryMask, firstPathName, numPaths, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; var metrics: single) :=
    z_GetPathMetricRangeNV_ovr_0(metricQueryMask, firstPathName, numPaths, stride, metrics);
    private static procedure z_GetPathMetricRangeNV_ovr_2(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr);
    external 'opengl32.dll' name 'glGetPathMetricRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathMetricRangeNV(metricQueryMask: PathMetricMask; firstPathName: UInt32; numPaths: Int32; stride: Int32; metrics: IntPtr) :=
    z_GetPathMetricRangeNV_ovr_2(metricQueryMask, firstPathName, numPaths, stride, metrics);
    
    private static procedure z_GetPathSpacingNV_ovr_0(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; var returnedSpacing: single);
    external 'opengl32.dll' name 'glGetPathSpacingNV';
    private static procedure z_GetPathSpacingNV_ovr_0_anh0000000001(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr);
    external 'opengl32.dll' name 'glGetPathSpacingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: array of single) :=
    if (returnedSpacing<>nil) and (returnedSpacing.Length<>0) then
      z_GetPathSpacingNV_ovr_0(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing[0]) else
      z_GetPathSpacingNV_ovr_0_anh0000000001(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; var returnedSpacing: single) :=
    z_GetPathSpacingNV_ovr_0(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
    private static procedure z_GetPathSpacingNV_ovr_2(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr);
    external 'opengl32.dll' name 'glGetPathSpacingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathSpacingNV(_pathListMode: PathListMode; numPaths: Int32; pathNameType: PathElementType; paths: IntPtr; pathBase: UInt32; advanceScale: single; kerningScale: single; transformType: PathTransformType; returnedSpacing: IntPtr) :=
    z_GetPathSpacingNV_ovr_2(_pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
    
    private static function z_IsPointInFillPathNV_ovr_0(path: UInt32; mask: UInt32; x: single; y: single): boolean;
    external 'opengl32.dll' name 'glIsPointInFillPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPointInFillPathNV(path: UInt32; mask: UInt32; x: single; y: single): boolean :=
    z_IsPointInFillPathNV_ovr_0(path, mask, x, y);
    
    private static function z_IsPointInStrokePathNV_ovr_0(path: UInt32; x: single; y: single): boolean;
    external 'opengl32.dll' name 'glIsPointInStrokePathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsPointInStrokePathNV(path: UInt32; x: single; y: single): boolean :=
    z_IsPointInStrokePathNV_ovr_0(path, x, y);
    
    private static function z_GetPathLengthNV_ovr_0(path: UInt32; startSegment: Int32; numSegments: Int32): single;
    external 'opengl32.dll' name 'glGetPathLengthNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetPathLengthNV(path: UInt32; startSegment: Int32; numSegments: Int32): single :=
    z_GetPathLengthNV_ovr_0(path, startSegment, numSegments);
    
    private static function z_PointAlongPathNV_ovr_0(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000000111(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_0_anh000001111(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: array of single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y[0], tangentX[0], tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x[0], y[0], tangentX[0], IntPtr.Zero) else
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x[0], y[0], IntPtr.Zero, tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000000011(path, startSegment, numSegments, distance, x[0], y[0], IntPtr.Zero, IntPtr.Zero) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX[0], tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000000101(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX[0], IntPtr.Zero) else
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000000110(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, IntPtr.Zero, tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000000111(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX[0], tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX[0], IntPtr.Zero) else
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], IntPtr.Zero, tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000001011(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], IntPtr.Zero, IntPtr.Zero) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX[0], tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000001101(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX[0], IntPtr.Zero) else
          if (tangentY<>nil) and (tangentY.Length<>0) then
            z_PointAlongPathNV_ovr_0_anh000001110(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, tangentY[0]) else
            z_PointAlongPathNV_ovr_0_anh000001111(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_1_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_1_anh000001110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: array of single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y[0], tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x[0], y[0], IntPtr.Zero, tangentY) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_0_anh000000110(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, IntPtr.Zero, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_0_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], IntPtr.Zero, tangentY) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_0_anh000001110(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_2(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_2_anh000001110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x[0], y[0], tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_2_anh000000010(path, startSegment, numSegments, distance, x[0], y[0], IntPtr.Zero, tangentY) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_2_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_2_anh000000110(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, IntPtr.Zero, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_2_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_2_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], IntPtr.Zero, tangentY) else
        if (tangentX<>nil) and (tangentX.Length<>0) then
          z_PointAlongPathNV_ovr_2_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX[0], tangentY) else
          z_PointAlongPathNV_ovr_2_anh000001110(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_3_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_3_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_3_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_3_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_3_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_3_anh000001101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; var tangentX: single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x[0], y[0], tangentX, IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000101(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000001101(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_4_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_4_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_4_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; var tangentX: single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_0_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_5_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_5_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_5_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; var tangentX: single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_2_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_2_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_2_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_6(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_6_anh000001101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_6_anh000000001(path, startSegment, numSegments, distance, x[0], y[0], tangentX, IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_6_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_6_anh000000101(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, IntPtr.Zero) else
      if (y<>nil) and (y.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_6_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_6_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_6_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY[0]) else
          z_PointAlongPathNV_ovr_6_anh000001101(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_7_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_7_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_7_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: IntPtr; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_6_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_6_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_6_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_8(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_8_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_8_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_8_anh000001100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: array of single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_8(path, startSegment, numSegments, distance, x[0], y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_8_anh000000100(path, startSegment, numSegments, distance, x[0], IntPtr.Zero, tangentX, tangentY) else
      if (y<>nil) and (y.Length<>0) then
        z_PointAlongPathNV_ovr_8_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y[0], tangentX, tangentY) else
        z_PointAlongPathNV_ovr_8_anh000001100(path, startSegment, numSegments, distance, IntPtr.Zero, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_9_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_9_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_9_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_9_anh000001011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: array of single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000011(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, IntPtr.Zero) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000001011(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_10_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_10_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: array of single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_0_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_11_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_11_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_2_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_2_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_2_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_12_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_12_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; var tangentX: single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_13_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; var tangentX: single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_0_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_14_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; var tangentX: single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_2_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_15_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_15_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_6_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_6_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_6_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_16_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: IntPtr; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_6_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_17_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_8(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_8_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_18(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000000011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_18_anh000001011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: array of single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_18_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_18_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_18_anh000000011(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, IntPtr.Zero) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_18_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_18_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_18_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_18_anh000001011(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_19_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_19_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_19_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: array of single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_18_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_18_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_18_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_20(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_20_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_20_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_20_anh000001010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_20(path, startSegment, numSegments, distance, x[0], y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_20_anh000000010(path, startSegment, numSegments, distance, x[0], y, IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_20_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_20_anh000001010(path, startSegment, numSegments, distance, IntPtr.Zero, y, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_21_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_21_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; var tangentX: single; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_18_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_18_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_18_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_22_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; var tangentX: single; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_18_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_23_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_20(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_20_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_24(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_24_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_24_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_24_anh000001001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_24(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_24_anh000000001(path, startSegment, numSegments, distance, x[0], y, tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_24_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_24_anh000001001(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_25_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_24(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_24_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_26(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_26_anh000001000(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: array of single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    if (x<>nil) and (x.Length<>0) then
      z_PointAlongPathNV_ovr_26(path, startSegment, numSegments, distance, x[0], y, tangentX, tangentY) else
      z_PointAlongPathNV_ovr_26_anh000001000(path, startSegment, numSegments, distance, IntPtr.Zero, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: array of single; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000011(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, IntPtr.Zero) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_0_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_0_anh000000111(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: array of single; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_0_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_2_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_2_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_2_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; var tangentX: single; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; var tangentX: single; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_0_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; var tangentX: single; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_2_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_6_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_6_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_6_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: IntPtr; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_6_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: array of single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_8(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_8_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: array of single; tangentY: array of single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX[0], IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY[0]) else
        z_PointAlongPathNV_ovr_0_anh000000011(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: array of single; var tangentY: single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_0_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_2_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_0_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_0(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_2(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_6_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_6(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_8(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: array of single; tangentY: array of single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY[0]) else
        z_PointAlongPathNV_ovr_18_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX[0], IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_18_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY[0]) else
        z_PointAlongPathNV_ovr_18_anh000000011(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: array of single; var tangentY: single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_18_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_20(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_20_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_18_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_18(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_20(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_24(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_24_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_24(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; var x: single; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_26(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_54(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_54_anh000000111(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: array of single; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_54_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_54_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_54_anh000000011(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, IntPtr.Zero) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_54_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY[0]) else
          z_PointAlongPathNV_ovr_54_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], IntPtr.Zero) else
        if (tangentY<>nil) and (tangentY.Length<>0) then
          z_PointAlongPathNV_ovr_54_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY[0]) else
          z_PointAlongPathNV_ovr_54_anh000000111(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_55_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_55_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_55_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: array of single; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_54_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_54_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_54_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_56(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_56_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_56_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_56_anh000000110(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_56(path, startSegment, numSegments, distance, x, y[0], tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_56_anh000000010(path, startSegment, numSegments, distance, x, y[0], IntPtr.Zero, tangentY) else
      if (tangentX<>nil) and (tangentX.Length<>0) then
        z_PointAlongPathNV_ovr_56_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX[0], tangentY) else
        z_PointAlongPathNV_ovr_56_anh000000110(path, startSegment, numSegments, distance, x, IntPtr.Zero, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_57_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_57_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; var tangentX: single; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_54_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_54_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_54_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_58_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; var tangentX: single; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_54_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_59_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; var tangentX: single; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_56(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_56_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_60(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_60_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_60_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_60_anh000000101(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_60(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_60_anh000000001(path, startSegment, numSegments, distance, x, y[0], tangentX, IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_60_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY[0]) else
        z_PointAlongPathNV_ovr_60_anh000000101(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_61_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: IntPtr; var tangentY: single): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_60(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_60_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_62(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_62_anh000000100(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: array of single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    if (y<>nil) and (y.Length<>0) then
      z_PointAlongPathNV_ovr_62(path, startSegment, numSegments, distance, x, y[0], tangentX, tangentY) else
      z_PointAlongPathNV_ovr_62_anh000000100(path, startSegment, numSegments, distance, x, IntPtr.Zero, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: array of single; tangentY: array of single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY[0]) else
        z_PointAlongPathNV_ovr_54_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX[0], IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_54_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY[0]) else
        z_PointAlongPathNV_ovr_54_anh000000011(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: array of single; var tangentY: single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_54_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_56(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_56_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_54_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_54(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_56(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_60(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_60_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_60(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; var y: single; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_62(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_72(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_72_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_72_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_72_anh000000011(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: array of single; tangentY: array of single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_72(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY[0]) else
        z_PointAlongPathNV_ovr_72_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX[0], IntPtr.Zero) else
      if (tangentY<>nil) and (tangentY.Length<>0) then
        z_PointAlongPathNV_ovr_72_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY[0]) else
        z_PointAlongPathNV_ovr_72_anh000000011(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, IntPtr.Zero);
    private static function z_PointAlongPathNV_ovr_73_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: array of single; var tangentY: single): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_72(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_72_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    private static function z_PointAlongPathNV_ovr_74(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_74_anh000000010(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: array of single; tangentY: IntPtr): boolean :=
    if (tangentX<>nil) and (tangentX.Length<>0) then
      z_PointAlongPathNV_ovr_74(path, startSegment, numSegments, distance, x, y, tangentX[0], tangentY) else
      z_PointAlongPathNV_ovr_74_anh000000010(path, startSegment, numSegments, distance, x, y, IntPtr.Zero, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_72(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_72_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_72(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; var tangentX: single; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_74(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_78(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    private static function z_PointAlongPathNV_ovr_78_anh000000001(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: array of single): boolean :=
    if (tangentY<>nil) and (tangentY.Length<>0) then
      z_PointAlongPathNV_ovr_78(path, startSegment, numSegments, distance, x, y, tangentX, tangentY[0]) else
      z_PointAlongPathNV_ovr_78_anh000000001(path, startSegment, numSegments, distance, x, y, tangentX, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; var tangentY: single): boolean :=
    z_PointAlongPathNV_ovr_78(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    private static function z_PointAlongPathNV_ovr_80(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean;
    external 'opengl32.dll' name 'glPointAlongPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PointAlongPathNV(path: UInt32; startSegment: Int32; numSegments: Int32; distance: single; x: IntPtr; y: IntPtr; tangentX: IntPtr; tangentY: IntPtr): boolean :=
    z_PointAlongPathNV_ovr_80(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
    
    private static procedure z_MatrixLoad3x2fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixLoad3x2fNV';
    private static procedure z_MatrixLoad3x2fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoad3x2fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoad3x2fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoad3x2fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoad3x2fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixLoad3x2fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoad3x2fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x2fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoad3x2fNV_ovr_2(matrixMode, m);
    
    private static procedure z_MatrixLoad3x3fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixLoad3x3fNV';
    private static procedure z_MatrixLoad3x3fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoad3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoad3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoad3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoad3x3fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixLoad3x3fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoad3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoad3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoad3x3fNV_ovr_2(matrixMode, m);
    
    private static procedure z_MatrixLoadTranspose3x3fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixLoadTranspose3x3fNV';
    private static procedure z_MatrixLoadTranspose3x3fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTranspose3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTranspose3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixLoadTranspose3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixLoadTranspose3x3fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixLoadTranspose3x3fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTranspose3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTranspose3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixLoadTranspose3x3fNV_ovr_2(matrixMode, m);
    
    private static procedure z_MatrixMult3x2fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixMult3x2fNV';
    private static procedure z_MatrixMult3x2fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMult3x2fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMult3x2fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMult3x2fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMult3x2fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixMult3x2fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMult3x2fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x2fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMult3x2fNV_ovr_2(matrixMode, m);
    
    private static procedure z_MatrixMult3x3fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixMult3x3fNV';
    private static procedure z_MatrixMult3x3fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMult3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMult3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMult3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMult3x3fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixMult3x3fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMult3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMult3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMult3x3fNV_ovr_2(matrixMode, m);
    
    private static procedure z_MatrixMultTranspose3x3fNV_ovr_0(matrixMode: DummyEnum; var m: single);
    external 'opengl32.dll' name 'glMatrixMultTranspose3x3fNV';
    private static procedure z_MatrixMultTranspose3x3fNV_ovr_0_anh001(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTranspose3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTranspose3x3fNV_ovr_0(matrixMode, m[0]) else
      z_MatrixMultTranspose3x3fNV_ovr_0_anh001(matrixMode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; var m: single) :=
    z_MatrixMultTranspose3x3fNV_ovr_0(matrixMode, m);
    private static procedure z_MatrixMultTranspose3x3fNV_ovr_2(matrixMode: DummyEnum; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTranspose3x3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTranspose3x3fNV(matrixMode: DummyEnum; m: IntPtr) :=
    z_MatrixMultTranspose3x3fNV_ovr_2(matrixMode, m);
    
    private static procedure z_StencilThenCoverFillPathNV_ovr_0(path: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum);
    external 'opengl32.dll' name 'glStencilThenCoverFillPathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathNV(path: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum) :=
    z_StencilThenCoverFillPathNV_ovr_0(path, fillMode, mask, coverMode);
    
    private static procedure z_StencilThenCoverStrokePathNV_ovr_0(path: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum);
    external 'opengl32.dll' name 'glStencilThenCoverStrokePathNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathNV(path: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum) :=
    z_StencilThenCoverStrokePathNV_ovr_0(path, reference, mask, coverMode);
    
    private static procedure z_StencilThenCoverFillPathInstancedNV_ovr_0(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single);
    external 'opengl32.dll' name 'glStencilThenCoverFillPathInstancedNV';
    private static procedure z_StencilThenCoverFillPathInstancedNV_ovr_0_anh0000000001(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilThenCoverFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilThenCoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues[0]) else
      z_StencilThenCoverFillPathInstancedNV_ovr_0_anh0000000001(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single) :=
    z_StencilThenCoverFillPathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues);
    private static procedure z_StencilThenCoverFillPathInstancedNV_ovr_2(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilThenCoverFillPathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverFillPathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; fillMode: DummyEnum; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr) :=
    z_StencilThenCoverFillPathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, fillMode, mask, coverMode, transformType, transformValues);
    
    private static procedure z_StencilThenCoverStrokePathInstancedNV_ovr_0(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single);
    external 'opengl32.dll' name 'glStencilThenCoverStrokePathInstancedNV';
    private static procedure z_StencilThenCoverStrokePathInstancedNV_ovr_0_anh0000000001(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilThenCoverStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: array of single) :=
    if (transformValues<>nil) and (transformValues.Length<>0) then
      z_StencilThenCoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues[0]) else
      z_StencilThenCoverStrokePathInstancedNV_ovr_0_anh0000000001(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; var transformValues: single) :=
    z_StencilThenCoverStrokePathInstancedNV_ovr_0(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues);
    private static procedure z_StencilThenCoverStrokePathInstancedNV_ovr_2(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr);
    external 'opengl32.dll' name 'glStencilThenCoverStrokePathInstancedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StencilThenCoverStrokePathInstancedNV(numPaths: Int32; pathNameType: DummyEnum; paths: IntPtr; pathBase: UInt32; reference: Int32; mask: UInt32; coverMode: DummyEnum; transformType: DummyEnum; transformValues: IntPtr) :=
    z_StencilThenCoverStrokePathInstancedNV_ovr_2(numPaths, pathNameType, paths, pathBase, reference, mask, coverMode, transformType, transformValues);
    
    private static function z_PathGlyphIndexRangeNV_ovr_0(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: UInt32): DummyEnum;
    external 'opengl32.dll' name 'glPathGlyphIndexRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexRangeNV(fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; pathParameterTemplate: UInt32; emScale: single; baseAndCount: UInt32): DummyEnum :=
    z_PathGlyphIndexRangeNV_ovr_0(fontTarget, fontName, fontStyle, pathParameterTemplate, emScale, baseAndCount);
    
    private static function z_PathGlyphIndexArrayNV_ovr_0(firstPathName: UInt32; fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum;
    external 'opengl32.dll' name 'glPathGlyphIndexArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathGlyphIndexArrayNV(firstPathName: UInt32; fontTarget: DummyEnum; fontName: IntPtr; fontStyle: PathFontStyle; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum :=
    z_PathGlyphIndexArrayNV_ovr_0(firstPathName, fontTarget, fontName, fontStyle, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
    
    private static function z_PathMemoryGlyphIndexArrayNV_ovr_0(firstPathName: UInt32; fontTarget: DummyEnum; fontSize: IntPtr; fontData: IntPtr; faceIndex: Int32; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum;
    external 'opengl32.dll' name 'glPathMemoryGlyphIndexArrayNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PathMemoryGlyphIndexArrayNV(firstPathName: UInt32; fontTarget: DummyEnum; fontSize: IntPtr; fontData: IntPtr; faceIndex: Int32; firstGlyphIndex: UInt32; numGlyphs: Int32; pathParameterTemplate: UInt32; emScale: single): DummyEnum :=
    z_PathMemoryGlyphIndexArrayNV_ovr_0(firstPathName, fontTarget, fontSize, fontData, faceIndex, firstGlyphIndex, numGlyphs, pathParameterTemplate, emScale);
    
    private static procedure z_ProgramPathFragmentInputGenNV_ovr_0(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; var coeffs: single);
    external 'opengl32.dll' name 'glProgramPathFragmentInputGenNV';
    private static procedure z_ProgramPathFragmentInputGenNV_ovr_0_anh000001(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr);
    external 'opengl32.dll' name 'glProgramPathFragmentInputGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_ProgramPathFragmentInputGenNV_ovr_0(&program, location, genMode, components, coeffs[0]) else
      z_ProgramPathFragmentInputGenNV_ovr_0_anh000001(&program, location, genMode, components, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; var coeffs: single) :=
    z_ProgramPathFragmentInputGenNV_ovr_0(&program, location, genMode, components, coeffs);
    private static procedure z_ProgramPathFragmentInputGenNV_ovr_2(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr);
    external 'opengl32.dll' name 'glProgramPathFragmentInputGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramPathFragmentInputGenNV(&program: UInt32; location: Int32; genMode: DummyEnum; components: Int32; coeffs: IntPtr) :=
    z_ProgramPathFragmentInputGenNV_ovr_2(&program, location, genMode, components, coeffs);
    
    private static procedure z_GetProgramResourcefvNV_ovr_0(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000000011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_0_anh000001011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: array of Int32; &params: array of single) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params[0]) else
          z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourcefvNV_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourcefvNV_ovr_0_anh000000011(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, IntPtr.Zero) else
      if (length<>nil) and (length.Length<>0) then
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params[0]) else
          z_GetProgramResourcefvNV_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], IntPtr.Zero) else
        if (&params<>nil) and (&params.Length<>0) then
          z_GetProgramResourcefvNV_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params[0]) else
          z_GetProgramResourcefvNV_ovr_0_anh000001011(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramResourcefvNV_ovr_1_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_1_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_1_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: array of Int32; var &params: single) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourcefvNV_ovr_0_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourcefvNV_ovr_0_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_2(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_2_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_2_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_2_anh000001010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props[0], count, length[0], &params) else
        z_GetProgramResourcefvNV_ovr_2_anh000000010(&program, _programInterface, index, propCount, props[0], count, IntPtr.Zero, &params) else
      if (length<>nil) and (length.Length<>0) then
        z_GetProgramResourcefvNV_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length[0], &params) else
        z_GetProgramResourcefvNV_ovr_2_anh000001010(&program, _programInterface, index, propCount, IntPtr.Zero, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_3_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_3_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; &params: array of single) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private static procedure z_GetProgramResourcefvNV_ovr_4_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; var &params: single) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_0_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_5_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; var length: Int32; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_2_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_6(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_6_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_6_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_6_anh000001001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; &params: array of single) :=
    if (props<>nil) and (props.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_6_anh000000001(&program, _programInterface, index, propCount, props[0], count, length, IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params[0]) else
        z_GetProgramResourcefvNV_ovr_6_anh000001001(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, IntPtr.Zero);
    private static procedure z_GetProgramResourcefvNV_ovr_7_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; var &params: single) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_6(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_6_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_8(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_8_anh000001000(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: array of DummyEnum; count: Int32; length: IntPtr; &params: IntPtr) :=
    if (props<>nil) and (props.Length<>0) then
      z_GetProgramResourcefvNV_ovr_8(&program, _programInterface, index, propCount, props[0], count, length, &params) else
      z_GetProgramResourcefvNV_ovr_8_anh000001000(&program, _programInterface, index, propCount, IntPtr.Zero, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: array of Int32; &params: array of single) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourcefvNV_ovr_0_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: array of Int32; var &params: single) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourcefvNV_ovr_0_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourcefvNV_ovr_2_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_0_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_0(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_2(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_6_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_6(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; var props: DummyEnum; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_8(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_18(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_18_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_18_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_18_anh000000011(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: array of single) :=
    if (length<>nil) and (length.Length<>0) then
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params[0]) else
        z_GetProgramResourcefvNV_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length[0], IntPtr.Zero) else
      if (&params<>nil) and (&params.Length<>0) then
        z_GetProgramResourcefvNV_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params[0]) else
        z_GetProgramResourcefvNV_ovr_18_anh000000011(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_GetProgramResourcefvNV_ovr_19_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; var &params: single) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourcefvNV_ovr_18(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourcefvNV_ovr_18_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_20(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_20_anh000000010(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: array of Int32; &params: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetProgramResourcefvNV_ovr_20(&program, _programInterface, index, propCount, props, count, length[0], &params) else
      z_GetProgramResourcefvNV_ovr_20_anh000000010(&program, _programInterface, index, propCount, props, count, IntPtr.Zero, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_18_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_18(&program, _programInterface, index, propCount, props, count, length, &params);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; var length: Int32; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_20(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_24(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    private static procedure z_GetProgramResourcefvNV_ovr_24_anh000000001(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramResourcefvNV_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params[0]) else
      z_GetProgramResourcefvNV_ovr_24_anh000000001(&program, _programInterface, index, propCount, props, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; var &params: single) :=
    z_GetProgramResourcefvNV_ovr_24(&program, _programInterface, index, propCount, props, count, length, &params);
    private static procedure z_GetProgramResourcefvNV_ovr_26(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramResourcefvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramResourcefvNV(&program: UInt32; _programInterface: ProgramInterface; index: UInt32; propCount: Int32; props: IntPtr; count: Int32; length: IntPtr; &params: IntPtr) :=
    z_GetProgramResourcefvNV_ovr_26(&program, _programInterface, index, propCount, props, count, length, &params);
    
    private static procedure z_PathColorGenNV_ovr_0(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; var coeffs: single);
    external 'opengl32.dll' name 'glPathColorGenNV';
    private static procedure z_PathColorGenNV_ovr_0_anh00001(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr);
    external 'opengl32.dll' name 'glPathColorGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_PathColorGenNV_ovr_0(color, genMode, colorFormat, coeffs[0]) else
      z_PathColorGenNV_ovr_0_anh00001(color, genMode, colorFormat, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; var coeffs: single) :=
    z_PathColorGenNV_ovr_0(color, genMode, colorFormat, coeffs);
    private static procedure z_PathColorGenNV_ovr_2(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr);
    external 'opengl32.dll' name 'glPathColorGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathColorGenNV(color: PathColor; genMode: PathGenMode; colorFormat: PathColorFormat; coeffs: IntPtr) :=
    z_PathColorGenNV_ovr_2(color, genMode, colorFormat, coeffs);
    
    private static procedure z_PathTexGenNV_ovr_0(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; var coeffs: single);
    external 'opengl32.dll' name 'glPathTexGenNV';
    private static procedure z_PathTexGenNV_ovr_0_anh00001(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr);
    external 'opengl32.dll' name 'glPathTexGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: array of single) :=
    if (coeffs<>nil) and (coeffs.Length<>0) then
      z_PathTexGenNV_ovr_0(texCoordSet, genMode, components, coeffs[0]) else
      z_PathTexGenNV_ovr_0_anh00001(texCoordSet, genMode, components, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; var coeffs: single) :=
    z_PathTexGenNV_ovr_0(texCoordSet, genMode, components, coeffs);
    private static procedure z_PathTexGenNV_ovr_2(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr);
    external 'opengl32.dll' name 'glPathTexGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathTexGenNV(texCoordSet: PathColor; genMode: PathGenMode; components: Int32; coeffs: IntPtr) :=
    z_PathTexGenNV_ovr_2(texCoordSet, genMode, components, coeffs);
    
    private static procedure z_PathFogGenNV_ovr_0(genMode: PathGenMode);
    external 'opengl32.dll' name 'glPathFogGenNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PathFogGenNV(genMode: PathGenMode) :=
    z_PathFogGenNV_ovr_0(genMode);
    
    private static procedure z_GetPathColorGenivNV_ovr_0(color: PathColor; pname: PathGenMode; var value: Int32);
    external 'opengl32.dll' name 'glGetPathColorGenivNV';
    private static procedure z_GetPathColorGenivNV_ovr_0_anh0001(color: PathColor; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathColorGenivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathColorGenivNV_ovr_0(color, pname, value[0]) else
      z_GetPathColorGenivNV_ovr_0_anh0001(color, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; var value: Int32) :=
    z_GetPathColorGenivNV_ovr_0(color, pname, value);
    private static procedure z_GetPathColorGenivNV_ovr_2(color: PathColor; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathColorGenivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenivNV(color: PathColor; pname: PathGenMode; value: IntPtr) :=
    z_GetPathColorGenivNV_ovr_2(color, pname, value);
    
    private static procedure z_GetPathColorGenfvNV_ovr_0(color: PathColor; pname: PathGenMode; var value: single);
    external 'opengl32.dll' name 'glGetPathColorGenfvNV';
    private static procedure z_GetPathColorGenfvNV_ovr_0_anh0001(color: PathColor; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathColorGenfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathColorGenfvNV_ovr_0(color, pname, value[0]) else
      z_GetPathColorGenfvNV_ovr_0_anh0001(color, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; var value: single) :=
    z_GetPathColorGenfvNV_ovr_0(color, pname, value);
    private static procedure z_GetPathColorGenfvNV_ovr_2(color: PathColor; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathColorGenfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathColorGenfvNV(color: PathColor; pname: PathGenMode; value: IntPtr) :=
    z_GetPathColorGenfvNV_ovr_2(color, pname, value);
    
    private static procedure z_GetPathTexGenivNV_ovr_0(texCoordSet: TextureUnit; pname: PathGenMode; var value: Int32);
    external 'opengl32.dll' name 'glGetPathTexGenivNV';
    private static procedure z_GetPathTexGenivNV_ovr_0_anh0001(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathTexGenivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; value: array of Int32) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathTexGenivNV_ovr_0(texCoordSet, pname, value[0]) else
      z_GetPathTexGenivNV_ovr_0_anh0001(texCoordSet, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; var value: Int32) :=
    z_GetPathTexGenivNV_ovr_0(texCoordSet, pname, value);
    private static procedure z_GetPathTexGenivNV_ovr_2(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathTexGenivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenivNV(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr) :=
    z_GetPathTexGenivNV_ovr_2(texCoordSet, pname, value);
    
    private static procedure z_GetPathTexGenfvNV_ovr_0(texCoordSet: TextureUnit; pname: PathGenMode; var value: single);
    external 'opengl32.dll' name 'glGetPathTexGenfvNV';
    private static procedure z_GetPathTexGenfvNV_ovr_0_anh0001(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathTexGenfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; value: array of single) :=
    if (value<>nil) and (value.Length<>0) then
      z_GetPathTexGenfvNV_ovr_0(texCoordSet, pname, value[0]) else
      z_GetPathTexGenfvNV_ovr_0_anh0001(texCoordSet, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; var value: single) :=
    z_GetPathTexGenfvNV_ovr_0(texCoordSet, pname, value);
    private static procedure z_GetPathTexGenfvNV_ovr_2(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr);
    external 'opengl32.dll' name 'glGetPathTexGenfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPathTexGenfvNV(texCoordSet: TextureUnit; pname: PathGenMode; value: IntPtr) :=
    z_GetPathTexGenfvNV_ovr_2(texCoordSet, pname, value);
    
    private static procedure z_MatrixFrustumEXT_ovr_0(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glMatrixFrustumEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixFrustumEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixFrustumEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private static procedure z_MatrixLoadIdentityEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixLoadIdentityEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadIdentityEXT(mode: MatrixMode) :=
    z_MatrixLoadIdentityEXT_ovr_0(mode);
    
    private static procedure z_MatrixLoadTransposefEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    private static procedure z_MatrixLoadTransposefEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadTransposefEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadTransposefEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposefEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoadTransposedEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    private static procedure z_MatrixLoadTransposedEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoadTransposedEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadTransposedEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadTransposedEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoadfEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    private static procedure z_MatrixLoadfEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoadfEXT_ovr_0(mode, m[0]) else
      z_MatrixLoadfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixLoadfEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoadfEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoadfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoadfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoadfEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixLoaddEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    private static procedure z_MatrixLoaddEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixLoaddEXT_ovr_0(mode, m[0]) else
      z_MatrixLoaddEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; var m: real) :=
    z_MatrixLoaddEXT_ovr_0(mode, m);
    private static procedure z_MatrixLoaddEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixLoaddEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixLoaddEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixLoaddEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultTransposefEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    private static procedure z_MatrixMultTransposefEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposefEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposefEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultTransposefEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultTransposefEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposefEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposefEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultTransposedEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    private static procedure z_MatrixMultTransposedEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultTransposedEXT_ovr_0(mode, m[0]) else
      z_MatrixMultTransposedEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultTransposedEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultTransposedEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultTransposedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultTransposedEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultTransposedEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultfEXT_ovr_0(mode: MatrixMode; var m: single);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    private static procedure z_MatrixMultfEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: array of single) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultfEXT_ovr_0(mode, m[0]) else
      z_MatrixMultfEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; var m: single) :=
    z_MatrixMultfEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultfEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultfEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultfEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultfEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixMultdEXT_ovr_0(mode: MatrixMode; var m: real);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    private static procedure z_MatrixMultdEXT_ovr_0_anh001(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: array of real) :=
    if (m<>nil) and (m.Length<>0) then
      z_MatrixMultdEXT_ovr_0(mode, m[0]) else
      z_MatrixMultdEXT_ovr_0_anh001(mode, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; var m: real) :=
    z_MatrixMultdEXT_ovr_0(mode, m);
    private static procedure z_MatrixMultdEXT_ovr_2(mode: MatrixMode; m: IntPtr);
    external 'opengl32.dll' name 'glMatrixMultdEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixMultdEXT(mode: MatrixMode; m: IntPtr) :=
    z_MatrixMultdEXT_ovr_2(mode, m);
    
    private static procedure z_MatrixOrthoEXT_ovr_0(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real);
    external 'opengl32.dll' name 'glMatrixOrthoEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixOrthoEXT(mode: MatrixMode; left: real; right: real; bottom: real; top: real; zNear: real; zFar: real) :=
    z_MatrixOrthoEXT_ovr_0(mode, left, right, bottom, top, zNear, zFar);
    
    private static procedure z_MatrixPopEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixPopEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPopEXT(mode: MatrixMode) :=
    z_MatrixPopEXT_ovr_0(mode);
    
    private static procedure z_MatrixPushEXT_ovr_0(mode: MatrixMode);
    external 'opengl32.dll' name 'glMatrixPushEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixPushEXT(mode: MatrixMode) :=
    z_MatrixPushEXT_ovr_0(mode);
    
    private static procedure z_MatrixRotatefEXT_ovr_0(mode: MatrixMode; angle: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixRotatefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatefEXT(mode: MatrixMode; angle: single; x: single; y: single; z: single) :=
    z_MatrixRotatefEXT_ovr_0(mode, angle, x, y, z);
    
    private static procedure z_MatrixRotatedEXT_ovr_0(mode: MatrixMode; angle: real; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixRotatedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixRotatedEXT(mode: MatrixMode; angle: real; x: real; y: real; z: real) :=
    z_MatrixRotatedEXT_ovr_0(mode, angle, x, y, z);
    
    private static procedure z_MatrixScalefEXT_ovr_0(mode: MatrixMode; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixScalefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScalefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixScalefEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixScaledEXT_ovr_0(mode: MatrixMode; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixScaledEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixScaledEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixScaledEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixTranslatefEXT_ovr_0(mode: MatrixMode; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glMatrixTranslatefEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatefEXT(mode: MatrixMode; x: single; y: single; z: single) :=
    z_MatrixTranslatefEXT_ovr_0(mode, x, y, z);
    
    private static procedure z_MatrixTranslatedEXT_ovr_0(mode: MatrixMode; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glMatrixTranslatedEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MatrixTranslatedEXT(mode: MatrixMode; x: real; y: real; z: real) :=
    z_MatrixTranslatedEXT_ovr_0(mode, x, y, z);
    
  end;
  
  glPixelDataRangeNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PixelDataRangeNV_ovr_0(target: PixelDataRangeTargetNV; length: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glPixelDataRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelDataRangeNV(target: PixelDataRangeTargetNV; length: Int32; pointer: IntPtr) :=
    z_PixelDataRangeNV_ovr_0(target, length, pointer);
    
    private static procedure z_FlushPixelDataRangeNV_ovr_0(target: PixelDataRangeTargetNV);
    external 'opengl32.dll' name 'glFlushPixelDataRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushPixelDataRangeNV(target: PixelDataRangeTargetNV) :=
    z_FlushPixelDataRangeNV_ovr_0(target);
    
  end;
  
  glPointSpriteNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PointParameteriNV_ovr_0(pname: PointParameterNameARB; param: Int32);
    external 'opengl32.dll' name 'glPointParameteriNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameteriNV(pname: PointParameterNameARB; param: Int32) :=
    z_PointParameteriNV_ovr_0(pname, param);
    
    private static procedure z_PointParameterivNV_ovr_0(pname: PointParameterNameARB; var &params: Int32);
    external 'opengl32.dll' name 'glPointParameterivNV';
    private static procedure z_PointParameterivNV_ovr_0_anh001(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterivNV_ovr_0(pname, &params[0]) else
      z_PointParameterivNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; var &params: Int32) :=
    z_PointParameterivNV_ovr_0(pname, &params);
    private static procedure z_PointParameterivNV_ovr_2(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterivNV(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterivNV_ovr_2(pname, &params);
    
  end;
  
  glPresentVideoNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PresentFrameKeyedNV_ovr_0(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; key0: UInt32; target1: DummyEnum; fill1: UInt32; key1: UInt32);
    external 'opengl32.dll' name 'glPresentFrameKeyedNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PresentFrameKeyedNV(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; key0: UInt32; target1: DummyEnum; fill1: UInt32; key1: UInt32) :=
    z_PresentFrameKeyedNV_ovr_0(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, &type, target0, fill0, key0, target1, fill1, key1);
    
    private static procedure z_PresentFrameDualFillNV_ovr_0(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; target1: DummyEnum; fill1: UInt32; target2: DummyEnum; fill2: UInt32; target3: DummyEnum; fill3: UInt32);
    external 'opengl32.dll' name 'glPresentFrameDualFillNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PresentFrameDualFillNV(video_slot: UInt32; minPresentTime: UInt64; beginPresentTimeId: UInt32; presentDurationId: UInt32; &type: DummyEnum; target0: DummyEnum; fill0: UInt32; target1: DummyEnum; fill1: UInt32; target2: DummyEnum; fill2: UInt32; target3: DummyEnum; fill3: UInt32) :=
    z_PresentFrameDualFillNV_ovr_0(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, &type, target0, fill0, target1, fill1, target2, fill2, target3, fill3);
    
    private static procedure z_GetVideoivNV_ovr_0(video_slot: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetVideoivNV';
    private static procedure z_GetVideoivNV_ovr_0_anh0001(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoivNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoivNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoivNV_ovr_0(video_slot, pname, &params);
    private static procedure z_GetVideoivNV_ovr_2(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoivNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoivNV_ovr_2(video_slot, pname, &params);
    
    private static procedure z_GetVideouivNV_ovr_0(video_slot: UInt32; pname: DummyEnum; var &params: UInt32);
    external 'opengl32.dll' name 'glGetVideouivNV';
    private static procedure z_GetVideouivNV_ovr_0_anh0001(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideouivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideouivNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideouivNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; var &params: UInt32) :=
    z_GetVideouivNV_ovr_0(video_slot, pname, &params);
    private static procedure z_GetVideouivNV_ovr_2(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideouivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideouivNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideouivNV_ovr_2(video_slot, pname, &params);
    
    private static procedure z_GetVideoi64vNV_ovr_0(video_slot: UInt32; pname: DummyEnum; var &params: Int64);
    external 'opengl32.dll' name 'glGetVideoi64vNV';
    private static procedure z_GetVideoi64vNV_ovr_0_anh0001(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoi64vNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoi64vNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; var &params: Int64) :=
    z_GetVideoi64vNV_ovr_0(video_slot, pname, &params);
    private static procedure z_GetVideoi64vNV_ovr_2(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoi64vNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoi64vNV_ovr_2(video_slot, pname, &params);
    
    private static procedure z_GetVideoui64vNV_ovr_0(video_slot: UInt32; pname: DummyEnum; var &params: UInt64);
    external 'opengl32.dll' name 'glGetVideoui64vNV';
    private static procedure z_GetVideoui64vNV_ovr_0_anh0001(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoui64vNV_ovr_0(video_slot, pname, &params[0]) else
      z_GetVideoui64vNV_ovr_0_anh0001(video_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; var &params: UInt64) :=
    z_GetVideoui64vNV_ovr_0(video_slot, pname, &params);
    private static procedure z_GetVideoui64vNV_ovr_2(video_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoui64vNV(video_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoui64vNV_ovr_2(video_slot, pname, &params);
    
  end;
  
  glPrimitiveRestartNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PrimitiveRestartNV_ovr_0;
    external 'opengl32.dll' name 'glPrimitiveRestartNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartNV :=
    z_PrimitiveRestartNV_ovr_0;
    
    private static procedure z_PrimitiveRestartIndexNV_ovr_0(index: UInt32);
    external 'opengl32.dll' name 'glPrimitiveRestartIndexNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrimitiveRestartIndexNV(index: UInt32) :=
    z_PrimitiveRestartIndexNV_ovr_0(index);
    
  end;
  
  glQueryResourceNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_QueryResourceNV_ovr_0(queryType: DummyEnum; tagId: Int32; count: UInt32; var buffer: Int32): Int32;
    external 'opengl32.dll' name 'glQueryResourceNV';
    private static function z_QueryResourceNV_ovr_0_anh00001(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32;
    external 'opengl32.dll' name 'glQueryResourceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: array of Int32): Int32 :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_QueryResourceNV_ovr_0(queryType, tagId, count, buffer[0]) else
      z_QueryResourceNV_ovr_0_anh00001(queryType, tagId, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; var buffer: Int32): Int32 :=
    z_QueryResourceNV_ovr_0(queryType, tagId, count, buffer);
    private static function z_QueryResourceNV_ovr_2(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32;
    external 'opengl32.dll' name 'glQueryResourceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryResourceNV(queryType: DummyEnum; tagId: Int32; count: UInt32; buffer: IntPtr): Int32 :=
    z_QueryResourceNV_ovr_2(queryType, tagId, count, buffer);
    
  end;
  
  glQueryResourceTagNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GenQueryResourceTagNV_ovr_0(n: Int32; var tagIds: Int32);
    external 'opengl32.dll' name 'glGenQueryResourceTagNV';
    private static procedure z_GenQueryResourceTagNV_ovr_0_anh001(n: Int32; tagIds: IntPtr);
    external 'opengl32.dll' name 'glGenQueryResourceTagNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; tagIds: array of Int32) :=
    if (tagIds<>nil) and (tagIds.Length<>0) then
      z_GenQueryResourceTagNV_ovr_0(n, tagIds[0]) else
      z_GenQueryResourceTagNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; var tagIds: Int32) :=
    z_GenQueryResourceTagNV_ovr_0(n, tagIds);
    private static procedure z_GenQueryResourceTagNV_ovr_2(n: Int32; tagIds: IntPtr);
    external 'opengl32.dll' name 'glGenQueryResourceTagNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenQueryResourceTagNV(n: Int32; tagIds: IntPtr) :=
    z_GenQueryResourceTagNV_ovr_2(n, tagIds);
    
    private static procedure z_DeleteQueryResourceTagNV_ovr_0(n: Int32; var tagIds: Int32);
    external 'opengl32.dll' name 'glDeleteQueryResourceTagNV';
    private static procedure z_DeleteQueryResourceTagNV_ovr_0_anh001(n: Int32; tagIds: IntPtr);
    external 'opengl32.dll' name 'glDeleteQueryResourceTagNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; tagIds: array of Int32) :=
    if (tagIds<>nil) and (tagIds.Length<>0) then
      z_DeleteQueryResourceTagNV_ovr_0(n, tagIds[0]) else
      z_DeleteQueryResourceTagNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; var tagIds: Int32) :=
    z_DeleteQueryResourceTagNV_ovr_0(n, tagIds);
    private static procedure z_DeleteQueryResourceTagNV_ovr_2(n: Int32; tagIds: IntPtr);
    external 'opengl32.dll' name 'glDeleteQueryResourceTagNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteQueryResourceTagNV(n: Int32; tagIds: IntPtr) :=
    z_DeleteQueryResourceTagNV_ovr_2(n, tagIds);
    
    private static procedure z_QueryResourceTagNV_ovr_0(tagId: Int32; tagString: IntPtr);
    external 'opengl32.dll' name 'glQueryResourceTagNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryResourceTagNV(tagId: Int32; tagString: string);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(tagString);
      z_QueryResourceTagNV_ovr_0(tagId, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure QueryResourceTagNV(tagId: Int32; tagString: IntPtr) :=
    z_QueryResourceTagNV_ovr_0(tagId, tagString);
    
  end;
  
  glRegisterCombinersNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CombinerParameterfvNV_ovr_0(pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glCombinerParameterfvNV';
    private static procedure z_CombinerParameterfvNV_ovr_0_anh001(pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerParameterfvNV_ovr_0(pname, &params[0]) else
      z_CombinerParameterfvNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; var &params: single) :=
    z_CombinerParameterfvNV_ovr_0(pname, &params);
    private static procedure z_CombinerParameterfvNV_ovr_2(pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfvNV(pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerParameterfvNV_ovr_2(pname, &params);
    
    private static procedure z_CombinerParameterfNV_ovr_0(pname: CombinerParameterNV; param: single);
    external 'opengl32.dll' name 'glCombinerParameterfNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterfNV(pname: CombinerParameterNV; param: single) :=
    z_CombinerParameterfNV_ovr_0(pname, param);
    
    private static procedure z_CombinerParameterivNV_ovr_0(pname: CombinerParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glCombinerParameterivNV';
    private static procedure z_CombinerParameterivNV_ovr_0_anh001(pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerParameterivNV_ovr_0(pname, &params[0]) else
      z_CombinerParameterivNV_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; var &params: Int32) :=
    z_CombinerParameterivNV_ovr_0(pname, &params);
    private static procedure z_CombinerParameterivNV_ovr_2(pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameterivNV(pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerParameterivNV_ovr_2(pname, &params);
    
    private static procedure z_CombinerParameteriNV_ovr_0(pname: CombinerParameterNV; param: Int32);
    external 'opengl32.dll' name 'glCombinerParameteriNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerParameteriNV(pname: CombinerParameterNV; param: Int32) :=
    z_CombinerParameteriNV_ovr_0(pname, param);
    
    private static procedure z_CombinerInputNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV);
    external 'opengl32.dll' name 'glCombinerInputNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerInputNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV) :=
    z_CombinerInputNV_ovr_0(stage, portion, variable, input, mapping, componentUsage);
    
    private static procedure z_CombinerOutputNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; abOutput: CombinerRegisterNV; cdOutput: CombinerRegisterNV; sumOutput: CombinerRegisterNV; scale: CombinerScaleNV; bias: CombinerBiasNV; abDotProduct: boolean; cdDotProduct: boolean; muxSum: boolean);
    external 'opengl32.dll' name 'glCombinerOutputNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerOutputNV(stage: CombinerStageNV; portion: CombinerPortionNV; abOutput: CombinerRegisterNV; cdOutput: CombinerRegisterNV; sumOutput: CombinerRegisterNV; scale: CombinerScaleNV; bias: CombinerBiasNV; abDotProduct: boolean; cdDotProduct: boolean; muxSum: boolean) :=
    z_CombinerOutputNV_ovr_0(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
    
    private static procedure z_FinalCombinerInputNV_ovr_0(variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV);
    external 'opengl32.dll' name 'glFinalCombinerInputNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinalCombinerInputNV(variable: CombinerVariableNV; input: CombinerRegisterNV; mapping: CombinerMappingNV; componentUsage: CombinerComponentUsageNV) :=
    z_FinalCombinerInputNV_ovr_0(variable, input, mapping, componentUsage);
    
    private static procedure z_GetCombinerInputParameterfvNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetCombinerInputParameterfvNV';
    private static procedure z_GetCombinerInputParameterfvNV_ovr_0_anh000001(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerInputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerInputParameterfvNV_ovr_0(stage, portion, variable, pname, &params[0]) else
      z_GetCombinerInputParameterfvNV_ovr_0_anh000001(stage, portion, variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerInputParameterfvNV_ovr_0(stage, portion, variable, pname, &params);
    private static procedure z_GetCombinerInputParameterfvNV_ovr_2(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerInputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerInputParameterfvNV_ovr_2(stage, portion, variable, pname, &params);
    
    private static procedure z_GetCombinerInputParameterivNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetCombinerInputParameterivNV';
    private static procedure z_GetCombinerInputParameterivNV_ovr_0_anh000001(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerInputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerInputParameterivNV_ovr_0(stage, portion, variable, pname, &params[0]) else
      z_GetCombinerInputParameterivNV_ovr_0_anh000001(stage, portion, variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetCombinerInputParameterivNV_ovr_0(stage, portion, variable, pname, &params);
    private static procedure z_GetCombinerInputParameterivNV_ovr_2(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerInputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerInputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerInputParameterivNV_ovr_2(stage, portion, variable, pname, &params);
    
    private static procedure z_GetCombinerOutputParameterfvNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterfvNV';
    private static procedure z_GetCombinerOutputParameterfvNV_ovr_0_anh00001(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerOutputParameterfvNV_ovr_0(stage, portion, pname, &params[0]) else
      z_GetCombinerOutputParameterfvNV_ovr_0_anh00001(stage, portion, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerOutputParameterfvNV_ovr_0(stage, portion, pname, &params);
    private static procedure z_GetCombinerOutputParameterfvNV_ovr_2(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterfvNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerOutputParameterfvNV_ovr_2(stage, portion, pname, &params);
    
    private static procedure z_GetCombinerOutputParameterivNV_ovr_0(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterivNV';
    private static procedure z_GetCombinerOutputParameterivNV_ovr_0_anh00001(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerOutputParameterivNV_ovr_0(stage, portion, pname, &params[0]) else
      z_GetCombinerOutputParameterivNV_ovr_0_anh00001(stage, portion, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetCombinerOutputParameterivNV_ovr_0(stage, portion, pname, &params);
    private static procedure z_GetCombinerOutputParameterivNV_ovr_2(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerOutputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerOutputParameterivNV(stage: CombinerStageNV; portion: CombinerPortionNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerOutputParameterivNV_ovr_2(stage, portion, pname, &params);
    
    private static procedure z_GetFinalCombinerInputParameterfvNV_ovr_0(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterfvNV';
    private static procedure z_GetFinalCombinerInputParameterfvNV_ovr_0_anh0001(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFinalCombinerInputParameterfvNV_ovr_0(variable, pname, &params[0]) else
      z_GetFinalCombinerInputParameterfvNV_ovr_0_anh0001(variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetFinalCombinerInputParameterfvNV_ovr_0(variable, pname, &params);
    private static procedure z_GetFinalCombinerInputParameterfvNV_ovr_2(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterfvNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetFinalCombinerInputParameterfvNV_ovr_2(variable, pname, &params);
    
    private static procedure z_GetFinalCombinerInputParameterivNV_ovr_0(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterivNV';
    private static procedure z_GetFinalCombinerInputParameterivNV_ovr_0_anh0001(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFinalCombinerInputParameterivNV_ovr_0(variable, pname, &params[0]) else
      z_GetFinalCombinerInputParameterivNV_ovr_0_anh0001(variable, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; var &params: Int32) :=
    z_GetFinalCombinerInputParameterivNV_ovr_0(variable, pname, &params);
    private static procedure z_GetFinalCombinerInputParameterivNV_ovr_2(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFinalCombinerInputParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFinalCombinerInputParameterivNV(variable: CombinerVariableNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetFinalCombinerInputParameterivNV_ovr_2(variable, pname, &params);
    
  end;
  
  glRegisterCombiners2NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_CombinerStageParameterfvNV_ovr_0(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glCombinerStageParameterfvNV';
    private static procedure z_CombinerStageParameterfvNV_ovr_0_anh0001(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerStageParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_CombinerStageParameterfvNV_ovr_0(stage, pname, &params[0]) else
      z_CombinerStageParameterfvNV_ovr_0_anh0001(stage, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single) :=
    z_CombinerStageParameterfvNV_ovr_0(stage, pname, &params);
    private static procedure z_CombinerStageParameterfvNV_ovr_2(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glCombinerStageParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_CombinerStageParameterfvNV_ovr_2(stage, pname, &params);
    
    private static procedure z_GetCombinerStageParameterfvNV_ovr_0(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single);
    external 'opengl32.dll' name 'glGetCombinerStageParameterfvNV';
    private static procedure z_GetCombinerStageParameterfvNV_ovr_0_anh0001(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerStageParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetCombinerStageParameterfvNV_ovr_0(stage, pname, &params[0]) else
      z_GetCombinerStageParameterfvNV_ovr_0_anh0001(stage, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; var &params: single) :=
    z_GetCombinerStageParameterfvNV_ovr_0(stage, pname, &params);
    private static procedure z_GetCombinerStageParameterfvNV_ovr_2(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetCombinerStageParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetCombinerStageParameterfvNV(stage: CombinerStageNV; pname: CombinerParameterNV; &params: IntPtr) :=
    z_GetCombinerStageParameterfvNV_ovr_2(stage, pname, &params);
    
  end;
  
  glSampleLocationsNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferSampleLocationsfvNV_ovr_0(target: FramebufferTarget; start: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvNV';
    private static procedure z_FramebufferSampleLocationsfvNV_ovr_0_anh00001(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_FramebufferSampleLocationsfvNV_ovr_0(target, start, count, v[0]) else
      z_FramebufferSampleLocationsfvNV_ovr_0_anh00001(target, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; var v: single) :=
    z_FramebufferSampleLocationsfvNV_ovr_0(target, start, count, v);
    private static procedure z_FramebufferSampleLocationsfvNV_ovr_2(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferSampleLocationsfvNV(target: FramebufferTarget; start: UInt32; count: Int32; v: IntPtr) :=
    z_FramebufferSampleLocationsfvNV_ovr_2(target, start, count, v);
    
    private static procedure z_NamedFramebufferSampleLocationsfvNV_ovr_0(framebuffer: UInt32; start: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvNV';
    private static procedure z_NamedFramebufferSampleLocationsfvNV_ovr_0_anh00001(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: UInt32; start: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_NamedFramebufferSampleLocationsfvNV_ovr_0(framebuffer, start, count, v[0]) else
      z_NamedFramebufferSampleLocationsfvNV_ovr_0_anh00001(framebuffer, start, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: UInt32; start: UInt32; count: Int32; var v: single) :=
    z_NamedFramebufferSampleLocationsfvNV_ovr_0(framebuffer, start, count, v);
    private static procedure z_NamedFramebufferSampleLocationsfvNV_ovr_2(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glNamedFramebufferSampleLocationsfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NamedFramebufferSampleLocationsfvNV(framebuffer: UInt32; start: UInt32; count: Int32; v: IntPtr) :=
    z_NamedFramebufferSampleLocationsfvNV_ovr_2(framebuffer, start, count, v);
    
    private static procedure z_ResolveDepthValuesNV_ovr_0;
    external 'opengl32.dll' name 'glResolveDepthValuesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResolveDepthValuesNV :=
    z_ResolveDepthValuesNV_ovr_0;
    
  end;
  
  glScissorExclusiveNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ScissorExclusiveNV_ovr_0(x: Int32; y: Int32; width: Int32; height: Int32);
    external 'opengl32.dll' name 'glScissorExclusiveNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveNV(x: Int32; y: Int32; width: Int32; height: Int32) :=
    z_ScissorExclusiveNV_ovr_0(x, y, width, height);
    
    private static procedure z_ScissorExclusiveArrayvNV_ovr_0(first: UInt32; count: Int32; var v: Int32);
    external 'opengl32.dll' name 'glScissorExclusiveArrayvNV';
    private static procedure z_ScissorExclusiveArrayvNV_ovr_0_anh0001(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorExclusiveArrayvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_ScissorExclusiveArrayvNV_ovr_0(first, count, v[0]) else
      z_ScissorExclusiveArrayvNV_ovr_0_anh0001(first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; var v: Int32) :=
    z_ScissorExclusiveArrayvNV_ovr_0(first, count, v);
    private static procedure z_ScissorExclusiveArrayvNV_ovr_2(first: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glScissorExclusiveArrayvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScissorExclusiveArrayvNV(first: UInt32; count: Int32; v: IntPtr) :=
    z_ScissorExclusiveArrayvNV_ovr_2(first, count, v);
    
  end;
  
  glShaderBufferLoadNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MakeBufferResidentNV_ovr_0(target: DummyEnum; access: DummyEnum);
    external 'opengl32.dll' name 'glMakeBufferResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeBufferResidentNV(target: DummyEnum; access: DummyEnum) :=
    z_MakeBufferResidentNV_ovr_0(target, access);
    
    private static procedure z_MakeBufferNonResidentNV_ovr_0(target: DummyEnum);
    external 'opengl32.dll' name 'glMakeBufferNonResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeBufferNonResidentNV(target: DummyEnum) :=
    z_MakeBufferNonResidentNV_ovr_0(target);
    
    private static function z_IsBufferResidentNV_ovr_0(target: DummyEnum): boolean;
    external 'opengl32.dll' name 'glIsBufferResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsBufferResidentNV(target: DummyEnum): boolean :=
    z_IsBufferResidentNV_ovr_0(target);
    
    private static procedure z_MakeNamedBufferResidentNV_ovr_0(buffer: UInt32; access: DummyEnum);
    external 'opengl32.dll' name 'glMakeNamedBufferResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeNamedBufferResidentNV(buffer: UInt32; access: DummyEnum) :=
    z_MakeNamedBufferResidentNV_ovr_0(buffer, access);
    
    private static procedure z_MakeNamedBufferNonResidentNV_ovr_0(buffer: UInt32);
    external 'opengl32.dll' name 'glMakeNamedBufferNonResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MakeNamedBufferNonResidentNV(buffer: UInt32) :=
    z_MakeNamedBufferNonResidentNV_ovr_0(buffer);
    
    private static function z_IsNamedBufferResidentNV_ovr_0(buffer: UInt32): boolean;
    external 'opengl32.dll' name 'glIsNamedBufferResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsNamedBufferResidentNV(buffer: UInt32): boolean :=
    z_IsNamedBufferResidentNV_ovr_0(buffer);
    
    private static procedure z_GetBufferParameterui64vNV_ovr_0(target: BufferTargetARB; pname: DummyEnum; var &params: UInt64);
    external 'opengl32.dll' name 'glGetBufferParameterui64vNV';
    private static procedure z_GetBufferParameterui64vNV_ovr_0_anh0001(target: BufferTargetARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferParameterui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTargetARB; pname: DummyEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetBufferParameterui64vNV_ovr_0(target, pname, &params[0]) else
      z_GetBufferParameterui64vNV_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTargetARB; pname: DummyEnum; var &params: UInt64) :=
    z_GetBufferParameterui64vNV_ovr_0(target, pname, &params);
    private static procedure z_GetBufferParameterui64vNV_ovr_2(target: BufferTargetARB; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetBufferParameterui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetBufferParameterui64vNV(target: BufferTargetARB; pname: DummyEnum; &params: IntPtr) :=
    z_GetBufferParameterui64vNV_ovr_2(target, pname, &params);
    
    private static procedure z_GetNamedBufferParameterui64vNV_ovr_0(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: UInt64);
    external 'opengl32.dll' name 'glGetNamedBufferParameterui64vNV';
    private static procedure z_GetNamedBufferParameterui64vNV_ovr_0_anh0001(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameterui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: UInt32; pname: VertexBufferObjectParameter; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetNamedBufferParameterui64vNV_ovr_0(buffer, pname, &params[0]) else
      z_GetNamedBufferParameterui64vNV_ovr_0_anh0001(buffer, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: UInt32; pname: VertexBufferObjectParameter; var &params: UInt64) :=
    z_GetNamedBufferParameterui64vNV_ovr_0(buffer, pname, &params);
    private static procedure z_GetNamedBufferParameterui64vNV_ovr_2(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetNamedBufferParameterui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetNamedBufferParameterui64vNV(buffer: UInt32; pname: VertexBufferObjectParameter; &params: IntPtr) :=
    z_GetNamedBufferParameterui64vNV_ovr_2(buffer, pname, &params);
    
    private static procedure z_GetIntegerui64vNV_ovr_0(value: DummyEnum; var result: UInt64);
    external 'opengl32.dll' name 'glGetIntegerui64vNV';
    private static procedure z_GetIntegerui64vNV_ovr_0_anh001(value: DummyEnum; result: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; result: array of UInt64) :=
    if (result<>nil) and (result.Length<>0) then
      z_GetIntegerui64vNV_ovr_0(value, result[0]) else
      z_GetIntegerui64vNV_ovr_0_anh001(value, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; var result: UInt64) :=
    z_GetIntegerui64vNV_ovr_0(value, result);
    private static procedure z_GetIntegerui64vNV_ovr_2(value: DummyEnum; result: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64vNV(value: DummyEnum; result: IntPtr) :=
    z_GetIntegerui64vNV_ovr_2(value, result);
    
    private static procedure z_Uniformui64NV_ovr_0(location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glUniformui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64NV(location: Int32; value: UInt64) :=
    z_Uniformui64NV_ovr_0(location, value);
    
    private static procedure z_Uniformui64vNV_ovr_0(location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glUniformui64vNV';
    private static procedure z_Uniformui64vNV_ovr_0_anh0001(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_Uniformui64vNV_ovr_0(location, count, value[0]) else
      z_Uniformui64vNV_ovr_0_anh0001(location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; var value: UInt64) :=
    z_Uniformui64vNV_ovr_0(location, count, value);
    private static procedure z_Uniformui64vNV_ovr_2(location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Uniformui64vNV(location: Int32; count: Int32; value: IntPtr) :=
    z_Uniformui64vNV_ovr_2(location, count, value);
    
    private static procedure z_GetUniformui64vNV_ovr_0(&program: UInt32; location: Int32; var &params: UInt64);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    private static procedure z_GetUniformui64vNV_ovr_0_anh0001(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetUniformui64vNV_ovr_0(&program, location, &params[0]) else
      z_GetUniformui64vNV_ovr_0_anh0001(&program, location, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; var &params: UInt64) :=
    z_GetUniformui64vNV_ovr_0(&program, location, &params);
    private static procedure z_GetUniformui64vNV_ovr_2(&program: UInt32; location: Int32; &params: IntPtr);
    external 'opengl32.dll' name 'glGetUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetUniformui64vNV(&program: UInt32; location: Int32; &params: IntPtr) :=
    z_GetUniformui64vNV_ovr_2(&program, location, &params);
    
    private static procedure z_ProgramUniformui64NV_ovr_0(&program: UInt32; location: Int32; value: UInt64);
    external 'opengl32.dll' name 'glProgramUniformui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64NV(&program: UInt32; location: Int32; value: UInt64) :=
    z_ProgramUniformui64NV_ovr_0(&program, location, value);
    
    private static procedure z_ProgramUniformui64vNV_ovr_0(&program: UInt32; location: Int32; count: Int32; var value: UInt64);
    external 'opengl32.dll' name 'glProgramUniformui64vNV';
    private static procedure z_ProgramUniformui64vNV_ovr_0_anh00001(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: UInt32; location: Int32; count: Int32; value: array of UInt64) :=
    if (value<>nil) and (value.Length<>0) then
      z_ProgramUniformui64vNV_ovr_0(&program, location, count, value[0]) else
      z_ProgramUniformui64vNV_ovr_0_anh00001(&program, location, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: UInt32; location: Int32; count: Int32; var value: UInt64) :=
    z_ProgramUniformui64vNV_ovr_0(&program, location, count, value);
    private static procedure z_ProgramUniformui64vNV_ovr_2(&program: UInt32; location: Int32; count: Int32; value: IntPtr);
    external 'opengl32.dll' name 'glProgramUniformui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramUniformui64vNV(&program: UInt32; location: Int32; count: Int32; value: IntPtr) :=
    z_ProgramUniformui64vNV_ovr_2(&program, location, count, value);
    
  end;
  
  glShadingRateImageNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindShadingRateImageNV_ovr_0(texture: UInt32);
    external 'opengl32.dll' name 'glBindShadingRateImageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindShadingRateImageNV(texture: UInt32) :=
    z_BindShadingRateImageNV_ovr_0(texture);
    
    private static procedure z_GetShadingRateImagePaletteNV_ovr_0(viewport: UInt32; entry: UInt32; var rate: DummyEnum);
    external 'opengl32.dll' name 'glGetShadingRateImagePaletteNV';
    private static procedure z_GetShadingRateImagePaletteNV_ovr_0_anh0001(viewport: UInt32; entry: UInt32; rate: IntPtr);
    external 'opengl32.dll' name 'glGetShadingRateImagePaletteNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateImagePaletteNV(viewport: UInt32; entry: UInt32; rate: array of DummyEnum) :=
    if (rate<>nil) and (rate.Length<>0) then
      z_GetShadingRateImagePaletteNV_ovr_0(viewport, entry, rate[0]) else
      z_GetShadingRateImagePaletteNV_ovr_0_anh0001(viewport, entry, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateImagePaletteNV(viewport: UInt32; entry: UInt32; var rate: DummyEnum) :=
    z_GetShadingRateImagePaletteNV_ovr_0(viewport, entry, rate);
    private static procedure z_GetShadingRateImagePaletteNV_ovr_2(viewport: UInt32; entry: UInt32; rate: IntPtr);
    external 'opengl32.dll' name 'glGetShadingRateImagePaletteNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateImagePaletteNV(viewport: UInt32; entry: UInt32; rate: IntPtr) :=
    z_GetShadingRateImagePaletteNV_ovr_2(viewport, entry, rate);
    
    private static procedure z_GetShadingRateSampleLocationivNV_ovr_0(rate: DummyEnum; samples: UInt32; index: UInt32; var location: Int32);
    external 'opengl32.dll' name 'glGetShadingRateSampleLocationivNV';
    private static procedure z_GetShadingRateSampleLocationivNV_ovr_0_anh00001(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr);
    external 'opengl32.dll' name 'glGetShadingRateSampleLocationivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; location: array of Int32) :=
    if (location<>nil) and (location.Length<>0) then
      z_GetShadingRateSampleLocationivNV_ovr_0(rate, samples, index, location[0]) else
      z_GetShadingRateSampleLocationivNV_ovr_0_anh00001(rate, samples, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; var location: Int32) :=
    z_GetShadingRateSampleLocationivNV_ovr_0(rate, samples, index, location);
    private static procedure z_GetShadingRateSampleLocationivNV_ovr_2(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr);
    external 'opengl32.dll' name 'glGetShadingRateSampleLocationivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetShadingRateSampleLocationivNV(rate: DummyEnum; samples: UInt32; index: UInt32; location: IntPtr) :=
    z_GetShadingRateSampleLocationivNV_ovr_2(rate, samples, index, location);
    
    private static procedure z_ShadingRateImageBarrierNV_ovr_0(synchronize: boolean);
    external 'opengl32.dll' name 'glShadingRateImageBarrierNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImageBarrierNV(synchronize: boolean) :=
    z_ShadingRateImageBarrierNV_ovr_0(synchronize);
    
    private static procedure z_ShadingRateImagePaletteNV_ovr_0(viewport: UInt32; first: UInt32; count: Int32; var rates: DummyEnum);
    external 'opengl32.dll' name 'glShadingRateImagePaletteNV';
    private static procedure z_ShadingRateImagePaletteNV_ovr_0_anh00001(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr);
    external 'opengl32.dll' name 'glShadingRateImagePaletteNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; rates: array of DummyEnum) :=
    if (rates<>nil) and (rates.Length<>0) then
      z_ShadingRateImagePaletteNV_ovr_0(viewport, first, count, rates[0]) else
      z_ShadingRateImagePaletteNV_ovr_0_anh00001(viewport, first, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; var rates: DummyEnum) :=
    z_ShadingRateImagePaletteNV_ovr_0(viewport, first, count, rates);
    private static procedure z_ShadingRateImagePaletteNV_ovr_2(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr);
    external 'opengl32.dll' name 'glShadingRateImagePaletteNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateImagePaletteNV(viewport: UInt32; first: UInt32; count: Int32; rates: IntPtr) :=
    z_ShadingRateImagePaletteNV_ovr_2(viewport, first, count, rates);
    
    private static procedure z_ShadingRateSampleOrderNV_ovr_0(order: DummyEnum);
    external 'opengl32.dll' name 'glShadingRateSampleOrderNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderNV(order: DummyEnum) :=
    z_ShadingRateSampleOrderNV_ovr_0(order);
    
    private static procedure z_ShadingRateSampleOrderCustomNV_ovr_0(rate: DummyEnum; samples: UInt32; var locations: Int32);
    external 'opengl32.dll' name 'glShadingRateSampleOrderCustomNV';
    private static procedure z_ShadingRateSampleOrderCustomNV_ovr_0_anh0001(rate: DummyEnum; samples: UInt32; locations: IntPtr);
    external 'opengl32.dll' name 'glShadingRateSampleOrderCustomNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; locations: array of Int32) :=
    if (locations<>nil) and (locations.Length<>0) then
      z_ShadingRateSampleOrderCustomNV_ovr_0(rate, samples, locations[0]) else
      z_ShadingRateSampleOrderCustomNV_ovr_0_anh0001(rate, samples, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; var locations: Int32) :=
    z_ShadingRateSampleOrderCustomNV_ovr_0(rate, samples, locations);
    private static procedure z_ShadingRateSampleOrderCustomNV_ovr_2(rate: DummyEnum; samples: UInt32; locations: IntPtr);
    external 'opengl32.dll' name 'glShadingRateSampleOrderCustomNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ShadingRateSampleOrderCustomNV(rate: DummyEnum; samples: UInt32; locations: IntPtr) :=
    z_ShadingRateSampleOrderCustomNV_ovr_2(rate, samples, locations);
    
  end;
  
  glTextureBarrierNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureBarrierNV_ovr_0;
    external 'opengl32.dll' name 'glTextureBarrierNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureBarrierNV :=
    z_TextureBarrierNV_ovr_0;
    
  end;
  
  glTextureMultisampleNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexImage2DMultisampleCoverageNV_ovr_0(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTexImage2DMultisampleCoverageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage2DMultisampleCoverageNV(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TexImage2DMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
    
    private static procedure z_TexImage3DMultisampleCoverageNV_ovr_0(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTexImage3DMultisampleCoverageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage3DMultisampleCoverageNV(target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TexImage3DMultisampleCoverageNV_ovr_0(target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
    
    private static procedure z_TextureImage2DMultisampleNV_ovr_0(texture: UInt32; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTextureImage2DMultisampleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DMultisampleNV(texture: UInt32; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage2DMultisampleNV_ovr_0(texture, target, samples, internalFormat, width, height, fixedSampleLocations);
    
    private static procedure z_TextureImage3DMultisampleNV_ovr_0(texture: UInt32; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTextureImage3DMultisampleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DMultisampleNV(texture: UInt32; target: TextureTarget; samples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage3DMultisampleNV_ovr_0(texture, target, samples, internalFormat, width, height, depth, fixedSampleLocations);
    
    private static procedure z_TextureImage2DMultisampleCoverageNV_ovr_0(texture: UInt32; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTextureImage2DMultisampleCoverageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage2DMultisampleCoverageNV(texture: UInt32; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage2DMultisampleCoverageNV_ovr_0(texture, target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
    
    private static procedure z_TextureImage3DMultisampleCoverageNV_ovr_0(texture: UInt32; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean);
    external 'opengl32.dll' name 'glTextureImage3DMultisampleCoverageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureImage3DMultisampleCoverageNV(texture: UInt32; target: TextureTarget; coverageSamples: Int32; colorSamples: Int32; internalFormat: Int32; width: Int32; height: Int32; depth: Int32; fixedSampleLocations: boolean) :=
    z_TextureImage3DMultisampleCoverageNV_ovr_0(texture, target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
    
  end;
  
  glTransformFeedbackNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginTransformFeedbackNV_ovr_0(primitiveMode: PrimitiveType);
    external 'opengl32.dll' name 'glBeginTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginTransformFeedbackNV(primitiveMode: PrimitiveType) :=
    z_BeginTransformFeedbackNV_ovr_0(primitiveMode);
    
    private static procedure z_EndTransformFeedbackNV_ovr_0;
    external 'opengl32.dll' name 'glEndTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndTransformFeedbackNV :=
    z_EndTransformFeedbackNV_ovr_0;
    
    private static procedure z_TransformFeedbackAttribsNV_ovr_0(count: Int32; var attribs: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackAttribsNV';
    private static procedure z_TransformFeedbackAttribsNV_ovr_0_anh0010(count: Int32; attribs: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; attribs: array of Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackAttribsNV_ovr_0(count, attribs[0], bufferMode) else
      z_TransformFeedbackAttribsNV_ovr_0_anh0010(count, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; var attribs: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackAttribsNV_ovr_0(count, attribs, bufferMode);
    private static procedure z_TransformFeedbackAttribsNV_ovr_2(count: Int32; attribs: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackAttribsNV(count: Int32; attribs: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackAttribsNV_ovr_2(count, attribs, bufferMode);
    
    private static procedure z_BindBufferRangeNV_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr; size: IntPtr);
    external 'opengl32.dll' name 'glBindBufferRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferRangeNV(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr; size: IntPtr) :=
    z_BindBufferRangeNV_ovr_0(target, index, buffer, offset, size);
    
    private static procedure z_BindBufferOffsetNV_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr);
    external 'opengl32.dll' name 'glBindBufferOffsetNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferOffsetNV(target: BufferTargetARB; index: UInt32; buffer: UInt32; offset: IntPtr) :=
    z_BindBufferOffsetNV_ovr_0(target, index, buffer, offset);
    
    private static procedure z_BindBufferBaseNV_ovr_0(target: BufferTargetARB; index: UInt32; buffer: UInt32);
    external 'opengl32.dll' name 'glBindBufferBaseNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindBufferBaseNV(target: BufferTargetARB; index: UInt32; buffer: UInt32) :=
    z_BindBufferBaseNV_ovr_0(target, index, buffer);
    
    private static procedure z_TransformFeedbackVaryingsNV_ovr_0(&program: UInt32; count: Int32; var locations: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsNV';
    private static procedure z_TransformFeedbackVaryingsNV_ovr_0_anh00010(&program: UInt32; count: Int32; locations: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: UInt32; count: Int32; locations: array of Int32; bufferMode: DummyEnum) :=
    if (locations<>nil) and (locations.Length<>0) then
      z_TransformFeedbackVaryingsNV_ovr_0(&program, count, locations[0], bufferMode) else
      z_TransformFeedbackVaryingsNV_ovr_0_anh00010(&program, count, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: UInt32; count: Int32; var locations: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsNV_ovr_0(&program, count, locations, bufferMode);
    private static procedure z_TransformFeedbackVaryingsNV_ovr_2(&program: UInt32; count: Int32; locations: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackVaryingsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackVaryingsNV(&program: UInt32; count: Int32; locations: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackVaryingsNV_ovr_2(&program, count, locations, bufferMode);
    
    private static procedure z_ActiveVaryingNV_ovr_0(&program: UInt32; name: IntPtr);
    external 'opengl32.dll' name 'glActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveVaryingNV(&program: UInt32; name: string);
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      z_ActiveVaryingNV_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ActiveVaryingNV(&program: UInt32; name: IntPtr) :=
    z_ActiveVaryingNV_ovr_0(&program, name);
    
    private static function z_GetVaryingLocationNV_ovr_0(&program: UInt32; name: IntPtr): Int32;
    external 'opengl32.dll' name 'glGetVaryingLocationNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVaryingLocationNV(&program: UInt32; name: string): Int32;
    begin
      var par_2_str_ptr := Marshal.StringToHGlobalAnsi(name);
      Result := z_GetVaryingLocationNV_ovr_0(&program, par_2_str_ptr);
      Marshal.FreeHGlobal(par_2_str_ptr);
    end;
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetVaryingLocationNV(&program: UInt32; name: IntPtr): Int32 :=
    z_GetVaryingLocationNV_ovr_0(&program, name);
    
    private static procedure z_GetActiveVaryingNV_ovr_0(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00000110(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_0_anh00001110(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length[0], size[0], &type[0], name) else
          z_GetActiveVaryingNV_ovr_0_anh00000010(&program, index, bufSize, length[0], size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveVaryingNV_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type[0], name) else
          z_GetActiveVaryingNV_ovr_0_anh00000110(&program, index, bufSize, length[0], IntPtr.Zero, IntPtr.Zero, name) else
      if (size<>nil) and (size.Length<>0) then
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveVaryingNV_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type[0], name) else
          z_GetActiveVaryingNV_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size[0], IntPtr.Zero, name) else
        if (&type<>nil) and (&type.Length<>0) then
          z_GetActiveVaryingNV_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type[0], name) else
          z_GetActiveVaryingNV_ovr_0_anh00001110(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveVaryingNV_ovr_1_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_1_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_1_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; var &type: DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveVaryingNV_ovr_0_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveVaryingNV_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveVaryingNV_ovr_0_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_2(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_2_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_2_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_2_anh00001100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveVaryingNV_ovr_2(&program, index, bufSize, length[0], size[0], &type, name) else
        z_GetActiveVaryingNV_ovr_2_anh00000100(&program, index, bufSize, length[0], IntPtr.Zero, &type, name) else
      if (size<>nil) and (size.Length<>0) then
        z_GetActiveVaryingNV_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size[0], &type, name) else
        z_GetActiveVaryingNV_ovr_2_anh00001100(&program, index, bufSize, IntPtr.Zero, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_3_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_3_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveVaryingNV_ovr_0_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveVaryingNV_ovr_0_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveVaryingNV_ovr_4_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; var &type: DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveVaryingNV_ovr_0_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_5_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveVaryingNV_ovr_2(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveVaryingNV_ovr_2_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_6(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_6_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_6_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_6_anh00001010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: array of DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_6(&program, index, bufSize, length[0], size, &type[0], name) else
        z_GetActiveVaryingNV_ovr_6_anh00000010(&program, index, bufSize, length[0], size, IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type[0], name) else
        z_GetActiveVaryingNV_ovr_6_anh00001010(&program, index, bufSize, IntPtr.Zero, size, IntPtr.Zero, name);
    private static procedure z_GetActiveVaryingNV_ovr_7_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveVaryingNV_ovr_6(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveVaryingNV_ovr_6_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_8(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_8_anh00001000(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: array of Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_GetActiveVaryingNV_ovr_8(&program, index, bufSize, length[0], size, &type, name) else
      z_GetActiveVaryingNV_ovr_8_anh00001000(&program, index, bufSize, IntPtr.Zero, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveVaryingNV_ovr_0_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveVaryingNV_ovr_0_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; var &type: DummyEnum; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveVaryingNV_ovr_0_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveVaryingNV_ovr_2(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveVaryingNV_ovr_2_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveVaryingNV_ovr_0_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_0(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_2(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: array of DummyEnum; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveVaryingNV_ovr_6(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveVaryingNV_ovr_6_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_6(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; var length: Int32; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_8(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_18(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_18_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_18_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_18_anh00000110(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_18(&program, index, bufSize, length, size[0], &type[0], name) else
        z_GetActiveVaryingNV_ovr_18_anh00000010(&program, index, bufSize, length, size[0], IntPtr.Zero, name) else
      if (&type<>nil) and (&type.Length<>0) then
        z_GetActiveVaryingNV_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type[0], name) else
        z_GetActiveVaryingNV_ovr_18_anh00000110(&program, index, bufSize, length, IntPtr.Zero, IntPtr.Zero, name);
    private static procedure z_GetActiveVaryingNV_ovr_19_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; var &type: DummyEnum; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveVaryingNV_ovr_18(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveVaryingNV_ovr_18_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_20(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_20_anh00000100(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: array of Int32; &type: IntPtr; name: IntPtr) :=
    if (size<>nil) and (size.Length<>0) then
      z_GetActiveVaryingNV_ovr_20(&program, index, bufSize, length, size[0], &type, name) else
      z_GetActiveVaryingNV_ovr_20_anh00000100(&program, index, bufSize, length, IntPtr.Zero, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: array of DummyEnum; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveVaryingNV_ovr_18(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveVaryingNV_ovr_18_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_18(&program, index, bufSize, length, size, &type, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; var size: Int32; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_20(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_24(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    private static procedure z_GetActiveVaryingNV_ovr_24_anh00000010(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: array of DummyEnum; name: IntPtr) :=
    if (&type<>nil) and (&type.Length<>0) then
      z_GetActiveVaryingNV_ovr_24(&program, index, bufSize, length, size, &type[0], name) else
      z_GetActiveVaryingNV_ovr_24_anh00000010(&program, index, bufSize, length, size, IntPtr.Zero, name);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; var &type: DummyEnum; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_24(&program, index, bufSize, length, size, &type, name);
    private static procedure z_GetActiveVaryingNV_ovr_26(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr);
    external 'opengl32.dll' name 'glGetActiveVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetActiveVaryingNV(&program: UInt32; index: UInt32; bufSize: Int32; length: IntPtr; size: IntPtr; &type: IntPtr; name: IntPtr) :=
    z_GetActiveVaryingNV_ovr_26(&program, index, bufSize, length, size, &type, name);
    
    private static procedure z_GetTransformFeedbackVaryingNV_ovr_0(&program: UInt32; index: UInt32; var location: Int32);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingNV';
    private static procedure z_GetTransformFeedbackVaryingNV_ovr_0_anh0001(&program: UInt32; index: UInt32; location: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingNV(&program: UInt32; index: UInt32; location: array of Int32) :=
    if (location<>nil) and (location.Length<>0) then
      z_GetTransformFeedbackVaryingNV_ovr_0(&program, index, location[0]) else
      z_GetTransformFeedbackVaryingNV_ovr_0_anh0001(&program, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingNV(&program: UInt32; index: UInt32; var location: Int32) :=
    z_GetTransformFeedbackVaryingNV_ovr_0(&program, index, location);
    private static procedure z_GetTransformFeedbackVaryingNV_ovr_2(&program: UInt32; index: UInt32; location: IntPtr);
    external 'opengl32.dll' name 'glGetTransformFeedbackVaryingNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTransformFeedbackVaryingNV(&program: UInt32; index: UInt32; location: IntPtr) :=
    z_GetTransformFeedbackVaryingNV_ovr_2(&program, index, location);
    
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_0(count: Int32; var attribs: Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_0_anh001010(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      if (bufstreams<>nil) and (bufstreams.Length<>0) then
        z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs[0], nbuffers, bufstreams[0], bufferMode) else
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010(count, attribs[0], nbuffers, IntPtr.Zero, bufferMode) else
      if (bufstreams<>nil) and (bufstreams.Length<>0) then
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000(count, IntPtr.Zero, nbuffers, bufstreams[0], bufferMode) else
        z_TransformFeedbackStreamAttribsNV_ovr_0_anh001010(count, IntPtr.Zero, nbuffers, IntPtr.Zero, bufferMode);
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_1_anh001000(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs[0], nbuffers, bufstreams, bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_0_anh001000(count, IntPtr.Zero, nbuffers, bufstreams, bufferMode);
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_2(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_2_anh001000(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: array of Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    if (attribs<>nil) and (attribs.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_2(count, attribs[0], nbuffers, bufstreams, bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_2_anh001000(count, IntPtr.Zero, nbuffers, bufstreams, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (bufstreams<>nil) and (bufstreams.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs, nbuffers, bufstreams[0], bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_0_anh000010(count, attribs, nbuffers, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_0(count, attribs, nbuffers, bufstreams, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; var attribs: Int32; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_2(count, attribs, nbuffers, bufstreams, bufferMode);
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_6(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_6_anh000010(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: array of Int32; bufferMode: DummyEnum) :=
    if (bufstreams<>nil) and (bufstreams.Length<>0) then
      z_TransformFeedbackStreamAttribsNV_ovr_6(count, attribs, nbuffers, bufstreams[0], bufferMode) else
      z_TransformFeedbackStreamAttribsNV_ovr_6_anh000010(count, attribs, nbuffers, IntPtr.Zero, bufferMode);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; var bufstreams: Int32; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_6(count, attribs, nbuffers, bufstreams, bufferMode);
    private static procedure z_TransformFeedbackStreamAttribsNV_ovr_8(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum);
    external 'opengl32.dll' name 'glTransformFeedbackStreamAttribsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TransformFeedbackStreamAttribsNV(count: Int32; attribs: IntPtr; nbuffers: Int32; bufstreams: IntPtr; bufferMode: DummyEnum) :=
    z_TransformFeedbackStreamAttribsNV_ovr_8(count, attribs, nbuffers, bufstreams, bufferMode);
    
  end;
  
  glTransformFeedback2NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BindTransformFeedbackNV_ovr_0(target: BufferTargetARB; id: UInt32);
    external 'opengl32.dll' name 'glBindTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindTransformFeedbackNV(target: BufferTargetARB; id: UInt32) :=
    z_BindTransformFeedbackNV_ovr_0(target, id);
    
    private static procedure z_DeleteTransformFeedbacksNV_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacksNV';
    private static procedure z_DeleteTransformFeedbacksNV_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacksNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_DeleteTransformFeedbacksNV_ovr_0(n, ids[0]) else
      z_DeleteTransformFeedbacksNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; var ids: UInt32) :=
    z_DeleteTransformFeedbacksNV_ovr_0(n, ids);
    private static procedure z_DeleteTransformFeedbacksNV_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glDeleteTransformFeedbacksNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteTransformFeedbacksNV(n: Int32; ids: IntPtr) :=
    z_DeleteTransformFeedbacksNV_ovr_2(n, ids);
    
    private static procedure z_GenTransformFeedbacksNV_ovr_0(n: Int32; var ids: UInt32);
    external 'opengl32.dll' name 'glGenTransformFeedbacksNV';
    private static procedure z_GenTransformFeedbacksNV_ovr_0_anh001(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenTransformFeedbacksNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; ids: array of UInt32) :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GenTransformFeedbacksNV_ovr_0(n, ids[0]) else
      z_GenTransformFeedbacksNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; var ids: UInt32) :=
    z_GenTransformFeedbacksNV_ovr_0(n, ids);
    private static procedure z_GenTransformFeedbacksNV_ovr_2(n: Int32; ids: IntPtr);
    external 'opengl32.dll' name 'glGenTransformFeedbacksNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenTransformFeedbacksNV(n: Int32; ids: IntPtr) :=
    z_GenTransformFeedbacksNV_ovr_2(n, ids);
    
    private static function z_IsTransformFeedbackNV_ovr_0(id: UInt32): boolean;
    external 'opengl32.dll' name 'glIsTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsTransformFeedbackNV(id: UInt32): boolean :=
    z_IsTransformFeedbackNV_ovr_0(id);
    
    private static procedure z_PauseTransformFeedbackNV_ovr_0;
    external 'opengl32.dll' name 'glPauseTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PauseTransformFeedbackNV :=
    z_PauseTransformFeedbackNV_ovr_0;
    
    private static procedure z_ResumeTransformFeedbackNV_ovr_0;
    external 'opengl32.dll' name 'glResumeTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ResumeTransformFeedbackNV :=
    z_ResumeTransformFeedbackNV_ovr_0;
    
    private static procedure z_DrawTransformFeedbackNV_ovr_0(mode: PrimitiveType; id: UInt32);
    external 'opengl32.dll' name 'glDrawTransformFeedbackNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawTransformFeedbackNV(mode: PrimitiveType; id: UInt32) :=
    z_DrawTransformFeedbackNV_ovr_0(mode, id);
    
  end;
  
  glVdpauInteropNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VDPAUInitNV_ovr_0(vdpDevice: IntPtr; getProcAddress: IntPtr);
    external 'opengl32.dll' name 'glVDPAUInitNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUInitNV(vdpDevice: IntPtr; getProcAddress: IntPtr) :=
    z_VDPAUInitNV_ovr_0(vdpDevice, getProcAddress);
    
    private static procedure z_VDPAUFiniNV_ovr_0;
    external 'opengl32.dll' name 'glVDPAUFiniNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUFiniNV :=
    z_VDPAUFiniNV_ovr_0;
    
    private static function z_VDPAURegisterVideoSurfaceNV_ovr_0(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceNV';
    private static function z_VDPAURegisterVideoSurfaceNV_ovr_0_anh00001(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32): GLvdpauSurfaceNV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterVideoSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0]) else
      z_VDPAURegisterVideoSurfaceNV_ovr_0_anh00001(vdpSurface, target, numTextureNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): GLvdpauSurfaceNV :=
    z_VDPAURegisterVideoSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames);
    private static function z_VDPAURegisterVideoSurfaceNV_ovr_2(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV :=
    z_VDPAURegisterVideoSurfaceNV_ovr_2(vdpSurface, target, numTextureNames, textureNames);
    
    private static function z_VDPAURegisterOutputSurfaceNV_ovr_0(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterOutputSurfaceNV';
    private static function z_VDPAURegisterOutputSurfaceNV_ovr_0_anh00001(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterOutputSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32): GLvdpauSurfaceNV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterOutputSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0]) else
      z_VDPAURegisterOutputSurfaceNV_ovr_0_anh00001(vdpSurface, target, numTextureNames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32): GLvdpauSurfaceNV :=
    z_VDPAURegisterOutputSurfaceNV_ovr_0(vdpSurface, target, numTextureNames, textureNames);
    private static function z_VDPAURegisterOutputSurfaceNV_ovr_2(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterOutputSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterOutputSurfaceNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr): GLvdpauSurfaceNV :=
    z_VDPAURegisterOutputSurfaceNV_ovr_2(vdpSurface, target, numTextureNames, textureNames);
    
    private static function z_VDPAUIsSurfaceNV_ovr_0(surface: GLvdpauSurfaceNV): boolean;
    external 'opengl32.dll' name 'glVDPAUIsSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAUIsSurfaceNV(surface: GLvdpauSurfaceNV): boolean :=
    z_VDPAUIsSurfaceNV_ovr_0(surface);
    
    private static procedure z_VDPAUUnregisterSurfaceNV_ovr_0(surface: GLvdpauSurfaceNV);
    external 'opengl32.dll' name 'glVDPAUUnregisterSurfaceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnregisterSurfaceNV(surface: GLvdpauSurfaceNV) :=
    z_VDPAUUnregisterSurfaceNV_ovr_0(surface);
    
    private static procedure z_VDPAUGetSurfaceivNV_ovr_0(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; var values: Int32);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    private static procedure z_VDPAUGetSurfaceivNV_ovr_0_anh000010(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    private static procedure z_VDPAUGetSurfaceivNV_ovr_0_anh000001(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    private static procedure z_VDPAUGetSurfaceivNV_ovr_0_anh000011(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: array of Int32; values: array of Int32) :=
    if (length<>nil) and (length.Length<>0) then
      if (values<>nil) and (values.Length<>0) then
        z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length[0], values[0]) else
        z_VDPAUGetSurfaceivNV_ovr_0_anh000001(surface, pname, count, length[0], IntPtr.Zero) else
      if (values<>nil) and (values.Length<>0) then
        z_VDPAUGetSurfaceivNV_ovr_0_anh000010(surface, pname, count, IntPtr.Zero, values[0]) else
        z_VDPAUGetSurfaceivNV_ovr_0_anh000011(surface, pname, count, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_VDPAUGetSurfaceivNV_ovr_1_anh000010(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: array of Int32; var values: Int32) :=
    if (length<>nil) and (length.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length[0], values) else
      z_VDPAUGetSurfaceivNV_ovr_0_anh000010(surface, pname, count, IntPtr.Zero, values);
    private static procedure z_VDPAUGetSurfaceivNV_ovr_2(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    private static procedure z_VDPAUGetSurfaceivNV_ovr_2_anh000010(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: array of Int32; values: IntPtr) :=
    if (length<>nil) and (length.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_2(surface, pname, count, length[0], values) else
      z_VDPAUGetSurfaceivNV_ovr_2_anh000010(surface, pname, count, IntPtr.Zero, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length, values[0]) else
      z_VDPAUGetSurfaceivNV_ovr_0_anh000001(surface, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; var values: Int32) :=
    z_VDPAUGetSurfaceivNV_ovr_0(surface, pname, count, length, values);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; var length: Int32; values: IntPtr) :=
    z_VDPAUGetSurfaceivNV_ovr_2(surface, pname, count, length, values);
    private static procedure z_VDPAUGetSurfaceivNV_ovr_6(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    private static procedure z_VDPAUGetSurfaceivNV_ovr_6_anh000001(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: array of Int32) :=
    if (values<>nil) and (values.Length<>0) then
      z_VDPAUGetSurfaceivNV_ovr_6(surface, pname, count, length, values[0]) else
      z_VDPAUGetSurfaceivNV_ovr_6_anh000001(surface, pname, count, length, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; var values: Int32) :=
    z_VDPAUGetSurfaceivNV_ovr_6(surface, pname, count, length, values);
    private static procedure z_VDPAUGetSurfaceivNV_ovr_8(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr);
    external 'opengl32.dll' name 'glVDPAUGetSurfaceivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUGetSurfaceivNV(surface: GLvdpauSurfaceNV; pname: DummyEnum; count: Int32; length: IntPtr; values: IntPtr) :=
    z_VDPAUGetSurfaceivNV_ovr_8(surface, pname, count, length, values);
    
    private static procedure z_VDPAUSurfaceAccessNV_ovr_0(surface: GLvdpauSurfaceNV; access: DummyEnum);
    external 'opengl32.dll' name 'glVDPAUSurfaceAccessNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUSurfaceAccessNV(surface: GLvdpauSurfaceNV; access: DummyEnum) :=
    z_VDPAUSurfaceAccessNV_ovr_0(surface, access);
    
    private static procedure z_VDPAUMapSurfacesNV_ovr_0(numSurfaces: Int32; var surfaces: GLvdpauSurfaceNV);
    external 'opengl32.dll' name 'glVDPAUMapSurfacesNV';
    private static procedure z_VDPAUMapSurfacesNV_ovr_0_anh001(numSurfaces: Int32; surfaces: IntPtr);
    external 'opengl32.dll' name 'glVDPAUMapSurfacesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; surfaces: array of GLvdpauSurfaceNV) :=
    if (surfaces<>nil) and (surfaces.Length<>0) then
      z_VDPAUMapSurfacesNV_ovr_0(numSurfaces, surfaces[0]) else
      z_VDPAUMapSurfacesNV_ovr_0_anh001(numSurfaces, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; var surfaces: GLvdpauSurfaceNV) :=
    z_VDPAUMapSurfacesNV_ovr_0(numSurfaces, surfaces);
    private static procedure z_VDPAUMapSurfacesNV_ovr_2(numSurfaces: Int32; surfaces: IntPtr);
    external 'opengl32.dll' name 'glVDPAUMapSurfacesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUMapSurfacesNV(numSurfaces: Int32; surfaces: IntPtr) :=
    z_VDPAUMapSurfacesNV_ovr_2(numSurfaces, surfaces);
    
    private static procedure z_VDPAUUnmapSurfacesNV_ovr_0(numSurface: Int32; var surfaces: GLvdpauSurfaceNV);
    external 'opengl32.dll' name 'glVDPAUUnmapSurfacesNV';
    private static procedure z_VDPAUUnmapSurfacesNV_ovr_0_anh001(numSurface: Int32; surfaces: IntPtr);
    external 'opengl32.dll' name 'glVDPAUUnmapSurfacesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; surfaces: array of GLvdpauSurfaceNV) :=
    if (surfaces<>nil) and (surfaces.Length<>0) then
      z_VDPAUUnmapSurfacesNV_ovr_0(numSurface, surfaces[0]) else
      z_VDPAUUnmapSurfacesNV_ovr_0_anh001(numSurface, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; var surfaces: GLvdpauSurfaceNV) :=
    z_VDPAUUnmapSurfacesNV_ovr_0(numSurface, surfaces);
    private static procedure z_VDPAUUnmapSurfacesNV_ovr_2(numSurface: Int32; surfaces: IntPtr);
    external 'opengl32.dll' name 'glVDPAUUnmapSurfacesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VDPAUUnmapSurfacesNV(numSurface: Int32; surfaces: IntPtr) :=
    z_VDPAUUnmapSurfacesNV_ovr_2(numSurface, surfaces);
    
  end;
  
  glVdpauInterop2NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32; isFrameStructure: boolean): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceWithPictureStructureNV';
    private static function z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0_anh000010(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceWithPictureStructureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: array of UInt32; isFrameStructure: boolean): GLvdpauSurfaceNV :=
    if (textureNames<>nil) and (textureNames.Length<>0) then
      z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0(vdpSurface, target, numTextureNames, textureNames[0], isFrameStructure) else
      z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0_anh000010(vdpSurface, target, numTextureNames, IntPtr.Zero, isFrameStructure);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; var textureNames: UInt32; isFrameStructure: boolean): GLvdpauSurfaceNV :=
    z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_0(vdpSurface, target, numTextureNames, textureNames, isFrameStructure);
    private static function z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_2(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): GLvdpauSurfaceNV;
    external 'opengl32.dll' name 'glVDPAURegisterVideoSurfaceWithPictureStructureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VDPAURegisterVideoSurfaceWithPictureStructureNV(vdpSurface: IntPtr; target: DummyEnum; numTextureNames: Int32; textureNames: IntPtr; isFrameStructure: boolean): GLvdpauSurfaceNV :=
    z_VDPAURegisterVideoSurfaceWithPictureStructureNV_ovr_2(vdpSurface, target, numTextureNames, textureNames, isFrameStructure);
    
  end;
  
  glVertexArrayRangeNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FlushVertexArrayRangeNV_ovr_0;
    external 'opengl32.dll' name 'glFlushVertexArrayRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushVertexArrayRangeNV :=
    z_FlushVertexArrayRangeNV_ovr_0;
    
    private static procedure z_VertexArrayRangeNV_ovr_0(length: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexArrayRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexArrayRangeNV(length: Int32; pointer: IntPtr) :=
    z_VertexArrayRangeNV_ovr_0(length, pointer);
    
  end;
  
  glVertexAttribInteger64bitNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribL1i64NV_ovr_0(index: UInt32; x: Int64);
    external 'opengl32.dll' name 'glVertexAttribL1i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64NV(index: UInt32; x: Int64) :=
    z_VertexAttribL1i64NV_ovr_0(index, x);
    
    private static procedure z_VertexAttribL2i64NV_ovr_0(index: UInt32; x: Int64; y: Int64);
    external 'opengl32.dll' name 'glVertexAttribL2i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64NV(index: UInt32; x: Int64; y: Int64) :=
    z_VertexAttribL2i64NV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribL3i64NV_ovr_0(index: UInt32; x: Int64; y: Int64; z: Int64);
    external 'opengl32.dll' name 'glVertexAttribL3i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64NV(index: UInt32; x: Int64; y: Int64; z: Int64) :=
    z_VertexAttribL3i64NV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribL4i64NV_ovr_0(index: UInt32; x: Int64; y: Int64; z: Int64; w: Int64);
    external 'opengl32.dll' name 'glVertexAttribL4i64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64NV(index: UInt32; x: Int64; y: Int64; z: Int64; w: Int64) :=
    z_VertexAttribL4i64NV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribL1i64vNV_ovr_0(index: UInt32; var v: Int64);
    external 'opengl32.dll' name 'glVertexAttribL1i64vNV';
    private static procedure z_VertexAttribL1i64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL1i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL1i64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL1i64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1i64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL2i64vNV_ovr_0(index: UInt32; var v: Int64);
    external 'opengl32.dll' name 'glVertexAttribL2i64vNV';
    private static procedure z_VertexAttribL2i64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL2i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL2i64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL2i64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2i64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL3i64vNV_ovr_0(index: UInt32; var v: Int64);
    external 'opengl32.dll' name 'glVertexAttribL3i64vNV';
    private static procedure z_VertexAttribL3i64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL3i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL3i64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL3i64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3i64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL4i64vNV_ovr_0(index: UInt32; var v: Int64);
    external 'opengl32.dll' name 'glVertexAttribL4i64vNV';
    private static procedure z_VertexAttribL4i64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; v: array of Int64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4i64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL4i64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; var v: Int64) :=
    z_VertexAttribL4i64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL4i64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4i64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4i64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4i64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL1ui64NV_ovr_0(index: UInt32; x: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL1ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64NV(index: UInt32; x: UInt64) :=
    z_VertexAttribL1ui64NV_ovr_0(index, x);
    
    private static procedure z_VertexAttribL2ui64NV_ovr_0(index: UInt32; x: UInt64; y: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL2ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64NV(index: UInt32; x: UInt64; y: UInt64) :=
    z_VertexAttribL2ui64NV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribL3ui64NV_ovr_0(index: UInt32; x: UInt64; y: UInt64; z: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL3ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64NV(index: UInt32; x: UInt64; y: UInt64; z: UInt64) :=
    z_VertexAttribL3ui64NV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribL4ui64NV_ovr_0(index: UInt32; x: UInt64; y: UInt64; z: UInt64; w: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL4ui64NV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64NV(index: UInt32; x: UInt64; y: UInt64; z: UInt64; w: UInt64) :=
    z_VertexAttribL4ui64NV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribL1ui64vNV_ovr_0(index: UInt32; var v: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vNV';
    private static procedure z_VertexAttribL1ui64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL1ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL1ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL1ui64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL1ui64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL1ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL1ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL1ui64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL2ui64vNV_ovr_0(index: UInt32; var v: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL2ui64vNV';
    private static procedure z_VertexAttribL2ui64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL2ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL2ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL2ui64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL2ui64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL2ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL2ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL2ui64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL3ui64vNV_ovr_0(index: UInt32; var v: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL3ui64vNV';
    private static procedure z_VertexAttribL3ui64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL3ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL3ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL3ui64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL3ui64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL3ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL3ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL3ui64vNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribL4ui64vNV_ovr_0(index: UInt32; var v: UInt64);
    external 'opengl32.dll' name 'glVertexAttribL4ui64vNV';
    private static procedure z_VertexAttribL4ui64vNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; v: array of UInt64) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribL4ui64vNV_ovr_0(index, v[0]) else
      z_VertexAttribL4ui64vNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; var v: UInt64) :=
    z_VertexAttribL4ui64vNV_ovr_0(index, v);
    private static procedure z_VertexAttribL4ui64vNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribL4ui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribL4ui64vNV(index: UInt32; v: IntPtr) :=
    z_VertexAttribL4ui64vNV_ovr_2(index, v);
    
    private static procedure z_GetVertexAttribLi64vNV_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: Int64);
    external 'opengl32.dll' name 'glGetVertexAttribLi64vNV';
    private static procedure z_GetVertexAttribLi64vNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; &params: array of Int64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLi64vNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLi64vNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; var &params: Int64) :=
    z_GetVertexAttribLi64vNV_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribLi64vNV_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLi64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLi64vNV(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLi64vNV_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribLui64vNV_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: UInt64);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vNV';
    private static procedure z_GetVertexAttribLui64vNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; &params: array of UInt64) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribLui64vNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribLui64vNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; var &params: UInt64) :=
    z_GetVertexAttribLui64vNV_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribLui64vNV_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribLui64vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribLui64vNV(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribLui64vNV_ovr_2(index, pname, &params);
    
    private static procedure z_VertexAttribLFormatNV_ovr_0(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32);
    external 'opengl32.dll' name 'glVertexAttribLFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribLFormatNV(index: UInt32; size: Int32; &type: VertexAttribLType; stride: Int32) :=
    z_VertexAttribLFormatNV_ovr_0(index, size, &type, stride);
    
  end;
  
  glVertexBufferUnifiedMemoryNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BufferAddressRangeNV_ovr_0(pname: DummyEnum; index: UInt32; address: UInt64; length: IntPtr);
    external 'opengl32.dll' name 'glBufferAddressRangeNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BufferAddressRangeNV(pname: DummyEnum; index: UInt32; address: UInt64; length: IntPtr) :=
    z_BufferAddressRangeNV_ovr_0(pname, index, address, length);
    
    private static procedure z_VertexFormatNV_ovr_0(size: Int32; &type: VertexPointerType; stride: Int32);
    external 'opengl32.dll' name 'glVertexFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexFormatNV(size: Int32; &type: VertexPointerType; stride: Int32) :=
    z_VertexFormatNV_ovr_0(size, &type, stride);
    
    private static procedure z_NormalFormatNV_ovr_0(&type: DummyEnum; stride: Int32);
    external 'opengl32.dll' name 'glNormalFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure NormalFormatNV(&type: DummyEnum; stride: Int32) :=
    z_NormalFormatNV_ovr_0(&type, stride);
    
    private static procedure z_ColorFormatNV_ovr_0(size: Int32; &type: DummyEnum; stride: Int32);
    external 'opengl32.dll' name 'glColorFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorFormatNV(size: Int32; &type: DummyEnum; stride: Int32) :=
    z_ColorFormatNV_ovr_0(size, &type, stride);
    
    private static procedure z_IndexFormatNV_ovr_0(&type: DummyEnum; stride: Int32);
    external 'opengl32.dll' name 'glIndexFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexFormatNV(&type: DummyEnum; stride: Int32) :=
    z_IndexFormatNV_ovr_0(&type, stride);
    
    private static procedure z_TexCoordFormatNV_ovr_0(size: Int32; &type: DummyEnum; stride: Int32);
    external 'opengl32.dll' name 'glTexCoordFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoordFormatNV(size: Int32; &type: DummyEnum; stride: Int32) :=
    z_TexCoordFormatNV_ovr_0(size, &type, stride);
    
    private static procedure z_EdgeFlagFormatNV_ovr_0(stride: Int32);
    external 'opengl32.dll' name 'glEdgeFlagFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EdgeFlagFormatNV(stride: Int32) :=
    z_EdgeFlagFormatNV_ovr_0(stride);
    
    private static procedure z_SecondaryColorFormatNV_ovr_0(size: Int32; &type: ColorPointerType; stride: Int32);
    external 'opengl32.dll' name 'glSecondaryColorFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SecondaryColorFormatNV(size: Int32; &type: ColorPointerType; stride: Int32) :=
    z_SecondaryColorFormatNV_ovr_0(size, &type, stride);
    
    private static procedure z_FogCoordFormatNV_ovr_0(&type: DummyEnum; stride: Int32);
    external 'opengl32.dll' name 'glFogCoordFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogCoordFormatNV(&type: DummyEnum; stride: Int32) :=
    z_FogCoordFormatNV_ovr_0(&type, stride);
    
    private static procedure z_VertexAttribFormatNV_ovr_0(index: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; stride: Int32);
    external 'opengl32.dll' name 'glVertexAttribFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribFormatNV(index: UInt32; size: Int32; &type: VertexAttribType; normalized: boolean; stride: Int32) :=
    z_VertexAttribFormatNV_ovr_0(index, size, &type, normalized, stride);
    
    private static procedure z_VertexAttribIFormatNV_ovr_0(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32);
    external 'opengl32.dll' name 'glVertexAttribIFormatNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIFormatNV(index: UInt32; size: Int32; &type: VertexAttribIType; stride: Int32) :=
    z_VertexAttribIFormatNV_ovr_0(index, size, &type, stride);
    
    private static procedure z_GetIntegerui64i_vNV_ovr_0(value: DummyEnum; index: UInt32; var result: UInt64);
    external 'opengl32.dll' name 'glGetIntegerui64i_vNV';
    private static procedure z_GetIntegerui64i_vNV_ovr_0_anh0001(value: DummyEnum; index: UInt32; result: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerui64i_vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; result: array of UInt64) :=
    if (result<>nil) and (result.Length<>0) then
      z_GetIntegerui64i_vNV_ovr_0(value, index, result[0]) else
      z_GetIntegerui64i_vNV_ovr_0_anh0001(value, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; var result: UInt64) :=
    z_GetIntegerui64i_vNV_ovr_0(value, index, result);
    private static procedure z_GetIntegerui64i_vNV_ovr_2(value: DummyEnum; index: UInt32; result: IntPtr);
    external 'opengl32.dll' name 'glGetIntegerui64i_vNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetIntegerui64i_vNV(value: DummyEnum; index: UInt32; result: IntPtr) :=
    z_GetIntegerui64i_vNV_ovr_2(value, index, result);
    
  end;
  
  glVertexProgramNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_AreProgramsResidentNV_ovr_0(n: Int32; var programs: UInt32; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    private static function z_AreProgramsResidentNV_ovr_0_anh0010(n: Int32; programs: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    private static function z_AreProgramsResidentNV_ovr_0_anh0001(n: Int32; var programs: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    private static function z_AreProgramsResidentNV_ovr_0_anh0011(n: Int32; programs: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of UInt32; residences: array of boolean): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      if (residences<>nil) and (residences.Length<>0) then
        z_AreProgramsResidentNV_ovr_0(n, programs[0], residences[0]) else
        z_AreProgramsResidentNV_ovr_0_anh0001(n, programs[0], IntPtr.Zero) else
      if (residences<>nil) and (residences.Length<>0) then
        z_AreProgramsResidentNV_ovr_0_anh0010(n, IntPtr.Zero, residences[0]) else
        z_AreProgramsResidentNV_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static function z_AreProgramsResidentNV_ovr_1_anh0010(n: Int32; programs: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of UInt32; var residences: boolean): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      z_AreProgramsResidentNV_ovr_0(n, programs[0], residences) else
      z_AreProgramsResidentNV_ovr_0_anh0010(n, IntPtr.Zero, residences);
    private static function z_AreProgramsResidentNV_ovr_2(n: Int32; var programs: UInt32; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    private static function z_AreProgramsResidentNV_ovr_2_anh0010(n: Int32; programs: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: array of UInt32; residences: IntPtr): boolean :=
    if (programs<>nil) and (programs.Length<>0) then
      z_AreProgramsResidentNV_ovr_2(n, programs[0], residences) else
      z_AreProgramsResidentNV_ovr_2_anh0010(n, IntPtr.Zero, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: UInt32; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreProgramsResidentNV_ovr_0(n, programs, residences[0]) else
      z_AreProgramsResidentNV_ovr_0_anh0001(n, programs, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: UInt32; var residences: boolean): boolean :=
    z_AreProgramsResidentNV_ovr_0(n, programs, residences);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; var programs: UInt32; residences: IntPtr): boolean :=
    z_AreProgramsResidentNV_ovr_2(n, programs, residences);
    private static function z_AreProgramsResidentNV_ovr_6(n: Int32; programs: IntPtr; var residences: boolean): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    private static function z_AreProgramsResidentNV_ovr_6_anh0001(n: Int32; programs: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; residences: array of boolean): boolean :=
    if (residences<>nil) and (residences.Length<>0) then
      z_AreProgramsResidentNV_ovr_6(n, programs, residences[0]) else
      z_AreProgramsResidentNV_ovr_6_anh0001(n, programs, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; var residences: boolean): boolean :=
    z_AreProgramsResidentNV_ovr_6(n, programs, residences);
    private static function z_AreProgramsResidentNV_ovr_8(n: Int32; programs: IntPtr; residences: IntPtr): boolean;
    external 'opengl32.dll' name 'glAreProgramsResidentNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function AreProgramsResidentNV(n: Int32; programs: IntPtr; residences: IntPtr): boolean :=
    z_AreProgramsResidentNV_ovr_8(n, programs, residences);
    
    private static procedure z_BindProgramNV_ovr_0(target: VertexAttribEnumNV; id: UInt32);
    external 'opengl32.dll' name 'glBindProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindProgramNV(target: VertexAttribEnumNV; id: UInt32) :=
    z_BindProgramNV_ovr_0(target, id);
    
    private static procedure z_DeleteProgramsNV_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glDeleteProgramsNV';
    private static procedure z_DeleteProgramsNV_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_DeleteProgramsNV_ovr_0(n, programs[0]) else
      z_DeleteProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; var programs: UInt32) :=
    z_DeleteProgramsNV_ovr_0(n, programs);
    private static procedure z_DeleteProgramsNV_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glDeleteProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteProgramsNV(n: Int32; programs: IntPtr) :=
    z_DeleteProgramsNV_ovr_2(n, programs);
    
    private static procedure z_ExecuteProgramNV_ovr_0(target: VertexAttribEnumNV; id: UInt32; var &params: single);
    external 'opengl32.dll' name 'glExecuteProgramNV';
    private static procedure z_ExecuteProgramNV_ovr_0_anh0001(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glExecuteProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ExecuteProgramNV_ovr_0(target, id, &params[0]) else
      z_ExecuteProgramNV_ovr_0_anh0001(target, id, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; var &params: single) :=
    z_ExecuteProgramNV_ovr_0(target, id, &params);
    private static procedure z_ExecuteProgramNV_ovr_2(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr);
    external 'opengl32.dll' name 'glExecuteProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ExecuteProgramNV(target: VertexAttribEnumNV; id: UInt32; &params: IntPtr) :=
    z_ExecuteProgramNV_ovr_2(target, id, &params);
    
    private static procedure z_GenProgramsNV_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glGenProgramsNV';
    private static procedure z_GenProgramsNV_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_GenProgramsNV_ovr_0(n, programs[0]) else
      z_GenProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; var programs: UInt32) :=
    z_GenProgramsNV_ovr_0(n, programs);
    private static procedure z_GenProgramsNV_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glGenProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GenProgramsNV(n: Int32; programs: IntPtr) :=
    z_GenProgramsNV_ovr_2(n, programs);
    
    private static procedure z_GetProgramParameterdvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: real);
    external 'opengl32.dll' name 'glGetProgramParameterdvNV';
    private static procedure z_GetProgramParameterdvNV_ovr_0_anh00001(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramParameterdvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetProgramParameterdvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: real) :=
    z_GetProgramParameterdvNV_ovr_0(target, index, pname, &params);
    private static procedure z_GetProgramParameterdvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterdvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramParameterdvNV_ovr_2(target, index, pname, &params);
    
    private static procedure z_GetProgramParameterfvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: single);
    external 'opengl32.dll' name 'glGetProgramParameterfvNV';
    private static procedure z_GetProgramParameterfvNV_ovr_0_anh00001(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramParameterfvNV_ovr_0(target, index, pname, &params[0]) else
      z_GetProgramParameterfvNV_ovr_0_anh00001(target, index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; var &params: single) :=
    z_GetProgramParameterfvNV_ovr_0(target, index, pname, &params);
    private static procedure z_GetProgramParameterfvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramParameterfvNV(target: VertexAttribEnumNV; index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramParameterfvNV_ovr_2(target, index, pname, &params);
    
    private static procedure z_GetProgramivNV_ovr_0(id: UInt32; pname: VertexAttribEnumNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetProgramivNV';
    private static procedure z_GetProgramivNV_ovr_0_anh0001(id: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: UInt32; pname: VertexAttribEnumNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetProgramivNV_ovr_0(id, pname, &params[0]) else
      z_GetProgramivNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: UInt32; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetProgramivNV_ovr_0(id, pname, &params);
    private static procedure z_GetProgramivNV_ovr_2(id: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetProgramivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramivNV(id: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetProgramivNV_ovr_2(id, pname, &params);
    
    private static procedure z_GetProgramStringNV_ovr_0(id: UInt32; pname: VertexAttribEnumNV; var &program: Byte);
    external 'opengl32.dll' name 'glGetProgramStringNV';
    private static procedure z_GetProgramStringNV_ovr_0_anh0001(id: UInt32; pname: VertexAttribEnumNV; &program: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStringNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: UInt32; pname: VertexAttribEnumNV; &program: array of Byte) :=
    if (&program<>nil) and (&program.Length<>0) then
      z_GetProgramStringNV_ovr_0(id, pname, &program[0]) else
      z_GetProgramStringNV_ovr_0_anh0001(id, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: UInt32; pname: VertexAttribEnumNV; var &program: Byte) :=
    z_GetProgramStringNV_ovr_0(id, pname, &program);
    private static procedure z_GetProgramStringNV_ovr_2(id: UInt32; pname: VertexAttribEnumNV; &program: IntPtr);
    external 'opengl32.dll' name 'glGetProgramStringNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetProgramStringNV(id: UInt32; pname: VertexAttribEnumNV; &program: IntPtr) :=
    z_GetProgramStringNV_ovr_2(id, pname, &program);
    
    private static procedure z_GetTrackMatrixivNV_ovr_0(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetTrackMatrixivNV';
    private static procedure z_GetTrackMatrixivNV_ovr_0_anh00001(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTrackMatrixivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTrackMatrixivNV(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTrackMatrixivNV_ovr_0(target, address, pname, &params[0]) else
      z_GetTrackMatrixivNV_ovr_0_anh00001(target, address, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTrackMatrixivNV(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetTrackMatrixivNV_ovr_0(target, address, pname, &params);
    private static procedure z_GetTrackMatrixivNV_ovr_2(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTrackMatrixivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTrackMatrixivNV(target: VertexAttribEnumNV; address: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetTrackMatrixivNV_ovr_2(target, address, pname, &params);
    
    private static procedure z_GetVertexAttribdvNV_ovr_0(index: UInt32; pname: VertexAttribEnumNV; var &params: real);
    external 'opengl32.dll' name 'glGetVertexAttribdvNV';
    private static procedure z_GetVertexAttribdvNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvNV(index: UInt32; pname: VertexAttribEnumNV; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribdvNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribdvNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvNV(index: UInt32; pname: VertexAttribEnumNV; var &params: real) :=
    z_GetVertexAttribdvNV_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribdvNV_ovr_2(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribdvNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribdvNV_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribfvNV_ovr_0(index: UInt32; pname: VertexAttribEnumNV; var &params: single);
    external 'opengl32.dll' name 'glGetVertexAttribfvNV';
    private static procedure z_GetVertexAttribfvNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvNV(index: UInt32; pname: VertexAttribEnumNV; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribfvNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribfvNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvNV(index: UInt32; pname: VertexAttribEnumNV; var &params: single) :=
    z_GetVertexAttribfvNV_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribfvNV_ovr_2(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribfvNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribfvNV_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribivNV_ovr_0(index: UInt32; pname: VertexAttribEnumNV; var &params: Int32);
    external 'opengl32.dll' name 'glGetVertexAttribivNV';
    private static procedure z_GetVertexAttribivNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivNV(index: UInt32; pname: VertexAttribEnumNV; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribivNV_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribivNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivNV(index: UInt32; pname: VertexAttribEnumNV; var &params: Int32) :=
    z_GetVertexAttribivNV_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribivNV_ovr_2(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribivNV(index: UInt32; pname: VertexAttribEnumNV; &params: IntPtr) :=
    z_GetVertexAttribivNV_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribPointervNV_ovr_0(index: UInt32; pname: VertexAttribEnumNV; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervNV';
    private static procedure z_GetVertexAttribPointervNV_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnumNV; _pointer: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribPointervNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervNV(index: UInt32; pname: VertexAttribEnumNV; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_GetVertexAttribPointervNV_ovr_0(index, pname, _pointer[0]) else
      z_GetVertexAttribPointervNV_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervNV(index: UInt32; pname: VertexAttribEnumNV; var _pointer: IntPtr) :=
    z_GetVertexAttribPointervNV_ovr_0(index, pname, _pointer);
    private static procedure z_GetVertexAttribPointervNV_ovr_2(index: UInt32; pname: VertexAttribEnumNV; _pointer: pointer);
    external 'opengl32.dll' name 'glGetVertexAttribPointervNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribPointervNV(index: UInt32; pname: VertexAttribEnumNV; _pointer: pointer) :=
    z_GetVertexAttribPointervNV_ovr_2(index, pname, _pointer);
    
    private static function z_IsProgramNV_ovr_0(id: UInt32): boolean;
    external 'opengl32.dll' name 'glIsProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsProgramNV(id: UInt32): boolean :=
    z_IsProgramNV_ovr_0(id);
    
    private static procedure z_LoadProgramNV_ovr_0(target: VertexAttribEnumNV; id: UInt32; len: Int32; var &program: Byte);
    external 'opengl32.dll' name 'glLoadProgramNV';
    private static procedure z_LoadProgramNV_ovr_0_anh00001(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr);
    external 'opengl32.dll' name 'glLoadProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: array of Byte) :=
    if (&program<>nil) and (&program.Length<>0) then
      z_LoadProgramNV_ovr_0(target, id, len, &program[0]) else
      z_LoadProgramNV_ovr_0_anh00001(target, id, len, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; var &program: Byte) :=
    z_LoadProgramNV_ovr_0(target, id, len, &program);
    private static procedure z_LoadProgramNV_ovr_2(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr);
    external 'opengl32.dll' name 'glLoadProgramNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadProgramNV(target: VertexAttribEnumNV; id: UInt32; len: Int32; &program: IntPtr) :=
    z_LoadProgramNV_ovr_2(target, id, len, &program);
    
    private static procedure z_ProgramParameter4dNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glProgramParameter4dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dNV(target: VertexAttribEnumNV; index: UInt32; x: real; y: real; z: real; w: real) :=
    z_ProgramParameter4dNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramParameter4dvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; var v: real);
    external 'opengl32.dll' name 'glProgramParameter4dvNV';
    private static procedure z_ProgramParameter4dvNV_ovr_0_anh0001(target: VertexAttribEnumNV; index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameter4dvNV_ovr_0(target, index, v[0]) else
      z_ProgramParameter4dvNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; var v: real) :=
    z_ProgramParameter4dvNV_ovr_0(target, index, v);
    private static procedure z_ProgramParameter4dvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameter4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4dvNV(target: VertexAttribEnumNV; index: UInt32; v: IntPtr) :=
    z_ProgramParameter4dvNV_ovr_2(target, index, v);
    
    private static procedure z_ProgramParameter4fNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glProgramParameter4fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fNV(target: VertexAttribEnumNV; index: UInt32; x: single; y: single; z: single; w: single) :=
    z_ProgramParameter4fNV_ovr_0(target, index, x, y, z, w);
    
    private static procedure z_ProgramParameter4fvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; var v: single);
    external 'opengl32.dll' name 'glProgramParameter4fvNV';
    private static procedure z_ProgramParameter4fvNV_ovr_0_anh0001(target: VertexAttribEnumNV; index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameter4fvNV_ovr_0(target, index, v[0]) else
      z_ProgramParameter4fvNV_ovr_0_anh0001(target, index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; var v: single) :=
    z_ProgramParameter4fvNV_ovr_0(target, index, v);
    private static procedure z_ProgramParameter4fvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameter4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameter4fvNV(target: VertexAttribEnumNV; index: UInt32; v: IntPtr) :=
    z_ProgramParameter4fvNV_ovr_2(target, index, v);
    
    private static procedure z_ProgramParameters4dvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glProgramParameters4dvNV';
    private static procedure z_ProgramParameters4dvNV_ovr_0_anh00001(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameters4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameters4dvNV_ovr_0(target, index, count, v[0]) else
      z_ProgramParameters4dvNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: real) :=
    z_ProgramParameters4dvNV_ovr_0(target, index, count, v);
    private static procedure z_ProgramParameters4dvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameters4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4dvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr) :=
    z_ProgramParameters4dvNV_ovr_2(target, index, count, v);
    
    private static procedure z_ProgramParameters4fvNV_ovr_0(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glProgramParameters4fvNV';
    private static procedure z_ProgramParameters4fvNV_ovr_0_anh00001(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameters4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ProgramParameters4fvNV_ovr_0(target, index, count, v[0]) else
      z_ProgramParameters4fvNV_ovr_0_anh00001(target, index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; var v: single) :=
    z_ProgramParameters4fvNV_ovr_0(target, index, count, v);
    private static procedure z_ProgramParameters4fvNV_ovr_2(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glProgramParameters4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ProgramParameters4fvNV(target: VertexAttribEnumNV; index: UInt32; count: Int32; v: IntPtr) :=
    z_ProgramParameters4fvNV_ovr_2(target, index, count, v);
    
    private static procedure z_RequestResidentProgramsNV_ovr_0(n: Int32; var programs: UInt32);
    external 'opengl32.dll' name 'glRequestResidentProgramsNV';
    private static procedure z_RequestResidentProgramsNV_ovr_0_anh001(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glRequestResidentProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; programs: array of UInt32) :=
    if (programs<>nil) and (programs.Length<>0) then
      z_RequestResidentProgramsNV_ovr_0(n, programs[0]) else
      z_RequestResidentProgramsNV_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; var programs: UInt32) :=
    z_RequestResidentProgramsNV_ovr_0(n, programs);
    private static procedure z_RequestResidentProgramsNV_ovr_2(n: Int32; programs: IntPtr);
    external 'opengl32.dll' name 'glRequestResidentProgramsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RequestResidentProgramsNV(n: Int32; programs: IntPtr) :=
    z_RequestResidentProgramsNV_ovr_2(n, programs);
    
    private static procedure z_TrackMatrixNV_ovr_0(target: VertexAttribEnumNV; address: UInt32; matrix: VertexAttribEnumNV; transform: VertexAttribEnumNV);
    external 'opengl32.dll' name 'glTrackMatrixNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TrackMatrixNV(target: VertexAttribEnumNV; address: UInt32; matrix: VertexAttribEnumNV; transform: VertexAttribEnumNV) :=
    z_TrackMatrixNV_ovr_0(target, address, matrix, transform);
    
    private static procedure z_VertexAttribPointerNV_ovr_0(index: UInt32; fsize: Int32; &type: VertexAttribEnumNV; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribPointerNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribPointerNV(index: UInt32; fsize: Int32; &type: VertexAttribEnumNV; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribPointerNV_ovr_0(index, fsize, &type, stride, pointer);
    
    private static procedure z_VertexAttrib1dNV_ovr_0(index: UInt32; x: real);
    external 'opengl32.dll' name 'glVertexAttrib1dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dNV(index: UInt32; x: real) :=
    z_VertexAttrib1dNV_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1dvNV_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib1dvNV';
    private static procedure z_VertexAttrib1dvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib1dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib1dvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib1dvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1dvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1fNV_ovr_0(index: UInt32; x: single);
    external 'opengl32.dll' name 'glVertexAttrib1fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fNV(index: UInt32; x: single) :=
    z_VertexAttrib1fNV_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1fvNV_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib1fvNV';
    private static procedure z_VertexAttrib1fvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib1fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib1fvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib1fvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1fvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib1sNV_ovr_0(index: UInt32; x: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1sNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1sNV(index: UInt32; x: Int16) :=
    z_VertexAttrib1sNV_ovr_0(index, x);
    
    private static procedure z_VertexAttrib1svNV_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib1svNV';
    private static procedure z_VertexAttrib1svNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib1svNV_ovr_0(index, v[0]) else
      z_VertexAttrib1svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib1svNV_ovr_0(index, v);
    private static procedure z_VertexAttrib1svNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib1svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib1svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib1svNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2dNV_ovr_0(index: UInt32; x: real; y: real);
    external 'opengl32.dll' name 'glVertexAttrib2dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dNV(index: UInt32; x: real; y: real) :=
    z_VertexAttrib2dNV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2dvNV_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib2dvNV';
    private static procedure z_VertexAttrib2dvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib2dvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib2dvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2dvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2fNV_ovr_0(index: UInt32; x: single; y: single);
    external 'opengl32.dll' name 'glVertexAttrib2fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fNV(index: UInt32; x: single; y: single) :=
    z_VertexAttrib2fNV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2fvNV_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib2fvNV';
    private static procedure z_VertexAttrib2fvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib2fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib2fvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib2fvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2fvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib2sNV_ovr_0(index: UInt32; x: Int16; y: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2sNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2sNV(index: UInt32; x: Int16; y: Int16) :=
    z_VertexAttrib2sNV_ovr_0(index, x, y);
    
    private static procedure z_VertexAttrib2svNV_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib2svNV';
    private static procedure z_VertexAttrib2svNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib2svNV_ovr_0(index, v[0]) else
      z_VertexAttrib2svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib2svNV_ovr_0(index, v);
    private static procedure z_VertexAttrib2svNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib2svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib2svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib2svNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3dNV_ovr_0(index: UInt32; x: real; y: real; z: real);
    external 'opengl32.dll' name 'glVertexAttrib3dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dNV(index: UInt32; x: real; y: real; z: real) :=
    z_VertexAttrib3dNV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3dvNV_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib3dvNV';
    private static procedure z_VertexAttrib3dvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib3dvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib3dvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3dvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3fNV_ovr_0(index: UInt32; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glVertexAttrib3fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fNV(index: UInt32; x: single; y: single; z: single) :=
    z_VertexAttrib3fNV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3fvNV_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib3fvNV';
    private static procedure z_VertexAttrib3fvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib3fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib3fvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib3fvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3fvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib3sNV_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3sNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3sNV(index: UInt32; x: Int16; y: Int16; z: Int16) :=
    z_VertexAttrib3sNV_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttrib3svNV_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib3svNV';
    private static procedure z_VertexAttrib3svNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib3svNV_ovr_0(index, v[0]) else
      z_VertexAttrib3svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib3svNV_ovr_0(index, v);
    private static procedure z_VertexAttrib3svNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib3svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib3svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib3svNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4dNV_ovr_0(index: UInt32; x: real; y: real; z: real; w: real);
    external 'opengl32.dll' name 'glVertexAttrib4dNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dNV(index: UInt32; x: real; y: real; z: real; w: real) :=
    z_VertexAttrib4dNV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4dvNV_ovr_0(index: UInt32; var v: real);
    external 'opengl32.dll' name 'glVertexAttrib4dvNV';
    private static procedure z_VertexAttrib4dvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4dvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4dvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; var v: real) :=
    z_VertexAttrib4dvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib4dvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4dvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4dvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4fNV_ovr_0(index: UInt32; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glVertexAttrib4fNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fNV(index: UInt32; x: single; y: single; z: single; w: single) :=
    z_VertexAttrib4fNV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4fvNV_ovr_0(index: UInt32; var v: single);
    external 'opengl32.dll' name 'glVertexAttrib4fvNV';
    private static procedure z_VertexAttrib4fvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4fvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4fvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; var v: single) :=
    z_VertexAttrib4fvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib4fvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4fvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4fvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4sNV_ovr_0(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4sNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4sNV(index: UInt32; x: Int16; y: Int16; z: Int16; w: Int16) :=
    z_VertexAttrib4sNV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4svNV_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttrib4svNV';
    private static procedure z_VertexAttrib4svNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4svNV_ovr_0(index, v[0]) else
      z_VertexAttrib4svNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; var v: Int16) :=
    z_VertexAttrib4svNV_ovr_0(index, v);
    private static procedure z_VertexAttrib4svNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4svNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4svNV_ovr_2(index, v);
    
    private static procedure z_VertexAttrib4ubNV_ovr_0(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4ubNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubNV(index: UInt32; x: Byte; y: Byte; z: Byte; w: Byte) :=
    z_VertexAttrib4ubNV_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttrib4ubvNV_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttrib4ubvNV';
    private static procedure z_VertexAttrib4ubvNV_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttrib4ubvNV_ovr_0(index, v[0]) else
      z_VertexAttrib4ubvNV_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; var v: Byte) :=
    z_VertexAttrib4ubvNV_ovr_0(index, v);
    private static procedure z_VertexAttrib4ubvNV_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttrib4ubvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttrib4ubvNV(index: UInt32; v: IntPtr) :=
    z_VertexAttrib4ubvNV_ovr_2(index, v);
    
    private static procedure z_VertexAttribs1dvNV_ovr_0(index: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribs1dvNV';
    private static procedure z_VertexAttribs1dvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs1dvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs1dvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1dvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs1fvNV_ovr_0(index: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glVertexAttribs1fvNV';
    private static procedure z_VertexAttribs1fvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs1fvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs1fvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1fvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs1svNV_ovr_0(index: UInt32; count: Int32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttribs1svNV';
    private static procedure z_VertexAttribs1svNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs1svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs1svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs1svNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs1svNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs1svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs1svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs1svNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs2dvNV_ovr_0(index: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribs2dvNV';
    private static procedure z_VertexAttribs2dvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs2dvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs2dvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2dvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs2fvNV_ovr_0(index: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glVertexAttribs2fvNV';
    private static procedure z_VertexAttribs2fvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs2fvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs2fvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2fvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs2svNV_ovr_0(index: UInt32; count: Int32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttribs2svNV';
    private static procedure z_VertexAttribs2svNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs2svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs2svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs2svNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs2svNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs2svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs2svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs2svNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs3dvNV_ovr_0(index: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribs3dvNV';
    private static procedure z_VertexAttribs3dvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs3dvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs3dvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3dvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs3fvNV_ovr_0(index: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glVertexAttribs3fvNV';
    private static procedure z_VertexAttribs3fvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs3fvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs3fvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3fvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs3svNV_ovr_0(index: UInt32; count: Int32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttribs3svNV';
    private static procedure z_VertexAttribs3svNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs3svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs3svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs3svNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs3svNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs3svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs3svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs3svNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs4dvNV_ovr_0(index: UInt32; count: Int32; var v: real);
    external 'opengl32.dll' name 'glVertexAttribs4dvNV';
    private static procedure z_VertexAttribs4dvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; v: array of real) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4dvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4dvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; var v: real) :=
    z_VertexAttribs4dvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs4dvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4dvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4dvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4dvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs4fvNV_ovr_0(index: UInt32; count: Int32; var v: single);
    external 'opengl32.dll' name 'glVertexAttribs4fvNV';
    private static procedure z_VertexAttribs4fvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4fvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4fvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; var v: single) :=
    z_VertexAttribs4fvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs4fvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4fvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4fvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4fvNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs4svNV_ovr_0(index: UInt32; count: Int32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttribs4svNV';
    private static procedure z_VertexAttribs4svNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4svNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4svNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; var v: Int16) :=
    z_VertexAttribs4svNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs4svNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4svNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4svNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4svNV_ovr_2(index, count, v);
    
    private static procedure z_VertexAttribs4ubvNV_ovr_0(index: UInt32; count: Int32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttribs4ubvNV';
    private static procedure z_VertexAttribs4ubvNV_ovr_0_anh0001(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4ubvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribs4ubvNV_ovr_0(index, count, v[0]) else
      z_VertexAttribs4ubvNV_ovr_0_anh0001(index, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; var v: Byte) :=
    z_VertexAttribs4ubvNV_ovr_0(index, count, v);
    private static procedure z_VertexAttribs4ubvNV_ovr_2(index: UInt32; count: Int32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribs4ubvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribs4ubvNV(index: UInt32; count: Int32; v: IntPtr) :=
    z_VertexAttribs4ubvNV_ovr_2(index, count, v);
    
  end;
  
  glVertexProgram4NV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_VertexAttribI1iEXT_ovr_0(index: UInt32; x: Int32);
    external 'opengl32.dll' name 'glVertexAttribI1iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1iEXT(index: UInt32; x: Int32) :=
    z_VertexAttribI1iEXT_ovr_0(index, x);
    
    private static procedure z_VertexAttribI2iEXT_ovr_0(index: UInt32; x: Int32; y: Int32);
    external 'opengl32.dll' name 'glVertexAttribI2iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2iEXT(index: UInt32; x: Int32; y: Int32) :=
    z_VertexAttribI2iEXT_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribI3iEXT_ovr_0(index: UInt32; x: Int32; y: Int32; z: Int32);
    external 'opengl32.dll' name 'glVertexAttribI3iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3iEXT(index: UInt32; x: Int32; y: Int32; z: Int32) :=
    z_VertexAttribI3iEXT_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribI4iEXT_ovr_0(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32);
    external 'opengl32.dll' name 'glVertexAttribI4iEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4iEXT(index: UInt32; x: Int32; y: Int32; z: Int32; w: Int32) :=
    z_VertexAttribI4iEXT_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribI1uiEXT_ovr_0(index: UInt32; x: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI1uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uiEXT(index: UInt32; x: UInt32) :=
    z_VertexAttribI1uiEXT_ovr_0(index, x);
    
    private static procedure z_VertexAttribI2uiEXT_ovr_0(index: UInt32; x: UInt32; y: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI2uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uiEXT(index: UInt32; x: UInt32; y: UInt32) :=
    z_VertexAttribI2uiEXT_ovr_0(index, x, y);
    
    private static procedure z_VertexAttribI3uiEXT_ovr_0(index: UInt32; x: UInt32; y: UInt32; z: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI3uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32) :=
    z_VertexAttribI3uiEXT_ovr_0(index, x, y, z);
    
    private static procedure z_VertexAttribI4uiEXT_ovr_0(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI4uiEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uiEXT(index: UInt32; x: UInt32; y: UInt32; z: UInt32; w: UInt32) :=
    z_VertexAttribI4uiEXT_ovr_0(index, x, y, z, w);
    
    private static procedure z_VertexAttribI1ivEXT_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttribI1ivEXT';
    private static procedure z_VertexAttribI1ivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI1ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI1ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI1ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI1ivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI1ivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI1ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1ivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI2ivEXT_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttribI2ivEXT';
    private static procedure z_VertexAttribI2ivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI2ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI2ivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI2ivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI2ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2ivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI3ivEXT_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttribI3ivEXT';
    private static procedure z_VertexAttribI3ivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI3ivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI3ivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI3ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3ivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4ivEXT_ovr_0(index: UInt32; var v: Int32);
    external 'opengl32.dll' name 'glVertexAttribI4ivEXT';
    private static procedure z_VertexAttribI4ivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: array of Int32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; var v: Int32) :=
    z_VertexAttribI4ivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4ivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4ivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI1uivEXT_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI1uivEXT';
    private static procedure z_VertexAttribI1uivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI1uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI1uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI1uivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI1uivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI1uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI1uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI1uivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI2uivEXT_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI2uivEXT';
    private static procedure z_VertexAttribI2uivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI2uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI2uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI2uivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI2uivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI2uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI2uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI2uivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI3uivEXT_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI3uivEXT';
    private static procedure z_VertexAttribI3uivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI3uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI3uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI3uivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI3uivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI3uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI3uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI3uivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4uivEXT_ovr_0(index: UInt32; var v: UInt32);
    external 'opengl32.dll' name 'glVertexAttribI4uivEXT';
    private static procedure z_VertexAttribI4uivEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: array of UInt32) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4uivEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4uivEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; var v: UInt32) :=
    z_VertexAttribI4uivEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4uivEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4uivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4uivEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4uivEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4bvEXT_ovr_0(index: UInt32; var v: SByte);
    external 'opengl32.dll' name 'glVertexAttribI4bvEXT';
    private static procedure z_VertexAttribI4bvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: array of SByte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4bvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4bvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; var v: SByte) :=
    z_VertexAttribI4bvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4bvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4bvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4bvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4bvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4svEXT_ovr_0(index: UInt32; var v: Int16);
    external 'opengl32.dll' name 'glVertexAttribI4svEXT';
    private static procedure z_VertexAttribI4svEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: array of Int16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4svEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4svEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; var v: Int16) :=
    z_VertexAttribI4svEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4svEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4svEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4svEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4svEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4ubvEXT_ovr_0(index: UInt32; var v: Byte);
    external 'opengl32.dll' name 'glVertexAttribI4ubvEXT';
    private static procedure z_VertexAttribI4ubvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4ubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: array of Byte) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4ubvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4ubvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; var v: Byte) :=
    z_VertexAttribI4ubvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4ubvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4ubvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4ubvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4ubvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribI4usvEXT_ovr_0(index: UInt32; var v: UInt16);
    external 'opengl32.dll' name 'glVertexAttribI4usvEXT';
    private static procedure z_VertexAttribI4usvEXT_ovr_0_anh001(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4usvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: array of UInt16) :=
    if (v<>nil) and (v.Length<>0) then
      z_VertexAttribI4usvEXT_ovr_0(index, v[0]) else
      z_VertexAttribI4usvEXT_ovr_0_anh001(index, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; var v: UInt16) :=
    z_VertexAttribI4usvEXT_ovr_0(index, v);
    private static procedure z_VertexAttribI4usvEXT_ovr_2(index: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribI4usvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribI4usvEXT(index: UInt32; v: IntPtr) :=
    z_VertexAttribI4usvEXT_ovr_2(index, v);
    
    private static procedure z_VertexAttribIPointerEXT_ovr_0(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr);
    external 'opengl32.dll' name 'glVertexAttribIPointerEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VertexAttribIPointerEXT(index: UInt32; size: Int32; &type: VertexAttribPointerType; stride: Int32; pointer: IntPtr) :=
    z_VertexAttribIPointerEXT_ovr_0(index, size, &type, stride, pointer);
    
    private static procedure z_GetVertexAttribIivEXT_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetVertexAttribIivEXT';
    private static procedure z_GetVertexAttribIivEXT_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribIivEXT_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribIivEXT_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; var &params: Int32) :=
    z_GetVertexAttribIivEXT_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribIivEXT_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribIivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIivEXT_ovr_2(index, pname, &params);
    
    private static procedure z_GetVertexAttribIuivEXT_ovr_0(index: UInt32; pname: VertexAttribEnum; var &params: UInt32);
    external 'opengl32.dll' name 'glGetVertexAttribIuivEXT';
    private static procedure z_GetVertexAttribIuivEXT_ovr_0_anh0001(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; &params: array of UInt32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVertexAttribIuivEXT_ovr_0(index, pname, &params[0]) else
      z_GetVertexAttribIuivEXT_ovr_0_anh0001(index, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; var &params: UInt32) :=
    z_GetVertexAttribIuivEXT_ovr_0(index, pname, &params);
    private static procedure z_GetVertexAttribIuivEXT_ovr_2(index: UInt32; pname: VertexAttribEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVertexAttribIuivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVertexAttribIuivEXT(index: UInt32; pname: VertexAttribEnum; &params: IntPtr) :=
    z_GetVertexAttribIuivEXT_ovr_2(index, pname, &params);
    
  end;
  
  glVideoCaptureNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_BeginVideoCaptureNV_ovr_0(video_capture_slot: UInt32);
    external 'opengl32.dll' name 'glBeginVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BeginVideoCaptureNV(video_capture_slot: UInt32) :=
    z_BeginVideoCaptureNV_ovr_0(video_capture_slot);
    
    private static procedure z_BindVideoCaptureStreamBufferNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; offset: IntPtr);
    external 'opengl32.dll' name 'glBindVideoCaptureStreamBufferNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVideoCaptureStreamBufferNV(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; offset: IntPtr) :=
    z_BindVideoCaptureStreamBufferNV_ovr_0(video_capture_slot, stream, frame_region, offset);
    
    private static procedure z_BindVideoCaptureStreamTextureNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; target: DummyEnum; texture: UInt32);
    external 'opengl32.dll' name 'glBindVideoCaptureStreamTextureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BindVideoCaptureStreamTextureNV(video_capture_slot: UInt32; stream: UInt32; frame_region: DummyEnum; target: DummyEnum; texture: UInt32) :=
    z_BindVideoCaptureStreamTextureNV_ovr_0(video_capture_slot, stream, frame_region, target, texture);
    
    private static procedure z_EndVideoCaptureNV_ovr_0(video_capture_slot: UInt32);
    external 'opengl32.dll' name 'glEndVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EndVideoCaptureNV(video_capture_slot: UInt32) :=
    z_EndVideoCaptureNV_ovr_0(video_capture_slot);
    
    private static procedure z_GetVideoCaptureivNV_ovr_0(video_capture_slot: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetVideoCaptureivNV';
    private static procedure z_GetVideoCaptureivNV_ovr_0_anh0001(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureivNV_ovr_0(video_capture_slot, pname, &params[0]) else
      z_GetVideoCaptureivNV_ovr_0_anh0001(video_capture_slot, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoCaptureivNV_ovr_0(video_capture_slot, pname, &params);
    private static procedure z_GetVideoCaptureivNV_ovr_2(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureivNV(video_capture_slot: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureivNV_ovr_2(video_capture_slot, pname, &params);
    
    private static procedure z_GetVideoCaptureStreamivNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamivNV';
    private static procedure z_GetVideoCaptureStreamivNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamivNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamivNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_GetVideoCaptureStreamivNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_GetVideoCaptureStreamivNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamivNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private static procedure z_GetVideoCaptureStreamfvNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamfvNV';
    private static procedure z_GetVideoCaptureStreamfvNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamfvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamfvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single) :=
    z_GetVideoCaptureStreamfvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_GetVideoCaptureStreamfvNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamfvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private static procedure z_GetVideoCaptureStreamdvNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamdvNV';
    private static procedure z_GetVideoCaptureStreamdvNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetVideoCaptureStreamdvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_GetVideoCaptureStreamdvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real) :=
    z_GetVideoCaptureStreamdvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_GetVideoCaptureStreamdvNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetVideoCaptureStreamdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetVideoCaptureStreamdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_GetVideoCaptureStreamdvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private static function z_VideoCaptureNV_ovr_0(video_capture_slot: UInt32; var sequence_num: UInt32; var capture_time: UInt64): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    private static function z_VideoCaptureNV_ovr_0_anh0010(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    private static function z_VideoCaptureNV_ovr_0_anh0001(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    private static function z_VideoCaptureNV_ovr_0_anh0011(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; capture_time: array of UInt64): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      if (capture_time<>nil) and (capture_time.Length<>0) then
        z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num[0], capture_time[0]) else
        z_VideoCaptureNV_ovr_0_anh0001(video_capture_slot, sequence_num[0], IntPtr.Zero) else
      if (capture_time<>nil) and (capture_time.Length<>0) then
        z_VideoCaptureNV_ovr_0_anh0010(video_capture_slot, IntPtr.Zero, capture_time[0]) else
        z_VideoCaptureNV_ovr_0_anh0011(video_capture_slot, IntPtr.Zero, IntPtr.Zero);
    private static function z_VideoCaptureNV_ovr_1_anh0010(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; var capture_time: UInt64): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num[0], capture_time) else
      z_VideoCaptureNV_ovr_0_anh0010(video_capture_slot, IntPtr.Zero, capture_time);
    private static function z_VideoCaptureNV_ovr_2(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    private static function z_VideoCaptureNV_ovr_2_anh0010(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: array of UInt32; capture_time: IntPtr): DummyEnum :=
    if (sequence_num<>nil) and (sequence_num.Length<>0) then
      z_VideoCaptureNV_ovr_2(video_capture_slot, sequence_num[0], capture_time) else
      z_VideoCaptureNV_ovr_2_anh0010(video_capture_slot, IntPtr.Zero, capture_time);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: array of UInt64): DummyEnum :=
    if (capture_time<>nil) and (capture_time.Length<>0) then
      z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num, capture_time[0]) else
      z_VideoCaptureNV_ovr_0_anh0001(video_capture_slot, sequence_num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; var capture_time: UInt64): DummyEnum :=
    z_VideoCaptureNV_ovr_0(video_capture_slot, sequence_num, capture_time);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; var sequence_num: UInt32; capture_time: IntPtr): DummyEnum :=
    z_VideoCaptureNV_ovr_2(video_capture_slot, sequence_num, capture_time);
    private static function z_VideoCaptureNV_ovr_6(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    private static function z_VideoCaptureNV_ovr_6_anh0001(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: array of UInt64): DummyEnum :=
    if (capture_time<>nil) and (capture_time.Length<>0) then
      z_VideoCaptureNV_ovr_6(video_capture_slot, sequence_num, capture_time[0]) else
      z_VideoCaptureNV_ovr_6_anh0001(video_capture_slot, sequence_num, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; var capture_time: UInt64): DummyEnum :=
    z_VideoCaptureNV_ovr_6(video_capture_slot, sequence_num, capture_time);
    private static function z_VideoCaptureNV_ovr_8(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum;
    external 'opengl32.dll' name 'glVideoCaptureNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function VideoCaptureNV(video_capture_slot: UInt32; sequence_num: IntPtr; capture_time: IntPtr): DummyEnum :=
    z_VideoCaptureNV_ovr_8(video_capture_slot, sequence_num, capture_time);
    
    private static procedure z_VideoCaptureStreamParameterivNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterivNV';
    private static procedure z_VideoCaptureStreamParameterivNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterivNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterivNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: Int32) :=
    z_VideoCaptureStreamParameterivNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_VideoCaptureStreamParameterivNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterivNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterivNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterivNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private static procedure z_VideoCaptureStreamParameterfvNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterfvNV';
    private static procedure z_VideoCaptureStreamParameterfvNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterfvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterfvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: single) :=
    z_VideoCaptureStreamParameterfvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_VideoCaptureStreamParameterfvNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterfvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterfvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterfvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
    private static procedure z_VideoCaptureStreamParameterdvNV_ovr_0(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterdvNV';
    private static procedure z_VideoCaptureStreamParameterdvNV_ovr_0_anh00001(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: array of real) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_VideoCaptureStreamParameterdvNV_ovr_0(video_capture_slot, stream, pname, &params[0]) else
      z_VideoCaptureStreamParameterdvNV_ovr_0_anh00001(video_capture_slot, stream, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; var &params: real) :=
    z_VideoCaptureStreamParameterdvNV_ovr_0(video_capture_slot, stream, pname, &params);
    private static procedure z_VideoCaptureStreamParameterdvNV_ovr_2(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glVideoCaptureStreamParameterdvNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure VideoCaptureStreamParameterdvNV(video_capture_slot: UInt32; stream: UInt32; pname: DummyEnum; &params: IntPtr) :=
    z_VideoCaptureStreamParameterdvNV_ovr_2(video_capture_slot, stream, pname, &params);
    
  end;
  
  glViewportSwizzleNV = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ViewportSwizzleNV_ovr_0(index: UInt32; swizzlex: DummyEnum; swizzley: DummyEnum; swizzlez: DummyEnum; swizzlew: DummyEnum);
    external 'opengl32.dll' name 'glViewportSwizzleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ViewportSwizzleNV(index: UInt32; swizzlex: DummyEnum; swizzley: DummyEnum; swizzlez: DummyEnum; swizzlew: DummyEnum) :=
    z_ViewportSwizzleNV_ovr_0(index, swizzlex, swizzley, swizzlez, swizzlew);
    
  end;
  
  glByteCoordinatesOES = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_MultiTexCoord1bOES_ovr_0(texture: TextureUnit; s: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord1bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bOES(texture: TextureUnit; s: SByte) :=
    z_MultiTexCoord1bOES_ovr_0(texture, s);
    
    private static procedure z_MultiTexCoord1bvOES_ovr_0(texture: TextureUnit; var coords: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord1bvOES';
    private static procedure z_MultiTexCoord1bvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord1bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord1bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord1bvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord1bvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord1bvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord2bOES_ovr_0(texture: TextureUnit; s: SByte; t: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord2bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bOES(texture: TextureUnit; s: SByte; t: SByte) :=
    z_MultiTexCoord2bOES_ovr_0(texture, s, t);
    
    private static procedure z_MultiTexCoord2bvOES_ovr_0(texture: TextureUnit; var coords: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord2bvOES';
    private static procedure z_MultiTexCoord2bvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord2bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord2bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord2bvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord2bvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord2bvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord3bOES_ovr_0(texture: TextureUnit; s: SByte; t: SByte; r: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord3bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bOES(texture: TextureUnit; s: SByte; t: SByte; r: SByte) :=
    z_MultiTexCoord3bOES_ovr_0(texture, s, t, r);
    
    private static procedure z_MultiTexCoord3bvOES_ovr_0(texture: TextureUnit; var coords: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord3bvOES';
    private static procedure z_MultiTexCoord3bvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord3bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord3bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord3bvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord3bvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord3bvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord4bOES_ovr_0(texture: TextureUnit; s: SByte; t: SByte; r: SByte; q: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord4bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bOES(texture: TextureUnit; s: SByte; t: SByte; r: SByte; q: SByte) :=
    z_MultiTexCoord4bOES_ovr_0(texture, s, t, r, q);
    
    private static procedure z_MultiTexCoord4bvOES_ovr_0(texture: TextureUnit; var coords: SByte);
    external 'opengl32.dll' name 'glMultiTexCoord4bvOES';
    private static procedure z_MultiTexCoord4bvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord4bvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord4bvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; var coords: SByte) :=
    z_MultiTexCoord4bvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord4bvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4bvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord4bvOES_ovr_2(texture, coords);
    
    private static procedure z_TexCoord1bOES_ovr_0(s: SByte);
    external 'opengl32.dll' name 'glTexCoord1bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bOES(s: SByte) :=
    z_TexCoord1bOES_ovr_0(s);
    
    private static procedure z_TexCoord1bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glTexCoord1bvOES';
    private static procedure z_TexCoord1bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord1bvOES_ovr_0(coords[0]) else
      z_TexCoord1bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bvOES(var coords: SByte) :=
    z_TexCoord1bvOES_ovr_0(coords);
    private static procedure z_TexCoord1bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1bvOES(coords: IntPtr) :=
    z_TexCoord1bvOES_ovr_2(coords);
    
    private static procedure z_TexCoord2bOES_ovr_0(s: SByte; t: SByte);
    external 'opengl32.dll' name 'glTexCoord2bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bOES(s: SByte; t: SByte) :=
    z_TexCoord2bOES_ovr_0(s, t);
    
    private static procedure z_TexCoord2bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glTexCoord2bvOES';
    private static procedure z_TexCoord2bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord2bvOES_ovr_0(coords[0]) else
      z_TexCoord2bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(var coords: SByte) :=
    z_TexCoord2bvOES_ovr_0(coords);
    private static procedure z_TexCoord2bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2bvOES(coords: IntPtr) :=
    z_TexCoord2bvOES_ovr_2(coords);
    
    private static procedure z_TexCoord3bOES_ovr_0(s: SByte; t: SByte; r: SByte);
    external 'opengl32.dll' name 'glTexCoord3bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bOES(s: SByte; t: SByte; r: SByte) :=
    z_TexCoord3bOES_ovr_0(s, t, r);
    
    private static procedure z_TexCoord3bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glTexCoord3bvOES';
    private static procedure z_TexCoord3bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord3bvOES_ovr_0(coords[0]) else
      z_TexCoord3bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(var coords: SByte) :=
    z_TexCoord3bvOES_ovr_0(coords);
    private static procedure z_TexCoord3bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3bvOES(coords: IntPtr) :=
    z_TexCoord3bvOES_ovr_2(coords);
    
    private static procedure z_TexCoord4bOES_ovr_0(s: SByte; t: SByte; r: SByte; q: SByte);
    external 'opengl32.dll' name 'glTexCoord4bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bOES(s: SByte; t: SByte; r: SByte; q: SByte) :=
    z_TexCoord4bOES_ovr_0(s, t, r, q);
    
    private static procedure z_TexCoord4bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glTexCoord4bvOES';
    private static procedure z_TexCoord4bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord4bvOES_ovr_0(coords[0]) else
      z_TexCoord4bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(var coords: SByte) :=
    z_TexCoord4bvOES_ovr_0(coords);
    private static procedure z_TexCoord4bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4bvOES(coords: IntPtr) :=
    z_TexCoord4bvOES_ovr_2(coords);
    
    private static procedure z_Vertex2bOES_ovr_0(x: SByte; y: SByte);
    external 'opengl32.dll' name 'glVertex2bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bOES(x: SByte; y: SByte) :=
    z_Vertex2bOES_ovr_0(x, y);
    
    private static procedure z_Vertex2bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glVertex2bvOES';
    private static procedure z_Vertex2bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex2bvOES_ovr_0(coords[0]) else
      z_Vertex2bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(var coords: SByte) :=
    z_Vertex2bvOES_ovr_0(coords);
    private static procedure z_Vertex2bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex2bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2bvOES(coords: IntPtr) :=
    z_Vertex2bvOES_ovr_2(coords);
    
    private static procedure z_Vertex3bOES_ovr_0(x: SByte; y: SByte; z: SByte);
    external 'opengl32.dll' name 'glVertex3bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bOES(x: SByte; y: SByte; z: SByte) :=
    z_Vertex3bOES_ovr_0(x, y, z);
    
    private static procedure z_Vertex3bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glVertex3bvOES';
    private static procedure z_Vertex3bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex3bvOES_ovr_0(coords[0]) else
      z_Vertex3bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(var coords: SByte) :=
    z_Vertex3bvOES_ovr_0(coords);
    private static procedure z_Vertex3bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex3bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3bvOES(coords: IntPtr) :=
    z_Vertex3bvOES_ovr_2(coords);
    
    private static procedure z_Vertex4bOES_ovr_0(x: SByte; y: SByte; z: SByte; w: SByte);
    external 'opengl32.dll' name 'glVertex4bOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bOES(x: SByte; y: SByte; z: SByte; w: SByte) :=
    z_Vertex4bOES_ovr_0(x, y, z, w);
    
    private static procedure z_Vertex4bvOES_ovr_0(var coords: SByte);
    external 'opengl32.dll' name 'glVertex4bvOES';
    private static procedure z_Vertex4bvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(coords: array of SByte) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex4bvOES_ovr_0(coords[0]) else
      z_Vertex4bvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(var coords: SByte) :=
    z_Vertex4bvOES_ovr_0(coords);
    private static procedure z_Vertex4bvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex4bvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4bvOES(coords: IntPtr) :=
    z_Vertex4bvOES_ovr_2(coords);
    
  end;
  
  glFixedPointOES = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_AlphaFuncxOES_ovr_0(func: AlphaFunction; ref: Fixed);
    external 'opengl32.dll' name 'glAlphaFuncxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AlphaFuncxOES(func: AlphaFunction; ref: Fixed) :=
    z_AlphaFuncxOES_ovr_0(func, ref);
    
    private static procedure z_ClearColorxOES_ovr_0(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed);
    external 'opengl32.dll' name 'glClearColorxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearColorxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_ClearColorxOES_ovr_0(red, green, blue, alpha);
    
    private static procedure z_ClearDepthxOES_ovr_0(depth: Fixed);
    external 'opengl32.dll' name 'glClearDepthxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthxOES(depth: Fixed) :=
    z_ClearDepthxOES_ovr_0(depth);
    
    private static procedure z_ClipPlanexOES_ovr_0(plane: ClipPlaneName; var equation: Fixed);
    external 'opengl32.dll' name 'glClipPlanexOES';
    private static procedure z_ClipPlanexOES_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlanexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; equation: array of Fixed) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlanexOES_ovr_0(plane, equation[0]) else
      z_ClipPlanexOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; var equation: Fixed) :=
    z_ClipPlanexOES_ovr_0(plane, equation);
    private static procedure z_ClipPlanexOES_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlanexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanexOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlanexOES_ovr_2(plane, equation);
    
    private static procedure z_Color4xOES_ovr_0(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed);
    external 'opengl32.dll' name 'glColor4xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_Color4xOES_ovr_0(red, green, blue, alpha);
    
    private static procedure z_DepthRangexOES_ovr_0(n: Fixed; f: Fixed);
    external 'opengl32.dll' name 'glDepthRangexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangexOES(n: Fixed; f: Fixed) :=
    z_DepthRangexOES_ovr_0(n, f);
    
    private static procedure z_FogxOES_ovr_0(pname: FogPName; param: Fixed);
    external 'opengl32.dll' name 'glFogxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxOES(pname: FogPName; param: Fixed) :=
    z_FogxOES_ovr_0(pname, param);
    
    private static procedure z_FogxvOES_ovr_0(pname: FogPName; var param: Fixed);
    external 'opengl32.dll' name 'glFogxvOES';
    private static procedure z_FogxvOES_ovr_0_anh001(pname: FogPName; param: IntPtr);
    external 'opengl32.dll' name 'glFogxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_FogxvOES_ovr_0(pname, param[0]) else
      z_FogxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; var param: Fixed) :=
    z_FogxvOES_ovr_0(pname, param);
    private static procedure z_FogxvOES_ovr_2(pname: FogPName; param: IntPtr);
    external 'opengl32.dll' name 'glFogxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogxvOES(pname: FogPName; param: IntPtr) :=
    z_FogxvOES_ovr_2(pname, param);
    
    private static procedure z_FrustumxOES_ovr_0(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed);
    external 'opengl32.dll' name 'glFrustumxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrustumxOES(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed) :=
    z_FrustumxOES_ovr_0(l, r, b, t, n, f);
    
    private static procedure z_GetClipPlanexOES_ovr_0(plane: ClipPlaneName; var equation: Fixed);
    external 'opengl32.dll' name 'glGetClipPlanexOES';
    private static procedure z_GetClipPlanexOES_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlanexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; equation: array of Fixed) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlanexOES_ovr_0(plane, equation[0]) else
      z_GetClipPlanexOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; var equation: Fixed) :=
    z_GetClipPlanexOES_ovr_0(plane, equation);
    private static procedure z_GetClipPlanexOES_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlanexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanexOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlanexOES_ovr_2(plane, equation);
    
    private static procedure z_GetFixedvOES_ovr_0(pname: GetPName; var &params: Fixed);
    external 'opengl32.dll' name 'glGetFixedvOES';
    private static procedure z_GetFixedvOES_ovr_0_anh001(pname: GetPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFixedvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFixedvOES_ovr_0(pname, &params[0]) else
      z_GetFixedvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; var &params: Fixed) :=
    z_GetFixedvOES_ovr_0(pname, &params);
    private static procedure z_GetFixedvOES_ovr_2(pname: GetPName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFixedvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFixedvOES(pname: GetPName; &params: IntPtr) :=
    z_GetFixedvOES_ovr_2(pname, &params);
    
    private static procedure z_GetTexEnvxvOES_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glGetTexEnvxvOES';
    private static procedure z_GetTexEnvxvOES_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnvxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexEnvxvOES_ovr_0(target, pname, &params[0]) else
      z_GetTexEnvxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed) :=
    z_GetTexEnvxvOES_ovr_0(target, pname, &params);
    private static procedure z_GetTexEnvxvOES_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexEnvxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_GetTexEnvxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_GetTexParameterxvOES_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glGetTexParameterxvOES';
    private static procedure z_GetTexParameterxvOES_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetTexParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed) :=
    z_GetTexParameterxvOES_ovr_0(target, pname, &params);
    private static procedure z_GetTexParameterxvOES_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexParameterxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_LightModelxOES_ovr_0(pname: LightModelParameter; param: Fixed);
    external 'opengl32.dll' name 'glLightModelxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxOES(pname: LightModelParameter; param: Fixed) :=
    z_LightModelxOES_ovr_0(pname, param);
    
    private static procedure z_LightModelxvOES_ovr_0(pname: LightModelParameter; var param: Fixed);
    external 'opengl32.dll' name 'glLightModelxvOES';
    private static procedure z_LightModelxvOES_ovr_0_anh001(pname: LightModelParameter; param: IntPtr);
    external 'opengl32.dll' name 'glLightModelxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_LightModelxvOES_ovr_0(pname, param[0]) else
      z_LightModelxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; var param: Fixed) :=
    z_LightModelxvOES_ovr_0(pname, param);
    private static procedure z_LightModelxvOES_ovr_2(pname: LightModelParameter; param: IntPtr);
    external 'opengl32.dll' name 'glLightModelxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightModelxvOES(pname: LightModelParameter; param: IntPtr) :=
    z_LightModelxvOES_ovr_2(pname, param);
    
    private static procedure z_LightxOES_ovr_0(light: LightName; pname: LightParameter; param: Fixed);
    external 'opengl32.dll' name 'glLightxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxOES(light: LightName; pname: LightParameter; param: Fixed) :=
    z_LightxOES_ovr_0(light, pname, param);
    
    private static procedure z_LightxvOES_ovr_0(light: LightName; pname: LightParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glLightxvOES';
    private static procedure z_LightxvOES_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_LightxvOES_ovr_0(light, pname, &params[0]) else
      z_LightxvOES_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; var &params: Fixed) :=
    z_LightxvOES_ovr_0(light, pname, &params);
    private static procedure z_LightxvOES_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glLightxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightxvOES(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_LightxvOES_ovr_2(light, pname, &params);
    
    private static procedure z_LineWidthxOES_ovr_0(width: Fixed);
    external 'opengl32.dll' name 'glLineWidthxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LineWidthxOES(width: Fixed) :=
    z_LineWidthxOES_ovr_0(width);
    
    private static procedure z_LoadMatrixxOES_ovr_0(var m: Fixed);
    external 'opengl32.dll' name 'glLoadMatrixxOES';
    private static procedure z_LoadMatrixxOES_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadMatrixxOES_ovr_0(m[0]) else
      z_LoadMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(var m: Fixed) :=
    z_LoadMatrixxOES_ovr_0(m);
    private static procedure z_LoadMatrixxOES_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadMatrixxOES(m: IntPtr) :=
    z_LoadMatrixxOES_ovr_2(m);
    
    private static procedure z_MaterialxOES_ovr_0(face: DummyEnum; pname: MaterialParameter; param: Fixed);
    external 'opengl32.dll' name 'glMaterialxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxOES(face: DummyEnum; pname: MaterialParameter; param: Fixed) :=
    z_MaterialxOES_ovr_0(face, pname, param);
    
    private static procedure z_MaterialxvOES_ovr_0(face: DummyEnum; pname: MaterialParameter; var param: Fixed);
    external 'opengl32.dll' name 'glMaterialxvOES';
    private static procedure z_MaterialxvOES_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; param: IntPtr);
    external 'opengl32.dll' name 'glMaterialxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: DummyEnum; pname: MaterialParameter; param: array of Fixed) :=
    if (param<>nil) and (param.Length<>0) then
      z_MaterialxvOES_ovr_0(face, pname, param[0]) else
      z_MaterialxvOES_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: DummyEnum; pname: MaterialParameter; var param: Fixed) :=
    z_MaterialxvOES_ovr_0(face, pname, param);
    private static procedure z_MaterialxvOES_ovr_2(face: DummyEnum; pname: MaterialParameter; param: IntPtr);
    external 'opengl32.dll' name 'glMaterialxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MaterialxvOES(face: DummyEnum; pname: MaterialParameter; param: IntPtr) :=
    z_MaterialxvOES_ovr_2(face, pname, param);
    
    private static procedure z_MultMatrixxOES_ovr_0(var m: Fixed);
    external 'opengl32.dll' name 'glMultMatrixxOES';
    private static procedure z_MultMatrixxOES_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultMatrixxOES_ovr_0(m[0]) else
      z_MultMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(var m: Fixed) :=
    z_MultMatrixxOES_ovr_0(m);
    private static procedure z_MultMatrixxOES_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultMatrixxOES(m: IntPtr) :=
    z_MultMatrixxOES_ovr_2(m);
    
    private static procedure z_MultiTexCoord4xOES_ovr_0(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed; q: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord4xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xOES(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed; q: Fixed) :=
    z_MultiTexCoord4xOES_ovr_0(texture, s, t, r, q);
    
    private static procedure z_Normal3xOES_ovr_0(nx: Fixed; ny: Fixed; nz: Fixed);
    external 'opengl32.dll' name 'glNormal3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xOES(nx: Fixed; ny: Fixed; nz: Fixed) :=
    z_Normal3xOES_ovr_0(nx, ny, nz);
    
    private static procedure z_OrthoxOES_ovr_0(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed);
    external 'opengl32.dll' name 'glOrthoxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure OrthoxOES(l: Fixed; r: Fixed; b: Fixed; t: Fixed; n: Fixed; f: Fixed) :=
    z_OrthoxOES_ovr_0(l, r, b, t, n, f);
    
    private static procedure z_PointParameterxvOES_ovr_0(pname: PointParameterNameARB; var &params: Fixed);
    external 'opengl32.dll' name 'glPointParameterxvOES';
    private static procedure z_PointParameterxvOES_ovr_0_anh001(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterxvOES_ovr_0(pname, &params[0]) else
      z_PointParameterxvOES_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; var &params: Fixed) :=
    z_PointParameterxvOES_ovr_0(pname, &params);
    private static procedure z_PointParameterxvOES_ovr_2(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterxvOES(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterxvOES_ovr_2(pname, &params);
    
    private static procedure z_PointSizexOES_ovr_0(size: Fixed);
    external 'opengl32.dll' name 'glPointSizexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointSizexOES(size: Fixed) :=
    z_PointSizexOES_ovr_0(size);
    
    private static procedure z_PolygonOffsetxOES_ovr_0(factor: Fixed; units: Fixed);
    external 'opengl32.dll' name 'glPolygonOffsetxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PolygonOffsetxOES(factor: Fixed; units: Fixed) :=
    z_PolygonOffsetxOES_ovr_0(factor, units);
    
    private static procedure z_RotatexOES_ovr_0(angle: Fixed; x: Fixed; y: Fixed; z: Fixed);
    external 'opengl32.dll' name 'glRotatexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RotatexOES(angle: Fixed; x: Fixed; y: Fixed; z: Fixed) :=
    z_RotatexOES_ovr_0(angle, x, y, z);
    
    private static procedure z_ScalexOES_ovr_0(x: Fixed; y: Fixed; z: Fixed);
    external 'opengl32.dll' name 'glScalexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ScalexOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_ScalexOES_ovr_0(x, y, z);
    
    private static procedure z_TexEnvxOES_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; param: Fixed);
    external 'opengl32.dll' name 'glTexEnvxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxOES(target: TextureEnvTarget; pname: TextureEnvParameter; param: Fixed) :=
    z_TexEnvxOES_ovr_0(target, pname, param);
    
    private static procedure z_TexEnvxvOES_ovr_0(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glTexEnvxvOES';
    private static procedure z_TexEnvxvOES_ovr_0_anh0001(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnvxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexEnvxvOES_ovr_0(target, pname, &params[0]) else
      z_TexEnvxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; var &params: Fixed) :=
    z_TexEnvxvOES_ovr_0(target, pname, &params);
    private static procedure z_TexEnvxvOES_ovr_2(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexEnvxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexEnvxvOES(target: TextureEnvTarget; pname: TextureEnvParameter; &params: IntPtr) :=
    z_TexEnvxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_TexParameterxOES_ovr_0(target: TextureTarget; pname: GetTextureParameter; param: Fixed);
    external 'opengl32.dll' name 'glTexParameterxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxOES(target: TextureTarget; pname: GetTextureParameter; param: Fixed) :=
    z_TexParameterxOES_ovr_0(target, pname, param);
    
    private static procedure z_TexParameterxvOES_ovr_0(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glTexParameterxvOES';
    private static procedure z_TexParameterxvOES_ovr_0_anh0001(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_TexParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; var &params: Fixed) :=
    z_TexParameterxvOES_ovr_0(target, pname, &params);
    private static procedure z_TexParameterxvOES_ovr_2(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexParameterxvOES(target: TextureTarget; pname: GetTextureParameter; &params: IntPtr) :=
    z_TexParameterxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_TranslatexOES_ovr_0(x: Fixed; y: Fixed; z: Fixed);
    external 'opengl32.dll' name 'glTranslatexOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TranslatexOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_TranslatexOES_ovr_0(x, y, z);
    
    private static procedure z_AccumxOES_ovr_0(op: DummyEnum; value: Fixed);
    external 'opengl32.dll' name 'glAccumxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AccumxOES(op: DummyEnum; value: Fixed) :=
    z_AccumxOES_ovr_0(op, value);
    
    private static procedure z_BitmapxOES_ovr_0(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; var bitmap: Byte);
    external 'opengl32.dll' name 'glBitmapxOES';
    private static procedure z_BitmapxOES_ovr_0_anh00000001(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr);
    external 'opengl32.dll' name 'glBitmapxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: array of Byte) :=
    if (bitmap<>nil) and (bitmap.Length<>0) then
      z_BitmapxOES_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap[0]) else
      z_BitmapxOES_ovr_0_anh00000001(width, height, xorig, yorig, xmove, ymove, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; var bitmap: Byte) :=
    z_BitmapxOES_ovr_0(width, height, xorig, yorig, xmove, ymove, bitmap);
    private static procedure z_BitmapxOES_ovr_2(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr);
    external 'opengl32.dll' name 'glBitmapxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BitmapxOES(width: Int32; height: Int32; xorig: Fixed; yorig: Fixed; xmove: Fixed; ymove: Fixed; bitmap: IntPtr) :=
    z_BitmapxOES_ovr_2(width, height, xorig, yorig, xmove, ymove, bitmap);
    
    private static procedure z_BlendColorxOES_ovr_0(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed);
    external 'opengl32.dll' name 'glBlendColorxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure BlendColorxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_BlendColorxOES_ovr_0(red, green, blue, alpha);
    
    private static procedure z_ClearAccumxOES_ovr_0(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed);
    external 'opengl32.dll' name 'glClearAccumxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearAccumxOES(red: Fixed; green: Fixed; blue: Fixed; alpha: Fixed) :=
    z_ClearAccumxOES_ovr_0(red, green, blue, alpha);
    
    private static procedure z_Color3xOES_ovr_0(red: Fixed; green: Fixed; blue: Fixed);
    external 'opengl32.dll' name 'glColor3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xOES(red: Fixed; green: Fixed; blue: Fixed) :=
    z_Color3xOES_ovr_0(red, green, blue);
    
    private static procedure z_Color3xvOES_ovr_0(var components: Fixed);
    external 'opengl32.dll' name 'glColor3xvOES';
    private static procedure z_Color3xvOES_ovr_0_anh01(components: IntPtr);
    external 'opengl32.dll' name 'glColor3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(components: array of Fixed) :=
    if (components<>nil) and (components.Length<>0) then
      z_Color3xvOES_ovr_0(components[0]) else
      z_Color3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(var components: Fixed) :=
    z_Color3xvOES_ovr_0(components);
    private static procedure z_Color3xvOES_ovr_2(components: IntPtr);
    external 'opengl32.dll' name 'glColor3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3xvOES(components: IntPtr) :=
    z_Color3xvOES_ovr_2(components);
    
    private static procedure z_Color4xvOES_ovr_0(var components: Fixed);
    external 'opengl32.dll' name 'glColor4xvOES';
    private static procedure z_Color4xvOES_ovr_0_anh01(components: IntPtr);
    external 'opengl32.dll' name 'glColor4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(components: array of Fixed) :=
    if (components<>nil) and (components.Length<>0) then
      z_Color4xvOES_ovr_0(components[0]) else
      z_Color4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(var components: Fixed) :=
    z_Color4xvOES_ovr_0(components);
    private static procedure z_Color4xvOES_ovr_2(components: IntPtr);
    external 'opengl32.dll' name 'glColor4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4xvOES(components: IntPtr) :=
    z_Color4xvOES_ovr_2(components);
    
    private static procedure z_ConvolutionParameterxOES_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; param: Fixed);
    external 'opengl32.dll' name 'glConvolutionParameterxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; param: Fixed) :=
    z_ConvolutionParameterxOES_ovr_0(target, pname, param);
    
    private static procedure z_ConvolutionParameterxvOES_ovr_0(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Fixed);
    external 'opengl32.dll' name 'glConvolutionParameterxvOES';
    private static procedure z_ConvolutionParameterxvOES_ovr_0_anh0001(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ConvolutionParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_ConvolutionParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; var &params: Fixed) :=
    z_ConvolutionParameterxvOES_ovr_0(target, pname, &params);
    private static procedure z_ConvolutionParameterxvOES_ovr_2(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glConvolutionParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ConvolutionParameterxvOES(target: ConvolutionTargetEXT; pname: ConvolutionParameterEXT; &params: IntPtr) :=
    z_ConvolutionParameterxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_EvalCoord1xOES_ovr_0(u: Fixed);
    external 'opengl32.dll' name 'glEvalCoord1xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xOES(u: Fixed) :=
    z_EvalCoord1xOES_ovr_0(u);
    
    private static procedure z_EvalCoord1xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glEvalCoord1xvOES';
    private static procedure z_EvalCoord1xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_EvalCoord1xvOES_ovr_0(coords[0]) else
      z_EvalCoord1xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xvOES(var coords: Fixed) :=
    z_EvalCoord1xvOES_ovr_0(coords);
    private static procedure z_EvalCoord1xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord1xvOES(coords: IntPtr) :=
    z_EvalCoord1xvOES_ovr_2(coords);
    
    private static procedure z_EvalCoord2xOES_ovr_0(u: Fixed; v: Fixed);
    external 'opengl32.dll' name 'glEvalCoord2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xOES(u: Fixed; v: Fixed) :=
    z_EvalCoord2xOES_ovr_0(u, v);
    
    private static procedure z_EvalCoord2xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glEvalCoord2xvOES';
    private static procedure z_EvalCoord2xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_EvalCoord2xvOES_ovr_0(coords[0]) else
      z_EvalCoord2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(var coords: Fixed) :=
    z_EvalCoord2xvOES_ovr_0(coords);
    private static procedure z_EvalCoord2xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glEvalCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure EvalCoord2xvOES(coords: IntPtr) :=
    z_EvalCoord2xvOES_ovr_2(coords);
    
    private static procedure z_FeedbackBufferxOES_ovr_0(n: Int32; &type: DummyEnum; var buffer: Fixed);
    external 'opengl32.dll' name 'glFeedbackBufferxOES';
    private static procedure z_FeedbackBufferxOES_ovr_0_anh0001(n: Int32; &type: DummyEnum; buffer: IntPtr);
    external 'opengl32.dll' name 'glFeedbackBufferxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; buffer: array of Fixed) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_FeedbackBufferxOES_ovr_0(n, &type, buffer[0]) else
      z_FeedbackBufferxOES_ovr_0_anh0001(n, &type, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; var buffer: Fixed) :=
    z_FeedbackBufferxOES_ovr_0(n, &type, buffer);
    private static procedure z_FeedbackBufferxOES_ovr_2(n: Int32; &type: DummyEnum; buffer: IntPtr);
    external 'opengl32.dll' name 'glFeedbackBufferxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FeedbackBufferxOES(n: Int32; &type: DummyEnum; buffer: IntPtr) :=
    z_FeedbackBufferxOES_ovr_2(n, &type, buffer);
    
    private static procedure z_GetConvolutionParameterxvOES_ovr_0(target: DummyEnum; pname: DummyEnum; var &params: Fixed);
    external 'opengl32.dll' name 'glGetConvolutionParameterxvOES';
    private static procedure z_GetConvolutionParameterxvOES_ovr_0_anh0001(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetConvolutionParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetConvolutionParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; var &params: Fixed) :=
    z_GetConvolutionParameterxvOES_ovr_0(target, pname, &params);
    private static procedure z_GetConvolutionParameterxvOES_ovr_2(target: DummyEnum; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glGetConvolutionParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetConvolutionParameterxvOES(target: DummyEnum; pname: DummyEnum; &params: IntPtr) :=
    z_GetConvolutionParameterxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_GetHistogramParameterxvOES_ovr_0(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Fixed);
    external 'opengl32.dll' name 'glGetHistogramParameterxvOES';
    private static procedure z_GetHistogramParameterxvOES_ovr_0_anh0001(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetHistogramParameterxvOES_ovr_0(target, pname, &params[0]) else
      z_GetHistogramParameterxvOES_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; var &params: Fixed) :=
    z_GetHistogramParameterxvOES_ovr_0(target, pname, &params);
    private static procedure z_GetHistogramParameterxvOES_ovr_2(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr);
    external 'opengl32.dll' name 'glGetHistogramParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetHistogramParameterxvOES(target: HistogramTargetEXT; pname: GetHistogramParameterPNameEXT; &params: IntPtr) :=
    z_GetHistogramParameterxvOES_ovr_2(target, pname, &params);
    
    private static procedure z_GetLightxOES_ovr_0(light: LightName; pname: LightParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glGetLightxOES';
    private static procedure z_GetLightxOES_ovr_0_anh0001(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetLightxOES_ovr_0(light, pname, &params[0]) else
      z_GetLightxOES_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; var &params: Fixed) :=
    z_GetLightxOES_ovr_0(light, pname, &params);
    private static procedure z_GetLightxOES_ovr_2(light: LightName; pname: LightParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetLightxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetLightxOES(light: LightName; pname: LightParameter; &params: IntPtr) :=
    z_GetLightxOES_ovr_2(light, pname, &params);
    
    private static procedure z_GetMapxvOES_ovr_0(target: MapTarget; query: GetMapQuery; var v: Fixed);
    external 'opengl32.dll' name 'glGetMapxvOES';
    private static procedure z_GetMapxvOES_ovr_0_anh0001(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; v: array of Fixed) :=
    if (v<>nil) and (v.Length<>0) then
      z_GetMapxvOES_ovr_0(target, query, v[0]) else
      z_GetMapxvOES_ovr_0_anh0001(target, query, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; var v: Fixed) :=
    z_GetMapxvOES_ovr_0(target, query, v);
    private static procedure z_GetMapxvOES_ovr_2(target: MapTarget; query: GetMapQuery; v: IntPtr);
    external 'opengl32.dll' name 'glGetMapxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMapxvOES(target: MapTarget; query: GetMapQuery; v: IntPtr) :=
    z_GetMapxvOES_ovr_2(target, query, v);
    
    private static procedure z_GetMaterialxOES_ovr_0(face: DummyEnum; pname: MaterialParameter; param: Fixed);
    external 'opengl32.dll' name 'glGetMaterialxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetMaterialxOES(face: DummyEnum; pname: MaterialParameter; param: Fixed) :=
    z_GetMaterialxOES_ovr_0(face, pname, param);
    
    private static procedure z_GetPixelMapxv_ovr_0(map: PixelMap; size: Int32; var values: Fixed);
    external 'opengl32.dll' name 'glGetPixelMapxv';
    private static procedure z_GetPixelMapxv_ovr_0_anh0001(map: PixelMap; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapxv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; values: array of Fixed) :=
    if (values<>nil) and (values.Length<>0) then
      z_GetPixelMapxv_ovr_0(map, size, values[0]) else
      z_GetPixelMapxv_ovr_0_anh0001(map, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; var values: Fixed) :=
    z_GetPixelMapxv_ovr_0(map, size, values);
    private static procedure z_GetPixelMapxv_ovr_2(map: PixelMap; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glGetPixelMapxv';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelMapxv(map: PixelMap; size: Int32; values: IntPtr) :=
    z_GetPixelMapxv_ovr_2(map, size, values);
    
    private static procedure z_GetTexGenxvOES_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glGetTexGenxvOES';
    private static procedure z_GetTexGenxvOES_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGenxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexGenxvOES_ovr_0(coord, pname, &params[0]) else
      z_GetTexGenxvOES_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed) :=
    z_GetTexGenxvOES_ovr_0(coord, pname, &params);
    private static procedure z_GetTexGenxvOES_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexGenxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_GetTexGenxvOES_ovr_2(coord, pname, &params);
    
    private static procedure z_GetTexLevelParameterxvOES_ovr_0(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glGetTexLevelParameterxvOES';
    private static procedure z_GetTexLevelParameterxvOES_ovr_0_anh00001(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetTexLevelParameterxvOES_ovr_0(target, level, pname, &params[0]) else
      z_GetTexLevelParameterxvOES_ovr_0_anh00001(target, level, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; var &params: Fixed) :=
    z_GetTexLevelParameterxvOES_ovr_0(target, level, pname, &params);
    private static procedure z_GetTexLevelParameterxvOES_ovr_2(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetTexLevelParameterxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexLevelParameterxvOES(target: TextureTarget; level: Int32; pname: GetTextureParameter; &params: IntPtr) :=
    z_GetTexLevelParameterxvOES_ovr_2(target, level, pname, &params);
    
    private static procedure z_IndexxOES_ovr_0(component: Fixed);
    external 'opengl32.dll' name 'glIndexxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxOES(component: Fixed) :=
    z_IndexxOES_ovr_0(component);
    
    private static procedure z_IndexxvOES_ovr_0(var component: Fixed);
    external 'opengl32.dll' name 'glIndexxvOES';
    private static procedure z_IndexxvOES_ovr_0_anh01(component: IntPtr);
    external 'opengl32.dll' name 'glIndexxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxvOES(component: array of Fixed) :=
    if (component<>nil) and (component.Length<>0) then
      z_IndexxvOES_ovr_0(component[0]) else
      z_IndexxvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxvOES(var component: Fixed) :=
    z_IndexxvOES_ovr_0(component);
    private static procedure z_IndexxvOES_ovr_2(component: IntPtr);
    external 'opengl32.dll' name 'glIndexxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IndexxvOES(component: IntPtr) :=
    z_IndexxvOES_ovr_2(component);
    
    private static procedure z_LoadTransposeMatrixxOES_ovr_0(var m: Fixed);
    external 'opengl32.dll' name 'glLoadTransposeMatrixxOES';
    private static procedure z_LoadTransposeMatrixxOES_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_LoadTransposeMatrixxOES_ovr_0(m[0]) else
      z_LoadTransposeMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(var m: Fixed) :=
    z_LoadTransposeMatrixxOES_ovr_0(m);
    private static procedure z_LoadTransposeMatrixxOES_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glLoadTransposeMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadTransposeMatrixxOES(m: IntPtr) :=
    z_LoadTransposeMatrixxOES_ovr_2(m);
    
    private static procedure z_Map1xOES_ovr_0(target: MapTarget; u1: Fixed; u2: Fixed; stride: Int32; order: Int32; points: Fixed);
    external 'opengl32.dll' name 'glMap1xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map1xOES(target: MapTarget; u1: Fixed; u2: Fixed; stride: Int32; order: Int32; points: Fixed) :=
    z_Map1xOES_ovr_0(target, u1, u2, stride, order, points);
    
    private static procedure z_Map2xOES_ovr_0(target: MapTarget; u1: Fixed; u2: Fixed; ustride: Int32; uorder: Int32; v1: Fixed; v2: Fixed; vstride: Int32; vorder: Int32; points: Fixed);
    external 'opengl32.dll' name 'glMap2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Map2xOES(target: MapTarget; u1: Fixed; u2: Fixed; ustride: Int32; uorder: Int32; v1: Fixed; v2: Fixed; vstride: Int32; vorder: Int32; points: Fixed) :=
    z_Map2xOES_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
    
    private static procedure z_MapGrid1xOES_ovr_0(n: Int32; u1: Fixed; u2: Fixed);
    external 'opengl32.dll' name 'glMapGrid1xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid1xOES(n: Int32; u1: Fixed; u2: Fixed) :=
    z_MapGrid1xOES_ovr_0(n, u1, u2);
    
    private static procedure z_MapGrid2xOES_ovr_0(n: Int32; u1: Fixed; u2: Fixed; v1: Fixed; v2: Fixed);
    external 'opengl32.dll' name 'glMapGrid2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MapGrid2xOES(n: Int32; u1: Fixed; u2: Fixed; v1: Fixed; v2: Fixed) :=
    z_MapGrid2xOES_ovr_0(n, u1, u2, v1, v2);
    
    private static procedure z_MultTransposeMatrixxOES_ovr_0(var m: Fixed);
    external 'opengl32.dll' name 'glMultTransposeMatrixxOES';
    private static procedure z_MultTransposeMatrixxOES_ovr_0_anh01(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(m: array of Fixed) :=
    if (m<>nil) and (m.Length<>0) then
      z_MultTransposeMatrixxOES_ovr_0(m[0]) else
      z_MultTransposeMatrixxOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(var m: Fixed) :=
    z_MultTransposeMatrixxOES_ovr_0(m);
    private static procedure z_MultTransposeMatrixxOES_ovr_2(m: IntPtr);
    external 'opengl32.dll' name 'glMultTransposeMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultTransposeMatrixxOES(m: IntPtr) :=
    z_MultTransposeMatrixxOES_ovr_2(m);
    
    private static procedure z_MultiTexCoord1xOES_ovr_0(texture: TextureUnit; s: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord1xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xOES(texture: TextureUnit; s: Fixed) :=
    z_MultiTexCoord1xOES_ovr_0(texture, s);
    
    private static procedure z_MultiTexCoord1xvOES_ovr_0(texture: TextureUnit; var coords: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord1xvOES';
    private static procedure z_MultiTexCoord1xvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord1xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord1xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord1xvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord1xvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord1xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord1xvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord2xOES_ovr_0(texture: TextureUnit; s: Fixed; t: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xOES(texture: TextureUnit; s: Fixed; t: Fixed) :=
    z_MultiTexCoord2xOES_ovr_0(texture, s, t);
    
    private static procedure z_MultiTexCoord2xvOES_ovr_0(texture: TextureUnit; var coords: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord2xvOES';
    private static procedure z_MultiTexCoord2xvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord2xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord2xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord2xvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord2xvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord2xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord2xvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord3xOES_ovr_0(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xOES(texture: TextureUnit; s: Fixed; t: Fixed; r: Fixed) :=
    z_MultiTexCoord3xOES_ovr_0(texture, s, t, r);
    
    private static procedure z_MultiTexCoord3xvOES_ovr_0(texture: TextureUnit; var coords: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord3xvOES';
    private static procedure z_MultiTexCoord3xvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord3xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord3xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord3xvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord3xvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord3xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord3xvOES_ovr_2(texture, coords);
    
    private static procedure z_MultiTexCoord4xvOES_ovr_0(texture: TextureUnit; var coords: Fixed);
    external 'opengl32.dll' name 'glMultiTexCoord4xvOES';
    private static procedure z_MultiTexCoord4xvOES_ovr_0_anh001(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_MultiTexCoord4xvOES_ovr_0(texture, coords[0]) else
      z_MultiTexCoord4xvOES_ovr_0_anh001(texture, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; var coords: Fixed) :=
    z_MultiTexCoord4xvOES_ovr_0(texture, coords);
    private static procedure z_MultiTexCoord4xvOES_ovr_2(texture: TextureUnit; coords: IntPtr);
    external 'opengl32.dll' name 'glMultiTexCoord4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure MultiTexCoord4xvOES(texture: TextureUnit; coords: IntPtr) :=
    z_MultiTexCoord4xvOES_ovr_2(texture, coords);
    
    private static procedure z_Normal3xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glNormal3xvOES';
    private static procedure z_Normal3xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glNormal3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Normal3xvOES_ovr_0(coords[0]) else
      z_Normal3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(var coords: Fixed) :=
    z_Normal3xvOES_ovr_0(coords);
    private static procedure z_Normal3xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glNormal3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3xvOES(coords: IntPtr) :=
    z_Normal3xvOES_ovr_2(coords);
    
    private static procedure z_PassThroughxOES_ovr_0(token: Fixed);
    external 'opengl32.dll' name 'glPassThroughxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PassThroughxOES(token: Fixed) :=
    z_PassThroughxOES_ovr_0(token);
    
    private static procedure z_PixelMapx_ovr_0(map: PixelMap; size: Int32; var values: Fixed);
    external 'opengl32.dll' name 'glPixelMapx';
    private static procedure z_PixelMapx_ovr_0_anh0001(map: PixelMap; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapx';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; values: array of Fixed) :=
    if (values<>nil) and (values.Length<>0) then
      z_PixelMapx_ovr_0(map, size, values[0]) else
      z_PixelMapx_ovr_0_anh0001(map, size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; var values: Fixed) :=
    z_PixelMapx_ovr_0(map, size, values);
    private static procedure z_PixelMapx_ovr_2(map: PixelMap; size: Int32; values: IntPtr);
    external 'opengl32.dll' name 'glPixelMapx';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelMapx(map: PixelMap; size: Int32; values: IntPtr) :=
    z_PixelMapx_ovr_2(map, size, values);
    
    private static procedure z_PixelStorex_ovr_0(pname: PixelStoreParameter; param: Fixed);
    external 'opengl32.dll' name 'glPixelStorex';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelStorex(pname: PixelStoreParameter; param: Fixed) :=
    z_PixelStorex_ovr_0(pname, param);
    
    private static procedure z_PixelTransferxOES_ovr_0(pname: PixelTransferParameter; param: Fixed);
    external 'opengl32.dll' name 'glPixelTransferxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTransferxOES(pname: PixelTransferParameter; param: Fixed) :=
    z_PixelTransferxOES_ovr_0(pname, param);
    
    private static procedure z_PixelZoomxOES_ovr_0(xfactor: Fixed; yfactor: Fixed);
    external 'opengl32.dll' name 'glPixelZoomxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelZoomxOES(xfactor: Fixed; yfactor: Fixed) :=
    z_PixelZoomxOES_ovr_0(xfactor, yfactor);
    
    private static procedure z_PrioritizeTexturesxOES_ovr_0(n: Int32; var textures: UInt32; var priorities: Fixed);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    private static procedure z_PrioritizeTexturesxOES_ovr_0_anh0010(n: Int32; textures: IntPtr; var priorities: Fixed);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    private static procedure z_PrioritizeTexturesxOES_ovr_0_anh0001(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    private static procedure z_PrioritizeTexturesxOES_ovr_0_anh0011(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of UInt32; priorities: array of Fixed) :=
    if (textures<>nil) and (textures.Length<>0) then
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesxOES_ovr_0(n, textures[0], priorities[0]) else
        z_PrioritizeTexturesxOES_ovr_0_anh0001(n, textures[0], IntPtr.Zero) else
      if (priorities<>nil) and (priorities.Length<>0) then
        z_PrioritizeTexturesxOES_ovr_0_anh0010(n, IntPtr.Zero, priorities[0]) else
        z_PrioritizeTexturesxOES_ovr_0_anh0011(n, IntPtr.Zero, IntPtr.Zero);
    private static procedure z_PrioritizeTexturesxOES_ovr_1_anh0010(n: Int32; textures: IntPtr; var priorities: Fixed);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of UInt32; var priorities: Fixed) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_0(n, textures[0], priorities) else
      z_PrioritizeTexturesxOES_ovr_0_anh0010(n, IntPtr.Zero, priorities);
    private static procedure z_PrioritizeTexturesxOES_ovr_2(n: Int32; var textures: UInt32; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    private static procedure z_PrioritizeTexturesxOES_ovr_2_anh0010(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: array of UInt32; priorities: IntPtr) :=
    if (textures<>nil) and (textures.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_2(n, textures[0], priorities) else
      z_PrioritizeTexturesxOES_ovr_2_anh0010(n, IntPtr.Zero, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: UInt32; priorities: array of Fixed) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_0(n, textures, priorities[0]) else
      z_PrioritizeTexturesxOES_ovr_0_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: UInt32; var priorities: Fixed) :=
    z_PrioritizeTexturesxOES_ovr_0(n, textures, priorities);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; var textures: UInt32; priorities: IntPtr) :=
    z_PrioritizeTexturesxOES_ovr_2(n, textures, priorities);
    private static procedure z_PrioritizeTexturesxOES_ovr_6(n: Int32; textures: IntPtr; var priorities: Fixed);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    private static procedure z_PrioritizeTexturesxOES_ovr_6_anh0001(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; priorities: array of Fixed) :=
    if (priorities<>nil) and (priorities.Length<>0) then
      z_PrioritizeTexturesxOES_ovr_6(n, textures, priorities[0]) else
      z_PrioritizeTexturesxOES_ovr_6_anh0001(n, textures, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; var priorities: Fixed) :=
    z_PrioritizeTexturesxOES_ovr_6(n, textures, priorities);
    private static procedure z_PrioritizeTexturesxOES_ovr_8(n: Int32; textures: IntPtr; priorities: IntPtr);
    external 'opengl32.dll' name 'glPrioritizeTexturesxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PrioritizeTexturesxOES(n: Int32; textures: IntPtr; priorities: IntPtr) :=
    z_PrioritizeTexturesxOES_ovr_8(n, textures, priorities);
    
    private static procedure z_RasterPos2xOES_ovr_0(x: Fixed; y: Fixed);
    external 'opengl32.dll' name 'glRasterPos2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xOES(x: Fixed; y: Fixed) :=
    z_RasterPos2xOES_ovr_0(x, y);
    
    private static procedure z_RasterPos2xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glRasterPos2xvOES';
    private static procedure z_RasterPos2xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos2xvOES_ovr_0(coords[0]) else
      z_RasterPos2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(var coords: Fixed) :=
    z_RasterPos2xvOES_ovr_0(coords);
    private static procedure z_RasterPos2xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos2xvOES(coords: IntPtr) :=
    z_RasterPos2xvOES_ovr_2(coords);
    
    private static procedure z_RasterPos3xOES_ovr_0(x: Fixed; y: Fixed; z: Fixed);
    external 'opengl32.dll' name 'glRasterPos3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_RasterPos3xOES_ovr_0(x, y, z);
    
    private static procedure z_RasterPos3xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glRasterPos3xvOES';
    private static procedure z_RasterPos3xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos3xvOES_ovr_0(coords[0]) else
      z_RasterPos3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(var coords: Fixed) :=
    z_RasterPos3xvOES_ovr_0(coords);
    private static procedure z_RasterPos3xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos3xvOES(coords: IntPtr) :=
    z_RasterPos3xvOES_ovr_2(coords);
    
    private static procedure z_RasterPos4xOES_ovr_0(x: Fixed; y: Fixed; z: Fixed; w: Fixed);
    external 'opengl32.dll' name 'glRasterPos4xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xOES(x: Fixed; y: Fixed; z: Fixed; w: Fixed) :=
    z_RasterPos4xOES_ovr_0(x, y, z, w);
    
    private static procedure z_RasterPos4xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glRasterPos4xvOES';
    private static procedure z_RasterPos4xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_RasterPos4xvOES_ovr_0(coords[0]) else
      z_RasterPos4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(var coords: Fixed) :=
    z_RasterPos4xvOES_ovr_0(coords);
    private static procedure z_RasterPos4xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glRasterPos4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RasterPos4xvOES(coords: IntPtr) :=
    z_RasterPos4xvOES_ovr_2(coords);
    
    private static procedure z_RectxOES_ovr_0(x1: Fixed; y1: Fixed; x2: Fixed; y2: Fixed);
    external 'opengl32.dll' name 'glRectxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxOES(x1: Fixed; y1: Fixed; x2: Fixed; y2: Fixed) :=
    z_RectxOES_ovr_0(x1, y1, x2, y2);
    
    private static procedure z_RectxvOES_ovr_0(var v1: Fixed; var v2: Fixed);
    external 'opengl32.dll' name 'glRectxvOES';
    private static procedure z_RectxvOES_ovr_0_anh010(v1: IntPtr; var v2: Fixed);
    external 'opengl32.dll' name 'glRectxvOES';
    private static procedure z_RectxvOES_ovr_0_anh001(var v1: Fixed; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    private static procedure z_RectxvOES_ovr_0_anh011(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; v2: array of Fixed) :=
    if (v1<>nil) and (v1.Length<>0) then
      if (v2<>nil) and (v2.Length<>0) then
        z_RectxvOES_ovr_0(v1[0], v2[0]) else
        z_RectxvOES_ovr_0_anh001(v1[0], IntPtr.Zero) else
      if (v2<>nil) and (v2.Length<>0) then
        z_RectxvOES_ovr_0_anh010(IntPtr.Zero, v2[0]) else
        z_RectxvOES_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static procedure z_RectxvOES_ovr_1_anh010(v1: IntPtr; var v2: Fixed);
    external 'opengl32.dll' name 'glRectxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; var v2: Fixed) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_RectxvOES_ovr_0(v1[0], v2) else
      z_RectxvOES_ovr_0_anh010(IntPtr.Zero, v2);
    private static procedure z_RectxvOES_ovr_2(var v1: Fixed; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    private static procedure z_RectxvOES_ovr_2_anh010(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: array of Fixed; v2: IntPtr) :=
    if (v1<>nil) and (v1.Length<>0) then
      z_RectxvOES_ovr_2(v1[0], v2) else
      z_RectxvOES_ovr_2_anh010(IntPtr.Zero, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; v2: array of Fixed) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_RectxvOES_ovr_0(v1, v2[0]) else
      z_RectxvOES_ovr_0_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; var v2: Fixed) :=
    z_RectxvOES_ovr_0(v1, v2);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(var v1: Fixed; v2: IntPtr) :=
    z_RectxvOES_ovr_2(v1, v2);
    private static procedure z_RectxvOES_ovr_6(v1: IntPtr; var v2: Fixed);
    external 'opengl32.dll' name 'glRectxvOES';
    private static procedure z_RectxvOES_ovr_6_anh001(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; v2: array of Fixed) :=
    if (v2<>nil) and (v2.Length<>0) then
      z_RectxvOES_ovr_6(v1, v2[0]) else
      z_RectxvOES_ovr_6_anh001(v1, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; var v2: Fixed) :=
    z_RectxvOES_ovr_6(v1, v2);
    private static procedure z_RectxvOES_ovr_8(v1: IntPtr; v2: IntPtr);
    external 'opengl32.dll' name 'glRectxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure RectxvOES(v1: IntPtr; v2: IntPtr) :=
    z_RectxvOES_ovr_8(v1, v2);
    
    private static procedure z_TexCoord1xOES_ovr_0(s: Fixed);
    external 'opengl32.dll' name 'glTexCoord1xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xOES(s: Fixed) :=
    z_TexCoord1xOES_ovr_0(s);
    
    private static procedure z_TexCoord1xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glTexCoord1xvOES';
    private static procedure z_TexCoord1xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord1xvOES_ovr_0(coords[0]) else
      z_TexCoord1xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xvOES(var coords: Fixed) :=
    z_TexCoord1xvOES_ovr_0(coords);
    private static procedure z_TexCoord1xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord1xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord1xvOES(coords: IntPtr) :=
    z_TexCoord1xvOES_ovr_2(coords);
    
    private static procedure z_TexCoord2xOES_ovr_0(s: Fixed; t: Fixed);
    external 'opengl32.dll' name 'glTexCoord2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xOES(s: Fixed; t: Fixed) :=
    z_TexCoord2xOES_ovr_0(s, t);
    
    private static procedure z_TexCoord2xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glTexCoord2xvOES';
    private static procedure z_TexCoord2xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord2xvOES_ovr_0(coords[0]) else
      z_TexCoord2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(var coords: Fixed) :=
    z_TexCoord2xvOES_ovr_0(coords);
    private static procedure z_TexCoord2xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2xvOES(coords: IntPtr) :=
    z_TexCoord2xvOES_ovr_2(coords);
    
    private static procedure z_TexCoord3xOES_ovr_0(s: Fixed; t: Fixed; r: Fixed);
    external 'opengl32.dll' name 'glTexCoord3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xOES(s: Fixed; t: Fixed; r: Fixed) :=
    z_TexCoord3xOES_ovr_0(s, t, r);
    
    private static procedure z_TexCoord3xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glTexCoord3xvOES';
    private static procedure z_TexCoord3xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord3xvOES_ovr_0(coords[0]) else
      z_TexCoord3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(var coords: Fixed) :=
    z_TexCoord3xvOES_ovr_0(coords);
    private static procedure z_TexCoord3xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord3xvOES(coords: IntPtr) :=
    z_TexCoord3xvOES_ovr_2(coords);
    
    private static procedure z_TexCoord4xOES_ovr_0(s: Fixed; t: Fixed; r: Fixed; q: Fixed);
    external 'opengl32.dll' name 'glTexCoord4xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xOES(s: Fixed; t: Fixed; r: Fixed; q: Fixed) :=
    z_TexCoord4xOES_ovr_0(s, t, r, q);
    
    private static procedure z_TexCoord4xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glTexCoord4xvOES';
    private static procedure z_TexCoord4xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_TexCoord4xvOES_ovr_0(coords[0]) else
      z_TexCoord4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(var coords: Fixed) :=
    z_TexCoord4xvOES_ovr_0(coords);
    private static procedure z_TexCoord4xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4xvOES(coords: IntPtr) :=
    z_TexCoord4xvOES_ovr_2(coords);
    
    private static procedure z_TexGenxOES_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; param: Fixed);
    external 'opengl32.dll' name 'glTexGenxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxOES(coord: TextureCoordName; pname: TextureGenParameter; param: Fixed) :=
    z_TexGenxOES_ovr_0(coord, pname, param);
    
    private static procedure z_TexGenxvOES_ovr_0(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed);
    external 'opengl32.dll' name 'glTexGenxvOES';
    private static procedure z_TexGenxvOES_ovr_0_anh0001(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGenxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: array of Fixed) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_TexGenxvOES_ovr_0(coord, pname, &params[0]) else
      z_TexGenxvOES_ovr_0_anh0001(coord, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; var &params: Fixed) :=
    z_TexGenxvOES_ovr_0(coord, pname, &params);
    private static procedure z_TexGenxvOES_ovr_2(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glTexGenxvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexGenxvOES(coord: TextureCoordName; pname: TextureGenParameter; &params: IntPtr) :=
    z_TexGenxvOES_ovr_2(coord, pname, &params);
    
    private static procedure z_Vertex2xOES_ovr_0(x: Fixed);
    external 'opengl32.dll' name 'glVertex2xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xOES(x: Fixed) :=
    z_Vertex2xOES_ovr_0(x);
    
    private static procedure z_Vertex2xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glVertex2xvOES';
    private static procedure z_Vertex2xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex2xvOES_ovr_0(coords[0]) else
      z_Vertex2xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(var coords: Fixed) :=
    z_Vertex2xvOES_ovr_0(coords);
    private static procedure z_Vertex2xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex2xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex2xvOES(coords: IntPtr) :=
    z_Vertex2xvOES_ovr_2(coords);
    
    private static procedure z_Vertex3xOES_ovr_0(x: Fixed; y: Fixed);
    external 'opengl32.dll' name 'glVertex3xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xOES(x: Fixed; y: Fixed) :=
    z_Vertex3xOES_ovr_0(x, y);
    
    private static procedure z_Vertex3xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glVertex3xvOES';
    private static procedure z_Vertex3xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex3xvOES_ovr_0(coords[0]) else
      z_Vertex3xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(var coords: Fixed) :=
    z_Vertex3xvOES_ovr_0(coords);
    private static procedure z_Vertex3xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex3xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex3xvOES(coords: IntPtr) :=
    z_Vertex3xvOES_ovr_2(coords);
    
    private static procedure z_Vertex4xOES_ovr_0(x: Fixed; y: Fixed; z: Fixed);
    external 'opengl32.dll' name 'glVertex4xOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xOES(x: Fixed; y: Fixed; z: Fixed) :=
    z_Vertex4xOES_ovr_0(x, y, z);
    
    private static procedure z_Vertex4xvOES_ovr_0(var coords: Fixed);
    external 'opengl32.dll' name 'glVertex4xvOES';
    private static procedure z_Vertex4xvOES_ovr_0_anh01(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(coords: array of Fixed) :=
    if (coords<>nil) and (coords.Length<>0) then
      z_Vertex4xvOES_ovr_0(coords[0]) else
      z_Vertex4xvOES_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(var coords: Fixed) :=
    z_Vertex4xvOES_ovr_0(coords);
    private static procedure z_Vertex4xvOES_ovr_2(coords: IntPtr);
    external 'opengl32.dll' name 'glVertex4xvOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Vertex4xvOES(coords: IntPtr) :=
    z_Vertex4xvOES_ovr_2(coords);
    
  end;
  
  glQueryMatrixOES = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_QueryMatrixxOES_ovr_0(var mantissa: Fixed; var exponent: Int32): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    private static function z_QueryMatrixxOES_ovr_0_anh010(mantissa: IntPtr; var exponent: Int32): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    private static function z_QueryMatrixxOES_ovr_0_anh001(var mantissa: Fixed; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    private static function z_QueryMatrixxOES_ovr_0_anh011(mantissa: IntPtr; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; exponent: array of Int32): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      if (exponent<>nil) and (exponent.Length<>0) then
        z_QueryMatrixxOES_ovr_0(mantissa[0], exponent[0]) else
        z_QueryMatrixxOES_ovr_0_anh001(mantissa[0], IntPtr.Zero) else
      if (exponent<>nil) and (exponent.Length<>0) then
        z_QueryMatrixxOES_ovr_0_anh010(IntPtr.Zero, exponent[0]) else
        z_QueryMatrixxOES_ovr_0_anh011(IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryMatrixxOES_ovr_1_anh010(mantissa: IntPtr; var exponent: Int32): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; var exponent: Int32): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      z_QueryMatrixxOES_ovr_0(mantissa[0], exponent) else
      z_QueryMatrixxOES_ovr_0_anh010(IntPtr.Zero, exponent);
    private static function z_QueryMatrixxOES_ovr_2(var mantissa: Fixed; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    private static function z_QueryMatrixxOES_ovr_2_anh010(mantissa: IntPtr; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: array of Fixed; exponent: IntPtr): DummyFlags :=
    if (mantissa<>nil) and (mantissa.Length<>0) then
      z_QueryMatrixxOES_ovr_2(mantissa[0], exponent) else
      z_QueryMatrixxOES_ovr_2_anh010(IntPtr.Zero, exponent);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; exponent: array of Int32): DummyFlags :=
    if (exponent<>nil) and (exponent.Length<>0) then
      z_QueryMatrixxOES_ovr_0(mantissa, exponent[0]) else
      z_QueryMatrixxOES_ovr_0_anh001(mantissa, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; var exponent: Int32): DummyFlags :=
    z_QueryMatrixxOES_ovr_0(mantissa, exponent);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(var mantissa: Fixed; exponent: IntPtr): DummyFlags :=
    z_QueryMatrixxOES_ovr_2(mantissa, exponent);
    private static function z_QueryMatrixxOES_ovr_6(mantissa: IntPtr; var exponent: Int32): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    private static function z_QueryMatrixxOES_ovr_6_anh001(mantissa: IntPtr; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; exponent: array of Int32): DummyFlags :=
    if (exponent<>nil) and (exponent.Length<>0) then
      z_QueryMatrixxOES_ovr_6(mantissa, exponent[0]) else
      z_QueryMatrixxOES_ovr_6_anh001(mantissa, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; var exponent: Int32): DummyFlags :=
    z_QueryMatrixxOES_ovr_6(mantissa, exponent);
    private static function z_QueryMatrixxOES_ovr_8(mantissa: IntPtr; exponent: IntPtr): DummyFlags;
    external 'opengl32.dll' name 'glQueryMatrixxOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function QueryMatrixxOES(mantissa: IntPtr; exponent: IntPtr): DummyFlags :=
    z_QueryMatrixxOES_ovr_8(mantissa, exponent);
    
  end;
  
  glSinglePrecisionOES = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ClearDepthfOES_ovr_0(depth: single);
    external 'opengl32.dll' name 'glClearDepthfOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClearDepthfOES(depth: single) :=
    z_ClearDepthfOES_ovr_0(depth);
    
    private static procedure z_ClipPlanefOES_ovr_0(plane: ClipPlaneName; var equation: single);
    external 'opengl32.dll' name 'glClipPlanefOES';
    private static procedure z_ClipPlanefOES_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlanefOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; equation: array of single) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ClipPlanefOES_ovr_0(plane, equation[0]) else
      z_ClipPlanefOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; var equation: single) :=
    z_ClipPlanefOES_ovr_0(plane, equation);
    private static procedure z_ClipPlanefOES_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glClipPlanefOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ClipPlanefOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_ClipPlanefOES_ovr_2(plane, equation);
    
    private static procedure z_DepthRangefOES_ovr_0(n: single; f: single);
    external 'opengl32.dll' name 'glDepthRangefOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DepthRangefOES(n: single; f: single) :=
    z_DepthRangefOES_ovr_0(n, f);
    
    private static procedure z_FrustumfOES_ovr_0(l: single; r: single; b: single; t: single; n: single; f: single);
    external 'opengl32.dll' name 'glFrustumfOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrustumfOES(l: single; r: single; b: single; t: single; n: single; f: single) :=
    z_FrustumfOES_ovr_0(l, r, b, t, n, f);
    
    private static procedure z_GetClipPlanefOES_ovr_0(plane: ClipPlaneName; var equation: single);
    external 'opengl32.dll' name 'glGetClipPlanefOES';
    private static procedure z_GetClipPlanefOES_ovr_0_anh001(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlanefOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; equation: array of single) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_GetClipPlanefOES_ovr_0(plane, equation[0]) else
      z_GetClipPlanefOES_ovr_0_anh001(plane, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; var equation: single) :=
    z_GetClipPlanefOES_ovr_0(plane, equation);
    private static procedure z_GetClipPlanefOES_ovr_2(plane: ClipPlaneName; equation: IntPtr);
    external 'opengl32.dll' name 'glGetClipPlanefOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetClipPlanefOES(plane: ClipPlaneName; equation: IntPtr) :=
    z_GetClipPlanefOES_ovr_2(plane, equation);
    
    private static procedure z_OrthofOES_ovr_0(l: single; r: single; b: single; t: single; n: single; f: single);
    external 'opengl32.dll' name 'glOrthofOES';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure OrthofOES(l: single; r: single; b: single; t: single; n: single; f: single) :=
    z_OrthofOES_ovr_0(l, r, b, t, n, f);
    
  end;
  
  glMultiviewOVR = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FramebufferTextureMultiviewOVR_ovr_0(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; baseViewIndex: Int32; numViews: Int32);
    external 'opengl32.dll' name 'glFramebufferTextureMultiviewOVR';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FramebufferTextureMultiviewOVR(target: FramebufferTarget; attachment: FramebufferAttachment; texture: UInt32; level: Int32; baseViewIndex: Int32; numViews: Int32) :=
    z_FramebufferTextureMultiviewOVR_ovr_0(target, attachment, texture, level, baseViewIndex, numViews);
    
  end;
  
  glMiscHintsPGI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_HintPGI_ovr_0(target: HintTargetPGI; mode: Int32);
    external 'opengl32.dll' name 'glHintPGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure HintPGI(target: HintTargetPGI; mode: Int32) :=
    z_HintPGI_ovr_0(target, mode);
    
  end;
  
  glDetailTextureSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DetailTexFuncSGIS_ovr_0(target: TextureTarget; n: Int32; var points: single);
    external 'opengl32.dll' name 'glDetailTexFuncSGIS';
    private static procedure z_DetailTexFuncSGIS_ovr_0_anh0001(target: TextureTarget; n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDetailTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_DetailTexFuncSGIS_ovr_0(target, n, points[0]) else
      z_DetailTexFuncSGIS_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; var points: single) :=
    z_DetailTexFuncSGIS_ovr_0(target, n, points);
    private static procedure z_DetailTexFuncSGIS_ovr_2(target: TextureTarget; n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDetailTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DetailTexFuncSGIS(target: TextureTarget; n: Int32; points: IntPtr) :=
    z_DetailTexFuncSGIS_ovr_2(target, n, points);
    
    private static procedure z_GetDetailTexFuncSGIS_ovr_0(target: TextureTarget; var points: single);
    external 'opengl32.dll' name 'glGetDetailTexFuncSGIS';
    private static procedure z_GetDetailTexFuncSGIS_ovr_0_anh001(target: TextureTarget; points: IntPtr);
    external 'opengl32.dll' name 'glGetDetailTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetDetailTexFuncSGIS_ovr_0(target, points[0]) else
      z_GetDetailTexFuncSGIS_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; var points: single) :=
    z_GetDetailTexFuncSGIS_ovr_0(target, points);
    private static procedure z_GetDetailTexFuncSGIS_ovr_2(target: TextureTarget; points: IntPtr);
    external 'opengl32.dll' name 'glGetDetailTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetDetailTexFuncSGIS(target: TextureTarget; points: IntPtr) :=
    z_GetDetailTexFuncSGIS_ovr_2(target, points);
    
  end;
  
  glFogFunctionSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FogFuncSGIS_ovr_0(n: Int32; var points: single);
    external 'opengl32.dll' name 'glFogFuncSGIS';
    private static procedure z_FogFuncSGIS_ovr_0_anh001(n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glFogFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_FogFuncSGIS_ovr_0(n, points[0]) else
      z_FogFuncSGIS_ovr_0_anh001(n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; var points: single) :=
    z_FogFuncSGIS_ovr_0(n, points);
    private static procedure z_FogFuncSGIS_ovr_2(n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glFogFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FogFuncSGIS(n: Int32; points: IntPtr) :=
    z_FogFuncSGIS_ovr_2(n, points);
    
    private static procedure z_GetFogFuncSGIS_ovr_0(var points: single);
    external 'opengl32.dll' name 'glGetFogFuncSGIS';
    private static procedure z_GetFogFuncSGIS_ovr_0_anh01(points: IntPtr);
    external 'opengl32.dll' name 'glGetFogFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetFogFuncSGIS_ovr_0(points[0]) else
      z_GetFogFuncSGIS_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(var points: single) :=
    z_GetFogFuncSGIS_ovr_0(points);
    private static procedure z_GetFogFuncSGIS_ovr_2(points: IntPtr);
    external 'opengl32.dll' name 'glGetFogFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFogFuncSGIS(points: IntPtr) :=
    z_GetFogFuncSGIS_ovr_2(points);
    
  end;
  
  glMultisampleSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SampleMaskSGIS_ovr_0(value: single; invert: boolean);
    external 'opengl32.dll' name 'glSampleMaskSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SampleMaskSGIS(value: single; invert: boolean) :=
    z_SampleMaskSGIS_ovr_0(value, invert);
    
    private static procedure z_SamplePatternSGIS_ovr_0(pattern: OpenGL.SamplePatternSGIS);
    external 'opengl32.dll' name 'glSamplePatternSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SamplePatternSGIS(pattern: OpenGL.SamplePatternSGIS) :=
    z_SamplePatternSGIS_ovr_0(pattern);
    
  end;
  
  glPixelTextureSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PixelTexGenParameteriSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; param: Int32);
    external 'opengl32.dll' name 'glPixelTexGenParameteriSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameteriSGIS(pname: PixelTexGenParameterNameSGIS; param: Int32) :=
    z_PixelTexGenParameteriSGIS_ovr_0(pname, param);
    
    private static procedure z_PixelTexGenParameterivSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; var &params: Int32);
    external 'opengl32.dll' name 'glPixelTexGenParameterivSGIS';
    private static procedure z_PixelTexGenParameterivSGIS_ovr_0_anh001(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTexGenParameterivSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTexGenParameterivSGIS_ovr_0(pname, &params[0]) else
      z_PixelTexGenParameterivSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; var &params: Int32) :=
    z_PixelTexGenParameterivSGIS_ovr_0(pname, &params);
    private static procedure z_PixelTexGenParameterivSGIS_ovr_2(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTexGenParameterivSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_PixelTexGenParameterivSGIS_ovr_2(pname, &params);
    
    private static procedure z_PixelTexGenParameterfSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; param: single);
    external 'opengl32.dll' name 'glPixelTexGenParameterfSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfSGIS(pname: PixelTexGenParameterNameSGIS; param: single) :=
    z_PixelTexGenParameterfSGIS_ovr_0(pname, param);
    
    private static procedure z_PixelTexGenParameterfvSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; var &params: single);
    external 'opengl32.dll' name 'glPixelTexGenParameterfvSGIS';
    private static procedure z_PixelTexGenParameterfvSGIS_ovr_0_anh001(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTexGenParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PixelTexGenParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_PixelTexGenParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; var &params: single) :=
    z_PixelTexGenParameterfvSGIS_ovr_0(pname, &params);
    private static procedure z_PixelTexGenParameterfvSGIS_ovr_2(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glPixelTexGenParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_PixelTexGenParameterfvSGIS_ovr_2(pname, &params);
    
    private static procedure z_GetPixelTexGenParameterivSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; var &params: Int32);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterivSGIS';
    private static procedure z_GetPixelTexGenParameterivSGIS_ovr_0_anh001(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterivSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTexGenParameterivSGIS_ovr_0(pname, &params[0]) else
      z_GetPixelTexGenParameterivSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; var &params: Int32) :=
    z_GetPixelTexGenParameterivSGIS_ovr_0(pname, &params);
    private static procedure z_GetPixelTexGenParameterivSGIS_ovr_2(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterivSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterivSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_GetPixelTexGenParameterivSGIS_ovr_2(pname, &params);
    
    private static procedure z_GetPixelTexGenParameterfvSGIS_ovr_0(pname: PixelTexGenParameterNameSGIS; var &params: single);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterfvSGIS';
    private static procedure z_GetPixelTexGenParameterfvSGIS_ovr_0_anh001(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetPixelTexGenParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_GetPixelTexGenParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; var &params: single) :=
    z_GetPixelTexGenParameterfvSGIS_ovr_0(pname, &params);
    private static procedure z_GetPixelTexGenParameterfvSGIS_ovr_2(pname: PixelTexGenParameterNameSGIS; &params: IntPtr);
    external 'opengl32.dll' name 'glGetPixelTexGenParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetPixelTexGenParameterfvSGIS(pname: PixelTexGenParameterNameSGIS; &params: IntPtr) :=
    z_GetPixelTexGenParameterfvSGIS_ovr_2(pname, &params);
    
  end;
  
  glPointParametersSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PointParameterfSGIS_ovr_0(pname: PointParameterNameARB; param: single);
    external 'opengl32.dll' name 'glPointParameterfSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfSGIS(pname: PointParameterNameARB; param: single) :=
    z_PointParameterfSGIS_ovr_0(pname, param);
    
    private static procedure z_PointParameterfvSGIS_ovr_0(pname: PointParameterNameARB; var &params: single);
    external 'opengl32.dll' name 'glPointParameterfvSGIS';
    private static procedure z_PointParameterfvSGIS_ovr_0_anh001(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_PointParameterfvSGIS_ovr_0(pname, &params[0]) else
      z_PointParameterfvSGIS_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; var &params: single) :=
    z_PointParameterfvSGIS_ovr_0(pname, &params);
    private static procedure z_PointParameterfvSGIS_ovr_2(pname: PointParameterNameARB; &params: IntPtr);
    external 'opengl32.dll' name 'glPointParameterfvSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PointParameterfvSGIS(pname: PointParameterNameARB; &params: IntPtr) :=
    z_PointParameterfvSGIS_ovr_2(pname, &params);
    
  end;
  
  glSharpenTextureSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SharpenTexFuncSGIS_ovr_0(target: TextureTarget; n: Int32; var points: single);
    external 'opengl32.dll' name 'glSharpenTexFuncSGIS';
    private static procedure z_SharpenTexFuncSGIS_ovr_0_anh0001(target: TextureTarget; n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glSharpenTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_SharpenTexFuncSGIS_ovr_0(target, n, points[0]) else
      z_SharpenTexFuncSGIS_ovr_0_anh0001(target, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; var points: single) :=
    z_SharpenTexFuncSGIS_ovr_0(target, n, points);
    private static procedure z_SharpenTexFuncSGIS_ovr_2(target: TextureTarget; n: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glSharpenTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SharpenTexFuncSGIS(target: TextureTarget; n: Int32; points: IntPtr) :=
    z_SharpenTexFuncSGIS_ovr_2(target, n, points);
    
    private static procedure z_GetSharpenTexFuncSGIS_ovr_0(target: TextureTarget; var points: single);
    external 'opengl32.dll' name 'glGetSharpenTexFuncSGIS';
    private static procedure z_GetSharpenTexFuncSGIS_ovr_0_anh001(target: TextureTarget; points: IntPtr);
    external 'opengl32.dll' name 'glGetSharpenTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_GetSharpenTexFuncSGIS_ovr_0(target, points[0]) else
      z_GetSharpenTexFuncSGIS_ovr_0_anh001(target, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; var points: single) :=
    z_GetSharpenTexFuncSGIS_ovr_0(target, points);
    private static procedure z_GetSharpenTexFuncSGIS_ovr_2(target: TextureTarget; points: IntPtr);
    external 'opengl32.dll' name 'glGetSharpenTexFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetSharpenTexFuncSGIS(target: TextureTarget; points: IntPtr) :=
    z_GetSharpenTexFuncSGIS_ovr_2(target, points);
    
  end;
  
  glTexture4DSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TexImage4DSGIS_ovr_0(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; size4d: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexImage4DSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexImage4DSGIS(target: TextureTarget; level: Int32; _internalformat: InternalFormat; width: Int32; height: Int32; depth: Int32; size4d: Int32; border: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexImage4DSGIS_ovr_0(target, level, _internalformat, width, height, depth, size4d, border, format, &type, pixels);
    
    private static procedure z_TexSubImage4DSGIS_ovr_0(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; woffset: Int32; width: Int32; height: Int32; depth: Int32; size4d: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr);
    external 'opengl32.dll' name 'glTexSubImage4DSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexSubImage4DSGIS(target: TextureTarget; level: Int32; xoffset: Int32; yoffset: Int32; zoffset: Int32; woffset: Int32; width: Int32; height: Int32; depth: Int32; size4d: Int32; format: PixelFormat; &type: PixelType; pixels: IntPtr) :=
    z_TexSubImage4DSGIS_ovr_0(target, level, xoffset, yoffset, zoffset, woffset, width, height, depth, size4d, format, &type, pixels);
    
  end;
  
  glTextureColorMaskSGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TextureColorMaskSGIS_ovr_0(red: boolean; green: boolean; blue: boolean; alpha: boolean);
    external 'opengl32.dll' name 'glTextureColorMaskSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TextureColorMaskSGIS(red: boolean; green: boolean; blue: boolean; alpha: boolean) :=
    z_TextureColorMaskSGIS_ovr_0(red, green, blue, alpha);
    
  end;
  
  glTextureFilter4SGIS = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetTexFilterFuncSGIS_ovr_0(target: TextureTarget; filter: TextureFilterSGIS; var weights: single);
    external 'opengl32.dll' name 'glGetTexFilterFuncSGIS';
    private static procedure z_GetTexFilterFuncSGIS_ovr_0_anh0001(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr);
    external 'opengl32.dll' name 'glGetTexFilterFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_GetTexFilterFuncSGIS_ovr_0(target, filter, weights[0]) else
      z_GetTexFilterFuncSGIS_ovr_0_anh0001(target, filter, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; var weights: single) :=
    z_GetTexFilterFuncSGIS_ovr_0(target, filter, weights);
    private static procedure z_GetTexFilterFuncSGIS_ovr_2(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr);
    external 'opengl32.dll' name 'glGetTexFilterFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetTexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; weights: IntPtr) :=
    z_GetTexFilterFuncSGIS_ovr_2(target, filter, weights);
    
    private static procedure z_TexFilterFuncSGIS_ovr_0(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; var weights: single);
    external 'opengl32.dll' name 'glTexFilterFuncSGIS';
    private static procedure z_TexFilterFuncSGIS_ovr_0_anh00001(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glTexFilterFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: array of single) :=
    if (weights<>nil) and (weights.Length<>0) then
      z_TexFilterFuncSGIS_ovr_0(target, filter, n, weights[0]) else
      z_TexFilterFuncSGIS_ovr_0_anh00001(target, filter, n, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; var weights: single) :=
    z_TexFilterFuncSGIS_ovr_0(target, filter, n, weights);
    private static procedure z_TexFilterFuncSGIS_ovr_2(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr);
    external 'opengl32.dll' name 'glTexFilterFuncSGIS';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexFilterFuncSGIS(target: TextureTarget; filter: TextureFilterSGIS; n: Int32; weights: IntPtr) :=
    z_TexFilterFuncSGIS_ovr_2(target, filter, n, weights);
    
  end;
  
  glAsyncSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_AsyncMarkerSGIX_ovr_0(marker: UInt32);
    external 'opengl32.dll' name 'glAsyncMarkerSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure AsyncMarkerSGIX(marker: UInt32) :=
    z_AsyncMarkerSGIX_ovr_0(marker);
    
    private static function z_FinishAsyncSGIX_ovr_0(var markerp: UInt32): Int32;
    external 'opengl32.dll' name 'glFinishAsyncSGIX';
    private static function z_FinishAsyncSGIX_ovr_0_anh01(markerp: IntPtr): Int32;
    external 'opengl32.dll' name 'glFinishAsyncSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FinishAsyncSGIX(markerp: array of UInt32): Int32 :=
    if (markerp<>nil) and (markerp.Length<>0) then
      z_FinishAsyncSGIX_ovr_0(markerp[0]) else
      z_FinishAsyncSGIX_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FinishAsyncSGIX(var markerp: UInt32): Int32 :=
    z_FinishAsyncSGIX_ovr_0(markerp);
    private static function z_FinishAsyncSGIX_ovr_2(markerp: IntPtr): Int32;
    external 'opengl32.dll' name 'glFinishAsyncSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function FinishAsyncSGIX(markerp: IntPtr): Int32 :=
    z_FinishAsyncSGIX_ovr_2(markerp);
    
    private static function z_PollAsyncSGIX_ovr_0(var markerp: UInt32): Int32;
    external 'opengl32.dll' name 'glPollAsyncSGIX';
    private static function z_PollAsyncSGIX_ovr_0_anh01(markerp: IntPtr): Int32;
    external 'opengl32.dll' name 'glPollAsyncSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollAsyncSGIX(markerp: array of UInt32): Int32 :=
    if (markerp<>nil) and (markerp.Length<>0) then
      z_PollAsyncSGIX_ovr_0(markerp[0]) else
      z_PollAsyncSGIX_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollAsyncSGIX(var markerp: UInt32): Int32 :=
    z_PollAsyncSGIX_ovr_0(markerp);
    private static function z_PollAsyncSGIX_ovr_2(markerp: IntPtr): Int32;
    external 'opengl32.dll' name 'glPollAsyncSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollAsyncSGIX(markerp: IntPtr): Int32 :=
    z_PollAsyncSGIX_ovr_2(markerp);
    
    private static function z_GenAsyncMarkersSGIX_ovr_0(range: Int32): UInt32;
    external 'opengl32.dll' name 'glGenAsyncMarkersSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GenAsyncMarkersSGIX(range: Int32): UInt32 :=
    z_GenAsyncMarkersSGIX_ovr_0(range);
    
    private static procedure z_DeleteAsyncMarkersSGIX_ovr_0(marker: UInt32; range: Int32);
    external 'opengl32.dll' name 'glDeleteAsyncMarkersSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeleteAsyncMarkersSGIX(marker: UInt32; range: Int32) :=
    z_DeleteAsyncMarkersSGIX_ovr_0(marker, range);
    
    private static function z_IsAsyncMarkerSGIX_ovr_0(marker: UInt32): boolean;
    external 'opengl32.dll' name 'glIsAsyncMarkerSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function IsAsyncMarkerSGIX(marker: UInt32): boolean :=
    z_IsAsyncMarkerSGIX_ovr_0(marker);
    
  end;
  
  glFlushRasterSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FlushRasterSGIX_ovr_0;
    external 'opengl32.dll' name 'glFlushRasterSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FlushRasterSGIX :=
    z_FlushRasterSGIX_ovr_0;
    
  end;
  
  glFragmentLightingSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FragmentColorMaterialSGIX_ovr_0(face: DummyEnum; mode: MaterialParameter);
    external 'opengl32.dll' name 'glFragmentColorMaterialSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentColorMaterialSGIX(face: DummyEnum; mode: MaterialParameter) :=
    z_FragmentColorMaterialSGIX_ovr_0(face, mode);
    
    private static procedure z_FragmentLightfSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: single);
    external 'opengl32.dll' name 'glFragmentLightfSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: single) :=
    z_FragmentLightfSGIX_ovr_0(light, pname, param);
    
    private static procedure z_FragmentLightfvSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single);
    external 'opengl32.dll' name 'glFragmentLightfvSGIX';
    private static procedure z_FragmentLightfvSGIX_ovr_0_anh0001(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightfvSGIX_ovr_0(light, pname, &params[0]) else
      z_FragmentLightfvSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single) :=
    z_FragmentLightfvSGIX_ovr_0(light, pname, &params);
    private static procedure z_FragmentLightfvSGIX_ovr_2(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_FragmentLightfvSGIX_ovr_2(light, pname, &params);
    
    private static procedure z_FragmentLightiSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: Int32);
    external 'opengl32.dll' name 'glFragmentLightiSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightiSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; param: Int32) :=
    z_FragmentLightiSGIX_ovr_0(light, pname, param);
    
    private static procedure z_FragmentLightivSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32);
    external 'opengl32.dll' name 'glFragmentLightivSGIX';
    private static procedure z_FragmentLightivSGIX_ovr_0_anh0001(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightivSGIX_ovr_0(light, pname, &params[0]) else
      z_FragmentLightivSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32) :=
    z_FragmentLightivSGIX_ovr_0(light, pname, &params);
    private static procedure z_FragmentLightivSGIX_ovr_2(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_FragmentLightivSGIX_ovr_2(light, pname, &params);
    
    private static procedure z_FragmentLightModelfSGIX_ovr_0(pname: FragmentLightModelParameterSGIX; param: single);
    external 'opengl32.dll' name 'glFragmentLightModelfSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfSGIX(pname: FragmentLightModelParameterSGIX; param: single) :=
    z_FragmentLightModelfSGIX_ovr_0(pname, param);
    
    private static procedure z_FragmentLightModelfvSGIX_ovr_0(pname: FragmentLightModelParameterSGIX; var &params: single);
    external 'opengl32.dll' name 'glFragmentLightModelfvSGIX';
    private static procedure z_FragmentLightModelfvSGIX_ovr_0_anh001(pname: FragmentLightModelParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightModelfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightModelfvSGIX_ovr_0(pname, &params[0]) else
      z_FragmentLightModelfvSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; var &params: single) :=
    z_FragmentLightModelfvSGIX_ovr_0(pname, &params);
    private static procedure z_FragmentLightModelfvSGIX_ovr_2(pname: FragmentLightModelParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightModelfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelfvSGIX(pname: FragmentLightModelParameterSGIX; &params: IntPtr) :=
    z_FragmentLightModelfvSGIX_ovr_2(pname, &params);
    
    private static procedure z_FragmentLightModeliSGIX_ovr_0(pname: FragmentLightModelParameterSGIX; param: Int32);
    external 'opengl32.dll' name 'glFragmentLightModeliSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModeliSGIX(pname: FragmentLightModelParameterSGIX; param: Int32) :=
    z_FragmentLightModeliSGIX_ovr_0(pname, param);
    
    private static procedure z_FragmentLightModelivSGIX_ovr_0(pname: FragmentLightModelParameterSGIX; var &params: Int32);
    external 'opengl32.dll' name 'glFragmentLightModelivSGIX';
    private static procedure z_FragmentLightModelivSGIX_ovr_0_anh001(pname: FragmentLightModelParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightModelivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentLightModelivSGIX_ovr_0(pname, &params[0]) else
      z_FragmentLightModelivSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; var &params: Int32) :=
    z_FragmentLightModelivSGIX_ovr_0(pname, &params);
    private static procedure z_FragmentLightModelivSGIX_ovr_2(pname: FragmentLightModelParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentLightModelivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentLightModelivSGIX(pname: FragmentLightModelParameterSGIX; &params: IntPtr) :=
    z_FragmentLightModelivSGIX_ovr_2(pname, &params);
    
    private static procedure z_FragmentMaterialfSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; param: single);
    external 'opengl32.dll' name 'glFragmentMaterialfSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfSGIX(face: DummyEnum; pname: MaterialParameter; param: single) :=
    z_FragmentMaterialfSGIX_ovr_0(face, pname, param);
    
    private static procedure z_FragmentMaterialfvSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: single);
    external 'opengl32.dll' name 'glFragmentMaterialfvSGIX';
    private static procedure z_FragmentMaterialfvSGIX_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentMaterialfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentMaterialfvSGIX_ovr_0(face, pname, &params[0]) else
      z_FragmentMaterialfvSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; var &params: single) :=
    z_FragmentMaterialfvSGIX_ovr_0(face, pname, &params);
    private static procedure z_FragmentMaterialfvSGIX_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentMaterialfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_FragmentMaterialfvSGIX_ovr_2(face, pname, &params);
    
    private static procedure z_FragmentMaterialiSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; param: Int32);
    external 'opengl32.dll' name 'glFragmentMaterialiSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialiSGIX(face: DummyEnum; pname: MaterialParameter; param: Int32) :=
    z_FragmentMaterialiSGIX_ovr_0(face, pname, param);
    
    private static procedure z_FragmentMaterialivSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: Int32);
    external 'opengl32.dll' name 'glFragmentMaterialivSGIX';
    private static procedure z_FragmentMaterialivSGIX_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentMaterialivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_FragmentMaterialivSGIX_ovr_0(face, pname, &params[0]) else
      z_FragmentMaterialivSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; var &params: Int32) :=
    z_FragmentMaterialivSGIX_ovr_0(face, pname, &params);
    private static procedure z_FragmentMaterialivSGIX_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glFragmentMaterialivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_FragmentMaterialivSGIX_ovr_2(face, pname, &params);
    
    private static procedure z_GetFragmentLightfvSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single);
    external 'opengl32.dll' name 'glGetFragmentLightfvSGIX';
    private static procedure z_GetFragmentLightfvSGIX_ovr_0_anh0001(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentLightfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentLightfvSGIX_ovr_0(light, pname, &params[0]) else
      z_GetFragmentLightfvSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: single) :=
    z_GetFragmentLightfvSGIX_ovr_0(light, pname, &params);
    private static procedure z_GetFragmentLightfvSGIX_ovr_2(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentLightfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightfvSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_GetFragmentLightfvSGIX_ovr_2(light, pname, &params);
    
    private static procedure z_GetFragmentLightivSGIX_ovr_0(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32);
    external 'opengl32.dll' name 'glGetFragmentLightivSGIX';
    private static procedure z_GetFragmentLightivSGIX_ovr_0_anh0001(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentLightivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentLightivSGIX_ovr_0(light, pname, &params[0]) else
      z_GetFragmentLightivSGIX_ovr_0_anh0001(light, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; var &params: Int32) :=
    z_GetFragmentLightivSGIX_ovr_0(light, pname, &params);
    private static procedure z_GetFragmentLightivSGIX_ovr_2(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentLightivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentLightivSGIX(light: FragmentLightNameSGIX; pname: FragmentLightParameterSGIX; &params: IntPtr) :=
    z_GetFragmentLightivSGIX_ovr_2(light, pname, &params);
    
    private static procedure z_GetFragmentMaterialfvSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: single);
    external 'opengl32.dll' name 'glGetFragmentMaterialfvSGIX';
    private static procedure z_GetFragmentMaterialfvSGIX_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentMaterialfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentMaterialfvSGIX_ovr_0(face, pname, &params[0]) else
      z_GetFragmentMaterialfvSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; var &params: single) :=
    z_GetFragmentMaterialfvSGIX_ovr_0(face, pname, &params);
    private static procedure z_GetFragmentMaterialfvSGIX_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentMaterialfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialfvSGIX(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_GetFragmentMaterialfvSGIX_ovr_2(face, pname, &params);
    
    private static procedure z_GetFragmentMaterialivSGIX_ovr_0(face: DummyEnum; pname: MaterialParameter; var &params: Int32);
    external 'opengl32.dll' name 'glGetFragmentMaterialivSGIX';
    private static procedure z_GetFragmentMaterialivSGIX_ovr_0_anh0001(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentMaterialivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetFragmentMaterialivSGIX_ovr_0(face, pname, &params[0]) else
      z_GetFragmentMaterialivSGIX_ovr_0_anh0001(face, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; var &params: Int32) :=
    z_GetFragmentMaterialivSGIX_ovr_0(face, pname, &params);
    private static procedure z_GetFragmentMaterialivSGIX_ovr_2(face: DummyEnum; pname: MaterialParameter; &params: IntPtr);
    external 'opengl32.dll' name 'glGetFragmentMaterialivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetFragmentMaterialivSGIX(face: DummyEnum; pname: MaterialParameter; &params: IntPtr) :=
    z_GetFragmentMaterialivSGIX_ovr_2(face, pname, &params);
    
    private static procedure z_LightEnviSGIX_ovr_0(pname: LightEnvParameterSGIX; param: Int32);
    external 'opengl32.dll' name 'glLightEnviSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LightEnviSGIX(pname: LightEnvParameterSGIX; param: Int32) :=
    z_LightEnviSGIX_ovr_0(pname, param);
    
  end;
  
  glFramezoomSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FrameZoomSGIX_ovr_0(factor: Int32);
    external 'opengl32.dll' name 'glFrameZoomSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FrameZoomSGIX(factor: Int32) :=
    z_FrameZoomSGIX_ovr_0(factor);
    
  end;
  
  glIglooInterfaceSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_IglooInterfaceSGIX_ovr_0(pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glIglooInterfaceSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure IglooInterfaceSGIX(pname: DummyEnum; &params: IntPtr) :=
    z_IglooInterfaceSGIX_ovr_0(pname, &params);
    
  end;
  
  glInstrumentsSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static function z_GetInstrumentsSGIX_ovr_0: Int32;
    external 'opengl32.dll' name 'glGetInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function GetInstrumentsSGIX: Int32 :=
    z_GetInstrumentsSGIX_ovr_0;
    
    private static procedure z_InstrumentsBufferSGIX_ovr_0(size: Int32; var buffer: Int32);
    external 'opengl32.dll' name 'glInstrumentsBufferSGIX';
    private static procedure z_InstrumentsBufferSGIX_ovr_0_anh001(size: Int32; buffer: IntPtr);
    external 'opengl32.dll' name 'glInstrumentsBufferSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; buffer: array of Int32) :=
    if (buffer<>nil) and (buffer.Length<>0) then
      z_InstrumentsBufferSGIX_ovr_0(size, buffer[0]) else
      z_InstrumentsBufferSGIX_ovr_0_anh001(size, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; var buffer: Int32) :=
    z_InstrumentsBufferSGIX_ovr_0(size, buffer);
    private static procedure z_InstrumentsBufferSGIX_ovr_2(size: Int32; buffer: IntPtr);
    external 'opengl32.dll' name 'glInstrumentsBufferSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure InstrumentsBufferSGIX(size: Int32; buffer: IntPtr) :=
    z_InstrumentsBufferSGIX_ovr_2(size, buffer);
    
    private static function z_PollInstrumentsSGIX_ovr_0(var marker_p: Int32): Int32;
    external 'opengl32.dll' name 'glPollInstrumentsSGIX';
    private static function z_PollInstrumentsSGIX_ovr_0_anh01(marker_p: IntPtr): Int32;
    external 'opengl32.dll' name 'glPollInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollInstrumentsSGIX(marker_p: array of Int32): Int32 :=
    if (marker_p<>nil) and (marker_p.Length<>0) then
      z_PollInstrumentsSGIX_ovr_0(marker_p[0]) else
      z_PollInstrumentsSGIX_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollInstrumentsSGIX(var marker_p: Int32): Int32 :=
    z_PollInstrumentsSGIX_ovr_0(marker_p);
    private static function z_PollInstrumentsSGIX_ovr_2(marker_p: IntPtr): Int32;
    external 'opengl32.dll' name 'glPollInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] function PollInstrumentsSGIX(marker_p: IntPtr): Int32 :=
    z_PollInstrumentsSGIX_ovr_2(marker_p);
    
    private static procedure z_ReadInstrumentsSGIX_ovr_0(marker: Int32);
    external 'opengl32.dll' name 'glReadInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReadInstrumentsSGIX(marker: Int32) :=
    z_ReadInstrumentsSGIX_ovr_0(marker);
    
    private static procedure z_StartInstrumentsSGIX_ovr_0;
    external 'opengl32.dll' name 'glStartInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StartInstrumentsSGIX :=
    z_StartInstrumentsSGIX_ovr_0;
    
    private static procedure z_StopInstrumentsSGIX_ovr_0(marker: Int32);
    external 'opengl32.dll' name 'glStopInstrumentsSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure StopInstrumentsSGIX(marker: Int32) :=
    z_StopInstrumentsSGIX_ovr_0(marker);
    
  end;
  
  glListPrioritySGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GetListParameterfvSGIX_ovr_0(list: UInt32; pname: ListParameterName; var &params: single);
    external 'opengl32.dll' name 'glGetListParameterfvSGIX';
    private static procedure z_GetListParameterfvSGIX_ovr_0_anh0001(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetListParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetListParameterfvSGIX_ovr_0(list, pname, &params[0]) else
      z_GetListParameterfvSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; var &params: single) :=
    z_GetListParameterfvSGIX_ovr_0(list, pname, &params);
    private static procedure z_GetListParameterfvSGIX_ovr_2(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetListParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_GetListParameterfvSGIX_ovr_2(list, pname, &params);
    
    private static procedure z_GetListParameterivSGIX_ovr_0(list: UInt32; pname: ListParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glGetListParameterivSGIX';
    private static procedure z_GetListParameterivSGIX_ovr_0_anh0001(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetListParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetListParameterivSGIX_ovr_0(list, pname, &params[0]) else
      z_GetListParameterivSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; var &params: Int32) :=
    z_GetListParameterivSGIX_ovr_0(list, pname, &params);
    private static procedure z_GetListParameterivSGIX_ovr_2(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glGetListParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_GetListParameterivSGIX_ovr_2(list, pname, &params);
    
    private static procedure z_ListParameterfSGIX_ovr_0(list: UInt32; pname: ListParameterName; param: single);
    external 'opengl32.dll' name 'glListParameterfSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfSGIX(list: UInt32; pname: ListParameterName; param: single) :=
    z_ListParameterfSGIX_ovr_0(list, pname, param);
    
    private static procedure z_ListParameterfvSGIX_ovr_0(list: UInt32; pname: ListParameterName; var &params: single);
    external 'opengl32.dll' name 'glListParameterfvSGIX';
    private static procedure z_ListParameterfvSGIX_ovr_0_anh0001(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glListParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ListParameterfvSGIX_ovr_0(list, pname, &params[0]) else
      z_ListParameterfvSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; var &params: single) :=
    z_ListParameterfvSGIX_ovr_0(list, pname, &params);
    private static procedure z_ListParameterfvSGIX_ovr_2(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glListParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterfvSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_ListParameterfvSGIX_ovr_2(list, pname, &params);
    
    private static procedure z_ListParameteriSGIX_ovr_0(list: UInt32; pname: ListParameterName; param: Int32);
    external 'opengl32.dll' name 'glListParameteriSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameteriSGIX(list: UInt32; pname: ListParameterName; param: Int32) :=
    z_ListParameteriSGIX_ovr_0(list, pname, param);
    
    private static procedure z_ListParameterivSGIX_ovr_0(list: UInt32; pname: ListParameterName; var &params: Int32);
    external 'opengl32.dll' name 'glListParameterivSGIX';
    private static procedure z_ListParameterivSGIX_ovr_0_anh0001(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glListParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ListParameterivSGIX_ovr_0(list, pname, &params[0]) else
      z_ListParameterivSGIX_ovr_0_anh0001(list, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; var &params: Int32) :=
    z_ListParameterivSGIX_ovr_0(list, pname, &params);
    private static procedure z_ListParameterivSGIX_ovr_2(list: UInt32; pname: ListParameterName; &params: IntPtr);
    external 'opengl32.dll' name 'glListParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ListParameterivSGIX(list: UInt32; pname: ListParameterName; &params: IntPtr) :=
    z_ListParameterivSGIX_ovr_2(list, pname, &params);
    
  end;
  
  glPixelTextureSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_PixelTexGenSGIX_ovr_0(mode: PixelTexGenModeSGIX);
    external 'opengl32.dll' name 'glPixelTexGenSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure PixelTexGenSGIX(mode: PixelTexGenModeSGIX) :=
    z_PixelTexGenSGIX_ovr_0(mode);
    
  end;
  
  glPolynomialFfdSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DeformationMap3dSGIX_ovr_0(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; var points: real);
    external 'opengl32.dll' name 'glDeformationMap3dSGIX';
    private static procedure z_DeformationMap3dSGIX_ovr_0_anh000000000000001(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDeformationMap3dSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: array of real) :=
    if (points<>nil) and (points.Length<>0) then
      z_DeformationMap3dSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points[0]) else
      z_DeformationMap3dSGIX_ovr_0_anh000000000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; var points: real) :=
    z_DeformationMap3dSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    private static procedure z_DeformationMap3dSGIX_ovr_2(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDeformationMap3dSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3dSGIX(target: FfdTargetSGIX; u1: real; u2: real; ustride: Int32; uorder: Int32; v1: real; v2: real; vstride: Int32; vorder: Int32; w1: real; w2: real; wstride: Int32; worder: Int32; points: IntPtr) :=
    z_DeformationMap3dSGIX_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    
    private static procedure z_DeformationMap3fSGIX_ovr_0(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; var points: single);
    external 'opengl32.dll' name 'glDeformationMap3fSGIX';
    private static procedure z_DeformationMap3fSGIX_ovr_0_anh000000000000001(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDeformationMap3fSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: array of single) :=
    if (points<>nil) and (points.Length<>0) then
      z_DeformationMap3fSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points[0]) else
      z_DeformationMap3fSGIX_ovr_0_anh000000000000001(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; var points: single) :=
    z_DeformationMap3fSGIX_ovr_0(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    private static procedure z_DeformationMap3fSGIX_ovr_2(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr);
    external 'opengl32.dll' name 'glDeformationMap3fSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformationMap3fSGIX(target: FfdTargetSGIX; u1: single; u2: single; ustride: Int32; uorder: Int32; v1: single; v2: single; vstride: Int32; vorder: Int32; w1: single; w2: single; wstride: Int32; worder: Int32; points: IntPtr) :=
    z_DeformationMap3fSGIX_ovr_2(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
    
    private static procedure z_DeformSGIX_ovr_0(mask: DummyFlags);
    external 'opengl32.dll' name 'glDeformSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DeformSGIX(mask: DummyFlags) :=
    z_DeformSGIX_ovr_0(mask);
    
    private static procedure z_LoadIdentityDeformationMapSGIX_ovr_0(mask: DummyFlags);
    external 'opengl32.dll' name 'glLoadIdentityDeformationMapSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure LoadIdentityDeformationMapSGIX(mask: DummyFlags) :=
    z_LoadIdentityDeformationMapSGIX_ovr_0(mask);
    
  end;
  
  glReferencePlaneSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ReferencePlaneSGIX_ovr_0(var equation: real);
    external 'opengl32.dll' name 'glReferencePlaneSGIX';
    private static procedure z_ReferencePlaneSGIX_ovr_0_anh01(equation: IntPtr);
    external 'opengl32.dll' name 'glReferencePlaneSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(equation: array of real) :=
    if (equation<>nil) and (equation.Length<>0) then
      z_ReferencePlaneSGIX_ovr_0(equation[0]) else
      z_ReferencePlaneSGIX_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(var equation: real) :=
    z_ReferencePlaneSGIX_ovr_0(equation);
    private static procedure z_ReferencePlaneSGIX_ovr_2(equation: IntPtr);
    external 'opengl32.dll' name 'glReferencePlaneSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReferencePlaneSGIX(equation: IntPtr) :=
    z_ReferencePlaneSGIX_ovr_2(equation);
    
  end;
  
  glSpriteSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_SpriteParameterfSGIX_ovr_0(pname: SpriteParameterNameSGIX; param: single);
    external 'opengl32.dll' name 'glSpriteParameterfSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfSGIX(pname: SpriteParameterNameSGIX; param: single) :=
    z_SpriteParameterfSGIX_ovr_0(pname, param);
    
    private static procedure z_SpriteParameterfvSGIX_ovr_0(pname: SpriteParameterNameSGIX; var &params: single);
    external 'opengl32.dll' name 'glSpriteParameterfvSGIX';
    private static procedure z_SpriteParameterfvSGIX_ovr_0_anh001(pname: SpriteParameterNameSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glSpriteParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SpriteParameterfvSGIX_ovr_0(pname, &params[0]) else
      z_SpriteParameterfvSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; var &params: single) :=
    z_SpriteParameterfvSGIX_ovr_0(pname, &params);
    private static procedure z_SpriteParameterfvSGIX_ovr_2(pname: SpriteParameterNameSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glSpriteParameterfvSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterfvSGIX(pname: SpriteParameterNameSGIX; &params: IntPtr) :=
    z_SpriteParameterfvSGIX_ovr_2(pname, &params);
    
    private static procedure z_SpriteParameteriSGIX_ovr_0(pname: SpriteParameterNameSGIX; param: Int32);
    external 'opengl32.dll' name 'glSpriteParameteriSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameteriSGIX(pname: SpriteParameterNameSGIX; param: Int32) :=
    z_SpriteParameteriSGIX_ovr_0(pname, param);
    
    private static procedure z_SpriteParameterivSGIX_ovr_0(pname: SpriteParameterNameSGIX; var &params: Int32);
    external 'opengl32.dll' name 'glSpriteParameterivSGIX';
    private static procedure z_SpriteParameterivSGIX_ovr_0_anh001(pname: SpriteParameterNameSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glSpriteParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_SpriteParameterivSGIX_ovr_0(pname, &params[0]) else
      z_SpriteParameterivSGIX_ovr_0_anh001(pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; var &params: Int32) :=
    z_SpriteParameterivSGIX_ovr_0(pname, &params);
    private static procedure z_SpriteParameterivSGIX_ovr_2(pname: SpriteParameterNameSGIX; &params: IntPtr);
    external 'opengl32.dll' name 'glSpriteParameterivSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure SpriteParameterivSGIX(pname: SpriteParameterNameSGIX; &params: IntPtr) :=
    z_SpriteParameterivSGIX_ovr_2(pname, &params);
    
  end;
  
  glTagSampleBufferSGIX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_TagSampleBufferSGIX_ovr_0;
    external 'opengl32.dll' name 'glTagSampleBufferSGIX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TagSampleBufferSGIX :=
    z_TagSampleBufferSGIX_ovr_0;
    
  end;
  
  glColorTableSGI = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ColorTableSGI_ovr_0(target: ColorTableTargetSGI; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr);
    external 'opengl32.dll' name 'glColorTableSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableSGI(target: ColorTableTargetSGI; _internalformat: InternalFormat; width: Int32; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_ColorTableSGI_ovr_0(target, _internalformat, width, format, &type, table);
    
    private static procedure z_ColorTableParameterfvSGI_ovr_0(target: ColorTableTargetSGI; pname: DummyEnum; var &params: single);
    external 'opengl32.dll' name 'glColorTableParameterfvSGI';
    private static procedure z_ColorTableParameterfvSGI_ovr_0_anh0001(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterfvSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: DummyEnum; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterfvSGI_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterfvSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: DummyEnum; var &params: single) :=
    z_ColorTableParameterfvSGI_ovr_0(target, pname, &params);
    private static procedure z_ColorTableParameterfvSGI_ovr_2(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterfvSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr) :=
    z_ColorTableParameterfvSGI_ovr_2(target, pname, &params);
    
    private static procedure z_ColorTableParameterivSGI_ovr_0(target: ColorTableTargetSGI; pname: DummyEnum; var &params: Int32);
    external 'opengl32.dll' name 'glColorTableParameterivSGI';
    private static procedure z_ColorTableParameterivSGI_ovr_0_anh0001(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterivSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: DummyEnum; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_ColorTableParameterivSGI_ovr_0(target, pname, &params[0]) else
      z_ColorTableParameterivSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: DummyEnum; var &params: Int32) :=
    z_ColorTableParameterivSGI_ovr_0(target, pname, &params);
    private static procedure z_ColorTableParameterivSGI_ovr_2(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr);
    external 'opengl32.dll' name 'glColorTableParameterivSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ColorTableParameterivSGI(target: ColorTableTargetSGI; pname: DummyEnum; &params: IntPtr) :=
    z_ColorTableParameterivSGI_ovr_2(target, pname, &params);
    
    private static procedure z_CopyColorTableSGI_ovr_0(target: ColorTableTargetSGI; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32);
    external 'opengl32.dll' name 'glCopyColorTableSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure CopyColorTableSGI(target: ColorTableTargetSGI; _internalformat: InternalFormat; x: Int32; y: Int32; width: Int32) :=
    z_CopyColorTableSGI_ovr_0(target, _internalformat, x, y, width);
    
    private static procedure z_GetColorTableSGI_ovr_0(target: ColorTableTargetSGI; format: PixelFormat; &type: PixelType; table: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableSGI(target: ColorTableTargetSGI; format: PixelFormat; &type: PixelType; table: IntPtr) :=
    z_GetColorTableSGI_ovr_0(target, format, &type, table);
    
    private static procedure z_GetColorTableParameterfvSGI_ovr_0(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: single);
    external 'opengl32.dll' name 'glGetColorTableParameterfvSGI';
    private static procedure z_GetColorTableParameterfvSGI_ovr_0_anh0001(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfvSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: array of single) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterfvSGI_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterfvSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: single) :=
    z_GetColorTableParameterfvSGI_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameterfvSGI_ovr_2(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterfvSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterfvSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterfvSGI_ovr_2(target, pname, &params);
    
    private static procedure z_GetColorTableParameterivSGI_ovr_0(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: Int32);
    external 'opengl32.dll' name 'glGetColorTableParameterivSGI';
    private static procedure z_GetColorTableParameterivSGI_ovr_0_anh0001(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterivSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: array of Int32) :=
    if (&params<>nil) and (&params.Length<>0) then
      z_GetColorTableParameterivSGI_ovr_0(target, pname, &params[0]) else
      z_GetColorTableParameterivSGI_ovr_0_anh0001(target, pname, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; var &params: Int32) :=
    z_GetColorTableParameterivSGI_ovr_0(target, pname, &params);
    private static procedure z_GetColorTableParameterivSGI_ovr_2(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr);
    external 'opengl32.dll' name 'glGetColorTableParameterivSGI';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GetColorTableParameterivSGI(target: ColorTableTargetSGI; pname: GetColorTableParameterPNameSGI; &params: IntPtr) :=
    z_GetColorTableParameterivSGI_ovr_2(target, pname, &params);
    
  end;
  
  glConstantDataSUNX = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_FinishTextureSUNX_ovr_0;
    external 'opengl32.dll' name 'glFinishTextureSUNX';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure FinishTextureSUNX :=
    z_FinishTextureSUNX_ovr_0;
    
  end;
  
  glGlobalAlphaSUN = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_GlobalAlphaFactorbSUN_ovr_0(factor: SByte);
    external 'opengl32.dll' name 'glGlobalAlphaFactorbSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorbSUN(factor: SByte) :=
    z_GlobalAlphaFactorbSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactorsSUN_ovr_0(factor: Int16);
    external 'opengl32.dll' name 'glGlobalAlphaFactorsSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorsSUN(factor: Int16) :=
    z_GlobalAlphaFactorsSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactoriSUN_ovr_0(factor: Int32);
    external 'opengl32.dll' name 'glGlobalAlphaFactoriSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactoriSUN(factor: Int32) :=
    z_GlobalAlphaFactoriSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactorfSUN_ovr_0(factor: single);
    external 'opengl32.dll' name 'glGlobalAlphaFactorfSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorfSUN(factor: single) :=
    z_GlobalAlphaFactorfSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactordSUN_ovr_0(factor: real);
    external 'opengl32.dll' name 'glGlobalAlphaFactordSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactordSUN(factor: real) :=
    z_GlobalAlphaFactordSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactorubSUN_ovr_0(factor: Byte);
    external 'opengl32.dll' name 'glGlobalAlphaFactorubSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorubSUN(factor: Byte) :=
    z_GlobalAlphaFactorubSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactorusSUN_ovr_0(factor: UInt16);
    external 'opengl32.dll' name 'glGlobalAlphaFactorusSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactorusSUN(factor: UInt16) :=
    z_GlobalAlphaFactorusSUN_ovr_0(factor);
    
    private static procedure z_GlobalAlphaFactoruiSUN_ovr_0(factor: UInt32);
    external 'opengl32.dll' name 'glGlobalAlphaFactoruiSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure GlobalAlphaFactoruiSUN(factor: UInt32) :=
    z_GlobalAlphaFactoruiSUN_ovr_0(factor);
    
  end;
  
  glMeshArraySUN = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_DrawMeshArraysSUN_ovr_0(mode: PrimitiveType; first: Int32; count: Int32; width: Int32);
    external 'opengl32.dll' name 'glDrawMeshArraysSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure DrawMeshArraysSUN(mode: PrimitiveType; first: Int32; count: Int32; width: Int32) :=
    z_DrawMeshArraysSUN_ovr_0(mode, first, count, width);
    
  end;
  
  glTriangleListSUN = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_ReplacementCodeuiSUN_ovr_0(code: UInt32);
    external 'opengl32.dll' name 'glReplacementCodeuiSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiSUN(code: UInt32) :=
    z_ReplacementCodeuiSUN_ovr_0(code);
    
    private static procedure z_ReplacementCodeusSUN_ovr_0(code: UInt16);
    external 'opengl32.dll' name 'glReplacementCodeusSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusSUN(code: UInt16) :=
    z_ReplacementCodeusSUN_ovr_0(code);
    
    private static procedure z_ReplacementCodeubSUN_ovr_0(code: Byte);
    external 'opengl32.dll' name 'glReplacementCodeubSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubSUN(code: Byte) :=
    z_ReplacementCodeubSUN_ovr_0(code);
    
    private static procedure z_ReplacementCodeuivSUN_ovr_0(var code: UInt32);
    external 'opengl32.dll' name 'glReplacementCodeuivSUN';
    private static procedure z_ReplacementCodeuivSUN_ovr_0_anh01(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuivSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(code: array of UInt32) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeuivSUN_ovr_0(code[0]) else
      z_ReplacementCodeuivSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(var code: UInt32) :=
    z_ReplacementCodeuivSUN_ovr_0(code);
    private static procedure z_ReplacementCodeuivSUN_ovr_2(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuivSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuivSUN(code: IntPtr) :=
    z_ReplacementCodeuivSUN_ovr_2(code);
    
    private static procedure z_ReplacementCodeusvSUN_ovr_0(var code: UInt16);
    external 'opengl32.dll' name 'glReplacementCodeusvSUN';
    private static procedure z_ReplacementCodeusvSUN_ovr_0_anh01(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeusvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(code: array of UInt16) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeusvSUN_ovr_0(code[0]) else
      z_ReplacementCodeusvSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(var code: UInt16) :=
    z_ReplacementCodeusvSUN_ovr_0(code);
    private static procedure z_ReplacementCodeusvSUN_ovr_2(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeusvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeusvSUN(code: IntPtr) :=
    z_ReplacementCodeusvSUN_ovr_2(code);
    
    private static procedure z_ReplacementCodeubvSUN_ovr_0(var code: Byte);
    external 'opengl32.dll' name 'glReplacementCodeubvSUN';
    private static procedure z_ReplacementCodeubvSUN_ovr_0_anh01(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeubvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(code: array of Byte) :=
    if (code<>nil) and (code.Length<>0) then
      z_ReplacementCodeubvSUN_ovr_0(code[0]) else
      z_ReplacementCodeubvSUN_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(var code: Byte) :=
    z_ReplacementCodeubvSUN_ovr_0(code);
    private static procedure z_ReplacementCodeubvSUN_ovr_2(code: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeubvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeubvSUN(code: IntPtr) :=
    z_ReplacementCodeubvSUN_ovr_2(code);
    
    private static procedure z_ReplacementCodePointerSUN_ovr_0(&type: ReplacementCodeTypeSUN; stride: Int32; var _pointer: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodePointerSUN';
    private static procedure z_ReplacementCodePointerSUN_ovr_0_anh0001(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodePointerSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: array of IntPtr) :=
    if (_pointer<>nil) and (_pointer.Length<>0) then
      z_ReplacementCodePointerSUN_ovr_0(&type, stride, _pointer[0]) else
      z_ReplacementCodePointerSUN_ovr_0_anh0001(&type, stride, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; var _pointer: IntPtr) :=
    z_ReplacementCodePointerSUN_ovr_0(&type, stride, _pointer);
    private static procedure z_ReplacementCodePointerSUN_ovr_2(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: pointer);
    external 'opengl32.dll' name 'glReplacementCodePointerSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodePointerSUN(&type: ReplacementCodeTypeSUN; stride: Int32; _pointer: pointer) :=
    z_ReplacementCodePointerSUN_ovr_2(&type, stride, _pointer);
    
  end;
  
  glVertexSUN = sealed class
    public static function GetFuncAdr([MarshalAs(UnmanagedType.LPStr)] lpszProc: string): IntPtr;
    external 'opengl32.dll' name 'wglGetProcAddress';
    public static function GetFuncOrNil<T>(fadr: IntPtr) :=
    fadr=IntPtr.Zero ? default(T) :
    Marshal.GetDelegateForFunctionPointer&<T>(fadr);
    
    private static procedure z_Color4ubVertex2fSUN_ovr_0(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single);
    external 'opengl32.dll' name 'glColor4ubVertex2fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fSUN(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single) :=
    z_Color4ubVertex2fSUN_ovr_0(r, g, b, a, x, y);
    
    private static procedure z_Color4ubVertex2fvSUN_ovr_0(var c: Vec4ub; var v: Vec2f);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(var c: Vec4ub; var v: Vec2f) :=
    z_Color4ubVertex2fvSUN_ovr_0(c, v);
    private static procedure z_Color4ubVertex2fvSUN_ovr_1(var c: Byte; var v: single);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    private static procedure z_Color4ubVertex2fvSUN_ovr_1_anh010(c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    private static procedure z_Color4ubVertex2fvSUN_ovr_1_anh001(var c: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    private static procedure z_Color4ubVertex2fvSUN_ovr_1_anh011(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex2fvSUN_ovr_1(c[0], v[0]) else
        z_Color4ubVertex2fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex2fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color4ubVertex2fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(var c: Byte; var v: single) :=
    z_Color4ubVertex2fvSUN_ovr_1(c, v);
    private static procedure z_Color4ubVertex2fvSUN_ovr_3(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex2fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex2fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color4ubVertex2fvSUN_ovr_3(c, v);
    
    private static procedure z_Color4ubVertex3fSUN_ovr_0(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glColor4ubVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fSUN(r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_Color4ubVertex3fSUN_ovr_0(r, g, b, a, x, y, z);
    
    private static procedure z_Color4ubVertex3fvSUN_ovr_0(var c: Vec4ub; var v: Vec3f);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(var c: Vec4ub; var v: Vec3f) :=
    z_Color4ubVertex3fvSUN_ovr_0(c, v);
    private static procedure z_Color4ubVertex3fvSUN_ovr_1(var c: Byte; var v: single);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    private static procedure z_Color4ubVertex3fvSUN_ovr_1_anh010(c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    private static procedure z_Color4ubVertex3fvSUN_ovr_1_anh001(var c: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    private static procedure z_Color4ubVertex3fvSUN_ovr_1_anh011(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex3fvSUN_ovr_1(c[0], v[0]) else
        z_Color4ubVertex3fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color4ubVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color4ubVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(var c: Byte; var v: single) :=
    z_Color4ubVertex3fvSUN_ovr_1(c, v);
    private static procedure z_Color4ubVertex3fvSUN_ovr_3(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4ubVertex3fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color4ubVertex3fvSUN_ovr_3(c, v);
    
    private static procedure z_Color3fVertex3fSUN_ovr_0(r: single; g: single; b: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glColor3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fSUN(r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_Color3fVertex3fSUN_ovr_0(r, g, b, x, y, z);
    
    private static procedure z_Color3fVertex3fvSUN_ovr_0(var c: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(var c: Vec3f; var v: Vec3f) :=
    z_Color3fVertex3fvSUN_ovr_0(c, v);
    private static procedure z_Color3fVertex3fvSUN_ovr_1(var c: single; var v: single);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    private static procedure z_Color3fVertex3fvSUN_ovr_1_anh010(c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    private static procedure z_Color3fVertex3fvSUN_ovr_1_anh001(var c: single; v: IntPtr);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    private static procedure z_Color3fVertex3fvSUN_ovr_1_anh011(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(c: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Color3fVertex3fvSUN_ovr_1(c[0], v[0]) else
        z_Color3fVertex3fvSUN_ovr_1_anh001(c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Color3fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Color3fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(var c: single; var v: single) :=
    z_Color3fVertex3fvSUN_ovr_1(c, v);
    private static procedure z_Color3fVertex3fvSUN_ovr_3(c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color3fVertex3fvSUN(c: IntPtr; v: IntPtr) :=
    z_Color3fVertex3fvSUN_ovr_3(c, v);
    
    private static procedure z_Normal3fVertex3fSUN_ovr_0(nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fSUN(nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_Normal3fVertex3fSUN_ovr_0(nx, ny, nz, x, y, z);
    
    private static procedure z_Normal3fVertex3fvSUN_ovr_0(var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(var n: Vec3f; var v: Vec3f) :=
    z_Normal3fVertex3fvSUN_ovr_0(n, v);
    private static procedure z_Normal3fVertex3fvSUN_ovr_1(var n: single; var v: single);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    private static procedure z_Normal3fVertex3fvSUN_ovr_1_anh010(n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    private static procedure z_Normal3fVertex3fvSUN_ovr_1_anh001(var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    private static procedure z_Normal3fVertex3fvSUN_ovr_1_anh011(n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(n: array of single; v: array of single) :=
    if (n<>nil) and (n.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_Normal3fVertex3fvSUN_ovr_1(n[0], v[0]) else
        z_Normal3fVertex3fvSUN_ovr_1_anh001(n[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_Normal3fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_Normal3fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(var n: single; var v: single) :=
    z_Normal3fVertex3fvSUN_ovr_1(n, v);
    private static procedure z_Normal3fVertex3fvSUN_ovr_3(n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Normal3fVertex3fvSUN(n: IntPtr; v: IntPtr) :=
    z_Normal3fVertex3fvSUN_ovr_3(n, v);
    
    private static procedure z_Color4fNormal3fVertex3fSUN_ovr_0(r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fSUN(r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_Color4fNormal3fVertex3fSUN_ovr_0(r, g, b, a, nx, ny, nz, x, y, z);
    
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_0(var c: Vec4f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_0(c, n, v);
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1(var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0100(c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0010(var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0110(c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0001(var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0101(c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0011(var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0111(c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(c: array of single; n: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1(c[0], n[0], v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0001(c[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0010(c[0], IntPtr.Zero, v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0011(c[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, n[0], v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_Color4fNormal3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(var c: single; var n: single; var v: single) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_1(c, n, v);
    private static procedure z_Color4fNormal3fVertex3fvSUN_ovr_3(c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure Color4fNormal3fVertex3fvSUN(c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_Color4fNormal3fVertex3fvSUN_ovr_3(c, n, v);
    
    private static procedure z_TexCoord2fVertex3fSUN_ovr_0(s: single; t: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fSUN(s: single; t: single; x: single; y: single; z: single) :=
    z_TexCoord2fVertex3fSUN_ovr_0(s, t, x, y, z);
    
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_0(var tc: Vec2f; var v: Vec3f);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(var tc: Vec2f; var v: Vec3f) :=
    z_TexCoord2fVertex3fvSUN_ovr_0(tc, v);
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_1(var tc: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_1_anh010(tc: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_1_anh001(var tc: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_1_anh011(tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord2fVertex3fvSUN_ovr_1(tc[0], v[0]) else
        z_TexCoord2fVertex3fvSUN_ovr_1_anh001(tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord2fVertex3fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_TexCoord2fVertex3fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(var tc: single; var v: single) :=
    z_TexCoord2fVertex3fvSUN_ovr_1(tc, v);
    private static procedure z_TexCoord2fVertex3fvSUN_ovr_3(tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fVertex3fvSUN(tc: IntPtr; v: IntPtr) :=
    z_TexCoord2fVertex3fvSUN_ovr_3(tc, v);
    
    private static procedure z_TexCoord4fVertex4fSUN_ovr_0(s: single; t: single; p: single; q: single; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fSUN(s: single; t: single; p: single; q: single; x: single; y: single; z: single; w: single) :=
    z_TexCoord4fVertex4fSUN_ovr_0(s, t, p, q, x, y, z, w);
    
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_0(var tc: Vec4f; var v: Vec4f);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(var tc: Vec4f; var v: Vec4f) :=
    z_TexCoord4fVertex4fvSUN_ovr_0(tc, v);
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_1(var tc: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_1_anh010(tc: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_1_anh001(var tc: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_1_anh011(tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord4fVertex4fvSUN_ovr_1(tc[0], v[0]) else
        z_TexCoord4fVertex4fvSUN_ovr_1_anh001(tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_TexCoord4fVertex4fvSUN_ovr_1_anh010(IntPtr.Zero, v[0]) else
        z_TexCoord4fVertex4fvSUN_ovr_1_anh011(IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(var tc: single; var v: single) :=
    z_TexCoord4fVertex4fvSUN_ovr_1(tc, v);
    private static procedure z_TexCoord4fVertex4fvSUN_ovr_3(tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fVertex4fvSUN(tc: IntPtr; v: IntPtr) :=
    z_TexCoord4fVertex4fvSUN_ovr_3(tc, v);
    
    private static procedure z_TexCoord2fColor4ubVertex3fSUN_ovr_0(s: single; t: single; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fSUN(s: single; t: single; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_TexCoord2fColor4ubVertex3fSUN_ovr_0(s, t, r, g, b, a, x, y, z);
    
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_0(var tc: Vec2f; var c: Vec4ub; var v: Vec3f);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(var tc: Vec2f; var c: Vec4ub; var v: Vec3f) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_0(tc, c, v);
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1(var tc: single; var c: Byte; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0100(tc: IntPtr; var c: Byte; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0010(var tc: single; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0110(tc: IntPtr; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0001(var tc: single; var c: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0101(tc: IntPtr; var c: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0011(var tc: single; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0111(tc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(tc: array of single; c: array of Byte; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1(tc[0], c[0], v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0001(tc[0], c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, c[0], v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fColor4ubVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(var tc: single; var c: Byte; var v: single) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_1(tc, c, v);
    private static procedure z_TexCoord2fColor4ubVertex3fvSUN_ovr_3(tc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4ubVertex3fvSUN(tc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor4ubVertex3fvSUN_ovr_3(tc, c, v);
    
    private static procedure z_TexCoord2fColor3fVertex3fSUN_ovr_0(s: single; t: single; r: single; g: single; b: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fSUN(s: single; t: single; r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_TexCoord2fColor3fVertex3fSUN_ovr_0(s, t, r, g, b, x, y, z);
    
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_0(var tc: Vec2f; var c: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(var tc: Vec2f; var c: Vec3f; var v: Vec3f) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_0(tc, c, v);
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1(var tc: single; var c: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0100(tc: IntPtr; var c: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0010(var tc: single; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0110(tc: IntPtr; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0001(var tc: single; var c: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0101(tc: IntPtr; var c: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0011(var tc: single; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0111(tc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(tc: array of single; c: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1(tc[0], c[0], v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0001(tc[0], c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, c[0], v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, c[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fColor3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(var tc: single; var c: single; var v: single) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_1(tc, c, v);
    private static procedure z_TexCoord2fColor3fVertex3fvSUN_ovr_3(tc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor3fVertex3fvSUN(tc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor3fVertex3fvSUN_ovr_3(tc, c, v);
    
    private static procedure z_TexCoord2fNormal3fVertex3fSUN_ovr_0(s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fSUN(s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_TexCoord2fNormal3fVertex3fSUN_ovr_0(s, t, nx, ny, nz, x, y, z);
    
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_0(var tc: Vec2f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(var tc: Vec2f; var n: Vec3f; var v: Vec3f) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_0(tc, n, v);
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1(var tc: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0100(tc: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0010(var tc: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0110(tc: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0001(var tc: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0101(tc: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0011(var tc: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0111(tc: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(tc: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1(tc[0], n[0], v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0001(tc[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0010(tc[0], IntPtr.Zero, v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0011(tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0100(IntPtr.Zero, n[0], v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0101(IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0110(IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_TexCoord2fNormal3fVertex3fvSUN_ovr_1_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(var tc: single; var n: single; var v: single) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_1(tc, n, v);
    private static procedure z_TexCoord2fNormal3fVertex3fvSUN_ovr_3(tc: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fNormal3fVertex3fvSUN(tc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord2fNormal3fVertex3fvSUN_ovr_3(tc, n, v);
    
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fSUN(s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_TexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(s, t, r, g, b, a, nx, ny, nz, x, y, z);
    
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(tc, c, n, v);
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(var tc: single; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01000(tc: IntPtr; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(var tc: single; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01100(tc: IntPtr; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(var tc: single; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01010(tc: IntPtr; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(var tc: single; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01110(tc: IntPtr; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(var tc: single; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01001(tc: IntPtr; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(var tc: single; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01101(tc: IntPtr; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(var tc: single; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01011(tc: IntPtr; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(var tc: single; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01111(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(tc[0], c[0], n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(tc[0], c[0], IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(tc[0], IntPtr.Zero, n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01000(IntPtr.Zero, c[0], n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01001(IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01010(IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01011(IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01100(IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01101(IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh01111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(var tc: single; var c: single; var n: single; var v: single) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(tc, c, n, v);
    private static procedure z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord2fColor4fNormal3fVertex3fvSUN(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(tc, c, n, v);
    
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fSUN_ovr_0(s: single; t: single; p: single; q: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single; w: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fSUN(s: single; t: single; p: single; q: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single; w: single) :=
    z_TexCoord4fColor4fNormal3fVertex4fSUN_ovr_0(s, t, p, q, r, g, b, a, nx, ny, nz, x, y, z, w);
    
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_0(var tc: Vec4f; var c: Vec4f; var n: Vec3f; var v: Vec4f);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(var tc: Vec4f; var c: Vec4f; var n: Vec3f; var v: Vec4f) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_0(tc, c, n, v);
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1(var tc: single; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01000(tc: IntPtr; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00100(var tc: single; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01100(tc: IntPtr; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00010(var tc: single; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01010(tc: IntPtr; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00110(var tc: single; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01110(tc: IntPtr; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00001(var tc: single; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01001(tc: IntPtr; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00101(var tc: single; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01101(tc: IntPtr; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00011(var tc: single; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01011(tc: IntPtr; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00111(var tc: single; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01111(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1(tc[0], c[0], n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00001(tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00010(tc[0], c[0], IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00011(tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00100(tc[0], IntPtr.Zero, n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00101(tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00110(tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh00111(tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01000(IntPtr.Zero, c[0], n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01001(IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01010(IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01011(IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01100(IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01101(IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01110(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1_anh01111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(var tc: single; var c: single; var n: single; var v: single) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_1(tc, c, n, v);
    private static procedure z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_3(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glTexCoord4fColor4fNormal3fVertex4fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure TexCoord4fColor4fNormal3fVertex4fvSUN(tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_TexCoord4fColor4fNormal3fVertex4fvSUN_ovr_3(tc, c, n, v);
    
    private static procedure z_ReplacementCodeuiVertex3fSUN_ovr_0(rc: UInt32; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fSUN(rc: UInt32; x: single; y: single; z: single) :=
    z_ReplacementCodeuiVertex3fSUN_ovr_0(rc, x, y, z);
    
    private static procedure z_ReplacementCodeuiVertex3fvSUN_ovr_0(var rc: UInt32; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; var v: Vec3f) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_0(rc, v);
    private static procedure z_ReplacementCodeuiVertex3fvSUN_ovr_1(var rc: UInt32; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiVertex3fvSUN';
    private static procedure z_ReplacementCodeuiVertex3fvSUN_ovr_1_anh001(var rc: UInt32; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; v: array of single) :=
    if (v<>nil) and (v.Length<>0) then
      z_ReplacementCodeuiVertex3fvSUN_ovr_1(rc, v[0]) else
      z_ReplacementCodeuiVertex3fvSUN_ovr_1_anh001(rc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(var rc: UInt32; var v: single) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_1(rc, v);
    private static procedure z_ReplacementCodeuiVertex3fvSUN_ovr_3(rc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiVertex3fvSUN(rc: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiVertex3fvSUN_ovr_3(rc, v);
    
    private static procedure z_ReplacementCodeuiColor4ubVertex3fSUN_ovr_0(rc: UInt32; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fSUN(rc: UInt32; r: Byte; g: Byte; b: Byte; a: Byte; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor4ubVertex3fSUN_ovr_0(rc, r, g, b, a, x, y, z);
    
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_0(var rc: UInt32; var c: Vec4ub; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; var c: Vec4ub; var v: Vec3f) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_0(rc, c, v);
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1(var rc: UInt32; var c: Byte; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0010(var rc: UInt32; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0001(var rc: UInt32; var c: Byte; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0011(var rc: UInt32; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; c: array of Byte; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1(rc, c[0], v[0]) else
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0001(rc, c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(var rc: UInt32; var c: Byte; var v: single) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_1(rc, c, v);
    private static procedure z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_3(rc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4ubVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4ubVertex3fvSUN(rc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor4ubVertex3fvSUN_ovr_3(rc, c, v);
    
    private static procedure z_ReplacementCodeuiColor3fVertex3fSUN_ovr_0(rc: UInt32; r: single; g: single; b: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fSUN(rc: UInt32; r: single; g: single; b: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor3fVertex3fSUN_ovr_0(rc, r, g, b, x, y, z);
    
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_0(var rc: UInt32; var c: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; var c: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_0(rc, c, v);
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1(var rc: UInt32; var c: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0010(var rc: UInt32; c: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0001(var rc: UInt32; var c: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0011(var rc: UInt32; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; c: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1(rc, c[0], v[0]) else
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0001(rc, c[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(var rc: UInt32; var c: single; var v: single) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_1(rc, c, v);
    private static procedure z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_3(rc: IntPtr; c: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor3fVertex3fvSUN(rc: IntPtr; c: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor3fVertex3fvSUN_ovr_3(rc, c, v);
    
    private static procedure z_ReplacementCodeuiNormal3fVertex3fSUN_ovr_0(rc: UInt32; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fSUN(rc: UInt32; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiNormal3fVertex3fSUN_ovr_0(rc, nx, ny, nz, x, y, z);
    
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_0(var rc: UInt32; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_0(rc, n, v);
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1(var rc: UInt32; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0010(var rc: UInt32; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0001(var rc: UInt32; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0011(var rc: UInt32; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; n: array of single; v: array of single) :=
    if (n<>nil) and (n.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1(rc, n[0], v[0]) else
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0001(rc, n[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(var rc: UInt32; var n: single; var v: single) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_1(rc, n, v);
    private static procedure z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_3(rc: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiNormal3fVertex3fvSUN(rc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiNormal3fVertex3fvSUN_ovr_3(rc, n, v);
    
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_ovr_0(rc: UInt32; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fSUN(rc: UInt32; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fSUN_ovr_0(rc, r, g, b, a, nx, ny, nz, x, y, z);
    
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_0(var rc: UInt32; var c: Vec4f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_0(rc, c, n, v);
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1(var rc: UInt32; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(var rc: UInt32; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(var rc: UInt32; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(var rc: UInt32; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(var rc: UInt32; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(var rc: UInt32; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(var rc: UInt32; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(var rc: UInt32; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; c: array of single; n: array of single; v: array of single) :=
    if (c<>nil) and (c.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1(rc, c[0], n[0], v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00001(rc, c[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00010(rc, c[0], IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00011(rc, c[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00100(rc, IntPtr.Zero, n[0], v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00101(rc, IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00110(rc, IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1_anh00111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(var rc: UInt32; var c: single; var n: single; var v: single) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_1(rc, c, n, v);
    private static procedure z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_3(rc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiColor4fNormal3fVertex3fvSUN(rc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiColor4fNormal3fVertex3fvSUN_ovr_3(rc, c, n, v);
    
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fSUN_ovr_0(rc: UInt32; s: single; t: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fSUN(rc: UInt32; s: single; t: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fVertex3fSUN_ovr_0(rc, s, t, x, y, z);
    
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_0(var rc: UInt32; var tc: Vec2f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_0(rc, tc, v);
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1(var rc: UInt32; var tc: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0010(var rc: UInt32; tc: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0001(var rc: UInt32; var tc: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0011(var rc: UInt32; tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; tc: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1(rc, tc[0], v[0]) else
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0001(rc, tc[0], IntPtr.Zero) else
      if (v<>nil) and (v.Length<>0) then
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0010(rc, IntPtr.Zero, v[0]) else
        z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1_anh0011(rc, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(var rc: UInt32; var tc: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_1(rc, tc, v);
    private static procedure z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_3(rc: IntPtr; tc: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fVertex3fvSUN(rc: IntPtr; tc: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fVertex3fvSUN_ovr_3(rc, tc, v);
    
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_ovr_0(rc: UInt32; s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(rc: UInt32; s: single; t: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fSUN_ovr_0(rc, s, t, nx, ny, nz, x, y, z);
    
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_0(var rc: UInt32; var tc: Vec2f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_0(rc, tc, n, v);
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1(var rc: UInt32; var tc: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00100(var rc: UInt32; tc: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00010(var rc: UInt32; var tc: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00110(var rc: UInt32; tc: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00001(var rc: UInt32; var tc: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00101(var rc: UInt32; tc: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00011(var rc: UInt32; var tc: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00111(var rc: UInt32; tc: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; tc: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1(rc, tc[0], n[0], v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00001(rc, tc[0], n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00010(rc, tc[0], IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00011(rc, tc[0], IntPtr.Zero, IntPtr.Zero) else
      if (n<>nil) and (n.Length<>0) then
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00100(rc, IntPtr.Zero, n[0], v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00101(rc, IntPtr.Zero, n[0], IntPtr.Zero) else
        if (v<>nil) and (v.Length<>0) then
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00110(rc, IntPtr.Zero, IntPtr.Zero, v[0]) else
          z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1_anh00111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(var rc: UInt32; var tc: single; var n: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_1(rc, tc, n, v);
    private static procedure z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_3(rc: IntPtr; tc: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(rc: IntPtr; tc: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN_ovr_3(rc, tc, n, v);
    
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(rc: UInt32; s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(rc: UInt32; s: single; t: single; r: single; g: single; b: single; a: single; nx: single; ny: single; nz: single; x: single; y: single; z: single) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN_ovr_0(rc, s, t, r, g, b, a, nx, ny, nz, x, y, z);
    
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(var rc: UInt32; var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; var tc: Vec2f; var c: Vec4f; var n: Vec3f; var v: Vec3f) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_0(rc, tc, c, n, v);
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(var rc: UInt32; var tc: single; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001000(var rc: UInt32; tc: IntPtr; var c: single; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000100(var rc: UInt32; var tc: single; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001100(var rc: UInt32; tc: IntPtr; c: IntPtr; var n: single; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000010(var rc: UInt32; var tc: single; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001010(var rc: UInt32; tc: IntPtr; var c: single; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000110(var rc: UInt32; var tc: single; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001110(var rc: UInt32; tc: IntPtr; c: IntPtr; n: IntPtr; var v: single);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000001(var rc: UInt32; var tc: single; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001001(var rc: UInt32; tc: IntPtr; var c: single; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000101(var rc: UInt32; var tc: single; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001101(var rc: UInt32; tc: IntPtr; c: IntPtr; var n: single; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000011(var rc: UInt32; var tc: single; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001011(var rc: UInt32; tc: IntPtr; var c: single; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000111(var rc: UInt32; var tc: single; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001111(var rc: UInt32; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; tc: array of single; c: array of single; n: array of single; v: array of single) :=
    if (tc<>nil) and (tc.Length<>0) then
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(rc, tc[0], c[0], n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000001(rc, tc[0], c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000010(rc, tc[0], c[0], IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000011(rc, tc[0], c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000100(rc, tc[0], IntPtr.Zero, n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000101(rc, tc[0], IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000110(rc, tc[0], IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh000111(rc, tc[0], IntPtr.Zero, IntPtr.Zero, IntPtr.Zero) else
      if (c<>nil) and (c.Length<>0) then
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001000(rc, IntPtr.Zero, c[0], n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001001(rc, IntPtr.Zero, c[0], n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001010(rc, IntPtr.Zero, c[0], IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001011(rc, IntPtr.Zero, c[0], IntPtr.Zero, IntPtr.Zero) else
        if (n<>nil) and (n.Length<>0) then
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001100(rc, IntPtr.Zero, IntPtr.Zero, n[0], v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001101(rc, IntPtr.Zero, IntPtr.Zero, n[0], IntPtr.Zero) else
          if (v<>nil) and (v.Length<>0) then
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001110(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, v[0]) else
            z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1_anh001111(rc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(var rc: UInt32; var tc: single; var c: single; var n: single; var v: single) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_1(rc, tc, c, n, v);
    private static procedure z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(rc: IntPtr; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr);
    external 'opengl32.dll' name 'glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] procedure ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(rc: IntPtr; tc: IntPtr; c: IntPtr; n: IntPtr; v: IntPtr) :=
    z_ReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN_ovr_3(rc, tc, c, n, v);
    
  end;
  
  wglStereoControl3DL = static class
    
    private static function z_SetStereoEmitterState3DL_ovr_0(hDC: GDI_DC; uState: UInt32): UInt32;
    external 'opengl32.dll' name 'wglSetStereoEmitterState3DL';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetStereoEmitterState3DL(hDC: GDI_DC; uState: UInt32): UInt32 :=
    z_SetStereoEmitterState3DL_ovr_0(hDC, uState);
    
  end;
  
  wglGpuAssociationAMD = static class
    
    private static function z_GetGPUIDsAMD_ovr_0(maxCount: UInt32; var ids: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGetGPUIDsAMD';
    private static function z_GetGPUIDsAMD_ovr_0_anh001(maxCount: UInt32; ids: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGPUIDsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGPUIDsAMD(maxCount: UInt32; ids: array of UInt32): UInt32 :=
    if (ids<>nil) and (ids.Length<>0) then
      z_GetGPUIDsAMD_ovr_0(maxCount, ids[0]) else
      z_GetGPUIDsAMD_ovr_0_anh001(maxCount, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGPUIDsAMD(maxCount: UInt32; var ids: UInt32): UInt32 :=
    z_GetGPUIDsAMD_ovr_0(maxCount, ids);
    private static function z_GetGPUIDsAMD_ovr_2(maxCount: UInt32; ids: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGPUIDsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGPUIDsAMD(maxCount: UInt32; ids: IntPtr): UInt32 :=
    z_GetGPUIDsAMD_ovr_2(maxCount, ids);
    
    private static function z_GetGPUInfoAMD_ovr_0(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32;
    external 'opengl32.dll' name 'wglGetGPUInfoAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGPUInfoAMD(id: UInt32; &property: Int32; dataType: DummyEnum; size: UInt32; data: IntPtr): Int32 :=
    z_GetGPUInfoAMD_ovr_0(id, &property, dataType, size, data);
    
    private static function z_GetContextGPUIDAMD_ovr_0(hglrc: GLContext): UInt32;
    external 'opengl32.dll' name 'wglGetContextGPUIDAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetContextGPUIDAMD(hglrc: GLContext): UInt32 :=
    z_GetContextGPUIDAMD_ovr_0(hglrc);
    
    private static function z_CreateAssociatedContextAMD_ovr_0(id: UInt32): GLContext;
    external 'opengl32.dll' name 'wglCreateAssociatedContextAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAssociatedContextAMD(id: UInt32): GLContext :=
    z_CreateAssociatedContextAMD_ovr_0(id);
    
    private static function z_CreateAssociatedContextAttribsAMD_ovr_0(id: UInt32; hShareContext: GLContext; var attribList: Int32): GLContext;
    external 'opengl32.dll' name 'wglCreateAssociatedContextAttribsAMD';
    private static function z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001(id: UInt32; hShareContext: GLContext; attribList: IntPtr): GLContext;
    external 'opengl32.dll' name 'wglCreateAssociatedContextAttribsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: GLContext; attribList: array of Int32): GLContext :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_CreateAssociatedContextAttribsAMD_ovr_0(id, hShareContext, attribList[0]) else
      z_CreateAssociatedContextAttribsAMD_ovr_0_anh0001(id, hShareContext, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: GLContext; var attribList: Int32): GLContext :=
    z_CreateAssociatedContextAttribsAMD_ovr_0(id, hShareContext, attribList);
    private static function z_CreateAssociatedContextAttribsAMD_ovr_2(id: UInt32; hShareContext: GLContext; attribList: IntPtr): GLContext;
    external 'opengl32.dll' name 'wglCreateAssociatedContextAttribsAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAssociatedContextAttribsAMD(id: UInt32; hShareContext: GLContext; attribList: IntPtr): GLContext :=
    z_CreateAssociatedContextAttribsAMD_ovr_2(id, hShareContext, attribList);
    
    private static function z_DeleteAssociatedContextAMD_ovr_0(hglrc: GLContext): UInt32;
    external 'opengl32.dll' name 'wglDeleteAssociatedContextAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DeleteAssociatedContextAMD(hglrc: GLContext): UInt32 :=
    z_DeleteAssociatedContextAMD_ovr_0(hglrc);
    
    private static function z_MakeAssociatedContextCurrentAMD_ovr_0(hglrc: GLContext): UInt32;
    external 'opengl32.dll' name 'wglMakeAssociatedContextCurrentAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeAssociatedContextCurrentAMD(hglrc: GLContext): UInt32 :=
    z_MakeAssociatedContextCurrentAMD_ovr_0(hglrc);
    
    private static function z_GetCurrentAssociatedContextAMD_ovr_0: GLContext;
    external 'opengl32.dll' name 'wglGetCurrentAssociatedContextAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentAssociatedContextAMD: GLContext :=
    z_GetCurrentAssociatedContextAMD_ovr_0;
    
    private static procedure z_BlitContextFramebufferAMD_ovr_0(dstCtx: GLContext; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum);
    external 'opengl32.dll' name 'wglBlitContextFramebufferAMD';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure BlitContextFramebufferAMD(dstCtx: GLContext; srcX0: Int32; srcY0: Int32; srcX1: Int32; srcY1: Int32; dstX0: Int32; dstY0: Int32; dstX1: Int32; dstY1: Int32; mask: DummyFlags; filter: DummyEnum) :=
    z_BlitContextFramebufferAMD_ovr_0(dstCtx, srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
    
  end;
  
  wglBufferRegionARB = static class
    
    private static function z_CreateBufferRegionARB_ovr_0(hDC: GDI_DC; iLayerPlane: Int32; uType: UInt32): IntPtr;
    external 'opengl32.dll' name 'wglCreateBufferRegionARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateBufferRegionARB(hDC: GDI_DC; iLayerPlane: Int32; uType: UInt32): IntPtr :=
    z_CreateBufferRegionARB_ovr_0(hDC, iLayerPlane, uType);
    
    private static procedure z_DeleteBufferRegionARB_ovr_0(hRegion: IntPtr);
    external 'opengl32.dll' name 'wglDeleteBufferRegionARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DeleteBufferRegionARB(hRegion: IntPtr) :=
    z_DeleteBufferRegionARB_ovr_0(hRegion);
    
    private static function z_SaveBufferRegionARB_ovr_0(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32): UInt32;
    external 'opengl32.dll' name 'wglSaveBufferRegionARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SaveBufferRegionARB(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32): UInt32 :=
    z_SaveBufferRegionARB_ovr_0(hRegion, x, y, width, height);
    
    private static function z_RestoreBufferRegionARB_ovr_0(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32; xSrc: Int32; ySrc: Int32): UInt32;
    external 'opengl32.dll' name 'wglRestoreBufferRegionARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function RestoreBufferRegionARB(hRegion: IntPtr; x: Int32; y: Int32; width: Int32; height: Int32; xSrc: Int32; ySrc: Int32): UInt32 :=
    z_RestoreBufferRegionARB_ovr_0(hRegion, x, y, width, height, xSrc, ySrc);
    
  end;
  
  wglCreateContextARB = static class
    
    private static function z_CreateContextAttribsARB_ovr_0(hDC: GDI_DC; hShareContext: GLContext; var attribList: Int32): GLContext;
    external 'opengl32.dll' name 'wglCreateContextAttribsARB';
    private static function z_CreateContextAttribsARB_ovr_0_anh0001(hDC: GDI_DC; hShareContext: GLContext; attribList: IntPtr): GLContext;
    external 'opengl32.dll' name 'wglCreateContextAttribsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContextAttribsARB(hDC: GDI_DC; hShareContext: GLContext; attribList: array of Int32): GLContext :=
    if (attribList<>nil) and (attribList.Length<>0) then
      z_CreateContextAttribsARB_ovr_0(hDC, hShareContext, attribList[0]) else
      z_CreateContextAttribsARB_ovr_0_anh0001(hDC, hShareContext, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContextAttribsARB(hDC: GDI_DC; hShareContext: GLContext; var attribList: Int32): GLContext :=
    z_CreateContextAttribsARB_ovr_0(hDC, hShareContext, attribList);
    private static function z_CreateContextAttribsARB_ovr_2(hDC: GDI_DC; hShareContext: GLContext; attribList: IntPtr): GLContext;
    external 'opengl32.dll' name 'wglCreateContextAttribsARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateContextAttribsARB(hDC: GDI_DC; hShareContext: GLContext; attribList: IntPtr): GLContext :=
    z_CreateContextAttribsARB_ovr_2(hDC, hShareContext, attribList);
    
  end;
  
  wglExtensionsStringARB = static class
    
    private static function z_GetExtensionsStringARB_ovr_0(hdc: GDI_DC): IntPtr;
    external 'opengl32.dll' name 'wglGetExtensionsStringARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetExtensionsStringARB(hdc: GDI_DC): string;
    begin
      var res_str_ptr := z_GetExtensionsStringARB_ovr_0(hdc);
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
  end;
  
  wglMakeCurrentReadARB = static class
    
    private static function z_MakeContextCurrentARB_ovr_0(hDrawDC: GDI_DC; hReadDC: GDI_DC; hglrc: GLContext): UInt32;
    external 'opengl32.dll' name 'wglMakeContextCurrentARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeContextCurrentARB(hDrawDC: GDI_DC; hReadDC: GDI_DC; hglrc: GLContext): UInt32 :=
    z_MakeContextCurrentARB_ovr_0(hDrawDC, hReadDC, hglrc);
    
    private static function z_GetCurrentReadDCARB_ovr_0: GDI_DC;
    external 'opengl32.dll' name 'wglGetCurrentReadDCARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentReadDCARB: GDI_DC :=
    z_GetCurrentReadDCARB_ovr_0;
    
  end;
  
  wglPbufferARB = static class
    
    private static function z_CreatePbufferARB_ovr_0(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferARB';
    private static function z_CreatePbufferARB_ovr_0_anh000001(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferARB(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: array of Int32): HPBUFFER :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_CreatePbufferARB_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList[0]) else
      z_CreatePbufferARB_ovr_0_anh000001(hDC, iPixelFormat, iWidth, iHeight, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferARB(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): HPBUFFER :=
    z_CreatePbufferARB_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    private static function z_CreatePbufferARB_ovr_2(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferARB(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER :=
    z_CreatePbufferARB_ovr_2(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    
    private static function z_GetPbufferDCARB_ovr_0(_hPbuffer: HPBUFFER): GDI_DC;
    external 'opengl32.dll' name 'wglGetPbufferDCARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPbufferDCARB(_hPbuffer: HPBUFFER): GDI_DC :=
    z_GetPbufferDCARB_ovr_0(_hPbuffer);
    
    private static function z_ReleasePbufferDCARB_ovr_0(_hPbuffer: HPBUFFER; hDC: GDI_DC): Int32;
    external 'opengl32.dll' name 'wglReleasePbufferDCARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleasePbufferDCARB(_hPbuffer: HPBUFFER; hDC: GDI_DC): Int32 :=
    z_ReleasePbufferDCARB_ovr_0(_hPbuffer, hDC);
    
    private static function z_DestroyPbufferARB_ovr_0(_hPbuffer: HPBUFFER): UInt32;
    external 'opengl32.dll' name 'wglDestroyPbufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DestroyPbufferARB(_hPbuffer: HPBUFFER): UInt32 :=
    z_DestroyPbufferARB_ovr_0(_hPbuffer);
    
    private static function z_QueryPbufferARB_ovr_0(_hPbuffer: HPBUFFER; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferARB';
    private static function z_QueryPbufferARB_ovr_0_anh0001(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferARB(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryPbufferARB_ovr_0(_hPbuffer, iAttribute, piValue[0]) else
      z_QueryPbufferARB_ovr_0_anh0001(_hPbuffer, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferARB(_hPbuffer: HPBUFFER; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_QueryPbufferARB_ovr_0(_hPbuffer, iAttribute, piValue);
    private static function z_QueryPbufferARB_ovr_2(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferARB(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_QueryPbufferARB_ovr_2(_hPbuffer, iAttribute, piValue);
    
  end;
  
  wglPixelFormatARB = static class
    
    private static function z_GetPixelFormatAttribivARB_ovr_0(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    private static function z_GetPixelFormatAttribivARB_ovr_0_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    private static function z_GetPixelFormatAttribivARB_ovr_0_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    private static function z_GetPixelFormatAttribivARB_ovr_0_anh0000011(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: array of Int32): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues[0]) else
        z_GetPixelFormatAttribivARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues[0]) else
        z_GetPixelFormatAttribivARB_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetPixelFormatAttribivARB_ovr_1_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var piValues: Int32): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    private static function z_GetPixelFormatAttribivARB_ovr_2(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    private static function z_GetPixelFormatAttribivARB_ovr_2_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: IntPtr): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivARB_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: array of Int32): UInt32 :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): UInt32 :=
    z_GetPixelFormatAttribivARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribivARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private static function z_GetPixelFormatAttribivARB_ovr_6(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    private static function z_GetPixelFormatAttribivARB_ovr_6_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: array of Int32): UInt32 :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivARB_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32 :=
    z_GetPixelFormatAttribivARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private static function z_GetPixelFormatAttribivARB_ovr_8(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribivARB_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    
    private static function z_GetPixelFormatAttribfvARB_ovr_0(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    private static function z_GetPixelFormatAttribfvARB_ovr_0_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    private static function z_GetPixelFormatAttribfvARB_ovr_0_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    private static function z_GetPixelFormatAttribfvARB_ovr_0_anh0000011(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: array of single): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues[0]) else
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues[0]) else
        z_GetPixelFormatAttribfvARB_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetPixelFormatAttribfvARB_ovr_1_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var pfValues: single): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvARB_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    private static function z_GetPixelFormatAttribfvARB_ovr_2(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    private static function z_GetPixelFormatAttribfvARB_ovr_2_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: IntPtr): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvARB_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: array of single): UInt32 :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvARB_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): UInt32 :=
    z_GetPixelFormatAttribfvARB_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribfvARB_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private static function z_GetPixelFormatAttribfvARB_ovr_6(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    private static function z_GetPixelFormatAttribfvARB_ovr_6_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: array of single): UInt32 :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvARB_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32 :=
    z_GetPixelFormatAttribfvARB_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private static function z_GetPixelFormatAttribfvARB_ovr_8(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvARB(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribfvARB_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    
    private static function z_ChoosePixelFormatARB_ovr_0(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0001011(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_0_anh0011011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0001011(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatARB_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatARB_ovr_0_anh0011011(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_1_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_1_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_2(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_2_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatARB_ovr_2_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_3_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_3_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_3_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_3_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_3_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_3_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_4_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_4_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_4_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_5_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_5_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_5_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_6(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_6_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_6_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_7_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_7_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_7_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_8(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_8_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_8_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_8_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_8_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatARB_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatARB_ovr_8_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_9_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_9_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_9_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_9_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_10_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_10_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_11_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_11_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_12_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_12_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_13_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_14_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_15_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_15_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_16_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_17_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_18(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0000011(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_18_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_18_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_19_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_19_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_19_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_20(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_20_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_20_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_20_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_20_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_20_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_21_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_21_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_22_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_23_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_24(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_24_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_24_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_24_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_24_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_24_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_25_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_26(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_26_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_26(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_26_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_0_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_2_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_6_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_8_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_8(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_18_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_20_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_24_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_26(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_54(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0000011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_54_anh0001011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatARB_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatARB_ovr_54_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_55_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_55_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_55_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_56(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_56_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_56_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_56_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatARB_ovr_56_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_57_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_57_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_58_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_59_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_60(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_60_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_60_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_60_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_60_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_61_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_62(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_62_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatARB_ovr_62(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatARB_ovr_62_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_62(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_72(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_72_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_72_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_72_anh0000011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatARB_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatARB_ovr_72_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatARB_ovr_73_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_74(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_74_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatARB_ovr_74_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_78(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    private static function z_ChoosePixelFormatARB_ovr_78_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatARB_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatARB_ovr_78_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatARB_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatARB_ovr_80(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatARB(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatARB_ovr_80(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    
  end;
  
  wglRenderTextureARB = static class
    
    private static function z_BindTexImageARB_ovr_0(_hPbuffer: HPBUFFER; iBuffer: Int32): UInt32;
    external 'opengl32.dll' name 'wglBindTexImageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindTexImageARB(_hPbuffer: HPBUFFER; iBuffer: Int32): UInt32 :=
    z_BindTexImageARB_ovr_0(_hPbuffer, iBuffer);
    
    private static function z_ReleaseTexImageARB_ovr_0(_hPbuffer: HPBUFFER; iBuffer: Int32): UInt32;
    external 'opengl32.dll' name 'wglReleaseTexImageARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseTexImageARB(_hPbuffer: HPBUFFER; iBuffer: Int32): UInt32 :=
    z_ReleaseTexImageARB_ovr_0(_hPbuffer, iBuffer);
    
    private static function z_SetPbufferAttribARB_ovr_0(_hPbuffer: HPBUFFER; var piAttribList: Int32): UInt32;
    external 'opengl32.dll' name 'wglSetPbufferAttribARB';
    private static function z_SetPbufferAttribARB_ovr_0_anh001(_hPbuffer: HPBUFFER; piAttribList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetPbufferAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPbufferAttribARB(_hPbuffer: HPBUFFER; piAttribList: array of Int32): UInt32 :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_SetPbufferAttribARB_ovr_0(_hPbuffer, piAttribList[0]) else
      z_SetPbufferAttribARB_ovr_0_anh001(_hPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPbufferAttribARB(_hPbuffer: HPBUFFER; var piAttribList: Int32): UInt32 :=
    z_SetPbufferAttribARB_ovr_0(_hPbuffer, piAttribList);
    private static function z_SetPbufferAttribARB_ovr_2(_hPbuffer: HPBUFFER; piAttribList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetPbufferAttribARB';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetPbufferAttribARB(_hPbuffer: HPBUFFER; piAttribList: IntPtr): UInt32 :=
    z_SetPbufferAttribARB_ovr_2(_hPbuffer, piAttribList);
    
  end;
  
  wglDisplayColorTableEXT = static class
    
    private static function z_CreateDisplayColorTableEXT_ovr_0(id: UInt16): boolean;
    external 'opengl32.dll' name 'wglCreateDisplayColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateDisplayColorTableEXT(id: UInt16): boolean :=
    z_CreateDisplayColorTableEXT_ovr_0(id);
    
    private static function z_LoadDisplayColorTableEXT_ovr_0(var table: UInt16; length: UInt32): boolean;
    external 'opengl32.dll' name 'wglLoadDisplayColorTableEXT';
    private static function z_LoadDisplayColorTableEXT_ovr_0_anh010(table: IntPtr; length: UInt32): boolean;
    external 'opengl32.dll' name 'wglLoadDisplayColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function LoadDisplayColorTableEXT(table: array of UInt16; length: UInt32): boolean :=
    if (table<>nil) and (table.Length<>0) then
      z_LoadDisplayColorTableEXT_ovr_0(table[0], length) else
      z_LoadDisplayColorTableEXT_ovr_0_anh010(IntPtr.Zero, length);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function LoadDisplayColorTableEXT(var table: UInt16; length: UInt32): boolean :=
    z_LoadDisplayColorTableEXT_ovr_0(table, length);
    private static function z_LoadDisplayColorTableEXT_ovr_2(table: IntPtr; length: UInt32): boolean;
    external 'opengl32.dll' name 'wglLoadDisplayColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function LoadDisplayColorTableEXT(table: IntPtr; length: UInt32): boolean :=
    z_LoadDisplayColorTableEXT_ovr_2(table, length);
    
    private static function z_BindDisplayColorTableEXT_ovr_0(id: UInt16): boolean;
    external 'opengl32.dll' name 'wglBindDisplayColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindDisplayColorTableEXT(id: UInt16): boolean :=
    z_BindDisplayColorTableEXT_ovr_0(id);
    
    private static procedure z_DestroyDisplayColorTableEXT_ovr_0(id: UInt16);
    external 'opengl32.dll' name 'wglDestroyDisplayColorTableEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure DestroyDisplayColorTableEXT(id: UInt16) :=
    z_DestroyDisplayColorTableEXT_ovr_0(id);
    
  end;
  
  wglExtensionsStringEXT = static class
    
    private static function z_GetExtensionsStringEXT_ovr_0: IntPtr;
    external 'opengl32.dll' name 'wglGetExtensionsStringEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetExtensionsStringEXT: string;
    begin
      var res_str_ptr := z_GetExtensionsStringEXT_ovr_0;
      Result := Marshal.PtrToStringAnsi(res_str_ptr);
    end;
    
  end;
  
  wglMakeCurrentReadEXT = static class
    
    private static function z_MakeContextCurrentEXT_ovr_0(hDrawDC: GDI_DC; hReadDC: GDI_DC; hglrc: GLContext): UInt32;
    external 'opengl32.dll' name 'wglMakeContextCurrentEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function MakeContextCurrentEXT(hDrawDC: GDI_DC; hReadDC: GDI_DC; hglrc: GLContext): UInt32 :=
    z_MakeContextCurrentEXT_ovr_0(hDrawDC, hReadDC, hglrc);
    
    private static function z_GetCurrentReadDCEXT_ovr_0: GDI_DC;
    external 'opengl32.dll' name 'wglGetCurrentReadDCEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetCurrentReadDCEXT: GDI_DC :=
    z_GetCurrentReadDCEXT_ovr_0;
    
  end;
  
  wglPbufferEXT = static class
    
    private static function z_CreatePbufferEXT_ovr_0(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferEXT';
    private static function z_CreatePbufferEXT_ovr_0_anh000001(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferEXT(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: array of Int32): HPBUFFER :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_CreatePbufferEXT_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList[0]) else
      z_CreatePbufferEXT_ovr_0_anh000001(hDC, iPixelFormat, iWidth, iHeight, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferEXT(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; var piAttribList: Int32): HPBUFFER :=
    z_CreatePbufferEXT_ovr_0(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    private static function z_CreatePbufferEXT_ovr_2(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER;
    external 'opengl32.dll' name 'wglCreatePbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreatePbufferEXT(hDC: GDI_DC; iPixelFormat: Int32; iWidth: Int32; iHeight: Int32; piAttribList: IntPtr): HPBUFFER :=
    z_CreatePbufferEXT_ovr_2(hDC, iPixelFormat, iWidth, iHeight, piAttribList);
    
    private static function z_GetPbufferDCEXT_ovr_0(_hPbuffer: HPBUFFER): GDI_DC;
    external 'opengl32.dll' name 'wglGetPbufferDCEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPbufferDCEXT(_hPbuffer: HPBUFFER): GDI_DC :=
    z_GetPbufferDCEXT_ovr_0(_hPbuffer);
    
    private static function z_ReleasePbufferDCEXT_ovr_0(_hPbuffer: HPBUFFER; hDC: GDI_DC): Int32;
    external 'opengl32.dll' name 'wglReleasePbufferDCEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleasePbufferDCEXT(_hPbuffer: HPBUFFER; hDC: GDI_DC): Int32 :=
    z_ReleasePbufferDCEXT_ovr_0(_hPbuffer, hDC);
    
    private static function z_DestroyPbufferEXT_ovr_0(_hPbuffer: HPBUFFER): UInt32;
    external 'opengl32.dll' name 'wglDestroyPbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DestroyPbufferEXT(_hPbuffer: HPBUFFER): UInt32 :=
    z_DestroyPbufferEXT_ovr_0(_hPbuffer);
    
    private static function z_QueryPbufferEXT_ovr_0(_hPbuffer: HPBUFFER; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferEXT';
    private static function z_QueryPbufferEXT_ovr_0_anh0001(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferEXT(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryPbufferEXT_ovr_0(_hPbuffer, iAttribute, piValue[0]) else
      z_QueryPbufferEXT_ovr_0_anh0001(_hPbuffer, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferEXT(_hPbuffer: HPBUFFER; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_QueryPbufferEXT_ovr_0(_hPbuffer, iAttribute, piValue);
    private static function z_QueryPbufferEXT_ovr_2(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryPbufferEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryPbufferEXT(_hPbuffer: HPBUFFER; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_QueryPbufferEXT_ovr_2(_hPbuffer, iAttribute, piValue);
    
  end;
  
  wglPixelFormatEXT = static class
    
    private static function z_GetPixelFormatAttribivEXT_ovr_0(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    private static function z_GetPixelFormatAttribivEXT_ovr_0_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    private static function z_GetPixelFormatAttribivEXT_ovr_0_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    private static function z_GetPixelFormatAttribivEXT_ovr_0_anh0000011(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: array of Int32): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues[0]) else
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (piValues<>nil) and (piValues.Length<>0) then
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues[0]) else
        z_GetPixelFormatAttribivEXT_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetPixelFormatAttribivEXT_ovr_1_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var piValues: Int32): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    private static function z_GetPixelFormatAttribivEXT_ovr_2(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    private static function z_GetPixelFormatAttribivEXT_ovr_2_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; piValues: IntPtr): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], piValues) else
      z_GetPixelFormatAttribivEXT_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: array of Int32): UInt32 :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var piValues: Int32): UInt32 :=
    z_GetPixelFormatAttribivEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; piValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribivEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private static function z_GetPixelFormatAttribivEXT_ovr_6(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    private static function z_GetPixelFormatAttribivEXT_ovr_6_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: array of Int32): UInt32 :=
    if (piValues<>nil) and (piValues.Length<>0) then
      z_GetPixelFormatAttribivEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues[0]) else
      z_GetPixelFormatAttribivEXT_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var piValues: Int32): UInt32 :=
    z_GetPixelFormatAttribivEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    private static function z_GetPixelFormatAttribivEXT_ovr_8(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribivEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribivEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; piValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribivEXT_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, piValues);
    
    private static function z_GetPixelFormatAttribfvEXT_ovr_0(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    private static function z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    private static function z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    private static function z_GetPixelFormatAttribfvEXT_ovr_0_anh0000011(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: array of single): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues[0]) else
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], IntPtr.Zero) else
      if (pfValues<>nil) and (pfValues.Length<>0) then
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues[0]) else
        z_GetPixelFormatAttribfvEXT_ovr_0_anh0000011(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetPixelFormatAttribfvEXT_ovr_1_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; var pfValues: single): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvEXT_ovr_0_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    private static function z_GetPixelFormatAttribfvEXT_ovr_2(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    private static function z_GetPixelFormatAttribfvEXT_ovr_2_anh0000010(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: array of Int32; pfValues: IntPtr): UInt32 :=
    if (piAttributes<>nil) and (piAttributes.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes[0], pfValues) else
      z_GetPixelFormatAttribfvEXT_ovr_2_anh0000010(hdc, iPixelFormat, iLayerPlane, nAttributes, IntPtr.Zero, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: array of single): UInt32 :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvEXT_ovr_0_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; var pfValues: single): UInt32 :=
    z_GetPixelFormatAttribfvEXT_ovr_0(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; var piAttributes: Int32; pfValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribfvEXT_ovr_2(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private static function z_GetPixelFormatAttribfvEXT_ovr_6(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    private static function z_GetPixelFormatAttribfvEXT_ovr_6_anh0000001(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: array of single): UInt32 :=
    if (pfValues<>nil) and (pfValues.Length<>0) then
      z_GetPixelFormatAttribfvEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues[0]) else
      z_GetPixelFormatAttribfvEXT_ovr_6_anh0000001(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; var pfValues: single): UInt32 :=
    z_GetPixelFormatAttribfvEXT_ovr_6(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    private static function z_GetPixelFormatAttribfvEXT_ovr_8(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetPixelFormatAttribfvEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetPixelFormatAttribfvEXT(hdc: GDI_DC; iPixelFormat: Int32; iLayerPlane: Int32; nAttributes: UInt32; piAttributes: IntPtr; pfValues: IntPtr): UInt32 :=
    z_GetPixelFormatAttribfvEXT_ovr_8(hdc, iPixelFormat, iLayerPlane, nAttributes, piAttributes, pfValues);
    
    private static function z_ChoosePixelFormatEXT_ovr_0(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0001011(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_0_anh0011011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0001011(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
          if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
            z_ChoosePixelFormatEXT_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
            z_ChoosePixelFormatEXT_ovr_0_anh0011011(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_1_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_0_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_2(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0001010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_2_anh0011010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0001010(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
        if (piFormats<>nil) and (piFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
          z_ChoosePixelFormatEXT_ovr_2_anh0011010(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_3_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_4_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_4_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_4_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_5_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_5_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_5_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_6(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0001001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_6_anh0011001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0001001(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_6_anh0011001(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_7_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_7_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_7_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_6_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_8(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_8_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_8_anh0001000(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_8_anh0011000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList[0], pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_8_anh0001000(hdc, piAttribIList[0], IntPtr.Zero, nMaxFormats, piFormats, nNumFormats) else
      if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_8_anh0011000(hdc, IntPtr.Zero, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_9_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_9_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_9_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_9_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_10_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_10_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_11_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_11_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_12_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_12_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_13_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_14_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_15_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_15_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_16_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_6_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_17_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_8_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_18(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0000011(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_18_anh0010011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0000011(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_18_anh0010011(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_19_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_19_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_19_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_18_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_20(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_20_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_20_anh0000010(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_20_anh0010010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_20_anh0000010(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_20_anh0010010(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_21_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_21_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_22_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_18_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_23_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_20_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_24(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_24_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_24_anh0000001(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_24_anh0010001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_24_anh0000001(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_24_anh0010001(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_25_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_24_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_26(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_26_anh0010000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: array of Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (piAttribIList<>nil) and (piAttribIList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_26(hdc, piAttribIList[0], pfAttribFList, nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_26_anh0010000(hdc, IntPtr.Zero, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_0_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_2_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_6_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_6_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_8_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_0_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_0_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_2_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_0_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_0(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_2(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_6_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_6(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_8(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_18_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_18_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_20_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_18_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_18(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_20(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_24_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_24(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; var piAttribIList: Int32; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_26(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_54(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0000011(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_54_anh0001011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, IntPtr.Zero) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], IntPtr.Zero) else
        if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
          z_ChoosePixelFormatEXT_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
          z_ChoosePixelFormatEXT_ovr_54_anh0001011(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_55_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_55_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_55_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_54_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_56(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_56_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_56_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_56_anh0001010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, IntPtr.Zero, nNumFormats) else
      if (piFormats<>nil) and (piFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats[0], nNumFormats) else
        z_ChoosePixelFormatEXT_ovr_56_anh0001010(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_57_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_57_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_58_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_54_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_59_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_56_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_60(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_60_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_60_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_60_anh0001001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_60_anh0001001(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_61_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_60_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_62(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_62_anh0001000(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: array of single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    if (pfAttribFList<>nil) and (pfAttribFList.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_62(hdc, piAttribIList, pfAttribFList[0], nMaxFormats, piFormats, nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_62_anh0001000(hdc, piAttribIList, IntPtr.Zero, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_54_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_54_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_56_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_54_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_54(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_56(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_60_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_60(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; var pfAttribFList: single; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_62(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_72(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_72_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_72_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_72_anh0000011(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: array of UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], IntPtr.Zero) else
      if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
        z_ChoosePixelFormatEXT_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats[0]) else
        z_ChoosePixelFormatEXT_ovr_72_anh0000011(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, IntPtr.Zero);
    private static function z_ChoosePixelFormatEXT_ovr_73_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; var nNumFormats: UInt32): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_72_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_74(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_74_anh0000010(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: array of Int32; nNumFormats: IntPtr): UInt32 :=
    if (piFormats<>nil) and (piFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats[0], nNumFormats) else
      z_ChoosePixelFormatEXT_ovr_74_anh0000010(hdc, piAttribIList, pfAttribFList, nMaxFormats, IntPtr.Zero, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_72_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_72(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; var piFormats: Int32; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_74(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_78(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    private static function z_ChoosePixelFormatEXT_ovr_78_anh0000001(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: array of UInt32): UInt32 :=
    if (nNumFormats<>nil) and (nNumFormats.Length<>0) then
      z_ChoosePixelFormatEXT_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats[0]) else
      z_ChoosePixelFormatEXT_ovr_78_anh0000001(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; var nNumFormats: UInt32): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_78(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    private static function z_ChoosePixelFormatEXT_ovr_80(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglChoosePixelFormatEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ChoosePixelFormatEXT(hdc: GDI_DC; piAttribIList: IntPtr; pfAttribFList: IntPtr; nMaxFormats: UInt32; piFormats: IntPtr; nNumFormats: IntPtr): UInt32 :=
    z_ChoosePixelFormatEXT_ovr_80(hdc, piAttribIList, pfAttribFList, nMaxFormats, piFormats, nNumFormats);
    
  end;
  
  wglSwapControlEXT = static class
    
    private static function z_SwapIntervalEXT_ovr_0(interval: Int32): UInt32;
    external 'opengl32.dll' name 'wglSwapIntervalEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapIntervalEXT(interval: Int32): UInt32 :=
    z_SwapIntervalEXT_ovr_0(interval);
    
    private static function z_GetSwapIntervalEXT_ovr_0: Int32;
    external 'opengl32.dll' name 'wglGetSwapIntervalEXT';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSwapIntervalEXT: Int32 :=
    z_GetSwapIntervalEXT_ovr_0;
    
  end;
  
  wglDigitalVideoControlI3D = static class
    
    private static function z_GetDigitalVideoParametersI3D_ovr_0(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetDigitalVideoParametersI3D';
    private static function z_GetDigitalVideoParametersI3D_ovr_0_anh0001(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetDigitalVideoParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_GetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_GetDigitalVideoParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_GetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private static function z_GetDigitalVideoParametersI3D_ovr_2(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetDigitalVideoParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_GetDigitalVideoParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private static function z_SetDigitalVideoParametersI3D_ovr_0(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglSetDigitalVideoParametersI3D';
    private static function z_SetDigitalVideoParametersI3D_ovr_0_anh0001(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetDigitalVideoParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_SetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_SetDigitalVideoParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_SetDigitalVideoParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private static function z_SetDigitalVideoParametersI3D_ovr_2(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetDigitalVideoParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetDigitalVideoParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_SetDigitalVideoParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
  end;
  
  wglGammaI3D = static class
    
    private static function z_GetGammaTableParametersI3D_ovr_0(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableParametersI3D';
    private static function z_GetGammaTableParametersI3D_ovr_0_anh0001(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_GetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_GetGammaTableParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_GetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private static function z_GetGammaTableParametersI3D_ovr_2(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_GetGammaTableParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private static function z_SetGammaTableParametersI3D_ovr_0(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableParametersI3D';
    private static function z_SetGammaTableParametersI3D_ovr_0_anh0001(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_SetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue[0]) else
      z_SetGammaTableParametersI3D_ovr_0_anh0001(hDC, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_SetGammaTableParametersI3D_ovr_0(hDC, iAttribute, piValue);
    private static function z_SetGammaTableParametersI3D_ovr_2(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableParametersI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableParametersI3D(hDC: GDI_DC; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_SetGammaTableParametersI3D_ovr_2(hDC, iAttribute, piValue);
    
    private static function z_GetGammaTableI3D_ovr_0(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000001(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000011(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_0_anh000111(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed[0], IntPtr.Zero, IntPtr.Zero) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_GetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue[0]) else
          z_GetGammaTableI3D_ovr_0_anh000111(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetGammaTableI3D_ovr_1_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_1_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_1_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private static function z_GetGammaTableI3D_ovr_2(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_2_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_2_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_2_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_GetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_GetGammaTableI3D_ovr_2_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private static function z_GetGammaTableI3D_ovr_3_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_3_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private static function z_GetGammaTableI3D_ovr_4_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_5_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_6(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_6_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_6_anh000001(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_6_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_GetGammaTableI3D_ovr_6_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private static function z_GetGammaTableI3D_ovr_7_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_8(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_8_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_GetGammaTableI3D_ovr_8(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_GetGammaTableI3D_ovr_8_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_GetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    z_GetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    z_GetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    z_GetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    z_GetGammaTableI3D_ovr_8(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_18(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_18_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_18_anh000001(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_18_anh000011(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_GetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_GetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_GetGammaTableI3D_ovr_18_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetGammaTableI3D_ovr_19_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    private static function z_GetGammaTableI3D_ovr_20(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_20_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_GetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_GetGammaTableI3D_ovr_20_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    z_GetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    z_GetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_24(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    private static function z_GetGammaTableI3D_ovr_24_anh000001(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_GetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_GetGammaTableI3D_ovr_24_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    z_GetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_GetGammaTableI3D_ovr_26(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    z_GetGammaTableI3D_ovr_26(hDC, iEntries, puRed, puGreen, puBlue);
    
    private static function z_SetGammaTableI3D_ovr_0(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000001(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000011(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_0_anh000111(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed[0], IntPtr.Zero, IntPtr.Zero) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen[0], IntPtr.Zero) else
        if (puBlue<>nil) and (puBlue.Length<>0) then
          z_SetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue[0]) else
          z_SetGammaTableI3D_ovr_0_anh000111(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_SetGammaTableI3D_ovr_1_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_1_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_1_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_0_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private static function z_SetGammaTableI3D_ovr_2(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_2_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_2_anh000010(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_2_anh000110(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed[0], IntPtr.Zero, puBlue) else
      if (puGreen<>nil) and (puGreen.Length<>0) then
        z_SetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen[0], puBlue) else
        z_SetGammaTableI3D_ovr_2_anh000110(hDC, iEntries, IntPtr.Zero, IntPtr.Zero, puBlue);
    private static function z_SetGammaTableI3D_ovr_3_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_3_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private static function z_SetGammaTableI3D_ovr_4_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_0_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_5_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_2_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_6(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_6_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_6_anh000001(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_6_anh000101(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed[0], puGreen, IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue[0]) else
        z_SetGammaTableI3D_ovr_6_anh000101(hDC, iEntries, IntPtr.Zero, puGreen, IntPtr.Zero);
    private static function z_SetGammaTableI3D_ovr_7_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_6_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_8(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_8_anh000100(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: array of UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    if (puRed<>nil) and (puRed.Length<>0) then
      z_SetGammaTableI3D_ovr_8(hDC, iEntries, puRed[0], puGreen, puBlue) else
      z_SetGammaTableI3D_ovr_8_anh000100(hDC, iEntries, IntPtr.Zero, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_SetGammaTableI3D_ovr_0_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_0_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_2_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_0_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    z_SetGammaTableI3D_ovr_0(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    z_SetGammaTableI3D_ovr_2(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_6_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    z_SetGammaTableI3D_ovr_6(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; var puRed: UInt16; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    z_SetGammaTableI3D_ovr_8(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_18(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_18_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_18_anh000001(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_18_anh000011(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: array of UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue[0]) else
        z_SetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen[0], IntPtr.Zero) else
      if (puBlue<>nil) and (puBlue.Length<>0) then
        z_SetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue[0]) else
        z_SetGammaTableI3D_ovr_18_anh000011(hDC, iEntries, puRed, IntPtr.Zero, IntPtr.Zero);
    private static function z_SetGammaTableI3D_ovr_19_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; var puBlue: UInt16): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_18_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    private static function z_SetGammaTableI3D_ovr_20(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_20_anh000010(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: array of UInt16; puBlue: IntPtr): UInt32 :=
    if (puGreen<>nil) and (puGreen.Length<>0) then
      z_SetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen[0], puBlue) else
      z_SetGammaTableI3D_ovr_20_anh000010(hDC, iEntries, puRed, IntPtr.Zero, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_18_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; var puBlue: UInt16): UInt32 :=
    z_SetGammaTableI3D_ovr_18(hDC, iEntries, puRed, puGreen, puBlue);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; var puGreen: UInt16; puBlue: IntPtr): UInt32 :=
    z_SetGammaTableI3D_ovr_20(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_24(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    private static function z_SetGammaTableI3D_ovr_24_anh000001(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: array of UInt16): UInt32 :=
    if (puBlue<>nil) and (puBlue.Length<>0) then
      z_SetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue[0]) else
      z_SetGammaTableI3D_ovr_24_anh000001(hDC, iEntries, puRed, puGreen, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; var puBlue: UInt16): UInt32 :=
    z_SetGammaTableI3D_ovr_24(hDC, iEntries, puRed, puGreen, puBlue);
    private static function z_SetGammaTableI3D_ovr_26(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglSetGammaTableI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SetGammaTableI3D(hDC: GDI_DC; iEntries: Int32; puRed: IntPtr; puGreen: IntPtr; puBlue: IntPtr): UInt32 :=
    z_SetGammaTableI3D_ovr_26(hDC, iEntries, puRed, puGreen, puBlue);
    
  end;
  
  wglGenlockI3D = static class
    
    private static function z_EnableGenlockI3D_ovr_0(hDC: GDI_DC): UInt32;
    external 'opengl32.dll' name 'wglEnableGenlockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnableGenlockI3D(hDC: GDI_DC): UInt32 :=
    z_EnableGenlockI3D_ovr_0(hDC);
    
    private static function z_DisableGenlockI3D_ovr_0(hDC: GDI_DC): UInt32;
    external 'opengl32.dll' name 'wglDisableGenlockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DisableGenlockI3D(hDC: GDI_DC): UInt32 :=
    z_DisableGenlockI3D_ovr_0(hDC);
    
    private static function z_IsEnabledGenlockI3D_ovr_0(hDC: GDI_DC; var pFlag: UInt32): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledGenlockI3D';
    private static function z_IsEnabledGenlockI3D_ovr_0_anh001(hDC: GDI_DC; pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledGenlockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledGenlockI3D(hDC: GDI_DC; pFlag: array of UInt32): UInt32 :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_IsEnabledGenlockI3D_ovr_0(hDC, pFlag[0]) else
      z_IsEnabledGenlockI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledGenlockI3D(hDC: GDI_DC; var pFlag: UInt32): UInt32 :=
    z_IsEnabledGenlockI3D_ovr_0(hDC, pFlag);
    private static function z_IsEnabledGenlockI3D_ovr_2(hDC: GDI_DC; pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledGenlockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledGenlockI3D(hDC: GDI_DC; pFlag: IntPtr): UInt32 :=
    z_IsEnabledGenlockI3D_ovr_2(hDC, pFlag);
    
    private static function z_GenlockSourceI3D_ovr_0(hDC: GDI_DC; uSource: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGenlockSourceI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GenlockSourceI3D(hDC: GDI_DC; uSource: UInt32): UInt32 :=
    z_GenlockSourceI3D_ovr_0(hDC, uSource);
    
    private static function z_GetGenlockSourceI3D_ovr_0(hDC: GDI_DC; var uSource: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceI3D';
    private static function z_GetGenlockSourceI3D_ovr_0_anh001(hDC: GDI_DC; uSource: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceI3D(hDC: GDI_DC; uSource: array of UInt32): UInt32 :=
    if (uSource<>nil) and (uSource.Length<>0) then
      z_GetGenlockSourceI3D_ovr_0(hDC, uSource[0]) else
      z_GetGenlockSourceI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceI3D(hDC: GDI_DC; var uSource: UInt32): UInt32 :=
    z_GetGenlockSourceI3D_ovr_0(hDC, uSource);
    private static function z_GetGenlockSourceI3D_ovr_2(hDC: GDI_DC; uSource: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceI3D(hDC: GDI_DC; uSource: IntPtr): UInt32 :=
    z_GetGenlockSourceI3D_ovr_2(hDC, uSource);
    
    private static function z_GenlockSourceEdgeI3D_ovr_0(hDC: GDI_DC; uEdge: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGenlockSourceEdgeI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GenlockSourceEdgeI3D(hDC: GDI_DC; uEdge: UInt32): UInt32 :=
    z_GenlockSourceEdgeI3D_ovr_0(hDC, uEdge);
    
    private static function z_GetGenlockSourceEdgeI3D_ovr_0(hDC: GDI_DC; var uEdge: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceEdgeI3D';
    private static function z_GetGenlockSourceEdgeI3D_ovr_0_anh001(hDC: GDI_DC; uEdge: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceEdgeI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceEdgeI3D(hDC: GDI_DC; uEdge: array of UInt32): UInt32 :=
    if (uEdge<>nil) and (uEdge.Length<>0) then
      z_GetGenlockSourceEdgeI3D_ovr_0(hDC, uEdge[0]) else
      z_GetGenlockSourceEdgeI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceEdgeI3D(hDC: GDI_DC; var uEdge: UInt32): UInt32 :=
    z_GetGenlockSourceEdgeI3D_ovr_0(hDC, uEdge);
    private static function z_GetGenlockSourceEdgeI3D_ovr_2(hDC: GDI_DC; uEdge: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceEdgeI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceEdgeI3D(hDC: GDI_DC; uEdge: IntPtr): UInt32 :=
    z_GetGenlockSourceEdgeI3D_ovr_2(hDC, uEdge);
    
    private static function z_GenlockSampleRateI3D_ovr_0(hDC: GDI_DC; uRate: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGenlockSampleRateI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GenlockSampleRateI3D(hDC: GDI_DC; uRate: UInt32): UInt32 :=
    z_GenlockSampleRateI3D_ovr_0(hDC, uRate);
    
    private static function z_GetGenlockSampleRateI3D_ovr_0(hDC: GDI_DC; var uRate: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSampleRateI3D';
    private static function z_GetGenlockSampleRateI3D_ovr_0_anh001(hDC: GDI_DC; uRate: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSampleRateI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSampleRateI3D(hDC: GDI_DC; uRate: array of UInt32): UInt32 :=
    if (uRate<>nil) and (uRate.Length<>0) then
      z_GetGenlockSampleRateI3D_ovr_0(hDC, uRate[0]) else
      z_GetGenlockSampleRateI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSampleRateI3D(hDC: GDI_DC; var uRate: UInt32): UInt32 :=
    z_GetGenlockSampleRateI3D_ovr_0(hDC, uRate);
    private static function z_GetGenlockSampleRateI3D_ovr_2(hDC: GDI_DC; uRate: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSampleRateI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSampleRateI3D(hDC: GDI_DC; uRate: IntPtr): UInt32 :=
    z_GetGenlockSampleRateI3D_ovr_2(hDC, uRate);
    
    private static function z_GenlockSourceDelayI3D_ovr_0(hDC: GDI_DC; uDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGenlockSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GenlockSourceDelayI3D(hDC: GDI_DC; uDelay: UInt32): UInt32 :=
    z_GenlockSourceDelayI3D_ovr_0(hDC, uDelay);
    
    private static function z_GetGenlockSourceDelayI3D_ovr_0(hDC: GDI_DC; var uDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceDelayI3D';
    private static function z_GetGenlockSourceDelayI3D_ovr_0_anh001(hDC: GDI_DC; uDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceDelayI3D(hDC: GDI_DC; uDelay: array of UInt32): UInt32 :=
    if (uDelay<>nil) and (uDelay.Length<>0) then
      z_GetGenlockSourceDelayI3D_ovr_0(hDC, uDelay[0]) else
      z_GetGenlockSourceDelayI3D_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceDelayI3D(hDC: GDI_DC; var uDelay: UInt32): UInt32 :=
    z_GetGenlockSourceDelayI3D_ovr_0(hDC, uDelay);
    private static function z_GetGenlockSourceDelayI3D_ovr_2(hDC: GDI_DC; uDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetGenlockSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetGenlockSourceDelayI3D(hDC: GDI_DC; uDelay: IntPtr): UInt32 :=
    z_GetGenlockSourceDelayI3D_ovr_2(hDC, uDelay);
    
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC: GDI_DC; var uMaxLineDelay: UInt32; var uMaxPixelDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010(hDC: GDI_DC; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001(hDC: GDI_DC; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0011(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: array of UInt32; uMaxPixelDelay: array of UInt32): UInt32 :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
        z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay[0], uMaxPixelDelay[0]) else
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001(hDC, uMaxLineDelay[0], IntPtr.Zero) else
      if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay[0]) else
        z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_1_anh0010(hDC: GDI_DC; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: array of UInt32; var uMaxPixelDelay: UInt32): UInt32 :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay[0], uMaxPixelDelay) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay);
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_2(hDC: GDI_DC; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_2_anh0010(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: array of UInt32; uMaxPixelDelay: IntPtr): UInt32 :=
    if (uMaxLineDelay<>nil) and (uMaxLineDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_2(hDC, uMaxLineDelay[0], uMaxPixelDelay) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_2_anh0010(hDC, IntPtr.Zero, uMaxPixelDelay);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; var uMaxLineDelay: UInt32; uMaxPixelDelay: array of UInt32): UInt32 :=
    if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay, uMaxPixelDelay[0]) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_0_anh0001(hDC, uMaxLineDelay, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; var uMaxLineDelay: UInt32; var uMaxPixelDelay: UInt32): UInt32 :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_0(hDC, uMaxLineDelay, uMaxPixelDelay);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; var uMaxLineDelay: UInt32; uMaxPixelDelay: IntPtr): UInt32 :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_2(hDC, uMaxLineDelay, uMaxPixelDelay);
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_6(hDC: GDI_DC; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_6_anh0001(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: array of UInt32): UInt32 :=
    if (uMaxPixelDelay<>nil) and (uMaxPixelDelay.Length<>0) then
      z_QueryGenlockMaxSourceDelayI3D_ovr_6(hDC, uMaxLineDelay, uMaxPixelDelay[0]) else
      z_QueryGenlockMaxSourceDelayI3D_ovr_6_anh0001(hDC, uMaxLineDelay, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: IntPtr; var uMaxPixelDelay: UInt32): UInt32 :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_6(hDC, uMaxLineDelay, uMaxPixelDelay);
    private static function z_QueryGenlockMaxSourceDelayI3D_ovr_8(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryGenlockMaxSourceDelayI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryGenlockMaxSourceDelayI3D(hDC: GDI_DC; uMaxLineDelay: IntPtr; uMaxPixelDelay: IntPtr): UInt32 :=
    z_QueryGenlockMaxSourceDelayI3D_ovr_8(hDC, uMaxLineDelay, uMaxPixelDelay);
    
  end;
  
  wglImageBufferI3D = static class
    
    private static function z_CreateImageBufferI3D_ovr_0(hDC: GDI_DC; dwSize: UInt32; uFlags: UInt32): IntPtr;
    external 'opengl32.dll' name 'wglCreateImageBufferI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateImageBufferI3D(hDC: GDI_DC; dwSize: UInt32; uFlags: UInt32): IntPtr :=
    z_CreateImageBufferI3D_ovr_0(hDC, dwSize, uFlags);
    
    private static function z_DestroyImageBufferI3D_ovr_0(hDC: GDI_DC; pAddress: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDestroyImageBufferI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DestroyImageBufferI3D(hDC: GDI_DC; pAddress: IntPtr): UInt32 :=
    z_DestroyImageBufferI3D_ovr_0(hDC, pAddress);
    
    private static function z_AssociateImageBufferEventsI3D_ovr_0(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh001100(hDC: GDI_DC; pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh001010(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh000110(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_0_anh001110(hDC: GDI_DC; pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress[0], pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent[0], pAddress[0], IntPtr.Zero, count) else
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh000110(hDC, pEvent[0], IntPtr.Zero, IntPtr.Zero, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh001010(hDC, IntPtr.Zero, pAddress[0], IntPtr.Zero, count) else
        if (pSize<>nil) and (pSize.Length<>0) then
          z_AssociateImageBufferEventsI3D_ovr_0_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize[0], count) else
          z_AssociateImageBufferEventsI3D_ovr_0_anh001110(hDC, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_1_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_1_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_1_anh001100(hDC: GDI_DC; pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_2(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_2_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_2_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_2_anh001100(hDC: GDI_DC; pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent[0], pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_2_anh000100(hDC, pEvent[0], IntPtr.Zero, pSize, count) else
      if (pAddress<>nil) and (pAddress.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_2_anh001000(hDC, IntPtr.Zero, pAddress[0], pSize, count) else
        z_AssociateImageBufferEventsI3D_ovr_2_anh001100(hDC, IntPtr.Zero, IntPtr.Zero, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_3_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_3_anh001010(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent[0], pAddress, IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh001010(hDC, IntPtr.Zero, pAddress, IntPtr.Zero, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_4_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_5_anh001000(hDC: GDI_DC; pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_2_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_6(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_6_anh001000(hDC: GDI_DC; pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_6_anh000010(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_6_anh001010(hDC: GDI_DC; pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: pointer; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent[0], pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_6_anh000010(hDC, pEvent[0], pAddress, IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_6_anh001000(hDC, IntPtr.Zero, pAddress, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_6_anh001010(hDC, IntPtr.Zero, pAddress, IntPtr.Zero, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_7_anh001000(hDC: GDI_DC; pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_6_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_8(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_8_anh001000(hDC: GDI_DC; pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: array of IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32 :=
    if (pEvent<>nil) and (pEvent.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_8(hDC, pEvent[0], pAddress, pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_8_anh001000(hDC, IntPtr.Zero, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_9_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_9_anh000110(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress[0], pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent, pAddress[0], IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent, IntPtr.Zero, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_0_anh000110(hDC, pEvent, IntPtr.Zero, IntPtr.Zero, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_10_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_11_anh000100(hDC: GDI_DC; var pEvent: IntPtr; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_2_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_0_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_0(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_2(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_6_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_6(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; var pEvent: IntPtr; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_8(hDC, pEvent, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_18(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_18_anh000100(hDC: GDI_DC; pEvent: pointer; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_18_anh000010(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_18_anh000110(hDC: GDI_DC; pEvent: pointer; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: array of IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress[0], pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_18_anh000010(hDC, pEvent, pAddress[0], IntPtr.Zero, count) else
      if (pSize<>nil) and (pSize.Length<>0) then
        z_AssociateImageBufferEventsI3D_ovr_18_anh000100(hDC, pEvent, IntPtr.Zero, pSize[0], count) else
        z_AssociateImageBufferEventsI3D_ovr_18_anh000110(hDC, pEvent, IntPtr.Zero, IntPtr.Zero, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_19_anh000100(hDC: GDI_DC; pEvent: pointer; pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: array of IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_18_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_20(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_20_anh000100(hDC: GDI_DC; pEvent: pointer; pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: array of IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_20(hDC, pEvent, pAddress[0], pSize, count) else
      z_AssociateImageBufferEventsI3D_ovr_20_anh000100(hDC, pEvent, IntPtr.Zero, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_18_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; var pSize: UInt32; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_18(hDC, pEvent, pAddress, pSize, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; var pAddress: IntPtr; pSize: IntPtr; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_20(hDC, pEvent, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_24(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    private static function z_AssociateImageBufferEventsI3D_ovr_24_anh000010(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; pSize: array of UInt32; count: UInt32): UInt32 :=
    if (pSize<>nil) and (pSize.Length<>0) then
      z_AssociateImageBufferEventsI3D_ovr_24(hDC, pEvent, pAddress, pSize[0], count) else
      z_AssociateImageBufferEventsI3D_ovr_24_anh000010(hDC, pEvent, pAddress, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; var pSize: UInt32; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_24(hDC, pEvent, pAddress, pSize, count);
    private static function z_AssociateImageBufferEventsI3D_ovr_26(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglAssociateImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AssociateImageBufferEventsI3D(hDC: GDI_DC; pEvent: pointer; pAddress: pointer; pSize: IntPtr; count: UInt32): UInt32 :=
    z_AssociateImageBufferEventsI3D_ovr_26(hDC, pEvent, pAddress, pSize, count);
    
    private static function z_ReleaseImageBufferEventsI3D_ovr_0(hDC: GDI_DC; var pAddress: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglReleaseImageBufferEventsI3D';
    private static function z_ReleaseImageBufferEventsI3D_ovr_0_anh0010(hDC: GDI_DC; pAddress: IntPtr; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglReleaseImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseImageBufferEventsI3D(hDC: GDI_DC; pAddress: array of IntPtr; count: UInt32): UInt32 :=
    if (pAddress<>nil) and (pAddress.Length<>0) then
      z_ReleaseImageBufferEventsI3D_ovr_0(hDC, pAddress[0], count) else
      z_ReleaseImageBufferEventsI3D_ovr_0_anh0010(hDC, IntPtr.Zero, count);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseImageBufferEventsI3D(hDC: GDI_DC; var pAddress: IntPtr; count: UInt32): UInt32 :=
    z_ReleaseImageBufferEventsI3D_ovr_0(hDC, pAddress, count);
    private static function z_ReleaseImageBufferEventsI3D_ovr_2(hDC: GDI_DC; pAddress: pointer; count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglReleaseImageBufferEventsI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseImageBufferEventsI3D(hDC: GDI_DC; pAddress: pointer; count: UInt32): UInt32 :=
    z_ReleaseImageBufferEventsI3D_ovr_2(hDC, pAddress, count);
    
  end;
  
  wglSwapFrameLockI3D = static class
    
    private static function z_EnableFrameLockI3D_ovr_0: UInt32;
    external 'opengl32.dll' name 'wglEnableFrameLockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnableFrameLockI3D: UInt32 :=
    z_EnableFrameLockI3D_ovr_0;
    
    private static function z_DisableFrameLockI3D_ovr_0: UInt32;
    external 'opengl32.dll' name 'wglDisableFrameLockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DisableFrameLockI3D: UInt32 :=
    z_DisableFrameLockI3D_ovr_0;
    
    private static function z_IsEnabledFrameLockI3D_ovr_0(var pFlag: UInt32): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledFrameLockI3D';
    private static function z_IsEnabledFrameLockI3D_ovr_0_anh01(pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledFrameLockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledFrameLockI3D(pFlag: array of UInt32): UInt32 :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_IsEnabledFrameLockI3D_ovr_0(pFlag[0]) else
      z_IsEnabledFrameLockI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledFrameLockI3D(var pFlag: UInt32): UInt32 :=
    z_IsEnabledFrameLockI3D_ovr_0(pFlag);
    private static function z_IsEnabledFrameLockI3D_ovr_2(pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglIsEnabledFrameLockI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function IsEnabledFrameLockI3D(pFlag: IntPtr): UInt32 :=
    z_IsEnabledFrameLockI3D_ovr_2(pFlag);
    
    private static function z_QueryFrameLockMasterI3D_ovr_0(var pFlag: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameLockMasterI3D';
    private static function z_QueryFrameLockMasterI3D_ovr_0_anh01(pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameLockMasterI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameLockMasterI3D(pFlag: array of UInt32): UInt32 :=
    if (pFlag<>nil) and (pFlag.Length<>0) then
      z_QueryFrameLockMasterI3D_ovr_0(pFlag[0]) else
      z_QueryFrameLockMasterI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameLockMasterI3D(var pFlag: UInt32): UInt32 :=
    z_QueryFrameLockMasterI3D_ovr_0(pFlag);
    private static function z_QueryFrameLockMasterI3D_ovr_2(pFlag: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameLockMasterI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameLockMasterI3D(pFlag: IntPtr): UInt32 :=
    z_QueryFrameLockMasterI3D_ovr_2(pFlag);
    
  end;
  
  wglSwapFrameUsageI3D = static class
    
    private static function z_GetFrameUsageI3D_ovr_0(var pUsage: single): UInt32;
    external 'opengl32.dll' name 'wglGetFrameUsageI3D';
    private static function z_GetFrameUsageI3D_ovr_0_anh01(pUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetFrameUsageI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFrameUsageI3D(pUsage: array of single): UInt32 :=
    if (pUsage<>nil) and (pUsage.Length<>0) then
      z_GetFrameUsageI3D_ovr_0(pUsage[0]) else
      z_GetFrameUsageI3D_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFrameUsageI3D(var pUsage: single): UInt32 :=
    z_GetFrameUsageI3D_ovr_0(pUsage);
    private static function z_GetFrameUsageI3D_ovr_2(pUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetFrameUsageI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetFrameUsageI3D(pUsage: IntPtr): UInt32 :=
    z_GetFrameUsageI3D_ovr_2(pUsage);
    
    private static function z_BeginFrameTrackingI3D_ovr_0: UInt32;
    external 'opengl32.dll' name 'wglBeginFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BeginFrameTrackingI3D: UInt32 :=
    z_BeginFrameTrackingI3D_ovr_0;
    
    private static function z_EndFrameTrackingI3D_ovr_0: UInt32;
    external 'opengl32.dll' name 'wglEndFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EndFrameTrackingI3D: UInt32 :=
    z_EndFrameTrackingI3D_ovr_0;
    
    private static function z_QueryFrameTrackingI3D_ovr_0(var pFrameCount: UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0010(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0110(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0001(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0101(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0011(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_0_anh0111(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames[0], pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount[0], pMissedFrames[0], IntPtr.Zero) else
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0011(pFrameCount[0], IntPtr.Zero, IntPtr.Zero) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0101(IntPtr.Zero, pMissedFrames[0], IntPtr.Zero) else
        if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
          z_QueryFrameTrackingI3D_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage[0]) else
          z_QueryFrameTrackingI3D_ovr_0_anh0111(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryFrameTrackingI3D_ovr_1_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_1_anh0010(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_1_anh0110(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; var pLastMissedUsage: single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_0_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_2(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_2_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_2_anh0010(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_2_anh0110(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_2(pFrameCount[0], pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_2_anh0010(pFrameCount[0], IntPtr.Zero, pLastMissedUsage) else
      if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_2_anh0100(IntPtr.Zero, pMissedFrames[0], pLastMissedUsage) else
        z_QueryFrameTrackingI3D_ovr_2_anh0110(IntPtr.Zero, IntPtr.Zero, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_3_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_3_anh0101(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount[0], pMissedFrames, IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0101(IntPtr.Zero, pMissedFrames, IntPtr.Zero);
    private static function z_QueryFrameTrackingI3D_ovr_4_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_0_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_5_anh0100(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_2(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_2_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_6(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_6_anh0100(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_6_anh0001(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_6_anh0101(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; pLastMissedUsage: array of single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_6(pFrameCount[0], pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_6_anh0001(pFrameCount[0], pMissedFrames, IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_6_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_6_anh0101(IntPtr.Zero, pMissedFrames, IntPtr.Zero);
    private static function z_QueryFrameTrackingI3D_ovr_7_anh0100(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_6(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_6_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_8(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_8_anh0100(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: array of UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32 :=
    if (pFrameCount<>nil) and (pFrameCount.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_8(pFrameCount[0], pMissedFrames, pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_8_anh0100(IntPtr.Zero, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames[0], pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount, pMissedFrames[0], IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_0_anh0011(pFrameCount, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; var pLastMissedUsage: single): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_0_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_2(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_2_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_0_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_0(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_2(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: array of single): UInt32 :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_6(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_6_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_6(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(var pFrameCount: UInt32; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_8(pFrameCount, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_18(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_18_anh0010(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_18_anh0001(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_18_anh0011(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames[0], pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_18_anh0001(pFrameCount, pMissedFrames[0], IntPtr.Zero) else
      if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
        z_QueryFrameTrackingI3D_ovr_18_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage[0]) else
        z_QueryFrameTrackingI3D_ovr_18_anh0011(pFrameCount, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryFrameTrackingI3D_ovr_19_anh0010(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; var pLastMissedUsage: single): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_18_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_20(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_20_anh0010(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: array of UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    if (pMissedFrames<>nil) and (pMissedFrames.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_20(pFrameCount, pMissedFrames[0], pLastMissedUsage) else
      z_QueryFrameTrackingI3D_ovr_20_anh0010(pFrameCount, IntPtr.Zero, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: array of single): UInt32 :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_18_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; var pLastMissedUsage: single): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_18(pFrameCount, pMissedFrames, pLastMissedUsage);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; var pMissedFrames: UInt32; pLastMissedUsage: IntPtr): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_20(pFrameCount, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_24(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    private static function z_QueryFrameTrackingI3D_ovr_24_anh0001(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: array of single): UInt32 :=
    if (pLastMissedUsage<>nil) and (pLastMissedUsage.Length<>0) then
      z_QueryFrameTrackingI3D_ovr_24(pFrameCount, pMissedFrames, pLastMissedUsage[0]) else
      z_QueryFrameTrackingI3D_ovr_24_anh0001(pFrameCount, pMissedFrames, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; var pLastMissedUsage: single): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_24(pFrameCount, pMissedFrames, pLastMissedUsage);
    private static function z_QueryFrameTrackingI3D_ovr_26(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameTrackingI3D';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameTrackingI3D(pFrameCount: IntPtr; pMissedFrames: IntPtr; pLastMissedUsage: IntPtr): UInt32 :=
    z_QueryFrameTrackingI3D_ovr_26(pFrameCount, pMissedFrames, pLastMissedUsage);
    
  end;
  
  wglCopyImageNV = static class
    
    private static function z_CopyImageSubDataNV_ovr_0(hSrcRC: GLContext; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; hDstRC: GLContext; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32): UInt32;
    external 'opengl32.dll' name 'wglCopyImageSubDataNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CopyImageSubDataNV(hSrcRC: GLContext; srcName: UInt32; srcTarget: DummyEnum; srcLevel: Int32; srcX: Int32; srcY: Int32; srcZ: Int32; hDstRC: GLContext; dstName: UInt32; dstTarget: DummyEnum; dstLevel: Int32; dstX: Int32; dstY: Int32; dstZ: Int32; width: Int32; height: Int32; depth: Int32): UInt32 :=
    z_CopyImageSubDataNV_ovr_0(hSrcRC, srcName, srcTarget, srcLevel, srcX, srcY, srcZ, hDstRC, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
    
  end;
  
  wglDelayBeforeSwapNV = static class
    
    private static function z_DelayBeforeSwapNV_ovr_0(hDC: GDI_DC; seconds: single): UInt32;
    external 'opengl32.dll' name 'wglDelayBeforeSwapNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DelayBeforeSwapNV(hDC: GDI_DC; seconds: single): UInt32 :=
    z_DelayBeforeSwapNV_ovr_0(hDC, seconds);
    
  end;
  
  wglDXInteropNV = static class
    
    private static function z_DXSetResourceShareHandleNV_ovr_0(dxObject: IntPtr; shareHandle: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXSetResourceShareHandleNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXSetResourceShareHandleNV(dxObject: IntPtr; shareHandle: IntPtr): UInt32 :=
    z_DXSetResourceShareHandleNV_ovr_0(dxObject, shareHandle);
    
    private static function z_DXOpenDeviceNV_ovr_0(dxDevice: IntPtr): IntPtr;
    external 'opengl32.dll' name 'wglDXOpenDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXOpenDeviceNV(dxDevice: IntPtr): IntPtr :=
    z_DXOpenDeviceNV_ovr_0(dxDevice);
    
    private static function z_DXCloseDeviceNV_ovr_0(hDevice: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXCloseDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXCloseDeviceNV(hDevice: IntPtr): UInt32 :=
    z_DXCloseDeviceNV_ovr_0(hDevice);
    
    private static function z_DXRegisterObjectNV_ovr_0(hDevice: IntPtr; dxObject: IntPtr; name: UInt32; &type: DummyEnum; access: DummyEnum): IntPtr;
    external 'opengl32.dll' name 'wglDXRegisterObjectNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXRegisterObjectNV(hDevice: IntPtr; dxObject: IntPtr; name: UInt32; &type: DummyEnum; access: DummyEnum): IntPtr :=
    z_DXRegisterObjectNV_ovr_0(hDevice, dxObject, name, &type, access);
    
    private static function z_DXUnregisterObjectNV_ovr_0(hDevice: IntPtr; hObject: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXUnregisterObjectNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXUnregisterObjectNV(hDevice: IntPtr; hObject: IntPtr): UInt32 :=
    z_DXUnregisterObjectNV_ovr_0(hDevice, hObject);
    
    private static function z_DXObjectAccessNV_ovr_0(hObject: IntPtr; access: DummyEnum): UInt32;
    external 'opengl32.dll' name 'wglDXObjectAccessNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXObjectAccessNV(hObject: IntPtr; access: DummyEnum): UInt32 :=
    z_DXObjectAccessNV_ovr_0(hObject, access);
    
    private static function z_DXLockObjectsNV_ovr_0(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXLockObjectsNV';
    private static function z_DXLockObjectsNV_ovr_0_anh0001(hDevice: IntPtr; count: Int32; hObjects: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXLockObjectsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXLockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: array of IntPtr): UInt32 :=
    if (hObjects<>nil) and (hObjects.Length<>0) then
      z_DXLockObjectsNV_ovr_0(hDevice, count, hObjects[0]) else
      z_DXLockObjectsNV_ovr_0_anh0001(hDevice, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXLockObjectsNV(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): UInt32 :=
    z_DXLockObjectsNV_ovr_0(hDevice, count, hObjects);
    private static function z_DXLockObjectsNV_ovr_2(hDevice: IntPtr; count: Int32; hObjects: pointer): UInt32;
    external 'opengl32.dll' name 'wglDXLockObjectsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXLockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: pointer): UInt32 :=
    z_DXLockObjectsNV_ovr_2(hDevice, count, hObjects);
    
    private static function z_DXUnlockObjectsNV_ovr_0(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXUnlockObjectsNV';
    private static function z_DXUnlockObjectsNV_ovr_0_anh0001(hDevice: IntPtr; count: Int32; hObjects: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglDXUnlockObjectsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: array of IntPtr): UInt32 :=
    if (hObjects<>nil) and (hObjects.Length<>0) then
      z_DXUnlockObjectsNV_ovr_0(hDevice, count, hObjects[0]) else
      z_DXUnlockObjectsNV_ovr_0_anh0001(hDevice, count, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; var hObjects: IntPtr): UInt32 :=
    z_DXUnlockObjectsNV_ovr_0(hDevice, count, hObjects);
    private static function z_DXUnlockObjectsNV_ovr_2(hDevice: IntPtr; count: Int32; hObjects: pointer): UInt32;
    external 'opengl32.dll' name 'wglDXUnlockObjectsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DXUnlockObjectsNV(hDevice: IntPtr; count: Int32; hObjects: pointer): UInt32 :=
    z_DXUnlockObjectsNV_ovr_2(hDevice, count, hObjects);
    
  end;
  
  wglGpuAffinityNV = static class
    
    private static function z_EnumGpusNV_ovr_0(iGpuIndex: UInt32; var phGpu: HGPUNV): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusNV';
    private static function z_EnumGpusNV_ovr_0_anh001(iGpuIndex: UInt32; phGpu: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusNV(iGpuIndex: UInt32; phGpu: array of HGPUNV): UInt32 :=
    if (phGpu<>nil) and (phGpu.Length<>0) then
      z_EnumGpusNV_ovr_0(iGpuIndex, phGpu[0]) else
      z_EnumGpusNV_ovr_0_anh001(iGpuIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusNV(iGpuIndex: UInt32; var phGpu: HGPUNV): UInt32 :=
    z_EnumGpusNV_ovr_0(iGpuIndex, phGpu);
    private static function z_EnumGpusNV_ovr_2(iGpuIndex: UInt32; phGpu: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusNV(iGpuIndex: UInt32; phGpu: IntPtr): UInt32 :=
    z_EnumGpusNV_ovr_2(iGpuIndex, phGpu);
    
    private static function z_EnumGpuDevicesNV_ovr_0(hGpu: HGPUNV; iDeviceIndex: UInt32; lpGpuDevice: PGPU_DEVICE): UInt32;
    external 'opengl32.dll' name 'wglEnumGpuDevicesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpuDevicesNV(hGpu: HGPUNV; iDeviceIndex: UInt32; lpGpuDevice: PGPU_DEVICE): UInt32 :=
    z_EnumGpuDevicesNV_ovr_0(hGpu, iDeviceIndex, lpGpuDevice);
    
    private static function z_CreateAffinityDCNV_ovr_0(var phGpuList: HGPUNV): GDI_DC;
    external 'opengl32.dll' name 'wglCreateAffinityDCNV';
    private static function z_CreateAffinityDCNV_ovr_0_anh01(phGpuList: IntPtr): GDI_DC;
    external 'opengl32.dll' name 'wglCreateAffinityDCNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAffinityDCNV(phGpuList: array of HGPUNV): GDI_DC :=
    if (phGpuList<>nil) and (phGpuList.Length<>0) then
      z_CreateAffinityDCNV_ovr_0(phGpuList[0]) else
      z_CreateAffinityDCNV_ovr_0_anh01(IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAffinityDCNV(var phGpuList: HGPUNV): GDI_DC :=
    z_CreateAffinityDCNV_ovr_0(phGpuList);
    private static function z_CreateAffinityDCNV_ovr_2(phGpuList: IntPtr): GDI_DC;
    external 'opengl32.dll' name 'wglCreateAffinityDCNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function CreateAffinityDCNV(phGpuList: IntPtr): GDI_DC :=
    z_CreateAffinityDCNV_ovr_2(phGpuList);
    
    private static function z_EnumGpusFromAffinityDCNV_ovr_0(hAffinityDC: GDI_DC; iGpuIndex: UInt32; var hGpu: HGPUNV): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusFromAffinityDCNV';
    private static function z_EnumGpusFromAffinityDCNV_ovr_0_anh0001(hAffinityDC: GDI_DC; iGpuIndex: UInt32; hGpu: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusFromAffinityDCNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusFromAffinityDCNV(hAffinityDC: GDI_DC; iGpuIndex: UInt32; hGpu: array of HGPUNV): UInt32 :=
    if (hGpu<>nil) and (hGpu.Length<>0) then
      z_EnumGpusFromAffinityDCNV_ovr_0(hAffinityDC, iGpuIndex, hGpu[0]) else
      z_EnumGpusFromAffinityDCNV_ovr_0_anh0001(hAffinityDC, iGpuIndex, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusFromAffinityDCNV(hAffinityDC: GDI_DC; iGpuIndex: UInt32; var hGpu: HGPUNV): UInt32 :=
    z_EnumGpusFromAffinityDCNV_ovr_0(hAffinityDC, iGpuIndex, hGpu);
    private static function z_EnumGpusFromAffinityDCNV_ovr_2(hAffinityDC: GDI_DC; iGpuIndex: UInt32; hGpu: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumGpusFromAffinityDCNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumGpusFromAffinityDCNV(hAffinityDC: GDI_DC; iGpuIndex: UInt32; hGpu: IntPtr): UInt32 :=
    z_EnumGpusFromAffinityDCNV_ovr_2(hAffinityDC, iGpuIndex, hGpu);
    
    private static function z_DeleteDCNV_ovr_0(hdc: GDI_DC): UInt32;
    external 'opengl32.dll' name 'wglDeleteDCNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function DeleteDCNV(hdc: GDI_DC): UInt32 :=
    z_DeleteDCNV_ovr_0(hdc);
    
  end;
  
  wglPresentVideoNV = static class
    
    private static function z_EnumerateVideoDevicesNV_ovr_0(hDc: GDI_DC; var phDeviceList: HVIDEOOUTPUTDEVICENV): Int32;
    external 'opengl32.dll' name 'wglEnumerateVideoDevicesNV';
    private static function z_EnumerateVideoDevicesNV_ovr_0_anh001(hDc: GDI_DC; phDeviceList: IntPtr): Int32;
    external 'opengl32.dll' name 'wglEnumerateVideoDevicesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoDevicesNV(hDc: GDI_DC; phDeviceList: array of HVIDEOOUTPUTDEVICENV): Int32 :=
    if (phDeviceList<>nil) and (phDeviceList.Length<>0) then
      z_EnumerateVideoDevicesNV_ovr_0(hDc, phDeviceList[0]) else
      z_EnumerateVideoDevicesNV_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoDevicesNV(hDc: GDI_DC; var phDeviceList: HVIDEOOUTPUTDEVICENV): Int32 :=
    z_EnumerateVideoDevicesNV_ovr_0(hDc, phDeviceList);
    private static function z_EnumerateVideoDevicesNV_ovr_2(hDc: GDI_DC; phDeviceList: IntPtr): Int32;
    external 'opengl32.dll' name 'wglEnumerateVideoDevicesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoDevicesNV(hDc: GDI_DC; phDeviceList: IntPtr): Int32 :=
    z_EnumerateVideoDevicesNV_ovr_2(hDc, phDeviceList);
    
    private static function z_BindVideoDeviceNV_ovr_0(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; var piAttribList: Int32): UInt32;
    external 'opengl32.dll' name 'wglBindVideoDeviceNV';
    private static function z_BindVideoDeviceNV_ovr_0_anh00001(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; piAttribList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglBindVideoDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindVideoDeviceNV(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; piAttribList: array of Int32): UInt32 :=
    if (piAttribList<>nil) and (piAttribList.Length<>0) then
      z_BindVideoDeviceNV_ovr_0(hDc, uVideoSlot, hVideoDevice, piAttribList[0]) else
      z_BindVideoDeviceNV_ovr_0_anh00001(hDc, uVideoSlot, hVideoDevice, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindVideoDeviceNV(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; var piAttribList: Int32): UInt32 :=
    z_BindVideoDeviceNV_ovr_0(hDc, uVideoSlot, hVideoDevice, piAttribList);
    private static function z_BindVideoDeviceNV_ovr_2(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; piAttribList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglBindVideoDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindVideoDeviceNV(hDc: GDI_DC; uVideoSlot: UInt32; hVideoDevice: HVIDEOOUTPUTDEVICENV; piAttribList: IntPtr): UInt32 :=
    z_BindVideoDeviceNV_ovr_2(hDc, uVideoSlot, hVideoDevice, piAttribList);
    
    private static function z_QueryCurrentContextNV_ovr_0(iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglQueryCurrentContextNV';
    private static function z_QueryCurrentContextNV_ovr_0_anh001(iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryCurrentContextNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryCurrentContextNV(iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryCurrentContextNV_ovr_0(iAttribute, piValue[0]) else
      z_QueryCurrentContextNV_ovr_0_anh001(iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryCurrentContextNV(iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_QueryCurrentContextNV_ovr_0(iAttribute, piValue);
    private static function z_QueryCurrentContextNV_ovr_2(iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryCurrentContextNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryCurrentContextNV(iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_QueryCurrentContextNV_ovr_2(iAttribute, piValue);
    
  end;
  
  wglSwapGroupNV = static class
    
    private static function z_JoinSwapGroupNV_ovr_0(hDC: GDI_DC; group: UInt32): UInt32;
    external 'opengl32.dll' name 'wglJoinSwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function JoinSwapGroupNV(hDC: GDI_DC; group: UInt32): UInt32 :=
    z_JoinSwapGroupNV_ovr_0(hDC, group);
    
    private static function z_BindSwapBarrierNV_ovr_0(group: UInt32; barrier: UInt32): UInt32;
    external 'opengl32.dll' name 'wglBindSwapBarrierNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindSwapBarrierNV(group: UInt32; barrier: UInt32): UInt32 :=
    z_BindSwapBarrierNV_ovr_0(group, barrier);
    
    private static function z_QuerySwapGroupNV_ovr_0(hDC: GDI_DC; var group: UInt32; var barrier: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    private static function z_QuerySwapGroupNV_ovr_0_anh0010(hDC: GDI_DC; group: IntPtr; var barrier: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    private static function z_QuerySwapGroupNV_ovr_0_anh0001(hDC: GDI_DC; var group: UInt32; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    private static function z_QuerySwapGroupNV_ovr_0_anh0011(hDC: GDI_DC; group: IntPtr; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: array of UInt32; barrier: array of UInt32): UInt32 :=
    if (group<>nil) and (group.Length<>0) then
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0(hDC, group[0], barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh0001(hDC, group[0], IntPtr.Zero) else
      if (barrier<>nil) and (barrier.Length<>0) then
        z_QuerySwapGroupNV_ovr_0_anh0010(hDC, IntPtr.Zero, barrier[0]) else
        z_QuerySwapGroupNV_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private static function z_QuerySwapGroupNV_ovr_1_anh0010(hDC: GDI_DC; group: IntPtr; var barrier: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: array of UInt32; var barrier: UInt32): UInt32 :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(hDC, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_0_anh0010(hDC, IntPtr.Zero, barrier);
    private static function z_QuerySwapGroupNV_ovr_2(hDC: GDI_DC; var group: UInt32; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    private static function z_QuerySwapGroupNV_ovr_2_anh0010(hDC: GDI_DC; group: IntPtr; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: array of UInt32; barrier: IntPtr): UInt32 :=
    if (group<>nil) and (group.Length<>0) then
      z_QuerySwapGroupNV_ovr_2(hDC, group[0], barrier) else
      z_QuerySwapGroupNV_ovr_2_anh0010(hDC, IntPtr.Zero, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; var group: UInt32; barrier: array of UInt32): UInt32 :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_0(hDC, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_0_anh0001(hDC, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; var group: UInt32; var barrier: UInt32): UInt32 :=
    z_QuerySwapGroupNV_ovr_0(hDC, group, barrier);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; var group: UInt32; barrier: IntPtr): UInt32 :=
    z_QuerySwapGroupNV_ovr_2(hDC, group, barrier);
    private static function z_QuerySwapGroupNV_ovr_6(hDC: GDI_DC; group: IntPtr; var barrier: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    private static function z_QuerySwapGroupNV_ovr_6_anh0001(hDC: GDI_DC; group: IntPtr; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: IntPtr; barrier: array of UInt32): UInt32 :=
    if (barrier<>nil) and (barrier.Length<>0) then
      z_QuerySwapGroupNV_ovr_6(hDC, group, barrier[0]) else
      z_QuerySwapGroupNV_ovr_6_anh0001(hDC, group, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: IntPtr; var barrier: UInt32): UInt32 :=
    z_QuerySwapGroupNV_ovr_6(hDC, group, barrier);
    private static function z_QuerySwapGroupNV_ovr_8(hDC: GDI_DC; group: IntPtr; barrier: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQuerySwapGroupNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QuerySwapGroupNV(hDC: GDI_DC; group: IntPtr; barrier: IntPtr): UInt32 :=
    z_QuerySwapGroupNV_ovr_8(hDC, group, barrier);
    
    private static function z_QueryMaxSwapGroupsNV_ovr_0(hDC: GDI_DC; var maxGroups: UInt32; var maxBarriers: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    private static function z_QueryMaxSwapGroupsNV_ovr_0_anh0010(hDC: GDI_DC; maxGroups: IntPtr; var maxBarriers: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    private static function z_QueryMaxSwapGroupsNV_ovr_0_anh0001(hDC: GDI_DC; var maxGroups: UInt32; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    private static function z_QueryMaxSwapGroupsNV_ovr_0_anh0011(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: array of UInt32; maxBarriers: array of UInt32): UInt32 :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups[0], maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh0001(hDC, maxGroups[0], IntPtr.Zero) else
      if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
        z_QueryMaxSwapGroupsNV_ovr_0_anh0010(hDC, IntPtr.Zero, maxBarriers[0]) else
        z_QueryMaxSwapGroupsNV_ovr_0_anh0011(hDC, IntPtr.Zero, IntPtr.Zero);
    private static function z_QueryMaxSwapGroupsNV_ovr_1_anh0010(hDC: GDI_DC; maxGroups: IntPtr; var maxBarriers: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: array of UInt32; var maxBarriers: UInt32): UInt32 :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh0010(hDC, IntPtr.Zero, maxBarriers);
    private static function z_QueryMaxSwapGroupsNV_ovr_2(hDC: GDI_DC; var maxGroups: UInt32; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    private static function z_QueryMaxSwapGroupsNV_ovr_2_anh0010(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: array of UInt32; maxBarriers: IntPtr): UInt32 :=
    if (maxGroups<>nil) and (maxGroups.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_2(hDC, maxGroups[0], maxBarriers) else
      z_QueryMaxSwapGroupsNV_ovr_2_anh0010(hDC, IntPtr.Zero, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; var maxGroups: UInt32; maxBarriers: array of UInt32): UInt32 :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_0_anh0001(hDC, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; var maxGroups: UInt32; var maxBarriers: UInt32): UInt32 :=
    z_QueryMaxSwapGroupsNV_ovr_0(hDC, maxGroups, maxBarriers);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; var maxGroups: UInt32; maxBarriers: IntPtr): UInt32 :=
    z_QueryMaxSwapGroupsNV_ovr_2(hDC, maxGroups, maxBarriers);
    private static function z_QueryMaxSwapGroupsNV_ovr_6(hDC: GDI_DC; maxGroups: IntPtr; var maxBarriers: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    private static function z_QueryMaxSwapGroupsNV_ovr_6_anh0001(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: array of UInt32): UInt32 :=
    if (maxBarriers<>nil) and (maxBarriers.Length<>0) then
      z_QueryMaxSwapGroupsNV_ovr_6(hDC, maxGroups, maxBarriers[0]) else
      z_QueryMaxSwapGroupsNV_ovr_6_anh0001(hDC, maxGroups, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: IntPtr; var maxBarriers: UInt32): UInt32 :=
    z_QueryMaxSwapGroupsNV_ovr_6(hDC, maxGroups, maxBarriers);
    private static function z_QueryMaxSwapGroupsNV_ovr_8(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryMaxSwapGroupsNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryMaxSwapGroupsNV(hDC: GDI_DC; maxGroups: IntPtr; maxBarriers: IntPtr): UInt32 :=
    z_QueryMaxSwapGroupsNV_ovr_8(hDC, maxGroups, maxBarriers);
    
    private static function z_QueryFrameCountNV_ovr_0(hDC: GDI_DC; var count: UInt32): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameCountNV';
    private static function z_QueryFrameCountNV_ovr_0_anh001(hDC: GDI_DC; count: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameCountNV(hDC: GDI_DC; count: array of UInt32): UInt32 :=
    if (count<>nil) and (count.Length<>0) then
      z_QueryFrameCountNV_ovr_0(hDC, count[0]) else
      z_QueryFrameCountNV_ovr_0_anh001(hDC, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameCountNV(hDC: GDI_DC; var count: UInt32): UInt32 :=
    z_QueryFrameCountNV_ovr_0(hDC, count);
    private static function z_QueryFrameCountNV_ovr_2(hDC: GDI_DC; count: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryFrameCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryFrameCountNV(hDC: GDI_DC; count: IntPtr): UInt32 :=
    z_QueryFrameCountNV_ovr_2(hDC, count);
    
    private static function z_ResetFrameCountNV_ovr_0(hDC: GDI_DC): UInt32;
    external 'opengl32.dll' name 'wglResetFrameCountNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ResetFrameCountNV(hDC: GDI_DC): UInt32 :=
    z_ResetFrameCountNV_ovr_0(hDC);
    
  end;
  
  wglVideoCaptureNV = static class
    
    private static function z_BindVideoCaptureDeviceNV_ovr_0(uVideoSlot: UInt32; hDevice: HVIDEOINPUTDEVICENV): UInt32;
    external 'opengl32.dll' name 'wglBindVideoCaptureDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindVideoCaptureDeviceNV(uVideoSlot: UInt32; hDevice: HVIDEOINPUTDEVICENV): UInt32 :=
    z_BindVideoCaptureDeviceNV_ovr_0(uVideoSlot, hDevice);
    
    private static function z_EnumerateVideoCaptureDevicesNV_ovr_0(hDc: GDI_DC; var phDeviceList: HVIDEOINPUTDEVICENV): UInt32;
    external 'opengl32.dll' name 'wglEnumerateVideoCaptureDevicesNV';
    private static function z_EnumerateVideoCaptureDevicesNV_ovr_0_anh001(hDc: GDI_DC; phDeviceList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumerateVideoCaptureDevicesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoCaptureDevicesNV(hDc: GDI_DC; phDeviceList: array of HVIDEOINPUTDEVICENV): UInt32 :=
    if (phDeviceList<>nil) and (phDeviceList.Length<>0) then
      z_EnumerateVideoCaptureDevicesNV_ovr_0(hDc, phDeviceList[0]) else
      z_EnumerateVideoCaptureDevicesNV_ovr_0_anh001(hDc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoCaptureDevicesNV(hDc: GDI_DC; var phDeviceList: HVIDEOINPUTDEVICENV): UInt32 :=
    z_EnumerateVideoCaptureDevicesNV_ovr_0(hDc, phDeviceList);
    private static function z_EnumerateVideoCaptureDevicesNV_ovr_2(hDc: GDI_DC; phDeviceList: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglEnumerateVideoCaptureDevicesNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function EnumerateVideoCaptureDevicesNV(hDc: GDI_DC; phDeviceList: IntPtr): UInt32 :=
    z_EnumerateVideoCaptureDevicesNV_ovr_2(hDc, phDeviceList);
    
    private static function z_LockVideoCaptureDeviceNV_ovr_0(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV): UInt32;
    external 'opengl32.dll' name 'wglLockVideoCaptureDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function LockVideoCaptureDeviceNV(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV): UInt32 :=
    z_LockVideoCaptureDeviceNV_ovr_0(hDc, hDevice);
    
    private static function z_QueryVideoCaptureDeviceNV_ovr_0(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; var piValue: Int32): UInt32;
    external 'opengl32.dll' name 'wglQueryVideoCaptureDeviceNV';
    private static function z_QueryVideoCaptureDeviceNV_ovr_0_anh00001(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryVideoCaptureDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVideoCaptureDeviceNV(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; piValue: array of Int32): UInt32 :=
    if (piValue<>nil) and (piValue.Length<>0) then
      z_QueryVideoCaptureDeviceNV_ovr_0(hDc, hDevice, iAttribute, piValue[0]) else
      z_QueryVideoCaptureDeviceNV_ovr_0_anh00001(hDc, hDevice, iAttribute, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVideoCaptureDeviceNV(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; var piValue: Int32): UInt32 :=
    z_QueryVideoCaptureDeviceNV_ovr_0(hDc, hDevice, iAttribute, piValue);
    private static function z_QueryVideoCaptureDeviceNV_ovr_2(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; piValue: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglQueryVideoCaptureDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function QueryVideoCaptureDeviceNV(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV; iAttribute: Int32; piValue: IntPtr): UInt32 :=
    z_QueryVideoCaptureDeviceNV_ovr_2(hDc, hDevice, iAttribute, piValue);
    
    private static function z_ReleaseVideoCaptureDeviceNV_ovr_0(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV): UInt32;
    external 'opengl32.dll' name 'wglReleaseVideoCaptureDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseVideoCaptureDeviceNV(hDc: GDI_DC; hDevice: HVIDEOINPUTDEVICENV): UInt32 :=
    z_ReleaseVideoCaptureDeviceNV_ovr_0(hDc, hDevice);
    
  end;
  
  wglVideoOutputNV = static class
    
    private static function z_GetVideoDeviceNV_ovr_0(hDC: GDI_DC; numDevices: Int32; var hVideoDevice: HPVIDEODEV): UInt32;
    external 'opengl32.dll' name 'wglGetVideoDeviceNV';
    private static function z_GetVideoDeviceNV_ovr_0_anh0001(hDC: GDI_DC; numDevices: Int32; hVideoDevice: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoDeviceNV(hDC: GDI_DC; numDevices: Int32; hVideoDevice: array of HPVIDEODEV): UInt32 :=
    if (hVideoDevice<>nil) and (hVideoDevice.Length<>0) then
      z_GetVideoDeviceNV_ovr_0(hDC, numDevices, hVideoDevice[0]) else
      z_GetVideoDeviceNV_ovr_0_anh0001(hDC, numDevices, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoDeviceNV(hDC: GDI_DC; numDevices: Int32; var hVideoDevice: HPVIDEODEV): UInt32 :=
    z_GetVideoDeviceNV_ovr_0(hDC, numDevices, hVideoDevice);
    private static function z_GetVideoDeviceNV_ovr_2(hDC: GDI_DC; numDevices: Int32; hVideoDevice: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoDeviceNV(hDC: GDI_DC; numDevices: Int32; hVideoDevice: IntPtr): UInt32 :=
    z_GetVideoDeviceNV_ovr_2(hDC, numDevices, hVideoDevice);
    
    private static function z_ReleaseVideoDeviceNV_ovr_0(hVideoDevice: HPVIDEODEV): UInt32;
    external 'opengl32.dll' name 'wglReleaseVideoDeviceNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseVideoDeviceNV(hVideoDevice: HPVIDEODEV): UInt32 :=
    z_ReleaseVideoDeviceNV_ovr_0(hVideoDevice);
    
    private static function z_BindVideoImageNV_ovr_0(hVideoDevice: HPVIDEODEV; _hPbuffer: HPBUFFER; iVideoBuffer: Int32): UInt32;
    external 'opengl32.dll' name 'wglBindVideoImageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function BindVideoImageNV(hVideoDevice: HPVIDEODEV; _hPbuffer: HPBUFFER; iVideoBuffer: Int32): UInt32 :=
    z_BindVideoImageNV_ovr_0(hVideoDevice, _hPbuffer, iVideoBuffer);
    
    private static function z_ReleaseVideoImageNV_ovr_0(_hPbuffer: HPBUFFER; iVideoBuffer: Int32): UInt32;
    external 'opengl32.dll' name 'wglReleaseVideoImageNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function ReleaseVideoImageNV(_hPbuffer: HPBUFFER; iVideoBuffer: Int32): UInt32 :=
    z_ReleaseVideoImageNV_ovr_0(_hPbuffer, iVideoBuffer);
    
    private static function z_SendPbufferToVideoNV_ovr_0(_hPbuffer: HPBUFFER; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: UInt32): UInt32;
    external 'opengl32.dll' name 'wglSendPbufferToVideoNV';
    private static function z_SendPbufferToVideoNV_ovr_0_anh00010(_hPbuffer: HPBUFFER; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: UInt32): UInt32;
    external 'opengl32.dll' name 'wglSendPbufferToVideoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SendPbufferToVideoNV(_hPbuffer: HPBUFFER; iBufferType: Int32; pulCounterPbuffer: array of UInt64; bBlock: UInt32): UInt32 :=
    if (pulCounterPbuffer<>nil) and (pulCounterPbuffer.Length<>0) then
      z_SendPbufferToVideoNV_ovr_0(_hPbuffer, iBufferType, pulCounterPbuffer[0], bBlock) else
      z_SendPbufferToVideoNV_ovr_0_anh00010(_hPbuffer, iBufferType, IntPtr.Zero, bBlock);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SendPbufferToVideoNV(_hPbuffer: HPBUFFER; iBufferType: Int32; var pulCounterPbuffer: UInt64; bBlock: UInt32): UInt32 :=
    z_SendPbufferToVideoNV_ovr_0(_hPbuffer, iBufferType, pulCounterPbuffer, bBlock);
    private static function z_SendPbufferToVideoNV_ovr_2(_hPbuffer: HPBUFFER; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: UInt32): UInt32;
    external 'opengl32.dll' name 'wglSendPbufferToVideoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SendPbufferToVideoNV(_hPbuffer: HPBUFFER; iBufferType: Int32; pulCounterPbuffer: IntPtr; bBlock: UInt32): UInt32 :=
    z_SendPbufferToVideoNV_ovr_2(_hPbuffer, iBufferType, pulCounterPbuffer, bBlock);
    
    private static function z_GetVideoInfoNV_ovr_0(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    private static function z_GetVideoInfoNV_ovr_0_anh0010(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    private static function z_GetVideoInfoNV_ovr_0_anh0001(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    private static function z_GetVideoInfoNV_ovr_0_anh0011(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: array of UInt64): UInt32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh0001(hpVideoDevice, pulCounterOutputPbuffer[0], IntPtr.Zero) else
      if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
        z_GetVideoInfoNV_ovr_0_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo[0]) else
        z_GetVideoInfoNV_ovr_0_anh0011(hpVideoDevice, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetVideoInfoNV_ovr_1_anh0010(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: array of UInt64; var pulCounterOutputVideo: UInt64): UInt32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_0_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    private static function z_GetVideoInfoNV_ovr_2(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    private static function z_GetVideoInfoNV_ovr_2_anh0010(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: array of UInt64; pulCounterOutputVideo: IntPtr): UInt32 :=
    if (pulCounterOutputPbuffer<>nil) and (pulCounterOutputPbuffer.Length<>0) then
      z_GetVideoInfoNV_ovr_2(hpVideoDevice, pulCounterOutputPbuffer[0], pulCounterOutputVideo) else
      z_GetVideoInfoNV_ovr_2_anh0010(hpVideoDevice, IntPtr.Zero, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: array of UInt64): UInt32 :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_0_anh0001(hpVideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; var pulCounterOutputVideo: UInt64): UInt32 :=
    z_GetVideoInfoNV_ovr_0(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; var pulCounterOutputPbuffer: UInt64; pulCounterOutputVideo: IntPtr): UInt32 :=
    z_GetVideoInfoNV_ovr_2(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private static function z_GetVideoInfoNV_ovr_6(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    private static function z_GetVideoInfoNV_ovr_6_anh0001(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: array of UInt64): UInt32 :=
    if (pulCounterOutputVideo<>nil) and (pulCounterOutputVideo.Length<>0) then
      z_GetVideoInfoNV_ovr_6(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo[0]) else
      z_GetVideoInfoNV_ovr_6_anh0001(hpVideoDevice, pulCounterOutputPbuffer, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; var pulCounterOutputVideo: UInt64): UInt32 :=
    z_GetVideoInfoNV_ovr_6(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    private static function z_GetVideoInfoNV_ovr_8(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetVideoInfoNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetVideoInfoNV(hpVideoDevice: HPVIDEODEV; pulCounterOutputPbuffer: IntPtr; pulCounterOutputVideo: IntPtr): UInt32 :=
    z_GetVideoInfoNV_ovr_8(hpVideoDevice, pulCounterOutputPbuffer, pulCounterOutputVideo);
    
  end;
  
  wglVertexArrayRangeNV = static class
    
    private static function z_AllocateMemoryNV_ovr_0(size: Int32; readfreq: single; writefreq: single; priority: single): IntPtr;
    external 'opengl32.dll' name 'wglAllocateMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function AllocateMemoryNV(size: Int32; readfreq: single; writefreq: single; priority: single): IntPtr :=
    z_AllocateMemoryNV_ovr_0(size, readfreq, writefreq, priority);
    
    private static procedure z_FreeMemoryNV_ovr_0(pointer: IntPtr);
    external 'opengl32.dll' name 'wglFreeMemoryNV';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static procedure FreeMemoryNV(pointer: IntPtr) :=
    z_FreeMemoryNV_ovr_0(pointer);
    
  end;
  
  wglSyncControlOML = static class
    
    private static function z_GetSyncValuesOML_ovr_0(hdc: GDI_DC; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00010(hdc: GDI_DC; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00110(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00001(hdc: GDI_DC; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00101(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00011(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_0_anh00111(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust[0], IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00011(hdc, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc[0], sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00101(hdc, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_GetSyncValuesOML_ovr_0_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_GetSyncValuesOML_ovr_0_anh00111(hdc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetSyncValuesOML_ovr_1_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_1_anh00010(hdc: GDI_DC; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_1_anh00110(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_0_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_GetSyncValuesOML_ovr_2(hdc: GDI_DC; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_2_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_2_anh00010(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_2_anh00110(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2(hdc, ust[0], msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh00010(hdc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_GetSyncValuesOML_ovr_2_anh00100(hdc, IntPtr.Zero, msc[0], sbc) else
        z_GetSyncValuesOML_ovr_2_anh00110(hdc, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_GetSyncValuesOML_ovr_3_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_3_anh00101(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00101(hdc, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_GetSyncValuesOML_ovr_4_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_0_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_5_anh00100(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_2(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_2_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_6(hdc: GDI_DC; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_6_anh00100(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_6_anh00001(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_6_anh00101(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6(hdc, ust[0], msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh00001(hdc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_6_anh00100(hdc, IntPtr.Zero, msc, sbc[0]) else
        z_GetSyncValuesOML_ovr_6_anh00101(hdc, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_GetSyncValuesOML_ovr_7_anh00100(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_6(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_6_anh00100(hdc, IntPtr.Zero, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_8(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_8_anh00100(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: array of Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_GetSyncValuesOML_ovr_8(hdc, ust[0], msc, sbc) else
      z_GetSyncValuesOML_ovr_8_anh00100(hdc, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0(hdc, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_0_anh00011(hdc, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_0_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_2(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_2_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_0(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_0_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    z_GetSyncValuesOML_ovr_0(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_GetSyncValuesOML_ovr_2(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_6(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_6_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_GetSyncValuesOML_ovr_6(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_GetSyncValuesOML_ovr_8(hdc, ust, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_18(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_18_anh00010(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_18_anh00001(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_18_anh00011(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18(hdc, ust, msc[0], sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh00001(hdc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_GetSyncValuesOML_ovr_18_anh00010(hdc, ust, IntPtr.Zero, sbc[0]) else
        z_GetSyncValuesOML_ovr_18_anh00011(hdc, ust, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetSyncValuesOML_ovr_19_anh00010(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_18_anh00010(hdc, ust, IntPtr.Zero, sbc);
    private static function z_GetSyncValuesOML_ovr_20(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_20_anh00010(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_GetSyncValuesOML_ovr_20(hdc, ust, msc[0], sbc) else
      z_GetSyncValuesOML_ovr_20_anh00010(hdc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_18(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_18_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32 :=
    z_GetSyncValuesOML_ovr_18(hdc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_GetSyncValuesOML_ovr_20(hdc, ust, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_24(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    private static function z_GetSyncValuesOML_ovr_24_anh00001(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_GetSyncValuesOML_ovr_24(hdc, ust, msc, sbc[0]) else
      z_GetSyncValuesOML_ovr_24_anh00001(hdc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_GetSyncValuesOML_ovr_24(hdc, ust, msc, sbc);
    private static function z_GetSyncValuesOML_ovr_26(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetSyncValuesOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetSyncValuesOML(hdc: GDI_DC; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_GetSyncValuesOML_ovr_26(hdc, ust, msc, sbc);
    
    private static function z_GetMscRateOML_ovr_0(hdc: GDI_DC; var numerator: Int32; var denominator: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    private static function z_GetMscRateOML_ovr_0_anh0010(hdc: GDI_DC; numerator: IntPtr; var denominator: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    private static function z_GetMscRateOML_ovr_0_anh0001(hdc: GDI_DC; var numerator: Int32; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    private static function z_GetMscRateOML_ovr_0_anh0011(hdc: GDI_DC; numerator: IntPtr; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: array of Int32; denominator: array of Int32): UInt32 :=
    if (numerator<>nil) and (numerator.Length<>0) then
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0(hdc, numerator[0], denominator[0]) else
        z_GetMscRateOML_ovr_0_anh0001(hdc, numerator[0], IntPtr.Zero) else
      if (denominator<>nil) and (denominator.Length<>0) then
        z_GetMscRateOML_ovr_0_anh0010(hdc, IntPtr.Zero, denominator[0]) else
        z_GetMscRateOML_ovr_0_anh0011(hdc, IntPtr.Zero, IntPtr.Zero);
    private static function z_GetMscRateOML_ovr_1_anh0010(hdc: GDI_DC; numerator: IntPtr; var denominator: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: array of Int32; var denominator: Int32): UInt32 :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_0(hdc, numerator[0], denominator) else
      z_GetMscRateOML_ovr_0_anh0010(hdc, IntPtr.Zero, denominator);
    private static function z_GetMscRateOML_ovr_2(hdc: GDI_DC; var numerator: Int32; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    private static function z_GetMscRateOML_ovr_2_anh0010(hdc: GDI_DC; numerator: IntPtr; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: array of Int32; denominator: IntPtr): UInt32 :=
    if (numerator<>nil) and (numerator.Length<>0) then
      z_GetMscRateOML_ovr_2(hdc, numerator[0], denominator) else
      z_GetMscRateOML_ovr_2_anh0010(hdc, IntPtr.Zero, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; var numerator: Int32; denominator: array of Int32): UInt32 :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_0(hdc, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_0_anh0001(hdc, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; var numerator: Int32; var denominator: Int32): UInt32 :=
    z_GetMscRateOML_ovr_0(hdc, numerator, denominator);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; var numerator: Int32; denominator: IntPtr): UInt32 :=
    z_GetMscRateOML_ovr_2(hdc, numerator, denominator);
    private static function z_GetMscRateOML_ovr_6(hdc: GDI_DC; numerator: IntPtr; var denominator: Int32): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    private static function z_GetMscRateOML_ovr_6_anh0001(hdc: GDI_DC; numerator: IntPtr; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: IntPtr; denominator: array of Int32): UInt32 :=
    if (denominator<>nil) and (denominator.Length<>0) then
      z_GetMscRateOML_ovr_6(hdc, numerator, denominator[0]) else
      z_GetMscRateOML_ovr_6_anh0001(hdc, numerator, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: IntPtr; var denominator: Int32): UInt32 :=
    z_GetMscRateOML_ovr_6(hdc, numerator, denominator);
    private static function z_GetMscRateOML_ovr_8(hdc: GDI_DC; numerator: IntPtr; denominator: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglGetMscRateOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function GetMscRateOML(hdc: GDI_DC; numerator: IntPtr; denominator: IntPtr): UInt32 :=
    z_GetMscRateOML_ovr_8(hdc, numerator, denominator);
    
    private static function z_SwapBuffersMscOML_ovr_0(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64): Int64;
    external 'opengl32.dll' name 'wglSwapBuffersMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapBuffersMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64): Int64 :=
    z_SwapBuffersMscOML_ovr_0(hdc, target_msc, divisor, remainder);
    
    private static function z_SwapLayerBuffersMscOML_ovr_0(hdc: GDI_DC; fuPlanes: Int32; target_msc: Int64; divisor: Int64; remainder: Int64): Int64;
    external 'opengl32.dll' name 'wglSwapLayerBuffersMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function SwapLayerBuffersMscOML(hdc: GDI_DC; fuPlanes: Int32; target_msc: Int64; divisor: Int64; remainder: Int64): Int64 :=
    z_SwapLayerBuffersMscOML_ovr_0(hdc, fuPlanes, target_msc, divisor, remainder);
    
    private static function z_WaitForMscOML_ovr_0(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000110(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000001(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000101(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000011(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_0_anh00000111(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000011(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForMscOML_ovr_0_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForMscOML_ovr_0_anh00000111(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_WaitForMscOML_ovr_1_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_1_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_1_anh00000110(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_0_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_WaitForMscOML_ovr_2(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_2_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_2_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_2_anh00000110(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust[0], msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh00000010(hdc, target_msc, divisor, remainder, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForMscOML_ovr_2_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc[0], sbc) else
        z_WaitForMscOML_ovr_2_anh00000110(hdc, target_msc, divisor, remainder, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_WaitForMscOML_ovr_3_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_3_anh00000101(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_WaitForMscOML_ovr_4_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_0_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private static function z_WaitForMscOML_ovr_5_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_2_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private static function z_WaitForMscOML_ovr_6(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_6_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_6_anh00000001(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_6_anh00000101(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust[0], msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh00000001(hdc, target_msc, divisor, remainder, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_6_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForMscOML_ovr_6_anh00000101(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_WaitForMscOML_ovr_7_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_6_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    private static function z_WaitForMscOML_ovr_8(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_8_anh00000100(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForMscOML_ovr_8(hdc, target_msc, divisor, remainder, ust[0], msc, sbc) else
      z_WaitForMscOML_ovr_8_anh00000100(hdc, target_msc, divisor, remainder, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_0_anh00000011(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_0_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_2_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_0_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    z_WaitForMscOML_ovr_0(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_WaitForMscOML_ovr_2(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_6_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_WaitForMscOML_ovr_6(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_WaitForMscOML_ovr_8(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private static function z_WaitForMscOML_ovr_18(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_18_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_18_anh00000001(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_18_anh00000011(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc[0], sbc[0]) else
        z_WaitForMscOML_ovr_18_anh00000001(hdc, target_msc, divisor, remainder, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForMscOML_ovr_18_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForMscOML_ovr_18_anh00000011(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, IntPtr.Zero);
    private static function z_WaitForMscOML_ovr_19_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_18_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    private static function z_WaitForMscOML_ovr_20(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_20_anh00000010(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForMscOML_ovr_20(hdc, target_msc, divisor, remainder, ust, msc[0], sbc) else
      z_WaitForMscOML_ovr_20_anh00000010(hdc, target_msc, divisor, remainder, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_18_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32 :=
    z_WaitForMscOML_ovr_18(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_WaitForMscOML_ovr_20(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private static function z_WaitForMscOML_ovr_24(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    private static function z_WaitForMscOML_ovr_24_anh00000001(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForMscOML_ovr_24(hdc, target_msc, divisor, remainder, ust, msc, sbc[0]) else
      z_WaitForMscOML_ovr_24_anh00000001(hdc, target_msc, divisor, remainder, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_WaitForMscOML_ovr_24(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    private static function z_WaitForMscOML_ovr_26(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForMscOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForMscOML(hdc: GDI_DC; target_msc: Int64; divisor: Int64; remainder: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_WaitForMscOML_ovr_26(hdc, target_msc, divisor, remainder, ust, msc, sbc);
    
    private static function z_WaitForSbcOML_ovr_0(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000010(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000110(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000001(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000101(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000011(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_0_anh000111(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust[0], msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000011(hdc, target_sbc, ust[0], IntPtr.Zero, IntPtr.Zero) else
      if (msc<>nil) and (msc.Length<>0) then
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000101(hdc, target_sbc, IntPtr.Zero, msc[0], IntPtr.Zero) else
        if (sbc<>nil) and (sbc.Length<>0) then
          z_WaitForSbcOML_ovr_0_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc[0]) else
          z_WaitForSbcOML_ovr_0_anh000111(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
    private static function z_WaitForSbcOML_ovr_1_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_1_anh000010(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_1_anh000110(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_0_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_WaitForSbcOML_ovr_2(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_2_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_2_anh000010(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_2_anh000110(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust[0], msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh000010(hdc, target_sbc, ust[0], IntPtr.Zero, sbc) else
      if (msc<>nil) and (msc.Length<>0) then
        z_WaitForSbcOML_ovr_2_anh000100(hdc, target_sbc, IntPtr.Zero, msc[0], sbc) else
        z_WaitForSbcOML_ovr_2_anh000110(hdc, target_sbc, IntPtr.Zero, IntPtr.Zero, sbc);
    private static function z_WaitForSbcOML_ovr_3_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_3_anh000101(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000101(hdc, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_WaitForSbcOML_ovr_4_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_0_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private static function z_WaitForSbcOML_ovr_5_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_2_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private static function z_WaitForSbcOML_ovr_6(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_6_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_6_anh000001(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_6_anh000101(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust[0], msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh000001(hdc, target_sbc, ust[0], msc, IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_6_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc[0]) else
        z_WaitForSbcOML_ovr_6_anh000101(hdc, target_sbc, IntPtr.Zero, msc, IntPtr.Zero);
    private static function z_WaitForSbcOML_ovr_7_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_6_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    private static function z_WaitForSbcOML_ovr_8(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_8_anh000100(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: array of Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    if (ust<>nil) and (ust.Length<>0) then
      z_WaitForSbcOML_ovr_8(hdc, target_sbc, ust[0], msc, sbc) else
      z_WaitForSbcOML_ovr_8_anh000100(hdc, target_sbc, IntPtr.Zero, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_0_anh000011(hdc, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_0_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_2_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_0_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; var sbc: Int64): UInt32 :=
    z_WaitForSbcOML_ovr_0(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_WaitForSbcOML_ovr_2(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_6_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_WaitForSbcOML_ovr_6(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; var ust: Int64; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_WaitForSbcOML_ovr_8(hdc, target_sbc, ust, msc, sbc);
    private static function z_WaitForSbcOML_ovr_18(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_18_anh000010(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_18_anh000001(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_18_anh000011(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: array of Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc[0], sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh000001(hdc, target_sbc, ust, msc[0], IntPtr.Zero) else
      if (sbc<>nil) and (sbc.Length<>0) then
        z_WaitForSbcOML_ovr_18_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc[0]) else
        z_WaitForSbcOML_ovr_18_anh000011(hdc, target_sbc, ust, IntPtr.Zero, IntPtr.Zero);
    private static function z_WaitForSbcOML_ovr_19_anh000010(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: array of Int64; var sbc: Int64): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_18_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    private static function z_WaitForSbcOML_ovr_20(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_20_anh000010(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: array of Int64; sbc: IntPtr): UInt32 :=
    if (msc<>nil) and (msc.Length<>0) then
      z_WaitForSbcOML_ovr_20(hdc, target_sbc, ust, msc[0], sbc) else
      z_WaitForSbcOML_ovr_20_anh000010(hdc, target_sbc, ust, IntPtr.Zero, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_18_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; var sbc: Int64): UInt32 :=
    z_WaitForSbcOML_ovr_18(hdc, target_sbc, ust, msc, sbc);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; var msc: Int64; sbc: IntPtr): UInt32 :=
    z_WaitForSbcOML_ovr_20(hdc, target_sbc, ust, msc, sbc);
    private static function z_WaitForSbcOML_ovr_24(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    private static function z_WaitForSbcOML_ovr_24_anh000001(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: array of Int64): UInt32 :=
    if (sbc<>nil) and (sbc.Length<>0) then
      z_WaitForSbcOML_ovr_24(hdc, target_sbc, ust, msc, sbc[0]) else
      z_WaitForSbcOML_ovr_24_anh000001(hdc, target_sbc, ust, msc, IntPtr.Zero);
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; var sbc: Int64): UInt32 :=
    z_WaitForSbcOML_ovr_24(hdc, target_sbc, ust, msc, sbc);
    private static function z_WaitForSbcOML_ovr_26(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32;
    external 'opengl32.dll' name 'wglWaitForSbcOML';
    public [MethodImpl(MethodImplOptions.AggressiveInlining)] static function WaitForSbcOML(hdc: GDI_DC; target_sbc: Int64; ust: IntPtr; msc: IntPtr; sbc: IntPtr): UInt32 :=
    z_WaitForSbcOML_ovr_26(hdc, target_sbc, ust, msc, sbc);
    
  end;
  
  {$endregion Extensions}
  
  ///Методы для интеграции с gdi
  gl_gdi = static class
    {$reference System.Windows.Forms.dll}
    
    {$region Misc}
    
    ///Создаёт новую поверхность рисования GDI для дескриптора элемента управления
    public static function GetControlDC(hwnd: IntPtr): GDI_DC;
    external 'user32.dll' name 'GetDC';
    
    {$endregion Misc}
    
    {$region InitControl}
    
    ///Создаёт и настраивает поверхность рисования GDI элемента управления WF
    ///hwnd - дескриптор элемента управления
    public static function InitControl(hwnd: IntPtr): GDI_DC;
    begin
      Result := gl_gdi.GetControlDC(hwnd);
      
      var pfd: GDI_PixelFormatDescriptor;
      pfd.nVersion := 1;
      
      pfd.dwFlags :=
        PixelFormatFlagsGDI.DRAW_TO_WINDOW or
        PixelFormatFlagsGDI.SUPPORT_OPENGL or
        PixelFormatFlagsGDI.DOUBLEBUFFER
      ;
      pfd.cColorBits := 24;
      pfd.cDepthBits := 16;
      
      if 1 <> gdi.SetPixelFormat(
        Result,
        gdi.ChoosePixelFormat(Result, pfd),
        pfd
      ) then raise new InvalidOperationException;
      
    end;
    
    ///Создаёт и настраивает поверхность рисования GDI элемента управления WF
    public static function InitControl(c: System.Windows.Forms.Control) := InitControl(c.Handle);
    
    {$endregion InitControl}
    
    {$region SetupControlRedrawing}
    
    ///Добавляет в эвент Form.Load формы (f) обработчик, который:
    ///1. Создаёт контекст OpenGL на поверхности рисования GDI (hdc)
    ///2. Запускает перерисовку (RedrawThreadProc)
    public static procedure SetupControlRedrawing(f: System.Windows.Forms.Form; hdc: GDI_DC; RedrawThreadProc: procedure(EndFrame: ()->()); vsync_fps: integer := 65);
    begin
      
      f.Load += (o,e)->
        System.Threading.Thread.Create(()->
        begin
          
          var context := wgl.CreateContext(hdc);
          if 1 <> wgl.MakeCurrent(hdc, context) then raise new InvalidOperationException('Не удалось применить контекст');
          
          var EndFrame: ()->();
          if vsync_fps<=0 then
            EndFrame := ()->gdi.SwapBuffers(hdc) else
          begin
            var LastRedr := DateTime.UtcNow;
            var FrameDuration := new TimeSpan(Trunc(TimeSpan.TicksPerSecond/vsync_fps));
            var MaxSlowDown := FrameDuration.Ticks*3;
            
            EndFrame := ()->
            begin
              gdi.SwapBuffers(hdc);
              
              LastRedr := LastRedr+FrameDuration;
              var time_left := LastRedr-DateTime.UtcNow;
              
              if time_left.Ticks>0 then
                System.Threading.Thread.Sleep(time_left) else
              if -time_left.Ticks > MaxSlowDown then
                LastRedr := LastRedr.AddTicks(-time_left.Ticks - MaxSlowDown);
              
            end;
            
          end;
          
          RedrawThreadProc(EndFrame);
        end).Start();
      
    end;
    
    {$endregion SetupControlRedrawing}
    
  end;
  
implementation

{$region MtrMlt}

function operator*(m1: Mtr2x2f; m2: Mtr2x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2f; m2: Mtr2x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3f; m2: Mtr3x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4f; m2: Mtr4x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3f; m2: Mtr3x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2f; m2: Mtr2x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x4f): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x2f): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x3f): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x4d): Mtr2x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x2d): Mtr2x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4f; m2: Mtr4x3d): Mtr2x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2f; m2: Mtr2x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x4f): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x2f): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x3f): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x4d): Mtr3x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x2d): Mtr3x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4f; m2: Mtr4x3d): Mtr3x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x3f): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x2f): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x4f): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x3d): Mtr4x3f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x2d): Mtr4x2f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3f; m2: Mtr3x4d): Mtr4x4f; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
end;

function operator*(m1: Mtr2x2d; m2: Mtr2x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
end;

function operator*(m1: Mtr3x3d; m2: Mtr3x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23 + m1.val33*m2.val33;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
end;

function operator*(m1: Mtr4x4d; m2: Mtr4x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20 + m1.val33*m2.val30;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21 + m1.val33*m2.val31;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22 + m1.val33*m2.val32;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
end;

function operator*(m1: Mtr2x3d; m2: Mtr3x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
end;

function operator*(m1: Mtr3x2d; m2: Mtr2x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x4f): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x2f): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x3f): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x4d): Mtr2x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x2d): Mtr2x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
end;

function operator*(m1: Mtr2x4d; m2: Mtr4x3d): Mtr2x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
end;

function operator*(m1: Mtr4x2d; m2: Mtr2x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x4f): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x2f): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x3f): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x4d): Mtr3x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23 + m1.val03*m2.val33;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23 + m1.val13*m2.val33;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23 + m1.val23*m2.val33;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x2d): Mtr3x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
end;

function operator*(m1: Mtr3x4d; m2: Mtr4x3d): Mtr3x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20 + m1.val03*m2.val30;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21 + m1.val03*m2.val31;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22 + m1.val03*m2.val32;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20 + m1.val13*m2.val30;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21 + m1.val13*m2.val31;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22 + m1.val13*m2.val32;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20 + m1.val23*m2.val30;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21 + m1.val23*m2.val31;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22 + m1.val23*m2.val32;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x3f): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x2f): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x4f): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x3d): Mtr4x3d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x2d): Mtr4x2d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
end;

function operator*(m1: Mtr4x3d; m2: Mtr3x4d): Mtr4x4d; extensionmethod;
begin
  Result.val00 := m1.val00*m2.val00 + m1.val01*m2.val10 + m1.val02*m2.val20;
  Result.val01 := m1.val00*m2.val01 + m1.val01*m2.val11 + m1.val02*m2.val21;
  Result.val02 := m1.val00*m2.val02 + m1.val01*m2.val12 + m1.val02*m2.val22;
  Result.val03 := m1.val00*m2.val03 + m1.val01*m2.val13 + m1.val02*m2.val23;
  Result.val10 := m1.val10*m2.val00 + m1.val11*m2.val10 + m1.val12*m2.val20;
  Result.val11 := m1.val10*m2.val01 + m1.val11*m2.val11 + m1.val12*m2.val21;
  Result.val12 := m1.val10*m2.val02 + m1.val11*m2.val12 + m1.val12*m2.val22;
  Result.val13 := m1.val10*m2.val03 + m1.val11*m2.val13 + m1.val12*m2.val23;
  Result.val20 := m1.val20*m2.val00 + m1.val21*m2.val10 + m1.val22*m2.val20;
  Result.val21 := m1.val20*m2.val01 + m1.val21*m2.val11 + m1.val22*m2.val21;
  Result.val22 := m1.val20*m2.val02 + m1.val21*m2.val12 + m1.val22*m2.val22;
  Result.val23 := m1.val20*m2.val03 + m1.val21*m2.val13 + m1.val22*m2.val23;
  Result.val30 := m1.val30*m2.val00 + m1.val31*m2.val10 + m1.val32*m2.val20;
  Result.val31 := m1.val30*m2.val01 + m1.val31*m2.val11 + m1.val32*m2.val21;
  Result.val32 := m1.val30*m2.val02 + m1.val31*m2.val12 + m1.val32*m2.val22;
  Result.val33 := m1.val30*m2.val03 + m1.val31*m2.val13 + m1.val32*m2.val23;
end;

{$endregion MtrMlt}

{$region MtrTranspose}

function Transpose(self: Mtr2x2f); extensionmethod :=
new Mtr2x2f(self.val00, self.val10, self.val01, self.val11);

function Transpose(self: Mtr3x3f); extensionmethod :=
new Mtr3x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22);

function Transpose(self: Mtr4x4f); extensionmethod :=
new Mtr4x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32, self.val03, self.val13, self.val23, self.val33);

function Transpose(self: Mtr2x3f); extensionmethod :=
new Mtr3x2f(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12);
function Transpose(self: Mtr3x2f); extensionmethod :=
new Mtr2x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21);

function Transpose(self: Mtr2x4f); extensionmethod :=
new Mtr4x2f(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12, self.val03, self.val13);
function Transpose(self: Mtr4x2f); extensionmethod :=
new Mtr2x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31);

function Transpose(self: Mtr3x4f); extensionmethod :=
new Mtr4x3f(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22, self.val03, self.val13, self.val23);
function Transpose(self: Mtr4x3f); extensionmethod :=
new Mtr3x4f(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32);

function Transpose(self: Mtr2x2d); extensionmethod :=
new Mtr2x2d(self.val00, self.val10, self.val01, self.val11);

function Transpose(self: Mtr3x3d); extensionmethod :=
new Mtr3x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22);

function Transpose(self: Mtr4x4d); extensionmethod :=
new Mtr4x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32, self.val03, self.val13, self.val23, self.val33);

function Transpose(self: Mtr2x3d); extensionmethod :=
new Mtr3x2d(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12);
function Transpose(self: Mtr3x2d); extensionmethod :=
new Mtr2x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21);

function Transpose(self: Mtr2x4d); extensionmethod :=
new Mtr4x2d(self.val00, self.val10, self.val01, self.val11, self.val02, self.val12, self.val03, self.val13);
function Transpose(self: Mtr4x2d); extensionmethod :=
new Mtr2x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31);

function Transpose(self: Mtr3x4d); extensionmethod :=
new Mtr4x3d(self.val00, self.val10, self.val20, self.val01, self.val11, self.val21, self.val02, self.val12, self.val22, self.val03, self.val13, self.val23);
function Transpose(self: Mtr4x3d); extensionmethod :=
new Mtr3x4d(self.val00, self.val10, self.val20, self.val30, self.val01, self.val11, self.val21, self.val31, self.val02, self.val12, self.val22, self.val32);

{$endregion MtrTranspose}

end.